<?php
/**
 *   @copyright Copyright (c) 2007 Quality Unit s.r.o.
 *   @author Michal Bebjak
 *   @package GwtPhpFramework
 *   @since Version 1.0.0
 *   $Id:
 *
 *   Licensed under the Quality Unit, s.r.o. Dual License Agreement,
 *   Version 1.0 (the "License"); you may not use this file except in compliance
 *   with the License. You may obtain a copy of the License at
 *   http://www.qualityunit.com/licenses/gpf
 *
 */

/**
 * @package GwtPhpFramework
 */
class Pap_IntegrityCheck extends Gpf_IntegrityCheck {

    protected function checkFiles() {
        $this->checkFile('.htaccess', '45a77dbbb2fd13808796f10a6e24604a');
        $this->checkFile('CHANGELOG.txt', '01a865929bdabd58b89dc36ab2092672');
        $this->checkFile('INSTALL.txt', '1a42121e0b38f50aade648c6c8a58861');
        $this->checkFile('LICENSE.txt', 'a72dd102feac28926e3d92e335faa0c6');
        $this->checkFile('README.txt', '72326c1587cbfbcbbc5c82dc234b3999');
        $this->checkFile('UPDATE.txt', 'ff37eff7e0138fe6f4833850b183a96a');
        $this->checkFile('accounts/README.txt', 'ce5afca3faf57c57d6966df6d57e6e83');
        $this->checkFile('affiliates/faq.php', 'b230b2d1f807aa8586b193ebd10ce653');
        $this->checkFile('affiliates/index.php', '88f9ebf72d3a5f07818995b137be2212');
        $this->checkFile('affiliates/js/affiliate-application-0.cache.js', '3c2f06cfe5ade6994536e0928c55f583');
        $this->checkFile('affiliates/js/affiliate-application-0.cache.php', '5ca958a28ef0dbbfcd9fdf743b051972');
        $this->checkFile('affiliates/js/affiliate-application-1.cache.js', '181c3441ee0df4ed954709cd67790fbc');
        $this->checkFile('affiliates/js/affiliate-application-1.cache.php', '5ca958a28ef0dbbfcd9fdf743b051972');
        $this->checkFile('affiliates/js/affiliate-application-2.cache.js', '68c19bbdccc7b9ae08360f095d227e6d');
        $this->checkFile('affiliates/js/affiliate-application-2.cache.php', '5ca958a28ef0dbbfcd9fdf743b051972');
        $this->checkFile('affiliates/js/affiliate-application-3.cache.js', 'ef7c1737a4c74d4f9e1cb01327c02e7f');
        $this->checkFile('affiliates/js/affiliate-application-3.cache.php', '5ca958a28ef0dbbfcd9fdf743b051972');
        $this->checkFile('affiliates/js/affiliate-login-0.cache.js', 'a0c05247aa42ec5175b5327def0ea59d');
        $this->checkFile('affiliates/js/affiliate-login-0.cache.php', '5ca958a28ef0dbbfcd9fdf743b051972');
        $this->checkFile('affiliates/js/affiliate-login-1.cache.js', 'bc20ccd4dc714027cd76ccba39ec831b');
        $this->checkFile('affiliates/js/affiliate-login-1.cache.php', '5ca958a28ef0dbbfcd9fdf743b051972');
        $this->checkFile('affiliates/js/affiliate-login-2.cache.js', '25cbb12722d58c4504dbd9c8596ee019');
        $this->checkFile('affiliates/js/affiliate-login-2.cache.php', '5ca958a28ef0dbbfcd9fdf743b051972');
        $this->checkFile('affiliates/js/affiliate-login-3.cache.js', '847b7a0b9e936e9e8e8822ac4a64b4a7');
        $this->checkFile('affiliates/js/affiliate-login-3.cache.php', '5ca958a28ef0dbbfcd9fdf743b051972');
        $this->checkFile('affiliates/js/affiliate-signup-0.cache.js', '8ed5646a49714bff114ccbe95daa3be4');
        $this->checkFile('affiliates/js/affiliate-signup-0.cache.php', '5ca958a28ef0dbbfcd9fdf743b051972');
        $this->checkFile('affiliates/js/affiliate-signup-1.cache.js', '5e16111ad57bb5ab92d244cff1de7ce9');
        $this->checkFile('affiliates/js/affiliate-signup-1.cache.php', '5ca958a28ef0dbbfcd9fdf743b051972');
        $this->checkFile('affiliates/js/affiliate-signup-2.cache.js', '1fa3084dfef1cab506583e5921005bd3');
        $this->checkFile('affiliates/js/affiliate-signup-2.cache.php', '5ca958a28ef0dbbfcd9fdf743b051972');
        $this->checkFile('affiliates/js/affiliate-signup-3.cache.js', '85ac7a510862774f3b1c653df4ba0b5e');
        $this->checkFile('affiliates/js/affiliate-signup-3.cache.php', '5ca958a28ef0dbbfcd9fdf743b051972');
        $this->checkFile('affiliates/js/clear.cache.gif', '6d22e4f2d2057c6e8d6fab098e76e80f');
        $this->checkFile('affiliates/js/com.qualityunit.pap.AffiliateApplication.devmode.js', '91f7d1c42f60c1e6609c0364dfcdbf67');
        $this->checkFile('affiliates/js/com.qualityunit.pap.AffiliateApplication.nocache.php', '152d87570c7d27ef1b2b0b1e0206bc29');
        $this->checkFile('affiliates/js/com.qualityunit.pap.AffiliateLoginModule.devmode.js', 'e9768222cab67b22b9c8c3986f33469f');
        $this->checkFile('affiliates/js/com.qualityunit.pap.AffiliateLoginModule.nocache.php', '78c19028ebdf60917a9f6b8f5798ecbe');
        $this->checkFile('affiliates/js/com.qualityunit.pap.SignupApplication.devmode.js', '29f0bca61e01d1f6c87457b90427e188');
        $this->checkFile('affiliates/js/com.qualityunit.pap.SignupApplication.nocache.php', 'bcc91751e3978cfd97f58b4191711b9a');
        $this->checkFile('affiliates/js/compilation-mappings.txt', '75b947a805932be06091d3cb4ac64b9b');
        $this->checkFile('affiliates/js/nocache.php', '68b329da9893e34099c7d8ad5cb9c940');
        $this->checkFile('affiliates/login.php', '8ef213a04ad1d01519d8b8eb8b854c93');
        $this->checkFile('affiliates/panel.php', 'f0c4eb8269c35e4e5a081c2ae1c33e7f');
        $this->checkFile('affiliates/signup.php', '6a453fcad9d0627d2ed3002010d43e24');
        $this->checkFile('affiliates/tests.php', 'c2b32a20ece6b321833a022c4135bfd3');
        $this->checkFile('affiliates/tour.php', '158b8e2a338bbeafe9cff93d5ad16785');
        $this->checkFile('api/.htaccess', '2d8971db3f5c217c3d8ba68e86a7a242');
        $this->checkFile('api/PapApi.class.php', 'e1393006883cdc7b2c97851868924f3d');
        $this->checkFile('api/README.txt', '62006128aaee111441a54a4aabe953fc');
        $this->checkFile('api/download.php', 'db013f9286744350f7318d786e5fd833');
        $this->checkFile('api/index.php', '92e823d4eaa1a10ae5da4df946a5323a');
        $this->checkFile('api/v2/.htaccess', '6f55144bc1795da904af3b464e1082a9');
        $this->checkFile('api/v2/index.php', '785910b343a48ff79697658dbdd4eac4');
        $this->checkFile('api/version.php', '03715b25d6590d0d98ffe57eb4fd149d');
        $this->checkFile('favicon.ico', '54cbdb12372483e405f46f140db973cc');
        $this->checkFile('include/Braintree/Braintree/AddOn.php', '123a5925222140946ceef6f78ad9573f');
        $this->checkFile('include/Braintree/Braintree/Address.php', '79d49b23c62f052242b790412eb27119');
        $this->checkFile('include/Braintree/Braintree/ApplePayCard.php', '6460a5c60c1fcfbf892476d377059e7d');
        $this->checkFile('include/Braintree/Braintree/ClientToken.php', '976d8ff777a799d71f747bd25d6eaaea');
        $this->checkFile('include/Braintree/Braintree/Collection.php', 'b6719e1494ba8b046b45f93e6876f076');
        $this->checkFile('include/Braintree/Braintree/Configuration.php', '317afaecd913f4e595c9aa838b9d73c0');
        $this->checkFile('include/Braintree/Braintree/CreditCard.php', '5aca00faec9248681e745cfad91368d0');
        $this->checkFile('include/Braintree/Braintree/CreditCardVerification.php', '3d007726e4a0fe9f1b36ddd7ffb591e9');
        $this->checkFile('include/Braintree/Braintree/CreditCardVerificationSearch.php', '6836866623266571aaaa1a8aa3c8f298');
        $this->checkFile('include/Braintree/Braintree/Customer.php', 'de9b5b038184cbf872c3bfb1d6c1a626');
        $this->checkFile('include/Braintree/Braintree/CustomerSearch.php', '954e7db4dc89b58a5e3188711c02050a');
        $this->checkFile('include/Braintree/Braintree/Descriptor.php', '6ba25e1810ada2912544c654e5e7725e');
        $this->checkFile('include/Braintree/Braintree/Digest.php', '40252e8d0459434d999bc83c2a8e12f0');
        $this->checkFile('include/Braintree/Braintree/Disbursement.php', '5bdcd9c559e2e7be3ea4a1fcc2c24f65');
        $this->checkFile('include/Braintree/Braintree/DisbursementDetails.php', '70078a7b12b35a7151d12c6179f76b3a');
        $this->checkFile('include/Braintree/Braintree/Discount.php', '0a461e0c38e00e5b4e7f4fb4deb2451c');
        $this->checkFile('include/Braintree/Braintree/Dispute/TransactionDetails.php', '3a33243a8a79da14ee1ee4e45c58281d');
        $this->checkFile('include/Braintree/Braintree/Dispute.php', '43284e642ff12ab4f94a3399523c0bc8');
        $this->checkFile('include/Braintree/Braintree/EqualityNode.php', '746175e908e363bfc6b39ef4c5f769aa');
        $this->checkFile('include/Braintree/Braintree/Error/Codes.php', '8828768de1eb537a39709ed1df5a1829');
        $this->checkFile('include/Braintree/Braintree/Error/ErrorCollection.php', '88e47abaf3c8350c3fb2b03ffd429ed9');
        $this->checkFile('include/Braintree/Braintree/Error/Validation.php', 'de0e8c90ffcc1d1de1e77ded9f7cd4a5');
        $this->checkFile('include/Braintree/Braintree/Error/ValidationErrorCollection.php', '4309b5e0be6020e219618e7250236931');
        $this->checkFile('include/Braintree/Braintree/Exception/Authentication.php', '2c7841ddce229f41a15d03dbb9462840');
        $this->checkFile('include/Braintree/Braintree/Exception/Authorization.php', 'c94e245153fa4f3b8bdc3fab6cdc5ab0');
        $this->checkFile('include/Braintree/Braintree/Exception/Configuration.php', 'dd9e4626fec15878e2c267a9920fe60f');
        $this->checkFile('include/Braintree/Braintree/Exception/DownForMaintenance.php', '029985d4cc84b752d816ef1b6b50e2d6');
        $this->checkFile('include/Braintree/Braintree/Exception/ForgedQueryString.php', '96cd6e5cc125a39c8e86070168963502');
        $this->checkFile('include/Braintree/Braintree/Exception/InvalidSignature.php', '860e8f111db94a6240c6d62e4997df53');
        $this->checkFile('include/Braintree/Braintree/Exception/NotFound.php', '162af400133a107d951ce945750f12d3');
        $this->checkFile('include/Braintree/Braintree/Exception/SSLCaFileNotFound.php', '2dd79fc8852e6f113b4a2a731ef3fee5');
        $this->checkFile('include/Braintree/Braintree/Exception/SSLCertificate.php', '470ff58b1cc40d6f4a09dd7aa8f36b96');
        $this->checkFile('include/Braintree/Braintree/Exception/ServerError.php', 'ea924837ecb45eee8ac54fb30ad27026');
        $this->checkFile('include/Braintree/Braintree/Exception/Unexpected.php', 'bccb22989c77a9e819864f26fb874608');
        $this->checkFile('include/Braintree/Braintree/Exception/UpgradeRequired.php', 'c93ab67a0bd94b1bf4e82d9d7287f65b');
        $this->checkFile('include/Braintree/Braintree/Exception/ValidationsFailed.php', '73024e101a34da957092845b175079fe');
        $this->checkFile('include/Braintree/Braintree/Exception.php', 'd98fde1f38eafc22df5fa4c7194bb5db');
        $this->checkFile('include/Braintree/Braintree/Http.php', 'cf39cb3e3fd65b6ca0b7237c20217fc4');
        $this->checkFile('include/Braintree/Braintree/Instance.php', 'b6d5f0bccb3bc1f185226de258d85a4c');
        $this->checkFile('include/Braintree/Braintree/IsNode.php', 'b9e46b2d448dae158a19c788c5d5178f');
        $this->checkFile('include/Braintree/Braintree/KeyValueNode.php', '9dd87cc13dcda946772ddeca35e62ca9');
        $this->checkFile('include/Braintree/Braintree/MerchantAccount/AddressDetails.php', '5d317798b4c221cbfff89d57f2b61bee');
        $this->checkFile('include/Braintree/Braintree/MerchantAccount/BusinessDetails.php', 'a9c400db99b3b8e64d214b4ee14aadaa');
        $this->checkFile('include/Braintree/Braintree/MerchantAccount/FundingDetails.php', '3c3d7c9e7a320306640ccb7d7c42c4f5');
        $this->checkFile('include/Braintree/Braintree/MerchantAccount/IndividualDetails.php', 'f4721ff8a2b06d16fcde414a4b935ab7');
        $this->checkFile('include/Braintree/Braintree/MerchantAccount.php', '1baa91855d0bd8e00564a7be07849be6');
        $this->checkFile('include/Braintree/Braintree/Modification.php', '3f99f43da3fd0be28d26a0636609284c');
        $this->checkFile('include/Braintree/Braintree/MultipleValueNode.php', '6c7bce874cf17b99b0a18c87abc28617');
        $this->checkFile('include/Braintree/Braintree/MultipleValueOrTextNode.php', 'dc00037fc417bc11c8fe0dc50c4dd3ae');
        $this->checkFile('include/Braintree/Braintree/PartialMatchNode.php', '808ffe54180b4320424bf30bbc6bfd6a');
        $this->checkFile('include/Braintree/Braintree/PartnerMerchant.php', '15bac3f75e87b40fe3355626e6767f00');
        $this->checkFile('include/Braintree/Braintree/PayPalAccount.php', '7d3fdd3fb12b73625ebc0ffecc887fec');
        $this->checkFile('include/Braintree/Braintree/PaymentInstrumentType.php', '85f15f53ea61219016ba1e3e54d069c8');
        $this->checkFile('include/Braintree/Braintree/PaymentMethod.php', 'cd33a855bc4f5c26a19e85fbc1c79816');
        $this->checkFile('include/Braintree/Braintree/Plan.php', 'e14819152c130b0b007bc067b4cf8bb7');
        $this->checkFile('include/Braintree/Braintree/RangeNode.php', '3a81697fdf8562370c8e642a8a1acc9a');
        $this->checkFile('include/Braintree/Braintree/ResourceCollection.php', 'e56cdbb575370d13d8266bc6c69018e1');
        $this->checkFile('include/Braintree/Braintree/Result/CreditCardVerification.php', '7b82334e3a33fa854999c5a96ee4562d');
        $this->checkFile('include/Braintree/Braintree/Result/Error.php', 'a0302a20ae4ff9d128689b331ac83244');
        $this->checkFile('include/Braintree/Braintree/Result/Successful.php', 'b3f0bd0eccca742cebca59a6b752c8e1');
        $this->checkFile('include/Braintree/Braintree/RiskData.php', '030239ea4ab20c687acac591285c44e0');
        $this->checkFile('include/Braintree/Braintree/SettlementBatchSummary.php', '2dda72679fd3f3b3d09b56c513f0f707');
        $this->checkFile('include/Braintree/Braintree/SignatureService.php', '02806a3112d8168fe3c6efee5727c69d');
        $this->checkFile('include/Braintree/Braintree/Subscription.php', '72cf7333584659ec3610112c45452e1c');
        $this->checkFile('include/Braintree/Braintree/SubscriptionSearch.php', '38d9b6bec058afac6f5f0c259e6aeb02');
        $this->checkFile('include/Braintree/Braintree/Test/CreditCardNumbers.php', 'f90c011a692ff549018bafde10861131');
        $this->checkFile('include/Braintree/Braintree/Test/MerchantAccount.php', 'e29c5641267e6f1537c80a2875a28941');
        $this->checkFile('include/Braintree/Braintree/Test/Nonces.php', '3953bd0465d3e070ef8f32564f698853');
        $this->checkFile('include/Braintree/Braintree/Test/TransactionAmounts.php', 'acc5abb905ebd58d435e490fef4936e7');
        $this->checkFile('include/Braintree/Braintree/Test/VenmoSdk.php', '475ffa312853069404b3d835a985b350');
        $this->checkFile('include/Braintree/Braintree/TextNode.php', '6889c2dfc03049adfb0aff5da9de6268');
        $this->checkFile('include/Braintree/Braintree/Transaction/AddressDetails.php', '043850f7036bf1978d215099cedfd9bc');
        $this->checkFile('include/Braintree/Braintree/Transaction/ApplePayCardDetails.php', '94e57a65d942d93e62e8d2597e4794fe');
        $this->checkFile('include/Braintree/Braintree/Transaction/CreditCardDetails.php', '65971d58981c35f1a7ec98cacfa34cb8');
        $this->checkFile('include/Braintree/Braintree/Transaction/CustomerDetails.php', '09440da4d9a87fcfff0bd2bbc66cd0cb');
        $this->checkFile('include/Braintree/Braintree/Transaction/PayPalDetails.php', '51c17afd8532f8878a1cec803ce54637');
        $this->checkFile('include/Braintree/Braintree/Transaction/StatusDetails.php', 'ef7ec13d4dfa48251c1f73852f9f8dce');
        $this->checkFile('include/Braintree/Braintree/Transaction/SubscriptionDetails.php', '848d002371cf0c01469180e7ed72dbca');
        $this->checkFile('include/Braintree/Braintree/Transaction.php', 'ce34686714ac0293599e495fae9d49f3');
        $this->checkFile('include/Braintree/Braintree/TransactionSearch.php', '7b3b98799c767126d63ea33aef675563');
        $this->checkFile('include/Braintree/Braintree/TransparentRedirect.php', 'dc173e61d8ad33d39dc129d015f96c11');
        $this->checkFile('include/Braintree/Braintree/UnknownPaymentMethod.php', 'd3e030a83b824a492669d477229a32bb');
        $this->checkFile('include/Braintree/Braintree/Util.php', '6da0c20be45b2d26c93c76328d72f761');
        $this->checkFile('include/Braintree/Braintree/Version.php', 'cc443c7643a604065db1a1136e6de773');
        $this->checkFile('include/Braintree/Braintree/WebhookNotification.php', 'e92e6e74a1922a6ba4a149388db0aa0d');
        $this->checkFile('include/Braintree/Braintree/WebhookTesting.php', 'e317930a60d936c8c9ee3a3f2a94fab4');
        $this->checkFile('include/Braintree/Braintree/Xml/Generator.php', '5a3249aadf1c427d62cd6f7755af3a73');
        $this->checkFile('include/Braintree/Braintree/Xml/Parser.php', 'cc36964857b3b047bb51c6037a3ffb43');
        $this->checkFile('include/Braintree/Braintree/Xml.php', '62034082a01ad35e5565e829f36809fd');
        $this->checkFile('include/Braintree/Braintree.php', '514aa2149af9ffc9a8257247227f43f0');
        $this->checkFile('include/Braintree/braintree.js', 'c3b0d76a16c55d22051753686b54e454');
        $this->checkFile('include/Braintree/ssl/api_braintreegateway_com.ca.crt', '04beb23c767547e980c76eb68c7eab15');
        $this->checkFile('include/Compiled/AffiliateLogin.php', 'ca5d088ac88ea5dcacd91479e4f49104');
        $this->checkFile('include/Compiled/AffiliateSignup.php', '8189c816b000898ae93a84566d45d600');
        $this->checkFile('include/Compiled/Banner.php', 'e0ebfee3b3266eb52d7e4a1e7e18060e');
        $this->checkFile('include/Compiled/Core.php', 'ff9f1b3d853be472ea210a3a54bc225c');
        $this->checkFile('include/Compiled/Impression.php', '2a7510b17828ba09ca6c308faa6b13e5');
        $this->checkFile('include/Compiled/Rpc.php', '531940bb19e65ae0905c6bb40695aeac');
        $this->checkFile('include/Compiled/Tracking.php', 'ab7f07c7a7f3319b58624affedad2340');
        $this->checkFile('include/Gpf/Api/Auth.class.php', 'd96a67fa098bc439d94267e7c0269775');
        $this->checkFile('include/Gpf/Api/AuthService.class.php', '989730caa998b720439f1c1b2342a188');
        $this->checkFile('include/Gpf/Api/DownloadAPI.class.php', '26cf3a9fe533fcb1cf2cd2f3cbc08573');
        $this->checkFile('include/Gpf/Api/IncompatibleVersionException.class.php', '246aff65d87797fe3adaae83589220c7');
        $this->checkFile('include/Gpf/Api/Session.class.php', 'bd95eb73a69a4299a7cc8fcabf8fdb02');
        $this->checkFile('include/Gpf/ApiModule.class.php', '1e2864f3e3ec4f97c11e3e24fdc76e85');
        $this->checkFile('include/Gpf/Application.class.php', 'b41f2a2bccdf581c2462c3c318d0f516');
        $this->checkFile('include/Gpf/ApplicationSettings.class.php', 'db716059e6f54045a45561a3987fe3ea');
        $this->checkFile('include/Gpf/AuditLog.class.php', '064f0f80dcb6a2a293d856c12513c766');
        $this->checkFile('include/Gpf/Auth/Anonym.class.php', '1fc4dbe93f89f42e212c3d6f7b7f6664');
        $this->checkFile('include/Gpf/Auth/BlockedIPAddressException.class.php', '9eeed2f20e51bc5e4d8d546948cbe460');
        $this->checkFile('include/Gpf/Auth/Exception.class.php', '32b4718d9f1d6d48ef576b8aae708c6b');
        $this->checkFile('include/Gpf/Auth/Info.class.php', '49c1b8162710179ee5b8b88ae9735bbd');
        $this->checkFile('include/Gpf/Auth/InfoAuthToken.class.php', '8798bbf6af9f15838885eee1af7e6eaa');
        $this->checkFile('include/Gpf/Auth/InfoAuthTokenApi.class.php', '81d8a3abf119a92e7c5de7cd35f675a6');
        $this->checkFile('include/Gpf/Auth/InfoOpenidToken.class.php', '26bb8dec1c31a50a7a66f9bec3bf08a0');
        $this->checkFile('include/Gpf/Auth/InfoUsernamePassword.class.php', '7847d7c06467640100cf53017726868b');
        $this->checkFile('include/Gpf/Auth/PasswordConstraintForm.class.php', '7f794b120a5411fb8d803d8ec3ecabd8');
        $this->checkFile('include/Gpf/Auth/PasswordSecure.class.php', '9b39978b22097dfe13516f90f6186711');
        $this->checkFile('include/Gpf/Auth/RequestNewPasswordMail.class.php', '0deff0f9cbdd9209ebf4b2543f880d8c');
        $this->checkFile('include/Gpf/Auth/Service.class.php', 'a4dd1cf152cd38886affe050887e0245');
        $this->checkFile('include/Gpf/Auth/User.class.php', '4f1babe6aeb598b0836850c5b5169991');
        $this->checkFile('include/Gpf/Auth/UserForm.class.php', '0c69981b0ac17269ae33cc3f62eb2bd9');
        $this->checkFile('include/Gpf/BarCode/BarCode.class.php', '189b4105c0525b1040f6925e3244ed01');
        $this->checkFile('include/Gpf/BarCode/Exception.class.php', '71549e6f13fb2da1342c51265a9a8bb1');
        $this->checkFile('include/Gpf/BarCode/Image.class.php', '265fe501df80a08f5902870b1a10ec2a');
        $this->checkFile('include/Gpf/BarCode/Type/BarCode.class.php', 'dd373c79225bac2f1cf33fab9a71a775');
        $this->checkFile('include/Gpf/BarCode/Type/C128A.class.php', '7890570351392b6234d10edf8c53498e');
        $this->checkFile('include/Gpf/BarCode/Type/C128B.class.php', '412f6b1d5b377f5cf56177441bce6a47');
        $this->checkFile('include/Gpf/BarCode/Type/C128C.class.php', 'dae997b7a0f1e35bcfa1dccd114ac494');
        $this->checkFile('include/Gpf/BarCode/Type/C39.class.php', '898d8e6f2b84e0d39a360fdc7a442e24');
        $this->checkFile('include/Gpf/BarCode/Type/I25.class.php', '16e9438cdb0d16347fe34af5c95ae35e');
        $this->checkFile('include/Gpf/BarCode/Type/lesser.txt', '7c45aba1c5df07e342d09a658cf8aecd');
        $this->checkFile('include/Gpf/Branding.class.php', 'f7cbd74f663ee0894a1222c41c9a56bf');
        $this->checkFile('include/Gpf/Browser.class.php', '050cd83393eebb455ae27861f7ac0818');
        $this->checkFile('include/Gpf/Build/Lang/CsvGenerator.class.php', '294d0d0144149d020a9a272cb5dd5abe');
        $this->checkFile('include/Gpf/Build/Lang/SourceParser.class.php', 'fdb077665a9f15797215fa6975b3770c');
        $this->checkFile('include/Gpf/CPanel/Account.class.php', '15019b09078372ea740a16a47b171d1e');
        $this->checkFile('include/Gpf/CPanel/AccountBandWidth.class.php', 'b181db8722a64b7ba7751e543b56fab6');
        $this->checkFile('include/Gpf/CPanel/CPanel.class.php', 'c28aae4533cee8b8643c9c728117b0f2');
        $this->checkFile('include/Gpf/CPanel/Whm.class.php', '8527868cca0d602e36eaf04766db0873');
        $this->checkFile('include/Gpf/Captcha.class.php', 'fbca7b55ad46d3395dafdb775d85e145');
        $this->checkFile('include/Gpf/Chart/DataRecordSet.class.php', '1c7facaa76e967ef94901738e67c3c2c');
        $this->checkFile('include/Gpf/Chart/Labels.class.php', 'ef844fa82b3fa99565009c9264875905');
        $this->checkFile('include/Gpf/ClassNotDefined.class.php', '0ef49c45c0e6762e6d284ef76c243e3c');
        $this->checkFile('include/Gpf/Common/ApplicationUtils.class.php', '9f8033dae809856d29ba293a6bf8c938');
        $this->checkFile('include/Gpf/Common/CallUrlAsync.class.php', '96a6d3623652ddc854bf765a55cda3cb');
        $this->checkFile('include/Gpf/Common/Captcha/ImageGenerator.class.php', 'e13bda3b7f35017b58dfc47c1a142a31');
        $this->checkFile('include/Gpf/Common/Captcha/RgbColor.class.php', '39df38d308eb66ff087e16926d54ab07');
        $this->checkFile('include/Gpf/Common/Captcha/font/actionj.ttf', '966fa0e7a1322981c3d26104178faa32');
        $this->checkFile('include/Gpf/Common/Captcha/font/bboron.ttf', '52d07189ae715fc37ac17759aa43cfd1');
        $this->checkFile('include/Gpf/Common/Captcha/font/epilog.ttf', '34dee525ef7b48ea88c3ee26cf45623b');
        $this->checkFile('include/Gpf/Common/Captcha/font/lexo.ttf', '20a3b78e438e555a2d61ba03f7ae080e');
        $this->checkFile('include/Gpf/Common/Captcha/font/license.txt', 'd8280381ae9860cb82ae291e97fed0a4');
        $this->checkFile('include/Gpf/Common/Captcha/font/tomnr.ttf', 'c332b75ec1079d13b0520913801adba1');
        $this->checkFile('include/Gpf/Common/ClassMerger.class.php', 'ea01e7a454d2ac27fa9a73a3a95456f6');
        $this->checkFile('include/Gpf/Common/CodeUtils/CodeBase.class.php', 'bb0f70c1bc0a4f44bb2f83149450ab8e');
        $this->checkFile('include/Gpf/Common/CodeUtils/CodeGenerator.class.php', 'e91a13167980549c4b06e360573f3f0b');
        $this->checkFile('include/Gpf/Common/CodeUtils/CodeValidator.class.php', '451d7b5a942d404d728043d44489ed29');
        $this->checkFile('include/Gpf/Common/ConnectionUtil.class.php', '4760edf113536ebc4b74e7e737c21b44');
        $this->checkFile('include/Gpf/Common/DateUtils.class.php', '761070c95e9a552df5b241fce18a9586');
        $this->checkFile('include/Gpf/Common/DeviceUtils.class.php', '97301ebcb8f5a480955d5053e8a94de2');
        $this->checkFile('include/Gpf/Common/MathUtils.class.php', '4092f69dd2070250cbdf8f8f7014fd7a');
        $this->checkFile('include/Gpf/Common/NumberUtils.class.php', 'ff2b20d155190307a830ca83154720d7');
        $this->checkFile('include/Gpf/Common/PdfUtils.class.php', 'f145445c1ede83da07f6729ab6265501');
        $this->checkFile('include/Gpf/Common/RecurrencePresets.class.php', 'f06a32df0d8a837ab4687fd84e485f80');
        $this->checkFile('include/Gpf/Common/SelectBuilderCompoundGridRecord.class.php', '1064d8d1a4106df7510401ba16f13796');
        $this->checkFile('include/Gpf/Common/SelectBuilderCompoundRecord.class.php', '147e4d40fd6a05e3f55048de3ec28ecc');
        $this->checkFile('include/Gpf/Common/SendCurlAsync.class.php', '891d32a1f950a729dccbe8c1099ef03e');
        $this->checkFile('include/Gpf/Common/Stream.class.php', 'cfd03df4f1f6c358b2ddaab2a1f093b7');
        $this->checkFile('include/Gpf/Common/String.class.php', 'bb2184e50b368b912dd139d165be4d1b');
        $this->checkFile('include/Gpf/Common/UrlUtils.class.php', '509498e425203a93d297bba2f0af67ab');
        $this->checkFile('include/Gpf/Common/UserRichListBox.class.php', 'b4867e26ae1c8275cbf639072605a54f');
        $this->checkFile('include/Gpf/Common/WhereClauseCompoundRecord.class.php', '30db553374cc83707894ff654586b6ab');
        $this->checkFile('include/Gpf/Contexts/Module.class.php', 'bd592e4654227adfc0ab84912e1d1ca8');
        $this->checkFile('include/Gpf/Country/Countries.class.php', 'bdc6cdf3f7d6f21a59cc8f7e5519c3b1');
        $this->checkFile('include/Gpf/Country/CountriesGrid.class.php', '5cf1847e2494d584fdc7fd75216b95a4');
        $this->checkFile('include/Gpf/Country/CountryData.class.php', 'c314ac293162a6297c71a38b9ad55812');
        $this->checkFile('include/Gpf/Country/CountryForm.class.php', '263bf76f5ad3c3bf9c246fe472f54b26');
        $this->checkFile('include/Gpf/Country/EuCountryData.class.php', '4881f87d95690746d2ec786c3e10662d');
        $this->checkFile('include/Gpf/Csv/DbFile.class.php', '665d49852f6c58351e3013afadd9e692');
        $this->checkFile('include/Gpf/Csv/DownloadFile.class.php', 'c9643420d554f72b92aa050b43c4a6e6');
        $this->checkFile('include/Gpf/Csv/DownloadServerExportFilesGrid.class.php', '31679825ae10447010438dd797106773');
        $this->checkFile('include/Gpf/Csv/ExportGridTask.class.php', '105c32393dc6f50e0857c79983b77c41');
        $this->checkFile('include/Gpf/Csv/ExportToCsvForm.class.php', 'ec485339de2ce782d398e08db09b140d');
        $this->checkFile('include/Gpf/Csv/File.class.php', 'eefb0d1c18858164b85bef129ef7aedf');
        $this->checkFile('include/Gpf/Csv/GeneratorResponse.class.php', '17746da10e05975fafdbe36eb0b2c6f4');
        $this->checkFile('include/Gpf/Csv/ImportExportGrid.class.php', '5c4576aaf8ad71ce35fabad83e1e6594');
        $this->checkFile('include/Gpf/Csv/ImportExportService.class.php', '4036f5562c483fe827a71cd8db98f444');
        $this->checkFile('include/Gpf/Csv/ImportFiles.class.php', '74c1dac06b7bd1974a141a0ae79d4441');
        $this->checkFile('include/Gpf/Csv/ImportTask.class.php', 'd48eec6222e75d4e06a657519a62dfbd');
        $this->checkFile('include/Gpf/Csv/NoCorrectImportFileException.class.php', '9386830e2b9ddf8327d007647fcb19b2');
        $this->checkFile('include/Gpf/Csv/ObjectImportExport.class.php', 'bd49673a6330a205cd4f29cb9fbfafaa');
        $this->checkFile('include/Gpf/Csv/Parser.class.php', 'd73660d5ade00f0966baa6803bb56bfa');
        $this->checkFile('include/Gpf/Csv/ServerExportFilesForm.class.php', '361264963cc8d4e529a68818e15d329f');
        $this->checkFile('include/Gpf/Csv/ServerExportFilesGrid.class.php', 'f9ff2650a80d518fa730f6260b23ca68');
        $this->checkFile('include/Gpf/Csv/UploadFile.class.php', '592e22e54a2cc1fb2b578be1023ca3c4');
        $this->checkFile('include/Gpf/Currency/Helper.class.php', '1765ebb7e1f52e928df84887172e37fa');
        $this->checkFile('include/Gpf/Currency/Updater.class.php', 'b295bb970a90d428ac724c7c68630228');
        $this->checkFile('include/Gpf/Data/Filter.class.php', 'fde97ebc00a6fbb151d023c0f23bdc26');
        $this->checkFile('include/Gpf/Data/Grid.class.php', '1a76f1885e0868db08ada135854de774');
        $this->checkFile('include/Gpf/Data/IndexedRecordSet.class.php', '5d534576695c88f02f8bf3a26d587f95');
        $this->checkFile('include/Gpf/Data/MenuItem.class.php', '08d83900c810a69fe0c21a1d5b2f205c');
        $this->checkFile('include/Gpf/Data/Record.class.php', '3f9226801e0f10045cce5e4ece924c76');
        $this->checkFile('include/Gpf/Data/RecordHeader.class.php', 'a314226b1ce230efe04092cbf97804a9');
        $this->checkFile('include/Gpf/Data/RecordSet.class.php', '3665f12cd9fd26717bd39c85509cfa5f');
        $this->checkFile('include/Gpf/Data/RecordSetNoRowException.class.php', 'ea6247ada3c504872eb92ce4a626ad4b');
        $this->checkFile('include/Gpf/Data/Row.class.php', 'dc700aef3e698aba31efb12e7100954c');
        $this->checkFile('include/Gpf/Data/Table.class.php', '2c4866beb4db82e7b7f8aabec2ad194d');
        $this->checkFile('include/Gpf/Data/Tree.class.php', 'c4547621811d3063f04a4f2e6f669e78');
        $this->checkFile('include/Gpf/Data/TreeNode.class.php', '9b46185804bad30ac1f2ff84e81fa1b8');
        $this->checkFile('include/Gpf/DateTime/Range.class.php', 'ded56060bf464ad5c032effee0fb40f1');
        $this->checkFile('include/Gpf/DateTime.class.php', 'd20d0ce4fb44e82ee38b1a23d36ba1cb');
        $this->checkFile('include/Gpf/Db/Account.class.php', '867b78b9db1fe1a81beb8cb78458e5f8');
        $this->checkFile('include/Gpf/Db/ActiveView.class.php', '278681958d8f910bc2e909496e6bfcdb');
        $this->checkFile('include/Gpf/Db/AuthUser.class.php', '4a800439f52ffb048149c7b54e37be5b');
        $this->checkFile('include/Gpf/Db/Broadcast.class.php', 'be8ed16d21c82f0c2adc73094b788925');
        $this->checkFile('include/Gpf/Db/Country.class.php', '78177a96790a96b3508d866554b493eb');
        $this->checkFile('include/Gpf/Db/Currency.class.php', '970e968deac2cd320677b689af038a2e');
        $this->checkFile('include/Gpf/Db/CurrencyRate.class.php', 'e533c01faab0263c22c00801cb63a120');
        $this->checkFile('include/Gpf/Db/Export.class.php', '75fc271ea11d6ecbbc962e7543a4ba89');
        $this->checkFile('include/Gpf/Db/FieldGroup.class.php', '3738f20b78abddf2676faf97d2f8bdab');
        $this->checkFile('include/Gpf/Db/File.class.php', 'c18a451e4f5db58191e5a6da30e76b06');
        $this->checkFile('include/Gpf/Db/FileContent.class.php', 'd5e146ef60fc7b4ad91b8848139a3e75');
        $this->checkFile('include/Gpf/Db/Filter.class.php', 'ed624218ead11a97879d98a6701c928e');
        $this->checkFile('include/Gpf/Db/FilterCondition.class.php', '8900c2d41948535e8dc1137d686eee24');
        $this->checkFile('include/Gpf/Db/Followup.class.php', '59e27ecc0e025e2c85c9fc23e82fc3bc');
        $this->checkFile('include/Gpf/Db/FormField.class.php', 'a8f6088059157960362a8748d84e2b0a');
        $this->checkFile('include/Gpf/Db/Gadget.class.php', '53e2388ff37c2ce07cbcf548665bfdc4');
        $this->checkFile('include/Gpf/Db/GadgetProperty.class.php', '02cfa8b0e590d45bd65cf68de37ad154');
        $this->checkFile('include/Gpf/Db/HierarchicalDataNode.class.php', '41604bba2c5a1c36e9267c4d8cbc0795');
        $this->checkFile('include/Gpf/Db/ImportExport.class.php', '9dbfb109952cc91335540dea0eb41240');
        $this->checkFile('include/Gpf/Db/JobsRun.class.php', '269e4af5ca462230b8713cf5e14b59ba');
        $this->checkFile('include/Gpf/Db/Language.class.php', '086ace253de856c0bbb02e2880973a0d');
        $this->checkFile('include/Gpf/Db/Log.class.php', '33e2efb64b4e9d8902adb175d77192e7');
        $this->checkFile('include/Gpf/Db/LoginHistory.class.php', '5a2e219b368a1e694e1ace30a753ecde');
        $this->checkFile('include/Gpf/Db/LoginUserAgent.class.php', '47c4a34b61f9a482c63c5147e64c1771');
        $this->checkFile('include/Gpf/Db/Mail.class.php', '8d3d907dad94f214494b6f8b11083881');
        $this->checkFile('include/Gpf/Db/MailAccount.class.php', '22105daffb387ad2c47564342cfa5b6b');
        $this->checkFile('include/Gpf/Db/MailAttachment.class.php', '1f66ce9ebccb97cd633ed5991f7b8d98');
        $this->checkFile('include/Gpf/Db/MailOutbox.class.php', '0c907c5814954e918a4f1b58e91d03e9');
        $this->checkFile('include/Gpf/Db/MailTemplate.class.php', '5dc93d140332e432410e773578cdee15');
        $this->checkFile('include/Gpf/Db/MailTemplateAttachment.class.php', 'fc7d0333428d04be25bda94ee88adaf2');
        $this->checkFile('include/Gpf/Db/Newsletter.class.php', 'a57ba9d88054a9ddd3db80cd52669b8e');
        $this->checkFile('include/Gpf/Db/NewsletterSignup.class.php', '6d1f714c27e21c469d93ffb3f638f8f1');
        $this->checkFile('include/Gpf/Db/NotificationRegistration.class.php', '222a09a12d517e99fdef98b51cb0c6ae');
        $this->checkFile('include/Gpf/Db/PasswordRequest.class.php', '98b2731728eb9102d5cd63b80effddb3');
        $this->checkFile('include/Gpf/Db/PlannedTask.class.php', '51e453e633eb39f16306584d93adfc64');
        $this->checkFile('include/Gpf/Db/QuickTask.class.php', '00efd5d66535cf3bca0e8186c53651cb');
        $this->checkFile('include/Gpf/Db/RateLimit.class.php', 'abfb519c1fd494d63631556954c8199e');
        $this->checkFile('include/Gpf/Db/RecurrencePreset.class.php', '5eff3297945bd08d3e2451d179226a0b');
        $this->checkFile('include/Gpf/Db/RecurrenceSetting.class.php', 'c796c12b0a698fadc06b9db8d12fbd22');
        $this->checkFile('include/Gpf/Db/Role.class.php', '7fcff87ecf22ebfc7f6f8d3f3878163b');
        $this->checkFile('include/Gpf/Db/RolePrivilege.class.php', 'd5a508c08285e232c45778f660b4cd6d');
        $this->checkFile('include/Gpf/Db/Session.class.php', 'cb9b149fb80006438f45fef83707ae84');
        $this->checkFile('include/Gpf/Db/SessionValue.class.php', 'c7869e27c70d3c9d825b2b71ea5fe130');
        $this->checkFile('include/Gpf/Db/Setting.class.php', 'd3bd6076065a9b97812dce334ff6ce43');
        $this->checkFile('include/Gpf/Db/Table/Accounts.class.php', '677650b9628bd5dc7d86a1999d375d77');
        $this->checkFile('include/Gpf/Db/Table/ActiveViews.class.php', '1c82823caf72c1c9c8bf92c71918e7df');
        $this->checkFile('include/Gpf/Db/Table/AuthUsers.class.php', '57ba60273c87a46d89b9a6dc8b838121');
        $this->checkFile('include/Gpf/Db/Table/Broadcasts.class.php', '6761706af9a7df4dfa16c9d8fdfaf8e6');
        $this->checkFile('include/Gpf/Db/Table/Constraints/UsersUniqueConstraint.class.php', '947ac8129cdc8703e29f9d6064904b28');
        $this->checkFile('include/Gpf/Db/Table/Countries.class.php', '3ccc5c1fc3923543ad21fb0fe9b5f199');
        $this->checkFile('include/Gpf/Db/Table/Currencies.class.php', 'da21a1d07eb792450dc48188852c3fea');
        $this->checkFile('include/Gpf/Db/Table/CurrencyRates.class.php', '08f031c70b901e049972854f249f9533');
        $this->checkFile('include/Gpf/Db/Table/Exports.class.php', '62c6218000c5f493fdbec96824ab65b7');
        $this->checkFile('include/Gpf/Db/Table/FieldGroups.class.php', '0ec7bc5feb7dd190ecb4ff96710bf409');
        $this->checkFile('include/Gpf/Db/Table/FileContents.class.php', 'eec1c03841065d8106f7c84e251645f1');
        $this->checkFile('include/Gpf/Db/Table/Files.class.php', 'b87aaf00116cc1d2cae11df86161da2a');
        $this->checkFile('include/Gpf/Db/Table/FilterConditions.class.php', 'b57c6e0049b462125c085607bd5667ac');
        $this->checkFile('include/Gpf/Db/Table/Filters.class.php', '9aaafeba6c7553be8971b4cd5a5eee60');
        $this->checkFile('include/Gpf/Db/Table/Followups.class.php', '0f9502e9ba31ebfe2f94dacc18b1cf9a');
        $this->checkFile('include/Gpf/Db/Table/FormFields.class.php', '9bcb1c30b3f9a388d6a7eec864a371a0');
        $this->checkFile('include/Gpf/Db/Table/GadgetProperties.class.php', '7209a4b53e0bf11f648f07ba3d50ad19');
        $this->checkFile('include/Gpf/Db/Table/Gadgets.class.php', 'cafa7210df668fb80138860af0d9ce33');
        $this->checkFile('include/Gpf/Db/Table/HierarchicalDataNodes.class.php', 'd08fa9bfe98e3747560a8d413afcd165');
        $this->checkFile('include/Gpf/Db/Table/ImportExports.class.php', '9c35d262b2b28631d87e1c35a245d3c8');
        $this->checkFile('include/Gpf/Db/Table/JobsRuns.class.php', 'b63efc7f980cbf6b36436fe3a357b6c2');
        $this->checkFile('include/Gpf/Db/Table/Languages.class.php', '90297252c4a2a36f31ccfdd219cbb5a0');
        $this->checkFile('include/Gpf/Db/Table/LoginUserAgents.class.php', 'e1d02dffac0c318d9f921a36d9747459');
        $this->checkFile('include/Gpf/Db/Table/LoginsHistory.class.php', '42920cfaadf14b2596c7ef1755b309cb');
        $this->checkFile('include/Gpf/Db/Table/Logs.class.php', '5cfaabea87fe50588e2ee83d9e8508d4');
        $this->checkFile('include/Gpf/Db/Table/MailAccounts.class.php', 'ebc498850640e75b3e1b86db72687d1a');
        $this->checkFile('include/Gpf/Db/Table/MailAttachments.class.php', '763c0b98c3dc8aedbd822cc4d85caaa7');
        $this->checkFile('include/Gpf/Db/Table/MailOutbox.class.php', 'b2fe9d6d3d44d1338831887e408419ac');
        $this->checkFile('include/Gpf/Db/Table/MailTemplateAttachments.class.php', '2b3e2a5f10668f5977afc9201f67e993');
        $this->checkFile('include/Gpf/Db/Table/MailTemplates.class.php', '863940ffdf1d62b9c8268fadafb9c2e6');
        $this->checkFile('include/Gpf/Db/Table/Mails.class.php', '0f4c1a95f97899db4df6d8d9fa64d87f');
        $this->checkFile('include/Gpf/Db/Table/NewsletterSignups.class.php', '7a53751a00ac8b0c51d15037f13f21a1');
        $this->checkFile('include/Gpf/Db/Table/Newsletters.class.php', '7901a59b7cc3fd001f9a145e7f805561');
        $this->checkFile('include/Gpf/Db/Table/NotificationRegistrations.class.php', '754218a76762e6dec731ac80bd6c7408');
        $this->checkFile('include/Gpf/Db/Table/PasswordRequests.class.php', '4405464811cc29a8945d745634bb1562');
        $this->checkFile('include/Gpf/Db/Table/PlannedTasks.class.php', 'cbbd44df115e8bd05a5c3d721085fdc0');
        $this->checkFile('include/Gpf/Db/Table/QuickTasks.class.php', 'd22c965a70332db5a8b3e305b21b7fea');
        $this->checkFile('include/Gpf/Db/Table/RateLimits.class.php', 'd8e2d088162f3d2fdf9e7d2da2b02b74');
        $this->checkFile('include/Gpf/Db/Table/RecurrencePresets.class.php', '3b59d1cf63eeda1455b2242fd94af057');
        $this->checkFile('include/Gpf/Db/Table/RecurrenceSettings.class.php', 'd5156d750e785279be961d027928e5eb');
        $this->checkFile('include/Gpf/Db/Table/RolePrivileges.class.php', '71e8950543e574bf216c017b0799d648');
        $this->checkFile('include/Gpf/Db/Table/Roles.class.php', '72afe0af0cc7b4d44df6f0dc5b5c7a34');
        $this->checkFile('include/Gpf/Db/Table/SessionValues.class.php', '4d06e65105caa89ba6ace73261cce931');
        $this->checkFile('include/Gpf/Db/Table/Sessions.class.php', 'd9f380dc75ad81dffeef62ed95b07f6d');
        $this->checkFile('include/Gpf/Db/Table/Settings.class.php', '609fe68156b8abea3b677279fa7369e8');
        $this->checkFile('include/Gpf/Db/Table/Tasks.class.php', 'a3d4c3fe0103c8999a95b2ef081e6692');
        $this->checkFile('include/Gpf/Db/Table/ThemeConfigs.class.php', 'b8d1a7d1161f47ff920cbb601bd98b90');
        $this->checkFile('include/Gpf/Db/Table/ThemeTemplates.class.php', '34c3e10ca30007f56b292369bede2975');
        $this->checkFile('include/Gpf/Db/Table/TokenBuckets.class.php', '8e1f962f44233ee916b4a777e3e02b6e');
        $this->checkFile('include/Gpf/Db/Table/Translations.class.php', '56bcb70fb400fff957d65a622ea2886d');
        $this->checkFile('include/Gpf/Db/Table/UserAttributes.class.php', 'e8d4948e427e7b33c1770aaa45e12460');
        $this->checkFile('include/Gpf/Db/Table/UserBroadcasts.class.php', '8a1e63d19d47ef4df42128c6aad6f465');
        $this->checkFile('include/Gpf/Db/Table/UserFollowups.class.php', 'edcdae4f1f26110bc2aaf2857269c8b4');
        $this->checkFile('include/Gpf/Db/Table/Users.class.php', '0b59c9b390dc6a1d3c27ea7c967306a2');
        $this->checkFile('include/Gpf/Db/Table/Versions.class.php', '2c93eb25038c85bb3faa42ef9e7af8de');
        $this->checkFile('include/Gpf/Db/Table/ViewColumns.class.php', 'c126551aec175c5c709dc325b8e707f7');
        $this->checkFile('include/Gpf/Db/Table/Views.class.php', 'f93ab19a9aa71b969f4433769430b5c3');
        $this->checkFile('include/Gpf/Db/Table/Wallpapers.class.php', '0ea3793687ab3e23e1893bf7531b787f');
        $this->checkFile('include/Gpf/Db/Table/Windows.class.php', '64b66930f0d8ed24d8743d2585fd72b0');
        $this->checkFile('include/Gpf/Db/Table/Words.class.php', '5af36172b301b46f4dfb60dda4aaad60');
        $this->checkFile('include/Gpf/Db/Task.class.php', 'a46007b7975f0880dbbfbe1c2e5809ed');
        $this->checkFile('include/Gpf/Db/ThemeConfig.class.php', '80709332254de8262772f5448852eb90');
        $this->checkFile('include/Gpf/Db/ThemeTemplate.class.php', '08f0d5d18e78ab6bb1ccd5817bd4b963');
        $this->checkFile('include/Gpf/Db/TokenBucket.class.php', 'b551b978c03e278ea0ae8a2ced71dbb1');
        $this->checkFile('include/Gpf/Db/Translation.class.php', '858c5924afc2d6864cfd609d1b1ede48');
        $this->checkFile('include/Gpf/Db/User.class.php', '4ee961e1bf1a697341e8b4ea531d6ada');
        $this->checkFile('include/Gpf/Db/UserAttribute.class.php', '64b405cc9f3f1f9fc2d93836dd0b9dab');
        $this->checkFile('include/Gpf/Db/UserBroadcast.class.php', '8c0ef3602e800a334deccad408ddf4cd');
        $this->checkFile('include/Gpf/Db/UserFollowup.class.php', '22468856748a7ea5b1809ca91437a00b');
        $this->checkFile('include/Gpf/Db/Version.class.php', '377d095e4c957a0abd019b233032cff1');
        $this->checkFile('include/Gpf/Db/View.class.php', '7e8e61375be9225f60800fa7c2f0af6c');
        $this->checkFile('include/Gpf/Db/ViewColumn.class.php', 'f0ba04082102fb70148330f5630e3d26');
        $this->checkFile('include/Gpf/Db/Wallpaper.class.php', '238696470cb2c787a9bd39cf7544b734');
        $this->checkFile('include/Gpf/Db/Window.class.php', '895b5fe21ab2a904ff446fd964fe5e4a');
        $this->checkFile('include/Gpf/Db/Word.class.php', 'ffe13ab33a279d2613b48855139863b0');
        $this->checkFile('include/Gpf/DbEngine/CantConnectException.class.php', '5fd2f53ebc52cb9ff41508649ea67a8e');
        $this->checkFile('include/Gpf/DbEngine/CascadeDeleteConstraint.class.php', '06871b08f657dacd224d2bd25041b92b');
        $this->checkFile('include/Gpf/DbEngine/Column.class.php', '284ea07b4f368d45d2715b100d1275e7');
        $this->checkFile('include/Gpf/DbEngine/ConnectionGoneException.class.php', '160dbf2d7a7b6646b8225b879318a617');
        $this->checkFile('include/Gpf/DbEngine/Database.class.php', '05aa2e8d1a77485d55635fc1b533fc7c');
        $this->checkFile('include/Gpf/DbEngine/DeleteConstraint.class.php', 'e62e8590c5c08cc0378cc37eb1161982');
        $this->checkFile('include/Gpf/DbEngine/Driver/Mysql/Database.class.php', '93b8c42bcff1dccc1e7a386384101c4d');
        $this->checkFile('include/Gpf/DbEngine/Driver/Mysql/Exception.class.php', 'e68b634f161bf35f64bd7ec0c44061fe');
        $this->checkFile('include/Gpf/DbEngine/Driver/Mysql/Statement.class.php', '51ae4964b3345fbc35e86b2d6d9adfde');
        $this->checkFile('include/Gpf/DbEngine/Driver/Pdo/Database.class.php', '4a3b2b5784c0c782f02afa26834c5b3f');
        $this->checkFile('include/Gpf/DbEngine/Driver/Pdo/Statement.class.php', '3e78bde1d453e83e14fc85ca9b8fa7cc');
        $this->checkFile('include/Gpf/DbEngine/DuplicateEntryException.class.php', '865513d6411b3fb269e886cbd5db72f9');
        $this->checkFile('include/Gpf/DbEngine/Exception.class.php', '688ecfd9caeab7e5a1e264f7da1ddde5');
        $this->checkFile('include/Gpf/DbEngine/LockException.class.php', 'aea6b05a848084e5defa75273af05520');
        $this->checkFile('include/Gpf/DbEngine/Maintenance.class.php', '2d4e2c57eaad1abcce435279795ccd3c');
        $this->checkFile('include/Gpf/DbEngine/Mysql/Engine.class.php', '5268f4338a16c852ddc1523af2d4f838');
        $this->checkFile('include/Gpf/DbEngine/Mysql/SqlException.class.php', '9e77cb9d104860105716b2b05fb67243');
        $this->checkFile('include/Gpf/DbEngine/NoRowException.class.php', 'da135abbd5c593c0a9b6a3ed9a9884e1');
        $this->checkFile('include/Gpf/DbEngine/RestrictDeleteConstraint.class.php', '84dc24819941527c61be4d84298604a6');
        $this->checkFile('include/Gpf/DbEngine/RestrictDeleteException.class.php', 'e155ca87149ae4cbc970cf0f5e5dbb35');
        $this->checkFile('include/Gpf/DbEngine/Row/CheckException.class.php', 'b794d63f1666dd3cad8670014a112c1c');
        $this->checkFile('include/Gpf/DbEngine/Row/Collection.class.php', '9cdb03e6ff7d1a7713ee56ef600a0388');
        $this->checkFile('include/Gpf/DbEngine/Row/ColumnsNotEqualConstraint.class.php', '6345098f3e54e1cc7fc18082c8e70065');
        $this->checkFile('include/Gpf/DbEngine/Row/CompoundConstraint.class.php', 'c3afa95e3b819f046705e552579f51c0');
        $this->checkFile('include/Gpf/DbEngine/Row/Constraint.class.php', 'c2321c82ebee697ae01186260ef9f83e');
        $this->checkFile('include/Gpf/DbEngine/Row/ConstraintException.class.php', '4a2fa023846d8f4a4c5b9ab8cdf435dc');
        $this->checkFile('include/Gpf/DbEngine/Row/ExactlyOneConstraint.class.php', 'cd4a1012390db6c77bb05f4e81187d2e');
        $this->checkFile('include/Gpf/DbEngine/Row/LengthConstraint.class.php', 'df992daf2b4c405d8136891a8ab9cf72');
        $this->checkFile('include/Gpf/DbEngine/Row/MandatoryConstraint.class.php', '91f01936cddd091641559eaf52e4157b');
        $this->checkFile('include/Gpf/DbEngine/Row/MissingFieldException.class.php', '90556a4ce5c5d1052dc51a3872b8799a');
        $this->checkFile('include/Gpf/DbEngine/Row/NumberConstraint.class.php', 'f680e9182babac9f954e6025f567708f');
        $this->checkFile('include/Gpf/DbEngine/Row/RegExpConstraint.class.php', '7142690fe62f65f7c1d0c98a02ef7522');
        $this->checkFile('include/Gpf/DbEngine/Row/RelationConstraint.class.php', '54d8f4f6bab51a19d45b39b416207b9d');
        $this->checkFile('include/Gpf/DbEngine/Row/SmartyConstraint.class.php', '5971eecf88ec24c51a54bd45b6da50f5');
        $this->checkFile('include/Gpf/DbEngine/Row/UniqueConstraint.class.php', 'e6cc5be14e5aff474d745ee992ad3ca4');
        $this->checkFile('include/Gpf/DbEngine/Row.class.php', 'fe038e6633d16744d3994909ec5924d2');
        $this->checkFile('include/Gpf/DbEngine/RowBase.class.php', 'adaece7c4bbfebed5a30ca5475895f42');
        $this->checkFile('include/Gpf/DbEngine/RowComposite.class.php', '923c92569ea40f8914cc1c5c90e4dc67');
        $this->checkFile('include/Gpf/DbEngine/SetNullDeleteConstraint.class.php', '359f2eb77cd3094857c403ebefa68837');
        $this->checkFile('include/Gpf/DbEngine/SqlException.class.php', 'd73783a8ec7add5382c0a431c09c32e8');
        $this->checkFile('include/Gpf/DbEngine/Statement.class.php', '6023d5b8f93911adf8a8d4ad75443803');
        $this->checkFile('include/Gpf/DbEngine/Table.class.php', '906c6b454c0e1c597935d275169b16e3');
        $this->checkFile('include/Gpf/DbEngine/TooManyConnectionsException.class.php', '2f73d0139b623331ecdbdfe5126fae1e');
        $this->checkFile('include/Gpf/DbEngine/TooManyRowsException.class.php', '7c3141ed44c64b653ecac85021339486');
        $this->checkFile('include/Gpf/Definition.class.php', '3079ba825145a50d4d7cbdee57b5f427');
        $this->checkFile('include/Gpf/Desktop/QuickLaunch.class.php', 'f4adf2e255e698980dd58aa211a67c91');
        $this->checkFile('include/Gpf/Desktop/Theme.class.php', '03fc88b817f7ec20ec709a1113a63ed8');
        $this->checkFile('include/Gpf/Desktop/ThemeManager.class.php', 'f0b0ef9f9878c2a6fdb5c7e27640ebc4');
        $this->checkFile('include/Gpf/Desktop/WallPaper.class.php', 'd6dec26447bd7b9018c41536ee728879');
        $this->checkFile('include/Gpf/Desktop/WindowManager.class.php', '00e8ec6df715add3067a6ec6138f3bdf');
        $this->checkFile('include/Gpf/Encrypt/Algorithm/AesCbc.class.php', '549d326d6b27a34155bbfe1dea6afe91');
        $this->checkFile('include/Gpf/Encrypt/Algorithm/AesCbcMcrypt.class.php', '8249a940d770593b78f39f349f1576dc');
        $this->checkFile('include/Gpf/Encrypt/Algorithm/RC4.class.php', '45fae3510263dc1313416d37952ae6a6');
        $this->checkFile('include/Gpf/Exception.class.php', 'f0e5086ced5db83bc2b3338371faebca');
        $this->checkFile('include/Gpf/File/Config.class.php', '37e94b31fa4de406f39f1335edeab951');
        $this->checkFile('include/Gpf/File/DbDownload.class.php', 'f3f04a180d338d1483842516055e9cb4');
        $this->checkFile('include/Gpf/File/DbIconUpload.class.php', '6727438e0f6e6618227d5c0ea0a9713d');
        $this->checkFile('include/Gpf/File/DbImageUpload.class.php', '255e571d8c2c2094be3aa0b54c10e5ea');
        $this->checkFile('include/Gpf/File/DbThemeUpload.class.php', '8397922f13b616056b9944ab3279b8ae');
        $this->checkFile('include/Gpf/File/DbUpload.class.php', 'e2919d0eb9c8cefb0ed6d766c8680828');
        $this->checkFile('include/Gpf/File/Download/Db.class.php', '4e25c4af4a30bb70c25077dfd7d90031');
        $this->checkFile('include/Gpf/File/Download/FileSystem.class.php', '9fc5581cb25a46d0eebb94fed6269179');
        $this->checkFile('include/Gpf/File/Download/String.class.php', 'aa611c8f74da22a64e9084bbd803ce38');
        $this->checkFile('include/Gpf/File/Download.class.php', 'dd8761e5d518b89da01972aa4360a407');
        $this->checkFile('include/Gpf/File/DownloadDriver.class.php', '19dd704ff7589a78fec6ec17ef54a0d5');
        $this->checkFile('include/Gpf/File/FilesTree.class.php', '993821baa956997412ff4c1a14c76f79');
        $this->checkFile('include/Gpf/File/Settings.class.php', 'de056e2c9c7e01370fd3330f7f23d2d6');
        $this->checkFile('include/Gpf/File/UploadBase.class.php', '193ba31c7257268c8aa14e58c91402e4');
        $this->checkFile('include/Gpf/FormHandler.class.php', 'e2ea54062a125aa0b28aadd30b3de78e');
        $this->checkFile('include/Gpf/Gadget/Content.class.php', '3d9b74900e043360c9dafd4cd6ebe62a');
        $this->checkFile('include/Gpf/Gadget/Factory.class.php', 'ae9a7fe4fe2a02fcca863f5b61d8826e');
        $this->checkFile('include/Gpf/Gadget/GadgetForm.class.php', '6423ae4663f923b397b84194cb80798a');
        $this->checkFile('include/Gpf/Gadget/GadgetGrid.class.php', '2c7780e6d91e2567e5ea0515e1e0f1c2');
        $this->checkFile('include/Gpf/Gadget/Google.class.php', '7132034f00c5ff501183e3a94e3a2695');
        $this->checkFile('include/Gpf/Gadget/Rss.class.php', 'cfa361589fac8fabc2f3a7d0a6c13772');
        $this->checkFile('include/Gpf/Gadget/Uwa.class.php', 'e169f8aae64442dbf45eb84a80f55bf3');
        $this->checkFile('include/Gpf/Gadget.class.php', 'f10bf954f2cabd9541176074f0a341cf');
        $this->checkFile('include/Gpf/GadgetManager.class.php', 'd384dc249e1564556464b22f529d2da8');
        $this->checkFile('include/Gpf/Http.class.php', '24edc9a66e21401752a57935b450b69a');
        $this->checkFile('include/Gpf/HttpResponse.class.php', '0b0896414acb68b4625f9c299047669c');
        $this->checkFile('include/Gpf/IconSet.class.php', '50055c7ef668ec72db05c72a2595c306');
        $this->checkFile('include/Gpf/Install/AcceptLicense.class.php', '73b3de0d9302bb73e50a970104214c89');
        $this->checkFile('include/Gpf/Install/CheckModSecRpcCaller.class.php', '58c5c31ad699f0fb9a5c2318238e8e27');
        $this->checkFile('include/Gpf/Install/CheckRequirements.class.php', '1c8d592e65f5e474cc86b8c44e37bb32');
        $this->checkFile('include/Gpf/Install/CleanInstallScenario.class.php', 'da856759b75b2c7ab26c1d725f1c518f');
        $this->checkFile('include/Gpf/Install/CreateAccount.class.php', '31dae34c46d84e23c876ab094058477d');
        $this->checkFile('include/Gpf/Install/CreateAccountTask.class.php', '4fd7fb1d82963851aad11ff33a21aa2b');
        $this->checkFile('include/Gpf/Install/CreateDatabase.class.php', '3aaeab82d35e2c13211bfc471e8d97e6');
        $this->checkFile('include/Gpf/Install/CreateDatabaseTask.class.php', '4d3f068bb69a0febb022b8ea964de2e2');
        $this->checkFile('include/Gpf/Install/DbFile.class.php', 'f61a778a9233764702e7345ed6ee4c3c');
        $this->checkFile('include/Gpf/Install/DoneScenario.class.php', 'edc2ea398c95ac26130b8b410178c37e');
        $this->checkFile('include/Gpf/Install/ExecuteSQLFileTask.class.php', '07a2f0a12c7b3b0026cb456bb8f50eb1');
        $this->checkFile('include/Gpf/Install/Finished.class.php', '09b47ca400c397d2c11e0171ff324088');
        $this->checkFile('include/Gpf/Install/IntegrityCheck.class.php', '5da85e9b576dab15f3f6e5a021995d22');
        $this->checkFile('include/Gpf/Install/LicenseInfo.class.php', 'cb2761f80b1c4f162a05370772fa881c');
        $this->checkFile('include/Gpf/Install/LicenseManager.class.php', 'ee10b633c0c4e211bc460b428b8a83e8');
        $this->checkFile('include/Gpf/Install/LicenseValidationException.class.php', '995374f2f7d85de632b2f2cb5a172624');
        $this->checkFile('include/Gpf/Install/Manager.class.php', 'ddabcd7e758f471afc5a68e218d1b1f8');
        $this->checkFile('include/Gpf/Install/Module.class.php', '599585dadcf23ea0d2212bf46188ceef');
        $this->checkFile('include/Gpf/Install/PhpDbFile.class.php', 'c0da02d965937f6662ac53ceeddbb1a4');
        $this->checkFile('include/Gpf/Install/RecommendedSettings.class.php', '96630c07d31adcd5966fb308c4dcca9b');
        $this->checkFile('include/Gpf/Install/Requirements.class.php', '2519d2280d1ef8edff2059c41a0fa2e7');
        $this->checkFile('include/Gpf/Install/Scenario.class.php', '2529bdcaaba3174dcd9e0d476aeada1b');
        $this->checkFile('include/Gpf/Install/SelectLanguage.class.php', '8551fd1612c929543b947b452b5edb1f');
        $this->checkFile('include/Gpf/Install/SelectTimezone.class.php', 'a6f29b2fcf0ac2ff10a1e8f9cd857091');
        $this->checkFile('include/Gpf/Install/SqlFile.class.php', '9a34ac6a1d59186ac567e64c65910cfa');
        $this->checkFile('include/Gpf/Install/Step.class.php', '10b742f4e954711bb3b144914f674e3e');
        $this->checkFile('include/Gpf/Install/UpdateAccount.class.php', 'f925b4e8147ffcc307c79eb354805c70');
        $this->checkFile('include/Gpf/Install/UpdateAccountTask.class.php', '698ad7c5c5dc46df2a872f0b6294b434');
        $this->checkFile('include/Gpf/Install/UpdateApplication.class.php', 'e33ce4548ccdae6b7af689464a16b6a6');
        $this->checkFile('include/Gpf/Install/UpdateFiles.class.php', '85531606a7f98e5d29d06713b1aaa9a5');
        $this->checkFile('include/Gpf/Install/UpdateScenario.class.php', '8ebfcc4c4479ed0c0926fe384b712cb3');
        $this->checkFile('include/Gpf/Install/Url.class.php', '2a787dd4c28d4b9b00de3cd0e4efecae');
        $this->checkFile('include/Gpf/IntegrityCheck.class.php', '809b2ecafc3d1b38f90c4e8cfa37db75');
        $this->checkFile('include/Gpf/Io/Csv/Reader.class.php', '6ea353c64ab682c26427ca47fd269802');
        $this->checkFile('include/Gpf/Io/Csv/Writer.class.php', '63fd13111d8b163be06759b9742f745d');
        $this->checkFile('include/Gpf/Io/DatabaseStorage.class.php', '980ddcfea159836e8000fa294c6bdd69');
        $this->checkFile('include/Gpf/Io/DirectoryIterator.class.php', '0d4c0a5f00741e06a086cbbd08da9ec8');
        $this->checkFile('include/Gpf/Io/File.class.php', 'd3f4f6509fa7b0d230dc5e075f945301');
        $this->checkFile('include/Gpf/Io/FileException.class.php', '93b7678e23fc628be17bbd58c58e5a55');
        $this->checkFile('include/Gpf/Io/LineWriter.class.php', '9d90941761f9a21f922cdacf9cd7724e');
        $this->checkFile('include/Gpf/Io/MimeTypes.class.php', '7c56648988d23c7408205825af2e8f15');
        $this->checkFile('include/Gpf/Lang/AddLanguageGrid.class.php', 'b79a6176aafd5257be29ca95049c3684');
        $this->checkFile('include/Gpf/Lang/CachedLanguageFile.class.php', '778f820341035a74268c7664971b7749');
        $this->checkFile('include/Gpf/Lang/ClientModuleProvider.class.php', '843f0c67446fd02ad603d79b5f78fda5');
        $this->checkFile('include/Gpf/Lang/CsvExporter.class.php', '6dcbcd97a59dfdb2ce1d2b955afdef4c');
        $this->checkFile('include/Gpf/Lang/CsvHandler.class.php', '6f8c27797fd5c3521e0af7cea03c38ac');
        $this->checkFile('include/Gpf/Lang/CsvLanguage.class.php', 'd5a31b6af5655c8003e1c3d15fec6d1a');
        $this->checkFile('include/Gpf/Lang/Dictionary.class.php', '27d501eb0300e1fd015003534c6a04cf');
        $this->checkFile('include/Gpf/Lang/DownloadStream.class.php', 'ab8cea53d458d2e47d33b62e1efa21d8');
        $this->checkFile('include/Gpf/Lang/ImportCustomLanguageTask.class.php', '1b824c0e90761722e1ddebed3a7b1b90');
        $this->checkFile('include/Gpf/Lang/ImportCustomLanguageTaskUploadCsv.class.php', 'fcc8b65ba0ea524804fdef35540f897e');
        $this->checkFile('include/Gpf/Lang/ImportLanguage.class.php', '8d89aff9a06382ef5ffe009d49f6b03c');
        $this->checkFile('include/Gpf/Lang/ImportLanguageTask.class.php', 'ff25c4d198adcbe1ad563c7f266168f6');
        $this->checkFile('include/Gpf/Lang/Language.class.php', '5ec29dd27ffa86a3a9e0745bcd5e2c97');
        $this->checkFile('include/Gpf/Lang/LanguageCreateNewForm.class.php', '6b13d4c2887d7f9d2851be52cb885c22');
        $this->checkFile('include/Gpf/Lang/LanguageTranslationsGrid.class.php', '110bec8af38da4b6900adea22e9ee5f5');
        $this->checkFile('include/Gpf/Lang/LanguageTranslationsGridRow.class.php', '774930d77b039736f39f1bf7fa181971');
        $this->checkFile('include/Gpf/Lang/LanguagesGrid.class.php', '7d2b92bea91d69194e56bfac3d3de22b');
        $this->checkFile('include/Gpf/Lang/LanguagesGridRow.class.php', '2c63ceb6ddbc682867c79fa34f7a9ec5');
        $this->checkFile('include/Gpf/Lang/MigrateLanguageTask.class.php', 'a05150db4172629d9ac1cad21fc59b27');
        $this->checkFile('include/Gpf/Lang/Parser/Sources.class.php', '95d6349601fd194e552686fde4d1cde6');
        $this->checkFile('include/Gpf/Lang/Parser/Translation.class.php', '49fdac268336e4a172b67f16be6c9463');
        $this->checkFile('include/Gpf/Lang/Storage/CacheFile.class.php', 'fcbd69b94d8e3e68ee5d45776275e812');
        $this->checkFile('include/Gpf/Lang/Storage/CsvFile.class.php', 'eee68ccf85f46187218bb4d1df5eb735');
        $this->checkFile('include/Gpf/Lang/Storage/Database.class.php', 'a2a30d5176f2697f8905926fd43a2104');
        $this->checkFile('include/Gpf/Lang/Storage/cachefile.tpl', '35ae9f18af9c2b413a59c30b6dfaa9db');
        $this->checkFile('include/Gpf/Lang/Storage.class.php', '046998fb9f61f307f99a9ea7f403f5cf');
        $this->checkFile('include/Gpf/Lang/TranslationMetaData.class.php', '1696e844ef7f273692879429ac8ba530');
        $this->checkFile('include/Gpf/Lang.class.php', 'def02d788e2da315ca9af1d7d3091010');
        $this->checkFile('include/Gpf/License/InvalidLicenseException.class.php', '6bcad33de617003463694b2b582f0853');
        $this->checkFile('include/Gpf/License/Processor.class.php', 'd6030ba496bf2f179c303b9b45be6531');
        $this->checkFile('include/Gpf/Log/Benchmark.class.php', 'ccde8ad6b21feb64a06c876e3fc4ef17');
        $this->checkFile('include/Gpf/Log/DeleteEventsTask.class.php', 'b2693be68797910ac11423ab23dec282');
        $this->checkFile('include/Gpf/Log/DeleteLoginsHistoryTask.class.php', '3159974c10da133449fec0a31862d027');
        $this->checkFile('include/Gpf/Log/DeleteTaskBase.class.php', '9628659a0314028cd9e08d3083d9746a');
        $this->checkFile('include/Gpf/Log/Exception.class.php', 'f3901a09345002f996f3fc0129652c52');
        $this->checkFile('include/Gpf/Log/Logger.class.php', '2dc351ed2a045c4498388f5671a4a93d');
        $this->checkFile('include/Gpf/Log/LoggerBase.class.php', '8b1e34616ec1649013c05ab3b44c650d');
        $this->checkFile('include/Gpf/Log/LoggerDatabase.class.php', '9f54a19f3e691e41a00962c0af1dd7f1');
        $this->checkFile('include/Gpf/Log/LoggerDisplay.class.php', '96f7501f6197dc9ef0645cd0fa073735');
        $this->checkFile('include/Gpf/Log/LoggerFile.class.php', '2f89e3057ba2a25e6af7f6dfe8e9dae0');
        $this->checkFile('include/Gpf/Log/Logs.class.php', 'b576896569b0d2b03cb307edcdeff7ae');
        $this->checkFile('include/Gpf/Log/LogsForm.class.php', '34e37b67e82428898138b3c005b502d2');
        $this->checkFile('include/Gpf/Log.class.php', '47e3c0ab579b9008151eba14dfd7c042');
        $this->checkFile('include/Gpf/LoginModule.class.php', 'b30f88ad822510b0b793f095f9d10b6a');
        $this->checkFile('include/Gpf/Mail/DbFileUpload.class.php', 'ef58416c8826a46aa0389035597e5ff9');
        $this->checkFile('include/Gpf/Mail/DeleteMailsTask.class.php', 'ca2278b8e36decaa9156d4b23dd1c9f5');
        $this->checkFile('include/Gpf/Mail/EmailAccountTestMail.class.php', '19fb0e821104d37e02d8f877146b751f');
        $this->checkFile('include/Gpf/Mail/EmailSettingsForms.class.php', 'e5ccb59d67310a75d766e95f15f64600');
        $this->checkFile('include/Gpf/Mail/EmailTemplateEditForm.class.php', 'be8050a2be03e58d4ff471ae8faf816a');
        $this->checkFile('include/Gpf/Mail/EmailValidator.class.php', 'b38f71892a40a7028883e1d41665f303');
        $this->checkFile('include/Gpf/Mail/Exception.class.php', '20f83c1581d2e8c030f6e7acbd34cada');
        $this->checkFile('include/Gpf/Mail/Fetcher/Imap.class.php', '8c049dbcdb7b9d2010e7d29bce836dab');
        $this->checkFile('include/Gpf/Mail/Footer.class.php', 'de784b5a9f1f5e79eca2165c181b96f3');
        $this->checkFile('include/Gpf/Mail/Header.class.php', '86cd9df85f7e91010bb84732b0e83475');
        $this->checkFile('include/Gpf/Mail/Html2Text.class.php', 'c7c683620b198123ef74c59f895cb1b9');
        $this->checkFile('include/Gpf/Mail/Imap/Driver/Extension.class.php', 'a8ab606efa5952a2b05025d89aacf959');
        $this->checkFile('include/Gpf/Mail/Imap/Driver/Pear.class.php', 'fd7c57fc51296480c4b3f2e50a502055');
        $this->checkFile('include/Gpf/Mail/Imap/Driver.class.php', '73cb11d30b5e6b53e118a0384cb1cd39');
        $this->checkFile('include/Gpf/Mail/Imap/DriverFactory.class.php', 'ce0fae54114290283230d57e78c34c96');
        $this->checkFile('include/Gpf/Mail/Imap/Processor.class.php', 'd85cbf38243e70010dcfb7c3c0613be3');
        $this->checkFile('include/Gpf/Mail/LimitException.class.php', 'bd5babfe9ad8dd0088bd1a65593fe24c');
        $this->checkFile('include/Gpf/Mail/MailDetail.class.php', 'ed2be82647c2357fac660f27610c3f7f');
        $this->checkFile('include/Gpf/Mail/MailOutboxForm.class.php', 'beeb59fb2a355684647fa76b08ace51b');
        $this->checkFile('include/Gpf/Mail/MailOutboxGrid.class.php', '3a8d8ce78c596f25e101347f8636c88c');
        $this->checkFile('include/Gpf/Mail/MailTemplateTestForm.class.php', 'b5ee3fa0431d22b3929ca329e9a98404');
        $this->checkFile('include/Gpf/Mail/MailTemplates.class.php', 'eba219328509f8f9d61a5cef9143a0ae');
        $this->checkFile('include/Gpf/Mail/Mime/Address.class.php', '0cdbbc74c40f089d741e0aa778aafc29');
        $this->checkFile('include/Gpf/Mail/Mime/Encoding/Base.class.php', '0b4a67d347d27508ba011d129b702660');
        $this->checkFile('include/Gpf/Mail/Mime/Encoding/Base64.class.php', '69e24df5e147eac5d745e9c66f48a906');
        $this->checkFile('include/Gpf/Mail/Mime/Encoding/No.class.php', '6b2f68ddf5f876689c682eeb2bd2acd1');
        $this->checkFile('include/Gpf/Mail/Mime/Encoding/QuotedPrintable.class.php', 'e4ab9313b2a7afce1a2486408279c18e');
        $this->checkFile('include/Gpf/Mail/Mime/Encoding/Utf8.class.php', 'd08313945f8bc887249deab6b8bf6f31');
        $this->checkFile('include/Gpf/Mail/Mime/Header.class.php', '59227728edcb660dc23c21e31546eadd');
        $this->checkFile('include/Gpf/Mail/Mime/HeaderException.class.php', '82b4ffff39ae6104e79d7be64443fe06');
        $this->checkFile('include/Gpf/Mail/Mime/HeaderValue.class.php', 'c2efcfe63830a7864847837a54fd5e6f');
        $this->checkFile('include/Gpf/Mail/Mime/HeaderValueParam.class.php', 'f3217a2a7a93ff00c1c969b4b15a6991');
        $this->checkFile('include/Gpf/Mail/Mime/Headers.class.php', '7d18dee0efcbef147db84cb36debb267');
        $this->checkFile('include/Gpf/Mail/Mime/Mail.class.php', 'c222b63a754e0a72b0406a4e320e4408');
        $this->checkFile('include/Gpf/Mail/Mime/Parser/Exception.class.php', 'ee9a9d16bc66298ef9018e07e804acb8');
        $this->checkFile('include/Gpf/Mail/Mime/Parser/Headers.class.php', 'c165834abb8db217e22d96f25e6613f7');
        $this->checkFile('include/Gpf/Mail/Mime/Parser/Mail.class.php', '4f96c7d82fc4209e8870df42211a34fe');
        $this->checkFile('include/Gpf/Mail/Mime/Parser/MultiPart.class.php', 'bc0734df1c671dd06d0c2235f7069c6f');
        $this->checkFile('include/Gpf/Mail/Mime/Parser/MultiPartStream.class.php', '6d36398cf44a79946caf49561985ccf8');
        $this->checkFile('include/Gpf/Mail/Mime/Parser/Quote.class.php', '74dec503ab65b1b37f71538334409364');
        $this->checkFile('include/Gpf/Mail/Mime/Parser/RFC822.class.php', '906fbb9460784f0f1ac88e1ce6782d83');
        $this->checkFile('include/Gpf/Mail/Mime/Parser/SubPartStream.class.php', 'd0dda96775c6b701fa3ebf9c785f83ab');
        $this->checkFile('include/Gpf/Mail/Mime/Part/ContentType.class.php', '36ba25e9512578b2e0f27afc60fa43e9');
        $this->checkFile('include/Gpf/Mail/Mime/Part/Multi/Alternative.class.php', '8cb5e1de34c654832374418d3a9df1f3');
        $this->checkFile('include/Gpf/Mail/Mime/Part/Multi/AlternativeProcessor.class.php', 'c3aa57c559f5c81fa09d11d1c2001dc4');
        $this->checkFile('include/Gpf/Mail/Mime/Part/Multi.class.php', '80c186f261a4cf4f810c8359f2145059');
        $this->checkFile('include/Gpf/Mail/Mime/Part/MultiProcessor.class.php', '6d273aa99e0ebd9093fe127e749f7079');
        $this->checkFile('include/Gpf/Mail/Mime/Part/Processor.class.php', 'f29470602ce8d113e9effefec6fd8f1e');
        $this->checkFile('include/Gpf/Mail/Mime/Part/ProcessorBase.class.php', '2d0dbfa8d1ca73f12268d9ed7544c03d');
        $this->checkFile('include/Gpf/Mail/Mime/Part/ProcessorComposite.class.php', '8916a84ccc2719acf0d520d4cb663c27');
        $this->checkFile('include/Gpf/Mail/Mime/Part/Simple.class.php', 'cf1ab948935b11ed85527406f5e7f49e');
        $this->checkFile('include/Gpf/Mail/Mime/Part.class.php', 'a216c54f965f098b9dda59830e000e2d');
        $this->checkFile('include/Gpf/Mail/Mime/Processor.class.php', '8d61a4e4339cabf6ca8e925eeb967f0a');
        $this->checkFile('include/Gpf/Mail/OnInvalidLicense.class.php', 'ba7eb5818adfc4dc4b892b657d5386af');
        $this->checkFile('include/Gpf/Mail/OutboxRunner.class.php', 'b024dff3ea859704e0b8f72a0166cec0');
        $this->checkFile('include/Gpf/Mail/Pop3/FetchSkipListProcessor.class.php', '35d8892e8405653e88598a7d2d1f2d14');
        $this->checkFile('include/Gpf/Mail/Pop3/ListProcessor.class.php', 'f9f7dcc58692932b2997e70c87018af0');
        $this->checkFile('include/Gpf/Mail/Pop3/Processor.class.php', 'f80e1a8ae3857e1630ce1d573fa88327');
        $this->checkFile('include/Gpf/Mail/Pop3.class.php', '9cc76323e36f0069d81eb5f95fcc2c85');
        $this->checkFile('include/Gpf/Mail/Protocol/AuthenticationFailedException.class.php', 'c2e6d3724f036ee555a84c4311ecd4a6');
        $this->checkFile('include/Gpf/Mail/Protocol/Base.class.php', '966d2fb9a7f3381a5916e483151b6e89');
        $this->checkFile('include/Gpf/Mail/Protocol/CommandFailedException.class.php', 'f814f4ffe102a5fce184862046c3dedd');
        $this->checkFile('include/Gpf/Mail/Protocol/Exception.class.php', '0e7f33772f4dd0f5850fa0bbcdca31cd');
        $this->checkFile('include/Gpf/Mail/Protocol/Imap.class.php', 'b0646a42baa1b775774cab7d38772bb4');
        $this->checkFile('include/Gpf/Mail/Protocol/Smtp.class.php', '8ecce4d51e804aeeeac80343e2d008b6');
        $this->checkFile('include/Gpf/Mail/Sender/Mail.class.php', '8c4c0806c327beb7a9be37795075f847');
        $this->checkFile('include/Gpf/Mail/Sender/Smtp.class.php', '4fe19fd92e0e52e757f8a8dc0951a06b');
        $this->checkFile('include/Gpf/Mail/Sender.class.php', '704977765d62a9d77e3c42420f131f6a');
        $this->checkFile('include/Gpf/Mail/SentMailTemplatesGrid.class.php', 'a14147e7a446e7699d9db416586c5671');
        $this->checkFile('include/Gpf/Mail/Template.class.php', '584d9caa9e4195616abcbcf1748ce068');
        $this->checkFile('include/Gpf/Mail.class.php', '5af3e36fbcddc886c4c447ce50927ed2');
        $this->checkFile('include/Gpf/Menu.class.php', '87edfdb0d0dd4323905ee1ddee0519c2');
        $this->checkFile('include/Gpf/Model/DbTemplateCahce.class.php', 'c372f9676cdfe5c66a25d33021fa877d');
        $this->checkFile('include/Gpf/Module.class.php', '25ad6cb4bcd11232b46ad75426c0efc9');
        $this->checkFile('include/Gpf/ModuleBase.class.php', '750bc00b04de04da1b1254b56773f931');
        $this->checkFile('include/Gpf/Net/Exception.class.php', '602c953253ed56e69198e3d72f4fa0ed');
        $this->checkFile('include/Gpf/Net/Http/Client.class.php', 'e68d287d9ca76c9686b682e4448b4ace');
        $this->checkFile('include/Gpf/Net/Http/ClientBase.class.php', 'fbc5c4b916dfb1a61293b58d31632486');
        $this->checkFile('include/Gpf/Net/Http/ProxyServerSettings.class.php', '76b93452c239546c47e4c79463c70d93');
        $this->checkFile('include/Gpf/Net/Http/Request.class.php', '27b4e878378466f1d609dfd99a52f6e8');
        $this->checkFile('include/Gpf/Net/Http/Response.class.php', '5a226cf529edd7cf03bfb761c64243a7');
        $this->checkFile('include/Gpf/Net/Http/SafeUrl/Options.class.php', '3905d99f1d492a4f9b02fc81f71ddcc5');
        $this->checkFile('include/Gpf/Net/Http/SafeUrl/SafeUrl.class.php', '1b778ebfca75ed4c83c52da3e1aa3a01');
        $this->checkFile('include/Gpf/Net/Http/SafeUrl/Url.class.php', '17662b0197b491ac14ac0a1c42a28857');
        $this->checkFile('include/Gpf/Net/Ip.class.php', 'f09a072350e563b8d78ad4bafc0989c3');
        $this->checkFile('include/Gpf/Net/MailException.class.php', '94009f188c596de876aaca4789651a30');
        $this->checkFile('include/Gpf/Net/Server/Driver/Fork.class.php', 'dc61bbb1491361437dc83f6504a6c1ac');
        $this->checkFile('include/Gpf/Net/Server/Driver/Sequential.class.php', '7ca808d221030e256f58b82bbc7286be');
        $this->checkFile('include/Gpf/Net/Server/Handler.class.php', '96d04fd069ddea5931f90713fbeb6384');
        $this->checkFile('include/Gpf/Net/Server/Http/Cookie.class.php', '680b59de87f3f4f1a70413eedc357c83');
        $this->checkFile('include/Gpf/Net/Server/Http/Handler/StaticFile.class.php', 'c90eebf355d5e9a3b549650bb8845fdb');
        $this->checkFile('include/Gpf/Net/Server/Http/Handler.class.php', 'bff4fb2c0c6c77917fdff93912e07584');
        $this->checkFile('include/Gpf/Net/Server/Http/Header.class.php', '070d9b11933c16ab634e4702fec39bd5');
        $this->checkFile('include/Gpf/Net/Server/Http/Message.class.php', 'be276afdd07158e64356f45c2969cfae');
        $this->checkFile('include/Gpf/Net/Server/Http/Request.class.php', '765114c23a3be0868c2415fb62dee7db');
        $this->checkFile('include/Gpf/Net/Server/Http/RequestException.class.php', '713ac76f55ca9fc4b2e0ba601078635c');
        $this->checkFile('include/Gpf/Net/Server/Http/Response.class.php', 'e73c1464084415b8b84bf541b76cee77');
        $this->checkFile('include/Gpf/Net/Server/Http/StreamResponse.class.php', '502da9da9b4f6f1e3a082441d492f9f5');
        $this->checkFile('include/Gpf/Net/Server/Http.class.php', '4078093fdb2f61dede20bc396863514b');
        $this->checkFile('include/Gpf/Net/Server/NoSocket.class.php', 'a439fa67bbb949acf92932376d9763bf');
        $this->checkFile('include/Gpf/Net/Server/Socket.class.php', '3b473bdc411631d5c9ae9552a5c7daaa');
        $this->checkFile('include/Gpf/Net/Server/SocketException.class.php', '133459e842944a8549c680115c89b72b');
        $this->checkFile('include/Gpf/Net/Server.class.php', 'da2ba652e338d239cb16b04ba3034c3d');
        $this->checkFile('include/Gpf/Net/Socket.class.php', '6c2a1be8795ff2b8a859f3bbf05f40af');
        $this->checkFile('include/Gpf/Net/SocketException.class.php', '806baf11de4a55d8bbba0f739819f224');
        $this->checkFile('include/Gpf/Object.class.php', 'c98f438a507a1d00b07ce99a1ef6065d');
        $this->checkFile('include/Gpf/Openid/LightOpenID.class.php', '191fb215e43da0566859b61c18863552');
        $this->checkFile('include/Gpf/Paths.class.php', 'd78e687f1095a5b1855689aaea58416b');
        $this->checkFile('include/Gpf/Pdf/Cmap/ByteEncoding/Static.class.php', '32515c29bffce03c921e4961b7ae6642');
        $this->checkFile('include/Gpf/Pdf/Cmap/ByteEncoding.class.php', '50d4fee7de1d7c0894485006e57d7156');
        $this->checkFile('include/Gpf/Pdf/Cmap/SegmentToDelta.class.php', '42e608499673d37bd9d4991c92aebfd0');
        $this->checkFile('include/Gpf/Pdf/Cmap/TrimmedTable.class.php', '72d856e40dcb971728b3828807b60a97');
        $this->checkFile('include/Gpf/Pdf/Cmap.class.php', '1e6977eef5fae84e0bb40b5af0d7c5af');
        $this->checkFile('include/Gpf/Pdf/Data/HasHash.class.php', '056374c3e3fc03bb540b9d98a8992c18');
        $this->checkFile('include/Gpf/Pdf/Data/List.class.php', '236dcc516bac8af5222a5c1ef142b918');
        $this->checkFile('include/Gpf/Pdf/Data/ListIterator.class.php', '0ab91fbf936a4a6fdb62751ea3d64d09');
        $this->checkFile('include/Gpf/Pdf/Disposable.class.php', '74497a23702463c07e86c5b21f451b6a');
        $this->checkFile('include/Gpf/Pdf/Document/Annotation/Link.class.php', '7630631637860b0718ad0e54f27d1e8b');
        $this->checkFile('include/Gpf/Pdf/Document/Annotation.class.php', 'a2352fade7e8d382dd6ace5869d1ec89');
        $this->checkFile('include/Gpf/Pdf/Document/Annotations.class.php', 'd9d9a6a0e99bd67910083a8cc48e107c');
        $this->checkFile('include/Gpf/Pdf/Document/ArrayObject.class.php', '9a49f93ab4ecea495f5f1c55b3a502c3');
        $this->checkFile('include/Gpf/Pdf/Document/Catalog.class.php', 'a43486215302daed7217238e2a345a2e');
        $this->checkFile('include/Gpf/Pdf/Document/CidSystemInfo.class.php', '7b55c161409980f5f6524589c76df85c');
        $this->checkFile('include/Gpf/Pdf/Document/Cmap/Encoding.class.php', '9e4dd4fed3af170243fbec92b2f5b4ed');
        $this->checkFile('include/Gpf/Pdf/Document/Cmap/ToUnicode.class.php', '14880bf8045cc7d91a1ead1ca4c916df');
        $this->checkFile('include/Gpf/Pdf/Document/Cmap.class.php', '818b009f4228636af20c0195bb1f8f7d');
        $this->checkFile('include/Gpf/Pdf/Document/Content.class.php', 'ec3d6c59d9e402b1c972728a51ef77f1');
        $this->checkFile('include/Gpf/Pdf/Document/DictionaryObject.class.php', 'ac90dca312e985d2372efa4ca0cbcee5');
        $this->checkFile('include/Gpf/Pdf/Document/Encoding/Dictionary.class.php', 'c0dd1e9de453f04d05dc9c1e3f8fdb80');
        $this->checkFile('include/Gpf/Pdf/Document/Encoding/Empty.class.php', '73b55e432607bcaca0c170187e53b91e');
        $this->checkFile('include/Gpf/Pdf/Document/Encoding/Name.class.php', 'fbddfed082e755c8f6b705fcd9171f5e');
        $this->checkFile('include/Gpf/Pdf/Document/Encoding.class.php', 'e6c928fbe13ce79f1aaa142d11b17185');
        $this->checkFile('include/Gpf/Pdf/Document/Encrypt/Standard.class.php', '3adfc40f1b28a399c22c47ced1eff2a6');
        $this->checkFile('include/Gpf/Pdf/Document/Encrypt.class.php', 'f55765f9da808a60880d490043b49698');
        $this->checkFile('include/Gpf/Pdf/Document/Font.class.php', '09c97d8d5f99bcb3ec849b1df467d089');
        $this->checkFile('include/Gpf/Pdf/Document/FontDescriptor.class.php', 'ab914909052751299ca058d6323854d3');
        $this->checkFile('include/Gpf/Pdf/Document/FontDictionary.class.php', '12b60c547e8d5a7c44fbe51e1574c339');
        $this->checkFile('include/Gpf/Pdf/Document/FormXObject.class.php', 'e8f0dff8c0fe661333dd45cca0ba1f67');
        $this->checkFile('include/Gpf/Pdf/Document/Info.class.php', '7c8d7aabaced2edfd8eb882ec11669de');
        $this->checkFile('include/Gpf/Pdf/Document/Object/Array.class.php', '68b97f4ef343a226b6a022da5acfc894');
        $this->checkFile('include/Gpf/Pdf/Document/Object/ArrayBase.class.php', '26e88bc1e48c7a560b621f6e269bba5d');
        $this->checkFile('include/Gpf/Pdf/Document/Object/Dictionary.class.php', '90b3e1efe1b037c46b888bdd861faab5');
        $this->checkFile('include/Gpf/Pdf/Document/Object/Stream.class.php', '5c00aad713fb3ad7e5faabcf4ac9c9ac');
        $this->checkFile('include/Gpf/Pdf/Document/Object.class.php', 'a53d5e92e782df082f1daa6fa490a181');
        $this->checkFile('include/Gpf/Pdf/Document/Page.class.php', 'e9fb5c368b5c6e1a6605956e13d7fcb0');
        $this->checkFile('include/Gpf/Pdf/Document/PageContents/Array.class.php', '309bbcc02f544636056deeb6dec03b5b');
        $this->checkFile('include/Gpf/Pdf/Document/PageContents/Stream.class.php', 'e126bce6b048e53228e65d05149647f6');
        $this->checkFile('include/Gpf/Pdf/Document/PageContents.class.php', 'cac7eeaecccaf44f727b059f308b5efd');
        $this->checkFile('include/Gpf/Pdf/Document/PageNode.class.php', 'dd1d0dcb7b3a9664ed8d5e1668fceb25');
        $this->checkFile('include/Gpf/Pdf/Document/PageNodeBase.class.php', 'a8da735d2a2e620acd9e21e96c34d038');
        $this->checkFile('include/Gpf/Pdf/Document/Pages.class.php', '84066aa5790be0a24a684aa00122aef0');
        $this->checkFile('include/Gpf/Pdf/Document/Resources.class.php', 'de0667da01f1c1d9fa0d4c2194240683');
        $this->checkFile('include/Gpf/Pdf/Document/StreamObject.class.php', '3650fa0e5b43ea855c6f3b79a81800a4');
        $this->checkFile('include/Gpf/Pdf/Document/XObjectDictionary.class.php', 'a0049a8754f4fe67e251b0e6a302a3b7');
        $this->checkFile('include/Gpf/Pdf/Document.class.php', '2607a72f2523d7eba90eeef7d20f38db');
        $this->checkFile('include/Gpf/Pdf/Encrypt/Algorithm/AesCbc.class.php', '2d31e298086b85eecb8d4bd09e72338d');
        $this->checkFile('include/Gpf/Pdf/Encrypt/Algorithm/RC4.class.php', '05ea14f90a550474e9a69ff8b0a8a630');
        $this->checkFile('include/Gpf/Pdf/Encrypt/SecurityHandler/Standard.class.php', '52a8294b12cdb6092c87b4c7dac0eb4d');
        $this->checkFile('include/Gpf/Pdf/Exception.class.php', 'c7e9fe46eacc6ef684667f726a66c894');
        $this->checkFile('include/Gpf/Pdf/Filter/Compression/Flate.class.php', '5b1cb545a08590edc66a518a5dce6e90');
        $this->checkFile('include/Gpf/Pdf/Filter/Compression/Lzw.class.php', '90556e9ba429fb3a29d3bf372299ada2');
        $this->checkFile('include/Gpf/Pdf/Font/Decoder.class.php', '3f84bbfd1283fe32bc8d94d0ca167a77');
        $this->checkFile('include/Gpf/Pdf/Font/EmptyDecoder.class.php', 'c36f1a64ec27d7d51ec1f4cbec1945c3');
        $this->checkFile('include/Gpf/Pdf/Font/Encoding/MacExp.class.php', 'dd2ec439eb21092dbb3c5abf0e909f8f');
        $this->checkFile('include/Gpf/Pdf/Font/Encoding/MacRoman.class.php', '53e46eb5fbca297bcd4083c2f4522e4e');
        $this->checkFile('include/Gpf/Pdf/Font/Encoding/PdfDoc.class.php', '543c9646aec524d3998e87063d8f8504');
        $this->checkFile('include/Gpf/Pdf/Font/Encoding/Standard.class.php', '3718940cfca13b40246f3a945521b2c2');
        $this->checkFile('include/Gpf/Pdf/Font/Encoding/WinAnsi.class.php', 'b2ce340a376a2147af8090edbc2d2219');
        $this->checkFile('include/Gpf/Pdf/Font/Encoding.class.php', '963f2136fc227e305aca5fd3187be063');
        $this->checkFile('include/Gpf/Pdf/Font/GlyphList.class.php', 'afa616b9e2123ee5092a2d93523b30bf');
        $this->checkFile('include/Gpf/Pdf/Font/OpenType/TrueType.class.php', 'de6b20e6c243030012744b2f84c4cff4');
        $this->checkFile('include/Gpf/Pdf/Font/OpenType.class.php', 'f0c9ea2c524ef577464dd815be8851c0');
        $this->checkFile('include/Gpf/Pdf/Font/Standard.class.php', 'f2e9eccdb300cf791371fc4cc984697d');
        $this->checkFile('include/Gpf/Pdf/Font.class.php', 'e5a76a44201fe6f1df7398f60e79258b');
        $this->checkFile('include/Gpf/Pdf/Log.class.php', 'ca12d1f39bc5078df5146f92377d7977');
        $this->checkFile('include/Gpf/Pdf/Map.class.php', 'bee2d151a26cffc2d134c88a6d37984d');
        $this->checkFile('include/Gpf/Pdf/Object/Array.class.php', '85863f723fd9c6f5aef444a571acc73b');
        $this->checkFile('include/Gpf/Pdf/Object/ArrayBase.class.php', '869c8a9ca0462b5f52d83f7f823d071d');
        $this->checkFile('include/Gpf/Pdf/Object/Boolean.class.php', '9909e87104d8f21b0c7394859e96402d');
        $this->checkFile('include/Gpf/Pdf/Object/Dictionary.class.php', '3409aac0f5ffde3b28c6661f6b3fb7d9');
        $this->checkFile('include/Gpf/Pdf/Object/Name.class.php', '0cf1b0aa7de5049e72cbbeb6d3422054');
        $this->checkFile('include/Gpf/Pdf/Object/Null.class.php', 'a9a6f2c5e10aac9e09a6adde6cf30958');
        $this->checkFile('include/Gpf/Pdf/Object/Number.class.php', '7322b114d6db4c1672eac5e8143c3cba');
        $this->checkFile('include/Gpf/Pdf/Object/Reference.class.php', 'e0b256eb2712a8e051873cc292342e2b');
        $this->checkFile('include/Gpf/Pdf/Object/Stream.class.php', 'b6d5c3b4cb302e8b064bbe1c323ef884');
        $this->checkFile('include/Gpf/Pdf/Object/String/Binary.class.php', '38e4155b4c99fcd1112bdf805a57c6ab');
        $this->checkFile('include/Gpf/Pdf/Object/String.class.php', 'c8f6d50e92f631509a9139df79b2175e');
        $this->checkFile('include/Gpf/Pdf/Object.class.php', '08c34d97c259e279457fe47de7cfd676');
        $this->checkFile('include/Gpf/Pdf/Operator/BeginText.class.php', 'b956ab902fb2c7447a63a81f44221912');
        $this->checkFile('include/Gpf/Pdf/Operator/EndText.class.php', '7939d7291424b86c542ff15b775fa419');
        $this->checkFile('include/Gpf/Pdf/Operator/InlineImage.class.php', '734cf60df9c20ffb37b47f759ed7fc73');
        $this->checkFile('include/Gpf/Pdf/Operator/NotImplemented.class.php', '7da767524a1d686c3b7a29d68df25a31');
        $this->checkFile('include/Gpf/Pdf/Operator/SelectFont.class.php', '3a16e4df611790a724aed70e6425a373');
        $this->checkFile('include/Gpf/Pdf/Operator/Text/Multi.class.php', '0eae1d2cbc19f1d38fe36b31f93953bc');
        $this->checkFile('include/Gpf/Pdf/Operator/Text/NewLine.class.php', '17750b5661c9330525c8322eedc6c2e6');
        $this->checkFile('include/Gpf/Pdf/Operator/Text/Spacing.class.php', '7562dd428482c57de8dde22ce77477e1');
        $this->checkFile('include/Gpf/Pdf/Operator/Text.class.php', '93aacdc027ad421034f8952eb693e42c');
        $this->checkFile('include/Gpf/Pdf/Operator/XObject.class.php', 'bd9fa7051e5990c83e47537106d1c1a7');
        $this->checkFile('include/Gpf/Pdf/Operator.class.php', 'bb23f2fda4b946a52701e19857845f39');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/CSRange.class.php', '301a0101d992ef5dfbbbbe5190e2265d');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Cid.class.php', '3655498168007a5d94f7a08f7473efe0');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Data.class.php', '00a2adb90381893aae49e0f1fecbc6d7');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/78-EUC-H', '1b63ef9b4dc6e61cc0ae6344bda08fce');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/78-EUC-V', '929a62410263798e902e03342f8ebeb5');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/78-H', 'f79a5ddd98cd18c1d40bd6fb33f9dccd');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/78-RKSJ-H', '3bd3ab46d6d939a23792fe37c66f7479');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/78-RKSJ-V', 'fb4ead5783fe0e55299c171cc9c4a135');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/78-V', '373e9be1468e2a984694b0fedf6d108b');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/78ms-RKSJ-H', '9e6e590eb3de509fc0131f20bec278cb');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/78ms-RKSJ-V', '4a943c224b3ec7de1ad3a5c15b4a1e47');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/83pv-RKSJ-H', '0983d07e1bd0d9568022fb0235724b89');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/90ms-RKSJ-H', '38f58ed0a64e03f1076cd1a37c85a015');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/90ms-RKSJ-UCS2', 'c8dbc16507fff927c7a6be8d81a9b5f7');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/90ms-RKSJ-V', '1d8a0b8c83bcf36e27671453d080f47d');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/90msp-RKSJ-H', '8be4a9ac0fffe3fb3a46211aea3e4273');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/90msp-RKSJ-V', '8651fdcda0ecbe14d5489586f76e4dd1');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/90pv-RKSJ-H', '8728d9aa726bd8fc907855d1f28cc541');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/90pv-RKSJ-UCS2', '91070a7f585137e78a89241f3e0e1004');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/90pv-RKSJ-UCS2C', '7752ecafd9348de9ad4cc9fe43f0d410');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/90pv-RKSJ-V', 'f5060a54dc8098855438b626ef0df9e9');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Add-H', 'b9bcd680726a951845bbd366f4220345');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Add-RKSJ-H', 'eb7dea92a9ccf8f4c5b8ce32214833fc');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Add-RKSJ-V', '262c6c3cb560db58ea9e824767ecfc95');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Add-V', 'caccb4b8f7cc38ea918378233ce6507f');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Adobe-CNS1-3', '135d89225a8f6906f46bb9219784de67');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Adobe-CNS1-B5pc', '2db73f76412832eb762b7e89785e1c47');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Adobe-CNS1-H-CID', 'c967ac70a9182d0a724a5f22cdbba86f');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Adobe-CNS1-H-Host', 'ececf9c681dbbcf37a060ffe5afa8b4d');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Adobe-CNS1-H-Mac', '603c64a402a5c2867c3eaf32bf0440e5');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Adobe-CNS1-UCS2', '63520b65f61186829864908039bca556');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Adobe-GB1-4', '60b06ae6dd99862e667cefc03105b04d');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Adobe-GB1-GBK-EUC', '918488c2eafc406705ad71265450cf2c');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Adobe-GB1-GBpc-EUC', '4aa7058d71a8d8facba97458e20ee1ea');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Adobe-GB1-H-CID', '86cee6fc469eab8b08417e13014ad2dd');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Adobe-GB1-H-Host', '4f2c81f7ca3fea6a0bfaa586d3baceb1');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Adobe-GB1-H-Mac', 'c2ec18ed412e9e39d6e87b9606ecb04b');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Adobe-GB1-UCS2', '7f2c2d6edfb0db6ec089ed8623af72f8');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Adobe-Japan1-0', 'e68683744e59280e745b006ad23384e4');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Adobe-Japan1-1', 'b7b9aef0adaa6ef714c95f7b2cc1ceaa');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Adobe-Japan1-2', '01472468c31b40c8160493484db4b42e');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Adobe-Japan1-4', 'ba39ad56a657218ddf5172ade3f1b704');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Adobe-Japan1-90ms-RKSJ', 'f4205c078ac61edef78f8b544a9bbcc2');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Adobe-Japan1-90pv-RKSJ', '634a52a0db0d9aae9b76c67fac1e532e');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Adobe-Japan1-H-CID', 'a966f2a52b6b861bb8a9e26193bca8f5');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Adobe-Japan1-H-Host', 'a91886c9a43608b96e4dee7040f41bae');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Adobe-Japan1-H-Mac', '3430aeaf477b0e20679aae6851429226');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Adobe-Japan1-PS-H', '7594f6a877662073217a319ae74074a8');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Adobe-Japan1-PS-V', '3cdcc7b8980b22de6c55bfe6e347962c');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Adobe-Japan1-UCS2', '6c472ab25110b6b65aea73a8da0f9474');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Adobe-Korea1-2', 'ddb8dcadc56a17eb855e1fe7625dd093');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Adobe-Korea1-H-CID', '55c1cd885824b30028e6849b99a70f57');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Adobe-Korea1-H-Host', '76003fd96c08953ee517da61949e7cef');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Adobe-Korea1-KSCms-UHC', '62e26c8901c53a2845ae225cb1a16707');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Adobe-Korea1-KSCpc-EUC', '55cddbdecb24d847295344f4bf63cfca');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Adobe-Korea1-UCS2', 'd8ab42ee7d16711eb2e87abc8406404e');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/B5pc-H', '3bf2515461b0dcbf4bd2e9c029a59eda');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/B5pc-UCS2', '149fb652f2a526e615d6028e6f283a48');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/B5pc-UCS2C', 'b1ddddb8fef40024dd3bc910ee09cb89');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/B5pc-V', '64b1ab2ad13d9aa27a28188ab0187954');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/CNS-EUC-H', '2d6e86adab1784ca86a953db009b004d');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/CNS-EUC-V', 'dda171cd50da84ff95ccae7f1868175f');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/ETHK-B5-H', '0218fc03320aae415dd871bd309401d6');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/ETHK-B5-V', '6da6650ef3e3836937252149d1d0ba27');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/ETen-B5-H', 'f5ad2c85c3aa0c37d01431e8b8918db0');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/ETen-B5-UCS2', '4ed21fedc330861614506e13c1c806ed');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/ETen-B5-V', 'd5e29d781bb2d172db7b4438a9324126');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/ETenms-B5-H', '3736f0cc8b8f6c4d559d6361734ef19d');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/ETenms-B5-V', '8190699e797c55817ce15eeff49cd0cb');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/EUC-H', '5e59a9badcc97cc3626823fce5d9435f');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/EUC-V', 'f0946a8f0d91fa618a2b5acc83085a1f');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Ext-H', '25ef45ec5cf2fcfa6c36fff5c452f442');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Ext-RKSJ-H', 'e57fe0c63f5a06c778be00857df15a41');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Ext-RKSJ-V', '7a2b0775d2e628a4b55b34005ad95e52');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Ext-V', '1a314e01a563ec47ccf96e231680cc23');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/GB-EUC-H', 'a49dbf2a470577fe83e622a92f64683b');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/GB-EUC-V', '9138345f074bb3dd2b1cdd1ba87c7db8');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/GBK-EUC-H', '67c53ddf7aa1a2a26063c8cd21fe4dd9');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/GBK-EUC-UCS2', '7774f3d5b532b96073cf55bef79dc994');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/GBK-EUC-V', 'bb1b270a0acbab38b6a7ec9d2f182319');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/GBK2K-H', 'df303ad9de927d472d533a84ed85cbb2');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/GBK2K-V', 'e96a0d60762c54561ee4309be563c3d6');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/GBKp-EUC-H', 'c60d2259963020efb493b50b7b882a5d');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/GBKp-EUC-V', 'e551b675ebc5d4748875fdc1c5c90632');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/GBT-EUC-H', '236482fad91aaf00b4f99dd23dffb82a');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/GBT-EUC-V', 'ab5e7351b95ef80f802a1c3541a8618e');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/GBpc-EUC-H', 'a3d595bbbc0cc14883fb02a9b90cffd7');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/GBpc-EUC-UCS2', '6863d6265e410a554a60f9c7d0cdbb55');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/GBpc-EUC-UCS2C', '4406b9e691ee68f78e6bcaf831b1db6b');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/GBpc-EUC-V', '82c54ddcb42df3866ae7145e91271bfc');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/H', '403ef54d232bfe90609badcffa1c9070');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/HKdla-B5-H', '50c65df7e26c757d4fd2c9bee7a0e2f7');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/HKdla-B5-V', 'ad9ec5288dd7bb8f7205d2b9b55aa4ba');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/HKdlb-B5-H', 'bc41dc7c4083115e2d9d771227cc25b5');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/HKdlb-B5-V', 'fcd9bfebcef6846c5574d262d94f03b3');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/HKgccs-B5-H', '381c480eb8d6ecdc13a1ae73f8ecce98');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/HKgccs-B5-V', '61671764d57b25aca95ce30e7f444f5c');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/HKm314-B5-H', '23bb9d677b585ca58f7f335742feed26');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/HKm314-B5-V', 'a01f2f20e465dce72cad3855f7edb685');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/HKm471-B5-H', '6733b5d565a1b0ff6b362de98078f066');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/HKm471-B5-V', '7335726c6f6c1d8adc5d2ce874dd3647');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/HKscs-B5-H', '1293ff04bfdff63779f0cf7a7fd3a203');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/HKscs-B5-V', '32d480b3df566f800dc379a54e22c3de');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Hankaku', '52c641b4df8e5dbfb4bb56672d196c96');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Hiragana', '0f19c71941ff1eb4860362f80842def3');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Identity-H', 'd6c7a2dc9d52fa79e314fb6b33e90ee1');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Identity-V', '0b26806368e7c47e0f684729a049abc3');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/KSC-EUC-H', '7a0c20f6929514a8aab091989fdba941');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/KSC-EUC-V', 'e5b5dce535e337d19ebd0380291ef800');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/KSC-Johab-H', 'd6a9f93d9f37d8e0bc1ba01d36d63b16');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/KSC-Johab-V', 'd4bc19682403d71e360bee920ba5af82');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/KSCms-UHC-H', 'affe2dcf9e0b745f014b2928441b7081');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/KSCms-UHC-HW-H', '3f155fceed3c24bc6a5619f77933a410');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/KSCms-UHC-HW-V', '6714a14e9669580f8d40c8995cde6e68');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/KSCms-UHC-UCS2', '0532cb5cae13ded2bbf8dfc05abf1653');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/KSCms-UHC-V', 'a0f98f3882d62534e1c267828316246c');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/KSCpc-EUC-H', '4df71f1f7ddacf13f2bc4893b5c6ff51');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/KSCpc-EUC-UCS2', 'f0cb00db488069e0f79e10eba7b9b4e0');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/KSCpc-EUC-UCS2C', 'b50d871ee7dfef35acf64794b1d22e68');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Katakana', 'f5a4ae30bf5e5d690d30688ee670e59f');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/NWP-H', '0ff389a91efca33479bba675288ff819');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/NWP-V', '5e45f317cf11e470912233551af16d99');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/RKSJ-H', 'a091e355981d65ba657c27a85041a249');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/RKSJ-V', '203c6e69eb21f3eb8911ff58d81169a5');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/Roman', '91d6bd01a5684fa080544c4050e0f5ff');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/UCS2-90ms-RKSJ', 'ff3de8ca28ed5e1833e0927c4e7d4d32');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/UCS2-90pv-RKSJ', '3dbacac15a262fbb12a55ee29a6006e5');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/UCS2-B5pc', '6438bc5447e6b9b18143f82a38deaff2');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/UCS2-GBK-EUC', 'c0eaa582a8d07acfe65e32acb94239d5');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/UCS2-GBpc-EUC', 'e9edf2c7ce3ace4a5832943939896d2b');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/UCS2-KSCms-UHC', '6d4e69b6e657204e630243e36bb42255');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/UCS2-KSCpc-EUC', '96f490cb070d604f631673afc3576e63');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/UniCNS-UCS2-H', '67877a71f7b796a198867654985c0661');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/UniCNS-UCS2-V', '33606b1da94fd042e64cd5cf6b9fa863');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/UniGB-UCS2-H', 'ad14717f3c11d7a09a2e9aed0ad1443a');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/UniGB-UCS2-V', '214e12521a3572089b9774d1414357c3');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/UniHojo-UCS2-H', '93e5cca0ef323d16a09cc8b0241f7ce4');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/UniJIS-UCS2-H', '97b8aa0a54263e70715bbf1565bca0d0');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/UniJIS-UCS2-HW-H', '05b10993eba684a71769f2dbf32fdc5c');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/UniJIS-UCS2-HW-V', 'f6a5038145e9d3d45b28b42bae6d7b1b');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/UniJIS-UCS2-V', 'bf29365d6a2234eb47b32b3207c5d3d8');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/UniKS-UCS2-H', 'adadeb05770397403ed0477603b923e9');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/UniKS-UCS2-V', '43fbd9711c4ce217ed21a17c84d2905f');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/V', '6a135875fbff6ad2476dfde518199aa6');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Resources/WP-Symbol', '46821e2f895307e98822b9fa22cf3d0c');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap/Unicode.class.php', '6a9931414c7f61c9e1e42a9a6684c399');
        $this->checkFile('include/Gpf/Pdf/Parser/Cmap.class.php', '3a79c1e50e6d06fe8348f3a75a22462d');
        $this->checkFile('include/Gpf/Pdf/Parser/Content.class.php', 'c6ffccb2eee372a3f5f944ee55611545');
        $this->checkFile('include/Gpf/Pdf/Parser/Document.class.php', 'd5663e5692d88175a94678e943e45d69');
        $this->checkFile('include/Gpf/Pdf/Parser/Font.class.php', '6299d085be706448aefbcd567ac8e6a6');
        $this->checkFile('include/Gpf/Pdf/Parser/InlineImage.class.php', '6d944881537f5c6cb014c9c540b2a268');
        $this->checkFile('include/Gpf/Pdf/Parser/XReferenceTable.class.php', '187eafd6149802360655fb93d74f5b2a');
        $this->checkFile('include/Gpf/Pdf/Parser.class.php', 'ca1919459828f94e855ccada37d1178d');
        $this->checkFile('include/Gpf/Pdf/Processor/GraphicsState.class.php', '05d9dd1498bbfbf889ed6a22bff11f0f');
        $this->checkFile('include/Gpf/Pdf/Processor/Stream.class.php', '944d25cc4de673cf494b555b6c4663e7');
        $this->checkFile('include/Gpf/Pdf/Processor/TextState.class.php', '9046eeedce06335e52c293b8cfb04139');
        $this->checkFile('include/Gpf/Pdf/Reader/Eof.class.php', '1416f3bec1f702cb59cd79263fede7ae');
        $this->checkFile('include/Gpf/Pdf/Reader/File.class.php', 'a07a6beaa72be7956adac630302d840f');
        $this->checkFile('include/Gpf/Pdf/Reader/MultiStream.class.php', '67dc7b712f13934225b4bb903ab00f0c');
        $this->checkFile('include/Gpf/Pdf/Reader/Offset.class.php', '204a4b0de5329b58a788541bd2f8555e');
        $this->checkFile('include/Gpf/Pdf/Reader/String/File.class.php', '0ed02281a0a2af469d8f42b91969e4a8');
        $this->checkFile('include/Gpf/Pdf/Reader/String.class.php', '6f769dd89255d6c32be755265c6f85be');
        $this->checkFile('include/Gpf/Pdf/Reader.class.php', 'b3ed2232d2609bedd4fe4564fab9bdbf');
        $this->checkFile('include/Gpf/Pdf/ResourceManager.class.php', '4f36d92c9e2a3e40773148395c329802');
        $this->checkFile('include/Gpf/Pdf/Source/Font/String.class.php', '13bd96693912972431916f985f0b34c2');
        $this->checkFile('include/Gpf/Pdf/Source/Font.class.php', '478f1dc24f86692e8b436abe50e23db6');
        $this->checkFile('include/Gpf/Pdf/Source.class.php', '3832d1d6de6b1269fafd6bcd455e955f');
        $this->checkFile('include/Gpf/Pdf/Task/FindRegexp.class.php', '121552980837731d697917ef42d3d10e');
        $this->checkFile('include/Gpf/Pdf/Task/Replace/Instructions.class.php', 'be80a6f2b87d54480fa6781e12d5f026');
        $this->checkFile('include/Gpf/Pdf/Task/Replace/StreamProcessor.class.php', '056d8164cfc52cf044b464ee61e63832');
        $this->checkFile('include/Gpf/Pdf/Task/Replace/String/Instruction/Multi.class.php', 'e4e9bbcaeb4f76c73b84ef4f74b551e4');
        $this->checkFile('include/Gpf/Pdf/Task/Replace/String/Instruction/Replace.class.php', 'ad09ecb0dbbeae996ffeea9a18fa52d1');
        $this->checkFile('include/Gpf/Pdf/Task/Replace/String/Instruction.class.php', 'e9b68d6ac09474638f82098a2f686ed8');
        $this->checkFile('include/Gpf/Pdf/Task/Replace/String.class.php', '31fe7cc746a5760b0c8151e5342edaab');
        $this->checkFile('include/Gpf/Pdf/Task/Replace.class.php', 'defb08c8ee321dc3e9b29fe9b86230bd');
        $this->checkFile('include/Gpf/Pdf/Task/Search/StreamProcessor.class.php', 'f7826d0283fd3b75f90be9870df33d69');
        $this->checkFile('include/Gpf/Pdf/Task.class.php', '80a33dc4e61313ac1b941f8f1ec38266');
        $this->checkFile('include/Gpf/Pdf/Trailer.class.php', '4c813f34a52036b3dc975d7ef99687ca');
        $this->checkFile('include/Gpf/Pdf/Writer/Full.class.php', 'b2001ebb9e0b1a8bd2012ceb0125601e');
        $this->checkFile('include/Gpf/Pdf/Writer/XrefSection.class.php', '61b122c6f8bebc75415d73b2dcc40f72');
        $this->checkFile('include/Gpf/Pdf/XReferenceTable/FreeItem.class.php', '23459a8f4c83ff18b23984c9f31ad61e');
        $this->checkFile('include/Gpf/Pdf/XReferenceTable/Item.class.php', '4a5df7974feb3dc5e6a802e27af9f745');
        $this->checkFile('include/Gpf/Pdf/XReferenceTable/ItemBase.class.php', '1f866c40ca1fa1dfd2486b960ba2711e');
        $this->checkFile('include/Gpf/Pdf/XReferenceTable.class.php', '401bc377b3fc573b0509890d74673402');
        $this->checkFile('include/Gpf/Php.class.php', '323c8118fd0c197a93ebfca4e0772cf8');
        $this->checkFile('include/Gpf/Plugins/Config.class.php', '3cf80e1873e675897cfb6d9a758cccd7');
        $this->checkFile('include/Gpf/Plugins/Context.class.php', 'ce47826529dcf05c51c856c00db3aec0');
        $this->checkFile('include/Gpf/Plugins/Definition/ExtensionPoint.class.php', '9db732f7a36e099982c001588874969d');
        $this->checkFile('include/Gpf/Plugins/Definition.class.php', '77bebecf268c4577ee9aad82baee52ba');
        $this->checkFile('include/Gpf/Plugins/Engine.class.php', '191f6f8299da98357ce2ccb50bd3f5d7');
        $this->checkFile('include/Gpf/Plugins/EngineConfig.class.php', '1d989cc4af7e21de7c57d0c83e3bd430');
        $this->checkFile('include/Gpf/Plugins/EngineSettings.class.php', '4cb75193ed14faa2e4638dd256c5cabd');
        $this->checkFile('include/Gpf/Plugins/Exception.class.php', '6b7e377e09dd86b7299e5bb072396d22');
        $this->checkFile('include/Gpf/Plugins/ExtensionPoint.class.php', 'b0a1323bf018cafbbc042da0bb9411f4');
        $this->checkFile('include/Gpf/Plugins/Handler.class.php', 'a6760b1d982b6273ee90069826d92b00');
        $this->checkFile('include/Gpf/Plugins/PluginsList.class.php', '2fe0d5a98919f3ffcd4bbe27f7f32f4a');
        $this->checkFile('include/Gpf/Plugins/ValueContext.class.php', '61904f4c6576eb5ce292bff74262d88a');
        $this->checkFile('include/Gpf/Privileges.class.php', '954129314a691538f0c431ac906d8f85');
        $this->checkFile('include/Gpf/QrCode/QrCode.class.php', '13dc0265b2c3af233a89e04508dee43d');
        $this->checkFile('include/Gpf/Recurrence/Preset.class.php', '8d101081e5a066a17adb12bd34f8100f');
        $this->checkFile('include/Gpf/Recurrence/PresetList.class.php', '39efc89ca089f8a79f2b23bf43763810');
        $this->checkFile('include/Gpf/Recurrence/Setting/Day.class.php', '8f4ab739f67dd3d56851f2c651232317');
        $this->checkFile('include/Gpf/Recurrence/Setting/Factory.class.php', '1b98bd0b7186e8870cdaf585253ad814');
        $this->checkFile('include/Gpf/Recurrence/Setting/Hour.class.php', '4ee6ba8c7cb5657b260b87732d6a8af8');
        $this->checkFile('include/Gpf/Recurrence/Setting/Month.class.php', 'af851c3b26584ff7728e29ac09edf450');
        $this->checkFile('include/Gpf/Recurrence/Setting/Once.class.php', 'f0c4ad10ccfd180bbe29a7d9ae83e2bc');
        $this->checkFile('include/Gpf/Recurrence/Setting/Repeating.class.php', 'cca49a00d6e5b26241ce106e9c7f6ca9');
        $this->checkFile('include/Gpf/Recurrence/Setting/Week.class.php', '45cb77193102cd01ff66e47c0f5bd215');
        $this->checkFile('include/Gpf/Recurrence/Setting/Year.class.php', 'b97868a02a4e6a0836e5b2799e95a7a0');
        $this->checkFile('include/Gpf/Recurrence/Setting.class.php', '7ef37b75dbb84b2f9d9f40a1d616dae4');
        $this->checkFile('include/Gpf/Report/LoginsHistory.class.php', '3320a6d54b50ed4d5551d650bbfc7e6d');
        $this->checkFile('include/Gpf/Report/LoginsHistoryForm.class.php', '3452f768d620c7d465688d13dcee91d9');
        $this->checkFile('include/Gpf/Report/OnlineUsers.class.php', '7befde0f61b208e46618ccc91d9f3355');
        $this->checkFile('include/Gpf/Report/OnlineUsersGadget.class.php', '40c3d07312728ce6d49842de9f6447fb');
        $this->checkFile('include/Gpf/ResourceNotFoundException.class.php', '6d20aa0df39868428eaf91286a30042b');
        $this->checkFile('include/Gpf/RestApi/Api.class.php', 'ab2a18ddebbd685b93e68f787f37cc6b');
        $this->checkFile('include/Gpf/RestApi/Auth/Key.class.php', 'f85f63870e647ebec5f49e5f3c6e5f1e');
        $this->checkFile('include/Gpf/RestApi/Auth/KeyNotFoundException.class.php', '13b28ca3147fef3669ae711ed5cdfc2e');
        $this->checkFile('include/Gpf/RestApi/Auth/KeyNotMatchException.class.php', '7973e0d79d9f2780387a0b75b35c23e5');
        $this->checkFile('include/Gpf/RestApi/BadHandlerException.class.php', 'aabc4f036a2d421ceee8a23b31413d01');
        $this->checkFile('include/Gpf/RestApi/Client.class.php', '0ffcfa1587f0c30f2c5a9783fed7ab36');
        $this->checkFile('include/Gpf/RestApi/Const/Base.class.php', '164b5954bc43faf4d6fbfb4a86f39850');
        $this->checkFile('include/Gpf/RestApi/Const/YesNo.class.php', 'b7a94b9c1433ac36fcba467b39ac2b79');
        $this->checkFile('include/Gpf/RestApi/Data.class.php', 'd9e7abd72eac2062b88a0e415c9569de');
        $this->checkFile('include/Gpf/RestApi/DeleteHandler.class.php', 'da33c56e24da04392734d912d98a6ad9');
        $this->checkFile('include/Gpf/RestApi/Doc/CallPrinter.class.php', '0cf5ff20525f75655291a9182d3e7c58');
        $this->checkFile('include/Gpf/RestApi/Doc/ClassHeaderParser.class.php', '2a457e1b8f57a0bd5eb18da4953d1026');
        $this->checkFile('include/Gpf/RestApi/Doc/ExamplePrinter.class.php', '220688594872475b3dbb3edc2e42322a');
        $this->checkFile('include/Gpf/RestApi/Doc/Generator.class.php', 'f19229fe8a93adb0df9e53d64c177cbf');
        $this->checkFile('include/Gpf/RestApi/Doc/Json.class.php', '400c88c8874aabb731c419e6d7bffaf3');
        $this->checkFile('include/Gpf/RestApi/Doc/RoleIconPrinter.class.php', 'bf581e80902e47446b7b9f2764289984');
        $this->checkFile('include/Gpf/RestApi/Doc/RoleIconPrinterInterface.class.php', '692359e403baae6f3bb7d61c91a63345');
        $this->checkFile('include/Gpf/RestApi/Doc/Styles.class.php', '22cf207e3a1e44772268de4de4c22ded');
        $this->checkFile('include/Gpf/RestApi/Doc/Xml.class.php', '362106ccc50c866499fc8865ca638a1f');
        $this->checkFile('include/Gpf/RestApi/GetHandler.class.php', 'deaeeb6dc501b6b6931e1c3175c26e94');
        $this->checkFile('include/Gpf/RestApi/Handler/IdentifierAndNextEntity.class.php', '9e7606d1bb29c9d9f2b13e4f6e849132');
        $this->checkFile('include/Gpf/RestApi/Handler/IdentifierOnly.class.php', '2c14692194f762f30679e0465fc3e5ec');
        $this->checkFile('include/Gpf/RestApi/Handler/RequestTypeOnly.class.php', '7c23f086de2ebe2d59597531c89f80bb');
        $this->checkFile('include/Gpf/RestApi/Handler/Switch.class.php', '5e00e81b29e5f804035211acb606facd');
        $this->checkFile('include/Gpf/RestApi/Handler.class.php', 'fef04c59f3936361086541923237844c');
        $this->checkFile('include/Gpf/RestApi/LatestHandler.class.php', 'b714ee13bab330bbdbbf731029ae11ff');
        $this->checkFile('include/Gpf/RestApi/Param/AnyWord.class.php', '2be2380f7794f48ffd41bed1504bcd02');
        $this->checkFile('include/Gpf/RestApi/Param/Base.class.php', 'e7dfcef5123bb3ef14fddeefca49bf38');
        $this->checkFile('include/Gpf/RestApi/Param/Regexp.class.php', '7807d140ad4929e112a00b409897334d');
        $this->checkFile('include/Gpf/RestApi/Param/Text.class.php', 'fa1c98b7e3afd0af22cb879c604df312');
        $this->checkFile('include/Gpf/RestApi/Param/WrongFormatException.class.php', '57811ee04734543ccc665ea6d5599bea');
        $this->checkFile('include/Gpf/RestApi/PostHandler.class.php', 'cac75f241caede1ab24e08a493a46c46');
        $this->checkFile('include/Gpf/RestApi/ProcessingException.class.php', '1e9dea77009d386b824f4297568def4e');
        $this->checkFile('include/Gpf/RestApi/PutHandler.class.php', '6179d122e498d862256c60487696e4bc');
        $this->checkFile('include/Gpf/RestApi/Response/Base.class.php', 'af974010ba4c5a2fa2cce3ca7ca97688');
        $this->checkFile('include/Gpf/RestApi/Response/ConstListField.class.php', 'da23d54e753084346f7da199bc107cfb');
        $this->checkFile('include/Gpf/RestApi/Response/DateTimeField.class.php', 'c83d433dd74bcf9f1fc9adba7450f540');
        $this->checkFile('include/Gpf/RestApi/Response/Encoder/Json.class.php', '7c08219f78548fe5685bf33ca44fa51f');
        $this->checkFile('include/Gpf/RestApi/Response/Encoder/Xml.class.php', 'a96c9f1cbb805062aad3a5417b1b7d30');
        $this->checkFile('include/Gpf/RestApi/Response/Encoder/Yaml.class.php', '78ea09ac55320f66474f8768676de8dd');
        $this->checkFile('include/Gpf/RestApi/Response/Encoder.class.php', '6655138230759ce00acd84fb29f58bc2');
        $this->checkFile('include/Gpf/RestApi/Response/Error.class.php', '5c8e9c901b5b5c22894bac0562501e82');
        $this->checkFile('include/Gpf/RestApi/Response/FieldBase.class.php', '9521fcd472f0a23c3a479a5e4faf63e2');
        $this->checkFile('include/Gpf/RestApi/Response/FieldNotFoundException.class.php', 'b0d2c6d0be09b9aed4a64b2fdfbb14d2');
        $this->checkFile('include/Gpf/RestApi/Response/FloatField.class.php', 'c39a2e41a3b4aa30344fc1cdc5701d2a');
        $this->checkFile('include/Gpf/RestApi/Response/GroupField.class.php', '4ffe45f1cf065c231301684a97a4b5b9');
        $this->checkFile('include/Gpf/RestApi/Response/IntField.class.php', '99bcceaef1d319ea8dfc300ef6e59534');
        $this->checkFile('include/Gpf/RestApi/Response/Ok.class.php', '74cfd03ea03ce62fedd0c3ff4e72fa0b');
        $this->checkFile('include/Gpf/RestApi/Response/RecordsetField.class.php', '0726fafe05ac282f31daac5ccbc7e4b5');
        $this->checkFile('include/Gpf/RestApi/Response/TextField.class.php', 'bab70e5ecf06fd4cf4038a527ecb55e7');
        $this->checkFile('include/Gpf/RestApi/Response.class.php', '21a8297642c67cda43cb44f14f3cc5ce');
        $this->checkFile('include/Gpf/RestApi/VersionParser.class.php', '9da39cd8a55b66fb38a99fa090f9d9d5');
        $this->checkFile('include/Gpf/Role/RoleForm.class.php', '75c98424d5a85e5d85309f0ab26f4a2b');
        $this->checkFile('include/Gpf/Role/RolePrivilegesForm.class.php', '3d70ed0d1e3bfa2a6883cbb4822f47a9');
        $this->checkFile('include/Gpf/Role/RoleUsersGrid.class.php', 'd1ffd3334a2ef58c6cc6aaa0cbad2ee0');
        $this->checkFile('include/Gpf/Rpc/Action.class.php', 'f516f7f82f4d284d2ed4d05fdabd0f7e');
        $this->checkFile('include/Gpf/Rpc/ActionRequest.class.php', '4dee143a84ff4b2e15d1f3b94891f398');
        $this->checkFile('include/Gpf/Rpc/Annotation/CommentParser.class.php', '1be701a8e48e78c58ef0598ce711de86');
        $this->checkFile('include/Gpf/Rpc/Annotation.class.php', '90f1fbf41a3f56bc9200ffb5237a1799');
        $this->checkFile('include/Gpf/Rpc/Array.class.php', '998e6cec8c6661802d31e9bf55f0d0e7');
        $this->checkFile('include/Gpf/Rpc/CachedResponse.class.php', '7ee4af4656a4c4bb86918b57e5b79dec');
        $this->checkFile('include/Gpf/Rpc/Data.class.php', 'b962e24993d46d3230fc3e19d58e24c9');
        $this->checkFile('include/Gpf/Rpc/DataDecoder.class.php', 'a77a749d955b42904b709382afb545a0');
        $this->checkFile('include/Gpf/Rpc/DataEncoder.class.php', 'e07b9f708fb487a1830677cb046e0c8c');
        $this->checkFile('include/Gpf/Rpc/DataRequest.class.php', '0d8b04334e6909c10737a8fee52c779c');
        $this->checkFile('include/Gpf/Rpc/ExceptionResponse.class.php', 'cfb192298aac4677a2917f062ac15875');
        $this->checkFile('include/Gpf/Rpc/ExecutionException.class.php', 'e893a170739bdec6c2feca29e7f8a419');
        $this->checkFile('include/Gpf/Rpc/FilterCollection.class.php', 'a25dcd336d5c1bb44127dc5d3517fca9');
        $this->checkFile('include/Gpf/Rpc/Form/Validator/DateValidator.class.php', '34b603d1be813ef09a587cb7a0cbd0a3');
        $this->checkFile('include/Gpf/Rpc/Form/Validator/EmailValidator.class.php', '4409302aa8df9859ef9eeea01ca2fb53');
        $this->checkFile('include/Gpf/Rpc/Form/Validator/FieldValidator.class.php', 'f99cc5ae2a80b01b483e89f0839b0017');
        $this->checkFile('include/Gpf/Rpc/Form/Validator/FormValidatorCollection.class.php', '305237cefab1c0c962b7a0366d6ac4db');
        $this->checkFile('include/Gpf/Rpc/Form/Validator/IntegerNumberPositiveValidator.class.php', 'cec4a340c123d8388176681b1573c149');
        $this->checkFile('include/Gpf/Rpc/Form/Validator/IntegerNumberValidator.class.php', '8440cce0d80fb9c4734177dcb92cf916');
        $this->checkFile('include/Gpf/Rpc/Form/Validator/MandatoryValidator.class.php', '4b8ec1c48ceb8b868a42e6b07ed9fa52');
        $this->checkFile('include/Gpf/Rpc/Form/Validator/NumberRangeValidator.class.php', '3754a9f1d4839113e00fd6e5aa51e0db');
        $this->checkFile('include/Gpf/Rpc/Form/Validator/NumberValidator.class.php', '5ed8c24408348c812ca235f6b5818879');
        $this->checkFile('include/Gpf/Rpc/Form/Validator/RegExpValidator.class.php', '0d0e97c421fedf4107c3ef60083f68d3');
        $this->checkFile('include/Gpf/Rpc/Form/Validator/UrlValidator.class.php', '22c38dfad539b1a3847cf7fdff80b8d4');
        $this->checkFile('include/Gpf/Rpc/Form/Validator/Validator.class.php', '249439e70424a241ad8167e5d82d6f0c');
        $this->checkFile('include/Gpf/Rpc/Form.class.php', '297e5bbcfb20a3974e1aee67fb5e4342');
        $this->checkFile('include/Gpf/Rpc/FormHandler.class.php', '7bdeb73b2def8fe80398e03da6f98e9c');
        $this->checkFile('include/Gpf/Rpc/FormRequest.class.php', 'c5790bb800c8d7ade125a79f7e5398cb');
        $this->checkFile('include/Gpf/Rpc/GridRequest.class.php', '731b8dba7fab4590db87a5cb620d1afb');
        $this->checkFile('include/Gpf/Rpc/HostnameFormValidator.class.php', '13d0685b7b629327698ce60c467e1999');
        $this->checkFile('include/Gpf/Rpc/Json.class.php', '586dcbd5069f561a7ead40cdc09c0b33');
        $this->checkFile('include/Gpf/Rpc/JsonObject.class.php', '20244cb27906830d0eb2007d473d7e15');
        $this->checkFile('include/Gpf/Rpc/LicenseInvalidException.class.php', '4e4715936d498303b8a50a3c443a9abb');
        $this->checkFile('include/Gpf/Rpc/Map.class.php', '311d1bc3f8809e88353f8b8497d5901c');
        $this->checkFile('include/Gpf/Rpc/MultiRequest.class.php', '218d31439a0922aca3671c38efe9a23a');
        $this->checkFile('include/Gpf/Rpc/Object.class.php', '695c4dbc7d5bfafd676afec4c76281b1');
        $this->checkFile('include/Gpf/Rpc/Params.class.php', '67918a848aa62b38bb958ded4fd18e6d');
        $this->checkFile('include/Gpf/Rpc/PermissionDeniedException.class.php', '2c034a5ea55df3b3afe36b9427410534');
        $this->checkFile('include/Gpf/Rpc/PermissionGenerator.class.php', 'e8cf140b45531c4237a900d01043a16d');
        $this->checkFile('include/Gpf/Rpc/PhpErrorHandler.class.php', '0d5dc16583b380b186a7039ec60aa00d');
        $this->checkFile('include/Gpf/Rpc/PhpShutdownHandler.class.php', '35d99b0c7d361691e2567ba09b3e26fe');
        $this->checkFile('include/Gpf/Rpc/RecordSetRequest.class.php', '65fd75b498040a1d32cff16ea354f2e9');
        $this->checkFile('include/Gpf/Rpc/Request.class.php', '20b3f661ab31446d5e51e6ad5aa1e8fe');
        $this->checkFile('include/Gpf/Rpc/Serializable.class.php', '5ef54b91546ac94f3cc1cc0e3a2f1479');
        $this->checkFile('include/Gpf/Rpc/Server.class.php', '7e8c1b408023c5f230ed0218be3dcb21');
        $this->checkFile('include/Gpf/Rpc/ServiceMethod.class.php', '92f1dec27f81f0f8fc668458b868a785');
        $this->checkFile('include/Gpf/Rpc/SessionExpiredException.class.php', '86931776133294a656727a2174487058');
        $this->checkFile('include/Gpf/Rpc/TableData.class.php', '78fd3588581f35a6a1aab5272905fd1f');
        $this->checkFile('include/Gpf/Rpc/WindowNameHandler.class.php', '953edaaf6f879a19c3f067eaf74b96df');
        $this->checkFile('include/Gpf/Search/Model/DataSet.class.php', '88bc641a822a45f7b487f1617748aab7');
        $this->checkFile('include/Gpf/Search/SearchEngine.class.php', '65fe528927ec711251f0f218870bc370');
        $this->checkFile('include/Gpf/Session/Exception/SessionAlreadyCreated.class.php', '147898845fd1e08bba7281e7c90eede5');
        $this->checkFile('include/Gpf/Session/Exception/SessionExpired.class.php', 'ad0aa3a86f5fa0f53f7fface0d90a6a3');
        $this->checkFile('include/Gpf/Session/Exception/SessionNotCreated.class.php', 'eb8d702299dae9d6fd82235038c511b9');
        $this->checkFile('include/Gpf/Session/Exception/SessionNotStarted.class.php', 'e327519df1017de43ea30b3d3a859e19');
        $this->checkFile('include/Gpf/Session/Exception.class.php', 'c59d45acdeffa3e6b556954af79ed602');
        $this->checkFile('include/Gpf/Session/Handler/Db.class.php', '4cbf6b89af0b86a0e10c80f21f32b732');
        $this->checkFile('include/Gpf/Session/Handler/Memory.class.php', '432c60f4b5faf959d9449ed4be9a3770');
        $this->checkFile('include/Gpf/Session/Handler/Php.class.php', '15bc9cbe6d7261d951109373cfe537a9');
        $this->checkFile('include/Gpf/Session/Handler.class.php', 'fc3f06f320bb70e26176ec1d2cbc22b6');
        $this->checkFile('include/Gpf/Session.class.php', '0d4c1f37953bd5d87e7874b678f70d8d');
        $this->checkFile('include/Gpf/Session_old.class.php', '8904fd0ef3cf48e92871c4dc9354e764');
        $this->checkFile('include/Gpf/Settings/AccountSettings.class.php', '41aba33e4ea2fe62079c91a319ae8687');
        $this->checkFile('include/Gpf/Settings/Base.class.php', 'd70bd5d10f8e473bd4c8be8704c75cab');
        $this->checkFile('include/Gpf/Settings/Define.class.php', '7f0ec86b6bd5218dcfb9a070b9ad4496');
        $this->checkFile('include/Gpf/Settings/Gpf.class.php', '607093cda83c9516443af8daa2efb2e0');
        $this->checkFile('include/Gpf/Settings/Regional.class.php', '0b5c2043e3a5ac7dfe65a238ca38f2f9');
        $this->checkFile('include/Gpf/Settings/RegionalSettingsForms.class.php', '8a1fb6bfa4534387919540345c2f44bc');
        $this->checkFile('include/Gpf/Settings/TimeZoneSettingsForm.class.php', '7df91d1e07e47f55a67b544f5b75433b');
        $this->checkFile('include/Gpf/Settings/UnknownSettingException.class.php', '4d8c24dac0a497a7e14bf1c881285ef8');
        $this->checkFile('include/Gpf/Settings.class.php', '62f16cfe8985d39bbe78541a1d419ba2');
        $this->checkFile('include/Gpf/SettingsImportExport.class.php', '12fed1bc01736fed03670c996285aa33');
        $this->checkFile('include/Gpf/SmartyPlugins/plugins/compiler.widget.php', '49713a3b9e84aa9f11cde88a94502dce');
        $this->checkFile('include/Gpf/SmartyPlugins/plugins/function.fetch.php', '99bebf8512950b3b3043a7a12ba16e32');
        $this->checkFile('include/Gpf/SmartyPlugins/plugins/function.localize.php', '0b741fafd4fed19afc43294f5a7b6535');
        $this->checkFile('include/Gpf/SmartyPlugins/plugins/function.ratioColon.php', '61da3aca1d33121613e73cae80ee2844');
        $this->checkFile('include/Gpf/SmartyPlugins/plugins/function.server_widget.php', 'da55f4f18a10f0837d12be98c90e11fc');
        $this->checkFile('include/Gpf/SmartyPlugins/plugins/function.widget_dynamic.php', 'ca80f2a392d8b697f16e50e240b005f1');
        $this->checkFile('include/Gpf/SmartyPlugins/plugins/modifier.date.php', '7ab6e6c7030c0e8a3c0fa43c56cc8951');
        $this->checkFile('include/Gpf/SmartyPlugins/plugins/modifier.escape_replace_new_lines.php', 'f85a957ec27a5c33b3f2855b43791506');
        $this->checkFile('include/Gpf/SmartyPlugins/plugins/modifier.escape_single_quotes.php', 'c727f679ba7271761be309e4f4c033ce');
        $this->checkFile('include/Gpf/SmartyPlugins/plugins/modifier.file_size.php', 'ae72404c5117ce92f9659765ee22529b');
        $this->checkFile('include/Gpf/SmartyPlugins/plugins/modifier.number.php', '7d6b10746e22f423835949c690404b4a');
        $this->checkFile('include/Gpf/SmartyPlugins/plugins/modifier.number_span.php', '825a4e79bc91872521b38f2919a082b4');
        $this->checkFile('include/Gpf/SmartyPlugins/plugins/resource.template.php', '92f1d76866741c9997229a92a8b49c09');
        $this->checkFile('include/Gpf/SmartyPlugins/plugins/resource.text.php', '5a75903bcc5bd8642d3ab9724ac4353c');
        $this->checkFile('include/Gpf/SqlBuilder/CompoundWhereCondition.class.php', '2cbf4a33f697fe84556056d1c59dc3e1');
        $this->checkFile('include/Gpf/SqlBuilder/DBMaintenance.class.php', 'a30c01f62e958724a05546b0506b7506');
        $this->checkFile('include/Gpf/SqlBuilder/DeleteBuilder.class.php', '8679ece26cc82f7896897e9d11f44fc9');
        $this->checkFile('include/Gpf/SqlBuilder/DeleteClause.class.php', '8f850996ac95bca5caa464921429198c');
        $this->checkFile('include/Gpf/SqlBuilder/Filter.class.php', '3bf7fd5adcb36988031d652c92239385');
        $this->checkFile('include/Gpf/SqlBuilder/FromClause.class.php', '1cd32d4920b98baefa49616b47e020f5');
        $this->checkFile('include/Gpf/SqlBuilder/FromClauseTable.class.php', '1d79200c4d9f2916d9ed39a6c4d56d38');
        $this->checkFile('include/Gpf/SqlBuilder/FromTable.class.php', '098be744d4c97eecfec92cdbb9d7a080');
        $this->checkFile('include/Gpf/SqlBuilder/GroupByClause.class.php', 'caec7d1c1f4ef23069ab262568a20a6f');
        $this->checkFile('include/Gpf/SqlBuilder/HavingClause.class.php', 'cc90aec3d6348e9481bc90815f184a4f');
        $this->checkFile('include/Gpf/SqlBuilder/IndexHintClause.class.php', '269225328aab9d42047c693bb16adc52');
        $this->checkFile('include/Gpf/SqlBuilder/InsertBuilder.class.php', '74ac25db9fcad676568d54a19aa3ee32');
        $this->checkFile('include/Gpf/SqlBuilder/JoinTable.class.php', '8b8543b24b0c535a4511bba6a07c4a56');
        $this->checkFile('include/Gpf/SqlBuilder/LimitClause.class.php', '3a6c64081a255806975da11a702d23c8');
        $this->checkFile('include/Gpf/SqlBuilder/ModifyBuilder.class.php', 'e92ca07c08c2f75447ee833001c25a6e');
        $this->checkFile('include/Gpf/SqlBuilder/Operator.class.php', '8de546d8ce4a2a7ea7309b9cda7c3532');
        $this->checkFile('include/Gpf/SqlBuilder/OrderByClause.class.php', '2db95ea9dc681a5fe6d593f692bf65d2');
        $this->checkFile('include/Gpf/SqlBuilder/OrderByColumn.class.php', 'd3befdb6c4408f32c444b34a8f71f934');
        $this->checkFile('include/Gpf/SqlBuilder/SelectBuilder.class.php', '1a575d3d5635fd265be489956af6566c');
        $this->checkFile('include/Gpf/SqlBuilder/SelectClause.class.php', '094ad708ebb862b654a2c40ba1e802b7');
        $this->checkFile('include/Gpf/SqlBuilder/SelectColumn.class.php', '8afaa1497d7be0b1f0391515f5b57680');
        $this->checkFile('include/Gpf/SqlBuilder/SelectIterator.class.php', 'ff70bbaf5336d59d86e6e9ba0227e8fa');
        $this->checkFile('include/Gpf/SqlBuilder/SetClause.class.php', '9372e4dc00ab3345dade724b6a98672e');
        $this->checkFile('include/Gpf/SqlBuilder/SubSelectTable.class.php', '17225774a0b0110dd512940d4eb1ab0d');
        $this->checkFile('include/Gpf/SqlBuilder/UnionBuilder.class.php', '36bc3813149b073b3da9c586521a407d');
        $this->checkFile('include/Gpf/SqlBuilder/UpdateBuilder.class.php', '707566e3e9c651dcdc0644df36ce4121');
        $this->checkFile('include/Gpf/SqlBuilder/UpdateLimitClause.class.php', 'd5f5a8ce6b53224a11a90a3dd5b855b3');
        $this->checkFile('include/Gpf/SqlBuilder/WhereClause.class.php', 'dfb4c03a2c4bc73833f29cd336aed139');
        $this->checkFile('include/Gpf/SqlBuilder/WhereCondition.class.php', 'a699f9cfd1b0bc6145e8f2126a04749d');
        $this->checkFile('include/Gpf/System/Module.class.php', '10e768721444836d359024bb68b1b8c3');
        $this->checkFile('include/Gpf/System/Session.class.php', '38098aa4a32b64a98de9164400b3780a');
        $this->checkFile('include/Gpf/Tasks/DeleteOldFilesTask.class.php', '77492f88825a8440ee2840feab07a646');
        $this->checkFile('include/Gpf/Tasks/DeleteOldQuickTasks.class.php', '9ad1cf17b43114343c9ad3086ff196b1');
        $this->checkFile('include/Gpf/Tasks/DeleteOldSessions.class.php', '5e5d7a1816784418365efb6ce0d523fb');
        $this->checkFile('include/Gpf/Tasks/LockingException.class.php', 'd3a5dd4e4ec4c7e77d5a88f2b0f96738');
        $this->checkFile('include/Gpf/Tasks/LongTask.class.php', '9b3b6e0c4e836270542d00bd68419527');
        $this->checkFile('include/Gpf/Tasks/LongTaskInterrupt.class.php', '6aa8585244eac330dd0019613e3f5880');
        $this->checkFile('include/Gpf/Tasks/MassGridActionTask.class.php', '6d98ebaaf86bfb68572d7dea4d618cd9');
        $this->checkFile('include/Gpf/Tasks/PendingTasksGrid.class.php', '85e18af8d8958447110176a1d70d82fe');
        $this->checkFile('include/Gpf/Tasks/PlannedTasksScheduler.class.php', '4adf312eb189536d00f917fe9d43d71f');
        $this->checkFile('include/Gpf/Tasks/PrivilegedUser.class.php', '54c4211c94d87463a4ce15f5ef2285c8');
        $this->checkFile('include/Gpf/Tasks/QuickTask.class.php', 'a8b69b4d774dd4b69cd1777d9ac982cd');
        $this->checkFile('include/Gpf/Tasks/QuickTaskGroup.class.php', '7d0283cb0857a64c8be61028ebcf8fe9');
        $this->checkFile('include/Gpf/Tasks/QuickTaskRunner.class.php', 'a90fb486214ca8b35b5ca8705ec00c9a');
        $this->checkFile('include/Gpf/Tasks/Runner.class.php', '687d83e5a9eda21d11cc1dce9830721f');
        $this->checkFile('include/Gpf/Tasks/SessionTask.class.php', '2600b3fed9e1702ef4ae4dc4197c857b');
        $this->checkFile('include/Gpf/Tasks/Task.class.php', 'f7b4893b62f9166f92c8cea8ff17a0b2');
        $this->checkFile('include/Gpf/Tasks/TaskSettingsFormBase.class.php', 'b93c7191b89e1e09542c186fb96e47e3');
        $this->checkFile('include/Gpf/TemplateExtensionsContext.class.php', '9c510151af5995eeecd7327666dbf22c');
        $this->checkFile('include/Gpf/Templates/HasAttributes.class.php', 'ee8ec11277bf565824bb4c9969a66d13');
        $this->checkFile('include/Gpf/Templates/NoWidget.class.php', '6815f5a0e6376c6abcdc48e07642406f');
        $this->checkFile('include/Gpf/Templates/Smarty.class.php', 'dfb772ec4adc99b03ab9b00a42ae180c');
        $this->checkFile('include/Gpf/Templates/SmartyCompiler.class.php', 'd3b85d9f15719b19e7e74dfa139173b3');
        $this->checkFile('include/Gpf/Templates/SmartySyntaxException.class.php', '69ad56096c474be7c296d5d8de62327b');
        $this->checkFile('include/Gpf/Templates/Template.class.php', '8ed3b1cbf95af736d39a9431b1b9ed6c');
        $this->checkFile('include/Gpf/Templates/TemplateForm.class.php', 'cf1d1421359efc184cad6168feef27be');
        $this->checkFile('include/Gpf/Templates/TemplateHelper.class.php', '7009f81d609dcee4d1c3d8b8a77463f3');
        $this->checkFile('include/Gpf/Templates/TemplateService.class.php', '343165c5952f77a99afe9b7ead897aef');
        $this->checkFile('include/Gpf/Templates/Templates.class.php', '7f28511df829d8591238fc262d91f24b');
        $this->checkFile('include/Gpf/TokenBucket/RateLimiter.class.php', 'fd098a8ac8896c611dc8f42ff855190b');
        $this->checkFile('include/Gpf/TokenBucket/Storage/Db.class.php', 'f10bd78fd10ef9f7f48e575aa1383984');
        $this->checkFile('include/Gpf/TokenBucket/TokenBucket.class.php', '3e4da5dd261e57489f1f0adfa79df271');
        $this->checkFile('include/Gpf/TokenBucket/TransactionalMutex.class.php', 'e2b6d82cc2e89efdc7d69b646546bdee');
        $this->checkFile('include/Gpf/Tree/Base.class.php', '333afc242a06a27139f1e01f855ee904');
        $this->checkFile('include/Gpf/Tree/Convertor.class.php', '4fc2c1fd4eadf74e8062a5bfb8aecb79');
        $this->checkFile('include/Gpf/Ui/ClientWidget.class.php', '3ce9b29b400fd4ff598af2002586e42b');
        $this->checkFile('include/Gpf/Ui/Controller/Action.class.php', '1805c1479864966090ef6bed6d2dfdfc');
        $this->checkFile('include/Gpf/Ui/Controller/ActionParser.class.php', 'f890a9a0beb177ea1fb7932731e9830a');
        $this->checkFile('include/Gpf/Ui/Controller/Main.class.php', '34e9bc2fab6b63de8e45a2cb94411c8b');
        $this->checkFile('include/Gpf/Ui/Controller/NoQueryParameter.class.php', 'ea861e1dc410ed51417f747821e5212d');
        $this->checkFile('include/Gpf/Ui/Controller/Url.class.php', '491e054b0223f6ecefd61888c3eb3230');
        $this->checkFile('include/Gpf/Ui/Controller/UrlParser.class.php', 'e47f2acf62de59e0c6035c6574f0ad0d');
        $this->checkFile('include/Gpf/Ui/DynamicFormPanel.class.php', '137fdb3f540cde917392d8c85b88c504');
        $this->checkFile('include/Gpf/Ui/DynamicFormPanelCheckException.class.php', 'bf182cd6f1d152bab9926c8355f0a47a');
        $this->checkFile('include/Gpf/Ui/LoadableTree.class.php', '9c8f000b9f81c69e55bb18bad64f1a85');
        $this->checkFile('include/Gpf/Ui/MashupWidget.class.php', '171fbf3040ce2024a5591ec96804eb8e');
        $this->checkFile('include/Gpf/Ui/Model/Breadcrumbs.class.php', 'cd3ec5dc8800458bfa8c6bfaaefd2bb7');
        $this->checkFile('include/Gpf/Ui/Model/Page.class.php', '529a8b49c8c9676373b4f327007658b2');
        $this->checkFile('include/Gpf/Ui/Page.class.php', 'fbffef3498ef0362f1ef02a0e398fda6');
        $this->checkFile('include/Gpf/Ui/RichListBox.class.php', '713d66085ec8824fe430986e646cdca3');
        $this->checkFile('include/Gpf/Ui/RichListBoxService.class.php', '90c2c5fcbd7d45503cf253d8189f4172');
        $this->checkFile('include/Gpf/Ui/TemplatePanel.class.php', 'fb5ab91d0caee6266b9f5a4e945376e2');
        $this->checkFile('include/Gpf/Ui/Widget.class.php', '5626363d7b65490adf5566a300813e36');
        $this->checkFile('include/Gpf/View/Column.class.php', 'ede1f0e989df6c1c2a32b60b79bd28f3');
        $this->checkFile('include/Gpf/View/Columns.class.php', '7c93cdf8f800c31209ee75e1fd2cdbe9');
        $this->checkFile('include/Gpf/View/CsvGridService.class.php', 'ffe6e48fb581687b8d9164ac76184a05');
        $this->checkFile('include/Gpf/View/CustomFilterFields.class.php', '4bb11a6cdfc84602db4db8c707bb3540');
        $this->checkFile('include/Gpf/View/FilterForm.class.php', 'c906def69757abb291a4c22d43a75160');
        $this->checkFile('include/Gpf/View/FormFieldForm.class.php', 'f07c54a11c7495da51f1b622c74370c6');
        $this->checkFile('include/Gpf/View/FormFieldGrid.class.php', 'f5a4a12a50a0886664796e9b2b200a10');
        $this->checkFile('include/Gpf/View/FormService.class.php', 'e4f60b293807b299b9aaeec656711cb0');
        $this->checkFile('include/Gpf/View/Grid/HasRowFilter.class.php', 'a9d40a816aef5448afc4649e72cca840');
        $this->checkFile('include/Gpf/View/GridInterface.class.php', '6cbc74ea0ed9dc5f39a4056b33db8be9');
        $this->checkFile('include/Gpf/View/GridService.class.php', '3a71c58737c28474f142c6a53c0e2c43');
        $this->checkFile('include/Gpf/View/MemoryGridService.class.php', '30c771c30802a6dec53cbe15211cdc6a');
        $this->checkFile('include/Gpf/View/MultiEditorService.class.php', '83f365d312d95e61941f4dccd338a464');
        $this->checkFile('include/Gpf/View/ViewColumn.class.php', '050bd47477fd3b4d5b620437d28a3cf4');
        $this->checkFile('include/Gpf/View/ViewService.class.php', 'c57da63a6bb5a0e1b683804868a06612');
        $this->checkFile('include/Gpf.class.php', 'dcfaae4f460d9c575af18bcb1f1f3262');
        $this->checkFile('include/Pap/Account.class.php', 'f22f3f7d25a562b71c84a86c199ce1b4');
        $this->checkFile('include/Pap/Affiliate.class.php', '942f75f8363be72930144b59e93a44dd');
        $this->checkFile('include/Pap/AffiliateLogin.class.php', '53acbf25328a70b2429c05cd5533f3aa');
        $this->checkFile('include/Pap/Affiliates/ApplicationSettings.class.php', '7ea00542cfab29c7e657382709a2167f');
        $this->checkFile('include/Pap/Affiliates/MainPanelHeader.class.php', '3531b25e2c690f2f266f864b5dd5190a');
        $this->checkFile('include/Pap/Affiliates/MerchantInfo.class.php', '332c6bf34ccd442b6e189f8c84376bd5');
        $this->checkFile('include/Pap/Affiliates/PayoutOptionListBox.class.php', '6b52a3ca8dd391d98aeab69a40dba607');
        $this->checkFile('include/Pap/Affiliates/Profile/ContactUsForm.class.php', 'cf79244b2103019d42ff7e5aed783208');
        $this->checkFile('include/Pap/Affiliates/Profile/EmailNotificationsForm.class.php', '3606c2197988db549ccb9d19d4209ed2');
        $this->checkFile('include/Pap/Affiliates/Profile/PersonalDetailsForm.class.php', 'ac5a7e8547bb2d1d4b68bac3a7d3dafe');
        $this->checkFile('include/Pap/Affiliates/Profile/SendToFriendForm.class.php', '50c3b6c25cb76746077b4c0ab9717ae7');
        $this->checkFile('include/Pap/Affiliates/Promo/BannerPreview.class.php', '3d523caaba609b805a96d4b300c375cb');
        $this->checkFile('include/Pap/Affiliates/Promo/BannerTypes.class.php', '4b229d6d9ba75eaf9408236e5754117f');
        $this->checkFile('include/Pap/Affiliates/Promo/BannersGrid.class.php', '362ab90e76257ddff114a3fc819bba59');
        $this->checkFile('include/Pap/Affiliates/Promo/Campaigns.class.php', '66e3e24c7edfc663523255f697ac1ca9');
        $this->checkFile('include/Pap/Affiliates/Promo/CampaignsGrid.class.php', 'e8f3b3817f6f3df7e62ce88af6fb532f');
        $this->checkFile('include/Pap/Affiliates/Promo/ChannelsForm.class.php', '009a1d6781bd77ecf13158db3003f485');
        $this->checkFile('include/Pap/Affiliates/Promo/ChannelsGrid.class.php', '0b103601e91d33b3baf76fdc5159338e');
        $this->checkFile('include/Pap/Affiliates/Promo/DirectLinksForm.class.php', '846f5c53cbc8435a6fa02337a90f4a35');
        $this->checkFile('include/Pap/Affiliates/Promo/DirectLinksGrid.class.php', 'a58e1f676b91cd011a82bb8766eccd10');
        $this->checkFile('include/Pap/Affiliates/Promo/DynamicLink.class.php', '89f2a2b84713f9ae3c81e5abe21088c2');
        $this->checkFile('include/Pap/Affiliates/Promo/LoginForm.class.php', '87320a96d6fcaa0916c9cea088e9edf8');
        $this->checkFile('include/Pap/Affiliates/Promo/RowCompoundFilter.class.php', 'e4f19662ec261c4bee149a2ee5be9853');
        $this->checkFile('include/Pap/Affiliates/Promo/SelectBuilderCompoundFilter.class.php', '97ab7051cc889306494ef22c2aad45e4');
        $this->checkFile('include/Pap/Affiliates/Promo/SignupForm.class.php', 'b581021633652cdadd981bb594cd669a');
        $this->checkFile('include/Pap/Affiliates/Reports/BannersStatsGrid.class.php', 'c19a6a12088d964f61d0a634367a8188');
        $this->checkFile('include/Pap/Affiliates/Reports/CampaignsStatsGrid.class.php', '5dbf54c4ff3b08513c75929799e4f9d4');
        $this->checkFile('include/Pap/Affiliates/Reports/ChannelStatsGrid.class.php', 'ac0321ec472abd60d52ab6753d0fb95f');
        $this->checkFile('include/Pap/Affiliates/Reports/ClicksGrid.class.php', '17fa891204bec08ad69be5a1b7304f2c');
        $this->checkFile('include/Pap/Affiliates/Reports/DailyReportGrid.class.php', '84bb4df0c04e03ab6253eb3b38c91d9b');
        $this->checkFile('include/Pap/Affiliates/Reports/DisplayInvoice.class.php', '32d438cdca0866b5801da73ce101c54c');
        $this->checkFile('include/Pap/Affiliates/Reports/FinancialOverview.class.php', '79385a5dc805d6c12a49c4e71b06a66f');
        $this->checkFile('include/Pap/Affiliates/Reports/PaidTransactions.class.php', '6c32664c7d7f49eb5ec199ab9e130245');
        $this->checkFile('include/Pap/Affiliates/Reports/PayoutsGrid.class.php', 'eb2b3f8f7c2b6f06fc885e33dd5d09f0');
        $this->checkFile('include/Pap/Affiliates/Reports/PeriodStats.class.php', 'bbc5a1cb64285ddd4e2f229dfd6b25c2');
        $this->checkFile('include/Pap/Affiliates/Reports/QuickStatsData.class.php', '3e8ab4159f3ec7164f1c3bc27538ac20');
        $this->checkFile('include/Pap/Affiliates/Reports/SubAffSaleStatsBuilder.class.php', 'bad48884fae393755edffc09fd9115c0');
        $this->checkFile('include/Pap/Affiliates/Reports/SubAffiliateStats.class.php', 'e3bdd00c2eacf75e04674bba24d026d9');
        $this->checkFile('include/Pap/Affiliates/Reports/SubAffiliatesSalesGrid.class.php', '0f3ad97d7128d7d17450f3a4b37885cb');
        $this->checkFile('include/Pap/Affiliates/Reports/SubAffiliatesTree.class.php', '19006072e0bec6cfe202bca3012d4a00');
        $this->checkFile('include/Pap/Affiliates/Reports/SubaffSaleStatsGrid.class.php', '27d0e2c4cc436f540dc0d40adc3820fc');
        $this->checkFile('include/Pap/Affiliates/Reports/TransactionsGrid.class.php', 'e1c943003632329edde5037432d87b7c');
        $this->checkFile('include/Pap/Affiliates/Reports/TrendsReport.class.php', '4e856b04b27684e15a8d5c03fd37c59e');
        $this->checkFile('include/Pap/Affiliates/Reports/TrendsReportActionWidget.class.php', 'c3e37b23757a34fe7b12da0ae72d91e7');
        $this->checkFile('include/Pap/Affiliates/Reports/TrendsReportWidget.class.php', '27c7f9cab6f4255a8da40ab16102e203');
        $this->checkFile('include/Pap/Affiliates/SubaffiliateRichListBox.class.php', '3060f310fe5f2ab101ec8246f0540c0c');
        $this->checkFile('include/Pap/Affiliates/SubaffiliatesGrid.class.php', 'a6a7243eae55940cc3a954958f770e85');
        $this->checkFile('include/Pap/Affiliates/TopReferrerUrlGridAffiliate.class.php', 'c7b11fee43de63183a3e659ab9c9c557');
        $this->checkFile('include/Pap/Affiliates/TopReferrerUrlStatsGrid.class.php', 'a38ca76d4ded3dbe195f9660e0b05a1f');
        $this->checkFile('include/Pap/Affiliates/TopUrlGridAffiliate.class.php', 'a7a663d39fc0a6a4d514fa7682c6c122');
        $this->checkFile('include/Pap/Affiliates/User.class.php', '263f2c5042d053d9d43d2775596374bb');
        $this->checkFile('include/Pap/Affiliates/UserForm.class.php', 'b06b307d0b215e9a8f3f738566e961d0');
        $this->checkFile('include/Pap/Alert/Data.class.php', 'a7a8b53abcab9dd82b11fcd28ffe6b36');
        $this->checkFile('include/Pap/Alert/Xml.class.php', 'a15d01a4f8a818023038a96454b61e36');
        $this->checkFile('include/Pap/AnonymUser.class.php', '6451800e01bb21ec2aa6d9f19e26e166');
        $this->checkFile('include/Pap/Api/Affiliate.class.php', '0c869d583e3736237c0c6108d2536ff5');
        $this->checkFile('include/Pap/Api/AffiliateSignup.class.php', 'e51b45b213a4bd127bb57f6ac69052f5');
        $this->checkFile('include/Pap/Api/AffiliatesGrid.class.php', 'c58b36f49073f70d9e2f7b84692bda48');
        $this->checkFile('include/Pap/Api/AffiliatesGridSimple.class.php', '3fae5d77d8ed6c6278991cfdb695e944');
        $this->checkFile('include/Pap/Api/Auth.class.php', '66ad250bf1bf3653e45a3ba57a29fce3');
        $this->checkFile('include/Pap/Api/AuthService.class.php', 'd9be2ae660c820dfa820b8cc406c57f9');
        $this->checkFile('include/Pap/Api/BannersGrid.class.php', '4826e58649b02659e077f0aae93e311f');
        $this->checkFile('include/Pap/Api/ClickStatsComputer.class.php', 'f675ef3ee753755f2f76548133b5d869');
        $this->checkFile('include/Pap/Api/ClickTracker.class.php', '2f2050a5ac8f5fd0c0b6885b024b6640');
        $this->checkFile('include/Pap/Api/ImpressionStatsComputer.class.php', '7b7dc44f83fc3a77541fb097f0825893');
        $this->checkFile('include/Pap/Api/Make.class.php', 'ce6f42f3fe133477e60bb722b4abcbbf');
        $this->checkFile('include/Pap/Api/Model/ActionTraffic.class.php', '4f92aca6f6f99e672d78f338950b030b');
        $this->checkFile('include/Pap/Api/Model/Addon.class.php', 'de0c1d6a4dfc274a58eb4302e1c33716');
        $this->checkFile('include/Pap/Api/Model/AddonList.class.php', 'bcd063a031f28583cf294a5bb4fc2e59');
        $this->checkFile('include/Pap/Api/Model/Affiliate.class.php', 'e6190abe5e8da9982154c40028a31d81');
        $this->checkFile('include/Pap/Api/Model/AffiliateDetail.class.php', '41f128f8399eccc64f31bae1adec1550');
        $this->checkFile('include/Pap/Api/Model/ApprovedPending.class.php', 'd73ca7e3f215763874d66b8dd411fde6');
        $this->checkFile('include/Pap/Api/Model/ApprovedPendingCount.class.php', '4787fbf70c0da2b3e7e56f91def6fdd0');
        $this->checkFile('include/Pap/Api/Model/AttributeSimple.class.php', '00db18bbf0756f461a8e68b6b26dc484');
        $this->checkFile('include/Pap/Api/Model/BillingInfo.class.php', '4c8fccb98daee7df427bd681ec99e346');
        $this->checkFile('include/Pap/Api/Model/BillingMetric.class.php', '86e91dc086cd6ba8b28bbce324be7a1d');
        $this->checkFile('include/Pap/Api/Model/BillingStatus.class.php', '84d3a02349ce023703308bdd9d339069');
        $this->checkFile('include/Pap/Api/Model/BooleanResponse.class.php', '37a011d008f181b28c6eadef9977627a');
        $this->checkFile('include/Pap/Api/Model/Campaign.class.php', '0aafb6264e270166d911325025b8f096');
        $this->checkFile('include/Pap/Api/Model/ChartData.class.php', 'bdc0b8c4fefccf47d6015c40cc08c603');
        $this->checkFile('include/Pap/Api/Model/ChartRow.class.php', '6cbf117ba86c492047455c77d312bcc3');
        $this->checkFile('include/Pap/Api/Model/CommissionComputer.class.php', 'ec4d01e0c245f585cda39f64930c14ad');
        $this->checkFile('include/Pap/Api/Model/Config.class.php', '55c5a3536d1420fff42446e1737d94bd');
        $this->checkFile('include/Pap/Api/Model/Contact.class.php', 'b82ec287757886531061fe855382314a');
        $this->checkFile('include/Pap/Api/Model/Country.class.php', 'cddb1ccd601dc17a64d4f477a507242a');
        $this->checkFile('include/Pap/Api/Model/Coupon.class.php', '14776c68248e3499585b6d6c3d9e6f78');
        $this->checkFile('include/Pap/Api/Model/Customer.class.php', '17331fa0307dbb80a014cf4c490493c1');
        $this->checkFile('include/Pap/Api/Model/DirectLink.class.php', '24ee1f87fe8318ae7b24dcc09bdbde51');
        $this->checkFile('include/Pap/Api/Model/DiscountValue.class.php', 'b83447f25ec4d8b03cf5da634aa4d8d2');
        $this->checkFile('include/Pap/Api/Model/FormField.class.php', '162ae8e833a2b44798dbc0fe4df8ecc6');
        $this->checkFile('include/Pap/Api/Model/HostingTrafficInfo.class.php', '4ad6e9edb05d0b00aaeb12e8d478eb77');
        $this->checkFile('include/Pap/Api/Model/InstallProgress.class.php', '5f5525ee6ebb8a5709b4d352d673f119');
        $this->checkFile('include/Pap/Api/Model/LaInstallProgress.class.php', 'fe551c4334c64c45be3a7fac718a67c3');
        $this->checkFile('include/Pap/Api/Model/LaSignup.class.php', 'ba65f9747bbdee1395428a001019aa0e');
        $this->checkFile('include/Pap/Api/Model/LaSubscription.class.php', 'a436ddb0c8024e51d52be77911c9a1e5');
        $this->checkFile('include/Pap/Api/Model/LoginRequest.class.php', 'd07f77f30afdb65b700ecef4dc4b807c');
        $this->checkFile('include/Pap/Api/Model/LoginResponse.class.php', '454d4fb911b513d275a1bf07ce3d2508');
        $this->checkFile('include/Pap/Api/Model/Message.class.php', '1ef79c66945aa32837009c8e7b1814b7');
        $this->checkFile('include/Pap/Api/Model/NameValue.class.php', 'da4286a55e70d098886f0685e1e683c4');
        $this->checkFile('include/Pap/Api/Model/PaymentInfo.class.php', '4e5fac88e5c7a2af07900d987bf4a517');
        $this->checkFile('include/Pap/Api/Model/PaymentMethod.class.php', 'a073e520ed1dd6943ec8f7157b884309');
        $this->checkFile('include/Pap/Api/Model/PaymentProcessorType.class.php', 'b0f2877379ba664b31d583ae49a51591');
        $this->checkFile('include/Pap/Api/Model/Privilege.class.php', 'f6a88d3159a57c6c07eb404ac4239a2a');
        $this->checkFile('include/Pap/Api/Model/PushNotificationOptions.class.php', 'a18068b9a12d517e7430f27e4c8d0e1f');
        $this->checkFile('include/Pap/Api/Model/PushNotificationRegistration.class.php', '141067682957347f2fb559568679859a');
        $this->checkFile('include/Pap/Api/Model/RepeatedUnique.class.php', '92f88e8301d8d1122972f11ab2e644b2');
        $this->checkFile('include/Pap/Api/Model/Settings.class.php', '55f325a91899d5c836287c8828b61ca7');
        $this->checkFile('include/Pap/Api/Model/Signup.class.php', '797006a0bc5ea86425bb94e612c68c3d');
        $this->checkFile('include/Pap/Api/Model/Subscription.class.php', '534befd54ec588342e8417aac51b0e3e');
        $this->checkFile('include/Pap/Api/Model/TrafficResponse.class.php', '76ae93f0b9ebde938033ea5e31c33f08');
        $this->checkFile('include/Pap/Api/Model/Transaction.class.php', '8ec7534b83e19d2f53c79000e37aa495');
        $this->checkFile('include/Pap/Api/Model/Upgrade.class.php', '2ce668c16fd888487696103cbaccd3a9');
        $this->checkFile('include/Pap/Api/Model/User.class.php', '49aba3c40daeadb34042690b56f6f3d9');
        $this->checkFile('include/Pap/Api/Model/Variation.class.php', '443aec81c1d20a31143b9a14a6613602');
        $this->checkFile('include/Pap/Api/Model/VariationUpgrade.class.php', '41fe289a9d4bbc6910e1bc3de8077fe1');
        $this->checkFile('include/Pap/Api/Model/VariationUpgrades.class.php', 'cb84045b22309dea099d6304f858a986');
        $this->checkFile('include/Pap/Api/Model/VisitorAffiliate.class.php', 'e0c912e6c6acb26ed80ca26b14beb4cf');
        $this->checkFile('include/Pap/Api/Module.class.php', '8ff92683257909f21420ebb37febd874');
        $this->checkFile('include/Pap/Api/Object.class.php', 'c22f35e93edec850371185e0229c0787');
        $this->checkFile('include/Pap/Api/PayoutsGrid.class.php', '5f73be5f57e18f2403948115e2b6f1c9');
        $this->checkFile('include/Pap/Api/PayoutsHistoryGrid.class.php', '53846dcee70fd4a39c0395e6337568f6');
        $this->checkFile('include/Pap/Api/RecurringCommission.class.php', 'b05e6b491a8fabce1296d10762087b5f');
        $this->checkFile('include/Pap/Api/RecurringCommissionsGrid.class.php', '0f022a3dfd4de9c2054ff821eb15a942');
        $this->checkFile('include/Pap/Api/RefundChargeBackComputer.class.php', '3bfb5e5c59607b7d571b4908dbafc5f1');
        $this->checkFile('include/Pap/Api/SaleTracker.class.php', 'd9cac0f0b7c12af3cb765985cc33f114');
        $this->checkFile('include/Pap/Api/Session.class.php', 'b8302b72d905a8f06e6659c36017af34');
        $this->checkFile('include/Pap/Api/StatsParams.class.php', '6c431e1fcc80d17021b52730daf5cbed');
        $this->checkFile('include/Pap/Api/Tracker.class.php', '050d7dee84c589ff9dd2124d1a9ff9c8');
        $this->checkFile('include/Pap/Api/Transaction.class.php', '22333d41c62361e1fcfcb71f5966d295');
        $this->checkFile('include/Pap/Api/TransactionsGrid.class.php', 'eebf07ea5eabff7bc6fdfce8738165e8');
        $this->checkFile('include/Pap/Api/TransactionsGrouped.class.php', 'c8532061f3f74060ec15052f71417b17');
        $this->checkFile('include/Pap/Api/V2/Addons.class.php', 'f66a503af844cc2550b860240acb4954');
        $this->checkFile('include/Pap/Api/V2/AffiliateDetails.class.php', '634825101deb2c88fd7fc803cfe178b4');
        $this->checkFile('include/Pap/Api/V2/Affiliates.class.php', '17ab8c09f49073a328ecfebd5a09badb');
        $this->checkFile('include/Pap/Api/V2/AuthUser.class.php', 'bfb173abb0d1cb15560c8e0e5b95adce');
        $this->checkFile('include/Pap/Api/V2/Campaigns.class.php', '4b3812c90ea480ee055f1af53f550c1d');
        $this->checkFile('include/Pap/Api/V2/Common.class.php', 'fa258f6995b3821e236ed3f12a3927e8');
        $this->checkFile('include/Pap/Api/V2/DirectLinks.class.php', '420666339b02a024d46a0170aed81049');
        $this->checkFile('include/Pap/Api/V2/Emails.class.php', '1228efa931b66d47b08ed8fb00caf2af');
        $this->checkFile('include/Pap/Api/V2/FormFields.class.php', 'bc5c06b39cf846b8488d3662770ccf15');
        $this->checkFile('include/Pap/Api/V2/HostingTraffic.class.php', 'd7d2e429500bc11882b8a3168a22e911');
        $this->checkFile('include/Pap/Api/V2/PushNotification.class.php', 'd1de1ccee977366b324c7664b95ecb70');
        $this->checkFile('include/Pap/Api/V2/Roles/Hosting.class.php', '30d52513f94ee54c51a7c9c56c510920');
        $this->checkFile('include/Pap/Api/V2/Settings.class.php', '2f76d3f20a036c31b6059584321e9616');
        $this->checkFile('include/Pap/Api/V2/Task.class.php', 'f008d87b9938ec1fede39e8652ce3697');
        $this->checkFile('include/Pap/Api/V2/Traffic.class.php', 'bf85b1a9528c0040666a52163efaf9c2');
        $this->checkFile('include/Pap/Api/V2/Transactions.class.php', '62054f1fcc657a356783d456fb8a7803');
        $this->checkFile('include/Pap/Api/V2/Users.class.php', '22cd804b77a2986e70a144f1908c6ad8');
        $this->checkFile('include/Pap/Api/V2/VisitorAffiliateProcessor.class.php', 'df0677839707ea71d9ddbc7ef40f675b');
        $this->checkFile('include/Pap/Api/V3/Model/PapTrackingParams.class.php', 'ab15e0e1cfcd4810cf22873fb066a16a');
        $this->checkFile('include/Pap/Api/V3/Model/Source.class.php', '39c060be03f7e49c77fa933a5b30dee5');
        $this->checkFile('include/Pap/Api/V3/Proxy.class.php', '4edb1148cc51914170345019f4aae0e0');
        $this->checkFile('include/Pap/Application.class.php', 'be9d1495cec11b541ddce8863f77b41a');
        $this->checkFile('include/Pap/ApplicationModule.class.php', '508077426a327350b345afe318fed9b8');
        $this->checkFile('include/Pap/ApplicationSettings.class.php', '3dd153058911a7c542dfd5e214045946');
        $this->checkFile('include/Pap/AuditLog/Handler/Base.class.php', 'fcbb01e63644b487d397843ff5d0c7cf');
        $this->checkFile('include/Pap/AuditLog/Model/Account.class.php', 'db8778f1680c70eaf8a09671bc066f37');
        $this->checkFile('include/Pap/AuditLog/Model/Banner.class.php', 'ca2e2bd32d2971fef5cbd245863df37f');
        $this->checkFile('include/Pap/AuditLog/Model/Base.class.php', '0f9797c337d89aedabe8766a5b50f8af');
        $this->checkFile('include/Pap/AuditLog/Model/Campaign.class.php', '37ec3a5b381eee3f92921c8c16db1225');
        $this->checkFile('include/Pap/AuditLog/Model/Commission.class.php', 'f96885f401d659386f4aad3164b80229');
        $this->checkFile('include/Pap/AuditLog/Model/DirectLink.class.php', '6d7fd8cad558ca538111e5464126e662');
        $this->checkFile('include/Pap/AuditLog/Model/Invoice.class.php', '4731f287b5910b8162a68fd88c424af8');
        $this->checkFile('include/Pap/AuditLog/Model/LifetimeReferral.class.php', '6724884fc416517bee7fe2d1fb739ab0');
        $this->checkFile('include/Pap/AuditLog/Model/PayoutOption.class.php', '02bd233195c8f07722afa0bcbd985f03');
        $this->checkFile('include/Pap/AuditLog/Model/Transaction.class.php', '07e19d0d4b735b6b92b00aa8ae8d3b57');
        $this->checkFile('include/Pap/AuditLog/Model/User.class.php', '83c260d623607b04bb5942cc986cc8ba');
        $this->checkFile('include/Pap/Auth/Service.class.php', '837ae257973a376b4d18947e4bd2f1ee');
        $this->checkFile('include/Pap/Auth/UserForm.class.php', '27120117954d00143e1d372b34e25d1b');
        $this->checkFile('include/Pap/AuthUser.class.php', '590aca8a7c71c8f8555066c7618b424f');
        $this->checkFile('include/Pap/Branding.class.php', 'f315b6306527c646372846a472d50243');
        $this->checkFile('include/Pap/Common/ActionProcessorCompoundContext.class.php', '23c243e68af20f86b9bd5124bc52538b');
        $this->checkFile('include/Pap/Common/AffiliateEmailsListBox.class.php', '3f1055b487d7ac5d85aa8417f22b817e');
        $this->checkFile('include/Pap/Common/AffiliateRichListBox.class.php', '8319a8098d029c8a9e85c69814dbdf92');
        $this->checkFile('include/Pap/Common/AuthUser.class.php', 'f7eea07942b31baa0559729408bbb2a3');
        $this->checkFile('include/Pap/Common/Banner/BannerForAffiliateRichListBox.class.php', 'e697666e75912a3bea693d828465fd23');
        $this->checkFile('include/Pap/Common/Banner/BannerRequest.class.php', 'c5ff35ccdc277c39dcfe986bbf5a3afe');
        $this->checkFile('include/Pap/Common/Banner/BannerRichListBox.class.php', 'a7c8829ec9b7a41c72d8ce7688fce131');
        $this->checkFile('include/Pap/Common/Banner/BannerSizeRichListBox.class.php', '661c6311812cdf2b6918591a87568aa8');
        $this->checkFile('include/Pap/Common/Banner/BannerWrappersListBox.class.php', 'edfbdf2ab58b544b677fe32e3ba6b1eb');
        $this->checkFile('include/Pap/Common/Banner/BannersGrid.class.php', '113f560bca74c0dff94f74069ac0b285');
        $this->checkFile('include/Pap/Common/Banner/DestinationUrlRichListBox.class.php', 'c607cf3703d63123d8412974b56db305');
        $this->checkFile('include/Pap/Common/Banner/Factory.class.php', 'b033fb3eb4edbd0d4ee8562f93cbcd35');
        $this->checkFile('include/Pap/Common/Banner/Flash.class.php', '1cabc41a021718aedec0a0d81e00248e');
        $this->checkFile('include/Pap/Common/Banner/Html.class.php', 'ba09bceb0e20ea7bbc7b2883da5d6eef');
        $this->checkFile('include/Pap/Common/Banner/Image.class.php', 'b4273a241ae16daf5d5ce3b2e8634839');
        $this->checkFile('include/Pap/Common/Banner/Link.class.php', '4582800b4773333480b27194d5318d18');
        $this->checkFile('include/Pap/Common/Banner/NotFound.class.php', 'fdac5cda0eb43f4431f5727102e5c017');
        $this->checkFile('include/Pap/Common/Banner/PDF.class.php', 'f8d8310ea77b99c50a1b8efbe9af4d36');
        $this->checkFile('include/Pap/Common/Banner/PDFBannerGenerator.class.php', '75fa3a051c0deb698bf9cadafe62bae3');
        $this->checkFile('include/Pap/Common/Banner/PdfGenerator.class.php', '96be5f112a9f5c0c37bddf169f97cdf6');
        $this->checkFile('include/Pap/Common/Banner/PdfGeneratorResponse.class.php', '4d933d524b5009c21e40c4875168e588');
        $this->checkFile('include/Pap/Common/Banner/PromoEmail.class.php', 'aae01a6f5afedf806e622ab791d4dde2');
        $this->checkFile('include/Pap/Common/Banner/Tcpdf.class.php', '2c2838a618533ce4c7d44a71e64a8004');
        $this->checkFile('include/Pap/Common/Banner/Text.class.php', 'eb820bda25c14ed0e106f3742c9e2dfd');
        $this->checkFile('include/Pap/Common/Banner/Viewer.class.php', '2db7d336bfd349196489fc3757ab3668');
        $this->checkFile('include/Pap/Common/Banner.class.php', '3701e6176edbdb555d11ff70e40138d7');
        $this->checkFile('include/Pap/Common/BannerDestinationCompound.class.php', 'b34fa89253ae6556bae499ff026f2d6a');
        $this->checkFile('include/Pap/Common/BannerReplaceVariablesContext.class.php', '93174f4dd90c896a1a9da2cb981f173d');
        $this->checkFile('include/Pap/Common/Campaign/AffiliateCampaigns.class.php', 'c1fd402f6eca6ec8b385dd5c1ec4988a');
        $this->checkFile('include/Pap/Common/Campaign/CampaignForAffiliateRichListBox.class.php', 'dd575fe84138ed540e6621677cb87312');
        $this->checkFile('include/Pap/Common/Campaign/CampaignForAffiliateTransactionsRichListBox.class.php', 'b2850cca47b6f65cbb5c59bd21cc1513');
        $this->checkFile('include/Pap/Common/Campaign/CampaignRichListBox.class.php', 'e1cff2b854a1e95934dda4e74fbeaf50');
        $this->checkFile('include/Pap/Common/Campaign/CommTypeListBox.class.php', '61e5d61abdcd1a005ded9ba801d77bb8');
        $this->checkFile('include/Pap/Common/Campaign/NotFound.class.php', '7c43aa2f3c10d58237ef8b1768af96ad');
        $this->checkFile('include/Pap/Common/Campaign/ZeroOrOneDefaultCampaignConstraint.class.php', '16d721bee047c0bf07c8c37d5a022bc8');
        $this->checkFile('include/Pap/Common/Campaign.class.php', '0c5a77a0e4bf434d0f8b3b91b1765a66');
        $this->checkFile('include/Pap/Common/Condition/ACR.class.php', '9445acf676f07ba2c4be46f234eeed62');
        $this->checkFile('include/Pap/Common/Condition/ASC.class.php', 'a7b30cc5555835cb88527671db6d18fc');
        $this->checkFile('include/Pap/Common/Condition/ActionsCommissionsAllTiers.class.php', 'df379e7d2a092e8ebc9f6616318816ca');
        $this->checkFile('include/Pap/Common/Condition/ActionsCommissionsFirstTier.class.php', '47d13e3dc3257aed1bf149554fe4c01e');
        $this->checkFile('include/Pap/Common/Condition/ActionsCount.class.php', 'e5a2712f27b04bfde8886a66d50b0832');
        $this->checkFile('include/Pap/Common/Condition/ClicksCommissionsAllTiers.class.php', '429c9aa2f0946cbefd87bfbea79b155e');
        $this->checkFile('include/Pap/Common/Condition/ClicksCommissionsFirstTier.class.php', 'b87c86c6469dab19ced06e311f10c8ee');
        $this->checkFile('include/Pap/Common/Condition/Commissions.class.php', '2644759a54a862511c507fa224bb8838');
        $this->checkFile('include/Pap/Common/Condition/CommissionsCustomTier.class.php', '3faf458fac9fc43cda6d592f87718805');
        $this->checkFile('include/Pap/Common/Condition/CommissionsFromFirstTier.class.php', '610e9105be94031e21f79014101d7ff2');
        $this->checkFile('include/Pap/Common/Condition/CommissionsSales.class.php', '767f070220e7d0aeb2ab4b57cf291bb1');
        $this->checkFile('include/Pap/Common/Condition/RecurringCommissionsFirstTier.class.php', '045b09069a766cee74f2532396b82126');
        $this->checkFile('include/Pap/Common/Condition/RecurringSalesCount.class.php', 'cf0b83d239001aa33a60f6de11f06531');
        $this->checkFile('include/Pap/Common/Condition/SCR.class.php', '6b2c3ea678039ed0b0c07788aead750e');
        $this->checkFile('include/Pap/Common/Condition/SalesCommissionsAllTiers.class.php', '18b5f3e6c542309a3d885f7ee200615e');
        $this->checkFile('include/Pap/Common/Condition/SalesCommissionsFirstTier.class.php', '7d63fa3a8e419a63e517b9abecb8f7f6');
        $this->checkFile('include/Pap/Common/Condition/SalesCount.class.php', '8396d3e5b01821b9418595e76ffcc6d2');
        $this->checkFile('include/Pap/Common/Condition/SalesCountAndRecurringSalesCount.class.php', 'dfb3f1546c17078fa283b5bb20c8b774');
        $this->checkFile('include/Pap/Common/Condition/SalesCountCustomTier.class.php', 'effee57571c180be0bba33c12fec6015');
        $this->checkFile('include/Pap/Common/Condition/Stat.class.php', '7e79ebd2a6bf37461a21683f634eacab');
        $this->checkFile('include/Pap/Common/Condition/SubAffiliatesCount.class.php', 'ddc28140d1fca687c4eaa555d85ee1ac');
        $this->checkFile('include/Pap/Common/Condition/SubAffiliatesCountAllTiers.class.php', '2050bdf8904dcf9c7f9d300f18686d3e');
        $this->checkFile('include/Pap/Common/Condition/SubAffiliatesCountAllVisibleTiers.class.php', '328e5a8bd024c17e9dd644a101cee0bb');
        $this->checkFile('include/Pap/Common/Condition/TotalCost.class.php', 'd2def120f4dcb281d4c5e0872c693ab3');
        $this->checkFile('include/Pap/Common/Condition/TotalCost2ndTier.class.php', '53d51e1a4848afd5964ea75ef8c44db8');
        $this->checkFile('include/Pap/Common/Condition/TotalCostActions.class.php', '2a6f289930f62dd21a640807881022e9');
        $this->checkFile('include/Pap/Common/Condition/TotalCostAll.class.php', '7167fa1ba641e1917039737499c5a497');
        $this->checkFile('include/Pap/Common/Condition/TotalCostAllTiers.class.php', 'd985d9a9bbc1bc344d3491f7ac0f997c');
        $this->checkFile('include/Pap/Common/Condition/TotalCostRecurringSales.class.php', 'd7c8eb9b950917c71535b932a8c21865');
        $this->checkFile('include/Pap/Common/Condition/TotalCostSalesAndRecurringSales.class.php', '672573137a92cc061ebd141bc0990f77');
        $this->checkFile('include/Pap/Common/Condition/TotalCostSalesAndRecurringSalesWholeTree.class.php', '004eaec7a82e678b03e33e0009504691');
        $this->checkFile('include/Pap/Common/Condition.class.php', '62ad019abc9188b426a487b01adb54b2');
        $this->checkFile('include/Pap/Common/Constants.class.php', 'bfa7ba2401fedada3df72a180da2a319');
        $this->checkFile('include/Pap/Common/CustomInvalidLicenseData.class.php', '8635404ee9fda345843f7f3b10f3d6f7');
        $this->checkFile('include/Pap/Common/HasHtml.class.php', '331a7e529838f724de2ae5a9cc303354');
        $this->checkFile('include/Pap/Common/IconSet.class.php', 'dbb3041fc7bbce1dee93ebf1bc7fc179');
        $this->checkFile('include/Pap/Common/List.class.php', 'd9e4977cc3d907e704f06c9fbb860281');
        $this->checkFile('include/Pap/Common/Members/HandlerInterface.class.php', 'e8428f800564518c59d19ffece5cc3f7');
        $this->checkFile('include/Pap/Common/Members/HandlerManager.class.php', '1eab49e97b634359924c7497424d7ef5');
        $this->checkFile('include/Pap/Common/Members/InvoiceGrid.class.php', 'e60a8cd453456f2a49654a8d5b4878b2');
        $this->checkFile('include/Pap/Common/Members/NewHandler.class.php', '48a7179a1c7bcba93ef6dbd830fd9f05');
        $this->checkFile('include/Pap/Common/Members/OldHandler.class.php', '84a90d87998749ef7438712d7ca53dfa');
        $this->checkFile('include/Pap/Common/NewsManager.class.php', 'ea7aaa09eb6de7f7cba5320a9bfe4667');
        $this->checkFile('include/Pap/Common/Overview/InfoData.class.php', '396d2495a0b252e4a5e58fb7eed9288e');
        $this->checkFile('include/Pap/Common/Overview/OverviewBase.class.php', '41a939f80680299a7697b79e65908507');
        $this->checkFile('include/Pap/Common/PapApiClassBuilder.class.php', 'c44d801e6892b887e7ad683614aa837a');
        $this->checkFile('include/Pap/Common/Payout.class.php', '8211e7c823e482f9d31edf7968f14286');
        $this->checkFile('include/Pap/Common/PayoutOptionListBox.class.php', '4c3c19caa03f85cceab569671b952803');
        $this->checkFile('include/Pap/Common/Reports/AffiliateTreeBase.class.php', 'f6309284ef90c19cbdf4fa2ac51138e0');
        $this->checkFile('include/Pap/Common/Reports/Chart/BaseDataType.class.php', '44d026fdd67e93f4e4b7ee8bd59d696d');
        $this->checkFile('include/Pap/Common/Reports/Chart/ClickDataType.class.php', '6816aa6d5af8da313754a29c1da6512e');
        $this->checkFile('include/Pap/Common/Reports/Chart/DataType.class.php', 'b4b3bddda91e3b31e3a53527b49c436d');
        $this->checkFile('include/Pap/Common/Reports/Chart/ImpressionDataType.class.php', '78220e9db5a49a7a4ad63472313b9b79');
        $this->checkFile('include/Pap/Common/Reports/Chart/TransactionDataType.class.php', '8501a1d776bec4f99fec6c5f02c99be9');
        $this->checkFile('include/Pap/Common/Reports/DailyReportGrid.class.php', '933566b73278685ea06ab0029f720cb1');
        $this->checkFile('include/Pap/Common/Reports/FilterCompoundParams.class.php', 'eadd1853cbd1d804ab1ecd1af93be924');
        $this->checkFile('include/Pap/Common/Reports/PayoutsGridBase.class.php', '4e7da102f6a3961b1ecbdc86ec1afeb3');
        $this->checkFile('include/Pap/Common/Reports/SelectBuilderCompoundParams.class.php', '1692fb36db6d2af8acaa4dc2c19ae693');
        $this->checkFile('include/Pap/Common/Reports/StatisticsBase.class.php', '45fa63df2f81ec212cf51872f3fbcbc0');
        $this->checkFile('include/Pap/Common/Reports/StatisticsBaseNew.class.php', '3707e1c347131bc2d2caca7b8abaabe2');
        $this->checkFile('include/Pap/Common/Reports/TransactionsGridBase.class.php', 'cc3f35dc54e936d30b8edaa6b2613e5d');
        $this->checkFile('include/Pap/Common/Rule.class.php', '4d9f38739324308abb1541efbb35130a');
        $this->checkFile('include/Pap/Common/SaveCommissionCompoundContext.class.php', '03e9655bda81eae3d069f8464deadb3b');
        $this->checkFile('include/Pap/Common/ServerTemplatePanel.class.php', 'e42c61c7b015150f768f0039447227c0');
        $this->checkFile('include/Pap/Common/SetPasswordService.class.php', 'e3705c2893fd3f0aaef8c324a6e9f573');
        $this->checkFile('include/Pap/Common/SignupApplicationSettings.class.php', '37555381000853402b0a3e1c31691608');
        $this->checkFile('include/Pap/Common/StatsColumnsContext.class.php', '5ad423b0950eee50a664b54b54c8e860');
        $this->checkFile('include/Pap/Common/StatsGrid.class.php', '3417c69eb3dc7a4da23299512d01fb9a');
        $this->checkFile('include/Pap/Common/StatsGridParamsContext.class.php', '2a2421f04cdc31f3d8b118a37472358d');
        $this->checkFile('include/Pap/Common/TopUrlGridBase.class.php', 'bc896c199333b71c4738c8f3d1d71af1');
        $this->checkFile('include/Pap/Common/TopUrlStatsGridBase.class.php', '431dff292aafa6f5abc1dd586f6efae4');
        $this->checkFile('include/Pap/Common/Transaction.class.php', '3c9d1afee88fdaaced4065e4a11dead9');
        $this->checkFile('include/Pap/Common/TransactionCompoundContext.class.php', 'ee2c3c6a25330257b12c2fb8d5062637');
        $this->checkFile('include/Pap/Common/TransactionFields.class.php', '4d82181d15dedc65246a649578eae80c');
        $this->checkFile('include/Pap/Common/TransactionsList.class.php', '4bd6db061256424c45afa62aad3b6543');
        $this->checkFile('include/Pap/Common/TransactionsListProvider.class.php', '881448ecbe03c714c9efb54b3fe6f27c');
        $this->checkFile('include/Pap/Common/UnknownRuleException.class.php', 'ecc2b1c839fe5b9108aed4f8e0e415bd');
        $this->checkFile('include/Pap/Common/User/DirectLinksFormBase.class.php', '5c176cb260d7fd5f7570a6209ab31c75');
        $this->checkFile('include/Pap/Common/User/DirectLinksGridBase.class.php', 'c520fe758f1dacfbf3715f22b2c8b325');
        $this->checkFile('include/Pap/Common/User/NotFound.class.php', 'feb7ae058cab6bcbf44a75e95711d677');
        $this->checkFile('include/Pap/Common/User/RefIdLengthConstraint.class.php', '80690ab5817b1578b1fb33151dfe03c7');
        $this->checkFile('include/Pap/Common/User/RefidConstraint.class.php', '12c699f225bb8d79668576e8463f544b');
        $this->checkFile('include/Pap/Common/User.class.php', '379595cae8afc42258bae8fcfc2cfb83');
        $this->checkFile('include/Pap/Common/UserFields.class.php', 'caa37a20e29c7b0f9f77148bda43029c');
        $this->checkFile('include/Pap/Common/UserForm.class.php', 'a9c22d30bc36e43edf3344504fbd4879');
        $this->checkFile('include/Pap/Common/UserNode.class.php', '532fecd582153a8015542a9a622c07f7');
        $this->checkFile('include/Pap/Common/UserRecipientsRichListBox.class.php', '12aa64f7e8e08e302b15e997ddf3dff9');
        $this->checkFile('include/Pap/Common/UserTree.class.php', 'c97d6e3900c27f6d4acbcd3d470d5e7b');
        $this->checkFile('include/Pap/Common/UserTreeCreateTask.class.php', '64b73b8a43d7eac9e9eced0caa57babd');
        $this->checkFile('include/Pap/Common/Utils/AdblockUtils.class.php', '88c70aa523dce66c9bd46f99ead24026');
        $this->checkFile('include/Pap/Common/Utils/CurrencyUtils.class.php', '6df1b2cc184f5976f1172399811327b8');
        $this->checkFile('include/Pap/Common/Utils/LinksUpdater.class.php', 'dc414a6c804a1f8e2d6dd6744d34ae0b');
        $this->checkFile('include/Pap/Common/Utils/UserAgentData.class.php', 'f6aec06618ec32566b1696833508e221');
        $this->checkFile('include/Pap/Common/Validator/CommentsEncloseValidator.class.php', '21726edb42eca2555baa36be10bf80d9');
        $this->checkFile('include/Pap/Common/ViewServiceAffiliateEdit.class.php', '40ef5d29e36acee09475648b34e22493');
        $this->checkFile('include/Pap/Common/VisitorAffiliateCacheCompoundContext.class.php', '7167c701148cf15901c4092cc486fed0');
        $this->checkFile('include/Pap/Contexts/Action.class.php', '7d089331f99593a2d5e4503ac1856ebd');
        $this->checkFile('include/Pap/Contexts/BackwardCompatibility.class.php', 'cca2b62151cf7a4534e43148ee112e76');
        $this->checkFile('include/Pap/Contexts/Click.class.php', '920c1c50a17dc773af15b4dbbe99d987');
        $this->checkFile('include/Pap/Contexts/Impression.class.php', '4919be16a958f366c51497bc0df12135');
        $this->checkFile('include/Pap/Contexts/Signup.class.php', '0515c49c3d67515dd487e98888243e1a');
        $this->checkFile('include/Pap/Contexts/Tracking.class.php', '7d430bf0bcad42aed945fbb7f30ebe56');
        $this->checkFile('include/Pap/Db/Accounting.class.php', 'a88dcb2cb4809c070083c2b3dca84aae');
        $this->checkFile('include/Pap/Db/AffiliateScreen.class.php', '02f6f03ecbcfadf6596d75f03965d42d');
        $this->checkFile('include/Pap/Db/AffiliateTrackingCode.class.php', '78e3fb5d318404718ff76a17e87d36fe');
        $this->checkFile('include/Pap/Db/AfterSignupAction.class.php', 'be8002c3f600d64d734f1eaff0dcc5b4');
        $this->checkFile('include/Pap/Db/ApiKey.class.php', '0ddef80fba9b196a56ee9ace14ff91f6');
        $this->checkFile('include/Pap/Db/AuditLog.class.php', 'da1515d11a167c33b7d4a3217e174989');
        $this->checkFile('include/Pap/Db/Banner.class.php', '0d84c40712caa962a76000284ae5dbcf');
        $this->checkFile('include/Pap/Db/BannerCategory.class.php', '6656aa33cae4d1d2e5e92c6d30cc38b5');
        $this->checkFile('include/Pap/Db/BannerDestination.class.php', 'ba32874859064f2ff1b445d12ee1342b');
        $this->checkFile('include/Pap/Db/BannerInCategory.class.php', '8394760e82d75e39aa6d978dc7f5244e');
        $this->checkFile('include/Pap/Db/BannerInRotator.class.php', 'b221f4a190e81a080419590950ac8c99');
        $this->checkFile('include/Pap/Db/BannerWrapper.class.php', '0f50df5e4b0a75cda668cf2ebea15860');
        $this->checkFile('include/Pap/Db/CachedBanner.class.php', '94cbd7dc4c2442f4dcb2874f8d506051');
        $this->checkFile('include/Pap/Db/CachedPage.class.php', '6cf1e3a7f363f081522981144806e3ca');
        $this->checkFile('include/Pap/Db/Campaign.class.php', 'edd5be12589c5a7b2ea8c3ce449e957c');
        $this->checkFile('include/Pap/Db/CampaignAttribute.class.php', 'f0ca1c881f88ae6710fa676381a0d1ff');
        $this->checkFile('include/Pap/Db/CampaignCategory.class.php', '85860cc2d57182a85965d287fb47da9c');
        $this->checkFile('include/Pap/Db/CampaignInCategory.class.php', 'd8b96c66cf8e2292e688ef20f4e87d98');
        $this->checkFile('include/Pap/Db/CampaignRule.class.php', '04e4cdba97a4d191585bd03036c7bda0');
        $this->checkFile('include/Pap/Db/Channel.class.php', '6a44fdd432aa44d9e80ecc9a174ffb66');
        $this->checkFile('include/Pap/Db/Click.class.php', '55ffb8ebb3454f0d2e304e84e690c2fe');
        $this->checkFile('include/Pap/Db/ClickImpression.class.php', '59da5e18c9765195bf4e34774a88e842');
        $this->checkFile('include/Pap/Db/Commission.class.php', 'fa4048fe1c723730b44a3831e8a03d49');
        $this->checkFile('include/Pap/Db/CommissionGroup.class.php', '93d61456c588f046c499f025e2ee70f6');
        $this->checkFile('include/Pap/Db/CommissionType.class.php', '498ea2d47f99cff447ceaaa416f04775');
        $this->checkFile('include/Pap/Db/CommissionTypeAttribute.class.php', 'e92dfad7c19e80387ec1ed0431f304fb');
        $this->checkFile('include/Pap/Db/Coupon.class.php', 'fea054fda8529aa9de18a14dca9c6eb0');
        $this->checkFile('include/Pap/Db/CpmCommission.class.php', 'fcbe365ed712914de729905404459edd');
        $this->checkFile('include/Pap/Db/CpmCommissionClicks.class.php', '960d256c42d21c692c850cc8227d4262');
        $this->checkFile('include/Pap/Db/DirectLinkUrl.class.php', '0fa7f3636782663e4cae4f8ab4236e0e');
        $this->checkFile('include/Pap/Db/Impression.class.php', 'a3deb2f6e98b1f09a47cecfec30cdf1b');
        $this->checkFile('include/Pap/Db/Invoice.class.php', '278029e323eb180d1509361c18e6400a');
        $this->checkFile('include/Pap/Db/Keyword.class.php', '1b2514bc1eefc0ba0838e0c80f585133');
        $this->checkFile('include/Pap/Db/KeywordClick.class.php', 'a876cb770c144f8f29e1321831077b12');
        $this->checkFile('include/Pap/Db/KeywordStat.class.php', '7cf5d0e4ddb574f16bcf643d26dc7f07');
        $this->checkFile('include/Pap/Db/LifetimeCommission.class.php', '65564d80f8a93c11cbfab4bc520cd993');
        $this->checkFile('include/Pap/Db/News.class.php', '2da364c8c06dec74a4710aa42721d63b');
        $this->checkFile('include/Pap/Db/NewsAttachment.class.php', '4b52073b90704c5cca0a60979ee2a559');
        $this->checkFile('include/Pap/Db/Payout.class.php', '33e35ec98a291bb3233256d2fc689ee0');
        $this->checkFile('include/Pap/Db/PayoutHistory.class.php', '502e128eeddaccea75d37df6e6ff6449');
        $this->checkFile('include/Pap/Db/PayoutOption.class.php', 'f442ef05107cc55185b09d2353bc9c31');
        $this->checkFile('include/Pap/Db/RawClick.class.php', '77ce3ffe77275ac33991bba0641e902b');
        $this->checkFile('include/Pap/Db/RawImpression.class.php', 'b0e2820bf15450a6b75cfe3c2915cc71');
        $this->checkFile('include/Pap/Db/RecurringCommission.class.php', '150e234ef6d0db665d95503d3b1e1a5e');
        $this->checkFile('include/Pap/Db/RecurringCommissionEntry.class.php', '45d5f20a28f983e5cc77cabf2c7e3a2f');
        $this->checkFile('include/Pap/Db/ReferrerUrl.class.php', '08ef8da6bd27962d96cf7d93eeb590d2');
        $this->checkFile('include/Pap/Db/Rule.class.php', '07271b682e37909a067986db40ed7515');
        $this->checkFile('include/Pap/Db/Table/Accountings.class.php', '97416cc6bbe54ab76d387da70ebbae97');
        $this->checkFile('include/Pap/Db/Table/AffiliateScreens.class.php', 'a86f917896e8f27f52a35cbcf3a6338c');
        $this->checkFile('include/Pap/Db/Table/AffiliateTrackingCodes.class.php', 'fd13cafdbfa1d954b020196a046b5096');
        $this->checkFile('include/Pap/Db/Table/ApiKeys.class.php', '9b8c439a39101ff320b0f52efea3313b');
        $this->checkFile('include/Pap/Db/Table/AuditLogs.class.php', 'ff59c8c79239c20169dff66dc73e170d');
        $this->checkFile('include/Pap/Db/Table/BannerDestinations.class.php', '76281c840063ddc6749d31ac2edeec73');
        $this->checkFile('include/Pap/Db/Table/BannerWrappers.class.php', '14ff772190aebf55ce73406b71433cf4');
        $this->checkFile('include/Pap/Db/Table/Banners.class.php', 'cc32c91eff0f7e090f82069cb7f05eaa');
        $this->checkFile('include/Pap/Db/Table/BannersCategories.class.php', '17eced358de0f66629d5658ad90a6af5');
        $this->checkFile('include/Pap/Db/Table/BannersInCategory.class.php', '782886f8e785c956fe4ccfc32235a0a2');
        $this->checkFile('include/Pap/Db/Table/BannersInRotators.class.php', '77f66c854907580751f0284b81800ff9');
        $this->checkFile('include/Pap/Db/Table/CachedBanners.class.php', '6c6b225e03d49f5757e3d950345f07c9');
        $this->checkFile('include/Pap/Db/Table/CachedPages.class.php', 'ff9e311023a0ef1abd1f363b1dd637fc');
        $this->checkFile('include/Pap/Db/Table/CampaignAttributes.class.php', '6fecb7986e8d98089cd21aa466edd1c1');
        $this->checkFile('include/Pap/Db/Table/CampaignRules.class.php', 'd044c159b199ca6c20cebfaddfa229e3');
        $this->checkFile('include/Pap/Db/Table/Campaigns.class.php', '1fb0232caeb35db0829585a8db225718');
        $this->checkFile('include/Pap/Db/Table/CampaignsCategories.class.php', '7b50a52c7559ec049b141b2f5f12046c');
        $this->checkFile('include/Pap/Db/Table/CampaignsInCategory.class.php', '5dcbdfd32845b3ff36fc31f9d16e160b');
        $this->checkFile('include/Pap/Db/Table/Channels.class.php', 'cb4653b80deb9665ceb0d7fc9ea0c861');
        $this->checkFile('include/Pap/Db/Table/Clicks.class.php', 'ef194ef6074c87c401566e802bf76c3e');
        $this->checkFile('include/Pap/Db/Table/ClicksImpressions.class.php', 'ae26342aff6c4050ac9b1058f0e8431b');
        $this->checkFile('include/Pap/Db/Table/CommissionGroups.class.php', 'ea51f07ba4b9ac40a4e979732543f848');
        $this->checkFile('include/Pap/Db/Table/CommissionTypeAttributes.class.php', 'deb3e62f6c1d9927a0d2156e18c5cff9');
        $this->checkFile('include/Pap/Db/Table/CommissionTypes.class.php', 'e6462bacb26b7fdc85e6d87676ab4579');
        $this->checkFile('include/Pap/Db/Table/Commissions.class.php', '7891cb16a2fb22bddcc8624835fa2939');
        $this->checkFile('include/Pap/Db/Table/Coupons.class.php', '0d390482233483e8621537c58f1d1ed6');
        $this->checkFile('include/Pap/Db/Table/CpmCommissions.class.php', '318ff220e5613cf1e83f9d875552822e');
        $this->checkFile('include/Pap/Db/Table/CpmCommissionsClicks.class.php', 'fdce6c91f6fdb51cc1baaa53c88e9664');
        $this->checkFile('include/Pap/Db/Table/DirectLinkUrls.class.php', '34a5ee7bd6a3ce9c917b1a2d7980361e');
        $this->checkFile('include/Pap/Db/Table/Impressions.class.php', 'b2fc4b7591c3989117b6aa1a127b2759');
        $this->checkFile('include/Pap/Db/Table/Invoices.class.php', '1370ccf9382e48fc601da051d3ae5faa');
        $this->checkFile('include/Pap/Db/Table/KeywordClicks.class.php', '8c06c5e69a23e36cb41dd994f9116eef');
        $this->checkFile('include/Pap/Db/Table/KeywordStats.class.php', 'becabcb2f81bfbdb565a91dc86ee5c4b');
        $this->checkFile('include/Pap/Db/Table/Keywords.class.php', 'fc6f1686cfa2f919d2c1bff83ea8358a');
        $this->checkFile('include/Pap/Db/Table/LifetimeCommissions.class.php', 'ac4e31bd8aad31f1eb8b3c8fbd895893');
        $this->checkFile('include/Pap/Db/Table/News.class.php', 'df22b0e11c1a7e2a97c01aed9aaa5767');
        $this->checkFile('include/Pap/Db/Table/NewsAttachments.class.php', 'f5891d9258dc8bbe75b4138d0aa2bed9');
        $this->checkFile('include/Pap/Db/Table/Payouts.class.php', '7d87b97475829e58a264c14b66506ee5');
        $this->checkFile('include/Pap/Db/Table/PayoutsHistory.class.php', '659ca7e86415f4160cff07f89614bcbf');
        $this->checkFile('include/Pap/Db/Table/RawClicks.class.php', 'ad93d12421ff9cb6b802c0fabb2f1771');
        $this->checkFile('include/Pap/Db/Table/RawImpressions.class.php', '564e9b6df9b79efbe106193dff8103e8');
        $this->checkFile('include/Pap/Db/Table/RecurringCommissionEntries.class.php', 'e527392a48401b523f0270b040aaaa58');
        $this->checkFile('include/Pap/Db/Table/RecurringCommissions.class.php', '81b03aee428bcd26d1292c6e9800d182');
        $this->checkFile('include/Pap/Db/Table/ReferrerUrls.class.php', '260fe5c3c465f13a68d509e526454600');
        $this->checkFile('include/Pap/Db/Table/Rules.class.php', '83a87512b52468f501f4abe6dbc57b59');
        $this->checkFile('include/Pap/Db/Table/TrafficUsages.class.php', '3d48d04c4d7d142337da95ee1f75c692');
        $this->checkFile('include/Pap/Db/Table/TransStatsDays.class.php', '58baf1c479b5ff29a5fa75c96beccbda');
        $this->checkFile('include/Pap/Db/Table/TransStatsReferrerDays.class.php', 'd36a1329ca7feaccd30eeffa3580bb19');
        $this->checkFile('include/Pap/Db/Table/Transactions.class.php', '795a092b8cc06b13d8849ea1a732dfc5');
        $this->checkFile('include/Pap/Db/Table/TransactionsStats.class.php', 'f77d25709a022c125ebb26f253c10132');
        $this->checkFile('include/Pap/Db/Table/TransactionsStatsAff.class.php', '03f2916e35d597287fb6d5ff39824d5f');
        $this->checkFile('include/Pap/Db/Table/TransactionsStatsReferrersUrls.class.php', '1494e2ea770cd0cb53825e62afa249eb');
        $this->checkFile('include/Pap/Db/Table/UnsubscribeEmails.class.php', '61c9ad4250ed57b4b3dfb7a176f917a1');
        $this->checkFile('include/Pap/Db/Table/UserAgents.class.php', 'e315041419fe68097923ba37c841d186');
        $this->checkFile('include/Pap/Db/Table/UserInCommissionGroup.class.php', '76e8ef887cea63f3fba95a128c84129b');
        $this->checkFile('include/Pap/Db/Table/UserPayoutOptions.class.php', '29460ccaad0dda1fc15e7c0e99dcd7a9');
        $this->checkFile('include/Pap/Db/Table/UserRecipients.class.php', 'f6fada08dfeb94b75b3b7d07bb1ea9b4');
        $this->checkFile('include/Pap/Db/Table/UserTreeUpdateUsers.class.php', '2af32f1ec99823f2b0b50352f164ef2b');
        $this->checkFile('include/Pap/Db/Table/Users.class.php', '7ca8f46924cd2f769046f29aad888c3c');
        $this->checkFile('include/Pap/Db/Table/VisitorAffiliates.class.php', '0607e3a3b6a36fb580a7ec0eb687bb6e');
        $this->checkFile('include/Pap/Db/Table/VisitorNonreferredClicks.class.php', '46eb970174758ae93febadfc3e60c03f');
        $this->checkFile('include/Pap/Db/Table/Visitors.class.php', 'aadded67019d2059f078c5421da04a98');
        $this->checkFile('include/Pap/Db/Table/Visits.class.php', 'f63a9ecc9961bf23918f6e93186c2bbc');
        $this->checkFile('include/Pap/Db/Table/VisitsSalesLogs.class.php', 'f9da0a026ec96f837d5e5591c5e3bafe');
        $this->checkFile('include/Pap/Db/TrafficUsage.class.php', '3552617d57622f9bba42302e8e6fb22c');
        $this->checkFile('include/Pap/Db/TransStatsDay.class.php', '88d36ba9a8559b3298ef7210241b9ffa');
        $this->checkFile('include/Pap/Db/TransStatsReferrerDay.class.php', '755e242952f528982495a28328c605e5');
        $this->checkFile('include/Pap/Db/Transaction.class.php', '2b9da4404be81f26706134334eb115df');
        $this->checkFile('include/Pap/Db/TransactionsStat.class.php', '70e09facda9cf5f3d9d52a16b7e49075');
        $this->checkFile('include/Pap/Db/TransactionsStatAff.class.php', 'c4a2b510fe4a87748f89d548267baa26');
        $this->checkFile('include/Pap/Db/TransactionsStatsReferrersUrl.class.php', '2694e6ea1cc67c806c820d1c9af0f059');
        $this->checkFile('include/Pap/Db/UnsubscribeEmail.class.php', '5db4a89132463d949104512fa1385593');
        $this->checkFile('include/Pap/Db/User.class.php', '7297b79fb42244291e282e2f6c3e701c');
        $this->checkFile('include/Pap/Db/UserAgent.class.php', '42585d60000578a1c13ef22fbd05e5d6');
        $this->checkFile('include/Pap/Db/UserInCommissionGroup.class.php', 'f52267145b18829473f3ab9479dc102e');
        $this->checkFile('include/Pap/Db/UserPayoutOption.class.php', 'dfed0644981f49ee036045ba8328dd63');
        $this->checkFile('include/Pap/Db/UserRecipient.class.php', '84da1a074b745527796d3227cf6009c1');
        $this->checkFile('include/Pap/Db/UserTreeUpdateUser.class.php', 'afa7b693fa2a86100b7e3ccc8364c0b0');
        $this->checkFile('include/Pap/Db/Visit.class.php', '56ba5a15bd7a7e2028297d3a8410c66b');
        $this->checkFile('include/Pap/Db/Visitor.class.php', '3d793feab137e7fd2d7abb8a00d18788');
        $this->checkFile('include/Pap/Db/VisitorAffiliate.class.php', '4aa9ee7d34f292594323a2d98c03ae80');
        $this->checkFile('include/Pap/Db/VisitorNonreferredClick.class.php', '3cf80f0ff5f369b5522d8c5ec00d8823');
        $this->checkFile('include/Pap/Db/VisitsSalesLog.class.php', '0c388cc61c2f01cdc2671601ffaae4a6');
        $this->checkFile('include/Pap/Definition.class.php', '9b79e779c16356dfd01b334635589813');
        $this->checkFile('include/Pap/Features/ActionCommission/ActionDataType.class.php', '20067318d4e51c2d5458937e256dfa95');
        $this->checkFile('include/Pap/Features/ActionCommission/ActionStatsBuilder.class.php', '0200dd0c945f1f22f7b2457b7af3c83a');
        $this->checkFile('include/Pap/Features/ActionCommission/ActionTypes.class.php', 'd237398db24dfb08658f3ecf38b4eafa');
        $this->checkFile('include/Pap/Features/ActionCommission/CommissionsForm.class.php', '8e1c4b039c3a01290f920283c8bc2e7e');
        $this->checkFile('include/Pap/Features/ActionCommission/Definition.class.php', '1dd2111129b58d01701ea1d3d8759957');
        $this->checkFile('include/Pap/Features/ActionCommission/Main.class.php', 'bf7c51aab90d3b893159e06009442fe2');
        $this->checkFile('include/Pap/Features/AffiliateTrackingCode/AffiliateCodesForm.class.php', '3c88fb75f5540f8fda5061adbfed6bf9');
        $this->checkFile('include/Pap/Features/AffiliateTrackingCode/AffiliateCodesGrid.class.php', '81961851f0ae26c20b12f021750fcd90');
        $this->checkFile('include/Pap/Features/AffiliateTrackingCode/CodesForm.class.php', '7402a20b7f43af448930d300751a8c15');
        $this->checkFile('include/Pap/Features/AffiliateTrackingCode/Config.class.php', 'f10ee3620e12389f6885fb205ed3625b');
        $this->checkFile('include/Pap/Features/AffiliateTrackingCode/Definition.class.php', 'eb04f7a6173fc3fcce4c4c01fc2162cc');
        $this->checkFile('include/Pap/Features/AffiliateTrackingCode/Main.class.php', 'd44a0aaff3a0a614be97a7d5547c15b7');
        $this->checkFile('include/Pap/Features/AffiliateTrackingCode/MerchantCodesForm.class.php', '1f1cac0b747fcdf83ca20bbcab4502f1');
        $this->checkFile('include/Pap/Features/AffiliateTrackingCode/MerchantCodesGrid.class.php', '3a480a8f7f1e334fe648cb6e2fea872a');
        $this->checkFile('include/Pap/Features/AuditLog/AuditLogGrid.class.php', '42877100d9e60c0a6e5785e32d154772');
        $this->checkFile('include/Pap/Features/AuditLog/AuditLogObjectGrid.class.php', '9959711337cb6bf7ace69c3594d2a3e9');
        $this->checkFile('include/Pap/Features/AuditLog/Config.class.php', 'fcba1e3247b5096260ca3ea739a1e7e4');
        $this->checkFile('include/Pap/Features/AuditLog/Definition.class.php', 'a2267af18d3feb6a874863713b5c2fd5');
        $this->checkFile('include/Pap/Features/AuditLog/ExtendableAuditLogs.class.php', '39c1df37f8e58e89b484fb467fb20458');
        $this->checkFile('include/Pap/Features/AuditLog/Handler/ActivityLog.class.php', '95f97f16246aefcce10b1fe60a184ad5');
        $this->checkFile('include/Pap/Features/AuditLog/Handler/AddUserToCommissionGroup.class.php', '62ab0164083a4f37d90f907d9e078e8a');
        $this->checkFile('include/Pap/Features/AuditLog/Handler/CreatedBanner.class.php', '2abdf4d38cc009288c1406d30cb4e664');
        $this->checkFile('include/Pap/Features/AuditLog/Handler/CreatedCampaign.class.php', 'd19cc25518b720dd697a1fe34e6abbec');
        $this->checkFile('include/Pap/Features/AuditLog/Handler/CreatedInvoice.class.php', 'afe8c23263f4f809c4efe42b2d790893');
        $this->checkFile('include/Pap/Features/AuditLog/Handler/CreatedLifetimeReferral.class.php', '632355557debee1ee06429669523b9a1');
        $this->checkFile('include/Pap/Features/AuditLog/Handler/CreatedTransaction.class.php', '1df00dc85b8e9e94eb4cf35ff1ba437e');
        $this->checkFile('include/Pap/Features/AuditLog/Handler/CreatedUser.class.php', 'd2847731069fc06754fa1e9ed5821492');
        $this->checkFile('include/Pap/Features/AuditLog/Handler/DeletedAccount.class.php', '7e643f020988fbf36a09f6fbd706bd12');
        $this->checkFile('include/Pap/Features/AuditLog/Handler/DeletedBanner.class.php', 'b8cee9c2a7aad5884bf51db3aedc33d2');
        $this->checkFile('include/Pap/Features/AuditLog/Handler/DeletedCampaign.class.php', 'e52c2f8cb9715c779c3fa4cbc4dd1101');
        $this->checkFile('include/Pap/Features/AuditLog/Handler/DeletedInvoice.class.php', '1e6caaa3ef4b585eeda2176f58aacc85');
        $this->checkFile('include/Pap/Features/AuditLog/Handler/DeletedLifetimeReferral.class.php', '70238c1d4b97031e0754b9dec118d372');
        $this->checkFile('include/Pap/Features/AuditLog/Handler/DeletedTransaction.class.php', '75de0221bc5fa02e7c830ba496a78e46');
        $this->checkFile('include/Pap/Features/AuditLog/Handler/DeletedUser.class.php', '7a607aa96dc34565bcad5f6121c96727');
        $this->checkFile('include/Pap/Features/AuditLog/Handler/Factory.class.php', 'dad8807d801f00160f471deb3cf3850d');
        $this->checkFile('include/Pap/Features/AuditLog/Handler/PropertyChangedAccount.class.php', '6534a038eeca876b323136a141b554f0');
        $this->checkFile('include/Pap/Features/AuditLog/Handler/PropertyChangedAccountSettings.class.php', '5b653ecb75d82437da39ddb57dddf070');
        $this->checkFile('include/Pap/Features/AuditLog/Handler/PropertyChangedBanner.class.php', 'd40a865d6b6fb3698b09282904f88396');
        $this->checkFile('include/Pap/Features/AuditLog/Handler/PropertyChangedCampaign.class.php', '543e62c0ccfc7b3e3b9e3d2cf46ecd33');
        $this->checkFile('include/Pap/Features/AuditLog/Handler/PropertyChangedCommissionType.class.php', '18b8b3515b37c310af019e6e6e42fdf6');
        $this->checkFile('include/Pap/Features/AuditLog/Handler/PropertyChangedDirectLink.class.php', '9867c10b405a11d4e0a6d69f341f853b');
        $this->checkFile('include/Pap/Features/AuditLog/Handler/PropertyChangedInvoice.class.php', '2086ce0fc5e37c9d0f51687c77bc594d');
        $this->checkFile('include/Pap/Features/AuditLog/Handler/PropertyChangedLifetimeReferral.class.php', '1acdaf73fc1d3dc5320308282b75ad3d');
        $this->checkFile('include/Pap/Features/AuditLog/Handler/PropertyChangedPayoutOption.class.php', 'ab16b8d54df825228eb6777b6c759aaa');
        $this->checkFile('include/Pap/Features/AuditLog/Handler/PropertyChangedTransaction.class.php', '753e2c50ccf68a010828309bc7d3b1ea');
        $this->checkFile('include/Pap/Features/AuditLog/Handler/PropertyChangedUser.class.php', 'f65135d917246ee5b67f1201ab1ae151');
        $this->checkFile('include/Pap/Features/AuditLog/Handler/RemoveUserFromCommissionGroup.class.php', '06c3810b69571366a880d1db3363f2b6');
        $this->checkFile('include/Pap/Features/AuditLog/Handler/StatusChangedAccount.class.php', 'f22172a3cbddd40c570af076093cab8c');
        $this->checkFile('include/Pap/Features/AuditLog/Handler/StatusChangedBanner.class.php', '165688bba2afcc9f72ae73da9021da27');
        $this->checkFile('include/Pap/Features/AuditLog/Handler/StatusChangedDirectLink.class.php', 'd8ca17d92fe62b08b61b7f91e06d92c6');
        $this->checkFile('include/Pap/Features/AuditLog/Handler/StatusChangedTransaction.class.php', '1c826fe1589e74e863c00a4988e66dd3');
        $this->checkFile('include/Pap/Features/AuditLog/Handler/StatusChangedUser.class.php', 'dc94534e1744e8056b6b4988c9340b17');
        $this->checkFile('include/Pap/Features/AuditLog/Handler/StatusChangedUserCommissionGroup.class.php', '0da8769046c5f93ba9dcf95607313ded');
        $this->checkFile('include/Pap/Features/AuditLog/Main.class.php', 'cead4e9b340b06c57c2d326db21381cb');
        $this->checkFile('include/Pap/Features/AuditLog/Task.class.php', 'c68df3b9ad286c2c7e607bb3b4fbeddf');
        $this->checkFile('include/Pap/Features/AuditLog/UserRichListBox.class.php', 'c5def54ac85ae4a207b261ba4071ce5f');
        $this->checkFile('include/Pap/Features/AutoRegisteringAffiliates/Config.class.php', '8bac3e3fa50915857545abfb1b92bd0f');
        $this->checkFile('include/Pap/Features/AutoRegisteringAffiliates/Definition.class.php', 'a4578db468c8486d06035ac1c64a65cb');
        $this->checkFile('include/Pap/Features/AutoRegisteringAffiliates/GetBannerForm.class.php', '096ece1b902da9b153d91a92563a0b68');
        $this->checkFile('include/Pap/Features/AutoRegisteringAffiliates/Main.class.php', 'cddc505fb444eaf3b045ed0ac0806170');
        $this->checkFile('include/Pap/Features/AutoRegisteringAffiliates/generatelink/affiliatelink.css', '7109172c167deded70849b2984a3ae2e');
        $this->checkFile('include/Pap/Features/AutoRegisteringAffiliates/generatelink/formbanner.php', '84337af6c5433b3b0c084f907ee06877');
        $this->checkFile('include/Pap/Features/AutoRegisteringAffiliates/generatelink/formlink.php', '0e0358e190dff69453a26192218a2671');
        $this->checkFile('include/Pap/Features/AutoRegisteringAffiliates/generatelink/getBanner.php', 'e62632408da15bff1eb0fd58664e44ed');
        $this->checkFile('include/Pap/Features/AutoRegisteringAffiliates/generatelink/getBannerCode.php', 'b165e0abe68ae394800184f8a3b60128');
        $this->checkFile('include/Pap/Features/AutoRegisteringAffiliates/generatelink/getLink.php', 'c57cf0c3a786a64c4867d0b9baa484ba');
        $this->checkFile('include/Pap/Features/AutomaticAffiliateRemoval/AffiliateActivityCheckingTask.class.php', 'ed98a78ec583906f05894124397b8df9');
        $this->checkFile('include/Pap/Features/AutomaticAffiliateRemoval/Definition.class.php', '57be66aa6c40fead9a7e569c9528f2f4');
        $this->checkFile('include/Pap/Features/AutomaticAffiliateRemoval/Form.class.php', '29455965b4c76b642cc303c54e813cbe');
        $this->checkFile('include/Pap/Features/AutomaticAffiliateRemoval/Main.class.php', 'f80207af04f36f6e2a8db663b1eed2c5');
        $this->checkFile('include/Pap/Features/BannerDestinations/Definition.class.php', '4c4a7034f9e33deaacd406becadd81c9');
        $this->checkFile('include/Pap/Features/BannerDestinations/DestinationsForm.class.php', '4bf17f69a5eb6147a2646f6a6691f485');
        $this->checkFile('include/Pap/Features/BannerDestinations/DestinationsGrid.class.php', '3d19a545103570f7ad6d2b95b6287b49');
        $this->checkFile('include/Pap/Features/BannerDestinations/Main.class.php', 'fb7e798ff3d8a359712a93ca96930476');
        $this->checkFile('include/Pap/Features/BannerRotator/BannersGrid.class.php', '54347cbb1c7553f10c69725410894234');
        $this->checkFile('include/Pap/Features/BannerRotator/Config.class.php', '55e610cffc51e72f36065b4017f0d5e1');
        $this->checkFile('include/Pap/Features/BannerRotator/Definition.class.php', '5f3811f5dbf3eeb056911c0b7ad30585');
        $this->checkFile('include/Pap/Features/BannerRotator/ListBox.class.php', '90f08b360d131f6f685ed84f3980cdd6');
        $this->checkFile('include/Pap/Features/BannerRotator/Main.class.php', 'a2aa88bae0aa7f7067c8659b72b775f9');
        $this->checkFile('include/Pap/Features/BannerRotator/Rotator.class.php', 'e30ad983d1bdaec166f780fb7987c794');
        $this->checkFile('include/Pap/Features/BannerRotator/RotatorFormService.class.php', 'f076fab124f791efe2cb41bf4619216e');
        $this->checkFile('include/Pap/Features/BannerRotator/Tracking.class.php', '1a828b86536d7a60c447314e864eed1d');
        $this->checkFile('include/Pap/Features/BannersCategories/BannerCategoriesFilterGrid.class.php', 'ba8d011701822df00db585ebc29180f9');
        $this->checkFile('include/Pap/Features/BannersCategories/BannerInCategoriesGrid.class.php', '6c17b44d65a682f9ee61ce9bdb9d3093');
        $this->checkFile('include/Pap/Features/BannersCategories/CategoryForm.class.php', 'da3017cb3cbee58ca61172db7e383948');
        $this->checkFile('include/Pap/Features/BannersCategories/CategoryInfoData.class.php', '51457d80ee21c2196e9d8aee25fb49b5');
        $this->checkFile('include/Pap/Features/BannersCategories/Definition.class.php', '4e038c00364b962f3f363b398f1d66cc');
        $this->checkFile('include/Pap/Features/BannersCategories/EditableCategoriesGrid.class.php', '08025cb8ffc842704c208fc1b3994f2c');
        $this->checkFile('include/Pap/Features/BannersCategories/Main.class.php', '221c99ff5150339f52149a9d68eac199');
        $this->checkFile('include/Pap/Features/BannersCategories/Tree.class.php', '0038f034750ef9a49eaded11efade42b');
        $this->checkFile('include/Pap/Features/BannersCategories/TreePanel.class.php', '34482de01cafb6ef0674602bafdd4ac6');
        $this->checkFile('include/Pap/Features/BrandingFree/Config.class.php', '710523c783e1b22e60220d93785aa1d5');
        $this->checkFile('include/Pap/Features/BrandingFree/Definition.class.php', '6732598d819018f64177198d68888c80');
        $this->checkFile('include/Pap/Features/CampaignScheduler/Action/ChangeCampaignStatusAction.class.php', 'a29055270872fc64db269c4b4e317ce3');
        $this->checkFile('include/Pap/Features/CampaignScheduler/Action/ChangeCampaignStatusBaseAction.class.php', '9d98aebb1182d7dae030a3c78d6cbec1');
        $this->checkFile('include/Pap/Features/CampaignScheduler/Definition.class.php', '3b73e7a30f1f8971eb45c0d15ff0dfb0');
        $this->checkFile('include/Pap/Features/CampaignScheduler/ExpiredTimeException.class.php', '803f668a4f0d578f9e2f0d8b34117694');
        $this->checkFile('include/Pap/Features/CampaignScheduler/Main.class.php', 'f17848bb92ea2b9ea86ba2c22e1f5ee7');
        $this->checkFile('include/Pap/Features/CampaignScheduler/Rule.class.php', '3a87bec8fe8f4957a722fa9c72bdd761');
        $this->checkFile('include/Pap/Features/CampaignScheduler/SchedulerForm.class.php', 'e8c47a9bf74ebb66fc95f99b6fbb3a0e');
        $this->checkFile('include/Pap/Features/CampaignScheduler/SchedulerGrid.class.php', '8e5b46b8c007d94c0184b06e442a8224');
        $this->checkFile('include/Pap/Features/CampaignScheduler/TimeCondition.class.php', 'ff2de17eb16e5049322aeee02480defd');
        $this->checkFile('include/Pap/Features/CampaignScheduler/TimeConditionTask.class.php', '8a98007b9bebbb643720df433b743966');
        $this->checkFile('include/Pap/Features/CampaignScheduler/TimeRule.class.php', 'c1c2d133f93e12c5a610d86cb7f6b7a5');
        $this->checkFile('include/Pap/Features/CampaignsCategories/CampaignCategoriesFilterGrid.class.php', '62a2c19fb51413649e5d556a2eafb9f5');
        $this->checkFile('include/Pap/Features/CampaignsCategories/CampaignInCategoriesGrid.class.php', '285bc2d61051062ad29c5c1fb52d7cc3');
        $this->checkFile('include/Pap/Features/CampaignsCategories/CategoryForm.class.php', 'cb23a4e704a8dbdad92c22a2d0d10249');
        $this->checkFile('include/Pap/Features/CampaignsCategories/CategoryInfoData.class.php', '69eebf14953ce6897313db937069aede');
        $this->checkFile('include/Pap/Features/CampaignsCategories/CategoryNode.class.php', 'bddc7423995c962eb36c1192e64050f4');
        $this->checkFile('include/Pap/Features/CampaignsCategories/Definition.class.php', '17d76b24e364a31ed0792520a53e90d5');
        $this->checkFile('include/Pap/Features/CampaignsCategories/EditableCategoriesGrid.class.php', 'e6dd3c9399a3acbf2eb16ea5943de7c3');
        $this->checkFile('include/Pap/Features/CampaignsCategories/Main.class.php', '3c3a76e1b9551cd2ca95ad3ef9be5fad');
        $this->checkFile('include/Pap/Features/CampaignsCategories/Tree.class.php', 'd0d3a5995a0dcc6de922e470275bb6e4');
        $this->checkFile('include/Pap/Features/CampaignsCategories/TreePanel.class.php', '0fbc3a6fe2d871be780b3e94780d2a20');
        $this->checkFile('include/Pap/Features/CommissionGroups/AffiliateChangeCommissionGroupMail.class.php', '29e9cc70b44fdf920ab3915d67914bb8');
        $this->checkFile('include/Pap/Features/CommissionGroups/AffiliateGroupForm.class.php', '0ae81d60e89e63a7f4ab83ada0713a25');
        $this->checkFile('include/Pap/Features/CommissionGroups/CommissionGroupRichListBox.class.php', '4dda64629440a3f538ac8892836c09d6');
        $this->checkFile('include/Pap/Features/CommissionGroups/CommissionGroupsForm.class.php', 'ef4ce807b11348a51d978272eb96e134');
        $this->checkFile('include/Pap/Features/CommissionGroups/CommissionGroupsGrid.class.php', 'ed71eb634c6e66bd2c6256314c2decfb');
        $this->checkFile('include/Pap/Features/CommissionGroups/CommissionsAffiliate.class.php', 'f4df4d6fe8364c3bceee9b1399558a0c');
        $this->checkFile('include/Pap/Features/CommissionGroups/CommissionsAffiliateGrid.class.php', '91288b625f5ec1e65f6c896a447c4794');
        $this->checkFile('include/Pap/Features/CommissionGroups/Definition.class.php', '53acb2dbd158852f94d30984e92ecc4b');
        $this->checkFile('include/Pap/Features/CommissionGroups/Main.class.php', '65ef9316039242155a131ccc31df6d3c');
        $this->checkFile('include/Pap/Features/Common/AffiliateCampaignsGrid.class.php', '3f0ffabc0961a95adce18a5bf6f521c7');
        $this->checkFile('include/Pap/Features/Common/AffiliateGroupForm.class.php', 'df0038f1fd9a589ff2d9cc038746a6c7');
        $this->checkFile('include/Pap/Features/Common/AffiliateGroupGrid.class.php', 'a2a42a1b00f7cbc78acc0714e7a50401');
        $this->checkFile('include/Pap/Features/CompressedCommissionPlacementModel/CompressedCommissionsSettingsForm.class.php', '9145b0e4404b24592ef7b54b580c7864');
        $this->checkFile('include/Pap/Features/CompressedCommissionPlacementModel/Definition.class.php', '7ceb3fa73d88dd94f2391d3a0306a513');
        $this->checkFile('include/Pap/Features/CompressedCommissionPlacementModel/Main.class.php', '54675f745ee420153861409ef2200828');
        $this->checkFile('include/Pap/Features/CompressedCommissionPlacementModel/PlacementOverviewForm.class.php', 'd388eedc3e9a29bcd642b9bfe15abd1f');
        $this->checkFile('include/Pap/Features/CompressedCommissionPlacementModel/PlacementOverviewGrid.class.php', '318c808d69fb3dd602e50578202291eb');
        $this->checkFile('include/Pap/Features/CompressedCommissionPlacementModel/Processor.class.php', '37357486cdee6fb1c4563e5a55665f71');
        $this->checkFile('include/Pap/Features/CompressedCommissionPlacementModel/Task.class.php', '35e8fb39d4549712ed7c3f426e543ae6');
        $this->checkFile('include/Pap/Features/CompressedCommissionPlacementModel/TransactionNotFoundException.class.php', '2b65e120939d655eea4cbb00811e9ada');
        $this->checkFile('include/Pap/Features/Coupon/Config.class.php', 'b79e48c98832285604a875e230deaea3');
        $this->checkFile('include/Pap/Features/Coupon/Constants.class.php', 'b5a8c4113e20018c3a232418f65a68db');
        $this->checkFile('include/Pap/Features/Coupon/Coupon.class.php', '819782e3f5cd88f74fe2c2556b72c3b8');
        $this->checkFile('include/Pap/Features/Coupon/CouponForm.class.php', '4a82c3e4661ea3eb21796a81237802ce');
        $this->checkFile('include/Pap/Features/Coupon/CouponPreviewsGrid.class.php', '6c82efe2d399e52f9e7771a1955fc7d9');
        $this->checkFile('include/Pap/Features/Coupon/CouponsBaseTask.class.php', '3ec53ee69f69a60daa76a45ca661e6d7');
        $this->checkFile('include/Pap/Features/Coupon/CouponsCsvImportForm.class.php', '23c5eca18c7f3f938311860db5ad4a32');
        $this->checkFile('include/Pap/Features/Coupon/CouponsCsvImportTask.class.php', 'fc33917b24224314c3112a86d145f5fe');
        $this->checkFile('include/Pap/Features/Coupon/CouponsGrid.class.php', '69ba38f007c0488b4e3203ebdf00ad36');
        $this->checkFile('include/Pap/Features/Coupon/CreateCoupons.class.php', 'b735dda0ccfdaf7bd0526cd5b8d2745a');
        $this->checkFile('include/Pap/Features/Coupon/Definition.class.php', 'ef428423e03684ebec9fb9caacaf6f81');
        $this->checkFile('include/Pap/Features/Coupon/GenerateCouponsTask.class.php', '742fcfc9020184a8867b42187c86f776');
        $this->checkFile('include/Pap/Features/Coupon/ImportCouponsTask.class.php', '1fcb76d769f9aec8043117b2bd8dbbc4');
        $this->checkFile('include/Pap/Features/Coupon/Main.class.php', '4c61a446d50eee2225732531ae00d3bd');
        $this->checkFile('include/Pap/Features/Coupon/OfflineSaleForm.class.php', 'cae61b1f5bb83e8ccf6a8210ba9e33e2');
        $this->checkFile('include/Pap/Features/Coupon/PreviewData.class.php', '1f26ba79c9a1215a8d73fb90e5fea993');
        $this->checkFile('include/Pap/Features/CpmCommission/Config.class.php', '0b5bc5d073357dbfd18e1d4819bb524a');
        $this->checkFile('include/Pap/Features/CpmCommission/Definition.class.php', '5f83ff774cebc1d8f486b5991eef49a0');
        $this->checkFile('include/Pap/Features/CpmCommission/Main.class.php', 'c4416ec7721226586e37a24e6cd69e60');
        $this->checkFile('include/Pap/Features/CpmCommissionClicks/Config.class.php', '08e50ab393fb75e8839abb911188e7a3');
        $this->checkFile('include/Pap/Features/CpmCommissionClicks/Definition.class.php', 'd21f9375c34ee4bc3b7266ac95bd4f21');
        $this->checkFile('include/Pap/Features/CpmCommissionClicks/Main.class.php', 'd9fd8c4efea986fc3f022b86e641752d');
        $this->checkFile('include/Pap/Features/Facebook/Config.class.php', 'f2e64dfd695c564d023cc23cf7d1e14d');
        $this->checkFile('include/Pap/Features/Facebook/Definition.class.php', 'ae8685775ec7e052a705dcbb575ba465');
        $this->checkFile('include/Pap/Features/Facebook/Main.class.php', '39282297ea7b22aa6fb00429c8334b85');
        $this->checkFile('include/Pap/Features/ForcedMatrix/AddBonusCommToOriginalRefererAction.class.php', '6fd2d580ade2b656d89d92f3e864aaf1');
        $this->checkFile('include/Pap/Features/ForcedMatrix/Definition.class.php', '388fbfba4397f1beaa3441798dd412a0');
        $this->checkFile('include/Pap/Features/ForcedMatrix/Main.class.php', 'fea45db1c9a89270934f0c2f296ae427');
        $this->checkFile('include/Pap/Features/ForcedMatrix/Matrix.class.php', '4d3737d15928a104c141471a5af062c0');
        $this->checkFile('include/Pap/Features/ForcedMatrix/MatrixFillBonus.class.php', 'b9787d3f6d0736f1abb9489185fca2b5');
        $this->checkFile('include/Pap/Features/ForcedMatrix/MatrixFillBonusSettings.class.php', '161a359795ffa8f30948b0a36f2f548b');
        $this->checkFile('include/Pap/Features/ForcedMatrix/MatrixFillUserSettings.class.php', '040ddba633db7b25b4a7d0b955f008c0');
        $this->checkFile('include/Pap/Features/GooglePlus/Definition.class.php', '8844f1f5bb977487c23ea798f58c5130');
        $this->checkFile('include/Pap/Features/HoverBanner/Definition.class.php', '99ad11fffef51be3e08689c0c5f2f6a8');
        $this->checkFile('include/Pap/Features/HoverBanner/Hover.class.php', 'f7e0fd519ddb206b2c1b62c716c7b7bd');
        $this->checkFile('include/Pap/Features/HoverBanner/LyteBox/images/blank.gif', 'fc94fb0c3ed8a8f909dbc7630a0987ff');
        $this->checkFile('include/Pap/Features/HoverBanner/LyteBox/images/close_blue.png', '562c11c8516814b77eaf594ccfaf6d80');
        $this->checkFile('include/Pap/Features/HoverBanner/LyteBox/images/close_gold.png', '0f8b2dce660a4bca80c924c5f6c1f58a');
        $this->checkFile('include/Pap/Features/HoverBanner/LyteBox/images/close_green.png', '16f10132bddc690d698543d53931ec18');
        $this->checkFile('include/Pap/Features/HoverBanner/LyteBox/images/close_grey.png', 'a7df8285279480e3c7951682b1822e78');
        $this->checkFile('include/Pap/Features/HoverBanner/LyteBox/images/close_red.png', 'c6aff1e7aa8fee0b91075f51daa5a486');
        $this->checkFile('include/Pap/Features/HoverBanner/LyteBox/images/loading.gif', '7e99e1159a3686f6aa4f90043c554483');
        $this->checkFile('include/Pap/Features/HoverBanner/LyteBox/images/next_blue.gif', '991382cc703fede8211caf90bfc9d7b2');
        $this->checkFile('include/Pap/Features/HoverBanner/LyteBox/images/next_gold.gif', 'dac1b61671657bd345033f829b4d023e');
        $this->checkFile('include/Pap/Features/HoverBanner/LyteBox/images/next_green.gif', 'aa40e7e01716700cf7b0ac0bbd54aa83');
        $this->checkFile('include/Pap/Features/HoverBanner/LyteBox/images/next_grey.gif', '05f1304f3693fe3d220fc71ec9ce6704');
        $this->checkFile('include/Pap/Features/HoverBanner/LyteBox/images/next_red.gif', 'dc8d51d41cc518d963cd94ac0caa16b0');
        $this->checkFile('include/Pap/Features/HoverBanner/LyteBox/images/pause_blue.png', 'ea7218fe22534380f23efd5e99375fcc');
        $this->checkFile('include/Pap/Features/HoverBanner/LyteBox/images/pause_gold.png', 'faef71f5386ed44c5caf95bfa562780e');
        $this->checkFile('include/Pap/Features/HoverBanner/LyteBox/images/pause_green.png', '25e4b8b88e16560e71bbf3b0ad70dac8');
        $this->checkFile('include/Pap/Features/HoverBanner/LyteBox/images/pause_grey.png', '54e9f0574c100e280ef757e6d52bdb67');
        $this->checkFile('include/Pap/Features/HoverBanner/LyteBox/images/pause_red.png', 'd33377c32008d7eded0908d8533d5f8a');
        $this->checkFile('include/Pap/Features/HoverBanner/LyteBox/images/play_blue.png', 'b447167c055a67c93f58eeb7d9a3c5af');
        $this->checkFile('include/Pap/Features/HoverBanner/LyteBox/images/play_gold.png', '049ea18b682fe928eac3aaa905d82d8d');
        $this->checkFile('include/Pap/Features/HoverBanner/LyteBox/images/play_green.png', 'fec50e905f687f28a414a6a5d1a159e0');
        $this->checkFile('include/Pap/Features/HoverBanner/LyteBox/images/play_grey.png', 'dd83740fb3ed1b0dcd9670099a98d72d');
        $this->checkFile('include/Pap/Features/HoverBanner/LyteBox/images/play_red.png', '338e9cdb52c3a8c7fd2547a21899a88c');
        $this->checkFile('include/Pap/Features/HoverBanner/LyteBox/images/prev_blue.gif', '78b24fd9e1ecc8a10996f5a0d3b2730f');
        $this->checkFile('include/Pap/Features/HoverBanner/LyteBox/images/prev_gold.gif', '758083084ccf7726b1f08ed201368360');
        $this->checkFile('include/Pap/Features/HoverBanner/LyteBox/images/prev_green.gif', 'e61ec81e13986afde7600d81a8bb037e');
        $this->checkFile('include/Pap/Features/HoverBanner/LyteBox/images/prev_grey.gif', '37fc1dbf036133a4a0c0f07c69912a91');
        $this->checkFile('include/Pap/Features/HoverBanner/LyteBox/images/prev_red.gif', '9316b29639a30b42ecdd6dfb52167eb3');
        $this->checkFile('include/Pap/Features/HoverBanner/LyteBox/lytebox.css', '273b6b05ff193bae41c6c0412e03e140');
        $this->checkFile('include/Pap/Features/HoverBanner/LyteBox/lytebox.js', '3f15640ecbd0c6eb4d120eec854402ce');
        $this->checkFile('include/Pap/Features/HoverBanner/Main.class.php', '1ee6353426bf4eed417319a4769e651b');
        $this->checkFile('include/Pap/Features/KeywordsPerformance/Config.class.php', '9c92662fa26974dddbb21f71d52a0d06');
        $this->checkFile('include/Pap/Features/KeywordsPerformance/Definition.class.php', 'f7da679a9fbccb48e57ce7be55ed06c2');
        $this->checkFile('include/Pap/Features/KeywordsPerformance/KeywordsGrid.class.php', '3176f7875fc58ba2a67e02fd20b2bcb0');
        $this->checkFile('include/Pap/Features/KeywordsPerformance/Main.class.php', '2d667ce3f82cadda77920b44bbc49bea');
        $this->checkFile('include/Pap/Features/KeywordsPerformance/RecomputeOldClicksTask.class.php', 'ec7ab7b17a1516a62b6541eb0627a8b6');
        $this->checkFile('include/Pap/Features/KeywordsPerformance/RecomputeOldTransactionsTask.class.php', '75422999c37708f5923ca3805bc570a7');
        $this->checkFile('include/Pap/Features/LifetimeReferralsManager/Definition.class.php', '9b223240391c19d6e0af343c5f303bc7');
        $this->checkFile('include/Pap/Features/LifetimeReferralsManager/LifetimeReferralsAffiliateGrid.class.php', '4fa2406941f81c7513873f636284f1cb');
        $this->checkFile('include/Pap/Features/LifetimeReferralsManager/LifetimeReferralsForm.class.php', '2f710415e9581096e80cad8a809be4c2');
        $this->checkFile('include/Pap/Features/LifetimeReferralsManager/LifetimeReferralsGrid.class.php', '083c8b093d833c5e69c89fdbf2b4c07c');
        $this->checkFile('include/Pap/Features/LifetimeReferralsManager/Main.class.php', '5a282b9e2cc1349a80419db493edae7f');
        $this->checkFile('include/Pap/Features/LifetimeReferralsManager/RelationsImportForm.class.php', '8313718a03c184550af8c43a3cf62505');
        $this->checkFile('include/Pap/Features/LifetimeReferralsManager/RelationsImportTask.class.php', '5e667d83557e7cf2d42c1fb2e743e7ce');
        $this->checkFile('include/Pap/Features/Linkedin/Definition.class.php', 'e4b61cca2a4a32751dff4f758817d815');
        $this->checkFile('include/Pap/Features/LiveAgent/Config.class.php', 'efdb6ffd459b8153e9c7d434ac89c326');
        $this->checkFile('include/Pap/Features/LiveAgent/Definition.class.php', 'cdc9f483362e6360ab872d61068b0d74');
        $this->checkFile('include/Pap/Features/LiveAgent/DepartmentsRichListBox.class.php', 'cb242b95a1f4f4d1bd85d4a5b1d3b6c5');
        $this->checkFile('include/Pap/Features/LiveAgent/Helper/Agents.class.php', '9816b6baaf2ff0b7269533124919cffd');
        $this->checkFile('include/Pap/Features/LiveAgent/Helper/Api.class.php', '4b4ab5db3c97496c9c1461b5a23b464a');
        $this->checkFile('include/Pap/Features/LiveAgent/Helper/ApiV3.class.php', '3ac9415e70aac199803ad4d07a6ad380');
        $this->checkFile('include/Pap/Features/LiveAgent/Helper/Conversations.class.php', '2b1a5ac2f7455334d907c85e5acf2a71');
        $this->checkFile('include/Pap/Features/LiveAgent/Helper/Departments.class.php', '7ce55bbb44b5abf39606947e7f8e419c');
        $this->checkFile('include/Pap/Features/LiveAgent/Helper/DepartmentsV3.class.php', '3cfba2c7838536cb2d58a7d38ea45e2b');
        $this->checkFile('include/Pap/Features/LiveAgent/Helper/Login.class.php', '2f40f8ce7a8bd3aa8692427a6efb6b50');
        $this->checkFile('include/Pap/Features/LiveAgent/Main.class.php', '51b6ca5dc22bcf10271bf2f00adcb5f9');
        $this->checkFile('include/Pap/Features/LiveAgent/Panel/Configuration.class.php', '628498051fbe7522d702c29eb042c007');
        $this->checkFile('include/Pap/Features/LiveAgent/Panel/Dashboard.class.php', 'da2f5ea9ccb9278149e5999dbb462ce8');
        $this->checkFile('include/Pap/Features/LiveAgent/Panel/DashboardConversationsGrid.class.php', '0593915f71aaeff11f7c380c2a9fa1f8');
        $this->checkFile('include/Pap/Features/LiveAgent/Panel/DashboardDepartmentsGrid.class.php', 'f1372ce462fc59399d3b026c46b61895');
        $this->checkFile('include/Pap/Features/MailToFriend/Definition.class.php', '17e1bb69f90a489d7cf2118d2243389f');
        $this->checkFile('include/Pap/Features/MailToFriend/Main.class.php', '55081737eed3b2cb232e16982136b561');
        $this->checkFile('include/Pap/Features/MembershipSubscriptionsManager/ConfigForm.class.php', '8bf0714d18b5de8ee0d810784b1e0c96');
        $this->checkFile('include/Pap/Features/MembershipSubscriptionsManager/Definition.class.php', 'ed45778156cbfc38b0908b7e55d84b96');
        $this->checkFile('include/Pap/Features/MembershipSubscriptionsManager/EmailSubscriptionCancelled.class.php', 'd1af30cb87c332a092fe232775d9f6e9');
        $this->checkFile('include/Pap/Features/MembershipSubscriptionsManager/EmailSubscriptionCancelledMerchant.class.php', 'a401c43ce2dd1db4caf3b2f41427bd05');
        $this->checkFile('include/Pap/Features/MembershipSubscriptionsManager/EmailSubscriptionCreated.class.php', 'aca1160812cd3c20d4198dc672fc8858');
        $this->checkFile('include/Pap/Features/MembershipSubscriptionsManager/EmailSubscriptionCreatedMerchant.class.php', 'b2c78302162e86659e93ac3848b52bee');
        $this->checkFile('include/Pap/Features/MembershipSubscriptionsManager/EmailSubscriptionRenewed.class.php', 'ce37a26ebebf0df33b8920196495b0d3');
        $this->checkFile('include/Pap/Features/MembershipSubscriptionsManager/EmailSubscriptionRenewedMerchant.class.php', '37a58b4e7d1f266f180ee02eb760c0d5');
        $this->checkFile('include/Pap/Features/MembershipSubscriptionsManager/Main.class.php', '08ad37fc1742ac5b39ec8793679d82bb');
        $this->checkFile('include/Pap/Features/MembershipSubscriptionsManager/SubscriptionsValidityCheckTask.class.php', '8b952a31dfb0bf5578bfde8465df6590');
        $this->checkFile('include/Pap/Features/MultipleCurrency/Config.class.php', '03d541d0bcd2a5593f3592f40ed32de3');
        $this->checkFile('include/Pap/Features/MultipleCurrency/CurrenciesGrid.class.php', '4bbc5c7f64648e216f6ce133b133e999');
        $this->checkFile('include/Pap/Features/MultipleCurrency/Definition.class.php', '9ecff69e046766f3f1e02f8f787e8079');
        $this->checkFile('include/Pap/Features/MultipleCurrency/ExchangeRateUpdater.class.php', '6ba34c34767af324e14fddafb5695199');
        $this->checkFile('include/Pap/Features/MultipleCurrency/Main.class.php', '35d4424224096b44de089aa70802dfcb');
        $this->checkFile('include/Pap/Features/MultipleCurrency/TaskConfig.class.php', '6fa2bd1318bf1200296cfabf229655d1');
        $this->checkFile('include/Pap/Features/MultipleMerchants/AdminForm.class.php', '894f71b15a1fab2723bbd28c0683463b');
        $this->checkFile('include/Pap/Features/MultipleMerchants/AdminsGrid.class.php', 'b68f8f6128651a1ad1c551f642611332');
        $this->checkFile('include/Pap/Features/MultipleMerchants/Definition.class.php', 'ae0e6c9baa11a4cc82ad2a5169c6f522');
        $this->checkFile('include/Pap/Features/MultipleMerchants/Main.class.php', '3e059876cf6c9dd74fbb66f82d09d7bc');
        $this->checkFile('include/Pap/Features/MultipleMerchants/RolesRichListBox.class.php', 'f793348cfece9dc518c7aecdb8c261b1');
        $this->checkFile('include/Pap/Features/PagePeelBanner/Banner.class.php', '69f3a6016747e2bf93ba29fb0db6efa7');
        $this->checkFile('include/Pap/Features/PagePeelBanner/BannerHtml.class.php', 'ac36c6a4d7cb26dd9bf0b9abb53d13ab');
        $this->checkFile('include/Pap/Features/PagePeelBanner/Definition.class.php', '5e7c42df0f61f3936e563ad089c3e50c');
        $this->checkFile('include/Pap/Features/PagePeelBanner/EdgeBanner/edge.png', 'bee7205b8c992ca6d9bd571494e0fd80');
        $this->checkFile('include/Pap/Features/PagePeelBanner/EdgeBanner/edgeBanner.swf', 'f58fa8efa67dd643248a62802d11e4d0');
        $this->checkFile('include/Pap/Features/PagePeelBanner/EdgeBanner/edge_right.png', 'd9c99ffd66ab70c7aeb40b919d11e881');
        $this->checkFile('include/Pap/Features/PagePeelBanner/Handler.class.php', '6fda873c635eafa4dbf2860df67010af');
        $this->checkFile('include/Pap/Features/PapGeoip/Config.class.php', '4c9b39277d5c4b3d9fd3c79f73c11e44');
        $this->checkFile('include/Pap/Features/PapGeoip/CountrySelectGrid.class.php', '7c7006bc21582e4f13b758bec56e8286');
        $this->checkFile('include/Pap/Features/PapGeoip/Definition.class.php', 'f59605b8e95c1347f3e096ef27ed0e6d');
        $this->checkFile('include/Pap/Features/PapGeoip/Main.class.php', '13f27138ba1f6089d9148076a2ca9615');
        $this->checkFile('include/Pap/Features/PapGeoip/MapOverlayGrid.class.php', 'eabcf887b6c6bd89a2fcdf781598fb83');
        $this->checkFile('include/Pap/Features/PapGeoip/MapOverlayTabSettings.class.php', 'f2098d20c656c95b5d2831d998e581b6');
        $this->checkFile('include/Pap/Features/PapGeoip/RecognizeCountryFromClick.class.php', 'b41ac6b5ed77f6a0c2010e3803e0cdc3');
        $this->checkFile('include/Pap/Features/PapGeoip/SelectAllCountriesGrid.class.php', 'a6a26f197b22adecdbfda08fab6fe46c');
        $this->checkFile('include/Pap/Features/PapGeoip/UserMailExtension.class.php', '0871faefeeed69c641607d2152659785');
        $this->checkFile('include/Pap/Features/PayoutFieldsEncryption/Config.class.php', '779c3cb466e52a2ede9ce0c4deeebf4f');
        $this->checkFile('include/Pap/Features/PayoutFieldsEncryption/Definition.class.php', '716fd7d5bd10be1d5fbb41d161fd3288');
        $this->checkFile('include/Pap/Features/PayoutFieldsEncryption/Encoder.class.php', 'd05c4046f0e8e8eb0e4675ac736f2611');
        $this->checkFile('include/Pap/Features/PayoutFieldsEncryption/Main.class.php', '9c72b8832df2c38e60bb611f94f5d78d');
        $this->checkFile('include/Pap/Features/PerformanceImpressionTracker/Definition.class.php', 'e6afd2f105dccaa36196eedd42b7210f');
        $this->checkFile('include/Pap/Features/PerformanceRewards/Action/AddBonusCommAction.class.php', '5a62bf4fd5cffe28cb127b3cf08df6e4');
        $this->checkFile('include/Pap/Features/PerformanceRewards/Action/ChangeGroup.class.php', 'e28cfd6beab70317a3d29ddf27fbc2b9');
        $this->checkFile('include/Pap/Features/PerformanceRewards/Action/ChangeGroupRetroactively.class.php', 'aa38d8d5d3c0772714e5a309bfaf5c13');
        $this->checkFile('include/Pap/Features/PerformanceRewards/Action/NoAction.class.php', 'ab2f70a15b35753834d7514db488f110');
        $this->checkFile('include/Pap/Features/PerformanceRewards/Action.class.php', 'fe756e86ff3ffa56f598b9efa0812950');
        $this->checkFile('include/Pap/Features/PerformanceRewards/ActionList.class.php', 'eefc0fd5e50b0fad0253bc4fc18ce25b');
        $this->checkFile('include/Pap/Features/PerformanceRewards/Definition.class.php', 'ef50860b6d4f14a2951e1f46d1f4638c');
        $this->checkFile('include/Pap/Features/PerformanceRewards/Main.class.php', 'f58ef4159c99b21cd44961cdab926f9b');
        $this->checkFile('include/Pap/Features/PerformanceRewards/Rule.class.php', '0aeb82a4ce350db1155ef5c1a560451d');
        $this->checkFile('include/Pap/Features/PerformanceRewards/RuleForm.class.php', '5f971d86729dab029824cc7f9e77509b');
        $this->checkFile('include/Pap/Features/PerformanceRewards/RulesCampaignsGrid.class.php', '16204b0c236d778a72d0ddfff40f4e92');
        $this->checkFile('include/Pap/Features/PerformanceRewards/RulesGrid.class.php', 'aaafbd48b28668de0e901b1a8bab7279');
        $this->checkFile('include/Pap/Features/Pinterest/Definition.class.php', '1865aab0f30ceacf785a90d70f0690d3');
        $this->checkFile('include/Pap/Features/PrivateCampaigns/Definition.class.php', '91ad3f82199feb6719fccd507e52191e');
        $this->checkFile('include/Pap/Features/PrivateCampaigns/MailContext.class.php', '0efebcd79348b392cebd761e221c11cb');
        $this->checkFile('include/Pap/Features/PrivateCampaigns/Main.class.php', 'b141810b2130931ca9d513a55c4ba5a6');
        $this->checkFile('include/Pap/Features/PrivateCampaigns/PrivateCampaignForAffiliateRichListBox.class.php', 'eefb0c6f65d8d7077a0a9d13ce2b2296');
        $this->checkFile('include/Pap/Features/PrivateCampaigns/RemoveFromCampaign.class.php', '7c523a625ea35d6266bbc01769df2e4c');
        $this->checkFile('include/Pap/Features/ReCaptcha/Definition.class.php', '61172162ea591a879d67553535fdc0c3');
        $this->checkFile('include/Pap/Features/ReCaptcha/Main.class.php', '986a9085f76fe24f4d2b4396142930f5');
        $this->checkFile('include/Pap/Features/ReCaptcha/ReCaptchaForm.class.php', '8d287784b1d9cfc72d01a010ec4992db');
        $this->checkFile('include/Pap/Features/RebrandPdfBanner/Banner.class.php', 'ea1ff6e7970f9e84022f6b03f9958d23');
        $this->checkFile('include/Pap/Features/RebrandPdfBanner/Config.class.php', 'ca47f0744198f3994e28642ed10e0630');
        $this->checkFile('include/Pap/Features/RebrandPdfBanner/Definition.class.php', '8c6caba641fb3dbff03d56614890fcbd');
        $this->checkFile('include/Pap/Features/RebrandPdfBanner/Pdf/FindRegexp.class.php', '17dfc3874bb71ccc578deb9b322f72de');
        $this->checkFile('include/Pap/Features/RebrandPdfBanner/Pdf/Processor.class.php', '534c1bf3a512ed5b9145c933203af598');
        $this->checkFile('include/Pap/Features/RebrandPdfBanner/Pdf/Replace.class.php', '7d94e7788d1aac29355bcd88c42c07d9');
        $this->checkFile('include/Pap/Features/RebrandPdfBanner/Service.class.php', '41d1883686335ae38490fd4ca0f4c973');
        $this->checkFile('include/Pap/Features/RebrandPdfBanner/Session.class.php', '907bb3bca8dc087877bbc8fcd16f805c');
        $this->checkFile('include/Pap/Features/RebrandPdfBanner/Upload.class.php', '5b216c02bbb10cb06ccb4c0a24f36e9f');
        $this->checkFile('include/Pap/Features/RebrandPdfBanner/Variables.class.php', 'dc4f1b7f797f7712797395bca1ecaac3');
        $this->checkFile('include/Pap/Features/RecurringCommissions/Config.class.php', 'f2ff5cc97ae745e5a2f44ca189fa4e64');
        $this->checkFile('include/Pap/Features/RecurringCommissions/Definition.class.php', 'b494b2ec5225abacb235a6f47d03416b');
        $this->checkFile('include/Pap/Features/RecurringCommissions/Main.class.php', 'bc657a2d12021896b1df2c1fac2efe19');
        $this->checkFile('include/Pap/Features/RecurringCommissions/RecurringCommission.class.php', '881de12e3223923834dcd633f137c790');
        $this->checkFile('include/Pap/Features/RecurringCommissions/RecurringCommissionsForm.class.php', 'de40ea2c670da734e89c9bf9cdf06691');
        $this->checkFile('include/Pap/Features/RecurringCommissions/RecurringCommissionsGrid.class.php', 'b55d3c0f8ceeebe584a18122131b7913');
        $this->checkFile('include/Pap/Features/RecurringCommissions/RecurringEntriesData.class.php', 'd5bcdb9910125c6be8123d83a8fa705a');
        $this->checkFile('include/Pap/Features/RecurringCommissions/RecurringStatsBuilder.class.php', '2133d22986aeed3194746877bd86df4d');
        $this->checkFile('include/Pap/Features/RecurringCommissions/Runner.class.php', 'e562b3fdce79149ea0e87118c480b6f6');
        $this->checkFile('include/Pap/Features/SiteReplication/Config.class.php', '9b1d0d715a74a9847aed8a1693bb38be');
        $this->checkFile('include/Pap/Features/SiteReplication/Definition.class.php', '3de3fae62578102876cebd46797570bb');
        $this->checkFile('include/Pap/Features/SiteReplication/DestinationValidator.class.php', '7ca4e95d39e59286a8709cc43683deb0');
        $this->checkFile('include/Pap/Features/SiteReplication/Driver/Base.class.php', '01a22e562d5f051054e50a6b19929635');
        $this->checkFile('include/Pap/Features/SiteReplication/Driver/ExternalUrl.class.php', '0e7a6d1a598163c051ecc27c4fada04b');
        $this->checkFile('include/Pap/Features/SiteReplication/Driver/LocalFiles.class.php', '8f6a71a4f296cadaa9f28be5c840c047');
        $this->checkFile('include/Pap/Features/SiteReplication/FileNotFoundException.class.php', '972931e0e6acb24e829ebf7b9ac89ec7');
        $this->checkFile('include/Pap/Features/SiteReplication/FilesTree.class.php', '7b9f2536939b6a5f91234960dacb861b');
        $this->checkFile('include/Pap/Features/SiteReplication/MerchantOnSiteStopped.class.php', '771ee3a266876922c77d2e57c619cc89');
        $this->checkFile('include/Pap/Features/SiteReplication/Replicator.class.php', 'c8d9335ac6030d9660d861972ff2171f');
        $this->checkFile('include/Pap/Features/SiteReplication/Site.class.php', '1cb51ca4b34d8fde56ff45b92be784d7');
        $this->checkFile('include/Pap/Features/SiteReplication/SiteHtaccess.class.php', '4195ff3a7065a2b2bcc3bb7613bf8a99');
        $this->checkFile('include/Pap/Features/SplitCommissions/Config.class.php', '3d7a9aeb720d36adbea6a326c9beaa92');
        $this->checkFile('include/Pap/Features/SplitCommissions/ContextProcessor.class.php', '91c86813f9a1bc63e11956ed14f53ab7');
        $this->checkFile('include/Pap/Features/SplitCommissions/Definition.class.php', '4cf7a4e8a265abdfcd8b73799eb0be66');
        $this->checkFile('include/Pap/Features/SplitCommissions/RecognizeVisitorAffiliate.class.php', '2114261ab6abff2e0e822418dca7804e');
        $this->checkFile('include/Pap/Features/SplitCommissions/SaveVisitorAffiliate.class.php', '696bd7320c4784b0a34b62b073b2bb9c');
        $this->checkFile('include/Pap/Features/SplitCommissions/SplitCommissions.class.php', '69e5dcd911d058414e02f2f06919642e');
        $this->checkFile('include/Pap/Features/SplitCommissions/SplitCommissionsForm.class.php', '60d2eb3212b275e07a11d9d2f061d683');
        $this->checkFile('include/Pap/Features/SplitCommissions/SplitCommissionsMailData.class.php', '69378e02e0f5e354dacf9f6449aacaf2');
        $this->checkFile('include/Pap/Features/SplitCommissions/VisitorAffiliateCheckCompatibility.class.php', '5de27a0585202ff7a61f4c744f2c853a');
        $this->checkFile('include/Pap/Features/Twitter/Definition.class.php', '007fcf5098254e77930e0149aaf79324');
        $this->checkFile('include/Pap/Features/ZipBanner/Config.class.php', '3e0670d957504d19175e96e0b32fb16b');
        $this->checkFile('include/Pap/Features/ZipBanner/Definition.class.php', '490f3b42db68f419799ba75a7b08f156');
        $this->checkFile('include/Pap/Features/ZipBanner/DisplayBanner.class.php', '33ad3e7d6f96c233ccb8ea4ef6b5e647');
        $this->checkFile('include/Pap/Features/ZipBanner/FilesTree.class.php', '9c9d8872ea74914aabcad21031006118');
        $this->checkFile('include/Pap/Features/ZipBanner/Unziper.class.php', '9de25e81bc4077f5ad8cff6c97669c77');
        $this->checkFile('include/Pap/Features/ZipBanner/UserFields.class.php', '4da3cbde29ed161db962a8c6026fe2af');
        $this->checkFile('include/Pap/Features/ZipBanner/Zip.class.php', 'aa91cb0962e6546331f1243bca608674');
        $this->checkFile('include/Pap/FooterExtensionsContext.class.php', '7f4a66d640b5dd85ff47c80efb5c4018');
        $this->checkFile('include/Pap/Install/AcceptLicense.class.php', 'c94e42d0d4aa084984e0b81b889a3211');
        $this->checkFile('include/Pap/Install/ApplicationSettings.class.php', 'b836f107ccc86646a05f382a34fc7788');
        $this->checkFile('include/Pap/Install/Brand.class.php', '5ea432c9382f5a2aa1313eefcbeafa05');
        $this->checkFile('include/Pap/Install/CheckVersion.class.php', '44a69dda0f7b6694442588a6ae2da5cf');
        $this->checkFile('include/Pap/Install/CleanInstallScenario.class.php', 'bb82b75efe83e584a074c56de57439c6');
        $this->checkFile('include/Pap/Install/CreateAccountTask.class.php', '609694ccd3e47c4a4a066a0b924516a2');
        $this->checkFile('include/Pap/Install/DefaultMerchant.class.php', '17a1a9c4eca8650ad1fb80b5ed680a3f');
        $this->checkFile('include/Pap/Install/DefaultNews.class.php', '83620e8b8aa77096943b6b10eba1e522');
        $this->checkFile('include/Pap/Install/DefaultPayoutMethods.class.php', '58b74f7c4e6c15ee3423305b21c1fc86');
        $this->checkFile('include/Pap/Install/DefaultPayoutMethodsBase.class.php', '86f96d26b8233bede372666bc6ce4c72');
        $this->checkFile('include/Pap/Install/Hosting/Account.class.php', '85fd266d0c4ae941a406cccb7ea80d9f');
        $this->checkFile('include/Pap/Install/Hosting/CleanInstallScenario.class.php', '98c742b131ce9b79006b541a839ca207');
        $this->checkFile('include/Pap/Install/Hosting/CreateAccount.class.php', '2fdc3a53a484f9ecf439ae9f278dea51');
        $this->checkFile('include/Pap/Install/Hosting/CreateAccountTask.class.php', 'd948358bff8bba14e29056cf5fc89b2f');
        $this->checkFile('include/Pap/Install/Hosting/DemoInstallScenario.class.php', '2ef1433d9dbb04e93cb81ad354761b62');
        $this->checkFile('include/Pap/Install/Hosting/FinishMigrationScenario.class.php', 'd9d4d04ef4c56a6cfbed5b425a0c4d51');
        $this->checkFile('include/Pap/Install/Hosting/Install.class.php', '0405eb5045d36f408a2081435e6f3f1e');
        $this->checkFile('include/Pap/Install/Hosting/Manager.class.php', 'dd42cc03217c527d111aadaa3262ae9b');
        $this->checkFile('include/Pap/Install/Hosting/RenameScenario.class.php', 'bf0a1259172f253b2f00432ee1545903');
        $this->checkFile('include/Pap/Install/Hosting/UpdateAccountTask.class.php', '106e830ef69aa73ce577b5eff33bbac7');
        $this->checkFile('include/Pap/Install/Hosting/UpdateApplication.class.php', '6630c81a87299358ce62105d824f3ae6');
        $this->checkFile('include/Pap/Install/Hosting/UpdateManager.class.php', '5d3da109dff2f71c4312a30f5b61618b');
        $this->checkFile('include/Pap/Install/Hosting/UpdateScenario.class.php', 'dc32c861719c877c847022d6d6150248');
        $this->checkFile('include/Pap/Install/LicenseManager.class.php', '9c85ff9a8355c372baad20d2a3885dcb');
        $this->checkFile('include/Pap/Install/Manager.class.php', 'ee39fdc82c84844a5d98337cb6ddec7b');
        $this->checkFile('include/Pap/Install/RecommendedSettings.class.php', '604824c21842773f88d3e25e76a09984');
        $this->checkFile('include/Pap/Install/Requirements.class.php', '4879d1e459f98ace135345a7076af91a');
        $this->checkFile('include/Pap/Install/RevalidateLicense.class.php', '8f3236bfa7e3862511a82f4bdbcef4c2');
        $this->checkFile('include/Pap/Install/SampleBanners.class.php', 'f1a73af213d25cc17a030eebe47291da');
        $this->checkFile('include/Pap/Install/SampleChannels.class.php', 'f4f9502cf5a734db5424fa5b3b99dae1');
        $this->checkFile('include/Pap/Install/Ui/CheckRequirements.class.php', '964f6d70bc6af112cf327722f99c0184');
        $this->checkFile('include/Pap/Install/Ui/RecommendedSettings.class.php', 'f538b9104b088132a9cbd35b86f23541');
        $this->checkFile('include/Pap/Install/UpdateCheckRequirements.class.php', '576ce30b319caa8de05960dbc4f07ab4');
        $this->checkFile('include/Pap/Install/UpdateScenario.class.php', 'f93b868b8103bb0a5e80fa27e112dc52');
        $this->checkFile('include/Pap/Install/WelcomeCheckRequirements.class.php', 'b3ecf360cc438b9c9f1b764763774a36');
        $this->checkFile('include/Pap/Installer.class.php', '199291f063c52b18d0530d38b0f9ff8d');
        $this->checkFile('include/Pap/Lang.class.php', '33e98e5dc3ec9a5f121d6ec260a992f9');
        $this->checkFile('include/Pap/License/Processor.class.php', 'd547a141dd45582e93a97856d2c40398');
        $this->checkFile('include/Pap/Logger.class.php', '0332baed31436736f8dce897c49a2d39');
        $this->checkFile('include/Pap/LoginApplicationSettings.class.php', '26cfccb95497d6de5f75b24528036532');
        $this->checkFile('include/Pap/Mail/AffiliateChangeCommissionStatus.class.php', '92b9e83d1de66066a4c996d62b809193');
        $this->checkFile('include/Pap/Mail/AffiliateDirectLinkNotification.class.php', '7707028ce1bcddf4718f787c35df260b');
        $this->checkFile('include/Pap/Mail/AffiliateInvoice.class.php', 'fdd7a95dc97e4cb4d2cf527a62644b0c');
        $this->checkFile('include/Pap/Mail/AffiliateOnCampaignStatusChanged.class.php', '52904e2ab350ca35a23f3685a1fcc354');
        $this->checkFile('include/Pap/Mail/AffiliateOnCommissionRefundChargeback.class.php', '6591da13531d60f05080218a1e44a633');
        $this->checkFile('include/Pap/Mail/AffiliateOnInactivity.class.php', '5d207e7a3e90845c42facd46fdde111c');
        $this->checkFile('include/Pap/Mail/AffiliateOnInactivityWarning.class.php', 'a085f854fe76747cf3ebd14fd3c27bb0');
        $this->checkFile('include/Pap/Mail/AffiliateOnNewActionCommission.class.php', 'b1d828996418a5fa9d9d4eaca150ac27');
        $this->checkFile('include/Pap/Mail/AffiliateOnNewExtraBonusCommission.class.php', '5e6fc24b1ca658311ab122ae3dda1249');
        $this->checkFile('include/Pap/Mail/AffiliateOnNewSale.class.php', '9b8d29f1c6f69b95ca141fde2e427285');
        $this->checkFile('include/Pap/Mail/AffiliateOnNewSpecialCommission.class.php', 'c8ff11da1831babe716fdce265f3f42f');
        $this->checkFile('include/Pap/Mail/AffiliateSendMassMail.class.php', '90ff547b382b8429b341d49e500d898d');
        $this->checkFile('include/Pap/Mail/AffiliateUserMail.class.php', '0cd0435c12cf44154e3b001675da720a');
        $this->checkFile('include/Pap/Mail/AutoRegisteringAffiliateOnFirstSale.class.php', 'cba19fb18234e140fde75819bbf7a416');
        $this->checkFile('include/Pap/Mail/CampaignMailBase.class.php', '415ee01049aa454f7a3e6b0148652615');
        $this->checkFile('include/Pap/Mail/CampaignStatusChangedMailTask.class.php', 'ae4385de9d3f2e3084f7e067fbbea1c2');
        $this->checkFile('include/Pap/Mail/EmailSettingsForms.class.php', '249cd5994a3574ed8c136f9d8caf13e5');
        $this->checkFile('include/Pap/Mail/EmailTemplateAffiliateForm.class.php', '9a457ba2be2d95b07f65ba962f156804');
        $this->checkFile('include/Pap/Mail/GenerateMassMailsTask.class.php', 'bd8036e17b5fef9a1febbd2d5c15c6e1');
        $this->checkFile('include/Pap/Mail/InviteToCampaign.class.php', '99c027b9870e5e9bdc932e4dd50fa50b');
        $this->checkFile('include/Pap/Mail/MassMailAffiliatesGrid.class.php', '80ee30bd9b0ae954ffdaa273a0c6ffd6');
        $this->checkFile('include/Pap/Mail/MassMailTemplate.class.php', 'bfe34adc1adf12db02d5cb20adee6bcd');
        $this->checkFile('include/Pap/Mail/MerchantInvoice.class.php', 'fbb73033443b7a296ee4dc2ec900c44a');
        $this->checkFile('include/Pap/Mail/MerchantNewDirectLinkNotification.class.php', '4a9c939f7ec149507264028d3ce75e8e');
        $this->checkFile('include/Pap/Mail/MerchantNewUserSignup.class.php', '2e6d5b7b740d49ab7347a9c821264d7c');
        $this->checkFile('include/Pap/Mail/MerchantOnActionCommission.class.php', '43acca359d66a59eaa58aba3a89012ee');
        $this->checkFile('include/Pap/Mail/MerchantOnAffiliateStopped.class.php', '8ea4a19b61dd601871d1950817d5c73c');
        $this->checkFile('include/Pap/Mail/MerchantOnCommissionApproved.class.php', 'e0b0810fdbb6e9f1de483482c2978ea4');
        $this->checkFile('include/Pap/Mail/MerchantOnContactUs.class.php', 'fd40d1047e239540855857931d12cab3');
        $this->checkFile('include/Pap/Mail/MerchantOnExtraBonus.class.php', 'a49f6f85b20cfc7f681881e7cdd56730');
        $this->checkFile('include/Pap/Mail/MerchantOnNewUnconfirmedBanner.class.php', '09522f1247532211716d821ab6bddc8a');
        $this->checkFile('include/Pap/Mail/MerchantOnSale.class.php', 'e4683dbb206e31b563894e31c1107a58');
        $this->checkFile('include/Pap/Mail/MerchantOnSignupContactUs.class.php', '32534fc72f3757d538b4f7230aeb569e');
        $this->checkFile('include/Pap/Mail/NewUserSignupApproved.class.php', 'bcb2af17d9ba424382e714dbc7444d3f');
        $this->checkFile('include/Pap/Mail/NewUserSignupBeforeApproval.class.php', '8a6c39437b45c3b5c2af6c45c4a59043');
        $this->checkFile('include/Pap/Mail/NewUserSignupDeclined.class.php', 'fdf1d67beab89a3a156fbf2431a5fa8c');
        $this->checkFile('include/Pap/Mail/OnAffiliateJoinToCampaign.class.php', 'b9ecfdcd43ab2c0f542a84f045aa69df');
        $this->checkFile('include/Pap/Mail/OnMerchantApproveAffiliateToCampaign.class.php', '4f6beb55754665e44b3ece929ba09da1');
        $this->checkFile('include/Pap/Mail/OnMerchantDeclineAffiliateForCampaign.class.php', 'd252174533eff4b4e910fe861162521a');
        $this->checkFile('include/Pap/Mail/OnMerchantUsernameChanged.class.php', 'ec54031d5103ee9e1e0aa73e804cf775');
        $this->checkFile('include/Pap/Mail/OnPayout.class.php', '834befc74d7f8530ec36176c206c1525');
        $this->checkFile('include/Pap/Mail/OnSubAffiliateActionCommission.class.php', '1d188a6906c78697e3bc5b20ef15d3cb');
        $this->checkFile('include/Pap/Mail/OnSubAffiliateSale.class.php', 'a6045a81e528d682970e1941959f2fe3');
        $this->checkFile('include/Pap/Mail/OnSubAffiliateSignup.class.php', '9e8f6f8b1583f7a468cb66a4563f2714');
        $this->checkFile('include/Pap/Mail/OnVATPayout.class.php', '979e0cc91b82ce07d23221133ff60f57');
        $this->checkFile('include/Pap/Mail/PayDayReminder/PayAffiliatesList.class.php', 'a1726c1c6cecbbfa4547b83fca2af328');
        $this->checkFile('include/Pap/Mail/PayDayReminder/PayDayReminder.class.php', '04a356124a0d3bb6cee594964c37a134');
        $this->checkFile('include/Pap/Mail/PayDayReminder/PayDaySendTask.class.php', '8d4660cee2396b1dbc4a28c78a66d933');
        $this->checkFile('include/Pap/Mail/PaymentRequest.class.php', '82d8ad4668186975e1329e675f98018e');
        $this->checkFile('include/Pap/Mail/Reports/AffDailyReport.class.php', '4baba975b85636fe275fea30137fabfe');
        $this->checkFile('include/Pap/Mail/Reports/AffMonthlyReport.class.php', '403d7320035ee358e021e1ff74e39a0e');
        $this->checkFile('include/Pap/Mail/Reports/AffWeeklyReport.class.php', '27aeec4dbd90264adbbb5f25ada12f37');
        $this->checkFile('include/Pap/Mail/Reports/DailyReport.class.php', 'e04467392746fd3e142b9dd491ea75ce');
        $this->checkFile('include/Pap/Mail/Reports/MonthlyReport.class.php', '1c81b2d79cf5bf11c4e6a91fe8caea63');
        $this->checkFile('include/Pap/Mail/Reports/Report.class.php', '8d34b8c6ebc62e799c490991cfc230c8');
        $this->checkFile('include/Pap/Mail/Reports/ReportsSendTask.class.php', '1365e936b7791fc6a9a9690ac39101d7');
        $this->checkFile('include/Pap/Mail/Reports/TransactionsList.class.php', '1b4fdd18c3c52d6461a816e85052b8de');
        $this->checkFile('include/Pap/Mail/Reports/TransactionsListProvider.class.php', 'a869fd0c67e4722de98333bd0ce00291');
        $this->checkFile('include/Pap/Mail/Reports/WeeklyReport.class.php', '9a43574f8e558a0343d0505c366f2a69');
        $this->checkFile('include/Pap/Mail/SaleMail.class.php', '0a75117341a67c446cd481746ec9208e');
        $this->checkFile('include/Pap/Mail/SendMailToAffiliate.class.php', 'c2adbcf4aac6ac6792949ada0c467ef4');
        $this->checkFile('include/Pap/Mail/SendMassMail.class.php', '65284c6c1030a8078e7f8fe3510e7142');
        $this->checkFile('include/Pap/Mail/SendTaskBase.class.php', 'ac80483788e93e3023876c65fd8534a8');
        $this->checkFile('include/Pap/Mail/SentMailTemplatesGridAffiliate.class.php', '23d65b43ecf146957a45918b2b7bab7a');
        $this->checkFile('include/Pap/Mail/SplitCommissionsMerchantOnSale.class.php', 'ca10d989fedf67fbccaae943591ce5a3');
        $this->checkFile('include/Pap/Mail/Template.class.php', '9d9d334152b98a6d164756519fe1f8ff');
        $this->checkFile('include/Pap/Mail/UserMail.class.php', 'a383b16595ed34f1bf9dea28e09dccf2');
        $this->checkFile('include/Pap/Merchant.class.php', '3755f51d6266303c1ab65ed0e5eb3aec');
        $this->checkFile('include/Pap/MerchantLogin.class.php', '5737810ae52293664bb646b05d5e790b');
        $this->checkFile('include/Pap/Merchants/ApplicationGadgets/PendingTasksGadgets.class.php', '9ed6536ee41955f546261038a23ab79e');
        $this->checkFile('include/Pap/Merchants/ApplicationSettings.class.php', '10abf48ffe732daa0c2512afeaba5166');
        $this->checkFile('include/Pap/Merchants/Banner/BannerForm.class.php', '1af6c93006b70215a3b79bc57e2d41ad');
        $this->checkFile('include/Pap/Merchants/Banner/BannerUpload.class.php', '29e18b6f50adaf670a42bc99e29170bd');
        $this->checkFile('include/Pap/Merchants/Banner/BannersGrid.class.php', 'f6e1170a0e9636fd9ad17fdc334dc34f');
        $this->checkFile('include/Pap/Merchants/Banner/BannersImportExport.class.php', 'c8eac986141587ce58a697e2ae561c8f');
        $this->checkFile('include/Pap/Merchants/Banner/BannersInfoData.class.php', '1aac6739ae0d68828f93f60c6e8d6edc');
        $this->checkFile('include/Pap/Merchants/Banner/BannersStatsGrid.class.php', '535eee0818d1df29a28cdf6cfa141afa');
        $this->checkFile('include/Pap/Merchants/Banner/ComplexListBox.class.php', '50dab75a380b58a5d6b321582b4f6072');
        $this->checkFile('include/Pap/Merchants/Banner/FlashUpload.class.php', '47c33d4c74f3faeea9cbdd5d0a2825c5');
        $this->checkFile('include/Pap/Merchants/Banner/ListBox.class.php', 'c5275bb36f12e98b88430d9d56065a53');
        $this->checkFile('include/Pap/Merchants/Campaign/ActionCodeValidator.class.php', '65f7b9b410cc45e604223583afba1bbe');
        $this->checkFile('include/Pap/Merchants/Campaign/AffChannelSearchRichListBox.class.php', 'ad1fa97a5227c7ced869f6b3b28fcff0');
        $this->checkFile('include/Pap/Merchants/Campaign/CampaignDetailsAdditionalForm.class.php', 'e1a17360b88f5fd3d52de165b285dcf5');
        $this->checkFile('include/Pap/Merchants/Campaign/CampaignForm.class.php', '579282e10e6d1b44b3205a32bbfae005');
        $this->checkFile('include/Pap/Merchants/Campaign/CampaignsGrid.class.php', '2c09a1a19bca158fedceae4d9f8969c4');
        $this->checkFile('include/Pap/Merchants/Campaign/CampaignsImportExport.class.php', 'b7971560649be268460a3bcbaf8acc82');
        $this->checkFile('include/Pap/Merchants/Campaign/CampaignsInfoData.class.php', '406832f225b634e5cb3838f4a1c5e1e7');
        $this->checkFile('include/Pap/Merchants/Campaign/CampaignsStatsGrid.class.php', '99c4f797fb766e90154e5d7817536c01');
        $this->checkFile('include/Pap/Merchants/Campaign/ChannelSearchRichListBox.class.php', '537056220b53371bd370b64c930d5d62');
        $this->checkFile('include/Pap/Merchants/Campaign/CommissionGroups.class.php', '52620faf31fd7cb1697d8203179a0d7e');
        $this->checkFile('include/Pap/Merchants/Campaign/CommissionTypeEditAdditionalForm.class.php', '650af76c510a89c48907f4ff638b998c');
        $this->checkFile('include/Pap/Merchants/Campaign/CommissionTypeForm.class.php', 'ff69abf26db5936ee5f534a949cf934d');
        $this->checkFile('include/Pap/Merchants/Campaign/CommissionTypeRpcForm.class.php', 'e16ef35fa396164ca3124ffb3a36d8c5');
        $this->checkFile('include/Pap/Merchants/Campaign/Commissions.class.php', 'a8b4ea3b691aea8009f2883bd58c7143');
        $this->checkFile('include/Pap/Merchants/Campaign/CommissionsImportExport.class.php', '918cf361392eb1409a844bf865903473');
        $this->checkFile('include/Pap/Merchants/Campaign/CommissionsInfoData.class.php', 'dcb083a44b0ebefdf4bd6b99de47e55a');
        $this->checkFile('include/Pap/Merchants/Config/AffEmailNotificationsForm.class.php', '475a95d028a3b05b0d89d463731fe8e0');
        $this->checkFile('include/Pap/Merchants/Config/Affiliate/CampaignsGridSettignsForm.class.php', '40de7a302b7f0052bcea02e55bb8614a');
        $this->checkFile('include/Pap/Merchants/Config/Affiliate/SubAffiliatesTreeFilterForm.class.php', '2b96721134ad0a4f125027e5392163f6');
        $this->checkFile('include/Pap/Merchants/Config/AffiliateFieldsForm.class.php', '8cd998906721ad067443a1c7e73fdb02');
        $this->checkFile('include/Pap/Merchants/Config/AffiliateFormDefinition.class.php', 'e19f05ed9d5bf7e1b72baf48a00ca344');
        $this->checkFile('include/Pap/Merchants/Config/AffiliateGeneralSettingsForm.class.php', 'a7e61c5de1c71871c6391017805ac2cd');
        $this->checkFile('include/Pap/Merchants/Config/AffiliatePanel.class.php', 'bd3ed8d30f90058953ed61c210278419');
        $this->checkFile('include/Pap/Merchants/Config/AffiliateScreensListBox.class.php', '2fcf7c81502a8d9965f3a754f0affa62');
        $this->checkFile('include/Pap/Merchants/Config/AffiliateSignupForm.class.php', 'a3d5afae7706fbd4d1802de6693ed191');
        $this->checkFile('include/Pap/Merchants/Config/AutoDeleteRawClicksValidator.class.php', '9e465a60848dba96f12b6ebf665ce0f4');
        $this->checkFile('include/Pap/Merchants/Config/BannerWrapperService.class.php', 'e6bdc6c0d452f5c6c8abf95f06c4609b');
        $this->checkFile('include/Pap/Merchants/Config/BannersFormatForm.class.php', '634c08a394d76f0ba52c98fce8eeb4c3');
        $this->checkFile('include/Pap/Merchants/Config/ConfigFieldsForm.class.php', '0b427f4104686f0f0642428908cff927');
        $this->checkFile('include/Pap/Merchants/Config/CookiesForm.class.php', '29a5dd67a4fc06d22b5ee4bb7c281a6b');
        $this->checkFile('include/Pap/Merchants/Config/CreateNewTheme.class.php', '06f35b1089aef7a99cfc3e0869aea2e1');
        $this->checkFile('include/Pap/Merchants/Config/CurrencyForm.class.php', '2b2d3dc9cda977a6deeeeb355cc1a4fd');
        $this->checkFile('include/Pap/Merchants/Config/DeeplinkGeneratorForm.class.php', '50f86c42e79d8958f03746586d227991');
        $this->checkFile('include/Pap/Merchants/Config/DeleteClicksTask.class.php', '0a83bb3d2d0467837ea12966ff1166b0');
        $this->checkFile('include/Pap/Merchants/Config/DynamicFormDefinition.class.php', '34a8b7925642ec3c90e9b5da202f6f9b');
        $this->checkFile('include/Pap/Merchants/Config/EmailNotificationsForm.class.php', '86b4ff74e3dd3fb4079f7362ca6ae580');
        $this->checkFile('include/Pap/Merchants/Config/EmailNotificationsFormBase.class.php', 'a17f6f8acefa32f9512d8970cadda122');
        $this->checkFile('include/Pap/Merchants/Config/FraudprotectionClicksForm.class.php', '4e73efd3d210fc3263d70217ea169843');
        $this->checkFile('include/Pap/Merchants/Config/FraudprotectionLoginsForm.class.php', '8891e9271d59f06ab0905a55b0c3f75f');
        $this->checkFile('include/Pap/Merchants/Config/FraudprotectionSalesForm.class.php', 'e15abc283b7895c846a50de5c0b677f9');
        $this->checkFile('include/Pap/Merchants/Config/FraudprotectionSignupsForm.class.php', 'cc77f16cc2de0b571e704c504bc659fb');
        $this->checkFile('include/Pap/Merchants/Config/LoggingForm.class.php', '88b22560967344274a5fe80bd64a31f0');
        $this->checkFile('include/Pap/Merchants/Config/MerchantForm.class.php', '494cdda9bd6fefa1a6ead5576670810b');
        $this->checkFile('include/Pap/Merchants/Config/MerchantFormDefinition.class.php', 'a80994a4022c823a889e3aaab71ede07');
        $this->checkFile('include/Pap/Merchants/Config/ParameterNamesForm.class.php', '380e0626c916efd6fafcc1a3c35bde9d');
        $this->checkFile('include/Pap/Merchants/Config/SignupCommissions.class.php', 'bb7e5eff510584c76b10a3fd79494e5c');
        $this->checkFile('include/Pap/Merchants/Config/ThemeEditor.class.php', '54d5422aa32626e7dc2a7ef04c2444f8');
        $this->checkFile('include/Pap/Merchants/Config/ThemesConfig.class.php', 'de695adbcb1fa03daafeb31a4372a75c');
        $this->checkFile('include/Pap/Merchants/Config/ThemesImportExport.class.php', '465b254e7b72a19a16da3d195ea90a44');
        $this->checkFile('include/Pap/Merchants/Config/TrackingAutoDeleteWithRepeatingClicksValidator.class.php', '940a67079a98d4af6e35974b036fc4d0');
        $this->checkFile('include/Pap/Merchants/Config/TrackingForm.class.php', '670e07168e0fa9824503bf5e1d266a7b');
        $this->checkFile('include/Pap/Merchants/Filters.class.php', 'b77cea3e86a026b833c1a5a7bd975854');
        $this->checkFile('include/Pap/Merchants/HomeData.class.php', 'a991e8a471c0a3b2d9ac9082a16a7b0a');
        $this->checkFile('include/Pap/Merchants/Menu.class.php', '62f8e9b89a8a6e53f534250b4f29b847');
        $this->checkFile('include/Pap/Merchants/Payout/AffiliateWithVatRichListBox.class.php', 'f139e20f39643a331d0080cfc0580dba');
        $this->checkFile('include/Pap/Merchants/Payout/DisplayInvoice.class.php', '5123204e5488b5b1d06c07745cce0d2a');
        $this->checkFile('include/Pap/Merchants/Payout/GeneralSettingsForm.class.php', '8373b0849291e986ea190a436c84839e');
        $this->checkFile('include/Pap/Merchants/Payout/InvoiceFormatForm.class.php', '127a8faa43629bc7673c95577b110d1a');
        $this->checkFile('include/Pap/Merchants/Payout/PaidTransactions.class.php', 'dcf52e57f02c6c070d32375518e881cd');
        $this->checkFile('include/Pap/Merchants/Payout/PayAffiliateData.class.php', 'abc5f2e0a429447dad26820c0f01f873');
        $this->checkFile('include/Pap/Merchants/Payout/PayAffiliatesForm.class.php', '92e9d6ae22ff13657411382250c2a712');
        $this->checkFile('include/Pap/Merchants/Payout/PayAffiliatesFormExportGrid.class.php', '520eb379933458bfba230e7a61cf4ea1');
        $this->checkFile('include/Pap/Merchants/Payout/PayAffiliatesGrid.class.php', '6435359ae698eb00afb71543153a0419');
        $this->checkFile('include/Pap/Merchants/Payout/PayAffiliatesTask.class.php', 'e501ac2252d58a0f29b3752f8d68f752');
        $this->checkFile('include/Pap/Merchants/Payout/PayeesGrid.class.php', 'e801d9bb0af78161d4180774ae4d436f');
        $this->checkFile('include/Pap/Merchants/Payout/PayoutData.class.php', '84585ee4109e9c7dfcea7de16e322904');
        $this->checkFile('include/Pap/Merchants/Payout/PayoutGridBase.class.php', '16606e44a9de4889a9b458a539a6374b');
        $this->checkFile('include/Pap/Merchants/Payout/PayoutHistoryForm.class.php', 'dc2be7f69fe4db0b544a6595ada3762e');
        $this->checkFile('include/Pap/Merchants/Payout/PayoutOptionsFields.class.php', '52f82b5498946761638199184189291f');
        $this->checkFile('include/Pap/Merchants/Payout/PayoutOptionsGrid.class.php', 'd9f89b89a5a28adfa515a93083b52ae2');
        $this->checkFile('include/Pap/Merchants/Payout/PayoutOptionsGridForm.class.php', 'afcae1f4efb140cd4050e7a902f7c116');
        $this->checkFile('include/Pap/Merchants/Payout/PayoutsHistoryGrid.class.php', '6d033a4de43e53b0cedafbe4b564849d');
        $this->checkFile('include/Pap/Merchants/Payout/PayoutsInfoData.class.php', 'ed1c77ec5e3ae08bf9084e47bfa36792');
        $this->checkFile('include/Pap/Merchants/Payout/PayoutsToAffiliatesGrid.class.php', '6e2c7fa69dc77a8e094b4f93aa2723e6');
        $this->checkFile('include/Pap/Merchants/Payout/SumPayoutsToAffiliatesGrid.class.php', '552f8353b78e1d3d2cfe8139c0f60f19');
        $this->checkFile('include/Pap/Merchants/Payout/VatHandlingForm.class.php', 'c0022bc4b9409db19a6a61bd50a950a0');
        $this->checkFile('include/Pap/Merchants/PayoutOptionListBox.class.php', 'f69b004e39748979d30fab8e50b0c39d');
        $this->checkFile('include/Pap/Merchants/Reports/AffiliateTree.class.php', 'b2815ae874765564a9b23e60b321f1e9');
        $this->checkFile('include/Pap/Merchants/Reports/ClicksGrid.class.php', '29059c39900d26043dd6dfcc9acef410');
        $this->checkFile('include/Pap/Merchants/Reports/QuickReportData.class.php', '360b6f8d5933dd4723a1acc8c7b93976');
        $this->checkFile('include/Pap/Merchants/Reports/QuickReportDataMultiTier.class.php', '9aae7f538e4a2b3c86204e15c555422e');
        $this->checkFile('include/Pap/Merchants/Reports/QuickReportDataTransactionsSum.class.php', '01d3e3a159f7c59af23667711f5652d7');
        $this->checkFile('include/Pap/Merchants/Reports/TrafficStatsData.class.php', '480416cb0a04543540c0a8697e928333');
        $this->checkFile('include/Pap/Merchants/Reports/TransactionReportsForm.class.php', 'd5757a3742be4aec97ea3331ba46843e');
        $this->checkFile('include/Pap/Merchants/Reports/TrendsReportActionWidget.class.php', '19ea4c4114f18c0d6116757560f84861');
        $this->checkFile('include/Pap/Merchants/Reports/TrendsReportWidget.class.php', '95e13d9a459ce17564c36afbe4594011');
        $this->checkFile('include/Pap/Merchants/Tools/CronJobIntegration.class.php', '50e5e020fa334c00ff224aabc78f33cc');
        $this->checkFile('include/Pap/Merchants/Tools/DatabaseStatusGrid.class.php', '51a30db3ac0e79f856c7d3b4eb5443a6');
        $this->checkFile('include/Pap/Merchants/Tools/GettingStarted.class.php', '34cd7b775f0ba66936ed21e6a907e196');
        $this->checkFile('include/Pap/Merchants/Tools/IntegrationMethods.class.php', 'f725850f2a4552ce713627d3cf303e50');
        $this->checkFile('include/Pap/Merchants/Tools/NewsForm.class.php', '19acd3c352074d9270c6093a95c56678');
        $this->checkFile('include/Pap/Merchants/Tools/NewsGrid.class.php', '1c4292808ec770287500aca542e0746e');
        $this->checkFile('include/Pap/Merchants/Tools/ObjectsImportCache.class.php', '28ca28b9892523f75ee28ff730018ab4');
        $this->checkFile('include/Pap/Merchants/Tools/ObjectsImportTask.class.php', '1f8ce24c44d3f7550473abdd526262ec');
        $this->checkFile('include/Pap/Merchants/Tools/ReportProblem.class.php', '2a82826f716c2fbb0723e74b5e98e8c9');
        $this->checkFile('include/Pap/Merchants/Tools/ViewsForm.class.php', '82bf80dc822c00237c8f8ea61296fe37');
        $this->checkFile('include/Pap/Merchants/Tools/ViewsGrid.class.php', '8c2ac278ec6e1cd2000988b1b2424565');
        $this->checkFile('include/Pap/Merchants/Tools/ViewsListBox.class.php', '4f008a4f3a5094ab1b0c8ba8d9565db9');
        $this->checkFile('include/Pap/Merchants/Tools/VisitorAffiliatesForm.class.php', 'd2689088cf2bcd66dea56dfef867352b');
        $this->checkFile('include/Pap/Merchants/Tools/VisitorAffiliatesGrid.class.php', 'f44a9a4bdef75fd3715aff618396e253');
        $this->checkFile('include/Pap/Merchants/Tools/VisitorNonrefClicksGrid.class.php', '3292c8fba3d99048597e3bb9d72c818e');
        $this->checkFile('include/Pap/Merchants/Tools/VisitsSalesLogDeleteTask.class.php', '0dc45c0381fa031198c321c0bcecebde');
        $this->checkFile('include/Pap/Merchants/Tools/VisitsSalesLogsForm.class.php', '232a95c8913891efe90a9a701f4058b5');
        $this->checkFile('include/Pap/Merchants/Tools/VisitsSalesLogsGrid.class.php', '04543fb3080bedce8c05cc61fea11757');
        $this->checkFile('include/Pap/Merchants/TopReferrerUrlGrid.class.php', '7bdc89b4c46fca26c4d74a5d24679754');
        $this->checkFile('include/Pap/Merchants/TopReferrerUrlStatsGrid.class.php', '67da940bbcfbfc2c94946abc40ebd0a0');
        $this->checkFile('include/Pap/Merchants/TopUrlGrid.class.php', '8bba2ef93e0b41258f65ddfe7e9afe8a');
        $this->checkFile('include/Pap/Merchants/Transaction/TransactionLogs.class.php', '066a1bb7929f21b47b924a572f3fa2ad');
        $this->checkFile('include/Pap/Merchants/Transaction/TransactionsForm.class.php', '5ed21ed260538b3bd18db3f70f11dd4e');
        $this->checkFile('include/Pap/Merchants/Transaction/TransactionsGrid.class.php', '63e408f6602cb6a64ad24a8e4d1cca20');
        $this->checkFile('include/Pap/Merchants/Transaction/TransactionsImportForm.class.php', '3ea8a9b9f8870b0d894d3115c9e39749');
        $this->checkFile('include/Pap/Merchants/Transaction/TransactionsImportTask.class.php', 'f105247a0389e743f8ce73f7af8436eb');
        $this->checkFile('include/Pap/Merchants/Transaction/TransactionsInfoData.class.php', '4b8b51c020aad7947cdf5798a6315177');
        $this->checkFile('include/Pap/Merchants/User/AffiliateForm.class.php', '5e84bb339f45e4fa52a70ab3a383a401');
        $this->checkFile('include/Pap/Merchants/User/AffiliateInfoData.class.php', 'bef58a8921d8d97cc353197458de870b');
        $this->checkFile('include/Pap/Merchants/User/AffiliateLoginsGrid.class.php', '430d2d732a8237fcdf95805d27b97548');
        $this->checkFile('include/Pap/Merchants/User/AffiliatesGrid.class.php', '350f28de011a6e399c178eaec5034e7c');
        $this->checkFile('include/Pap/Merchants/User/AffiliatesGridSimple.class.php', 'deab4728d0040411b5ea79943ef68620');
        $this->checkFile('include/Pap/Merchants/User/AffiliatesImportExport.class.php', '4d07447736b65c956b927c3a8f263e73');
        $this->checkFile('include/Pap/Merchants/User/AffiliatesImportForm.class.php', 'd6123bedb4787e6f56858753cb24981d');
        $this->checkFile('include/Pap/Merchants/User/AffiliatesImportTask.class.php', '104fdfea300c29b4720e6f26e08cfecb');
        $this->checkFile('include/Pap/Merchants/User/DirectLinksForm.class.php', 'e45c734b05a94e4233daf246e12918fe');
        $this->checkFile('include/Pap/Merchants/User/DirectLinksGrid.class.php', '33b1f830fea2f58c304df9357c35e49c');
        $this->checkFile('include/Pap/Merchants/User/TopAffiliatesGrid.class.php', '597f2e3ca7b566884d28930da25e48f0');
        $this->checkFile('include/Pap/Merchants/User/UserAttributesImportExport.class.php', '9471fb39967fb59e58aacc250e4dc2b2');
        $this->checkFile('include/Pap/Merchants/User/UserDirectLinksGrid.class.php', '4037884671832682d7853e83052fe758');
        $this->checkFile('include/Pap/Merchants/User/UserInCommisionGroupsGrid.class.php', '6c34d763a757ebb590df763499106a13');
        $this->checkFile('include/Pap/Merchants/User/UserInCommisonGroupsForm.class.php', 'f0b93e8bba197a42ecec3bb9664197a1');
        $this->checkFile('include/Pap/Merchants/User.class.php', '2c0c0b40d2028d1bf0321cc2998777bc');
        $this->checkFile('include/Pap/Merchants/UserForm.class.php', '224aca9e8628f43536eeaeb8c45bb8cb');
        $this->checkFile('include/Pap/Mobile/AndroidPush.class.php', '2dc97f957abd3cef5ad67249a4d5f52e');
        $this->checkFile('include/Pap/Mobile/ApplePush.class.php', '876f1914fd2c439b92d7a8e3beaadfa0');
        $this->checkFile('include/Pap/Mobile/Main.class.php', '90661379202d77f280d2231cb4ca5c59');
        $this->checkFile('include/Pap/Mobile/MobileNotification.class.php', '01a72ee1870e1b72d7b20826b3dc1881');
        $this->checkFile('include/Pap/Mobile/NotificationTask.class.php', '1efd7bc3ad72ec641281fa6a3d2077d0');
        $this->checkFile('include/Pap/Mobile/Response.class.php', 'a0ee39a841055a531f199c6f8f9623a3');
        $this->checkFile('include/Pap/Mobile/ResponseManager.class.php', '6174393e677bcce6210bd6152cfa324e');
        $this->checkFile('include/Pap/Mobile/apns-prod.pem', '8ac346594ac6e1686869590fb0064a7a');
        $this->checkFile('include/Pap/Mobile/cacert.pem', '68ba72f273dc654217a0583e704dc99c');
        $this->checkFile('include/Pap/Model/ApiKey.class.php', 'c2482ac435cf2e91ecc739add3ac3580');
        $this->checkFile('include/Pap/Model/CampaignRule.class.php', '6188c10ae013968ae31e2aa8d0e7a3da');
        $this->checkFile('include/Pap/Model/Impressions.class.php', '04571c5b033f2f70cae05e9dfe8578e1');
        $this->checkFile('include/Pap/Model/ImpressionsDb.class.php', '1b14f0ec693fab97d7b9d9eb1b999183');
        $this->checkFile('include/Pap/Model/PerformanceRule.class.php', '3ec717c51ba9c298939963d007be8797');
        $this->checkFile('include/Pap/Model/RateLimitHandler.class.php', '4b502e37c73561885bd3dd17e3427e06');
        $this->checkFile('include/Pap/Model/RateLimiterDb.class.php', 'ddd30ba956fe8ab594ecf3ac9a28fbc7');
        $this->checkFile('include/Pap/Model/Rule.class.php', 'eb0379ee61d2b14ed41e65df429ba530');
        $this->checkFile('include/Pap/Model/Visits.class.php', 'a3f2786dae8fb32260e5d7ea154eac79');
        $this->checkFile('include/Pap/Model/VisitsDb.class.php', '0817bc7f8d3ae7403961d514c2cb3b27');
        $this->checkFile('include/Pap/Module.class.php', 'f8c9c946e4327874d8dfa6a561b50be2');
        $this->checkFile('include/Pap/Perf/PerfTracking.class.php', '5a1840a10b688965d9ca6bb97116f86d');
        $this->checkFile('include/Pap/Perf/Redis/Impressions.class.php', 'aeeb4982efcb04722572aa224d199e28');
        $this->checkFile('include/Pap/Perf/Redis/ImpressionsIterator.class.php', 'e681684c11607ea089453bde17991a28');
        $this->checkFile('include/Pap/Perf/Redis/RateLimiter.class.php', '1b8200caca7e3c38037e9292e6a2b9a8');
        $this->checkFile('include/Pap/Perf/Redis/Visits.class.php', 'ff628cb51532498da43196ccf070b3ca');
        $this->checkFile('include/Pap/Plugins/Definition.class.php', '5411f2ae70376d2584790a87ea3ec868');
        $this->checkFile('include/Pap/Plugins/Features.class.php', '516ec6f150282ce70c3b84521f76e424');
        $this->checkFile('include/Pap/PrivilegedUser.class.php', 'e2440601285c05cec583692f2059a0a4');
        $this->checkFile('include/Pap/Privileges/Affiliate.class.php', '32782330fa05d9b50c9107880021f44c');
        $this->checkFile('include/Pap/Privileges/Merchant.class.php', '2fd465b35d8cf3606daa97988b28d861');
        $this->checkFile('include/Pap/Privileges.class.php', 'a63179ea4b850b4eddde07a22cf8cac3');
        $this->checkFile('include/Pap/Redis/Client.class.php', '9ab512614832ada852a008025ca9accd');
        $this->checkFile('include/Pap/Settings.class.php', '7300931af8302769edc22a8146addfb9');
        $this->checkFile('include/Pap/Signup/AffiliateForm.class.php', 'cbe9965fb998b317401914a545887723');
        $this->checkFile('include/Pap/Signup/ContactUsForm.class.php', '36cb6d38dc6fca58c57affa8a23f1bbf');
        $this->checkFile('include/Pap/Signup/FraudProtection.class.php', 'e8380b7c3fd31f6abac1d28e49f02231');
        $this->checkFile('include/Pap/Signup/MerchantInfo.class.php', '44e646f564c8d24e100a285c5ff91a92');
        $this->checkFile('include/Pap/Signup/PayoutOptionListBox.class.php', '3233c76e209ef2d3088d7fd4b03426a7');
        $this->checkFile('include/Pap/Signup/SendEmailToUser.class.php', '2d70804fdc1b3034d6df2403af7b26d1');
        $this->checkFile('include/Pap/Signup/SendNotificationEmails.class.php', '2706268f0456d59f5543754765004f9c');
        $this->checkFile('include/Pap/Signup/SignupFormContext.class.php', 'a3b77feb064535065205035aaa34ec86');
        $this->checkFile('include/Pap/Signup.class.php', '4830907f3404362b768d8a399a38016b');
        $this->checkFile('include/Pap/SignupBase.class.php', '4dcb8d925aa3b1e0ecd40390c95c50e8');
        $this->checkFile('include/Pap/SmartyPlugins/function.ratio.php', '648329caddd643afc8baeca04b0aad83');
        $this->checkFile('include/Pap/SmartyPlugins/function.ratioPercentage.php', 'e54e0ab2bb617368fc4436e03345dfd3');
        $this->checkFile('include/Pap/SmartyPlugins/modifier.currency.php', '37e15909d53983c7558c1a9348aa3645');
        $this->checkFile('include/Pap/SmartyPlugins/modifier.currency_span.php', '985cfeac0001a78e20034cf42363573a');
        $this->checkFile('include/Pap/Stats/Actions.class.php', '8cc96491480abb57f19619d65323b055');
        $this->checkFile('include/Pap/Stats/Base.class.php', 'e0afeceb1e3ab0a7e4704ed4f6089fb6');
        $this->checkFile('include/Pap/Stats/Chargebacks.class.php', '6ff7c7597a9d6f35d68a2cfe46065227');
        $this->checkFile('include/Pap/Stats/Clicks.class.php', '49322a6f93665f3269182bf7d98e5e3f');
        $this->checkFile('include/Pap/Stats/Computer/Base.class.php', '6b26f0326518ffd2e5030e9a5ae1cc61');
        $this->checkFile('include/Pap/Stats/Computer/Clicks.class.php', 'd4caddd07e52e9094cc1cf031e34495d');
        $this->checkFile('include/Pap/Stats/Computer/Graph/Base.class.php', 'a5a8ef193fae99c3f9b7198e6d1008ff');
        $this->checkFile('include/Pap/Stats/Computer/Graph/Clicks.class.php', '6b43f0185fe2ad91a5bd50b5def3b468');
        $this->checkFile('include/Pap/Stats/Computer/Graph/Impressions.class.php', '20ba19b158636ffba39eb92aa605ed62');
        $this->checkFile('include/Pap/Stats/Computer/Graph/Transactions.class.php', 'b9513a16d606ef7316863d31bb0a1e9d');
        $this->checkFile('include/Pap/Stats/Computer/Impressions.class.php', '7c6ec06adfe33e19c28c7f1bfe1d59ec');
        $this->checkFile('include/Pap/Stats/Computer/RefundChargeback.class.php', '5661f38210020afe49fe6b10a7dfb536');
        $this->checkFile('include/Pap/Stats/Computer/StatsBuilderBase.class.php', 'e0a365476964de5d8134920d332a3cb7');
        $this->checkFile('include/Pap/Stats/Computer/Transactions.class.php', '8ea2ad6ae8eca0818667326b08fc9d99');
        $this->checkFile('include/Pap/Stats/Computer/TransactionsBase.class.php', 'd4e73ae5f89798327ddce57f70bbe5e5');
        $this->checkFile('include/Pap/Stats/Computer/TransactionsGrouped.class.php', 'a4bdf43668db05c99e2eaf28f98e07ba');
        $this->checkFile('include/Pap/Stats/Computer/TransactionsGroupedAff.class.php', '3871a52caffb5094914d1e61ff67d649');
        $this->checkFile('include/Pap/Stats/Computer/TransactionsHigherTiers.class.php', '530a4f5dc3c249d7acce2a9673cc1863');
        $this->checkFile('include/Pap/Stats/Computer/TransactionsStatsBuilder.class.php', '11738b709d4e651eecd5d8fa3fed1797');
        $this->checkFile('include/Pap/Stats/Computer/TransactionsStatsBuilderContext.class.php', '6f669e3fdb2b89c4c9cba3be71051d07');
        $this->checkFile('include/Pap/Stats/Data/Click.class.php', '025f1576b2307c46145c2e8e5f4406fc');
        $this->checkFile('include/Pap/Stats/Data/Commission.class.php', 'a97f7ca2280b4d7fde1bef68ea84b928');
        $this->checkFile('include/Pap/Stats/Data/Impression.class.php', 'ca9bf03034fac8f149ac2007800b5d59');
        $this->checkFile('include/Pap/Stats/Data/Object.class.php', '884318d63b6b6d39d50cfa96e1f876e0');
        $this->checkFile('include/Pap/Stats/GroupOldClicksTask.class.php', '51a44402ede60fd0078e5a467e6d6312');
        $this->checkFile('include/Pap/Stats/GroupOldImpressionsTask.class.php', '4e73cef7a162a08a5d9494fa2873c7e8');
        $this->checkFile('include/Pap/Stats/GroupOldStatsTask.class.php', '8184adbcc3cb31ea01be132d2af58fcb');
        $this->checkFile('include/Pap/Stats/Impressions.class.php', '3cd921cee5d2a55988c3dab165adf33f');
        $this->checkFile('include/Pap/Stats/Params.class.php', 'b39b3da0b3fbdf0d91dfff90ae333629');
        $this->checkFile('include/Pap/Stats/ParentAffiliate.class.php', '3b3a42f23a91c79a431bc75b01f86cb0');
        $this->checkFile('include/Pap/Stats/Recurring.class.php', 'f1675e66442c059e670363d6e9c7f1dd');
        $this->checkFile('include/Pap/Stats/RefundChargeback.class.php', '58d507813be68cf9fb5e5acb43d3a05f');
        $this->checkFile('include/Pap/Stats/Refunds.class.php', '9234cb6d47eafe25118de5ba9ddf5b4d');
        $this->checkFile('include/Pap/Stats/Sales.class.php', '84d6dc3153194c3481a2db8c411b7f4d');
        $this->checkFile('include/Pap/Stats/SalesHigherTiers.class.php', '23e3a23c8ca698c4e3dbcffaa00195d0');
        $this->checkFile('include/Pap/Stats/StatsSelectContext.class.php', '7016065a0c8673d0531f536318b3152e');
        $this->checkFile('include/Pap/Stats/Table.class.php', '9a6ca4e2eaab5239c431ad9c72d70840');
        $this->checkFile('include/Pap/Stats/Trans/SalesStats.class.php', '39db5babb8f148ebd73b2b87be8a313d');
        $this->checkFile('include/Pap/Stats/Trans/SalesStatsProcessorTask.class.php', '21580da7d087870a24631bb8dee9c915');
        $this->checkFile('include/Pap/Stats/Trans/SalesStatsProcessorUserTask.class.php', 'b78ff39524e55d9777e79dbd930beb23');
        $this->checkFile('include/Pap/Stats/Trans/SalesStatsReferrerUrlsProcessorTask.class.php', '60e19ae5d3f0272f4bc462a3580ca3f2');
        $this->checkFile('include/Pap/Stats/TransactionTypeStats.class.php', 'fd088392beb66a8cb3880450cb7b67db');
        $this->checkFile('include/Pap/Stats/TransactionTypeStatsFirstTier.class.php', '5639370ba43f593cf001b406a3400836');
        $this->checkFile('include/Pap/Stats/TransactionTypeStatsHigherTiers.class.php', '58c46491e4acd235514212df64324e5f');
        $this->checkFile('include/Pap/Stats/TransactionTypes.class.php', 'f6b3973bb2098765ac06c91e9b040495');
        $this->checkFile('include/Pap/Stats/Transactions.class.php', '98f221df95ac9a074dd96b579b1c15c9');
        $this->checkFile('include/Pap/Stats/TransactionsFirstTier.class.php', '4b0f916fe779ad25fc94bd9a48ed7ac4');
        $this->checkFile('include/Pap/Stats/TransactionsHigherTiers.class.php', 'be705fe87b0c024c369413fa5232137b');
        $this->checkFile('include/Pap/Tasks/ChangeCommissionStatus.class.php', '90ba60198ce9a570d4a8b026520dfc51');
        $this->checkFile('include/Pap/Tasks/CopyTemplatesToDbTask.class.php', 'c406325fb4e1bdd271310b470c604f6b');
        $this->checkFile('include/Pap/Tasks/DeleteReferrerUrlsTask.class.php', 'b1e4633f143c9cfe5c068bd60fbafaad');
        $this->checkFile('include/Pap/Tasks/DeleteUseragentsTask.class.php', 'ad95b00225d7c1cfa2dcae355d36ad46');
        $this->checkFile('include/Pap/Tasks/MoveReferrerUrlsClicksTask.class.php', 'a6d4280dbe9459009d71db8b5b60d369');
        $this->checkFile('include/Pap/Tasks/MoveReferrerUrlsVisitorAffiliatesTask.class.php', 'a5d421e562121d35aaffb2497471af46');
        $this->checkFile('include/Pap/Tasks/MoveReferrerUrlsVisitorNonrefClicksTask.class.php', 'b339a94755064c8ea14d229dc8e0ae8a');
        $this->checkFile('include/Pap/Tasks/MoveTrafficToRedis.class.php', '7d78990b21b6c84cf555f1b542ace0c7');
        $this->checkFile('include/Pap/Tasks/SetParentToAffiliate.class.php', '4b65a09623de7c71df207753b4db7dc0');
        $this->checkFile('include/Pap/Tasks/TaskCreatedException.class.php', '14c00f30a37f538f64a0c60696fae916');
        $this->checkFile('include/Pap/Tasks/UpdateUserTreeTask.class.php', '1341618935e5f7578d1a7af7ce09db17');
        $this->checkFile('include/Pap/Tracking/Action/ActionProcessor.class.php', '7e7eb7f89a09079d071b22c0a176d5ce');
        $this->checkFile('include/Pap/Tracking/Action/ActionRecognizers.class.php', '5e47115a4b418586ee0018903387fc41');
        $this->checkFile('include/Pap/Tracking/Action/ComputeCommissions.class.php', 'f8a38974e9bb2c50f1f24daa529a0d38');
        $this->checkFile('include/Pap/Tracking/Action/ComputeStatus.class.php', 'e16668dec462c026bb92d831f46c7b17');
        $this->checkFile('include/Pap/Tracking/Action/FraudProtection.class.php', '784d163c57806ead987584e6e367a1bf');
        $this->checkFile('include/Pap/Tracking/Action/RecognizeAffiliate.class.php', '091a80b3bcbedbaa191ca2d2f297b180');
        $this->checkFile('include/Pap/Tracking/Action/RecognizeBanner.class.php', '8cec168a52590a7d0b0284b8846c972a');
        $this->checkFile('include/Pap/Tracking/Action/RecognizeCampaign.class.php', '85a75ad2192d983729696ff31236355f');
        $this->checkFile('include/Pap/Tracking/Action/RecognizeCampaignIdByProductId.class.php', '25bbc392c6ac38e03fa7ebebdf32e48b');
        $this->checkFile('include/Pap/Tracking/Action/RecognizeChannel.class.php', 'ced8b0b23e737ad08c60564f9bc7dc74');
        $this->checkFile('include/Pap/Tracking/Action/RecognizeCommType.class.php', '4a371a617011f028824d1b4d1c659f57');
        $this->checkFile('include/Pap/Tracking/Action/RecognizeCurrency.class.php', 'a2cb35e57ab2209956cb74af49b24da9');
        $this->checkFile('include/Pap/Tracking/Action/RecognizeVisitorAffiliateFromIp.class.php', 'b49a589f3968317648ee757cac8c2ecc');
        $this->checkFile('include/Pap/Tracking/Action/RecognizeVisitorAffiliateFromUserAgentAndIp.class.php', 'edb17602dd46504d02d1e11615dbef95');
        $this->checkFile('include/Pap/Tracking/Action/RecognizeVisitorAffiliateFromVisitorId.class.php', '3d4ca63320f717f73a44b2e08b7d4a81');
        $this->checkFile('include/Pap/Tracking/Action/RequestActionObject.class.php', '522086cd73383e3236d00f2992637e45');
        $this->checkFile('include/Pap/Tracking/Action/SendTransactionNotificationEmails.class.php', '586d26bc7cef84ee1e0438ea62b16329');
        $this->checkFile('include/Pap/Tracking/ActionObject.class.php', '60c48f20102e91cec4e806d91ddb200e');
        $this->checkFile('include/Pap/Tracking/ActionRequest.class.php', '64f750b33da6c0384b587d6d4e6eac68');
        $this->checkFile('include/Pap/Tracking/ActionTracker.class.php', '614e0bc27a1a2cdf1280877ae7712e7e');
        $this->checkFile('include/Pap/Tracking/BackwardCompatibility/BackwardCompatibilityProcessor.class.php', '5cb42c8d106725136f0c88d4f2caae61');
        $this->checkFile('include/Pap/Tracking/BackwardCompatibility/RecognizeAffiliate.class.php', 'fe4197a307c6c495a8f5f837dfeb01c4');
        $this->checkFile('include/Pap/Tracking/BackwardCompatibility/RecognizeCampaign.class.php', 'd1d3be601fef6694ff2ea99db6356d2f');
        $this->checkFile('include/Pap/Tracking/BannerViewer.class.php', '3505d1f41493c6edb48ed25d1c4aacf2');
        $this->checkFile('include/Pap/Tracking/BannerViewerRequest.class.php', 'ce3dcc78c4e5c7003da959c838085fb0');
        $this->checkFile('include/Pap/Tracking/CallbackTracker.class.php', '2bbdfd53dc1e6578a8f0ef3fded38598');
        $this->checkFile('include/Pap/Tracking/CampaignStoppedException.class.php', 'e1349e3a740603eafb01fb4594e08708');
        $this->checkFile('include/Pap/Tracking/Click/ClickProcessor.class.php', 'e861eeb62a3cab99a988a85aaf5f2985');
        $this->checkFile('include/Pap/Tracking/Click/FraudProtection.class.php', '29393ad2d3120e75bf4a628735431f7c');
        $this->checkFile('include/Pap/Tracking/Click/RecognizeAffiliate.class.php', '99f0efa89c1326b465a67583bfff14f7');
        $this->checkFile('include/Pap/Tracking/Click/RecognizeBanner.class.php', '00fbced36ba93ebbcea6c01fe10b1932');
        $this->checkFile('include/Pap/Tracking/Click/RecognizeCampaign.class.php', '71db521f8bfc7cefdcaf9ce22b0a2c36');
        $this->checkFile('include/Pap/Tracking/Click/RecognizeChannel.class.php', 'bbd3da73e7cdcd00dbe25c0866117732');
        $this->checkFile('include/Pap/Tracking/Click/RecognizeDirectLink.class.php', 'da18fc87d9f1bca32a99e76862709d7e');
        $this->checkFile('include/Pap/Tracking/Click/SaveClick.class.php', 'd020b6324b4446ccd371a08dffb99e4f');
        $this->checkFile('include/Pap/Tracking/Click/SaveClickCommissions.class.php', 'bc811dd928ff1bd3aa5e5c95eb432b56');
        $this->checkFile('include/Pap/Tracking/Click/SaveVisitorAffiliate.class.php', '17c3e4e1fe8b6e27f65a9a06866d86c7');
        $this->checkFile('include/Pap/Tracking/ClickTracker.class.php', '127483e99eb48b1d719625a80a930f2a');
        $this->checkFile('include/Pap/Tracking/Common/Commission.class.php', 'def2552b3dd27cd0abb0884aa5d508fa');
        $this->checkFile('include/Pap/Tracking/Common/RecognizeAccountId.class.php', 'a99764e11a54d0e100ae5d7bd121440d');
        $this->checkFile('include/Pap/Tracking/Common/RecognizeAffiliate.class.php', 'fb856e8f171aec0cd5a36a21dd153b60');
        $this->checkFile('include/Pap/Tracking/Common/RecognizeBanner.class.php', 'b8cfe982643fa552a0a80ab09f92bc35');
        $this->checkFile('include/Pap/Tracking/Common/RecognizeCampaign.class.php', '3d24e4b7aab8f4bed00bd3d2b906d4c3');
        $this->checkFile('include/Pap/Tracking/Common/RecognizeChannel.class.php', '613d98cd7196c339fdf664169482d867');
        $this->checkFile('include/Pap/Tracking/Common/RecognizeCommGroup.class.php', '9b441a61372a16222437eb75567eb130');
        $this->checkFile('include/Pap/Tracking/Common/RecognizeCommSettings.class.php', '58f81fcac1d988498cfd1f779b3bf2fe');
        $this->checkFile('include/Pap/Tracking/Common/RecognizeCommType.class.php', '87d6c9637fc76477d07a1aba0a44cef1');
        $this->checkFile('include/Pap/Tracking/Common/Recognizer.class.php', 'de1a4d25614697599643b9af7eb88757');
        $this->checkFile('include/Pap/Tracking/Common/SaveAllCommissions.class.php', '826ec4411ab7d02b3ab3d5568696f21a');
        $this->checkFile('include/Pap/Tracking/Common/Saver.class.php', '2b8ce71a42835074ecf868dfcbf54f7d');
        $this->checkFile('include/Pap/Tracking/Common/TrackingBase.class.php', '16b2a7385e51b4f348f7da8b03ef7997');
        $this->checkFile('include/Pap/Tracking/Common/UpdateAllCommissions.class.php', '29f06563228f918d9ce3f6c9aed09439');
        $this->checkFile('include/Pap/Tracking/Common/VisitProcessor.class.php', '4c00480b420340ac1a7b1d8ffd63091d');
        $this->checkFile('include/Pap/Tracking/Common/VisitorAffiliateCheckCompatibility.class.php', '3e05a539e7a50f3238a1a9a750ac8b99');
        $this->checkFile('include/Pap/Tracking/Common/VisitorAffiliateCollection.class.php', 'e56f505eec432dac49e5b82f15189441');
        $this->checkFile('include/Pap/Tracking/Cookie/Base.class.php', 'a6a581b4e470fa09883fd8ae9a6f9337');
        $this->checkFile('include/Pap/Tracking/Cookie/ClickData.class.php', 'faad6be9605ed762e27e8b9865d7db53');
        $this->checkFile('include/Pap/Tracking/Cookie/Sale.class.php', '7af2c2a25a9f3a6a8da1a1d50613f8fc');
        $this->checkFile('include/Pap/Tracking/Cookie.class.php', '291797b05f46bc22b07e8a4b6cee890d');
        $this->checkFile('include/Pap/Tracking/DirectLinksBase.class.php', 'f44c8d4bc582be9967a2622003cc4950');
        $this->checkFile('include/Pap/Tracking/Exception.class.php', '11113902092826671d1d6c65cf5827ae');
        $this->checkFile('include/Pap/Tracking/Impression/ImpressionProcessor.class.php', '613dbac55c46bcb1d855e021fc8b90b3');
        $this->checkFile('include/Pap/Tracking/Impression/RecognizeChannel.class.php', 'f2463b700a048793668eb96b823c3c2a');
        $this->checkFile('include/Pap/Tracking/Impression/Save.class.php', 'b13e1f6411b60d6c6bdf3fa33eb25ed3');
        $this->checkFile('include/Pap/Tracking/ImpressionTracker.class.php', '98a027498e00d0930328b5f287b3a093');
        $this->checkFile('include/Pap/Tracking/LinkCloakerGenerator.class.php', '207ccbec175a7f2990755f3aeec1ad2d');
        $this->checkFile('include/Pap/Tracking/Links.class.php', 'a8a61139f569d3e3a7908dd136133f54');
        $this->checkFile('include/Pap/Tracking/ModRewriteForm.class.php', '94c576ea4170c781181625bbba440349');
        $this->checkFile('include/Pap/Tracking/ModuleBase.class.php', '253455ad7cbd71f878e9cd5b336a4081');
        $this->checkFile('include/Pap/Tracking/Request.class.php', 'e036c3c17051d9ef095a8c9f53243ed0');
        $this->checkFile('include/Pap/Tracking/Response.class.php', '0e106b5b415eb64d3cc0b62fd1f1ecde');
        $this->checkFile('include/Pap/Tracking/TrackerBase.class.php', 'abb1c747a5435a721de22f43365970ab');
        $this->checkFile('include/Pap/Tracking/Visit/DeleteVisitorAffiliatesTask.class.php', '0a288245602d4e7293c5ac633d6bfe6e');
        $this->checkFile('include/Pap/Tracking/Visit/Processor.class.php', '10052df5d745f12dec3d692c6d6a15bc');
        $this->checkFile('include/Pap/Tracking/Visit/SingleVisitorProcessor.class.php', '8ee1b33345b7c20516ea5d2eaa0f1aac');
        $this->checkFile('include/Pap/Tracking/Visit/VisitorAffiliateCache.class.php', 'a6d6816ae41db74821c6971adcee9ccc');
        $this->checkFile('include/Pap/View/RemoteGridService.class.php', '35b09fa36f29d211be3be3cbfce50586');
        $this->checkFile('include/Pear/Auth/SASL/Anonymous.php', '9e001f5000bd17211e92cc93fd741bbf');
        $this->checkFile('include/Pear/Auth/SASL/Common.php', '906d3d9ed4e57db1cc02e13896037de2');
        $this->checkFile('include/Pear/Auth/SASL/CramMD5.php', '4e811f7146904b60a8a23cb3f596da85');
        $this->checkFile('include/Pear/Auth/SASL/DigestMD5.php', 'e314d8a8a42c1e10823be69c802703df');
        $this->checkFile('include/Pear/Auth/SASL/External.php', 'aeab0dea7491cebfae9678548e65230b');
        $this->checkFile('include/Pear/Auth/SASL/Login.php', '318aa48f8975a800da4ecd7c05b14bf1');
        $this->checkFile('include/Pear/Auth/SASL/Plain.php', 'f0aed170a45e7e79f3530efa87a772bb');
        $this->checkFile('include/Pear/Auth/SASL/SCRAM.php', '2516bdf126b21e717ecb3d4fae1e292e');
        $this->checkFile('include/Pear/Auth/SASL.php', 'add2d44edb00052f5e638be6b5865be4');
        $this->checkFile('include/Pear/Getopt.php', '07def079c434bf7dea029855c401e334');
        $this->checkFile('include/Pear/HTTP.php', '78f57756ca2714cad158ddefeab1980e');
        $this->checkFile('include/Pear/Mail/RFC822.php', '3e5898ec0524b6b8ff3525fe4637ff29');
        $this->checkFile('include/Pear/Mail/mail.php', '04ae45579ac4242769f6b351e7e7e5ff');
        $this->checkFile('include/Pear/Mail/mime.php', '3871bf0c40f0d3e44caf5e069b1e0502');
        $this->checkFile('include/Pear/Mail/mimeDecode.php', 'a8ced3763752f0d3e2052f6226209995');
        $this->checkFile('include/Pear/Mail/mimePart.php', '8a9d2956a36984dd2802ff74c3d25a49');
        $this->checkFile('include/Pear/Mail/null.php', '2d80fbb2d922aedfc1638b09d71f626c');
        $this->checkFile('include/Pear/Mail/sendmail.php', 'a40700f313a8a12d0f1b3cc37b44eff2');
        $this->checkFile('include/Pear/Mail/smtp.php', 'c72729b1dac8151c59736bb85ec69c49');
        $this->checkFile('include/Pear/Mail.php', '59ad00d9c0140686778fc0af57831df5');
        $this->checkFile('include/Pear/Net/GeoIP/DMA.php', '0ecf182d3dbb9c151c0a0be4efc23a2c');
        $this->checkFile('include/Pear/Net/GeoIP/Location.php', 'fc444656efceea25225ea0765863724c');
        $this->checkFile('include/Pear/Net/GeoIP.php', 'e56a89018fd963bf2b95976377f51816');
        $this->checkFile('include/Pear/Net/IMAP.php', '2505de453f705c05f870ad50b81a2137');
        $this->checkFile('include/Pear/Net/IMAPProtocol.php', '75859ecfe78a5f49a72f3c421bc54f04');
        $this->checkFile('include/Pear/Net/SMTP.php', 'dc901edaae72040598afe257bb23dd9c');
        $this->checkFile('include/Pear/Net/Socket.php', '315c31de179b4a4ea9e5580bcd54c899');
        $this->checkFile('include/Pear/PEAR/Exception.php', '75a1db2d9abf2cc7f5fc47e6c7d5ab3c');
        $this->checkFile('include/Pear/PEAR.php', '808bc5e7d866e0f139c3ef604678bd08');
        $this->checkFile('include/Pear/Text/LanguageDetect/Exception.php', 'f688c5310c1b68da764a6515a2712109');
        $this->checkFile('include/Pear/Text/LanguageDetect/ISO639.php', '48e9f717d80a68c01954edc2a70e1a4a');
        $this->checkFile('include/Pear/Text/LanguageDetect/Parser.php', 'a8d9dab2788244b36470e6c764084913');
        $this->checkFile('include/Pear/Text/LanguageDetect/lang.dat', 'e0fd9f7b872be34d47ae81a6c298f117');
        $this->checkFile('include/Pear/Text/LanguageDetect/unicode_blocks.dat', 'd7e4256e9d51a58cbaf128f6585daca9');
        $this->checkFile('include/Pear/Text/LanguageDetect.php', '6d6f368342730ea3a524caa9b165266d');
        $this->checkFile('include/Pear/TmOAuth/cacert.pem', '68ba72f273dc654217a0583e704dc99c');
        $this->checkFile('include/Pear/TmOAuth/tmhOAuth.php', '181de06cb3a6b9919a005ecdfb3ce215');
        $this->checkFile('include/Pear/TmOAuth/tmhUtilities.php', 'ee24ec4d8903015a15d3aeceb11ccd06');
        $this->checkFile('include/Pear/XML/Parser/Simple.php', '9ed3c0308a18b2733c88f890b2bc307c');
        $this->checkFile('include/Pear/XML/Parser.php', 'f3cb3d17b16060256b0240ee984a62dd');
        $this->checkFile('include/Pear/XML/RSS.php', '62868f68a2dd160ed815cd57ee598e58');
        $this->checkFile('include/RestApi/Auth.class.php', '5f2aa76d95f6b4ed2715fddea893420a');
        $this->checkFile('include/RestApi/Client/ApiClient.class.php', '001b624171e69e377f7568dc56096f06');
        $this->checkFile('include/RestApi/Client/ApiException.class.php', 'cc772eb8b02d4062e6a504c747096d6b');
        $this->checkFile('include/RestApi/Client/Config.class.php', 'b5a5dedd6add90c2e4b189205f968cc0');
        $this->checkFile('include/RestApi/Client/Crm/Adminpanel.class.php', '36384c1f5b8ca7d473db7b688464452c');
        $this->checkFile('include/RestApi/Client/Crm/Attributes.class.php', 'c8f94d61a669c3b4f845e1d5555c2d8e');
        $this->checkFile('include/RestApi/Client/Crm/Billing.class.php', '598ec2d688387f625454e67cb33bf50f');
        $this->checkFile('include/RestApi/Client/Crm/Config/Default.class.php', 'd696261c865404ce0f134e5ecd0d2b20');
        $this->checkFile('include/RestApi/Client/Crm/Countries.class.php', '62ab15fd8198672f23d2edf0dbd6be8a');
        $this->checkFile('include/RestApi/Client/Crm/Internal.class.php', '2ad43dd6c7c3f79bb23142750ccd613b');
        $this->checkFile('include/RestApi/Client/Crm/Invoices.class.php', '3f4e1e03871c7900b62fac7b099b0796');
        $this->checkFile('include/RestApi/Client/Crm/Jobs.class.php', '2d243f2a5ecc12266ffaf877ac582c77');
        $this->checkFile('include/RestApi/Client/Crm/Minions.class.php', '359bafce2d9163a9e0820884a0f78d91');
        $this->checkFile('include/RestApi/Client/Crm/Model/Account.class.php', '77d8e495cbf37b7cb54ab4e818273d08');
        $this->checkFile('include/RestApi/Client/Crm/Model/AccountStats.class.php', '17a8046984618a6b868a8efe7e8af279');
        $this->checkFile('include/RestApi/Client/Crm/Model/AccountUser.class.php', '6e46a59a340bbefeee640b6ed11a91e6');
        $this->checkFile('include/RestApi/Client/Crm/Model/Addon.class.php', 'db4a0644d55d49998f4697fa7b86eb25');
        $this->checkFile('include/RestApi/Client/Crm/Model/AddonList.class.php', '98fd5e961c5815418abf375685727a1c');
        $this->checkFile('include/RestApi/Client/Crm/Model/Attribute.class.php', '1176249e8f05735fda7f8be3b7b27e2a');
        $this->checkFile('include/RestApi/Client/Crm/Model/AttributeSimple.class.php', '9e4702389cbbe17a1473c864884752a6');
        $this->checkFile('include/RestApi/Client/Crm/Model/BillingInfo.class.php', '875d614d5f85be7fc11b30cd892914c2');
        $this->checkFile('include/RestApi/Client/Crm/Model/BillingMetric.class.php', '697b5cf0ebe77e1219eba748e8d8390f');
        $this->checkFile('include/RestApi/Client/Crm/Model/BillingStatus.class.php', 'ce132b0298fc4503d27cb5ead90f8d2b');
        $this->checkFile('include/RestApi/Client/Crm/Model/BooleanResponse.class.php', 'af398057b0164c046e08ffe6d8cabdbd');
        $this->checkFile('include/RestApi/Client/Crm/Model/Country.class.php', '0657faec426fa889ca67ac4ef002af89');
        $this->checkFile('include/RestApi/Client/Crm/Model/Coupon.class.php', 'c61450987d2e776af762f4c5af495319');
        $this->checkFile('include/RestApi/Client/Crm/Model/Customer.class.php', '54e9613ae5290b953e8312cd6d6808c5');
        $this->checkFile('include/RestApi/Client/Crm/Model/Discount.class.php', '2b65b88c20f09722c11a922978d84b87');
        $this->checkFile('include/RestApi/Client/Crm/Model/DiscountValue.class.php', '358d1ec38232a2e2a3706bf83699f14f');
        $this->checkFile('include/RestApi/Client/Crm/Model/Domain.class.php', '729472ef2a783881e23121332830f68d');
        $this->checkFile('include/RestApi/Client/Crm/Model/Email.class.php', '2dfb168aef3da92cfa7c318117d5d574');
        $this->checkFile('include/RestApi/Client/Crm/Model/ErrorResponse.class.php', '622afd45580339dfd5a9f8e7149c7118');
        $this->checkFile('include/RestApi/Client/Crm/Model/FailedPayment.class.php', 'e81548b2d6c11895bec21bd172ef9eec');
        $this->checkFile('include/RestApi/Client/Crm/Model/Ids.class.php', '96539f2c3bb2d3747df287e0fd559bbb');
        $this->checkFile('include/RestApi/Client/Crm/Model/InstallProgress.class.php', '1803d374626e37a4cd1021aac09f708d');
        $this->checkFile('include/RestApi/Client/Crm/Model/Invoice.class.php', 'a0e03382b24e3431109de06405ee62e5');
        $this->checkFile('include/RestApi/Client/Crm/Model/InvoiceItem.class.php', 'acb408ab34da01379e7b79e85fa70d67');
        $this->checkFile('include/RestApi/Client/Crm/Model/Job.class.php', '371f0dcbc04aabcba29e3135c2c5255b');
        $this->checkFile('include/RestApi/Client/Crm/Model/MassResponse.class.php', 'e50c1a95726009a8c2b41ba54c0bc6c0');
        $this->checkFile('include/RestApi/Client/Crm/Model/Minion.class.php', '1b10c7f8c20960bc033d642c6d6d8b2a');
        $this->checkFile('include/RestApi/Client/Crm/Model/Note.class.php', '23168f5cda2961c23f52edec9a64101a');
        $this->checkFile('include/RestApi/Client/Crm/Model/OkResponse.class.php', '3917008e10a7887818f9513c56ee8fbb');
        $this->checkFile('include/RestApi/Client/Crm/Model/PapTrackingParams.class.php', '0e0d1784477f10e097a0510ae6199db1');
        $this->checkFile('include/RestApi/Client/Crm/Model/PaymentInfo.class.php', '13eebee8460513c09c08138c68489a37');
        $this->checkFile('include/RestApi/Client/Crm/Model/PaymentMethod.class.php', 'b4ffe295d7a0b3b4d089d31da743e534');
        $this->checkFile('include/RestApi/Client/Crm/Model/PaymentProcessorType.class.php', '13275d631678fe702a5daddad9cff18f');
        $this->checkFile('include/RestApi/Client/Crm/Model/Price.class.php', '777c4498cd9c0769a54baa43c884b9a7');
        $this->checkFile('include/RestApi/Client/Crm/Model/Product.class.php', 'cc7bb04910e9a6c23c447afbc27bd58e');
        $this->checkFile('include/RestApi/Client/Crm/Model/Refund.class.php', 'd15dc3accf621bb1e6a6da495df41794');
        $this->checkFile('include/RestApi/Client/Crm/Model/RefundRequest.class.php', '1fdffac4d5c8a52cfb477a731b317faf');
        $this->checkFile('include/RestApi/Client/Crm/Model/SaleStats.class.php', '122bf697cd2a4efbfd9985a8aa1f9fe3');
        $this->checkFile('include/RestApi/Client/Crm/Model/Signup.class.php', '380844a4ceb8a9a7e86c1257515692a3');
        $this->checkFile('include/RestApi/Client/Crm/Model/Source.class.php', '4c3f4a5207cb5ca9debd3a5b5467d531');
        $this->checkFile('include/RestApi/Client/Crm/Model/Subscription.class.php', '0d1cd021e8d811960de4120d8e0e8434');
        $this->checkFile('include/RestApi/Client/Crm/Model/SubscriptionViewData.class.php', '1bf1ae1a61499b763ab94725cc508c63');
        $this->checkFile('include/RestApi/Client/Crm/Model/Task.class.php', '4e6578a2936071b9b75405420470f6c3');
        $this->checkFile('include/RestApi/Client/Crm/Model/Template.class.php', 'b6a2c17b1461cc30b2d8fc60bd1afe91');
        $this->checkFile('include/RestApi/Client/Crm/Model/Token.class.php', 'e02f4599bb6de8106277f2b29213b554');
        $this->checkFile('include/RestApi/Client/Crm/Model/Upgrade.class.php', 'ff8da6fa156752c636f64d8745b486a5');
        $this->checkFile('include/RestApi/Client/Crm/Model/UsageData.class.php', '49d200daa54c97d7d3bb7445fd7e8eab');
        $this->checkFile('include/RestApi/Client/Crm/Model/Variation.class.php', 'cdee79420e39b55bbaab913a107d0570');
        $this->checkFile('include/RestApi/Client/Crm/Model/VariationUpgrade.class.php', '835a4cbc32601e81c8cdfcc0fffe47f6');
        $this->checkFile('include/RestApi/Client/Crm/Model/VariationUpgrades.class.php', '8b6ca38c755cc843c52feb8972885af7');
        $this->checkFile('include/RestApi/Client/Crm/Products.class.php', '704fb39d3c01805cb907f5c3caeae5d1');
        $this->checkFile('include/RestApi/Client/Crm/Refunds.class.php', '7bce9f1f16758330af802de1f499a610');
        $this->checkFile('include/RestApi/Client/Crm/Stats.class.php', '0649aad7b2648e172e2770d3d2eec8d0');
        $this->checkFile('include/RestApi/Client/Crm/Subscriptions.class.php', 'e1ea2cea29bb2b08b93023ab43f3e1db');
        $this->checkFile('include/RestApi/Client/Crm/Tasks.class.php', '95d8abe93af952456a4665235d1f0afb');
        $this->checkFile('include/RestApi/Client/Crm/Templates.class.php', '13c6913a027d0498be3f45ed70f864d9');
        $this->checkFile('include/RestApi/Client/Crm/Token.class.php', '45992a75a776c5db6e50dd3bba3b7d43');
        $this->checkFile('include/RestApi/Client/Crm/Variations.class.php', '9082b1db906a01c708c1f31e0f2ec2ee');
        $this->checkFile('include/RestApi/Client/Utils.class.php', '91da05887c2baa13c54031273e38aaa8');
        $this->checkFile('include/RestApi/DbEntityHandler.class.php', '9387e3271d5fba7ba4f63ad835d2983f');
        $this->checkFile('include/RestApi/Handler.class.php', '150e3d0f3965d3c2f692cb9b3522062b');
        $this->checkFile('include/RestApi/Make.class.php', '6e3ae34fe7a18b4987760c96d67cfd07');
        $this->checkFile('include/RestApi/OkResponse.class.php', 'eee0aba10f4bca941f531e734431bd54');
        $this->checkFile('include/RestApi/Params.class.php', 'fe635621c1ceb81bb6dc49d9767e6537');
        $this->checkFile('include/RestApi/ProcessingException.class.php', '31cb45d7c926d158f894502f1040b2d5');
        $this->checkFile('include/RestApi/Response.class.php', '4cb2c462dec318cab63616cbf3c6c3ea');
        $this->checkFile('include/RestApi/Result.class.php', 'e50c8c9195cdc8de007ccdaee7bad563');
        $this->checkFile('include/RestApi/Role.class.php', '850f5cabb7d2040b320ab83740ebe06b');
        $this->checkFile('include/RestApi/Token.class.php', '1b46eaa5f7ba6ef999d5225e9862ee1b');
        $this->checkFile('include/RestApi/TypeUtils/BoolField.class.php', 'b76fce584ab59143ca194eeacbbe146a');
        $this->checkFile('include/RestApi/TypeUtils/Field.class.php', '79e91e34b83e902c9f57426aff5e81de');
        $this->checkFile('include/RestApi/TypeUtils/FloatField.class.php', '12a9ae4fa660ef8ef964a7a242ce8ba9');
        $this->checkFile('include/RestApi/TypeUtils/IntField.class.php', '5f0ec1ab66a469d4b82a5429922d1600');
        $this->checkFile('include/RestApi/TypeUtils/ParseException.class.php', '190fa9d405fd9161a211cc075b653c6a');
        $this->checkFile('include/RestApi/TypeUtils/StringField.class.php', 'bc14ed6cf74a8ed885771ee1318c8e0e');
        $this->checkFile('include/Smarty/Config_File.class.php', '7a0c7514b063970a050fd3a97b401a89');
        $this->checkFile('include/Smarty/Smarty.class.php', '8655012738487178454c473bcfddd25e');
        $this->checkFile('include/Smarty/Smarty_Compiler.class.php', '093aa410aca25ffbfa1b5f4269b5d55d');
        $this->checkFile('include/Smarty/debug.tpl', '37741e4370d5f3ca9d950391a8f7c225');
        $this->checkFile('include/Smarty/internals/core.assemble_plugin_filepath.php', '7c0cd4430790ac03b61043b3a69f6192');
        $this->checkFile('include/Smarty/internals/core.assign_smarty_interface.php', 'aa4f0bfb49bcb5838970447d6c930e88');
        $this->checkFile('include/Smarty/internals/core.create_dir_structure.php', '33a6c7c1a300e169b3988d38162700ff');
        $this->checkFile('include/Smarty/internals/core.display_debug_console.php', '60a6d93545bd23513f2360017d3fe5d1');
        $this->checkFile('include/Smarty/internals/core.get_include_path.php', '8cc773f3ebf6819639c754120e35577b');
        $this->checkFile('include/Smarty/internals/core.get_microtime.php', '36518497e5d7cc02b5a7c70e21372d27');
        $this->checkFile('include/Smarty/internals/core.get_php_resource.php', 'f8d57bb695f725aacb68d5f0b5b23ba5');
        $this->checkFile('include/Smarty/internals/core.is_secure.php', '555123df0a2fee035bfc81e70859831a');
        $this->checkFile('include/Smarty/internals/core.is_trusted.php', 'd9f84b52d2cabe34fda51176ed8f7ae1');
        $this->checkFile('include/Smarty/internals/core.load_plugins.php', '8e97f7043430265eca9f092550243d7d');
        $this->checkFile('include/Smarty/internals/core.load_resource_plugin.php', '3a4d26e0177f1841178aac666081e523');
        $this->checkFile('include/Smarty/internals/core.process_cached_inserts.php', 'badd25e8c2e238e6a0167d1c15798182');
        $this->checkFile('include/Smarty/internals/core.process_compiled_include.php', '40b17971ab3f1aef500bdc1e69057f23');
        $this->checkFile('include/Smarty/internals/core.read_cache_file.php', '8cec4c55329153390f51f411911e30ae');
        $this->checkFile('include/Smarty/internals/core.rm_auto.php', 'f0b82946c1f24be370d3f7b2725316be');
        $this->checkFile('include/Smarty/internals/core.rmdir.php', 'e9e060385c2ffdb2bec59b36dd4f89ea');
        $this->checkFile('include/Smarty/internals/core.run_insert_handler.php', 'da3c5011a9d6ff7c0073af826544576b');
        $this->checkFile('include/Smarty/internals/core.smarty_include_php.php', 'd2d95d7ab4558575baa2230ddd6ef1db');
        $this->checkFile('include/Smarty/internals/core.write_cache_file.php', '8db6706481fbde645603024189d2a5b8');
        $this->checkFile('include/Smarty/internals/core.write_compiled_include.php', 'e73a12d6f9396ce2d48da5c1eb2f5840');
        $this->checkFile('include/Smarty/internals/core.write_compiled_resource.php', 'a396f373f4f6075097c779e23b63bc5b');
        $this->checkFile('include/Smarty/internals/core.write_file.php', '681c2e20f08e301cdc30e1c2395d7f26');
        $this->checkFile('include/Smarty/plugins/block.textformat.php', '7c508e70e5c33e96bba6a5adb3372e6c');
        $this->checkFile('include/Smarty/plugins/compiler.assign.php', '06901724daa0a892c94a2e4f7fe47271');
        $this->checkFile('include/Smarty/plugins/function.assign_debug_info.php', '8e655ed99514198d3b42347d84ca70d6');
        $this->checkFile('include/Smarty/plugins/function.config_load.php', 'ffc79ac06cbbea9d5f011836807df55a');
        $this->checkFile('include/Smarty/plugins/function.counter.php', 'ee546b65f6874b21c83158cd20d198ff');
        $this->checkFile('include/Smarty/plugins/function.cycle.php', '5e68ca7fe99130663410fa0aaa11f1e9');
        $this->checkFile('include/Smarty/plugins/function.debug.php', '820f09d11b56cf0e3a410bc4b759f3ac');
        $this->checkFile('include/Smarty/plugins/function.eval.php', 'e43616b3789fad64c3db78a45f37c4b8');
        $this->checkFile('include/Smarty/plugins/function.fetch.php', 'e44e1ac77846cb3b1661bfe766b5056e');
        $this->checkFile('include/Smarty/plugins/function.html_checkboxes.php', '9ceef629c2081e98fed3cd05ec6cb4a5');
        $this->checkFile('include/Smarty/plugins/function.html_image.php', '91f8ed2a857497d7cd86b6afea8f35c6');
        $this->checkFile('include/Smarty/plugins/function.html_options.php', '0083af9dc91ea1c51813490506536535');
        $this->checkFile('include/Smarty/plugins/function.html_radios.php', '05727084c122b2de7697d8e95bf5d406');
        $this->checkFile('include/Smarty/plugins/function.html_select_date.php', '81cbeb3f99dbec48a5d77177f94c0788');
        $this->checkFile('include/Smarty/plugins/function.html_select_time.php', 'c5ccb0a4353f396b01ccb448e2f67f7d');
        $this->checkFile('include/Smarty/plugins/function.html_table.php', '0a935837077575324d1a3e89f676f4ac');
        $this->checkFile('include/Smarty/plugins/function.mailto.php', 'e6643a69f7364cb1d2a0853e1d6bc828');
        $this->checkFile('include/Smarty/plugins/function.math.php', '6f1779139a9832f9c81f03d951f2f255');
        $this->checkFile('include/Smarty/plugins/function.popup.php', '897988dbce0d3b8acd81121db2cf0565');
        $this->checkFile('include/Smarty/plugins/function.popup_init.php', '9965da2adc04337108e5680f558d0910');
        $this->checkFile('include/Smarty/plugins/modifier.capitalize.php', '235a92575b4427a347237273dc179939');
        $this->checkFile('include/Smarty/plugins/modifier.cat.php', '62e2895595e82b4fd2eb967df7afa2a4');
        $this->checkFile('include/Smarty/plugins/modifier.count_characters.php', '1dbbc6c4b2778bc3e8e7c77439b3e75f');
        $this->checkFile('include/Smarty/plugins/modifier.count_paragraphs.php', '5e6837efebf564cf06e463a7b45e2b25');
        $this->checkFile('include/Smarty/plugins/modifier.count_sentences.php', '627d484fe39a36040a43151af5012f8a');
        $this->checkFile('include/Smarty/plugins/modifier.count_words.php', '2aae189d8d9447706dc446235a8c3f5a');
        $this->checkFile('include/Smarty/plugins/modifier.date_format.php', '8c705edead8ce2f600b1cd2d79421a91');
        $this->checkFile('include/Smarty/plugins/modifier.debug_print_var.php', '37b37b7ac4e5e7786e085d45c7cbd8ba');
        $this->checkFile('include/Smarty/plugins/modifier.default.php', '2d7ab8829a1778d8335c5349324122b7');
        $this->checkFile('include/Smarty/plugins/modifier.escape.php', '017e7b96e9c436e9bc0e007d3be67645');
        $this->checkFile('include/Smarty/plugins/modifier.indent.php', '05706949758059ca3a4edeec9b3465fe');
        $this->checkFile('include/Smarty/plugins/modifier.lower.php', '00399629b46973f29f2d6654bf50a213');
        $this->checkFile('include/Smarty/plugins/modifier.nl2br.php', '0348522437be22dc5c8cdc3a0f86c80a');
        $this->checkFile('include/Smarty/plugins/modifier.regex_replace.php', '56a0677115297398fe142ef16929a560');
        $this->checkFile('include/Smarty/plugins/modifier.replace.php', '4dca02f7320231af60d4cecaf350ce32');
        $this->checkFile('include/Smarty/plugins/modifier.spacify.php', 'f59665c28831d86675c14986b9a00fc6');
        $this->checkFile('include/Smarty/plugins/modifier.string_format.php', '9641e5d7ded64e142d24c487012211d5');
        $this->checkFile('include/Smarty/plugins/modifier.strip.php', '5d047fe0e564197158313cdf26a1aca7');
        $this->checkFile('include/Smarty/plugins/modifier.strip_tags.php', '16491ebfea6384de8dec4399da96c999');
        $this->checkFile('include/Smarty/plugins/modifier.truncate.php', 'c15b798399c607f33a2c981b33675ede');
        $this->checkFile('include/Smarty/plugins/modifier.upper.php', 'fc73785c02c02b759d67f94d9bea1dca');
        $this->checkFile('include/Smarty/plugins/modifier.wordwrap.php', 'e8ba637a013ce92f8ca3d15952b7ab8a');
        $this->checkFile('include/Smarty/plugins/outputfilter.trimwhitespace.php', 'ef01cef7072e4ff3204b85d6153117ed');
        $this->checkFile('include/Smarty/plugins/shared.escape_special_chars.php', '5d074cc75fb008db21a80daf22d78e2e');
        $this->checkFile('include/Smarty/plugins/shared.make_timestamp.php', 'f1910052d8ac96c79b72a3b35dc28dfa');
        $this->checkFile('include/pclzip/gnu-lgpl.txt', '7fbc338309ac38fefcd64b04bb903e34');
        $this->checkFile('include/pclzip/pclzip.lib.php', '36d19a7fe6828bae56ce01b68d3f9ca6');
        $this->checkFile('include/pclzip/readme.txt', 'a7cc93c07a1ab786029e417d20d8092d');
        $this->checkFile('include/tcpdf/CHANGELOG.TXT', '5bdb84796d0539058a672fb99c783f05');
        $this->checkFile('include/tcpdf/LICENSE.TXT', '5c87b66a5358ebcc495b03e0afcd342c');
        $this->checkFile('include/tcpdf/README.TXT', 'eba2e61977ee2051ce3622c057396704');
        $this->checkFile('include/tcpdf/README.md', '250a84971d3f00da77c551fab3f5e756');
        $this->checkFile('include/tcpdf/barcodes.php', '4254470e1898d572b4b36527aa9bb9ba');
        $this->checkFile('include/tcpdf/config/lang/eng.php', 'cb6850831d0c0393f272e89dfa756717');
        $this->checkFile('include/tcpdf/config/tcpdf_config.php', '6dcac54b23cb86bf72d3a11fbef69dd6');
        $this->checkFile('include/tcpdf/config/tcpdf_config_alt.php', 'd0486a6a7f3ca5c3e07925aefdfe981d');
        $this->checkFile('include/tcpdf/fonts/ae_fonts_2.0/COPYING', '9f9baa5319cbed2bafd8500aa5c2c9dc');
        $this->checkFile('include/tcpdf/fonts/ae_fonts_2.0/ChangeLog', '24cc17d8ae965601b7ffdc0473d8312b');
        $this->checkFile('include/tcpdf/fonts/ae_fonts_2.0/ChangeLog.9745.BAK', '81f1d0eb3f38e2ff1cf2c110b620096c');
        $this->checkFile('include/tcpdf/fonts/ae_fonts_2.0/README', 'de471949923e79ef976e314c74adcad2');
        $this->checkFile('include/tcpdf/fonts/aealarabiya.ctg.z', '0eac1ff3b999791227dadfb340ddd83f');
        $this->checkFile('include/tcpdf/fonts/aealarabiya.php', 'c49883919b7912057b1ffad674a9c7c2');
        $this->checkFile('include/tcpdf/fonts/aealarabiya.z', '18ca47dea418152b135e93b582f84d3b');
        $this->checkFile('include/tcpdf/fonts/aefurat.ctg.z', '338bf17de7248821ee33c2eff77e9d5c');
        $this->checkFile('include/tcpdf/fonts/aefurat.php', 'c0f60dd955a2bd3e6bace66eb362c9a5');
        $this->checkFile('include/tcpdf/fonts/aefurat.z', '3ae824c26cb84c39a279c29472b4a5de');
        $this->checkFile('include/tcpdf/fonts/cid0cs.php', 'cc57e711467da789a9f36a8ec5fc9562');
        $this->checkFile('include/tcpdf/fonts/cid0ct.php', '2c76b0b724c88c85c7b32f4a0b61385c');
        $this->checkFile('include/tcpdf/fonts/cid0jp.php', 'bfc5e69bc85924258c68da3717e553b1');
        $this->checkFile('include/tcpdf/fonts/cid0kr.php', '3701c4e8068cb8875dcf1ba714b7a4c2');
        $this->checkFile('include/tcpdf/fonts/courier.php', '2894170c52a47ac02bf094bf047f1984');
        $this->checkFile('include/tcpdf/fonts/courierb.php', 'baadbf936466cfc106ae73e5f15dba89');
        $this->checkFile('include/tcpdf/fonts/courierbi.php', 'f9389202889738a0935be0d96f3aa609');
        $this->checkFile('include/tcpdf/fonts/courieri.php', 'afdcd64e0d7d78942401354d7f5f180d');
        $this->checkFile('include/tcpdf/fonts/dejavu-fonts-ttf-2.33/AUTHORS', 'a8c6a30ab1a4493084f9789d3c8403b0');
        $this->checkFile('include/tcpdf/fonts/dejavu-fonts-ttf-2.33/BUGS', 'fc037b603dc40195bbd1bbd8564340cc');
        $this->checkFile('include/tcpdf/fonts/dejavu-fonts-ttf-2.33/LICENSE', '9f867da7a73fad2715291348e80d0763');
        $this->checkFile('include/tcpdf/fonts/dejavu-fonts-ttf-2.33/NEWS', '896afdebfc3f279860ff9bf3c7831e3d');
        $this->checkFile('include/tcpdf/fonts/dejavu-fonts-ttf-2.33/README', '90ae8780196d47f77e6c4e3042e7ef83');
        $this->checkFile('include/tcpdf/fonts/dejavu-fonts-ttf-2.33/langcover.txt', 'f2b633fd2839641cd4c095935a1d8a33');
        $this->checkFile('include/tcpdf/fonts/dejavu-fonts-ttf-2.33/status.txt', '12dfc21c5d65d04290459ee8dfa7de51');
        $this->checkFile('include/tcpdf/fonts/dejavu-fonts-ttf-2.33/unicover.txt', '80810c8ed3ec5756f029cf584b11c81f');
        $this->checkFile('include/tcpdf/fonts/dejavu-fonts-ttf-2.34/AUTHORS', '1000a53f98be8258946d51516864989e');
        $this->checkFile('include/tcpdf/fonts/dejavu-fonts-ttf-2.34/BUGS', 'fc037b603dc40195bbd1bbd8564340cc');
        $this->checkFile('include/tcpdf/fonts/dejavu-fonts-ttf-2.34/LICENSE', '9f867da7a73fad2715291348e80d0763');
        $this->checkFile('include/tcpdf/fonts/dejavu-fonts-ttf-2.34/NEWS', '5f28daf5850a1ad61051cc432eb053b1');
        $this->checkFile('include/tcpdf/fonts/dejavu-fonts-ttf-2.34/README', 'aaeeab2d5344153a897728f12a5bde71');
        $this->checkFile('include/tcpdf/fonts/dejavu-fonts-ttf-2.34/langcover.txt', '0dba7d44ec611c7bdca62e51921c34d9');
        $this->checkFile('include/tcpdf/fonts/dejavu-fonts-ttf-2.34/status.txt', '321d0860cabebdcda87ce7827b783fb3');
        $this->checkFile('include/tcpdf/fonts/dejavu-fonts-ttf-2.34/unicover.txt', '979ae350ce77ba897f567cebacff6eae');
        $this->checkFile('include/tcpdf/fonts/dejavusans.ctg.z', '4856e25c5027ef93e512646becf3eda5');
        $this->checkFile('include/tcpdf/fonts/dejavusans.php', '8b75ae7921f26b4f4b11d18ed921248e');
        $this->checkFile('include/tcpdf/fonts/dejavusans.z', 'f910decf31ee5f189c5397ee0937794a');
        $this->checkFile('include/tcpdf/fonts/dejavusansb.ctg.z', '2cd707fef915349263363bedb83ceba6');
        $this->checkFile('include/tcpdf/fonts/dejavusansb.php', '95bf00532c504c237041c4e3f04936a1');
        $this->checkFile('include/tcpdf/fonts/dejavusansb.z', '50d61b15904ee2a7d56673fc42dcc1ae');
        $this->checkFile('include/tcpdf/fonts/dejavusansbi.ctg.z', '3f20f10cb46cd58bb26d5a80b4f29d74');
        $this->checkFile('include/tcpdf/fonts/dejavusansbi.php', '7db990cc030127f1b64a4d3492f8f3e2');
        $this->checkFile('include/tcpdf/fonts/dejavusansbi.z', '716611c7a37f177cf3cb53c5866c7e43');
        $this->checkFile('include/tcpdf/fonts/dejavusanscondensed.ctg.z', '4856e25c5027ef93e512646becf3eda5');
        $this->checkFile('include/tcpdf/fonts/dejavusanscondensed.php', '6ac17b4d7485fe73dd2d754ce2a0e2d9');
        $this->checkFile('include/tcpdf/fonts/dejavusanscondensed.z', '034ce5e2a8acc79b58b6aaae31cf5bf1');
        $this->checkFile('include/tcpdf/fonts/dejavusanscondensedb.ctg.z', '2cd707fef915349263363bedb83ceba6');
        $this->checkFile('include/tcpdf/fonts/dejavusanscondensedb.php', '72b2fd6a41260897ef758436603d33a2');
        $this->checkFile('include/tcpdf/fonts/dejavusanscondensedb.z', '08c775814634616b5ea683f297d60a51');
        $this->checkFile('include/tcpdf/fonts/dejavusanscondensedbi.ctg.z', '3f20f10cb46cd58bb26d5a80b4f29d74');
        $this->checkFile('include/tcpdf/fonts/dejavusanscondensedbi.php', 'de96058dc4fedbe4ccca03f9966ff743');
        $this->checkFile('include/tcpdf/fonts/dejavusanscondensedbi.z', '0b833b6efe53fc391c5f90b3b916c8f6');
        $this->checkFile('include/tcpdf/fonts/dejavusanscondensedi.ctg.z', 'f110fbb18db8a227880b27e099358117');
        $this->checkFile('include/tcpdf/fonts/dejavusanscondensedi.php', 'a1775d6ba3d8b76629dcdc2c1006048b');
        $this->checkFile('include/tcpdf/fonts/dejavusanscondensedi.z', '5ad7b719402d1042038241da3c2d950a');
        $this->checkFile('include/tcpdf/fonts/dejavusansextralight.ctg.z', 'a83da87e770342aba842708f6ddc5379');
        $this->checkFile('include/tcpdf/fonts/dejavusansextralight.php', 'bc1d75d2d4988d2ad9cac651bc44b8b3');
        $this->checkFile('include/tcpdf/fonts/dejavusansextralight.z', '3d251a8fb2df58153f1b6820c81858df');
        $this->checkFile('include/tcpdf/fonts/dejavusansi.ctg.z', 'f110fbb18db8a227880b27e099358117');
        $this->checkFile('include/tcpdf/fonts/dejavusansi.php', '016527b52b6af2d6784fffeb23a2349b');
        $this->checkFile('include/tcpdf/fonts/dejavusansi.z', '649d51e9fcd4989c23940a24fc271742');
        $this->checkFile('include/tcpdf/fonts/dejavusansmono.ctg.z', '0dae2b4888dbfa64798623f701eefed5');
        $this->checkFile('include/tcpdf/fonts/dejavusansmono.php', '5af577705b43ce01285f2721a4850ac4');
        $this->checkFile('include/tcpdf/fonts/dejavusansmono.z', '81924961aadc0697a09a0c6594d55811');
        $this->checkFile('include/tcpdf/fonts/dejavusansmonob.ctg.z', 'b76ace3e5487a0c49c6bbda84dc90a56');
        $this->checkFile('include/tcpdf/fonts/dejavusansmonob.php', 'fc1cb0e9030ce6b891319ce46dd8c434');
        $this->checkFile('include/tcpdf/fonts/dejavusansmonob.z', 'c61fb661657d61d6acc0fa631bb23755');
        $this->checkFile('include/tcpdf/fonts/dejavusansmonobi.ctg.z', 'adf3957c2eca46fa765d43004c0cc48e');
        $this->checkFile('include/tcpdf/fonts/dejavusansmonobi.php', '75c68bb955477a99fc98600f5e1f40a3');
        $this->checkFile('include/tcpdf/fonts/dejavusansmonobi.z', 'abfa503eb43ae328fe9b2c980ebe0a2a');
        $this->checkFile('include/tcpdf/fonts/dejavusansmonoi.ctg.z', 'e0b76dd30e46b3642f866bfed35e07e1');
        $this->checkFile('include/tcpdf/fonts/dejavusansmonoi.php', 'a2a228f499608ddddeb2ba54834a5b7f');
        $this->checkFile('include/tcpdf/fonts/dejavusansmonoi.z', '16aa93d6a17c67cebf9ede2168018e29');
        $this->checkFile('include/tcpdf/fonts/dejavuserif.ctg.z', '8973197006c4361981420bc87ef5d9bf');
        $this->checkFile('include/tcpdf/fonts/dejavuserif.php', 'eee692f442eaec2b8291419a2017e50b');
        $this->checkFile('include/tcpdf/fonts/dejavuserif.z', 'f8e88e908e5bfecb162849d885e6b960');
        $this->checkFile('include/tcpdf/fonts/dejavuserifb.ctg.z', '6cf11a9402bc087474b90cb56c91b74d');
        $this->checkFile('include/tcpdf/fonts/dejavuserifb.php', '18638db567f8b6fd7b1c6641ebf2c958');
        $this->checkFile('include/tcpdf/fonts/dejavuserifb.z', '1fc1e2e5af73ffc8bfe1222c61bfda37');
        $this->checkFile('include/tcpdf/fonts/dejavuserifbi.ctg.z', '71e67935c1f0c9475c2b9489bf812ef8');
        $this->checkFile('include/tcpdf/fonts/dejavuserifbi.php', 'bccc18d3b8c2b941ef7ef6602aab6c69');
        $this->checkFile('include/tcpdf/fonts/dejavuserifbi.z', '8ba4178280ca7bb1ac22a197deef154e');
        $this->checkFile('include/tcpdf/fonts/dejavuserifcondensed.ctg.z', '8973197006c4361981420bc87ef5d9bf');
        $this->checkFile('include/tcpdf/fonts/dejavuserifcondensed.php', '4775a411c20fe8fb13e9fb3a46629dc3');
        $this->checkFile('include/tcpdf/fonts/dejavuserifcondensed.z', '562d027d0090fcf872158162e9a3ca4b');
        $this->checkFile('include/tcpdf/fonts/dejavuserifcondensedb.ctg.z', '6cf11a9402bc087474b90cb56c91b74d');
        $this->checkFile('include/tcpdf/fonts/dejavuserifcondensedb.php', 'bcc98729a04598aecb86c451b91433ea');
        $this->checkFile('include/tcpdf/fonts/dejavuserifcondensedb.z', '844d1631ba8f58ce496d4ff6897d121f');
        $this->checkFile('include/tcpdf/fonts/dejavuserifcondensedbi.ctg.z', '71e67935c1f0c9475c2b9489bf812ef8');
        $this->checkFile('include/tcpdf/fonts/dejavuserifcondensedbi.php', '950310a6c12362b084a68b0cfa7f3373');
        $this->checkFile('include/tcpdf/fonts/dejavuserifcondensedbi.z', '4076a566cc91006c7db31ce3516bb133');
        $this->checkFile('include/tcpdf/fonts/dejavuserifcondensedi.ctg.z', '3cbfa12b1f62d72314cf2daae4ceaa3e');
        $this->checkFile('include/tcpdf/fonts/dejavuserifcondensedi.php', '52b7639c5c4e35f33bb3c69cbfa0588d');
        $this->checkFile('include/tcpdf/fonts/dejavuserifcondensedi.z', '9ffcb7d53dfb7a80e61419cffbbbc952');
        $this->checkFile('include/tcpdf/fonts/dejavuserifi.ctg.z', '3cbfa12b1f62d72314cf2daae4ceaa3e');
        $this->checkFile('include/tcpdf/fonts/dejavuserifi.php', '368af9ad30db4935e51b2109b9d4e9ca');
        $this->checkFile('include/tcpdf/fonts/dejavuserifi.z', '3fd9b7f1009f8aaf22dd9a5b25509ff7');
        $this->checkFile('include/tcpdf/fonts/freefont-20100919/AUTHORS', '34f12a4b2efc6ba0739da4702a42616e');
        $this->checkFile('include/tcpdf/fonts/freefont-20100919/COPYING', 'd32239bcb673463ab874e80d47fae504');
        $this->checkFile('include/tcpdf/fonts/freefont-20100919/CREDITS', '32ee004055e47f24ac93be709c899dc4');
        $this->checkFile('include/tcpdf/fonts/freefont-20100919/ChangeLog', '877880ae713f5679a53e5b47c9b4f32e');
        $this->checkFile('include/tcpdf/fonts/freefont-20100919/INSTALL', 'a2e9f46a8e42686872c9d6761a549199');
        $this->checkFile('include/tcpdf/fonts/freefont-20100919/README', '2f218d1adbdc1bd2e4ebc0b382bb3b8a');
        $this->checkFile('include/tcpdf/fonts/freefont-20120503/AUTHORS', 'cc8c19ca8b612519b040f6f6d6ed2a2b');
        $this->checkFile('include/tcpdf/fonts/freefont-20120503/COPYING', 'd32239bcb673463ab874e80d47fae504');
        $this->checkFile('include/tcpdf/fonts/freefont-20120503/CREDITS', '879b65ce99ecff3401551d0ce8497d5a');
        $this->checkFile('include/tcpdf/fonts/freefont-20120503/ChangeLog', '409cf2c0195d2b5802d6948999f023c5');
        $this->checkFile('include/tcpdf/fonts/freefont-20120503/ChangeLog.10070.BAK', 'e80566efc867d2663f4dfd5bae5fd1ba');
        $this->checkFile('include/tcpdf/fonts/freefont-20120503/INSTALL', 'f47e1bd2753896200a97fea6f6175ce9');
        $this->checkFile('include/tcpdf/fonts/freefont-20120503/README', '97e543830b6483a04637601bd4b62e11');
        $this->checkFile('include/tcpdf/fonts/freefont-20120503/TROUBLESHOOTING', '916b61cbb2bd621b617c36b51f681935');
        $this->checkFile('include/tcpdf/fonts/freefont-20120503/USAGE', 'c04898b16f88e2c2fa98fbbbe7fbef95');
        $this->checkFile('include/tcpdf/fonts/freemono.ctg.z', '80bd51941ebdfdd61f69aa3067ae600e');
        $this->checkFile('include/tcpdf/fonts/freemono.php', '2652ce7b4dcf00a1b07d8b1debedf867');
        $this->checkFile('include/tcpdf/fonts/freemono.z', 'bae95a030b030f44bcad2e87dcc14815');
        $this->checkFile('include/tcpdf/fonts/freemonob.ctg.z', '22ebf9af13beac714c8114f15b40ef97');
        $this->checkFile('include/tcpdf/fonts/freemonob.php', '7596c070ac1bc839022e0a7aba2156ef');
        $this->checkFile('include/tcpdf/fonts/freemonob.z', '78e033eb5863a8b60f987f5fb2b604ac');
        $this->checkFile('include/tcpdf/fonts/freemonobi.ctg.z', '1915ac55e94138dcd9f924e4fe507ea0');
        $this->checkFile('include/tcpdf/fonts/freemonobi.php', '99d8349acae8fcd95094364adf24dae2');
        $this->checkFile('include/tcpdf/fonts/freemonobi.z', '28b46c5f466ce631317e1fe067daa7ab');
        $this->checkFile('include/tcpdf/fonts/freemonoi.ctg.z', 'c40ce9128e9f654222f0c17958ba14f9');
        $this->checkFile('include/tcpdf/fonts/freemonoi.php', '96fe7b1e5cd48c7332cf17b789f7af66');
        $this->checkFile('include/tcpdf/fonts/freemonoi.z', '1c632653ab6592fb8cfef0471afb6807');
        $this->checkFile('include/tcpdf/fonts/freesans.ctg.z', 'be9c85808d55cbef8619a67495a43fbc');
        $this->checkFile('include/tcpdf/fonts/freesans.php', '4fd59032d7c3a59fd45028bafa245721');
        $this->checkFile('include/tcpdf/fonts/freesans.z', 'bc1ca4370455ca07e2c22b8c5c5d3cce');
        $this->checkFile('include/tcpdf/fonts/freesansb.ctg.z', '545a8d71aed6db0d0f484381919153e5');
        $this->checkFile('include/tcpdf/fonts/freesansb.php', 'bf1c8fcdd3706774086cd133a6e04d45');
        $this->checkFile('include/tcpdf/fonts/freesansb.z', '624c779b5be21bc75a6143c5c6bed476');
        $this->checkFile('include/tcpdf/fonts/freesansbi.ctg.z', '13907e3bfcd13606bdda730ce79e8399');
        $this->checkFile('include/tcpdf/fonts/freesansbi.php', '9b2ce8f93949146d63dfef4d4784ad4c');
        $this->checkFile('include/tcpdf/fonts/freesansbi.z', '4e7e7def683b75b19157aca2512da95c');
        $this->checkFile('include/tcpdf/fonts/freesansi.ctg.z', 'f52ed143368f4a4776d8c79c67e946de');
        $this->checkFile('include/tcpdf/fonts/freesansi.php', '4711cc4662b9136a881497c27b596135');
        $this->checkFile('include/tcpdf/fonts/freesansi.z', '32347eeb8a29a880094fc12ca3f737b2');
        $this->checkFile('include/tcpdf/fonts/freeserif.ctg.z', '0daa9bbabdda3c85e5060086916447d5');
        $this->checkFile('include/tcpdf/fonts/freeserif.php', '02aac38356af65808e08e21f1ddd225d');
        $this->checkFile('include/tcpdf/fonts/freeserif.z', '084dca967854129a0aaec1713a46733e');
        $this->checkFile('include/tcpdf/fonts/freeserifb.ctg.z', 'dfbd810d93a50a07dfcf37bb233cd10b');
        $this->checkFile('include/tcpdf/fonts/freeserifb.php', 'bdf5ae55ea4d553beb785266dd0f9ffa');
        $this->checkFile('include/tcpdf/fonts/freeserifb.z', 'd9b4f759ac774221a94e535647f2a5d4');
        $this->checkFile('include/tcpdf/fonts/freeserifbi.ctg.z', 'b9180475fb312ff211c397b19242cdc2');
        $this->checkFile('include/tcpdf/fonts/freeserifbi.php', '0a9d5e42c711a284436fa6f267e8ab85');
        $this->checkFile('include/tcpdf/fonts/freeserifbi.z', '941a72b661dbada4602f430afcc6e6b1');
        $this->checkFile('include/tcpdf/fonts/freeserifi.ctg.z', 'eab0ec8a49a5c70306868aa902bf9fa6');
        $this->checkFile('include/tcpdf/fonts/freeserifi.php', '463334491415afc3e56661e87196b4f8');
        $this->checkFile('include/tcpdf/fonts/freeserifi.z', '3538a74f377d39d74fbb8cdcdb8c6fa8');
        $this->checkFile('include/tcpdf/fonts/helvetica.php', '2a315fa2593161154c319788f0ef2127');
        $this->checkFile('include/tcpdf/fonts/helveticab.php', '3daad3713df02c15beebd09ceecacacd');
        $this->checkFile('include/tcpdf/fonts/helveticabi.php', 'c22fdc8941f2956e0930b20105870468');
        $this->checkFile('include/tcpdf/fonts/helveticai.php', 'e0a7f23376f50de631db93814aff2e35');
        $this->checkFile('include/tcpdf/fonts/hysmyeongjostdmedium.php', '51f6fe162641de3714866950d5eff4e8');
        $this->checkFile('include/tcpdf/fonts/kozgopromedium.php', '2c5e8a67d1a805aae9842bbad59a873f');
        $this->checkFile('include/tcpdf/fonts/kozminproregular.php', '78fdf805f1cea6cd01912192821ec734');
        $this->checkFile('include/tcpdf/fonts/msungstdlight.php', 'c940b153fb6c5b3498efa181881b5b6c');
        $this->checkFile('include/tcpdf/fonts/pdfacourier.php', '35b71c6a8e678cdaa9d484ebab42c2ca');
        $this->checkFile('include/tcpdf/fonts/pdfacourier.z', 'db1790e0fe82682912346b130a1c18ed');
        $this->checkFile('include/tcpdf/fonts/pdfacourierb.php', '5aeb1084e3a6ae5ef7ecc2bfc7a15592');
        $this->checkFile('include/tcpdf/fonts/pdfacourierb.z', '1213e9dbdad624c9eeb8c0c4499df2e7');
        $this->checkFile('include/tcpdf/fonts/pdfacourierbi.php', '1f2386bedbebd633223278c1fd25109a');
        $this->checkFile('include/tcpdf/fonts/pdfacourierbi.z', '15331f3dc06c251d4e70172b102b6c27');
        $this->checkFile('include/tcpdf/fonts/pdfacourieri.php', '8702f5d6fbad08bf74378506ef376f83');
        $this->checkFile('include/tcpdf/fonts/pdfacourieri.z', '8250c16214460a972f33820c056d6ed1');
        $this->checkFile('include/tcpdf/fonts/pdfahelvetica.php', 'b8f1f393d7a247fdfe7668acf776e9d2');
        $this->checkFile('include/tcpdf/fonts/pdfahelvetica.z', '3a95f101300286c33f2ae8cc4e105029');
        $this->checkFile('include/tcpdf/fonts/pdfahelveticab.php', '36cc4107f0d39d89b8031042c4159468');
        $this->checkFile('include/tcpdf/fonts/pdfahelveticab.z', '718087c09de2e30da4b348a474687652');
        $this->checkFile('include/tcpdf/fonts/pdfahelveticabi.php', '351ce642d2008500c8780cce574acdb2');
        $this->checkFile('include/tcpdf/fonts/pdfahelveticabi.z', '19753dca7aaacbd7aa38c86ae5565fb9');
        $this->checkFile('include/tcpdf/fonts/pdfahelveticai.php', 'fa8aa7a5c2077676637614809bc0ea0c');
        $this->checkFile('include/tcpdf/fonts/pdfahelveticai.z', '04f68b3d4cd7d6bc69dbcc10d2888002');
        $this->checkFile('include/tcpdf/fonts/pdfasymbol.php', 'a874a391c41c223a007297af0fc82d71');
        $this->checkFile('include/tcpdf/fonts/pdfasymbol.z', 'f3d1e27ac78ef1f985cd42365b3604d0');
        $this->checkFile('include/tcpdf/fonts/pdfatimes.php', '287cb7bb6e6966708534cb9ed48d48ac');
        $this->checkFile('include/tcpdf/fonts/pdfatimes.z', 'b1cabe1c591ed9bd76afff6b00f32dc4');
        $this->checkFile('include/tcpdf/fonts/pdfatimesb.php', '8f55434707b160cf1a8331d27e37e7e4');
        $this->checkFile('include/tcpdf/fonts/pdfatimesb.z', '807af038ca9bf1036916265df16bacb4');
        $this->checkFile('include/tcpdf/fonts/pdfatimesbi.php', '2937220203e5a52762f5c9a4527e1988');
        $this->checkFile('include/tcpdf/fonts/pdfatimesbi.z', '181cfa98e2e195d89255fae25bbff32d');
        $this->checkFile('include/tcpdf/fonts/pdfatimesi.php', 'e0d060c7f70126e74c443b72ae560791');
        $this->checkFile('include/tcpdf/fonts/pdfatimesi.z', 'ccd6c02b787b16078ecd92c0942163c8');
        $this->checkFile('include/tcpdf/fonts/pdfazapfdingbats.php', '34b9ef2cadf050ad58f391a7990c6975');
        $this->checkFile('include/tcpdf/fonts/pdfazapfdingbats.z', 'cdf0f9187269fe46938e4009eeddf8e3');
        $this->checkFile('include/tcpdf/fonts/stsongstdlight.php', 'eb85dc872664c0769e9fab1b7540b4d5');
        $this->checkFile('include/tcpdf/fonts/symbol.php', '20e28c8b386ddbb38ead777f717d7c44');
        $this->checkFile('include/tcpdf/fonts/times.php', 'a75033315ee90464410b47cc27ce9ff0');
        $this->checkFile('include/tcpdf/fonts/timesb.php', 'ad485022027867116de0bf6c25b1854a');
        $this->checkFile('include/tcpdf/fonts/timesbi.php', 'a5f3fbbef1831fe0bcd060edb6e5010b');
        $this->checkFile('include/tcpdf/fonts/timesi.php', '8fd8e9a11cca513a4da0f25ff1a24149');
        $this->checkFile('include/tcpdf/fonts/uni2cid_ac15.php', '96c6b586a6afb6d72dc8b93b30f844d5');
        $this->checkFile('include/tcpdf/fonts/uni2cid_ag15.php', '0f6007361d5e4c8f34a2e83d402567b1');
        $this->checkFile('include/tcpdf/fonts/uni2cid_aj16.php', 'c458a95a74915bb3e01102060bf3d27c');
        $this->checkFile('include/tcpdf/fonts/uni2cid_ak12.php', '7ad3c70ef87d3657f918d3ee3649f31f');
        $this->checkFile('include/tcpdf/fonts/zapfdingbats.php', '191b3c2e856e750c06c0ba7987f902fb');
        $this->checkFile('include/tcpdf/htmlcolors.php', '08717a403044a836e619973a060d6a0b');
        $this->checkFile('include/tcpdf/include/barcodes/datamatrix.php', '9a29da1e201fb23de4f499adbb9f6a71');
        $this->checkFile('include/tcpdf/include/barcodes/pdf417.php', '3abe66ba8da6b6bf9cf1c6b0e907d51d');
        $this->checkFile('include/tcpdf/include/barcodes/qrcode.php', 'f214c50485dc7301cdd70b23e46193a0');
        $this->checkFile('include/tcpdf/include/sRGB.icc', '7fb30d688bf82d32a0e748daf3dba95d');
        $this->checkFile('include/tcpdf/include/tcpdf_colors.php', '4cfe22d56a39d9ffd7c38cee820657cf');
        $this->checkFile('include/tcpdf/include/tcpdf_filters.php', 'fb794db6e06fa3cf7479fc889894caf3');
        $this->checkFile('include/tcpdf/include/tcpdf_font_data.php', '8f83bbc144d70505672f82679546c72d');
        $this->checkFile('include/tcpdf/include/tcpdf_fonts.php', '21c2fb254f21b8df1b62ef4d24466673');
        $this->checkFile('include/tcpdf/include/tcpdf_images.php', '1c062e25736fcff31d8ba41cadee7571');
        $this->checkFile('include/tcpdf/include/tcpdf_static.php', 'e2b838f8ba3ce3e6c643db109b3e58d4');
        $this->checkFile('include/tcpdf/tcpdf.php', '381557bb328d8ca0722d9d8e59fc6a85');
        $this->checkFile('include/tcpdf/tcpdf_autoconfig.php', 'bcb93bbeb8cf2831e49ff5541d277a1f');
        $this->checkFile('include/tcpdf/tcpdf_barcodes_1d.php', 'd306e9ad7b8b67464493c3281417afdc');
        $this->checkFile('include/tcpdf/tcpdf_barcodes_2d.php', 'bc489174d04512daeb2fe3d86c3894fb');
        $this->checkFile('include/tcpdf/tcpdf_import.php', '09eaafab82a3fdea8ea5b715f68b5cec');
        $this->checkFile('include/tcpdf/tcpdf_parser.php', 'e8792d5153a1f644c4dada1efcb28770');
        $this->checkFile('include/tcpdf/tools/.htaccess', '183e8e4abc660eaba3c3da4bb82b0bcf');
        $this->checkFile('include/tcpdf/tools/convert_fonts_examples.txt', '01d1bb3c8c8bdb35f3837e2715dbe681');
        $this->checkFile('include/tcpdf/tools/tcpdf_addfont.php', '9467022f9c3f6c7aef00b3896e0ba092');
        $this->checkFile('include/tcpdf/unicode_data.php', 'e4e5d48e43acd5ee4a1e333f5fbf56a7');
        $this->checkFile('index.php', 'a250b5449761fc5dd8a673cf195d1a82');
        $this->checkFile('install/check.php', 'fe88cdff780d403abaf7dc5b0eae31ae');
        $this->checkFile('install/db/gpf/compressed_tables.sql', '5fe4262b211289ca81d52ab1c5afb8ee');
        $this->checkFile('install/db/gpf/create.sql', 'e6ad96922c1c567e2a56143ced8ddb07');
        $this->checkFile('install/db/gpf/update_1.0.1.php', '92ce07d65922a71d38b53b07d3087fae');
        $this->checkFile('install/db/gpf/update_1.0.10.sql', '20e9075dce8c93c7bc5253aed3f91d38');
        $this->checkFile('install/db/gpf/update_1.0.11.sql', 'd3389a7f5eb0531894078f7fca1ef079');
        $this->checkFile('install/db/gpf/update_1.0.12.sql', '1d3ac3a60bb9637b24b8a7aa058d1ee4');
        $this->checkFile('install/db/gpf/update_1.0.13.sql', 'e8abb311d24358a6854d353a79a7d83d');
        $this->checkFile('install/db/gpf/update_1.0.14.sql', '4246bccdfe1e55a2b52cc0f24e0f73ff');
        $this->checkFile('install/db/gpf/update_1.0.15.sql', '6d37e2a2a1c9e23758348ef493d06289');
        $this->checkFile('install/db/gpf/update_1.0.16.sql', '097e137609a10354312be2e605bede48');
        $this->checkFile('install/db/gpf/update_1.0.17.sql', 'd9b4f3fa11f7beb91856db4ae07a862c');
        $this->checkFile('install/db/gpf/update_1.0.18.sql', 'a27a958669aaca43bd263e5be1059ea3');
        $this->checkFile('install/db/gpf/update_1.0.19.sql', 'fcd2421263dbc9c65109f35647843aab');
        $this->checkFile('install/db/gpf/update_1.0.2.sql', '0e2b1049b21be69aa894d2d77d002d98');
        $this->checkFile('install/db/gpf/update_1.0.20.sql', 'a146345b1ebed5bf20f62bde478e137b');
        $this->checkFile('install/db/gpf/update_1.0.21.sql', '8571cb271ebcfe95ebc1cc801a854c75');
        $this->checkFile('install/db/gpf/update_1.0.22.sql', '83b11eebb1ea3a947e4f3e64f7521fe8');
        $this->checkFile('install/db/gpf/update_1.0.23.sql', '35467de8359f6a9b8e1782c9dae66cf6');
        $this->checkFile('install/db/gpf/update_1.0.24.php', '579f46907ee25085a0ef33a895d5b2ac');
        $this->checkFile('install/db/gpf/update_1.0.25.sql', '1a0b52cd6debbb795db5a903e0ca484f');
        $this->checkFile('install/db/gpf/update_1.0.26.sql', 'b8055a194ad1947c14496f5e41e0854d');
        $this->checkFile('install/db/gpf/update_1.0.27.sql', 'b8370aea1ab1b988cc0a18daeec81f33');
        $this->checkFile('install/db/gpf/update_1.0.28.sql', '503dad166d4010b3a10fd7ca278c4faa');
        $this->checkFile('install/db/gpf/update_1.0.29.sql', '9c9926866ea52b6b24a4b22575f6c87f');
        $this->checkFile('install/db/gpf/update_1.0.3.sql', 'babae8bf9c9b298da468077a674bcd23');
        $this->checkFile('install/db/gpf/update_1.0.30.sql', '80322753d3470f610eff3eb62656dc43');
        $this->checkFile('install/db/gpf/update_1.0.4.sql', '58126b5f3e6e71bccadb9ceeaa195e91');
        $this->checkFile('install/db/gpf/update_1.0.5.sql', '13be3cfd272777393486f188416294f1');
        $this->checkFile('install/db/gpf/update_1.0.6.sql', '1ca47e667f1acc3c1f6ba152aec11bc2');
        $this->checkFile('install/db/gpf/update_1.0.7.sql', '11f4e16348de4f69dbaecad6dfc24e21');
        $this->checkFile('install/db/gpf/update_1.0.8.sql', '6cad49754629862652768b7c9fc2bdf7');
        $this->checkFile('install/db/gpf/update_1.0.9.php', '1ec5dbedf858bbcebcaa91f038d02dda');
        $this->checkFile('install/db/gpf/update_1.1.0.sql', '63db88039663906d20e79c4172e18f83');
        $this->checkFile('install/db/gpf/update_1.1.1.sql', '726aa6f68d3d1c07af8fee79c91f3a19');
        $this->checkFile('install/db/gpf/update_1.1.10.php', 'b67076ad71d1b6def8ec9942da89e17c');
        $this->checkFile('install/db/gpf/update_1.1.11.sql', '78db52ad2504f5bc276b384d567b9e19');
        $this->checkFile('install/db/gpf/update_1.1.12.sql', '7e0fe826aa2afbfac1d5226f77157263');
        $this->checkFile('install/db/gpf/update_1.1.13.sql', 'f78abd797972aadbdb9dfbbe81106ffe');
        $this->checkFile('install/db/gpf/update_1.1.14.sql', 'd9f3a5167c4fbfdc7c41d0a089e93ea4');
        $this->checkFile('install/db/gpf/update_1.1.15.sql', '138293df6f0bd58a40d835fda173e1d9');
        $this->checkFile('install/db/gpf/update_1.1.2.sql', '492faca8582087b2da0131e433024fc6');
        $this->checkFile('install/db/gpf/update_1.1.3.php', 'a62f09238079cd21149ff834fddb1981');
        $this->checkFile('install/db/gpf/update_1.1.4.sql', '2c35eefcf28a654155b52deb00def384');
        $this->checkFile('install/db/gpf/update_1.1.5.sql', '573b450de8e300a360f615f46134f3ef');
        $this->checkFile('install/db/gpf/update_1.1.6.sql', '725951ef84150e7fb232b8831867bd91');
        $this->checkFile('install/db/gpf/update_1.1.7.sql', '27a45c078702dd1e494b18bd9faf75b7');
        $this->checkFile('install/db/gpf/update_1.1.8.sql', '4c9278b9277af75a90b444e2496ba102');
        $this->checkFile('install/db/gpf/update_1.1.9.sql', 'f377f57c6832af32987a96607ff2ab9f');
        $this->checkFile('install/db/gpf/update_1.2.0.php', '6f8e4171bab303292d6cbf9c20414456');
        $this->checkFile('install/db/gpf/update_1.2.1.sql', 'd97178bbe900871c78157ec240e4784b');
        $this->checkFile('install/db/gpf/update_1.2.10.sql', 'c95d92390939ddb9a574bd9c644d0e64');
        $this->checkFile('install/db/gpf/update_1.2.2.php', '488bb0e8b5d5085cbae26803281d2fff');
        $this->checkFile('install/db/gpf/update_1.2.3.php', 'e1d83e1007d5c4dd696efe5108bf1e51');
        $this->checkFile('install/db/gpf/update_1.2.4.sql', 'd66cdc8cafb997ea23f2596a106ec479');
        $this->checkFile('install/db/gpf/update_1.2.5.php', 'a1606930ff0eebbabaec0e24afb623cc');
        $this->checkFile('install/db/gpf/update_1.2.6.sql', 'd91a4e4953414e8554c6b8c475d1563d');
        $this->checkFile('install/db/gpf/update_1.2.7.php', 'eeb2c5c09cfbada8d71e35ed0da88946');
        $this->checkFile('install/db/gpf/update_1.2.8.sql', '8e91a39d87a6ba41e07130aa25628a3e');
        $this->checkFile('install/db/gpf/update_1.2.9.sql', '87425b9d66acb8a28067adbb94e7c345');
        $this->checkFile('install/db/gpf/update_1.3.0.php', 'a9da24dc2959500919519660610a4a85');
        $this->checkFile('install/db/gpf/update_1.3.1.php', '70eae932a4f49dd49e4ea176bb25e3f8');
        $this->checkFile('install/db/gpf/update_1.3.10.php', '78db4cba386a8781d72d681a736f549a');
        $this->checkFile('install/db/gpf/update_1.3.11.php', 'cdddd9088e23169ca2415a826ea91c0a');
        $this->checkFile('install/db/gpf/update_1.3.12.php', '69dd510054edf1b7a3ae8863848c4e55');
        $this->checkFile('install/db/gpf/update_1.3.13.php', '90fc29207c72f93468c7e6607081b428');
        $this->checkFile('install/db/gpf/update_1.3.14.php', 'ff789a7e74558e9876e839e0539bc9c1');
        $this->checkFile('install/db/gpf/update_1.3.15.php', 'e163175e0a55f83d86375d95e61b8ec4');
        $this->checkFile('install/db/gpf/update_1.3.16.php', '5fa8a43576146230456f041e6582bae3');
        $this->checkFile('install/db/gpf/update_1.3.17.php', 'f6e1ba4180d378576af05a43613336a2');
        $this->checkFile('install/db/gpf/update_1.3.18.php', '73b14da0b3d46ca91115d5e3ff528738');
        $this->checkFile('install/db/gpf/update_1.3.19.php', '8f1b6300dde66e6b9831fbd51e91c2fb');
        $this->checkFile('install/db/gpf/update_1.3.2.php', 'afae577417e92f15f1b0dd47da69bcf5');
        $this->checkFile('install/db/gpf/update_1.3.20.php', '7983e48f016f4642929b45f06f148d44');
        $this->checkFile('install/db/gpf/update_1.3.21.php', 'a50797c02e678b1d53d86246ff16f097');
        $this->checkFile('install/db/gpf/update_1.3.22.php', '31f4894981216d583eb31f2eb054c222');
        $this->checkFile('install/db/gpf/update_1.3.23.php', '8ec1e6c6f642d13b883a582ccf16a5c6');
        $this->checkFile('install/db/gpf/update_1.3.24.php', '29f1e42a150ace0d569d47257278d1a6');
        $this->checkFile('install/db/gpf/update_1.3.25.php', '4e6e3a01875be018c7549373431dca79');
        $this->checkFile('install/db/gpf/update_1.3.26.php', '93189173d3e84db494c35b62bacf2b60');
        $this->checkFile('install/db/gpf/update_1.3.27.php', 'cb9cfa998db1f910188f1cf67be7de05');
        $this->checkFile('install/db/gpf/update_1.3.28.php', '4a2f0ea0c1185ca3b165768534a80e02');
        $this->checkFile('install/db/gpf/update_1.3.29.php', '8ee3899396a9e05bea69b859b38f0ea1');
        $this->checkFile('install/db/gpf/update_1.3.3.php', '6d3365d3a0503cba025ad2aaefb9a2a2');
        $this->checkFile('install/db/gpf/update_1.3.30.php', 'd192468845c830d7d7d3f6c0eedc158a');
        $this->checkFile('install/db/gpf/update_1.3.31.php', '485b75e80e462abffd5726348046fc3e');
        $this->checkFile('install/db/gpf/update_1.3.32.php', '52ec657cbbeb97ef483acf5338f7d8f5');
        $this->checkFile('install/db/gpf/update_1.3.33.php', '542fb18898c636d192df9bb0d650dd73');
        $this->checkFile('install/db/gpf/update_1.3.34.php', '5272ef492e2482f0677a10cee1a24a28');
        $this->checkFile('install/db/gpf/update_1.3.35.php', '3a26cbdaa2136d7c692f29606d4045f1');
        $this->checkFile('install/db/gpf/update_1.3.36.php', '827861b3f2b191a228ec27f554aeabd7');
        $this->checkFile('install/db/gpf/update_1.3.37.php', '3cf9cf81a159ca2a50acb000558052d7');
        $this->checkFile('install/db/gpf/update_1.3.38.php', '2ec26ae8041c9891f5738288c4fca955');
        $this->checkFile('install/db/gpf/update_1.3.39.php', 'bd67f994d09d5cbe84233b1f7d52f09a');
        $this->checkFile('install/db/gpf/update_1.3.4.php', '21b54e3263438985987690fb6832b88c');
        $this->checkFile('install/db/gpf/update_1.3.40.php', '76d678566197ab2a1c2b7ae74f9e08e3');
        $this->checkFile('install/db/gpf/update_1.3.41.php', '7d7f627639b134f91784576a3f2639b7');
        $this->checkFile('install/db/gpf/update_1.3.42.php', 'ccbe42e143c2efc1400f07aec8ecddf2');
        $this->checkFile('install/db/gpf/update_1.3.43.php', '3b05140202c7b97611cb4fd0f3c49d86');
        $this->checkFile('install/db/gpf/update_1.3.44.php', '817d8bbff91e2911abace8f9fb1c2fdc');
        $this->checkFile('install/db/gpf/update_1.3.45.php', 'c8a30b3123dc25b0b26c0d300f7de962');
        $this->checkFile('install/db/gpf/update_1.3.46.php', '996f0bfdee1b61d7b436142aa5910e52');
        $this->checkFile('install/db/gpf/update_1.3.47.php', '2785463552d65e7025b65287ef841a04');
        $this->checkFile('install/db/gpf/update_1.3.48.php', '3b78f3b2011c4d04998c8a74908938c6');
        $this->checkFile('install/db/gpf/update_1.3.49.php', 'f01639232e8d0c757cb20295f17d4566');
        $this->checkFile('install/db/gpf/update_1.3.5.php', 'ff9b94355f8bc42106ea8ff78904821a');
        $this->checkFile('install/db/gpf/update_1.3.50.php', '2b92b8aa9792e45ecadefeab1d2033fe');
        $this->checkFile('install/db/gpf/update_1.3.51.php', '5528aa6485e4b0c1bc747ecce3289282');
        $this->checkFile('install/db/gpf/update_1.3.52.php', 'a4e5b99c60cfba86b70f5a4f907e4ffa');
        $this->checkFile('install/db/gpf/update_1.3.53.php', 'c10491774c21189421e90f104a8d2c3d');
        $this->checkFile('install/db/gpf/update_1.3.54.php', '51596cc7f7640a758d1e2d743a57ffa9');
        $this->checkFile('install/db/gpf/update_1.3.55.php', '450bc2e7b9f1e3c573e34f7d366cdcba');
        $this->checkFile('install/db/gpf/update_1.3.56.php', 'ce6f2bec14f955d7dd057222d10b7808');
        $this->checkFile('install/db/gpf/update_1.3.57.php', '061d9a7cbc4a493110ebebea9d952dff');
        $this->checkFile('install/db/gpf/update_1.3.58.php', '892ad7d2ea366fc790132197a7c2a74e');
        $this->checkFile('install/db/gpf/update_1.3.59.php', '811e1150858ebe5f975c125e139e2018');
        $this->checkFile('install/db/gpf/update_1.3.6.php', 'fe47f503830446c6d5be498ac37c611f');
        $this->checkFile('install/db/gpf/update_1.3.60.php', '90464ac2a7f6c35800b0ee186f3b9adf');
        $this->checkFile('install/db/gpf/update_1.3.61.php', 'fbb5e61293b0fbeb2e9759c75005e63e');
        $this->checkFile('install/db/gpf/update_1.3.62.php', 'e441bc5a7b93346093b217eefc5438ab');
        $this->checkFile('install/db/gpf/update_1.3.63.php', '25b76c2815d56babd31230e643ec3e7a');
        $this->checkFile('install/db/gpf/update_1.3.64.php', '1c892b936d1e71c4daa9781a2c036af4');
        $this->checkFile('install/db/gpf/update_1.3.65.php', 'b9000604b239f10bcf8a68d389493f12');
        $this->checkFile('install/db/gpf/update_1.3.66.php', '9ea4db4ce4202ec413c28ac1fc03dbae');
        $this->checkFile('install/db/gpf/update_1.3.7.php', '78b77ec5ddab759bdd2516e16b4af6fe');
        $this->checkFile('install/db/pap/compressed_tables.sql', '1371f4c0852064b8d4ff467143aa7f8c');
        $this->checkFile('install/db/pap/create.sql', '6aca47748a698d4407f8b7c80002962b');
        $this->checkFile('install/db/pap/update_4.0.1.sql', '42e7d526dcc536fff8f73e1f51079a50');
        $this->checkFile('install/db/pap/update_4.0.10.sql', 'd493f9b6e9c19c759a8f46f635136141');
        $this->checkFile('install/db/pap/update_4.0.11.sql', '2dc89f3271dcedaa52ae5956c68142e1');
        $this->checkFile('install/db/pap/update_4.0.12.sql', 'af81ebe81401df8b1d43579c4b7231a7');
        $this->checkFile('install/db/pap/update_4.0.13.sql', '943cc65898c362d77f97da4695445d8f');
        $this->checkFile('install/db/pap/update_4.0.2.sql', '054309d87366de849aadc4744ffc996a');
        $this->checkFile('install/db/pap/update_4.0.3.sql', 'f150e3388dd6bc3aa4ba85dd9988d3d9');
        $this->checkFile('install/db/pap/update_4.0.4.sql', 'deaf82d657dd2d0c8f333346dff550c1');
        $this->checkFile('install/db/pap/update_4.0.5.sql', '57c79c98ad023aaa01640c89fa13880c');
        $this->checkFile('install/db/pap/update_4.0.6.sql', 'b0e5983e6f2947b300d00beba4829b83');
        $this->checkFile('install/db/pap/update_4.0.7.sql', '3dbace46adb249a9753b2c68ad63ad7b');
        $this->checkFile('install/db/pap/update_4.0.8.sql', 'd7792e8a06404d0cd7249c4c6998f98b');
        $this->checkFile('install/db/pap/update_4.0.9.php', '250eb1a9c40faedb9bf065b17836605c');
        $this->checkFile('install/db/pap/update_4.1.1.sql', 'b9b0c038a6b57c964b3be5ed555f8ed6');
        $this->checkFile('install/db/pap/update_4.1.10.sql', '58fe0d23f390593372d82fbe53069df4');
        $this->checkFile('install/db/pap/update_4.1.11.sql', '6c439c9e0afaadb03055ff753a71a740');
        $this->checkFile('install/db/pap/update_4.1.12.sql', '046efa7c9e51f203a8bbd1239585cf96');
        $this->checkFile('install/db/pap/update_4.1.13.sql', '6bc2a659ea8a380f49037a5201ae9972');
        $this->checkFile('install/db/pap/update_4.1.14.php', '6c18c7f79a2aac41b2d32118561f72a0');
        $this->checkFile('install/db/pap/update_4.1.15.php', '2e84c5517efd3c550d6d802fac2e5146');
        $this->checkFile('install/db/pap/update_4.1.16.sql', '9c4fd828314e34225ce34c22cc91b675');
        $this->checkFile('install/db/pap/update_4.1.17.php', '7cf5c51124e836c85f2f3f58a32ee694');
        $this->checkFile('install/db/pap/update_4.1.18.sql', 'e1ba2103fa2191ef8e113969390cd459');
        $this->checkFile('install/db/pap/update_4.1.19.sql', '90ee76ea40457ae3109ce0e3b7d6735b');
        $this->checkFile('install/db/pap/update_4.1.2.sql', '59a953ac05678391b108f58b1d3e3d47');
        $this->checkFile('install/db/pap/update_4.1.20.sql', '3fa7d133073b243944e10ccaa35c05f6');
        $this->checkFile('install/db/pap/update_4.1.21.sql', '8aec11402e922b1de1e17754ddaf8225');
        $this->checkFile('install/db/pap/update_4.1.22.sql', 'd41d8cd98f00b204e9800998ecf8427e');
        $this->checkFile('install/db/pap/update_4.1.23.sql', '15a76fa13148983f8456915595eac35d');
        $this->checkFile('install/db/pap/update_4.1.24.php', 'cad9492a5c8e8c63e2c2d57733aeade9');
        $this->checkFile('install/db/pap/update_4.1.25.sql', '5c30aac4f183987c19d5a8c0cf728da3');
        $this->checkFile('install/db/pap/update_4.1.26.sql', 'b615e85c65061fb397b5d235175c0074');
        $this->checkFile('install/db/pap/update_4.1.27.sql', 'b7d7528a9b8e2e01d796404e1d086aec');
        $this->checkFile('install/db/pap/update_4.1.28.php', 'e861202c8b66991145169a8d7562e55a');
        $this->checkFile('install/db/pap/update_4.1.29.sql', '5039c6296e131d1fd8de5d30bc7cf4dc');
        $this->checkFile('install/db/pap/update_4.1.3.php', 'c7450684f3872bd6064c800d0acf7a0e');
        $this->checkFile('install/db/pap/update_4.1.30.sql', '6e633c66d8c1498e923ea8f0f30bb7c9');
        $this->checkFile('install/db/pap/update_4.1.31.php', '66c150d132fef60bc93afbd90e47f69a');
        $this->checkFile('install/db/pap/update_4.1.32.sql', '90d883644dfb97ad3d5c4a7c3b7600a1');
        $this->checkFile('install/db/pap/update_4.1.33.sql', 'd41d8cd98f00b204e9800998ecf8427e');
        $this->checkFile('install/db/pap/update_4.1.34.php', '95a85ab976a49a41b95c98fa098e588c');
        $this->checkFile('install/db/pap/update_4.1.35.sql', 'c3b87005f2b25f4ce768bb31ab8ce819');
        $this->checkFile('install/db/pap/update_4.1.36.php', 'd7ef492dcac2740b5f08dea085cd1cc9');
        $this->checkFile('install/db/pap/update_4.1.37.sql', '7d8469cff4dc0b981d84ed6080437293');
        $this->checkFile('install/db/pap/update_4.1.4.sql', 'aacd843f957b079ed54819242866f730');
        $this->checkFile('install/db/pap/update_4.1.5.sql', '48bc2022945d9249bee437998ed8d45c');
        $this->checkFile('install/db/pap/update_4.1.6.sql', '94838bcae8583f43632966cb33d7c043');
        $this->checkFile('install/db/pap/update_4.1.7.php', '091394c06547ab9aa30d36b7c216d225');
        $this->checkFile('install/db/pap/update_4.1.8.sql', 'c373c2b5a26f875ade0af5192f2ed50b');
        $this->checkFile('install/db/pap/update_4.1.9.php', '32643e1b97b1ba2a915065714fb162fb');
        $this->checkFile('install/db/pap/update_4.2.1.sql', 'de71bb8d9b43094263706a5ca2d14e07');
        $this->checkFile('install/db/pap/update_4.2.10.sql', '8ce1768741a87479f29a43e2b280626a');
        $this->checkFile('install/db/pap/update_4.2.11.sql', '5aa2412e845d61a8341e01eb40dfa91e');
        $this->checkFile('install/db/pap/update_4.2.2.php', '7ae06552206445dce224c58a3ccf5141');
        $this->checkFile('install/db/pap/update_4.2.3.sql', 'b39fea9a4081e5e42bb16a6559112779');
        $this->checkFile('install/db/pap/update_4.2.4.php', 'aea64e059f3ed39c7ba74def90ad19e8');
        $this->checkFile('install/db/pap/update_4.2.5.php', '77be211f03aa899eaa6c331acb4ece6f');
        $this->checkFile('install/db/pap/update_4.2.6.sql', 'e9cc6cfd919e8f7f6a2405653db104f2');
        $this->checkFile('install/db/pap/update_4.2.7.php', '9fc3701b4f20610c93db0ef4297b937a');
        $this->checkFile('install/db/pap/update_4.2.8.sql', 'd41d8cd98f00b204e9800998ecf8427e');
        $this->checkFile('install/db/pap/update_4.2.9.sql', '668dfa498fc038b5ae99982fa6c03482');
        $this->checkFile('install/db/pap/update_4.3.0.php', '887cb95db4fd7dda0f22b4ed3022f562');
        $this->checkFile('install/db/pap/update_4.3.1.sql', 'eb869a9159a750b1971bd63baffd8104');
        $this->checkFile('install/db/pap/update_4.3.10.sql', 'c0c9b73b2666b2550a5f74defbe65521');
        $this->checkFile('install/db/pap/update_4.3.100.sql', 'a73c7fc71c04f0a14e5aa96f8c02c4b7');
        $this->checkFile('install/db/pap/update_4.3.101.sql', '14dea5cb78d82fac958b56face8ae220');
        $this->checkFile('install/db/pap/update_4.3.102.sql', 'aae9574db1d237d5e1a22bd8509c8633');
        $this->checkFile('install/db/pap/update_4.3.103.sql', '9e93db261ed08c3c7031a7a475194dc6');
        $this->checkFile('install/db/pap/update_4.3.104.sql', 'c1715e7008bc0c8a7fff929b09c065b8');
        $this->checkFile('install/db/pap/update_4.3.105.sql', 'e2beabf382301a40774e796de663b8ac');
        $this->checkFile('install/db/pap/update_4.3.106.sql', '3c3238d78670be71b21e5d779aae85b2');
        $this->checkFile('install/db/pap/update_4.3.107.sql', '11b7d8d5aba0480bac53991b6e3a7ae7');
        $this->checkFile('install/db/pap/update_4.3.108.sql', 'c93c7e1d2ad39fab5f2610685dd6b9c8');
        $this->checkFile('install/db/pap/update_4.3.109.sql', '90a0f86065864e2c4e4692711adab966');
        $this->checkFile('install/db/pap/update_4.3.11.sql', 'dc65c0e7b6ca06568048c78ba60429ab');
        $this->checkFile('install/db/pap/update_4.3.110.sql', '032806b7c770c43cffe094b5bf5cbd72');
        $this->checkFile('install/db/pap/update_4.3.111.sql', '929f75ec7e67ee95076b545234fe8fd6');
        $this->checkFile('install/db/pap/update_4.3.112.sql', '0513ee38289965782dc19152f4b8a74f');
        $this->checkFile('install/db/pap/update_4.3.113.sql', 'bcc81111a37f09ec8d33c2bf52e28c6a');
        $this->checkFile('install/db/pap/update_4.3.114.sql', '16d5a9ea66f86e87f403dd36462949d5');
        $this->checkFile('install/db/pap/update_4.3.115.sql', '3f050c450430de19a9ad5c143f077f48');
        $this->checkFile('install/db/pap/update_4.3.116.sql', '3f1b9eefc37c69710132f21457d1266c');
        $this->checkFile('install/db/pap/update_4.3.117.sql', 'd8ec4be0708cd1f6e2a773945d6ff8da');
        $this->checkFile('install/db/pap/update_4.3.118.sql', '5afc7c4c85250efeae3a72292147a25f');
        $this->checkFile('install/db/pap/update_4.3.119.sql', '6eb9d471f014ea95750398188e679773');
        $this->checkFile('install/db/pap/update_4.3.12.sql', '03fd66f9a0af822872945d786bfe390f');
        $this->checkFile('install/db/pap/update_4.3.122.sql', 'ad2a61e315310b57071fd47375ed5ef7');
        $this->checkFile('install/db/pap/update_4.3.123.php', 'c8606e6558d942b8ed926794147aa299');
        $this->checkFile('install/db/pap/update_4.3.124.sql', 'a3ca85943e38b12f8db2f96aa997df83');
        $this->checkFile('install/db/pap/update_4.3.125.sql', 'df7f8a6c6b64c43b74cf2270445a6c2b');
        $this->checkFile('install/db/pap/update_4.3.126.php', 'c0c5f6d52025f9a360b29149798e0c90');
        $this->checkFile('install/db/pap/update_4.3.127.sql', '50c30e7ff265e6c57d17dc8363f431c6');
        $this->checkFile('install/db/pap/update_4.3.128.sql', '2e6d40c6f9f6f0eeee0a6314466b0590');
        $this->checkFile('install/db/pap/update_4.3.129.sql', '2e2378b1aa330f1c6bf831a4c5bc5579');
        $this->checkFile('install/db/pap/update_4.3.13.sql', '4725058fd7b08c6a212a8e99bd3010be');
        $this->checkFile('install/db/pap/update_4.3.130.php', 'f6bb3d20b417c9b4341811396ee1bd5b');
        $this->checkFile('install/db/pap/update_4.3.131.sql', 'adf50ba065611893a3a15ea1affc8de7');
        $this->checkFile('install/db/pap/update_4.3.132.sql', '714d84ef8ac160a21c09c70e3ee9a2ff');
        $this->checkFile('install/db/pap/update_4.3.133.sql', 'f9f3d046ac9f35237f7b07ef15dd50a1');
        $this->checkFile('install/db/pap/update_4.3.134.php', 'e3d661726e60d661a6534d1923d21a35');
        $this->checkFile('install/db/pap/update_4.3.135.php', 'a3fd7a25e139e41429bd881f573663cc');
        $this->checkFile('install/db/pap/update_4.3.14.sql', '7763fb0d79d81b2ceb90c4f291c555db');
        $this->checkFile('install/db/pap/update_4.3.15.sql', 'dd4d4d7b1b2579d7ef1b8e9abeda8653');
        $this->checkFile('install/db/pap/update_4.3.16.sql', 'a06c141e0633536ed522bd436ea4962a');
        $this->checkFile('install/db/pap/update_4.3.17.sql', 'a2a1fe39dfb5093429f2cdc6464f5699');
        $this->checkFile('install/db/pap/update_4.3.18.sql', 'de7115add35987b8b9b22c080e4c8ed2');
        $this->checkFile('install/db/pap/update_4.3.19.sql', 'f4af45816cb0894969292f316802099f');
        $this->checkFile('install/db/pap/update_4.3.2.sql', 'cc6681e4116e972536598370a01ecdf8');
        $this->checkFile('install/db/pap/update_4.3.20.sql', '0b0932d7a0499c2fdf6b655364174df7');
        $this->checkFile('install/db/pap/update_4.3.21.sql', '2fc0cd611c62e26ab0560f940d9a215c');
        $this->checkFile('install/db/pap/update_4.3.22.sql', 'e8276302a2ae889d0d2b404182bc9976');
        $this->checkFile('install/db/pap/update_4.3.23.sql', 'cfa245db0546d3d7afe2a9aed1aa191b');
        $this->checkFile('install/db/pap/update_4.3.24.sql', '0da7895b3d6d5351391b0c8a6f85501a');
        $this->checkFile('install/db/pap/update_4.3.25.sql', '53ebce2f14552aa84a66397ec1febe4b');
        $this->checkFile('install/db/pap/update_4.3.26.sql', '6d9e8681e28f14b0309201434c65da43');
        $this->checkFile('install/db/pap/update_4.3.27.sql', '18c6a4ba2e91943445e2a485366e5a9e');
        $this->checkFile('install/db/pap/update_4.3.28.sql', '3e192b05fe8f0db2e355474b885e1af3');
        $this->checkFile('install/db/pap/update_4.3.29.sql', '0e760e7d05e33cc8bdada66c2b64349b');
        $this->checkFile('install/db/pap/update_4.3.3.sql', '5151a0313b037d38a5c1c1cf4ac45d76');
        $this->checkFile('install/db/pap/update_4.3.30.sql', '82d6e57ded57c863801e17204a02010a');
        $this->checkFile('install/db/pap/update_4.3.31.sql', '136f60545228ffc537e1eb11f1b9e796');
        $this->checkFile('install/db/pap/update_4.3.32.sql', 'fafbc6aa13bd0bcd89efb4299375d046');
        $this->checkFile('install/db/pap/update_4.3.33.sql', '6259481fb317bb139286b8633aa088e3');
        $this->checkFile('install/db/pap/update_4.3.34.sql', '25bc41e5d8fad1a1c444fb44f32702b7');
        $this->checkFile('install/db/pap/update_4.3.35.sql', '81841114ad4ac470d1ebadabcdc4e1f5');
        $this->checkFile('install/db/pap/update_4.3.36.sql', '3761057074f0390c3b2eea6f46c0f3e8');
        $this->checkFile('install/db/pap/update_4.3.37.sql', 'b44a8ace382749fe0536e4a862c1ebbe');
        $this->checkFile('install/db/pap/update_4.3.38.sql', 'd24b8f45e07835f26baac19f59e9a60c');
        $this->checkFile('install/db/pap/update_4.3.39.sql', '4de589197c5045e32329bc0c6ca9af23');
        $this->checkFile('install/db/pap/update_4.3.4.php', '7d981d9002bb6b6e54931bbe0cd9e4ee');
        $this->checkFile('install/db/pap/update_4.3.40.sql', '8e7219d952237093f633272bda10ab46');
        $this->checkFile('install/db/pap/update_4.3.41.sql', '76468674434c706e51028858ed06ebda');
        $this->checkFile('install/db/pap/update_4.3.42.sql', '9cee3ab9053d5769ac2ae1edc93493e6');
        $this->checkFile('install/db/pap/update_4.3.43.sql', '0da6d06eb74a14dcd18e8cf0b0be5b92');
        $this->checkFile('install/db/pap/update_4.3.44.sql', '99104ab2e915604274444341e340a707');
        $this->checkFile('install/db/pap/update_4.3.45.sql', '3ef77ccbb3bd239aed64408edcaa3d75');
        $this->checkFile('install/db/pap/update_4.3.46.sql', 'd02beb0c220a685081cdb00c09a25979');
        $this->checkFile('install/db/pap/update_4.3.47.sql', '41ce2da5faf80dc768aa9d63226449b6');
        $this->checkFile('install/db/pap/update_4.3.48.sql', 'c0a7fe3ed5030943f4cd6d8b84bd1e16');
        $this->checkFile('install/db/pap/update_4.3.49.sql', '4e9b19750c2d3a6a0f0ba8135b83a828');
        $this->checkFile('install/db/pap/update_4.3.5.sql', '3010be8fdde37f157fc2cb8a15a80a04');
        $this->checkFile('install/db/pap/update_4.3.50.sql', 'aceffa26e538e441b6ee01ac6e6367a5');
        $this->checkFile('install/db/pap/update_4.3.51.sql', '1b98703d1b4d8b7a8c02e885b502722e');
        $this->checkFile('install/db/pap/update_4.3.52.sql', 'ffaf4c2b5365408f8525083638e307bd');
        $this->checkFile('install/db/pap/update_4.3.53.sql', 'abaddf42abb10179093b89b53f142ad2');
        $this->checkFile('install/db/pap/update_4.3.54.sql', 'b842787917cd7b4dfd91ab6f84d153f1');
        $this->checkFile('install/db/pap/update_4.3.55.sql', 'de35239ceedf7702e3acb0e272471489');
        $this->checkFile('install/db/pap/update_4.3.56.sql', '18a2e426ad5978227bb9230d0fd40fbd');
        $this->checkFile('install/db/pap/update_4.3.57.sql', '02ae659bf10b74a95971a20272b19801');
        $this->checkFile('install/db/pap/update_4.3.58.sql', '429b3218119393933baefb1b1993e70a');
        $this->checkFile('install/db/pap/update_4.3.59.sql', '4d05762e8e0dbde7920913947b8f9461');
        $this->checkFile('install/db/pap/update_4.3.6.sql', 'e8ea646f4847cc61936a718d7cc676f2');
        $this->checkFile('install/db/pap/update_4.3.60.sql', '3a740045273661d0a32bf6bb5e9348f0');
        $this->checkFile('install/db/pap/update_4.3.61.sql', '0ddb347c196838bbdae19351312a72c8');
        $this->checkFile('install/db/pap/update_4.3.62.sql', '0feff9aaee476444e61936701e9ed235');
        $this->checkFile('install/db/pap/update_4.3.63.sql', '32cb35baf6a05dcb6cedb1eccdb53df2');
        $this->checkFile('install/db/pap/update_4.3.64.sql', 'a9f0c1a1932df99121a6ad0c73dc1f0d');
        $this->checkFile('install/db/pap/update_4.3.65.sql', '876fdf9f1d9b92411c32a34f5c09ea56');
        $this->checkFile('install/db/pap/update_4.3.66.sql', '873054c286061087c8db58ee0f7c3904');
        $this->checkFile('install/db/pap/update_4.3.67.sql', 'dc1745e592b4f753549ce3f7b1076af2');
        $this->checkFile('install/db/pap/update_4.3.68.sql', '62a3ebe1e242b8ead81aff410dae30c1');
        $this->checkFile('install/db/pap/update_4.3.69.sql', '6b67e5da5274285defad2a7c83a11c64');
        $this->checkFile('install/db/pap/update_4.3.7.php', '8e8c1c1dc16184f1d64db3c8f1a1824a');
        $this->checkFile('install/db/pap/update_4.3.70.sql', '6081eda46b0f3c782efe6bdd914d300f');
        $this->checkFile('install/db/pap/update_4.3.71.sql', '6c8dc6737a246f959fc57d7cfcdc037a');
        $this->checkFile('install/db/pap/update_4.3.72.sql', '749998eb634a28069eb51b0bcf03a2ef');
        $this->checkFile('install/db/pap/update_4.3.73.sql', 'aea592ea25478b956f67af23acc77a4e');
        $this->checkFile('install/db/pap/update_4.3.74.sql', '65f1ed0d18472d5a27b9a1aa6b0190ff');
        $this->checkFile('install/db/pap/update_4.3.75.sql', '60b745bbfd3dd07ef41042892175fd59');
        $this->checkFile('install/db/pap/update_4.3.76.sql', 'd8202960d7344ace419b058ff4398448');
        $this->checkFile('install/db/pap/update_4.3.77.sql', '05477ca5fefb13ced6acee685164ba91');
        $this->checkFile('install/db/pap/update_4.3.78.sql', '157ebe1a651fce326fbe4ebf4daa67af');
        $this->checkFile('install/db/pap/update_4.3.79.sql', '5096c61582958658e484cec6526e1e45');
        $this->checkFile('install/db/pap/update_4.3.8.sql', '414dae00a16dfe5fdfaf46ed438d02c8');
        $this->checkFile('install/db/pap/update_4.3.80.sql', '0a29ef1052364456ddccbbb4b0ca2ac0');
        $this->checkFile('install/db/pap/update_4.3.81.sql', '97f4504794f791d11eec5c5877657ff8');
        $this->checkFile('install/db/pap/update_4.3.82.sql', '60788130a6e638ecc6c8dfa372f30e91');
        $this->checkFile('install/db/pap/update_4.3.83.sql', '02011a6162a67dcbb71f2c708a864cf5');
        $this->checkFile('install/db/pap/update_4.3.84.sql', 'a54e65f4b7b182ca31e17fe9f7bf4240');
        $this->checkFile('install/db/pap/update_4.3.85.sql', '4716a4b549d2b646a8a83a644e2055ca');
        $this->checkFile('install/db/pap/update_4.3.86.sql', '4c690d0f1519f337751248952e300d65');
        $this->checkFile('install/db/pap/update_4.3.87.sql', '8100d7462ad8c803b7da9f4feea16d23');
        $this->checkFile('install/db/pap/update_4.3.88.sql', '337591fab2301f5db88d6478c8abc2b4');
        $this->checkFile('install/db/pap/update_4.3.89.sql', '5925b39eff4036b5c8c34095e34e77b4');
        $this->checkFile('install/db/pap/update_4.3.90.sql', 'd0001ac22f0fcdf2eca5ffcea18e58f9');
        $this->checkFile('install/db/pap/update_4.3.91.sql', '6e4ac4fd073b305aaa71b83e5ab082f0');
        $this->checkFile('install/db/pap/update_4.3.92.sql', '6fb003eba18910359f2c20c48a95ca14');
        $this->checkFile('install/db/pap/update_4.3.93.sql', 'a822e09116d3401bc08be5c78e9fd92e');
        $this->checkFile('install/db/pap/update_4.3.94.sql', '513d5095477b287c98f3c1f45ded428f');
        $this->checkFile('install/db/pap/update_4.3.95.sql', '094e0d2600fe87065e1e262507b73e20');
        $this->checkFile('install/db/pap/update_4.3.96.sql', 'e1f65f2aa897b313fe6be6dd589b68dc');
        $this->checkFile('install/db/pap/update_4.3.97.sql', '232a1c45cfc128b182e15f44ef4a7139');
        $this->checkFile('install/db/pap/update_4.3.98.sql', 'a22139b2325997897d8c95f40a134dd3');
        $this->checkFile('install/db/pap/update_4.3.99.sql', '023dbfc98db4322b5dc7f4ee9e35c61b');
        $this->checkFile('install/db/pap/update_4.4.1.sql', 'aea9a22083a0a066b978efbdc7bb59fa');
        $this->checkFile('install/db/pap/update_4.4.10.sql', '17749fe362de76a46b9160a41049c39a');
        $this->checkFile('install/db/pap/update_4.4.11.sql', '8382dd14c81b5e35cba4655b2876340d');
        $this->checkFile('install/db/pap/update_4.4.12.sql', '29c724240adb76b2f959c284eccb575f');
        $this->checkFile('install/db/pap/update_4.4.13.php', '78ab98238c1ecc51c50fdc1003d0beab');
        $this->checkFile('install/db/pap/update_4.4.14.sql', 'c39ca4c6b55e4e57f2b663444a08d194');
        $this->checkFile('install/db/pap/update_4.4.15.sql', 'e8abfab1c26a229f9bf48ba938f23dc8');
        $this->checkFile('install/db/pap/update_4.4.16.sql', '2a0be0e174b1623a9ddc2bfea91af5a7');
        $this->checkFile('install/db/pap/update_4.4.2.sql', '436483a13932426a899dd7185de38ba8');
        $this->checkFile('install/db/pap/update_4.4.3.sql', 'c960dbe7fa1523de1ab879842eeb248a');
        $this->checkFile('install/db/pap/update_4.4.4.php', '56482894d80db0d96beb853327100503');
        $this->checkFile('install/db/pap/update_4.4.5.sql', '1c1eabd71ffc853a8d4185d4e8988c08');
        $this->checkFile('install/db/pap/update_4.4.6.php', '4713d4a614d3139b8abfd3fdaf40b965');
        $this->checkFile('install/db/pap/update_4.4.7.sql', 'caf596bd07166c0035eb6302791b2967');
        $this->checkFile('install/db/pap/update_4.4.8.php', '6c09a49c2aa7a39df16e5195ebe8811e');
        $this->checkFile('install/db/pap/update_4.4.9.php', '56f6db8d87d86c971bccd1b73d5fca8e');
        $this->checkFile('install/db/pap/update_4.5.0.sql', 'fc1f3d9ed5738e332d2e3e3663585e55');
        $this->checkFile('install/db/pap/update_4.5.1.sql', '5544f43a467d16b85245bcd8028084b6');
        $this->checkFile('install/db/pap/update_4.5.10.sql', '1f04ca22bb0f5900dba37ea8cd6eca3e');
        $this->checkFile('install/db/pap/update_4.5.11.sql', 'ef9a39d1d6badad34ef344a590af35d6');
        $this->checkFile('install/db/pap/update_4.5.12.sql', '2ca47203566435ad182b05f47424eeaa');
        $this->checkFile('install/db/pap/update_4.5.13.sql', '3b904e2341a4d56700d7ef0d175f0e49');
        $this->checkFile('install/db/pap/update_4.5.14.sql', '92b56211645b2f86dba46634b25cecbd');
        $this->checkFile('install/db/pap/update_4.5.15.sql', 'a1df398a075c2f4a429152dfa8476068');
        $this->checkFile('install/db/pap/update_4.5.16.sql', 'b51feb33f2bab9108f615aec86597171');
        $this->checkFile('install/db/pap/update_4.5.17.sql', '23f87d8748b08f1c40b61292d7ff1d32');
        $this->checkFile('install/db/pap/update_4.5.18.sql', '39fcef7a9be8fbf7cb1ca96929949831');
        $this->checkFile('install/db/pap/update_4.5.19.sql', '73773833a9f74da80975374a3e8af4ac');
        $this->checkFile('install/db/pap/update_4.5.2.sql', 'fcbf009080369bb19a5370498f5c6552');
        $this->checkFile('install/db/pap/update_4.5.20.php', '4ead6273ed452da575122a365cd1d602');
        $this->checkFile('install/db/pap/update_4.5.21.sql', '1a890cc96701593d351bec868fe6e34c');
        $this->checkFile('install/db/pap/update_4.5.22.sql', '05c451d094e1ca5c40db09700d9d1445');
        $this->checkFile('install/db/pap/update_4.5.23.sql', 'fef3eee9b4818fd8c72e3d127717dabe');
        $this->checkFile('install/db/pap/update_4.5.24.php', '6c2d2e750121bcd21cd364a768553764');
        $this->checkFile('install/db/pap/update_4.5.25.sql', '1e0127d974fd36ce6ddb4ed01359ee90');
        $this->checkFile('install/db/pap/update_4.5.26.php', '47a6830b4df8ee3409b96d73f66f0b9c');
        $this->checkFile('install/db/pap/update_4.5.27.sql', 'f6775431f91a5f4769a2dfdd755aa32b');
        $this->checkFile('install/db/pap/update_4.5.28.php', '54570d665efe4d566e95ef72f30590d0');
        $this->checkFile('install/db/pap/update_4.5.29.php', 'f5b5e7af93de4b526efe0cee5afc9d96');
        $this->checkFile('install/db/pap/update_4.5.3.sql', 'b8c8ea9b203d77d728af61d4d7157a1a');
        $this->checkFile('install/db/pap/update_4.5.30.sql', '43b2b24a00f37bceb56ef51177e42ef0');
        $this->checkFile('install/db/pap/update_4.5.31.sql', '16e69b27e605b91debd935ed8f339144');
        $this->checkFile('install/db/pap/update_4.5.32.php', '06611f80bd913068d624f69d7f33fa83');
        $this->checkFile('install/db/pap/update_4.5.33.sql', '1e86ba0970f5af8ffdc5b640e4972342');
        $this->checkFile('install/db/pap/update_4.5.34.sql', '8b95f95ef4435f9fe5b87d018c9f7750');
        $this->checkFile('install/db/pap/update_4.5.35.sql', '0db8509cf8eb8ad8e760ce11b2dd7cab');
        $this->checkFile('install/db/pap/update_4.5.36.sql', 'e1fdc201393ee551ecb7e7055012354b');
        $this->checkFile('install/db/pap/update_4.5.37.sql', 'b779d0f4819f5230ebf9f7d900625d7f');
        $this->checkFile('install/db/pap/update_4.5.38.sql', '29edbd6d9a86ba653130277471daf141');
        $this->checkFile('install/db/pap/update_4.5.39.php', '669c79686c3927797113205950338280');
        $this->checkFile('install/db/pap/update_4.5.4.sql', '7693e135ce4b959b51a02d5722fe0ac9');
        $this->checkFile('install/db/pap/update_4.5.40.sql', 'e97e3c2c35405646c709715ffe3b9fd8');
        $this->checkFile('install/db/pap/update_4.5.41.sql', '3328889c5c5e694a30e52dee516f02ff');
        $this->checkFile('install/db/pap/update_4.5.42.sql', '69c4e96d44b17e864f08f75e94c2b4f4');
        $this->checkFile('install/db/pap/update_4.5.43.sql', 'bbf319468e42e1a9e1d8d95a94efa754');
        $this->checkFile('install/db/pap/update_4.5.44.sql', '8e9a147e5b1b12ec70108413769e0840');
        $this->checkFile('install/db/pap/update_4.5.45.sql', 'c537362b7e94d1536ed9a4ff38666e13');
        $this->checkFile('install/db/pap/update_4.5.46.sql', '285d44d0988c3be62f1e5b4db9186bb6');
        $this->checkFile('install/db/pap/update_4.5.47.php', 'aa816d9891fbdb3721aa96dee2f0b3ed');
        $this->checkFile('install/db/pap/update_4.5.48.sql', 'ed947a67f4e341ef76e487ddbec56f9e');
        $this->checkFile('install/db/pap/update_4.5.49.sql', '3d280e39679756cd0887428640bca5b9');
        $this->checkFile('install/db/pap/update_4.5.5.php', 'a0758d43c4d03bc4184cbaf63040eb87');
        $this->checkFile('install/db/pap/update_4.5.50.php', 'cf0634d14bd0206857e1ba03416d8133');
        $this->checkFile('install/db/pap/update_4.5.51.sql', '427e147d57acef457e652e705e3ff078');
        $this->checkFile('install/db/pap/update_4.5.52.sql', '644325f7c7957f210bce9257cf3f4b95');
        $this->checkFile('install/db/pap/update_4.5.53.sql', 'c41d7254ae91f6e5966b037e4e588ea8');
        $this->checkFile('install/db/pap/update_4.5.54.php', 'd9df85d1e107bd5a225e00da593cee2a');
        $this->checkFile('install/db/pap/update_4.5.55.php', '9698e21151912d7198b19305621ce9fb');
        $this->checkFile('install/db/pap/update_4.5.56.sql', '88df7a461ef1f998da963c12792868dc');
        $this->checkFile('install/db/pap/update_4.5.57.sql', 'b260df8c33117d4e0a2fe6954b433dc0');
        $this->checkFile('install/db/pap/update_4.5.58.sql', 'e00ce2bc23b25933965749c6ff5bf970');
        $this->checkFile('install/db/pap/update_4.5.59.php', '907181454e72cd1e64520bb6457746f8');
        $this->checkFile('install/db/pap/update_4.5.60.php', '1789933649feac201ddac7bda8efad4b');
        $this->checkFile('install/db/pap/update_4.5.61.php', '9ab3fae7beb576c6a9e4646b3abbde67');
        $this->checkFile('install/db/pap/update_4.5.62.sql', '681633850fd59e84579cd8247eb4f7d2');
        $this->checkFile('install/db/pap/update_4.5.63.sql', 'e39bbccc0b10abe237280880de90f16e');
        $this->checkFile('install/db/pap/update_4.5.64.sql', '39ae3a0eab55b9d7e4ab1b8285ae8ad0');
        $this->checkFile('install/db/pap/update_4.5.65.sql', '868499d488d13e2600ff09c00bf492de');
        $this->checkFile('install/db/pap/update_4.5.66.sql', '9e7a80ef4382e6dd75a4cd04bdedbaed');
        $this->checkFile('install/db/pap/update_4.5.67.sql', '0ab44ffc9b3639c2611272d98049c1f2');
        $this->checkFile('install/db/pap/update_4.5.68.php', '6893bc23ac028356a98abcc9e58dcab3');
        $this->checkFile('install/db/pap/update_4.5.69.php', 'e8b271e4d109cbc95107b86e2980a743');
        $this->checkFile('install/db/pap/update_4.5.7.sql', 'd7f9612cfe8e0d2e06bee082ac746ac3');
        $this->checkFile('install/db/pap/update_4.5.70.php', '7c87fe5447c77b07f99f697c07ad067f');
        $this->checkFile('install/db/pap/update_4.5.71.php', '0220fe5342e78b72e46264e8a4d9a2e1');
        $this->checkFile('install/db/pap/update_4.5.72.sql', '9483bc893acc12e23b7459521d446fc5');
        $this->checkFile('install/db/pap/update_4.5.73.sql', '9b773cd0272444562a2df04ac8c21868');
        $this->checkFile('install/db/pap/update_4.5.74.sql', '02a1838301dcfb0052e46e1941a55737');
        $this->checkFile('install/db/pap/update_4.5.75.sql', '01034bec745a5e8b44351769d726ce8b');
        $this->checkFile('install/db/pap/update_4.5.76.sql', '5ad1d8e3df136758476fb53c547d71b9');
        $this->checkFile('install/db/pap/update_4.5.77.sql', 'a0c95f466cce1306eab3a85af783dd12');
        $this->checkFile('install/db/pap/update_4.5.78.php', 'f6e6e1a2d75457f7b6380a4ec35ead2c');
        $this->checkFile('install/db/pap/update_4.5.79.sql', 'c759fecb66d02a4e5955de9d8365889e');
        $this->checkFile('install/db/pap/update_4.5.8.sql', 'ab4d438892e2ad908f1ba7e28d70a405');
        $this->checkFile('install/db/pap/update_4.5.80.sql', 'c8e33605a01b78da2a247b42d2724d86');
        $this->checkFile('install/db/pap/update_4.5.81.sql', '4ba5904876ebbd0be3c92f6bed69990e');
        $this->checkFile('install/db/pap/update_4.5.82.php', '96e117ee3341070eb084bebada800404');
        $this->checkFile('install/db/pap/update_4.5.83.sql', '1d71eff64d683a781c825ccd1178210f');
        $this->checkFile('install/db/pap/update_4.5.84.sql', '9499b1e6a57fb71224b498cb47a8dc12');
        $this->checkFile('install/db/pap/update_4.5.85.sql', '65f060ae643eb2dea46999720d9a6c16');
        $this->checkFile('install/db/pap/update_4.5.86.sql', 'd54ebe8801d9aa31dd529bd30b193c46');
        $this->checkFile('install/db/pap/update_4.5.87.sql', '0d8000f36131ffa7b010362331e03d99');
        $this->checkFile('install/db/pap/update_4.5.88.sql', '0f78141d3e6c4dbdf150c612ef74d53f');
        $this->checkFile('install/db/pap/update_4.5.89.sql', '2e970d78b67927b767a7d39a3b0ab893');
        $this->checkFile('install/db/pap/update_4.5.9.sql', '446e5063665483147bd250496ac37fe7');
        $this->checkFile('install/db/pap/update_4.5.90.sql', '6668cd2f83d2ba6051d821e31ec3b447');
        $this->checkFile('install/db/pap/update_4.6.1.php', '79dfdfcd7d77eb873b2be3a03bb0cbc7');
        $this->checkFile('install/db/pap/update_4.6.10.php', '53dddc66dcf614e6b256b5956d61b553');
        $this->checkFile('install/db/pap/update_4.6.2.php', '9cb5d9e0ada217c40300c08134abeafd');
        $this->checkFile('install/db/pap/update_4.6.3.php', '84c45297497407d2106994d77091315c');
        $this->checkFile('install/db/pap/update_4.6.4.sql', '49d21785dd9a9cdc7e8bde431309db61');
        $this->checkFile('install/db/pap/update_4.6.5.php', 'a33a6a9f98dc55e9df4672a3fcf94adf');
        $this->checkFile('install/db/pap/update_4.6.6.php', '42bf154295ad3a7fdb4e2fda1bc113e2');
        $this->checkFile('install/db/pap/update_4.6.7.php', 'fedf70422a2adfc1174f4c87e0aa91d8');
        $this->checkFile('install/db/pap/update_4.6.8.php', '8f3924d13d37611440e530145d275162');
        $this->checkFile('install/db/pap/update_4.6.9.php', '5944b93ac05a6761df3128419e393ee6');
        $this->checkFile('install/db/pap/update_4.7.0.sql', '403b0fd009ae7cc5792593afac7ff752');
        $this->checkFile('install/db/pap/update_4.7.1.sql', '10fedd188e20502e4227f386845452d2');
        $this->checkFile('install/db/pap/update_4.7.10.php', '7675102d37463b0e87fc9d9f6f2c60cf');
        $this->checkFile('install/db/pap/update_4.7.11.php', '0f0cc80881dfec5428aeacbc33b61e59');
        $this->checkFile('install/db/pap/update_4.7.12.php', '96aecfe391ae1babcc512a9e51626989');
        $this->checkFile('install/db/pap/update_4.7.13.php', '3aea16c739924b411f584165a3622368');
        $this->checkFile('install/db/pap/update_4.7.14.php', '0174dddd32a3da4aef1f96cf8bca8ab9');
        $this->checkFile('install/db/pap/update_4.7.15.php', 'f11afd028037c89d9514cf72f326fc19');
        $this->checkFile('install/db/pap/update_4.7.2.php', '7b63b79d8c4b441f822fa9699f8bcaa4');
        $this->checkFile('install/db/pap/update_4.7.3.php', 'c451c7983f5ff9f8c76e313a8ca24392');
        $this->checkFile('install/db/pap/update_4.7.4.sql', '8b9031ef35281db4aa85f8c09e194f18');
        $this->checkFile('install/db/pap/update_4.7.5.php', 'da42e98ce5e676a96a25756182a09f70');
        $this->checkFile('install/db/pap/update_4.7.6.php', '0904d77a968d0c54cae84d03f4a72e9d');
        $this->checkFile('install/db/pap/update_4.7.7.php', '5dfaa8dcdee9f008a104fcf0e9a0b39b');
        $this->checkFile('install/db/pap/update_4.7.8.php', '427f896fa1503dcf5b93e3dcd40873d3');
        $this->checkFile('install/db/pap/update_4.7.9.php', '8e25824a0e8c2cc63f1223393e9212e5');
        $this->checkFile('install/db/pap/update_4.8.0.php', '8464bf8afd9558e217afe54c4e8b5710');
        $this->checkFile('install/db/pap/update_4.8.1.php', 'b3515bc48ca06d11a4fce8233ecf2ce7');
        $this->checkFile('install/db/pap/update_4.9.1.php', '1aaefb009ab6af307d95856dfb440101');
        $this->checkFile('install/db/pap/update_4.9.10.sql', '4744813d494c7bcd114f8c13d60d983c');
        $this->checkFile('install/db/pap/update_4.9.11.php', '515f96413f356a0a42d04b4a4049f160');
        $this->checkFile('install/db/pap/update_4.9.12.sql', '9058e696bdd5fc4ffd2b132d64015319');
        $this->checkFile('install/db/pap/update_4.9.13.php', '6dda5d203013dc11949eebb5b07285d5');
        $this->checkFile('install/db/pap/update_4.9.14.php', '1bda448b0dc3d94572fc40acb5d223e5');
        $this->checkFile('install/db/pap/update_4.9.15.sql', '52691210e8cad9ef852f1f9e41665aed');
        $this->checkFile('install/db/pap/update_4.9.16.sql', 'eca2a8cdb7ed00866f24005cce5356af');
        $this->checkFile('install/db/pap/update_4.9.2.php', 'e9531d9a99ea4555786026d4e8e32676');
        $this->checkFile('install/db/pap/update_4.9.3.php', '16b21f9de6311b175d6d6aa381de208a');
        $this->checkFile('install/db/pap/update_4.9.4.php', 'b5567d8eb24f0ae0021ce4249b01156d');
        $this->checkFile('install/db/pap/update_4.9.5.php', '6449f3d6483700d0384e4009db671bda');
        $this->checkFile('install/db/pap/update_4.9.6.php', '72930370f07f42ca7d4ad062af02bcf0');
        $this->checkFile('install/db/pap/update_4.9.7.php', '824ce28de32f2a63cb5d9bffd3f8f36b');
        $this->checkFile('install/db/pap/update_4.9.8.php', '4bbb6d0ee10784e8b146a74c1bfff1d6');
        $this->checkFile('install/db/pap/update_4.9.9.php', '35797bea164167b879c5e39c22354dd6');
        $this->checkFile('install/db/pap/update_5.0.1.php', '341dd31bc4423961579b69e4486820bf');
        $this->checkFile('install/db/pap/update_5.0.10.php', 'cb7c2dee68d1a43d8e042b8b2e58602e');
        $this->checkFile('install/db/pap/update_5.0.11.sql', '39210d9a87e459c370690579c2539720');
        $this->checkFile('install/db/pap/update_5.0.12.php', '32a686500e1396eff5edca0013d6dbd6');
        $this->checkFile('install/db/pap/update_5.0.13.sql', 'c0ccac62e6f368425fef808cae612591');
        $this->checkFile('install/db/pap/update_5.0.14.php', 'ae850af4b0db718026700f6977d7227c');
        $this->checkFile('install/db/pap/update_5.0.2.php', '6ff409552245dd010471a8bd5389397f');
        $this->checkFile('install/db/pap/update_5.0.3.php', '70e0f34291bc6cfe644543de9d5408df');
        $this->checkFile('install/db/pap/update_5.0.4.php', '87bcb959ffb1d84f6b1ee5a7377230c7');
        $this->checkFile('install/db/pap/update_5.0.5.php', '186472454961ac2d15c9e15167ceaf93');
        $this->checkFile('install/db/pap/update_5.0.6.sql', 'dd41a01db640518daf6ff9ed793a2793');
        $this->checkFile('install/db/pap/update_5.0.7.php', 'b406bb21b3458ce598d0c4c7cdc959be');
        $this->checkFile('install/db/pap/update_5.0.8.sql', 'dd41a01db640518daf6ff9ed793a2793');
        $this->checkFile('install/db/pap/update_5.0.9.php', '0be472ce4a41961ab138d5500fc356a6');
        $this->checkFile('install/db/pap/update_5.1.1.php', '0a53eab0665fe68c72892a9a74740a2b');
        $this->checkFile('install/db/pap/update_5.1.10.php', 'a5cd3b59499e4cf0eb6b3dbd5e7d6d4f');
        $this->checkFile('install/db/pap/update_5.1.2.php', '0727dff1c60860bc3ca8a0b1c14aadbd');
        $this->checkFile('install/db/pap/update_5.1.3.sql', '2617ff49dba9f6683ceb267416627446');
        $this->checkFile('install/db/pap/update_5.1.4.php', '474e85e8b0b24feabffb739ce4f70e52');
        $this->checkFile('install/db/pap/update_5.1.5.php', '73111081bf0aa215138c465cfa3abee6');
        $this->checkFile('install/db/pap/update_5.1.6.php', 'd130b273e638c213bed4d49ddc6f6233');
        $this->checkFile('install/db/pap/update_5.1.7.sql', '4f1b0124f3c02507247d9cb32e6b0cb4');
        $this->checkFile('install/db/pap/update_5.1.8.sql', 'a050c40f9a85c6ba2d2c84a38f1cb3e4');
        $this->checkFile('install/db/pap/update_5.1.9.php', 'dfc83fba2b6a4f41a340a686a097b732');
        $this->checkFile('install/db/pap/update_5.2.1.sql', '3401444301f392970f84647054462dcb');
        $this->checkFile('install/db/pap/update_5.2.10.php', '5841afbb6ededc52d04bc8c2c5194927');
        $this->checkFile('install/db/pap/update_5.2.11.php', 'e39f0052a8281f20722412a0cea61c1e');
        $this->checkFile('install/db/pap/update_5.2.12.php', 'b07cd1f281d9e0051248c664232ff68d');
        $this->checkFile('install/db/pap/update_5.2.13.php', '8d9e27626dc431a5f34689607e2feae6');
        $this->checkFile('install/db/pap/update_5.2.14.php', '039f70c8fa2cf4f000b18db063fca0d7');
        $this->checkFile('install/db/pap/update_5.2.15.php', 'cd38e9350017d93b634a62303580f01b');
        $this->checkFile('install/db/pap/update_5.2.16.php', '04fd3aaf189b59caa4f0e84713b7f54a');
        $this->checkFile('install/db/pap/update_5.2.2.sql', '4d4d6db2567d3e426d0c8a290b8d7a34');
        $this->checkFile('install/db/pap/update_5.2.3.sql', '3d61665ffcdb11bc2aa0f282c2034a47');
        $this->checkFile('install/db/pap/update_5.2.4.php', '74a3826982a8b29a3429fea2dde31b44');
        $this->checkFile('install/db/pap/update_5.2.6.php', 'a5ad090c1a08a615ea8e5216a4af9d24');
        $this->checkFile('install/db/pap/update_5.2.7.php', 'd4181c19f0805a2d6a614e42fdb67b83');
        $this->checkFile('install/db/pap/update_5.2.8.sql', '5f31247db13e7f794082075b2950ffc9');
        $this->checkFile('install/db/pap/update_5.2.9.php', '6cb463607973b75a09aae3bf1ad1a7bc');
        $this->checkFile('install/db/pap/update_5.3.10.php', '9a41b4e86c5810e2d36725b466e892c9');
        $this->checkFile('install/db/pap/update_5.3.11.php', '5f4b87a5c468d7776d5ef31d8c215526');
        $this->checkFile('install/db/pap/update_5.3.12.php', '3c56b0ca7e1d67de7732b62b40c0af23');
        $this->checkFile('install/db/pap/update_5.3.13.php', '4ad214aade1e14b333860c38534e56b6');
        $this->checkFile('install/db/pap/update_5.3.14.php', '853ddf3f0ef9dcb85b2929e61c1344d9');
        $this->checkFile('install/db/pap/update_5.3.15.php', '302ca14040a7221dde489704d25e406b');
        $this->checkFile('install/db/pap/update_5.3.16.php', 'f3ba927b3ab31077939a93629019ef1a');
        $this->checkFile('install/db/pap/update_5.3.17.php', 'b2c3c771bfaddf86d5bf9fa2c725f64f');
        $this->checkFile('install/db/pap/update_5.3.18.php', 'f1d2130a11d63b28329fc186d261d41d');
        $this->checkFile('install/db/pap/update_5.3.19.php', '00ebd4ad538ff851ab21363d6c6a9403');
        $this->checkFile('install/db/pap/update_5.3.20.php', '5deab3bc5af8a08f1c468841c7514e06');
        $this->checkFile('install/db/pap/update_5.3.21.php', 'f21ce437414c6b7378e9e2011cf12983');
        $this->checkFile('install/db/pap/update_5.3.22.php', '3f36e9d8056530a7f8f0f272d2390fed');
        $this->checkFile('install/db/pap/update_5.3.23.php', '531a7a43f70ef7add5677952b279e59e');
        $this->checkFile('install/db/pap/update_5.3.24.php', 'b2b5e45f77a5f3c4d6f4d2a91563f95d');
        $this->checkFile('install/db/pap/update_5.3.25.php', '135fa46acf8254febc188f847a2e87b2');
        $this->checkFile('install/db/pap/update_5.3.27.php', '05da10fe0a3552cbb0458057b43c588f');
        $this->checkFile('install/db/pap/update_5.3.28.php', '19dddf41a99a1a2c5ea957729d6a2692');
        $this->checkFile('install/db/pap/update_5.3.29.php', '2ad4878d82e14c8846c36f5fa24e1f65');
        $this->checkFile('install/db/pap/update_5.3.30.php', 'e51b3410c5ce29974d64eff926d3603d');
        $this->checkFile('install/db/pap/update_5.3.31.php', '35be6502303ed77be3bcf804c1083eb1');
        $this->checkFile('install/db/pap/update_5.3.32.php', '6ccdf8435b856443119f32fe13da9473');
        $this->checkFile('install/db/pap/update_5.3.4.php', '73ce14172e1259f29d1e887a436f71ee');
        $this->checkFile('install/db/pap/update_5.3.5.php', '56f4ff6ea18888a6d7651ebe76458232');
        $this->checkFile('install/db/pap/update_5.3.6.php', 'cae506e69832c80452cbb2fe9c3b0cd6');
        $this->checkFile('install/db/pap/update_5.3.7.php', 'ac35d84379ea0a6370bb1a6ef4ab91a0');
        $this->checkFile('install/db/pap/update_5.3.8.php', 'ec6c6ea30b5b85ff93336c34f3a39b7c');
        $this->checkFile('install/db/pap/update_5.3.9.php', 'db79c4288432357974002995b43afeed');
        $this->checkFile('install/db/pap/update_5.4.1.php', '7b9ad838b701a55cfb2128d81ef13d3a');
        $this->checkFile('install/db/pap/update_5.4.10.php', '8a1107d5f40fcc4979ade28de7f90c57');
        $this->checkFile('install/db/pap/update_5.4.11.php', '1834f26c72ef079dc6944e9cf496c800');
        $this->checkFile('install/db/pap/update_5.4.12.php', 'f505781ebb866ce0eef254753a075257');
        $this->checkFile('install/db/pap/update_5.4.13.php', 'b746d5405acbb674019f2e60a7bfdf8a');
        $this->checkFile('install/db/pap/update_5.4.14.php', 'adb852ccfdddd5f1d0acea6061631872');
        $this->checkFile('install/db/pap/update_5.4.15.php', 'f4cf8525091306a9db28b6a4579090d7');
        $this->checkFile('install/db/pap/update_5.4.16.php', '8c5cd240381c2b836102e4b7aa6766cb');
        $this->checkFile('install/db/pap/update_5.4.17.php', 'ef869426ed0239a741f506fbf749332b');
        $this->checkFile('install/db/pap/update_5.4.18.php', 'a8de55182a9638ab89fb52e0521724fe');
        $this->checkFile('install/db/pap/update_5.4.19.php', '001c18994ea107d6b72f773b90c548bf');
        $this->checkFile('install/db/pap/update_5.4.2.php', 'daa449967706f857e86eff336b3b33c0');
        $this->checkFile('install/db/pap/update_5.4.20.php', 'c42cf96421ae505a86c43b85f256018a');
        $this->checkFile('install/db/pap/update_5.4.21.php', '688500b8a2557f16589e55a7db87991e');
        $this->checkFile('install/db/pap/update_5.4.22.php', 'eee2849087c0acd1acf152d6b5c15677');
        $this->checkFile('install/db/pap/update_5.4.23.php', '529edca2122f7617e193a149c05475c4');
        $this->checkFile('install/db/pap/update_5.4.24.php', '94d9a30d5de2cc50240558d274ec3886');
        $this->checkFile('install/db/pap/update_5.4.25.php', 'e8c3f80e2768a9c7f7664fd6abe96e7f');
        $this->checkFile('install/db/pap/update_5.4.26.php', '9c65b32c8e01a42106d680b0f59f80b7');
        $this->checkFile('install/db/pap/update_5.4.27.php', 'c6a0ebd90f75b78a928b597d60cddf16');
        $this->checkFile('install/db/pap/update_5.4.28.php', '09ba84b4dd8269d9d3a6299e21897aca');
        $this->checkFile('install/db/pap/update_5.4.29.php', '9c7ae3569dbda993e4a168e5e5e5997d');
        $this->checkFile('install/db/pap/update_5.4.3.php', '51c1a12c9f05da8121f381005f39f2b6');
        $this->checkFile('install/db/pap/update_5.4.30.php', '9b86a1ff23148d6ae9edaaf135bf5bd8');
        $this->checkFile('install/db/pap/update_5.4.31.php', 'debba4f5ff93fc499df973e36d90bb64');
        $this->checkFile('install/db/pap/update_5.4.32.php', 'f826d5afa9d613daa4cb149fa9232e56');
        $this->checkFile('install/db/pap/update_5.4.33.php', 'f7027073911ec6f6c58a587e249e2252');
        $this->checkFile('install/db/pap/update_5.4.34.php', '3b83e9135dcb5ae7d0e4f3cf4126eac4');
        $this->checkFile('install/db/pap/update_5.4.35.php', '68cadaefded63485f61f5f73ee94d30c');
        $this->checkFile('install/db/pap/update_5.4.36.php', '215a7cb01f50d3bb430459ca23eb4e22');
        $this->checkFile('install/db/pap/update_5.4.37.php', '69c190b1912e1b76f9a6e21dce063389');
        $this->checkFile('install/db/pap/update_5.4.38.php', '5c6dc76a4b87a6701bd31776c39b5544');
        $this->checkFile('install/db/pap/update_5.4.39.php', '020cb75637771cec22294cc53b3d2cce');
        $this->checkFile('install/db/pap/update_5.4.4.php', 'aea08fa4bc589735255b562134cfa5fe');
        $this->checkFile('install/db/pap/update_5.4.40.php', '9d241491a12fd79a869af6924815e08f');
        $this->checkFile('install/db/pap/update_5.4.41.php', '097a8d2987e87f41580241b674d0c319');
        $this->checkFile('install/db/pap/update_5.4.42.php', '281d016debba8ff343b5357784ece715');
        $this->checkFile('install/db/pap/update_5.4.43.php', '97441edd417b9c5ecd2afa5966e986d0');
        $this->checkFile('install/db/pap/update_5.4.44.php', '4f207e5cefd72dad2f91d31fa2df8265');
        $this->checkFile('install/db/pap/update_5.4.45.php', 'd77ec8d383238c34f75f75ab883f0b2d');
        $this->checkFile('install/db/pap/update_5.4.5.php', 'f7992f2397786675a92388bde7e46f37');
        $this->checkFile('install/db/pap/update_5.4.6.php', '59e1f19573fc7337d7319d97f7a7b737');
        $this->checkFile('install/db/pap/update_5.4.7.php', '618a9cf24c1b6f80cb4e6eec2b2b0b0e');
        $this->checkFile('install/db/pap/update_5.4.8.php', 'f878693589afb77563eda7e5946aebca');
        $this->checkFile('install/db/pap/update_5.4.9.php', 'e4c13e47eb38281053e2146fa60cc9ae');
        $this->checkFile('install/db/pap/update_5.5.1.php', '0add972b6889065a7bc8f0327d116b22');
        $this->checkFile('install/db/pap/update_5.5.10.php', 'a2965e0c3ed3c4378cdf07c87ce1c734');
        $this->checkFile('install/db/pap/update_5.5.11.php', 'c50a3641829879c37ec83aec760cfa0a');
        $this->checkFile('install/db/pap/update_5.5.12.php', '350dc02a55d535ca23260c3bbc284bf9');
        $this->checkFile('install/db/pap/update_5.5.13.php', '1eb7d777ade6a6b302c0dc9eb9d30c73');
        $this->checkFile('install/db/pap/update_5.5.14.php', '34058d1df1b0197154351de582c04b89');
        $this->checkFile('install/db/pap/update_5.5.15.php', 'd504889c7aee0dadba36cd3ec84f2173');
        $this->checkFile('install/db/pap/update_5.5.16.php', '51710df98a3d1e55a02349ca83ef7d88');
        $this->checkFile('install/db/pap/update_5.5.17.php', 'eb98d5749ce770019da07c55758dd30a');
        $this->checkFile('install/db/pap/update_5.5.18.php', '136aee2304127726060d3631c19642f9');
        $this->checkFile('install/db/pap/update_5.5.19.php', '5ded5c64b6ce440bcf73b72c1a101aaa');
        $this->checkFile('install/db/pap/update_5.5.2.php', 'cd5fd87fb85a4c35df4d1628971d3f01');
        $this->checkFile('install/db/pap/update_5.5.20.php', '99c7fd09d4929c3b9cac4dbdbfb17837');
        $this->checkFile('install/db/pap/update_5.5.21.php', '45ba66285b3601beb6f6deeb105a4782');
        $this->checkFile('install/db/pap/update_5.5.22.php', '81d463b4b3ea98fcd6b99662aa6189b9');
        $this->checkFile('install/db/pap/update_5.5.23.php', 'c648f5ba90fb03054ecd63c6709c824f');
        $this->checkFile('install/db/pap/update_5.5.24.php', '61ce11ff9ccf5d0f0d9c03fd257550a1');
        $this->checkFile('install/db/pap/update_5.5.25.php', '203f6b7ea93ac0a625e894b0159c2373');
        $this->checkFile('install/db/pap/update_5.5.28.php', '6601dd6190eda0be9f26c5006e47ae79');
        $this->checkFile('install/db/pap/update_5.5.29.php', 'b8f8a72c051aaf1b7983ef517da5fc0f');
        $this->checkFile('install/db/pap/update_5.5.3.php', 'd919e04f4f4a460038e78c2a00cd419d');
        $this->checkFile('install/db/pap/update_5.5.30.php', '8548394b9ab777ee1a51721f086b8203');
        $this->checkFile('install/db/pap/update_5.5.31.php', 'aed0b70df4794412887bfe782ae0cc7d');
        $this->checkFile('install/db/pap/update_5.5.32.php', '97ce7b76316f514f03f7da7b1db09d61');
        $this->checkFile('install/db/pap/update_5.5.33.php', '88d1db3cb3815faa2ff44fb281d33a2d');
        $this->checkFile('install/db/pap/update_5.5.34.php', '847c9e0262bdbd6f491347c0cb9932d2');
        $this->checkFile('install/db/pap/update_5.5.35.php', 'e5bbe4d21aeed92965a6dde3d857983d');
        $this->checkFile('install/db/pap/update_5.5.36.php', '399d2ed0caa35d97674c5635115840ae');
        $this->checkFile('install/db/pap/update_5.5.37.php', '524db0fb40a28ec690c6b0f8d369ea4a');
        $this->checkFile('install/db/pap/update_5.5.38.php', '481aaf7932b71c49cc8baeef0ff28498');
        $this->checkFile('install/db/pap/update_5.5.39.php', '0a3755adfb7472764e8513ecb8a84687');
        $this->checkFile('install/db/pap/update_5.5.4.php', '311641b26fe558866b535c0ee3b11e60');
        $this->checkFile('install/db/pap/update_5.5.40.php', '09f57012d074aeb4362060a6ec0e4775');
        $this->checkFile('install/db/pap/update_5.5.41.php', '1f32d738fb7f9e3607f198fa8a8a2da7');
        $this->checkFile('install/db/pap/update_5.5.42.php', '00520ea2f92d7a16960af405be901c34');
        $this->checkFile('install/db/pap/update_5.5.43.php', '67a0825ed03ba07be9977efb31f7799a');
        $this->checkFile('install/db/pap/update_5.5.44.php', '9345dcf8b87c87edefe32dd2d7a1bb53');
        $this->checkFile('install/db/pap/update_5.5.45.php', 'f4d7ccd292b1a0584afcf72572e3dee1');
        $this->checkFile('install/db/pap/update_5.5.46.php', 'e3fec92080a9a903e1f07ae0b9b4426d');
        $this->checkFile('install/db/pap/update_5.5.47.php', '8814f704febd3f2acc4531121875c062');
        $this->checkFile('install/db/pap/update_5.5.49.php', '248502b311b5f49f95f4b8d142676777');
        $this->checkFile('install/db/pap/update_5.5.5.php', '5225e07124cba659e86155c3d871f4ad');
        $this->checkFile('install/db/pap/update_5.5.50.php', '57fe04b8449472417a196773fa6e507e');
        $this->checkFile('install/db/pap/update_5.5.51.php', '3f733894ad752ef7d0efb1955afd464a');
        $this->checkFile('install/db/pap/update_5.5.52.php', '2c1baa060a8edfed78ed0ff0d35beed5');
        $this->checkFile('install/db/pap/update_5.5.53.php', '5f33903480f6e9508abf558fb9f2a905');
        $this->checkFile('install/db/pap/update_5.5.54.php', '538e4f586d596251d094e8279de9c24f');
        $this->checkFile('install/db/pap/update_5.5.55.php', '521b8ed675228c4d4dda5fe3be4b1f4e');
        $this->checkFile('install/db/pap/update_5.5.56.php', 'e0dd71434f39c2fa9846936965e49d6c');
        $this->checkFile('install/db/pap/update_5.5.57.php', '741494969063368901c6a7533366db5d');
        $this->checkFile('install/db/pap/update_5.5.58.php', '8b298249303e8154695c1caf03f05201');
        $this->checkFile('install/db/pap/update_5.5.59.php', '3b6188d359fef5fa76f94b75a2405f4c');
        $this->checkFile('install/db/pap/update_5.5.6.php', 'c1b8ae922fce3f5d2b5c1e0b7add5ca9');
        $this->checkFile('install/db/pap/update_5.5.60.php', 'cb0529daac20104b131e086d121104c1');
        $this->checkFile('install/db/pap/update_5.5.61.php', '58695295b3ce996ec2f82e0d9d78a272');
        $this->checkFile('install/db/pap/update_5.5.7.php', 'a2574cc4498249c1aad03c1c3a8866b5');
        $this->checkFile('install/db/pap/update_5.5.8.php', '4d6290fdecb4e92f256d7549537caded');
        $this->checkFile('install/db/pap/update_5.5.9.php', '84a8f281bb3b892d4478cbe868e6e1f4');
        $this->checkFile('install/db/pap/update_5.6.1.php', '228c7b03f485e79438d371f62031d826');
        $this->checkFile('install/db/pap/update_5.6.10.php', '536b6a1dfbca3e975c15f42c332b0630');
        $this->checkFile('install/db/pap/update_5.6.11.php', '0af2a530441a8c8282b21323d21ade45');
        $this->checkFile('install/db/pap/update_5.6.12.php', 'b748e89d0b58776350e0c8546d1c183e');
        $this->checkFile('install/db/pap/update_5.6.13.php', '3b48060c9366d455324335f038d30bbc');
        $this->checkFile('install/db/pap/update_5.6.14.php', 'c2d4cce849627a0304bae719020ed8a3');
        $this->checkFile('install/db/pap/update_5.6.15.php', '5abe2bb926ee30f754c4549819df0345');
        $this->checkFile('install/db/pap/update_5.6.16.php', 'e5d87eb6ff0f009593ea473ed57ec7ee');
        $this->checkFile('install/db/pap/update_5.6.17.php', 'b5695a9d7d42b477fb19f73be2608ea5');
        $this->checkFile('install/db/pap/update_5.6.18.php', 'bb0ae0164c8a417e96a16b207f12abda');
        $this->checkFile('install/db/pap/update_5.6.19.php', '037f3282b1e5d2a20dc62022276556b8');
        $this->checkFile('install/db/pap/update_5.6.2.php', '202d5392c04ff219dc41dc07b4ffc6f2');
        $this->checkFile('install/db/pap/update_5.6.20.php', '0f8585863b2d5c38f63928a1cbb28d7a');
        $this->checkFile('install/db/pap/update_5.6.21.php', 'a5b96f1a5a59b32fc883c04e13a7fb5b');
        $this->checkFile('install/db/pap/update_5.6.22.php', '17090d85383a6884fa7a331839bd13dd');
        $this->checkFile('install/db/pap/update_5.6.23.php', '4117bcf45cf2648d192ba3c7853f311c');
        $this->checkFile('install/db/pap/update_5.6.24.php', '4fd7b9e08c399e4d0a267c53f4b93d92');
        $this->checkFile('install/db/pap/update_5.6.25.php', '24ac4549d10101dbeb1afbd80dbea60e');
        $this->checkFile('install/db/pap/update_5.6.26.php', 'ba688cb64ea31970aeba36ede36ad44e');
        $this->checkFile('install/db/pap/update_5.6.27.php', '022fdf0b4641a1fe8e57f001634bdd3c');
        $this->checkFile('install/db/pap/update_5.6.28.php', 'b5b3659a8aece2aa22ed17f35332aa6e');
        $this->checkFile('install/db/pap/update_5.6.29.php', 'd429c09fd08267edc4ef48f9335c8b41');
        $this->checkFile('install/db/pap/update_5.6.3.php', '2ec4ccdd1262a965b67e97f968a3d373');
        $this->checkFile('install/db/pap/update_5.6.30.php', '708f726b6fe711ad72f4bbffa7edbab6');
        $this->checkFile('install/db/pap/update_5.6.31.php', 'e4324fec4648a595b87f1687da358902');
        $this->checkFile('install/db/pap/update_5.6.32.php', '6caf2fbb3e5239eb87263ad91846acf4');
        $this->checkFile('install/db/pap/update_5.6.33.php', 'd8f5463184134da1a5759da6ecbd1da2');
        $this->checkFile('install/db/pap/update_5.6.34.php', '1c5e4b409aef2097531e3c8729921294');
        $this->checkFile('install/db/pap/update_5.6.35.php', '5a4b2c47eafa980b94daa305d9f90cf2');
        $this->checkFile('install/db/pap/update_5.6.36.php', '34d23addfb6b6942ca3cc3a2b77747e6');
        $this->checkFile('install/db/pap/update_5.6.37.php', '2001d2ff3035b0282c033a01df115166');
        $this->checkFile('install/db/pap/update_5.6.38.php', 'c81bdf007837ce769d40f0d59de7a256');
        $this->checkFile('install/db/pap/update_5.6.39.php', '54cb6ca88f077b3334577dafa70394b0');
        $this->checkFile('install/db/pap/update_5.6.4.php', '069085eabcf3655b45eb503277a3404d');
        $this->checkFile('install/db/pap/update_5.6.5.php', '37d94a00ffdcdbf8dade96f4c9f20390');
        $this->checkFile('install/db/pap/update_5.6.6.php', 'cad004d11d1aecb9c81d31201bfa1e6a');
        $this->checkFile('install/db/pap/update_5.6.7.php', '9d5fe8531c19f144d904496f46e4793d');
        $this->checkFile('install/db/pap/update_5.6.8.php', '8ec9de6e30fd30a36ea7428a50735190');
        $this->checkFile('install/db/pap/update_5.6.9.php', '62dcce16181a1b4582c6a93501206ce8');
        $this->checkFile('install/db/pap/update_5.7.1.php', '3f54191d0f250db36faef58bcb80b6cf');
        $this->checkFile('install/db/pap/update_5.7.10.php', 'a8ff245024da032c26d276e2a3fb27fc');
        $this->checkFile('install/db/pap/update_5.7.11.php', '534d556d8b92b00e683eac8e0f969a58');
        $this->checkFile('install/db/pap/update_5.7.12.php', '4ff17b76bb560e50e9ff27c35b0dbcb3');
        $this->checkFile('install/db/pap/update_5.7.13.php', 'bd60d614ffd6636277a0ed9a5414a8c4');
        $this->checkFile('install/db/pap/update_5.7.14.php', 'eeaed065dd4847faa642d78feaff74eb');
        $this->checkFile('install/db/pap/update_5.7.15.php', '11976c661aa398643cf632423cd01a78');
        $this->checkFile('install/db/pap/update_5.7.16.php', '82f578d3ed4391de250d466c8210daf6');
        $this->checkFile('install/db/pap/update_5.7.17.php', '8f420413484690162471ded248f0eb7f');
        $this->checkFile('install/db/pap/update_5.7.18.php', 'c181a0307065aba8e242cbe2db76397d');
        $this->checkFile('install/db/pap/update_5.7.19.php', 'd87cca36a1eef68c261fe3b439e550cd');
        $this->checkFile('install/db/pap/update_5.7.2.php', '39482fede3c8ba1496ab6d64df597b4e');
        $this->checkFile('install/db/pap/update_5.7.20.php', '5e3b6bd48547fc4025dd68e57af40c69');
        $this->checkFile('install/db/pap/update_5.7.21.php', 'e6134963f6f209fe01cd9effff5e3465');
        $this->checkFile('install/db/pap/update_5.7.22.php', '773c8ac856de76a1acb734be75984c02');
        $this->checkFile('install/db/pap/update_5.7.3.php', '8723355004e513de35d796f763cf3683');
        $this->checkFile('install/db/pap/update_5.7.4.php', 'f254766476d2c9a4e5dfbef07069a969');
        $this->checkFile('install/db/pap/update_5.7.5.php', 'b0b6839563c2c5e9ec4815f38756a3c0');
        $this->checkFile('install/db/pap/update_5.7.6.php', 'a818808fbab9011cef0efcd0dbc654b6');
        $this->checkFile('install/db/pap/update_5.7.7.php', '284ff1bff51e2f0daabfcce44716a280');
        $this->checkFile('install/db/pap/update_5.7.8.php', 'a26a14fcc2e5b5ab13ac57c27c2a73e5');
        $this->checkFile('install/db/pap/update_5.7.9.php', '3f29f2f36793ffb6b02d34b524929083');
        $this->checkFile('install/db/pap/update_5.8.1.php', 'fe259a409efbecba0a04e3d1719d1032');
        $this->checkFile('install/db/pap/update_5.8.10.php', '27afd84d1fba722dd9a65eba8efc40c6');
        $this->checkFile('install/db/pap/update_5.8.11.php', 'a68ce6bb8d40000ffe37d0491f9b72f1');
        $this->checkFile('install/db/pap/update_5.8.2.php', 'd76485d581194f0e8217430b5b297dbc');
        $this->checkFile('install/db/pap/update_5.8.3.php', 'ef6a85a94e17d856b60ff058d4678c2c');
        $this->checkFile('install/db/pap/update_5.8.4.php', '9b70be8bb6c7dadffef631e0634d25d1');
        $this->checkFile('install/db/pap/update_5.8.5.php', '395be5a87ba873ad5d41e68a39f053b2');
        $this->checkFile('install/db/pap/update_5.8.6.php', '81b005db04703e736263714a29f575b0');
        $this->checkFile('install/db/pap/update_5.8.7.php', '91f96f67573380a57021d442e6e2fb5a');
        $this->checkFile('install/db/pap/update_5.8.8.php', '0c9e6bb878930c9f7ea03784cb2235f0');
        $this->checkFile('install/db/pap/update_5.8.9.php', '9cbfaa95a2a23b19b986d7590c800bfa');
        $this->checkFile('install/db/pap/update_5.9.1.php', '630119ea9700504ac333daf2d4205107');
        $this->checkFile('install/db/pap/update_5.9.10.php', 'aecaecd6945a580a692d23c156cfcb92');
        $this->checkFile('install/db/pap/update_5.9.11.php', '2f3c826c803ee8efde70455f147b1899');
        $this->checkFile('install/db/pap/update_5.9.12.php', '8b3e22e579983bbdf9f5e8166505289b');
        $this->checkFile('install/db/pap/update_5.9.13.php', '67e09a9ffcdc2c7e3563c00d677c286f');
        $this->checkFile('install/db/pap/update_5.9.14.php', 'bee04f677c10302435e1136ebeb31137');
        $this->checkFile('install/db/pap/update_5.9.15.php', '046015b6bbf142a931537430ed85cdcb');
        $this->checkFile('install/db/pap/update_5.9.16.php', '64e4a620d17dcfaa8a2286095a9f0a22');
        $this->checkFile('install/db/pap/update_5.9.17.php', 'c80c6d9b955bbadc49da0071eb3700fb');
        $this->checkFile('install/db/pap/update_5.9.18.php', 'd63d6b692f81768e76009b76be8eda8a');
        $this->checkFile('install/db/pap/update_5.9.19.php', 'd908c283370270e21d521e4bfe438ecd');
        $this->checkFile('install/db/pap/update_5.9.2.php', 'ee88dc77059816f5697054bca0f33dfd');
        $this->checkFile('install/db/pap/update_5.9.3.php', '86de69d1aaad94a65fc90d14da79e8fb');
        $this->checkFile('install/db/pap/update_5.9.4.php', 'c25d6fda18699ef8d3cee476929b5831');
        $this->checkFile('install/db/pap/update_5.9.5.php', '905f9bf4a28d8415f8078782cc26fdfa');
        $this->checkFile('install/db/pap/update_5.9.6.php', '2cdc82692d2dcb56da85469d8048b72e');
        $this->checkFile('install/db/pap/update_5.9.7.php', '135513f66f0bdee87d1e0cfa25079f97');
        $this->checkFile('install/db/pap/update_5.9.8.php', '72a2aa78f6d33afca8299eb75a1b6eaa');
        $this->checkFile('install/db/pap/update_5.9.9.php', '3f672932393bded53b47397e2fcf6ece');
        $this->checkFile('install/index.php', '955eb273ed21d78dccad3e742706956a');
        $this->checkFile('install/js/clear.cache.gif', '6d22e4f2d2057c6e8d6fab098e76e80f');
        $this->checkFile('install/js/com.qualityunit.pap.Installer.devmode.js', '3080472a88e7d5d32d7025602863c64d');
        $this->checkFile('install/js/com.qualityunit.pap.Installer.nocache.php', '1076c0a40a5b0cf6378dd0e520b6b5a1');
        $this->checkFile('install/js/compilation-mappings.txt', '65017c125c4812591f74b31bb1df1cd6');
        $this->checkFile('install/js/installer-0.cache.js', '08aec519427df3002f92551fae640a86');
        $this->checkFile('install/js/installer-0.cache.php', '910591501ea110c21faabc52f29c32d5');
        $this->checkFile('install/js/installer-1.cache.js', 'e7cf8296c40957c4afa3f895567e54ee');
        $this->checkFile('install/js/installer-1.cache.php', '910591501ea110c21faabc52f29c32d5');
        $this->checkFile('install/js/installer-2.cache.js', 'b82791d7d4a9506b9dac199f36811080');
        $this->checkFile('install/js/installer-2.cache.php', '910591501ea110c21faabc52f29c32d5');
        $this->checkFile('install/js/installer-3.cache.js', 'd3f15501b012a8544d4c22007743aff9');
        $this->checkFile('install/js/installer-3.cache.php', '910591501ea110c21faabc52f29c32d5');
        $this->checkFile('install/js/nocache.php', '68b329da9893e34099c7d8ad5cb9c940');
        $this->checkFile('install/resources/bigflags.jpg', '9e825a4fdc39e3edadd99374f8b377ad');
        $this->checkFile('install/resources/flags.jpg', 'ec669e22b760cc12ffc539da975038c2');
        $this->checkFile('install/server.php', '065e597a4af384a837c1e85469f600b2');
        $this->checkFile('lang/pap_ar-EG.csv', 'e449d65115c94498202537033f86a84e');
        $this->checkFile('lang/pap_bg.csv', '7db8192ff06d8cac9da594876d1b9b8a');
        $this->checkFile('lang/pap_cs.csv', 'cf306d60e7fce4236d5b2dda02bf07c3');
        $this->checkFile('lang/pap_da.csv', '0dbe738391f07af5c7cc76a04d7fcb8a');
        $this->checkFile('lang/pap_de.csv', 'bf99c125e04c659803f50ecea5bf4a21');
        $this->checkFile('lang/pap_el.csv', '57b934d8d7f3b53fe75b0fe5de330773');
        $this->checkFile('lang/pap_en-US.csv', 'd752ccc692081e5ac1979b1c5eb6e3a5');
        $this->checkFile('lang/pap_es.csv', '29f5249bbd8c21e1b7e164f7276b20e0');
        $this->checkFile('lang/pap_et.csv', '2c06404edfc0e3589c680e0add72cd60');
        $this->checkFile('lang/pap_fi.csv', 'd27f68ac1d2c9335244e1791d6a9d2bc');
        $this->checkFile('lang/pap_fr.csv', 'cae4b2a4bea78415f5ff25e5c7af2c20');
        $this->checkFile('lang/pap_he-IL.csv', 'f4c8063842bdf7458ec41f18a2be1f02');
        $this->checkFile('lang/pap_hr.csv', 'c1890256d25ea4da1557c22e261a071c');
        $this->checkFile('lang/pap_hu.csv', 'd9465981d373ca93f713a6af19f689c9');
        $this->checkFile('lang/pap_id.csv', '397d625698435a9fa9cfdc4ab912b5a5');
        $this->checkFile('lang/pap_it.csv', '4702c87108615bd09d224e78163aa5b0');
        $this->checkFile('lang/pap_ja.csv', '826c2bf2a02bff68fefd866aedce16d1');
        $this->checkFile('lang/pap_kk.csv', 'd758407f20a526d48b8a40a161653531');
        $this->checkFile('lang/pap_ko.csv', 'ee7d8329fdac5f450b9e2cc07d8dc3a5');
        $this->checkFile('lang/pap_lt.csv', '00fff9fe2223234fdc56242b0c05017e');
        $this->checkFile('lang/pap_lv.csv', '25f9ec2629f1462baffd855e88c1601e');
        $this->checkFile('lang/pap_nl.csv', 'a13ee3f6198e2dab7600c553ce33293f');
        $this->checkFile('lang/pap_no.csv', '9e096e38db1c9ea7e3d8347bad052de5');
        $this->checkFile('lang/pap_pl.csv', 'b31edc89f9268b09a30ae711760d571d');
        $this->checkFile('lang/pap_pt-BR.csv', '879104ba039be9cfc36858d2ce45ba7e');
        $this->checkFile('lang/pap_ro.csv', 'aef50c2ebca7387766fa4abc32f05412');
        $this->checkFile('lang/pap_ru.csv', 'c77cd47d21a77875370283968d2acdff');
        $this->checkFile('lang/pap_sk.csv', '0f8be638055793ce4aa8954659661eda');
        $this->checkFile('lang/pap_sl.csv', '057ede60445cb9c053af1556e421fc5e');
        $this->checkFile('lang/pap_sr.csv', '551f956464be3347600ef885e449a42e');
        $this->checkFile('lang/pap_sv.csv', '18c82f1ca0813c7c5b7599790ffbcd2d');
        $this->checkFile('lang/pap_tr.csv', 'e9e3337cb7f9f3b6ae69deba37097692');
        $this->checkFile('lang/pap_uk.csv', '00b725ede1f7332f8e44b9effe7957a1');
        $this->checkFile('lang/pap_vi.csv', '16e98eba5173eed0b39902138bf02ef9');
        $this->checkFile('lang/pap_zh-CN.csv', 'ca75c5c3ca987d120802d74e57c723c5');
        $this->checkFile('lang/pap_zh-TW.csv', 'a09c0149cbb725b69d10c929c0089641');
        $this->checkFile('merchants/home.php', '062551077150f7558f858579d2a2a35e');
        $this->checkFile('merchants/index.php', '6e3843f94002b608bc34051cf510d369');
        $this->checkFile('merchants/js/clear.cache.gif', '6d22e4f2d2057c6e8d6fab098e76e80f');
        $this->checkFile('merchants/js/com.qualityunit.pap.AccountSignupApplication.devmode.js', '3f199adce6717da43c3e29be80984576');
        $this->checkFile('merchants/js/com.qualityunit.pap.MerchantApplication.devmode.js', '70ea57f70ad6468b5c71e10bbdb602f1');
        $this->checkFile('merchants/js/com.qualityunit.pap.MerchantApplication.nocache.php', '39c74047d610be6b61feeade7295f8e8');
        $this->checkFile('merchants/js/com.qualityunit.pap.MerchantLoginModule.devmode.js', '6e921081edc327da1a50f508eff6d5cf');
        $this->checkFile('merchants/js/com.qualityunit.pap.MerchantLoginModule.nocache.php', '01b071f5a84dbb63f059948a30e3ef6d');
        $this->checkFile('merchants/js/compilation-mappings.txt', 'f3d85a0755a74188f3d1bd7d097bc069');
        $this->checkFile('merchants/js/merchant-application-0.cache.js', '2d29dd3905f36f8bc1c77845b50661e7');
        $this->checkFile('merchants/js/merchant-application-0.cache.php', '5ca958a28ef0dbbfcd9fdf743b051972');
        $this->checkFile('merchants/js/merchant-application-1.cache.js', '5d625b42313e2c2bc87a89631a3d22e3');
        $this->checkFile('merchants/js/merchant-application-1.cache.php', '5ca958a28ef0dbbfcd9fdf743b051972');
        $this->checkFile('merchants/js/merchant-application-2.cache.js', '685d1eb38eb3a1accc43b5c399537b93');
        $this->checkFile('merchants/js/merchant-application-2.cache.php', '5ca958a28ef0dbbfcd9fdf743b051972');
        $this->checkFile('merchants/js/merchant-application-3.cache.js', 'c1b8520697d8de0168b6a2dead064b23');
        $this->checkFile('merchants/js/merchant-application-3.cache.php', '5ca958a28ef0dbbfcd9fdf743b051972');
        $this->checkFile('merchants/js/merchant-login-0.cache.js', '6df26574d685bf078cdad0703eed355e');
        $this->checkFile('merchants/js/merchant-login-0.cache.php', '5ca958a28ef0dbbfcd9fdf743b051972');
        $this->checkFile('merchants/js/merchant-login-1.cache.js', '02a54bd5e8fe369cf944d43ecdcb3688');
        $this->checkFile('merchants/js/merchant-login-1.cache.php', '5ca958a28ef0dbbfcd9fdf743b051972');
        $this->checkFile('merchants/js/merchant-login-2.cache.js', '3e196ece0e16cea91b2a00150c9310d0');
        $this->checkFile('merchants/js/merchant-login-2.cache.php', '5ca958a28ef0dbbfcd9fdf743b051972');
        $this->checkFile('merchants/js/merchant-login-3.cache.js', 'c0d3dc69b9a965511949c67c4037ea31');
        $this->checkFile('merchants/js/merchant-login-3.cache.php', '5ca958a28ef0dbbfcd9fdf743b051972');
        $this->checkFile('merchants/js/nocache.php', '68b329da9893e34099c7d8ad5cb9c940');
        $this->checkFile('merchants/login.php', 'b92b939a241c8258f090e90fdd5f67d7');
        $this->checkFile('merchants/signup.php', '849721407fd0ce76f85670b76de30aff');
        $this->checkFile('plugins/AWeber/Config.class.php', 'd87e9f6276eca016d813e1a7b932327f');
        $this->checkFile('plugins/AWeber/Definition.class.php', '37d29f5420849114a51d3cf0279f5925');
        $this->checkFile('plugins/AWeber/Mail.class.php', '37ed6152d285a96f735856f3075c3060');
        $this->checkFile('plugins/AWeber/Main.class.php', '0b0d5ed901c06753345d588b7982a274');
        $this->checkFile('plugins/AWeberAPI/Config.class.php', 'd8ee99f75b6382fa8c3bf7cbfa6c0a02');
        $this->checkFile('plugins/AWeberAPI/Definition.class.php', 'a32430b7cd10c4a1d6aa319d6a4d2f35');
        $this->checkFile('plugins/AWeberAPI/Main.class.php', 'e63a3da6380ebfa0ad6a6318af2da5d1');
        $this->checkFile('plugins/AWeberAPI/aweber_api/aweber.php', 'c8311deab02c75004923560e8dd3fb70');
        $this->checkFile('plugins/AWeberAPI/aweber_api/aweber_api.php', '5d523e1bf0e7fb847b5f9153bf6e45af');
        $this->checkFile('plugins/AWeberAPI/aweber_api/aweber_collection.php', 'e86d24c70e079c37054b6690f8c9bc01');
        $this->checkFile('plugins/AWeberAPI/aweber_api/aweber_entry.php', '3c9dc5c9d32da0512c6b7a89211f8a5e');
        $this->checkFile('plugins/AWeberAPI/aweber_api/aweber_entry_data_array.php', '9e9e14aeb95bf9f3bfdeb02cfc9cf847');
        $this->checkFile('plugins/AWeberAPI/aweber_api/aweber_response.php', '75581152151b21056f9278538030361c');
        $this->checkFile('plugins/AWeberAPI/aweber_api/curl_object.php', '0fe0db3f8023505deea463f62203f9e9');
        $this->checkFile('plugins/AWeberAPI/aweber_api/curl_response.php', 'ac48c0e16d7a69ea3ea68e0519b17b5d');
        $this->checkFile('plugins/AWeberAPI/aweber_api/exceptions.php', '34ed75c17973c9cbe741f2b9ff5f46a4');
        $this->checkFile('plugins/AWeberAPI/aweber_api/oauth_adapter.php', 'bb4244c36cb6de7b7f3c4d5085fc59a9');
        $this->checkFile('plugins/AWeberAPI/aweber_api/oauth_application.php', '39ab70f125b8e7f9332161ed372ec8fb');
        $this->checkFile('plugins/AWeberAPI/aweber_authorization.php', '3524e0d4cea66acb837eb97f1fa81380');
        $this->checkFile('plugins/ActiveCampaign/Config.class.php', '3fbae4221b191b1e141e961ddff913ed');
        $this->checkFile('plugins/ActiveCampaign/Definition.class.php', '88dc97bb5cfe6f4811a9c062f367b13e');
        $this->checkFile('plugins/ActiveCampaign/Main.class.php', 'a4a2ad045dd2df3acf3134b72253efc9');
        $this->checkFile('plugins/AffidRefid/Definition.class.php', '8cc353d8bb1403abc84eeff0237750d5');
        $this->checkFile('plugins/AffidRefid/Main.class.php', 'a0363650d55775b869ecd0c913cec10b');
        $this->checkFile('plugins/AffiliateCampaigns/Definition.class.php', '91f5aaa135e8af15069b3108fa5b043e');
        $this->checkFile('plugins/AffiliateCampaigns/Main.class.php', 'd7718d955e072b123ff69d0f1cf7fed5');
        $this->checkFile('plugins/AffiliateInfo/Config.class.php', 'a72b81b27fbd0ada0f593b6fcd18bc9b');
        $this->checkFile('plugins/AffiliateInfo/Definition.class.php', 'b4fd28b5e66a3d56fd755f65523ee418');
        $this->checkFile('plugins/AffiliateInfo/Main.class.php', 'b97ad0cc3a122d0553ef07a21b27b803');
        $this->checkFile('plugins/AffiliateInfo/affiliateinfo.php', '29a9fc4e6b4e915e370c154b509cb816');
        $this->checkFile('plugins/AffiliateProfileChangeWebhook/Config.class.php', '78df7f880b9058f9a9a047ca4ad56e8d');
        $this->checkFile('plugins/AffiliateProfileChangeWebhook/Definition.class.php', 'eb1c794123dd8edbd6e4090b10b071e8');
        $this->checkFile('plugins/AffiliateProfileChangeWebhook/Main.class.php', '42f9f6d26157ca3eca3c031abe48ca18');
        $this->checkFile('plugins/AlertPay/Config.class.php', 'e5a151f891d359ffbb0ed4805ff9bc57');
        $this->checkFile('plugins/AlertPay/Definition.class.php', '73d7575214d4ad7f347b6e314ffd728f');
        $this->checkFile('plugins/AlertPay/Main.class.php', '74b9e45877ae6b06fdf4158d5a9f311f');
        $this->checkFile('plugins/AlertPay/Tracker.class.php', 'f4708f7c21e95bfcfdc20fc19999f08f');
        $this->checkFile('plugins/AlertPay/alertpay.php', '118d2a40854c88deb95a201362eba4d3');
        $this->checkFile('plugins/AnonymizeTransactionDataFields/Config.class.php', 'a96b915a4a86ccaaee49cd206e43f523');
        $this->checkFile('plugins/AnonymizeTransactionDataFields/Definition.class.php', 'b33bf18e1731e4718cc759e9b12fd2d5');
        $this->checkFile('plugins/AnonymizeTransactionDataFields/Main.class.php', 'e3acec0cb1905b02b28e9c5974da1eca');
        $this->checkFile('plugins/ArpReach/Config.class.php', '08942816de9014275a92f5f0247c355f');
        $this->checkFile('plugins/ArpReach/Definition.class.php', '1bec05bbe4e9399b86ff82c0b23975c9');
        $this->checkFile('plugins/ArpReach/Main.class.php', '45ad66287aa7a9b4b0068fba7652fa9e');
        $this->checkFile('plugins/AssignToGroupsByProducts/Config.class.php', 'b268e31481c04a643fc0195ed7fdbaba');
        $this->checkFile('plugins/AssignToGroupsByProducts/Definition.class.php', '3415f3e99d506d14ae7a223f04f10c19');
        $this->checkFile('plugins/AssignToGroupsByProducts/Main.class.php', 'fc173ed0aab6bf2ec3e7d0c942bd32e5');
        $this->checkFile('plugins/AssignToGroupsByProfileFields/Config.class.php', '8e1a0c182a66d710319010ec3f416966');
        $this->checkFile('plugins/AssignToGroupsByProfileFields/Definition.class.php', '95fe432d5b50ccdfa06ff343280eb127');
        $this->checkFile('plugins/AssignToGroupsByProfileFields/Main.class.php', '61b478e1132d441205dff0c1055155e9');
        $this->checkFile('plugins/AuthorizeNet/Config.class.php', '227ce5f8d7e6cbe686af57de468cf427');
        $this->checkFile('plugins/AuthorizeNet/Definition.class.php', 'ebb49141ca3ab748e259c41bc58a5d59');
        $this->checkFile('plugins/AuthorizeNet/Main.class.php', '01eafae2f7726a82b318f9d6c93c1881');
        $this->checkFile('plugins/AuthorizeNet/Tracker.class.php', 'fd8cb9184b8291e7a96a7c97dd932f9a');
        $this->checkFile('plugins/AuthorizeNet/authorizenet.php', '69c32793a46dff13bc8ac18929f871cb');
        $this->checkFile('plugins/AutoApprovalCommissions/Config.class.php', 'a886eb526f2907e51f61d2790476aef1');
        $this->checkFile('plugins/AutoApprovalCommissions/Definition.class.php', '070ce90c9a9977c6180707450e704d24');
        $this->checkFile('plugins/AutoApprovalCommissions/Main.class.php', '6d62fce89c59d6af51fece8a1918458d');
        $this->checkFile('plugins/AutoApprovalCommissions/MerchantOnSaleApproved.class.php', '9da38ad834795b5df8e93127b6b4a920');
        $this->checkFile('plugins/AutoApprovalCommissions/Runner.class.php', '5a906eb366e2348545eade78ee97022a');
        $this->checkFile('plugins/AutoResponsePlus/Config.class.php', 'a5623510d3e234d804ba2ec0ad15b5ec');
        $this->checkFile('plugins/AutoResponsePlus/Definition.class.php', '2fdc77784309b4ccf2fcdff90aaeaf08');
        $this->checkFile('plugins/AutoResponsePlus/Mail.class.php', '6b4cf89155d47bfa768688b350eb4d16');
        $this->checkFile('plugins/AutoResponsePlus/Main.class.php', '25566195f088c9fba432e9cadd712b37');
        $this->checkFile('plugins/AutoResponsePlus3/Config.class.php', 'dcb7ce3b1ecc61415452a52e06e4bc99');
        $this->checkFile('plugins/AutoResponsePlus3/Definition.class.php', '0bb2bc6c8996473f7d0be96378795a1f');
        $this->checkFile('plugins/AutoResponsePlus3/Main.class.php', '475de46890ffe1926c0410347815a0e7');
        $this->checkFile('plugins/Avangate/Config.class.php', '542ae2cc70e5683bdb9f532d6e343675');
        $this->checkFile('plugins/Avangate/Definition.class.php', '1479ef778a51d9e9e8db6a07a0371b88');
        $this->checkFile('plugins/Avangate/Main.class.php', 'f08f18b7b5f5ff224a3abcfc38e27612');
        $this->checkFile('plugins/Avangate/Tracker.class.php', 'd6d042bbbb690a0c4bd4a43c033d1d29');
        $this->checkFile('plugins/Avangate/avangate.php', '7bef0d91d7ca30a0838f3af7875ca395');
        $this->checkFile('plugins/BigCommerceAPI/Config.class.php', 'bf578204038bf6b2b280372f8be33310');
        $this->checkFile('plugins/BigCommerceAPI/Definition.class.php', 'c9e142a54fe411e2d58f870a1c3d5864');
        $this->checkFile('plugins/BigCommerceAPI/Main.class.php', '1688f3c4ab52b9b3ad9feb805cf36d44');
        $this->checkFile('plugins/BigCommerceAPI/Tracker.class.php', 'f10637c3b80b9be7ac92c435389d3fe7');
        $this->checkFile('plugins/BigCommerceAPI/bigcommerce.php', '22e47e824e12805cebf6dbbaa0a39a63');
        $this->checkFile('plugins/BigCommerceAPIv3/Config.class.php', 'ff5db65bbb6327e207a99485638901e2');
        $this->checkFile('plugins/BigCommerceAPIv3/Definition.class.php', 'f03c2d7874bf883cd6c8eaa079a07db9');
        $this->checkFile('plugins/BigCommerceAPIv3/Main.class.php', '5155dd373150ecf95432ef67a0a5c2f7');
        $this->checkFile('plugins/BigCommerceAPIv3/Tracker.class.php', '12e806bc5594ca219b02499a22079739');
        $this->checkFile('plugins/BigCommerceAPIv3/bigcommerce.php', '45bd28a9b719803ace6ebb46e6a233fc');
        $this->checkFile('plugins/Bluepay/Config.class.php', 'fa16b5b0e134126478147f9f104f51c1');
        $this->checkFile('plugins/Bluepay/Definition.class.php', 'bd8c48daeb0174d76c15c381db4c1373');
        $this->checkFile('plugins/Bluepay/Main.class.php', '624a9911e5d5c417839256f51f33711d');
        $this->checkFile('plugins/Bluepay/Tracker.class.php', '71ea1e410a697ccdc7aa363c1eabda39');
        $this->checkFile('plugins/Bluepay/bluepay.php', 'd3febcc9969babd516fbc97299b8a356');
        $this->checkFile('plugins/Bluepay/test.php', 'f10e73ba8d7d22a8aada7396f2343797');
        $this->checkFile('plugins/Braintree/Config.class.php', 'da02df20ac58b2796c69650831862153');
        $this->checkFile('plugins/Braintree/Definition.class.php', '778aed937233fb786448ab1e1464a875');
        $this->checkFile('plugins/Braintree/Main.class.php', '1b3ce728847eac161a9686dd5554981a');
        $this->checkFile('plugins/Braintree/Tracker.class.php', 'c9b534b2f4037df0e218658fc4089ea7');
        $this->checkFile('plugins/Braintree/braintree.php', '93e4fdde6b1e96d29b8231c0fcb0bca4');
        $this->checkFile('plugins/BusinessCatalyst/Config.class.php', 'b3f126ae561a9d6558020908fb9e1aeb');
        $this->checkFile('plugins/BusinessCatalyst/Definition.class.php', 'ab3ffb3ca0d6d3425e8836d35f279cc9');
        $this->checkFile('plugins/BusinessCatalyst/Main.class.php', '582e2d77ace2aa53f40052ffef052e95');
        $this->checkFile('plugins/BusinessCatalyst/Retrieve.class.php', '1b3f483ced1cf7790aab9134ad02ff07');
        $this->checkFile('plugins/BusinessCatalyst/RetrieveCase.class.php', '68ac736e3be41c7d269782b463863987');
        $this->checkFile('plugins/BusinessCatalyst/RetrieveOrders.class.php', '4ba649e32368ca70dc4df585778f159e');
        $this->checkFile('plugins/BusinessCatalyst/Tracker.class.php', 'a1ba8afd3c1bc5742cf64086d21d682c');
        $this->checkFile('plugins/BusinessCatalyst/bc.php', '715cbfb8915519b779c2aacff33eb399');
        $this->checkFile('plugins/ChannelsListInTemplates/Definition.class.php', '2da4eb586ca2cbc341e088d642c3b584');
        $this->checkFile('plugins/ChannelsListInTemplates/Main.class.php', '19e8ed0fd6ef5a83fa27c3f0ecbdea03');
        $this->checkFile('plugins/Chargebee/Config.class.php', '2e822585b40a7db041a5d8cc7db79d62');
        $this->checkFile('plugins/Chargebee/Definition.class.php', '852095cd806743088dd96e8ffb270bdf');
        $this->checkFile('plugins/Chargebee/Main.class.php', '04a4d77d32d10334931edb5b522e91b9');
        $this->checkFile('plugins/Chargebee/Tracker.class.php', '9b0f8c3e22cd097e0bcd0174d0dc3266');
        $this->checkFile('plugins/Chargebee/chargebee.php', '79eaa8d15fadc59e01eaac33c7f6ad97');
        $this->checkFile('plugins/Chargify/Config.class.php', 'a306df6514437c1c760a4687ea2ac18c');
        $this->checkFile('plugins/Chargify/Definition.class.php', '8193c5ab0c5f9d4769dd5d9d90f1cea7');
        $this->checkFile('plugins/Chargify/Main.class.php', 'edf7179381883f3088089579ecf97f5e');
        $this->checkFile('plugins/Chargify/Tracker.class.php', '7ecb779f349cd58483b3b641aab26037');
        $this->checkFile('plugins/Chargify/chargify.php', 'df0ed25c754ed9002cbfc2fea99b4795');
        $this->checkFile('plugins/CheddarGetter/Config.class.php', '203a7f3b8033d55fd3813ea4d64cbf84');
        $this->checkFile('plugins/CheddarGetter/Definition.class.php', '989e2105a52a1c17b68283dca2f17c8b');
        $this->checkFile('plugins/CheddarGetter/Main.class.php', '8a9df853f9f837721ab78812a819eaa9');
        $this->checkFile('plugins/CheddarGetter/Tracker.class.php', '3af5bacce1f6a73be7ce1165d2337137');
        $this->checkFile('plugins/CheddarGetter/cheddargetter.php', '22c92128bfec77acc8d2cb714526d197');
        $this->checkFile('plugins/Cleeng/Config.class.php', 'c22bd98f7a3e2f53489c4a12a0a74cb8');
        $this->checkFile('plugins/Cleeng/Definition.class.php', '5626bded02a22e566b3cadce6ab1df5d');
        $this->checkFile('plugins/Cleeng/Main.class.php', '1a6ad223516e2640652486539ca50e8f');
        $this->checkFile('plugins/Cleeng/Tracker.class.php', '065e1c632265fc0d24398ed1b6ffcca0');
        $this->checkFile('plugins/Cleeng/cleeng.php', '7ad9d640fb3165636412c306eba9cd7d');
        $this->checkFile('plugins/ClickStatsOptimizer/Definition.class.php', '48b0e298ff061852aeba3ce87ba2321f');
        $this->checkFile('plugins/ClickStatsOptimizer/Main.class.php', 'b7c9b542abc8341467ac13bba7a03495');
        $this->checkFile('plugins/CommerceGate/Config.class.php', 'e56ae96167596ccf3ac87b81ee5acb67');
        $this->checkFile('plugins/CommerceGate/Definition.class.php', '844f863c76baff8f36429034a6670ce9');
        $this->checkFile('plugins/CommerceGate/Main.class.php', 'e791e045facbe3366188f6ed34f299ec');
        $this->checkFile('plugins/CommerceGate/Tracker.class.php', '196938ef11896c281ee80a365665bde1');
        $this->checkFile('plugins/CommerceGate/commercegate.php', '7826639efdf34fcfef9c958ea2787115');
        $this->checkFile('plugins/CommissionBonus/Definition.class.php', '5984af290cd4ad77a5ac354350417c57');
        $this->checkFile('plugins/CommissionBonus/Main.class.php', '0a6f594a0619cf3c52f2979f883ed033');
        $this->checkFile('plugins/CommissionGroupsSynchro/Definition.class.php', 'd64818368f8f8eb529dbf3adf0e3e8e2');
        $this->checkFile('plugins/CommissionGroupsSynchro/Main.class.php', '5fbf1218dc9753f603263d874f17bf25');
        $this->checkFile('plugins/CouponGeneratorForNewAffiliates/Config.class.php', '4d83ce50b6d13d96ab05e5c780b65d0a');
        $this->checkFile('plugins/CouponGeneratorForNewAffiliates/Definition.class.php', '9b48d4b6edbc0f97a51dd5f9df024b9b');
        $this->checkFile('plugins/CouponGeneratorForNewAffiliates/Main.class.php', '00076904fe9fa30bd54c769e1b887a27');
        $this->checkFile('plugins/Cratejoy/Config.class.php', 'bcde3e9a34cf8b39dc5be1077f009aec');
        $this->checkFile('plugins/Cratejoy/Definition.class.php', '4e2db1cb8e82aea19c5fadd729c3e366');
        $this->checkFile('plugins/Cratejoy/Main.class.php', '87296bd2d6f8b99ab034c802eedc905b');
        $this->checkFile('plugins/Cratejoy/Tracker.class.php', '7cce47869bace8c1cb02440c19f304dc');
        $this->checkFile('plugins/Cratejoy/cratejoy.php', '8d0899d06fa3c5ea7777cd4504a75c3d');
        $this->checkFile('plugins/CustomOptionsInTrendsReport/Definition.class.php', '2fd98aa8dcf32f9ce3cbbebd037443bb');
        $this->checkFile('plugins/CustomOptionsInTrendsReport/Main.class.php', 'd0f527cab3a6afc955ad478d263e85c3');
        $this->checkFile('plugins/CustomOptionsInTrendsReport/TierActionDataType.class.php', '8b9d2371388f62caea3009129c908b58');
        $this->checkFile('plugins/CustomOptionsInTrendsReport/TierTransactionDataType.class.php', '188c7e4a92185a3d76e7a992f7d9703f');
        $this->checkFile('plugins/CustomRecurringLevel/Config.class.php', 'd941456bd3d3d088f411cdfa4dc7a1fc');
        $this->checkFile('plugins/CustomRecurringLevel/Definition.class.php', '4eb964f5fe0231300ebe406bf63722bf');
        $this->checkFile('plugins/CustomRecurringLevel/Main.class.php', 'c679daee359882268c10200be91efd36');
        $this->checkFile('plugins/CustomRefid/Config.class.php', '5ee99b2c9d8edaef09d844241f0188a2');
        $this->checkFile('plugins/CustomRefid/CustomRefidConstraint.class.php', '4fac4a226225061aebf72398e81e0bc8');
        $this->checkFile('plugins/CustomRefid/Definition.class.php', 'eb1f6d245400af2651966bb75a72aa8e');
        $this->checkFile('plugins/CustomRefid/Main.class.php', '3acc7deefe4b80b59a95a16c35d9bb19');
        $this->checkFile('plugins/CyberSource/Config.class.php', '00e387607ee956141475a31bf959e31b');
        $this->checkFile('plugins/CyberSource/Definition.class.php', 'aefb5e0aeb5a0385b7b848ff195cf951');
        $this->checkFile('plugins/CyberSource/Main.class.php', '23208758dab7b4bedfd2995809bf15df');
        $this->checkFile('plugins/CyberSource/Tracker.class.php', '9770a279153557d4067b5a3c69cbc4f7');
        $this->checkFile('plugins/CyberSource/cybersource.php', '698958b9c93b5acda04d096a71efd491');
        $this->checkFile('plugins/DatabaseStatus/Definition.class.php', '097da440c67ee1b68278a467607c5c4e');
        $this->checkFile('plugins/DatabaseStatus/Main.class.php', '2eb7d4c88ad12bb0406d4e4df9794a4b');
        $this->checkFile('plugins/DefaultSignupValues/Config.class.php', '90d220eacd6e89fd11eafbc54e52561a');
        $this->checkFile('plugins/DefaultSignupValues/Definition.class.php', 'e78f5e856379c927647f420a4def145c');
        $this->checkFile('plugins/DefaultSignupValues/Main.class.php', '41cc11b2201ccd2ccc5758dc2c018eca');
        $this->checkFile('plugins/DontOverwriteCookieForDays/Definition.class.php', 'e53846b8d235e2893c11d4f7ed882eed');
        $this->checkFile('plugins/DontOverwriteCookieForDays/Main.class.php', '84340f36d2c81c498068f51be4a8fb5b');
        $this->checkFile('plugins/Dwolla/Config.class.php', 'b38a300504f8f3441f2e44c48a5a2e64');
        $this->checkFile('plugins/Dwolla/Definition.class.php', '8a18d68a8f83a83c4f788c366d30728f');
        $this->checkFile('plugins/Dwolla/Main.class.php', '145af63fc19278e02b54a155ae319285');
        $this->checkFile('plugins/Dwolla/Tracker.class.php', '4c2f6409708e6fa38017d6c792c3bb0b');
        $this->checkFile('plugins/Dwolla/dwolla.php', 'a4fc592acd238913e640a262aee36e6d');
        $this->checkFile('plugins/EasyLocator/AffiliateUpdateTask.class.php', 'f5e9aa259fa7062b9f331dc1ab244db3');
        $this->checkFile('plugins/EasyLocator/Config.class.php', '1e2ccdc0e91a7ebdd8c75c0452ca0c65');
        $this->checkFile('plugins/EasyLocator/Definition.class.php', '05de95794063f1b5cfc75b07af3dacea');
        $this->checkFile('plugins/EasyLocator/JsonRPCClient.class.php', '05701e30a4aac3ffa106961e5779de2d');
        $this->checkFile('plugins/EasyLocator/Main.class.php', '39beffe1cd527c08d0015f2267af45d3');
        $this->checkFile('plugins/EcwidAPI/Config.class.php', 'e5961d89762a5eee7e6607e95c329d20');
        $this->checkFile('plugins/EcwidAPI/Definition.class.php', 'b13be3e3b4feba303bbaeef168ca6ad1');
        $this->checkFile('plugins/EcwidAPI/Main.class.php', '770301eab653d93b3493e353ae020cb3');
        $this->checkFile('plugins/EcwidAPI/Tracker.class.php', '274e3824e2940b460b43223891176f75');
        $this->checkFile('plugins/EcwidAPI/ecwidapi.php', '5d81faeb8f68cb272924c9ca69ef5ef5');
        $this->checkFile('plugins/Ejunkie/Config.class.php', '2a9ab31629612038db10a4346acc6172');
        $this->checkFile('plugins/Ejunkie/Definition.class.php', '9d1d28a9728b70575f9290e088365169');
        $this->checkFile('plugins/Ejunkie/Main.class.php', '2198193c69d2173af2298345e1b839bf');
        $this->checkFile('plugins/Ejunkie/Tracker.class.php', '070b78950a990c488fd95b23e8b1a578');
        $this->checkFile('plugins/Ejunkie/ejunkie.php', '8a7936e473a2eb07c2f26657363e6bfe');
        $this->checkFile('plugins/Ejunkie/test.php', '2d567b4628e2f5212e027246eddff066');
        $this->checkFile('plugins/Eventbrite/Config.class.php', 'ac3ded57b3fd26a9b3fd77e9be63e241');
        $this->checkFile('plugins/Eventbrite/Definition.class.php', '729c7d66e7097d04994156641206a099');
        $this->checkFile('plugins/Eventbrite/Main.class.php', '97f85373ababcca086d54c1c988106b4');
        $this->checkFile('plugins/Eventbrite/Tracker.class.php', '78caea0e2342e95ced5def4a32024d58');
        $this->checkFile('plugins/Eventbrite/eventbrite.php', 'c8196d63eb551931cf60ff94b3a93cbc');
        $this->checkFile('plugins/Eway/Config.class.php', '7104e8bc093cc98402de48c8cc5ac4d0');
        $this->checkFile('plugins/Eway/Definition.class.php', '946a8bcfca5bd2e41a9b09cf943ce74b');
        $this->checkFile('plugins/Eway/Main.class.php', 'd9a9b10cb3df26417243ccb500830582');
        $this->checkFile('plugins/Eway/Tracker.class.php', 'ee23a38684a292955430cc406f494b52');
        $this->checkFile('plugins/Eway/eway.php', '5fe661f28dbf1f8fcbd4673ed929b6f1');
        $this->checkFile('plugins/FastSpring/Config.class.php', '66806ed4c0b907071b85fb3591751499');
        $this->checkFile('plugins/FastSpring/Definition.class.php', 'e5a45a25f3e343728f8fd7e76bb555e6');
        $this->checkFile('plugins/FastSpring/Main.class.php', '8d8074ba8546cd71b7bbefadcf3802d8');
        $this->checkFile('plugins/FastSpring/Tracker.class.php', '75e2b2bb10c8606f99d80c4dc94bebb9');
        $this->checkFile('plugins/FastSpring/fastspring.php', '3b9a1173af83f79f00aa0fb784f05305');
        $this->checkFile('plugins/GeneralWebhookProcessor/Config.class.php', '1dbe5f45653fb461ebb15308c9cd2c5d');
        $this->checkFile('plugins/GeneralWebhookProcessor/Definition.class.php', 'ef0488066f7cb3135712784d73690c62');
        $this->checkFile('plugins/GeneralWebhookProcessor/Main.class.php', 'defd9d48ee20c0874547d7ff56beb4c8');
        $this->checkFile('plugins/GeneralWebhookProcessor/hook.php', '2ff22c9d4c99d91bf480190ac377c799');
        $this->checkFile('plugins/GeoIp/Definition.class.php', 'b877679d60af350efd42cb54d7cb76a5');
        $this->checkFile('plugins/GeoIp/Driver/File.class.php', '0a0d259f67511a829ff267d4a285ab03');
        $this->checkFile('plugins/GeoIp/Driver.class.php', 'a5326a2da0f15d006674ab63cc4cfdce');
        $this->checkFile('plugins/GeoIp/GeoService.class.php', '457199b185e19a7c2a3816de2729690a');
        $this->checkFile('plugins/GeoIp/Location.class.php', '1bbee27e0429d406af4282bf67c4a42f');
        $this->checkFile('plugins/GeoIp/Main.class.php', 'd3b35a5f2e3f2bb5348d82bbbc05b70b');
        $this->checkFile('plugins/GetResponseSignup/Client.class.php', '61807c362ad90b1bb30f592d9f4ec678');
        $this->checkFile('plugins/GetResponseSignup/Config.class.php', '2798c6c5a4973ec058d44f3891b9890a');
        $this->checkFile('plugins/GetResponseSignup/Definition.class.php', '86d80ee01c24522bbc3a87ddaaa4e3a3');
        $this->checkFile('plugins/GetResponseSignup/JsonRPCClient.class.php', '9a90d8b5df1af60025c7bfd9dd5156d1');
        $this->checkFile('plugins/GetResponseSignup/Main.class.php', 'b945882448d2911d3993d6e3afdf06ce');
        $this->checkFile('plugins/GetResponseSignup/V3Client.class.php', 'f40c7cd84476440821077cfdbba2c383');
        $this->checkFile('plugins/GoogleCheckout/Config.class.php', '0ce5fe5aadf32aa592f6bec0c32985c5');
        $this->checkFile('plugins/GoogleCheckout/Definition.class.php', '4621f89a09bc498340a5bc27b238590e');
        $this->checkFile('plugins/GoogleCheckout/GoogleLog.class.php', 'b9769dc3e263853cbd03390c5fcc14c8');
        $this->checkFile('plugins/GoogleCheckout/GoogleResponse.class.php', 'c06ccf9d9f2d431788b4289da2659558');
        $this->checkFile('plugins/GoogleCheckout/Main.class.php', '26a806a03263e00338f70d1de7aae281');
        $this->checkFile('plugins/GoogleCheckout/Tracker.class.php', 'bb4994673aa15b0faac1dc371f0ffef9');
        $this->checkFile('plugins/GoogleCheckout/googlecheckout.php', '3c959fdc387791a48376f744a5facd8f');
        $this->checkFile('plugins/HideCampaigns/Definition.class.php', '781c30edeb471e145e257aaedeb416ba');
        $this->checkFile('plugins/HideCampaigns/Main.class.php', 'ab333c9cddc02dd81190a37e5a529c45');
        $this->checkFile('plugins/HideIPAddresses/Config.class.php', 'a7955f53281143edb3e738c9bb993a62');
        $this->checkFile('plugins/HideIPAddresses/Definition.class.php', '90bf1cf1d24979943f14382e31f771aa');
        $this->checkFile('plugins/HideIPAddresses/Main.class.php', 'e270c59de40c0cfe0a715c4f9c4e4067');
        $this->checkFile('plugins/HubSpot/Config.class.php', '7210d8e2ae65324738cc067b11e1b6f2');
        $this->checkFile('plugins/HubSpot/Definition.class.php', '2db18f5921331adca9bb8f7b9bdd9973');
        $this->checkFile('plugins/HubSpot/Main.class.php', 'd26652b1f23c74934a937418ff81fbe2');
        $this->checkFile('plugins/ISecure/Config.class.php', '558b21019a9dbedfd86f17c9981582af');
        $this->checkFile('plugins/ISecure/Definition.class.php', '818a71984bad47effb66426c6be4c380');
        $this->checkFile('plugins/ISecure/Main.class.php', 'cb099c4e3ef3da51491779fc886afade');
        $this->checkFile('plugins/ISecure/Tracker.class.php', '69e600b054ee18d3cdeea53da23d1edf');
        $this->checkFile('plugins/ISecure/isecure.php', 'd473be98314fe5758936eb8a52daa602');
        $this->checkFile('plugins/ISecure/test.php', '02137feba77a89857e568b623dd70b3c');
        $this->checkFile('plugins/Infusionsoft/Config.class.php', '7def217edfeb66be1e9264dbe15c1d31');
        $this->checkFile('plugins/Infusionsoft/Definition.class.php', '10a1afb6a8734aee2ddf1e293567b811');
        $this->checkFile('plugins/Infusionsoft/Main.class.php', '5c464e85c11025dac13e319e6b800562');
        $this->checkFile('plugins/Infusionsoft/Tracker.class.php', 'f24dd2bf91f78fb67a8dec9e774106d8');
        $this->checkFile('plugins/Infusionsoft/infusionsoft.php', 'e6b5f08cc2c285f2192b7475104be512');
        $this->checkFile('plugins/Intercom/Config.class.php', '9ebc925d83467a3a3a595ce40c3d6765');
        $this->checkFile('plugins/Intercom/Definition.class.php', '31c50a44068fc8d3fd83b65abb2ecac6');
        $this->checkFile('plugins/Intercom/Main.class.php', 'ee469088c05e21a1aa61696867221956');
        $this->checkFile('plugins/InterspireEmailMarketer/Config.class.php', '4b0c02591fecaada89edac3efe76bc29');
        $this->checkFile('plugins/InterspireEmailMarketer/Definition.class.php', '3fe40dbaae650772387801026bf83333');
        $this->checkFile('plugins/InterspireEmailMarketer/Main.class.php', 'd10b6be6d0507af88e3cb4fcb445a56e');
        $this->checkFile('plugins/Kartra/Config.class.php', 'e243b10f969116f1c9659763123a6986');
        $this->checkFile('plugins/Kartra/Definition.class.php', '3ce6457bf10677d212250182068fc09e');
        $this->checkFile('plugins/Kartra/Main.class.php', 'bca96c691a0d2396a632e561943edf06');
        $this->checkFile('plugins/Kartra/Tracker.class.php', '230ab7a6e4f06efc93c7ed587d079667');
        $this->checkFile('plugins/Kartra/kartra.php', '5fea0c7bfd31c264e761480716af8867');
        $this->checkFile('plugins/LifetimeCommissions/Config.class.php', '43cb255275bdd7cc5b474f8cb0c2fb7c');
        $this->checkFile('plugins/LifetimeCommissions/Definition.class.php', 'dd8a687e292d367761b64cad5d07eec9');
        $this->checkFile('plugins/LifetimeCommissions/Main.class.php', '68d670d73818c24c151491e3fdb9a3a3');
        $this->checkFile('plugins/LimeLight/Config.class.php', 'a42ea035a1a7f98c5f8b99b149bbc96c');
        $this->checkFile('plugins/LimeLight/Definition.class.php', 'bec4fc3a6f01f11d0ced4f58fb85b37c');
        $this->checkFile('plugins/LimeLight/Main.class.php', '1f7cc9da70acfe71c1d0b2ce0008327e');
        $this->checkFile('plugins/LimeLight/Tracker.class.php', 'e0ad89146a5ed54bcfcc4c0e3fe71f80');
        $this->checkFile('plugins/LimeLight/limelight.php', 'ef1400af3112273eab815213e2374cb3');
        $this->checkFile('plugins/MailChimpSynchro/Config.class.php', 'c31e125f42cc09743fd54c42e524083f');
        $this->checkFile('plugins/MailChimpSynchro/Definition.class.php', '5316cc24dc36ac2cac995034a3e62c97');
        $this->checkFile('plugins/MailChimpSynchro/MCAPI.class.php', '275a0905bed9fa264cf3d53fc103f5bc');
        $this->checkFile('plugins/MailChimpSynchro/Main.class.php', 'b98505d0e5ba58597a608101c444d320');
        $this->checkFile('plugins/MailChimpSynchro/mailchimp.php', 'b1f9e3b4767f72ebfdce0065b2e9d3d7');
        $this->checkFile('plugins/MailChimpV3/Config.class.php', 'a368c4fde64dc60c48fed180ee217a4f');
        $this->checkFile('plugins/MailChimpV3/Definition.class.php', '01a7c414cfc055a438dadb46b463a57d');
        $this->checkFile('plugins/MailChimpV3/Main.class.php', 'c3fccd7dc3569df9543e8dfd0476d9a7');
        $this->checkFile('plugins/MailChimpV3/mailchimp.php', 'aa20b57a73de965747c43ae96e3f42a1');
        $this->checkFile('plugins/MandatoryRefid/Definition.class.php', 'c59abefc653c3e1871b8050254b44740');
        $this->checkFile('plugins/MandatoryRefid/Main.class.php', 'b62dd2c9b8d1a19ddd5fca1ca6048ab0');
        $this->checkFile('plugins/MaxCommissionsPerReferral/Config.class.php', '3876825f59693cb4d401f488f437d70a');
        $this->checkFile('plugins/MaxCommissionsPerReferral/Definition.class.php', '5443b185d2e2b41377822733d8a5fb3a');
        $this->checkFile('plugins/MaxCommissionsPerReferral/Main.class.php', '20831743a976f975a8b26a9226890ce3');
        $this->checkFile('plugins/MemberMouse/Config.class.php', '1ab3c7cb21c85b598c8be6e4af47b40b');
        $this->checkFile('plugins/MemberMouse/Definition.class.php', '800e64582b19c8b40bb6fc4671acfdaf');
        $this->checkFile('plugins/MemberMouse/Main.class.php', '2176ebf62c15e858ddd55faaa4570241');
        $this->checkFile('plugins/MemberMouse/Tracker.class.php', 'e4974cea0fd59e24998a3e7fcef2cad8');
        $this->checkFile('plugins/MemberMouse/membermouse.php', '8c918de3d1e06a5c33894ccf0155dd1e');
        $this->checkFile('plugins/MerchantPages/Config.class.php', 'c7d811c42d15590b5a07ad8ad7fc3819');
        $this->checkFile('plugins/MerchantPages/Definition.class.php', 'adda70ab84d9689104cd33d9fa6ae53e');
        $this->checkFile('plugins/MerchantPages/Main.class.php', '9e5b1016e1e30e21fbe036b4737b5d39');
        $this->checkFile('plugins/MinTotalCost/Config.class.php', '528f0119fb9e5276ddccb1503d13fcee');
        $this->checkFile('plugins/MinTotalCost/Definition.class.php', '3840c83ada3fd91a2c2a2dee1ef6b0bf');
        $this->checkFile('plugins/MinTotalCost/Main.class.php', 'f0a1907f6f078b7e992f775be7aef8cf');
        $this->checkFile('plugins/MoneyBookers/Config.class.php', 'ad3cd8320c94a2db76b4e2cf332bcb17');
        $this->checkFile('plugins/MoneyBookers/Definition.class.php', 'dbd3916b6d204e88c3ec699b8643ae79');
        $this->checkFile('plugins/MoneyBookers/Main.class.php', '8b380d22421c0843f9b7e3ade871a3e5');
        $this->checkFile('plugins/MoneyBookers/Tracker.class.php', 'b1dae3f560e3648889e1810e1f6461ff');
        $this->checkFile('plugins/MoneyBookers/moneybookers.php', '8289c4be0701b4099085764e7be534c4');
        $this->checkFile('plugins/MoneyBookers/test.php', '263eacdce05bb8d7d723a6a3b825c1b6');
        $this->checkFile('plugins/MonthlyActionCommission/CommissionRunner.class.php', '3408f625ae53ee2b843275b06c9ed801');
        $this->checkFile('plugins/MonthlyActionCommission/Config.class.php', 'd6fa2c92376a68926da1521c6483664a');
        $this->checkFile('plugins/MonthlyActionCommission/Definition.class.php', '13d35c20cdfcbcc55ee91cfb473a9083');
        $this->checkFile('plugins/MonthlyActionCommission/Main.class.php', '61b81c6e520714e017ab62f3533b27c8');
        $this->checkFile('plugins/Moonclerk/Config.class.php', '0b81cac6729752220af9e372845e8154');
        $this->checkFile('plugins/Moonclerk/Definition.class.php', 'e110b59c86fc0641ea03c0c2243969bc');
        $this->checkFile('plugins/Moonclerk/Main.class.php', '592e59e98fb29ee9421a1bdfcbaaa1bc');
        $this->checkFile('plugins/Moonclerk/Tracker.class.php', 'dc018983cdab68f82c085f32a40ee376');
        $this->checkFile('plugins/Moonclerk/lib/Stripe/Account.php', '340710912eb0ec204c1cfe8e430c2f75');
        $this->checkFile('plugins/Moonclerk/lib/Stripe/ApiConnectionError.php', '68df2237c9e802856535e5807f1957f4');
        $this->checkFile('plugins/Moonclerk/lib/Stripe/ApiError.php', 'f6ac4e94fcd6354bb46f471eb17c30da');
        $this->checkFile('plugins/Moonclerk/lib/Stripe/ApiRequestor.php', '3adb7c13adbe93a1fa0e5506ec0f5b59');
        $this->checkFile('plugins/Moonclerk/lib/Stripe/ApiResource.php', '03838d6c4a72e7020a24bd0e9cd59019');
        $this->checkFile('plugins/Moonclerk/lib/Stripe/AuthenticationError.php', '405a594c072b3eeb3f39859bcd7984ba');
        $this->checkFile('plugins/Moonclerk/lib/Stripe/Card.php', 'e8fdaf813e89e736cc3cde7d9aed8c41');
        $this->checkFile('plugins/Moonclerk/lib/Stripe/CardError.php', 'a241c5a8788e59c8b690bbe845cae6f7');
        $this->checkFile('plugins/Moonclerk/lib/Stripe/Charge.php', '79d5895a63e7aa48acfc92f36483894b');
        $this->checkFile('plugins/Moonclerk/lib/Stripe/Coupon.php', 'db1c52041f8629b62c07230c2a8837af');
        $this->checkFile('plugins/Moonclerk/lib/Stripe/Customer.php', '61e800cf298b376656305f09e58e81f8');
        $this->checkFile('plugins/Moonclerk/lib/Stripe/Error.php', '3445f27abb55918cc9d593a07c463b8d');
        $this->checkFile('plugins/Moonclerk/lib/Stripe/Event.php', '8593f7dc7ee471421034231269f0cc55');
        $this->checkFile('plugins/Moonclerk/lib/Stripe/InvalidRequestError.php', '4e893a93457276b6847daacba38e4193');
        $this->checkFile('plugins/Moonclerk/lib/Stripe/Invoice.php', 'f8ebf4c31718fd3d783b594ee44d7bea');
        $this->checkFile('plugins/Moonclerk/lib/Stripe/InvoiceItem.php', '86fde4c4464b791b2f362ddfc6940c8c');
        $this->checkFile('plugins/Moonclerk/lib/Stripe/List.php', 'bc0b399bc14833ed5a103371f20f08ec');
        $this->checkFile('plugins/Moonclerk/lib/Stripe/Object.php', '621e86a72e081d10db2527c18ac06572');
        $this->checkFile('plugins/Moonclerk/lib/Stripe/Plan.php', '613fd92404f21a43824bf5a2649737d5');
        $this->checkFile('plugins/Moonclerk/lib/Stripe/Recipient.php', '17737e39b1096c6e555b336b44a8313c');
        $this->checkFile('plugins/Moonclerk/lib/Stripe/SingletonApiResource.php', '5cfda80f66d1fbb2e6a6ccee07816d92');
        $this->checkFile('plugins/Moonclerk/lib/Stripe/Stripe.php', '339cf5523a11f9e4851240993068792b');
        $this->checkFile('plugins/Moonclerk/lib/Stripe/Token.php', '3459786109316805cdcac4745d5c3a72');
        $this->checkFile('plugins/Moonclerk/lib/Stripe/Transfer.php', 'f27fca78ec7990a1519be22926887fdb');
        $this->checkFile('plugins/Moonclerk/lib/Stripe/Util/Set.php', '9c0aab301a817cc7bc9fc4b4d1d91f12');
        $this->checkFile('plugins/Moonclerk/lib/Stripe/Util.php', 'b61a5a5352adec9b0f7201b06080ad8c');
        $this->checkFile('plugins/Moonclerk/lib/Stripe.php', '3a5ff46e95c74dc5ee5169974e759aff');
        $this->checkFile('plugins/Moonclerk/lib/data/ca-certificates.crt', 'bf4376caf777a5387c776ba554fa79ea');
        $this->checkFile('plugins/Moonclerk/moonclerk.php', 'c7a4f60d40e13a3de8591c52802615cd');
        $this->checkFile('plugins/Netbilling/Definition.class.php', '41edce4eb41f1abd194b7470a2749883');
        $this->checkFile('plugins/Netbilling/Tracker.class.php', '3cc96b33e6d3b8cecf02740048a9fcad');
        $this->checkFile('plugins/Netbilling/netbilling.php', 'a1d80748d7c90492e1b0cc1f2ae83621');
        $this->checkFile('plugins/NumberRefid/AffiliateRegExpConstraint.class.php', '2f0580590bdf0d00dfa3119fe2fb6e9e');
        $this->checkFile('plugins/NumberRefid/Definition.class.php', 'd03fd11ae42939168ae542f61652c1d6');
        $this->checkFile('plugins/NumberRefid/Main.class.php', 'dd69043f17fd40488def62cb75296397');
        $this->checkFile('plugins/OneShoppingCart/Config.class.php', '13a6cde9f3fc8fb7564c14880a3035d4');
        $this->checkFile('plugins/OneShoppingCart/Definition.class.php', 'e582763b5d637db2afb97e2c97aabbb8');
        $this->checkFile('plugins/OneShoppingCart/Main.class.php', '246b263fa14f2cdc794953b38c3dc5a7');
        $this->checkFile('plugins/OneShoppingCart/Tracker.class.php', '09629130331ad301dba1b2a3114b101c');
        $this->checkFile('plugins/OneShoppingCart/oneshoppingcart.php', '9321f57698abb3fc09f87bb790d165cd');
        $this->checkFile('plugins/OptimizeMember/Config.class.php', 'ba7fd80a4d6b4ca02d52415962e8283e');
        $this->checkFile('plugins/OptimizeMember/Definition.class.php', 'bed388d12ed3c32cca46f75e2f8fcef6');
        $this->checkFile('plugins/OptimizeMember/Main.class.php', '25e5c3f719262dd598e381ac6e6079e0');
        $this->checkFile('plugins/OptimizeMember/Tracker.class.php', '8af27b40ed26693aa49e7322c1c5ad13');
        $this->checkFile('plugins/OptimizeMember/optimizemember.php', '25c3ca6dae51cb532397ec4589d6384f');
        $this->checkFile('plugins/PagSeguro/Config.class.php', 'c2abe17927db940fd48b38519f9cf925');
        $this->checkFile('plugins/PagSeguro/Definition.class.php', '0039713cd3440006383e1dcfc2ad9d4c');
        $this->checkFile('plugins/PagSeguro/Main.class.php', '50220f2985d131ad8c75c8884dfd1179');
        $this->checkFile('plugins/PagSeguro/Tracker.class.php', 'a2e6b95e054380d03c94df088c4861e1');
        $this->checkFile('plugins/PagSeguro/pagseguro.php', 'ab2834dd1cecfead9b26bcc44bdade06');
        $this->checkFile('plugins/PagosOnline/Config.class.php', '287c6fd7616ddf1c3b5ff7b485de3ef4');
        $this->checkFile('plugins/PagosOnline/Definition.class.php', '7179d54f4a7c80ea0a78b19582315a4d');
        $this->checkFile('plugins/PagosOnline/Main.class.php', 'ade63ae179048bd961bd4c44c65d32d9');
        $this->checkFile('plugins/PagosOnline/Tracker.class.php', '5d882ba6b342489319e132a9bb219fec');
        $this->checkFile('plugins/PagosOnline/pagosonline.php', '2f18704617b62b290261f728d97af47a');
        $this->checkFile('plugins/Pap3Compatibility/Definition.class.php', 'f634cedc05d91b1eb680d8f267eb2237');
        $this->checkFile('plugins/Pap3Compatibility/Migration/CannotUpgradeScenario.class.php', '1983312c0cbb3198ff0a2d4993bc95c1');
        $this->checkFile('plugins/Pap3Compatibility/Migration/DeletePap4Tables.class.php', '71c54b8b72020261461d738a17112ff7');
        $this->checkFile('plugins/Pap3Compatibility/Migration/LongTask.class.php', 'aebd5c4ea3015f51b6e32997aa4c37ae');
        $this->checkFile('plugins/Pap3Compatibility/Migration/OutputWriter.class.php', 'a2b3c95080685596301f2c3ff16f297e');
        $this->checkFile('plugins/Pap3Compatibility/Migration/Pap3Constants.class.php', 'e8872466949655f83e13d55956e5914d');
        $this->checkFile('plugins/Pap3Compatibility/Migration/TaskAffiliates.class.php', 'b307e6809bdad804063a796c44965fd6');
        $this->checkFile('plugins/Pap3Compatibility/Migration/TaskAffiliatesData.class.php', 'd4f4cb991c72f914e843653fe096ff98');
        $this->checkFile('plugins/Pap3Compatibility/Migration/TaskBanners.class.php', '7aa9554adfed023584a3cf4af8828e49');
        $this->checkFile('plugins/Pap3Compatibility/Migration/TaskCampaigns.class.php', '9356839e4f68420f0f5d75af7307d215');
        $this->checkFile('plugins/Pap3Compatibility/Migration/TaskClickCounts.class.php', '26837bdf9d6a80520d14dc32a646a2ed');
        $this->checkFile('plugins/Pap3Compatibility/Migration/TaskClickImpCounts.class.php', '0b708f7130994c932d76ccef5ab0db79');
        $this->checkFile('plugins/Pap3Compatibility/Migration/TaskClicksImpsCommissions.class.php', '9870e96e60f8c70209bf556fa1efb339');
        $this->checkFile('plugins/Pap3Compatibility/Migration/TaskImpCounts.class.php', '4f174aee2d5588af91684d658c129b09');
        $this->checkFile('plugins/Pap3Compatibility/Migration/TaskPayouts.class.php', 'bde481440364d6b806f3124014510f32');
        $this->checkFile('plugins/Pap3Compatibility/Migration/TaskSalesCommissions.class.php', '5def601d723273e007976dfd953534e0');
        $this->checkFile('plugins/Pap3Compatibility/Migration/TaskSettings.class.php', '78ea93439d739d1280d3ce7ed7bd1ac5');
        $this->checkFile('plugins/Pap3Compatibility/Migration/TaskSpecialCommissions.class.php', 'b006199d263514c28bcf62d3fe85364d');
        $this->checkFile('plugins/Pap3Compatibility/Migration/TaskTransactions.class.php', 'd349dfe83154870c773fc4e6a5063860');
        $this->checkFile('plugins/Pap3Compatibility/Migration/UpgradeFromPap3.class.php', 'fca604ccddf04320dd514cd9e51e131d');
        $this->checkFile('plugins/Pap3Compatibility/PreSale.class.php', 'b5c1bf0583b20f39c77e4a9079ab0678');
        $this->checkFile('plugins/Pap3Compatibility/pap3topap4.php', '88bf3194f85ac5c9f319a34f98c8524d');
        $this->checkFile('plugins/Pap3Compatibility/scripts/presale.php', '804a5e74bf9926cd3130130e7128ce45');
        $this->checkFile('plugins/Pap3Compatibility/scripts/sale.js', 'e4efb524c2e2b695ce9830d1607f33d9');
        $this->checkFile('plugins/Pap3Compatibility/scripts/sb.php', '4866d9cd20e3427da46776ba1efcbdb4');
        $this->checkFile('plugins/Pap3Compatibility/scripts/t.php', '3a577de2707aa4cbc16492b5692910a1');
        $this->checkFile('plugins/Pap3Compatibility/scripts/track.js', '01876bd736f067a348d7f33e858cbd06');
        $this->checkFile('plugins/PartnerCommission/Definition.class.php', 'dd89ba89b698c4664617f8b524156729');
        $this->checkFile('plugins/PartnerCommission/Main.class.php', '4873c869487675c4787e6a5a0d93f1bf');
        $this->checkFile('plugins/PayPal/Config.class.php', '5092d222d2d44d857436d1f2e91b058a');
        $this->checkFile('plugins/PayPal/Definition.class.php', '2cc7e3a42b8213aace9643b23695d4ec');
        $this->checkFile('plugins/PayPal/Main.class.php', 'f26b2579e0268c8ed2c2fc5e61d2de03');
        $this->checkFile('plugins/PayPal/Tracker.class.php', '0dc2368accbab80400346796f873f9ca');
        $this->checkFile('plugins/PayPal/paypal.php', 'cbdbea831ca1d5d54a4e005999694f1d');
        $this->checkFile('plugins/PayPal/test.php', '7726c67c11d6dc4f06ac3c307784fd0a');
        $this->checkFile('plugins/PaySiteCash/Definition.class.php', '674bea624d2b52383d804e2a66dfaf12');
        $this->checkFile('plugins/PaySiteCash/Main.class.php', 'c18fc54bcf057c1a27baddbbcd56a7b0');
        $this->checkFile('plugins/PaySiteCash/Tracker.class.php', 'a15bbc299d2d7a6215e7376c53d29b42');
        $this->checkFile('plugins/PaySiteCash/paysitecash.php', 'd5219450e3c5b2c5c8dbef13036fad4a');
        $this->checkFile('plugins/PayWhirl/Config.class.php', '4313a4f1370b5311b568489a83dc7931');
        $this->checkFile('plugins/PayWhirl/Definition.class.php', 'ba8d397cd280e71b5d4ab4f07dc8f7e1');
        $this->checkFile('plugins/PayWhirl/Main.class.php', 'bee7c94a84380589820f65276ad55cbf');
        $this->checkFile('plugins/PayWhirl/Tracker.class.php', 'f9ae33990098028375c1f7fee11e5ebb');
        $this->checkFile('plugins/PayWhirl/paywhirl.php', '0d7f126107a57943f474d0bd9d96110a');
        $this->checkFile('plugins/Paymate/Config.class.php', '0171580b0bfba191d3c93edd247d7448');
        $this->checkFile('plugins/Paymate/Definition.class.php', '13c0402dcbc3594f4d0cf4a729108a6e');
        $this->checkFile('plugins/Paymate/Main.class.php', 'ae5fdaaee88d9e697e66ddc5a7f1a46c');
        $this->checkFile('plugins/Paymate/Tracker.class.php', '08ed38318dc4524fecbf2b6ffe63c204');
        $this->checkFile('plugins/Paymate/paymate.php', '3a093ef4577e78add5bf2d2ba37b588b');
        $this->checkFile('plugins/PremiumWebCart/Config.class.php', '6ea671ae3add7771978d65698d33f222');
        $this->checkFile('plugins/PremiumWebCart/Definition.class.php', 'efd9d9218c902ab1bd66456eab6cc7d4');
        $this->checkFile('plugins/PremiumWebCart/Main.class.php', '256f56dbd688ce8ab8fa775bdf6f2207');
        $this->checkFile('plugins/PremiumWebCart/Tracker.class.php', '9380be7dc0c4d54825d213284ffcfe8d');
        $this->checkFile('plugins/PremiumWebCart/premiumwebcart.php', '563dce7e139a775d8cb38ae6a422bfee');
        $this->checkFile('plugins/PremiumWebCartIPN/Config.class.php', '68d9c2e5b0aec957e9f10c80aa0c2126');
        $this->checkFile('plugins/PremiumWebCartIPN/Definition.class.php', 'e813b159a1159444199a21c64672c8f2');
        $this->checkFile('plugins/PremiumWebCartIPN/Main.class.php', 'c6f8a2ddc278dd4509cefcf4d4386fe8');
        $this->checkFile('plugins/PremiumWebCartIPN/Tracker.class.php', '2ed41c486e297643129c0c386b583ccd');
        $this->checkFile('plugins/PremiumWebCartIPN/pwcipn.php', 'a3d9949c75a959f230249ae95b6e2747');
        $this->checkFile('plugins/ProhibitCommissionIfAffIsPurchaser/Config.class.php', '79526423cb55204f26cb6d9be0eabe4d');
        $this->checkFile('plugins/ProhibitCommissionIfAffIsPurchaser/Definition.class.php', '514ac0c203000c75996d66cc7c6526e9');
        $this->checkFile('plugins/ProhibitCommissionIfAffIsPurchaser/Mail.class.php', 'd6f459ecafe66fc01ec1541c8f2008c4');
        $this->checkFile('plugins/ProhibitCommissionIfAffIsPurchaser/Main.class.php', '80acf37d33787f499ef5c466f147888c');
        $this->checkFile('plugins/QuickBooks/Config.class.php', '68ae855262bf16831395bc55d14e84a2');
        $this->checkFile('plugins/QuickBooks/Definition.class.php', '059b6b0bf37532a77efe44178c403740');
        $this->checkFile('plugins/QuickBooks/GeneratorResponse.class.php', '5334aa782b165cf5370a5cc1f1907acd');
        $this->checkFile('plugins/QuickBooks/Main.class.php', 'fb980e335aef049732453abf139b8953');
        $this->checkFile('plugins/ReCharge/Config.class.php', 'dc9e0afc7c87c002446d52a75e253534');
        $this->checkFile('plugins/ReCharge/Definition.class.php', 'b2f06de1d165557b79fc866b75b37a04');
        $this->checkFile('plugins/ReCharge/Main.class.php', 'c63bb3a1ef3ee597a3c24a45dfe0a591');
        $this->checkFile('plugins/ReCharge/Tracker.class.php', 'b2b93f258da088ebc27d1cde8882908e');
        $this->checkFile('plugins/ReCharge/recharge.php', 'bf638d8bdde5bf1ee8f7d89daae32339');
        $this->checkFile('plugins/Recurly/Definition.class.php', 'b432e0d3324819b1f5a4ff41f6d67585');
        $this->checkFile('plugins/Recurly/Tracker.class.php', '5655410003729fa98c35011b7904c0c2');
        $this->checkFile('plugins/Recurly/recurly.php', '319aa30692c61e25b2879c94183ef1dd');
        $this->checkFile('plugins/ReferringAffiliateToCommissionFields/Config.class.php', '6d7abee7e107f5cad25bda84743fdb1c');
        $this->checkFile('plugins/ReferringAffiliateToCommissionFields/Definition.class.php', 'd0c5f4cb73b4205b4838097ba57c0a9d');
        $this->checkFile('plugins/ReferringAffiliateToCommissionFields/Main.class.php', '3ea62d5aa0e22c0e417ef7c3680c1b6a');
        $this->checkFile('plugins/RefidLength/Config.class.php', '46699f61dea5bb06ec8f43e2045880b7');
        $this->checkFile('plugins/RefidLength/Definition.class.php', '468b2348e906889ddbfe06bebe1c13b3');
        $this->checkFile('plugins/RefidLength/Main.class.php', '7e116f48b5cb56765b3ee944cedc46b3');
        $this->checkFile('plugins/RestCommissions/Config.class.php', '2c4daf1ad53ac041a8d7d22bf0a6ba66');
        $this->checkFile('plugins/RestCommissions/Definition.class.php', 'fe37b17436eceabdc5d96b1160c10ca5');
        $this->checkFile('plugins/RestCommissions/Main.class.php', '388da440de907c3da3e7e24c08138c1e');
        $this->checkFile('plugins/RoboKassa/Config.class.php', 'ad06185c7728ea69d5feeddd9aa55284');
        $this->checkFile('plugins/RoboKassa/Definition.class.php', '589dc57f5f44811e6745aa89cdd081f8');
        $this->checkFile('plugins/RoboKassa/Main.class.php', 'e9dd35b99d7fcbddc84e70d4a8ef00a3');
        $this->checkFile('plugins/RoboKassa/Tracker.class.php', '01021b13e53ec3f72a108e0ff6f7db94');
        $this->checkFile('plugins/RoboKassa/robokassa.php', 'e34fd7a361b58a8333782da00e4af313');
        $this->checkFile('plugins/RocketGate/Config.class.php', 'c24a86d5f49e7fe8ccf1b519eb7cc620');
        $this->checkFile('plugins/RocketGate/Definition.class.php', '117dda8f8a21852254d3aebf382b7f4d');
        $this->checkFile('plugins/RocketGate/Main.class.php', 'b8d85b9c1eb547917b825d698e131f78');
        $this->checkFile('plugins/RocketGate/Tracker.class.php', '0b43e14de969fae5ec6366287361c24b');
        $this->checkFile('plugins/RocketGate/rocketgate.php', '282129b138be2e4b6c4e145a3b1f7364');
        $this->checkFile('plugins/SafePay/Config.class.php', '01f4306f16f81fbedecacb3061f37ac1');
        $this->checkFile('plugins/SafePay/Definition.class.php', 'a532e8471ba08723eeab03ad57d1b4a5');
        $this->checkFile('plugins/SafePay/Main.class.php', '6ff348b41fdccc93f1895aae133a9e3b');
        $this->checkFile('plugins/SafePay/Tracker.class.php', '81d15d9ad5d134c57c9a507e713b37bb');
        $this->checkFile('plugins/SafePay/safepay.php', '1a84f3349270e653138fb52eb442511f');
        $this->checkFile('plugins/SafePay/test.php', '0223a47fcd8aa503ce496fea315dc48a');
        $this->checkFile('plugins/SaleFilter/Config.class.php', 'af936467bfe07011131fb35aa5cf76ce');
        $this->checkFile('plugins/SaleFilter/Definition.class.php', '353eb7e761f812760081114a28efed98');
        $this->checkFile('plugins/SaleFilter/Main.class.php', '3d1de2c994a78cd287f65eb313ec19a2');
        $this->checkFile('plugins/SaleFraudProtection/Config.class.php', '79bc42f7fe384772e5c7e56f35317ff5');
        $this->checkFile('plugins/SaleFraudProtection/Definition.class.php', '3289c773567e2ebe23eba5b430c35dba');
        $this->checkFile('plugins/SaleFraudProtection/Main.class.php', '3d3c469da62412de352e8a4aecd1af42');
        $this->checkFile('plugins/SamCart/Config.class.php', '1d376b3a1d214521c0b637a03bc68800');
        $this->checkFile('plugins/SamCart/Definition.class.php', '1f43f39a994cd9ff660c183cd9190c11');
        $this->checkFile('plugins/SamCart/Main.class.php', 'cb68cc4aaae94f7ad42d92f287ddd254');
        $this->checkFile('plugins/SamCart/Tracker.class.php', '87f78e38ddfbd14042a1ae1082102209');
        $this->checkFile('plugins/SamCart/samcart.php', 'b2027071158cc6d0635cedc105616f5a');
        $this->checkFile('plugins/Segpay/Config.class.php', 'ce505f68a67255573f169ea95d4c2039');
        $this->checkFile('plugins/Segpay/Definition.class.php', '64df26a87fe01089c813f78091192e2c');
        $this->checkFile('plugins/Segpay/Main.class.php', '7f504411a969ab4b3a4f758208c000d7');
        $this->checkFile('plugins/Segpay/Tracker.class.php', 'b0bff93a0dab806357a55f11e29df099');
        $this->checkFile('plugins/Segpay/segpay.php', 'e8ffd2735916fadb9285b695df6f9a49');
        $this->checkFile('plugins/SeoTargetUrlVariable/Definition.class.php', 'dcc5f84e5044f61bcd5e75fae8b06b39');
        $this->checkFile('plugins/SeoTargetUrlVariable/Main.class.php', '8abb35b48338f763216ca632b3e726e2');
        $this->checkFile('plugins/SequenceAffiliateUserId/Config.class.php', '7d3bd206c0a79453908539d949672275');
        $this->checkFile('plugins/SequenceAffiliateUserId/Definition.class.php', 'ac72d4710175a8f9e3295bbdee1584b5');
        $this->checkFile('plugins/SequenceAffiliateUserId/Main.class.php', 'a98fe71c5b9a2e4647b6feedc4705aa4');
        $this->checkFile('plugins/Setcom/Config.class.php', '16fce377dd63ea14a34a7009c831a68d');
        $this->checkFile('plugins/Setcom/Definition.class.php', 'eb0a2198ce02132ab627a3fd3ec2e62a');
        $this->checkFile('plugins/Setcom/Main.class.php', 'c476d4c4bca796089e53b795e4f2555a');
        $this->checkFile('plugins/Setcom/Tracker.class.php', '558f3b78be424e350c39530d3c6761da');
        $this->checkFile('plugins/Setcom/setcom.php', '2871b012205ab3ec4e7f3bd70bc445af');
        $this->checkFile('plugins/Shopify/Config.class.php', '6001da37893a849cdf2a0f2550731fa8');
        $this->checkFile('plugins/Shopify/Definition.class.php', '475c1bda629a82be42c7213467a6fa94');
        $this->checkFile('plugins/Shopify/Main.class.php', '3487181fd0e05760aea7e0de42ede908');
        $this->checkFile('plugins/Shopify/shopify.php', 'c4446cd37fef429e53f0c5dfc2f6c839');
        $this->checkFile('plugins/SignupActionCommissions/Config.class.php', 'acfc6be8084c3bef264ecfbd9249388c');
        $this->checkFile('plugins/SignupActionCommissions/Definition.class.php', 'ee81473d0c5812c8ee586d8b20457fad');
        $this->checkFile('plugins/SignupActionCommissions/Main.class.php', '7d374ba8df999350b6c230c89d3ebf9f');
        $this->checkFile('plugins/SignupToCampaign/Config.class.php', '8cbb9cb5a446646824e00ffc35e84da9');
        $this->checkFile('plugins/SignupToCampaign/Definition.class.php', '76f0286d2c06b2559486f98c6e0d9c90');
        $this->checkFile('plugins/SignupToCampaign/Main.class.php', '0b7e81f0ab86c8a0e542f376837c9481');
        $this->checkFile('plugins/SignupToPrivateCampaigns/Config.class.php', '0a5e17fbaffa20b141b595a319fba708');
        $this->checkFile('plugins/SignupToPrivateCampaigns/Definition.class.php', '050732cc8ebf748f9d2639c0c9850e4b');
        $this->checkFile('plugins/SignupToPrivateCampaigns/Main.class.php', '34572cfab3b3cebad10940626c66200f');
        $this->checkFile('plugins/SimpleShop/Config.class.php', 'a09b03c7623cc08259f09c3f0245e253');
        $this->checkFile('plugins/SimpleShop/Definition.class.php', '7100c7a091bf2f246897785fc07ab94e');
        $this->checkFile('plugins/SimpleShop/Main.class.php', 'ee8d16fd25ceef84bd8347f54b587f52');
        $this->checkFile('plugins/SimpleShop/Tracker.class.php', '9d1f96cb5d56fd1c3cbda6cf5f1a3c90');
        $this->checkFile('plugins/SimpleShop/webhook.php', '0cedd4626314ff31bf004a73a83bfb4a');
        $this->checkFile('plugins/SolidTrustPay/Config.class.php', 'ac53c9e9c41645012135a2e56b171bac');
        $this->checkFile('plugins/SolidTrustPay/Definition.class.php', 'a71c02d136e431d153c0a222a3d48c93');
        $this->checkFile('plugins/SolidTrustPay/Main.class.php', '46e477668e6395c148e94e8a53f7526b');
        $this->checkFile('plugins/SolidTrustPay/Tracker.class.php', '39ea52a7b806046ec45e9d1c667719e4');
        $this->checkFile('plugins/SolidTrustPay/solidtrustpay.php', '7926a396e2fcbae6baacc1fcb9fdbd1c');
        $this->checkFile('plugins/SparkPay/Config.class.php', 'ff3e37cc5555848065f4aa03fd653df5');
        $this->checkFile('plugins/SparkPay/Definition.class.php', '0ad5e63dcb8131ddf058a470f7ec1e89');
        $this->checkFile('plugins/SparkPay/Main.class.php', 'dedaba3e32d0908d93842ae33a6a8928');
        $this->checkFile('plugins/SparkPay/SparkPay.php', 'a6716878bdc187c363be3f8722270a2d');
        $this->checkFile('plugins/SparkPay/Tracker.class.php', '06c41f686a53334ac4b58a0343885193');
        $this->checkFile('plugins/SpotOption/Config.class.php', '836c0b0591f3f1f2f2142ec2fba9b7b4');
        $this->checkFile('plugins/SpotOption/Definition.class.php', '9c73c879f3c8a7a84d7855938d56949a');
        $this->checkFile('plugins/SpotOption/Main.class.php', '080beb2704e845b2bb4fdbbe21b33572');
        $this->checkFile('plugins/SpotOption/Runner.class.php', 'e94fbeb16a67d72afb4b14c4bd1ac9b8');
        $this->checkFile('plugins/StormPay/Definition.class.php', '18e8e01af3be526ac5cfbcb6ea2eda37');
        $this->checkFile('plugins/StormPay/Tracker.class.php', '2bab21cdbb49ecfa4defa06d1a24f2e2');
        $this->checkFile('plugins/StormPay/stormpay.php', '9e403d957146de40cd60e4b84bfbed17');
        $this->checkFile('plugins/StormPay/test.php', '997ee8263982232b4257f0e5c7fe3aa6');
        $this->checkFile('plugins/Stripe/Config.class.php', '829130e3e0d14a452127e49239ae9212');
        $this->checkFile('plugins/Stripe/Definition.class.php', 'd8a4796e227854af84f970733b6f97c9');
        $this->checkFile('plugins/Stripe/Main.class.php', '98f57a131ed63f33606e2ef1f2140b84');
        $this->checkFile('plugins/Stripe/Tracker.class.php', '53a4a7786f3605cff2a20eff2c7b15b6');
        $this->checkFile('plugins/Stripe/lib/Stripe/Account.php', '14c8e5988d248bb4e88f69767a94db51');
        $this->checkFile('plugins/Stripe/lib/Stripe/AccountLink.php', 'f60c0d74f26a0a5324eaca593e8b3179');
        $this->checkFile('plugins/Stripe/lib/Stripe/ApiOperations/All.php', '2f0a73cbd68ffc1eabd595b3f421cbf9');
        $this->checkFile('plugins/Stripe/lib/Stripe/ApiOperations/Create.php', '7aadb09373508140926cf96849ce00de');
        $this->checkFile('plugins/Stripe/lib/Stripe/ApiOperations/Delete.php', '1752824b2d142c89d380a137f3988cb8');
        $this->checkFile('plugins/Stripe/lib/Stripe/ApiOperations/NestedResource.php', '640b5b070115b84db8ab37dbb89f2cd3');
        $this->checkFile('plugins/Stripe/lib/Stripe/ApiOperations/Request.php', '199a26be2655a1526471f94c06726cd4');
        $this->checkFile('plugins/Stripe/lib/Stripe/ApiOperations/Retrieve.php', 'ab9eba19e825f5b53dfc0ebb0e5a1db6');
        $this->checkFile('plugins/Stripe/lib/Stripe/ApiOperations/Update.php', '6f21ea86c19c605171439294e26182df');
        $this->checkFile('plugins/Stripe/lib/Stripe/ApiRequestor.php', '114d42b3a992c36df3088f1b2f608e93');
        $this->checkFile('plugins/Stripe/lib/Stripe/ApiResource.php', '4d550ef765f00b562a3331c4121880dd');
        $this->checkFile('plugins/Stripe/lib/Stripe/ApiResponse.php', '5bdd3335291e428fa803790c83bb8eb4');
        $this->checkFile('plugins/Stripe/lib/Stripe/Charge.php', '812a72020247bf2854abe0666d0b0357');
        $this->checkFile('plugins/Stripe/lib/Stripe/Collection.php', 'd14cd35cd8088c854cf9a779db62b2a3');
        $this->checkFile('plugins/Stripe/lib/Stripe/Customer.php', '23a6ede18af1944321cc846fc52dd2d7');
        $this->checkFile('plugins/Stripe/lib/Stripe/ErrorObject.php', '27ed618f6c720d7e1a9cffce3e99ddee');
        $this->checkFile('plugins/Stripe/lib/Stripe/Exception/ApiConnectionException.php', '87a238114ffa5fbdf773bc789caae27b');
        $this->checkFile('plugins/Stripe/lib/Stripe/Exception/ApiErrorException.php', '996d43e51076fbdf286017e58a156984');
        $this->checkFile('plugins/Stripe/lib/Stripe/Exception/AuthenticationException.php', 'b0b6e49d9d2fb4b4b091f274f976cb0b');
        $this->checkFile('plugins/Stripe/lib/Stripe/Exception/BadMethodCallException.php', '111ab9687872b9d67465be35492b6e42');
        $this->checkFile('plugins/Stripe/lib/Stripe/Exception/CardException.php', '97f3497ea7b690612a7150da2200a231');
        $this->checkFile('plugins/Stripe/lib/Stripe/Exception/ExceptionInterface.php', '4915327c3e364452763a4c4f183931fa');
        $this->checkFile('plugins/Stripe/lib/Stripe/Exception/IdempotencyException.php', '1bbeed2ed96cb554b26f8e09d0f5b000');
        $this->checkFile('plugins/Stripe/lib/Stripe/Exception/InvalidArgumentException.php', 'b150b4548f9361ef561b89f13296f075');
        $this->checkFile('plugins/Stripe/lib/Stripe/Exception/InvalidRequestException.php', 'ffe3119678c5130ce8379d154937f97e');
        $this->checkFile('plugins/Stripe/lib/Stripe/Exception/PermissionException.php', '83bd345dcb6d715296a7413386424943');
        $this->checkFile('plugins/Stripe/lib/Stripe/Exception/RateLimitException.php', '363c90dfcb0fff13c17e6e80cef1d449');
        $this->checkFile('plugins/Stripe/lib/Stripe/Exception/SignatureVerificationException.php', '7312bcf86c8d1482608e9ae2b500727b');
        $this->checkFile('plugins/Stripe/lib/Stripe/Exception/UnexpectedValueException.php', 'a9a4921b7ed868891d8826686e47ec40');
        $this->checkFile('plugins/Stripe/lib/Stripe/Exception/UnknownApiErrorException.php', '70f30bb73e2db8b12a2fe54f00bce931');
        $this->checkFile('plugins/Stripe/lib/Stripe/HttpClient/ClientInterface.php', 'd759b21327e4dd5da40e956a90256818');
        $this->checkFile('plugins/Stripe/lib/Stripe/HttpClient/CurlClient.php', '0fe6732d5a26df8a1705be4e749846eb');
        $this->checkFile('plugins/Stripe/lib/Stripe/Invoice.php', '78a16e4391798ef4b19566acde8aeb3b');
        $this->checkFile('plugins/Stripe/lib/Stripe/RequestTelemetry.php', 'f2ff319fdc862f5b2bdd3010962300b6');
        $this->checkFile('plugins/Stripe/lib/Stripe/SingletonApiResource.php', '8f665cf34ca087082768d39df5bb0419');
        $this->checkFile('plugins/Stripe/lib/Stripe/Stripe.php', '290b4329d291a70b73f33c5f585497e1');
        $this->checkFile('plugins/Stripe/lib/Stripe/StripeObject.php', 'ac1ea923ced38cf0fe7c1db334354cd4');
        $this->checkFile('plugins/Stripe/lib/Stripe/Util/CaseInsensitiveArray.php', '11ffa2aa3ec23f8a920346450e2abb95');
        $this->checkFile('plugins/Stripe/lib/Stripe/Util/DefaultLogger.php', 'aeace9988aea84b43c3f198745886894');
        $this->checkFile('plugins/Stripe/lib/Stripe/Util/LoggerInterface.php', 'b0c8a8983ac7a66ab02686fed44cd40b');
        $this->checkFile('plugins/Stripe/lib/Stripe/Util/RandomGenerator.php', '75c4bfb86f5932750de26d29965b31b9');
        $this->checkFile('plugins/Stripe/lib/Stripe/Util/RequestOptions.php', '3ba0d8c96ba20fc7cd65a071fcaefa8a');
        $this->checkFile('plugins/Stripe/lib/Stripe/Util/Set.php', 'ebfbd53c2c9eaf617f63d20ca60e1c9c');
        $this->checkFile('plugins/Stripe/lib/Stripe/Util/Util.php', '2c48101f14312dc52bbf4c3e2e469861');
        $this->checkFile('plugins/Stripe/lib/Stripe.php', 'a0aa3a61ae7774adaec7613957417258');
        $this->checkFile('plugins/Stripe/lib/data/ca-certificates.crt', '6c8779e5755d9dddf677bf7a52d035ce');
        $this->checkFile('plugins/Stripe/stripe.php', '3bc7341d0f1aa6ae5fdfd47296b0c99c');
        $this->checkFile('plugins/SubaffiliateFirstSaleBonus/Config.class.php', 'af738b6f7d0ae6085d931e2dd6a3982a');
        $this->checkFile('plugins/SubaffiliateFirstSaleBonus/Definition.class.php', '0c99615defbb80f89a2f4474c0987a6d');
        $this->checkFile('plugins/SubaffiliateFirstSaleBonus/Main.class.php', 'df3640a4fed06a18d754936b54e63f25');
        $this->checkFile('plugins/Swreg/Definition.class.php', '0633587281531e7eba30947ce7646801');
        $this->checkFile('plugins/Swreg/Main.class.php', '7bfbe92875c4fbaef69b2c41e7532fb5');
        $this->checkFile('plugins/Swreg/Tracker.class.php', '326f7e62a6c95eef20a46e704d9def30');
        $this->checkFile('plugins/Swreg/swreg.php', '07df1d0892c9b017d23bf9c1e67a3fd1');
        $this->checkFile('plugins/ThreeDCart/3dcart.php', '453dc4442f0a5a35bbd3ecc60a331707');
        $this->checkFile('plugins/ThreeDCart/Config.class.php', 'a9685731b1477007b38f8aaf89f562de');
        $this->checkFile('plugins/ThreeDCart/Definition.class.php', 'a83bfbfa5519ade2382668ee62f6169f');
        $this->checkFile('plugins/ThreeDCart/Main.class.php', 'b1b6ace79cd4645c837f778455f58d6f');
        $this->checkFile('plugins/TopLevelAffiliateCommision/Config.class.php', 'af645af4487c3b5f060cff98a24833ca');
        $this->checkFile('plugins/TopLevelAffiliateCommision/Definition.class.php', '0e3658bb09c32218b003b11547dce1fa');
        $this->checkFile('plugins/TopLevelAffiliateCommision/Main.class.php', 'c840cef503b1dff18b6742ea5cbaf657');
        $this->checkFile('plugins/TopLevelAffiliateFixedCommision/Config.class.php', '9bb744751450b5665237e3fc0fb6f64f');
        $this->checkFile('plugins/TopLevelAffiliateFixedCommision/Definition.class.php', '7c5a609b03a5c9030b943da7651db152');
        $this->checkFile('plugins/TopLevelAffiliateFixedCommision/Main.class.php', '040a12e652c612c742ba091771e792a4');
        $this->checkFile('plugins/TopLevelAffiliateFixedCommision/PluginConfig.class.php', '3c8a72e4135036d467d08e40a8fca2d7');
        $this->checkFile('plugins/TrialPay/Config.class.php', '03ae59008e61373da65e7dd594692f09');
        $this->checkFile('plugins/TrialPay/Definition.class.php', 'c55d0e30264d270f585a7a1a72813963');
        $this->checkFile('plugins/TrialPay/Main.class.php', '6fde98bfe1e121ca1e85fbf06b995baa');
        $this->checkFile('plugins/TrialPay/Tracker.class.php', '86263dd5e565f91495e765df92e36c74');
        $this->checkFile('plugins/TrialPay/trialpay.php', 'bc1a06b96df9f81c0107831542635c9c');
        $this->checkFile('plugins/TwoCheckout/Config.class.php', 'abb91101d40da201f6b4fcc3d7c487ef');
        $this->checkFile('plugins/TwoCheckout/Definition.class.php', '3e974f871961c3496760d45a35095265');
        $this->checkFile('plugins/TwoCheckout/Main.class.php', '43ac1fdbc6a015068400f6812436c815');
        $this->checkFile('plugins/TwoCheckout/Tracker.class.php', 'e95cae5a181a093a25b1e1b03c164a6f');
        $this->checkFile('plugins/TwoCheckout/twocheckout.php', '90b535fd7b65eee49bd4e1bd2349433e');
        $this->checkFile('plugins/UltraCart/Config.class.php', 'b25ef322d75a06e9f63359625a91fab3');
        $this->checkFile('plugins/UltraCart/Definition.class.php', '79ae65ae69d270756bb4624f2b5a4153');
        $this->checkFile('plugins/UltraCart/Main.class.php', '114fa7ce70a911a34625a917fbb768dd');
        $this->checkFile('plugins/UltraCart/Tracker.class.php', 'cce197a447815260262a10cc4f238299');
        $this->checkFile('plugins/UltraCart/ultracart.php', '9dc29f38c661e6e73e3f477427de5c8e');
        $this->checkFile('plugins/UsernameConstraint/Config.class.php', 'f5f1d362b47f4cd3c952475e6207df97');
        $this->checkFile('plugins/UsernameConstraint/Definition.class.php', '547b3a7360dfce1e0e71a778e33b196b');
        $this->checkFile('plugins/UsernameConstraint/Main.class.php', 'c5b66805313f9578b192891694bd938f');
        $this->checkFile('plugins/UsernameRefid/Definition.class.php', '48066313ba9d7b20959dc934028a660e');
        $this->checkFile('plugins/UsernameRefid/Main.class.php', 'd271a5e9ee91df51f016d43da5e0ba06');
        $this->checkFile('plugins/VoguePay/Definition.class.php', '602e595ac37460a1b9dcdafbfcb5e695');
        $this->checkFile('plugins/VoguePay/Main.class.php', '6569efc6a358432c21b962491d67dfdf');
        $this->checkFile('plugins/VoguePay/Tracker.class.php', 'e722880e40ef03ed76e5389398e7eb2d');
        $this->checkFile('plugins/VoguePay/voguepay.php', '79f8eec954a5787cbd4c04768e369a72');
        $this->checkFile('plugins/VolusionAPI/Config.class.php', '062a14a4e1a30f031065331abd44f042');
        $this->checkFile('plugins/VolusionAPI/Definition.class.php', 'df23bc90f2ad42cfb62fab54e5148820');
        $this->checkFile('plugins/VolusionAPI/Main.class.php', '142fb2114b0d0718e4d76d7870e2ec2b');
        $this->checkFile('plugins/VolusionAPI/Tracker.class.php', 'cc40cdce7a0abe139434b99814df0721');
        $this->checkFile('plugins/VolusionAPI/volusion.php', 'dcb65c0e42d1219c7067571d608e0d79');
        $this->checkFile('plugins/WebMoney/Config.class.php', 'd77df4d629dd93c6ad560206a257cdf4');
        $this->checkFile('plugins/WebMoney/Definition.class.php', '0ab6009e9705ede1effc9dc4363aedfe');
        $this->checkFile('plugins/WebMoney/Main.class.php', '41206133c8da8feb5c96b73369eeb652');
        $this->checkFile('plugins/WebMoney/Tracker.class.php', '413feaa220eada034e8bd2ce301a86be');
        $this->checkFile('plugins/WebMoney/webmoney_failed.php', 'c4cbd9be1291c58f8d57fc3e6649ae15');
        $this->checkFile('plugins/WebMoney/webmoney_result.php', '2ef586746d7562d14a53dac45d6272cb');
        $this->checkFile('plugins/WebMoney/webmoney_success.php', '57038a9c435fd7324b9a73fb83dabf57');
        $this->checkFile('plugins/WorldPay/Definition.class.php', 'fa7e2eee3398cdf68e25be0bf33a8a87');
        $this->checkFile('plugins/WorldPay/Tracker.class.php', '52898f9ccae484602b1153fabde160be');
        $this->checkFile('plugins/WorldPay/test.php', '27dd00ba340575075b561c4ce970b627');
        $this->checkFile('plugins/WorldPay/worldpay.php', 'ed92bda3f4967452ef181d367cd4e3e1');
        $this->checkFile('plugins/ccBill/Config.class.php', 'f28d6de86f414ccb75364098364e462c');
        $this->checkFile('plugins/ccBill/Definition.class.php', 'd48ff7e54e304d8d8573fad6a9ad2564');
        $this->checkFile('plugins/ccBill/Main.class.php', '3fd8f7297a6ea530d57b3c279ee332d1');
        $this->checkFile('plugins/ccBill/Tracker.class.php', '83f9260463011a63fc21afb9f32dcc17');
        $this->checkFile('plugins/ccBill/ccbill.php', '4c5d735819004d370310c6ecf170540d');
        $this->checkFile('plugins/ccBill/test.php', '65556cfb8721ff24abe6be06cb46a80a');
        $this->checkFile('plugins/s2Member/Config.class.php', 'c5664cae32ff1412fcf58c419a17f7ce');
        $this->checkFile('plugins/s2Member/Definition.class.php', 'e5c69ebcf83e216e68d05d7313778d13');
        $this->checkFile('plugins/s2Member/Main.class.php', 'ef081d14de985b6338a614b870940451');
        $this->checkFile('plugins/s2Member/Tracker.class.php', 'ebe3f69692e09f0ecdacf4074f2ed00b');
        $this->checkFile('plugins/s2Member/s2member.php', '33b3a7134ca7f0c4f0308003edfbaec5');
        $this->checkFile('robots.txt', 'acf2746261af9847ab1c3d335c2026cf');
        $this->checkFile('samples_tests/.htaccess', '753ffa6cebb7f06b16d1f52c7ae9f8ee');
        $this->checkFile('samples_tests/account_signup_html.php', '8e855e9fe77e5eb66efc478be8946640');
        $this->checkFile('samples_tests/banners_linking.php', '359fde6275a3067d71151427fa7a0963');
        $this->checkFile('samples_tests/banners_sample.php', '265b23373f7ccbcec8aa128891e7dbaf');
        $this->checkFile('samples_tests/banners_subid.php', '304829bd88e5531b297d53610a499be0');
        $this->checkFile('samples_tests/cookie_info.php', '6a2e94fb7411e318579e98f4fde8e720');
        $this->checkFile('samples_tests/img/app_market.png', 'fa0b46877d482c8b34aab1689d925628');
        $this->checkFile('samples_tests/img/samples_bg.jpg', '9fb98ffd9d708e4473001d2bf1497d60');
        $this->checkFile('samples_tests/img/social_buttons_3.png', '23deb57122e7a9de4dd1161d2c4d94e7');
        $this->checkFile('samples_tests/img/transparent-95.png', '03be98067b8c0e04a43930e671620c32');
        $this->checkFile('samples_tests/img/transparent.png', 'c63e7f3d2a41cab628be8e4b86de789e');
        $this->checkFile('samples_tests/index.php', '40e3139da6c4644dcb0ea9b5c25772ca');
        $this->checkFile('samples_tests/sale_tracking_docu.php', '93c9aa22fb48ad4a15ab9b493d761866');
        $this->checkFile('samples_tests/sale_tracking_normal.php', 'bd21cbb84eabe467839650b587eec6cb');
        $this->checkFile('samples_tests/sample_homepage.php', 'e1838380e762e4911af9d6815ebadb78');
        $this->checkFile('samples_tests/signup_html.php', '5e0a901d7cad42c0e7be14a331c2f562');
        $this->checkFile('scripts/.htaccess', 'cfb8fba83c52f80a854ff75ee52912d4');
        $this->checkFile('scripts/action.php', '6c75edb4ca94073771656e6a680bc2a4');
        $this->checkFile('scripts/banner.php', '566689c568c36a7c437320d4e1a6109c');
        $this->checkFile('scripts/barcode.php', '6b74cbe8723dda98eb565b881a8cc215');
        $this->checkFile('scripts/bootstrap.php', 'b203a61e1ca454889108666fd4631552');
        $this->checkFile('scripts/bootstrap_api.php', 'e131afa058072cafbc11b00f2d9356d6');
        $this->checkFile('scripts/click.php', '81c71f36709e897b479a7c416086ebe4');
        $this->checkFile('scripts/clickjs.php', '76382273867bb3ecd48876bf00f8eaf5');
        $this->checkFile('scripts/data.php', 'f088b5387d23abdfd28df5b057e7290f');
        $this->checkFile('scripts/do.php', 'd1ce90304caf1af7c592a92e542b15d1');
        $this->checkFile('scripts/facebook.html', 'e0c469cc95f14734b1066bcbe213e450');
        $this->checkFile('scripts/file.php', '6c810e6fde867ecb84c1b5654d529868');
        $this->checkFile('scripts/get_affinfo.php', '191ac9c7bdc8dbb880bac379095cb904');
        $this->checkFile('scripts/hover.php', '54fce6782da9f7c399ae4b6a399bf01e');
        $this->checkFile('scripts/imp.php', '287d834c8c55e28771cfefc69d515f18');
        $this->checkFile('scripts/jobs.php', 'ad80c62f19c66d4556d9501b2bcb2efc');
        $this->checkFile('scripts/lib/banner_viewer.php', '8c07e2f8014cc6f21652276db1f8ecca');
        $this->checkFile('scripts/lib/cronHelper.php', '22c9110e7775f6d6b355e722e02d54c3');
        $this->checkFile('scripts/lib/fast_init.php', '079579d20287bf301bb83a24ba38a58f');
        $this->checkFile('scripts/lib/fast_init_db.php', 'def23528c00caabb100100c426d2f051');
        $this->checkFile('scripts/lib/fast_init_db_pdo.php', '4b59cf5dd0f3ee78f742cc4d41621508');
        $this->checkFile('scripts/lib/fraudHelper.php', '7b5ca6ddc8747341cef006cf5e22f08a');
        $this->checkFile('scripts/lib/tracking.php', '802d2103dd9882f68b5c91ebe1f0a3ff');
        $this->checkFile('scripts/mobile.php', 'f3bdaa4bfd50376b6bfd7a3b85bfd6b8');
        $this->checkFile('scripts/notifysale.php', '1269b70743448b9c07aa701b43c78fde');
        $this->checkFile('scripts/page.php', 'b2ecf337259881fa669991dcab82a530');
        $this->checkFile('scripts/pap.swf', '976552deec7382f1dd013c3d29048416');
        $this->checkFile('scripts/paths.php', '16650bb93e46787730605c0bb8559bf0');
        $this->checkFile('scripts/perf/click.php', '8d486b0e01cba547a369810291a55d6e');
        $this->checkFile('scripts/pix.gif', 'accba0b69f352b4c9440f05891b015c5');
        $this->checkFile('scripts/preview.php', '92b44799ecb0069bc61dc41ccc98d172');
        $this->checkFile('scripts/qrcode.php', 'a5d9fbf543feceb48c824a9709debe88');
        $this->checkFile('scripts/sale.php', '2024fe1bc9a7ce3d68433af1862031a9');
        $this->checkFile('scripts/salejs.php', '76382273867bb3ecd48876bf00f8eaf5');
        $this->checkFile('scripts/saletrack.js', '7af0a6650d958ebb231603af70457823');
        $this->checkFile('scripts/server.php', 'f2181b336d5938c54ba9b15b0b63b2d3');
        $this->checkFile('scripts/track.php', 'bfcdfa4fc1a5153f50bee1ae53d55ca7');
        $this->checkFile('scripts/trackjs.js', '54fae6c93dd03b349fac0166793b39fc');
        $this->checkFile('scripts/trackjs.php', '45644abc8031257f9438b4a4f802e539');
        $this->checkFile('themes/WARNING.txt', '1a6abc743e10b7411995669529614e75');
        $this->checkFile('themes/_common_templates/add_custom_translation.tpl', '27d1ceda006816900510682e881ac15d');
        $this->checkFile('themes/_common_templates/add_gadget_category.tpl', 'e2ec9306de4bf074a33e72c96ff238ca');
        $this->checkFile('themes/_common_templates/add_gadget_panel.tpl', 'be8c80e8aff49f52f5b5c1b79be9526f');
        $this->checkFile('themes/_common_templates/add_gadget_select_url.tpl', 'b9e3459257a1d9c8a6c66009c826d06c');
        $this->checkFile('themes/_common_templates/additional_dynamic_form_panel.tpl', '8b70e079bce66f8b2b0af4d84772ad68');
        $this->checkFile('themes/_common_templates/advanced_email_settings_form.tpl', '0becd78691a8f1dc9a0e651f32b32b29');
        $this->checkFile('themes/_common_templates/advanced_email_settings_tab.tpl', '3b2b799cb7e9573908c049d177517f0d');
        $this->checkFile('themes/_common_templates/align_widget.tpl', '124769dbcc410ae58c1dfd53f15b58d6');
        $this->checkFile('themes/_common_templates/api_integration.tpl', '5add416010644d6b9eb7fc6888d305ec');
        $this->checkFile('themes/_common_templates/available_values_edit.tpl', 'd8ae0a51c292d5f580fb8f43c6aa8db5');
        $this->checkFile('themes/_common_templates/breadcrumbs.tpl', '921035f90b931792de2bfd1fb40dc597');
        $this->checkFile('themes/_common_templates/breadcrumbs_entry.tpl', '42ee9a25b7525589ed65bf9625adc890');
        $this->checkFile('themes/_common_templates/button.tpl', 'ab00df127be0dd89a125fe05f33c0380');
        $this->checkFile('themes/_common_templates/calendar.tpl', '3e821628e6e72f7cd46b3c42d2727cd3');
        $this->checkFile('themes/_common_templates/captcha.tpl', '0326fedb283400e2c13eeae155d7b536');
        $this->checkFile('themes/_common_templates/change_coupon_validity.tpl', 'fbaceda41d1e117cd888b07dd7011d47');
        $this->checkFile('themes/_common_templates/change_status_button.tpl', 'a0d13402819088b5078e8100a21a0159');
        $this->checkFile('themes/_common_templates/chart_datatype_popup.tpl', '98c4768cca92f50bf5ddbed967b2f576');
        $this->checkFile('themes/_common_templates/check_box_group.tpl', '9935dbc5bf9461709c69b0856a7d4099');
        $this->checkFile('themes/_common_templates/check_box_group_row.tpl', '06dba660be425f9bf15e1644d90290ca');
        $this->checkFile('themes/_common_templates/checkboxes_filter.tpl', 'fef5c1833920987bd3172dbe9d75797a');
        $this->checkFile('themes/_common_templates/colorpicker.tpl', '05db94b41bf41706ce49bf32d75aad22');
        $this->checkFile('themes/_common_templates/config_theme_panel.tpl', '5117d0d0da286c8f6b004fb64ecf376b');
        $this->checkFile('themes/_common_templates/confirm_dialog.tpl', 'e23acdf8f02455be771f5844a3bed51c');
        $this->checkFile('themes/_common_templates/confirm_dialog_label_value.tpl', '3b53a0711a39da60f308e1846fbbb8ab');
        $this->checkFile('themes/_common_templates/confirm_dialog_with_checkbox.tpl', '76df98eea5ef2ec2baeb3fbafb122d03');
        $this->checkFile('themes/_common_templates/confirm_dialog_with_value.tpl', '197325eadea8c36f199d51db65f73bb2');
        $this->checkFile('themes/_common_templates/content_gadget_panel.tpl', '79428f6a77f38592dfa1716653bbe79b');
        $this->checkFile('themes/_common_templates/context_menu.tpl', 'cddf235a2fec1ae75063d576ccdc6185');
        $this->checkFile('themes/_common_templates/copy_user_role.tpl', '67725ef54593ecb567ed04a3935faecb');
        $this->checkFile('themes/_common_templates/currency_textbox.tpl', '859fd8293b92897b3be4c9a6c4aa3a8f');
        $this->checkFile('themes/_common_templates/custom_date_panel.tpl', 'c624f3d63d0e94db867529dc13a827d1');
        $this->checkFile('themes/_common_templates/custom_filter_element.tpl', '904d449eaca3de00dcd78d66eb33af21');
        $this->checkFile('themes/_common_templates/custom_filter_field.tpl', 'ba1e6ae828d1170750cddf934c25bd7a');
        $this->checkFile('themes/_common_templates/custom_time_panel.tpl', '94bb18d120b20b9b6d2a0377e9df8958');
        $this->checkFile('themes/_common_templates/data_field.tpl', 'e60b9b057bded055daffbdb797698a50');
        $this->checkFile('themes/_common_templates/data_field_with_help.tpl', '4615cdd789beea34c16b4c1f692a3a3b');
        $this->checkFile('themes/_common_templates/date_number_format_panel.tpl', 'e26284328d2ba7da47d30e8e458c13b1');
        $this->checkFile('themes/_common_templates/date_preset_panel.tpl', 'abc7d225baa948aed70cc1073b786fe8');
        $this->checkFile('themes/_common_templates/date_range_filter.tpl', '3875dbc075f33ccaac856190ee103557');
        $this->checkFile('themes/_common_templates/date_range_filter_field.tpl', '7e6f9d039cb8a6c5e79888773499dc7b');
        $this->checkFile('themes/_common_templates/date_textbox.tpl', '4d2bf89bd754bbaccc15e48d7a37dd02');
        $this->checkFile('themes/_common_templates/daterange_popup.tpl', '8286747eb7bf5f14f1e25fc155faa773');
        $this->checkFile('themes/_common_templates/datetimepickercontent.tpl', '9771684f29bc88d974cc64283055d1d1');
        $this->checkFile('themes/_common_templates/desktop.tpl', 'b653025800e416896bd453246061a535');
        $this->checkFile('themes/_common_templates/desktop_gadget.tpl', '21394ff13337e4716860c12b5e4fb312');
        $this->checkFile('themes/_common_templates/desktop_main_menu.tpl', '31eb02f3f6b767d24012753d50ff5159');
        $this->checkFile('themes/_common_templates/desktop_settings_mode.tpl', '1054d3be606383580f8d521f2d72682f');
        $this->checkFile('themes/_common_templates/drag_container.tpl', '358104feb6f9c3c2a01206e460726eac');
        $this->checkFile('themes/_common_templates/dynamic_form_panel.tpl', 'ea42da62b4a44f1fa9caf50a59c29160');
        $this->checkFile('themes/_common_templates/edit_textarea_widget.tpl', '4e89808e2e5b5e063e76f8a8b24dcba0');
        $this->checkFile('themes/_common_templates/editor.tpl', 'a8c5483c720526b56fa899a91045c287');
        $this->checkFile('themes/_common_templates/editor_with_constants_panel.tpl', '6c9e8d91f33bc90c661e9b67ca5ff1e1');
        $this->checkFile('themes/_common_templates/email_form.tpl', '98396265215c84baf14b7bab8a241c4c');
        $this->checkFile('themes/_common_templates/email_setting_smtp_form.tpl', 'd17124a143f842ab1876ed14a74bc762');
        $this->checkFile('themes/_common_templates/email_settings_form.tpl', '36761150517762c305ad136aed57a9db');
        $this->checkFile('themes/_common_templates/email_settings_spf.tpl', 'ca349c37b841ccef522f8767817bf1d2');
        $this->checkFile('themes/_common_templates/email_settings_tab.tpl', '8fef8cf6eacfffe581527d391ffb97da');
        $this->checkFile('themes/_common_templates/email_template_edit_panel.tpl', '2a432b9530ad4375605916e152dd8b60');
        $this->checkFile('themes/_common_templates/expired_session_dialog.tpl', 'ba711bd5d1e932ffc4fbc8e601204905');
        $this->checkFile('themes/_common_templates/export_to_csv.tpl', '5a754fcdf929d811159cdfbf3b31c2bf');
        $this->checkFile('themes/_common_templates/extendable_text.tpl', '92610a0b6f1a0dd45190608dd016043c');
        $this->checkFile('themes/_common_templates/extendable_text_content.tpl', 'cca4ebdf72f3cb7638b6c5bf0f59d9aa');
        $this->checkFile('themes/_common_templates/extendable_text_widget.tpl', 'bca137cf1b7ac0b8071967207c6de3d6');
        $this->checkFile('themes/_common_templates/feature_detail.tpl', 'cec8d6e64ba23602284a375c0b5af033');
        $this->checkFile('themes/_common_templates/feature_on_activate.tpl', '544374f96c5524c306a5c6f6f956200c');
        $this->checkFile('themes/_common_templates/feature_on_deactivate.tpl', 'a1767954af4547adcfb12cf4107f3468');
        $this->checkFile('themes/_common_templates/feature_settings.tpl', '7e58f908f22326e44d7c87b6f8dcc863');
        $this->checkFile('themes/_common_templates/field_type_edit.tpl', 'b1294ba5d4486ea1cf8022a51e277a11');
        $this->checkFile('themes/_common_templates/file_widget.tpl', '9bbc3cc3dab5406cfb7581ebcdbdf71e');
        $this->checkFile('themes/_common_templates/filter.tpl', 'c263132078ee38cbeeee938917b3cf55');
        $this->checkFile('themes/_common_templates/filter_form.tpl', '6a9d073a7143e7d497b2582122a6d9ef');
        $this->checkFile('themes/_common_templates/footer.tpl', 'cab31d41350d09479737e4f25b0afe75');
        $this->checkFile('themes/_common_templates/form_field.tpl', 'ad4cd0dd5e6c64fa5f93a816fa72e897');
        $this->checkFile('themes/_common_templates/form_field_checkbox.tpl', '300ea0a723fe945e10a21d9fb187a6c0');
        $this->checkFile('themes/_common_templates/form_field_checkboxgroup.tpl', 'be1b525a89f033d4f79433dd3eaab593');
        $this->checkFile('themes/_common_templates/form_field_radio.tpl', '84240ba42e1aff3ba2e1096bcd84e61f');
        $this->checkFile('themes/_common_templates/frame_panel.tpl', '7b13a1add8ba712d8a34f4285414b419');
        $this->checkFile('themes/_common_templates/gadget_config.tpl', '3c5a54d063eda6b88286217d189c3e4c');
        $this->checkFile('themes/_common_templates/gadget_google.stpl', '230f19aa2e3c55750b51dbc0fd118c5e');
        $this->checkFile('themes/_common_templates/gadget_header.tpl', 'a72a8c2c242fdf3a1ef76f6e0a5d6695');
        $this->checkFile('themes/_common_templates/gadget_panel.tpl', '4178c029db5e146bc731d779d65a8a36');
        $this->checkFile('themes/_common_templates/gadget_row_panel.tpl', 'a8c6e59d5de5496dbdeda9d57d2788da');
        $this->checkFile('themes/_common_templates/gadget_rss.stpl', '5f237164fdfdf0ae57ef355caa5823a6');
        $this->checkFile('themes/_common_templates/gadget_settings.tpl', '105ff2811c81ac9c55ea57b7d0ac0148');
        $this->checkFile('themes/_common_templates/gadget_uwa.stpl', '68b329da9893e34099c7d8ad5cb9c940');
        $this->checkFile('themes/_common_templates/gadget_window.tpl', '513ecc937c6be566a42aaf549652fdbe');
        $this->checkFile('themes/_common_templates/gadget_window_bottomleft.tpl', 'ff7129ad4f9f45270ed9e44b088a5e55');
        $this->checkFile('themes/_common_templates/gadget_window_left.tpl', 'fee5ef79e66e21558f2d86fd2c4f6f83');
        $this->checkFile('themes/_common_templates/gadget_window_topleft.tpl', 'cd802bf0b15f07cb12f8cc74ff1e4679');
        $this->checkFile('themes/_common_templates/gadgets_filter_panel.tpl', '8feacd08914d0dd918bb1a6864fa3f31');
        $this->checkFile('themes/_common_templates/gadgets_no_data.tpl', '10490ba64dc553766a2a507867ea5d9a');
        $this->checkFile('themes/_common_templates/gpf.css', 'afd3964f8f466b1029b6a5ac1b6bd856');
        $this->checkFile('themes/_common_templates/gpf_db_mail.tpl', 'b5ea5e9ecef2152fdf967085a7689adc');
        $this->checkFile('themes/_common_templates/grid.tpl', '7771062f084a7792e96ffadf1e26cb04');
        $this->checkFile('themes/_common_templates/grid_bottombuttons.tpl', 'd8b9c62b18c62b9f514591196341f55d');
        $this->checkFile('themes/_common_templates/grid_bottomgridline.tpl', 'c835d38d6156165a02cb1dd2661ddd07');
        $this->checkFile('themes/_common_templates/grid_nodata.tpl', 'e30adc67da2434c4e93dfdedb6023bc2');
        $this->checkFile('themes/_common_templates/grid_pager.tpl', 'a4eae610598debf021109f81744cb263');
        $this->checkFile('themes/_common_templates/grid_selector.tpl', '4961944e8e7e0606c831881c32b591bb');
        $this->checkFile('themes/_common_templates/grid_topbuttons.tpl', '9c49ab2cd972c3d5446087eeafcca6a7');
        $this->checkFile('themes/_common_templates/grid_topgridline.tpl', 'da6ec34c642ca6fe8b39f1d1609cab2a');
        $this->checkFile('themes/_common_templates/header.tpl', '32d459ea9f7ebf7a241715058cc91f38');
        $this->checkFile('themes/_common_templates/horizontal_layout_panel.tpl', '8b6098cd64720cff686cc24e06ac4c17');
        $this->checkFile('themes/_common_templates/icon_button.tpl', 'a7497a39fe733586fb4f5a1b9f424b0f');
        $this->checkFile('themes/_common_templates/icon_object.tpl', 'ff8d25e63eca03b325c4501e13358fb2');
        $this->checkFile('themes/_common_templates/icon_picker.tpl', '77a002b90f678df44bcca5776f314820');
        $this->checkFile('themes/_common_templates/icon_picker_panel.tpl', '4342c424a8cb290701f64d0cb63655ec');
        $this->checkFile('themes/_common_templates/icon_status_widget.tpl', 'ff9e2bc87e203324cc33c4b3ac365dfe');
        $this->checkFile('themes/_common_templates/image_uploader.tpl', 'e776cc30cbbaa543fed52cdba2e3db6e');
        $this->checkFile('themes/_common_templates/imagepicker.tpl', '35d8511a1b80dac8424bd6652b565f47');
        $this->checkFile('themes/_common_templates/img/FB_share_button.png', 'a56c7efd784eb61b5ac1e6f4111f59a8');
        $this->checkFile('themes/_common_templates/img/LinkedIn_share_button.png', 'd0dfb70a7e64ee73f718af05ce995875');
        $this->checkFile('themes/_common_templates/img/alt.png', 'b0f9d31351efbf90578ff392cae6b51e');
        $this->checkFile('themes/_common_templates/img/attachment.png', '8351d8840155b42ed4555035657b3892');
        $this->checkFile('themes/_common_templates/img/attachment_delete.png', '36ec1f9102d2f054a045f89bcfed1427');
        $this->checkFile('themes/_common_templates/img/balloon.error.arrow.png', '57f6d7c5e22cfbd50f5c2a86f5c31552');
        $this->checkFile('themes/_common_templates/img/balloon.error.png', 'c865f28e7f1cbdaaf5cde203ee9c899d');
        $this->checkFile('themes/_common_templates/img/balloon.error.vertical.png', '9b41530651528380532abd74241e04a1');
        $this->checkFile('themes/_common_templates/img/balloon.help.arrow.png', 'e945d6f57c493e1ef8e752cb41a0ec2d');
        $this->checkFile('themes/_common_templates/img/balloon.help.png', 'dc84b0cd861b1336d026a522a8a64409');
        $this->checkFile('themes/_common_templates/img/balloon.help.vertical.png', '3de65bed0fc348f05b5ee22a971454a2');
        $this->checkFile('themes/_common_templates/img/browsers.png', '67e449054e2a51c023e8cd867a9a9f42');
        $this->checkFile('themes/_common_templates/img/button.icon.png', '7fe0dae178ca48f31ca3b440d88ba011');
        $this->checkFile('themes/_common_templates/img/button.png', 'bfeaa27a8b0c7c52e978ee91a0609975');
        $this->checkFile('themes/_common_templates/img/checkbox.png', 'e6c73db129231076471c0ff043cb83a3');
        $this->checkFile('themes/_common_templates/img/custom.jpg', 'd9c02d3d767d73e707bfc28075d882c3');
        $this->checkFile('themes/_common_templates/img/delete.png', 'f0e6c0036c26a8a263eb53b28296e4ac');
        $this->checkFile('themes/_common_templates/img/dirty.gif', 'decca3b96e2c37cf6eb04ddb0d9f669b');
        $this->checkFile('themes/_common_templates/img/doc.png', 'c914d3518532910b13728f3d9b43056d');
        $this->checkFile('themes/_common_templates/img/down.png', '4e00f930b8aa431c643ff462c84b70b0');
        $this->checkFile('themes/_common_templates/img/draggable.png', 'ab4fb4e3c82ccb353b30640cc36eaf67');
        $this->checkFile('themes/_common_templates/img/favicon.ico', 'd7dbca3e2df70d3aee5b2d2bf9ab15e6');
        $this->checkFile('themes/_common_templates/img/feature.png', 'a17a20726ab706b8cc4d7ad89ee36ef9');
        $this->checkFile('themes/_common_templates/img/fieldset.background.png', '4b7f6a73070e0ec1141544824eebf286');
        $this->checkFile('themes/_common_templates/img/filter.background.png', 'd0dd4171464ced5e0a869ab2faa211f8');
        $this->checkFile('themes/_common_templates/img/folder.png', '74ad8feccb7ac18bde1380dd7bdbdd06');
        $this->checkFile('themes/_common_templates/img/footer.background.jpg', '785055f715fc8c153fe6fa9231620e8c');
        $this->checkFile('themes/_common_templates/img/gadget.background.png', 'ad4d3131595af98d69b699d7bcb560f4');
        $this->checkFile('themes/_common_templates/img/gadget.png', '149cda728abc46f8e7d6ba2b7ffa3844');
        $this->checkFile('themes/_common_templates/img/gadget.vertical.png', '0931466af2cc61f0fcdaa76ef26ad932');
        $this->checkFile('themes/_common_templates/img/grid.no.data.png', '8d4e78d189687b989b07cfb5ccce6522');
        $this->checkFile('themes/_common_templates/img/grid.png', '9b74b8b6aee2d3456a0fdd0d871317c0');
        $this->checkFile('themes/_common_templates/img/grid.views-rtl.png', '415b4df097d32184a3c9f8edad9e3683');
        $this->checkFile('themes/_common_templates/img/grid.views.png', 'f3cccc4cf313aad1e2d6a51f3ab169a8');
        $this->checkFile('themes/_common_templates/img/html.png', '23bf6c9bc9121ffd0c273b5414faaba0');
        $this->checkFile('themes/_common_templates/img/icon-addgadget-big.png', '49e2f7dd155012136b5eea97f9b99ed4');
        $this->checkFile('themes/_common_templates/img/icon-addgadget-middle.png', '5c6969388ac082e7ffd663e962dd958a');
        $this->checkFile('themes/_common_templates/img/icon-addgadget-small.png', '80fa5db57fa49bbe9107d3551e2e838f');
        $this->checkFile('themes/_common_templates/img/icon-adminadd-big.png', 'c237d6f787767e2f76b4a299fd125fe0');
        $this->checkFile('themes/_common_templates/img/icon-adminadd-middle.png', 'd2c4880aa1784ce3fb133558bccd8834');
        $this->checkFile('themes/_common_templates/img/icon-adminadd-small.png', '0f70cfe05138f5d664f50b009bebdaf7');
        $this->checkFile('themes/_common_templates/img/icon-admins-big.png', 'c237d6f787767e2f76b4a299fd125fe0');
        $this->checkFile('themes/_common_templates/img/icon-admins-middle.png', 'd2c4880aa1784ce3fb133558bccd8834');
        $this->checkFile('themes/_common_templates/img/icon-admins-small.png', '0f70cfe05138f5d664f50b009bebdaf7');
        $this->checkFile('themes/_common_templates/img/icon-communication-big.png', 'd9634c6d21ab0388db756a302b43c24b');
        $this->checkFile('themes/_common_templates/img/icon-communication-middle.png', 'dad7567ea8455db8f9d04f62827f95b7');
        $this->checkFile('themes/_common_templates/img/icon-communication-small.png', '4ca468f4707653aea90c10a8aee280be');
        $this->checkFile('themes/_common_templates/img/icon-confirmationrequired-big.png', '99e46acda790c695b9e695235bc567ea');
        $this->checkFile('themes/_common_templates/img/icon-confirmationrequired-middle.png', '8f46b185cc39f2a1eac84b10786b1a22');
        $this->checkFile('themes/_common_templates/img/icon-confirmationrequired-small.png', '398919d212a85128db98277d1637fc66');
        $this->checkFile('themes/_common_templates/img/icon-content-big.png', 'f91559c3b5a898237f1e2e2c096205d0');
        $this->checkFile('themes/_common_templates/img/icon-content-middle.png', 'f20de38e9b7094525ac7090f1ff4c1cf');
        $this->checkFile('themes/_common_templates/img/icon-content-small.png', '20808f3aecdc6e5b884598b6cb826405');
        $this->checkFile('themes/_common_templates/img/icon-desktop-big.png', '5a993071a268cb9c4b8ff360204666e8');
        $this->checkFile('themes/_common_templates/img/icon-desktop-middle.png', '4dafab8ad39af078221f93bb72afd489');
        $this->checkFile('themes/_common_templates/img/icon-desktop-small.png', '4097ff78d80c697ec3601e8bfeacf3c0');
        $this->checkFile('themes/_common_templates/img/icon-dialog-big.png', 'ea668db8e90d4d2dd5891be9c3662d65');
        $this->checkFile('themes/_common_templates/img/icon-dialog-middle.png', '72a5e3a0a993e899b89747f7a977c3b8');
        $this->checkFile('themes/_common_templates/img/icon-dialog-small.png', 'aba167c8a15a1f84f1cc004498e2fcd1');
        $this->checkFile('themes/_common_templates/img/icon-edit-big.png', '12f011ddba56c84e4629ff19b4ab50cd');
        $this->checkFile('themes/_common_templates/img/icon-edit-middle.png', 'c7cd4aa95a0e0c95ff7695b0e63ef10d');
        $this->checkFile('themes/_common_templates/img/icon-edit-small.png', '677c4e10d0399599557af965c833a34d');
        $this->checkFile('themes/_common_templates/img/icon-export-big.png', '0b33f3a6ea9cc42150d97444626249cc');
        $this->checkFile('themes/_common_templates/img/icon-export-middle.png', '065e11d3d5f7cd3e9cb62b7930ccd618');
        $this->checkFile('themes/_common_templates/img/icon-export-small.png', 'ce6a9dc9ddd0a392fd7ec680bfa3e77b');
        $this->checkFile('themes/_common_templates/img/icon-exportfiles-big.png', '4affb865e1adcfa375831dd6946eac39');
        $this->checkFile('themes/_common_templates/img/icon-exportfiles-middle.png', 'd4d80ae06ef763aa17607b25703cae46');
        $this->checkFile('themes/_common_templates/img/icon-exportfiles-small.png', '34ff8df8776318a79a686ba86d24c750');
        $this->checkFile('themes/_common_templates/img/icon-features-big.png', '4ba9e54a2c4441183ea17ae39caf15f5');
        $this->checkFile('themes/_common_templates/img/icon-features-middle.png', '17d215110cdaae0725f1a108c7d6e74d');
        $this->checkFile('themes/_common_templates/img/icon-features-small.png', 'e51f91c359e0bed9d11b78080290b28f');
        $this->checkFile('themes/_common_templates/img/icon-help-big.png', '9007ac5af8f6f10ccffb0bfb2bf7d363');
        $this->checkFile('themes/_common_templates/img/icon-help-middle.png', '01dbb879f7f4c662128d1d9f4c04640c');
        $this->checkFile('themes/_common_templates/img/icon-help-small.png', '832097c7d37772be765ef635e6d348ee');
        $this->checkFile('themes/_common_templates/img/icon-home-big.png', '46fad7bed165099bc5c520b1ab962fed');
        $this->checkFile('themes/_common_templates/img/icon-home-middle.png', '051d86170471f4c07947c14be0768bc0');
        $this->checkFile('themes/_common_templates/img/icon-home-small.png', 'c5b62a0af020b01ed1791e44e76aec4f');
        $this->checkFile('themes/_common_templates/img/icon-import-big.png', '077886a7a7fde922b46a0116ae1f60ee');
        $this->checkFile('themes/_common_templates/img/icon-import-middle.png', '809edd07acbdffaab010ab6c365dfca0');
        $this->checkFile('themes/_common_templates/img/icon-import-small.png', '6e4e62703d746625306f230211abe5e0');
        $this->checkFile('themes/_common_templates/img/icon-importexport-big.png', 'ec07ded49abf1de13fca318f4a3e1e0d');
        $this->checkFile('themes/_common_templates/img/icon-importexport-middle.png', '6d4fb0ee56db17d61501ba8c26e62258');
        $this->checkFile('themes/_common_templates/img/icon-importexport-small.png', '56d6557f6098dd41450c3e4b81ace802');
        $this->checkFile('themes/_common_templates/img/icon-informations-big.png', '52544f78f6c21ff28917b9f0a3577333');
        $this->checkFile('themes/_common_templates/img/icon-informations-middle.png', '66fcddef6f1a68251e6840914910938b');
        $this->checkFile('themes/_common_templates/img/icon-informations-small.png', 'fcf56ff111c67e58b05ae8b0ecc18e62');
        $this->checkFile('themes/_common_templates/img/icon-integration-big.png', '59e9ca2ec6c48baa0034b7cd94ca20d4');
        $this->checkFile('themes/_common_templates/img/icon-integration-middle.png', '3956f57d21eae12542914fbca1a0522b');
        $this->checkFile('themes/_common_templates/img/icon-integration-small.png', '169795179b919a3c29083e88654803ea');
        $this->checkFile('themes/_common_templates/img/icon-invalidlicence-big.png', '8e513b68fc1fb1a26753a71d88e189fa');
        $this->checkFile('themes/_common_templates/img/icon-invalidlicence-middle.png', '09047b54107b0ce1f958b7b78b8b46a4');
        $this->checkFile('themes/_common_templates/img/icon-invalidlicence-small.png', '965eb4bda8d43d1fc8b5cefbcc3bea1b');
        $this->checkFile('themes/_common_templates/img/icon-languagetranslations-big.png', 'c7b03e7670e0263ed8dd55324b811f60');
        $this->checkFile('themes/_common_templates/img/icon-languagetranslations-middle.png', '025e0ea10cd3f9b89be1ab15412d7c68');
        $this->checkFile('themes/_common_templates/img/icon-languagetranslations-small.png', 'bab82ad50c6b71eb79f739b9833be610');
        $this->checkFile('themes/_common_templates/img/icon-logout-big.png', '6f78c0a1e928927c4dfb85f45ed17080');
        $this->checkFile('themes/_common_templates/img/icon-logout-middle.png', '0d4707b0b2e66d1ea54777ed43f55a9e');
        $this->checkFile('themes/_common_templates/img/icon-logout-small.png', '6e148662423620afe5dc9c67ed10b9c9');
        $this->checkFile('themes/_common_templates/img/icon-message-big.png', 'e2bad90c5d8f666dcad0572b60f919eb');
        $this->checkFile('themes/_common_templates/img/icon-message-middle.png', '28fba13255f80302f636d470e5573338');
        $this->checkFile('themes/_common_templates/img/icon-message-small.png', '3f02e3ee2ad26c65ea98836bbe1f5b45');
        $this->checkFile('themes/_common_templates/img/icon-newsletter-big.png', '0e6c53e8789a22eaded0a6770875c0ab');
        $this->checkFile('themes/_common_templates/img/icon-newsletter-middle.png', '510fc6f35665bacf1ee6d2970c368e64');
        $this->checkFile('themes/_common_templates/img/icon-newsletter-small.png', '75cb0a912f421e011c4dad05c3b77f00');
        $this->checkFile('themes/_common_templates/img/icon-onlineusers-big.png', 'b555c4f219c63d13adbe6b2a24096b74');
        $this->checkFile('themes/_common_templates/img/icon-onlineusers-middle.png', 'b6ded37c6ec167344eb93e4c7076f429');
        $this->checkFile('themes/_common_templates/img/icon-onlineusers-small.png', '03681a5b24afc538a6b3c396758bcd31');
        $this->checkFile('themes/_common_templates/img/icon-outbox-big.png', 'cd244f1f99b9c4edc97e1517e61647b6');
        $this->checkFile('themes/_common_templates/img/icon-outbox-middle.png', 'd78563c123666abaa270e69447818704');
        $this->checkFile('themes/_common_templates/img/icon-outbox-small.png', 'edc06a19e14830e7ca622238a0442419');
        $this->checkFile('themes/_common_templates/img/icon-panelsettings-big.png', '600e41998f62d8ff1d12105a835ce077');
        $this->checkFile('themes/_common_templates/img/icon-panelsettings-middle.png', '4ca98335815494b810a1df5b10b3af9c');
        $this->checkFile('themes/_common_templates/img/icon-panelsettings-small.png', '4734308c4657e7724cf940fa6e2da368');
        $this->checkFile('themes/_common_templates/img/icon-pendingtasks-big.png', '75e112adbc8f279ba02ce8bd53788ab9');
        $this->checkFile('themes/_common_templates/img/icon-pendingtasks-middle.png', '2b145a585a11689729dc6b300bc6ab80');
        $this->checkFile('themes/_common_templates/img/icon-pendingtasks-small.png', '999f171e840f0ff48b17a8d28d18ca40');
        $this->checkFile('themes/_common_templates/img/icon-plugins-big.png', '4e532d82c3818e8dc7613f45df3273cf');
        $this->checkFile('themes/_common_templates/img/icon-plugins-middle.png', '91d3d01c5db120803e72a48d8b405b0f');
        $this->checkFile('themes/_common_templates/img/icon-plugins-small.png', '7b73534b3d26811b757579eed53e1c97');
        $this->checkFile('themes/_common_templates/img/icon-quickstart-big.png', 'cdaacce8f5b76692164172510acad242');
        $this->checkFile('themes/_common_templates/img/icon-quickstart-middle.png', 'b4c7e287563225d44db2b409dfe2ec94');
        $this->checkFile('themes/_common_templates/img/icon-quickstart-small.png', '9ec548f1a0b48bd4a2adf99f1623501e');
        $this->checkFile('themes/_common_templates/img/icon-rss-big.png', '72ced7ea320583602b850ff6e5c7fbdc');
        $this->checkFile('themes/_common_templates/img/icon-rss-small.png', 'c41b65d7645345f0edd36f0c19bf28db');
        $this->checkFile('themes/_common_templates/img/icon-screen-big.png', 'ea668db8e90d4d2dd5891be9c3662d65');
        $this->checkFile('themes/_common_templates/img/icon-screen-middle.png', '72a5e3a0a993e899b89747f7a977c3b8');
        $this->checkFile('themes/_common_templates/img/icon-screen-small.png', 'aba167c8a15a1f84f1cc004498e2fcd1');
        $this->checkFile('themes/_common_templates/img/icon-showdesktop-big.png', '5a993071a268cb9c4b8ff360204666e8');
        $this->checkFile('themes/_common_templates/img/icon-showdesktop-middle.png', '4dafab8ad39af078221f93bb72afd489');
        $this->checkFile('themes/_common_templates/img/icon-showdesktop-small.png', '4097ff78d80c697ec3601e8bfeacf3c0');
        $this->checkFile('themes/_common_templates/img/icon-systemconfiguration-big.png', '780d29b146d1fd1469962a39350b7767');
        $this->checkFile('themes/_common_templates/img/icon-systemconfiguration-middle.png', 'a82bd70cbf1862dbbb35a8f275f78f2e');
        $this->checkFile('themes/_common_templates/img/icon-systemconfiguration-small.png', '4cd18f1231c702d5bc15ee14587b7133');
        $this->checkFile('themes/_common_templates/img/icon-tools-big.png', 'de50f63cb50a437e16cfddff26b146eb');
        $this->checkFile('themes/_common_templates/img/icon-tools-middle.png', '62754247b7afc6cdb0cbca04f7368ba9');
        $this->checkFile('themes/_common_templates/img/icon-tools-small.png', 'a39d5ed7068b48792e2eff6a85ae9081');
        $this->checkFile('themes/_common_templates/img/icon-trafficstats-big.png', '7396c4a63fabbcf7ce1b7abd6852a3b1');
        $this->checkFile('themes/_common_templates/img/icon-trafficstats-middle.png', 'ebb54e0c30d26bc3077f7264f887815b');
        $this->checkFile('themes/_common_templates/img/icon-trafficstats-small.png', '6b9e08748fa5d33948876d3bfe1c6b54');
        $this->checkFile('themes/_common_templates/img/icon-tutorialvideo-big.png', 'ee091c797e90320d8210e2989d6989f3');
        $this->checkFile('themes/_common_templates/img/icon-tutorialvideo-middle.png', 'c49e2420482831fa242bd4ba6b8c1854');
        $this->checkFile('themes/_common_templates/img/icon-tutorialvideo-small.png', '9681c0591166287c6c3144837fdf1008');
        $this->checkFile('themes/_common_templates/img/icon-user-big.png', 'bc4511d6f8f71e95e5cc1947ba4ff354');
        $this->checkFile('themes/_common_templates/img/icon-user-middle.png', '3352bdb7bd22d53efce08be9ed5a3297');
        $this->checkFile('themes/_common_templates/img/icon-user-small.png', 'bd2438c09d6833c37706bcbb7897e416');
        $this->checkFile('themes/_common_templates/img/icon-userprofile-big.png', 'dec04d9a592589c404ca0b98f91aa2e3');
        $this->checkFile('themes/_common_templates/img/icon-userprofile-middle.png', 'ae5baad5e00912508c86719fca40c4b4');
        $this->checkFile('themes/_common_templates/img/icon-userprofile-small.png', '238472f137c9bce99f2a3ff9389c98fb');
        $this->checkFile('themes/_common_templates/img/icon-userroleprivileges-big.png', '3875d989907efba233d0d88f96f3510f');
        $this->checkFile('themes/_common_templates/img/icon-userroleprivileges-middle.png', '4e019456b00ec3fd8cefb27d9dd31e80');
        $this->checkFile('themes/_common_templates/img/icon-userroleprivileges-small.png', 'a46a756d3ca1ea013f1ab4f7dc3ade77');
        $this->checkFile('themes/_common_templates/img/icon.delete.png', 'b15770a3f6cd2ec6becfc53a0d9ee039');
        $this->checkFile('themes/_common_templates/img/icon.detail.png', '7badfe4d050b451af06cd95e22f6db73');
        $this->checkFile('themes/_common_templates/img/icon.gadgets.png', 'c1d4bdfff360696f27b1f0518331124d');
        $this->checkFile('themes/_common_templates/img/icon.grid.png', 'caf5e4363c9e78a928290d95049a411b');
        $this->checkFile('themes/_common_templates/img/icon.refresh-small.png', 'd57feca8c4318a1f241b6b5c06a32575');
        $this->checkFile('themes/_common_templates/img/icon.refresh.png', '206b046cf2e08490ebf6e78b05cc8cf7');
        $this->checkFile('themes/_common_templates/img/icon.trash.png', 'a80c890e08320c5c4d12f77a7fda7328');
        $this->checkFile('themes/_common_templates/img/image.png', '66517d22e9c688e521951b3c2d4498e0');
        $this->checkFile('themes/_common_templates/img/input.png', '0df09f38346ba18c1a69510138fc7bea');
        $this->checkFile('themes/_common_templates/img/insert.png', '1eb65fc224afb8e9bb81bf6182e7fe22');
        $this->checkFile('themes/_common_templates/img/layout.border.png', '67415f356ff2d05286f9546d54d30423');
        $this->checkFile('themes/_common_templates/img/layout.hsplitter.png', '779103035b8b142f010428f761d80b2d');
        $this->checkFile('themes/_common_templates/img/layout.png', '934b808be1deb24c637e24a67a695e2e');
        $this->checkFile('themes/_common_templates/img/layout.vsplitter.png', '8c6b3d5f84cef04868751cdb27e16d2b');
        $this->checkFile('themes/_common_templates/img/line.short.gif', '13914f3810787c4d0571df1fd447627e');
        $this->checkFile('themes/_common_templates/img/link.chart.png', 'f273dd6a01598348ede2a3a365b33e9a');
        $this->checkFile('themes/_common_templates/img/link.toggle.button.png', '256a3c6cec4387c1b8d852026029b9d6');
        $this->checkFile('themes/_common_templates/img/listbox-rtl.png', '29a1b1778743d04a0df79657a369432c');
        $this->checkFile('themes/_common_templates/img/listbox.png', 'a1249146b52c6680a2a3ad175290c624');
        $this->checkFile('themes/_common_templates/img/loading.gif', '53e05833f2fa7301fc36a0e61d90bc43');
        $this->checkFile('themes/_common_templates/img/loading_small.gif', '770ff172b603c5bf2050383334cdda48');
        $this->checkFile('themes/_common_templates/img/loading_window.gif', '5c76e28fc98f79a35eb525059807cf16');
        $this->checkFile('themes/_common_templates/img/login.background.png', 'f4e33aa080de5810aca48e71fdd8d972');
        $this->checkFile('themes/_common_templates/img/main.menu.app.background.png', '79d8c565edeeae2dc07d6acd1f403e65');
        $this->checkFile('themes/_common_templates/img/main.menu.app.png', 'aaba9866a85701c44499ad8f04405257');
        $this->checkFile('themes/_common_templates/img/main.menu.app.vertical.png', '1df6e61d6c6e71ac8e63738d6a0addf6');
        $this->checkFile('themes/_common_templates/img/main.menu.background.png', 'aca1267c2307be4d1cc4b3c00625e443');
        $this->checkFile('themes/_common_templates/img/main.menu.divider.png', '00a4f221b42b935a7fe4d55dfeb6b0b1');
        $this->checkFile('themes/_common_templates/img/main.menu.entry.png', '7cdfe32d5125dfdd9a37300c7f0a7691');
        $this->checkFile('themes/_common_templates/img/main.menu.item.png', '2fe92ae59144361f5a05db2d923ba1bc');
        $this->checkFile('themes/_common_templates/img/main.menu.png', '57e241fec7fad9f9c11a9eee5b9eb074');
        $this->checkFile('themes/_common_templates/img/main.menu.sub.divider.png', '444a2ed56210c48ad4d6d4bbd03607fd');
        $this->checkFile('themes/_common_templates/img/main.menu.sub.png', '398cf8cd757764d82a9ba940da44f2f1');
        $this->checkFile('themes/_common_templates/img/main.menu.vertical.png', '450f5560c9fb728f845f9f9a40c56066');
        $this->checkFile('themes/_common_templates/img/message.blue.background.png', '6cd2f54c4ff35a4c0e57b03777264f43');
        $this->checkFile('themes/_common_templates/img/message.blue.png', '204bd82ddd1f3475dd4f2b37fa0d3d4c');
        $this->checkFile('themes/_common_templates/img/message.blue.vertical.png', 'c75579cb4811384ffe25e1a76f605ea6');
        $this->checkFile('themes/_common_templates/img/message.green.background.png', '2230156da1f1ca7ed780620e5aa22e6e');
        $this->checkFile('themes/_common_templates/img/message.green.png', '96b47d0ad6b9d15cb9ef07fbc074afcd');
        $this->checkFile('themes/_common_templates/img/message.green.vertical.png', '44e1e2b8f501e5c3a05e17108e33aa3e');
        $this->checkFile('themes/_common_templates/img/message.red.background.png', '932fab46849dff3faf5c4dd6b9c88ffd');
        $this->checkFile('themes/_common_templates/img/message.red.png', '38256bded885bfab4b4fe52ae30bdf25');
        $this->checkFile('themes/_common_templates/img/message.red.vertical.png', '0e5d19452105c587ec699489d4d27618');
        $this->checkFile('themes/_common_templates/img/no.theme.thumbnail.jpg', 'db2b9f70f5fe89a3c9c2f98d69b19254');
        $this->checkFile('themes/_common_templates/img/no_image.gif', '07f5f79d487dbf795f7ea37a04aa24c0');
        $this->checkFile('themes/_common_templates/img/pager.png', '6eafb724bc4df33a304f917bad9e8df9');
        $this->checkFile('themes/_common_templates/img/panel.top.start.gif', '65c76e8d0542445989df2e6607b41713');
        $this->checkFile('themes/_common_templates/img/pdf.png', 'f8dfa3fa0386adcd2370c6d509a0be91');
        $this->checkFile('themes/_common_templates/img/php.png', '2c63cf93ca9b1ff5d5b16c6646a59ddc');
        $this->checkFile('themes/_common_templates/img/plugin.png', 'd0855f7cc39d69bbdbda15bafc12ec07');
        $this->checkFile('themes/_common_templates/img/plugin_background.png', 'c8af77191cef9f17341b28dcc10f1224');
        $this->checkFile('themes/_common_templates/img/popupwin.png', '81ae96d56f85db0ef7bdf64fd90b3a93');
        $this->checkFile('themes/_common_templates/img/popupwin.vertical.png', '160b32bdc82aae186903a8c5ead0f411');
        $this->checkFile('themes/_common_templates/img/popupwinextendable.png', 'bdf61250f8ba67e0aa99c99fdaf1dfad');
        $this->checkFile('themes/_common_templates/img/popupwinextendable.vertical.png', '1ccba43654691d38dd1d7e539b5454b5');
        $this->checkFile('themes/_common_templates/img/quicklaunch.png', '4f6d9444fb7357e7618f5d1207f1753c');
        $this->checkFile('themes/_common_templates/img/radio.button.png', '6a39f9742ecd1d0dd34c70c9822bf508');
        $this->checkFile('themes/_common_templates/img/resizecorner.gif', '6fdef023649dd80e70caa11908cc5e1b');
        $this->checkFile('themes/_common_templates/img/resizer.png', '483f968e104d8ccdbd72d9000f3afa3e');
        $this->checkFile('themes/_common_templates/img/select.button.png', '5923d5e2d9300e5c81943acd32bbf73e');
        $this->checkFile('themes/_common_templates/img/sidebar.background.png', '13e856653642c59049cbc3ba3e39421f');
        $this->checkFile('themes/_common_templates/img/sidebar.border.png', '7ee72bc27a791f47a665bd9f854bda0f');
        $this->checkFile('themes/_common_templates/img/sidebar.closed.png', 'c5f457634f56191dbe8d400cfbae7fe8');
        $this->checkFile('themes/_common_templates/img/sidebar.png', '879eeb488a41cb3d03f0cbce69fc02eb');
        $this->checkFile('themes/_common_templates/img/smpl_logs_no_data.jpg', '31ae35eb109dd7769c35b64a0e357d16');
        $this->checkFile('themes/_common_templates/img/swf.png', '1623343ec1b366081175a4d28feb66ae');
        $this->checkFile('themes/_common_templates/img/table2-hrow.gif', '3e4484ea8db10af1320808c8477346ea');
        $this->checkFile('themes/_common_templates/img/tabs.png', 'fce94d82812219c0ed1b98840637ec3b');
        $this->checkFile('themes/_common_templates/img/task.menu.png', 'a468968cbd7503cb3c8d756db0601872');
        $this->checkFile('themes/_common_templates/img/task.png', 'd383a77c351c41ad3dc81cda01e9a529');
        $this->checkFile('themes/_common_templates/img/thin.button.png', '1dafda5af36aaf342a7c9b28916e82cf');
        $this->checkFile('themes/_common_templates/img/toogle.button.png', '14f3eaddd669780b2d14f1ed7f1f5dfa');
        $this->checkFile('themes/_common_templates/img/trash.png', 'a80c890e08320c5c4d12f77a7fda7328');
        $this->checkFile('themes/_common_templates/img/txt.png', '79520d0ef237730c55eb5bcd50b78ea2');
        $this->checkFile('themes/_common_templates/img/unknown_file.png', '3a00859ebcd6dfef1572ecdddbe693fe');
        $this->checkFile('themes/_common_templates/img/up.png', '7d79552d42f3165aeede80ba93fabc75');
        $this->checkFile('themes/_common_templates/img/video.png', '9681c0591166287c6c3144837fdf1008');
        $this->checkFile('themes/_common_templates/img/wallpaper.positions.png', 'd7f9e09eb6636a711db53e044c03b69b');
        $this->checkFile('themes/_common_templates/img/wallpapers/Default.jpg', 'd09f190e29a076dd5bc556497132ada1');
        $this->checkFile('themes/_common_templates/img/wallpapers/Fusion.jpg', 'a7c4bbdac79eade34a4ecc949519ffee');
        $this->checkFile('themes/_common_templates/img/wallpapers/Galaxy.jpg', '5804af1f0cf62f6d95bf013e3b55b2a3');
        $this->checkFile('themes/_common_templates/img/wallpapers/Karel_Hejkal_1920x1080.jpg', '77cab71cc6e1dfbd58c387b1c0332ac4');
        $this->checkFile('themes/_common_templates/img/wallpapers/Lines.jpg', 'e340600c3c350a0b23a902e9aa1260c2');
        $this->checkFile('themes/_common_templates/img/wallpapers/Matrix.jpg', '993836f8fdbca9c50b75c8f5b6aa413c');
        $this->checkFile('themes/_common_templates/img/wallpapers/Waves.jpg', '3bac4d23f3b79cc74f38f80a62445a6d');
        $this->checkFile('themes/_common_templates/img/window.active.br.clean.png', 'b8259f618710a96bd510e385939ee1c0');
        $this->checkFile('themes/_common_templates/img/window.active.png', '5e71b625b030bd08bf17c24cd3e0b719');
        $this->checkFile('themes/_common_templates/img/window.active.vertical.png', '00f530e9d94402da73bd494e6601feff');
        $this->checkFile('themes/_common_templates/img/window.inactive.png', 'bb649008559d5ba9474ceced08acc968');
        $this->checkFile('themes/_common_templates/img/window.inactive.vertical.png', 'e9da8405d45d7b6831960e3cbb6d308e');
        $this->checkFile('themes/_common_templates/img/window.move.png', '76f22f47d0161cc8255aa60dd337e327');
        $this->checkFile('themes/_common_templates/img/wysiwyg.gif', '017283b1ab06fc9391f796f2c13b0da8');
        $this->checkFile('themes/_common_templates/img/xls.png', '3f2844cce5616ee82f1e0dc0b9f0d53b');
        $this->checkFile('themes/_common_templates/img/zip.png', 'ce15cafabf396370aac29085b3c1a5dd');
        $this->checkFile('themes/_common_templates/import_custom_language_panel.tpl', '36fe179dc09cd1a1bf3561ef9d13a647');
        $this->checkFile('themes/_common_templates/import_language.tpl', 'c1df1cf60613d3df6e19681193ae41a9');
        $this->checkFile('themes/_common_templates/info_dialog.tpl', '20c6cfa4ddf8a5d4bdddb1229754a49b');
        $this->checkFile('themes/_common_templates/ip_detail.tpl', '3723b4ce7dc6ccc4b8c8193f4c982d18');
        $this->checkFile('themes/_common_templates/item.tpl', '766385be509b8ee36bbbdd77e4c24ac6');
        $this->checkFile('themes/_common_templates/item_panel.tpl', '29d23d91da01848dcabcddb94eac62ec');
        $this->checkFile('themes/_common_templates/language_create_new.tpl', '1ae789af118ce84a76ec067e82d52aec');
        $this->checkFile('themes/_common_templates/language_edit_panel.tpl', '4b582c49c5aec0a72765e8764ba390b0');
        $this->checkFile('themes/_common_templates/language_translations_grid.tpl', 'b3d4b3ff7279bf9383886e84ba3218ab');
        $this->checkFile('themes/_common_templates/languages_configuration.tpl', '86f17a42cef0bedb165295e99c970582');
        $this->checkFile('themes/_common_templates/layout_panel_content.tpl', 'aa2bff15b8ac47c5ec4d4946b90cd926');
        $this->checkFile('themes/_common_templates/layout_panel_header_navigation.tpl', '6b0d746501001da8615a22d57266dcb0');
        $this->checkFile('themes/_common_templates/layout_panel_tab.tpl', '316df333cac9b455c7dc04100c2e2d1d');
        $this->checkFile('themes/_common_templates/license_invalid.tpl', '6181e1127345050c94d6708cd805aefb');
        $this->checkFile('themes/_common_templates/link_button.tpl', '71fad92bff79f1fd2e1066818afac789');
        $this->checkFile('themes/_common_templates/listbox.tpl', '671aeeb5f3655cc0045d5145afa3b298');
        $this->checkFile('themes/_common_templates/listbox_popup.tpl', 'df6e88ad302451d31a3f03e85106df72');
        $this->checkFile('themes/_common_templates/listdown_button.tpl', 'a1cd26a1aec6d403420971d7469a6f1b');
        $this->checkFile('themes/_common_templates/loadable_tree.tpl', 'e2c214b134bffe5fe2bb38f679a64eb5');
        $this->checkFile('themes/_common_templates/loading_indicator.tpl', 'd942694554fa66708876069a57faff38');
        $this->checkFile('themes/_common_templates/loading_screen.tpl', '45d70765ad380ad3f0df92c82de65792');
        $this->checkFile('themes/_common_templates/loading_template.tpl', '314bd47f80b2a12b8ba66653a380bc35');
        $this->checkFile('themes/_common_templates/login.tpl', 'e7be8367104ee7221547730250f9b0f0');
        $this->checkFile('themes/_common_templates/login_form.tpl', 'f91280418e3361150182135a8cb34a23');
        $this->checkFile('themes/_common_templates/login_main.tpl', '8e084c2033a598597409e68a78593026');
        $this->checkFile('themes/_common_templates/logins_history.tpl', '740e9d7a1b893fe3280b782958742998');
        $this->checkFile('themes/_common_templates/loginshistory_filter.tpl', '64804e791ea2ca4fcc7e01d7a8443479');
        $this->checkFile('themes/_common_templates/logs_no_data.tpl', '9139b1d227cf085cf5f2cc11e396625a');
        $this->checkFile('themes/_common_templates/mail/email_account_test_mail.stpl', '6f8d04634f7386ed4fc73d420b8e4c6a');
        $this->checkFile('themes/_common_templates/mail/email_footer.stpl', '68b329da9893e34099c7d8ad5cb9c940');
        $this->checkFile('themes/_common_templates/mail/email_header.stpl', '68b329da9893e34099c7d8ad5cb9c940');
        $this->checkFile('themes/_common_templates/mail/email_on_invalid_license.stpl', '4aa473cd064ac4383e5b7e38b687b99a');
        $this->checkFile('themes/_common_templates/mail/email_request_new_password.stpl', 'e7a0348af98e08df1f398af4d8de9cb8');
        $this->checkFile('themes/_common_templates/mail_detail_data.tpl', 'cb8867c95ce35d7ad35b82f5c663ae42');
        $this->checkFile('themes/_common_templates/mail_outbox_panel.tpl', 'eda83d3c7fed41f0449b2464e96df945');
        $this->checkFile('themes/_common_templates/mail_template_not_selected.tpl', '8f8e4d19a09cd7bc7e96df0e0729ef8d');
        $this->checkFile('themes/_common_templates/mail_template_preview.tpl', 'ea7d0df5aef2645e05d768c51a294389');
        $this->checkFile('themes/_common_templates/mail_template_test_form.tpl', 'ddc839ac6255a0a9481a54433a3da7a6');
        $this->checkFile('themes/_common_templates/mail_templates.tpl', 'd1c0843df8307b67266b71e16f5b34c1');
        $this->checkFile('themes/_common_templates/mail_templates_list.tpl', 'd68cf4d9f0f51fbb8a0aff0d568ae036');
        $this->checkFile('themes/_common_templates/mailoutbox_filter.tpl', '8fd6e8ae35323bbc8debd1c248142e61');
        $this->checkFile('themes/_common_templates/mailoutbox_list_no_data.tpl', '6e73857c29657b145fa6408024d45bb4');
        $this->checkFile('themes/_common_templates/main_error_html_doc.tpl', 'f1028b2ebd52ffcb0f0d647b2ec7f842');
        $this->checkFile('themes/_common_templates/main_filter_panel.tpl', '0985a7421f898d75d4df72b4a6081c49');
        $this->checkFile('themes/_common_templates/main_html_doc.tpl', 'f23282522e493eefa05881d349abb362');
        $this->checkFile('themes/_common_templates/main_menu.tpl', '1036ce189dc092adca21d6405e83544f');
        $this->checkFile('themes/_common_templates/mass_pay_export_form.tpl', 'c3b9939154fe31ce081f9c4edee7c410');
        $this->checkFile('themes/_common_templates/menu_entry.tpl', '9245aaaa5732793ce089f5fe25d703ea');
        $this->checkFile('themes/_common_templates/menu_section.tpl', '2420c835d490c654f3c006c12becdf52');
        $this->checkFile('themes/_common_templates/messages.tpl', 'bf1a3bac08c419320acb94673ad29f0b');
        $this->checkFile('themes/_common_templates/module_body.stpl', 'c079addcd33eb725ab7efbf09c16a793');
        $this->checkFile('themes/_common_templates/multi_editor.tpl', '3ee5baa5bdb7824c0c2ae6f2dc275830');
        $this->checkFile('themes/_common_templates/multiselect.tpl', '9d1863b21edd131520315ce252fde639');
        $this->checkFile('themes/_common_templates/newsletter_broadcast_form.tpl', '1ccb4e8c2a3873263c7c8c1fc7c19f27');
        $this->checkFile('themes/_common_templates/newsletter_broadcasts.tpl', 'e85ba6dc04b3a921af601f6bf976a5b8');
        $this->checkFile('themes/_common_templates/newsletter_edit_panel.tpl', '73ddca2129beb12e11215b1c55e70461');
        $this->checkFile('themes/_common_templates/newsletter_form.tpl', 'e86bb366b8986ac4cb1b50c9ccc94b8e');
        $this->checkFile('themes/_common_templates/no_content_gadgets.tpl', '1d4ce600d473f33e2b229101a50cbc3f');
        $this->checkFile('themes/_common_templates/no_language_selected.tpl', 'd61125f2b1cf78e4e66653d4e2f04bdd');
        $this->checkFile('themes/_common_templates/notification_window.tpl', 'db781872bdb9748bc838e051b8e5e4e2');
        $this->checkFile('themes/_common_templates/online_users.tpl', 'e78ff82eb18c092018cd48d90ae48863');
        $this->checkFile('themes/_common_templates/online_users_gadget_rolecount.tpl', '5fd6af0c5f2edec24d0e35dc00a9e870');
        $this->checkFile('themes/_common_templates/onlinegadgets_no_data.tpl', 'f5f692a433b4911963a92c41cc269768');
        $this->checkFile('themes/_common_templates/onlineusers_filter.tpl', '7a0572e8ae3375f2c79c8fe985295bd6');
        $this->checkFile('themes/_common_templates/page_header.tpl', '1fc6cb8ba9169bea326c2696c3924853');
        $this->checkFile('themes/_common_templates/panel_footer.stpl', '940e5a3345f1058d0cfc751d22355e3b');
        $this->checkFile('themes/_common_templates/password_constraint_panel.tpl', '71b23765c240aff0073e713cfc4da992');
        $this->checkFile('themes/_common_templates/password_panel.tpl', 'b1440553a785aae589233a91315b281f');
        $this->checkFile('themes/_common_templates/payment_next_steps.tpl', 'f2df9ade0b792ef3c0f73a621c63d156');
        $this->checkFile('themes/_common_templates/pending_backround_tasks.tpl', '75149233f7ae446473c9220c9ff1ef8f');
        $this->checkFile('themes/_common_templates/plugin_config_tabs.tpl', '76f8b322c45a71144a6935bc65f672f5');
        $this->checkFile('themes/_common_templates/plugin_configuration.tpl', '4cce88fd93f2df049f0df8215074fea8');
        $this->checkFile('themes/_common_templates/plugin_detail.tpl', '2d4b93316cbc3428022aeb460393172d');
        $this->checkFile('themes/_common_templates/plugins_list.tpl', '483337896fc80bf5529906afd9128a53');
        $this->checkFile('themes/_common_templates/popup_form_widget.tpl', '0f5d2ef3d678d026df06fe1f1e5991a8');
        $this->checkFile('themes/_common_templates/post_response.stpl', '790ab48da1fcc9a767719874254d9311');
        $this->checkFile('themes/_common_templates/proxy_server_configuration.tpl', '732a20cf9c1d59496e88d9bd5b080484');
        $this->checkFile('themes/_common_templates/quick_launch.tpl', '8c748719166b610dffa58760bc4b70b8');
        $this->checkFile('themes/_common_templates/quick_launch_draggable.tpl', '95c176695c4d4c278fee2d956446c7bd');
        $this->checkFile('themes/_common_templates/quick_task.stpl', 'a474cbc0953af7ef1ea35c6d8e6e18fe');
        $this->checkFile('themes/_common_templates/quicklaunch_settings.tpl', '1e595ebaeb4364f173ee3fec71c1762d');
        $this->checkFile('themes/_common_templates/radio_button_group_row.tpl', '3713f6d400aa1ca96d9e404082304912');
        $this->checkFile('themes/_common_templates/refresh_panel.tpl', '5c709df4d219d5feb4f29003ca932f77');
        $this->checkFile('themes/_common_templates/regional_settings.tpl', '7fd67a6e2e8b44c62dc36ce4812b7189');
        $this->checkFile('themes/_common_templates/regional_settings_tab.tpl', '82a573fa67deb883c207f05c019f7eeb');
        $this->checkFile('themes/_common_templates/report_filter.tpl', 'b37d7cb139866b0da13d266ad5e76941');
        $this->checkFile('themes/_common_templates/request_new_password_form.tpl', '8c07378ea682ae07ad03e5c0720e85ad');
        $this->checkFile('themes/_common_templates/resizable_text_area.tpl', '7995c217048ccd289dfee567a455b08e');
        $this->checkFile('themes/_common_templates/richlistbox.tpl', '9a4923e8ac9d635de021509a0d7de661');
        $this->checkFile('themes/_common_templates/richlistbox_popup.tpl', 'c155c59eea77770589bcadca0c75f1af');
        $this->checkFile('themes/_common_templates/richtext_editor.tpl', '7c3c83f529005fa41bf8e76f75a06b8d');
        $this->checkFile('themes/_common_templates/richtext_editor_toolbar.tpl', '2df0dc7e43c92cd9f89b52e26e6715df');
        $this->checkFile('themes/_common_templates/richtexteditor_addlink.tpl', '7368b95c47c79c4e631694e6c0d29154');
        $this->checkFile('themes/_common_templates/role_privileges.tpl', 'eaaedd2e557d9ea7f7e44b1369d09fd3');
        $this->checkFile('themes/_common_templates/search_filter.tpl', 'c43c492cae5282a628238b4ff75508b2');
        $this->checkFile('themes/_common_templates/select_account_form.tpl', '1842c10af162287abb6059725231c263');
        $this->checkFile('themes/_common_templates/selectbutton_search.tpl', '4f661b915729a3d71b09113d1c0e1fe5');
        $this->checkFile('themes/_common_templates/set_new_password_form.tpl', '9270391a0892b67b03efbd67084806c6');
        $this->checkFile('themes/_common_templates/sidebar.tpl', '65226d7e25dcdca0cf71a9f3118d8139');
        $this->checkFile('themes/_common_templates/sidebar_closed.tpl', '3d903661713a9ee5fb402776ee06d310');
        $this->checkFile('themes/_common_templates/sidebar_gadget.tpl', '1f904859e056808c8826836a4e256761');
        $this->checkFile('themes/_common_templates/simple_filter.tpl', '569adac6a4e4346b441cd19152972e21');
        $this->checkFile('themes/_common_templates/simple_icon_object.tpl', 'bcbc9ea994d4aa8bbdee1eddc3ad19d8');
        $this->checkFile('themes/_common_templates/simple_popup_window.tpl', '38f46b253b18038fe8af0babfb96f05b');
        $this->checkFile('themes/_common_templates/simplecolorpicker.tpl', 'a212703ffb38e2c79152ba5926953049');
        $this->checkFile('themes/_common_templates/single_content_panel.tpl', '529d4a42f9106d91881f8b8b8e87748b');
        $this->checkFile('themes/_common_templates/size_format_widget.tpl', 'ebfb7db6718ec601af59a570d8e0ccb3');
        $this->checkFile('themes/_common_templates/start_button.tpl', '7aa2278c46b897536625cc042b4f5499');
        $this->checkFile('themes/_common_templates/start_error.tpl', '3356dfc9c4553e91553570acfaba7c68');
        $this->checkFile('themes/_common_templates/sub_menu_section.tpl', '7b1009df6d4fb8ff3b592d7c85ccbc4e');
        $this->checkFile('themes/_common_templates/submit_dialog.tpl', '77b5f23d1a810a68c9f2a1a9f19e84ce');
        $this->checkFile('themes/_common_templates/system_menu.tpl', '61db9353df9cdb7b10fc36bc15b88aa5');
        $this->checkFile('themes/_common_templates/tab_item.tpl', 'b1c6b9bf5bda5b8ba145fe000823b40f');
        $this->checkFile('themes/_common_templates/tab_panel.tpl', '15b20f431fdcf7da7c2f02c0f6c2ba19');
        $this->checkFile('themes/_common_templates/task.tpl', '38a4b70b6456a12285be4bb113c72575');
        $this->checkFile('themes/_common_templates/taskbar.tpl', 'd7cf8ef7a71bf324aee5c1c7173afc7e');
        $this->checkFile('themes/_common_templates/template_form.tpl', 'e47caf8cb37049be84a31c5c4f15ba49');
        $this->checkFile('themes/_common_templates/template_form_constants.tpl', '91c398393e519cf7c6a53ba758eefc47');
        $this->checkFile('themes/_common_templates/template_form_theme_entry.tpl', '91a40d5bfbb3ff3b61cd7771e24a2684');
        $this->checkFile('themes/_common_templates/template_form_themes.tpl', 'e7158c1782ef49ddbf3fbe671c5c5b8a');
        $this->checkFile('themes/_common_templates/template_form_variables.tpl', 'e1c008058f4be04a9e6e76ba72cc3290');
        $this->checkFile('themes/_common_templates/templates_form.tpl', '7a0a1baf13edabb10c8c6bef5a3dac41');
        $this->checkFile('themes/_common_templates/theme_panel.tpl', '9c5a217986d2ce35abc6594f5ce2f012');
        $this->checkFile('themes/_common_templates/theme_settings.tpl', 'f7450b4590d95d3e2cf2636de397dc26');
        $this->checkFile('themes/_common_templates/timezone_settings.tpl', 'f6125710e1dbb548b94640dfed4af35b');
        $this->checkFile('themes/_common_templates/timezone_settings_tab.tpl', '9742d50f5fd09bca0e4c454fb53b4e77');
        $this->checkFile('themes/_common_templates/tooltip_popup.tpl', 'e63b270daacbb197d59737282cf49ea0');
        $this->checkFile('themes/_common_templates/trash.tpl', '270d020eabfcf284be7a97e7102924d5');
        $this->checkFile('themes/_common_templates/update_version.stpl', '5602f52fe8248df474201a16c922048f');
        $this->checkFile('themes/_common_templates/upload_panel.tpl', '6933359965cd48784d15459145469dec');
        $this->checkFile('themes/_common_templates/uploaded_file.tpl', 'f9313defa0216f7702ee94b6b6185dd7');
        $this->checkFile('themes/_common_templates/user_edit.tpl', '241951fc4518a7104554d8490cc2a329');
        $this->checkFile('themes/_common_templates/view_form.tpl', '7e739d26dd3e6e38f47330f1d0e1b301');
        $this->checkFile('themes/_common_templates/visits_sales_logs_no_data.tpl', 'bf638a14b2e42e62be90e049727694e1');
        $this->checkFile('themes/_common_templates/wallpaper_add_custom.tpl', '2210741b569ef188fa352c977a289261');
        $this->checkFile('themes/_common_templates/wallpaper_entry.tpl', '64c85f4da7897cd0f34168c62de661b9');
        $this->checkFile('themes/_common_templates/wallpaper_settings.tpl', 'd160dbed38556231aeac49a96213e4d4');
        $this->checkFile('themes/_common_templates/window.tpl', 'd1937e90c9256204636d87e991d84a3d');
        $this->checkFile('themes/_common_templates/window_bottom_left.tpl', 'd14b545c27afa02ab7a919bdeb4c9470');
        $this->checkFile('themes/_common_templates/window_empty_content.tpl', 'b1535ec719cada5b9f5d98849074b9bd');
        $this->checkFile('themes/_common_templates/window_header.tpl', 'fb5aca529f44f12c3f3a8bda2761054d');
        $this->checkFile('themes/_common_templates/window_header_refresh.tpl', 'fcd47f4585abcac3c3a61ee3991379bc');
        $this->checkFile('themes/_common_templates/window_left.tpl', '9ac901446bfa26918e32fa029fb42093');
        $this->checkFile('themes/_common_templates/window_move_panel.tpl', 'f5bbd373a758bf76e6efadc94dca4b11');
        $this->checkFile('themes/_common_templates/wizard_panel.tpl', '3142ce6354cb3e1c86b6c13c1d906189');
        $this->checkFile('themes/affiliates/Bootstrap/advanced_email_settings_form.tpl', '2a83754f5d407d1c031bf0259ae82b11');
        $this->checkFile('themes/affiliates/Bootstrap/advanced_email_settings_tab.tpl', '4cdac3ab7ec6827e1307d48028f2d835');
        $this->checkFile('themes/affiliates/Bootstrap/advanced_screen.tpl', '7a6fc49337838298197f0d2a4a49746b');
        $this->checkFile('themes/affiliates/Bootstrap/aff_status_panel.tpl', 'f6c8ed375a26bfa2b3262189422c5a1c');
        $this->checkFile('themes/affiliates/Bootstrap/aff_status_widget.tpl', '518ca3971863bd4c41412a286ebfdf75');
        $this->checkFile('themes/affiliates/Bootstrap/affiliate_edit_details_additional.tpl', '98de15bb9a88b36dc47ba266389cb413');
        $this->checkFile('themes/affiliates/Bootstrap/affiliate_manager.tpl', '71f61fa4905cf1b525e2c826f01b2f2f');
        $this->checkFile('themes/affiliates/Bootstrap/affiliate_subaffiliates.tpl', '8c995322ed3cd841aae0928dd8e148fd');
        $this->checkFile('themes/affiliates/Bootstrap/affiliate_theme_settings.tpl', '46f3d82a7762c6669d5014aa5be3d0b8');
        $this->checkFile('themes/affiliates/Bootstrap/affiliate_tutorial_video.tpl', 'dcd2156f94a7bdc8fb75d594ed40a308');
        $this->checkFile('themes/affiliates/Bootstrap/affiliate_urls_no_data.tpl', 'c9868414093445accf0f0d7551847116');
        $this->checkFile('themes/affiliates/Bootstrap/afflink_protector_screen.tpl', '97da4ebc987ac62bbaf542a0e8ce5316');
        $this->checkFile('themes/affiliates/Bootstrap/align_widget.tpl', '124769dbcc410ae58c1dfd53f15b58d6');
        $this->checkFile('themes/affiliates/Bootstrap/api_integration.tpl', '8cc1da5572a29e72e4215867364998ac');
        $this->checkFile('themes/affiliates/Bootstrap/available_values_edit.tpl', 'e96fa729b9a61e7e4a21fbddf80565fb');
        $this->checkFile('themes/affiliates/Bootstrap/banner_category_item.tpl', '38ca8170d3d7b851fbc815cc63681df9');
        $this->checkFile('themes/affiliates/Bootstrap/banner_code_widget.tpl', '91a021d77bd1ddb4f2f007809ad07902');
        $this->checkFile('themes/affiliates/Bootstrap/banner_filter.tpl', 'ed6100072214442574d06b6aa1792976');
        $this->checkFile('themes/affiliates/Bootstrap/banner_preview_promo.tpl', '96b67011b02cd4a04bd508a21d1a8bb4');
        $this->checkFile('themes/affiliates/Bootstrap/banner_preview_textwidget.tpl', '690ff2bbd824bcd5c5bb52be01597520');
        $this->checkFile('themes/affiliates/Bootstrap/banner_preview_widget.tpl', '9df335ee41605fbbc3a3fcdb239478ad');
        $this->checkFile('themes/affiliates/Bootstrap/banner_stats_filter.tpl', '437ce34d575bf783e3b85cd5d39a9cf3');
        $this->checkFile('themes/affiliates/Bootstrap/banner_stats_list.tpl', '3e71f3763376f08380959fe865aad875');
        $this->checkFile('themes/affiliates/Bootstrap/banner_widget.tpl', 'c3ac45f49f8fdc43301943a701882c56');
        $this->checkFile('themes/affiliates/Bootstrap/banner_widget_affiliate_pagepeel.tpl', '50cc893da765f31585fc3e36674d387f');
        $this->checkFile('themes/affiliates/Bootstrap/banner_widget_code.tpl', '0fb2039eec50061e0b6401a239eeca1e');
        $this->checkFile('themes/affiliates/Bootstrap/banner_widget_header.tpl', '76ebd7fa61540f74648a71ba981e3d87');
        $this->checkFile('themes/affiliates/Bootstrap/banner_widget_stats.tpl', 'fe3b4c8e04d179d36b203d53010814da');
        $this->checkFile('themes/affiliates/Bootstrap/banners.tpl', '78cf0cc4bf8f5b94d8000d2ef79383cc');
        $this->checkFile('themes/affiliates/Bootstrap/banners_no_data.tpl', 'c89e4cdd6bccb5df3314e93446c964a4');
        $this->checkFile('themes/affiliates/Bootstrap/breadcrumbs.tpl', '921035f90b931792de2bfd1fb40dc597');
        $this->checkFile('themes/affiliates/Bootstrap/breadcrumbs_entry.tpl', '42ee9a25b7525589ed65bf9625adc890');
        $this->checkFile('themes/affiliates/Bootstrap/broadcast_email.tpl', '7e2d20d16e127ec77e00be3f5d6eab8d');
        $this->checkFile('themes/affiliates/Bootstrap/button.tpl', 'ab00df127be0dd89a125fe05f33c0380');
        $this->checkFile('themes/affiliates/Bootstrap/calendar.tpl', 'd6831aa786acf1f829a90cec776126eb');
        $this->checkFile('themes/affiliates/Bootstrap/campaign_category_item.tpl', '60aa1b58ff10d53fd1e800888b1069cb');
        $this->checkFile('themes/affiliates/Bootstrap/campaign_detail.tpl', '00c57f959e4cff9634cf1acbc181cf21');
        $this->checkFile('themes/affiliates/Bootstrap/campaign_grid_widget.tpl', '984c1470ce27033a2d9d465972298675');
        $this->checkFile('themes/affiliates/Bootstrap/campaign_long_description.tpl', 'c8224613917e714a724a19ed20ce2505');
        $this->checkFile('themes/affiliates/Bootstrap/campaign_stats_filter.tpl', 'ef03bd124d478bb5f8fd418a64c7ab3c');
        $this->checkFile('themes/affiliates/Bootstrap/campaign_stats_list.tpl', 'e45c163f75670253d0dcc5037f7168e2');
        $this->checkFile('themes/affiliates/Bootstrap/campaign_tracking_codes.tpl', '3a2324b74f6d9c54211cc58fe3d38742');
        $this->checkFile('themes/affiliates/Bootstrap/campaign_tracking_codes_filter.tpl', '30062ab9dea3ba63b6ea0d205ca453e0');
        $this->checkFile('themes/affiliates/Bootstrap/campaigns_filter.tpl', '3db463dfecc9eb428dab1f2257f2a5d9');
        $this->checkFile('themes/affiliates/Bootstrap/campaigns_list.tpl', '6b63624d55078a801bc09a2e56a04417');
        $this->checkFile('themes/affiliates/Bootstrap/campaigns_list_tree.tpl', 'e344f71cf7eddd7c6c1cc24d4f85fe72');
        $this->checkFile('themes/affiliates/Bootstrap/captcha.tpl', '0326fedb283400e2c13eeae155d7b536');
        $this->checkFile('themes/affiliates/Bootstrap/category_info.tpl', 'bf2e78d31f6a93380f4fbc0538589e84');
        $this->checkFile('themes/affiliates/Bootstrap/change_status_button.tpl', 'a0d13402819088b5078e8100a21a0159');
        $this->checkFile('themes/affiliates/Bootstrap/channel_stats_filter.tpl', '3a5aa4e605bdcf300bcc1f1ad0bf56fb');
        $this->checkFile('themes/affiliates/Bootstrap/channel_stats_panel.tpl', '978b24c1f50a0c2fab07e3d9cf2e6272');
        $this->checkFile('themes/affiliates/Bootstrap/channels_no_data.tpl', '0e1e8193a32385d8c980e2d4a2eff439');
        $this->checkFile('themes/affiliates/Bootstrap/channels_panel.tpl', '5cf41aa13455ddde2cc935f3d2e39672');
        $this->checkFile('themes/affiliates/Bootstrap/chart_datatype_popup.tpl', '7a1a0e024c8392ea5df8cd40b179d4f7');
        $this->checkFile('themes/affiliates/Bootstrap/check_box_group.tpl', 'e182dd7429a276dc85e09049b2a6c19e');
        $this->checkFile('themes/affiliates/Bootstrap/check_box_group_row.tpl', '97219c5c2d3c996953fd6bd882e6200c');
        $this->checkFile('themes/affiliates/Bootstrap/checkboxes_filter.tpl', 'fef5c1833920987bd3172dbe9d75797a');
        $this->checkFile('themes/affiliates/Bootstrap/clicks_list.tpl', 'b1ee1d4fbc2e98ea4e7fc240527a6d46');
        $this->checkFile('themes/affiliates/Bootstrap/clicks_list_filter_base.tpl', 'fb7bfe0b49eb4671b5f8fdcc3fbb54b0');
        $this->checkFile('themes/affiliates/Bootstrap/colorpicker.tpl', '297c4e74e89b8b3dedd12e7c319bce41');
        $this->checkFile('themes/affiliates/Bootstrap/commission_details.tpl', 'c274d41cf9e0a2cfe28d66c36edb40a5');
        $this->checkFile('themes/affiliates/Bootstrap/commissions_no_data.tpl', 'fcd3503c324d1988af6df1c864bfdd80');
        $this->checkFile('themes/affiliates/Bootstrap/confirm_dialog.tpl', 'f92a8f6b3081444abf7fc4ab63c99302');
        $this->checkFile('themes/affiliates/Bootstrap/confirm_dialog_with_value.tpl', '46e7630a0a094110f6819ea655683337');
        $this->checkFile('themes/affiliates/Bootstrap/contact_us.tpl', 'ab01f72bb71446f679190833bdc7b003');
        $this->checkFile('themes/affiliates/Bootstrap/content_gadget_panel.tpl', '79428f6a77f38592dfa1716653bbe79b');
        $this->checkFile('themes/affiliates/Bootstrap/context_menu.tpl', 'cddf235a2fec1ae75063d576ccdc6185');
        $this->checkFile('themes/affiliates/Bootstrap/copy_user_role.tpl', '67725ef54593ecb567ed04a3935faecb');
        $this->checkFile('themes/affiliates/Bootstrap/countries_list_scrolling_wrapper.tpl', '4bf0a92924334c72075b4ddafd3b243b');
        $this->checkFile('themes/affiliates/Bootstrap/coupon.tpl', '7603de7353751cc37e762400f6dc1734');
        $this->checkFile('themes/affiliates/Bootstrap/coupon_codes.tpl', 'a324bcc28deef842f75b6d3b4803dc6e');
        $this->checkFile('themes/affiliates/Bootstrap/coupon_html_code.tpl', '4b85f57df88ff11ee43192e348076b42');
        $this->checkFile('themes/affiliates/Bootstrap/coupon_previews.tpl', '3c5988cdbef06b3ae23b1de600ebf2b0');
        $this->checkFile('themes/affiliates/Bootstrap/coupon_view.tpl', '1d6323a8ae51b2f146792372ec16f690');
        $this->checkFile('themes/affiliates/Bootstrap/coupons_no_data.tpl', 'c8bcc725598c714ca764a2196f380d9d');
        $this->checkFile('themes/affiliates/Bootstrap/currency_textbox.tpl', '859fd8293b92897b3be4c9a6c4aa3a8f');
        $this->checkFile('themes/affiliates/Bootstrap/custom/advanced_tracking.tpl', 'a59f52de667fc173c0266306f5062827');
        $this->checkFile('themes/affiliates/Bootstrap/custom/directlink_explained.tpl', '6f3915445547afa953c203b68c4fa2e5');
        $this->checkFile('themes/affiliates/Bootstrap/custom/frequently_asked_questions.tpl', '835b2045c86a1b65a5202f271947904e');
        $this->checkFile('themes/affiliates/Bootstrap/custom/getting_started.tpl', '8b2b7649d029c6bfe0706fcd053cdf2b');
        $this->checkFile('themes/affiliates/Bootstrap/custom/promotion_tips.tpl', '4e39eb13d5fefdb3a8db63fbbd5e2d00');
        $this->checkFile('themes/affiliates/Bootstrap/custom.css', '4877ef2467745239a93ebe1e79b2f813');
        $this->checkFile('themes/affiliates/Bootstrap/custom_date_panel.tpl', 'c624f3d63d0e94db867529dc13a827d1');
        $this->checkFile('themes/affiliates/Bootstrap/custom_filter_element.tpl', 'bf05e5d299fb1982ea8139f2a605846b');
        $this->checkFile('themes/affiliates/Bootstrap/custom_filter_field.tpl', '21c8ab135d5d89e320ec85456ec457e0');
        $this->checkFile('themes/affiliates/Bootstrap/custom_license_invalid.tpl', '9157ecde6accdbe2f6cd622084e79d53');
        $this->checkFile('themes/affiliates/Bootstrap/custom_time_panel.tpl', 'd408a8352774d70124788d61a90493b6');
        $this->checkFile('themes/affiliates/Bootstrap/daily_report.tpl', '696092e06570b6eebad4c345d98c5ca9');
        $this->checkFile('themes/affiliates/Bootstrap/daily_report_filter.tpl', 'cdd6b5b0f3f67e1c68221170d4075b5c');
        $this->checkFile('themes/affiliates/Bootstrap/data_field.tpl', 'dd553594505158cd53cc285d3a91fe23');
        $this->checkFile('themes/affiliates/Bootstrap/data_field_with_help.tpl', '4615cdd789beea34c16b4c1f692a3a3b');
        $this->checkFile('themes/affiliates/Bootstrap/date_number_format_panel.tpl', 'e26284328d2ba7da47d30e8e458c13b1');
        $this->checkFile('themes/affiliates/Bootstrap/date_preset_panel.tpl', 'abc7d225baa948aed70cc1073b786fe8');
        $this->checkFile('themes/affiliates/Bootstrap/date_range_filter.tpl', '3875dbc075f33ccaac856190ee103557');
        $this->checkFile('themes/affiliates/Bootstrap/date_range_filter_field.tpl', '94048704212b6797b7b7a08fb7888da9');
        $this->checkFile('themes/affiliates/Bootstrap/date_textbox.tpl', '4d2bf89bd754bbaccc15e48d7a37dd02');
        $this->checkFile('themes/affiliates/Bootstrap/daterange_popup.tpl', 'dc1728d13b0440b8df5e12359010168a');
        $this->checkFile('themes/affiliates/Bootstrap/datetimepickercontent.tpl', '9771684f29bc88d974cc64283055d1d1');
        $this->checkFile('themes/affiliates/Bootstrap/desktop.tpl', 'b653025800e416896bd453246061a535');
        $this->checkFile('themes/affiliates/Bootstrap/desktop_gadget.tpl', '21394ff13337e4716860c12b5e4fb312');
        $this->checkFile('themes/affiliates/Bootstrap/desktop_main_menu.tpl', '31eb02f3f6b767d24012753d50ff5159');
        $this->checkFile('themes/affiliates/Bootstrap/desktop_settings_mode.tpl', '1054d3be606383580f8d521f2d72682f');
        $this->checkFile('themes/affiliates/Bootstrap/direct_link_form.tpl', '48d9f1ab56c63c05304185fbc8163922');
        $this->checkFile('themes/affiliates/Bootstrap/direct_link_grid_widget.tpl', '586c3b902d66c903d87e510bca5843ec');
        $this->checkFile('themes/affiliates/Bootstrap/direct_linking_panel.tpl', 'd96cd58bb0f0537f8404f641367e0801');
        $this->checkFile('themes/affiliates/Bootstrap/direct_links_screen.tpl', 'ec5317f983964f7c42f2a4a8a28c5e3b');
        $this->checkFile('themes/affiliates/Bootstrap/download_login_form.tpl', 'ccf5bf5eab2bc42572c4538224cbef4e');
        $this->checkFile('themes/affiliates/Bootstrap/download_signup_form.tpl', '9dff3be2354fc10a70cc1b98b2f08434');
        $this->checkFile('themes/affiliates/Bootstrap/drag_container.tpl', '358104feb6f9c3c2a01206e460726eac');
        $this->checkFile('themes/affiliates/Bootstrap/dynamic_form_panel.tpl', 'ea42da62b4a44f1fa9caf50a59c29160');
        $this->checkFile('themes/affiliates/Bootstrap/dynamic_link_panel.tpl', '33245e1f6d416f28a8555078142abfe4');
        $this->checkFile('themes/affiliates/Bootstrap/edit_textarea_widget.tpl', '94b2c94dd103b5209bd89470fc70268c');
        $this->checkFile('themes/affiliates/Bootstrap/edit_tracking_code_widget.tpl', '5f25a27d5086317f495922f67ad88e33');
        $this->checkFile('themes/affiliates/Bootstrap/editor.tpl', 'a8c5483c720526b56fa899a91045c287');
        $this->checkFile('themes/affiliates/Bootstrap/editor_with_constants_panel.tpl', '6c9e8d91f33bc90c661e9b67ca5ff1e1');
        $this->checkFile('themes/affiliates/Bootstrap/email_form.tpl', '7809f19dc7e837c8dbe6f4d58e6574b7');
        $this->checkFile('themes/affiliates/Bootstrap/email_notifications.tpl', '8153cb771f309301f07a29ebec237250');
        $this->checkFile('themes/affiliates/Bootstrap/email_setting_smtp_form.tpl', 'd17124a143f842ab1876ed14a74bc762');
        $this->checkFile('themes/affiliates/Bootstrap/email_settings_spf.tpl', 'ca349c37b841ccef522f8767817bf1d2');
        $this->checkFile('themes/affiliates/Bootstrap/email_settings_tab.tpl', '8fef8cf6eacfffe581527d391ffb97da');
        $this->checkFile('themes/affiliates/Bootstrap/email_template_edit_panel.tpl', '2a432b9530ad4375605916e152dd8b60');
        $this->checkFile('themes/affiliates/Bootstrap/expired_session_dialog.tpl', 'ba711bd5d1e932ffc4fbc8e601204905');
        $this->checkFile('themes/affiliates/Bootstrap/export_to_csv.tpl', 'cdbd08521a7f231bbf4f0181cb0d807f');
        $this->checkFile('themes/affiliates/Bootstrap/extendable_commission_data.tpl', '43b5108a8212bccdb414370023388e10');
        $this->checkFile('themes/affiliates/Bootstrap/extendable_text.tpl', 'a69efdb298a3aae26e26793c9b9fea36');
        $this->checkFile('themes/affiliates/Bootstrap/extendable_text_content.tpl', 'cca4ebdf72f3cb7638b6c5bf0f59d9aa');
        $this->checkFile('themes/affiliates/Bootstrap/extendable_text_widget.tpl', '83288dfd8795a2a9105965dde2ebc927');
        $this->checkFile('themes/affiliates/Bootstrap/field_type_edit.tpl', 'b1294ba5d4486ea1cf8022a51e277a11');
        $this->checkFile('themes/affiliates/Bootstrap/file_widget.tpl', 'a7410b3e376c1b177c47831f83a68c55');
        $this->checkFile('themes/affiliates/Bootstrap/filter.tpl', '10de4692c8015c544a44267942cf4017');
        $this->checkFile('themes/affiliates/Bootstrap/filter_field_decorator.tpl', '531d57478d7718e216ea04ff79d493ca');
        $this->checkFile('themes/affiliates/Bootstrap/filter_form.tpl', '67551720cbc190c8df85c24d3f8a4cbe');
        $this->checkFile('themes/affiliates/Bootstrap/financial_overview.tpl', '8a82f2f60d7ad6eeeda3e4a4122ac3c8');
        $this->checkFile('themes/affiliates/Bootstrap/font/Raleway/raleway-bold.eot', '1ec4e6139616fedc458857908716aec3');
        $this->checkFile('themes/affiliates/Bootstrap/font/Raleway/raleway-bold.svg', 'f6f5ff6f96997ac8988c1ab7d07e5b5c');
        $this->checkFile('themes/affiliates/Bootstrap/font/Raleway/raleway-bold.ttf', '7fc4d9e141a4e29e8499c833792a487b');
        $this->checkFile('themes/affiliates/Bootstrap/font/Raleway/raleway-bold.woff', '8548037bd586a43acab45a89220232a7');
        $this->checkFile('themes/affiliates/Bootstrap/font/Raleway/raleway-extrabold.eot', 'eb0c8c8d7568b233c238891c6e0970b1');
        $this->checkFile('themes/affiliates/Bootstrap/font/Raleway/raleway-extrabold.svg', '9f495e26e94739143f7e55334ba0e5de');
        $this->checkFile('themes/affiliates/Bootstrap/font/Raleway/raleway-extrabold.ttf', '9d2454489d5dc43104f5b6aaeeb74d8c');
        $this->checkFile('themes/affiliates/Bootstrap/font/Raleway/raleway-extrabold.woff', '9025b71b1b7f1bdf84ac4593ab2633bd');
        $this->checkFile('themes/affiliates/Bootstrap/font/Raleway/raleway-extralight.eot', 'ae96d5c702c0507eef98fc8216c1cf68');
        $this->checkFile('themes/affiliates/Bootstrap/font/Raleway/raleway-extralight.svg', '7c9c0060950532d8b1f829deacd5761e');
        $this->checkFile('themes/affiliates/Bootstrap/font/Raleway/raleway-extralight.ttf', 'dbf00de8af7cabb8d6a24d5a6c1376f1');
        $this->checkFile('themes/affiliates/Bootstrap/font/Raleway/raleway-extralight.woff', 'cec3113c150ebaccfadd249d6a6c6fe3');
        $this->checkFile('themes/affiliates/Bootstrap/font/Raleway/raleway-heavy.eot', '17ce555c013828ebcceee5d602eb1abd');
        $this->checkFile('themes/affiliates/Bootstrap/font/Raleway/raleway-heavy.svg', '14aff14eda470731bc576352fb405243');
        $this->checkFile('themes/affiliates/Bootstrap/font/Raleway/raleway-heavy.ttf', 'e9e0cd13fac726479aa0c6ec85dad4b0');
        $this->checkFile('themes/affiliates/Bootstrap/font/Raleway/raleway-heavy.woff', 'ebc9ec7d8bfd11a5e181d4d0eb5ae655');
        $this->checkFile('themes/affiliates/Bootstrap/font/Raleway/raleway-light.eot', '0f861fc85ca8480122fdee73a3bc9b34');
        $this->checkFile('themes/affiliates/Bootstrap/font/Raleway/raleway-light.svg', '72fa36880542bb3ee2ef61d6e7762722');
        $this->checkFile('themes/affiliates/Bootstrap/font/Raleway/raleway-light.ttf', '5013a32d49ea3e3b7179cdebcf04c8ee');
        $this->checkFile('themes/affiliates/Bootstrap/font/Raleway/raleway-light.woff', 'e0621c851c98d15e3d225b58e60b1df3');
        $this->checkFile('themes/affiliates/Bootstrap/font/Raleway/raleway-medium.eot', 'cb960b7985a829ff8f35f27917c37c16');
        $this->checkFile('themes/affiliates/Bootstrap/font/Raleway/raleway-medium.svg', 'b722d214aef535acbc677cb184bacf4e');
        $this->checkFile('themes/affiliates/Bootstrap/font/Raleway/raleway-medium.ttf', 'a450c35bf2fb797c59521976c251816a');
        $this->checkFile('themes/affiliates/Bootstrap/font/Raleway/raleway-medium.woff', '345ce78497f8fd8cc6ca3e5f87fae51b');
        $this->checkFile('themes/affiliates/Bootstrap/font/Raleway/raleway-regular.eot', 'd003da0078843bef358483adaf001e6e');
        $this->checkFile('themes/affiliates/Bootstrap/font/Raleway/raleway-regular.svg', 'bf475ebe4f6bfb8aa9739489914d85b0');
        $this->checkFile('themes/affiliates/Bootstrap/font/Raleway/raleway-regular.ttf', '044df6936074fbef1e2a0bb83f9be9ed');
        $this->checkFile('themes/affiliates/Bootstrap/font/Raleway/raleway-regular.woff', 'e2a42f14d410966808fa3e1a6c6610ed');
        $this->checkFile('themes/affiliates/Bootstrap/font/Raleway/raleway-semibold.eot', '996ba4ecf6030f166bfd2865ba2007c2');
        $this->checkFile('themes/affiliates/Bootstrap/font/Raleway/raleway-semibold.svg', '2bd749decf7db7f3f41d7ce14bd2bf91');
        $this->checkFile('themes/affiliates/Bootstrap/font/Raleway/raleway-semibold.ttf', '4601b5909c48d8741187ef047135d5a5');
        $this->checkFile('themes/affiliates/Bootstrap/font/Raleway/raleway-semibold.woff', 'ca59bf4cefe8b05a5c874bfdf6a2de0f');
        $this->checkFile('themes/affiliates/Bootstrap/font/Raleway/raleway-thin.eot', '0da2e90cf6205e3fa6adc3d2378c474f');
        $this->checkFile('themes/affiliates/Bootstrap/font/Raleway/raleway-thin.svg', '36e5002be7798795643b0ba1cc659a58');
        $this->checkFile('themes/affiliates/Bootstrap/font/Raleway/raleway-thin.ttf', '196e4d4ee33ca51eb5c1bcee792e2842');
        $this->checkFile('themes/affiliates/Bootstrap/font/Raleway/raleway-thin.woff', '853cc2d80ab72d6a0ac1f8ecbc5f50c6');
        $this->checkFile('themes/affiliates/Bootstrap/font/fontello.eot', 'b2012373de53bdcf186b789d03b1b651');
        $this->checkFile('themes/affiliates/Bootstrap/font/fontello.svg', '1045c4485908e58054e248bf90c4f758');
        $this->checkFile('themes/affiliates/Bootstrap/font/fontello.ttf', '8da4acbde1b1dbbaee498b2adcfd4bf7');
        $this->checkFile('themes/affiliates/Bootstrap/font/fontello.woff', 'f57a4db78bda8b28d724838c290ff166');
        $this->checkFile('themes/affiliates/Bootstrap/font/fontello.woff2', '067318fe80a3455f47aba86c12dde49d');
        $this->checkFile('themes/affiliates/Bootstrap/fontello.css', '7abe36cc2ed0ccbbaad467c15445aa12');
        $this->checkFile('themes/affiliates/Bootstrap/footer.stpl', 'cae74dd5cc67d8eb1a47e0bbeaf3fee4');
        $this->checkFile('themes/affiliates/Bootstrap/footer.tpl', 'acf430b8fece1dddd26ef7f7165a7044');
        $this->checkFile('themes/affiliates/Bootstrap/forgot_password.tpl', 'e31e8cf668201db153fb5783283dc75c');
        $this->checkFile('themes/affiliates/Bootstrap/form_field.tpl', '5c7ae4b0f01f4a7753ab811e0a57f29f');
        $this->checkFile('themes/affiliates/Bootstrap/form_field_checkbox.tpl', 'c1f1746d1bf5c7abfaf9e5ddb7b4cc52');
        $this->checkFile('themes/affiliates/Bootstrap/form_field_checkboxgroup.tpl', 'be1b525a89f033d4f79433dd3eaab593');
        $this->checkFile('themes/affiliates/Bootstrap/form_field_radio.tpl', '9013ed97a5fc7b4b52052d816a9b25d0');
        $this->checkFile('themes/affiliates/Bootstrap/frame_panel.tpl', '7b13a1add8ba712d8a34f4285414b419');
        $this->checkFile('themes/affiliates/Bootstrap/general_no_data.stpl', '03433ae7bf79c177a476922c2ee779c5');
        $this->checkFile('themes/affiliates/Bootstrap/gpf.css', 'ec27b549fa06e9420afb4e6d56ee3a96');
        $this->checkFile('themes/affiliates/Bootstrap/gpf_db_mail.tpl', 'b5ea5e9ecef2152fdf967085a7689adc');
        $this->checkFile('themes/affiliates/Bootstrap/grid.tpl', '1797f6072932e243275fbf0fe1382a6d');
        $this->checkFile('themes/affiliates/Bootstrap/grid_bottombuttons.tpl', '30a61eeb486bc2ce22368100d53fc392');
        $this->checkFile('themes/affiliates/Bootstrap/grid_bottomgridline.tpl', '9bf2013a170e094e82dc1ae0a2ed0f97');
        $this->checkFile('themes/affiliates/Bootstrap/grid_nodata.tpl', '340ff6de789cd7277a35d763f6366f24');
        $this->checkFile('themes/affiliates/Bootstrap/grid_pager.tpl', '46e6d959616563985ece2d92c0234826');
        $this->checkFile('themes/affiliates/Bootstrap/grid_selector.tpl', 'ff2d81e3866f53d540a0d063bdf7b480');
        $this->checkFile('themes/affiliates/Bootstrap/grid_topbuttons.tpl', '83a65b7b03d432beb47d16e78cdf8aee');
        $this->checkFile('themes/affiliates/Bootstrap/grid_topgridline.tpl', '3ff9c43cb7f7fcbbcdc7f03c8822a70d');
        $this->checkFile('themes/affiliates/Bootstrap/header.stpl', 'a1280de5b51c8c21c5c8169fa4075378');
        $this->checkFile('themes/affiliates/Bootstrap/header.tpl', '32d459ea9f7ebf7a241715058cc91f38');
        $this->checkFile('themes/affiliates/Bootstrap/home.tpl', 'd25d3eb83817cf220778e4ee39d1f887');
        $this->checkFile('themes/affiliates/Bootstrap/horizontal_layout_panel.tpl', '8b6098cd64720cff686cc24e06ac4c17');
        $this->checkFile('themes/affiliates/Bootstrap/html_window_preview.stpl', '02d9e7142f0e2fa88afa0b9af7d9f5fc');
        $this->checkFile('themes/affiliates/Bootstrap/icon_button.tpl', 'a7497a39fe733586fb4f5a1b9f424b0f');
        $this->checkFile('themes/affiliates/Bootstrap/icon_object.tpl', 'ff8d25e63eca03b325c4501e13358fb2');
        $this->checkFile('themes/affiliates/Bootstrap/icon_picker.tpl', '77a002b90f678df44bcca5776f314820');
        $this->checkFile('themes/affiliates/Bootstrap/icon_picker_panel.tpl', '4342c424a8cb290701f64d0cb63655ec');
        $this->checkFile('themes/affiliates/Bootstrap/icon_status_widget.tpl', 'ff9e2bc87e203324cc33c4b3ac365dfe');
        $this->checkFile('themes/affiliates/Bootstrap/image_uploader.tpl', '091439bdf235f35fb4c42d58b789f216');
        $this->checkFile('themes/affiliates/Bootstrap/img/favicon.ico', 'ac3e93c93589318e5dcf69efc8a76176');
        $this->checkFile('themes/affiliates/Bootstrap/img/icon-128.png', 'a450a0dd5959518fdb2308cc5e523bcc');
        $this->checkFile('themes/affiliates/Bootstrap/img/icon-192.png', '8cb72062e4df9eab6c2a064459a5ee62');
        $this->checkFile('themes/affiliates/Bootstrap/img/pan-logo.svg', 'a00e0890d1da3f81a0ddf2d27c111504');
        $this->checkFile('themes/affiliates/Bootstrap/img/pap-logo.svg', '5e82bd9eddbcd704a8b581b5c5037d54');
        $this->checkFile('themes/affiliates/Bootstrap/img/theme_thumbnail.jpg', '41d59ee47a95e22028a3f536ef7a1ed3');
        $this->checkFile('themes/affiliates/Bootstrap/import_custom_language_panel.tpl', '36fe179dc09cd1a1bf3561ef9d13a647');
        $this->checkFile('themes/affiliates/Bootstrap/import_language.tpl', 'c1df1cf60613d3df6e19681193ae41a9');
        $this->checkFile('themes/affiliates/Bootstrap/info_dialog.tpl', '886c377f8e8c1b2c6957451436e1d090');
        $this->checkFile('themes/affiliates/Bootstrap/ip_detail.tpl', '3723b4ce7dc6ccc4b8c8193f4c982d18');
        $this->checkFile('themes/affiliates/Bootstrap/item.tpl', '717eff0e06a712a76effb2d6723183b5');
        $this->checkFile('themes/affiliates/Bootstrap/item_panel.tpl', 'b24ed05bdf4cb76a7afc1e9a9908def8');
        $this->checkFile('themes/affiliates/Bootstrap/language_create_new.tpl', '1ae789af118ce84a76ec067e82d52aec');
        $this->checkFile('themes/affiliates/Bootstrap/language_edit_panel.tpl', '4b582c49c5aec0a72765e8764ba390b0');
        $this->checkFile('themes/affiliates/Bootstrap/language_translations_grid.tpl', 'b3d4b3ff7279bf9383886e84ba3218ab');
        $this->checkFile('themes/affiliates/Bootstrap/languages_configuration.tpl', '86f17a42cef0bedb165295e99c970582');
        $this->checkFile('themes/affiliates/Bootstrap/layout_panel_content.tpl', 'd49730d94578e00ed7395eaa1d2a3df6');
        $this->checkFile('themes/affiliates/Bootstrap/layout_panel_header_navigation.tpl', '6b0d746501001da8615a22d57266dcb0');
        $this->checkFile('themes/affiliates/Bootstrap/layout_panel_tab.tpl', '316df333cac9b455c7dc04100c2e2d1d');
        $this->checkFile('themes/affiliates/Bootstrap/license_invalid.tpl', '6181e1127345050c94d6708cd805aefb');
        $this->checkFile('themes/affiliates/Bootstrap/link_button.tpl', '71fad92bff79f1fd2e1066818afac789');
        $this->checkFile('themes/affiliates/Bootstrap/listbox.tpl', '2739c2a9e22d54280cacf4d67ed2e7bc');
        $this->checkFile('themes/affiliates/Bootstrap/listbox_popup.tpl', '8c45877411c0727e814eb5e3caa76822');
        $this->checkFile('themes/affiliates/Bootstrap/listdown_button.tpl', 'a1cd26a1aec6d403420971d7469a6f1b');
        $this->checkFile('themes/affiliates/Bootstrap/load_mail_from_template.tpl', '42c0029422eaf077a5b0c316cd3317b5');
        $this->checkFile('themes/affiliates/Bootstrap/loadable_tree.tpl', 'e2c214b134bffe5fe2bb38f679a64eb5');
        $this->checkFile('themes/affiliates/Bootstrap/loading_screen.tpl', '45d70765ad380ad3f0df92c82de65792');
        $this->checkFile('themes/affiliates/Bootstrap/login.tpl', 'e7be8367104ee7221547730250f9b0f0');
        $this->checkFile('themes/affiliates/Bootstrap/login_form.tpl', '297656a8cfb59277903ed38dfaa9e2f1');
        $this->checkFile('themes/affiliates/Bootstrap/login_form_downloadable.tpl', '6f2b17262524a8c12cfdcd572ad36bf9');
        $this->checkFile('themes/affiliates/Bootstrap/login_main.tpl', '0cd828d3f67418d0795faf78316d9aaf');
        $this->checkFile('themes/affiliates/Bootstrap/logins_history.tpl', '740e9d7a1b893fe3280b782958742998');
        $this->checkFile('themes/affiliates/Bootstrap/loginshistory_filter.tpl', '64804e791ea2ca4fcc7e01d7a8443479');
        $this->checkFile('themes/affiliates/Bootstrap/logs_no_data.tpl', 'c807c1484862c46a3f72f1ea0d276b3f');
        $this->checkFile('themes/affiliates/Bootstrap/mail_detail_data.tpl', 'cb8867c95ce35d7ad35b82f5c663ae42');
        $this->checkFile('themes/affiliates/Bootstrap/mail_outbox_panel.tpl', 'eda83d3c7fed41f0449b2464e96df945');
        $this->checkFile('themes/affiliates/Bootstrap/mailoutbox_filter.tpl', '8fd6e8ae35323bbc8debd1c248142e61');
        $this->checkFile('themes/affiliates/Bootstrap/mailoutbox_list_no_data.tpl', '12637515858ca4d960c6202e8a89042b');
        $this->checkFile('themes/affiliates/Bootstrap/main.tpl', '5461cc6e184ba38a56ac7d5c0da6e4b2');
        $this->checkFile('themes/affiliates/Bootstrap/main_aff_html_doc.stpl', '786f39429ba9b054704bae3a500f60c2');
        $this->checkFile('themes/affiliates/Bootstrap/main_error_html_doc.tpl', 'cc7808f71ce49f9004d1c4f03966375c');
        $this->checkFile('themes/affiliates/Bootstrap/main_filter_panel.tpl', '0985a7421f898d75d4df72b4a6081c49');
        $this->checkFile('themes/affiliates/Bootstrap/main_header.tpl', '5b01f94a773845f032b3f39078104c1f');
        $this->checkFile('themes/affiliates/Bootstrap/main_menu.tpl', '5fddab52f7b44bcb5717c1d67875f567');
        $this->checkFile('themes/affiliates/Bootstrap/map_overlay.tpl', 'd12618268f18867d1f8ef84d12c8ba32');
        $this->checkFile('themes/affiliates/Bootstrap/map_overlay_advanced_filter.tpl', 'cf259a9627f69eb5f1a05e5a9b9fe7bd');
        $this->checkFile('themes/affiliates/Bootstrap/menu_entry.tpl', '9245aaaa5732793ce089f5fe25d703ea');
        $this->checkFile('themes/affiliates/Bootstrap/menu_section.tpl', 'ce9552c9579aa842bfd16e9c61b1cd0e');
        $this->checkFile('themes/affiliates/Bootstrap/messages.tpl', 'bf1a3bac08c419320acb94673ad29f0b');
        $this->checkFile('themes/affiliates/Bootstrap/module_body.stpl', 'c079addcd33eb725ab7efbf09c16a793');
        $this->checkFile('themes/affiliates/Bootstrap/multi_editor.tpl', '3ee5baa5bdb7824c0c2ae6f2dc275830');
        $this->checkFile('themes/affiliates/Bootstrap/multiselect.tpl', '9d1863b21edd131520315ce252fde639');
        $this->checkFile('themes/affiliates/Bootstrap/myprofile.tpl', 'bc9c2c67e2fac95d707b8508da3bfca6');
        $this->checkFile('themes/affiliates/Bootstrap/news_content.tpl', 'a576598444bb0db20fa8d47854f1ef34');
        $this->checkFile('themes/affiliates/Bootstrap/news_item.tpl', '18161a56a8f4dc5df01f08191709f864');
        $this->checkFile('themes/affiliates/Bootstrap/newsletter_broadcast_form.tpl', '1ccb4e8c2a3873263c7c8c1fc7c19f27');
        $this->checkFile('themes/affiliates/Bootstrap/newsletter_broadcasts.tpl', 'e85ba6dc04b3a921af601f6bf976a5b8');
        $this->checkFile('themes/affiliates/Bootstrap/newsletter_edit_panel.tpl', '73ddca2129beb12e11215b1c55e70461');
        $this->checkFile('themes/affiliates/Bootstrap/newsletter_form.tpl', 'e86bb366b8986ac4cb1b50c9ccc94b8e');
        $this->checkFile('themes/affiliates/Bootstrap/no_content_gadgets.tpl', '1d4ce600d473f33e2b229101a50cbc3f');
        $this->checkFile('themes/affiliates/Bootstrap/no_language_selected.tpl', 'd61125f2b1cf78e4e66653d4e2f04bdd');
        $this->checkFile('themes/affiliates/Bootstrap/notification_window.tpl', 'db781872bdb9748bc838e051b8e5e4e2');
        $this->checkFile('themes/affiliates/Bootstrap/online_users.tpl', 'e78ff82eb18c092018cd48d90ae48863');
        $this->checkFile('themes/affiliates/Bootstrap/online_users_gadget_rolecount.tpl', '5fd6af0c5f2edec24d0e35dc00a9e870');
        $this->checkFile('themes/affiliates/Bootstrap/onlinegadgets_no_data.tpl', 'f5f692a433b4911963a92c41cc269768');
        $this->checkFile('themes/affiliates/Bootstrap/onlineusers_filter.tpl', '7a0572e8ae3375f2c79c8fe985295bd6');
        $this->checkFile('themes/affiliates/Bootstrap/order_id_filter.tpl', '103e1ce5be4c9d2f1cc161390371e222');
        $this->checkFile('themes/affiliates/Bootstrap/page_header.tpl', '4fd5676c44341f95ee0435c1f78da534');
        $this->checkFile('themes/affiliates/Bootstrap/panel_footer.stpl', '2ecfae35d4c9436786fd4b2c26747242');
        $this->checkFile('themes/affiliates/Bootstrap/panel_with_icons.tpl', 'cdc3dafa07941a7c6c1ec5c4297528d6');
        $this->checkFile('themes/affiliates/Bootstrap/pap4.css', 'cbb2af047e0ed5d588ee02f4fdd407d0');
        $this->checkFile('themes/affiliates/Bootstrap/pap4.rtl.css', '06e6095bc125be3d8350bd21633f5771');
        $this->checkFile('themes/affiliates/Bootstrap/password_constraint_panel.tpl', '71b23765c240aff0073e713cfc4da992');
        $this->checkFile('themes/affiliates/Bootstrap/password_panel.tpl', 'b1440553a785aae589233a91315b281f');
        $this->checkFile('themes/affiliates/Bootstrap/payment_details_panel.tpl', 'a3e9de7c3f7f02631e17f2ddfd47c1a6');
        $this->checkFile('themes/affiliates/Bootstrap/payout_data.tpl', '04fbc30b334480035464925430c1b84c');
        $this->checkFile('themes/affiliates/Bootstrap/payout_fields_panel.tpl', 'a0574ca1f8ca180f8bb347a75856b6c5');
        $this->checkFile('themes/affiliates/Bootstrap/payouts_no_data.tpl', '679aa0a26f28531b3303c5ad09c962fc');
        $this->checkFile('themes/affiliates/Bootstrap/payouts_to_affiliates.tpl', '48147fc1ef03936a6eed55f580ec7721');
        $this->checkFile('themes/affiliates/Bootstrap/pending_backround_tasks.tpl', '75149233f7ae446473c9220c9ff1ef8f');
        $this->checkFile('themes/affiliates/Bootstrap/period_stats.stpl', 'fa4c74d62a92931f3e0973537c987b56');
        $this->checkFile('themes/affiliates/Bootstrap/personal_details.tpl', '68d8be3219269a1feddaf77b02e8333f');
        $this->checkFile('themes/affiliates/Bootstrap/popup_form_widget.tpl', '0f5d2ef3d678d026df06fe1f1e5991a8');
        $this->checkFile('themes/affiliates/Bootstrap/promotools_screen.tpl', 'd00db589b34cfb6468a9eab3d94303f8');
        $this->checkFile('themes/affiliates/Bootstrap/proxy_server_configuration.tpl', '732a20cf9c1d59496e88d9bd5b080484');
        $this->checkFile('themes/affiliates/Bootstrap/quick_report_base.tpl', '03394fc9a529f4d9d13f8cbcb664be8f');
        $this->checkFile('themes/affiliates/Bootstrap/quick_report_content.stpl', 'a75ca3ba3fc385de73eae7311f79c650');
        $this->checkFile('themes/affiliates/Bootstrap/quick_report_content_multitier.stpl', 'e45556a573992274576437d9d34bdd71');
        $this->checkFile('themes/affiliates/Bootstrap/quick_report_filter_base.tpl', '5998ae63fc0257404ef11638ca30eb95');
        $this->checkFile('themes/affiliates/Bootstrap/quick_report_multitier_widget.tpl', '2f19acbcc8ca3270ba3b1d16b6253c1d');
        $this->checkFile('themes/affiliates/Bootstrap/quick_stats.tpl', 'eb812b06f6292efc64d3aa411c1f8cc0');
        $this->checkFile('themes/affiliates/Bootstrap/quick_stats_box.tpl', '745d64595b8a0e5869bfc1e9bf10b9c2');
        $this->checkFile('themes/affiliates/Bootstrap/radio_button_group_row.tpl', '3713f6d400aa1ca96d9e404082304912');
        $this->checkFile('themes/affiliates/Bootstrap/rawclicks_no_data.tpl', '4377ca4cc0e45e3ee4676ec94def1e0a');
        $this->checkFile('themes/affiliates/Bootstrap/recipients.tpl', 'cae0cd53d947d39c2ad761f6f29b2d65');
        $this->checkFile('themes/affiliates/Bootstrap/referringurl_advanced_filter.tpl', 'f1479abbb38dc35d909f4a3c8c961a94');
        $this->checkFile('themes/affiliates/Bootstrap/refresh_panel.tpl', '5c709df4d219d5feb4f29003ca932f77');
        $this->checkFile('themes/affiliates/Bootstrap/regional_settings.tpl', '7fd67a6e2e8b44c62dc36ce4812b7189');
        $this->checkFile('themes/affiliates/Bootstrap/regional_settings_tab.tpl', '82a573fa67deb883c207f05c019f7eeb');
        $this->checkFile('themes/affiliates/Bootstrap/report_filter.tpl', 'cfa31cd337c81b3e863f97b664581327');
        $this->checkFile('themes/affiliates/Bootstrap/reports_screen.tpl', 'c49a73add81baccd69c14ee5ff38b904');
        $this->checkFile('themes/affiliates/Bootstrap/request_new_password_form.tpl', 'e4e20e8042328f80b7b400e39d921986');
        $this->checkFile('themes/affiliates/Bootstrap/resizable_text_area.tpl', '7995c217048ccd289dfee567a455b08e');
        $this->checkFile('themes/affiliates/Bootstrap/richlistbox.tpl', '13229a43763945932dc8d5d7fa21d08e');
        $this->checkFile('themes/affiliates/Bootstrap/richlistbox_popup.tpl', 'c155c59eea77770589bcadca0c75f1af');
        $this->checkFile('themes/affiliates/Bootstrap/richtext_editor.tpl', '99af0e75e8761690e55e65fa238d8d4c');
        $this->checkFile('themes/affiliates/Bootstrap/richtext_editor_toolbar.tpl', '3798b9151ed1d87c99e5783005c81773');
        $this->checkFile('themes/affiliates/Bootstrap/richtexteditor_addlink.tpl', 'c9bd3a510535abef1076a29328f069e7');
        $this->checkFile('themes/affiliates/Bootstrap/role_privileges.tpl', '9163270235450787bb9ebf86df5b2f69');
        $this->checkFile('themes/affiliates/Bootstrap/rotator_preview_affiliate.stpl', 'b9766c5bec13353b6b35944db1a983e0');
        $this->checkFile('themes/affiliates/Bootstrap/search_filter.tpl', 'c43c492cae5282a628238b4ff75508b2');
        $this->checkFile('themes/affiliates/Bootstrap/selectbutton_search.tpl', 'dedb23ce356b1b66377e648232dc2b8b');
        $this->checkFile('themes/affiliates/Bootstrap/send_to_friend.tpl', 'e7b902ca2beb79a6dab513cebf161a87');
        $this->checkFile('themes/affiliates/Bootstrap/set_new_password_form.tpl', '9270391a0892b67b03efbd67084806c6');
        $this->checkFile('themes/affiliates/Bootstrap/sidebar.tpl', '65226d7e25dcdca0cf71a9f3118d8139');
        $this->checkFile('themes/affiliates/Bootstrap/sidebar_closed.tpl', '3d903661713a9ee5fb402776ee06d310');
        $this->checkFile('themes/affiliates/Bootstrap/sidebar_gadget.tpl', '1f904859e056808c8826836a4e256761');
        $this->checkFile('themes/affiliates/Bootstrap/signup_fields.tpl', '16c26f808a27c220930859db1a454042');
        $this->checkFile('themes/affiliates/Bootstrap/signup_form.tpl', 'a55f02ab4d649b4eb23fbd252e3555fb');
        $this->checkFile('themes/affiliates/Bootstrap/signup_subaffiliates.tpl', '37eb3bcb00f8bbbc2f3b6c793c0b5a4d');
        $this->checkFile('themes/affiliates/Bootstrap/simple_filter.tpl', 'a55a1095bcbdbef9d9d9f5e2078b19a2');
        $this->checkFile('themes/affiliates/Bootstrap/simple_icon_object.tpl', 'bcbc9ea994d4aa8bbdee1eddc3ad19d8');
        $this->checkFile('themes/affiliates/Bootstrap/simple_popup_window.tpl', 'e7d6ad58d85a85eab20414bb734b8c81');
        $this->checkFile('themes/affiliates/Bootstrap/simplecolorpicker.tpl', '9c031fbdd2b35909faeea73e5f1203a1');
        $this->checkFile('themes/affiliates/Bootstrap/single_content_panel.tpl', '529d4a42f9106d91881f8b8b8e87748b');
        $this->checkFile('themes/affiliates/Bootstrap/size_format_widget.tpl', 'ebfb7db6718ec601af59a570d8e0ccb3');
        $this->checkFile('themes/affiliates/Bootstrap/start_button.tpl', '7aa2278c46b897536625cc042b4f5499');
        $this->checkFile('themes/affiliates/Bootstrap/statistics_double_value_widget.tpl', '7e243a39277ad97843b418e45881a6d2');
        $this->checkFile('themes/affiliates/Bootstrap/stats_chart.tpl', 'b5bb3d9a0dd5361a4e34e479aacf2480');
        $this->checkFile('themes/affiliates/Bootstrap/sub_aff_tree.tpl', '679faa77de04d865fc22b6c25fd48275');
        $this->checkFile('themes/affiliates/Bootstrap/sub_menu_section.tpl', 'ab7871c677c0d90bb2d878548157b628');
        $this->checkFile('themes/affiliates/Bootstrap/subaff_stats_no_data.tpl', 'f81af900ac8f9c419e2b3cf9742a1d69');
        $this->checkFile('themes/affiliates/Bootstrap/subaffiliate_sales_panel.tpl', '74f82f4ed0910799758338dbfc8630bc');
        $this->checkFile('themes/affiliates/Bootstrap/subaffiliates_filter.tpl', 'd929d7710df12abd81cff41504a91c08');
        $this->checkFile('themes/affiliates/Bootstrap/subaffiliates_panel.tpl', '471e8e9ee69c9cb55ec9e0bd689be941');
        $this->checkFile('themes/affiliates/Bootstrap/subaffiliates_sales_filter.tpl', '9f9fd28d6f934e3937e6551e0cfbf7fb');
        $this->checkFile('themes/affiliates/Bootstrap/subaffiliates_tree_panel.tpl', 'bd640ce415c67d2170ee88da05712f7b');
        $this->checkFile('themes/affiliates/Bootstrap/subaffstats_filter.tpl', 'd0d0b51a10872fa37758a642237c5abd');
        $this->checkFile('themes/affiliates/Bootstrap/subaffstats_list.tpl', '43e8f570edf8311ab5963d04432b98a7');
        $this->checkFile('themes/affiliates/Bootstrap/subid_tracking_screen.tpl', '1407cbdf136a2197520287e9c3bec51e');
        $this->checkFile('themes/affiliates/Bootstrap/system_menu.tpl', '4ccb9c521f5df4b69deb61125efa7008');
        $this->checkFile('themes/affiliates/Bootstrap/tab_item.tpl', 'd869bc1a3b8c511712e039399333d129');
        $this->checkFile('themes/affiliates/Bootstrap/tab_panel.tpl', '8c2853c4e62119a5b6f89c5e340af5d3');
        $this->checkFile('themes/affiliates/Bootstrap/task.tpl', '38a4b70b6456a12285be4bb113c72575');
        $this->checkFile('themes/affiliates/Bootstrap/taskbar.tpl', 'd7cf8ef7a71bf324aee5c1c7173afc7e');
        $this->checkFile('themes/affiliates/Bootstrap/template_form.tpl', 'e47caf8cb37049be84a31c5c4f15ba49');
        $this->checkFile('themes/affiliates/Bootstrap/template_form_constants.tpl', '91c398393e519cf7c6a53ba758eefc47');
        $this->checkFile('themes/affiliates/Bootstrap/template_form_theme_entry.tpl', '91a40d5bfbb3ff3b61cd7771e24a2684');
        $this->checkFile('themes/affiliates/Bootstrap/template_form_themes.tpl', 'e7158c1782ef49ddbf3fbe671c5c5b8a');
        $this->checkFile('themes/affiliates/Bootstrap/template_form_variables.tpl', 'e1c008058f4be04a9e6e76ba72cc3290');
        $this->checkFile('themes/affiliates/Bootstrap/templates_form.tpl', '7a0a1baf13edabb10c8c6bef5a3dac41');
        $this->checkFile('themes/affiliates/Bootstrap/tests.tpl', '2e8601708f27cfadc9ee8a3454080aaf');
        $this->checkFile('themes/affiliates/Bootstrap/theme.php', '15b97fafa703d17061d636bbec86e163');
        $this->checkFile('themes/affiliates/Bootstrap/theme_panel.tpl', '7fea066d8d557fce572b77f00240cebc');
        $this->checkFile('themes/affiliates/Bootstrap/theme_settings.tpl', '5c596388ecc46c2ac89c029f811f565e');
        $this->checkFile('themes/affiliates/Bootstrap/tooltip_popup.tpl', 'e4a5b50c70875ee64d9fdf4f88fa8045');
        $this->checkFile('themes/affiliates/Bootstrap/topmenu_logged.stpl', '3309092595865ba40186a7d7c009226b');
        $this->checkFile('themes/affiliates/Bootstrap/topmenu_notlogged.stpl', 'fa06a5615600582c22cc5f57ee59ba94');
        $this->checkFile('themes/affiliates/Bootstrap/topurl_list.tpl', 'f108c2b8e2583a45a2016869735c87d3');
        $this->checkFile('themes/affiliates/Bootstrap/traffic_stats_gadget.tpl', '0a2882140e9f850399b2a0c198b9ad98');
        $this->checkFile('themes/affiliates/Bootstrap/traffic_stats_in_gadget.tpl', 'ae38670c7e593de4a995af34968842b1');
        $this->checkFile('themes/affiliates/Bootstrap/transaction_list.tpl', 'eb31bc8e7c91183f1520cf00d057d1cc');
        $this->checkFile('themes/affiliates/Bootstrap/transaction_list_filter_base.tpl', 'efb3de54e7fc05e3bd0581cb5dfd8c1c');
        $this->checkFile('themes/affiliates/Bootstrap/trash.tpl', '270d020eabfcf284be7a97e7102924d5');
        $this->checkFile('themes/affiliates/Bootstrap/tree_affiliate_widget.tpl', '0f7a52f0b26bda649f60e2a994645e98');
        $this->checkFile('themes/affiliates/Bootstrap/trend_actions_stats.tpl', '87efaeae069ec2872a33fe3e755a30e7');
        $this->checkFile('themes/affiliates/Bootstrap/trend_actions_stats_widget.tpl', '7c26676ceb09baf3fafeb0dba3bdaec4');
        $this->checkFile('themes/affiliates/Bootstrap/trend_stats.tpl', 'bd3333acced97fe829f3458bcd108bf8');
        $this->checkFile('themes/affiliates/Bootstrap/trends_report.stpl', '18264d58de48af1de2b77137b0df48fb');
        $this->checkFile('themes/affiliates/Bootstrap/trends_report.tpl', '078803b3f100dafeb1d773060290ff63');
        $this->checkFile('themes/affiliates/Bootstrap/trends_report_action.stpl', '929fa1c9535d05f1e8a0492013b9de33');
        $this->checkFile('themes/affiliates/Bootstrap/trends_report_filter.tpl', '18ce8dcf794b1fff579521fbadb505a7');
        $this->checkFile('themes/affiliates/Bootstrap/trends_report_no_data.tpl', '9d1dd7b6d3ef5f6ada42de2c7d182df2');
        $this->checkFile('themes/affiliates/Bootstrap/update_version.stpl', '5602f52fe8248df474201a16c922048f');
        $this->checkFile('themes/affiliates/Bootstrap/upload_panel.tpl', '222a0dd80ab37bb49060da0cf7eaf447');
        $this->checkFile('themes/affiliates/Bootstrap/uploaded_file.tpl', 'fad11b13e3b41eff41a129b1af232e7e');
        $this->checkFile('themes/affiliates/Bootstrap/user_edit.tpl', '241951fc4518a7104554d8490cc2a329');
        $this->checkFile('themes/affiliates/Bootstrap/validity.tpl', 'fbf29129f480c05f2f02e8d69bd1ccf9');
        $this->checkFile('themes/affiliates/Bootstrap/view_form.tpl', '923d4fc8de0546c10e788de580b3562b');
        $this->checkFile('themes/affiliates/Bootstrap/visits_sales_logs_no_data.tpl', '969b350cc45c6f7c68fa6322e98a3de1');
        $this->checkFile('themes/affiliates/Bootstrap/wallpaper_add_custom.tpl', '2210741b569ef188fa352c977a289261');
        $this->checkFile('themes/affiliates/Bootstrap/wallpaper_entry.tpl', '64c85f4da7897cd0f34168c62de661b9');
        $this->checkFile('themes/affiliates/Bootstrap/wallpaper_settings.tpl', 'd160dbed38556231aeac49a96213e4d4');
        $this->checkFile('themes/affiliates/Bootstrap/window.tpl', '2391705887d707e05187606c4a819e73');
        $this->checkFile('themes/affiliates/Bootstrap/window_bottom_left.tpl', 'd14b545c27afa02ab7a919bdeb4c9470');
        $this->checkFile('themes/affiliates/Bootstrap/window_empty_content.tpl', 'b1535ec719cada5b9f5d98849074b9bd');
        $this->checkFile('themes/affiliates/Bootstrap/window_header.tpl', '02a337d4184c3924a2792a84493794cc');
        $this->checkFile('themes/affiliates/Bootstrap/window_header_refresh.tpl', 'fcd47f4585abcac3c3a61ee3991379bc');
        $this->checkFile('themes/affiliates/Bootstrap/window_left.tpl', '9ac901446bfa26918e32fa029fb42093');
        $this->checkFile('themes/affiliates/Bootstrap/window_move_panel.tpl', 'f5bbd373a758bf76e6efadc94dca4b11');
        $this->checkFile('themes/affiliates/Bootstrap/wizard_panel.tpl', '3142ce6354cb3e1c86b6c13c1d906189');
        $this->checkFile('themes/affiliates/Compact/advanced_email_settings_form.tpl', '2a83754f5d407d1c031bf0259ae82b11');
        $this->checkFile('themes/affiliates/Compact/advanced_email_settings_tab.tpl', '4cdac3ab7ec6827e1307d48028f2d835');
        $this->checkFile('themes/affiliates/Compact/advanced_screen.tpl', '7a6fc49337838298197f0d2a4a49746b');
        $this->checkFile('themes/affiliates/Compact/aff_status_panel.tpl', 'f6c8ed375a26bfa2b3262189422c5a1c');
        $this->checkFile('themes/affiliates/Compact/aff_status_widget.tpl', '518ca3971863bd4c41412a286ebfdf75');
        $this->checkFile('themes/affiliates/Compact/affiliate_edit_details_additional.tpl', '98de15bb9a88b36dc47ba266389cb413');
        $this->checkFile('themes/affiliates/Compact/affiliate_manager.tpl', '71f61fa4905cf1b525e2c826f01b2f2f');
        $this->checkFile('themes/affiliates/Compact/affiliate_subaffiliates.tpl', '8c995322ed3cd841aae0928dd8e148fd');
        $this->checkFile('themes/affiliates/Compact/affiliate_theme_settings.tpl', '46f3d82a7762c6669d5014aa5be3d0b8');
        $this->checkFile('themes/affiliates/Compact/affiliate_tutorial_video.tpl', 'dcd2156f94a7bdc8fb75d594ed40a308');
        $this->checkFile('themes/affiliates/Compact/affiliate_urls_no_data.tpl', 'c9868414093445accf0f0d7551847116');
        $this->checkFile('themes/affiliates/Compact/afflink_protector_screen.tpl', '97da4ebc987ac62bbaf542a0e8ce5316');
        $this->checkFile('themes/affiliates/Compact/align_widget.tpl', '124769dbcc410ae58c1dfd53f15b58d6');
        $this->checkFile('themes/affiliates/Compact/api_integration.tpl', '665e24db154f4732b6c80158a8239309');
        $this->checkFile('themes/affiliates/Compact/available_values_edit.tpl', 'e96fa729b9a61e7e4a21fbddf80565fb');
        $this->checkFile('themes/affiliates/Compact/banner_category_item.tpl', '38ca8170d3d7b851fbc815cc63681df9');
        $this->checkFile('themes/affiliates/Compact/banner_code_widget.tpl', '91a021d77bd1ddb4f2f007809ad07902');
        $this->checkFile('themes/affiliates/Compact/banner_filter.tpl', 'ed6100072214442574d06b6aa1792976');
        $this->checkFile('themes/affiliates/Compact/banner_preview_promo.tpl', '96b67011b02cd4a04bd508a21d1a8bb4');
        $this->checkFile('themes/affiliates/Compact/banner_preview_textwidget.tpl', '690ff2bbd824bcd5c5bb52be01597520');
        $this->checkFile('themes/affiliates/Compact/banner_preview_widget.tpl', '9df335ee41605fbbc3a3fcdb239478ad');
        $this->checkFile('themes/affiliates/Compact/banner_stats_filter.tpl', '80805113ff9588315609acdd12f6a290');
        $this->checkFile('themes/affiliates/Compact/banner_stats_list.tpl', '3e71f3763376f08380959fe865aad875');
        $this->checkFile('themes/affiliates/Compact/banner_widget.tpl', 'c3ac45f49f8fdc43301943a701882c56');
        $this->checkFile('themes/affiliates/Compact/banner_widget_affiliate_pagepeel.tpl', '50cc893da765f31585fc3e36674d387f');
        $this->checkFile('themes/affiliates/Compact/banner_widget_code.tpl', '0fb2039eec50061e0b6401a239eeca1e');
        $this->checkFile('themes/affiliates/Compact/banner_widget_header.tpl', 'e1afa92c63ae3fdc28918ffe2e6f7555');
        $this->checkFile('themes/affiliates/Compact/banner_widget_stats.tpl', 'fe3b4c8e04d179d36b203d53010814da');
        $this->checkFile('themes/affiliates/Compact/banners.tpl', '78cf0cc4bf8f5b94d8000d2ef79383cc');
        $this->checkFile('themes/affiliates/Compact/banners_no_data.tpl', 'c89e4cdd6bccb5df3314e93446c964a4');
        $this->checkFile('themes/affiliates/Compact/breadcrumbs.tpl', '921035f90b931792de2bfd1fb40dc597');
        $this->checkFile('themes/affiliates/Compact/breadcrumbs_entry.tpl', '42ee9a25b7525589ed65bf9625adc890');
        $this->checkFile('themes/affiliates/Compact/broadcast_email.tpl', '7e2d20d16e127ec77e00be3f5d6eab8d');
        $this->checkFile('themes/affiliates/Compact/button.tpl', 'ab00df127be0dd89a125fe05f33c0380');
        $this->checkFile('themes/affiliates/Compact/calendar.tpl', 'd6831aa786acf1f829a90cec776126eb');
        $this->checkFile('themes/affiliates/Compact/campaign_category_item.tpl', '60aa1b58ff10d53fd1e800888b1069cb');
        $this->checkFile('themes/affiliates/Compact/campaign_detail.tpl', '00c57f959e4cff9634cf1acbc181cf21');
        $this->checkFile('themes/affiliates/Compact/campaign_grid_widget.tpl', '984c1470ce27033a2d9d465972298675');
        $this->checkFile('themes/affiliates/Compact/campaign_long_description.tpl', 'c8224613917e714a724a19ed20ce2505');
        $this->checkFile('themes/affiliates/Compact/campaign_stats_filter.tpl', 'ef03bd124d478bb5f8fd418a64c7ab3c');
        $this->checkFile('themes/affiliates/Compact/campaign_stats_list.tpl', 'e45c163f75670253d0dcc5037f7168e2');
        $this->checkFile('themes/affiliates/Compact/campaign_tracking_codes.tpl', '3a2324b74f6d9c54211cc58fe3d38742');
        $this->checkFile('themes/affiliates/Compact/campaign_tracking_codes_filter.tpl', '30062ab9dea3ba63b6ea0d205ca453e0');
        $this->checkFile('themes/affiliates/Compact/campaigns_filter.tpl', '3db463dfecc9eb428dab1f2257f2a5d9');
        $this->checkFile('themes/affiliates/Compact/campaigns_list.tpl', '6b63624d55078a801bc09a2e56a04417');
        $this->checkFile('themes/affiliates/Compact/campaigns_list_tree.tpl', 'e344f71cf7eddd7c6c1cc24d4f85fe72');
        $this->checkFile('themes/affiliates/Compact/captcha.tpl', '0326fedb283400e2c13eeae155d7b536');
        $this->checkFile('themes/affiliates/Compact/category_info.tpl', 'bf2e78d31f6a93380f4fbc0538589e84');
        $this->checkFile('themes/affiliates/Compact/change_status_button.tpl', 'a0d13402819088b5078e8100a21a0159');
        $this->checkFile('themes/affiliates/Compact/channel_stats_filter.tpl', '3a5aa4e605bdcf300bcc1f1ad0bf56fb');
        $this->checkFile('themes/affiliates/Compact/channel_stats_panel.tpl', '978b24c1f50a0c2fab07e3d9cf2e6272');
        $this->checkFile('themes/affiliates/Compact/channels_no_data.tpl', '0e1e8193a32385d8c980e2d4a2eff439');
        $this->checkFile('themes/affiliates/Compact/channels_panel.tpl', '5cf41aa13455ddde2cc935f3d2e39672');
        $this->checkFile('themes/affiliates/Compact/chart_datatype_popup.tpl', '7a1a0e024c8392ea5df8cd40b179d4f7');
        $this->checkFile('themes/affiliates/Compact/check_box_group.tpl', 'e182dd7429a276dc85e09049b2a6c19e');
        $this->checkFile('themes/affiliates/Compact/check_box_group_row.tpl', '97219c5c2d3c996953fd6bd882e6200c');
        $this->checkFile('themes/affiliates/Compact/checkboxes_filter.tpl', 'fef5c1833920987bd3172dbe9d75797a');
        $this->checkFile('themes/affiliates/Compact/clicks_list.tpl', 'b1ee1d4fbc2e98ea4e7fc240527a6d46');
        $this->checkFile('themes/affiliates/Compact/clicks_list_filter_base.tpl', 'fb7bfe0b49eb4671b5f8fdcc3fbb54b0');
        $this->checkFile('themes/affiliates/Compact/colorpicker.tpl', '297c4e74e89b8b3dedd12e7c319bce41');
        $this->checkFile('themes/affiliates/Compact/commission_details.tpl', 'c274d41cf9e0a2cfe28d66c36edb40a5');
        $this->checkFile('themes/affiliates/Compact/commissions_no_data.tpl', 'fcd3503c324d1988af6df1c864bfdd80');
        $this->checkFile('themes/affiliates/Compact/confirm_dialog.tpl', 'f92a8f6b3081444abf7fc4ab63c99302');
        $this->checkFile('themes/affiliates/Compact/confirm_dialog_with_value.tpl', '46e7630a0a094110f6819ea655683337');
        $this->checkFile('themes/affiliates/Compact/contact_us.tpl', '66fc6f47713f05cf7103cf5bc81ad14a');
        $this->checkFile('themes/affiliates/Compact/content_gadget_panel.tpl', '79428f6a77f38592dfa1716653bbe79b');
        $this->checkFile('themes/affiliates/Compact/context_menu.tpl', 'cddf235a2fec1ae75063d576ccdc6185');
        $this->checkFile('themes/affiliates/Compact/copy_user_role.tpl', '67725ef54593ecb567ed04a3935faecb');
        $this->checkFile('themes/affiliates/Compact/countries_list_scrolling_wrapper.tpl', '4bf0a92924334c72075b4ddafd3b243b');
        $this->checkFile('themes/affiliates/Compact/coupon.tpl', '7603de7353751cc37e762400f6dc1734');
        $this->checkFile('themes/affiliates/Compact/coupon_codes.tpl', 'a324bcc28deef842f75b6d3b4803dc6e');
        $this->checkFile('themes/affiliates/Compact/coupon_html_code.tpl', '4b85f57df88ff11ee43192e348076b42');
        $this->checkFile('themes/affiliates/Compact/coupon_previews.tpl', '3c5988cdbef06b3ae23b1de600ebf2b0');
        $this->checkFile('themes/affiliates/Compact/coupon_view.tpl', '1d6323a8ae51b2f146792372ec16f690');
        $this->checkFile('themes/affiliates/Compact/coupons_no_data.tpl', 'c8bcc725598c714ca764a2196f380d9d');
        $this->checkFile('themes/affiliates/Compact/currency_textbox.tpl', '859fd8293b92897b3be4c9a6c4aa3a8f');
        $this->checkFile('themes/affiliates/Compact/custom/advanced_tracking.tpl', 'a59f52de667fc173c0266306f5062827');
        $this->checkFile('themes/affiliates/Compact/custom/directlink_explained.tpl', '6f3915445547afa953c203b68c4fa2e5');
        $this->checkFile('themes/affiliates/Compact/custom/frequently_asked_questions.tpl', '835b2045c86a1b65a5202f271947904e');
        $this->checkFile('themes/affiliates/Compact/custom/getting_started.tpl', '8b2b7649d029c6bfe0706fcd053cdf2b');
        $this->checkFile('themes/affiliates/Compact/custom/promotion_tips.tpl', '4e39eb13d5fefdb3a8db63fbbd5e2d00');
        $this->checkFile('themes/affiliates/Compact/custom.css', '4877ef2467745239a93ebe1e79b2f813');
        $this->checkFile('themes/affiliates/Compact/custom_date_panel.tpl', 'c624f3d63d0e94db867529dc13a827d1');
        $this->checkFile('themes/affiliates/Compact/custom_filter_element.tpl', 'bf05e5d299fb1982ea8139f2a605846b');
        $this->checkFile('themes/affiliates/Compact/custom_filter_field.tpl', '21c8ab135d5d89e320ec85456ec457e0');
        $this->checkFile('themes/affiliates/Compact/custom_license_invalid.tpl', '9157ecde6accdbe2f6cd622084e79d53');
        $this->checkFile('themes/affiliates/Compact/custom_time_panel.tpl', 'd408a8352774d70124788d61a90493b6');
        $this->checkFile('themes/affiliates/Compact/daily_report.tpl', '696092e06570b6eebad4c345d98c5ca9');
        $this->checkFile('themes/affiliates/Compact/daily_report_filter.tpl', 'cdd6b5b0f3f67e1c68221170d4075b5c');
        $this->checkFile('themes/affiliates/Compact/data_field.tpl', 'dd553594505158cd53cc285d3a91fe23');
        $this->checkFile('themes/affiliates/Compact/data_field_with_help.tpl', '4615cdd789beea34c16b4c1f692a3a3b');
        $this->checkFile('themes/affiliates/Compact/date_number_format_panel.tpl', 'e26284328d2ba7da47d30e8e458c13b1');
        $this->checkFile('themes/affiliates/Compact/date_preset_panel.tpl', 'abc7d225baa948aed70cc1073b786fe8');
        $this->checkFile('themes/affiliates/Compact/date_range_filter.tpl', '3875dbc075f33ccaac856190ee103557');
        $this->checkFile('themes/affiliates/Compact/date_range_filter_field.tpl', '94048704212b6797b7b7a08fb7888da9');
        $this->checkFile('themes/affiliates/Compact/date_textbox.tpl', '4d2bf89bd754bbaccc15e48d7a37dd02');
        $this->checkFile('themes/affiliates/Compact/daterange_popup.tpl', 'dc1728d13b0440b8df5e12359010168a');
        $this->checkFile('themes/affiliates/Compact/datetimepickercontent.tpl', '9771684f29bc88d974cc64283055d1d1');
        $this->checkFile('themes/affiliates/Compact/desktop.tpl', 'b653025800e416896bd453246061a535');
        $this->checkFile('themes/affiliates/Compact/desktop_gadget.tpl', '21394ff13337e4716860c12b5e4fb312');
        $this->checkFile('themes/affiliates/Compact/desktop_main_menu.tpl', '31eb02f3f6b767d24012753d50ff5159');
        $this->checkFile('themes/affiliates/Compact/desktop_settings_mode.tpl', '1054d3be606383580f8d521f2d72682f');
        $this->checkFile('themes/affiliates/Compact/direct_link_form.tpl', '48d9f1ab56c63c05304185fbc8163922');
        $this->checkFile('themes/affiliates/Compact/direct_link_grid_widget.tpl', '586c3b902d66c903d87e510bca5843ec');
        $this->checkFile('themes/affiliates/Compact/direct_linking_panel.tpl', 'd96cd58bb0f0537f8404f641367e0801');
        $this->checkFile('themes/affiliates/Compact/direct_links_screen.tpl', 'ec5317f983964f7c42f2a4a8a28c5e3b');
        $this->checkFile('themes/affiliates/Compact/download_login_form.tpl', 'ccf5bf5eab2bc42572c4538224cbef4e');
        $this->checkFile('themes/affiliates/Compact/download_signup_form.tpl', '9dff3be2354fc10a70cc1b98b2f08434');
        $this->checkFile('themes/affiliates/Compact/drag_container.tpl', '358104feb6f9c3c2a01206e460726eac');
        $this->checkFile('themes/affiliates/Compact/dynamic_form_panel.tpl', 'ea42da62b4a44f1fa9caf50a59c29160');
        $this->checkFile('themes/affiliates/Compact/dynamic_link_panel.tpl', '33245e1f6d416f28a8555078142abfe4');
        $this->checkFile('themes/affiliates/Compact/edit_textarea_widget.tpl', '94b2c94dd103b5209bd89470fc70268c');
        $this->checkFile('themes/affiliates/Compact/edit_tracking_code_widget.tpl', '5f25a27d5086317f495922f67ad88e33');
        $this->checkFile('themes/affiliates/Compact/editor.tpl', 'a8c5483c720526b56fa899a91045c287');
        $this->checkFile('themes/affiliates/Compact/editor_with_constants_panel.tpl', '6c9e8d91f33bc90c661e9b67ca5ff1e1');
        $this->checkFile('themes/affiliates/Compact/email_form.tpl', '7809f19dc7e837c8dbe6f4d58e6574b7');
        $this->checkFile('themes/affiliates/Compact/email_notifications.tpl', '8153cb771f309301f07a29ebec237250');
        $this->checkFile('themes/affiliates/Compact/email_setting_smtp_form.tpl', 'd17124a143f842ab1876ed14a74bc762');
        $this->checkFile('themes/affiliates/Compact/email_settings_spf.tpl', 'ca349c37b841ccef522f8767817bf1d2');
        $this->checkFile('themes/affiliates/Compact/email_settings_tab.tpl', '8fef8cf6eacfffe581527d391ffb97da');
        $this->checkFile('themes/affiliates/Compact/email_template_edit_panel.tpl', '2a432b9530ad4375605916e152dd8b60');
        $this->checkFile('themes/affiliates/Compact/expired_session_dialog.tpl', 'ba711bd5d1e932ffc4fbc8e601204905');
        $this->checkFile('themes/affiliates/Compact/export_to_csv.tpl', 'cdbd08521a7f231bbf4f0181cb0d807f');
        $this->checkFile('themes/affiliates/Compact/extendable_commission_data.tpl', '43b5108a8212bccdb414370023388e10');
        $this->checkFile('themes/affiliates/Compact/extendable_text.tpl', 'a69efdb298a3aae26e26793c9b9fea36');
        $this->checkFile('themes/affiliates/Compact/extendable_text_content.tpl', 'cca4ebdf72f3cb7638b6c5bf0f59d9aa');
        $this->checkFile('themes/affiliates/Compact/extendable_text_widget.tpl', '83288dfd8795a2a9105965dde2ebc927');
        $this->checkFile('themes/affiliates/Compact/field_type_edit.tpl', 'b1294ba5d4486ea1cf8022a51e277a11');
        $this->checkFile('themes/affiliates/Compact/file_widget.tpl', 'a7410b3e376c1b177c47831f83a68c55');
        $this->checkFile('themes/affiliates/Compact/filter.tpl', 'd51de72535f52fc100a59cad0a15fd37');
        $this->checkFile('themes/affiliates/Compact/filter_field_decorator.tpl', '531d57478d7718e216ea04ff79d493ca');
        $this->checkFile('themes/affiliates/Compact/filter_form.tpl', '67551720cbc190c8df85c24d3f8a4cbe');
        $this->checkFile('themes/affiliates/Compact/financial_overview.tpl', '8a82f2f60d7ad6eeeda3e4a4122ac3c8');
        $this->checkFile('themes/affiliates/Compact/font/OpenSans/OpenSans-Bold.ttf', '50145685042b4df07a1fd19957275b81');
        $this->checkFile('themes/affiliates/Compact/font/OpenSans/OpenSans-Bold.woff', '9c3358645bea28438a96b34355b58942');
        $this->checkFile('themes/affiliates/Compact/font/OpenSans/OpenSans-BoldItalic.ttf', '78b08a68d05d5fabb0b8effd51bf6ade');
        $this->checkFile('themes/affiliates/Compact/font/OpenSans/OpenSans-BoldItalic.woff', '58851fad50f52be1f51f4e01ebf38a56');
        $this->checkFile('themes/affiliates/Compact/font/OpenSans/OpenSans-Extrabold.ttf', '8bac22ed4fd7c8a30536be18e2984f84');
        $this->checkFile('themes/affiliates/Compact/font/OpenSans/OpenSans-Extrabold.woff', '9ccabd1c4ea479b66aeced76b5060c0f');
        $this->checkFile('themes/affiliates/Compact/font/OpenSans/OpenSans-ExtraboldItalic.ttf', '73d6bb0d4f596a91992e6be32e82e3bc');
        $this->checkFile('themes/affiliates/Compact/font/OpenSans/OpenSans-ExtraboldItalic.woff', 'd73d0d6b2a48d336534b668e7adc981f');
        $this->checkFile('themes/affiliates/Compact/font/OpenSans/OpenSans-Italic.ttf', 'c7dcce084c445260a266f92db56f5517');
        $this->checkFile('themes/affiliates/Compact/font/OpenSans/OpenSans-Italic.woff', 'c0d39dd78d6397286f2dc292465c3517');
        $this->checkFile('themes/affiliates/Compact/font/OpenSans/OpenSans-Light.ttf', '1bf71be111189e76987a4bb9b3115cb7');
        $this->checkFile('themes/affiliates/Compact/font/OpenSans/OpenSans-Light.woff', '5193f01d42787bba6c0fbda289658b6f');
        $this->checkFile('themes/affiliates/Compact/font/OpenSans/OpenSans-Semibold.ttf', '33f225b8f5f7d6b34a0926f58f96c1e9');
        $this->checkFile('themes/affiliates/Compact/font/OpenSans/OpenSans-Semibold.woff', 'bbaf165415d191c0b967d80aed2dea9c');
        $this->checkFile('themes/affiliates/Compact/font/OpenSans/OpenSans-SemiboldItalic.ttf', '73f7301a9cd7a086295401eefe0c998f');
        $this->checkFile('themes/affiliates/Compact/font/OpenSans/OpenSans-SemiboldItalic.woff', '6da7bfea96b6fce269b93524cb113af6');
        $this->checkFile('themes/affiliates/Compact/font/OpenSans/OpenSans.ttf', '629a55a7e793da068dc580d184cc0e31');
        $this->checkFile('themes/affiliates/Compact/font/OpenSans/OpenSans.woff', '10bb6c1975b08eb0833d810553a209d3');
        $this->checkFile('themes/affiliates/Compact/font/OpenSans/OpenSansLight-Italic.ttf', '6943fb6fd4200f3d073469325c6acdc9');
        $this->checkFile('themes/affiliates/Compact/font/OpenSans/OpenSansLight-Italic.woff', 'e8358540a6070aff786c6adece2863db');
        $this->checkFile('themes/affiliates/Compact/font/fontello.eot', 'b2012373de53bdcf186b789d03b1b651');
        $this->checkFile('themes/affiliates/Compact/font/fontello.svg', '1045c4485908e58054e248bf90c4f758');
        $this->checkFile('themes/affiliates/Compact/font/fontello.ttf', '8da4acbde1b1dbbaee498b2adcfd4bf7');
        $this->checkFile('themes/affiliates/Compact/font/fontello.woff', 'f57a4db78bda8b28d724838c290ff166');
        $this->checkFile('themes/affiliates/Compact/font/fontello.woff2', '067318fe80a3455f47aba86c12dde49d');
        $this->checkFile('themes/affiliates/Compact/fontello.css', '7abe36cc2ed0ccbbaad467c15445aa12');
        $this->checkFile('themes/affiliates/Compact/footer.stpl', 'b25112e75b6b1adba69b09bd501fd387');
        $this->checkFile('themes/affiliates/Compact/footer.tpl', 'acf430b8fece1dddd26ef7f7165a7044');
        $this->checkFile('themes/affiliates/Compact/forgot_password.tpl', 'e31e8cf668201db153fb5783283dc75c');
        $this->checkFile('themes/affiliates/Compact/form_field.tpl', '5c7ae4b0f01f4a7753ab811e0a57f29f');
        $this->checkFile('themes/affiliates/Compact/form_field_checkbox.tpl', 'c1f1746d1bf5c7abfaf9e5ddb7b4cc52');
        $this->checkFile('themes/affiliates/Compact/form_field_checkboxgroup.tpl', 'be1b525a89f033d4f79433dd3eaab593');
        $this->checkFile('themes/affiliates/Compact/form_field_radio.tpl', '9013ed97a5fc7b4b52052d816a9b25d0');
        $this->checkFile('themes/affiliates/Compact/frame_panel.tpl', '7b13a1add8ba712d8a34f4285414b419');
        $this->checkFile('themes/affiliates/Compact/general_no_data.stpl', '03433ae7bf79c177a476922c2ee779c5');
        $this->checkFile('themes/affiliates/Compact/gpf.css', 'ec27b549fa06e9420afb4e6d56ee3a96');
        $this->checkFile('themes/affiliates/Compact/gpf_db_mail.tpl', 'b5ea5e9ecef2152fdf967085a7689adc');
        $this->checkFile('themes/affiliates/Compact/grid.tpl', '1797f6072932e243275fbf0fe1382a6d');
        $this->checkFile('themes/affiliates/Compact/grid_bottombuttons.tpl', '30a61eeb486bc2ce22368100d53fc392');
        $this->checkFile('themes/affiliates/Compact/grid_bottomgridline.tpl', '2bbe7acea603b281b758a49cc3fca124');
        $this->checkFile('themes/affiliates/Compact/grid_nodata.tpl', '340ff6de789cd7277a35d763f6366f24');
        $this->checkFile('themes/affiliates/Compact/grid_pager.tpl', '46e6d959616563985ece2d92c0234826');
        $this->checkFile('themes/affiliates/Compact/grid_selector.tpl', 'ff2d81e3866f53d540a0d063bdf7b480');
        $this->checkFile('themes/affiliates/Compact/grid_topbuttons.tpl', '83a65b7b03d432beb47d16e78cdf8aee');
        $this->checkFile('themes/affiliates/Compact/grid_topgridline.tpl', '3ff9c43cb7f7fcbbcdc7f03c8822a70d');
        $this->checkFile('themes/affiliates/Compact/header.stpl', 'a1280de5b51c8c21c5c8169fa4075378');
        $this->checkFile('themes/affiliates/Compact/header.tpl', '32d459ea9f7ebf7a241715058cc91f38');
        $this->checkFile('themes/affiliates/Compact/home.tpl', 'd25d3eb83817cf220778e4ee39d1f887');
        $this->checkFile('themes/affiliates/Compact/horizontal_layout_panel.tpl', '8b6098cd64720cff686cc24e06ac4c17');
        $this->checkFile('themes/affiliates/Compact/html_window_preview.stpl', '02d9e7142f0e2fa88afa0b9af7d9f5fc');
        $this->checkFile('themes/affiliates/Compact/icon_button.tpl', 'a7497a39fe733586fb4f5a1b9f424b0f');
        $this->checkFile('themes/affiliates/Compact/icon_object.tpl', 'ff8d25e63eca03b325c4501e13358fb2');
        $this->checkFile('themes/affiliates/Compact/icon_picker.tpl', '77a002b90f678df44bcca5776f314820');
        $this->checkFile('themes/affiliates/Compact/icon_picker_panel.tpl', '4342c424a8cb290701f64d0cb63655ec');
        $this->checkFile('themes/affiliates/Compact/icon_status_widget.tpl', 'ff9e2bc87e203324cc33c4b3ac365dfe');
        $this->checkFile('themes/affiliates/Compact/image_uploader.tpl', '091439bdf235f35fb4c42d58b789f216');
        $this->checkFile('themes/affiliates/Compact/img/favicon.ico', 'ac3e93c93589318e5dcf69efc8a76176');
        $this->checkFile('themes/affiliates/Compact/img/icon-128.png', 'a450a0dd5959518fdb2308cc5e523bcc');
        $this->checkFile('themes/affiliates/Compact/img/icon-192.png', '8cb72062e4df9eab6c2a064459a5ee62');
        $this->checkFile('themes/affiliates/Compact/img/pan-logo.svg', 'a19c0ad7bfad0399a0f82599a571db9a');
        $this->checkFile('themes/affiliates/Compact/img/pap-logo.svg', '6280dc47fe440c1c1c3af00cc27f1ced');
        $this->checkFile('themes/affiliates/Compact/img/theme_thumbnail.jpg', '68c382c044e9661b07452db6e8b6f89b');
        $this->checkFile('themes/affiliates/Compact/import_custom_language_panel.tpl', '36fe179dc09cd1a1bf3561ef9d13a647');
        $this->checkFile('themes/affiliates/Compact/import_language.tpl', 'c1df1cf60613d3df6e19681193ae41a9');
        $this->checkFile('themes/affiliates/Compact/info_dialog.tpl', '886c377f8e8c1b2c6957451436e1d090');
        $this->checkFile('themes/affiliates/Compact/ip_detail.tpl', '3723b4ce7dc6ccc4b8c8193f4c982d18');
        $this->checkFile('themes/affiliates/Compact/item.tpl', '717eff0e06a712a76effb2d6723183b5');
        $this->checkFile('themes/affiliates/Compact/item_panel.tpl', 'b24ed05bdf4cb76a7afc1e9a9908def8');
        $this->checkFile('themes/affiliates/Compact/language_create_new.tpl', '1ae789af118ce84a76ec067e82d52aec');
        $this->checkFile('themes/affiliates/Compact/language_edit_panel.tpl', '4b582c49c5aec0a72765e8764ba390b0');
        $this->checkFile('themes/affiliates/Compact/language_translations_grid.tpl', 'b3d4b3ff7279bf9383886e84ba3218ab');
        $this->checkFile('themes/affiliates/Compact/languages_configuration.tpl', '86f17a42cef0bedb165295e99c970582');
        $this->checkFile('themes/affiliates/Compact/layout_panel_content.tpl', 'd49730d94578e00ed7395eaa1d2a3df6');
        $this->checkFile('themes/affiliates/Compact/layout_panel_header_navigation.tpl', '6b0d746501001da8615a22d57266dcb0');
        $this->checkFile('themes/affiliates/Compact/layout_panel_tab.tpl', '316df333cac9b455c7dc04100c2e2d1d');
        $this->checkFile('themes/affiliates/Compact/license_invalid.tpl', '6181e1127345050c94d6708cd805aefb');
        $this->checkFile('themes/affiliates/Compact/link_button.tpl', '71fad92bff79f1fd2e1066818afac789');
        $this->checkFile('themes/affiliates/Compact/listbox.tpl', '2739c2a9e22d54280cacf4d67ed2e7bc');
        $this->checkFile('themes/affiliates/Compact/listbox_popup.tpl', '8c45877411c0727e814eb5e3caa76822');
        $this->checkFile('themes/affiliates/Compact/listdown_button.tpl', 'a1cd26a1aec6d403420971d7469a6f1b');
        $this->checkFile('themes/affiliates/Compact/load_mail_from_template.tpl', '42c0029422eaf077a5b0c316cd3317b5');
        $this->checkFile('themes/affiliates/Compact/loadable_tree.tpl', 'e2c214b134bffe5fe2bb38f679a64eb5');
        $this->checkFile('themes/affiliates/Compact/loading_indicator.tpl', '8d3b3ac51e79a10e35aa11c9bd87d83c');
        $this->checkFile('themes/affiliates/Compact/loading_screen.tpl', '5da99de875a9deebff88a2806fdad49f');
        $this->checkFile('themes/affiliates/Compact/loading_template.tpl', '39be2fe5f53ed914cc8979ea146ac398');
        $this->checkFile('themes/affiliates/Compact/login.tpl', 'e7be8367104ee7221547730250f9b0f0');
        $this->checkFile('themes/affiliates/Compact/login_form.tpl', '297656a8cfb59277903ed38dfaa9e2f1');
        $this->checkFile('themes/affiliates/Compact/login_form_downloadable.tpl', '6f2b17262524a8c12cfdcd572ad36bf9');
        $this->checkFile('themes/affiliates/Compact/login_main.tpl', '0cd828d3f67418d0795faf78316d9aaf');
        $this->checkFile('themes/affiliates/Compact/logins_history.tpl', '740e9d7a1b893fe3280b782958742998');
        $this->checkFile('themes/affiliates/Compact/loginshistory_filter.tpl', '64804e791ea2ca4fcc7e01d7a8443479');
        $this->checkFile('themes/affiliates/Compact/logs_no_data.tpl', 'c807c1484862c46a3f72f1ea0d276b3f');
        $this->checkFile('themes/affiliates/Compact/mail_detail_data.tpl', 'cb8867c95ce35d7ad35b82f5c663ae42');
        $this->checkFile('themes/affiliates/Compact/mail_outbox_panel.tpl', 'eda83d3c7fed41f0449b2464e96df945');
        $this->checkFile('themes/affiliates/Compact/mailoutbox_filter.tpl', '8fd6e8ae35323bbc8debd1c248142e61');
        $this->checkFile('themes/affiliates/Compact/mailoutbox_list_no_data.tpl', '12637515858ca4d960c6202e8a89042b');
        $this->checkFile('themes/affiliates/Compact/main.tpl', '6c31ae616669c86717a9ced0e1b28693');
        $this->checkFile('themes/affiliates/Compact/main_aff_html_doc.stpl', '533db7c6dbd9f6d188fb3db71bc7d5b1');
        $this->checkFile('themes/affiliates/Compact/main_error_html_doc.tpl', 'cc7808f71ce49f9004d1c4f03966375c');
        $this->checkFile('themes/affiliates/Compact/main_filter_panel.tpl', '0985a7421f898d75d4df72b4a6081c49');
        $this->checkFile('themes/affiliates/Compact/main_header.tpl', '5b01f94a773845f032b3f39078104c1f');
        $this->checkFile('themes/affiliates/Compact/main_menu.tpl', '5fddab52f7b44bcb5717c1d67875f567');
        $this->checkFile('themes/affiliates/Compact/map_overlay.tpl', 'd12618268f18867d1f8ef84d12c8ba32');
        $this->checkFile('themes/affiliates/Compact/map_overlay_advanced_filter.tpl', 'cf259a9627f69eb5f1a05e5a9b9fe7bd');
        $this->checkFile('themes/affiliates/Compact/menu_entry.tpl', '64a9c8f6b89eb5d0fb9a2d174b5f0427');
        $this->checkFile('themes/affiliates/Compact/menu_section.tpl', 'ce9552c9579aa842bfd16e9c61b1cd0e');
        $this->checkFile('themes/affiliates/Compact/messages.tpl', 'bf1a3bac08c419320acb94673ad29f0b');
        $this->checkFile('themes/affiliates/Compact/module_body.stpl', 'c079addcd33eb725ab7efbf09c16a793');
        $this->checkFile('themes/affiliates/Compact/multi_editor.tpl', '3ee5baa5bdb7824c0c2ae6f2dc275830');
        $this->checkFile('themes/affiliates/Compact/multiselect.tpl', '9d1863b21edd131520315ce252fde639');
        $this->checkFile('themes/affiliates/Compact/myprofile.tpl', 'bc9c2c67e2fac95d707b8508da3bfca6');
        $this->checkFile('themes/affiliates/Compact/news_content.tpl', 'a576598444bb0db20fa8d47854f1ef34');
        $this->checkFile('themes/affiliates/Compact/news_item.tpl', '18161a56a8f4dc5df01f08191709f864');
        $this->checkFile('themes/affiliates/Compact/newsletter_broadcast_form.tpl', '1ccb4e8c2a3873263c7c8c1fc7c19f27');
        $this->checkFile('themes/affiliates/Compact/newsletter_broadcasts.tpl', 'e85ba6dc04b3a921af601f6bf976a5b8');
        $this->checkFile('themes/affiliates/Compact/newsletter_edit_panel.tpl', '73ddca2129beb12e11215b1c55e70461');
        $this->checkFile('themes/affiliates/Compact/newsletter_form.tpl', 'e86bb366b8986ac4cb1b50c9ccc94b8e');
        $this->checkFile('themes/affiliates/Compact/no_content_gadgets.tpl', '1d4ce600d473f33e2b229101a50cbc3f');
        $this->checkFile('themes/affiliates/Compact/no_language_selected.tpl', 'd61125f2b1cf78e4e66653d4e2f04bdd');
        $this->checkFile('themes/affiliates/Compact/notification_window.tpl', 'db781872bdb9748bc838e051b8e5e4e2');
        $this->checkFile('themes/affiliates/Compact/online_users.tpl', 'e78ff82eb18c092018cd48d90ae48863');
        $this->checkFile('themes/affiliates/Compact/online_users_gadget_rolecount.tpl', '5fd6af0c5f2edec24d0e35dc00a9e870');
        $this->checkFile('themes/affiliates/Compact/onlinegadgets_no_data.tpl', 'f5f692a433b4911963a92c41cc269768');
        $this->checkFile('themes/affiliates/Compact/onlineusers_filter.tpl', '7a0572e8ae3375f2c79c8fe985295bd6');
        $this->checkFile('themes/affiliates/Compact/order_id_filter.tpl', 'b0abf428294c4575a75ab1dbaf7b391a');
        $this->checkFile('themes/affiliates/Compact/page_header.tpl', '4fd5676c44341f95ee0435c1f78da534');
        $this->checkFile('themes/affiliates/Compact/panel_footer.stpl', '2ecfae35d4c9436786fd4b2c26747242');
        $this->checkFile('themes/affiliates/Compact/panel_with_icons.tpl', 'cdc3dafa07941a7c6c1ec5c4297528d6');
        $this->checkFile('themes/affiliates/Compact/pap4.css', 'b2be85241b08ee0fd22288234de090c3');
        $this->checkFile('themes/affiliates/Compact/pap4.rtl.css', '63775367687e0f0a795e06e76e3860b9');
        $this->checkFile('themes/affiliates/Compact/password_constraint_panel.tpl', '71b23765c240aff0073e713cfc4da992');
        $this->checkFile('themes/affiliates/Compact/password_panel.tpl', 'b1440553a785aae589233a91315b281f');
        $this->checkFile('themes/affiliates/Compact/payment_details_panel.tpl', 'a3e9de7c3f7f02631e17f2ddfd47c1a6');
        $this->checkFile('themes/affiliates/Compact/payout_data.tpl', '04fbc30b334480035464925430c1b84c');
        $this->checkFile('themes/affiliates/Compact/payout_fields_panel.tpl', 'a0574ca1f8ca180f8bb347a75856b6c5');
        $this->checkFile('themes/affiliates/Compact/payouts_no_data.tpl', '679aa0a26f28531b3303c5ad09c962fc');
        $this->checkFile('themes/affiliates/Compact/payouts_to_affiliates.tpl', '48147fc1ef03936a6eed55f580ec7721');
        $this->checkFile('themes/affiliates/Compact/pending_backround_tasks.tpl', '75149233f7ae446473c9220c9ff1ef8f');
        $this->checkFile('themes/affiliates/Compact/period_stats.stpl', 'bb896332ac55e4f2236c3307cd5cabce');
        $this->checkFile('themes/affiliates/Compact/personal_details.tpl', '68d8be3219269a1feddaf77b02e8333f');
        $this->checkFile('themes/affiliates/Compact/popup_form_widget.tpl', '0f5d2ef3d678d026df06fe1f1e5991a8');
        $this->checkFile('themes/affiliates/Compact/promotools_screen.tpl', 'd00db589b34cfb6468a9eab3d94303f8');
        $this->checkFile('themes/affiliates/Compact/proxy_server_configuration.tpl', '732a20cf9c1d59496e88d9bd5b080484');
        $this->checkFile('themes/affiliates/Compact/quick_report_base.tpl', '03394fc9a529f4d9d13f8cbcb664be8f');
        $this->checkFile('themes/affiliates/Compact/quick_report_content.stpl', 'a75ca3ba3fc385de73eae7311f79c650');
        $this->checkFile('themes/affiliates/Compact/quick_report_content_multitier.stpl', 'e45556a573992274576437d9d34bdd71');
        $this->checkFile('themes/affiliates/Compact/quick_report_filter_base.tpl', '5998ae63fc0257404ef11638ca30eb95');
        $this->checkFile('themes/affiliates/Compact/quick_report_multitier_widget.tpl', '2f19acbcc8ca3270ba3b1d16b6253c1d');
        $this->checkFile('themes/affiliates/Compact/quick_stats.tpl', 'eb812b06f6292efc64d3aa411c1f8cc0');
        $this->checkFile('themes/affiliates/Compact/quick_stats_box.tpl', '745d64595b8a0e5869bfc1e9bf10b9c2');
        $this->checkFile('themes/affiliates/Compact/radio_button_group_row.tpl', '3713f6d400aa1ca96d9e404082304912');
        $this->checkFile('themes/affiliates/Compact/rawclicks_no_data.tpl', '4377ca4cc0e45e3ee4676ec94def1e0a');
        $this->checkFile('themes/affiliates/Compact/recipients.tpl', 'cae0cd53d947d39c2ad761f6f29b2d65');
        $this->checkFile('themes/affiliates/Compact/referringurl_advanced_filter.tpl', 'f1479abbb38dc35d909f4a3c8c961a94');
        $this->checkFile('themes/affiliates/Compact/refresh_panel.tpl', '5c709df4d219d5feb4f29003ca932f77');
        $this->checkFile('themes/affiliates/Compact/regional_settings.tpl', '7fd67a6e2e8b44c62dc36ce4812b7189');
        $this->checkFile('themes/affiliates/Compact/regional_settings_tab.tpl', '82a573fa67deb883c207f05c019f7eeb');
        $this->checkFile('themes/affiliates/Compact/report_filter.tpl', 'cfa31cd337c81b3e863f97b664581327');
        $this->checkFile('themes/affiliates/Compact/reports_screen.tpl', 'c49a73add81baccd69c14ee5ff38b904');
        $this->checkFile('themes/affiliates/Compact/request_new_password_form.tpl', 'e4e20e8042328f80b7b400e39d921986');
        $this->checkFile('themes/affiliates/Compact/resizable_text_area.tpl', '7995c217048ccd289dfee567a455b08e');
        $this->checkFile('themes/affiliates/Compact/richlistbox.tpl', '13229a43763945932dc8d5d7fa21d08e');
        $this->checkFile('themes/affiliates/Compact/richlistbox_popup.tpl', 'c155c59eea77770589bcadca0c75f1af');
        $this->checkFile('themes/affiliates/Compact/richtext_editor.tpl', '99af0e75e8761690e55e65fa238d8d4c');
        $this->checkFile('themes/affiliates/Compact/richtext_editor_toolbar.tpl', '3798b9151ed1d87c99e5783005c81773');
        $this->checkFile('themes/affiliates/Compact/richtexteditor_addlink.tpl', 'c9bd3a510535abef1076a29328f069e7');
        $this->checkFile('themes/affiliates/Compact/role_privileges.tpl', '9163270235450787bb9ebf86df5b2f69');
        $this->checkFile('themes/affiliates/Compact/rotator_preview_affiliate.stpl', 'b9766c5bec13353b6b35944db1a983e0');
        $this->checkFile('themes/affiliates/Compact/search_filter.tpl', 'c43c492cae5282a628238b4ff75508b2');
        $this->checkFile('themes/affiliates/Compact/selectbutton_search.tpl', 'dedb23ce356b1b66377e648232dc2b8b');
        $this->checkFile('themes/affiliates/Compact/send_to_friend.tpl', 'e7b902ca2beb79a6dab513cebf161a87');
        $this->checkFile('themes/affiliates/Compact/set_new_password_form.tpl', '9270391a0892b67b03efbd67084806c6');
        $this->checkFile('themes/affiliates/Compact/sidebar.tpl', '65226d7e25dcdca0cf71a9f3118d8139');
        $this->checkFile('themes/affiliates/Compact/sidebar_closed.tpl', '3d903661713a9ee5fb402776ee06d310');
        $this->checkFile('themes/affiliates/Compact/sidebar_gadget.tpl', '1f904859e056808c8826836a4e256761');
        $this->checkFile('themes/affiliates/Compact/signup_fields.tpl', '16c26f808a27c220930859db1a454042');
        $this->checkFile('themes/affiliates/Compact/signup_form.tpl', 'a55f02ab4d649b4eb23fbd252e3555fb');
        $this->checkFile('themes/affiliates/Compact/signup_subaffiliates.tpl', '37eb3bcb00f8bbbc2f3b6c793c0b5a4d');
        $this->checkFile('themes/affiliates/Compact/simple_filter.tpl', 'a55a1095bcbdbef9d9d9f5e2078b19a2');
        $this->checkFile('themes/affiliates/Compact/simple_icon_object.tpl', 'bcbc9ea994d4aa8bbdee1eddc3ad19d8');
        $this->checkFile('themes/affiliates/Compact/simple_popup_window.tpl', 'e7d6ad58d85a85eab20414bb734b8c81');
        $this->checkFile('themes/affiliates/Compact/simplecolorpicker.tpl', '9c031fbdd2b35909faeea73e5f1203a1');
        $this->checkFile('themes/affiliates/Compact/single_content_panel.tpl', '529d4a42f9106d91881f8b8b8e87748b');
        $this->checkFile('themes/affiliates/Compact/size_format_widget.tpl', 'ebfb7db6718ec601af59a570d8e0ccb3');
        $this->checkFile('themes/affiliates/Compact/start_button.tpl', '7aa2278c46b897536625cc042b4f5499');
        $this->checkFile('themes/affiliates/Compact/statistics_double_value_widget.tpl', '7e243a39277ad97843b418e45881a6d2');
        $this->checkFile('themes/affiliates/Compact/stats_chart.tpl', 'b5bb3d9a0dd5361a4e34e479aacf2480');
        $this->checkFile('themes/affiliates/Compact/sub_aff_tree.tpl', '679faa77de04d865fc22b6c25fd48275');
        $this->checkFile('themes/affiliates/Compact/sub_menu_section.tpl', 'ab7871c677c0d90bb2d878548157b628');
        $this->checkFile('themes/affiliates/Compact/subaff_stats_no_data.tpl', 'f81af900ac8f9c419e2b3cf9742a1d69');
        $this->checkFile('themes/affiliates/Compact/subaffiliate_sales_panel.tpl', '74f82f4ed0910799758338dbfc8630bc');
        $this->checkFile('themes/affiliates/Compact/subaffiliates_filter.tpl', 'd929d7710df12abd81cff41504a91c08');
        $this->checkFile('themes/affiliates/Compact/subaffiliates_panel.tpl', '471e8e9ee69c9cb55ec9e0bd689be941');
        $this->checkFile('themes/affiliates/Compact/subaffiliates_sales_filter.tpl', '9f9fd28d6f934e3937e6551e0cfbf7fb');
        $this->checkFile('themes/affiliates/Compact/subaffiliates_tree_panel.tpl', 'bd640ce415c67d2170ee88da05712f7b');
        $this->checkFile('themes/affiliates/Compact/subaffstats_filter.tpl', 'd0d0b51a10872fa37758a642237c5abd');
        $this->checkFile('themes/affiliates/Compact/subaffstats_list.tpl', '43e8f570edf8311ab5963d04432b98a7');
        $this->checkFile('themes/affiliates/Compact/subid_tracking_screen.tpl', '1407cbdf136a2197520287e9c3bec51e');
        $this->checkFile('themes/affiliates/Compact/system_menu.tpl', 'e4b4fa01982a97d8f747e7afe35283c0');
        $this->checkFile('themes/affiliates/Compact/tab_item.tpl', 'd869bc1a3b8c511712e039399333d129');
        $this->checkFile('themes/affiliates/Compact/tab_panel.tpl', '8c2853c4e62119a5b6f89c5e340af5d3');
        $this->checkFile('themes/affiliates/Compact/task.tpl', '38a4b70b6456a12285be4bb113c72575');
        $this->checkFile('themes/affiliates/Compact/taskbar.tpl', 'd7cf8ef7a71bf324aee5c1c7173afc7e');
        $this->checkFile('themes/affiliates/Compact/template_form.tpl', '70fcacb2c2cab369cc096283d5784afa');
        $this->checkFile('themes/affiliates/Compact/template_form_constants.tpl', '91c398393e519cf7c6a53ba758eefc47');
        $this->checkFile('themes/affiliates/Compact/template_form_theme_entry.tpl', '91a40d5bfbb3ff3b61cd7771e24a2684');
        $this->checkFile('themes/affiliates/Compact/template_form_themes.tpl', 'e7158c1782ef49ddbf3fbe671c5c5b8a');
        $this->checkFile('themes/affiliates/Compact/template_form_variables.tpl', 'e1c008058f4be04a9e6e76ba72cc3290');
        $this->checkFile('themes/affiliates/Compact/templates_form.tpl', '7a0a1baf13edabb10c8c6bef5a3dac41');
        $this->checkFile('themes/affiliates/Compact/tests.tpl', '2e8601708f27cfadc9ee8a3454080aaf');
        $this->checkFile('themes/affiliates/Compact/theme.php', '0bfa134aafb90ab623736bd80a6ce3b6');
        $this->checkFile('themes/affiliates/Compact/theme_panel.tpl', '7fea066d8d557fce572b77f00240cebc');
        $this->checkFile('themes/affiliates/Compact/theme_settings.tpl', '5c596388ecc46c2ac89c029f811f565e');
        $this->checkFile('themes/affiliates/Compact/tooltip_popup.tpl', 'e4a5b50c70875ee64d9fdf4f88fa8045');
        $this->checkFile('themes/affiliates/Compact/topmenu_logged.stpl', '3309092595865ba40186a7d7c009226b');
        $this->checkFile('themes/affiliates/Compact/topmenu_notlogged.stpl', 'fa06a5615600582c22cc5f57ee59ba94');
        $this->checkFile('themes/affiliates/Compact/topurl_list.tpl', 'f108c2b8e2583a45a2016869735c87d3');
        $this->checkFile('themes/affiliates/Compact/traffic_stats_gadget.tpl', '0a2882140e9f850399b2a0c198b9ad98');
        $this->checkFile('themes/affiliates/Compact/traffic_stats_in_gadget.tpl', 'ae38670c7e593de4a995af34968842b1');
        $this->checkFile('themes/affiliates/Compact/transaction_list.tpl', 'eb31bc8e7c91183f1520cf00d057d1cc');
        $this->checkFile('themes/affiliates/Compact/transaction_list_filter_base.tpl', 'efb3de54e7fc05e3bd0581cb5dfd8c1c');
        $this->checkFile('themes/affiliates/Compact/trash.tpl', '270d020eabfcf284be7a97e7102924d5');
        $this->checkFile('themes/affiliates/Compact/tree_affiliate_widget.tpl', '0f7a52f0b26bda649f60e2a994645e98');
        $this->checkFile('themes/affiliates/Compact/trend_actions_stats.tpl', '87efaeae069ec2872a33fe3e755a30e7');
        $this->checkFile('themes/affiliates/Compact/trend_actions_stats_widget.tpl', '7c26676ceb09baf3fafeb0dba3bdaec4');
        $this->checkFile('themes/affiliates/Compact/trend_stats.tpl', 'bd3333acced97fe829f3458bcd108bf8');
        $this->checkFile('themes/affiliates/Compact/trends_report.stpl', '18264d58de48af1de2b77137b0df48fb');
        $this->checkFile('themes/affiliates/Compact/trends_report.tpl', '078803b3f100dafeb1d773060290ff63');
        $this->checkFile('themes/affiliates/Compact/trends_report_action.stpl', '929fa1c9535d05f1e8a0492013b9de33');
        $this->checkFile('themes/affiliates/Compact/trends_report_filter.tpl', '18ce8dcf794b1fff579521fbadb505a7');
        $this->checkFile('themes/affiliates/Compact/trends_report_no_data.tpl', '9d1dd7b6d3ef5f6ada42de2c7d182df2');
        $this->checkFile('themes/affiliates/Compact/update_version.stpl', '5602f52fe8248df474201a16c922048f');
        $this->checkFile('themes/affiliates/Compact/upload_panel.tpl', '222a0dd80ab37bb49060da0cf7eaf447');
        $this->checkFile('themes/affiliates/Compact/uploaded_file.tpl', 'fad11b13e3b41eff41a129b1af232e7e');
        $this->checkFile('themes/affiliates/Compact/user_edit.tpl', 'f41ba1817ee0d15f16c57dff5be39bb1');
        $this->checkFile('themes/affiliates/Compact/validity.tpl', 'fbf29129f480c05f2f02e8d69bd1ccf9');
        $this->checkFile('themes/affiliates/Compact/view_form.tpl', '923d4fc8de0546c10e788de580b3562b');
        $this->checkFile('themes/affiliates/Compact/visits_sales_logs_no_data.tpl', '969b350cc45c6f7c68fa6322e98a3de1');
        $this->checkFile('themes/affiliates/Compact/wallpaper_add_custom.tpl', '2210741b569ef188fa352c977a289261');
        $this->checkFile('themes/affiliates/Compact/wallpaper_entry.tpl', '64c85f4da7897cd0f34168c62de661b9');
        $this->checkFile('themes/affiliates/Compact/wallpaper_settings.tpl', 'd160dbed38556231aeac49a96213e4d4');
        $this->checkFile('themes/affiliates/Compact/window.tpl', '2391705887d707e05187606c4a819e73');
        $this->checkFile('themes/affiliates/Compact/window_bottom_left.tpl', 'd14b545c27afa02ab7a919bdeb4c9470');
        $this->checkFile('themes/affiliates/Compact/window_empty_content.tpl', 'b1535ec719cada5b9f5d98849074b9bd');
        $this->checkFile('themes/affiliates/Compact/window_header.tpl', '02a337d4184c3924a2792a84493794cc');
        $this->checkFile('themes/affiliates/Compact/window_header_refresh.tpl', 'fcd47f4585abcac3c3a61ee3991379bc');
        $this->checkFile('themes/affiliates/Compact/window_left.tpl', '9ac901446bfa26918e32fa029fb42093');
        $this->checkFile('themes/affiliates/Compact/window_move_panel.tpl', 'f5bbd373a758bf76e6efadc94dca4b11');
        $this->checkFile('themes/affiliates/Compact/wizard_panel.tpl', '3142ce6354cb3e1c86b6c13c1d906189');
        $this->checkFile('themes/affiliates/Coupe_window/advanced_email_settings_form.tpl', '2a83754f5d407d1c031bf0259ae82b11');
        $this->checkFile('themes/affiliates/Coupe_window/advanced_email_settings_tab.tpl', '4cdac3ab7ec6827e1307d48028f2d835');
        $this->checkFile('themes/affiliates/Coupe_window/advanced_screen.tpl', '7a6fc49337838298197f0d2a4a49746b');
        $this->checkFile('themes/affiliates/Coupe_window/aff_status_panel.tpl', 'f6c8ed375a26bfa2b3262189422c5a1c');
        $this->checkFile('themes/affiliates/Coupe_window/aff_status_widget.tpl', '518ca3971863bd4c41412a286ebfdf75');
        $this->checkFile('themes/affiliates/Coupe_window/affiliate_edit_details_additional.tpl', '98de15bb9a88b36dc47ba266389cb413');
        $this->checkFile('themes/affiliates/Coupe_window/affiliate_manager.tpl', '71f61fa4905cf1b525e2c826f01b2f2f');
        $this->checkFile('themes/affiliates/Coupe_window/affiliate_subaffiliates.tpl', '8c995322ed3cd841aae0928dd8e148fd');
        $this->checkFile('themes/affiliates/Coupe_window/affiliate_theme_settings.tpl', '46f3d82a7762c6669d5014aa5be3d0b8');
        $this->checkFile('themes/affiliates/Coupe_window/affiliate_tutorial_video.tpl', 'dcd2156f94a7bdc8fb75d594ed40a308');
        $this->checkFile('themes/affiliates/Coupe_window/affiliate_urls_no_data.tpl', 'c9868414093445accf0f0d7551847116');
        $this->checkFile('themes/affiliates/Coupe_window/afflink_protector_screen.tpl', '97da4ebc987ac62bbaf542a0e8ce5316');
        $this->checkFile('themes/affiliates/Coupe_window/align_widget.tpl', '124769dbcc410ae58c1dfd53f15b58d6');
        $this->checkFile('themes/affiliates/Coupe_window/api_integration.tpl', '665e24db154f4732b6c80158a8239309');
        $this->checkFile('themes/affiliates/Coupe_window/available_values_edit.tpl', 'e96fa729b9a61e7e4a21fbddf80565fb');
        $this->checkFile('themes/affiliates/Coupe_window/banner_category_item.tpl', '38ca8170d3d7b851fbc815cc63681df9');
        $this->checkFile('themes/affiliates/Coupe_window/banner_code_widget.tpl', '91a021d77bd1ddb4f2f007809ad07902');
        $this->checkFile('themes/affiliates/Coupe_window/banner_filter.tpl', 'ed6100072214442574d06b6aa1792976');
        $this->checkFile('themes/affiliates/Coupe_window/banner_preview_promo.tpl', '96b67011b02cd4a04bd508a21d1a8bb4');
        $this->checkFile('themes/affiliates/Coupe_window/banner_preview_textwidget.tpl', '690ff2bbd824bcd5c5bb52be01597520');
        $this->checkFile('themes/affiliates/Coupe_window/banner_preview_widget.tpl', '9df335ee41605fbbc3a3fcdb239478ad');
        $this->checkFile('themes/affiliates/Coupe_window/banner_stats_filter.tpl', '437ce34d575bf783e3b85cd5d39a9cf3');
        $this->checkFile('themes/affiliates/Coupe_window/banner_stats_list.tpl', '3e71f3763376f08380959fe865aad875');
        $this->checkFile('themes/affiliates/Coupe_window/banner_widget.tpl', 'c3ac45f49f8fdc43301943a701882c56');
        $this->checkFile('themes/affiliates/Coupe_window/banner_widget_affiliate_pagepeel.tpl', '50cc893da765f31585fc3e36674d387f');
        $this->checkFile('themes/affiliates/Coupe_window/banner_widget_code.tpl', '0fb2039eec50061e0b6401a239eeca1e');
        $this->checkFile('themes/affiliates/Coupe_window/banner_widget_header.tpl', '61b14598dded31b1223dea7d65113ff6');
        $this->checkFile('themes/affiliates/Coupe_window/banner_widget_stats.tpl', 'fe3b4c8e04d179d36b203d53010814da');
        $this->checkFile('themes/affiliates/Coupe_window/banners.tpl', '78cf0cc4bf8f5b94d8000d2ef79383cc');
        $this->checkFile('themes/affiliates/Coupe_window/banners_no_data.tpl', 'c89e4cdd6bccb5df3314e93446c964a4');
        $this->checkFile('themes/affiliates/Coupe_window/breadcrumbs.tpl', '921035f90b931792de2bfd1fb40dc597');
        $this->checkFile('themes/affiliates/Coupe_window/breadcrumbs_entry.tpl', '42ee9a25b7525589ed65bf9625adc890');
        $this->checkFile('themes/affiliates/Coupe_window/broadcast_email.tpl', '7e2d20d16e127ec77e00be3f5d6eab8d');
        $this->checkFile('themes/affiliates/Coupe_window/button.tpl', 'ab00df127be0dd89a125fe05f33c0380');
        $this->checkFile('themes/affiliates/Coupe_window/calendar.tpl', 'd6831aa786acf1f829a90cec776126eb');
        $this->checkFile('themes/affiliates/Coupe_window/campaign_category_item.tpl', '60aa1b58ff10d53fd1e800888b1069cb');
        $this->checkFile('themes/affiliates/Coupe_window/campaign_detail.tpl', '00c57f959e4cff9634cf1acbc181cf21');
        $this->checkFile('themes/affiliates/Coupe_window/campaign_grid_widget.tpl', '984c1470ce27033a2d9d465972298675');
        $this->checkFile('themes/affiliates/Coupe_window/campaign_long_description.tpl', 'c8224613917e714a724a19ed20ce2505');
        $this->checkFile('themes/affiliates/Coupe_window/campaign_stats_filter.tpl', 'ef03bd124d478bb5f8fd418a64c7ab3c');
        $this->checkFile('themes/affiliates/Coupe_window/campaign_stats_list.tpl', 'e45c163f75670253d0dcc5037f7168e2');
        $this->checkFile('themes/affiliates/Coupe_window/campaign_tracking_codes.tpl', '3a2324b74f6d9c54211cc58fe3d38742');
        $this->checkFile('themes/affiliates/Coupe_window/campaign_tracking_codes_filter.tpl', '30062ab9dea3ba63b6ea0d205ca453e0');
        $this->checkFile('themes/affiliates/Coupe_window/campaigns_filter.tpl', '3db463dfecc9eb428dab1f2257f2a5d9');
        $this->checkFile('themes/affiliates/Coupe_window/campaigns_list.tpl', '6b63624d55078a801bc09a2e56a04417');
        $this->checkFile('themes/affiliates/Coupe_window/campaigns_list_tree.tpl', 'e344f71cf7eddd7c6c1cc24d4f85fe72');
        $this->checkFile('themes/affiliates/Coupe_window/captcha.tpl', '0326fedb283400e2c13eeae155d7b536');
        $this->checkFile('themes/affiliates/Coupe_window/category_info.tpl', 'bf2e78d31f6a93380f4fbc0538589e84');
        $this->checkFile('themes/affiliates/Coupe_window/change_status_button.tpl', 'a0d13402819088b5078e8100a21a0159');
        $this->checkFile('themes/affiliates/Coupe_window/channel_stats_filter.tpl', '3a5aa4e605bdcf300bcc1f1ad0bf56fb');
        $this->checkFile('themes/affiliates/Coupe_window/channel_stats_panel.tpl', '978b24c1f50a0c2fab07e3d9cf2e6272');
        $this->checkFile('themes/affiliates/Coupe_window/channels_no_data.tpl', '0e1e8193a32385d8c980e2d4a2eff439');
        $this->checkFile('themes/affiliates/Coupe_window/channels_panel.tpl', '5cf41aa13455ddde2cc935f3d2e39672');
        $this->checkFile('themes/affiliates/Coupe_window/chart_datatype_popup.tpl', '7a1a0e024c8392ea5df8cd40b179d4f7');
        $this->checkFile('themes/affiliates/Coupe_window/check_box_group.tpl', 'e182dd7429a276dc85e09049b2a6c19e');
        $this->checkFile('themes/affiliates/Coupe_window/check_box_group_row.tpl', '97219c5c2d3c996953fd6bd882e6200c');
        $this->checkFile('themes/affiliates/Coupe_window/checkboxes_filter.tpl', 'fef5c1833920987bd3172dbe9d75797a');
        $this->checkFile('themes/affiliates/Coupe_window/clicks_list.tpl', 'b1ee1d4fbc2e98ea4e7fc240527a6d46');
        $this->checkFile('themes/affiliates/Coupe_window/clicks_list_filter_base.tpl', 'fb7bfe0b49eb4671b5f8fdcc3fbb54b0');
        $this->checkFile('themes/affiliates/Coupe_window/colorpicker.tpl', '297c4e74e89b8b3dedd12e7c319bce41');
        $this->checkFile('themes/affiliates/Coupe_window/commission_details.tpl', 'c274d41cf9e0a2cfe28d66c36edb40a5');
        $this->checkFile('themes/affiliates/Coupe_window/commissions_no_data.tpl', 'fcd3503c324d1988af6df1c864bfdd80');
        $this->checkFile('themes/affiliates/Coupe_window/confirm_dialog.tpl', 'f92a8f6b3081444abf7fc4ab63c99302');
        $this->checkFile('themes/affiliates/Coupe_window/confirm_dialog_with_value.tpl', '46e7630a0a094110f6819ea655683337');
        $this->checkFile('themes/affiliates/Coupe_window/contact_us.tpl', '66fc6f47713f05cf7103cf5bc81ad14a');
        $this->checkFile('themes/affiliates/Coupe_window/content_gadget_panel.tpl', '79428f6a77f38592dfa1716653bbe79b');
        $this->checkFile('themes/affiliates/Coupe_window/context_menu.tpl', 'cddf235a2fec1ae75063d576ccdc6185');
        $this->checkFile('themes/affiliates/Coupe_window/copy_user_role.tpl', '67725ef54593ecb567ed04a3935faecb');
        $this->checkFile('themes/affiliates/Coupe_window/countries_list_scrolling_wrapper.tpl', '4bf0a92924334c72075b4ddafd3b243b');
        $this->checkFile('themes/affiliates/Coupe_window/coupon.tpl', '7603de7353751cc37e762400f6dc1734');
        $this->checkFile('themes/affiliates/Coupe_window/coupon_codes.tpl', 'a324bcc28deef842f75b6d3b4803dc6e');
        $this->checkFile('themes/affiliates/Coupe_window/coupon_html_code.tpl', '4b85f57df88ff11ee43192e348076b42');
        $this->checkFile('themes/affiliates/Coupe_window/coupon_previews.tpl', '3c5988cdbef06b3ae23b1de600ebf2b0');
        $this->checkFile('themes/affiliates/Coupe_window/coupon_view.tpl', '1d6323a8ae51b2f146792372ec16f690');
        $this->checkFile('themes/affiliates/Coupe_window/coupons_no_data.tpl', 'c8bcc725598c714ca764a2196f380d9d');
        $this->checkFile('themes/affiliates/Coupe_window/currency_textbox.tpl', '859fd8293b92897b3be4c9a6c4aa3a8f');
        $this->checkFile('themes/affiliates/Coupe_window/custom/advanced_tracking.tpl', 'a59f52de667fc173c0266306f5062827');
        $this->checkFile('themes/affiliates/Coupe_window/custom/directlink_explained.tpl', '6f3915445547afa953c203b68c4fa2e5');
        $this->checkFile('themes/affiliates/Coupe_window/custom/frequently_asked_questions.tpl', '835b2045c86a1b65a5202f271947904e');
        $this->checkFile('themes/affiliates/Coupe_window/custom/getting_started.tpl', '8b2b7649d029c6bfe0706fcd053cdf2b');
        $this->checkFile('themes/affiliates/Coupe_window/custom/promotion_tips.tpl', '4e39eb13d5fefdb3a8db63fbbd5e2d00');
        $this->checkFile('themes/affiliates/Coupe_window/custom.css', '4877ef2467745239a93ebe1e79b2f813');
        $this->checkFile('themes/affiliates/Coupe_window/custom_date_panel.tpl', 'c624f3d63d0e94db867529dc13a827d1');
        $this->checkFile('themes/affiliates/Coupe_window/custom_filter_element.tpl', 'bf05e5d299fb1982ea8139f2a605846b');
        $this->checkFile('themes/affiliates/Coupe_window/custom_filter_field.tpl', '21c8ab135d5d89e320ec85456ec457e0');
        $this->checkFile('themes/affiliates/Coupe_window/custom_license_invalid.tpl', '9157ecde6accdbe2f6cd622084e79d53');
        $this->checkFile('themes/affiliates/Coupe_window/custom_time_panel.tpl', 'd408a8352774d70124788d61a90493b6');
        $this->checkFile('themes/affiliates/Coupe_window/daily_report.tpl', '696092e06570b6eebad4c345d98c5ca9');
        $this->checkFile('themes/affiliates/Coupe_window/daily_report_filter.tpl', 'cdd6b5b0f3f67e1c68221170d4075b5c');
        $this->checkFile('themes/affiliates/Coupe_window/data_field.tpl', 'dd553594505158cd53cc285d3a91fe23');
        $this->checkFile('themes/affiliates/Coupe_window/data_field_with_help.tpl', '4615cdd789beea34c16b4c1f692a3a3b');
        $this->checkFile('themes/affiliates/Coupe_window/date_number_format_panel.tpl', 'e26284328d2ba7da47d30e8e458c13b1');
        $this->checkFile('themes/affiliates/Coupe_window/date_preset_panel.tpl', 'abc7d225baa948aed70cc1073b786fe8');
        $this->checkFile('themes/affiliates/Coupe_window/date_range_filter.tpl', '3875dbc075f33ccaac856190ee103557');
        $this->checkFile('themes/affiliates/Coupe_window/date_range_filter_field.tpl', '94048704212b6797b7b7a08fb7888da9');
        $this->checkFile('themes/affiliates/Coupe_window/date_textbox.tpl', '4d2bf89bd754bbaccc15e48d7a37dd02');
        $this->checkFile('themes/affiliates/Coupe_window/daterange_popup.tpl', 'dc1728d13b0440b8df5e12359010168a');
        $this->checkFile('themes/affiliates/Coupe_window/datetimepickercontent.tpl', '9771684f29bc88d974cc64283055d1d1');
        $this->checkFile('themes/affiliates/Coupe_window/desktop.tpl', 'b653025800e416896bd453246061a535');
        $this->checkFile('themes/affiliates/Coupe_window/desktop_gadget.tpl', '21394ff13337e4716860c12b5e4fb312');
        $this->checkFile('themes/affiliates/Coupe_window/desktop_main_menu.tpl', '31eb02f3f6b767d24012753d50ff5159');
        $this->checkFile('themes/affiliates/Coupe_window/desktop_settings_mode.tpl', '1054d3be606383580f8d521f2d72682f');
        $this->checkFile('themes/affiliates/Coupe_window/direct_link_form.tpl', '48d9f1ab56c63c05304185fbc8163922');
        $this->checkFile('themes/affiliates/Coupe_window/direct_link_grid_widget.tpl', '586c3b902d66c903d87e510bca5843ec');
        $this->checkFile('themes/affiliates/Coupe_window/direct_linking_panel.tpl', 'd96cd58bb0f0537f8404f641367e0801');
        $this->checkFile('themes/affiliates/Coupe_window/direct_links_screen.tpl', 'ec5317f983964f7c42f2a4a8a28c5e3b');
        $this->checkFile('themes/affiliates/Coupe_window/download_login_form.tpl', 'ccf5bf5eab2bc42572c4538224cbef4e');
        $this->checkFile('themes/affiliates/Coupe_window/download_signup_form.tpl', '9dff3be2354fc10a70cc1b98b2f08434');
        $this->checkFile('themes/affiliates/Coupe_window/drag_container.tpl', '358104feb6f9c3c2a01206e460726eac');
        $this->checkFile('themes/affiliates/Coupe_window/dynamic_form_panel.tpl', 'ea42da62b4a44f1fa9caf50a59c29160');
        $this->checkFile('themes/affiliates/Coupe_window/dynamic_link_panel.tpl', '33245e1f6d416f28a8555078142abfe4');
        $this->checkFile('themes/affiliates/Coupe_window/edit_textarea_widget.tpl', '94b2c94dd103b5209bd89470fc70268c');
        $this->checkFile('themes/affiliates/Coupe_window/edit_tracking_code_widget.tpl', '5f25a27d5086317f495922f67ad88e33');
        $this->checkFile('themes/affiliates/Coupe_window/editor.tpl', 'a8c5483c720526b56fa899a91045c287');
        $this->checkFile('themes/affiliates/Coupe_window/editor_with_constants_panel.tpl', '6c9e8d91f33bc90c661e9b67ca5ff1e1');
        $this->checkFile('themes/affiliates/Coupe_window/email_form.tpl', '7809f19dc7e837c8dbe6f4d58e6574b7');
        $this->checkFile('themes/affiliates/Coupe_window/email_notifications.tpl', 'e95f46c8f970eaf6ca3c6103e571a2da');
        $this->checkFile('themes/affiliates/Coupe_window/email_setting_smtp_form.tpl', 'd17124a143f842ab1876ed14a74bc762');
        $this->checkFile('themes/affiliates/Coupe_window/email_settings_spf.tpl', 'ca349c37b841ccef522f8767817bf1d2');
        $this->checkFile('themes/affiliates/Coupe_window/email_settings_tab.tpl', '8fef8cf6eacfffe581527d391ffb97da');
        $this->checkFile('themes/affiliates/Coupe_window/email_template_edit_panel.tpl', '2a432b9530ad4375605916e152dd8b60');
        $this->checkFile('themes/affiliates/Coupe_window/expired_session_dialog.tpl', 'ba711bd5d1e932ffc4fbc8e601204905');
        $this->checkFile('themes/affiliates/Coupe_window/export_to_csv.tpl', 'cdbd08521a7f231bbf4f0181cb0d807f');
        $this->checkFile('themes/affiliates/Coupe_window/extendable_commission_data.tpl', '43b5108a8212bccdb414370023388e10');
        $this->checkFile('themes/affiliates/Coupe_window/extendable_text.tpl', 'a69efdb298a3aae26e26793c9b9fea36');
        $this->checkFile('themes/affiliates/Coupe_window/extendable_text_content.tpl', 'cca4ebdf72f3cb7638b6c5bf0f59d9aa');
        $this->checkFile('themes/affiliates/Coupe_window/extendable_text_widget.tpl', '83288dfd8795a2a9105965dde2ebc927');
        $this->checkFile('themes/affiliates/Coupe_window/field_type_edit.tpl', 'b1294ba5d4486ea1cf8022a51e277a11');
        $this->checkFile('themes/affiliates/Coupe_window/file_widget.tpl', 'a7410b3e376c1b177c47831f83a68c55');
        $this->checkFile('themes/affiliates/Coupe_window/filter.tpl', 'd51de72535f52fc100a59cad0a15fd37');
        $this->checkFile('themes/affiliates/Coupe_window/filter_field_decorator.tpl', '531d57478d7718e216ea04ff79d493ca');
        $this->checkFile('themes/affiliates/Coupe_window/filter_form.tpl', '67551720cbc190c8df85c24d3f8a4cbe');
        $this->checkFile('themes/affiliates/Coupe_window/financial_overview.tpl', '8a82f2f60d7ad6eeeda3e4a4122ac3c8');
        $this->checkFile('themes/affiliates/Coupe_window/font/OpenSans/OpenSans-Bold.ttf', '50145685042b4df07a1fd19957275b81');
        $this->checkFile('themes/affiliates/Coupe_window/font/OpenSans/OpenSans-Bold.woff', '9c3358645bea28438a96b34355b58942');
        $this->checkFile('themes/affiliates/Coupe_window/font/OpenSans/OpenSans-BoldItalic.ttf', '78b08a68d05d5fabb0b8effd51bf6ade');
        $this->checkFile('themes/affiliates/Coupe_window/font/OpenSans/OpenSans-BoldItalic.woff', '58851fad50f52be1f51f4e01ebf38a56');
        $this->checkFile('themes/affiliates/Coupe_window/font/OpenSans/OpenSans-Extrabold.ttf', '8bac22ed4fd7c8a30536be18e2984f84');
        $this->checkFile('themes/affiliates/Coupe_window/font/OpenSans/OpenSans-Extrabold.woff', '9ccabd1c4ea479b66aeced76b5060c0f');
        $this->checkFile('themes/affiliates/Coupe_window/font/OpenSans/OpenSans-ExtraboldItalic.ttf', '73d6bb0d4f596a91992e6be32e82e3bc');
        $this->checkFile('themes/affiliates/Coupe_window/font/OpenSans/OpenSans-ExtraboldItalic.woff', 'd73d0d6b2a48d336534b668e7adc981f');
        $this->checkFile('themes/affiliates/Coupe_window/font/OpenSans/OpenSans-Italic.ttf', 'c7dcce084c445260a266f92db56f5517');
        $this->checkFile('themes/affiliates/Coupe_window/font/OpenSans/OpenSans-Italic.woff', 'c0d39dd78d6397286f2dc292465c3517');
        $this->checkFile('themes/affiliates/Coupe_window/font/OpenSans/OpenSans-Light.ttf', '1bf71be111189e76987a4bb9b3115cb7');
        $this->checkFile('themes/affiliates/Coupe_window/font/OpenSans/OpenSans-Light.woff', '5193f01d42787bba6c0fbda289658b6f');
        $this->checkFile('themes/affiliates/Coupe_window/font/OpenSans/OpenSans-Semibold.ttf', '33f225b8f5f7d6b34a0926f58f96c1e9');
        $this->checkFile('themes/affiliates/Coupe_window/font/OpenSans/OpenSans-Semibold.woff', 'bbaf165415d191c0b967d80aed2dea9c');
        $this->checkFile('themes/affiliates/Coupe_window/font/OpenSans/OpenSans-SemiboldItalic.ttf', '73f7301a9cd7a086295401eefe0c998f');
        $this->checkFile('themes/affiliates/Coupe_window/font/OpenSans/OpenSans-SemiboldItalic.woff', '6da7bfea96b6fce269b93524cb113af6');
        $this->checkFile('themes/affiliates/Coupe_window/font/OpenSans/OpenSans.ttf', '629a55a7e793da068dc580d184cc0e31');
        $this->checkFile('themes/affiliates/Coupe_window/font/OpenSans/OpenSans.woff', '10bb6c1975b08eb0833d810553a209d3');
        $this->checkFile('themes/affiliates/Coupe_window/font/OpenSans/OpenSansLight-Italic.ttf', '6943fb6fd4200f3d073469325c6acdc9');
        $this->checkFile('themes/affiliates/Coupe_window/font/OpenSans/OpenSansLight-Italic.woff', 'e8358540a6070aff786c6adece2863db');
        $this->checkFile('themes/affiliates/Coupe_window/font/fontello.eot', 'cc1b737823e3a4d882787ed020884927');
        $this->checkFile('themes/affiliates/Coupe_window/font/fontello.svg', '2172a8fec29ec907fc46f31a083b6d6e');
        $this->checkFile('themes/affiliates/Coupe_window/font/fontello.ttf', 'c170bf1de24973d38aa2f8dbfe1ad80a');
        $this->checkFile('themes/affiliates/Coupe_window/font/fontello.woff', '69bf6015a78744824eafb4df9da39012');
        $this->checkFile('themes/affiliates/Coupe_window/font/fontello.woff2', 'eba84f2d8dfa34e0ca9688854619f57c');
        $this->checkFile('themes/affiliates/Coupe_window/fontello.css', '7abe36cc2ed0ccbbaad467c15445aa12');
        $this->checkFile('themes/affiliates/Coupe_window/footer.stpl', 'b25112e75b6b1adba69b09bd501fd387');
        $this->checkFile('themes/affiliates/Coupe_window/footer.tpl', 'acf430b8fece1dddd26ef7f7165a7044');
        $this->checkFile('themes/affiliates/Coupe_window/forgot_password.tpl', 'e31e8cf668201db153fb5783283dc75c');
        $this->checkFile('themes/affiliates/Coupe_window/form_field.tpl', '5c7ae4b0f01f4a7753ab811e0a57f29f');
        $this->checkFile('themes/affiliates/Coupe_window/form_field_checkbox.tpl', 'a480f63987c14d38c18ecea5911e75d2');
        $this->checkFile('themes/affiliates/Coupe_window/form_field_checkboxgroup.tpl', 'be1b525a89f033d4f79433dd3eaab593');
        $this->checkFile('themes/affiliates/Coupe_window/form_field_radio.tpl', '9013ed97a5fc7b4b52052d816a9b25d0');
        $this->checkFile('themes/affiliates/Coupe_window/frame_panel.tpl', '7b13a1add8ba712d8a34f4285414b419');
        $this->checkFile('themes/affiliates/Coupe_window/general_no_data.stpl', '03433ae7bf79c177a476922c2ee779c5');
        $this->checkFile('themes/affiliates/Coupe_window/gpf.css', 'c490b27edf5c4eccfcce08e7804766fe');
        $this->checkFile('themes/affiliates/Coupe_window/gpf_db_mail.tpl', 'b5ea5e9ecef2152fdf967085a7689adc');
        $this->checkFile('themes/affiliates/Coupe_window/grid.tpl', 'c0182bb0f7e479174dcb1bb80b6b7ebf');
        $this->checkFile('themes/affiliates/Coupe_window/grid_bottombuttons.tpl', '30a61eeb486bc2ce22368100d53fc392');
        $this->checkFile('themes/affiliates/Coupe_window/grid_bottomgridline.tpl', '2bbe7acea603b281b758a49cc3fca124');
        $this->checkFile('themes/affiliates/Coupe_window/grid_nodata.tpl', '340ff6de789cd7277a35d763f6366f24');
        $this->checkFile('themes/affiliates/Coupe_window/grid_pager.tpl', '46e6d959616563985ece2d92c0234826');
        $this->checkFile('themes/affiliates/Coupe_window/grid_selector.tpl', 'ff2d81e3866f53d540a0d063bdf7b480');
        $this->checkFile('themes/affiliates/Coupe_window/grid_topbuttons.tpl', '83a65b7b03d432beb47d16e78cdf8aee');
        $this->checkFile('themes/affiliates/Coupe_window/grid_topgridline.tpl', '3ff9c43cb7f7fcbbcdc7f03c8822a70d');
        $this->checkFile('themes/affiliates/Coupe_window/header.stpl', 'a1280de5b51c8c21c5c8169fa4075378');
        $this->checkFile('themes/affiliates/Coupe_window/header.tpl', '32d459ea9f7ebf7a241715058cc91f38');
        $this->checkFile('themes/affiliates/Coupe_window/home.tpl', 'd25d3eb83817cf220778e4ee39d1f887');
        $this->checkFile('themes/affiliates/Coupe_window/horizontal_layout_panel.tpl', '8b6098cd64720cff686cc24e06ac4c17');
        $this->checkFile('themes/affiliates/Coupe_window/html_window_preview.stpl', '02d9e7142f0e2fa88afa0b9af7d9f5fc');
        $this->checkFile('themes/affiliates/Coupe_window/icon_button.tpl', 'a7497a39fe733586fb4f5a1b9f424b0f');
        $this->checkFile('themes/affiliates/Coupe_window/icon_object.tpl', 'ff8d25e63eca03b325c4501e13358fb2');
        $this->checkFile('themes/affiliates/Coupe_window/icon_picker.tpl', '77a002b90f678df44bcca5776f314820');
        $this->checkFile('themes/affiliates/Coupe_window/icon_picker_panel.tpl', '4342c424a8cb290701f64d0cb63655ec');
        $this->checkFile('themes/affiliates/Coupe_window/icon_status_widget.tpl', 'ff9e2bc87e203324cc33c4b3ac365dfe');
        $this->checkFile('themes/affiliates/Coupe_window/image_uploader.tpl', '091439bdf235f35fb4c42d58b789f216');
        $this->checkFile('themes/affiliates/Coupe_window/img/favicon.ico', 'ac3e93c93589318e5dcf69efc8a76176');
        $this->checkFile('themes/affiliates/Coupe_window/img/icon-128.png', 'a450a0dd5959518fdb2308cc5e523bcc');
        $this->checkFile('themes/affiliates/Coupe_window/img/icon-192.png', '8cb72062e4df9eab6c2a064459a5ee62');
        $this->checkFile('themes/affiliates/Coupe_window/img/pan-logo.svg', 'a19c0ad7bfad0399a0f82599a571db9a');
        $this->checkFile('themes/affiliates/Coupe_window/img/pap-logo.svg', '6280dc47fe440c1c1c3af00cc27f1ced');
        $this->checkFile('themes/affiliates/Coupe_window/img/theme_thumbnail.jpg', 'eb50910722c9a4fdc8af83de2fd39303');
        $this->checkFile('themes/affiliates/Coupe_window/import_custom_language_panel.tpl', '36fe179dc09cd1a1bf3561ef9d13a647');
        $this->checkFile('themes/affiliates/Coupe_window/import_language.tpl', 'c1df1cf60613d3df6e19681193ae41a9');
        $this->checkFile('themes/affiliates/Coupe_window/info_dialog.tpl', '886c377f8e8c1b2c6957451436e1d090');
        $this->checkFile('themes/affiliates/Coupe_window/ip_detail.tpl', '3723b4ce7dc6ccc4b8c8193f4c982d18');
        $this->checkFile('themes/affiliates/Coupe_window/item.tpl', '717eff0e06a712a76effb2d6723183b5');
        $this->checkFile('themes/affiliates/Coupe_window/item_panel.tpl', '29d23d91da01848dcabcddb94eac62ec');
        $this->checkFile('themes/affiliates/Coupe_window/language_create_new.tpl', '1ae789af118ce84a76ec067e82d52aec');
        $this->checkFile('themes/affiliates/Coupe_window/language_edit_panel.tpl', '4b582c49c5aec0a72765e8764ba390b0');
        $this->checkFile('themes/affiliates/Coupe_window/language_translations_grid.tpl', 'b3d4b3ff7279bf9383886e84ba3218ab');
        $this->checkFile('themes/affiliates/Coupe_window/languages_configuration.tpl', '86f17a42cef0bedb165295e99c970582');
        $this->checkFile('themes/affiliates/Coupe_window/layout_panel_content.tpl', 'd49730d94578e00ed7395eaa1d2a3df6');
        $this->checkFile('themes/affiliates/Coupe_window/layout_panel_header_navigation.tpl', '6b0d746501001da8615a22d57266dcb0');
        $this->checkFile('themes/affiliates/Coupe_window/layout_panel_tab.tpl', '316df333cac9b455c7dc04100c2e2d1d');
        $this->checkFile('themes/affiliates/Coupe_window/license_invalid.tpl', '6181e1127345050c94d6708cd805aefb');
        $this->checkFile('themes/affiliates/Coupe_window/link_button.tpl', '71fad92bff79f1fd2e1066818afac789');
        $this->checkFile('themes/affiliates/Coupe_window/listbox.tpl', '2739c2a9e22d54280cacf4d67ed2e7bc');
        $this->checkFile('themes/affiliates/Coupe_window/listbox_popup.tpl', '8c45877411c0727e814eb5e3caa76822');
        $this->checkFile('themes/affiliates/Coupe_window/listdown_button.tpl', 'a1cd26a1aec6d403420971d7469a6f1b');
        $this->checkFile('themes/affiliates/Coupe_window/load_mail_from_template.tpl', '42c0029422eaf077a5b0c316cd3317b5');
        $this->checkFile('themes/affiliates/Coupe_window/loadable_tree.tpl', 'e2c214b134bffe5fe2bb38f679a64eb5');
        $this->checkFile('themes/affiliates/Coupe_window/loading_indicator.tpl', '8d3b3ac51e79a10e35aa11c9bd87d83c');
        $this->checkFile('themes/affiliates/Coupe_window/loading_screen.tpl', '5da99de875a9deebff88a2806fdad49f');
        $this->checkFile('themes/affiliates/Coupe_window/loading_template.tpl', '39be2fe5f53ed914cc8979ea146ac398');
        $this->checkFile('themes/affiliates/Coupe_window/login.tpl', 'e7be8367104ee7221547730250f9b0f0');
        $this->checkFile('themes/affiliates/Coupe_window/login_form.tpl', '297656a8cfb59277903ed38dfaa9e2f1');
        $this->checkFile('themes/affiliates/Coupe_window/login_form_downloadable.tpl', '6f2b17262524a8c12cfdcd572ad36bf9');
        $this->checkFile('themes/affiliates/Coupe_window/login_main.tpl', '0cd828d3f67418d0795faf78316d9aaf');
        $this->checkFile('themes/affiliates/Coupe_window/logins_history.tpl', '740e9d7a1b893fe3280b782958742998');
        $this->checkFile('themes/affiliates/Coupe_window/loginshistory_filter.tpl', '64804e791ea2ca4fcc7e01d7a8443479');
        $this->checkFile('themes/affiliates/Coupe_window/logs_no_data.tpl', 'c807c1484862c46a3f72f1ea0d276b3f');
        $this->checkFile('themes/affiliates/Coupe_window/mail_detail_data.tpl', 'cb8867c95ce35d7ad35b82f5c663ae42');
        $this->checkFile('themes/affiliates/Coupe_window/mail_outbox_panel.tpl', 'eda83d3c7fed41f0449b2464e96df945');
        $this->checkFile('themes/affiliates/Coupe_window/mailoutbox_filter.tpl', '8fd6e8ae35323bbc8debd1c248142e61');
        $this->checkFile('themes/affiliates/Coupe_window/mailoutbox_list_no_data.tpl', '12637515858ca4d960c6202e8a89042b');
        $this->checkFile('themes/affiliates/Coupe_window/main.tpl', '6c31ae616669c86717a9ced0e1b28693');
        $this->checkFile('themes/affiliates/Coupe_window/main_aff_html_doc.stpl', '533db7c6dbd9f6d188fb3db71bc7d5b1');
        $this->checkFile('themes/affiliates/Coupe_window/main_error_html_doc.tpl', 'cc7808f71ce49f9004d1c4f03966375c');
        $this->checkFile('themes/affiliates/Coupe_window/main_filter_panel.tpl', '0985a7421f898d75d4df72b4a6081c49');
        $this->checkFile('themes/affiliates/Coupe_window/main_header.tpl', '5b01f94a773845f032b3f39078104c1f');
        $this->checkFile('themes/affiliates/Coupe_window/main_menu.tpl', '5fddab52f7b44bcb5717c1d67875f567');
        $this->checkFile('themes/affiliates/Coupe_window/map_overlay.tpl', 'd12618268f18867d1f8ef84d12c8ba32');
        $this->checkFile('themes/affiliates/Coupe_window/map_overlay_advanced_filter.tpl', 'cf259a9627f69eb5f1a05e5a9b9fe7bd');
        $this->checkFile('themes/affiliates/Coupe_window/menu_entry.tpl', '64a9c8f6b89eb5d0fb9a2d174b5f0427');
        $this->checkFile('themes/affiliates/Coupe_window/menu_section.tpl', 'ce9552c9579aa842bfd16e9c61b1cd0e');
        $this->checkFile('themes/affiliates/Coupe_window/messages.tpl', 'bf1a3bac08c419320acb94673ad29f0b');
        $this->checkFile('themes/affiliates/Coupe_window/module_body.stpl', 'c079addcd33eb725ab7efbf09c16a793');
        $this->checkFile('themes/affiliates/Coupe_window/multi_editor.tpl', '3ee5baa5bdb7824c0c2ae6f2dc275830');
        $this->checkFile('themes/affiliates/Coupe_window/multiselect.tpl', '9d1863b21edd131520315ce252fde639');
        $this->checkFile('themes/affiliates/Coupe_window/myprofile.tpl', 'bc9c2c67e2fac95d707b8508da3bfca6');
        $this->checkFile('themes/affiliates/Coupe_window/news_content.tpl', 'a576598444bb0db20fa8d47854f1ef34');
        $this->checkFile('themes/affiliates/Coupe_window/news_item.tpl', '18161a56a8f4dc5df01f08191709f864');
        $this->checkFile('themes/affiliates/Coupe_window/newsletter_broadcast_form.tpl', '1ccb4e8c2a3873263c7c8c1fc7c19f27');
        $this->checkFile('themes/affiliates/Coupe_window/newsletter_broadcasts.tpl', 'e85ba6dc04b3a921af601f6bf976a5b8');
        $this->checkFile('themes/affiliates/Coupe_window/newsletter_edit_panel.tpl', '73ddca2129beb12e11215b1c55e70461');
        $this->checkFile('themes/affiliates/Coupe_window/newsletter_form.tpl', 'e86bb366b8986ac4cb1b50c9ccc94b8e');
        $this->checkFile('themes/affiliates/Coupe_window/no_content_gadgets.tpl', '1d4ce600d473f33e2b229101a50cbc3f');
        $this->checkFile('themes/affiliates/Coupe_window/no_language_selected.tpl', 'd61125f2b1cf78e4e66653d4e2f04bdd');
        $this->checkFile('themes/affiliates/Coupe_window/notification_window.tpl', 'db781872bdb9748bc838e051b8e5e4e2');
        $this->checkFile('themes/affiliates/Coupe_window/online_users.tpl', 'e78ff82eb18c092018cd48d90ae48863');
        $this->checkFile('themes/affiliates/Coupe_window/online_users_gadget_rolecount.tpl', '5fd6af0c5f2edec24d0e35dc00a9e870');
        $this->checkFile('themes/affiliates/Coupe_window/onlinegadgets_no_data.tpl', 'f5f692a433b4911963a92c41cc269768');
        $this->checkFile('themes/affiliates/Coupe_window/onlineusers_filter.tpl', '7a0572e8ae3375f2c79c8fe985295bd6');
        $this->checkFile('themes/affiliates/Coupe_window/order_id_filter.tpl', 'b0abf428294c4575a75ab1dbaf7b391a');
        $this->checkFile('themes/affiliates/Coupe_window/page_header.tpl', '55fc71480cbd743a225bd79b63bb1027');
        $this->checkFile('themes/affiliates/Coupe_window/panel_footer.stpl', '2ecfae35d4c9436786fd4b2c26747242');
        $this->checkFile('themes/affiliates/Coupe_window/panel_with_icons.tpl', 'cdc3dafa07941a7c6c1ec5c4297528d6');
        $this->checkFile('themes/affiliates/Coupe_window/pap4.css', '74ad4dde2635aac9aa02470dbc78cddd');
        $this->checkFile('themes/affiliates/Coupe_window/pap4.rtl.css', '6f7e2f3a2ea67599a5342df22b272847');
        $this->checkFile('themes/affiliates/Coupe_window/password_constraint_panel.tpl', '71b23765c240aff0073e713cfc4da992');
        $this->checkFile('themes/affiliates/Coupe_window/password_panel.tpl', 'b1440553a785aae589233a91315b281f');
        $this->checkFile('themes/affiliates/Coupe_window/payment_details_panel.tpl', 'a3e9de7c3f7f02631e17f2ddfd47c1a6');
        $this->checkFile('themes/affiliates/Coupe_window/payout_data.tpl', '04fbc30b334480035464925430c1b84c');
        $this->checkFile('themes/affiliates/Coupe_window/payout_fields_panel.tpl', 'a0574ca1f8ca180f8bb347a75856b6c5');
        $this->checkFile('themes/affiliates/Coupe_window/payouts_no_data.tpl', '679aa0a26f28531b3303c5ad09c962fc');
        $this->checkFile('themes/affiliates/Coupe_window/payouts_to_affiliates.tpl', '48147fc1ef03936a6eed55f580ec7721');
        $this->checkFile('themes/affiliates/Coupe_window/pending_backround_tasks.tpl', '75149233f7ae446473c9220c9ff1ef8f');
        $this->checkFile('themes/affiliates/Coupe_window/period_stats.stpl', 'bb896332ac55e4f2236c3307cd5cabce');
        $this->checkFile('themes/affiliates/Coupe_window/personal_details.tpl', '68d8be3219269a1feddaf77b02e8333f');
        $this->checkFile('themes/affiliates/Coupe_window/popup_form_widget.tpl', '0f5d2ef3d678d026df06fe1f1e5991a8');
        $this->checkFile('themes/affiliates/Coupe_window/promotools_screen.tpl', 'd00db589b34cfb6468a9eab3d94303f8');
        $this->checkFile('themes/affiliates/Coupe_window/proxy_server_configuration.tpl', '732a20cf9c1d59496e88d9bd5b080484');
        $this->checkFile('themes/affiliates/Coupe_window/quick_report_base.tpl', '03394fc9a529f4d9d13f8cbcb664be8f');
        $this->checkFile('themes/affiliates/Coupe_window/quick_report_content.stpl', 'a75ca3ba3fc385de73eae7311f79c650');
        $this->checkFile('themes/affiliates/Coupe_window/quick_report_content_multitier.stpl', 'e45556a573992274576437d9d34bdd71');
        $this->checkFile('themes/affiliates/Coupe_window/quick_report_filter_base.tpl', '5998ae63fc0257404ef11638ca30eb95');
        $this->checkFile('themes/affiliates/Coupe_window/quick_report_multitier_widget.tpl', '2f19acbcc8ca3270ba3b1d16b6253c1d');
        $this->checkFile('themes/affiliates/Coupe_window/quick_stats.tpl', 'eb812b06f6292efc64d3aa411c1f8cc0');
        $this->checkFile('themes/affiliates/Coupe_window/quick_stats_box.tpl', '745d64595b8a0e5869bfc1e9bf10b9c2');
        $this->checkFile('themes/affiliates/Coupe_window/radio_button_group_row.tpl', '3713f6d400aa1ca96d9e404082304912');
        $this->checkFile('themes/affiliates/Coupe_window/rawclicks_no_data.tpl', '4377ca4cc0e45e3ee4676ec94def1e0a');
        $this->checkFile('themes/affiliates/Coupe_window/recipients.tpl', 'cae0cd53d947d39c2ad761f6f29b2d65');
        $this->checkFile('themes/affiliates/Coupe_window/referringurl_advanced_filter.tpl', 'f1479abbb38dc35d909f4a3c8c961a94');
        $this->checkFile('themes/affiliates/Coupe_window/refresh_panel.tpl', '5c709df4d219d5feb4f29003ca932f77');
        $this->checkFile('themes/affiliates/Coupe_window/regional_settings.tpl', '7fd67a6e2e8b44c62dc36ce4812b7189');
        $this->checkFile('themes/affiliates/Coupe_window/regional_settings_tab.tpl', '82a573fa67deb883c207f05c019f7eeb');
        $this->checkFile('themes/affiliates/Coupe_window/report_filter.tpl', 'cfa31cd337c81b3e863f97b664581327');
        $this->checkFile('themes/affiliates/Coupe_window/reports_screen.tpl', 'c49a73add81baccd69c14ee5ff38b904');
        $this->checkFile('themes/affiliates/Coupe_window/request_new_password_form.tpl', 'e4e20e8042328f80b7b400e39d921986');
        $this->checkFile('themes/affiliates/Coupe_window/resizable_text_area.tpl', '7995c217048ccd289dfee567a455b08e');
        $this->checkFile('themes/affiliates/Coupe_window/richlistbox.tpl', '13229a43763945932dc8d5d7fa21d08e');
        $this->checkFile('themes/affiliates/Coupe_window/richlistbox_popup.tpl', 'c155c59eea77770589bcadca0c75f1af');
        $this->checkFile('themes/affiliates/Coupe_window/richtext_editor.tpl', '99af0e75e8761690e55e65fa238d8d4c');
        $this->checkFile('themes/affiliates/Coupe_window/richtext_editor_toolbar.tpl', '3798b9151ed1d87c99e5783005c81773');
        $this->checkFile('themes/affiliates/Coupe_window/richtexteditor_addlink.tpl', 'c9bd3a510535abef1076a29328f069e7');
        $this->checkFile('themes/affiliates/Coupe_window/role_privileges.tpl', '9163270235450787bb9ebf86df5b2f69');
        $this->checkFile('themes/affiliates/Coupe_window/rotator_preview_affiliate.stpl', 'b9766c5bec13353b6b35944db1a983e0');
        $this->checkFile('themes/affiliates/Coupe_window/search_filter.tpl', 'c43c492cae5282a628238b4ff75508b2');
        $this->checkFile('themes/affiliates/Coupe_window/selectbutton_search.tpl', 'dedb23ce356b1b66377e648232dc2b8b');
        $this->checkFile('themes/affiliates/Coupe_window/send_to_friend.tpl', 'e7b902ca2beb79a6dab513cebf161a87');
        $this->checkFile('themes/affiliates/Coupe_window/set_new_password_form.tpl', '9270391a0892b67b03efbd67084806c6');
        $this->checkFile('themes/affiliates/Coupe_window/sidebar.tpl', '65226d7e25dcdca0cf71a9f3118d8139');
        $this->checkFile('themes/affiliates/Coupe_window/sidebar_closed.tpl', '3d903661713a9ee5fb402776ee06d310');
        $this->checkFile('themes/affiliates/Coupe_window/sidebar_gadget.tpl', '1f904859e056808c8826836a4e256761');
        $this->checkFile('themes/affiliates/Coupe_window/signup_fields.tpl', '16c26f808a27c220930859db1a454042');
        $this->checkFile('themes/affiliates/Coupe_window/signup_form.tpl', 'a55f02ab4d649b4eb23fbd252e3555fb');
        $this->checkFile('themes/affiliates/Coupe_window/signup_subaffiliates.tpl', '37eb3bcb00f8bbbc2f3b6c793c0b5a4d');
        $this->checkFile('themes/affiliates/Coupe_window/simple_filter.tpl', 'a55a1095bcbdbef9d9d9f5e2078b19a2');
        $this->checkFile('themes/affiliates/Coupe_window/simple_icon_object.tpl', 'bcbc9ea994d4aa8bbdee1eddc3ad19d8');
        $this->checkFile('themes/affiliates/Coupe_window/simple_popup_window.tpl', 'e7d6ad58d85a85eab20414bb734b8c81');
        $this->checkFile('themes/affiliates/Coupe_window/simplecolorpicker.tpl', '9c031fbdd2b35909faeea73e5f1203a1');
        $this->checkFile('themes/affiliates/Coupe_window/single_content_panel.tpl', '529d4a42f9106d91881f8b8b8e87748b');
        $this->checkFile('themes/affiliates/Coupe_window/size_format_widget.tpl', 'ebfb7db6718ec601af59a570d8e0ccb3');
        $this->checkFile('themes/affiliates/Coupe_window/start_button.tpl', '7aa2278c46b897536625cc042b4f5499');
        $this->checkFile('themes/affiliates/Coupe_window/statistics_double_value_widget.tpl', '7e243a39277ad97843b418e45881a6d2');
        $this->checkFile('themes/affiliates/Coupe_window/stats_chart.tpl', 'b5bb3d9a0dd5361a4e34e479aacf2480');
        $this->checkFile('themes/affiliates/Coupe_window/sub_aff_tree.tpl', '679faa77de04d865fc22b6c25fd48275');
        $this->checkFile('themes/affiliates/Coupe_window/sub_menu_section.tpl', 'ab7871c677c0d90bb2d878548157b628');
        $this->checkFile('themes/affiliates/Coupe_window/subaff_stats_no_data.tpl', 'f81af900ac8f9c419e2b3cf9742a1d69');
        $this->checkFile('themes/affiliates/Coupe_window/subaffiliate_sales_panel.tpl', '74f82f4ed0910799758338dbfc8630bc');
        $this->checkFile('themes/affiliates/Coupe_window/subaffiliates_filter.tpl', 'd929d7710df12abd81cff41504a91c08');
        $this->checkFile('themes/affiliates/Coupe_window/subaffiliates_panel.tpl', '471e8e9ee69c9cb55ec9e0bd689be941');
        $this->checkFile('themes/affiliates/Coupe_window/subaffiliates_sales_filter.tpl', '9f9fd28d6f934e3937e6551e0cfbf7fb');
        $this->checkFile('themes/affiliates/Coupe_window/subaffiliates_tree_panel.tpl', 'bd640ce415c67d2170ee88da05712f7b');
        $this->checkFile('themes/affiliates/Coupe_window/subaffstats_filter.tpl', '8d21355a05d7f8ee0da22c9c6e19f5b6');
        $this->checkFile('themes/affiliates/Coupe_window/subaffstats_list.tpl', '43e8f570edf8311ab5963d04432b98a7');
        $this->checkFile('themes/affiliates/Coupe_window/subid_tracking_screen.tpl', '1407cbdf136a2197520287e9c3bec51e');
        $this->checkFile('themes/affiliates/Coupe_window/system_menu.tpl', 'e4b4fa01982a97d8f747e7afe35283c0');
        $this->checkFile('themes/affiliates/Coupe_window/tab_item.tpl', 'd869bc1a3b8c511712e039399333d129');
        $this->checkFile('themes/affiliates/Coupe_window/tab_panel.tpl', '8c2853c4e62119a5b6f89c5e340af5d3');
        $this->checkFile('themes/affiliates/Coupe_window/task.tpl', '38a4b70b6456a12285be4bb113c72575');
        $this->checkFile('themes/affiliates/Coupe_window/taskbar.tpl', 'd7cf8ef7a71bf324aee5c1c7173afc7e');
        $this->checkFile('themes/affiliates/Coupe_window/template_form.tpl', '70fcacb2c2cab369cc096283d5784afa');
        $this->checkFile('themes/affiliates/Coupe_window/template_form_constants.tpl', '91c398393e519cf7c6a53ba758eefc47');
        $this->checkFile('themes/affiliates/Coupe_window/template_form_theme_entry.tpl', '91a40d5bfbb3ff3b61cd7771e24a2684');
        $this->checkFile('themes/affiliates/Coupe_window/template_form_themes.tpl', 'e7158c1782ef49ddbf3fbe671c5c5b8a');
        $this->checkFile('themes/affiliates/Coupe_window/template_form_variables.tpl', 'e1c008058f4be04a9e6e76ba72cc3290');
        $this->checkFile('themes/affiliates/Coupe_window/templates_form.tpl', '7a0a1baf13edabb10c8c6bef5a3dac41');
        $this->checkFile('themes/affiliates/Coupe_window/tests.tpl', '2e8601708f27cfadc9ee8a3454080aaf');
        $this->checkFile('themes/affiliates/Coupe_window/theme.php', 'b16c66507bfbc730babff8b48afffe8b');
        $this->checkFile('themes/affiliates/Coupe_window/theme_panel.tpl', '7fea066d8d557fce572b77f00240cebc');
        $this->checkFile('themes/affiliates/Coupe_window/theme_settings.tpl', '5c596388ecc46c2ac89c029f811f565e');
        $this->checkFile('themes/affiliates/Coupe_window/tooltip_popup.tpl', 'e4a5b50c70875ee64d9fdf4f88fa8045');
        $this->checkFile('themes/affiliates/Coupe_window/topmenu_logged.stpl', '3309092595865ba40186a7d7c009226b');
        $this->checkFile('themes/affiliates/Coupe_window/topmenu_notlogged.stpl', 'fa06a5615600582c22cc5f57ee59ba94');
        $this->checkFile('themes/affiliates/Coupe_window/topurl_list.tpl', 'f108c2b8e2583a45a2016869735c87d3');
        $this->checkFile('themes/affiliates/Coupe_window/traffic_stats_gadget.tpl', '0a2882140e9f850399b2a0c198b9ad98');
        $this->checkFile('themes/affiliates/Coupe_window/traffic_stats_in_gadget.tpl', 'ae38670c7e593de4a995af34968842b1');
        $this->checkFile('themes/affiliates/Coupe_window/transaction_list.tpl', 'eb31bc8e7c91183f1520cf00d057d1cc');
        $this->checkFile('themes/affiliates/Coupe_window/transaction_list_filter_base.tpl', 'efb3de54e7fc05e3bd0581cb5dfd8c1c');
        $this->checkFile('themes/affiliates/Coupe_window/trash.tpl', '270d020eabfcf284be7a97e7102924d5');
        $this->checkFile('themes/affiliates/Coupe_window/tree_affiliate_widget.tpl', '0f7a52f0b26bda649f60e2a994645e98');
        $this->checkFile('themes/affiliates/Coupe_window/trend_actions_stats.tpl', '87efaeae069ec2872a33fe3e755a30e7');
        $this->checkFile('themes/affiliates/Coupe_window/trend_actions_stats_widget.tpl', '7c26676ceb09baf3fafeb0dba3bdaec4');
        $this->checkFile('themes/affiliates/Coupe_window/trend_stats.tpl', 'bd3333acced97fe829f3458bcd108bf8');
        $this->checkFile('themes/affiliates/Coupe_window/trends_report.stpl', '18264d58de48af1de2b77137b0df48fb');
        $this->checkFile('themes/affiliates/Coupe_window/trends_report.tpl', '078803b3f100dafeb1d773060290ff63');
        $this->checkFile('themes/affiliates/Coupe_window/trends_report_action.stpl', '929fa1c9535d05f1e8a0492013b9de33');
        $this->checkFile('themes/affiliates/Coupe_window/trends_report_filter.tpl', '18ce8dcf794b1fff579521fbadb505a7');
        $this->checkFile('themes/affiliates/Coupe_window/trends_report_no_data.tpl', '9d1dd7b6d3ef5f6ada42de2c7d182df2');
        $this->checkFile('themes/affiliates/Coupe_window/update_version.stpl', '5602f52fe8248df474201a16c922048f');
        $this->checkFile('themes/affiliates/Coupe_window/upload_panel.tpl', '222a0dd80ab37bb49060da0cf7eaf447');
        $this->checkFile('themes/affiliates/Coupe_window/uploaded_file.tpl', 'fad11b13e3b41eff41a129b1af232e7e');
        $this->checkFile('themes/affiliates/Coupe_window/user_edit.tpl', 'f41ba1817ee0d15f16c57dff5be39bb1');
        $this->checkFile('themes/affiliates/Coupe_window/validity.tpl', 'fbf29129f480c05f2f02e8d69bd1ccf9');
        $this->checkFile('themes/affiliates/Coupe_window/view_form.tpl', '923d4fc8de0546c10e788de580b3562b');
        $this->checkFile('themes/affiliates/Coupe_window/visits_sales_logs_no_data.tpl', '969b350cc45c6f7c68fa6322e98a3de1');
        $this->checkFile('themes/affiliates/Coupe_window/wallpaper_add_custom.tpl', '2210741b569ef188fa352c977a289261');
        $this->checkFile('themes/affiliates/Coupe_window/wallpaper_entry.tpl', 'c24d10203224f47e2b385b0fff40c2d5');
        $this->checkFile('themes/affiliates/Coupe_window/wallpaper_settings.tpl', 'd160dbed38556231aeac49a96213e4d4');
        $this->checkFile('themes/affiliates/Coupe_window/window.tpl', '2391705887d707e05187606c4a819e73');
        $this->checkFile('themes/affiliates/Coupe_window/window_bottom_left.tpl', 'd14b545c27afa02ab7a919bdeb4c9470');
        $this->checkFile('themes/affiliates/Coupe_window/window_empty_content.tpl', 'b1535ec719cada5b9f5d98849074b9bd');
        $this->checkFile('themes/affiliates/Coupe_window/window_header.tpl', '02a337d4184c3924a2792a84493794cc');
        $this->checkFile('themes/affiliates/Coupe_window/window_header_refresh.tpl', 'fcd47f4585abcac3c3a61ee3991379bc');
        $this->checkFile('themes/affiliates/Coupe_window/window_left.tpl', '984d69649ec171a5c6b522e795feb904');
        $this->checkFile('themes/affiliates/Coupe_window/window_move_panel.tpl', 'f5bbd373a758bf76e6efadc94dca4b11');
        $this->checkFile('themes/affiliates/Coupe_window/wizard_panel.tpl', '3142ce6354cb3e1c86b6c13c1d906189');
        $this->checkFile('themes/affiliates/Dash/README.txt', 'c5e378c3027a6b4f00637e35fa00d549');
        $this->checkFile('themes/affiliates/Dash/advanced_screen.tpl', '3cbda4ba3c4fdd78e8a50a2af11fde70');
        $this->checkFile('themes/affiliates/Dash/affiliate_edit_details_additional.tpl', 'd984176b8e43b8c22223802b16dbad94');
        $this->checkFile('themes/affiliates/Dash/affiliate_theme_settings.tpl', 'ad58869b2b84d778c8bbc1329896e132');
        $this->checkFile('themes/affiliates/Dash/affiliate_tutorial_video.tpl', 'f391e407ae3be8b719a1ad218d0c5824');
        $this->checkFile('themes/affiliates/Dash/afflink_protector_screen.tpl', '143ad5c37c3d174315ae54f0f238f71e');
        $this->checkFile('themes/affiliates/Dash/banner_filter.tpl', '4760bd411c89422a1bdda919efc086b1');
        $this->checkFile('themes/affiliates/Dash/banner_stats_filter.tpl', 'c342d2f202a02e732dee7b05a295978b');
        $this->checkFile('themes/affiliates/Dash/banner_stats_list.tpl', '871b5198402d7bf61abc4606e68729f9');
        $this->checkFile('themes/affiliates/Dash/banners.tpl', 'd9be4dda29dee7e968a0bde2e5f594f8');
        $this->checkFile('themes/affiliates/Dash/broadcast_email.tpl', '3198d32e4b3e1d2ff0eeb9759d74844c');
        $this->checkFile('themes/affiliates/Dash/campaign_filter.tpl', '97d8fa0311dc58b4408ca9b65d1097dd');
        $this->checkFile('themes/affiliates/Dash/campaign_stats_filter.tpl', '2b6e28bb38f9cee07e3a7135fddee70b');
        $this->checkFile('themes/affiliates/Dash/campaign_stats_list.tpl', 'f66146fc0fbf7eeafd3e8d7c4eab70ba');
        $this->checkFile('themes/affiliates/Dash/campaign_tracking_codes.tpl', '871194226e22cc5d6256a03b2ffc3530');
        $this->checkFile('themes/affiliates/Dash/campaign_tracking_codes_filter.tpl', '7314306fc48c07a75fb759d4279a936a');
        $this->checkFile('themes/affiliates/Dash/campaigns_filter.tpl', '692a896ffc1e91e95c47861416690497');
        $this->checkFile('themes/affiliates/Dash/campaigns_list.tpl', 'ba6bd8d681ee99855a0aa1405fedc1fd');
        $this->checkFile('themes/affiliates/Dash/channel_stats_filter.tpl', '33780a17f47df46989004280f73e9f7d');
        $this->checkFile('themes/affiliates/Dash/channel_stats_panel.tpl', '492444f45797c3a0df419c63c77d0a90');
        $this->checkFile('themes/affiliates/Dash/channels_panel.tpl', '2b40bfe86742f3de8835b3132bd26d20');
        $this->checkFile('themes/affiliates/Dash/clicks_list.tpl', 'b01219873d68594dc414ebf731fa7a91');
        $this->checkFile('themes/affiliates/Dash/clicks_list_filter_base.tpl', '61fbc9df345acda35c7c8546eb9813f1');
        $this->checkFile('themes/affiliates/Dash/contact_us.tpl', 'cbc621bf1f1e06e9c47bf331cecde2e4');
        $this->checkFile('themes/affiliates/Dash/custom/advanced_tracking.tpl', 'd15160adfaa12cebb74d846eac731a70');
        $this->checkFile('themes/affiliates/Dash/custom/directlink_explained.tpl', 'f2cd62d49bdbeef23945d78f1c138fc5');
        $this->checkFile('themes/affiliates/Dash/custom/frequently_asked_questions.tpl', '632217d18b86b68640f2663e399b9d30');
        $this->checkFile('themes/affiliates/Dash/custom/getting_started.tpl', '0a2ec830c56d6a289eed2744452d0945');
        $this->checkFile('themes/affiliates/Dash/custom/promotion_tips.tpl', '4ee4330c8baa4e3071a16471fb268e0e');
        $this->checkFile('themes/affiliates/Dash/custom.css', '4877ef2467745239a93ebe1e79b2f813');
        $this->checkFile('themes/affiliates/Dash/daily_report.tpl', '1a52f8984957039c5de86e50b53b5273');
        $this->checkFile('themes/affiliates/Dash/daily_report_filter.tpl', '5e3add7cd2c4e8a7c150452d8e99861e');
        $this->checkFile('themes/affiliates/Dash/direct_link_form.tpl', 'b14d464dbcaac59248771ac5db562fdd');
        $this->checkFile('themes/affiliates/Dash/direct_linking_panel.tpl', '747a111348d8fae2bd13ada3ff43caec');
        $this->checkFile('themes/affiliates/Dash/direct_links_screen.tpl', '505e876dd646825d1b25934a5a6c8f99');
        $this->checkFile('themes/affiliates/Dash/download_login_form.tpl', 'a4a9fc7f0a5013f181ccacad70e40a20');
        $this->checkFile('themes/affiliates/Dash/download_signup_form.tpl', 'b83712dbf467ae3b3257a3dbbfa93494');
        $this->checkFile('themes/affiliates/Dash/dynamic_link_panel.tpl', '7e8d0f31838a8ffd1d3bb8f8e984d043');
        $this->checkFile('themes/affiliates/Dash/email_form.tpl', '6e6382058bad8a628360d20b84699981');
        $this->checkFile('themes/affiliates/Dash/email_notifications.tpl', '0f0aae344ace4ddecf45b47929d802a9');
        $this->checkFile('themes/affiliates/Dash/filter.tpl', 'cc93c246e4fd3e0acfb93c5eeeaef8ee');
        $this->checkFile('themes/affiliates/Dash/filter_field_decorator.tpl', '0afa75f69e50c2a31dc1a1987dbf050f');
        $this->checkFile('themes/affiliates/Dash/financial_overview.tpl', '0adf68a6054325c7b5070117eada64de');
        $this->checkFile('themes/affiliates/Dash/footer.stpl', '3fbd103789f1ff2a151c16f490a913dd');
        $this->checkFile('themes/affiliates/Dash/header.stpl', 'ae862a12eeff63f7827bcb4edf7e7bf9');
        $this->checkFile('themes/affiliates/Dash/home.tpl', '3e1cbe1fe7811dccb519ac494fcbe060');
        $this->checkFile('themes/affiliates/Dash/icons_panel_with_header.tpl', '36294e05dea06c7ad45c5910401e1a6b');
        $this->checkFile('themes/affiliates/Dash/img/box_divider.png', '88ec74dba62142217c8daddbd30ad9ec');
        $this->checkFile('themes/affiliates/Dash/img/config-hover.png', '0e622df8cefda5590d2e187f7732d956');
        $this->checkFile('themes/affiliates/Dash/img/feature_icon.png', '47556c7aac8fcae73b927a914c2e45f0');
        $this->checkFile('themes/affiliates/Dash/img/header_divider.png', '9c04ac8b0e24b7815be8feda5e810d14');
        $this->checkFile('themes/affiliates/Dash/img/icon-about-big.png', '428601da0d9ba4c3deea1b57259f53d9');
        $this->checkFile('themes/affiliates/Dash/img/icon-about-middle.png', '6fc0eace07b68020677f7fb7c2181588');
        $this->checkFile('themes/affiliates/Dash/img/icon-about-small.png', 'd7c377c6c1839c02d8ff4c08241d059e');
        $this->checkFile('themes/affiliates/Dash/img/icon-accounting-big.png', 'fa93f5c4b60b9d095a2a23a52211168e');
        $this->checkFile('themes/affiliates/Dash/img/icon-accounting-middle.png', 'ce15d7fe919f3baccb7ec11e8871de17');
        $this->checkFile('themes/affiliates/Dash/img/icon-accounting-small.png', 'a14dd58b2eff427007308e6c395da74f');
        $this->checkFile('themes/affiliates/Dash/img/icon-actioncommision-big.png', 'b7245ce1da39458df4478fb97c2ec907');
        $this->checkFile('themes/affiliates/Dash/img/icon-actioncommision-middle.png', '7eb0586f935a67af185020db03ee57ec');
        $this->checkFile('themes/affiliates/Dash/img/icon-actioncommision-small.png', '50647c7a2ce6e87c05e67856140a01be');
        $this->checkFile('themes/affiliates/Dash/img/icon-admins-big.png', '57361cd2d4a488cd2eed00831b26bd5f');
        $this->checkFile('themes/affiliates/Dash/img/icon-admins-middle.png', '244601e0d1d7647625e1bd20ca1d56d3');
        $this->checkFile('themes/affiliates/Dash/img/icon-admins-small.png', '039ecbce68831dfb1dce0752932bf5a6');
        $this->checkFile('themes/affiliates/Dash/img/icon-advancedfunc-big.png', '8691f9054949c63439b1c099c849fe37');
        $this->checkFile('themes/affiliates/Dash/img/icon-advancedfunc-middle.png', '25cd291870396e2b6cf06a30b3040836');
        $this->checkFile('themes/affiliates/Dash/img/icon-advancedfunc-small.png', 'f224df62fe414aa5b654a2aa9c9083ca');
        $this->checkFile('themes/affiliates/Dash/img/icon-advancedtracking.png', '5e5ea91bd67ccdb99100698735397963');
        $this->checkFile('themes/affiliates/Dash/img/icon-affiliateadd-big.png', 'd5c7131c1975085da373524f57febc48');
        $this->checkFile('themes/affiliates/Dash/img/icon-affiliateadd-middle.png', 'bddd0c46250303debbcdd13164d88964');
        $this->checkFile('themes/affiliates/Dash/img/icon-affiliateadd-small.png', '050c51fd19d53154f31252c2cec060c8');
        $this->checkFile('themes/affiliates/Dash/img/icon-affiliatesettings-big.png', '6a8d19a4c2a2f49b7a483eb554c67a7e');
        $this->checkFile('themes/affiliates/Dash/img/icon-affiliatesettings-middle.png', 'bff4513cb0ac7fc3651376312da1dacb');
        $this->checkFile('themes/affiliates/Dash/img/icon-affiliatesettings-small.png', '477ab1aa47a3b25ec0edff418f3829c0');
        $this->checkFile('themes/affiliates/Dash/img/icon-affiliateslist-big.png', '8531931a1a8deec989a128b251b7d8f5');
        $this->checkFile('themes/affiliates/Dash/img/icon-affiliateslist-middle.png', '9869e3506102a1fd354c780332b50b9f');
        $this->checkFile('themes/affiliates/Dash/img/icon-affiliateslist-small.png', 'd4c2e1649a26e4fd19dc1960dddbbd34');
        $this->checkFile('themes/affiliates/Dash/img/icon-affiliatesoverview-big.png', '108370d42effb2502ba4ea4c947518f0');
        $this->checkFile('themes/affiliates/Dash/img/icon-affiliatesoverview-middle.png', '24ee97e9eac08324347d2ed61b2b1b44');
        $this->checkFile('themes/affiliates/Dash/img/icon-affiliatesoverview-small.png', 'f9e1bdcc59800c0c103b55291d10018c');
        $this->checkFile('themes/affiliates/Dash/img/icon-affiliatetree-big.png', 'f3a3935903ffd1fc62078a69c94b3e96');
        $this->checkFile('themes/affiliates/Dash/img/icon-affiliatetree-middle.png', '297f228e008b762991c0c9586523d3ea');
        $this->checkFile('themes/affiliates/Dash/img/icon-affiliatetree-small.png', '987817c468127c8b45d72d965b8f808a');
        $this->checkFile('themes/affiliates/Dash/img/icon-afflinkprotector-big.png', '41210425d22e80b3415aa664b00d398a');
        $this->checkFile('themes/affiliates/Dash/img/icon-afflinkprotector-middle.png', 'b00984ccb6a7693b671b57697c37f62e');
        $this->checkFile('themes/affiliates/Dash/img/icon-afflinkprotector-small.png', '8a6ca0c7bed131e76f4fae31000201ab');
        $this->checkFile('themes/affiliates/Dash/img/icon-affpanel-big.png', 'ad0c3f7baf452316627482ce47ec9b37');
        $this->checkFile('themes/affiliates/Dash/img/icon-affpanel-middle.png', 'ffc44262a749e2bdcd5ee4a030dc9e91');
        $this->checkFile('themes/affiliates/Dash/img/icon-affpanel-small.png', '89acee5cdf219cfb2d1400d3b4a248a5');
        $this->checkFile('themes/affiliates/Dash/img/icon-apiintegration-big.png', '702515b8933c9c7ed457d3280ea8e340');
        $this->checkFile('themes/affiliates/Dash/img/icon-apiintegration-middle.png', 'd37af643a7d0e045a121f291388c91fd');
        $this->checkFile('themes/affiliates/Dash/img/icon-apiintegration-small.png', '676c13fdb6c683af387767cb1789df66');
        $this->checkFile('themes/affiliates/Dash/img/icon-banneradd-big.png', '1f5c8423f1a329ac06e2929dfee1b7e3');
        $this->checkFile('themes/affiliates/Dash/img/icon-banneradd-middle.png', '6ff2ef8a8bddee3f52187074ffbf0b5e');
        $this->checkFile('themes/affiliates/Dash/img/icon-banneradd-small.png', 'b3d8b98e27e2b98f160deae84ef556c2');
        $this->checkFile('themes/affiliates/Dash/img/icon-banners-big.png', 'a13d36f6a14c4059befca90c969d12ee');
        $this->checkFile('themes/affiliates/Dash/img/icon-banners-middle.png', '9c4cb78b0c5441a5ac15300afd4a301a');
        $this->checkFile('themes/affiliates/Dash/img/icon-banners-small.png', '5ba134d161fe9424b876e7e50511d7dc');
        $this->checkFile('themes/affiliates/Dash/img/icon-bannerscategories-big.png', 'a310cda6bf44049c1b0dd3d203e06140');
        $this->checkFile('themes/affiliates/Dash/img/icon-bannerscategories-small.png', 'ae5c90546f68383ca6471da4a36870da');
        $this->checkFile('themes/affiliates/Dash/img/icon-bannerslist-big.png', '1bf599dbf6524cb922f1f09e4bbda116');
        $this->checkFile('themes/affiliates/Dash/img/icon-bannerslist-middle.png', '68dc7a4fda17deebdfb1d83119a1670a');
        $this->checkFile('themes/affiliates/Dash/img/icon-bannerslist-small.png', 'c8f299bb45397ccdaecb7df3c9600ffe');
        $this->checkFile('themes/affiliates/Dash/img/icon-bannersoverview-big.png', '8c7b4be8a563f9d0f8c657fbd7b064c0');
        $this->checkFile('themes/affiliates/Dash/img/icon-bannersoverview-middle.png', '9c4cb78b0c5441a5ac15300afd4a301a');
        $this->checkFile('themes/affiliates/Dash/img/icon-bannersoverview-small.png', 'b70ada457ab1c9981f8ab4bef5653e7e');
        $this->checkFile('themes/affiliates/Dash/img/icon-bannersscategories-middle.png', '2c5dfa811b4f68b71eb3c78dc0e353ce');
        $this->checkFile('themes/affiliates/Dash/img/icon-broadcastemail-big.png', '1d2cfa3b506deb6280ebf4cc98b8c010');
        $this->checkFile('themes/affiliates/Dash/img/icon-broadcastemail-middle.png', 'f85bf24631dcc851559f51b9568c0f75');
        $this->checkFile('themes/affiliates/Dash/img/icon-broadcastemail-small.png', '11b04a9929cd413f1cb3fce70c717a30');
        $this->checkFile('themes/affiliates/Dash/img/icon-calccommission-big.png', '7086ebb3d568dcb605be0e4a0924896b');
        $this->checkFile('themes/affiliates/Dash/img/icon-calccommission-middle.png', 'c4f5035411491e3a26d8fffe23b20b24');
        $this->checkFile('themes/affiliates/Dash/img/icon-calccommission-small.png', 'b0f099674dc9c78dfa40e32a832a3b0a');
        $this->checkFile('themes/affiliates/Dash/img/icon-calcsettings-big.png', '89d5be624ffbbc8474f2b8030c1cb92e');
        $this->checkFile('themes/affiliates/Dash/img/icon-calcsettings-middle.png', '90836a1a3f58251a18bf1c3df92e483a');
        $this->checkFile('themes/affiliates/Dash/img/icon-calcsettings-small.png', 'b963cdbae235cc78f68a8acfef8bc6e4');
        $this->checkFile('themes/affiliates/Dash/img/icon-campaignadd-big.png', '69354264e1b50b1f050b35af8a1aebb5');
        $this->checkFile('themes/affiliates/Dash/img/icon-campaignadd-middle.png', '1b8fd564ff105aab6e578391a528aad2');
        $this->checkFile('themes/affiliates/Dash/img/icon-campaignadd-small.png', '9b4aae84c0f775bb20507a1414da70e1');
        $this->checkFile('themes/affiliates/Dash/img/icon-campaignscategories-big.png', 'a310cda6bf44049c1b0dd3d203e06140');
        $this->checkFile('themes/affiliates/Dash/img/icon-campaignscategories-middle.png', '2c5dfa811b4f68b71eb3c78dc0e353ce');
        $this->checkFile('themes/affiliates/Dash/img/icon-campaignscategories-small.png', 'ae5c90546f68383ca6471da4a36870da');
        $this->checkFile('themes/affiliates/Dash/img/icon-campaignslist-big.png', 'a52bc02f28d4f56220c320c6574f8f9c');
        $this->checkFile('themes/affiliates/Dash/img/icon-campaignslist-middle.png', '569ab60e0e3ff10de816f1571925b5b6');
        $this->checkFile('themes/affiliates/Dash/img/icon-campaignslist-small.png', '193e4f56908fa9d045972749abc9780c');
        $this->checkFile('themes/affiliates/Dash/img/icon-campaignsoverview-big.png', 'ed8ad85caf2c1ff8c34dfdefb67965ed');
        $this->checkFile('themes/affiliates/Dash/img/icon-campaignsoverview-middle.png', '6b3d072dd8c3d965eb097b66da7fcd54');
        $this->checkFile('themes/affiliates/Dash/img/icon-campaignsoverview-small.png', '6df551a67a7077c5220e6b609359857a');
        $this->checkFile('themes/affiliates/Dash/img/icon-channels-big.png', 'f76d1d8030637adbfa2981b132f80d96');
        $this->checkFile('themes/affiliates/Dash/img/icon-channels-middle.png', '0a13491607b6fbc88a946f43b7bafdb4');
        $this->checkFile('themes/affiliates/Dash/img/icon-channels-small.png', '03cfb7b9ad94827a4d0bf8336e7e52c0');
        $this->checkFile('themes/affiliates/Dash/img/icon-channelstatsreport-big.png', '4b1c13143a301c246e9fcef695e58666');
        $this->checkFile('themes/affiliates/Dash/img/icon-channelstatsreport-middle.png', '12b291a0caf561e006ca5535d9e09ba8');
        $this->checkFile('themes/affiliates/Dash/img/icon-channelstatsreport-small.png', '302858f05a10b04f087efe27052206fe');
        $this->checkFile('themes/affiliates/Dash/img/icon-clickcommission-big.png', '7da264525cc0d547db7d68817639093e');
        $this->checkFile('themes/affiliates/Dash/img/icon-clickcommission-middle.png', '10e5545ae349e632483b1860544e010b');
        $this->checkFile('themes/affiliates/Dash/img/icon-clickcommission-small.png', '2d37adb9026b332a059618cc27896c47');
        $this->checkFile('themes/affiliates/Dash/img/icon-clickslist-big.png', 'fbda1422f6bd873d56894c1d7d95ba4f');
        $this->checkFile('themes/affiliates/Dash/img/icon-clickslist-middle.png', 'a0b0d63612a9f48cf42c93f9fa3ed316');
        $this->checkFile('themes/affiliates/Dash/img/icon-clickslist-small.png', 'e6570b0542c57f628986082628994f72');
        $this->checkFile('themes/affiliates/Dash/img/icon-clickstracking-big.png', '14d844dae72c0e0511edd4ea5cf7a47a');
        $this->checkFile('themes/affiliates/Dash/img/icon-clickstracking-middle.png', '94dc574d346a486ff452ec7f093e3673');
        $this->checkFile('themes/affiliates/Dash/img/icon-clickstracking-small.png', '6aa780ce3413adaa4ac15e7bd95c3958');
        $this->checkFile('themes/affiliates/Dash/img/icon-commissionadd-big.png', '622fad726c5bbc696241898640e20926');
        $this->checkFile('themes/affiliates/Dash/img/icon-commissionadd-middle.png', '3f8f3b9b892e851a200c6f02b9e7165e');
        $this->checkFile('themes/affiliates/Dash/img/icon-commissionadd-small.png', '80f1404144c2a625bcc331a5e5263eab');
        $this->checkFile('themes/affiliates/Dash/img/icon-commissionslist-big.png', '0195a700dbe8d2c3ac1608f3cd883ad0');
        $this->checkFile('themes/affiliates/Dash/img/icon-commissionslist-middle.png', '304c4f5a092da2d081683196a011e14d');
        $this->checkFile('themes/affiliates/Dash/img/icon-commissionslist-small.png', 'b08f72525311b61be001eb1604554eeb');
        $this->checkFile('themes/affiliates/Dash/img/icon-commreport-big.png', 'f4fce1db7a0c10e677de57dc38a2609e');
        $this->checkFile('themes/affiliates/Dash/img/icon-commreport-middle.png', '57b04030103cf97fbe0d92a731e85e12');
        $this->checkFile('themes/affiliates/Dash/img/icon-commreport-small.png', 'dcab4d1c0b0faf44f649a819071a0487');
        $this->checkFile('themes/affiliates/Dash/img/icon-communication-big.png', '5accfde00d1b34b6e771d0faebc2b1b6');
        $this->checkFile('themes/affiliates/Dash/img/icon-communication-middle.png', 'b4253d4909fd0a0cbafa4f813429d8fa');
        $this->checkFile('themes/affiliates/Dash/img/icon-communication-small.png', 'cebe3e7324bb0d86051f9cbdedfd6ecb');
        $this->checkFile('themes/affiliates/Dash/img/icon-configuration-big.png', '2cddf90ad25270348ab96a6d9d874152');
        $this->checkFile('themes/affiliates/Dash/img/icon-configuration-middle.png', '55ac5018150298f812e2765a19550fdc');
        $this->checkFile('themes/affiliates/Dash/img/icon-configuration-small.png', '7b0623ad383b0246f58aa6bc45277678');
        $this->checkFile('themes/affiliates/Dash/img/icon-confirmationrequired-big.png', '90210b42d7d84c2185a4a0643454a9fa');
        $this->checkFile('themes/affiliates/Dash/img/icon-confirmationrequired-middle.png', '1e661972fb77bd24788d319eecd4e962');
        $this->checkFile('themes/affiliates/Dash/img/icon-confirmationrequired-small.png', '02c4ce14907c147b902e83da8c2f2abb');
        $this->checkFile('themes/affiliates/Dash/img/icon-contactus-big.png', '925ea74565475d763da214a66848d090');
        $this->checkFile('themes/affiliates/Dash/img/icon-contactus-middle.png', '35a5a52620dcf4421b3603850ad86ed9');
        $this->checkFile('themes/affiliates/Dash/img/icon-contactus-small.png', 'e62035b9b08fd22200b9d0e63401a66b');
        $this->checkFile('themes/affiliates/Dash/img/icon-content-big.png', '428601da0d9ba4c3deea1b57259f53d9');
        $this->checkFile('themes/affiliates/Dash/img/icon-content-middle.png', '6fc0eace07b68020677f7fb7c2181588');
        $this->checkFile('themes/affiliates/Dash/img/icon-content-small.png', 'd7c377c6c1839c02d8ff4c08241d059e');
        $this->checkFile('themes/affiliates/Dash/img/icon-cookie-big.png', '3438d09467e579a8cd77d73556add8fe');
        $this->checkFile('themes/affiliates/Dash/img/icon-cookie-middle.png', '651796ee7b2dea8243a37517fbf62250');
        $this->checkFile('themes/affiliates/Dash/img/icon-cookie-small.png', '56bec98a07cb2dac95671393cda6c0d5');
        $this->checkFile('themes/affiliates/Dash/img/icon-cron-big.png', '854e5c2afb7981b64009af910cb91c2a');
        $this->checkFile('themes/affiliates/Dash/img/icon-cron-middle.png', '5d5b7a8b3068b16613bd526011b4095e');
        $this->checkFile('themes/affiliates/Dash/img/icon-cron-small.png', '21af15916c7cb3887c3579a6362c34e3');
        $this->checkFile('themes/affiliates/Dash/img/icon-currency-big.png', '599af390c3935dfadab5c6c8a36d717a');
        $this->checkFile('themes/affiliates/Dash/img/icon-currency-middle.png', '23b48ed1f7c7d581105b15eb1aed05c0');
        $this->checkFile('themes/affiliates/Dash/img/icon-currency-small.png', 'e00d0f217b9c13089a324ebb2a4a276c');
        $this->checkFile('themes/affiliates/Dash/img/icon-dailyreports-big.png', '51f3e844ba86a439576661e6fd24ab10');
        $this->checkFile('themes/affiliates/Dash/img/icon-dailyreports-middle.png', '1f48d2a78e794508530ccb2d8fa24fc4');
        $this->checkFile('themes/affiliates/Dash/img/icon-dailyreports-small.png', 'b69fc28548f6ca7ae3f46bb3006a333e');
        $this->checkFile('themes/affiliates/Dash/img/icon-databasestats-big.png', '92877608b8101fc8f19d6c73c66cf678');
        $this->checkFile('themes/affiliates/Dash/img/icon-databasestats-middle.png', 'a647326ebbdfa5a7edf8add89a4f6c04');
        $this->checkFile('themes/affiliates/Dash/img/icon-databasestats-small.png', '878c6102aacf869afa9faf11f88edfa3');
        $this->checkFile('themes/affiliates/Dash/img/icon-dialog-big.png', '90210b42d7d84c2185a4a0643454a9fa');
        $this->checkFile('themes/affiliates/Dash/img/icon-dialog-middle.png', '1e661972fb77bd24788d319eecd4e962');
        $this->checkFile('themes/affiliates/Dash/img/icon-dialog-small.png', '02c4ce14907c147b902e83da8c2f2abb');
        $this->checkFile('themes/affiliates/Dash/img/icon-directlink-big.png', 'c278ffcff33c372f76a7e60decf69bb1');
        $this->checkFile('themes/affiliates/Dash/img/icon-directlink-middle.png', '347f26a3d31903a3fbf53650c525a329');
        $this->checkFile('themes/affiliates/Dash/img/icon-directlink-small.png', 'ba793d7acb6322f1cf6ad3ce700fb640');
        $this->checkFile('themes/affiliates/Dash/img/icon-directlinksmanager-big.png', 'c278ffcff33c372f76a7e60decf69bb1');
        $this->checkFile('themes/affiliates/Dash/img/icon-directlinksmanager-middle.png', '347f26a3d31903a3fbf53650c525a329');
        $this->checkFile('themes/affiliates/Dash/img/icon-directlinksmanager-small.png', 'ba793d7acb6322f1cf6ad3ce700fb640');
        $this->checkFile('themes/affiliates/Dash/img/icon-emailnotification-big.png', '24e0fa4c00e137fac96db534320154db');
        $this->checkFile('themes/affiliates/Dash/img/icon-emailnotification-middle.png', 'afdc9afa184892bbcec0b84b3c6f3cd5');
        $this->checkFile('themes/affiliates/Dash/img/icon-emailnotification-small.png', '9f5a038c227bbedcfc87ddcc568dd96c');
        $this->checkFile('themes/affiliates/Dash/img/icon-emailsettings-big.png', '9f5d46acd00fb265ebbd545c32f3d9e2');
        $this->checkFile('themes/affiliates/Dash/img/icon-emailsettings-middle.png', 'a9332d19d58bc0690331e2df4d19ccce');
        $this->checkFile('themes/affiliates/Dash/img/icon-emailsettings-small.png', '727f303733ffea427cc17427fcad1c2c');
        $this->checkFile('themes/affiliates/Dash/img/icon-emailtemplates-big.png', 'd0518c39e49dc80897d0f691060f1142');
        $this->checkFile('themes/affiliates/Dash/img/icon-emailtemplates-middle.png', 'a2c81f3a5b895097eef35d722506bef3');
        $this->checkFile('themes/affiliates/Dash/img/icon-emailtemplates-small.png', '1d78171288453cbc025021098d1b4982');
        $this->checkFile('themes/affiliates/Dash/img/icon-eventlog-big.png', 'bbfa889e79729293e1303ed0a2ffe309');
        $this->checkFile('themes/affiliates/Dash/img/icon-eventlog-middle.png', '50b3620c109dce278f12f8b2b340674f');
        $this->checkFile('themes/affiliates/Dash/img/icon-eventlog-small.png', '3ca1dafbb4a2e956fdb9808be6b45f82');
        $this->checkFile('themes/affiliates/Dash/img/icon-export-big.png', '35be33047c8e02e1a32d55be841a65d5');
        $this->checkFile('themes/affiliates/Dash/img/icon-export-middle.png', '660f811c7fce5d3cb64739e3139cdd8b');
        $this->checkFile('themes/affiliates/Dash/img/icon-export-small.png', '9835074ca5282cfeba17b8d7a036294a');
        $this->checkFile('themes/affiliates/Dash/img/icon-exportfiles-big.png', '6ad2c2691a3ce2edb276ac28ee77f621');
        $this->checkFile('themes/affiliates/Dash/img/icon-exportfiles-middle.png', '2aebf5fe0283ca6b536ea69c0db30151');
        $this->checkFile('themes/affiliates/Dash/img/icon-exportfiles-small.png', '8a1316abaf6351d2ba61a39ca628eab2');
        $this->checkFile('themes/affiliates/Dash/img/icon-faq.png', 'f084e3b93bd5de7793716bfe94862d4f');
        $this->checkFile('themes/affiliates/Dash/img/icon-features-big.png', 'dd45e0325fdac4e3d98c24b36e30bf19');
        $this->checkFile('themes/affiliates/Dash/img/icon-features-middle.png', '7c23951c67dfd1c6b45eaba392c73b22');
        $this->checkFile('themes/affiliates/Dash/img/icon-features-small.png', '39df80c8c1eb1bf6b29fa100ebad750d');
        $this->checkFile('themes/affiliates/Dash/img/icon-folder-big.png', '964b4525aa06127c52b84a589049c3b8');
        $this->checkFile('themes/affiliates/Dash/img/icon-folder-middle.png', '1f85a4d29265faf9aa15862b7ed1d7a3');
        $this->checkFile('themes/affiliates/Dash/img/icon-folder-small.png', '365a922fabd91c200543597d98cf0564');
        $this->checkFile('themes/affiliates/Dash/img/icon-foldergrey-big.png', 'e1942d05c09d21e20e56c094002f1fa0');
        $this->checkFile('themes/affiliates/Dash/img/icon-foldergrey-middle.png', '0bc47f85c8177d32d7993a2c2604c408');
        $this->checkFile('themes/affiliates/Dash/img/icon-foldergrey-small.png', '55104fb0a0d0492c26055bf2ba7c4f00');
        $this->checkFile('themes/affiliates/Dash/img/icon-fraudprotection-big.png', '0f46b039dc06851045f36d4e9eb378e2');
        $this->checkFile('themes/affiliates/Dash/img/icon-fraudprotection-middle.png', '8bcb3f94b6ead9502d5498a28fb17257');
        $this->checkFile('themes/affiliates/Dash/img/icon-fraudprotection-small.png', '697acc0f7c159c13072eaae0033af2d4');
        $this->checkFile('themes/affiliates/Dash/img/icon-gettingstarted-big.png', 'd197bbf5a9900bb8d536e66afed03206');
        $this->checkFile('themes/affiliates/Dash/img/icon-gettingstarted-middle.png', '74997aac35c7c4f12c8fc0e7fc014e30');
        $this->checkFile('themes/affiliates/Dash/img/icon-gettingstarted-small.png', '62ecdf49ec3da0bfad4211057e6e051e');
        $this->checkFile('themes/affiliates/Dash/img/icon-help-big.png', '5b04efbf4559f7d56773ade80e8923c7');
        $this->checkFile('themes/affiliates/Dash/img/icon-help-middle.png', '38204f96fa196244e088a8c095f0dca1');
        $this->checkFile('themes/affiliates/Dash/img/icon-help-small.png', '61d96309c23e3ed484a8cb498313d9e4');
        $this->checkFile('themes/affiliates/Dash/img/icon-home-big.png', '8c15857acaf46bf2bca9ee23ca005fdb');
        $this->checkFile('themes/affiliates/Dash/img/icon-home-middle.png', 'fc15f6e3aa4fa46571f63b3c2232a5d2');
        $this->checkFile('themes/affiliates/Dash/img/icon-home-small.png', 'aafc8e41d2753a4f9b6516181acb2dfa');
        $this->checkFile('themes/affiliates/Dash/img/icon-import-big.png', 'a3994f14cdc5fdf9447cf1c5f222fb98');
        $this->checkFile('themes/affiliates/Dash/img/icon-import-middle.png', 'ede5849ad737983ae60affb29777c3ea');
        $this->checkFile('themes/affiliates/Dash/img/icon-import-small.png', 'ca31d217f2c82a3686c25caaf90f18eb');
        $this->checkFile('themes/affiliates/Dash/img/icon-importexport-big.png', '22bc4deef07277d9c6157e960b4fccda');
        $this->checkFile('themes/affiliates/Dash/img/icon-importexport-middle.png', '6eaa1d276bbfa7ac4b0293f908aa69a3');
        $this->checkFile('themes/affiliates/Dash/img/icon-importexport-small.png', 'ad47885de018e70115fe1e4232b77269');
        $this->checkFile('themes/affiliates/Dash/img/icon-impressioncommision-big.png', '495f55816ffa5216e4746c1d1eee9557');
        $this->checkFile('themes/affiliates/Dash/img/icon-impressioncommision-middle.png', '6361429fa7303b1efb0735ef4548fed6');
        $this->checkFile('themes/affiliates/Dash/img/icon-impressioncommision-small.png', 'e97f06809d7944cd2cebc2683aa22370');
        $this->checkFile('themes/affiliates/Dash/img/icon-informations-big.png', '90210b42d7d84c2185a4a0643454a9fa');
        $this->checkFile('themes/affiliates/Dash/img/icon-informations-middle.png', '1e661972fb77bd24788d319eecd4e962');
        $this->checkFile('themes/affiliates/Dash/img/icon-informations-small.png', '02c4ce14907c147b902e83da8c2f2abb');
        $this->checkFile('themes/affiliates/Dash/img/icon-integration-big.png', '6bd708116619dcfa262a6d40674d8e5b');
        $this->checkFile('themes/affiliates/Dash/img/icon-integration-middle.png', '245668bb8c7796aec7c18d6b6a51483c');
        $this->checkFile('themes/affiliates/Dash/img/icon-integration-small.png', 'c61bb436dc255ce9be68ce8bc94291b2');
        $this->checkFile('themes/affiliates/Dash/img/icon-integrationmethods-big.png', '17e48a253c213fb67da54d8cdebf95f0');
        $this->checkFile('themes/affiliates/Dash/img/icon-integrationmethods-middle.png', '795868d412ad71c3041f4266ca70a42f');
        $this->checkFile('themes/affiliates/Dash/img/icon-integrationmethods-small.png', 'a3a8267d8fe64a8876f4b12150c7b143');
        $this->checkFile('themes/affiliates/Dash/img/icon-invalidlicence-big.png', '28b65cd15641f0bcac4a7ca9ff12f3e2');
        $this->checkFile('themes/affiliates/Dash/img/icon-invalidlicence-middle.png', '97de3a74719bbd0e97e6cff2f0081bf4');
        $this->checkFile('themes/affiliates/Dash/img/icon-invalidlicence-small.png', '8abe2ba041d63018480d9a412e54db6c');
        $this->checkFile('themes/affiliates/Dash/img/icon-invoice-big.png', '8c950adce63c0a3d575e5592aa2981b3');
        $this->checkFile('themes/affiliates/Dash/img/icon-invoice-middle.png', 'bb1eaae413b6893cceea285a4d0607e4');
        $this->checkFile('themes/affiliates/Dash/img/icon-invoice-small.png', '5bbc98c7efb943177890379332dc5109');
        $this->checkFile('themes/affiliates/Dash/img/icon-invoiceformat-big.png', '5cffed26d74d9b98dbbfb01888b58559');
        $this->checkFile('themes/affiliates/Dash/img/icon-invoiceformat-middle.png', 'aede063c8b9e337ea3e23082e8c8b51e');
        $this->checkFile('themes/affiliates/Dash/img/icon-invoiceformat-small.png', '321e3605531407784effbe53635a8aef');
        $this->checkFile('themes/affiliates/Dash/img/icon-languages-big.png', 'a0b72821e1d253339513db5d4643d3cf');
        $this->checkFile('themes/affiliates/Dash/img/icon-languages-middle.png', '4a2ccb5b04b3c98e178252cb0d14df7e');
        $this->checkFile('themes/affiliates/Dash/img/icon-languages-small.png', '9c3b59920c9e4dfd9cd7f96d775b9627');
        $this->checkFile('themes/affiliates/Dash/img/icon-languagetranslations-big.png', '2103875d8558a3cc616f9a4abf85e713');
        $this->checkFile('themes/affiliates/Dash/img/icon-languagetranslations-middle.png', 'd71bc87daf8b1edf3bda4680321f9f6b');
        $this->checkFile('themes/affiliates/Dash/img/icon-languagetranslations-small.png', 'ea7e3479c5f47119261cfecef4ab309b');
        $this->checkFile('themes/affiliates/Dash/img/icon-linkformats-big.png', 'b2202763a3a9a28a957a17bcb7007943');
        $this->checkFile('themes/affiliates/Dash/img/icon-linkformats-middle.png', 'e6ba0774a7607e608f77841c46b6609d');
        $this->checkFile('themes/affiliates/Dash/img/icon-linkformats-small.png', '8d2b611c63b8dca40d9dcb09fab53385');
        $this->checkFile('themes/affiliates/Dash/img/icon-linktracking.png', '030a54df177257201202d3a21fcd2664');
        $this->checkFile('themes/affiliates/Dash/img/icon-logging-big.png', 'f3f381ea4a2a4b8a1aa0e19de56437de');
        $this->checkFile('themes/affiliates/Dash/img/icon-logging-middle.png', 'd9f7515eb7521d4163e2f4790387885f');
        $this->checkFile('themes/affiliates/Dash/img/icon-logging-small.png', '741214ca11b87b38d0d904650cb3a717');
        $this->checkFile('themes/affiliates/Dash/img/icon-logout-big.png', 'd4bba32201c5056c278d53fed4b1bbc7');
        $this->checkFile('themes/affiliates/Dash/img/icon-logout-middle.png', '46b1e38582fba3c1d82cffd42ff65b9e');
        $this->checkFile('themes/affiliates/Dash/img/icon-logout-small.png', '25d153721685338959a2dad7af6321ab');
        $this->checkFile('themes/affiliates/Dash/img/icon-mapoverlay-big.png', '0f6b98425312f5c78b7f290cc8c89c35');
        $this->checkFile('themes/affiliates/Dash/img/icon-mapoverlay-middle.png', '80a789d18aacb4013f1cbb83db9c431b');
        $this->checkFile('themes/affiliates/Dash/img/icon-mapoverlay-small.png', '26d00c127fbf4a4ae6310f889758ad2d');
        $this->checkFile('themes/affiliates/Dash/img/icon-message-big.png', '403ba3600f9e63e33ffc5c0dbb53c44f');
        $this->checkFile('themes/affiliates/Dash/img/icon-message-middle.png', 'f0f630bee3a08f61161f095d3e47fbaa');
        $this->checkFile('themes/affiliates/Dash/img/icon-message-small.png', 'ac79d200fb4199e60193d606ce574d8f');
        $this->checkFile('themes/affiliates/Dash/img/icon-networkaccountadd-big.png', '1d869a10b51e3cb53738cf5d4b185511');
        $this->checkFile('themes/affiliates/Dash/img/icon-networkaccountadd-middle.png', 'e3c42a7413200843e6dbdf82ff314470');
        $this->checkFile('themes/affiliates/Dash/img/icon-networkaccountadd-small.png', '18bd89d5bd977cceb1656787f14771d2');
        $this->checkFile('themes/affiliates/Dash/img/icon-networkaccountfields-big.png', 'b8bc6614fbbf1e4deae4d2cf5d2f4501');
        $this->checkFile('themes/affiliates/Dash/img/icon-networkaccountfields-middle.png', '2ed54dec6cf0fdc65ba5264b02b31089');
        $this->checkFile('themes/affiliates/Dash/img/icon-networkaccountfields-small.png', '8514ea6a22d424dd3a14876ec70cb3b2');
        $this->checkFile('themes/affiliates/Dash/img/icon-networkaccounts-big.png', 'e6fe2e1cd1cda349384c87e57a26865d');
        $this->checkFile('themes/affiliates/Dash/img/icon-networkaccounts-middle.png', 'a600fe8d8d41c26f81695a2eadbf8111');
        $this->checkFile('themes/affiliates/Dash/img/icon-networkaccounts-small.png', 'a0432c0d3443735d331430568c69e4fa');
        $this->checkFile('themes/affiliates/Dash/img/icon-newsletter-big.png', 'd0b8e5c3b293ad29e1a66eeb383d2c8e');
        $this->checkFile('themes/affiliates/Dash/img/icon-newsletter-middle.png', 'bf5c713d0d26b0890b5c6edea73dac34');
        $this->checkFile('themes/affiliates/Dash/img/icon-newsletter-small.png', '7d52c62d5397230708b2448df035ca1d');
        $this->checkFile('themes/affiliates/Dash/img/icon-offlinesale-big.png', '35127b1b9d03b19aea95b905e400c1ec');
        $this->checkFile('themes/affiliates/Dash/img/icon-offlinesale-middle.png', '9fdd100b5a41e4f1ce8850c0b5c49bc0');
        $this->checkFile('themes/affiliates/Dash/img/icon-offlinesale-small.png', 'f64a930d43970b319f484c35059114b8');
        $this->checkFile('themes/affiliates/Dash/img/icon-onlineusers-big.png', '8a140f9f5787e65335573c35af435912');
        $this->checkFile('themes/affiliates/Dash/img/icon-onlineusers-middle.png', '6418adf7bb30e826a0dee7e5afc57dbd');
        $this->checkFile('themes/affiliates/Dash/img/icon-onlineusers-small.png', 'f969b9cec13f1afdbe832d0fd74d9e85');
        $this->checkFile('themes/affiliates/Dash/img/icon-outbox-big.png', 'bd4be7e782336809737c3f56d0d95840');
        $this->checkFile('themes/affiliates/Dash/img/icon-outbox-middle.png', '0a8f03555b8cc0a53214502a9f1d36e0');
        $this->checkFile('themes/affiliates/Dash/img/icon-outbox-small.png', '793acba64f930962243773f51217e905');
        $this->checkFile('themes/affiliates/Dash/img/icon-panelsettings-big.png', 'f7b70b68d910bc557de2e42f7d711a3a');
        $this->checkFile('themes/affiliates/Dash/img/icon-panelsettings-middle.png', 'e5603910d6e7f850c7e8d3aacee031fc');
        $this->checkFile('themes/affiliates/Dash/img/icon-panelsettings-small.png', 'b67eca984d0d89a6805d7712462f56d0');
        $this->checkFile('themes/affiliates/Dash/img/icon-parameternames-big.png', '47a57e7c5d1a402c30d102bb8f73c2a6');
        $this->checkFile('themes/affiliates/Dash/img/icon-parameternames-middle.png', '2676b02f65b5f2620a2dbcb8302b0d8c');
        $this->checkFile('themes/affiliates/Dash/img/icon-parameternames-small.png', '192530feb2fa8aebe3ee491b6f5f1c5d');
        $this->checkFile('themes/affiliates/Dash/img/icon-payaffiliates-big.png', '5262ba6c21f92887786620c1ea8b7637');
        $this->checkFile('themes/affiliates/Dash/img/icon-payaffiliates-middle.png', '585633a4b8b38828f1faf1a6ede688d3');
        $this->checkFile('themes/affiliates/Dash/img/icon-payaffiliates-small.png', '708f3f7485253ee76d8aa9882a3e81ae');
        $this->checkFile('themes/affiliates/Dash/img/icon-paymentdetails-big.png', '2c3dcc019b163e58f6e991ec3cdeb93a');
        $this->checkFile('themes/affiliates/Dash/img/icon-paymentdetails-middle.png', '00d39c41e921dd7325d5da86d8fba797');
        $this->checkFile('themes/affiliates/Dash/img/icon-paymentdetails-small.png', 'e7cc29a55755c0c1c600f3eb29970e30');
        $this->checkFile('themes/affiliates/Dash/img/icon-payoutsbalance-big.png', '6d5dfc08ff356dea7e5b4498351b2abb');
        $this->checkFile('themes/affiliates/Dash/img/icon-payoutsbalance-middle.png', 'f29e1fa4fc12cf76d79dfb4cdb0b8b99');
        $this->checkFile('themes/affiliates/Dash/img/icon-payoutsbalance-small.png', 'e7be75d8d0774747990ea964f1e0101d');
        $this->checkFile('themes/affiliates/Dash/img/icon-payoutsbyaff-big.png', 'fb58c02622942f34bab91ebce940f3ec');
        $this->checkFile('themes/affiliates/Dash/img/icon-payoutsbyaff-middle.png', 'cb3833b7044e920d8d941f6781fa2df3');
        $this->checkFile('themes/affiliates/Dash/img/icon-payoutsbyaff-small.png', 'e61f9ac8562802dc0aac00ebc31eb31d');
        $this->checkFile('themes/affiliates/Dash/img/icon-payoutsettings-big.png', 'ff7264578099e47bf2d4646d357742b2');
        $this->checkFile('themes/affiliates/Dash/img/icon-payoutsettings-middle.png', '4ec26382ffb573c0ccc2e957f077c1e5');
        $this->checkFile('themes/affiliates/Dash/img/icon-payoutsettings-small.png', 'ca9c7400e3ff2e50a1725d7b1732c5e3');
        $this->checkFile('themes/affiliates/Dash/img/icon-payoutshistory-big.png', '8e87c06adbef25733e01ab3e51b4f6d3');
        $this->checkFile('themes/affiliates/Dash/img/icon-payoutshistory-middle.png', 'fa0a56093d19e471f2ecd5b4c34beaa4');
        $this->checkFile('themes/affiliates/Dash/img/icon-payoutshistory-small.png', '9e957f26370ef8282a267e5060bcea32');
        $this->checkFile('themes/affiliates/Dash/img/icon-payoutslist-big.png', '1bede851415e062a888451c1ef493385');
        $this->checkFile('themes/affiliates/Dash/img/icon-payoutslist-middle.png', '887ca9d34e9e545928c94b1f68fb8b94');
        $this->checkFile('themes/affiliates/Dash/img/icon-payoutslist-small.png', '27c574fe08115a833acb8e0bdeaf50b9');
        $this->checkFile('themes/affiliates/Dash/img/icon-payoutsoverview-big.png', '1bede851415e062a888451c1ef493385');
        $this->checkFile('themes/affiliates/Dash/img/icon-payoutsoverview-middle.png', '887ca9d34e9e545928c94b1f68fb8b94');
        $this->checkFile('themes/affiliates/Dash/img/icon-payoutsoverview-small.png', '27c574fe08115a833acb8e0bdeaf50b9');
        $this->checkFile('themes/affiliates/Dash/img/icon-pendingtasks-big.png', 'efbc34dc0e67b2e87a108e524ddb16bf');
        $this->checkFile('themes/affiliates/Dash/img/icon-pendingtasks-middle.png', '6907bcc9fa6fbe811b775ec0323757cf');
        $this->checkFile('themes/affiliates/Dash/img/icon-pendingtasks-small.png', '038469d25098ca85aac324d68f46b9c2');
        $this->checkFile('themes/affiliates/Dash/img/icon-personaldetails-big.png', 'db24999d6b323cc4160481b9197cf52e');
        $this->checkFile('themes/affiliates/Dash/img/icon-personaldetails-middle.png', '84d4ba7eeab1224e6af2039176089267');
        $this->checkFile('themes/affiliates/Dash/img/icon-personaldetails-small.png', '893a70e6fb2ac1b86c02d7c3bbe06c4a');
        $this->checkFile('themes/affiliates/Dash/img/icon-plugins-big.png', 'bf88b03059137ed6ea16485f8e1d4545');
        $this->checkFile('themes/affiliates/Dash/img/icon-plugins-middle.png', '7add6287f8be625735d47ac4d1e81b4a');
        $this->checkFile('themes/affiliates/Dash/img/icon-plugins-small.png', '8c999c38a9d57971341676aa0002cd67');
        $this->checkFile('themes/affiliates/Dash/img/icon-promotion-big.png', '7a839eab485f58c64f18373fb98071c1');
        $this->checkFile('themes/affiliates/Dash/img/icon-promotion-middle.png', '288fd61451befab7496361770ea14d33');
        $this->checkFile('themes/affiliates/Dash/img/icon-promotion-small.png', 'baddc96d178672ba3d353459432469ac');
        $this->checkFile('themes/affiliates/Dash/img/icon-promotips.png', '8b688e5aa3af76b89b0295f762939d35');
        $this->checkFile('themes/affiliates/Dash/img/icon-proxy-big.png', '873881ce0902d108856b66d6cd1bbeb5');
        $this->checkFile('themes/affiliates/Dash/img/icon-proxy-middle.png', '230ff2e2fb3e95933026c0f9e4d6842c');
        $this->checkFile('themes/affiliates/Dash/img/icon-proxy-small.png', 'f3b4244c5a02eb94ed262d6254d06298');
        $this->checkFile('themes/affiliates/Dash/img/icon-quickreport-big.png', '13d6307a75e92e4a1dfa3dd47647cedb');
        $this->checkFile('themes/affiliates/Dash/img/icon-quickreport-middle.png', '3bea495c70f8c47812a8d9775bffca63');
        $this->checkFile('themes/affiliates/Dash/img/icon-quickreport-small.png', '931422301455d42e667b0472d3d43066');
        $this->checkFile('themes/affiliates/Dash/img/icon-quickstart-big.png', 'd197bbf5a9900bb8d536e66afed03206');
        $this->checkFile('themes/affiliates/Dash/img/icon-quickstart-middle.png', '74997aac35c7c4f12c8fc0e7fc014e30');
        $this->checkFile('themes/affiliates/Dash/img/icon-quickstart-small.png', '62ecdf49ec3da0bfad4211057e6e051e');
        $this->checkFile('themes/affiliates/Dash/img/icon-recurringcommissionslist-big.png', '8316e4d32f09f67d5b85deaa26577dcf');
        $this->checkFile('themes/affiliates/Dash/img/icon-recurringcommissionslist-middle.png', 'dfa8f0fe9edb348b79aebfd6ab775a33');
        $this->checkFile('themes/affiliates/Dash/img/icon-recurringcommissionslist-small.png', '3489d6da95b9a3f59dbe9d3b994b6c37');
        $this->checkFile('themes/affiliates/Dash/img/icon-reportproblems-big.png', '9395e24a8125e59d979dcf106f5fa56a');
        $this->checkFile('themes/affiliates/Dash/img/icon-reportproblems-middle.png', 'e3b0e0cef2bf97f63eabe07b2698e892');
        $this->checkFile('themes/affiliates/Dash/img/icon-reportproblems-small.png', 'c3bcb16b71995ea184725313eab14ba3');
        $this->checkFile('themes/affiliates/Dash/img/icon-reports-big.png', '4b6dce1244d75b94379200e21b318b45');
        $this->checkFile('themes/affiliates/Dash/img/icon-reports-middle.png', '185720125c09730d91189ae69074ff17');
        $this->checkFile('themes/affiliates/Dash/img/icon-reports-small.png', '8dcf1727963537d5dea129b9f0833684');
        $this->checkFile('themes/affiliates/Dash/img/icon-salecommission-big.png', 'edad2d2af87b8f7cbff8c40cab472e8e');
        $this->checkFile('themes/affiliates/Dash/img/icon-salecommission-middle.png', '6122ee20716d3f0dec569778abf17b6d');
        $this->checkFile('themes/affiliates/Dash/img/icon-salecommission-small.png', 'edc571e2de6de0164b7b505b4ae22507');
        $this->checkFile('themes/affiliates/Dash/img/icon-screen-big.png', '428601da0d9ba4c3deea1b57259f53d9');
        $this->checkFile('themes/affiliates/Dash/img/icon-screen-middle.png', '6fc0eace07b68020677f7fb7c2181588');
        $this->checkFile('themes/affiliates/Dash/img/icon-screen-small.png', 'd7c377c6c1839c02d8ff4c08241d059e');
        $this->checkFile('themes/affiliates/Dash/img/icon-send-message-big.png', '925ea74565475d763da214a66848d090');
        $this->checkFile('themes/affiliates/Dash/img/icon-send-message-middle.png', '35a5a52620dcf4421b3603850ad86ed9');
        $this->checkFile('themes/affiliates/Dash/img/icon-send-message-small.png', 'e62035b9b08fd22200b9d0e63401a66b');
        $this->checkFile('themes/affiliates/Dash/img/icon-signupform-big.png', '94d57c6ffa91773a9e094a7a3f3f09a7');
        $this->checkFile('themes/affiliates/Dash/img/icon-signupform-middle.png', '0cc9db6f3dfd91fa73678c0ac36a05e7');
        $this->checkFile('themes/affiliates/Dash/img/icon-signupform-small.png', 'ae097dc49a26bc036ad207cb9a5eca52');
        $this->checkFile('themes/affiliates/Dash/img/icon-signupsubaff-big.png', 'a45245b27a33cf936d4c9b2d1251d981');
        $this->checkFile('themes/affiliates/Dash/img/icon-signupsubaff-middle.png', '284b1281deda84131f40e429135600bd');
        $this->checkFile('themes/affiliates/Dash/img/icon-signupsubaff-small.png', 'a3a9c4345b984dc9522d4ae2c932ab90');
        $this->checkFile('themes/affiliates/Dash/img/icon-subaffiliates-big.png', 'd5886239b93fe9bfe1298d968395e761');
        $this->checkFile('themes/affiliates/Dash/img/icon-subaffiliates-middle.png', '0cb6a0cddffa82ae33e3cf911a8d0a63');
        $this->checkFile('themes/affiliates/Dash/img/icon-subaffiliates-small.png', '4a6501ad5d0cf5ee1098037345ea6f04');
        $this->checkFile('themes/affiliates/Dash/img/icon-subaffiliatestat-big.png', 'a779b82895bf11652232bfbebbddcf3a');
        $this->checkFile('themes/affiliates/Dash/img/icon-subaffiliatestat-middle.png', 'dc7cfd8b9e9ae721265f990b8faa1a1f');
        $this->checkFile('themes/affiliates/Dash/img/icon-subaffiliatestat-small.png', 'e981446661750ce0b4aabdb056aa21af');
        $this->checkFile('themes/affiliates/Dash/img/icon-subidtracking-big.png', 'a9f00f3f0d2880363eca08b4cb5f1077');
        $this->checkFile('themes/affiliates/Dash/img/icon-subidtracking-middle.png', '782e7b4584e3605b08e63e1213b16e3a');
        $this->checkFile('themes/affiliates/Dash/img/icon-subidtracking-small.png', '089f1ee83e8c314b3aa08c00b52ef773');
        $this->checkFile('themes/affiliates/Dash/img/icon-systemconfiguration-big.png', '2cddf90ad25270348ab96a6d9d874152');
        $this->checkFile('themes/affiliates/Dash/img/icon-systemconfiguration-middle.png', '55ac5018150298f812e2765a19550fdc');
        $this->checkFile('themes/affiliates/Dash/img/icon-systemconfiguration-small.png', '7b0623ad383b0246f58aa6bc45277678');
        $this->checkFile('themes/affiliates/Dash/img/icon-themes-big.png', 'f7b70b68d910bc557de2e42f7d711a3a');
        $this->checkFile('themes/affiliates/Dash/img/icon-themes-middle.png', 'e5603910d6e7f850c7e8d3aacee031fc');
        $this->checkFile('themes/affiliates/Dash/img/icon-themes-small.png', 'b67eca984d0d89a6805d7712462f56d0');
        $this->checkFile('themes/affiliates/Dash/img/icon-tools-big.png', 'e0da1ad291513772326fefcddc8ab42d');
        $this->checkFile('themes/affiliates/Dash/img/icon-tools-middle.png', '4602d231274ac2cac78fe20abfb49c9a');
        $this->checkFile('themes/affiliates/Dash/img/icon-tools-small.png', '506cbde7bdb6c61fe786122b08c59c1c');
        $this->checkFile('themes/affiliates/Dash/img/icon-topreferringurl-big.png', 'f1c63c47194544ad073ff2d8800aff57');
        $this->checkFile('themes/affiliates/Dash/img/icon-topreferringurl-middle.png', '7743b51e3964c9ec09d0d20f3fda81e5');
        $this->checkFile('themes/affiliates/Dash/img/icon-topreferringurl-small.png', 'c44b37822d23b4eb69107b80ca8c9996');
        $this->checkFile('themes/affiliates/Dash/img/icon-trackingaffiliates-big.png', '5025622c054d25ce154025f58b04f3e1');
        $this->checkFile('themes/affiliates/Dash/img/icon-trackingaffiliates-middle.png', '88e06c1afa8422bb3158f3e43e349266');
        $this->checkFile('themes/affiliates/Dash/img/icon-trackingaffiliates-small.png', '5750ed980100417d63819f951f7d3617');
        $this->checkFile('themes/affiliates/Dash/img/icon-trackingsettings-big.png', 'fecc4f7d7b716f954f3324feed92ef23');
        $this->checkFile('themes/affiliates/Dash/img/icon-trackingsettings-middle.png', '6ac879219f21fcc998338d9294877735');
        $this->checkFile('themes/affiliates/Dash/img/icon-trackingsettings-small.png', '99e6af89545c48d6c7d2a7f9930a86ca');
        $this->checkFile('themes/affiliates/Dash/img/icon-trafficstats-big.png', '4bbbb6d078d6804700d1282bdfdda165');
        $this->checkFile('themes/affiliates/Dash/img/icon-trafficstats-middle.png', 'e3783a33c6f662dbe63f394c49fd8e57');
        $this->checkFile('themes/affiliates/Dash/img/icon-trafficstats-small.png', '7ca396360b45a8e9c1d250d5b0824be2');
        $this->checkFile('themes/affiliates/Dash/img/icon-transactionsoverview-big.png', '2a8079383dc03f24a774b3d087333826');
        $this->checkFile('themes/affiliates/Dash/img/icon-transactionsoverview-middle.png', 'd4fca55f9fc90a7f385b122426884fc0');
        $this->checkFile('themes/affiliates/Dash/img/icon-transactionsoverview-small.png', '6fd329efc615a54f433f8033024b9395');
        $this->checkFile('themes/affiliates/Dash/img/icon-trendsreport-big.png', 'a9763385aa10959738675255bd887e23');
        $this->checkFile('themes/affiliates/Dash/img/icon-trendsreport-middle.png', '669e6948c8a7b0a91d8ff1e000644d76');
        $this->checkFile('themes/affiliates/Dash/img/icon-trendsreport-small.png', '8c89cd1902b375fc60c95cc7b750e00f');
        $this->checkFile('themes/affiliates/Dash/img/icon-troubleshooting-big.png', '28b65cd15641f0bcac4a7ca9ff12f3e2');
        $this->checkFile('themes/affiliates/Dash/img/icon-troubleshooting-middle.png', '97de3a74719bbd0e97e6cff2f0081bf4');
        $this->checkFile('themes/affiliates/Dash/img/icon-troubleshooting-small.png', '8abe2ba041d63018480d9a412e54db6c');
        $this->checkFile('themes/affiliates/Dash/img/icon-tutorialvideo-big.png', 'caff5c6e41fc7a40cd96a9b824736a97');
        $this->checkFile('themes/affiliates/Dash/img/icon-tutorialvideo-middle.png', 'f7d43ef307e5090b3c5b0a8b1f2f430f');
        $this->checkFile('themes/affiliates/Dash/img/icon-tutorialvideo-small.png', '1ea035f5e1baa010c6f146f8b2864dad');
        $this->checkFile('themes/affiliates/Dash/img/icon-undefined-big.png', '90210b42d7d84c2185a4a0643454a9fa');
        $this->checkFile('themes/affiliates/Dash/img/icon-undefined-middle.png', '1e661972fb77bd24788d319eecd4e962');
        $this->checkFile('themes/affiliates/Dash/img/icon-undefined-small.png', '02c4ce14907c147b902e83da8c2f2abb');
        $this->checkFile('themes/affiliates/Dash/img/icon-user-big.png', '0e702be569fe18fd148352dd35eef5e2');
        $this->checkFile('themes/affiliates/Dash/img/icon-user-middle.png', 'a0bf2afecbcfbdb1571d9a061780c1a0');
        $this->checkFile('themes/affiliates/Dash/img/icon-user-small.png', '7a1aa33a04a1e6b22cc6783e41dde93b');
        $this->checkFile('themes/affiliates/Dash/img/icon-userprofile-big.png', 'bbfd648d5aa54e015218481966b13ce2');
        $this->checkFile('themes/affiliates/Dash/img/icon-userprofile-middle.png', 'c1428282a47c10750493c744b45b0b6e');
        $this->checkFile('themes/affiliates/Dash/img/icon-userprofile-small.png', '3033136cc1fad425f585eefadf311da8');
        $this->checkFile('themes/affiliates/Dash/img/icon-userroleprivileges-big.png', 'cb55e04eed7cbee58b0f0b78019062e0');
        $this->checkFile('themes/affiliates/Dash/img/icon-userroleprivileges-middle.png', '00fd7c474c52ae44a8687c1aaea9c864');
        $this->checkFile('themes/affiliates/Dash/img/icon-userroleprivileges-small.png', 'b075544877b61c6a4b26a8a18936d1eb');
        $this->checkFile('themes/affiliates/Dash/img/icon-vathandling-big.png', '6bd2f6913cb33846aa9f885c4d632ba0');
        $this->checkFile('themes/affiliates/Dash/img/icon-vathandling-middle.png', '6363bb9c47ed899a15bbd87d47c5bc75');
        $this->checkFile('themes/affiliates/Dash/img/icon-vathandling-small.png', '72a79ab793a44af78ff83ea71a8f68ff');
        $this->checkFile('themes/affiliates/Dash/img/icon-views-big.png', '6da16ea156043161746b99da65cf1735');
        $this->checkFile('themes/affiliates/Dash/img/icon-views-middle.png', '3532fa7ada483eae52c946efba4edfc9');
        $this->checkFile('themes/affiliates/Dash/img/icon-views-small.png', '312f72396b458c3ea1f9186ae14fe548');
        $this->checkFile('themes/affiliates/Dash/img/icon-youraccount-big.png', '8af27a0489c96e8e6a0931a7bd326224');
        $this->checkFile('themes/affiliates/Dash/img/icon-youraccount-middle.png', '4b718e03995b4eb6355eb59ea3ea7211');
        $this->checkFile('themes/affiliates/Dash/img/icon-youraccount-small.png', 'd0d92ffdca1215c55dd1f79246e369f2');
        $this->checkFile('themes/affiliates/Dash/img/icons22.png', 'b2ea77f479d2b5020c4c4692d5c6e885');
        $this->checkFile('themes/affiliates/Dash/img/left_bg.gif', '6b805be091fa27230cc6750ccc38fc37');
        $this->checkFile('themes/affiliates/Dash/img/loading.gif', '546d9515580e0c8e3d0813c2e04ed9aa');
        $this->checkFile('themes/affiliates/Dash/img/logo_pap.jpg', 'aba77ff0db8d780333de3c6d61e34216');
        $this->checkFile('themes/affiliates/Dash/img/plugin_icon.png', '38f662af0c9848d4afc772c72f711af4');
        $this->checkFile('themes/affiliates/Dash/img/reports-month.png', '189ca5b357e070e385b693be11e0ad96');
        $this->checkFile('themes/affiliates/Dash/img/reports.png', '2cb48b10c4178fd34b55815ae51ed21c');
        $this->checkFile('themes/affiliates/Dash/img/theme_thumbnail.jpg', '6cee9c51d1291764b3b44689be7b5ad7');
        $this->checkFile('themes/affiliates/Dash/img/tree.png', 'b379dab92b732c6b3a9d857b4e2c7fc0');
        $this->checkFile('themes/affiliates/Dash/img/window.active.png', '83eda02ef182e2ad1345b2e9eb8bf201');
        $this->checkFile('themes/affiliates/Dash/login_form.tpl', 'fb9d17de38b511dd6a24eb3647427fd0');
        $this->checkFile('themes/affiliates/Dash/main.tpl', '6b08948b62aa6f367ab8dd98908d0946');
        $this->checkFile('themes/affiliates/Dash/main_aff_html_doc.stpl', 'c176f986237133b335efd9af406ff9cb');
        $this->checkFile('themes/affiliates/Dash/main_header.tpl', 'e4c89bc628cad5401f6dfcb4dfe838b7');
        $this->checkFile('themes/affiliates/Dash/main_menu.tpl', '5fddab52f7b44bcb5717c1d67875f567');
        $this->checkFile('themes/affiliates/Dash/map_overlay.tpl', '49786b189baf1608aa2dcf356cc6a909');
        $this->checkFile('themes/affiliates/Dash/map_overlay_advanced_filter.tpl', '2c07dd5f442caaaaf6f2d5426acf0ec6');
        $this->checkFile('themes/affiliates/Dash/menu_entry.tpl', 'ae560837dfc1d2ff53ba3fea866de9ab');
        $this->checkFile('themes/affiliates/Dash/menu_section.tpl', 'da446dbc5a24b9881bd8417ce0371bb5');
        $this->checkFile('themes/affiliates/Dash/news_content.tpl', '240db12f7ed3698d10779e4498ff1cd5');
        $this->checkFile('themes/affiliates/Dash/onlineusers_filter.tpl', '4edca7157016faf110102bb4c36c8854');
        $this->checkFile('themes/affiliates/Dash/overview_panel.tpl', 'ae62662f04bfa67b6ef921d73e3bf5e1');
        $this->checkFile('themes/affiliates/Dash/panel_includes.stpl', '0f94d032ed0894e4a4fbaf4d54bf3dc0');
        $this->checkFile('themes/affiliates/Dash/pap4.css', '8ab95f68791f855de254c91b15b61ce5');
        $this->checkFile('themes/affiliates/Dash/payment_details_panel.tpl', 'ed5212db20276b77a5f203502d5ae0a9');
        $this->checkFile('themes/affiliates/Dash/payout_fields_panel.tpl', 'dfe2a4e0c6c80100491a4d139d31fe60');
        $this->checkFile('themes/affiliates/Dash/payouts_history_filter.tpl', '581756a76965326732abb2494fbbe8df');
        $this->checkFile('themes/affiliates/Dash/payouts_to_affiliates.tpl', 'd42b3367486deccb48895e0e7635f8fe');
        $this->checkFile('themes/affiliates/Dash/payouts_to_affiliates_filter.tpl', '240e032a99e6384fd923d3d41a7ecc43');
        $this->checkFile('themes/affiliates/Dash/period_stats.stpl', '86cd67a4d0a6ac9f69caaaa6cbce7e1e');
        $this->checkFile('themes/affiliates/Dash/personal_details.tpl', 'aae32aa556942d1b9dc79026c3fc1224');
        $this->checkFile('themes/affiliates/Dash/quick_report_content.stpl', 'f2edacccd420c175aeb91386fd7850dc');
        $this->checkFile('themes/affiliates/Dash/quick_report_filter_base.tpl', 'feec7fef33366e95cd3f46570790f055');
        $this->checkFile('themes/affiliates/Dash/quick_report_multitier_widget.tpl', '532534a0616364f99f7e5df1365711c9');
        $this->checkFile('themes/affiliates/Dash/referringurl_advanced_filter.tpl', 'dc3a01ea392255eb0dcc1d21cff25457');
        $this->checkFile('themes/affiliates/Dash/report_filter.tpl', 'b37d7cb139866b0da13d266ad5e76941');
        $this->checkFile('themes/affiliates/Dash/send_to_friend.tpl', '8744caafa6e9485d2df807924c933299');
        $this->checkFile('themes/affiliates/Dash/set_new_password_form.tpl', '8e7fd161e9e90b7abcdd0b51da4aed92');
        $this->checkFile('themes/affiliates/Dash/signup_fields.tpl', '16c26f808a27c220930859db1a454042');
        $this->checkFile('themes/affiliates/Dash/signup_subaffiliates.tpl', 'fd4d5c5e6fd7962bde8dbc637b2ac98a');
        $this->checkFile('themes/affiliates/Dash/stats_chart.tpl', '7695f3fc6835c168c7ba3e0f721e83f3');
        $this->checkFile('themes/affiliates/Dash/sub_menu_section.tpl', 'f14329a6ad21f2551a068111201c9918');
        $this->checkFile('themes/affiliates/Dash/subaffiliate_sales_panel.tpl', '07f7ade87e85de4f5d08dea06266a51a');
        $this->checkFile('themes/affiliates/Dash/subaffiliates_filter.tpl', '7bdd8b4887f806ae9e1299bd37adbadb');
        $this->checkFile('themes/affiliates/Dash/subaffiliates_panel.tpl', 'e40edb6691208354262ee1ba84361cf2');
        $this->checkFile('themes/affiliates/Dash/subaffiliates_sales_filter.tpl', '0b031778afec8e5892c25e73fc14baab');
        $this->checkFile('themes/affiliates/Dash/subaffstats_filter.tpl', '829c12fdc814af3a2c231bcafeb74f7e');
        $this->checkFile('themes/affiliates/Dash/subaffstats_list.tpl', '5043920b3c9584b83f9845b77dec2970');
        $this->checkFile('themes/affiliates/Dash/subid_tracking_screen.tpl', '90bda2de9ee0dd7be14fd70506aba283');
        $this->checkFile('themes/affiliates/Dash/system_menu.tpl', '7d26f32f97e8aa1345ae8f224aeca2c9');
        $this->checkFile('themes/affiliates/Dash/tests.tpl', 'c684c3cd569104ca2d0505cc1d73f8c6');
        $this->checkFile('themes/affiliates/Dash/theme.php', '45e823dd7f1862f9f395d7f7a0879b03');
        $this->checkFile('themes/affiliates/Dash/theme_settings.tpl', 'e5cc392956225e60996dbe65455439d0');
        $this->checkFile('themes/affiliates/Dash/topurl_list.tpl', '4027efbcefdbe77ad75e8f11c29ab2ea');
        $this->checkFile('themes/affiliates/Dash/transaction_list.tpl', '3c78b1c7551845ee5ee4d1c7d56d969a');
        $this->checkFile('themes/affiliates/Dash/transaction_list_filter_base.tpl', '82d6848fe147c349d456d5ca8b633296');
        $this->checkFile('themes/affiliates/Dash/trend_actions_stats.tpl', '5d6e55fa6711b536fad187f3a0d26e05');
        $this->checkFile('themes/affiliates/Dash/trend_actions_stats_widget.tpl', 'cd6b17a53c5dccc568f6382638fffc9b');
        $this->checkFile('themes/affiliates/Dash/trend_stats.tpl', '9d0e4c50a7ded2d8cb86dc32dbb071b9');
        $this->checkFile('themes/affiliates/Dash/trends_report_filter.tpl', 'cf7b16a9962cf24283dd10d63a41d382');
        $this->checkFile('themes/affiliates/Dash/window.tpl', '564d64cbe6768aab4554e85783c60d38');
        $this->checkFile('themes/affiliates/Dash/window_bottom_left.tpl', '6fb7ac67f0f538f52fc427b755ce8e5b');
        $this->checkFile('themes/affiliates/Dash/window_left.tpl', '984d69649ec171a5c6b522e795feb904');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/README.txt', 'c5e378c3027a6b4f00637e35fa00d549');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/advanced_screen.tpl', '3cbda4ba3c4fdd78e8a50a2af11fde70');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/affiliate_edit_details_additional.tpl', 'bc0f7b57c46640802a563ab8cbfd0f5d');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/affiliate_theme_settings.tpl', '5c6451cd1dd06ff3acf843394e16586a');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/afflink_protector_screen.tpl', '61d5dbcce0f5ab1cf7a0bb92ed12e543');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/banner_filter.tpl', '622963a4eba50c77e0775883f24719f6');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/banner_stats_filter.tpl', 'c342d2f202a02e732dee7b05a295978b');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/banner_stats_list.tpl', '871b5198402d7bf61abc4606e68729f9');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/banners.tpl', 'd8ed85ce8b2f4af07c54a3922b6d0fa6');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/campaign_filter.tpl', '97d8fa0311dc58b4408ca9b65d1097dd');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/campaign_stats_filter.tpl', '2b6e28bb38f9cee07e3a7135fddee70b');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/campaign_stats_list.tpl', 'f66146fc0fbf7eeafd3e8d7c4eab70ba');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/campaign_tracking_codes.tpl', 'dda6b432171a4bd502aa17deecb2c409');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/campaign_tracking_codes_filter.tpl', '5f518601bb721b72efe355ae964924c4');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/campaigns_filter.tpl', '692a896ffc1e91e95c47861416690497');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/campaigns_list.tpl', '398bd0a296bd21e94289fe8ac919df0f');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/channel_stats_filter.tpl', '87344f7ed227e6f2c77ddc6746c47257');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/channel_stats_panel.tpl', '17737a0ac3c9d85a8713c8f0415ce4e8');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/channels_panel.tpl', 'c572b9c29e22105ab18468cf52314212');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/clicks_list.tpl', '68b59b4266ed5ec31e0e85d63f380d12');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/clicks_list_filter_base.tpl', '8088823085cca0521494012847e6d400');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/contact_us.tpl', '9f86f6a577153259f4fca7babc71201a');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/custom.css', '4877ef2467745239a93ebe1e79b2f813');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/daily_report.tpl', 'b20880541206a63cd7cb9fe010ea1084');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/daily_report_filter.tpl', '5e3add7cd2c4e8a7c150452d8e99861e');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/direct_link_form.tpl', 'b14d464dbcaac59248771ac5db562fdd');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/direct_linking_panel.tpl', '747a111348d8fae2bd13ada3ff43caec');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/direct_links_screen.tpl', 'c7f1c0d97f725e5122c7293485b3a606');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/dynamic_link_panel.tpl', '7e8d0f31838a8ffd1d3bb8f8e984d043');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/email_notifications.tpl', '5832f8d793dbd3beb643c0aaf4c8d754');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/filter.tpl', 'cc93c246e4fd3e0acfb93c5eeeaef8ee');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/filter_field_decorator.tpl', '0afa75f69e50c2a31dc1a1987dbf050f');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/financial_overview.tpl', 'fe0a40bf202eae0fbff2c4de81cbe72e');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/footer.stpl', '3fbd103789f1ff2a151c16f490a913dd');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/header.stpl', '976551fbf73e0d4a94bf699029e74a49');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/home.tpl', '5e4f500715b02c7be21d1573597f9a95');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/icons_panel_with_header.tpl', '49915f3e094bfd40d009b4bddecbe862');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/box_divider.png', '88ec74dba62142217c8daddbd30ad9ec');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/config-hover.png', '0e622df8cefda5590d2e187f7732d956');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/feature_icon.png', '47556c7aac8fcae73b927a914c2e45f0');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/header_divider.png', '9c04ac8b0e24b7815be8feda5e810d14');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-about-big.png', '428601da0d9ba4c3deea1b57259f53d9');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-about-middle.png', '08f103818c506e89fa2e7aee7d0970ec');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-about-small.png', 'd7c377c6c1839c02d8ff4c08241d059e');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-accounting-big.png', 'fa93f5c4b60b9d095a2a23a52211168e');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-accounting-middle.png', '7da96ba7ebbfb004234d789e5f36ce69');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-accounting-small.png', 'a14dd58b2eff427007308e6c395da74f');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-actioncommision-big.png', 'b7245ce1da39458df4478fb97c2ec907');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-actioncommision-middle.png', '7ae18337038f543b5defede7792eda07');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-actioncommision-small.png', '50647c7a2ce6e87c05e67856140a01be');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-admins-big.png', '57361cd2d4a488cd2eed00831b26bd5f');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-admins-middle.png', '46b9654e5de894bb1906ef4f498d35ac');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-admins-small.png', '039ecbce68831dfb1dce0752932bf5a6');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-advancedfunc-big.png', '8691f9054949c63439b1c099c849fe37');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-advancedfunc-middle.png', '31ca17b7f2dc610f34f9f36ad2078199');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-advancedfunc-small.png', 'f224df62fe414aa5b654a2aa9c9083ca');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-affiliateadd-big.png', 'd5c7131c1975085da373524f57febc48');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-affiliateadd-middle.png', 'c05ec87dd20e86e40c5ee7a23d184acf');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-affiliateadd-small.png', '050c51fd19d53154f31252c2cec060c8');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-affiliatesettings-big.png', '6a8d19a4c2a2f49b7a483eb554c67a7e');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-affiliatesettings-middle.png', '462b0a2b18b14dadb0a9359a3e3296ae');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-affiliatesettings-small.png', '477ab1aa47a3b25ec0edff418f3829c0');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-affiliateslist-big.png', '8531931a1a8deec989a128b251b7d8f5');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-affiliateslist-middle.png', '792702720d9f73f31b131a600e263b31');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-affiliateslist-small.png', 'd4c2e1649a26e4fd19dc1960dddbbd34');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-affiliatesoverview-big.png', '108370d42effb2502ba4ea4c947518f0');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-affiliatesoverview-middle.png', 'ad8de49bca55781e6f7b9366d10848f3');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-affiliatesoverview-small.png', 'f9e1bdcc59800c0c103b55291d10018c');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-affiliatetree-big.png', 'f3a3935903ffd1fc62078a69c94b3e96');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-affiliatetree-middle.png', '3efb3954dbfde93f0c7bd5d562b3c27c');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-affiliatetree-small.png', '987817c468127c8b45d72d965b8f808a');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-afflinkprotector-big.png', '41210425d22e80b3415aa664b00d398a');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-afflinkprotector-middle.png', 'f8f8399f715a2a31678b96bea47c9ae0');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-afflinkprotector-small.png', '8a6ca0c7bed131e76f4fae31000201ab');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-affpanel-big.png', 'ad0c3f7baf452316627482ce47ec9b37');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-affpanel-middle.png', '05d7b2248ad334121d39726a988b3493');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-affpanel-small.png', '89acee5cdf219cfb2d1400d3b4a248a5');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-apiintegration-big.png', '702515b8933c9c7ed457d3280ea8e340');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-apiintegration-middle.png', 'd37af643a7d0e045a121f291388c91fd');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-apiintegration-small.png', '676c13fdb6c683af387767cb1789df66');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-banneradd-big.png', '1f5c8423f1a329ac06e2929dfee1b7e3');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-banneradd-middle.png', '5faa76618891e14178f306de5c1c72c0');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-banneradd-small.png', 'b3d8b98e27e2b98f160deae84ef556c2');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-banners-big.png', 'a13d36f6a14c4059befca90c969d12ee');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-banners-middle.png', '0f4345a212b496cef45afec891b05c24');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-banners-small.png', '5ba134d161fe9424b876e7e50511d7dc');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-bannerscategories-big.png', 'a310cda6bf44049c1b0dd3d203e06140');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-bannerscategories-small.png', 'ae5c90546f68383ca6471da4a36870da');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-bannerslist-big.png', '1bf599dbf6524cb922f1f09e4bbda116');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-bannerslist-middle.png', '134ffe754f0e2f838a2f3a02693f0ecf');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-bannerslist-small.png', 'c8f299bb45397ccdaecb7df3c9600ffe');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-bannersoverview-big.png', '8c7b4be8a563f9d0f8c657fbd7b064c0');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-bannersoverview-middle.png', '1e2211f286811bfeba9ba96d1f32e5de');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-bannersoverview-small.png', 'b70ada457ab1c9981f8ab4bef5653e7e');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-bannersscategories-middle.png', '6d575e2b8cddb98be3f83386bf1f1431');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-broadcastemail-big.png', '1d2cfa3b506deb6280ebf4cc98b8c010');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-broadcastemail-middle.png', '8a6537ef09913526b4c1206c170a69d7');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-broadcastemail-small.png', '11b04a9929cd413f1cb3fce70c717a30');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-calccommission-big.png', '7086ebb3d568dcb605be0e4a0924896b');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-calccommission-middle.png', '40ab427ab7b4e42ddb82e0dfcb9d1a1a');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-calccommission-small.png', 'b0f099674dc9c78dfa40e32a832a3b0a');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-calcsettings-big.png', '89d5be624ffbbc8474f2b8030c1cb92e');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-calcsettings-middle.png', '7ddfd7f2b19d63da77caf6a739876951');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-calcsettings-small.png', 'b963cdbae235cc78f68a8acfef8bc6e4');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-campaignadd-big.png', '69354264e1b50b1f050b35af8a1aebb5');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-campaignadd-middle.png', '398346125f7b6b9a61fc4f68220b3fc3');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-campaignadd-small.png', '9b4aae84c0f775bb20507a1414da70e1');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-campaignscategories-big.png', 'a310cda6bf44049c1b0dd3d203e06140');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-campaignscategories-middle.png', 'e6988def816a3b83d6485f81c97d228a');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-campaignscategories-small.png', 'ae5c90546f68383ca6471da4a36870da');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-campaignslist-big.png', 'a52bc02f28d4f56220c320c6574f8f9c');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-campaignslist-middle.png', '18d1cf55d9b41463bf1cc8a61082fd7e');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-campaignslist-small.png', '193e4f56908fa9d045972749abc9780c');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-campaignsoverview-big.png', 'ed8ad85caf2c1ff8c34dfdefb67965ed');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-campaignsoverview-middle.png', 'f2595a1a929404d07b7442927156bdf5');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-campaignsoverview-small.png', '6df551a67a7077c5220e6b609359857a');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-channels-big.png', 'f76d1d8030637adbfa2981b132f80d96');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-channels-middle.png', '2cb39c0ab010e237816a14f8f72c9e83');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-channels-small.png', '03cfb7b9ad94827a4d0bf8336e7e52c0');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-channelstatsreport-big.png', '4b1c13143a301c246e9fcef695e58666');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-channelstatsreport-middle.png', '5041b217680c01a939634c064db1680d');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-channelstatsreport-small.png', '302858f05a10b04f087efe27052206fe');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-clickcommission-big.png', '7da264525cc0d547db7d68817639093e');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-clickcommission-middle.png', '9062c8bdaed678780d9adcdfbf71805e');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-clickcommission-small.png', '2d37adb9026b332a059618cc27896c47');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-clickslist-big.png', 'fbda1422f6bd873d56894c1d7d95ba4f');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-clickslist-middle.png', '1e9e6fd98dede11eb46c274f84402a20');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-clickslist-small.png', 'e6570b0542c57f628986082628994f72');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-clickstracking-big.png', '14d844dae72c0e0511edd4ea5cf7a47a');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-clickstracking-middle.png', 'cbc4cdb681b448d9142ec67da772b748');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-clickstracking-small.png', '6aa780ce3413adaa4ac15e7bd95c3958');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-commissionadd-big.png', '622fad726c5bbc696241898640e20926');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-commissionadd-middle.png', '4c985782fca423e78dcd2b6745b45702');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-commissionadd-small.png', '80f1404144c2a625bcc331a5e5263eab');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-commissionslist-big.png', '0195a700dbe8d2c3ac1608f3cd883ad0');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-commissionslist-middle.png', 'c1825e4ab7760d62b2966b8a8f7c8fe6');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-commissionslist-small.png', 'b08f72525311b61be001eb1604554eeb');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-commreport-big.png', 'f4fce1db7a0c10e677de57dc38a2609e');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-commreport-middle.png', 'b2306eee5a0e98596eeba19e46fecdd1');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-commreport-small.png', 'dcab4d1c0b0faf44f649a819071a0487');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-communication-big.png', '5accfde00d1b34b6e771d0faebc2b1b6');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-communication-middle.png', '0dfd1e7a41c470dc778cd31304e87bbd');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-communication-small.png', 'cebe3e7324bb0d86051f9cbdedfd6ecb');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-configuration-big.png', '2cddf90ad25270348ab96a6d9d874152');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-configuration-middle.png', '3b15283fb36f3944926ac9f33c198b14');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-configuration-small.png', '7b0623ad383b0246f58aa6bc45277678');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-confirmationrequired-big.png', '90210b42d7d84c2185a4a0643454a9fa');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-confirmationrequired-middle.png', 'ac1eff9620b54544f2cade0ba324e6e7');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-confirmationrequired-small.png', '02c4ce14907c147b902e83da8c2f2abb');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-contactus-big.png', '925ea74565475d763da214a66848d090');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-contactus-middle.png', '002d837a4e1aa1f0c9c985e0bcd6a60e');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-contactus-small.png', 'e62035b9b08fd22200b9d0e63401a66b');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-content-big.png', '428601da0d9ba4c3deea1b57259f53d9');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-content-middle.png', '08f103818c506e89fa2e7aee7d0970ec');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-content-small.png', 'd7c377c6c1839c02d8ff4c08241d059e');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-cookie-big.png', '3438d09467e579a8cd77d73556add8fe');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-cookie-middle.png', 'f781aecc5805c2477ef59ea604102290');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-cookie-small.png', '56bec98a07cb2dac95671393cda6c0d5');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-cron-big.png', '854e5c2afb7981b64009af910cb91c2a');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-cron-middle.png', '8aa0ecdb6c6cb2101af2a44262b0cff8');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-cron-small.png', '21af15916c7cb3887c3579a6362c34e3');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-currency-big.png', '599af390c3935dfadab5c6c8a36d717a');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-currency-middle.png', '476ebd22b8b3ee70914a986bf0ed44ee');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-currency-small.png', 'e00d0f217b9c13089a324ebb2a4a276c');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-dailyreports-big.png', '51f3e844ba86a439576661e6fd24ab10');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-dailyreports-middle.png', '8610d4e0dfd7208784d563d874fa887b');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-dailyreports-small.png', 'b69fc28548f6ca7ae3f46bb3006a333e');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-databasestats-big.png', '92877608b8101fc8f19d6c73c66cf678');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-databasestats-middle.png', 'b6ac069c16ff64ce58a6d21d620468c2');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-databasestats-small.png', '878c6102aacf869afa9faf11f88edfa3');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-dialog-big.png', '90210b42d7d84c2185a4a0643454a9fa');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-dialog-middle.png', 'ac1eff9620b54544f2cade0ba324e6e7');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-dialog-small.png', '02c4ce14907c147b902e83da8c2f2abb');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-directlink-big.png', 'c278ffcff33c372f76a7e60decf69bb1');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-directlink-middle.png', '680770b962b47fdbf8f67b31b0d646cd');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-directlink-small.png', 'ba793d7acb6322f1cf6ad3ce700fb640');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-directlinksmanager-big.png', 'c278ffcff33c372f76a7e60decf69bb1');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-directlinksmanager-middle.png', '680770b962b47fdbf8f67b31b0d646cd');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-directlinksmanager-small.png', 'ba793d7acb6322f1cf6ad3ce700fb640');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-emailnotification-big.png', '24e0fa4c00e137fac96db534320154db');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-emailnotification-middle.png', 'c270a2eb37d703dced4196e94fbe7dde');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-emailnotification-small.png', '9f5a038c227bbedcfc87ddcc568dd96c');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-emailsettings-big.png', '9f5d46acd00fb265ebbd545c32f3d9e2');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-emailsettings-middle.png', '1239fedeb1606d41dcf1ccb234ed738c');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-emailsettings-small.png', '727f303733ffea427cc17427fcad1c2c');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-emailtemplates-big.png', 'd0518c39e49dc80897d0f691060f1142');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-emailtemplates-middle.png', 'be7414ea54e19ffe0650fa796d785733');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-emailtemplates-small.png', '1d78171288453cbc025021098d1b4982');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-eventlog-big.png', 'bbfa889e79729293e1303ed0a2ffe309');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-eventlog-middle.png', '338d53857746a8937c029b7ac569d335');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-eventlog-small.png', '3ca1dafbb4a2e956fdb9808be6b45f82');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-export-big.png', '35be33047c8e02e1a32d55be841a65d5');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-export-middle.png', 'ec292304e5b591c83ea7c9394275a9a9');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-export-small.png', '9835074ca5282cfeba17b8d7a036294a');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-exportfiles-big.png', '6ad2c2691a3ce2edb276ac28ee77f621');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-exportfiles-middle.png', 'fd0819f8105a837e30986da44f5bc6e4');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-exportfiles-small.png', '8a1316abaf6351d2ba61a39ca628eab2');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-features-big.png', 'dd45e0325fdac4e3d98c24b36e30bf19');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-features-middle.png', '7ea1404bd47a6185f1d67f367be0f2b2');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-features-small.png', '39df80c8c1eb1bf6b29fa100ebad750d');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-folder-big.png', '964b4525aa06127c52b84a589049c3b8');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-folder-middle.png', '5813b0412260d952b4460e19be72e7ea');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-folder-small.png', '365a922fabd91c200543597d98cf0564');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-foldergrey-big.png', 'e1942d05c09d21e20e56c094002f1fa0');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-foldergrey-middle.png', 'ec0d082b63dfe3a6830fbda08f4ff54c');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-foldergrey-small.png', '55104fb0a0d0492c26055bf2ba7c4f00');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-fraudprotection-big.png', '0f46b039dc06851045f36d4e9eb378e2');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-fraudprotection-middle.png', '1a73eae9b90951de01bc2ff730aa092e');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-fraudprotection-small.png', '697acc0f7c159c13072eaae0033af2d4');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-gettingstarted-big.png', 'd197bbf5a9900bb8d536e66afed03206');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-gettingstarted-middle.png', 'd2f4a4665a3fe71ca2dafc18d668f3cb');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-gettingstarted-small.png', '62ecdf49ec3da0bfad4211057e6e051e');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-help-big.png', '5b04efbf4559f7d56773ade80e8923c7');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-help-middle.png', '70a562cbc3713f88e521d05cb3dd7f1a');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-help-small.png', '61d96309c23e3ed484a8cb498313d9e4');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-home-big.png', '8c15857acaf46bf2bca9ee23ca005fdb');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-home-middle.png', 'c0628583bebe9e6174a1fe020f978c89');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-home-small.png', 'aafc8e41d2753a4f9b6516181acb2dfa');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-import-big.png', 'a3994f14cdc5fdf9447cf1c5f222fb98');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-import-middle.png', '6f71e329a1afc3045ce4d673a5266390');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-import-small.png', 'ca31d217f2c82a3686c25caaf90f18eb');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-importexport-big.png', '22bc4deef07277d9c6157e960b4fccda');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-importexport-middle.png', 'c1afe17385ddb0d901a90ad111415600');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-importexport-small.png', 'ad47885de018e70115fe1e4232b77269');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-impressioncommision-big.png', '495f55816ffa5216e4746c1d1eee9557');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-impressioncommision-middle.png', 'bb4d0494dd90f486d90783a343f2bf15');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-impressioncommision-small.png', 'e97f06809d7944cd2cebc2683aa22370');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-informations-big.png', '90210b42d7d84c2185a4a0643454a9fa');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-informations-middle.png', 'ac1eff9620b54544f2cade0ba324e6e7');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-informations-small.png', '02c4ce14907c147b902e83da8c2f2abb');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-integration-big.png', '6bd708116619dcfa262a6d40674d8e5b');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-integration-middle.png', '6bdc55939230fa36f99e61dc2ad49125');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-integration-small.png', 'c61bb436dc255ce9be68ce8bc94291b2');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-integrationmethods-big.png', '17e48a253c213fb67da54d8cdebf95f0');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-integrationmethods-middle.png', '0ae3248fdb2afb2fa8504f8f32838645');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-integrationmethods-small.png', 'a3a8267d8fe64a8876f4b12150c7b143');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-invalidlicence-big.png', '28b65cd15641f0bcac4a7ca9ff12f3e2');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-invalidlicence-middle.png', 'd4138638238334a9f1c101c18b7f3dc7');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-invalidlicence-small.png', '8abe2ba041d63018480d9a412e54db6c');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-invoice-big.png', '8c950adce63c0a3d575e5592aa2981b3');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-invoice-middle.png', 'eee62a121a1ddb1da1f8f1361876b447');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-invoice-small.png', '5bbc98c7efb943177890379332dc5109');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-invoiceformat-big.png', '5cffed26d74d9b98dbbfb01888b58559');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-invoiceformat-middle.png', 'f2ba0cc61a485dc665beb10a6f7a7c98');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-invoiceformat-small.png', '321e3605531407784effbe53635a8aef');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-languages-big.png', 'a0b72821e1d253339513db5d4643d3cf');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-languages-middle.png', 'aec76897d11268756df3ef7be19876f5');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-languages-small.png', '9c3b59920c9e4dfd9cd7f96d775b9627');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-languagetranslations-big.png', '2103875d8558a3cc616f9a4abf85e713');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-languagetranslations-middle.png', '9b2d68e032e33fbe9bddad86cc3bef1c');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-languagetranslations-small.png', 'ea7e3479c5f47119261cfecef4ab309b');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-linkformats-big.png', 'b2202763a3a9a28a957a17bcb7007943');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-linkformats-middle.png', '19db12b55ce7c4a1ffd3015f3fde7764');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-linkformats-small.png', '8d2b611c63b8dca40d9dcb09fab53385');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-logging-big.png', 'f3f381ea4a2a4b8a1aa0e19de56437de');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-logging-middle.png', 'a2f1359597d5f418e6ea3d635b6daf59');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-logging-small.png', '741214ca11b87b38d0d904650cb3a717');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-logout-big.png', 'd4bba32201c5056c278d53fed4b1bbc7');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-logout-middle.png', '1a1b1120551e1f9a8173859aa4f2cbe3');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-logout-small.png', '25d153721685338959a2dad7af6321ab');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-mapoverlay-big.png', '0f6b98425312f5c78b7f290cc8c89c35');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-mapoverlay-middle.png', '63a3414c94e2a41aea15d05456be47fe');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-mapoverlay-small.png', '26d00c127fbf4a4ae6310f889758ad2d');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-message-big.png', '403ba3600f9e63e33ffc5c0dbb53c44f');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-message-middle.png', '8dd9ebb863d0d76aa6f720eb8f332cd4');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-message-small.png', 'ac79d200fb4199e60193d606ce574d8f');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-networkaccountadd-big.png', '1d869a10b51e3cb53738cf5d4b185511');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-networkaccountadd-middle.png', '55133aa727cc82e002059e82abf4b699');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-networkaccountadd-small.png', '18bd89d5bd977cceb1656787f14771d2');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-networkaccountfields-big.png', 'b8bc6614fbbf1e4deae4d2cf5d2f4501');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-networkaccountfields-middle.png', 'fc399368b0b7044e891f8c83f713e97a');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-networkaccountfields-small.png', '8514ea6a22d424dd3a14876ec70cb3b2');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-networkaccounts-big.png', 'e6fe2e1cd1cda349384c87e57a26865d');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-networkaccounts-middle.png', 'c001bf4f7c6e94020dc00cc44e6682da');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-networkaccounts-small.png', 'a0432c0d3443735d331430568c69e4fa');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-newsletter-big.png', 'd0b8e5c3b293ad29e1a66eeb383d2c8e');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-newsletter-middle.png', 'd06b7b2b542bb1cf12aaf0d939820cf5');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-newsletter-small.png', '7d52c62d5397230708b2448df035ca1d');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-offlinesale-big.png', '35127b1b9d03b19aea95b905e400c1ec');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-offlinesale-middle.png', 'a76f012b2b526bc2455c1be3df69b968');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-offlinesale-small.png', 'f64a930d43970b319f484c35059114b8');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-onlineusers-big.png', '8a140f9f5787e65335573c35af435912');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-onlineusers-middle.png', '40903caac39a38a1f4de08a19dc4f1d5');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-onlineusers-small.png', 'f969b9cec13f1afdbe832d0fd74d9e85');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-outbox-big.png', 'bd4be7e782336809737c3f56d0d95840');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-outbox-middle.png', '51da280d0b41b48e88af9492c74c5b11');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-outbox-small.png', '793acba64f930962243773f51217e905');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-panelsettings-big.png', 'f7b70b68d910bc557de2e42f7d711a3a');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-panelsettings-middle.png', '2d03ba94b420563960bb930bf36edf6e');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-panelsettings-small.png', 'b67eca984d0d89a6805d7712462f56d0');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-parameternames-big.png', '47a57e7c5d1a402c30d102bb8f73c2a6');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-parameternames-middle.png', '06d16585e4f3be531b154ee4b6788907');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-parameternames-small.png', '192530feb2fa8aebe3ee491b6f5f1c5d');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-payaffiliates-big.png', '5262ba6c21f92887786620c1ea8b7637');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-payaffiliates-middle.png', 'd3d46fc871afb345aed861b12b494411');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-payaffiliates-small.png', '708f3f7485253ee76d8aa9882a3e81ae');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-paymentdetails-big.png', '2c3dcc019b163e58f6e991ec3cdeb93a');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-paymentdetails-middle.png', 'ae0d1d42210ddf8010e4b18903a71a5b');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-paymentdetails-small.png', 'e7cc29a55755c0c1c600f3eb29970e30');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-payoutsbalance-big.png', '6d5dfc08ff356dea7e5b4498351b2abb');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-payoutsbalance-middle.png', 'e69a2216780616d8b3d3f051931a05b6');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-payoutsbalance-small.png', 'e7be75d8d0774747990ea964f1e0101d');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-payoutsbyaff-big.png', 'fb58c02622942f34bab91ebce940f3ec');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-payoutsbyaff-middle.png', 'eef1db9e3a6026586901b3fe33b36545');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-payoutsbyaff-small.png', 'e61f9ac8562802dc0aac00ebc31eb31d');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-payoutsettings-big.png', 'ff7264578099e47bf2d4646d357742b2');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-payoutsettings-middle.png', 'ebe350b6ff8af2d08075b28f5db11f3e');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-payoutsettings-small.png', 'ca9c7400e3ff2e50a1725d7b1732c5e3');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-payoutshistory-big.png', '8e87c06adbef25733e01ab3e51b4f6d3');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-payoutshistory-middle.png', '6130fe62b04a66ef19ba1241fb1404a2');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-payoutshistory-small.png', '9e957f26370ef8282a267e5060bcea32');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-payoutslist-big.png', '1bede851415e062a888451c1ef493385');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-payoutslist-middle.png', '6641a3364f458f94d91d6182cc01b176');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-payoutslist-small.png', '27c574fe08115a833acb8e0bdeaf50b9');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-payoutsoverview-big.png', '1bede851415e062a888451c1ef493385');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-payoutsoverview-middle.png', '6641a3364f458f94d91d6182cc01b176');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-payoutsoverview-small.png', '27c574fe08115a833acb8e0bdeaf50b9');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-pendingtasks-big.png', 'efbc34dc0e67b2e87a108e524ddb16bf');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-pendingtasks-middle.png', 'd48852893e28977e18edf8080200712c');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-pendingtasks-small.png', '038469d25098ca85aac324d68f46b9c2');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-personaldetails-big.png', 'db24999d6b323cc4160481b9197cf52e');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-personaldetails-middle.png', 'bcfcba468799c8309ffb8cb8d0cfaa6d');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-personaldetails-small.png', '893a70e6fb2ac1b86c02d7c3bbe06c4a');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-plugins-big.png', 'bf88b03059137ed6ea16485f8e1d4545');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-plugins-middle.png', 'c118bf8d916cf78e70202df8f9c75d4d');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-plugins-small.png', '8c999c38a9d57971341676aa0002cd67');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-promotion-big.png', '7a839eab485f58c64f18373fb98071c1');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-promotion-middle.png', '58f5cac0a7c05b9793088812a786d3ce');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-promotion-small.png', 'baddc96d178672ba3d353459432469ac');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-proxy-big.png', '873881ce0902d108856b66d6cd1bbeb5');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-proxy-middle.png', '9159eda478c488ff964fc3998c7166fe');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-proxy-small.png', 'f3b4244c5a02eb94ed262d6254d06298');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-quickreport-big.png', '13d6307a75e92e4a1dfa3dd47647cedb');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-quickreport-middle.png', '9ef336fd190f5b6e17ed3164d3cb0e9f');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-quickreport-small.png', '931422301455d42e667b0472d3d43066');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-quickstart-big.png', 'd197bbf5a9900bb8d536e66afed03206');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-quickstart-middle.png', 'd2f4a4665a3fe71ca2dafc18d668f3cb');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-quickstart-small.png', '62ecdf49ec3da0bfad4211057e6e051e');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-recurringcommissionslist-big.png', '8316e4d32f09f67d5b85deaa26577dcf');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-recurringcommissionslist-middle.png', '0933b97b1a7da82bf1225ab9eb6b0621');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-recurringcommissionslist-small.png', '3489d6da95b9a3f59dbe9d3b994b6c37');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-reportproblems-big.png', '9395e24a8125e59d979dcf106f5fa56a');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-reportproblems-middle.png', '5d83c6bcafab0d1cb343eaedf66cc855');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-reportproblems-small.png', 'c3bcb16b71995ea184725313eab14ba3');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-reports-big.png', '4b6dce1244d75b94379200e21b318b45');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-reports-middle.png', 'c131c83139fe6e3fe0632abcca35f7e5');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-reports-small.png', '8dcf1727963537d5dea129b9f0833684');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-salecommission-big.png', 'edad2d2af87b8f7cbff8c40cab472e8e');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-salecommission-middle.png', '0fb923346b00270c10d6383310bcb678');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-salecommission-small.png', 'edc571e2de6de0164b7b505b4ae22507');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-screen-big.png', '428601da0d9ba4c3deea1b57259f53d9');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-screen-middle.png', '08f103818c506e89fa2e7aee7d0970ec');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-screen-small.png', 'd7c377c6c1839c02d8ff4c08241d059e');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-send-message-big.png', '925ea74565475d763da214a66848d090');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-send-message-middle.png', '002d837a4e1aa1f0c9c985e0bcd6a60e');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-send-message-small.png', 'e62035b9b08fd22200b9d0e63401a66b');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-signupform-big.png', '94d57c6ffa91773a9e094a7a3f3f09a7');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-signupform-middle.png', 'e568fa54535e4f385eaf91a191e3d38e');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-signupform-small.png', 'ae097dc49a26bc036ad207cb9a5eca52');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-signupsubaff-big.png', 'a45245b27a33cf936d4c9b2d1251d981');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-signupsubaff-middle.png', '4e0de7731560b7c07be66a36fbd5c8a5');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-signupsubaff-small.png', 'a3a9c4345b984dc9522d4ae2c932ab90');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-subaffiliates-big.png', 'd5886239b93fe9bfe1298d968395e761');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-subaffiliates-middle.png', '37c376b667fdcfd16aac1344d5e04b59');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-subaffiliates-small.png', '4a6501ad5d0cf5ee1098037345ea6f04');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-subaffiliatestat-big.png', 'a779b82895bf11652232bfbebbddcf3a');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-subaffiliatestat-middle.png', '9f3d3636c930b1e3adc87e6aba12686c');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-subaffiliatestat-small.png', 'e981446661750ce0b4aabdb056aa21af');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-subidtracking-big.png', 'a9f00f3f0d2880363eca08b4cb5f1077');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-subidtracking-middle.png', 'e9c30cfcbdef74d756ed814f12817a1b');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-subidtracking-small.png', '089f1ee83e8c314b3aa08c00b52ef773');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-systemconfiguration-big.png', '2cddf90ad25270348ab96a6d9d874152');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-systemconfiguration-middle.png', '3b15283fb36f3944926ac9f33c198b14');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-systemconfiguration-small.png', '7b0623ad383b0246f58aa6bc45277678');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-themes-big.png', 'f7b70b68d910bc557de2e42f7d711a3a');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-themes-middle.png', '2d03ba94b420563960bb930bf36edf6e');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-themes-small.png', 'b67eca984d0d89a6805d7712462f56d0');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-tools-big.png', 'e0da1ad291513772326fefcddc8ab42d');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-tools-middle.png', 'b2a25a7a471bba57b2050857980124a5');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-tools-small.png', '506cbde7bdb6c61fe786122b08c59c1c');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-topreferringurl-big.png', 'f1c63c47194544ad073ff2d8800aff57');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-topreferringurl-middle.png', '0193ef9b3cd4c809fe167da539c8c8f0');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-topreferringurl-small.png', 'c44b37822d23b4eb69107b80ca8c9996');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-trackingaffiliates-big.png', '5025622c054d25ce154025f58b04f3e1');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-trackingaffiliates-middle.png', '951449d8043c3a4b87d516dd29b7df2d');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-trackingaffiliates-small.png', '5750ed980100417d63819f951f7d3617');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-trackingsettings-big.png', 'fecc4f7d7b716f954f3324feed92ef23');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-trackingsettings-middle.png', 'bbe8c71155ca22d61746abaff77904d6');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-trackingsettings-small.png', '99e6af89545c48d6c7d2a7f9930a86ca');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-trafficstats-big.png', '4bbbb6d078d6804700d1282bdfdda165');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-trafficstats-middle.png', '2a0efd1e3b9a38d08e5dbd76b8326bea');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-trafficstats-small.png', '7ca396360b45a8e9c1d250d5b0824be2');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-transactionsoverview-big.png', '2a8079383dc03f24a774b3d087333826');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-transactionsoverview-middle.png', 'ddaee41388bb9555e6a0f9ec9eb85eb4');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-transactionsoverview-small.png', '6fd329efc615a54f433f8033024b9395');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-trendsreport-big.png', 'a9763385aa10959738675255bd887e23');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-trendsreport-middle.png', '9820cc73655c0705cffc88c3b4955c38');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-trendsreport-small.png', '8c89cd1902b375fc60c95cc7b750e00f');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-troubleshooting-big.png', '28b65cd15641f0bcac4a7ca9ff12f3e2');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-troubleshooting-middle.png', 'd4138638238334a9f1c101c18b7f3dc7');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-troubleshooting-small.png', '8abe2ba041d63018480d9a412e54db6c');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-tutorialvideo-big.png', 'caff5c6e41fc7a40cd96a9b824736a97');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-tutorialvideo-middle.png', 'a0f1663ecb761ec9cd9f56b9f5021749');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-tutorialvideo-small.png', '1ea035f5e1baa010c6f146f8b2864dad');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-undefined-big.png', '90210b42d7d84c2185a4a0643454a9fa');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-undefined-middle.png', 'ac1eff9620b54544f2cade0ba324e6e7');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-undefined-small.png', '02c4ce14907c147b902e83da8c2f2abb');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-user-big.png', '0e702be569fe18fd148352dd35eef5e2');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-user-middle.png', 'f878bab662c76b22ffa7d13ede296674');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-user-small.png', '7a1aa33a04a1e6b22cc6783e41dde93b');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-userprofile-big.png', 'bbfd648d5aa54e015218481966b13ce2');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-userprofile-middle.png', '2c8656debcb0755306adf8f907d39ceb');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-userprofile-small.png', '3033136cc1fad425f585eefadf311da8');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-userroleprivileges-big.png', 'cb55e04eed7cbee58b0f0b78019062e0');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-userroleprivileges-middle.png', '3b7b51ccd2f9e3beabf92773c15f3f74');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-userroleprivileges-small.png', 'b075544877b61c6a4b26a8a18936d1eb');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-vathandling-big.png', '6bd2f6913cb33846aa9f885c4d632ba0');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-vathandling-middle.png', 'af0af1db4bfada5d4ade650b586371e8');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-vathandling-small.png', '72a79ab793a44af78ff83ea71a8f68ff');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-views-big.png', '6da16ea156043161746b99da65cf1735');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-views-middle.png', 'b6670660397dd9d8f05c6f0260e732f0');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-views-small.png', '312f72396b458c3ea1f9186ae14fe548');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-youraccount-big.png', '8af27a0489c96e8e6a0931a7bd326224');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-youraccount-middle.png', '1df746a876fe002c1b4275f6e813f308');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icon-youraccount-small.png', 'd0d92ffdca1215c55dd1f79246e369f2');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/icons22.png', 'b2ea77f479d2b5020c4c4692d5c6e885');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/left_bg.gif', '6b805be091fa27230cc6750ccc38fc37');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/loading.gif', 'a1ab7b44ef8951bc503b6a80a7a6f24a');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/logo_pap.jpg', 'aba77ff0db8d780333de3c6d61e34216');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/plugin_icon.png', '38f662af0c9848d4afc772c72f711af4');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/reports-month.png', '189ca5b357e070e385b693be11e0ad96');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/reports.png', '2cb48b10c4178fd34b55815ae51ed21c');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/theme_thumbnail.jpg', 'f97187bfcbb5953abf5ed9ce6a4aa2c7');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/img/window.active.png', '83eda02ef182e2ad1345b2e9eb8bf201');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/login_form.tpl', 'fb9d17de38b511dd6a24eb3647427fd0');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/main.tpl', 'f829882a254060b541aea4543c53c73d');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/main_aff_html_doc.stpl', 'ab9130393b2511ae6f169bc730f9abbb');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/main_header.tpl', '732b692c9aa7809d9c71c8e55732af57');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/main_menu.tpl', '5fddab52f7b44bcb5717c1d67875f567');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/map_overlay.tpl', 'da586ddf1266591766692cf8f5f75e1c');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/map_overlay_advanced_filter.tpl', '168f9aad70fd8d84f03bb1cd98acc4f9');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/menu_entry.tpl', 'ae560837dfc1d2ff53ba3fea866de9ab');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/menu_section.tpl', 'da446dbc5a24b9881bd8417ce0371bb5');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/news_content.tpl', '302bb49452665920d9dab6b6addc6700');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/onlineusers_filter.tpl', '4edca7157016faf110102bb4c36c8854');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/overview_panel.tpl', 'ae62662f04bfa67b6ef921d73e3bf5e1');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/panel_includes.stpl', '0f94d032ed0894e4a4fbaf4d54bf3dc0');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/pap4.css', 'e0b27d4800898f6127191efbc8a73eb1');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/payout_fields_panel.tpl', '0b7fafc977b4bb50734ef19256fdddc7');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/payouts_history_filter.tpl', '581756a76965326732abb2494fbbe8df');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/payouts_to_affiliates.tpl', '8e6e3b93e42fccb24184593b8e94989f');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/payouts_to_affiliates_filter.tpl', '240e032a99e6384fd923d3d41a7ecc43');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/period_stats.stpl', '59abd41686ba3646b948ee7af3a4bf00');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/personal_details.tpl', '37f700ae729fbb0f0e1d33570bd4b93d');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/quick_report_content.stpl', 'fe4cd8119b1c9bd75de57ba8df61dfc9');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/quick_report_filter_base.tpl', '5286557cd6c1f6e78006a46b752b4c2e');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/quick_report_multitier_widget.tpl', '8c70fe726b9a6f88e156f9d066678e2d');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/referringurl_advanced_filter.tpl', 'dc3a01ea392255eb0dcc1d21cff25457');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/report_filter.tpl', 'b37d7cb139866b0da13d266ad5e76941');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/send_to_friend.tpl', '8744caafa6e9485d2df807924c933299');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/set_new_password_form.tpl', '8e7fd161e9e90b7abcdd0b51da4aed92');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/signup_fields.tpl', '16c26f808a27c220930859db1a454042');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/signup_subaffiliates.tpl', '2f36cb4fcb6137fd02898c3d305891df');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/stats_chart.tpl', 'a88fcd97c658fc09672adcd4e1b053c9');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/sub_menu_section.tpl', 'f14329a6ad21f2551a068111201c9918');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/subaffiliate_sales_panel.tpl', '40f3e3c0ca3a4aa1ada9b6ce967d02f9');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/subaffiliates_filter.tpl', '7bdd8b4887f806ae9e1299bd37adbadb');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/subaffiliates_panel.tpl', '1bb0059800820188867704265a05d424');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/subaffiliates_sales_filter.tpl', '126d5129aa416789042bf87889d375e6');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/subaffstats_filter.tpl', '829c12fdc814af3a2c231bcafeb74f7e');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/subaffstats_list.tpl', '58f41bd7b4ad280f7a325e11828afadf');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/subid_tracking_screen.tpl', '8270ffce5ea2abf7dc1eefc5163f458e');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/system_menu.tpl', '7d26f32f97e8aa1345ae8f224aeca2c9');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/tests.tpl', 'c684c3cd569104ca2d0505cc1d73f8c6');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/theme.php', 'a44a4a17321fed2ebf67a54f11d432e0');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/theme_settings.tpl', 'e5cc392956225e60996dbe65455439d0');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/topurl_list.tpl', '80dc7467ce6fc992e3bb75b6d7b133dd');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/transaction_list.tpl', 'b263097be77963108886f9cfc95734c1');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/transaction_list_filter_base.tpl', '4fa23a5b6ff9cc4c55b505ca8ebab369');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/trend_actions_stats.tpl', '5d6e55fa6711b536fad187f3a0d26e05');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/trend_actions_stats_widget.tpl', 'cd6b17a53c5dccc568f6382638fffc9b');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/trend_stats.tpl', 'fa4185229e724a7ef92762cba12b53db');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/trends_report_filter.tpl', '2ea0405350afe16cff9d0a92a41aa6a5');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/window.tpl', '564d64cbe6768aab4554e85783c60d38');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/window_bottom_left.tpl', '6fb7ac67f0f538f52fc427b755ce8e5b');
        $this->checkFile('themes/affiliates/LiveAgent_Affiliate_Theme/window_left.tpl', '984d69649ec171a5c6b522e795feb904');
        $this->checkFile('themes/affiliates/Midnight_city/advanced_email_settings_form.tpl', '2a83754f5d407d1c031bf0259ae82b11');
        $this->checkFile('themes/affiliates/Midnight_city/advanced_email_settings_tab.tpl', '4cdac3ab7ec6827e1307d48028f2d835');
        $this->checkFile('themes/affiliates/Midnight_city/advanced_screen.tpl', '7a6fc49337838298197f0d2a4a49746b');
        $this->checkFile('themes/affiliates/Midnight_city/aff_status_panel.tpl', 'f6c8ed375a26bfa2b3262189422c5a1c');
        $this->checkFile('themes/affiliates/Midnight_city/aff_status_widget.tpl', '518ca3971863bd4c41412a286ebfdf75');
        $this->checkFile('themes/affiliates/Midnight_city/affiliate_edit_details_additional.tpl', '98de15bb9a88b36dc47ba266389cb413');
        $this->checkFile('themes/affiliates/Midnight_city/affiliate_manager.tpl', '71f61fa4905cf1b525e2c826f01b2f2f');
        $this->checkFile('themes/affiliates/Midnight_city/affiliate_subaffiliates.tpl', '8c995322ed3cd841aae0928dd8e148fd');
        $this->checkFile('themes/affiliates/Midnight_city/affiliate_theme_settings.tpl', '46f3d82a7762c6669d5014aa5be3d0b8');
        $this->checkFile('themes/affiliates/Midnight_city/affiliate_tutorial_video.tpl', 'dcd2156f94a7bdc8fb75d594ed40a308');
        $this->checkFile('themes/affiliates/Midnight_city/affiliate_urls_no_data.tpl', 'c9868414093445accf0f0d7551847116');
        $this->checkFile('themes/affiliates/Midnight_city/afflink_protector_screen.tpl', '97da4ebc987ac62bbaf542a0e8ce5316');
        $this->checkFile('themes/affiliates/Midnight_city/align_widget.tpl', '124769dbcc410ae58c1dfd53f15b58d6');
        $this->checkFile('themes/affiliates/Midnight_city/api_integration.tpl', '8cc1da5572a29e72e4215867364998ac');
        $this->checkFile('themes/affiliates/Midnight_city/available_values_edit.tpl', 'e96fa729b9a61e7e4a21fbddf80565fb');
        $this->checkFile('themes/affiliates/Midnight_city/banner_category_item.tpl', '38ca8170d3d7b851fbc815cc63681df9');
        $this->checkFile('themes/affiliates/Midnight_city/banner_code_widget.tpl', '91a021d77bd1ddb4f2f007809ad07902');
        $this->checkFile('themes/affiliates/Midnight_city/banner_filter.tpl', 'ed6100072214442574d06b6aa1792976');
        $this->checkFile('themes/affiliates/Midnight_city/banner_preview_promo.tpl', '96b67011b02cd4a04bd508a21d1a8bb4');
        $this->checkFile('themes/affiliates/Midnight_city/banner_preview_textwidget.tpl', '690ff2bbd824bcd5c5bb52be01597520');
        $this->checkFile('themes/affiliates/Midnight_city/banner_preview_widget.tpl', '9df335ee41605fbbc3a3fcdb239478ad');
        $this->checkFile('themes/affiliates/Midnight_city/banner_stats_filter.tpl', '437ce34d575bf783e3b85cd5d39a9cf3');
        $this->checkFile('themes/affiliates/Midnight_city/banner_stats_list.tpl', '3e71f3763376f08380959fe865aad875');
        $this->checkFile('themes/affiliates/Midnight_city/banner_widget.tpl', 'c3ac45f49f8fdc43301943a701882c56');
        $this->checkFile('themes/affiliates/Midnight_city/banner_widget_affiliate_pagepeel.tpl', '50cc893da765f31585fc3e36674d387f');
        $this->checkFile('themes/affiliates/Midnight_city/banner_widget_code.tpl', '0fb2039eec50061e0b6401a239eeca1e');
        $this->checkFile('themes/affiliates/Midnight_city/banner_widget_header.tpl', '76ebd7fa61540f74648a71ba981e3d87');
        $this->checkFile('themes/affiliates/Midnight_city/banner_widget_stats.tpl', 'fe3b4c8e04d179d36b203d53010814da');
        $this->checkFile('themes/affiliates/Midnight_city/banners.tpl', '78cf0cc4bf8f5b94d8000d2ef79383cc');
        $this->checkFile('themes/affiliates/Midnight_city/banners_no_data.tpl', 'c89e4cdd6bccb5df3314e93446c964a4');
        $this->checkFile('themes/affiliates/Midnight_city/breadcrumbs.tpl', '921035f90b931792de2bfd1fb40dc597');
        $this->checkFile('themes/affiliates/Midnight_city/breadcrumbs_entry.tpl', '42ee9a25b7525589ed65bf9625adc890');
        $this->checkFile('themes/affiliates/Midnight_city/broadcast_email.tpl', '7e2d20d16e127ec77e00be3f5d6eab8d');
        $this->checkFile('themes/affiliates/Midnight_city/button.tpl', 'ab00df127be0dd89a125fe05f33c0380');
        $this->checkFile('themes/affiliates/Midnight_city/calendar.tpl', 'd6831aa786acf1f829a90cec776126eb');
        $this->checkFile('themes/affiliates/Midnight_city/campaign_category_item.tpl', '60aa1b58ff10d53fd1e800888b1069cb');
        $this->checkFile('themes/affiliates/Midnight_city/campaign_detail.tpl', '00c57f959e4cff9634cf1acbc181cf21');
        $this->checkFile('themes/affiliates/Midnight_city/campaign_grid_widget.tpl', '984c1470ce27033a2d9d465972298675');
        $this->checkFile('themes/affiliates/Midnight_city/campaign_long_description.tpl', 'c8224613917e714a724a19ed20ce2505');
        $this->checkFile('themes/affiliates/Midnight_city/campaign_stats_filter.tpl', 'ef03bd124d478bb5f8fd418a64c7ab3c');
        $this->checkFile('themes/affiliates/Midnight_city/campaign_stats_list.tpl', 'e45c163f75670253d0dcc5037f7168e2');
        $this->checkFile('themes/affiliates/Midnight_city/campaign_tracking_codes.tpl', '5b62fce6c93e0e85b963c4604a0e8e7f');
        $this->checkFile('themes/affiliates/Midnight_city/campaign_tracking_codes_filter.tpl', '30062ab9dea3ba63b6ea0d205ca453e0');
        $this->checkFile('themes/affiliates/Midnight_city/campaigns_filter.tpl', '3db463dfecc9eb428dab1f2257f2a5d9');
        $this->checkFile('themes/affiliates/Midnight_city/campaigns_list.tpl', '6b63624d55078a801bc09a2e56a04417');
        $this->checkFile('themes/affiliates/Midnight_city/campaigns_list_tree.tpl', 'e344f71cf7eddd7c6c1cc24d4f85fe72');
        $this->checkFile('themes/affiliates/Midnight_city/captcha.tpl', '0326fedb283400e2c13eeae155d7b536');
        $this->checkFile('themes/affiliates/Midnight_city/category_info.tpl', 'bf2e78d31f6a93380f4fbc0538589e84');
        $this->checkFile('themes/affiliates/Midnight_city/change_status_button.tpl', 'a0d13402819088b5078e8100a21a0159');
        $this->checkFile('themes/affiliates/Midnight_city/channel_stats_filter.tpl', '3a5aa4e605bdcf300bcc1f1ad0bf56fb');
        $this->checkFile('themes/affiliates/Midnight_city/channel_stats_panel.tpl', '978b24c1f50a0c2fab07e3d9cf2e6272');
        $this->checkFile('themes/affiliates/Midnight_city/channels_no_data.tpl', '0e1e8193a32385d8c980e2d4a2eff439');
        $this->checkFile('themes/affiliates/Midnight_city/channels_panel.tpl', '5cf41aa13455ddde2cc935f3d2e39672');
        $this->checkFile('themes/affiliates/Midnight_city/chart_datatype_popup.tpl', '7a1a0e024c8392ea5df8cd40b179d4f7');
        $this->checkFile('themes/affiliates/Midnight_city/check_box_group.tpl', 'e182dd7429a276dc85e09049b2a6c19e');
        $this->checkFile('themes/affiliates/Midnight_city/check_box_group_row.tpl', '97219c5c2d3c996953fd6bd882e6200c');
        $this->checkFile('themes/affiliates/Midnight_city/checkboxes_filter.tpl', 'fef5c1833920987bd3172dbe9d75797a');
        $this->checkFile('themes/affiliates/Midnight_city/clicks_list.tpl', 'b1ee1d4fbc2e98ea4e7fc240527a6d46');
        $this->checkFile('themes/affiliates/Midnight_city/clicks_list_filter_base.tpl', 'fb7bfe0b49eb4671b5f8fdcc3fbb54b0');
        $this->checkFile('themes/affiliates/Midnight_city/colorpicker.tpl', '297c4e74e89b8b3dedd12e7c319bce41');
        $this->checkFile('themes/affiliates/Midnight_city/commission_details.tpl', 'c274d41cf9e0a2cfe28d66c36edb40a5');
        $this->checkFile('themes/affiliates/Midnight_city/commissions_no_data.tpl', 'fcd3503c324d1988af6df1c864bfdd80');
        $this->checkFile('themes/affiliates/Midnight_city/confirm_dialog.tpl', 'f92a8f6b3081444abf7fc4ab63c99302');
        $this->checkFile('themes/affiliates/Midnight_city/confirm_dialog_with_value.tpl', '46e7630a0a094110f6819ea655683337');
        $this->checkFile('themes/affiliates/Midnight_city/contact_us.tpl', 'ab01f72bb71446f679190833bdc7b003');
        $this->checkFile('themes/affiliates/Midnight_city/content_gadget_panel.tpl', '79428f6a77f38592dfa1716653bbe79b');
        $this->checkFile('themes/affiliates/Midnight_city/context_menu.tpl', 'cddf235a2fec1ae75063d576ccdc6185');
        $this->checkFile('themes/affiliates/Midnight_city/copy_user_role.tpl', '67725ef54593ecb567ed04a3935faecb');
        $this->checkFile('themes/affiliates/Midnight_city/countries_list_scrolling_wrapper.tpl', '4bf0a92924334c72075b4ddafd3b243b');
        $this->checkFile('themes/affiliates/Midnight_city/coupon.tpl', '7603de7353751cc37e762400f6dc1734');
        $this->checkFile('themes/affiliates/Midnight_city/coupon_codes.tpl', 'a324bcc28deef842f75b6d3b4803dc6e');
        $this->checkFile('themes/affiliates/Midnight_city/coupon_html_code.tpl', '4b85f57df88ff11ee43192e348076b42');
        $this->checkFile('themes/affiliates/Midnight_city/coupon_previews.tpl', '3c5988cdbef06b3ae23b1de600ebf2b0');
        $this->checkFile('themes/affiliates/Midnight_city/coupon_view.tpl', '1d6323a8ae51b2f146792372ec16f690');
        $this->checkFile('themes/affiliates/Midnight_city/coupons_no_data.tpl', 'c8bcc725598c714ca764a2196f380d9d');
        $this->checkFile('themes/affiliates/Midnight_city/currency_textbox.tpl', '859fd8293b92897b3be4c9a6c4aa3a8f');
        $this->checkFile('themes/affiliates/Midnight_city/custom/advanced_tracking.tpl', 'a59f52de667fc173c0266306f5062827');
        $this->checkFile('themes/affiliates/Midnight_city/custom/directlink_explained.tpl', '6f3915445547afa953c203b68c4fa2e5');
        $this->checkFile('themes/affiliates/Midnight_city/custom/frequently_asked_questions.tpl', '835b2045c86a1b65a5202f271947904e');
        $this->checkFile('themes/affiliates/Midnight_city/custom/getting_started.tpl', '8d25f47ab8949fb017ef0d43c0ff51aa');
        $this->checkFile('themes/affiliates/Midnight_city/custom/promotion_tips.tpl', '4e39eb13d5fefdb3a8db63fbbd5e2d00');
        $this->checkFile('themes/affiliates/Midnight_city/custom.css', '4877ef2467745239a93ebe1e79b2f813');
        $this->checkFile('themes/affiliates/Midnight_city/custom_date_panel.tpl', 'c624f3d63d0e94db867529dc13a827d1');
        $this->checkFile('themes/affiliates/Midnight_city/custom_filter_element.tpl', 'bf05e5d299fb1982ea8139f2a605846b');
        $this->checkFile('themes/affiliates/Midnight_city/custom_filter_field.tpl', '21c8ab135d5d89e320ec85456ec457e0');
        $this->checkFile('themes/affiliates/Midnight_city/custom_license_invalid.tpl', '9157ecde6accdbe2f6cd622084e79d53');
        $this->checkFile('themes/affiliates/Midnight_city/custom_time_panel.tpl', 'd408a8352774d70124788d61a90493b6');
        $this->checkFile('themes/affiliates/Midnight_city/daily_report.tpl', '696092e06570b6eebad4c345d98c5ca9');
        $this->checkFile('themes/affiliates/Midnight_city/daily_report_filter.tpl', 'cdd6b5b0f3f67e1c68221170d4075b5c');
        $this->checkFile('themes/affiliates/Midnight_city/data_field.tpl', 'dd553594505158cd53cc285d3a91fe23');
        $this->checkFile('themes/affiliates/Midnight_city/data_field_with_help.tpl', '4615cdd789beea34c16b4c1f692a3a3b');
        $this->checkFile('themes/affiliates/Midnight_city/date_number_format_panel.tpl', 'e26284328d2ba7da47d30e8e458c13b1');
        $this->checkFile('themes/affiliates/Midnight_city/date_preset_panel.tpl', 'abc7d225baa948aed70cc1073b786fe8');
        $this->checkFile('themes/affiliates/Midnight_city/date_range_filter.tpl', '3875dbc075f33ccaac856190ee103557');
        $this->checkFile('themes/affiliates/Midnight_city/date_range_filter_field.tpl', '94048704212b6797b7b7a08fb7888da9');
        $this->checkFile('themes/affiliates/Midnight_city/date_textbox.tpl', '4d2bf89bd754bbaccc15e48d7a37dd02');
        $this->checkFile('themes/affiliates/Midnight_city/daterange_popup.tpl', 'dc1728d13b0440b8df5e12359010168a');
        $this->checkFile('themes/affiliates/Midnight_city/datetimepickercontent.tpl', '9771684f29bc88d974cc64283055d1d1');
        $this->checkFile('themes/affiliates/Midnight_city/desktop.tpl', 'b653025800e416896bd453246061a535');
        $this->checkFile('themes/affiliates/Midnight_city/desktop_gadget.tpl', '21394ff13337e4716860c12b5e4fb312');
        $this->checkFile('themes/affiliates/Midnight_city/desktop_main_menu.tpl', '31eb02f3f6b767d24012753d50ff5159');
        $this->checkFile('themes/affiliates/Midnight_city/desktop_settings_mode.tpl', '1054d3be606383580f8d521f2d72682f');
        $this->checkFile('themes/affiliates/Midnight_city/direct_link_form.tpl', '48d9f1ab56c63c05304185fbc8163922');
        $this->checkFile('themes/affiliates/Midnight_city/direct_link_grid_widget.tpl', '586c3b902d66c903d87e510bca5843ec');
        $this->checkFile('themes/affiliates/Midnight_city/direct_linking_panel.tpl', 'd96cd58bb0f0537f8404f641367e0801');
        $this->checkFile('themes/affiliates/Midnight_city/direct_links_screen.tpl', 'ec5317f983964f7c42f2a4a8a28c5e3b');
        $this->checkFile('themes/affiliates/Midnight_city/download_login_form.tpl', 'ccf5bf5eab2bc42572c4538224cbef4e');
        $this->checkFile('themes/affiliates/Midnight_city/download_signup_form.tpl', '9dff3be2354fc10a70cc1b98b2f08434');
        $this->checkFile('themes/affiliates/Midnight_city/drag_container.tpl', '358104feb6f9c3c2a01206e460726eac');
        $this->checkFile('themes/affiliates/Midnight_city/dynamic_form_panel.tpl', 'ea42da62b4a44f1fa9caf50a59c29160');
        $this->checkFile('themes/affiliates/Midnight_city/dynamic_link_panel.tpl', '33245e1f6d416f28a8555078142abfe4');
        $this->checkFile('themes/affiliates/Midnight_city/edit_textarea_widget.tpl', '94b2c94dd103b5209bd89470fc70268c');
        $this->checkFile('themes/affiliates/Midnight_city/edit_tracking_code_widget.tpl', '5f25a27d5086317f495922f67ad88e33');
        $this->checkFile('themes/affiliates/Midnight_city/editor.tpl', 'a8c5483c720526b56fa899a91045c287');
        $this->checkFile('themes/affiliates/Midnight_city/editor_with_constants_panel.tpl', '6c9e8d91f33bc90c661e9b67ca5ff1e1');
        $this->checkFile('themes/affiliates/Midnight_city/email_form.tpl', '7809f19dc7e837c8dbe6f4d58e6574b7');
        $this->checkFile('themes/affiliates/Midnight_city/email_notifications.tpl', '8153cb771f309301f07a29ebec237250');
        $this->checkFile('themes/affiliates/Midnight_city/email_setting_smtp_form.tpl', 'd17124a143f842ab1876ed14a74bc762');
        $this->checkFile('themes/affiliates/Midnight_city/email_settings_spf.tpl', 'ca349c37b841ccef522f8767817bf1d2');
        $this->checkFile('themes/affiliates/Midnight_city/email_settings_tab.tpl', '8fef8cf6eacfffe581527d391ffb97da');
        $this->checkFile('themes/affiliates/Midnight_city/email_template_edit_panel.tpl', '2a432b9530ad4375605916e152dd8b60');
        $this->checkFile('themes/affiliates/Midnight_city/expired_session_dialog.tpl', 'ba711bd5d1e932ffc4fbc8e601204905');
        $this->checkFile('themes/affiliates/Midnight_city/export_to_csv.tpl', 'cdbd08521a7f231bbf4f0181cb0d807f');
        $this->checkFile('themes/affiliates/Midnight_city/extendable_commission_data.tpl', '43b5108a8212bccdb414370023388e10');
        $this->checkFile('themes/affiliates/Midnight_city/extendable_text.tpl', 'a69efdb298a3aae26e26793c9b9fea36');
        $this->checkFile('themes/affiliates/Midnight_city/extendable_text_content.tpl', 'cca4ebdf72f3cb7638b6c5bf0f59d9aa');
        $this->checkFile('themes/affiliates/Midnight_city/extendable_text_widget.tpl', '83288dfd8795a2a9105965dde2ebc927');
        $this->checkFile('themes/affiliates/Midnight_city/field_type_edit.tpl', 'b1294ba5d4486ea1cf8022a51e277a11');
        $this->checkFile('themes/affiliates/Midnight_city/file_widget.tpl', 'a7410b3e376c1b177c47831f83a68c55');
        $this->checkFile('themes/affiliates/Midnight_city/filter.tpl', '10de4692c8015c544a44267942cf4017');
        $this->checkFile('themes/affiliates/Midnight_city/filter_field_decorator.tpl', '531d57478d7718e216ea04ff79d493ca');
        $this->checkFile('themes/affiliates/Midnight_city/filter_form.tpl', '67551720cbc190c8df85c24d3f8a4cbe');
        $this->checkFile('themes/affiliates/Midnight_city/financial_overview.tpl', '8a82f2f60d7ad6eeeda3e4a4122ac3c8');
        $this->checkFile('themes/affiliates/Midnight_city/font/Roboto/Roboto-Black.ttf', '31d51f54d6fd75795fce785dcad65bea');
        $this->checkFile('themes/affiliates/Midnight_city/font/Roboto/Roboto-Black.woff', '23d7e55956013dddec52a7bf4e3b411d');
        $this->checkFile('themes/affiliates/Midnight_city/font/Roboto/Roboto-Bold.ttf', '27d971424eb4ddde73416cc6b04e9f30');
        $this->checkFile('themes/affiliates/Midnight_city/font/Roboto/Roboto-Bold.woff', '72e37e5bf95a8dba938c78b1d7d91253');
        $this->checkFile('themes/affiliates/Midnight_city/font/Roboto/Roboto-Light.ttf', '2f681219c70f2e32a091f1ccd1e072df');
        $this->checkFile('themes/affiliates/Midnight_city/font/Roboto/Roboto-Light.woff', '56991a6627087ad081029dc0a64a91e4');
        $this->checkFile('themes/affiliates/Midnight_city/font/Roboto/Roboto-Medium.ttf', '9aa5df0dfc4a7d26f1ed59527ed3475f');
        $this->checkFile('themes/affiliates/Midnight_city/font/Roboto/Roboto-Medium.woff', 'f4fa50c4003f87e7dc10459e500933c3');
        $this->checkFile('themes/affiliates/Midnight_city/font/Roboto/Roboto-Regular.ttf', 'f19e9ae531ffabc1847c2aa8c8e8a75d');
        $this->checkFile('themes/affiliates/Midnight_city/font/Roboto/Roboto-Regular.woff', 'fc3d4b35e4d07d4e0485cc2db0e57c77');
        $this->checkFile('themes/affiliates/Midnight_city/font/fontello.eot', 'b2012373de53bdcf186b789d03b1b651');
        $this->checkFile('themes/affiliates/Midnight_city/font/fontello.svg', '1045c4485908e58054e248bf90c4f758');
        $this->checkFile('themes/affiliates/Midnight_city/font/fontello.ttf', '8da4acbde1b1dbbaee498b2adcfd4bf7');
        $this->checkFile('themes/affiliates/Midnight_city/font/fontello.woff', 'f57a4db78bda8b28d724838c290ff166');
        $this->checkFile('themes/affiliates/Midnight_city/font/fontello.woff2', '067318fe80a3455f47aba86c12dde49d');
        $this->checkFile('themes/affiliates/Midnight_city/fontello.css', '7abe36cc2ed0ccbbaad467c15445aa12');
        $this->checkFile('themes/affiliates/Midnight_city/footer.stpl', 'cae74dd5cc67d8eb1a47e0bbeaf3fee4');
        $this->checkFile('themes/affiliates/Midnight_city/footer.tpl', 'acf430b8fece1dddd26ef7f7165a7044');
        $this->checkFile('themes/affiliates/Midnight_city/forgot_password.tpl', 'e31e8cf668201db153fb5783283dc75c');
        $this->checkFile('themes/affiliates/Midnight_city/form_field.tpl', '5c7ae4b0f01f4a7753ab811e0a57f29f');
        $this->checkFile('themes/affiliates/Midnight_city/form_field_checkbox.tpl', 'c1f1746d1bf5c7abfaf9e5ddb7b4cc52');
        $this->checkFile('themes/affiliates/Midnight_city/form_field_checkboxgroup.tpl', 'be1b525a89f033d4f79433dd3eaab593');
        $this->checkFile('themes/affiliates/Midnight_city/form_field_radio.tpl', '9013ed97a5fc7b4b52052d816a9b25d0');
        $this->checkFile('themes/affiliates/Midnight_city/frame_panel.tpl', '7b13a1add8ba712d8a34f4285414b419');
        $this->checkFile('themes/affiliates/Midnight_city/general_no_data.stpl', '03433ae7bf79c177a476922c2ee779c5');
        $this->checkFile('themes/affiliates/Midnight_city/gpf.css', 'ec27b549fa06e9420afb4e6d56ee3a96');
        $this->checkFile('themes/affiliates/Midnight_city/gpf_db_mail.tpl', 'b5ea5e9ecef2152fdf967085a7689adc');
        $this->checkFile('themes/affiliates/Midnight_city/grid.tpl', '1797f6072932e243275fbf0fe1382a6d');
        $this->checkFile('themes/affiliates/Midnight_city/grid_bottombuttons.tpl', '30a61eeb486bc2ce22368100d53fc392');
        $this->checkFile('themes/affiliates/Midnight_city/grid_bottomgridline.tpl', '9bf2013a170e094e82dc1ae0a2ed0f97');
        $this->checkFile('themes/affiliates/Midnight_city/grid_nodata.tpl', '340ff6de789cd7277a35d763f6366f24');
        $this->checkFile('themes/affiliates/Midnight_city/grid_pager.tpl', '46e6d959616563985ece2d92c0234826');
        $this->checkFile('themes/affiliates/Midnight_city/grid_selector.tpl', 'ff2d81e3866f53d540a0d063bdf7b480');
        $this->checkFile('themes/affiliates/Midnight_city/grid_topbuttons.tpl', '83a65b7b03d432beb47d16e78cdf8aee');
        $this->checkFile('themes/affiliates/Midnight_city/grid_topgridline.tpl', '3ff9c43cb7f7fcbbcdc7f03c8822a70d');
        $this->checkFile('themes/affiliates/Midnight_city/header.stpl', 'a1280de5b51c8c21c5c8169fa4075378');
        $this->checkFile('themes/affiliates/Midnight_city/header.tpl', '32d459ea9f7ebf7a241715058cc91f38');
        $this->checkFile('themes/affiliates/Midnight_city/home.tpl', 'd25d3eb83817cf220778e4ee39d1f887');
        $this->checkFile('themes/affiliates/Midnight_city/horizontal_layout_panel.tpl', '8b6098cd64720cff686cc24e06ac4c17');
        $this->checkFile('themes/affiliates/Midnight_city/html_window_preview.stpl', '02d9e7142f0e2fa88afa0b9af7d9f5fc');
        $this->checkFile('themes/affiliates/Midnight_city/icon_button.tpl', 'a7497a39fe733586fb4f5a1b9f424b0f');
        $this->checkFile('themes/affiliates/Midnight_city/icon_object.tpl', 'ff8d25e63eca03b325c4501e13358fb2');
        $this->checkFile('themes/affiliates/Midnight_city/icon_picker.tpl', '77a002b90f678df44bcca5776f314820');
        $this->checkFile('themes/affiliates/Midnight_city/icon_picker_panel.tpl', '4342c424a8cb290701f64d0cb63655ec');
        $this->checkFile('themes/affiliates/Midnight_city/icon_status_widget.tpl', 'ff9e2bc87e203324cc33c4b3ac365dfe');
        $this->checkFile('themes/affiliates/Midnight_city/image_uploader.tpl', '091439bdf235f35fb4c42d58b789f216');
        $this->checkFile('themes/affiliates/Midnight_city/img/favicon.ico', 'ac3e93c93589318e5dcf69efc8a76176');
        $this->checkFile('themes/affiliates/Midnight_city/img/icon-128.png', 'a450a0dd5959518fdb2308cc5e523bcc');
        $this->checkFile('themes/affiliates/Midnight_city/img/icon-192.png', '8cb72062e4df9eab6c2a064459a5ee62');
        $this->checkFile('themes/affiliates/Midnight_city/img/pan-logo.svg', 'a19c0ad7bfad0399a0f82599a571db9a');
        $this->checkFile('themes/affiliates/Midnight_city/img/pap-logo.svg', '6280dc47fe440c1c1c3af00cc27f1ced');
        $this->checkFile('themes/affiliates/Midnight_city/img/theme_thumbnail.jpg', '528745e98a840c740f86155659e3b728');
        $this->checkFile('themes/affiliates/Midnight_city/import_custom_language_panel.tpl', '36fe179dc09cd1a1bf3561ef9d13a647');
        $this->checkFile('themes/affiliates/Midnight_city/import_language.tpl', 'c1df1cf60613d3df6e19681193ae41a9');
        $this->checkFile('themes/affiliates/Midnight_city/info_dialog.tpl', '886c377f8e8c1b2c6957451436e1d090');
        $this->checkFile('themes/affiliates/Midnight_city/ip_detail.tpl', '3723b4ce7dc6ccc4b8c8193f4c982d18');
        $this->checkFile('themes/affiliates/Midnight_city/item.tpl', '717eff0e06a712a76effb2d6723183b5');
        $this->checkFile('themes/affiliates/Midnight_city/item_panel.tpl', 'b24ed05bdf4cb76a7afc1e9a9908def8');
        $this->checkFile('themes/affiliates/Midnight_city/language_create_new.tpl', '1ae789af118ce84a76ec067e82d52aec');
        $this->checkFile('themes/affiliates/Midnight_city/language_edit_panel.tpl', '4b582c49c5aec0a72765e8764ba390b0');
        $this->checkFile('themes/affiliates/Midnight_city/language_translations_grid.tpl', 'b3d4b3ff7279bf9383886e84ba3218ab');
        $this->checkFile('themes/affiliates/Midnight_city/languages_configuration.tpl', '86f17a42cef0bedb165295e99c970582');
        $this->checkFile('themes/affiliates/Midnight_city/layout_panel_content.tpl', 'd49730d94578e00ed7395eaa1d2a3df6');
        $this->checkFile('themes/affiliates/Midnight_city/layout_panel_header_navigation.tpl', '6b0d746501001da8615a22d57266dcb0');
        $this->checkFile('themes/affiliates/Midnight_city/layout_panel_tab.tpl', '316df333cac9b455c7dc04100c2e2d1d');
        $this->checkFile('themes/affiliates/Midnight_city/license_invalid.tpl', '6181e1127345050c94d6708cd805aefb');
        $this->checkFile('themes/affiliates/Midnight_city/link_button.tpl', '71fad92bff79f1fd2e1066818afac789');
        $this->checkFile('themes/affiliates/Midnight_city/listbox.tpl', '2739c2a9e22d54280cacf4d67ed2e7bc');
        $this->checkFile('themes/affiliates/Midnight_city/listbox_popup.tpl', '8c45877411c0727e814eb5e3caa76822');
        $this->checkFile('themes/affiliates/Midnight_city/listdown_button.tpl', 'a1cd26a1aec6d403420971d7469a6f1b');
        $this->checkFile('themes/affiliates/Midnight_city/load_mail_from_template.tpl', '42c0029422eaf077a5b0c316cd3317b5');
        $this->checkFile('themes/affiliates/Midnight_city/loadable_tree.tpl', 'e2c214b134bffe5fe2bb38f679a64eb5');
        $this->checkFile('themes/affiliates/Midnight_city/loading_screen.tpl', '45d70765ad380ad3f0df92c82de65792');
        $this->checkFile('themes/affiliates/Midnight_city/login.tpl', 'e7be8367104ee7221547730250f9b0f0');
        $this->checkFile('themes/affiliates/Midnight_city/login_form.tpl', '297656a8cfb59277903ed38dfaa9e2f1');
        $this->checkFile('themes/affiliates/Midnight_city/login_form_downloadable.tpl', '6f2b17262524a8c12cfdcd572ad36bf9');
        $this->checkFile('themes/affiliates/Midnight_city/login_main.tpl', '0cd828d3f67418d0795faf78316d9aaf');
        $this->checkFile('themes/affiliates/Midnight_city/logins_history.tpl', '740e9d7a1b893fe3280b782958742998');
        $this->checkFile('themes/affiliates/Midnight_city/loginshistory_filter.tpl', '64804e791ea2ca4fcc7e01d7a8443479');
        $this->checkFile('themes/affiliates/Midnight_city/logs_no_data.tpl', 'c807c1484862c46a3f72f1ea0d276b3f');
        $this->checkFile('themes/affiliates/Midnight_city/mail_detail_data.tpl', 'cb8867c95ce35d7ad35b82f5c663ae42');
        $this->checkFile('themes/affiliates/Midnight_city/mail_outbox_panel.tpl', 'eda83d3c7fed41f0449b2464e96df945');
        $this->checkFile('themes/affiliates/Midnight_city/mailoutbox_filter.tpl', '8fd6e8ae35323bbc8debd1c248142e61');
        $this->checkFile('themes/affiliates/Midnight_city/mailoutbox_list_no_data.tpl', '12637515858ca4d960c6202e8a89042b');
        $this->checkFile('themes/affiliates/Midnight_city/main.tpl', '5461cc6e184ba38a56ac7d5c0da6e4b2');
        $this->checkFile('themes/affiliates/Midnight_city/main_aff_html_doc.stpl', '042c213a30cb852e0920feb881496bd6');
        $this->checkFile('themes/affiliates/Midnight_city/main_error_html_doc.tpl', '89e4ff6367f0c343868fd155905c5bbd');
        $this->checkFile('themes/affiliates/Midnight_city/main_filter_panel.tpl', '0985a7421f898d75d4df72b4a6081c49');
        $this->checkFile('themes/affiliates/Midnight_city/main_header.tpl', '5b01f94a773845f032b3f39078104c1f');
        $this->checkFile('themes/affiliates/Midnight_city/main_menu.tpl', '5fddab52f7b44bcb5717c1d67875f567');
        $this->checkFile('themes/affiliates/Midnight_city/map_overlay.tpl', 'd12618268f18867d1f8ef84d12c8ba32');
        $this->checkFile('themes/affiliates/Midnight_city/map_overlay_advanced_filter.tpl', '49179fdc36d2dbe8d6630d267fbdb2c0');
        $this->checkFile('themes/affiliates/Midnight_city/menu_entry.tpl', '9245aaaa5732793ce089f5fe25d703ea');
        $this->checkFile('themes/affiliates/Midnight_city/menu_section.tpl', 'ce9552c9579aa842bfd16e9c61b1cd0e');
        $this->checkFile('themes/affiliates/Midnight_city/messages.tpl', 'bf1a3bac08c419320acb94673ad29f0b');
        $this->checkFile('themes/affiliates/Midnight_city/module_body.stpl', 'c079addcd33eb725ab7efbf09c16a793');
        $this->checkFile('themes/affiliates/Midnight_city/multi_editor.tpl', '3ee5baa5bdb7824c0c2ae6f2dc275830');
        $this->checkFile('themes/affiliates/Midnight_city/multiselect.tpl', '9d1863b21edd131520315ce252fde639');
        $this->checkFile('themes/affiliates/Midnight_city/myprofile.tpl', 'bc9c2c67e2fac95d707b8508da3bfca6');
        $this->checkFile('themes/affiliates/Midnight_city/news_content.tpl', 'a576598444bb0db20fa8d47854f1ef34');
        $this->checkFile('themes/affiliates/Midnight_city/news_item.tpl', '18161a56a8f4dc5df01f08191709f864');
        $this->checkFile('themes/affiliates/Midnight_city/newsletter_broadcast_form.tpl', '1ccb4e8c2a3873263c7c8c1fc7c19f27');
        $this->checkFile('themes/affiliates/Midnight_city/newsletter_broadcasts.tpl', 'e85ba6dc04b3a921af601f6bf976a5b8');
        $this->checkFile('themes/affiliates/Midnight_city/newsletter_edit_panel.tpl', '73ddca2129beb12e11215b1c55e70461');
        $this->checkFile('themes/affiliates/Midnight_city/newsletter_form.tpl', 'e86bb366b8986ac4cb1b50c9ccc94b8e');
        $this->checkFile('themes/affiliates/Midnight_city/no_content_gadgets.tpl', '1d4ce600d473f33e2b229101a50cbc3f');
        $this->checkFile('themes/affiliates/Midnight_city/no_language_selected.tpl', 'd61125f2b1cf78e4e66653d4e2f04bdd');
        $this->checkFile('themes/affiliates/Midnight_city/notification_window.tpl', 'db781872bdb9748bc838e051b8e5e4e2');
        $this->checkFile('themes/affiliates/Midnight_city/online_users.tpl', 'e78ff82eb18c092018cd48d90ae48863');
        $this->checkFile('themes/affiliates/Midnight_city/online_users_gadget_rolecount.tpl', '5fd6af0c5f2edec24d0e35dc00a9e870');
        $this->checkFile('themes/affiliates/Midnight_city/onlinegadgets_no_data.tpl', 'f5f692a433b4911963a92c41cc269768');
        $this->checkFile('themes/affiliates/Midnight_city/onlineusers_filter.tpl', '7a0572e8ae3375f2c79c8fe985295bd6');
        $this->checkFile('themes/affiliates/Midnight_city/order_id_filter.tpl', '103e1ce5be4c9d2f1cc161390371e222');
        $this->checkFile('themes/affiliates/Midnight_city/page_header.tpl', '4fd5676c44341f95ee0435c1f78da534');
        $this->checkFile('themes/affiliates/Midnight_city/panel_footer.stpl', '2ecfae35d4c9436786fd4b2c26747242');
        $this->checkFile('themes/affiliates/Midnight_city/panel_with_icons.tpl', 'cdc3dafa07941a7c6c1ec5c4297528d6');
        $this->checkFile('themes/affiliates/Midnight_city/pap4.css', 'a5b76263097bb425768d5ed2bc23da86');
        $this->checkFile('themes/affiliates/Midnight_city/pap4.rtl.css', 'b2be773411012d5d09a4b162689e50bd');
        $this->checkFile('themes/affiliates/Midnight_city/password_constraint_panel.tpl', '71b23765c240aff0073e713cfc4da992');
        $this->checkFile('themes/affiliates/Midnight_city/password_panel.tpl', 'b1440553a785aae589233a91315b281f');
        $this->checkFile('themes/affiliates/Midnight_city/payment_details_panel.tpl', 'a3e9de7c3f7f02631e17f2ddfd47c1a6');
        $this->checkFile('themes/affiliates/Midnight_city/payout_data.tpl', '04fbc30b334480035464925430c1b84c');
        $this->checkFile('themes/affiliates/Midnight_city/payout_fields_panel.tpl', 'a0574ca1f8ca180f8bb347a75856b6c5');
        $this->checkFile('themes/affiliates/Midnight_city/payouts_no_data.tpl', '679aa0a26f28531b3303c5ad09c962fc');
        $this->checkFile('themes/affiliates/Midnight_city/payouts_to_affiliates.tpl', '48147fc1ef03936a6eed55f580ec7721');
        $this->checkFile('themes/affiliates/Midnight_city/pending_backround_tasks.tpl', '75149233f7ae446473c9220c9ff1ef8f');
        $this->checkFile('themes/affiliates/Midnight_city/period_stats.stpl', 'fa4c74d62a92931f3e0973537c987b56');
        $this->checkFile('themes/affiliates/Midnight_city/personal_details.tpl', '1fbbdbb864bbfcadf87cb2bbab9b8870');
        $this->checkFile('themes/affiliates/Midnight_city/popup_form_widget.tpl', '0f5d2ef3d678d026df06fe1f1e5991a8');
        $this->checkFile('themes/affiliates/Midnight_city/promotools_screen.tpl', 'd00db589b34cfb6468a9eab3d94303f8');
        $this->checkFile('themes/affiliates/Midnight_city/proxy_server_configuration.tpl', '732a20cf9c1d59496e88d9bd5b080484');
        $this->checkFile('themes/affiliates/Midnight_city/quick_report_base.tpl', '03394fc9a529f4d9d13f8cbcb664be8f');
        $this->checkFile('themes/affiliates/Midnight_city/quick_report_content.stpl', 'a75ca3ba3fc385de73eae7311f79c650');
        $this->checkFile('themes/affiliates/Midnight_city/quick_report_content_multitier.stpl', 'e45556a573992274576437d9d34bdd71');
        $this->checkFile('themes/affiliates/Midnight_city/quick_report_filter_base.tpl', '5998ae63fc0257404ef11638ca30eb95');
        $this->checkFile('themes/affiliates/Midnight_city/quick_report_multitier_widget.tpl', '2f19acbcc8ca3270ba3b1d16b6253c1d');
        $this->checkFile('themes/affiliates/Midnight_city/quick_stats.tpl', 'eb812b06f6292efc64d3aa411c1f8cc0');
        $this->checkFile('themes/affiliates/Midnight_city/quick_stats_box.tpl', '745d64595b8a0e5869bfc1e9bf10b9c2');
        $this->checkFile('themes/affiliates/Midnight_city/quicklaunch_settings.tpl', '1e595ebaeb4364f173ee3fec71c1762d');
        $this->checkFile('themes/affiliates/Midnight_city/radio_button_group_row.tpl', '3713f6d400aa1ca96d9e404082304912');
        $this->checkFile('themes/affiliates/Midnight_city/rawclicks_no_data.tpl', '4377ca4cc0e45e3ee4676ec94def1e0a');
        $this->checkFile('themes/affiliates/Midnight_city/recipients.tpl', 'cae0cd53d947d39c2ad761f6f29b2d65');
        $this->checkFile('themes/affiliates/Midnight_city/referringurl_advanced_filter.tpl', 'f1479abbb38dc35d909f4a3c8c961a94');
        $this->checkFile('themes/affiliates/Midnight_city/refresh_panel.tpl', '5c709df4d219d5feb4f29003ca932f77');
        $this->checkFile('themes/affiliates/Midnight_city/regional_settings.tpl', '7fd67a6e2e8b44c62dc36ce4812b7189');
        $this->checkFile('themes/affiliates/Midnight_city/regional_settings_tab.tpl', '82a573fa67deb883c207f05c019f7eeb');
        $this->checkFile('themes/affiliates/Midnight_city/report_filter.tpl', 'cfa31cd337c81b3e863f97b664581327');
        $this->checkFile('themes/affiliates/Midnight_city/reports_screen.tpl', 'c49a73add81baccd69c14ee5ff38b904');
        $this->checkFile('themes/affiliates/Midnight_city/request_new_password_form.tpl', 'e4e20e8042328f80b7b400e39d921986');
        $this->checkFile('themes/affiliates/Midnight_city/resizable_text_area.tpl', '7995c217048ccd289dfee567a455b08e');
        $this->checkFile('themes/affiliates/Midnight_city/richlistbox.tpl', '13229a43763945932dc8d5d7fa21d08e');
        $this->checkFile('themes/affiliates/Midnight_city/richlistbox_popup.tpl', 'c155c59eea77770589bcadca0c75f1af');
        $this->checkFile('themes/affiliates/Midnight_city/richtext_editor.tpl', '99af0e75e8761690e55e65fa238d8d4c');
        $this->checkFile('themes/affiliates/Midnight_city/richtext_editor_toolbar.tpl', '3798b9151ed1d87c99e5783005c81773');
        $this->checkFile('themes/affiliates/Midnight_city/richtexteditor_addlink.tpl', 'c9bd3a510535abef1076a29328f069e7');
        $this->checkFile('themes/affiliates/Midnight_city/role_privileges.tpl', '9163270235450787bb9ebf86df5b2f69');
        $this->checkFile('themes/affiliates/Midnight_city/rotator_preview_affiliate.stpl', 'b9766c5bec13353b6b35944db1a983e0');
        $this->checkFile('themes/affiliates/Midnight_city/search_filter.tpl', 'c43c492cae5282a628238b4ff75508b2');
        $this->checkFile('themes/affiliates/Midnight_city/selectbutton_search.tpl', 'dedb23ce356b1b66377e648232dc2b8b');
        $this->checkFile('themes/affiliates/Midnight_city/send_to_friend.tpl', 'e7b902ca2beb79a6dab513cebf161a87');
        $this->checkFile('themes/affiliates/Midnight_city/set_new_password_form.tpl', '9270391a0892b67b03efbd67084806c6');
        $this->checkFile('themes/affiliates/Midnight_city/sidebar.tpl', '65226d7e25dcdca0cf71a9f3118d8139');
        $this->checkFile('themes/affiliates/Midnight_city/sidebar_closed.tpl', '3d903661713a9ee5fb402776ee06d310');
        $this->checkFile('themes/affiliates/Midnight_city/sidebar_gadget.tpl', '1f904859e056808c8826836a4e256761');
        $this->checkFile('themes/affiliates/Midnight_city/signup_fields.tpl', '16c26f808a27c220930859db1a454042');
        $this->checkFile('themes/affiliates/Midnight_city/signup_form.tpl', 'a55f02ab4d649b4eb23fbd252e3555fb');
        $this->checkFile('themes/affiliates/Midnight_city/signup_subaffiliates.tpl', '37eb3bcb00f8bbbc2f3b6c793c0b5a4d');
        $this->checkFile('themes/affiliates/Midnight_city/simple_filter.tpl', 'a55a1095bcbdbef9d9d9f5e2078b19a2');
        $this->checkFile('themes/affiliates/Midnight_city/simple_icon_object.tpl', 'bcbc9ea994d4aa8bbdee1eddc3ad19d8');
        $this->checkFile('themes/affiliates/Midnight_city/simple_popup_window.tpl', 'e7d6ad58d85a85eab20414bb734b8c81');
        $this->checkFile('themes/affiliates/Midnight_city/simplecolorpicker.tpl', '9c031fbdd2b35909faeea73e5f1203a1');
        $this->checkFile('themes/affiliates/Midnight_city/single_content_panel.tpl', '529d4a42f9106d91881f8b8b8e87748b');
        $this->checkFile('themes/affiliates/Midnight_city/size_format_widget.tpl', 'ebfb7db6718ec601af59a570d8e0ccb3');
        $this->checkFile('themes/affiliates/Midnight_city/start_button.tpl', '7aa2278c46b897536625cc042b4f5499');
        $this->checkFile('themes/affiliates/Midnight_city/statistics_double_value_widget.tpl', '7e243a39277ad97843b418e45881a6d2');
        $this->checkFile('themes/affiliates/Midnight_city/stats_chart.tpl', 'b5bb3d9a0dd5361a4e34e479aacf2480');
        $this->checkFile('themes/affiliates/Midnight_city/sub_aff_tree.tpl', '679faa77de04d865fc22b6c25fd48275');
        $this->checkFile('themes/affiliates/Midnight_city/sub_menu_section.tpl', 'ab7871c677c0d90bb2d878548157b628');
        $this->checkFile('themes/affiliates/Midnight_city/subaff_stats_no_data.tpl', 'f81af900ac8f9c419e2b3cf9742a1d69');
        $this->checkFile('themes/affiliates/Midnight_city/subaffiliate_sales_panel.tpl', '74f82f4ed0910799758338dbfc8630bc');
        $this->checkFile('themes/affiliates/Midnight_city/subaffiliates_filter.tpl', 'd929d7710df12abd81cff41504a91c08');
        $this->checkFile('themes/affiliates/Midnight_city/subaffiliates_panel.tpl', '471e8e9ee69c9cb55ec9e0bd689be941');
        $this->checkFile('themes/affiliates/Midnight_city/subaffiliates_sales_filter.tpl', '9f9fd28d6f934e3937e6551e0cfbf7fb');
        $this->checkFile('themes/affiliates/Midnight_city/subaffiliates_tree_panel.tpl', 'bd640ce415c67d2170ee88da05712f7b');
        $this->checkFile('themes/affiliates/Midnight_city/subaffstats_filter.tpl', 'd0d0b51a10872fa37758a642237c5abd');
        $this->checkFile('themes/affiliates/Midnight_city/subaffstats_list.tpl', '43e8f570edf8311ab5963d04432b98a7');
        $this->checkFile('themes/affiliates/Midnight_city/subid_tracking_screen.tpl', '1407cbdf136a2197520287e9c3bec51e');
        $this->checkFile('themes/affiliates/Midnight_city/system_menu.tpl', '4ccb9c521f5df4b69deb61125efa7008');
        $this->checkFile('themes/affiliates/Midnight_city/tab_item.tpl', 'd869bc1a3b8c511712e039399333d129');
        $this->checkFile('themes/affiliates/Midnight_city/tab_panel.tpl', '8c2853c4e62119a5b6f89c5e340af5d3');
        $this->checkFile('themes/affiliates/Midnight_city/task.tpl', '38a4b70b6456a12285be4bb113c72575');
        $this->checkFile('themes/affiliates/Midnight_city/taskbar.tpl', 'd7cf8ef7a71bf324aee5c1c7173afc7e');
        $this->checkFile('themes/affiliates/Midnight_city/template_form.tpl', 'e47caf8cb37049be84a31c5c4f15ba49');
        $this->checkFile('themes/affiliates/Midnight_city/template_form_constants.tpl', '91c398393e519cf7c6a53ba758eefc47');
        $this->checkFile('themes/affiliates/Midnight_city/template_form_theme_entry.tpl', '91a40d5bfbb3ff3b61cd7771e24a2684');
        $this->checkFile('themes/affiliates/Midnight_city/template_form_themes.tpl', 'e7158c1782ef49ddbf3fbe671c5c5b8a');
        $this->checkFile('themes/affiliates/Midnight_city/template_form_variables.tpl', 'e1c008058f4be04a9e6e76ba72cc3290');
        $this->checkFile('themes/affiliates/Midnight_city/templates_form.tpl', '7a0a1baf13edabb10c8c6bef5a3dac41');
        $this->checkFile('themes/affiliates/Midnight_city/tests.tpl', '2e8601708f27cfadc9ee8a3454080aaf');
        $this->checkFile('themes/affiliates/Midnight_city/theme.php', '51f596659fcb3b46dbc8f5ed5367bfa7');
        $this->checkFile('themes/affiliates/Midnight_city/theme_panel.tpl', '7fea066d8d557fce572b77f00240cebc');
        $this->checkFile('themes/affiliates/Midnight_city/theme_settings.tpl', '5c596388ecc46c2ac89c029f811f565e');
        $this->checkFile('themes/affiliates/Midnight_city/tooltip_popup.tpl', 'e4a5b50c70875ee64d9fdf4f88fa8045');
        $this->checkFile('themes/affiliates/Midnight_city/topmenu_logged.stpl', '3309092595865ba40186a7d7c009226b');
        $this->checkFile('themes/affiliates/Midnight_city/topmenu_notlogged.stpl', 'fa06a5615600582c22cc5f57ee59ba94');
        $this->checkFile('themes/affiliates/Midnight_city/topurl_list.tpl', 'f108c2b8e2583a45a2016869735c87d3');
        $this->checkFile('themes/affiliates/Midnight_city/traffic_stats_gadget.tpl', '0a2882140e9f850399b2a0c198b9ad98');
        $this->checkFile('themes/affiliates/Midnight_city/traffic_stats_in_gadget.tpl', 'ae38670c7e593de4a995af34968842b1');
        $this->checkFile('themes/affiliates/Midnight_city/transaction_list.tpl', 'eb31bc8e7c91183f1520cf00d057d1cc');
        $this->checkFile('themes/affiliates/Midnight_city/transaction_list_filter_base.tpl', 'efb3de54e7fc05e3bd0581cb5dfd8c1c');
        $this->checkFile('themes/affiliates/Midnight_city/trash.tpl', '270d020eabfcf284be7a97e7102924d5');
        $this->checkFile('themes/affiliates/Midnight_city/tree_affiliate_widget.tpl', '0f7a52f0b26bda649f60e2a994645e98');
        $this->checkFile('themes/affiliates/Midnight_city/trend_actions_stats.tpl', '87efaeae069ec2872a33fe3e755a30e7');
        $this->checkFile('themes/affiliates/Midnight_city/trend_actions_stats_widget.tpl', '7c26676ceb09baf3fafeb0dba3bdaec4');
        $this->checkFile('themes/affiliates/Midnight_city/trend_stats.tpl', 'bd3333acced97fe829f3458bcd108bf8');
        $this->checkFile('themes/affiliates/Midnight_city/trends_report.stpl', '18264d58de48af1de2b77137b0df48fb');
        $this->checkFile('themes/affiliates/Midnight_city/trends_report.tpl', '078803b3f100dafeb1d773060290ff63');
        $this->checkFile('themes/affiliates/Midnight_city/trends_report_action.stpl', '929fa1c9535d05f1e8a0492013b9de33');
        $this->checkFile('themes/affiliates/Midnight_city/trends_report_filter.tpl', '18ce8dcf794b1fff579521fbadb505a7');
        $this->checkFile('themes/affiliates/Midnight_city/trends_report_no_data.tpl', '9d1dd7b6d3ef5f6ada42de2c7d182df2');
        $this->checkFile('themes/affiliates/Midnight_city/update_version.stpl', '5602f52fe8248df474201a16c922048f');
        $this->checkFile('themes/affiliates/Midnight_city/upload_panel.tpl', '222a0dd80ab37bb49060da0cf7eaf447');
        $this->checkFile('themes/affiliates/Midnight_city/uploaded_file.tpl', 'fad11b13e3b41eff41a129b1af232e7e');
        $this->checkFile('themes/affiliates/Midnight_city/user_edit.tpl', '241951fc4518a7104554d8490cc2a329');
        $this->checkFile('themes/affiliates/Midnight_city/validity.tpl', 'fbf29129f480c05f2f02e8d69bd1ccf9');
        $this->checkFile('themes/affiliates/Midnight_city/view_form.tpl', '923d4fc8de0546c10e788de580b3562b');
        $this->checkFile('themes/affiliates/Midnight_city/visits_sales_logs_no_data.tpl', '969b350cc45c6f7c68fa6322e98a3de1');
        $this->checkFile('themes/affiliates/Midnight_city/wallpaper_add_custom.tpl', '2210741b569ef188fa352c977a289261');
        $this->checkFile('themes/affiliates/Midnight_city/wallpaper_entry.tpl', '64c85f4da7897cd0f34168c62de661b9');
        $this->checkFile('themes/affiliates/Midnight_city/wallpaper_settings.tpl', 'd160dbed38556231aeac49a96213e4d4');
        $this->checkFile('themes/affiliates/Midnight_city/window.tpl', '2391705887d707e05187606c4a819e73');
        $this->checkFile('themes/affiliates/Midnight_city/window_bottom_left.tpl', 'd14b545c27afa02ab7a919bdeb4c9470');
        $this->checkFile('themes/affiliates/Midnight_city/window_empty_content.tpl', 'b1535ec719cada5b9f5d98849074b9bd');
        $this->checkFile('themes/affiliates/Midnight_city/window_header.tpl', '02a337d4184c3924a2792a84493794cc');
        $this->checkFile('themes/affiliates/Midnight_city/window_header_refresh.tpl', 'fcd47f4585abcac3c3a61ee3991379bc');
        $this->checkFile('themes/affiliates/Midnight_city/window_left.tpl', '9ac901446bfa26918e32fa029fb42093');
        $this->checkFile('themes/affiliates/Midnight_city/window_move_panel.tpl', 'f5bbd373a758bf76e6efadc94dca4b11');
        $this->checkFile('themes/affiliates/Midnight_city/wizard_panel.tpl', '3142ce6354cb3e1c86b6c13c1d906189');
        $this->checkFile('themes/affiliates/WooPrice/advanced_email_settings_form.tpl', '2a83754f5d407d1c031bf0259ae82b11');
        $this->checkFile('themes/affiliates/WooPrice/advanced_email_settings_tab.tpl', '4cdac3ab7ec6827e1307d48028f2d835');
        $this->checkFile('themes/affiliates/WooPrice/advanced_screen.tpl', '7a6fc49337838298197f0d2a4a49746b');
        $this->checkFile('themes/affiliates/WooPrice/aff_status_panel.tpl', 'f6c8ed375a26bfa2b3262189422c5a1c');
        $this->checkFile('themes/affiliates/WooPrice/aff_status_widget.tpl', '518ca3971863bd4c41412a286ebfdf75');
        $this->checkFile('themes/affiliates/WooPrice/affiliate_edit_details_additional.tpl', '98de15bb9a88b36dc47ba266389cb413');
        $this->checkFile('themes/affiliates/WooPrice/affiliate_manager.tpl', '71f61fa4905cf1b525e2c826f01b2f2f');
        $this->checkFile('themes/affiliates/WooPrice/affiliate_subaffiliates.tpl', '8c995322ed3cd841aae0928dd8e148fd');
        $this->checkFile('themes/affiliates/WooPrice/affiliate_theme_settings.tpl', '46f3d82a7762c6669d5014aa5be3d0b8');
        $this->checkFile('themes/affiliates/WooPrice/affiliate_tutorial_video.tpl', 'dcd2156f94a7bdc8fb75d594ed40a308');
        $this->checkFile('themes/affiliates/WooPrice/affiliate_urls_no_data.tpl', 'c9868414093445accf0f0d7551847116');
        $this->checkFile('themes/affiliates/WooPrice/afflink_protector_screen.tpl', '97da4ebc987ac62bbaf542a0e8ce5316');
        $this->checkFile('themes/affiliates/WooPrice/align_widget.tpl', '124769dbcc410ae58c1dfd53f15b58d6');
        $this->checkFile('themes/affiliates/WooPrice/api_integration.tpl', '8cc1da5572a29e72e4215867364998ac');
        $this->checkFile('themes/affiliates/WooPrice/available_values_edit.tpl', 'e96fa729b9a61e7e4a21fbddf80565fb');
        $this->checkFile('themes/affiliates/WooPrice/banner_category_item.tpl', '38ca8170d3d7b851fbc815cc63681df9');
        $this->checkFile('themes/affiliates/WooPrice/banner_code_widget.tpl', '91a021d77bd1ddb4f2f007809ad07902');
        $this->checkFile('themes/affiliates/WooPrice/banner_filter.tpl', 'ed6100072214442574d06b6aa1792976');
        $this->checkFile('themes/affiliates/WooPrice/banner_preview_promo.tpl', '96b67011b02cd4a04bd508a21d1a8bb4');
        $this->checkFile('themes/affiliates/WooPrice/banner_preview_textwidget.tpl', '690ff2bbd824bcd5c5bb52be01597520');
        $this->checkFile('themes/affiliates/WooPrice/banner_preview_widget.tpl', '9df335ee41605fbbc3a3fcdb239478ad');
        $this->checkFile('themes/affiliates/WooPrice/banner_stats_filter.tpl', '437ce34d575bf783e3b85cd5d39a9cf3');
        $this->checkFile('themes/affiliates/WooPrice/banner_stats_list.tpl', '3e71f3763376f08380959fe865aad875');
        $this->checkFile('themes/affiliates/WooPrice/banner_widget.tpl', 'c3ac45f49f8fdc43301943a701882c56');
        $this->checkFile('themes/affiliates/WooPrice/banner_widget_affiliate_pagepeel.tpl', '50cc893da765f31585fc3e36674d387f');
        $this->checkFile('themes/affiliates/WooPrice/banner_widget_code.tpl', '0fb2039eec50061e0b6401a239eeca1e');
        $this->checkFile('themes/affiliates/WooPrice/banner_widget_header.tpl', '76ebd7fa61540f74648a71ba981e3d87');
        $this->checkFile('themes/affiliates/WooPrice/banner_widget_stats.tpl', 'fe3b4c8e04d179d36b203d53010814da');
        $this->checkFile('themes/affiliates/WooPrice/banners.tpl', '78cf0cc4bf8f5b94d8000d2ef79383cc');
        $this->checkFile('themes/affiliates/WooPrice/banners_no_data.tpl', 'c89e4cdd6bccb5df3314e93446c964a4');
        $this->checkFile('themes/affiliates/WooPrice/breadcrumbs.tpl', '921035f90b931792de2bfd1fb40dc597');
        $this->checkFile('themes/affiliates/WooPrice/breadcrumbs_entry.tpl', '42ee9a25b7525589ed65bf9625adc890');
        $this->checkFile('themes/affiliates/WooPrice/broadcast_email.tpl', '7e2d20d16e127ec77e00be3f5d6eab8d');
        $this->checkFile('themes/affiliates/WooPrice/button.tpl', 'ab00df127be0dd89a125fe05f33c0380');
        $this->checkFile('themes/affiliates/WooPrice/calendar.tpl', 'd6831aa786acf1f829a90cec776126eb');
        $this->checkFile('themes/affiliates/WooPrice/campaign_category_item.tpl', '60aa1b58ff10d53fd1e800888b1069cb');
        $this->checkFile('themes/affiliates/WooPrice/campaign_detail.tpl', '00c57f959e4cff9634cf1acbc181cf21');
        $this->checkFile('themes/affiliates/WooPrice/campaign_grid_widget.tpl', '984c1470ce27033a2d9d465972298675');
        $this->checkFile('themes/affiliates/WooPrice/campaign_long_description.tpl', 'c8224613917e714a724a19ed20ce2505');
        $this->checkFile('themes/affiliates/WooPrice/campaign_stats_filter.tpl', '50ce95c2acc374d45150f51a4d115049');
        $this->checkFile('themes/affiliates/WooPrice/campaign_tracking_codes.tpl', '3a2324b74f6d9c54211cc58fe3d38742');
        $this->checkFile('themes/affiliates/WooPrice/campaign_tracking_codes_filter.tpl', '30062ab9dea3ba63b6ea0d205ca453e0');
        $this->checkFile('themes/affiliates/WooPrice/campaigns_filter.tpl', '3db463dfecc9eb428dab1f2257f2a5d9');
        $this->checkFile('themes/affiliates/WooPrice/campaigns_list.tpl', '6b63624d55078a801bc09a2e56a04417');
        $this->checkFile('themes/affiliates/WooPrice/campaigns_list_tree.tpl', 'e344f71cf7eddd7c6c1cc24d4f85fe72');
        $this->checkFile('themes/affiliates/WooPrice/captcha.tpl', '0326fedb283400e2c13eeae155d7b536');
        $this->checkFile('themes/affiliates/WooPrice/category_info.tpl', 'bf2e78d31f6a93380f4fbc0538589e84');
        $this->checkFile('themes/affiliates/WooPrice/change_status_button.tpl', 'a0d13402819088b5078e8100a21a0159');
        $this->checkFile('themes/affiliates/WooPrice/channel_stats_filter.tpl', '3a5aa4e605bdcf300bcc1f1ad0bf56fb');
        $this->checkFile('themes/affiliates/WooPrice/channel_stats_panel.tpl', '978b24c1f50a0c2fab07e3d9cf2e6272');
        $this->checkFile('themes/affiliates/WooPrice/channels_no_data.tpl', '0e1e8193a32385d8c980e2d4a2eff439');
        $this->checkFile('themes/affiliates/WooPrice/channels_panel.tpl', '5cf41aa13455ddde2cc935f3d2e39672');
        $this->checkFile('themes/affiliates/WooPrice/chart_datatype_popup.tpl', '7a1a0e024c8392ea5df8cd40b179d4f7');
        $this->checkFile('themes/affiliates/WooPrice/check_box_group.tpl', 'e182dd7429a276dc85e09049b2a6c19e');
        $this->checkFile('themes/affiliates/WooPrice/check_box_group_row.tpl', '97219c5c2d3c996953fd6bd882e6200c');
        $this->checkFile('themes/affiliates/WooPrice/checkboxes_filter.tpl', 'fef5c1833920987bd3172dbe9d75797a');
        $this->checkFile('themes/affiliates/WooPrice/clicks_list.tpl', 'b1ee1d4fbc2e98ea4e7fc240527a6d46');
        $this->checkFile('themes/affiliates/WooPrice/clicks_list_filter_base.tpl', 'fb7bfe0b49eb4671b5f8fdcc3fbb54b0');
        $this->checkFile('themes/affiliates/WooPrice/colorpicker.tpl', '297c4e74e89b8b3dedd12e7c319bce41');
        $this->checkFile('themes/affiliates/WooPrice/commission_details.tpl', 'c274d41cf9e0a2cfe28d66c36edb40a5');
        $this->checkFile('themes/affiliates/WooPrice/commissions_no_data.tpl', 'fcd3503c324d1988af6df1c864bfdd80');
        $this->checkFile('themes/affiliates/WooPrice/confirm_dialog.tpl', 'f92a8f6b3081444abf7fc4ab63c99302');
        $this->checkFile('themes/affiliates/WooPrice/confirm_dialog_with_value.tpl', '46e7630a0a094110f6819ea655683337');
        $this->checkFile('themes/affiliates/WooPrice/contact_us.tpl', 'ab01f72bb71446f679190833bdc7b003');
        $this->checkFile('themes/affiliates/WooPrice/content_gadget_panel.tpl', '79428f6a77f38592dfa1716653bbe79b');
        $this->checkFile('themes/affiliates/WooPrice/context_menu.tpl', 'cddf235a2fec1ae75063d576ccdc6185');
        $this->checkFile('themes/affiliates/WooPrice/copy_user_role.tpl', '67725ef54593ecb567ed04a3935faecb');
        $this->checkFile('themes/affiliates/WooPrice/countries_list_scrolling_wrapper.tpl', '4bf0a92924334c72075b4ddafd3b243b');
        $this->checkFile('themes/affiliates/WooPrice/coupon.tpl', '7603de7353751cc37e762400f6dc1734');
        $this->checkFile('themes/affiliates/WooPrice/coupon_codes.tpl', 'a324bcc28deef842f75b6d3b4803dc6e');
        $this->checkFile('themes/affiliates/WooPrice/coupon_html_code.tpl', '4b85f57df88ff11ee43192e348076b42');
        $this->checkFile('themes/affiliates/WooPrice/coupon_previews.tpl', '3c5988cdbef06b3ae23b1de600ebf2b0');
        $this->checkFile('themes/affiliates/WooPrice/coupon_view.tpl', '1d6323a8ae51b2f146792372ec16f690');
        $this->checkFile('themes/affiliates/WooPrice/coupons_no_data.tpl', 'c8bcc725598c714ca764a2196f380d9d');
        $this->checkFile('themes/affiliates/WooPrice/currency_textbox.tpl', '859fd8293b92897b3be4c9a6c4aa3a8f');
        $this->checkFile('themes/affiliates/WooPrice/custom/advanced_tracking.tpl', 'a59f52de667fc173c0266306f5062827');
        $this->checkFile('themes/affiliates/WooPrice/custom/directlink_explained.tpl', '6f3915445547afa953c203b68c4fa2e5');
        $this->checkFile('themes/affiliates/WooPrice/custom/frequently_asked_questions.tpl', '835b2045c86a1b65a5202f271947904e');
        $this->checkFile('themes/affiliates/WooPrice/custom/getting_started.tpl', '8b2b7649d029c6bfe0706fcd053cdf2b');
        $this->checkFile('themes/affiliates/WooPrice/custom/promotion_tips.tpl', '4e39eb13d5fefdb3a8db63fbbd5e2d00');
        $this->checkFile('themes/affiliates/WooPrice/custom.css', '4877ef2467745239a93ebe1e79b2f813');
        $this->checkFile('themes/affiliates/WooPrice/custom_date_panel.tpl', 'c624f3d63d0e94db867529dc13a827d1');
        $this->checkFile('themes/affiliates/WooPrice/custom_filter_element.tpl', 'bf05e5d299fb1982ea8139f2a605846b');
        $this->checkFile('themes/affiliates/WooPrice/custom_filter_field.tpl', '21c8ab135d5d89e320ec85456ec457e0');
        $this->checkFile('themes/affiliates/WooPrice/custom_license_invalid.tpl', '9157ecde6accdbe2f6cd622084e79d53');
        $this->checkFile('themes/affiliates/WooPrice/custom_time_panel.tpl', 'd408a8352774d70124788d61a90493b6');
        $this->checkFile('themes/affiliates/WooPrice/daily_report.tpl', '696092e06570b6eebad4c345d98c5ca9');
        $this->checkFile('themes/affiliates/WooPrice/daily_report_filter.tpl', 'cdd6b5b0f3f67e1c68221170d4075b5c');
        $this->checkFile('themes/affiliates/WooPrice/data_field.tpl', 'dd553594505158cd53cc285d3a91fe23');
        $this->checkFile('themes/affiliates/WooPrice/data_field_with_help.tpl', '4615cdd789beea34c16b4c1f692a3a3b');
        $this->checkFile('themes/affiliates/WooPrice/date_number_format_panel.tpl', 'e26284328d2ba7da47d30e8e458c13b1');
        $this->checkFile('themes/affiliates/WooPrice/date_preset_panel.tpl', 'abc7d225baa948aed70cc1073b786fe8');
        $this->checkFile('themes/affiliates/WooPrice/date_range_filter.tpl', '3875dbc075f33ccaac856190ee103557');
        $this->checkFile('themes/affiliates/WooPrice/date_range_filter_field.tpl', '94048704212b6797b7b7a08fb7888da9');
        $this->checkFile('themes/affiliates/WooPrice/date_textbox.tpl', '4d2bf89bd754bbaccc15e48d7a37dd02');
        $this->checkFile('themes/affiliates/WooPrice/daterange_popup.tpl', 'dc1728d13b0440b8df5e12359010168a');
        $this->checkFile('themes/affiliates/WooPrice/datetimepickercontent.tpl', '9771684f29bc88d974cc64283055d1d1');
        $this->checkFile('themes/affiliates/WooPrice/desktop.tpl', 'b653025800e416896bd453246061a535');
        $this->checkFile('themes/affiliates/WooPrice/desktop_gadget.tpl', '21394ff13337e4716860c12b5e4fb312');
        $this->checkFile('themes/affiliates/WooPrice/desktop_main_menu.tpl', '31eb02f3f6b767d24012753d50ff5159');
        $this->checkFile('themes/affiliates/WooPrice/desktop_settings_mode.tpl', '1054d3be606383580f8d521f2d72682f');
        $this->checkFile('themes/affiliates/WooPrice/direct_link_form.tpl', '48d9f1ab56c63c05304185fbc8163922');
        $this->checkFile('themes/affiliates/WooPrice/direct_link_grid_widget.tpl', '586c3b902d66c903d87e510bca5843ec');
        $this->checkFile('themes/affiliates/WooPrice/direct_linking_panel.tpl', 'd96cd58bb0f0537f8404f641367e0801');
        $this->checkFile('themes/affiliates/WooPrice/direct_links_screen.tpl', 'ec5317f983964f7c42f2a4a8a28c5e3b');
        $this->checkFile('themes/affiliates/WooPrice/download_login_form.tpl', 'ccf5bf5eab2bc42572c4538224cbef4e');
        $this->checkFile('themes/affiliates/WooPrice/download_signup_form.tpl', '9dff3be2354fc10a70cc1b98b2f08434');
        $this->checkFile('themes/affiliates/WooPrice/drag_container.tpl', '358104feb6f9c3c2a01206e460726eac');
        $this->checkFile('themes/affiliates/WooPrice/dynamic_form_panel.tpl', 'ea42da62b4a44f1fa9caf50a59c29160');
        $this->checkFile('themes/affiliates/WooPrice/dynamic_link_panel.tpl', '33245e1f6d416f28a8555078142abfe4');
        $this->checkFile('themes/affiliates/WooPrice/edit_textarea_widget.tpl', '94b2c94dd103b5209bd89470fc70268c');
        $this->checkFile('themes/affiliates/WooPrice/edit_tracking_code_widget.tpl', '5f25a27d5086317f495922f67ad88e33');
        $this->checkFile('themes/affiliates/WooPrice/editor.tpl', 'a8c5483c720526b56fa899a91045c287');
        $this->checkFile('themes/affiliates/WooPrice/editor_with_constants_panel.tpl', '6c9e8d91f33bc90c661e9b67ca5ff1e1');
        $this->checkFile('themes/affiliates/WooPrice/email_form.tpl', '7809f19dc7e837c8dbe6f4d58e6574b7');
        $this->checkFile('themes/affiliates/WooPrice/email_notifications.tpl', '8153cb771f309301f07a29ebec237250');
        $this->checkFile('themes/affiliates/WooPrice/email_setting_smtp_form.tpl', 'd17124a143f842ab1876ed14a74bc762');
        $this->checkFile('themes/affiliates/WooPrice/email_settings_spf.tpl', 'ca349c37b841ccef522f8767817bf1d2');
        $this->checkFile('themes/affiliates/WooPrice/email_settings_tab.tpl', '8fef8cf6eacfffe581527d391ffb97da');
        $this->checkFile('themes/affiliates/WooPrice/email_template_edit_panel.tpl', '2a432b9530ad4375605916e152dd8b60');
        $this->checkFile('themes/affiliates/WooPrice/expired_session_dialog.tpl', 'ba711bd5d1e932ffc4fbc8e601204905');
        $this->checkFile('themes/affiliates/WooPrice/export_to_csv.tpl', 'cdbd08521a7f231bbf4f0181cb0d807f');
        $this->checkFile('themes/affiliates/WooPrice/extendable_commission_data.tpl', '43b5108a8212bccdb414370023388e10');
        $this->checkFile('themes/affiliates/WooPrice/extendable_text.tpl', 'a69efdb298a3aae26e26793c9b9fea36');
        $this->checkFile('themes/affiliates/WooPrice/extendable_text_content.tpl', 'cca4ebdf72f3cb7638b6c5bf0f59d9aa');
        $this->checkFile('themes/affiliates/WooPrice/extendable_text_widget.tpl', '83288dfd8795a2a9105965dde2ebc927');
        $this->checkFile('themes/affiliates/WooPrice/field_type_edit.tpl', 'b1294ba5d4486ea1cf8022a51e277a11');
        $this->checkFile('themes/affiliates/WooPrice/file_widget.tpl', 'a7410b3e376c1b177c47831f83a68c55');
        $this->checkFile('themes/affiliates/WooPrice/filter.tpl', 'd51de72535f52fc100a59cad0a15fd37');
        $this->checkFile('themes/affiliates/WooPrice/filter_field_decorator.tpl', '531d57478d7718e216ea04ff79d493ca');
        $this->checkFile('themes/affiliates/WooPrice/filter_form.tpl', '67551720cbc190c8df85c24d3f8a4cbe');
        $this->checkFile('themes/affiliates/WooPrice/financial_overview.tpl', '8a82f2f60d7ad6eeeda3e4a4122ac3c8');
        $this->checkFile('themes/affiliates/WooPrice/font/Titillium/TitilliumWeb-Black.ttf', '42f7635089a79cbee683dea44317d627');
        $this->checkFile('themes/affiliates/WooPrice/font/Titillium/TitilliumWeb-Black.woff', '2c43c3759ff678fb0b343380e1813b2e');
        $this->checkFile('themes/affiliates/WooPrice/font/Titillium/TitilliumWeb-Bold.ttf', '5ead9f49abe9f8e6245c0d9f5c31fde4');
        $this->checkFile('themes/affiliates/WooPrice/font/Titillium/TitilliumWeb-Bold.woff', 'e9542b9f4b66d94ec265e87a679e8d88');
        $this->checkFile('themes/affiliates/WooPrice/font/Titillium/TitilliumWeb-Light.ttf', 'aefd3e5229c69eb9d6af08a08df46255');
        $this->checkFile('themes/affiliates/WooPrice/font/Titillium/TitilliumWeb-Light.woff', '1541d554558df286b889c2c4848204ff');
        $this->checkFile('themes/affiliates/WooPrice/font/Titillium/TitilliumWeb-Regular.ttf', 'ad51f12c62f6e11300c25bd2ea696266');
        $this->checkFile('themes/affiliates/WooPrice/font/Titillium/TitilliumWeb-Regular.woff', '48573bcb38bf5624363f2c538019a682');
        $this->checkFile('themes/affiliates/WooPrice/font/Titillium/TitilliumWeb-SemiBold.ttf', '292d3d436d085b5e691f23722cdee7ae');
        $this->checkFile('themes/affiliates/WooPrice/font/Titillium/TitilliumWeb-SemiBold.woff', 'e4ac435feb5ea77c7672924cc9ec1b0d');
        $this->checkFile('themes/affiliates/WooPrice/font/fontello.eot', 'b2012373de53bdcf186b789d03b1b651');
        $this->checkFile('themes/affiliates/WooPrice/font/fontello.svg', '1045c4485908e58054e248bf90c4f758');
        $this->checkFile('themes/affiliates/WooPrice/font/fontello.ttf', '8da4acbde1b1dbbaee498b2adcfd4bf7');
        $this->checkFile('themes/affiliates/WooPrice/font/fontello.woff', 'f57a4db78bda8b28d724838c290ff166');
        $this->checkFile('themes/affiliates/WooPrice/font/fontello.woff2', '067318fe80a3455f47aba86c12dde49d');
        $this->checkFile('themes/affiliates/WooPrice/fontello.css', '7abe36cc2ed0ccbbaad467c15445aa12');
        $this->checkFile('themes/affiliates/WooPrice/footer.stpl', 'cae74dd5cc67d8eb1a47e0bbeaf3fee4');
        $this->checkFile('themes/affiliates/WooPrice/footer.tpl', 'acf430b8fece1dddd26ef7f7165a7044');
        $this->checkFile('themes/affiliates/WooPrice/forgot_password.tpl', 'e31e8cf668201db153fb5783283dc75c');
        $this->checkFile('themes/affiliates/WooPrice/form_field.tpl', '5c7ae4b0f01f4a7753ab811e0a57f29f');
        $this->checkFile('themes/affiliates/WooPrice/form_field_checkbox.tpl', 'c1f1746d1bf5c7abfaf9e5ddb7b4cc52');
        $this->checkFile('themes/affiliates/WooPrice/form_field_checkboxgroup.tpl', 'be1b525a89f033d4f79433dd3eaab593');
        $this->checkFile('themes/affiliates/WooPrice/form_field_radio.tpl', '9013ed97a5fc7b4b52052d816a9b25d0');
        $this->checkFile('themes/affiliates/WooPrice/frame_panel.tpl', '7b13a1add8ba712d8a34f4285414b419');
        $this->checkFile('themes/affiliates/WooPrice/general_no_data.stpl', '03433ae7bf79c177a476922c2ee779c5');
        $this->checkFile('themes/affiliates/WooPrice/gpf.css', 'ec27b549fa06e9420afb4e6d56ee3a96');
        $this->checkFile('themes/affiliates/WooPrice/gpf_db_mail.tpl', 'b5ea5e9ecef2152fdf967085a7689adc');
        $this->checkFile('themes/affiliates/WooPrice/grid.tpl', '1797f6072932e243275fbf0fe1382a6d');
        $this->checkFile('themes/affiliates/WooPrice/grid_bottombuttons.tpl', '30a61eeb486bc2ce22368100d53fc392');
        $this->checkFile('themes/affiliates/WooPrice/grid_bottomgridline.tpl', '9bf2013a170e094e82dc1ae0a2ed0f97');
        $this->checkFile('themes/affiliates/WooPrice/grid_nodata.tpl', '340ff6de789cd7277a35d763f6366f24');
        $this->checkFile('themes/affiliates/WooPrice/grid_pager.tpl', '46e6d959616563985ece2d92c0234826');
        $this->checkFile('themes/affiliates/WooPrice/grid_selector.tpl', 'ff2d81e3866f53d540a0d063bdf7b480');
        $this->checkFile('themes/affiliates/WooPrice/grid_topbuttons.tpl', '83a65b7b03d432beb47d16e78cdf8aee');
        $this->checkFile('themes/affiliates/WooPrice/grid_topgridline.tpl', '3ff9c43cb7f7fcbbcdc7f03c8822a70d');
        $this->checkFile('themes/affiliates/WooPrice/header.stpl', 'a1280de5b51c8c21c5c8169fa4075378');
        $this->checkFile('themes/affiliates/WooPrice/header.tpl', '32d459ea9f7ebf7a241715058cc91f38');
        $this->checkFile('themes/affiliates/WooPrice/home.tpl', 'd25d3eb83817cf220778e4ee39d1f887');
        $this->checkFile('themes/affiliates/WooPrice/horizontal_layout_panel.tpl', '8b6098cd64720cff686cc24e06ac4c17');
        $this->checkFile('themes/affiliates/WooPrice/html_window_preview.stpl', '02d9e7142f0e2fa88afa0b9af7d9f5fc');
        $this->checkFile('themes/affiliates/WooPrice/icon_button.tpl', 'a7497a39fe733586fb4f5a1b9f424b0f');
        $this->checkFile('themes/affiliates/WooPrice/icon_object.tpl', 'ff8d25e63eca03b325c4501e13358fb2');
        $this->checkFile('themes/affiliates/WooPrice/icon_picker.tpl', '77a002b90f678df44bcca5776f314820');
        $this->checkFile('themes/affiliates/WooPrice/icon_picker_panel.tpl', '4342c424a8cb290701f64d0cb63655ec');
        $this->checkFile('themes/affiliates/WooPrice/icon_status_widget.tpl', 'ff9e2bc87e203324cc33c4b3ac365dfe');
        $this->checkFile('themes/affiliates/WooPrice/image_uploader.tpl', '091439bdf235f35fb4c42d58b789f216');
        $this->checkFile('themes/affiliates/WooPrice/img/favicon.ico', 'ac3e93c93589318e5dcf69efc8a76176');
        $this->checkFile('themes/affiliates/WooPrice/img/icon-128.png', 'a450a0dd5959518fdb2308cc5e523bcc');
        $this->checkFile('themes/affiliates/WooPrice/img/icon-192.png', '8cb72062e4df9eab6c2a064459a5ee62');
        $this->checkFile('themes/affiliates/WooPrice/img/pan-logo.svg', 'a00e0890d1da3f81a0ddf2d27c111504');
        $this->checkFile('themes/affiliates/WooPrice/img/pap-logo.svg', '5e82bd9eddbcd704a8b581b5c5037d54');
        $this->checkFile('themes/affiliates/WooPrice/img/theme_thumbnail.jpg', 'f4746d8145dba10036d25d2fb91f8774');
        $this->checkFile('themes/affiliates/WooPrice/import_custom_language_panel.tpl', '36fe179dc09cd1a1bf3561ef9d13a647');
        $this->checkFile('themes/affiliates/WooPrice/import_language.tpl', 'c1df1cf60613d3df6e19681193ae41a9');
        $this->checkFile('themes/affiliates/WooPrice/info_dialog.tpl', '886c377f8e8c1b2c6957451436e1d090');
        $this->checkFile('themes/affiliates/WooPrice/ip_detail.tpl', '3723b4ce7dc6ccc4b8c8193f4c982d18');
        $this->checkFile('themes/affiliates/WooPrice/item.tpl', '717eff0e06a712a76effb2d6723183b5');
        $this->checkFile('themes/affiliates/WooPrice/item_panel.tpl', 'b24ed05bdf4cb76a7afc1e9a9908def8');
        $this->checkFile('themes/affiliates/WooPrice/language_create_new.tpl', '1ae789af118ce84a76ec067e82d52aec');
        $this->checkFile('themes/affiliates/WooPrice/language_edit_panel.tpl', '4b582c49c5aec0a72765e8764ba390b0');
        $this->checkFile('themes/affiliates/WooPrice/language_translations_grid.tpl', 'b3d4b3ff7279bf9383886e84ba3218ab');
        $this->checkFile('themes/affiliates/WooPrice/languages_configuration.tpl', '86f17a42cef0bedb165295e99c970582');
        $this->checkFile('themes/affiliates/WooPrice/layout_panel_content.tpl', 'd49730d94578e00ed7395eaa1d2a3df6');
        $this->checkFile('themes/affiliates/WooPrice/layout_panel_header_navigation.tpl', '6b0d746501001da8615a22d57266dcb0');
        $this->checkFile('themes/affiliates/WooPrice/layout_panel_tab.tpl', '316df333cac9b455c7dc04100c2e2d1d');
        $this->checkFile('themes/affiliates/WooPrice/license_invalid.tpl', '6181e1127345050c94d6708cd805aefb');
        $this->checkFile('themes/affiliates/WooPrice/link_button.tpl', '71fad92bff79f1fd2e1066818afac789');
        $this->checkFile('themes/affiliates/WooPrice/listbox.tpl', '2739c2a9e22d54280cacf4d67ed2e7bc');
        $this->checkFile('themes/affiliates/WooPrice/listbox_popup.tpl', '8c45877411c0727e814eb5e3caa76822');
        $this->checkFile('themes/affiliates/WooPrice/listdown_button.tpl', 'a1cd26a1aec6d403420971d7469a6f1b');
        $this->checkFile('themes/affiliates/WooPrice/load_mail_from_template.tpl', '42c0029422eaf077a5b0c316cd3317b5');
        $this->checkFile('themes/affiliates/WooPrice/loadable_tree.tpl', 'e2c214b134bffe5fe2bb38f679a64eb5');
        $this->checkFile('themes/affiliates/WooPrice/loading_screen.tpl', '45d70765ad380ad3f0df92c82de65792');
        $this->checkFile('themes/affiliates/WooPrice/login.tpl', 'e7be8367104ee7221547730250f9b0f0');
        $this->checkFile('themes/affiliates/WooPrice/login_form.tpl', '297656a8cfb59277903ed38dfaa9e2f1');
        $this->checkFile('themes/affiliates/WooPrice/login_form_downloadable.tpl', '6f2b17262524a8c12cfdcd572ad36bf9');
        $this->checkFile('themes/affiliates/WooPrice/login_main.tpl', '0cd828d3f67418d0795faf78316d9aaf');
        $this->checkFile('themes/affiliates/WooPrice/logins_history.tpl', '740e9d7a1b893fe3280b782958742998');
        $this->checkFile('themes/affiliates/WooPrice/loginshistory_filter.tpl', '64804e791ea2ca4fcc7e01d7a8443479');
        $this->checkFile('themes/affiliates/WooPrice/logs_no_data.tpl', 'c807c1484862c46a3f72f1ea0d276b3f');
        $this->checkFile('themes/affiliates/WooPrice/mail_detail_data.tpl', 'cb8867c95ce35d7ad35b82f5c663ae42');
        $this->checkFile('themes/affiliates/WooPrice/mail_outbox_panel.tpl', 'eda83d3c7fed41f0449b2464e96df945');
        $this->checkFile('themes/affiliates/WooPrice/mailoutbox_filter.tpl', '8fd6e8ae35323bbc8debd1c248142e61');
        $this->checkFile('themes/affiliates/WooPrice/mailoutbox_list_no_data.tpl', '12637515858ca4d960c6202e8a89042b');
        $this->checkFile('themes/affiliates/WooPrice/main.tpl', '5461cc6e184ba38a56ac7d5c0da6e4b2');
        $this->checkFile('themes/affiliates/WooPrice/main_aff_html_doc.stpl', 'ada01c74a6a37d324a41482f65fe7a4f');
        $this->checkFile('themes/affiliates/WooPrice/main_error_html_doc.tpl', 'cc7808f71ce49f9004d1c4f03966375c');
        $this->checkFile('themes/affiliates/WooPrice/main_filter_panel.tpl', '0985a7421f898d75d4df72b4a6081c49');
        $this->checkFile('themes/affiliates/WooPrice/main_header.tpl', '5b01f94a773845f032b3f39078104c1f');
        $this->checkFile('themes/affiliates/WooPrice/main_menu.tpl', '5fddab52f7b44bcb5717c1d67875f567');
        $this->checkFile('themes/affiliates/WooPrice/map_overlay.tpl', 'd12618268f18867d1f8ef84d12c8ba32');
        $this->checkFile('themes/affiliates/WooPrice/map_overlay_advanced_filter.tpl', 'cf259a9627f69eb5f1a05e5a9b9fe7bd');
        $this->checkFile('themes/affiliates/WooPrice/menu_entry.tpl', '64a9c8f6b89eb5d0fb9a2d174b5f0427');
        $this->checkFile('themes/affiliates/WooPrice/menu_section.tpl', 'ce9552c9579aa842bfd16e9c61b1cd0e');
        $this->checkFile('themes/affiliates/WooPrice/messages.tpl', 'bf1a3bac08c419320acb94673ad29f0b');
        $this->checkFile('themes/affiliates/WooPrice/module_body.stpl', 'c079addcd33eb725ab7efbf09c16a793');
        $this->checkFile('themes/affiliates/WooPrice/multi_editor.tpl', '3ee5baa5bdb7824c0c2ae6f2dc275830');
        $this->checkFile('themes/affiliates/WooPrice/multiselect.tpl', '9d1863b21edd131520315ce252fde639');
        $this->checkFile('themes/affiliates/WooPrice/myprofile.tpl', 'bc9c2c67e2fac95d707b8508da3bfca6');
        $this->checkFile('themes/affiliates/WooPrice/news_content.tpl', 'a576598444bb0db20fa8d47854f1ef34');
        $this->checkFile('themes/affiliates/WooPrice/news_item.tpl', '18161a56a8f4dc5df01f08191709f864');
        $this->checkFile('themes/affiliates/WooPrice/newsletter_broadcast_form.tpl', '1ccb4e8c2a3873263c7c8c1fc7c19f27');
        $this->checkFile('themes/affiliates/WooPrice/newsletter_broadcasts.tpl', 'e85ba6dc04b3a921af601f6bf976a5b8');
        $this->checkFile('themes/affiliates/WooPrice/newsletter_edit_panel.tpl', '73ddca2129beb12e11215b1c55e70461');
        $this->checkFile('themes/affiliates/WooPrice/newsletter_form.tpl', 'e86bb366b8986ac4cb1b50c9ccc94b8e');
        $this->checkFile('themes/affiliates/WooPrice/no_content_gadgets.tpl', '1d4ce600d473f33e2b229101a50cbc3f');
        $this->checkFile('themes/affiliates/WooPrice/no_language_selected.tpl', 'd61125f2b1cf78e4e66653d4e2f04bdd');
        $this->checkFile('themes/affiliates/WooPrice/notification_window.tpl', 'db781872bdb9748bc838e051b8e5e4e2');
        $this->checkFile('themes/affiliates/WooPrice/online_users.tpl', 'e78ff82eb18c092018cd48d90ae48863');
        $this->checkFile('themes/affiliates/WooPrice/online_users_gadget_rolecount.tpl', '5fd6af0c5f2edec24d0e35dc00a9e870');
        $this->checkFile('themes/affiliates/WooPrice/onlinegadgets_no_data.tpl', 'f5f692a433b4911963a92c41cc269768');
        $this->checkFile('themes/affiliates/WooPrice/onlineusers_filter.tpl', '7a0572e8ae3375f2c79c8fe985295bd6');
        $this->checkFile('themes/affiliates/WooPrice/order_id_filter.tpl', 'b0abf428294c4575a75ab1dbaf7b391a');
        $this->checkFile('themes/affiliates/WooPrice/page_header.tpl', '4fd5676c44341f95ee0435c1f78da534');
        $this->checkFile('themes/affiliates/WooPrice/panel_footer.stpl', '2ecfae35d4c9436786fd4b2c26747242');
        $this->checkFile('themes/affiliates/WooPrice/panel_with_icons.tpl', 'cdc3dafa07941a7c6c1ec5c4297528d6');
        $this->checkFile('themes/affiliates/WooPrice/pap4.css', 'fee1117f59a63ab6d6654f0b4a723e47');
        $this->checkFile('themes/affiliates/WooPrice/pap4.rtl.css', '5aae7c7259750510d29a80aa9ab92db0');
        $this->checkFile('themes/affiliates/WooPrice/password_constraint_panel.tpl', '71b23765c240aff0073e713cfc4da992');
        $this->checkFile('themes/affiliates/WooPrice/password_panel.tpl', 'b1440553a785aae589233a91315b281f');
        $this->checkFile('themes/affiliates/WooPrice/payment_details_panel.tpl', 'a3e9de7c3f7f02631e17f2ddfd47c1a6');
        $this->checkFile('themes/affiliates/WooPrice/payout_data.tpl', '04fbc30b334480035464925430c1b84c');
        $this->checkFile('themes/affiliates/WooPrice/payout_fields_panel.tpl', 'a0574ca1f8ca180f8bb347a75856b6c5');
        $this->checkFile('themes/affiliates/WooPrice/payouts_no_data.tpl', '679aa0a26f28531b3303c5ad09c962fc');
        $this->checkFile('themes/affiliates/WooPrice/payouts_to_affiliates.tpl', '48147fc1ef03936a6eed55f580ec7721');
        $this->checkFile('themes/affiliates/WooPrice/pending_backround_tasks.tpl', '75149233f7ae446473c9220c9ff1ef8f');
        $this->checkFile('themes/affiliates/WooPrice/period_stats.stpl', 'bb896332ac55e4f2236c3307cd5cabce');
        $this->checkFile('themes/affiliates/WooPrice/personal_details.tpl', '1fbbdbb864bbfcadf87cb2bbab9b8870');
        $this->checkFile('themes/affiliates/WooPrice/popup_form_widget.tpl', '0f5d2ef3d678d026df06fe1f1e5991a8');
        $this->checkFile('themes/affiliates/WooPrice/promotools_screen.tpl', 'd00db589b34cfb6468a9eab3d94303f8');
        $this->checkFile('themes/affiliates/WooPrice/proxy_server_configuration.tpl', '732a20cf9c1d59496e88d9bd5b080484');
        $this->checkFile('themes/affiliates/WooPrice/quick_report_base.tpl', '03394fc9a529f4d9d13f8cbcb664be8f');
        $this->checkFile('themes/affiliates/WooPrice/quick_report_content.stpl', 'a75ca3ba3fc385de73eae7311f79c650');
        $this->checkFile('themes/affiliates/WooPrice/quick_report_content_multitier.stpl', 'e45556a573992274576437d9d34bdd71');
        $this->checkFile('themes/affiliates/WooPrice/quick_report_filter_base.tpl', '5998ae63fc0257404ef11638ca30eb95');
        $this->checkFile('themes/affiliates/WooPrice/quick_report_multitier_widget.tpl', '2f19acbcc8ca3270ba3b1d16b6253c1d');
        $this->checkFile('themes/affiliates/WooPrice/quick_stats.tpl', 'eb812b06f6292efc64d3aa411c1f8cc0');
        $this->checkFile('themes/affiliates/WooPrice/quick_stats_box.tpl', '745d64595b8a0e5869bfc1e9bf10b9c2');
        $this->checkFile('themes/affiliates/WooPrice/radio_button_group_row.tpl', '3713f6d400aa1ca96d9e404082304912');
        $this->checkFile('themes/affiliates/WooPrice/rawclicks_no_data.tpl', '4377ca4cc0e45e3ee4676ec94def1e0a');
        $this->checkFile('themes/affiliates/WooPrice/recipients.tpl', 'cae0cd53d947d39c2ad761f6f29b2d65');
        $this->checkFile('themes/affiliates/WooPrice/referringurl_advanced_filter.tpl', 'f1479abbb38dc35d909f4a3c8c961a94');
        $this->checkFile('themes/affiliates/WooPrice/refresh_panel.tpl', '5c709df4d219d5feb4f29003ca932f77');
        $this->checkFile('themes/affiliates/WooPrice/regional_settings.tpl', '7fd67a6e2e8b44c62dc36ce4812b7189');
        $this->checkFile('themes/affiliates/WooPrice/regional_settings_tab.tpl', '82a573fa67deb883c207f05c019f7eeb');
        $this->checkFile('themes/affiliates/WooPrice/report_filter.tpl', 'cfa31cd337c81b3e863f97b664581327');
        $this->checkFile('themes/affiliates/WooPrice/reports_screen.tpl', 'c49a73add81baccd69c14ee5ff38b904');
        $this->checkFile('themes/affiliates/WooPrice/request_new_password_form.tpl', 'e4e20e8042328f80b7b400e39d921986');
        $this->checkFile('themes/affiliates/WooPrice/resizable_text_area.tpl', '7995c217048ccd289dfee567a455b08e');
        $this->checkFile('themes/affiliates/WooPrice/richlistbox.tpl', '13229a43763945932dc8d5d7fa21d08e');
        $this->checkFile('themes/affiliates/WooPrice/richlistbox_popup.tpl', 'c155c59eea77770589bcadca0c75f1af');
        $this->checkFile('themes/affiliates/WooPrice/richtext_editor.tpl', '99af0e75e8761690e55e65fa238d8d4c');
        $this->checkFile('themes/affiliates/WooPrice/richtext_editor_toolbar.tpl', '3798b9151ed1d87c99e5783005c81773');
        $this->checkFile('themes/affiliates/WooPrice/richtexteditor_addlink.tpl', 'c9bd3a510535abef1076a29328f069e7');
        $this->checkFile('themes/affiliates/WooPrice/role_privileges.tpl', '9163270235450787bb9ebf86df5b2f69');
        $this->checkFile('themes/affiliates/WooPrice/rotator_preview_affiliate.stpl', 'b9766c5bec13353b6b35944db1a983e0');
        $this->checkFile('themes/affiliates/WooPrice/search_filter.tpl', 'c43c492cae5282a628238b4ff75508b2');
        $this->checkFile('themes/affiliates/WooPrice/selectbutton_search.tpl', 'dedb23ce356b1b66377e648232dc2b8b');
        $this->checkFile('themes/affiliates/WooPrice/send_to_friend.tpl', 'e7b902ca2beb79a6dab513cebf161a87');
        $this->checkFile('themes/affiliates/WooPrice/set_new_password_form.tpl', '9270391a0892b67b03efbd67084806c6');
        $this->checkFile('themes/affiliates/WooPrice/sidebar.tpl', '65226d7e25dcdca0cf71a9f3118d8139');
        $this->checkFile('themes/affiliates/WooPrice/sidebar_closed.tpl', '3d903661713a9ee5fb402776ee06d310');
        $this->checkFile('themes/affiliates/WooPrice/sidebar_gadget.tpl', '1f904859e056808c8826836a4e256761');
        $this->checkFile('themes/affiliates/WooPrice/signup_fields.tpl', '16c26f808a27c220930859db1a454042');
        $this->checkFile('themes/affiliates/WooPrice/signup_form.tpl', 'a55f02ab4d649b4eb23fbd252e3555fb');
        $this->checkFile('themes/affiliates/WooPrice/signup_subaffiliates.tpl', '37eb3bcb00f8bbbc2f3b6c793c0b5a4d');
        $this->checkFile('themes/affiliates/WooPrice/simple_filter.tpl', 'a55a1095bcbdbef9d9d9f5e2078b19a2');
        $this->checkFile('themes/affiliates/WooPrice/simple_icon_object.tpl', 'bcbc9ea994d4aa8bbdee1eddc3ad19d8');
        $this->checkFile('themes/affiliates/WooPrice/simple_popup_window.tpl', 'e7d6ad58d85a85eab20414bb734b8c81');
        $this->checkFile('themes/affiliates/WooPrice/simplecolorpicker.tpl', '9c031fbdd2b35909faeea73e5f1203a1');
        $this->checkFile('themes/affiliates/WooPrice/single_content_panel.tpl', '529d4a42f9106d91881f8b8b8e87748b');
        $this->checkFile('themes/affiliates/WooPrice/size_format_widget.tpl', 'ebfb7db6718ec601af59a570d8e0ccb3');
        $this->checkFile('themes/affiliates/WooPrice/start_button.tpl', '7aa2278c46b897536625cc042b4f5499');
        $this->checkFile('themes/affiliates/WooPrice/statistics_double_value_widget.tpl', '7e243a39277ad97843b418e45881a6d2');
        $this->checkFile('themes/affiliates/WooPrice/stats_chart.tpl', 'b5bb3d9a0dd5361a4e34e479aacf2480');
        $this->checkFile('themes/affiliates/WooPrice/sub_aff_tree.tpl', '679faa77de04d865fc22b6c25fd48275');
        $this->checkFile('themes/affiliates/WooPrice/sub_menu_section.tpl', 'ab7871c677c0d90bb2d878548157b628');
        $this->checkFile('themes/affiliates/WooPrice/subaff_stats_no_data.tpl', 'f81af900ac8f9c419e2b3cf9742a1d69');
        $this->checkFile('themes/affiliates/WooPrice/subaffiliate_sales_panel.tpl', '74f82f4ed0910799758338dbfc8630bc');
        $this->checkFile('themes/affiliates/WooPrice/subaffiliates_filter.tpl', 'd929d7710df12abd81cff41504a91c08');
        $this->checkFile('themes/affiliates/WooPrice/subaffiliates_panel.tpl', '471e8e9ee69c9cb55ec9e0bd689be941');
        $this->checkFile('themes/affiliates/WooPrice/subaffiliates_sales_filter.tpl', '9f9fd28d6f934e3937e6551e0cfbf7fb');
        $this->checkFile('themes/affiliates/WooPrice/subaffiliates_tree_panel.tpl', 'bd640ce415c67d2170ee88da05712f7b');
        $this->checkFile('themes/affiliates/WooPrice/subaffstats_filter.tpl', 'd0d0b51a10872fa37758a642237c5abd');
        $this->checkFile('themes/affiliates/WooPrice/subaffstats_list.tpl', '43e8f570edf8311ab5963d04432b98a7');
        $this->checkFile('themes/affiliates/WooPrice/subid_tracking_screen.tpl', '1407cbdf136a2197520287e9c3bec51e');
        $this->checkFile('themes/affiliates/WooPrice/system_menu.tpl', '4ccb9c521f5df4b69deb61125efa7008');
        $this->checkFile('themes/affiliates/WooPrice/tab_item.tpl', 'd869bc1a3b8c511712e039399333d129');
        $this->checkFile('themes/affiliates/WooPrice/tab_panel.tpl', '8c2853c4e62119a5b6f89c5e340af5d3');
        $this->checkFile('themes/affiliates/WooPrice/task.tpl', '38a4b70b6456a12285be4bb113c72575');
        $this->checkFile('themes/affiliates/WooPrice/taskbar.tpl', 'd7cf8ef7a71bf324aee5c1c7173afc7e');
        $this->checkFile('themes/affiliates/WooPrice/template_form.tpl', 'e47caf8cb37049be84a31c5c4f15ba49');
        $this->checkFile('themes/affiliates/WooPrice/template_form_constants.tpl', '91c398393e519cf7c6a53ba758eefc47');
        $this->checkFile('themes/affiliates/WooPrice/template_form_theme_entry.tpl', '91a40d5bfbb3ff3b61cd7771e24a2684');
        $this->checkFile('themes/affiliates/WooPrice/template_form_themes.tpl', 'e7158c1782ef49ddbf3fbe671c5c5b8a');
        $this->checkFile('themes/affiliates/WooPrice/template_form_variables.tpl', 'e1c008058f4be04a9e6e76ba72cc3290');
        $this->checkFile('themes/affiliates/WooPrice/templates_form.tpl', '7a0a1baf13edabb10c8c6bef5a3dac41');
        $this->checkFile('themes/affiliates/WooPrice/tests.tpl', '2e8601708f27cfadc9ee8a3454080aaf');
        $this->checkFile('themes/affiliates/WooPrice/theme.php', 'e89a4aebd73b5313f4c73661cc851997');
        $this->checkFile('themes/affiliates/WooPrice/theme_panel.tpl', '7fea066d8d557fce572b77f00240cebc');
        $this->checkFile('themes/affiliates/WooPrice/theme_settings.tpl', '5c596388ecc46c2ac89c029f811f565e');
        $this->checkFile('themes/affiliates/WooPrice/tooltip_popup.tpl', 'e4a5b50c70875ee64d9fdf4f88fa8045');
        $this->checkFile('themes/affiliates/WooPrice/topmenu_logged.stpl', '3309092595865ba40186a7d7c009226b');
        $this->checkFile('themes/affiliates/WooPrice/topmenu_notlogged.stpl', 'fa06a5615600582c22cc5f57ee59ba94');
        $this->checkFile('themes/affiliates/WooPrice/topurl_list.tpl', 'f108c2b8e2583a45a2016869735c87d3');
        $this->checkFile('themes/affiliates/WooPrice/traffic_stats_gadget.tpl', '0a2882140e9f850399b2a0c198b9ad98');
        $this->checkFile('themes/affiliates/WooPrice/traffic_stats_in_gadget.tpl', 'ae38670c7e593de4a995af34968842b1');
        $this->checkFile('themes/affiliates/WooPrice/transaction_list.tpl', 'eb31bc8e7c91183f1520cf00d057d1cc');
        $this->checkFile('themes/affiliates/WooPrice/transaction_list_filter_base.tpl', 'efb3de54e7fc05e3bd0581cb5dfd8c1c');
        $this->checkFile('themes/affiliates/WooPrice/trash.tpl', '270d020eabfcf284be7a97e7102924d5');
        $this->checkFile('themes/affiliates/WooPrice/tree_affiliate_widget.tpl', '0f7a52f0b26bda649f60e2a994645e98');
        $this->checkFile('themes/affiliates/WooPrice/trend_actions_stats.tpl', '87efaeae069ec2872a33fe3e755a30e7');
        $this->checkFile('themes/affiliates/WooPrice/trend_actions_stats_widget.tpl', '7c26676ceb09baf3fafeb0dba3bdaec4');
        $this->checkFile('themes/affiliates/WooPrice/trend_stats.tpl', 'bd3333acced97fe829f3458bcd108bf8');
        $this->checkFile('themes/affiliates/WooPrice/trends_report.stpl', '18264d58de48af1de2b77137b0df48fb');
        $this->checkFile('themes/affiliates/WooPrice/trends_report.tpl', '078803b3f100dafeb1d773060290ff63');
        $this->checkFile('themes/affiliates/WooPrice/trends_report_action.stpl', '929fa1c9535d05f1e8a0492013b9de33');
        $this->checkFile('themes/affiliates/WooPrice/trends_report_filter.tpl', '18ce8dcf794b1fff579521fbadb505a7');
        $this->checkFile('themes/affiliates/WooPrice/trends_report_no_data.tpl', '9d1dd7b6d3ef5f6ada42de2c7d182df2');
        $this->checkFile('themes/affiliates/WooPrice/update_version.stpl', '5602f52fe8248df474201a16c922048f');
        $this->checkFile('themes/affiliates/WooPrice/upload_panel.tpl', '222a0dd80ab37bb49060da0cf7eaf447');
        $this->checkFile('themes/affiliates/WooPrice/uploaded_file.tpl', 'fad11b13e3b41eff41a129b1af232e7e');
        $this->checkFile('themes/affiliates/WooPrice/user_edit.tpl', '241951fc4518a7104554d8490cc2a329');
        $this->checkFile('themes/affiliates/WooPrice/validity.tpl', 'cc364de4a049f1afa7bced56ad2560de');
        $this->checkFile('themes/affiliates/WooPrice/view_form.tpl', '923d4fc8de0546c10e788de580b3562b');
        $this->checkFile('themes/affiliates/WooPrice/visits_sales_logs_no_data.tpl', '969b350cc45c6f7c68fa6322e98a3de1');
        $this->checkFile('themes/affiliates/WooPrice/wallpaper_add_custom.tpl', '2210741b569ef188fa352c977a289261');
        $this->checkFile('themes/affiliates/WooPrice/wallpaper_entry.tpl', '64c85f4da7897cd0f34168c62de661b9');
        $this->checkFile('themes/affiliates/WooPrice/wallpaper_settings.tpl', 'd160dbed38556231aeac49a96213e4d4');
        $this->checkFile('themes/affiliates/WooPrice/window.tpl', '2391705887d707e05187606c4a819e73');
        $this->checkFile('themes/affiliates/WooPrice/window_bottom_left.tpl', 'd14b545c27afa02ab7a919bdeb4c9470');
        $this->checkFile('themes/affiliates/WooPrice/window_empty_content.tpl', 'b1535ec719cada5b9f5d98849074b9bd');
        $this->checkFile('themes/affiliates/WooPrice/window_header.tpl', '02a337d4184c3924a2792a84493794cc');
        $this->checkFile('themes/affiliates/WooPrice/window_header_refresh.tpl', 'fcd47f4585abcac3c3a61ee3991379bc');
        $this->checkFile('themes/affiliates/WooPrice/window_left.tpl', '9ac901446bfa26918e32fa029fb42093');
        $this->checkFile('themes/affiliates/WooPrice/window_move_panel.tpl', 'f5bbd373a758bf76e6efadc94dca4b11');
        $this->checkFile('themes/affiliates/WooPrice/wizard_panel.tpl', '3142ce6354cb3e1c86b6c13c1d906189');
        $this->checkFile('themes/affiliates/_common_templates/advanced_screen.tpl', '5250a182b0e7d0bbd9ca981237da89bc');
        $this->checkFile('themes/affiliates/_common_templates/aff_status_panel.tpl', 'f6c8ed375a26bfa2b3262189422c5a1c');
        $this->checkFile('themes/affiliates/_common_templates/aff_status_widget.tpl', '518ca3971863bd4c41412a286ebfdf75');
        $this->checkFile('themes/affiliates/_common_templates/affiliate_edit_details_additional.tpl', 'e48afbaaa177b8741b965a75b001c867');
        $this->checkFile('themes/affiliates/_common_templates/affiliate_manager.tpl', 'e1c628b71abdd11df7252a7a7d8c5b5f');
        $this->checkFile('themes/affiliates/_common_templates/affiliate_subaffiliates.tpl', 'f6defd91d38ca94e90c5260428666f51');
        $this->checkFile('themes/affiliates/_common_templates/affiliate_theme_settings.tpl', '4417a50c301f400774bd03b9787c9371');
        $this->checkFile('themes/affiliates/_common_templates/affiliate_tutorial_video.tpl', 'ba00ad4d653c35549b05c8d1a0ab618d');
        $this->checkFile('themes/affiliates/_common_templates/affiliate_urls_no_data.tpl', '00c87375743af0cf98224c113b75473b');
        $this->checkFile('themes/affiliates/_common_templates/afflink_protector_screen.tpl', 'a2e4eb4dcade06dd4455cc7cf3582c17');
        $this->checkFile('themes/affiliates/_common_templates/banner_category_item.tpl', '7d81648a5b40af0b2c0b843c7b19bcd5');
        $this->checkFile('themes/affiliates/_common_templates/banner_code_widget.tpl', '91a021d77bd1ddb4f2f007809ad07902');
        $this->checkFile('themes/affiliates/_common_templates/banner_filter.tpl', 'e2adbbf5a3230049d120c0a2dabb55d7');
        $this->checkFile('themes/affiliates/_common_templates/banner_preview.tpl', '6f9d0f2cdea56dba80e404e2492edb4e');
        $this->checkFile('themes/affiliates/_common_templates/banner_preview_promo.tpl', '96b67011b02cd4a04bd508a21d1a8bb4');
        $this->checkFile('themes/affiliates/_common_templates/banner_preview_textwidget.tpl', '690ff2bbd824bcd5c5bb52be01597520');
        $this->checkFile('themes/affiliates/_common_templates/banner_preview_widget.tpl', '9df335ee41605fbbc3a3fcdb239478ad');
        $this->checkFile('themes/affiliates/_common_templates/banner_stats_filter.tpl', 'e84cad4217404e65ab8cf01a72db6b16');
        $this->checkFile('themes/affiliates/_common_templates/banner_stats_list.tpl', '8f03dbd8c7daeedf4f2d376550f01a74');
        $this->checkFile('themes/affiliates/_common_templates/banner_stats_list_no_data.tpl', 'a1ebe10fc45d75e5414fced94a0d79ec');
        $this->checkFile('themes/affiliates/_common_templates/banner_widget.tpl', '166a02e2ac6f3b516fc4e284aa273817');
        $this->checkFile('themes/affiliates/_common_templates/banner_widget_affiliate_pagepeel.tpl', '50cc893da765f31585fc3e36674d387f');
        $this->checkFile('themes/affiliates/_common_templates/banner_widget_code.tpl', '888140b0934ba886ee1b0d205ddcf989');
        $this->checkFile('themes/affiliates/_common_templates/banner_widget_header.tpl', 'ac4b536905daa2f22cc12a764fa151f2');
        $this->checkFile('themes/affiliates/_common_templates/banner_widget_stats.tpl', 'fe3b4c8e04d179d36b203d53010814da');
        $this->checkFile('themes/affiliates/_common_templates/banners.tpl', '92b3432ebc83ce66530695a636b45f86');
        $this->checkFile('themes/affiliates/_common_templates/banners_no_data.tpl', '836ba065a8ecdd4894d307a98c8c9ad1');
        $this->checkFile('themes/affiliates/_common_templates/bannerscategories_no_data.tpl', '3df35d8c385cfc14c75759c80f11aa02');
        $this->checkFile('themes/affiliates/_common_templates/broadcast_email.tpl', '40d668d81e6731a79e7da7f3d0b02581');
        $this->checkFile('themes/affiliates/_common_templates/campaign_category_item.tpl', '40bb5e0ae4252d9ef36cd2a9337cd9a2');
        $this->checkFile('themes/affiliates/_common_templates/campaign_detail.tpl', '00c57f959e4cff9634cf1acbc181cf21');
        $this->checkFile('themes/affiliates/_common_templates/campaign_grid_widget.tpl', 'caaed8e31354d9949c9c41a6e7ff623d');
        $this->checkFile('themes/affiliates/_common_templates/campaign_long_description.tpl', 'c8224613917e714a724a19ed20ce2505');
        $this->checkFile('themes/affiliates/_common_templates/campaign_stats_filter.tpl', '0ebbfdd3019bf817826d9d76cb776d64');
        $this->checkFile('themes/affiliates/_common_templates/campaign_stats_list.tpl', 'd85d06d50a5b5570c9cfe95a5f982b1c');
        $this->checkFile('themes/affiliates/_common_templates/campaign_stats_list_no_data.tpl', 'a7d3a0de70332e0bc3d38a9545f706d5');
        $this->checkFile('themes/affiliates/_common_templates/campaign_tracking_codes.tpl', 'b2ecefcc8375a0d13474fdd2f12e92c5');
        $this->checkFile('themes/affiliates/_common_templates/campaign_tracking_codes_filter.tpl', '30062ab9dea3ba63b6ea0d205ca453e0');
        $this->checkFile('themes/affiliates/_common_templates/campaigns_filter.tpl', '30d2f598e2f608b58d1b46500d10eae4');
        $this->checkFile('themes/affiliates/_common_templates/campaigns_list.tpl', '8016e6c6b72717bdf5c6b3f447b940a9');
        $this->checkFile('themes/affiliates/_common_templates/campaigns_list_tree.tpl', 'e344f71cf7eddd7c6c1cc24d4f85fe72');
        $this->checkFile('themes/affiliates/_common_templates/campaignscategories_no_data.tpl', 'b6fdeaa9e97591514e8bc48fc1762f47');
        $this->checkFile('themes/affiliates/_common_templates/category_info.tpl', 'f3ebde419d34c18122b021345bd8ec02');
        $this->checkFile('themes/affiliates/_common_templates/channel_stats_filter.tpl', '196b299cf385e7766bc07924726724bd');
        $this->checkFile('themes/affiliates/_common_templates/channel_stats_panel.tpl', '8fa9806b9638265f1e24fd11653f4759');
        $this->checkFile('themes/affiliates/_common_templates/channels_no_data.tpl', 'b4ca4bf72edc4d781af27cc433f9769c');
        $this->checkFile('themes/affiliates/_common_templates/channels_panel.tpl', 'f33898b5c54ec2e3cae45cc51cf6ca8d');
        $this->checkFile('themes/affiliates/_common_templates/clicks_list.tpl', '2bac05e41e9b7d1603cbd26b15180ece');
        $this->checkFile('themes/affiliates/_common_templates/clicks_list_filter_base.tpl', '4c144d257b08a65d945f315b444294db');
        $this->checkFile('themes/affiliates/_common_templates/commission_details.tpl', 'c274d41cf9e0a2cfe28d66c36edb40a5');
        $this->checkFile('themes/affiliates/_common_templates/commissions_no_data.tpl', '9a2f84b1bfd55ecdc653f8ddf07a6f4c');
        $this->checkFile('themes/affiliates/_common_templates/contact_us.tpl', 'd79035feeecc880822b4001cb2b70773');
        $this->checkFile('themes/affiliates/_common_templates/countries_list_scrolling_wrapper.tpl', '4bf0a92924334c72075b4ddafd3b243b');
        $this->checkFile('themes/affiliates/_common_templates/coupon.tpl', '7603de7353751cc37e762400f6dc1734');
        $this->checkFile('themes/affiliates/_common_templates/coupon_codes.tpl', 'a324bcc28deef842f75b6d3b4803dc6e');
        $this->checkFile('themes/affiliates/_common_templates/coupon_html_code.tpl', '4b85f57df88ff11ee43192e348076b42');
        $this->checkFile('themes/affiliates/_common_templates/coupon_previews.tpl', '3c5988cdbef06b3ae23b1de600ebf2b0');
        $this->checkFile('themes/affiliates/_common_templates/coupon_view.tpl', '1d6323a8ae51b2f146792372ec16f690');
        $this->checkFile('themes/affiliates/_common_templates/coupons_no_data.tpl', '7cfc619a48522b10ea82b76e667a197a');
        $this->checkFile('themes/affiliates/_common_templates/custom/advanced_tracking.tpl', '688e6a27720d8b877c167adafba63622');
        $this->checkFile('themes/affiliates/_common_templates/custom/directlink_explained.tpl', 'fbb1c9bf6714d461168da6c8ce9d17df');
        $this->checkFile('themes/affiliates/_common_templates/custom/frequently_asked_questions.tpl', 'a20edf1d913aa7b3a2d0a5f47189cd2e');
        $this->checkFile('themes/affiliates/_common_templates/custom/getting_started.tpl', '52c9abeb8090cbb26375f88f45200185');
        $this->checkFile('themes/affiliates/_common_templates/custom/promotion_tips.tpl', 'af2bbadfa205582078d22020db6bb780');
        $this->checkFile('themes/affiliates/_common_templates/custom_license_invalid.tpl', '9157ecde6accdbe2f6cd622084e79d53');
        $this->checkFile('themes/affiliates/_common_templates/daily_report.tpl', '696092e06570b6eebad4c345d98c5ca9');
        $this->checkFile('themes/affiliates/_common_templates/daily_report_filter.tpl', 'cdd6b5b0f3f67e1c68221170d4075b5c');
        $this->checkFile('themes/affiliates/_common_templates/direct_link_form.tpl', '7ff29892578e716dbc4f41b4509e1c70');
        $this->checkFile('themes/affiliates/_common_templates/direct_link_grid_widget.tpl', '586c3b902d66c903d87e510bca5843ec');
        $this->checkFile('themes/affiliates/_common_templates/direct_linking_panel.tpl', 'd96cd58bb0f0537f8404f641367e0801');
        $this->checkFile('themes/affiliates/_common_templates/direct_links_screen.tpl', '51bff33b38defef0aa9f24ba754caf76');
        $this->checkFile('themes/affiliates/_common_templates/download_login_form.tpl', 'db236b033d8f6217202ca5094a51ddf9');
        $this->checkFile('themes/affiliates/_common_templates/download_signup_form.tpl', '4a69ad70c68aff01b43bf53e775f74f1');
        $this->checkFile('themes/affiliates/_common_templates/dynamic_link_panel.tpl', '8b91b0d2c46352387c588e7cb59e1541');
        $this->checkFile('themes/affiliates/_common_templates/edit_tracking_code_widget.tpl', 'b7e7f42a46592a39498c4f09b9881571');
        $this->checkFile('themes/affiliates/_common_templates/email_notifications.tpl', 'dff046b3fe1dd02c697d52346af53525');
        $this->checkFile('themes/affiliates/_common_templates/extendable_commission_data.tpl', '189a7a2e1e5cbaeeb306c64ef1295e2a');
        $this->checkFile('themes/affiliates/_common_templates/filter_field_decorator.tpl', '5e64b134ec320a59cc5fe5da1342f578');
        $this->checkFile('themes/affiliates/_common_templates/financial_overview.tpl', '72f0f6986005b326ba12a01b07197fb8');
        $this->checkFile('themes/affiliates/_common_templates/footer.stpl', '7fff62da95ab3d8b7c4443b65611f1ed');
        $this->checkFile('themes/affiliates/_common_templates/footer.tpl', 'acf430b8fece1dddd26ef7f7165a7044');
        $this->checkFile('themes/affiliates/_common_templates/forgot_password.tpl', 'e31e8cf668201db153fb5783283dc75c');
        $this->checkFile('themes/affiliates/_common_templates/header.stpl', 'a1280de5b51c8c21c5c8169fa4075378');
        $this->checkFile('themes/affiliates/_common_templates/home.tpl', 'd91045e6e5db23f477c3ab310e6303f7');
        $this->checkFile('themes/affiliates/_common_templates/html_window_preview.stpl', '02d9e7142f0e2fa88afa0b9af7d9f5fc');
        $this->checkFile('themes/affiliates/_common_templates/img/affiliate.default.png', '4fe6ffc5c01d77a5e8b6408feb4d89b7');
        $this->checkFile('themes/affiliates/_common_templates/img/banner_flash-middle.png', 'c9c019525c41b5fce9a26e4f8d00a88c');
        $this->checkFile('themes/affiliates/_common_templates/img/banner_flash.png', '36f4e485ce10d8f5d661cd369497b58a');
        $this->checkFile('themes/affiliates/_common_templates/img/banner_html-middle.png', '1574314f83735158ef7a0fd1b8b93c86');
        $this->checkFile('themes/affiliates/_common_templates/img/banner_html.png', '0c5d9dc22178ea9e12aca239ca067fc5');
        $this->checkFile('themes/affiliates/_common_templates/img/banner_image-middle.png', 'd6bc27e84fe3a2ffe10fdc74132328ba');
        $this->checkFile('themes/affiliates/_common_templates/img/banner_image.png', '27edf0f1545e6f0acc40cd11732f1e6a');
        $this->checkFile('themes/affiliates/_common_templates/img/banner_link.png', '2b460f46d03323eb892a0b6e71bb5b69');
        $this->checkFile('themes/affiliates/_common_templates/img/banner_pdf-middle.png', 'e4d6133f65ff179aeba0779330ada67b');
        $this->checkFile('themes/affiliates/_common_templates/img/banner_pdf.gif', 'f376b73bf71f3f2ea1dc874086182783');
        $this->checkFile('themes/affiliates/_common_templates/img/banner_pdf.png', '5659684fa51315488c700d5e28cf7b86');
        $this->checkFile('themes/affiliates/_common_templates/img/banner_peel-middle.png', '10596c5299de137c98620795ff9a1f2e');
        $this->checkFile('themes/affiliates/_common_templates/img/banner_peel.png', '349692c03196bc32abcf7af659904afc');
        $this->checkFile('themes/affiliates/_common_templates/img/banner_peel_html-middle.png', '20e9de121dba95b1a9baa4cff9fffa7b');
        $this->checkFile('themes/affiliates/_common_templates/img/banner_peel_html.png', 'aaac3ee0e19bced62cdfb0bbaa37876d');
        $this->checkFile('themes/affiliates/_common_templates/img/banner_promoemail-middle.png', '4e8995641c51ebb67376e55414363790');
        $this->checkFile('themes/affiliates/_common_templates/img/banner_promoemail.png', 'ea8b7efcdbd3a1248b2f768c606e9470');
        $this->checkFile('themes/affiliates/_common_templates/img/banner_rebrand_pdf.png', 'aa36b576aecb4ba12d26aa9e07524027');
        $this->checkFile('themes/affiliates/_common_templates/img/banner_text-middle.png', 'd991eb71cf8655640f7d13b2bbfbcf47');
        $this->checkFile('themes/affiliates/_common_templates/img/banner_text.png', '2b0128371e3fb3f1370bb3d91753e9e1');
        $this->checkFile('themes/affiliates/_common_templates/img/banner_zip.png', 'fc08870d95436f47a15ff7cfbf5ff45a');
        $this->checkFile('themes/affiliates/_common_templates/img/button.icon.banner_rebrand_pdf.png', '2e9d58dc5d39c843ed7310e2d2c82cfc');
        $this->checkFile('themes/affiliates/_common_templates/img/button.icon.coupon.png', 'e38de70bbd3c0535e90d31f5e26dc837');
        $this->checkFile('themes/affiliates/_common_templates/img/button.icon.flash.png', '8ec346412290fc353e63b1b334962113');
        $this->checkFile('themes/affiliates/_common_templates/img/button.icon.hover.png', '38e73330dad0b0008e3953e9da761836');
        $this->checkFile('themes/affiliates/_common_templates/img/button.icon.html.png', 'bf779e6be27fc9f565827e3b44ac1964');
        $this->checkFile('themes/affiliates/_common_templates/img/button.icon.image.png', 'd3c71dd4c221da70bd2a01dd52402cce');
        $this->checkFile('themes/affiliates/_common_templates/img/button.icon.link.png', 'dfbc23b903320223dec4b206e3bbde04');
        $this->checkFile('themes/affiliates/_common_templates/img/button.icon.pdf.png', '33d0e16ed152aaeeb45be8a897225139');
        $this->checkFile('themes/affiliates/_common_templates/img/button.icon.peel.png', '2417dc2f99298d017651faee616b2a67');
        $this->checkFile('themes/affiliates/_common_templates/img/button.icon.peel_html.png', 'cde7a5f76399b839cfec297196bfa2b8');
        $this->checkFile('themes/affiliates/_common_templates/img/button.icon.promoemail.png', '02f0749e2bb9d04c1915cfbb5d916336');
        $this->checkFile('themes/affiliates/_common_templates/img/button.icon.rebrand.pdf.png', '2e9d58dc5d39c843ed7310e2d2c82cfc');
        $this->checkFile('themes/affiliates/_common_templates/img/button.icon.rotator.png', '633d9a8526c1ce798670b125f7d591d2');
        $this->checkFile('themes/affiliates/_common_templates/img/button.icon.site.png', '98cfb6286cf9b18e1dadde85b0e0ff90');
        $this->checkFile('themes/affiliates/_common_templates/img/button.icon.text.png', '0d77cd10a601be67f3dee483f87a8d97');
        $this->checkFile('themes/affiliates/_common_templates/img/button.icon.zip.png', 'f4e1e9fefa6f324b0b8f81a6cd0c43eb');
        $this->checkFile('themes/affiliates/_common_templates/img/campaign.default.png', '1be5bc07868c30ec347da3490788c07d');
        $this->checkFile('themes/affiliates/_common_templates/img/down.png', '5981ae525e3e3b7e9511c26e09eb18b5');
        $this->checkFile('themes/affiliates/_common_templates/img/favicon.ico', 'e15128807c80c86ddc36d69e0712d019');
        $this->checkFile('themes/affiliates/_common_templates/img/favicon.png', 'b7b49aa6d5f1611aa416c3623d057db8');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-about-big.png', '945937935f1ede0338e33618b51d9413');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-about-middle.png', 'e441842ea3ded7549178b024af817581');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-about-small.png', 'd5e3e336a761588b2cea0a51a5a07d5e');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-accounting-big.png', 'fa93f5c4b60b9d095a2a23a52211168e');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-accounting-middle.png', '7da96ba7ebbfb004234d789e5f36ce69');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-accounting-small.png', 'a14dd58b2eff427007308e6c395da74f');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-actioncommision-big.png', '699dc662dfe42872afc96a702562a3c7');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-actioncommision-middle.png', '34c506634c221c66d9254eeba2b82bcf');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-actioncommision-small.png', 'e7b6f38aa84c86e69e0db0c35ed85313');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-advancedfunc-big.png', 'd952bcf36cf4d79da6f18181163c0613');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-advancedfunc-middle.png', 'ba04970443fa6df133c32bb2fa32952b');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-advancedfunc-small.png', 'a3d6c775a0cc1ae61ef7216e70d14675');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-affiliateadd-big.png', '26cca94c4c749056882bd4556d907bfd');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-affiliateadd-middle.png', '31ea2f9625850f1a599926887ddf2f3b');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-affiliateadd-small.png', 'acc87948b57319a9b577fefcafdf3c67');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-affiliatesettings-big.png', '04338152a0aa405228bdc06ae28aafbc');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-affiliatesettings-middle.png', 'b136c5a4a48ebce146fdcd74886a1b11');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-affiliatesettings-small.png', '92e194238f23d1a083147e0dff48c7d7');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-affiliateslist-big.png', '77bfd3ca54a0f7116908c0f65333b55e');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-affiliateslist-middle.png', '5cfbf053d261347ad3366389e78a6756');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-affiliateslist-small.png', '5f8c8a8cff8512fc608ddba8b4ab93bd');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-affiliatesoverview-big.png', '646727bef41c7fbe31e33e4aceb02e20');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-affiliatesoverview-middle.png', 'f2356acee2206a810aecd118aa71335f');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-affiliatesoverview-small.png', 'dc623d54779af92572a5453ca3580451');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-affiliatetree-big.png', '16637581ac6ae00036ed4cf0e95edbed');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-affiliatetree-middle.png', '50da22141c8638e2e33579a96730d447');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-affiliatetree-small.png', '8fe777e521204a54ef685caf830773ac');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-afflinkprotector-big.png', '579c33f76a72c642825593d236bef201');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-afflinkprotector-middle.png', '94cd61264c5f9b912bf5f8410cd9721a');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-afflinkprotector-small.png', '2d7e90db6d345da6d6ee6d87475abe9f');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-affpanel-big.png', 'c1cfd6a87b6c075f80a4078dc8e11bfc');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-affpanel-middle.png', 'f389cba50adbde11cca261597d22cc68');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-affpanel-small.png', '048948d101c7021f4689499ea5a3aac2');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-apiintegration-big.png', '8ffaaf6917c42e391f8dfac25603dc2c');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-apiintegration-middle.png', '61c67a4e19292e3a41d467a9255c617e');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-apiintegration-small.png', '2c63cf93ca9b1ff5d5b16c6646a59ddc');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-banneradd-big.png', '81df063ae38e46bf38935e9cefc0327d');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-banneradd-middle.png', 'f9eed2f2063ae89a43dd119cd957a81c');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-banneradd-small.png', 'ce4bc4ce2e5f8e34580dc6333b208aa8');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-banners-big.png', 'b94b60d34d903b93aaa1a13441b7aaf5');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-banners-middle.png', '123c2b69fb53085e84882f1af3aeb08a');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-banners-small.png', 'a99bead174a4ef7b5e8f43dcb50a2d66');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-bannerscategories-big.png', 'faea92b05cd5199241c814f685484394');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-bannerscategories-small.png', '81844453c555423b54b39aa264118425');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-bannerslist-big.png', '07dabd09a236c2c292732164bbd11829');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-bannerslist-middle.png', '4c44bbd6d7225a94b88a518f06f54008');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-bannerslist-small.png', 'db323fe7922f367738f6a58ac4da3a37');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-bannersoverview-big.png', '81df063ae38e46bf38935e9cefc0327d');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-bannersoverview-middle.png', 'f9eed2f2063ae89a43dd119cd957a81c');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-bannersoverview-small.png', 'ce4bc4ce2e5f8e34580dc6333b208aa8');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-bannersscategories-middle.png', '774c6fa7bfe558afe5fda5fde938fafc');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-billinginfo-big.png', '46fad7bed165099bc5c520b1ab962fed');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-billinginfo-middle.png', '051d86170471f4c07947c14be0768bc0');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-billinginfo-small.png', 'c5b62a0af020b01ed1791e44e76aec4f');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-broadcastemail-big.png', 'f2c91ecade89182f16fea8d893ae70fa');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-broadcastemail-middle.png', 'a84a478aab18a99fe403344166a6d7fd');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-broadcastemail-small.png', '52dcfbc66219534f2cacb336e3d7da8a');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-calccommission-big.png', 'b88131af43864361414eecae42f65860');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-calccommission-middle.png', '511a64884ae7c537179549d2a79e322b');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-calccommission-small.png', '7fc14c2584cce9f02df8e54fa825545c');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-calcsettings-big.png', '7c3b1590dd6bea9564d93f406062f968');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-calcsettings-middle.png', '755675398819a380039075bc1ee1ff6e');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-calcsettings-small.png', 'd6f3b62f678dcc50de2b50f026a6559a');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-campaignadd-big.png', 'bcde6cec8d0312a5e207211d8a591233');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-campaignadd-middle.png', '150ea540b710cbfa76359c33f17400ab');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-campaignadd-small.png', 'd412d150a33ac60e3473147b9629bfa3');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-campaignscategories-big.png', 'faea92b05cd5199241c814f685484394');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-campaignscategories-middle.png', '774c6fa7bfe558afe5fda5fde938fafc');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-campaignscategories-small.png', '81844453c555423b54b39aa264118425');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-campaignslist-big.png', 'c7c7a7c6407fe15a05658988ab87d058');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-campaignslist-middle.png', '35b521416ecfb40343409f69f6cc345d');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-campaignslist-small.png', '21776d92e031be82ea1377103d62117a');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-campaignsoverview-big.png', 'bcde6cec8d0312a5e207211d8a591233');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-campaignsoverview-middle.png', '150ea540b710cbfa76359c33f17400ab');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-campaignsoverview-small.png', 'd412d150a33ac60e3473147b9629bfa3');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-channels-big.png', '4aba5775ccb5380d84320c41998ff4c3');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-channels-middle.png', 'ecb3bff2feb9e2c299546a3c55d140de');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-channels-small.png', '8fec8c8716b6df4308c5ec9d1c06d628');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-channelstatsreport-big.png', 'f31865e5049c9a5e3e180f3144dd44b2');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-channelstatsreport-middle.png', 'af8c71a3d487c7e81212b928ca9aa656');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-channelstatsreport-small.png', 'e891cde05e7973a19ffc591104d9d555');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-clickcommission-big.png', '36e5ade0af6dadf475f4dbac18b853e1');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-clickcommission-middle.png', 'aff86bed51ff309b10dbcb3b5abf9770');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-clickcommission-small.png', '5fd3fa783a954bb9b095aefbddda05eb');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-clickslist-big.png', '433859124a82977494b15c25af528fe6');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-clickslist-middle.png', 'e70f680636193963e0045de62f7107c9');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-clickslist-small.png', '686b1ea11592b864385dc9bc74c333de');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-clickstracking-big.png', 'c0b769ba7ed7af6ca066171495585214');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-clickstracking-middle.png', '0670cf8762aaaefecdff2d7a056954e3');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-clickstracking-small.png', 'ebccf888171423d12f55c94d84afadf3');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-commissionadd-big.png', 'c09448d768479c3c116cea35d25d1a64');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-commissionadd-middle.png', '308ff5c4c45e8135f7b1047dd26b56f1');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-commissionadd-small.png', '762eb56287f9a3943224a393c40b59d6');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-commissionslist-big.png', 'c09448d768479c3c116cea35d25d1a64');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-commissionslist-middle.png', '308ff5c4c45e8135f7b1047dd26b56f1');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-commissionslist-small.png', '762eb56287f9a3943224a393c40b59d6');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-commreport-big.png', '5ee29fb34b71df8d37849e62d560287c');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-commreport-middle.png', 'c2e88cdf3e2ccd03d443f6c4aa7cf259');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-commreport-small.png', 'c255702b93356cd648af7258da3ef874');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-communication-big.png', 'd9634c6d21ab0388db756a302b43c24b');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-communication-middle.png', 'dad7567ea8455db8f9d04f62827f95b7');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-communication-small.png', '4ca468f4707653aea90c10a8aee280be');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-configuration-big.png', '759290e16f4426e393ebc622842746c1');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-configuration-middle.png', '3ebd61d05d6f69672dc3072414f9e470');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-configuration-small.png', '60d07f619550c84932132bdf6d5536cf');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-contactus-big.png', '95be20cb2afbefa61eba4931aaab9ef3');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-contactus-middle.png', 'a4fc0c0524972fc3cfd69006e35fb23c');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-contactus-small.png', '51fc7d111cec13771493fa76c8e0b9c0');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-cookie-big.png', '8a245985191ed381885daa40336a9d3c');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-cookie-middle.png', 'ac167af6efcca0b5b5c07ffee0088f74');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-cookie-small.png', 'db41360e227b890774ecea23c9291ac5');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-creditcardinfo-big.png', '4097374ea71eacf24b851b377519cca2');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-creditcardinfo-middle.png', '737248672afd083ecdb80467bf7b1932');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-creditcardinfo-small.png', 'f4d12911b67ae75aeb68725833395a1f');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-cron-big.png', 'a8986017aef2d39fcce5647aa166623a');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-cron-middle.png', '5a85f870602dbb253d9e321aa2302c81');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-cron-small.png', '4edb02cc7eb9fcd59f17fcdcd8925a2d');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-currency-big.png', '816bb049bcffc480c9b350704a8adbc2');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-currency-middle.png', '10fe7d529a376968cf05ad721f3bb605');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-currency-small.png', 'd5f81da7b49a3421cfa7f54ad050c790');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-dailyreports-big.png', '7cc246a3a285c2e3e16fc3f449da598f');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-dailyreports-middle.png', '1dedab44e1e695c57597adab0e42320e');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-dailyreports-small.png', '14a6064d2c1aeb957ae01c8b2b2a8b5f');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-databasestats-big.png', '4c5ca10598302a2e33390b2a0c449305');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-databasestats-middle.png', 'f41d856d3b4f4755427ae7d23d2eec77');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-databasestats-small.png', '4780055a8d7b99626a51c58d3e646d6e');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-directlink-big.png', 'b7534b930f7b69a3ce941fccc34161cc');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-directlink-middle.png', '4293fc92b931d8ae75471b5cb08f2a0e');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-directlink-small.png', '8986e8e2f6374595fd49a0137cf6831f');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-directlinksmanager-big.png', '646727bef41c7fbe31e33e4aceb02e20');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-directlinksmanager-middle.png', 'f2356acee2206a810aecd118aa71335f');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-directlinksmanager-small.png', 'dc623d54779af92572a5453ca3580451');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-domain-big.png', 'deef24e04a5df724664a652494d1fa6f');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-domain-middle.png', '84629e5b4f85c5131175c567692dfe00');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-domain-small.png', 'f2f26fcf1aba80559fdd8538b6fbaf41');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-emailnotification-big.png', '8a2404df009e9ba936324c8702b87b3e');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-emailnotification-middle.png', '9658622a8a1a5ffa0153f043df28b19a');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-emailnotification-small.png', '29c293c006a77a0eeda2d8cc7fb80603');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-emailsettings-big.png', 'd1dd11f7f507e192bcfdbda56175caa3');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-emailsettings-middle.png', '2c5e01cfab6546e9e1a9f2c770aec242');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-emailsettings-small.png', 'eb08c9d0e83954e6fb6a9deff4ad27d0');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-emailtemplates-big.png', 'c4cb709797ed19238676c29cb1472c70');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-emailtemplates-middle.png', 'f5e1a27dc997f8480d67f4461c825edd');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-emailtemplates-small.png', '5d49ee20c991a906969ad4d36c7e413d');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-eventlog-big.png', '22d3eefca55604346012a6d93546859f');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-eventlog-middle.png', '7305dd68781c753da2254eab32c81190');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-eventlog-small.png', '9a7f8439d6939cdc9bb82ad160971789');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-folder-big.png', 'befebaf27b76b65ef3a0a2056b6717b5');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-folder-middle.png', '44212fdaf6e707dcd63f96b91254fa6d');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-folder-small.png', 'ea493e348f302fae514119d7f83c45c6');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-foldergrey-big.png', '0ebd3c105f9148e6b3c2f148429e3a39');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-foldergrey-middle.png', '6606aad448bf6e880b16ee07917368d1');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-foldergrey-small.png', '6f79edef86528343b6edd4687671008c');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-fraudprotection-big.png', '9010f7b5556d925a916511445f28af47');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-fraudprotection-middle.png', '26b7b0ce01dc95ff89f934e449e23c27');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-fraudprotection-small.png', 'a86fc50a3868eb1e583828e8a1f036b3');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-generalsettings-big.png', '840fc19fa2a425a86c2eb5862487db29');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-generalsettings-middle.png', 'e2756d829c93ca5d748f6af91b84a4dd');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-generalsettings-small.png', '289602fe0948eac1eabb91637e299e4a');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-gettingstarted-big.png', '64b1522f4f5bea2e7ad6facc1f78a474');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-gettingstarted-middle.png', 'e0d7aec79ef50ba26365c881b0025784');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-gettingstarted-small.png', 'b3f95b6b0f495a8d878e96f2f5779e94');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-impressioncommision-big.png', '4c1e7a03efa32fe7635a30fbbd8f2c85');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-impressioncommision-middle.png', '55960d902a1fc6db9e60ded10a7ed23c');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-impressioncommision-small.png', '10a3ee7b00176808f90b91b87e8d0789');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-informations-big.png', '52544f78f6c21ff28917b9f0a3577333');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-informations-middle.png', '66fcddef6f1a68251e6840914910938b');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-informations-small.png', 'fcf56ff111c67e58b05ae8b0ecc18e62');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-integration-big.png', '52bdc4d11bae3a9c174ea5789fb54458');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-integration-middle.png', '84629e5b4f85c5131175c567692dfe00');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-integration-small.png', 'f2f26fcf1aba80559fdd8538b6fbaf41');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-integrationmethods-big.png', '2c0a44031f6adea26c905d507b533d37');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-integrationmethods-middle.png', '5693ce47e662486ad8d514b6d4b86f37');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-integrationmethods-small.png', '215e07387a6248ab4fb93725be7a871f');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-invoice-big.png', 'ad77071d26277108741750ce3c29e4ba');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-invoice-middle.png', '8eaee3186c342a787159e27267e22d43');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-invoice-small.png', '85bd979002fa06ec1cf65d38b7d7a7fe');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-invoiceformat-big.png', '6bf9da1c9eb48ed0c19257ead306f8dd');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-invoiceformat-middle.png', '76c95db323aa1516ca1f565d900cff47');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-invoiceformat-small.png', 'f961da6366d582d141e04b425df167ca');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-languages-big.png', 'cae29a0f574666e60b484da7dc02c42d');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-languages-middle.png', '2579c343d6a2659a91e2b11b03fa7831');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-languages-small.png', '69a22cf6c18734c3f5f34f534f59d0dc');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-linkformats-big.png', '0b7c3b7cfe7b0d4fb13b13119c9d4e3e');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-linkformats-middle.png', '4e9a9be9246491551816510d7cfad3da');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-linkformats-small.png', '5e117734176b4174b1d3fc855f9bdee1');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-liveagent-big.png', 'eb8a8d704ddeb8169d7acc791025b019');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-liveagent-middle.png', '1013b101a0914f3ddfedc66acbdf2ff2');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-liveagent-small.png', 'cd947a9498aefe06551852e9633d4e5f');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-logging-big.png', 'a836bc888a51cc3272c440b76e1f4489');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-logging-middle.png', 'b4d937e0513feaaa49c951690e65b6ab');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-logging-small.png', 'c8001b73dd7b9c29222a358fa7439cf6');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-mapoverlay-big.png', 'f95e21092dcec6999407f32482de8654');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-mapoverlay-middle.png', '1ff8bf5448529154c95588e3da6b2bd5');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-mapoverlay-small.png', '4b9dddb70e5e0f41b1b069de5d129b0f');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-myinvoices-big.png', 'ad77071d26277108741750ce3c29e4ba');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-myinvoices-middle.png', '8eaee3186c342a787159e27267e22d43');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-myinvoices-small.png', '85bd979002fa06ec1cf65d38b7d7a7fe');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-networkaccountadd-big.png', '418a388c12bd60225f5899b1c87ac0b9');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-networkaccountadd-middle.png', '231dfa7e08303b7c4558d23170d5cb4e');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-networkaccountadd-small.png', 'ba4724b82d7f2747d0792e2073f8a7b2');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-networkaccountfields-big.png', '6cd403a39def5fb616f49f3d7e0b3fe2');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-networkaccountfields-middle.png', '0b174b7645e1ac9a8cd04da69dd5a859');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-networkaccountfields-small.png', 'e601d9478659d4205021d2a77c04c2eb');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-networkaccounts-big.png', '418a388c12bd60225f5899b1c87ac0b9');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-networkaccounts-middle.png', '231dfa7e08303b7c4558d23170d5cb4e');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-networkaccounts-small.png', 'ba4724b82d7f2747d0792e2073f8a7b2');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-news-big.png', '40bb8cc702f44fc780915538395f4bcc');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-news-middle.png', '06e1bacdbe2a9098e98b883dd1a65ab3');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-news-small.png', '8d9da5c42931d0869eab8201c76a78ce');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-offlinesale-big.png', 'ec90135d4a9d0130e8e304bae081c440');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-offlinesale-middle.png', '66dcbbf01bbf792063fc9fada45885a2');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-offlinesale-small.png', 'f7f3f63493c0322becb736a5728e5bd3');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-outbox-big.png', 'cd244f1f99b9c4edc97e1517e61647b6');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-outbox-middle.png', 'd78563c123666abaa270e69447818704');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-outbox-small.png', 'edc06a19e14830e7ca622238a0442419');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-parameternames-big.png', '9dfb5dd726b437a4365e7c45a7c408d3');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-parameternames-middle.png', '43de9c57262992d30beb88f52fb3af21');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-parameternames-small.png', '4bbe462e5afa4a1e0215f368d0fb8903');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-payaffiliates-big.png', '4334ddecb0a08a61b26044e1185e87d1');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-payaffiliates-middle.png', 'd473f2fb10ab1b3ef84ae1285c90647f');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-payaffiliates-small.png', '014347b0105edd288bd701e5fc544a5a');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-paymentdetails-big.png', '552a96fe0d8d2db810699dd48b6db3e4');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-paymentdetails-middle.png', '858a4b81c6972ccb39bbeaf658dd7bfb');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-paymentdetails-small.png', 'bd5735f849deb0b18f84414651c3d3d3');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-payoutsbalance-big.png', '6cd403a39def5fb616f49f3d7e0b3fe2');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-payoutsbalance-middle.png', '0b174b7645e1ac9a8cd04da69dd5a859');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-payoutsbalance-small.png', 'e601d9478659d4205021d2a77c04c2eb');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-payoutsbyaff-big.png', '8afa8f6c1f712f425740c505448b418d');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-payoutsbyaff-middle.png', '13c1199787c0aad4c092f6f7bf3cb1a1');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-payoutsbyaff-small.png', '5dd8b265a8499dba9f1876f9181f3ebe');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-payoutsettings-big.png', '0918b6fdfd048814037fdad23454454f');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-payoutsettings-middle.png', 'd768bd937f53dbf8515e3a4cfa4bf0b7');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-payoutsettings-small.png', 'e97cbe419aa145bf610152bc94f18883');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-payoutshistory-big.png', 'c31359b802eed7c5513f87c9e98643fd');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-payoutshistory-middle.png', 'a91743250db435d7256f3881676311fd');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-payoutshistory-small.png', '44a4f54972ffffbcc87696dfcd69fcd0');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-payoutslist-big.png', '076584a088f94d940884833af3400a1d');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-payoutslist-middle.png', '5310f372b209cefb76454e8bcd79456c');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-payoutslist-small.png', 'f67a8ff098d10da4f1bacdeb5cc8a447');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-payoutsoverview-big.png', 'f60a1248df1dae429b019f2637430665');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-payoutsoverview-middle.png', 'f4a9ba1b4b951ec34fcadb7305a0af08');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-payoutsoverview-small.png', '1c4436ae5675d4931ef345b95f8e1a94');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-personaldetails-big.png', 'd2e23c57548c0ba0c4cd3a710155679a');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-personaldetails-middle.png', '59506d20cc58f7d6c43f33856564cf15');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-personaldetails-small.png', 'd30744870d1cb2e8bc998f3f00e1f1a8');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-promotion-big.png', 'eda85624d63cc3f1c51d6e2cdc23c74e');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-promotion-middle.png', '40e4d1ac990e57416a041bafcfe29606');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-promotion-small.png', '40557c962a36593985c570c43cd2ffd5');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-proxy-big.png', '67899c6630a1d54cb882ac30bc4c1fea');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-proxy-middle.png', '8c84e7263189e5302b4ef463bc29e6b1');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-proxy-small.png', 'de57ff1e951414cdf1d4c495db128aea');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-quickreport-big.png', '4943bbc7b309a9a8e0e65119df227a10');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-quickreport-middle.png', 'bfdd9e69170349a0b90340310823e566');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-quickreport-small.png', '083dab2a8c4025a05c2df99eee9bb628');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-recurringcommissionslist-big.png', 'f0069a7b12a4c842189d353a16787d63');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-recurringcommissionslist-middle.png', 'e22b0e87b75fa45fbcce9fd7bc0e3a32');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-recurringcommissionslist-small.png', 'd9fd1789958cb9843284d5182d239541');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-reportproblems-big.png', 'ea668db8e90d4d2dd5891be9c3662d65');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-reportproblems-middle.png', '72a5e3a0a993e899b89747f7a977c3b8');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-reportproblems-small.png', 'aba167c8a15a1f84f1cc004498e2fcd1');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-reports-big.png', '52bdc4d11bae3a9c174ea5789fb54458');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-reports-middle.png', '84629e5b4f85c5131175c567692dfe00');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-reports-small.png', 'f2f26fcf1aba80559fdd8538b6fbaf41');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-rss-big.png', '72ced7ea320583602b850ff6e5c7fbdc');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-salecommission-big.png', '8e29539a67c5649a182722073913a313');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-salecommission-middle.png', 'e6f76cab2074540649a7a42cabf9f3ca');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-salecommission-small.png', '1a5ca460dd7ec1682c789d9fdcaafd08');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-send-message-big.png', '8d399ab3d79e492ef1e525425e2acf2a');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-send-message-middle.png', 'a52b5ba5de1cafd7bb8b2b5ee7ac0f6d');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-send-message-small.png', 'ea5783d3bd4c110703f21c67be4a30b9');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-signupform-big.png', '874c07a23557bcf6db1f6262037b2ed0');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-signupform-middle.png', '277f7f5abb7389776280cd789e75e656');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-signupform-small.png', '4758fab900531342f95ded1e28d36dcb');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-signupsubaff-big.png', '69e7210754e55ac547349458ee1da0ce');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-signupsubaff-middle.png', '04ea8feb34f124bff9da8d254a1945d8');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-signupsubaff-small.png', 'e9671ad31b3ec8fe215ffa93b19495bd');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-subaffiliates-big.png', '77fd3a6fc05ce80838cc6b83595332aa');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-subaffiliates-middle.png', '55aa3b7234a778033d4b046ecc79913b');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-subaffiliates-small.png', 'a04355f2afb2fcdae93ea858d670412b');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-subaffiliatestat-big.png', '56e6fd28294cd37caf9255d491b59619');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-subaffiliatestat-middle.png', '543edd91794a13447084719c7d599753');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-subaffiliatestat-small.png', '6727873e91826f067526d1eaa63bb931');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-subidtracking-big.png', '2ff7b754a1b84f86c9e47e5d92c1ad12');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-subidtracking-middle.png', 'cce0da093e207845535e53e4f893e63c');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-subidtracking-small.png', 'b13ce5350c0317e004c68e2a66dbf006');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-themes-big.png', '600e41998f62d8ff1d12105a835ce077');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-themes-middle.png', '4ca98335815494b810a1df5b10b3af9c');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-themes-small.png', '4734308c4657e7724cf940fa6e2da368');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-tools-big.png', '52bdc4d11bae3a9c174ea5789fb54458');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-tools-middle.png', '84629e5b4f85c5131175c567692dfe00');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-tools-small.png', 'f2f26fcf1aba80559fdd8538b6fbaf41');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-topreferringurl-big.png', '418a388c12bd60225f5899b1c87ac0b9');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-topreferringurl-middle.png', '231dfa7e08303b7c4558d23170d5cb4e');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-topreferringurl-small.png', 'ba4724b82d7f2747d0792e2073f8a7b2');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-trackingaffiliates-big.png', 'f717823f3c85d837811ed97caeb2a66b');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-trackingaffiliates-middle.png', 'd457fbb7ee85000bdfc251ac1502b413');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-trackingaffiliates-small.png', '4c2ebf2c84cb6b1236b8b22004798df9');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-trackingsettings-big.png', '929dfcbe7e88ea55fc9a8b3c63d428c4');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-trackingsettings-middle.png', 'be2d1542b81cb886a185fc2da45a3b4c');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-trackingsettings-small.png', '950cb2bef87680ffa76138e5314a3dbf');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-trafficinfo-big.png', '52bdc4d11bae3a9c174ea5789fb54458');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-trafficinfo-middle.png', '84629e5b4f85c5131175c567692dfe00');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-trafficinfo-small.png', 'f2f26fcf1aba80559fdd8538b6fbaf41');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-transactionsoverview-big.png', 'c09448d768479c3c116cea35d25d1a64');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-transactionsoverview-middle.png', '308ff5c4c45e8135f7b1047dd26b56f1');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-transactionsoverview-small.png', '762eb56287f9a3943224a393c40b59d6');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-trendsreport-big.png', 'eb6156337cf90b343d14cba8324681e2');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-trendsreport-middle.png', '1073e897e447b1100d8758eec72f6f8c');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-trendsreport-small.png', '59df43c57dae4742593ff9eb34465182');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-troubleshooting-big.png', 'a7a159dabd19227a3c31aa37fbd3eebc');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-troubleshooting-middle.png', '6df05fc06950d48599d11ddfd86bd72c');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-troubleshooting-small.png', '653eb83ea77d1fb244556829a2c4bcf8');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-undefined-big.png', '52bdc4d11bae3a9c174ea5789fb54458');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-undefined-middle.png', '84629e5b4f85c5131175c567692dfe00');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-undefined-small.png', 'f2f26fcf1aba80559fdd8538b6fbaf41');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-vathandling-big.png', '514522fd956ad10fd392ff7a145c6873');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-vathandling-middle.png', 'b1f77e628bfe32b0f9898b97d091779a');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-vathandling-small.png', 'c212e16c531c0b338b81bd97083e2a50');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-views-big.png', '9c84c38db0ea8cbb675db9e03c54bd38');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-views-middle.png', 'c9e3031d5c622b524e418aef9a9c768b');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-views-small.png', '0297aac207d61c873818888fa2112d19');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-youraccount-big.png', '418a388c12bd60225f5899b1c87ac0b9');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-youraccount-middle.png', '231dfa7e08303b7c4558d23170d5cb4e');
        $this->checkFile('themes/affiliates/_common_templates/img/icon-youraccount-small.png', 'ba4724b82d7f2747d0792e2073f8a7b2');
        $this->checkFile('themes/affiliates/_common_templates/img/logo_pan.png', '97ebd132ae8ec2dd08bbef552d03a0fd');
        $this->checkFile('themes/affiliates/_common_templates/img/logo_pap.png', '011698765bb35b0ae0dd13f8f16955d5');
        $this->checkFile('themes/affiliates/_common_templates/img/overview.png', '63ec9d3983440826362b89e3d42db410');
        $this->checkFile('themes/affiliates/_common_templates/img/smpl_ad_channel.jpg', 'e20ff10cc96830daf13b7ccaf7f716ad');
        $this->checkFile('themes/affiliates/_common_templates/img/smpl_aff_rawclick.jpg', '8c76c42bd0499ccf68c72aefb2cde511');
        $this->checkFile('themes/affiliates/_common_templates/img/smpl_aff_urls.jpg', '0c67faf4b2efb34e9d80d419abb27f4f');
        $this->checkFile('themes/affiliates/_common_templates/img/smpl_commissions.jpg', '9d97fc7a1c6e9e2eb3eae1a9a0ae76b7');
        $this->checkFile('themes/affiliates/_common_templates/img/smpl_payouts.jpg', '788f2e1dcdd89aabe293d878bf9015f3');
        $this->checkFile('themes/affiliates/_common_templates/img/smpl_subaff_stats.jpg', '483e353a8b37c019472eec58ac9a227d');
        $this->checkFile('themes/affiliates/_common_templates/lifetime_referrals_panel.tpl', '57fdc30f1434427f31e456701817165a');
        $this->checkFile('themes/affiliates/_common_templates/load_mail_from_template.tpl', 'ea8100528686a687181767b7eac64c17');
        $this->checkFile('themes/affiliates/_common_templates/login_form.tpl', '297656a8cfb59277903ed38dfaa9e2f1');
        $this->checkFile('themes/affiliates/_common_templates/login_form_downloadable.tpl', '6f2b17262524a8c12cfdcd572ad36bf9');
        $this->checkFile('themes/affiliates/_common_templates/login_main.tpl', '0cd828d3f67418d0795faf78316d9aaf');
        $this->checkFile('themes/affiliates/_common_templates/main.tpl', '77e2554f073f14740c0807ad124704e6');
        $this->checkFile('themes/affiliates/_common_templates/main_aff_html_doc.stpl', '84115d5f16fbb9080d2a0d4e9c90e9bd');
        $this->checkFile('themes/affiliates/_common_templates/main_header.tpl', 'cd2fc3cb58a6bceabf1897fd42dfc70f');
        $this->checkFile('themes/affiliates/_common_templates/main_menu.tpl', '5fddab52f7b44bcb5717c1d67875f567');
        $this->checkFile('themes/affiliates/_common_templates/map_overlay.tpl', '89360a2ff85754296007534dcc6b408d');
        $this->checkFile('themes/affiliates/_common_templates/map_overlay_advanced_filter.tpl', '517988f41fe554d9a067048a33675a0c');
        $this->checkFile('themes/affiliates/_common_templates/menu_section.tpl', 'ce9552c9579aa842bfd16e9c61b1cd0e');
        $this->checkFile('themes/affiliates/_common_templates/myprofile.tpl', '53e66ce2c1232e59a8c00c2c5be657f5');
        $this->checkFile('themes/affiliates/_common_templates/news_content.tpl', '08d9f1f5e6ebcc1c34812ee3daf52065');
        $this->checkFile('themes/affiliates/_common_templates/news_item.tpl', '18161a56a8f4dc5df01f08191709f864');
        $this->checkFile('themes/affiliates/_common_templates/order_id_filter.tpl', '103e1ce5be4c9d2f1cc161390371e222');
        $this->checkFile('themes/affiliates/_common_templates/panel_footer.stpl', '2ecfae35d4c9436786fd4b2c26747242');
        $this->checkFile('themes/affiliates/_common_templates/panel_includes.stpl', '0f94d032ed0894e4a4fbaf4d54bf3dc0');
        $this->checkFile('themes/affiliates/_common_templates/panel_with_icons.tpl', 'cdc3dafa07941a7c6c1ec5c4297528d6');
        $this->checkFile('themes/affiliates/_common_templates/pap4.css', 'adb7a2547650272764a0ec8e3e2a4e98');
        $this->checkFile('themes/affiliates/_common_templates/payment_details_panel.tpl', 'bd1428f1106f97eec1521cc03308d390');
        $this->checkFile('themes/affiliates/_common_templates/payout_data.tpl', '04fbc30b334480035464925430c1b84c');
        $this->checkFile('themes/affiliates/_common_templates/payout_fields_panel.tpl', '783033d19881c72d05d99c6719dd49c0');
        $this->checkFile('themes/affiliates/_common_templates/payouts_no_data.tpl', '7f552824865e5fa36468c099be260a58');
        $this->checkFile('themes/affiliates/_common_templates/payouts_to_affiliates.tpl', '49d7e922d8bdda291c5666d5dbfee4d5');
        $this->checkFile('themes/affiliates/_common_templates/period_stats.stpl', '6dfc4fca15ae8bbbcb139c8a2eaf0180');
        $this->checkFile('themes/affiliates/_common_templates/personal_details.tpl', '92b89a61705000268346e93997089df0');
        $this->checkFile('themes/affiliates/_common_templates/promotools_screen.tpl', 'c55f44f1596b21ec9514ca977ab97cbe');
        $this->checkFile('themes/affiliates/_common_templates/quick_report_base.tpl', '9ab056e97e59a1ef7e81e5a2ddafd977');
        $this->checkFile('themes/affiliates/_common_templates/quick_report_content.stpl', '95ebcbc8dc01f90575e70586f6fc0e38');
        $this->checkFile('themes/affiliates/_common_templates/quick_report_content_multitier.stpl', '241f17e7a86b9eb71490cefd7ffe082e');
        $this->checkFile('themes/affiliates/_common_templates/quick_report_filter_base.tpl', 'f87f3cadd19c5fbaf665b1bbcf4f6ad2');
        $this->checkFile('themes/affiliates/_common_templates/quick_report_multitier_widget.tpl', '2f19acbcc8ca3270ba3b1d16b6253c1d');
        $this->checkFile('themes/affiliates/_common_templates/quick_stats.tpl', 'eb812b06f6292efc64d3aa411c1f8cc0');
        $this->checkFile('themes/affiliates/_common_templates/quick_stats_box.tpl', '745d64595b8a0e5869bfc1e9bf10b9c2');
        $this->checkFile('themes/affiliates/_common_templates/rawclicks_no_data.tpl', '533c13261c4af002034840f85b0c0c80');
        $this->checkFile('themes/affiliates/_common_templates/recipients.tpl', 'cae0cd53d947d39c2ad761f6f29b2d65');
        $this->checkFile('themes/affiliates/_common_templates/referringurl_advanced_filter.tpl', '6bc6dea93c4524ee0ae4d509fbc612f0');
        $this->checkFile('themes/affiliates/_common_templates/reports_screen.tpl', '4e44da368f7bb6e26bd84a882c55f699');
        $this->checkFile('themes/affiliates/_common_templates/rotator_preview_affiliate.stpl', 'b9766c5bec13353b6b35944db1a983e0');
        $this->checkFile('themes/affiliates/_common_templates/sales_list.tpl', '5af405985c7c15163235dc47143cdd68');
        $this->checkFile('themes/affiliates/_common_templates/send_to_friend.tpl', '5e46c580ad06b12c37e6befa88a4ad52');
        $this->checkFile('themes/affiliates/_common_templates/signup_fields.tpl', '16c26f808a27c220930859db1a454042');
        $this->checkFile('themes/affiliates/_common_templates/signup_form.tpl', 'a55f02ab4d649b4eb23fbd252e3555fb');
        $this->checkFile('themes/affiliates/_common_templates/signup_subaffiliates.tpl', 'e50c248dd0978fbd417ce16b5a64a846');
        $this->checkFile('themes/affiliates/_common_templates/statistics_double_value_widget.tpl', '7e243a39277ad97843b418e45881a6d2');
        $this->checkFile('themes/affiliates/_common_templates/stats_chart.tpl', 'ae416723ccb917fc5b17ed3929842bfa');
        $this->checkFile('themes/affiliates/_common_templates/sub_aff_tree.tpl', 'b44e7e79bbe5f90995e3f12091d82bb5');
        $this->checkFile('themes/affiliates/_common_templates/sub_menu_section.tpl', 'ab7871c677c0d90bb2d878548157b628');
        $this->checkFile('themes/affiliates/_common_templates/subaff_stats_no_data.tpl', '39b81251804f71939bed55ca677c6f27');
        $this->checkFile('themes/affiliates/_common_templates/subaffiliate_sales_panel.tpl', 'db4e194adc58204d57ceb55e1938702f');
        $this->checkFile('themes/affiliates/_common_templates/subaffiliates_filter.tpl', '1aa5c661d4397d165d32f720e93d4695');
        $this->checkFile('themes/affiliates/_common_templates/subaffiliates_panel.tpl', '3f4e12c8ee33816f7eaaa9aee7626c3b');
        $this->checkFile('themes/affiliates/_common_templates/subaffiliates_sales_filter.tpl', '9f9fd28d6f934e3937e6551e0cfbf7fb');
        $this->checkFile('themes/affiliates/_common_templates/subaffiliates_tree_panel.tpl', 'bd640ce415c67d2170ee88da05712f7b');
        $this->checkFile('themes/affiliates/_common_templates/subaffstats_filter.tpl', 'd0d0b51a10872fa37758a642237c5abd');
        $this->checkFile('themes/affiliates/_common_templates/subaffstats_list.tpl', '6410e8f12149667eb7c496c25ccea070');
        $this->checkFile('themes/affiliates/_common_templates/subid_tracking_screen.tpl', '6cea00799d59a74f82161c7d02f951cc');
        $this->checkFile('themes/affiliates/_common_templates/system_menu.tpl', 'c77607e9537a635eae51274af1013e3d');
        $this->checkFile('themes/affiliates/_common_templates/terms_and_conditions_confirmation.tpl', 'd80b7e300b4b81e3bb35d1d2516e2ee7');
        $this->checkFile('themes/affiliates/_common_templates/tests.tpl', '2e8601708f27cfadc9ee8a3454080aaf');
        $this->checkFile('themes/affiliates/_common_templates/topmenu_logged.stpl', '3309092595865ba40186a7d7c009226b');
        $this->checkFile('themes/affiliates/_common_templates/topmenu_notlogged.stpl', 'fa06a5615600582c22cc5f57ee59ba94');
        $this->checkFile('themes/affiliates/_common_templates/topurl_list.tpl', 'd0880f68969dcf6e1ce2473ae194290e');
        $this->checkFile('themes/affiliates/_common_templates/traffic_stats_gadget.tpl', '0a2882140e9f850399b2a0c198b9ad98');
        $this->checkFile('themes/affiliates/_common_templates/traffic_stats_in_gadget.tpl', 'ae38670c7e593de4a995af34968842b1');
        $this->checkFile('themes/affiliates/_common_templates/transaction_list.tpl', '9f8821c8d652ef009065e292a4cbbbac');
        $this->checkFile('themes/affiliates/_common_templates/transaction_list_filter_base.tpl', '02ffef5018217239456ca193bedfbcf0');
        $this->checkFile('themes/affiliates/_common_templates/tree_affiliate_widget.tpl', '0f7a52f0b26bda649f60e2a994645e98');
        $this->checkFile('themes/affiliates/_common_templates/trend_actions_stats.tpl', '790735d304a6cb007b73b383ad981082');
        $this->checkFile('themes/affiliates/_common_templates/trend_actions_stats_widget.tpl', '7c26676ceb09baf3fafeb0dba3bdaec4');
        $this->checkFile('themes/affiliates/_common_templates/trend_stats.tpl', '095f81f317cc90564bd9572029ef486d');
        $this->checkFile('themes/affiliates/_common_templates/trends_report.stpl', 'ba65f3bdca37cda45b5df967858ef3d4');
        $this->checkFile('themes/affiliates/_common_templates/trends_report.tpl', 'b5c594ddd23b421f4d94699a123b7c89');
        $this->checkFile('themes/affiliates/_common_templates/trends_report_action.stpl', '186621ded1143468396cd4d874651027');
        $this->checkFile('themes/affiliates/_common_templates/trends_report_filter.tpl', 'ef2191d61ae61bd1ed152c9e369203b1');
        $this->checkFile('themes/affiliates/_common_templates/trends_report_no_data.tpl', '1df74a6e3299c9176ac8047b05fd26dd');
        $this->checkFile('themes/affiliates/_common_templates/validity.tpl', '4fef1c7acf4a13df9d45c45a5c4d9568');
        $this->checkFile('themes/affiliates/blue_aero/README.txt', 'c5e378c3027a6b4f00637e35fa00d549');
        $this->checkFile('themes/affiliates/blue_aero/custom.css', '4877ef2467745239a93ebe1e79b2f813');
        $this->checkFile('themes/affiliates/blue_aero/footer.stpl', '3fbd103789f1ff2a151c16f490a913dd');
        $this->checkFile('themes/affiliates/blue_aero/header.stpl', '20f4ec9408ecccabb04bd70c8a858c92');
        $this->checkFile('themes/affiliates/blue_aero/home.tpl', '352ad4cf45752885f62baa0780013e29');
        $this->checkFile('themes/affiliates/blue_aero/img/gadgetin.b.png', 'f06e13c0620d89fc464cf0223df9d349');
        $this->checkFile('themes/affiliates/blue_aero/img/gadgetin.back.png', '23e4e12e286d074c423d1b387bf8902f');
        $this->checkFile('themes/affiliates/blue_aero/img/gadgetin.bl.png', '07c07e8c743573064ee8eeca1c799a34');
        $this->checkFile('themes/affiliates/blue_aero/img/gadgetin.br.png', '4148944211041cf9bf7807ac222e7082');
        $this->checkFile('themes/affiliates/blue_aero/img/gadgetin.l.png', '48659819a474cc38eaf46ae58be0ada0');
        $this->checkFile('themes/affiliates/blue_aero/img/gadgetin.r.png', '48659819a474cc38eaf46ae58be0ada0');
        $this->checkFile('themes/affiliates/blue_aero/img/gadgetin.t.png', 'f06e13c0620d89fc464cf0223df9d349');
        $this->checkFile('themes/affiliates/blue_aero/img/gadgetin.tl.png', '045b6145e46d3ad85a7a4aa34013b64f');
        $this->checkFile('themes/affiliates/blue_aero/img/gadgetin.tr.png', '6737317d906258d61f9f9c80fc04b3e9');
        $this->checkFile('themes/affiliates/blue_aero/img/pap4.logo.jpg', '401e48f00975e0f33b54c27e19864fba');
        $this->checkFile('themes/affiliates/blue_aero/img/theme_thumbnail.jpg', 'dd8f23908534c823fbd79bdc417c5f1d');
        $this->checkFile('themes/affiliates/blue_aero/login_form.tpl', '70f1bfa47deb59c11961cf534733fd58');
        $this->checkFile('themes/affiliates/blue_aero/login_main.tpl', 'dcd6d69a2cf67b2b8abb6eebcfc81261');
        $this->checkFile('themes/affiliates/blue_aero/pap4.css', '033ef647bd25da62272a480c356288c5');
        $this->checkFile('themes/affiliates/blue_aero/theme.php', 'a840cd180377c88237d0b59d86fb2e5d');
        $this->checkFile('themes/affiliates/classic_wide/README.txt', 'c5e378c3027a6b4f00637e35fa00d549');
        $this->checkFile('themes/affiliates/classic_wide/custom.css', '4877ef2467745239a93ebe1e79b2f813');
        $this->checkFile('themes/affiliates/classic_wide/home.tpl', 'fb22d17a0319351f7ea36083793ec754');
        $this->checkFile('themes/affiliates/classic_wide/img/content.bottom.gif', '752b9cf627b4c7dbccc857d5a691d4b9');
        $this->checkFile('themes/affiliates/classic_wide/img/content.bottom.left.gif', 'f050f014c1de2756f669817b104181b0');
        $this->checkFile('themes/affiliates/classic_wide/img/content.bottom.right.gif', 'f7196a6f7f8e41930f25cb60103297e4');
        $this->checkFile('themes/affiliates/classic_wide/img/content.left.gif', 'd8538d3756f8c6027414a583858618a8');
        $this->checkFile('themes/affiliates/classic_wide/img/content.right.gif', '97177491028c3422434d64a29fce343b');
        $this->checkFile('themes/affiliates/classic_wide/img/content.top.gif', '1206ee1251333832e10a09d0dd84c3f8');
        $this->checkFile('themes/affiliates/classic_wide/img/content.top.left.gif', '8a397076700e439a1c8f24aa9e1c1760');
        $this->checkFile('themes/affiliates/classic_wide/img/content.top.right.gif', '13947f410657fe4b089d663c9b9922a2');
        $this->checkFile('themes/affiliates/classic_wide/img/left.column-rtl.gif', 'b5fc073d676545e3b6407ea59cb5c94b');
        $this->checkFile('themes/affiliates/classic_wide/img/left.column.gif', '1ea7ba64fdb58c3b6b90ef45427db330');
        $this->checkFile('themes/affiliates/classic_wide/img/menu.divider-rtl.gif', '1b2bc17e8857716a7cdf75dfc3dae977');
        $this->checkFile('themes/affiliates/classic_wide/img/menu.divider.gif', '041bb37bea32338b1c0a9d031c9d4a68');
        $this->checkFile('themes/affiliates/classic_wide/img/menu.entry-over-rtl.gif', 'e1459b50df8553106bdb23ef80078b0a');
        $this->checkFile('themes/affiliates/classic_wide/img/menu.entry-over.gif', 'da0c7a49ad258dbb35e190602a70b628');
        $this->checkFile('themes/affiliates/classic_wide/img/menu.entry.back-over-rtl.gif', 'f9b4443d2c43c02fdd1ce4ce1d961dfd');
        $this->checkFile('themes/affiliates/classic_wide/img/menu.entry.back-over.gif', '80eee6c80b01a1a97026ad89f4285af4');
        $this->checkFile('themes/affiliates/classic_wide/img/menu.entry.bottom-over-rtl.gif', '6535e027928a92528ee27cdff2a82e05');
        $this->checkFile('themes/affiliates/classic_wide/img/menu.entry.bottom-over.gif', '32819c898e14b221264804785147b5d0');
        $this->checkFile('themes/affiliates/classic_wide/img/menu.entry.top-over-rtl.gif', '1c3a6a486d590df3d89f0338acb76fed');
        $this->checkFile('themes/affiliates/classic_wide/img/menu.entry.top-over.gif', 'ca840699467392d1da2eb8d6e173dff6');
        $this->checkFile('themes/affiliates/classic_wide/img/submenu-rtl.gif', '8e96bfd8f3a175b6a81d4eb2291db331');
        $this->checkFile('themes/affiliates/classic_wide/img/submenu.entry-over.gif', '7296aeb880fb7a28f64ebc4fdbd9c1b0');
        $this->checkFile('themes/affiliates/classic_wide/img/submenu.entry-rtl.gif', '40bf261a700bb616fc5bdf40409ff740');
        $this->checkFile('themes/affiliates/classic_wide/img/submenu.entry.back-over-rtl.gif', '5a52ace4443cec172f1524ae39dd602d');
        $this->checkFile('themes/affiliates/classic_wide/img/submenu.entry.back-over.gif', '9ebfeff8b4172af9c299920a3ac78d65');
        $this->checkFile('themes/affiliates/classic_wide/img/submenu.entry.bottom-over-rtl.gif', '225a12172a7b4c111c32b657dde915da');
        $this->checkFile('themes/affiliates/classic_wide/img/submenu.entry.bottom-over.gif', '22622c2c689e004e658f1c47e112d6b1');
        $this->checkFile('themes/affiliates/classic_wide/img/submenu.entry.gif', '2e00d05fbf25527e21ef327e42aaf05c');
        $this->checkFile('themes/affiliates/classic_wide/img/submenu.entry.top-over-rtl.gif', '217f2d6b380191c057e5cdbe8ca4aedd');
        $this->checkFile('themes/affiliates/classic_wide/img/submenu.entry.top-over.gif', 'c4313a7313ac6f6ce0208b70db0c99ff');
        $this->checkFile('themes/affiliates/classic_wide/img/theme_thumbnail.jpg', '910b9181e1a23db4c074582d071bd4e4');
        $this->checkFile('themes/affiliates/classic_wide/login_form.tpl', 'fb9d17de38b511dd6a24eb3647427fd0');
        $this->checkFile('themes/affiliates/classic_wide/main.tpl', 'd9053f8ec6f5561285b433e06aadc02c');
        $this->checkFile('themes/affiliates/classic_wide/menu_entry.tpl', '7607d6b22315cc526abad1fd026c74f5');
        $this->checkFile('themes/affiliates/classic_wide/menu_section.tpl', 'da446dbc5a24b9881bd8417ce0371bb5');
        $this->checkFile('themes/affiliates/classic_wide/pap4.css', '8adebe56342138a170ae0c50bc160cf3');
        $this->checkFile('themes/affiliates/classic_wide/set_new_password_form.tpl', '8e7fd161e9e90b7abcdd0b51da4aed92');
        $this->checkFile('themes/affiliates/classic_wide/stats_chart.tpl', 'd744777d1a408bd49c777fc66b2995f7');
        $this->checkFile('themes/affiliates/classic_wide/theme.php', '75803d4b02dc140c7eaa1fb6e0bd50db');
        $this->checkFile('themes/affiliates/wide/README.txt', 'c5e378c3027a6b4f00637e35fa00d549');
        $this->checkFile('themes/affiliates/wide/advanced_screen.tpl', '5250a182b0e7d0bbd9ca981237da89bc');
        $this->checkFile('themes/affiliates/wide/breadcrumbs.tpl', 'e685a6dcc5c7cc448d9b2da94bbe35de');
        $this->checkFile('themes/affiliates/wide/custom.css', '4877ef2467745239a93ebe1e79b2f813');
        $this->checkFile('themes/affiliates/wide/footer.stpl', '08c8fe2e266537c515f8e3dd6cb50a66');
        $this->checkFile('themes/affiliates/wide/header.stpl', 'a4c7b4cba31c3b321677fba88685d74f');
        $this->checkFile('themes/affiliates/wide/home.tpl', 'fb22d17a0319351f7ea36083793ec754');
        $this->checkFile('themes/affiliates/wide/img/background.jpg', '063df928c03eab0aeac39097089183ca');
        $this->checkFile('themes/affiliates/wide/img/footer.background.jpg', '8935eb5b49d1a182d493692d48dace7c');
        $this->checkFile('themes/affiliates/wide/img/iconbox.background.jpg', '03137987594c0248e8ab2ae152a6e324');
        $this->checkFile('themes/affiliates/wide/img/logo_pap.jpg', 'cd14b7752b98bf01c9723d525a3f8e4b');
        $this->checkFile('themes/affiliates/wide/img/main.background.jpg', 'f1c0f812a7d89571d5137285b771015f');
        $this->checkFile('themes/affiliates/wide/img/menu.background.jpg', 'ce86291a742fcb3bed04288c09dc108e');
        $this->checkFile('themes/affiliates/wide/img/menu.background.open.jpg', '346cd8ad284ec82d758a2467f10513ed');
        $this->checkFile('themes/affiliates/wide/img/menu.background.over.jpg', 'b90162657902cf061175ee102226a8a0');
        $this->checkFile('themes/affiliates/wide/img/quick.menu.back.jpg', '5efd062969442507a2e7f21c89800f7d');
        $this->checkFile('themes/affiliates/wide/img/quick.menu.left.jpg', '86ab400c6a9f866a3906c2d5e97b538a');
        $this->checkFile('themes/affiliates/wide/img/quick.menu.right.jpg', '977638e15682f68bfccc40505b9a202c');
        $this->checkFile('themes/affiliates/wide/img/submenu.background.jpg', '6880542ce155b54b1823cb5624c8cec5');
        $this->checkFile('themes/affiliates/wide/img/theme_thumbnail.jpg', 'a043dcd4ad6af0b563bb8fc430e42188');
        $this->checkFile('themes/affiliates/wide/login_form.tpl', '9f53ef8f62ce25926cb48e5c400bbe91');
        $this->checkFile('themes/affiliates/wide/login_main.tpl', '382e0595693c883b5fabe18d530fd694');
        $this->checkFile('themes/affiliates/wide/main.tpl', '022bf74b3eede6d34c391f22ec996a0d');
        $this->checkFile('themes/affiliates/wide/main_menu.tpl', 'e3475ad0f955dfc4479db866ff718eda');
        $this->checkFile('themes/affiliates/wide/menu_section.tpl', 'cf42c95e8f89d461f44528b8c2136e68');
        $this->checkFile('themes/affiliates/wide/myprofile.tpl', 'd40463456df7407a7d43c477eeb96618');
        $this->checkFile('themes/affiliates/wide/pap4.css', 'be9b8fad3fb9bc9a5eaf54a859d02cb5');
        $this->checkFile('themes/affiliates/wide/personal_details.tpl', 'bbc27c4bd55202d04255821e10da5283');
        $this->checkFile('themes/affiliates/wide/set_new_password_form.tpl', '58bf3e73d3a6b46460fb05216df1d0a8');
        $this->checkFile('themes/affiliates/wide/stats_chart.tpl', 'd744777d1a408bd49c777fc66b2995f7');
        $this->checkFile('themes/affiliates/wide/system_menu.tpl', 'c4825611dfce0c9c765616c816320c02');
        $this->checkFile('themes/affiliates/wide/theme.php', '9772f5ba91b364b816a75439c9d8a197');
        $this->checkFile('themes/affiliates/wide/theme_settings.tpl', '9df4358da743a43f9feea1cca8b23801');
        $this->checkFile('themes/affiliates/wide/topmenu_logged.stpl', '0978c87d58ab2c05885e045c892b539b');
        $this->checkFile('themes/affiliates/wide/topmenu_notlogged.stpl', '1d4d61b06781c185b3218e181f84bedf');
        $this->checkFile('themes/install/_common_templates/accounts_wrong_permission.stpl', '97a1bdfeb9e50279b13320733f0de93e');
        $this->checkFile('themes/install/_common_templates/img/affiliate-manager.gif', '553d2079dbcc1b2baf63fc28e309cbf3');
        $this->checkFile('themes/install/_common_templates/img/checkbox.png', '789997c2a072aee3026cb81f4dc183d9');
        $this->checkFile('themes/install/_common_templates/img/checked.gif', 'f3216326c00890259e84f1726dd1043f');
        $this->checkFile('themes/install/_common_templates/img/divider.png', '9c04ac8b0e24b7815be8feda5e810d14');
        $this->checkFile('themes/install/_common_templates/img/expand.png', '2ae38766ee108c250e2d961d5c75fc62');
        $this->checkFile('themes/install/_common_templates/img/failed.png', 'b6a268fab3d9f1cc551c693ee6839830');
        $this->checkFile('themes/install/_common_templates/img/favicon.ico', 'e15128807c80c86ddc36d69e0712d019');
        $this->checkFile('themes/install/_common_templates/img/favicon.png', 'b7b49aa6d5f1611aa416c3623d057db8');
        $this->checkFile('themes/install/_common_templates/img/icon.step.create.account.png', 'e2977eb62eba3c7ab78c82bc953b77cc');
        $this->checkFile('themes/install/_common_templates/img/icon.step.create.database.png', 'c4ee1ec7ab7449ece19f92a2c448cd78');
        $this->checkFile('themes/install/_common_templates/img/icon.step.finished.png', 'eceb7ccd8882265e1b6399027d9a00ab');
        $this->checkFile('themes/install/_common_templates/img/icon.step.integrity.check.png', 'ad77071d26277108741750ce3c29e4ba');
        $this->checkFile('themes/install/_common_templates/img/icon.step.license.png', '13070580d8628086425779486ee5d2b3');
        $this->checkFile('themes/install/_common_templates/img/icon.step.package.png', '8c1f5d3896805c7c6fcd3c8b3d039397');
        $this->checkFile('themes/install/_common_templates/img/icon.step.package.update.png', '8c1f5d3896805c7c6fcd3c8b3d039397');
        $this->checkFile('themes/install/_common_templates/img/icon.step.select-language.png', '5ac66265ea9a39086c8f5fc23b789cdc');
        $this->checkFile('themes/install/_common_templates/img/icon.step.select-timezone.png', '5ac66265ea9a39086c8f5fc23b789cdc');
        $this->checkFile('themes/install/_common_templates/img/icon.step.update.files.png', '75537abfd10d37a00b1a358875759f95');
        $this->checkFile('themes/install/_common_templates/img/icon.step.update.version.png', 'fab4df6a2b8e9071992376891ed26c37');
        $this->checkFile('themes/install/_common_templates/img/loading.gif', '546d9515580e0c8e3d0813c2e04ed9aa');
        $this->checkFile('themes/install/_common_templates/img/logo_pan.jpg', 'e11b89662d01ad51927067143efe6298');
        $this->checkFile('themes/install/_common_templates/img/logo_pan.png', '97ebd132ae8ec2dd08bbef552d03a0fd');
        $this->checkFile('themes/install/_common_templates/img/logo_pap.gif', '1ab1785b74d4268672ef9b00ea236792');
        $this->checkFile('themes/install/_common_templates/img/logo_pap.jpg', 'ca04ee94087ed09c0d7424df82e509b0');
        $this->checkFile('themes/install/_common_templates/img/logo_pap.png', '011698765bb35b0ae0dd13f8f16955d5');
        $this->checkFile('themes/install/_common_templates/img/ok.png', 'db2216509429c061ec5143b8b2d3c198');
        $this->checkFile('themes/install/_common_templates/img/sample_flash_banner.swf', '7dc6805cef2f2bf891deca0e88e430d1');
        $this->checkFile('themes/install/_common_templates/img/sample_html_banner_image.gif', '73af3f44598cce660b73cdd605c0eace');
        $this->checkFile('themes/install/_common_templates/img/sample_image_banner.jpg', '57339dd4fea5b3a2db7d96c7b2065f44');
        $this->checkFile('themes/install/_common_templates/img/unchecked.gif', 'ae536c37391ba78143b5c8283cec8d13');
        $this->checkFile('themes/install/_common_templates/installer_accept_license.tpl', 'e518a10a1948f38d5f1d7e8fc91d3184');
        $this->checkFile('themes/install/_common_templates/installer_check_requirements.stpl', '0e41612d916e1ef59741b2a57c7fe464');
        $this->checkFile('themes/install/_common_templates/installer_create_account.tpl', '5baf59673c4a7f13e3f9be55b8112bbe');
        $this->checkFile('themes/install/_common_templates/installer_create_database.tpl', 'b265b67218ccdf658774524ee2664d5e');
        $this->checkFile('themes/install/_common_templates/installer_finished.tpl', 'ccd47981e758737b5a623fe2645afd14');
        $this->checkFile('themes/install/_common_templates/installer_footer.stpl', '3609adc22434412ffffe4048e5194efa');
        $this->checkFile('themes/install/_common_templates/installer_header.stpl', 'f92f4031b0c1e14bc7dd5201115c40ab');
        $this->checkFile('themes/install/_common_templates/installer_integrity_check.tpl', '86e8ea54141b03157374e98b06202d96');
        $this->checkFile('themes/install/_common_templates/installer_internal_error.tpl', '711d21468e189f78767cbb7c73d8676c');
        $this->checkFile('themes/install/_common_templates/installer_main.tpl', '057e051754a2442cb63a6ab348f22678');
        $this->checkFile('themes/install/_common_templates/installer_recommended_settings.stpl', '6e0a23d42a745afdf801c55bb6bd18e9');
        $this->checkFile('themes/install/_common_templates/installer_revalidate_license.tpl', '38bc9de12225cbafa98d060691c006f1');
        $this->checkFile('themes/install/_common_templates/installer_select_language.tpl', 'e358747942e847a1341a83a82a725aa3');
        $this->checkFile('themes/install/_common_templates/installer_select_timezone.tpl', '3fe1a823b191350311d62fb166fd1898');
        $this->checkFile('themes/install/_common_templates/installer_step.tpl', '13fc8b1453352f54e7c0df4eea30ef5e');
        $this->checkFile('themes/install/_common_templates/installer_update_files.tpl', 'e6c981c9a0ee10603b04be521baa51dd');
        $this->checkFile('themes/install/_common_templates/installer_welcome.stpl', '6405d17cad6f67cab625ca9be32737b8');
        $this->checkFile('themes/install/_common_templates/mail/account_declined_merchant.stpl', '3f976fd57893134bf4c4b00dc15ac74a');
        $this->checkFile('themes/install/_common_templates/mail/account_new_account_signup_approved.stpl', '32d83b3b578f1c456a543187220b00b5');
        $this->checkFile('themes/install/_common_templates/mail/account_new_account_signup_before_approval.stpl', '77bd73e8d37ccf4da25ca6fab058371c');
        $this->checkFile('themes/install/_common_templates/mail/account_prepaid_low_credit_merchant.stpl', '46fc44f96710124549a2061cf2cbb3ed');
        $this->checkFile('themes/install/_common_templates/mail/account_suspended_merchant.stpl', 'e8e921f959312e2e65d8299c5f5a1c64');
        $this->checkFile('themes/install/_common_templates/mail/aff_daily_report.stpl', '3c5b344aa79ed40fde87a9c37b77a65e');
        $this->checkFile('themes/install/_common_templates/mail/aff_monthly_report.stpl', 'c64623413e4fc9487b8214da571d331c');
        $this->checkFile('themes/install/_common_templates/mail/aff_weekly_report.stpl', '2546b3e99f86119b6b16a29cafd956c5');
        $this->checkFile('themes/install/_common_templates/mail/affiliate_direct_link_notification.stpl', '6974fd1012e0ac2b08caa958de1c43ff');
        $this->checkFile('themes/install/_common_templates/mail/affiliate_invoice.stpl', 'b66cb1679015341dbe7d4e1ec0776abf');
        $this->checkFile('themes/install/_common_templates/mail/affiliate_on_campaign_status_changed.stpl', '83dee5d50b51e7366b87658fa671a735');
        $this->checkFile('themes/install/_common_templates/mail/affiliate_on_change_commission_group.stpl', '62ce6c789a879decf1b4219c7a2b628e');
        $this->checkFile('themes/install/_common_templates/mail/affiliate_on_change_commission_status.stpl', '2e99e6115d1ab168d3a8423a366afd62');
        $this->checkFile('themes/install/_common_templates/mail/affiliate_on_commission_refund_chargeback.stpl', 'c76e14df59b01f68f3e19c29e7ab56e2');
        $this->checkFile('themes/install/_common_templates/mail/affiliate_on_inactivity.stpl', 'ed6f895fd9a7b594b2a97aa8f79a7936');
        $this->checkFile('themes/install/_common_templates/mail/affiliate_on_inactivity_warning.stpl', 'eb51bb66890afb5ef5081717fa995fce');
        $this->checkFile('themes/install/_common_templates/mail/affiliate_on_new_action_commission.stpl', '3b505de02def2d1a953b9629794d2c28');
        $this->checkFile('themes/install/_common_templates/mail/affiliate_on_new_extra_bonus_commission.stpl', '478c1f4050594a094018f579c75a9895');
        $this->checkFile('themes/install/_common_templates/mail/affiliate_on_new_manual_bonus.stpl', 'cbabf432f020e877c5a54d00b04641af');
        $this->checkFile('themes/install/_common_templates/mail/affiliate_on_new_sale.stpl', 'dcaefbeb9d4292c537090603c1db5f83');
        $this->checkFile('themes/install/_common_templates/mail/autoregisteringaffiliates_affiliate_on_first_sale.stpl', '3262b7f6d6448fb961ccc72bc1e8013d');
        $this->checkFile('themes/install/_common_templates/mail/campaign_suspended_affiliate.stpl', '255afc8d26c109d147726731a976df9d');
        $this->checkFile('themes/install/_common_templates/mail/daily_report.stpl', '6f495c98cac5b44f7d4e06bf6065f0c8');
        $this->checkFile('themes/install/_common_templates/mail/invite_to_campaign.stpl', '55567384baa0d463b43bb42e9cae5578');
        $this->checkFile('themes/install/_common_templates/mail/invoice_paid.stpl', 'decf73938e143649837cff459ba4d86b');
        $this->checkFile('themes/install/_common_templates/mail/merchant_contact_us.stpl', '71228c24da8a7b7db51bcd669c54b15f');
        $this->checkFile('themes/install/_common_templates/mail/merchant_invoice.stpl', 'b66cb1679015341dbe7d4e1ec0776abf');
        $this->checkFile('themes/install/_common_templates/mail/merchant_new_account_signup.stpl', '77c15138b36cd07e972fbdfa0d13eb35');
        $this->checkFile('themes/install/_common_templates/mail/merchant_new_direct_link_notification.stpl', '0cf29fbfdd5772c0e33351c5b603692f');
        $this->checkFile('themes/install/_common_templates/mail/merchant_new_user_signup.stpl', '102af73570968d6ba526a8f2ce3121f2');
        $this->checkFile('themes/install/_common_templates/mail/merchant_on_action_commission.stpl', '12dab8704296a6cacce5a6f7f7ae8a9f');
        $this->checkFile('themes/install/_common_templates/mail/merchant_on_affiliate_stopped.stpl', 'e22e022ee338038b0cd3aa61ef86402e');
        $this->checkFile('themes/install/_common_templates/mail/merchant_on_commission_approved.stpl', '406cbeb8e7d1ce20c3b6067efb7fcb5f');
        $this->checkFile('themes/install/_common_templates/mail/merchant_on_extra_bonus.stpl', 'aecdf21aa47dea1a666d647ba2cbe8b2');
        $this->checkFile('themes/install/_common_templates/mail/merchant_on_new_unconfirmed_banner.stpl', '5d4037e4309cc4f8b1a97a46c4c56283');
        $this->checkFile('themes/install/_common_templates/mail/merchant_on_sale.stpl', 'c7e63a98d81b715ed4d0da3decd831d1');
        $this->checkFile('themes/install/_common_templates/mail/merchant_on_sale_approved.stpl', '3c4e0d90477a844912359d97a03d2af5');
        $this->checkFile('themes/install/_common_templates/mail/merchant_on_site_stopped.stpl', 'a2c694fa3146e3601d8c2cc4e6f98c08');
        $this->checkFile('themes/install/_common_templates/mail/merchant_on_username_changed.stpl', '33897052075ae3053c991171c1a71283');
        $this->checkFile('themes/install/_common_templates/mail/merchant_payment_request.stpl', 'b55e5cc67dfdc2457442fbaf8ac5dfe1');
        $this->checkFile('themes/install/_common_templates/mail/merchant_signup_contact_us.stpl', '8f69cf69bcaa507e61b3b27a806978fe');
        $this->checkFile('themes/install/_common_templates/mail/monthly_report.stpl', '8d83b6cbc7d8e1f89de4d8a9a121a512');
        $this->checkFile('themes/install/_common_templates/mail/new_user_signup_approved.stpl', 'a5745939bc67df8a7eff9a99908ffb0b');
        $this->checkFile('themes/install/_common_templates/mail/new_user_signup_before_approval.stpl', '615ceabcfe666f7139c7f1f32ac718c2');
        $this->checkFile('themes/install/_common_templates/mail/new_user_signup_declined.stpl', '66ab5007320052224130c18cb1c0929d');
        $this->checkFile('themes/install/_common_templates/mail/on_affiliate_join_to_campaign.stpl', '78c69ab826278c42ead7cdfbe2024c95');
        $this->checkFile('themes/install/_common_templates/mail/on_merchant_approve_affiliate_to_campaign.stpl', '7adece7868968a8957122b374ead5436');
        $this->checkFile('themes/install/_common_templates/mail/on_merchant_decline_affiliate_to_campaign.stpl', '86320da73624b2989254f8212655caf7');
        $this->checkFile('themes/install/_common_templates/mail/on_payout.stpl', 'd76926aeada042cd2c0ffb26dcf32927');
        $this->checkFile('themes/install/_common_templates/mail/on_subaffiliate_action_commission.stpl', '5fc3fa6320236397d774077b52e12042');
        $this->checkFile('themes/install/_common_templates/mail/on_subaffiliate_sale.stpl', '95bda067e1e28e370560366fb19d8766');
        $this->checkFile('themes/install/_common_templates/mail/on_subaffiliate_signup.stpl', '3dbec10b5c410182bf228dd59014ed72');
        $this->checkFile('themes/install/_common_templates/mail/on_vat_payout.stpl', '180611ee38326be3302ff74410f397a8');
        $this->checkFile('themes/install/_common_templates/mail/pay_day_reminder.stpl', '87e3f8fc4da7bae7cb9aa51963a86b8b');
        $this->checkFile('themes/install/_common_templates/mail/remove_from_campaign.stpl', '065ec9b8807b991ea9ff9494843f0627');
        $this->checkFile('themes/install/_common_templates/mail/request_payment.stpl', '5d2de97692bdf0cfaf5986b5fb1865eb');
        $this->checkFile('themes/install/_common_templates/mail/splitcommissions_merchant_on_sale.stpl', '51372ea8849c3691f6ae42629c63d842');
        $this->checkFile('themes/install/_common_templates/mail/subscription_cancelled.stpl', '179fcbc3b91b42bf53a62f03a98faa7f');
        $this->checkFile('themes/install/_common_templates/mail/subscription_cancelled_merchant.stpl', '07b3e5808b40860a4f45ad310ac3396f');
        $this->checkFile('themes/install/_common_templates/mail/subscription_created.stpl', '16fda51c3bde15d1d5b12f6dbf60b5d8');
        $this->checkFile('themes/install/_common_templates/mail/subscription_created_merchant.stpl', '790f2ea57780e5de43300f05ca9cffc7');
        $this->checkFile('themes/install/_common_templates/mail/subscription_renewed.stpl', 'c75566be50ee39038e24557e7eeea1d3');
        $this->checkFile('themes/install/_common_templates/mail/subscription_renewed_merchant.stpl', '0c8a39b1738f29f15badf4bc119a5f4b');
        $this->checkFile('themes/install/_common_templates/mail/weekly_report.stpl', '6a0b199ea24c55b16cf86b67d07cf919');
        $this->checkFile('themes/install/_common_templates/offline_validation.tpl', 'cb7a7418d3a4854c816414ea9b3aaaca');
        $this->checkFile('themes/install/_common_templates/pap4.css', '38bf66ae7db777816101236ed6f571e4');
        $this->checkFile('themes/install/_common_templates/update_check_requirements.stpl', 'c6adcf5451a492242443e62931b39311');
        $this->checkFile('themes/install/classic/README.txt', 'c5e378c3027a6b4f00637e35fa00d549');
        $this->checkFile('themes/install/classic/theme.php', '35d9fe6949185985e5382dda6b601401');
        $this->checkFile('themes/install/classic_old/README.txt', 'c5e378c3027a6b4f00637e35fa00d549');
        $this->checkFile('themes/install/classic_old/img/affiliate-manager.gif', '553d2079dbcc1b2baf63fc28e309cbf3');
        $this->checkFile('themes/install/classic_old/img/checked.gif', 'f3216326c00890259e84f1726dd1043f');
        $this->checkFile('themes/install/classic_old/img/content_bottom.gif', '752b9cf627b4c7dbccc857d5a691d4b9');
        $this->checkFile('themes/install/classic_old/img/content_bottom_left.gif', 'f050f014c1de2756f669817b104181b0');
        $this->checkFile('themes/install/classic_old/img/content_bottom_right.gif', 'f7196a6f7f8e41930f25cb60103297e4');
        $this->checkFile('themes/install/classic_old/img/content_left.gif', 'd8538d3756f8c6027414a583858618a8');
        $this->checkFile('themes/install/classic_old/img/content_right.gif', '97177491028c3422434d64a29fce343b');
        $this->checkFile('themes/install/classic_old/img/content_top.gif', '1206ee1251333832e10a09d0dd84c3f8');
        $this->checkFile('themes/install/classic_old/img/content_top_left.gif', '8a397076700e439a1c8f24aa9e1c1760');
        $this->checkFile('themes/install/classic_old/img/content_top_right.gif', '13947f410657fe4b089d663c9b9922a2');
        $this->checkFile('themes/install/classic_old/img/failed.png', 'b6a268fab3d9f1cc551c693ee6839830');
        $this->checkFile('themes/install/classic_old/img/favicon.ico', 'e15128807c80c86ddc36d69e0712d019');
        $this->checkFile('themes/install/classic_old/img/favicon.png', 'b7b49aa6d5f1611aa416c3623d057db8');
        $this->checkFile('themes/install/classic_old/img/icon.step.create.account.png', '8a2a0dc00b99b353dfd27e9cbc59e9bd');
        $this->checkFile('themes/install/classic_old/img/icon.step.create.database.png', '3b625dad35285da8b25319ec9651f4cf');
        $this->checkFile('themes/install/classic_old/img/icon.step.finished.png', '784463185eeef1ea0ff5c8bfedabc190');
        $this->checkFile('themes/install/classic_old/img/icon.step.integrity.check.png', 'ad77071d26277108741750ce3c29e4ba');
        $this->checkFile('themes/install/classic_old/img/icon.step.license.png', '3072ec6653940ca96049b6a83ab1d183');
        $this->checkFile('themes/install/classic_old/img/icon.step.package.png', '72aed669235aa0c47d7e8a3dc894c8ca');
        $this->checkFile('themes/install/classic_old/img/icon.step.package.update.png', '3e303185d8d414425bbf40bcdbc430a2');
        $this->checkFile('themes/install/classic_old/img/icon.step.select-language.png', '0a6d001304a9470d92e408e86b237e04');
        $this->checkFile('themes/install/classic_old/img/icon.step.update.files.png', '75537abfd10d37a00b1a358875759f95');
        $this->checkFile('themes/install/classic_old/img/icon.step.update.version.png', '7d2ac4903f8b63ee0b7a343796110e46');
        $this->checkFile('themes/install/classic_old/img/logo_pap.gif', '1ab1785b74d4268672ef9b00ea236792');
        $this->checkFile('themes/install/classic_old/img/logo_pap.jpg', 'ca04ee94087ed09c0d7424df82e509b0');
        $this->checkFile('themes/install/classic_old/img/logo_pap.png', '011698765bb35b0ae0dd13f8f16955d5');
        $this->checkFile('themes/install/classic_old/img/ok.png', 'db2216509429c061ec5143b8b2d3c198');
        $this->checkFile('themes/install/classic_old/img/sample_flash_banner.swf', '7dc6805cef2f2bf891deca0e88e430d1');
        $this->checkFile('themes/install/classic_old/img/sample_html_banner_image.gif', '73af3f44598cce660b73cdd605c0eace');
        $this->checkFile('themes/install/classic_old/img/sample_image_banner.gif', '57339dd4fea5b3a2db7d96c7b2065f44');
        $this->checkFile('themes/install/classic_old/img/unchecked.gif', 'ae536c37391ba78143b5c8283cec8d13');
        $this->checkFile('themes/install/classic_old/pap4.css', '9da114d2cab1e497bad066706a4ab67f');
        $this->checkFile('themes/install/classic_old/theme.php', '46cce8f829defa67d828efda9033048a');
        $this->checkFile('themes/merchants/Bootstrap/TreeItemWidget.tpl', 'd1bfa5574da9cfa131eef997e0870e92');
        $this->checkFile('themes/merchants/Bootstrap/account_form.tpl', 'bec2cc19f2320dfebd3e493c97eeae52');
        $this->checkFile('themes/merchants/Bootstrap/account_form_show.tpl', '481066cec1fdf42f68f2db4c2fabca35');
        $this->checkFile('themes/merchants/Bootstrap/account_form_view.tpl', '3c3a69f103776f35bf195a27db899cb9');
        $this->checkFile('themes/merchants/Bootstrap/account_fraud_protection_clicks.tpl', '559a9b6630eb145dbdc5fa575a97ecb0');
        $this->checkFile('themes/merchants/Bootstrap/account_fraud_protection_sales.tpl', '1eabaf9f7df78e8502403383c9393ad9');
        $this->checkFile('themes/merchants/Bootstrap/account_info_data.tpl', '48e5394b52c65f2174b235bcd7ec792c');
        $this->checkFile('themes/merchants/Bootstrap/account_notifications_form.tpl', '1fb8f96e9b5c02448da103459cdf6aa7');
        $this->checkFile('themes/merchants/Bootstrap/account_private_campaign_settings.tpl', '940f4bcdbf2de9045887c436f31300ab');
        $this->checkFile('themes/merchants/Bootstrap/account_screen.tpl', '738e8b0997ff8592a4524b3f6c6c4ad6');
        $this->checkFile('themes/merchants/Bootstrap/account_settings.tpl', 'bef40a405c258ac960ea1370e7d02de7');
        $this->checkFile('themes/merchants/Bootstrap/account_signup_settings_form.tpl', '68d7a20fdb3a245a8444d5ea27924b4c');
        $this->checkFile('themes/merchants/Bootstrap/accounting_filter.tpl', '0943670f8ba31ff555e7dc4e5915fdf3');
        $this->checkFile('themes/merchants/Bootstrap/accounting_gadget_data.tpl', 'd94f4bee085512317d28081b9f1d5c26');
        $this->checkFile('themes/merchants/Bootstrap/accounting_gadget_template.tpl', '99927018924623a51361c651857aa116');
        $this->checkFile('themes/merchants/Bootstrap/accounting_panel.tpl', 'a95d5eee70654bd6c562e736f4a9f0c5');
        $this->checkFile('themes/merchants/Bootstrap/accounting_stats_data.tpl', '1470a597ddd286d583fbe27231af4eed');
        $this->checkFile('themes/merchants/Bootstrap/accounts_fields.tpl', '1d3c5c66916b50467c03d8602aa291c5');
        $this->checkFile('themes/merchants/Bootstrap/accounts_filter.tpl', 'dd123439f945f76b09422ad55b2bd4cb');
        $this->checkFile('themes/merchants/Bootstrap/accounts_invoices_panel.tpl', 'e62d96763f78f49afcb568b7de9933ad');
        $this->checkFile('themes/merchants/Bootstrap/accounts_panel.tpl', '77b8fd37eb4f0427cf2b3a6f757e30d8');
        $this->checkFile('themes/merchants/Bootstrap/add_affiliate_page.tpl', 'e69a0888131f7a941dc7e7c744f5dd11');
        $this->checkFile('themes/merchants/Bootstrap/add_affiliate_page_content.tpl', '0f11dbecb7f2f1eea6ab769eb625e322');
        $this->checkFile('themes/merchants/Bootstrap/add_affiliate_page_page.tpl', '70a1f240785c415fb99947f94972de26');
        $this->checkFile('themes/merchants/Bootstrap/add_affiliate_page_url.tpl', '58f8f5e302e28d28522e7265e3694665');
        $this->checkFile('themes/merchants/Bootstrap/add_affiliate_to_campaign.tpl', 'ddb8f68a2edb3955a5a209e11442b1bf');
        $this->checkFile('themes/merchants/Bootstrap/add_affiliate_to_group.tpl', '4f69927d7cad9e8466fe91bd3e3af69c');
        $this->checkFile('themes/merchants/Bootstrap/add_custom_translation.tpl', '91a22a74346db521569588e934048e79');
        $this->checkFile('themes/merchants/Bootstrap/add_gadget_category.tpl', 'e2ec9306de4bf074a33e72c96ff238ca');
        $this->checkFile('themes/merchants/Bootstrap/add_gadget_panel.tpl', 'be8c80e8aff49f52f5b5c1b79be9526f');
        $this->checkFile('themes/merchants/Bootstrap/add_gadget_select_url.tpl', 'b9e3459257a1d9c8a6c66009c826d06c');
        $this->checkFile('themes/merchants/Bootstrap/add_transaction_form.tpl', '6c9da9a05ee604bb7ad0cc4225c07e88');
        $this->checkFile('themes/merchants/Bootstrap/add_user_to_group_form.tpl', 'f5353d26cbc32f5b59f99d0388244462');
        $this->checkFile('themes/merchants/Bootstrap/additional_dynamic_form_panel.tpl', '39fe1aad3bb309004ee15c8537c90d15');
        $this->checkFile('themes/merchants/Bootstrap/admin_panel.tpl', '974dc9641d622a6723650da268bebf5f');
        $this->checkFile('themes/merchants/Bootstrap/admins_panel.tpl', '043af9e3cecec2e85866aa06c2a04a37');
        $this->checkFile('themes/merchants/Bootstrap/admins_panel_filter.tpl', '4ec418856a865586f6d6ed313e0cffb6');
        $this->checkFile('themes/merchants/Bootstrap/advanced_email_settings_form.tpl', '304064505236c0bb68e3a8f4bc3b1c08');
        $this->checkFile('themes/merchants/Bootstrap/advanced_email_settings_tab.tpl', '4cdac3ab7ec6827e1307d48028f2d835');
        $this->checkFile('themes/merchants/Bootstrap/advanced_integration_steps_icons.tpl', 'fc1f4fb9ee86fc80e6ef1e365e0d77f5');
        $this->checkFile('themes/merchants/Bootstrap/aff_notifications_form.tpl', '10c7955484538d42dd52ccfcef274408');
        $this->checkFile('themes/merchants/Bootstrap/affilate_advanced_filter.tpl', '11bde2dcecd82caeeb4616944f36ff5b');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_commission_groups.tpl', '9d4046dbc63fe4b678f8c62ffca79854');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_delete.tpl', '2157c7c0e31996f4fc0f85a185977ac5');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_details.tpl', 'bd86d96ae0a6f75ea0547ca235cabde6');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_edit_commission_groups_no_data.tpl', 'a9756aeb0730e4fd5f4fa9cb6de8012b');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_edit_details.tpl', 'b911b7098ffb6e1511b33e3f35d6f9b2');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_edit_details_additional.tpl', '98de15bb9a88b36dc47ba266389cb413');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_edit_dialog.tpl', 'acaf92b10f7821b0f5794593db70df01');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_edit_no_payout_history.tpl', '0d40b1e330f67d9e74c3890beca74b29');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_fields.tpl', 'c54826ec0f80194f7381304b20b5e95e');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_general_settings.tpl', 'e747d64338280436d5f3478d1f0cb514');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_info_data.tpl', 'b57513f9b5504095638e810826ac3e63');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_list.tpl', 'cc032a88a7775b2938522ca3f58dc755');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_list_no_data.tpl', '7741570acae759090cf04aeb6f313bb2');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_logins.tpl', '9f5432cc0f1f1bb464a38a23fb16e6e3');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_logins_header.tpl', '7fc020dd9a1268955faaf16b973b82c7');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_logins_map.tpl', '76fe92abae4eacb0bfbd670ac54aa0b3');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_menu_settings.tpl', '3507cb91be549e264e21b007c3571ba8');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_panel_config.tpl', '99bc43fef7dbe936c4e733215585a277');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_payout_settings.tpl', '8304e34183caa27262c69cec69c12373');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_postsignup_settings.tpl', '295c4b2802684750cc74e93282fb5732');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_screen_detail.tpl', '1075539ad2bdd3dd1eeb74078b054f03');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_screen_header_edit.tpl', 'cb37af28ddbd0c61c9abadf675e7d8bc');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_screen_settings.tpl', '5fb92d5bc22ff7ede5ec1572ef94ced9');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_screen_settings_nodata.tpl', 'bb4ad3e2d922192ec998ee5ae5c51e50');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_screens_list.tpl', '08ad8cbadce365f01978ef5f8b0c7d32');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_signup_settings.tpl', 'c9a8f99f2c61ead6d8bdb0d125e0f183');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_signup_settings_button.tpl', 'adccd555745134a857328990ed086077');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_signup_settings_form.tpl', 'eb832a062e7059bb5074dbeec7f2f890');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_stats.tpl', 'b1c8b06e198d9ed22a5564a73ff26e0e');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_subaffiliates.tpl', '633205fc5244112afa932c8b18f58edd');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_tracking_code_filter.tpl', '614c11facd7d5ebaee38deae93e139c9');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_tracking_code_panel.tpl', '2563d59c5d920af9e929d25715e3758e');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_tracking_cookiepanel.tpl', 'afe8791a0c4895979c261a672103de97');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_tracking_options.tpl', '85a3391abee5f9a8dc727fe266534ed8');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_tracking_testlinks.tpl', '3407045ee29fe67b40621cdb381ff40e');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_tree.tpl', '875e8e5d865578c1b5efe31580b9e719');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_tree_filter.tpl', 'c676ed3f6a9ee3860ad9e60e62dbab86');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_tree_filter_edit.tpl', '959100eeceade475bc20ec5272660a38');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_tree_panel.tpl', '9ddd4e10bea7ad43a028f867760df9d6');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_url_page_editor.tpl', '1563cbaaa42ab9c7c0c8898a17b3b10a');
        $this->checkFile('themes/merchants/Bootstrap/affiliate_urls_no_data.tpl', 'c9868414093445accf0f0d7551847116');
        $this->checkFile('themes/merchants/Bootstrap/affiliates_group.tpl', 'e1f5bcb91bd2f949694890186ff3566a');
        $this->checkFile('themes/merchants/Bootstrap/affiliates_group_filter.tpl', '466c832f6c6b327cbee63030a81d410c');
        $this->checkFile('themes/merchants/Bootstrap/affiliates_import.tpl', '5d25493eca047e7b66627090a7bcf423');
        $this->checkFile('themes/merchants/Bootstrap/affpanel_design.tpl', '47558761ee69c8a906f6b3f3c0b7fe1e');
        $this->checkFile('themes/merchants/Bootstrap/after_signup_actions_fields_no_data.tpl', '2fe9a7bbd29402632be238ea0cb7f2dd');
        $this->checkFile('themes/merchants/Bootstrap/after_signup_actions_no_data.tpl', 'c9868414093445accf0f0d7551847116');
        $this->checkFile('themes/merchants/Bootstrap/after_signup_no_data.tpl', 'acc4136ac3d8c01816ce79b2281ca9f1');
        $this->checkFile('themes/merchants/Bootstrap/align_widget.tpl', '124769dbcc410ae58c1dfd53f15b58d6');
        $this->checkFile('themes/merchants/Bootstrap/api_integration.tpl', '87329cb5ed35f3bfbb29e45947ae8bab');
        $this->checkFile('themes/merchants/Bootstrap/assigment.tpl', '48b84b37bf127adc78ef230b61a22e60');
        $this->checkFile('themes/merchants/Bootstrap/assign_auto_panel.tpl', '4414ff53bc35c96dd1932aa630eb128f');
        $this->checkFile('themes/merchants/Bootstrap/audit_log_filter.tpl', '67c7322e9a203c85a10210cb496b110e');
        $this->checkFile('themes/merchants/Bootstrap/available_values_edit.tpl', 'e96fa729b9a61e7e4a21fbddf80565fb');
        $this->checkFile('themes/merchants/Bootstrap/banner_and_link_form_panel.tpl', '5c7a5c4a303dffe6d76424abd90a0236');
        $this->checkFile('themes/merchants/Bootstrap/banner_button.tpl', 'e1cb4d807552c33476c9dc37bca24dc6');
        $this->checkFile('themes/merchants/Bootstrap/banner_category_edit.tpl', '2fc9f159a4666a456e4de83356cf2511');
        $this->checkFile('themes/merchants/Bootstrap/banner_category_item.tpl', '55fcd96a4eabd7825f722f3f36bab5d4');
        $this->checkFile('themes/merchants/Bootstrap/banner_category_selector.tpl', 'ba32ee51a99861b1a19d9b66e45f4db0');
        $this->checkFile('themes/merchants/Bootstrap/banner_category_settings_panel.tpl', 'fa002655c612fad61b7cd5121e786391');
        $this->checkFile('themes/merchants/Bootstrap/banner_clone_dialog.tpl', '87df8d4453785b4924425c45fc252f20');
        $this->checkFile('themes/merchants/Bootstrap/banner_destination_url_panel.tpl', 'd2cf85ec3a941d8acc4f8c673c3c2781');
        $this->checkFile('themes/merchants/Bootstrap/banner_destinations.tpl', 'c2466e9211af205aaa302153ecf54ec0');
        $this->checkFile('themes/merchants/Bootstrap/banner_details.tpl', '02ec398758e8c9d094be8ddd3dea86e9');
        $this->checkFile('themes/merchants/Bootstrap/banner_details_params.tpl', 'daca6d0de978ff1a272adbe072455399');
        $this->checkFile('themes/merchants/Bootstrap/banner_edit_header.tpl', '8be5daca610e30e2fc600a9c8a03cf56');
        $this->checkFile('themes/merchants/Bootstrap/banner_edit_panel.tpl', 'd371721abec7a70439373826893749c8');
        $this->checkFile('themes/merchants/Bootstrap/banner_filter.tpl', 'c329bee9165d04cc757e990a92c1b019');
        $this->checkFile('themes/merchants/Bootstrap/banner_format_form.tpl', '5f8fd9d50c3f4817158302d1834f7e26');
        $this->checkFile('themes/merchants/Bootstrap/banner_in_rotator_edit_panel.tpl', '331b8b61058b5f85750cc690e63d08cc');
        $this->checkFile('themes/merchants/Bootstrap/banner_list_no_data.tpl', '6ec4d243cc9d9b0ee86612709590882e');
        $this->checkFile('themes/merchants/Bootstrap/banner_manager.tpl', '18d6d96df57962f8d1a9b8effe339b15');
        $this->checkFile('themes/merchants/Bootstrap/banner_name.tpl', '0e8385998fddbc3260837cf0590a35a5');
        $this->checkFile('themes/merchants/Bootstrap/banner_or_link_edit_template_panel.tpl', '346160178349fe7d0b8f4f55bbf96ecd');
        $this->checkFile('themes/merchants/Bootstrap/banner_or_link_not_selected.tpl', '180941a437e8e722a4b7f7b44e73e0f0');
        $this->checkFile('themes/merchants/Bootstrap/banner_own_size_panel.tpl', 'ec916344f7150972a863c771ccb676df');
        $this->checkFile('themes/merchants/Bootstrap/banner_parameters_coupon.tpl', 'd7c6fc6e00c9e11d262f7c767454b9c7');
        $this->checkFile('themes/merchants/Bootstrap/banner_parameters_flash.tpl', 'a6356eb54289b4b062c0250c5e9b7963');
        $this->checkFile('themes/merchants/Bootstrap/banner_parameters_hover.tpl', 'f15317ed6c2ed30c9a2e897dbaaa79a6');
        $this->checkFile('themes/merchants/Bootstrap/banner_parameters_html.tpl', 'f00f7657b51377b05cca05db4a27b4bf');
        $this->checkFile('themes/merchants/Bootstrap/banner_parameters_image.tpl', 'f4227e6ffab89f9fecf00de0db1ea261');
        $this->checkFile('themes/merchants/Bootstrap/banner_parameters_pagepeel.tpl', 'f0477017e173b2a6d887e3eabe77ccc8');
        $this->checkFile('themes/merchants/Bootstrap/banner_parameters_pagepeelhtml.tpl', 'c4722a470e19f5966ee208dfd75b72cd');
        $this->checkFile('themes/merchants/Bootstrap/banner_parameters_pdf.tpl', 'b02138b4e56eb4d1b40be08282348643');
        $this->checkFile('themes/merchants/Bootstrap/banner_parameters_promo_email.tpl', '5d558a2ce40bd6997c670115425bc67b');
        $this->checkFile('themes/merchants/Bootstrap/banner_parameters_rebrandpdf.tpl', '11451d812f2b92bf7928f77a448252ba');
        $this->checkFile('themes/merchants/Bootstrap/banner_parameters_rebrandpdf_allvars.tpl', 'c01f39df6d7b58ed19794de908c314b2');
        $this->checkFile('themes/merchants/Bootstrap/banner_parameters_rebrandpdf_filefield.tpl', '4f3e422e757c8bd5c3460a24dd453153');
        $this->checkFile('themes/merchants/Bootstrap/banner_parameters_rotator.tpl', 'be18e74db4df618a8452b053fed379b6');
        $this->checkFile('themes/merchants/Bootstrap/banner_parameters_site.tpl', '80b74b4c7419b3fd362fcffb1ebe0639');
        $this->checkFile('themes/merchants/Bootstrap/banner_parameters_site_files.tpl', 'ef8d201e428e0a06cba243bbfeb4d0be');
        $this->checkFile('themes/merchants/Bootstrap/banner_parameters_site_files_local.tpl', 'a7f630aa7eb54c3cb467cb80f17674cc');
        $this->checkFile('themes/merchants/Bootstrap/banner_parameters_site_files_url.tpl', '9e1571660d6fab85245ee3418abd1350');
        $this->checkFile('themes/merchants/Bootstrap/banner_parameters_site_preview.tpl', '7dcf0d92d184a60ff334ad28adb1fd66');
        $this->checkFile('themes/merchants/Bootstrap/banner_parameters_site_variables.tpl', 'adb74a84e21883cd904c0732316c0bce');
        $this->checkFile('themes/merchants/Bootstrap/banner_parameters_zip.tpl', '262a21aedc240fc1e154b3274cf38cf5');
        $this->checkFile('themes/merchants/Bootstrap/banner_parameters_zip_bannerpreview.tpl', '919258983eb853742ec1aabd2505f388');
        $this->checkFile('themes/merchants/Bootstrap/banner_parameters_zip_files.tpl', '0d3f2c5edba5f03f8fb35dcbaeeebae2');
        $this->checkFile('themes/merchants/Bootstrap/banner_parameters_zip_variables.tpl', 'bea861fe51d3a9e95f9ae5e5cf9c4e81');
        $this->checkFile('themes/merchants/Bootstrap/banner_params_link.tpl', '16e7b10d24dd70483e8c67184d3ec46f');
        $this->checkFile('themes/merchants/Bootstrap/banner_params_text_link.tpl', '36887496682c2c2872c526ca6acba1fd');
        $this->checkFile('themes/merchants/Bootstrap/banner_preview.tpl', '75b30e1735f8ec02072cb2aa83a06047');
        $this->checkFile('themes/merchants/Bootstrap/banner_preview_field.tpl', '71e5ce8dff03853ca9e30de9dfe5006c');
        $this->checkFile('themes/merchants/Bootstrap/banner_preview_widget.tpl', 'f21248876762eecce70f4f6a6d64cad1');
        $this->checkFile('themes/merchants/Bootstrap/banner_rotator_feature_on_deactivate.tpl', 'a1bfe671194574c6d8b231e70bbd0f08');
        $this->checkFile('themes/merchants/Bootstrap/banner_size.tpl', 'e74a26d2165d73dc5a842acd7f481c97');
        $this->checkFile('themes/merchants/Bootstrap/banner_stats_filter.tpl', '99385b61d4e01703bc055a1a910564a1');
        $this->checkFile('themes/merchants/Bootstrap/banner_stats_list.tpl', '3e71f3763376f08380959fe865aad875');
        $this->checkFile('themes/merchants/Bootstrap/banner_stats_list_no_data.tpl', '2bac0448c515370fac072b46a74938ec');
        $this->checkFile('themes/merchants/Bootstrap/banner_with_category_filter_field.tpl', 'dd1d3439d1f76c0deda21232287fbdd2');
        $this->checkFile('themes/merchants/Bootstrap/banner_wrapper_edit_panel.tpl', 'e13d8f01e20f4fa82847845bfac1026b');
        $this->checkFile('themes/merchants/Bootstrap/banner_wrappers_table.tpl', '54f784f44c21afa6941daecd6088cd4a');
        $this->checkFile('themes/merchants/Bootstrap/banners_and_links_format.tpl', 'a298ada6f4a07b79050cb51d23ac099f');
        $this->checkFile('themes/merchants/Bootstrap/banners_categories_list.tpl', '4b6c1997242f90357b1c721a4303d816');
        $this->checkFile('themes/merchants/Bootstrap/banners_categories_tree.tpl', 'fc55213c31030c3a47d4b80338c88783');
        $this->checkFile('themes/merchants/Bootstrap/bannerscategories_no_data.tpl', '3df35d8c385cfc14c75759c80f11aa02');
        $this->checkFile('themes/merchants/Bootstrap/bannerscategories_not_in_category.tpl', 'b4797977dcf354a6a7c77745910e839a');
        $this->checkFile('themes/merchants/Bootstrap/branding_config.tpl', 'bd94806a4df51742d143a23dec8f2cdb');
        $this->checkFile('themes/merchants/Bootstrap/breadcrumbs.tpl', '9981a5d8af1fb510574d67a2e0ba2481');
        $this->checkFile('themes/merchants/Bootstrap/breadcrumbs_entry.tpl', '42ee9a25b7525589ed65bf9625adc890');
        $this->checkFile('themes/merchants/Bootstrap/button.tpl', '40db744b463f7f71d97cd92ff46fecf4');
        $this->checkFile('themes/merchants/Bootstrap/buy_feature.tpl', 'adfbf6783ae850e63499a923231e4f37');
        $this->checkFile('themes/merchants/Bootstrap/calendar.tpl', 'd6831aa786acf1f829a90cec776126eb');
        $this->checkFile('themes/merchants/Bootstrap/campaign_account.tpl', '9e2989cc05bb9dac952b80a40246e4e2');
        $this->checkFile('themes/merchants/Bootstrap/campaign_capping.tpl', 'b9f6737a4b04f0eca0d7957191b51231');
        $this->checkFile('themes/merchants/Bootstrap/campaign_category_edit.tpl', 'd1460a8d0cb69f821b18051a81907550');
        $this->checkFile('themes/merchants/Bootstrap/campaign_category_item.tpl', 'de7ade79ce37b86264373c01e9ad4149');
        $this->checkFile('themes/merchants/Bootstrap/campaign_category_selector.tpl', '4618de8975b4a1f2b94d168304707892');
        $this->checkFile('themes/merchants/Bootstrap/campaign_category_settings_panel.tpl', '18e7ac241cca0c4c360bcf45e7d2ef71');
        $this->checkFile('themes/merchants/Bootstrap/campaign_commissions_tab.tpl', '52c31b8ce3af03ce54ae51917ff87b7a');
        $this->checkFile('themes/merchants/Bootstrap/campaign_filter.tpl', '7f3514d50b873ca8f3e464ad67139a31');
        $this->checkFile('themes/merchants/Bootstrap/campaign_form_edit.tpl', 'ebbce6c2aba4d73403d2d9dc5a4967c1');
        $this->checkFile('themes/merchants/Bootstrap/campaign_form_show.tpl', '9bd49430f9655da593402eb6d221a59d');
        $this->checkFile('themes/merchants/Bootstrap/campaign_list_no_data.tpl', 'd44d658e6b3fb7b4b2f6e0e3bbe938c7');
        $this->checkFile('themes/merchants/Bootstrap/campaign_rule_conditions_panel.tpl', 'd4f35ff94140ca1eb7a5e28dbfd22d0c');
        $this->checkFile('themes/merchants/Bootstrap/campaign_rule_conditions_panel_full.tpl', '46ac5265ab6c374aaae2b3c13d4a7734');
        $this->checkFile('themes/merchants/Bootstrap/campaign_schedule_nodata.tpl', '3e87dc9b305506f1f13895478de1ee2e');
        $this->checkFile('themes/merchants/Bootstrap/campaign_scheduler.tpl', '20870e8e684fb12348a0ade8874d66c8');
        $this->checkFile('themes/merchants/Bootstrap/campaign_scheduling_rule_panel.tpl', 'b0403d7927d7e01cb056da9027b82a8b');
        $this->checkFile('themes/merchants/Bootstrap/campaign_screen.tpl', '48d3e63714873d79a6092b2aa0417dd9');
        $this->checkFile('themes/merchants/Bootstrap/campaign_screen_edit.tpl', '4dd40cd4020a39e251a16d01ffa65723');
        $this->checkFile('themes/merchants/Bootstrap/campaign_shortdetails_form.tpl', '99bd3a0b3e5790f2307e9b897dcd6811');
        $this->checkFile('themes/merchants/Bootstrap/campaign_stats_filter.tpl', '656adb646eecec0d3f5091cfce68095d');
        $this->checkFile('themes/merchants/Bootstrap/campaign_stats_list.tpl', 'e45c163f75670253d0dcc5037f7168e2');
        $this->checkFile('themes/merchants/Bootstrap/campaign_stats_list_no_data.tpl', '6991606b8141a584b01311f5eb86bb51');
        $this->checkFile('themes/merchants/Bootstrap/campaign_status.tpl', 'b732873daaced1e1e9aa43cb2f4c09fa');
        $this->checkFile('themes/merchants/Bootstrap/campaign_step_create.tpl', '2d419b7525bdd89abdec8c0d31d1f71d');
        $this->checkFile('themes/merchants/Bootstrap/campaign_type.tpl', '831bfbcebd1f2ccb1040cfdaa2291011');
        $this->checkFile('themes/merchants/Bootstrap/campaign_validity_edit.tpl', '22198581b13ee3fbd1e3729236df3189');
        $this->checkFile('themes/merchants/Bootstrap/campaign_with_category_filter_field.tpl', 'baf1267e1481cb1cf5433a0ccaf80ee8');
        $this->checkFile('themes/merchants/Bootstrap/campaign_wizard.tpl', 'e6f7ad6b18e7c273490cea2a19a19654');
        $this->checkFile('themes/merchants/Bootstrap/campaigns_categories_list.tpl', '8169d41f1880ba87724c80ce89553605');
        $this->checkFile('themes/merchants/Bootstrap/campaigns_categories_tree.tpl', '2d96c71a0f30a75176ae42f055de8ad0');
        $this->checkFile('themes/merchants/Bootstrap/campaigns_grid_settings_affiliate_panel.tpl', '6830692ae10fdc0b2083cc58268baa4c');
        $this->checkFile('themes/merchants/Bootstrap/campaigns_list.tpl', '983019d6bd514bd1a348f8ad840b8c7a');
        $this->checkFile('themes/merchants/Bootstrap/campaignscategories_no_data.tpl', '7d8325a745599a8d918ac08217275012');
        $this->checkFile('themes/merchants/Bootstrap/campaignscategories_not_in_category.tpl', '0dd23250bcee882b765ec32ad21249af');
        $this->checkFile('themes/merchants/Bootstrap/captcha.tpl', '0326fedb283400e2c13eeae155d7b536');
        $this->checkFile('themes/merchants/Bootstrap/category_list.tpl', '579457d7da6e88deda06b092844c5c52');
        $this->checkFile('themes/merchants/Bootstrap/change_status_button.tpl', 'a0d13402819088b5078e8100a21a0159');
        $this->checkFile('themes/merchants/Bootstrap/chart_datatype_popup.tpl', '54103c7a9bcc7c757c8011ae17aa8585');
        $this->checkFile('themes/merchants/Bootstrap/check_box_group.tpl', 'e182dd7429a276dc85e09049b2a6c19e');
        $this->checkFile('themes/merchants/Bootstrap/check_box_group_row.tpl', '97219c5c2d3c996953fd6bd882e6200c');
        $this->checkFile('themes/merchants/Bootstrap/checkboxes_filter.tpl', 'fef5c1833920987bd3172dbe9d75797a');
        $this->checkFile('themes/merchants/Bootstrap/clicks_list.tpl', 'bd1179311cf04f759ddcc79744179a93');
        $this->checkFile('themes/merchants/Bootstrap/clicks_list_filter_base.tpl', '6b6ac3cc08d8a1d3a9d3e6e1e473a962');
        $this->checkFile('themes/merchants/Bootstrap/clicks_list_no_data.tpl', 'e2f13b9b96a4f0a248ea753b0c7c9178');
        $this->checkFile('themes/merchants/Bootstrap/clicks_tracking.tpl', 'a017892f84d373c678ecdc5276f9e6c3');
        $this->checkFile('themes/merchants/Bootstrap/colorpicker.tpl', '297c4e74e89b8b3dedd12e7c319bce41');
        $this->checkFile('themes/merchants/Bootstrap/commission_edit_values.tpl', 'b277423c214667a9202d3aefac1d7619');
        $this->checkFile('themes/merchants/Bootstrap/commission_edit_values_tierpanel.tpl', 'ed403054ea7f2ccb731265f9d3f0ef4f');
        $this->checkFile('themes/merchants/Bootstrap/commission_edit_with_fixedcost.tpl', '3af76ab79f10ff3d0629b1c4b0cc7ba9');
        $this->checkFile('themes/merchants/Bootstrap/commission_group_panel.tpl', 'fbc95c3f3b9a95e9daf3df46d8dc8a2d');
        $this->checkFile('themes/merchants/Bootstrap/commission_groups.tpl', 'cd9f803bcafdc842b0226fa653242f1b');
        $this->checkFile('themes/merchants/Bootstrap/commission_groups_panel.tpl', '44d889bc8bf1f467cbc7d2c18c03c230');
        $this->checkFile('themes/merchants/Bootstrap/commission_recurring.tpl', 'aa827abeee6bb0f472b500c096cd3625');
        $this->checkFile('themes/merchants/Bootstrap/commission_sale.tpl', 'fbdf7f44f6df291e9da9e8172dcad9ce');
        $this->checkFile('themes/merchants/Bootstrap/commission_subsales.tpl', 'c21fc8858085c294ac7630f53d6bd36e');
        $this->checkFile('themes/merchants/Bootstrap/commission_tabs.tpl', '2eec354045cec652c7cd4ff1cfc8bf56');
        $this->checkFile('themes/merchants/Bootstrap/commission_tiers_info_panel.tpl', '20e88ef5e3d641ecd6dd8fea0350b7e1');
        $this->checkFile('themes/merchants/Bootstrap/commission_type_detail.tpl', 'd6d266aba20845c41e04fd8dbfa33732');
        $this->checkFile('themes/merchants/Bootstrap/commission_type_sail_detail.tpl', '73a00350b64b30cb1b5341e050982d83');
        $this->checkFile('themes/merchants/Bootstrap/commissions_details_view.tpl', '6481e92bb25a139b55290e0d5b209cdd');
        $this->checkFile('themes/merchants/Bootstrap/commissions_edit.tpl', '9ec2a9da2c0eaf09392f96b836bc0310');
        $this->checkFile('themes/merchants/Bootstrap/commissions_panel.tpl', 'ff232af7da984c8e346b2bc9b8a6ca88');
        $this->checkFile('themes/merchants/Bootstrap/compressed_commission_settings.tpl', 'b355949c5d9849b51c1f59f96c7e4acc');
        $this->checkFile('themes/merchants/Bootstrap/comunication_overview_panel.tpl', '06ea7c53421b51e4a8fed669637a909f');
        $this->checkFile('themes/merchants/Bootstrap/config_aff_panel.tpl', '58c2a6eae06023e889cee734923b713e');
        $this->checkFile('themes/merchants/Bootstrap/config_affiliates.tpl', '4870980191d1873460bbc2d8894b2bf2');
        $this->checkFile('themes/merchants/Bootstrap/config_communication.tpl', 'b7af569e05800de423c52fc28d7bc40b');
        $this->checkFile('themes/merchants/Bootstrap/config_currencies_form.tpl', 'cdff097c17040c60be3ace45afa62642');
        $this->checkFile('themes/merchants/Bootstrap/config_currency_tab.tpl', '57c84054dcf9ca885c39c1d9bddb860c');
        $this->checkFile('themes/merchants/Bootstrap/config_date_format.tpl', '771f72b6514cd4c9103217a955fb171d');
        $this->checkFile('themes/merchants/Bootstrap/config_language_and_date_form.tpl', '1ad6231d44243a014dd06b3a18709fac');
        $this->checkFile('themes/merchants/Bootstrap/config_overview.tpl', '60db4f006e3afe01077620baf9bc19fa');
        $this->checkFile('themes/merchants/Bootstrap/config_signup_form.tpl', '884261ef7e0c23326874bd92cdda1094');
        $this->checkFile('themes/merchants/Bootstrap/config_system.tpl', '783ebbddb4a39f395967456062db2396');
        $this->checkFile('themes/merchants/Bootstrap/config_theme_panel.tpl', 'ae440349c66b55c5da3d341f2e620729');
        $this->checkFile('themes/merchants/Bootstrap/config_themes.tpl', '0bab46cdedf333176ecb62c8cdc1d672');
        $this->checkFile('themes/merchants/Bootstrap/config_tracking.tpl', '81056b36d3ec69a8fac9d843ed7d7240');
        $this->checkFile('themes/merchants/Bootstrap/confirm_dialog.tpl', 'f92a8f6b3081444abf7fc4ab63c99302');
        $this->checkFile('themes/merchants/Bootstrap/confirm_dialog_label_note.tpl', 'f76c3c08642335eb7b3e0ce42bfe753a');
        $this->checkFile('themes/merchants/Bootstrap/confirm_dialog_label_value.tpl', '0c2d427e2c1c8f4545a90a3a56e64580');
        $this->checkFile('themes/merchants/Bootstrap/confirm_dialog_with_checkbox.tpl', '9e1fd32194d6bfabb251bad0645755da');
        $this->checkFile('themes/merchants/Bootstrap/confirm_dialog_with_value.tpl', '46e7630a0a094110f6819ea655683337');
        $this->checkFile('themes/merchants/Bootstrap/content_gadget_panel.tpl', '79428f6a77f38592dfa1716653bbe79b');
        $this->checkFile('themes/merchants/Bootstrap/context_menu.tpl', 'cddf235a2fec1ae75063d576ccdc6185');
        $this->checkFile('themes/merchants/Bootstrap/cookie_lifetime_group.tpl', 'ea8a6a5ad128f265d7d6891a41fdf097');
        $this->checkFile('themes/merchants/Bootstrap/cookies_tab.tpl', '0ee8a325e03187328807a5c149eb90be');
        $this->checkFile('themes/merchants/Bootstrap/copy_campaign.tpl', 'a12f62962eb0cb273f54414f688f091a');
        $this->checkFile('themes/merchants/Bootstrap/copy_user_role.tpl', '31c4493a09a1d2ad96e0c6133399199c');
        $this->checkFile('themes/merchants/Bootstrap/countries_list_scrolling_wrapper.tpl', '4bf0a92924334c72075b4ddafd3b243b');
        $this->checkFile('themes/merchants/Bootstrap/country_commission_type_panel.tpl', '13728b6a4d83a9d3ca751ea1050e6c2d');
        $this->checkFile('themes/merchants/Bootstrap/country_select_panel.tpl', '8503f8f693cc44082380626a7b0ebbfc');
        $this->checkFile('themes/merchants/Bootstrap/country_specific_commission_type_panel.tpl', 'db0122ec2a13ac87a9443a6dc4594302');
        $this->checkFile('themes/merchants/Bootstrap/coupons_filter.tpl', '4caab93e4b46d2f0fff1d619536efb8b');
        $this->checkFile('themes/merchants/Bootstrap/coupons_import.tpl', 'e9bb34e160a258ff1deb1dfe55f0e4a5');
        $this->checkFile('themes/merchants/Bootstrap/coupons_panel.tpl', 'dcb054cd9abe5cbea02724014d27c7ef');
        $this->checkFile('themes/merchants/Bootstrap/create_banners_buttons.tpl', 'd981b97a16d7f5620a85944aa8d550f7');
        $this->checkFile('themes/merchants/Bootstrap/cron_job_integration.tpl', '0bd75d5d32d1d775a4c81a7cc1a41cdb');
        $this->checkFile('themes/merchants/Bootstrap/currencies_no_data.tpl', 'e3a2a92b3119abe6bca9ce0b0e505c28');
        $this->checkFile('themes/merchants/Bootstrap/currency_form.tpl', 'dbee13da7abe05b10990f7ee89eee4be');
        $this->checkFile('themes/merchants/Bootstrap/currency_textbox.tpl', 'b25a0b754d14d14452ecb52e0a090d2a');
        $this->checkFile('themes/merchants/Bootstrap/custom.css', '4877ef2467745239a93ebe1e79b2f813');
        $this->checkFile('themes/merchants/Bootstrap/custom_cookie_panel.tpl', 'b1b3a9b5c5aa2b7de8e67fa2975bbf0e');
        $this->checkFile('themes/merchants/Bootstrap/custom_date_panel.tpl', 'c624f3d63d0e94db867529dc13a827d1');
        $this->checkFile('themes/merchants/Bootstrap/custom_filter_element.tpl', 'bf05e5d299fb1982ea8139f2a605846b');
        $this->checkFile('themes/merchants/Bootstrap/custom_filter_field.tpl', '21c8ab135d5d89e320ec85456ec457e0');
        $this->checkFile('themes/merchants/Bootstrap/custom_time_panel.tpl', 'd408a8352774d70124788d61a90493b6');
        $this->checkFile('themes/merchants/Bootstrap/daily_report.tpl', 'ae280bf29c298b0a0e28944cc61c9e86');
        $this->checkFile('themes/merchants/Bootstrap/daily_report_filter.tpl', '4fb9b31f01026eb252955d75c0428d99');
        $this->checkFile('themes/merchants/Bootstrap/data_field.tpl', 'dd553594505158cd53cc285d3a91fe23');
        $this->checkFile('themes/merchants/Bootstrap/data_field_with_help.tpl', '4615cdd789beea34c16b4c1f692a3a3b');
        $this->checkFile('themes/merchants/Bootstrap/database_status_panel.tpl', '57191b13eff4abf914143e15b97bac30');
        $this->checkFile('themes/merchants/Bootstrap/date_number_format_panel.tpl', 'e26284328d2ba7da47d30e8e458c13b1');
        $this->checkFile('themes/merchants/Bootstrap/date_preset_panel.tpl', 'abc7d225baa948aed70cc1073b786fe8');
        $this->checkFile('themes/merchants/Bootstrap/date_range_filter.tpl', '3875dbc075f33ccaac856190ee103557');
        $this->checkFile('themes/merchants/Bootstrap/date_range_filter_field.tpl', '94048704212b6797b7b7a08fb7888da9');
        $this->checkFile('themes/merchants/Bootstrap/date_textbox.tpl', '4d2bf89bd754bbaccc15e48d7a37dd02');
        $this->checkFile('themes/merchants/Bootstrap/daterange_popup.tpl', 'da31a5a22326107f9d053252837d701c');
        $this->checkFile('themes/merchants/Bootstrap/datetimepickercontent.tpl', '9771684f29bc88d974cc64283055d1d1');
        $this->checkFile('themes/merchants/Bootstrap/deeplink_generator_network_setting_edit.tpl', '818d1c4a3bb685f4cb6e825a2c577d82');
        $this->checkFile('themes/merchants/Bootstrap/default_campaign_form.tpl', '2524ebdb94130b6701af650fb63c9c68');
        $this->checkFile('themes/merchants/Bootstrap/default_theme_config.tpl', 'fd3377e1da30c75e82ed6db948bc9199');
        $this->checkFile('themes/merchants/Bootstrap/description_panel.tpl', 'eb196bc81ac670a6081876c8d17158c0');
        $this->checkFile('themes/merchants/Bootstrap/design_panel.tpl', 'ee823fb6ea6bc06ff8ab43422a986363');
        $this->checkFile('themes/merchants/Bootstrap/desktop.tpl', 'b653025800e416896bd453246061a535');
        $this->checkFile('themes/merchants/Bootstrap/desktop_gadget.tpl', '21394ff13337e4716860c12b5e4fb312');
        $this->checkFile('themes/merchants/Bootstrap/desktop_main_menu.tpl', '31eb02f3f6b767d24012753d50ff5159');
        $this->checkFile('themes/merchants/Bootstrap/desktop_settings_mode.tpl', '1054d3be606383580f8d521f2d72682f');
        $this->checkFile('themes/merchants/Bootstrap/destination.tpl', '3f11435e707dc3ef178328280ef4614e');
        $this->checkFile('themes/merchants/Bootstrap/destination_panel.tpl', 'f8a860741ffc1e8bdd52437db021caaf');
        $this->checkFile('themes/merchants/Bootstrap/direct_link_form.tpl', '3db93d545868ad72723a137a4ed2fba5');
        $this->checkFile('themes/merchants/Bootstrap/direct_link_grid_widget.tpl', '586c3b902d66c903d87e510bca5843ec');
        $this->checkFile('themes/merchants/Bootstrap/directlinks_advanced_filter.tpl', '65c2e2150b56faacebc94ec4eb426935');
        $this->checkFile('themes/merchants/Bootstrap/directlinks_list.tpl', '3047fe6b8e221bb3e186190f6eeeeb3f');
        $this->checkFile('themes/merchants/Bootstrap/directlinks_list_no_data.tpl', 'f1f450f7a011578950f7253089286a34');
        $this->checkFile('themes/merchants/Bootstrap/disclosure_content.tpl', '27557135898f8d0dc1ff849cba4f875a');
        $this->checkFile('themes/merchants/Bootstrap/download_auto_reg_banner_form.tpl', '8ef3e7205380f487fa84bc4eaf5f5c63');
        $this->checkFile('themes/merchants/Bootstrap/download_auto_reg_iframe_form.tpl', '59498b35efce960fd3b4871d26d7855b');
        $this->checkFile('themes/merchants/Bootstrap/download_auto_reg_link_form.tpl', '33484bae042f1bde3a5a163eab5570f0');
        $this->checkFile('themes/merchants/Bootstrap/download_login_form.tpl', 'd73ed70f4d96b76f37965d9f8c753ac5');
        $this->checkFile('themes/merchants/Bootstrap/download_signup_form.tpl', 'e608aa9b32b4b044d528815cb9392516');
        $this->checkFile('themes/merchants/Bootstrap/drag_container.tpl', '358104feb6f9c3c2a01206e460726eac');
        $this->checkFile('themes/merchants/Bootstrap/dynamic_form_panel.tpl', 'ea42da62b4a44f1fa9caf50a59c29160');
        $this->checkFile('themes/merchants/Bootstrap/edit_affiliate_page_page.tpl', '367f8d79bdffc8cb0dcc344e2c1c79bd');
        $this->checkFile('themes/merchants/Bootstrap/edit_destination_url_widget.tpl', 'd0918936a67033179b7b41946e54ddb5');
        $this->checkFile('themes/merchants/Bootstrap/edit_textarea_widget.tpl', '94b2c94dd103b5209bd89470fc70268c');
        $this->checkFile('themes/merchants/Bootstrap/edit_tracking_code_widget.tpl', '059499fee95c96a9e0fc37b517b0e72a');
        $this->checkFile('themes/merchants/Bootstrap/editor.tpl', 'a8c5483c720526b56fa899a91045c287');
        $this->checkFile('themes/merchants/Bootstrap/editor_with_constants_panel.tpl', '6c9e8d91f33bc90c661e9b67ca5ff1e1');
        $this->checkFile('themes/merchants/Bootstrap/email_form.tpl', '7809f19dc7e837c8dbe6f4d58e6574b7');
        $this->checkFile('themes/merchants/Bootstrap/email_notifications.tpl', '6e8120071227fb823ed1af6f1b3ad223');
        $this->checkFile('themes/merchants/Bootstrap/email_setting_smtp_form.tpl', 'd17124a143f842ab1876ed14a74bc762');
        $this->checkFile('themes/merchants/Bootstrap/email_settings_spf.tpl', 'ca349c37b841ccef522f8767817bf1d2');
        $this->checkFile('themes/merchants/Bootstrap/email_settings_tab.tpl', '029bff75bc5d1d6eda64c14de2c4d88e');
        $this->checkFile('themes/merchants/Bootstrap/email_template_edit_panel.tpl', '0673c3c609ca2fa5a693bcc03986a0d6');
        $this->checkFile('themes/merchants/Bootstrap/expand_matrix.tpl', 'dc72b136436320776269f40795008156');
        $this->checkFile('themes/merchants/Bootstrap/expired_session_dialog.tpl', 'ba711bd5d1e932ffc4fbc8e601204905');
        $this->checkFile('themes/merchants/Bootstrap/export_files_panel.tpl', 'ea4620e2d7d8da656e903d2a1ee80fec');
        $this->checkFile('themes/merchants/Bootstrap/export_panel.tpl', '054b8f0de5cb1cd25ce50d914b6c64a1');
        $this->checkFile('themes/merchants/Bootstrap/export_to_csv.tpl', '472a1e543ad141354022ce9ce4d16e56');
        $this->checkFile('themes/merchants/Bootstrap/extendable_commission_data.tpl', '43b5108a8212bccdb414370023388e10');
        $this->checkFile('themes/merchants/Bootstrap/extendable_text.tpl', 'a69efdb298a3aae26e26793c9b9fea36');
        $this->checkFile('themes/merchants/Bootstrap/extendable_text_content.tpl', 'cca4ebdf72f3cb7638b6c5bf0f59d9aa');
        $this->checkFile('themes/merchants/Bootstrap/extendable_text_widget.tpl', '83288dfd8795a2a9105965dde2ebc927');
        $this->checkFile('themes/merchants/Bootstrap/feature_detail.tpl', 'b23eb80665302207d86365efbef72846');
        $this->checkFile('themes/merchants/Bootstrap/feature_on_activate.tpl', '544374f96c5524c306a5c6f6f956200c');
        $this->checkFile('themes/merchants/Bootstrap/feature_on_deactivate.tpl', 'a1767954af4547adcfb12cf4107f3468');
        $this->checkFile('themes/merchants/Bootstrap/feature_settings.tpl', '13e5f54c1b98e65f9a4132abe613c188');
        $this->checkFile('themes/merchants/Bootstrap/fee_panel.tpl', '6c4f808bd9b75f8fc11e4fce3196994c');
        $this->checkFile('themes/merchants/Bootstrap/field_type_edit.tpl', 'b1294ba5d4486ea1cf8022a51e277a11');
        $this->checkFile('themes/merchants/Bootstrap/file_widget.tpl', 'a7410b3e376c1b177c47831f83a68c55');
        $this->checkFile('themes/merchants/Bootstrap/files_tree_panel.tpl', 'e11e884c210779b572bc928e01cf3d96');
        $this->checkFile('themes/merchants/Bootstrap/filter.tpl', '10de4692c8015c544a44267942cf4017');
        $this->checkFile('themes/merchants/Bootstrap/filter_field_decorator.tpl', '531d57478d7718e216ea04ff79d493ca');
        $this->checkFile('themes/merchants/Bootstrap/filter_form.tpl', '67551720cbc190c8df85c24d3f8a4cbe');
        $this->checkFile('themes/merchants/Bootstrap/font/Raleway/raleway-bold.eot', '1ec4e6139616fedc458857908716aec3');
        $this->checkFile('themes/merchants/Bootstrap/font/Raleway/raleway-bold.svg', 'f6f5ff6f96997ac8988c1ab7d07e5b5c');
        $this->checkFile('themes/merchants/Bootstrap/font/Raleway/raleway-bold.ttf', '7fc4d9e141a4e29e8499c833792a487b');
        $this->checkFile('themes/merchants/Bootstrap/font/Raleway/raleway-bold.woff', '8548037bd586a43acab45a89220232a7');
        $this->checkFile('themes/merchants/Bootstrap/font/Raleway/raleway-extrabold.eot', 'eb0c8c8d7568b233c238891c6e0970b1');
        $this->checkFile('themes/merchants/Bootstrap/font/Raleway/raleway-extrabold.svg', '9f495e26e94739143f7e55334ba0e5de');
        $this->checkFile('themes/merchants/Bootstrap/font/Raleway/raleway-extrabold.ttf', '9d2454489d5dc43104f5b6aaeeb74d8c');
        $this->checkFile('themes/merchants/Bootstrap/font/Raleway/raleway-extrabold.woff', '9025b71b1b7f1bdf84ac4593ab2633bd');
        $this->checkFile('themes/merchants/Bootstrap/font/Raleway/raleway-extralight.eot', 'ae96d5c702c0507eef98fc8216c1cf68');
        $this->checkFile('themes/merchants/Bootstrap/font/Raleway/raleway-extralight.svg', '7c9c0060950532d8b1f829deacd5761e');
        $this->checkFile('themes/merchants/Bootstrap/font/Raleway/raleway-extralight.ttf', 'dbf00de8af7cabb8d6a24d5a6c1376f1');
        $this->checkFile('themes/merchants/Bootstrap/font/Raleway/raleway-extralight.woff', 'cec3113c150ebaccfadd249d6a6c6fe3');
        $this->checkFile('themes/merchants/Bootstrap/font/Raleway/raleway-heavy.eot', '17ce555c013828ebcceee5d602eb1abd');
        $this->checkFile('themes/merchants/Bootstrap/font/Raleway/raleway-heavy.svg', '14aff14eda470731bc576352fb405243');
        $this->checkFile('themes/merchants/Bootstrap/font/Raleway/raleway-heavy.ttf', 'e9e0cd13fac726479aa0c6ec85dad4b0');
        $this->checkFile('themes/merchants/Bootstrap/font/Raleway/raleway-heavy.woff', 'ebc9ec7d8bfd11a5e181d4d0eb5ae655');
        $this->checkFile('themes/merchants/Bootstrap/font/Raleway/raleway-light.eot', '0f861fc85ca8480122fdee73a3bc9b34');
        $this->checkFile('themes/merchants/Bootstrap/font/Raleway/raleway-light.svg', '72fa36880542bb3ee2ef61d6e7762722');
        $this->checkFile('themes/merchants/Bootstrap/font/Raleway/raleway-light.ttf', '5013a32d49ea3e3b7179cdebcf04c8ee');
        $this->checkFile('themes/merchants/Bootstrap/font/Raleway/raleway-light.woff', 'e0621c851c98d15e3d225b58e60b1df3');
        $this->checkFile('themes/merchants/Bootstrap/font/Raleway/raleway-medium.eot', 'cb960b7985a829ff8f35f27917c37c16');
        $this->checkFile('themes/merchants/Bootstrap/font/Raleway/raleway-medium.svg', 'b722d214aef535acbc677cb184bacf4e');
        $this->checkFile('themes/merchants/Bootstrap/font/Raleway/raleway-medium.ttf', 'a450c35bf2fb797c59521976c251816a');
        $this->checkFile('themes/merchants/Bootstrap/font/Raleway/raleway-medium.woff', '345ce78497f8fd8cc6ca3e5f87fae51b');
        $this->checkFile('themes/merchants/Bootstrap/font/Raleway/raleway-regular.eot', 'd003da0078843bef358483adaf001e6e');
        $this->checkFile('themes/merchants/Bootstrap/font/Raleway/raleway-regular.svg', 'bf475ebe4f6bfb8aa9739489914d85b0');
        $this->checkFile('themes/merchants/Bootstrap/font/Raleway/raleway-regular.ttf', '044df6936074fbef1e2a0bb83f9be9ed');
        $this->checkFile('themes/merchants/Bootstrap/font/Raleway/raleway-regular.woff', 'e2a42f14d410966808fa3e1a6c6610ed');
        $this->checkFile('themes/merchants/Bootstrap/font/Raleway/raleway-semibold.eot', '996ba4ecf6030f166bfd2865ba2007c2');
        $this->checkFile('themes/merchants/Bootstrap/font/Raleway/raleway-semibold.svg', '2bd749decf7db7f3f41d7ce14bd2bf91');
        $this->checkFile('themes/merchants/Bootstrap/font/Raleway/raleway-semibold.ttf', '4601b5909c48d8741187ef047135d5a5');
        $this->checkFile('themes/merchants/Bootstrap/font/Raleway/raleway-semibold.woff', 'ca59bf4cefe8b05a5c874bfdf6a2de0f');
        $this->checkFile('themes/merchants/Bootstrap/font/Raleway/raleway-thin.eot', '0da2e90cf6205e3fa6adc3d2378c474f');
        $this->checkFile('themes/merchants/Bootstrap/font/Raleway/raleway-thin.svg', '36e5002be7798795643b0ba1cc659a58');
        $this->checkFile('themes/merchants/Bootstrap/font/Raleway/raleway-thin.ttf', '196e4d4ee33ca51eb5c1bcee792e2842');
        $this->checkFile('themes/merchants/Bootstrap/font/Raleway/raleway-thin.woff', '853cc2d80ab72d6a0ac1f8ecbc5f50c6');
        $this->checkFile('themes/merchants/Bootstrap/font/fontello.eot', 'cc4c3813496412813e92ce25c7b963e3');
        $this->checkFile('themes/merchants/Bootstrap/font/fontello.svg', '66090721850d522363f5745b6265983f');
        $this->checkFile('themes/merchants/Bootstrap/font/fontello.ttf', 'baf30392615b9f8dd06420642304e9fb');
        $this->checkFile('themes/merchants/Bootstrap/font/fontello.woff', 'aca17066a8fe19fe88404827ede14eee');
        $this->checkFile('themes/merchants/Bootstrap/font/fontello.woff2', '58f62b369b922e87b001bacc5d4e2274');
        $this->checkFile('themes/merchants/Bootstrap/fontello.css', '7abe36cc2ed0ccbbaad467c15445aa12');
        $this->checkFile('themes/merchants/Bootstrap/footer.stpl', '3fbd103789f1ff2a151c16f490a913dd');
        $this->checkFile('themes/merchants/Bootstrap/forced_matrix_panel.tpl', '0f06e2a7d0482fa847967cd918e0e614');
        $this->checkFile('themes/merchants/Bootstrap/form_field.tpl', '5c7ae4b0f01f4a7753ab811e0a57f29f');
        $this->checkFile('themes/merchants/Bootstrap/form_field_checkbox.tpl', 'c1f1746d1bf5c7abfaf9e5ddb7b4cc52');
        $this->checkFile('themes/merchants/Bootstrap/form_field_checkboxgroup.tpl', 'be1b525a89f033d4f79433dd3eaab593');
        $this->checkFile('themes/merchants/Bootstrap/form_field_radio.tpl', '9013ed97a5fc7b4b52052d816a9b25d0');
        $this->checkFile('themes/merchants/Bootstrap/frame_panel.tpl', '7b13a1add8ba712d8a34f4285414b419');
        $this->checkFile('themes/merchants/Bootstrap/fraud_protection_clicks.tpl', '73301bfff7cb1dd3780e29dbb344c2e5');
        $this->checkFile('themes/merchants/Bootstrap/fraud_protection_form.tpl', 'd0992b66d5f952ca446613a5f74b5f3a');
        $this->checkFile('themes/merchants/Bootstrap/fraud_protection_logins.tpl', '219e554a2a20528c0d83188d36e5cf67');
        $this->checkFile('themes/merchants/Bootstrap/fraud_protection_sales.tpl', '793795df266e0941ce8bccff6813ab07');
        $this->checkFile('themes/merchants/Bootstrap/fraud_protection_signups.tpl', '11dc6c3dd936cdda2667149211a62a19');
        $this->checkFile('themes/merchants/Bootstrap/full_banner_stats.tpl', '9c8d43347b069c27ac3a1af40909a95e');
        $this->checkFile('themes/merchants/Bootstrap/full_commision_stats.tpl', '267321735038275c392ddf30a5c4d35d');
        $this->checkFile('themes/merchants/Bootstrap/full_payout_stats.tpl', '6c5e691e6069884d5d1be146054c14dd');
        $this->checkFile('themes/merchants/Bootstrap/full_transaction_stats.tpl', '2669b46d3f14aa9c57872f5373c2797d');
        $this->checkFile('themes/merchants/Bootstrap/general_no_data.stpl', '03433ae7bf79c177a476922c2ee779c5');
        $this->checkFile('themes/merchants/Bootstrap/generate_coupons_form.tpl', 'beddaaf1aa37c10aab9838f1c4b8f1e8');
        $this->checkFile('themes/merchants/Bootstrap/generate_htaccess.tpl', '05d9d8606bdf35455fb48ec7f928b702');
        $this->checkFile('themes/merchants/Bootstrap/geoip_commissiontype_detailpanel.tpl', '734dc6f1a0cc432cd287f22ef5824f49');
        $this->checkFile('themes/merchants/Bootstrap/geoip_fraudprotection_affiliates.tpl', '8fadf652ac9ea3507a4a6173faf8eb62');
        $this->checkFile('themes/merchants/Bootstrap/geoip_fraudprotection_clicks.tpl', 'db19ca033fb30646f0ae504d43683c92');
        $this->checkFile('themes/merchants/Bootstrap/geoip_fraudprotection_logins.tpl', '660ab5115a24ae974e9739dde8530d30');
        $this->checkFile('themes/merchants/Bootstrap/geoip_fraudprotection_logins_aff.tpl', 'af98bdbc38201d8c9db2d63c83ccdf9d');
        $this->checkFile('themes/merchants/Bootstrap/geoip_fraudprotection_sales.tpl', 'c2c170214c10ba59d591261e85dc4cff');
        $this->checkFile('themes/merchants/Bootstrap/get_pdf.tpl', '7de69c1b98a6f1cac1f9c8e570e3b6b9');
        $this->checkFile('themes/merchants/Bootstrap/getting_started_icons.tpl', '612e44ecb9bc1526bd8694a0655342bf');
        $this->checkFile('themes/merchants/Bootstrap/getting_started_merchant.tpl', '9f02ac92cddb211fce5fb826fe7473e5');
        $this->checkFile('themes/merchants/Bootstrap/google_recaptcha_settings.tpl', 'b93feccb5cdfccc02846aea495459127');
        $this->checkFile('themes/merchants/Bootstrap/gpf.css', 'ec27b549fa06e9420afb4e6d56ee3a96');
        $this->checkFile('themes/merchants/Bootstrap/gpf_db_mail.tpl', 'b5ea5e9ecef2152fdf967085a7689adc');
        $this->checkFile('themes/merchants/Bootstrap/grid.tpl', 'c0efa81ea11d739f933438236d6fb12d');
        $this->checkFile('themes/merchants/Bootstrap/grid_bottombuttons.tpl', '1aa9463da984fac10b988d8758c82297');
        $this->checkFile('themes/merchants/Bootstrap/grid_bottomgridline.tpl', '9bf2013a170e094e82dc1ae0a2ed0f97');
        $this->checkFile('themes/merchants/Bootstrap/grid_nodata.tpl', '340ff6de789cd7277a35d763f6366f24');
        $this->checkFile('themes/merchants/Bootstrap/grid_pager.tpl', '46e6d959616563985ece2d92c0234826');
        $this->checkFile('themes/merchants/Bootstrap/grid_selector.tpl', 'ff2d81e3866f53d540a0d063bdf7b480');
        $this->checkFile('themes/merchants/Bootstrap/grid_topbuttons.tpl', 'b605a4f548962d4bf0c8d8662353b795');
        $this->checkFile('themes/merchants/Bootstrap/grid_topgridline.tpl', '3ff9c43cb7f7fcbbcdc7f03c8822a70d');
        $this->checkFile('themes/merchants/Bootstrap/header.tpl', '32d459ea9f7ebf7a241715058cc91f38');
        $this->checkFile('themes/merchants/Bootstrap/home_edit.tpl', '1e659b8ee09e43c02d567356206c7c93');
        $this->checkFile('themes/merchants/Bootstrap/home_edit_main_template.tpl', 'cd4fbd7e59c2c1813b4b1c9d54025223');
        $this->checkFile('themes/merchants/Bootstrap/home_edit_merch_template.tpl', '1079945929a23a68a38676fe78432211');
        $this->checkFile('themes/merchants/Bootstrap/home_panel.tpl', '1404c1c1a5f5048ce23760ddd33a49b3');
        $this->checkFile('themes/merchants/Bootstrap/home_panel_content.stpl', 'c8265cd85552ee1a86a68214b000cc2b');
        $this->checkFile('themes/merchants/Bootstrap/horizontal_layout_panel.tpl', '8b6098cd64720cff686cc24e06ac4c17');
        $this->checkFile('themes/merchants/Bootstrap/hosted_account.tpl', 'e58e46daeeb498d85227982e6ee6ae2d');
        $this->checkFile('themes/merchants/Bootstrap/hosted_account_plan.tpl', 'bfb67b63d21a4482e2528a4fb581629c');
        $this->checkFile('themes/merchants/Bootstrap/htaccess_panel.tpl', 'b3632f76f8ab6d2e56f7a776401dedaf');
        $this->checkFile('themes/merchants/Bootstrap/html_preview.tpl', '08392603f2252347986bb4b341e964dd');
        $this->checkFile('themes/merchants/Bootstrap/html_preview_iframe_panel.tpl', '22405951702ab2132d0fe99577f4968e');
        $this->checkFile('themes/merchants/Bootstrap/html_preview_image_panel.tpl', 'ebc5b8605c42ac31f653b65deb66e04d');
        $this->checkFile('themes/merchants/Bootstrap/icon_button.tpl', 'a7497a39fe733586fb4f5a1b9f424b0f');
        $this->checkFile('themes/merchants/Bootstrap/icon_object.tpl', 'ff8d25e63eca03b325c4501e13358fb2');
        $this->checkFile('themes/merchants/Bootstrap/icon_picker.tpl', '77a002b90f678df44bcca5776f314820');
        $this->checkFile('themes/merchants/Bootstrap/icon_picker_panel.tpl', '4342c424a8cb290701f64d0cb63655ec');
        $this->checkFile('themes/merchants/Bootstrap/icon_status_widget.tpl', 'ff9e2bc87e203324cc33c4b3ac365dfe');
        $this->checkFile('themes/merchants/Bootstrap/icons_panel_with_header.tpl', '97091a954a48c0889fa82a2464266e84');
        $this->checkFile('themes/merchants/Bootstrap/image_uploader.tpl', '9f93ea577dd2511b19071fa735b6b684');
        $this->checkFile('themes/merchants/Bootstrap/img/FB_share_button.png', 'a56c7efd784eb61b5ac1e6f4111f59a8');
        $this->checkFile('themes/merchants/Bootstrap/img/LinkedIn_share_button.png', 'd0dfb70a7e64ee73f718af05ce995875');
        $this->checkFile('themes/merchants/Bootstrap/img/cards.jpg', '36a8e2ad3f39a4c9c71c8abbcec24823');
        $this->checkFile('themes/merchants/Bootstrap/img/cron_job_example.png', 'f0cd89597b814b000ef2775c2f9dea1b');
        $this->checkFile('themes/merchants/Bootstrap/img/dirty.gif', 'decca3b96e2c37cf6eb04ddb0d9f669b');
        $this->checkFile('themes/merchants/Bootstrap/img/doc.png', 'c914d3518532910b13728f3d9b43056d');
        $this->checkFile('themes/merchants/Bootstrap/img/draggable.png', 'ab4fb4e3c82ccb353b30640cc36eaf67');
        $this->checkFile('themes/merchants/Bootstrap/img/favicon.ico', 'ac3e93c93589318e5dcf69efc8a76176');
        $this->checkFile('themes/merchants/Bootstrap/img/feature.png', 'a17a20726ab706b8cc4d7ad89ee36ef9');
        $this->checkFile('themes/merchants/Bootstrap/img/folder.png', '74ad8feccb7ac18bde1380dd7bdbdd06');
        $this->checkFile('themes/merchants/Bootstrap/img/html.png', '23bf6c9bc9121ffd0c273b5414faaba0');
        $this->checkFile('themes/merchants/Bootstrap/img/icon-128.png', 'a450a0dd5959518fdb2308cc5e523bcc');
        $this->checkFile('themes/merchants/Bootstrap/img/icon-192.png', '8cb72062e4df9eab6c2a064459a5ee62');
        $this->checkFile('themes/merchants/Bootstrap/img/image.png', '66517d22e9c688e521951b3c2d4498e0');
        $this->checkFile('themes/merchants/Bootstrap/img/input.png', '0df09f38346ba18c1a69510138fc7bea');
        $this->checkFile('themes/merchants/Bootstrap/img/insert.png', '1eb65fc224afb8e9bb81bf6182e7fe22');
        $this->checkFile('themes/merchants/Bootstrap/img/line.short.gif', '13914f3810787c4d0571df1fd447627e');
        $this->checkFile('themes/merchants/Bootstrap/img/no.theme.thumbnail.jpg', 'db2b9f70f5fe89a3c9c2f98d69b19254');
        $this->checkFile('themes/merchants/Bootstrap/img/no_image.gif', '07f5f79d487dbf795f7ea37a04aa24c0');
        $this->checkFile('themes/merchants/Bootstrap/img/pan-logo.svg', 'a00e0890d1da3f81a0ddf2d27c111504');
        $this->checkFile('themes/merchants/Bootstrap/img/pap-logo.svg', '5e82bd9eddbcd704a8b581b5c5037d54');
        $this->checkFile('themes/merchants/Bootstrap/img/paypal.jpg', '1e18c3feef21be6605c97f5ac72e7453');
        $this->checkFile('themes/merchants/Bootstrap/img/pdf.png', 'f8dfa3fa0386adcd2370c6d509a0be91');
        $this->checkFile('themes/merchants/Bootstrap/img/php.png', '2c63cf93ca9b1ff5d5b16c6646a59ddc');
        $this->checkFile('themes/merchants/Bootstrap/img/secure.png', '4490e30d2ac3700e78315f510dfff342');
        $this->checkFile('themes/merchants/Bootstrap/img/swf.png', '1623343ec1b366081175a4d28feb66ae');
        $this->checkFile('themes/merchants/Bootstrap/img/tabs.png', 'fce94d82812219c0ed1b98840637ec3b');
        $this->checkFile('themes/merchants/Bootstrap/img/theme_thumbnail.jpg', 'e5253a63e375da2a90d8de96ae19ad8f');
        $this->checkFile('themes/merchants/Bootstrap/img/txt.png', '79520d0ef237730c55eb5bcd50b78ea2');
        $this->checkFile('themes/merchants/Bootstrap/img/unknown_file.png', '3a00859ebcd6dfef1572ecdddbe693fe');
        $this->checkFile('themes/merchants/Bootstrap/img/video.png', '9681c0591166287c6c3144837fdf1008');
        $this->checkFile('themes/merchants/Bootstrap/img/wysiwyg.gif', '017283b1ab06fc9391f796f2c13b0da8');
        $this->checkFile('themes/merchants/Bootstrap/img/xls.png', '3f2844cce5616ee82f1e0dc0b9f0d53b');
        $this->checkFile('themes/merchants/Bootstrap/img/zip.png', 'ce15cafabf396370aac29085b3c1a5dd');
        $this->checkFile('themes/merchants/Bootstrap/import_coupons_form.tpl', '8fc3b5964331ebd6232227b4f8fa937d');
        $this->checkFile('themes/merchants/Bootstrap/import_custom_language_panel.tpl', 'f14fe8af188194edeb7896eb3284c5b1');
        $this->checkFile('themes/merchants/Bootstrap/import_export_panel.tpl', '7562d00dfa6c2eb770a88757ba736996');
        $this->checkFile('themes/merchants/Bootstrap/import_language.tpl', '20d22e5e6eebf43dc6143490803aaa03');
        $this->checkFile('themes/merchants/Bootstrap/import_panel.tpl', 'd8370787bb8f6d6e702c72ed8f7a744d');
        $this->checkFile('themes/merchants/Bootstrap/import_theme_panel.tpl', '5fbd6be91a3a7dbf7b2def44f344b889');
        $this->checkFile('themes/merchants/Bootstrap/info_dialog.tpl', '886c377f8e8c1b2c6957451436e1d090');
        $this->checkFile('themes/merchants/Bootstrap/integration.tpl', '939839cb552c71fdcb243c4a34aa35ee');
        $this->checkFile('themes/merchants/Bootstrap/integration_method.tpl', 'cfdd3053443ce85b757a89dc64ddd45e');
        $this->checkFile('themes/merchants/Bootstrap/integration_method_step.tpl', '4661c951290cf670ee9c26b45fff0a8c');
        $this->checkFile('themes/merchants/Bootstrap/integration_methods.tpl', 'f5f0fe244869bc5da0517349aba9d291');
        $this->checkFile('themes/merchants/Bootstrap/integration_methods_advanced.tpl', '0e72005d09820e3a2f057ea3c71cb7a7');
        $this->checkFile('themes/merchants/Bootstrap/invoice_data_panel.tpl', '1ac898a59516e468e0f047d97db210c6');
        $this->checkFile('themes/merchants/Bootstrap/invoice_form.tpl', '62a0cbc7e109fc019bcc00457b556594');
        $this->checkFile('themes/merchants/Bootstrap/invoices_filter.tpl', '44dfcc122d155b5352b283d84d71f5d2');
        $this->checkFile('themes/merchants/Bootstrap/invoices_list.tpl', '4ee98efc16f05c766be1ae760cc3837c');
        $this->checkFile('themes/merchants/Bootstrap/ip_detail.tpl', 'ff7f24d21c8ac5aa1f3645cd8d59663a');
        $this->checkFile('themes/merchants/Bootstrap/item.tpl', '717eff0e06a712a76effb2d6723183b5');
        $this->checkFile('themes/merchants/Bootstrap/item_panel.tpl', 'b24ed05bdf4cb76a7afc1e9a9908def8');
        $this->checkFile('themes/merchants/Bootstrap/keywords_performance.tpl', '0a76bec58708a4041df21ab9548abadc');
        $this->checkFile('themes/merchants/Bootstrap/keywords_performance_advanced_filter.tpl', '618269ec4149b6ffab19282eb9d1a2c5');
        $this->checkFile('themes/merchants/Bootstrap/label_panel.tpl', 'e0c85a01af8477fe16cb6770fbb5e7af');
        $this->checkFile('themes/merchants/Bootstrap/language_create_new.tpl', '486f695b2fe3d17aaf29ae39e7f7e0ea');
        $this->checkFile('themes/merchants/Bootstrap/language_edit_panel.tpl', '5b8d472500f9e38a967306d007409d1f');
        $this->checkFile('themes/merchants/Bootstrap/language_translations_filter.tpl', '930f22e595469a617570927021bf9d15');
        $this->checkFile('themes/merchants/Bootstrap/language_translations_grid.tpl', 'a4247bb921179c395cf7a2972cbcef3f');
        $this->checkFile('themes/merchants/Bootstrap/languages_configuration.tpl', 'a146b693cd6b18b1f7711d750e444175');
        $this->checkFile('themes/merchants/Bootstrap/layout_panel_content.tpl', '353b904baf333a2e0456ef5cb0fa179c');
        $this->checkFile('themes/merchants/Bootstrap/layout_panel_header_navigation.tpl', '6b0d746501001da8615a22d57266dcb0');
        $this->checkFile('themes/merchants/Bootstrap/layout_panel_tab.tpl', '27ee274cfd12ed770eff98d0913dd8e8');
        $this->checkFile('themes/merchants/Bootstrap/license_invalid.tpl', '6181e1127345050c94d6708cd805aefb');
        $this->checkFile('themes/merchants/Bootstrap/lifetime_referral_edit.tpl', '3d3923ef67ea430835a1f951955543b2');
        $this->checkFile('themes/merchants/Bootstrap/lifetime_referrals_filter.tpl', 'dcac6d377be0092c4fbf75b5ff6824e8');
        $this->checkFile('themes/merchants/Bootstrap/lifetime_referrals_import.tpl', '402219176174a0ed91b952fa0527bfab');
        $this->checkFile('themes/merchants/Bootstrap/lifetime_referrals_panel.tpl', '57fdc30f1434427f31e456701817165a');
        $this->checkFile('themes/merchants/Bootstrap/link_button.tpl', '71fad92bff79f1fd2e1066818afac789');
        $this->checkFile('themes/merchants/Bootstrap/link_method_panel.tpl', '9af6c599de2f311cb0149524b50ff20d');
        $this->checkFile('themes/merchants/Bootstrap/linking_method.tpl', '7e0919bff0810701acf299531e0ef0eb');
        $this->checkFile('themes/merchants/Bootstrap/listbox.tpl', '2739c2a9e22d54280cacf4d67ed2e7bc');
        $this->checkFile('themes/merchants/Bootstrap/listbox_popup.tpl', '8c45877411c0727e814eb5e3caa76822');
        $this->checkFile('themes/merchants/Bootstrap/listdown_button.tpl', 'a1cd26a1aec6d403420971d7469a6f1b');
        $this->checkFile('themes/merchants/Bootstrap/lite_campaign_wizard.tpl', 'eaa5d01dd5deee48986f5f98f22caf40');
        $this->checkFile('themes/merchants/Bootstrap/load_mail_from_template.tpl', '42c0029422eaf077a5b0c316cd3317b5');
        $this->checkFile('themes/merchants/Bootstrap/loadable_tree.tpl', 'e2c214b134bffe5fe2bb38f679a64eb5');
        $this->checkFile('themes/merchants/Bootstrap/loading_screen.tpl', '34ccb2c18cf3ba7225b2107a1c6a8002');
        $this->checkFile('themes/merchants/Bootstrap/log_filter.tpl', '7f09ae6ce70590ead04d534e6019fca9');
        $this->checkFile('themes/merchants/Bootstrap/log_list.tpl', '17f5cd218930723c21afa914b4fee8fe');
        $this->checkFile('themes/merchants/Bootstrap/logging_tab.tpl', 'bbe2b73c70c24bbafb56a75ed4279f81');
        $this->checkFile('themes/merchants/Bootstrap/logging_tab_debug.tpl', '32912cc60dfc885333623335a44ab19c');
        $this->checkFile('themes/merchants/Bootstrap/logging_tab_logins_history.tpl', 'e59ce588474c4019a05eafd91c45bd2c');
        $this->checkFile('themes/merchants/Bootstrap/login.tpl', 'e7be8367104ee7221547730250f9b0f0');
        $this->checkFile('themes/merchants/Bootstrap/login_form.tpl', '68fec5fc89be1ee473d62ac966211289');
        $this->checkFile('themes/merchants/Bootstrap/login_main.tpl', '5b3eb0529047463ac6b90a529de64d85');
        $this->checkFile('themes/merchants/Bootstrap/logins_history.tpl', '1ef6edb0f2167b8d05c961c7d6379f92');
        $this->checkFile('themes/merchants/Bootstrap/loginshistory_filter.tpl', '6fa20923cc33142105a51ef6f3a51ad7');
        $this->checkFile('themes/merchants/Bootstrap/logo_settings.tpl', '6c5dbe6195a7b19dd0e0dcb58a207523');
        $this->checkFile('themes/merchants/Bootstrap/logs_no_data.tpl', 'c807c1484862c46a3f72f1ea0d276b3f');
        $this->checkFile('themes/merchants/Bootstrap/mail_detail_data.tpl', '72d679a44b2ad0f888e829b479e6550e');
        $this->checkFile('themes/merchants/Bootstrap/mail_outbox_panel.tpl', 'fa6291a64c1e5a21237be44f192a8c99');
        $this->checkFile('themes/merchants/Bootstrap/mail_template_not_selected.tpl', '8f8e4d19a09cd7bc7e96df0e0729ef8d');
        $this->checkFile('themes/merchants/Bootstrap/mail_template_preview.tpl', 'ea7d0df5aef2645e05d768c51a294389');
        $this->checkFile('themes/merchants/Bootstrap/mail_template_test_form.tpl', 'd5c10c451945fe2cd1545ab10c11a959');
        $this->checkFile('themes/merchants/Bootstrap/mail_templates.tpl', 'cceaeaa496bd10868bcf67ef9f9acc45');
        $this->checkFile('themes/merchants/Bootstrap/mail_templates_list.tpl', '0888271c902c0589a3a022a59a9b7e00');
        $this->checkFile('themes/merchants/Bootstrap/mailoutbox_filter.tpl', '59f66fe33f07d333de586095367ca23d');
        $this->checkFile('themes/merchants/Bootstrap/mailoutbox_list_no_data.tpl', '12637515858ca4d960c6202e8a89042b');
        $this->checkFile('themes/merchants/Bootstrap/main.tpl', '9f9d575516a9ea38936579841bd5502d');
        $this->checkFile('themes/merchants/Bootstrap/main_error_html_doc.tpl', 'e99d46538cab7c9fe32dc247711589d3');
        $this->checkFile('themes/merchants/Bootstrap/main_filter_panel.tpl', '0985a7421f898d75d4df72b4a6081c49');
        $this->checkFile('themes/merchants/Bootstrap/main_html_doc.tpl', '48d6098b9095884a85569168859dc97d');
        $this->checkFile('themes/merchants/Bootstrap/main_integration_steps_icons.tpl', '2107115d75013a0ad392566bb3fa1d54');
        $this->checkFile('themes/merchants/Bootstrap/main_menu.tpl', '1036ce189dc092adca21d6405e83544f');
        $this->checkFile('themes/merchants/Bootstrap/map_overlay.tpl', '9deb511a7295d19349480562f6771d87');
        $this->checkFile('themes/merchants/Bootstrap/map_overlay_advanced_filter.tpl', 'd41f999b16fbe6f34fe9315aff388a67');
        $this->checkFile('themes/merchants/Bootstrap/map_overlay_edit.tpl', 'd173ac586a3502e61f80a956597e1496');
        $this->checkFile('themes/merchants/Bootstrap/mass_pay_export.tpl', 'ae796c4555ef8f236db4f7ec9c838cc9');
        $this->checkFile('themes/merchants/Bootstrap/mass_pay_export_form.tpl', 'c3b9939154fe31ce081f9c4edee7c410');
        $this->checkFile('themes/merchants/Bootstrap/menu_entry.tpl', '9245aaaa5732793ce089f5fe25d703ea');
        $this->checkFile('themes/merchants/Bootstrap/menu_section.tpl', 'cec8b58c248868d64eaddc18923f7743');
        $this->checkFile('themes/merchants/Bootstrap/merchant_category_info.tpl', 'ecf110e07235298eb0403fdb6c8a1448');
        $this->checkFile('themes/merchants/Bootstrap/merchant_tutorial_video.tpl', 'ce8d0f0aad10353b46888942abfb96e5');
        $this->checkFile('themes/merchants/Bootstrap/messages.tpl', 'bf1a3bac08c419320acb94673ad29f0b');
        $this->checkFile('themes/merchants/Bootstrap/module_body.stpl', 'c079addcd33eb725ab7efbf09c16a793');
        $this->checkFile('themes/merchants/Bootstrap/month_banner_stats.tpl', 'fc0ecc72cbc42efa3835713eebcf8d4f');
        $this->checkFile('themes/merchants/Bootstrap/multi_editor.tpl', '6cd4d8823bd6b67cd3e0a2aa2cf52b29');
        $this->checkFile('themes/merchants/Bootstrap/multi_form_widget.tpl', '3f92d96633ec487b28dc6bfae7cc8e30');
        $this->checkFile('themes/merchants/Bootstrap/multiple_currencies_panel.tpl', 'c7b959fe11ad02a2fcbe22f5f62d344b');
        $this->checkFile('themes/merchants/Bootstrap/multiselect.tpl', '9d1863b21edd131520315ce252fde639');
        $this->checkFile('themes/merchants/Bootstrap/network_invoice.tpl', 'da2d8c12f409758081a229e78c1306fe');
        $this->checkFile('themes/merchants/Bootstrap/network_proforma_invoice.tpl', '5f9dcea372e00363e6dc2ffbdd5a8187');
        $this->checkFile('themes/merchants/Bootstrap/news_content.tpl', 'a576598444bb0db20fa8d47854f1ef34');
        $this->checkFile('themes/merchants/Bootstrap/news_filter.tpl', '59508e33dc1a696ffa5a18d5f619eedd');
        $this->checkFile('themes/merchants/Bootstrap/news_form_edit.tpl', '517272eac91c024292fe594cecae2c28');
        $this->checkFile('themes/merchants/Bootstrap/news_item.tpl', '18161a56a8f4dc5df01f08191709f864');
        $this->checkFile('themes/merchants/Bootstrap/news_list.tpl', 'f37df45ddce385805e34da5d81b17a1f');
        $this->checkFile('themes/merchants/Bootstrap/news_panel.tpl', '0e6eda2d6e6edab31d596d86939f0933');
        $this->checkFile('themes/merchants/Bootstrap/newsletter_broadcast_form.tpl', '1ccb4e8c2a3873263c7c8c1fc7c19f27');
        $this->checkFile('themes/merchants/Bootstrap/newsletter_broadcasts.tpl', 'e85ba6dc04b3a921af601f6bf976a5b8');
        $this->checkFile('themes/merchants/Bootstrap/newsletter_edit_panel.tpl', '73ddca2129beb12e11215b1c55e70461');
        $this->checkFile('themes/merchants/Bootstrap/newsletter_form.tpl', 'e86bb366b8986ac4cb1b50c9ccc94b8e');
        $this->checkFile('themes/merchants/Bootstrap/no_category_selected_settings_panel.tpl', '28bc9d284f2cbec3dde908dc0d4e9f7c');
        $this->checkFile('themes/merchants/Bootstrap/no_content_gadgets.tpl', '1d4ce600d473f33e2b229101a50cbc3f');
        $this->checkFile('themes/merchants/Bootstrap/no_language_selected.tpl', 'd61125f2b1cf78e4e66653d4e2f04bdd');
        $this->checkFile('themes/merchants/Bootstrap/note_filter.tpl', '5984797bddb6b9dff4b4066106da1bcf');
        $this->checkFile('themes/merchants/Bootstrap/notification_window.tpl', 'db781872bdb9748bc838e051b8e5e4e2');
        $this->checkFile('themes/merchants/Bootstrap/offline_sale.tpl', '589eb1238aac5800197e6e56a26cacf7');
        $this->checkFile('themes/merchants/Bootstrap/offline_sale_form.tpl', '86fe26a2a1e02d811e892233db9d6b5e');
        $this->checkFile('themes/merchants/Bootstrap/online_users.tpl', '1242aa25d7ed7b3a278684e0d4a13c4c');
        $this->checkFile('themes/merchants/Bootstrap/online_users_gadget_rolecount.tpl', '5fd6af0c5f2edec24d0e35dc00a9e870');
        $this->checkFile('themes/merchants/Bootstrap/online_users_gadget_template.tpl', '80ebdfe2a212375942cac09081e371b2');
        $this->checkFile('themes/merchants/Bootstrap/onlinegadgets_no_data.tpl', 'f5f692a433b4911963a92c41cc269768');
        $this->checkFile('themes/merchants/Bootstrap/onlineusers_filter.tpl', 'a5ec412a7f620cb47ddcf48b9f0d6625');
        $this->checkFile('themes/merchants/Bootstrap/order_id_filter.tpl', 'e3b95af73c9456fd1cc3d3ecf3814ea2');
        $this->checkFile('themes/merchants/Bootstrap/orgchart_affiliate_widget.tpl', '32f4faf30d0289ffd4c9d53f92a39388');
        $this->checkFile('themes/merchants/Bootstrap/overview_panel.tpl', '1874d6377cb2a53e5eba387cd0874215');
        $this->checkFile('themes/merchants/Bootstrap/overview_stats_panel.tpl', '674d3c5e07dddbfcc6b89bfa7b420640');
        $this->checkFile('themes/merchants/Bootstrap/page_header.tpl', '4fd5676c44341f95ee0435c1f78da534');
        $this->checkFile('themes/merchants/Bootstrap/page_type_radio.tpl', 'd132376c54a57b3962d1ca08eda22000');
        $this->checkFile('themes/merchants/Bootstrap/panel_footer.stpl', '9ac4165a950d1760c4b0ed086c71788e');
        $this->checkFile('themes/merchants/Bootstrap/pap4.css', '5ad703b8a30ffefacf435c5c52c9b99c');
        $this->checkFile('themes/merchants/Bootstrap/pap4.rtl.css', '2a468c7262d09207157eba5f36d338ac');
        $this->checkFile('themes/merchants/Bootstrap/parameter_names_form.tpl', '32bfa373ae61cdae7c70a202ba921e62');
        $this->checkFile('themes/merchants/Bootstrap/password_constraint_panel.tpl', '6d328bcd04ea68b87c18d4fd52099888');
        $this->checkFile('themes/merchants/Bootstrap/password_panel.tpl', 'b1440553a785aae589233a91315b281f');
        $this->checkFile('themes/merchants/Bootstrap/pay_affilates_form.tpl', '47ca863e6f0e46c4b2e631d2ebd313f0');
        $this->checkFile('themes/merchants/Bootstrap/pay_affiliate_template.tpl', '692261c025aab9b05408b9651de9a894');
        $this->checkFile('themes/merchants/Bootstrap/pay_affiliates.tpl', '9a08ef03ed4b0d076203c45c369918d1');
        $this->checkFile('themes/merchants/Bootstrap/pay_affiliates_filter.tpl', 'b614af81b7bae93abeec49415de0f758');
        $this->checkFile('themes/merchants/Bootstrap/pay_affiliates_list.tpl', '85b17725f87d1ea59102020c1f290070');
        $this->checkFile('themes/merchants/Bootstrap/pay_affiliates_no_data.tpl', 'bdd593288f13c714bdb19de5d264318c');
        $this->checkFile('themes/merchants/Bootstrap/pay_invoice_form.tpl', 'c7490c619a883b6b90c2817b22025984');
        $this->checkFile('themes/merchants/Bootstrap/payee_info.tpl', '740af57f0054d67e6c689466e90980d8');
        $this->checkFile('themes/merchants/Bootstrap/payee_info_main.tpl', '8048bb0c734d26af0a077e1728b2e814');
        $this->checkFile('themes/merchants/Bootstrap/payout_data.tpl', 'b6f6f6c19617690d683128ee13b8b688');
        $this->checkFile('themes/merchants/Bootstrap/payout_fields_form.tpl', '0f8a8b9516b729ab4899926ead42be16');
        $this->checkFile('themes/merchants/Bootstrap/payout_fields_no_data.tpl', '22728157d2ebba66c42b8632edcc2eee');
        $this->checkFile('themes/merchants/Bootstrap/payout_history_form.tpl', 'fdf50ed31df6ef2a90efc52c043f13f8');
        $this->checkFile('themes/merchants/Bootstrap/payout_history_list_no_data.tpl', 'eaea8ff071a4da8272b5b57616544789');
        $this->checkFile('themes/merchants/Bootstrap/payout_history_template.tpl', '2ec2b28dafe8f0a65230016c4ba9c126');
        $this->checkFile('themes/merchants/Bootstrap/payout_invoice_format.tpl', 'c33ad82f202fb7fc45f83d2c8d547efa');
        $this->checkFile('themes/merchants/Bootstrap/payout_methods_filter_field.tpl', '3e44e83bdfd9080f05070dd2281dcfd2');
        $this->checkFile('themes/merchants/Bootstrap/payout_option_form.tpl', '309c28785f0a1aa14ded20d7037c6d3e');
        $this->checkFile('themes/merchants/Bootstrap/payout_options_form.tpl', '747bdbfe5eca6068d61275e19f4472a4');
        $this->checkFile('themes/merchants/Bootstrap/payout_options_no_data.tpl', '19f1bead958da75d50d38d893f93f4e1');
        $this->checkFile('themes/merchants/Bootstrap/payout_options_text_box.tpl', '9d7c675a676c204bafaa2c1f32b3f6a4');
        $this->checkFile('themes/merchants/Bootstrap/payout_settings_icons.tpl', 'aa4813c156afb53ed10a02319166c340');
        $this->checkFile('themes/merchants/Bootstrap/payouts_balance_form.tpl', 'd01274716d5700a7180cd8277b575cb0');
        $this->checkFile('themes/merchants/Bootstrap/payouts_balance_settings.tpl', '61c8ca2e6971fef86250e0b1a3adcb41');
        $this->checkFile('themes/merchants/Bootstrap/payouts_history.tpl', '8a1c74d4f1312a63ceee7907076e2d45');
        $this->checkFile('themes/merchants/Bootstrap/payouts_history_filter.tpl', '49514d217f0a77dcd9cbae68ab504e38');
        $this->checkFile('themes/merchants/Bootstrap/payouts_to_affiliates.tpl', '6e8868d55f61a825057b3890e0ec4afd');
        $this->checkFile('themes/merchants/Bootstrap/payouts_to_affiliates_filter.tpl', '06f0e81d2ad6a474fb81ccaef755477d');
        $this->checkFile('themes/merchants/Bootstrap/payoutstoaffiliates_list_no_data.tpl', '1bf1e39b51797acb2bac6428dabb0929');
        $this->checkFile('themes/merchants/Bootstrap/peel_banner_feature_on_deactivate.tpl', '88a989ccfb54f68203c01176a104541f');
        $this->checkFile('themes/merchants/Bootstrap/pending_backround_tasks.tpl', '9c91e4d0f413f7d7327783449c4222d7');
        $this->checkFile('themes/merchants/Bootstrap/pending_tasks.tpl', '3aa9f9ee68b7ef3258fe7a9c3994f952');
        $this->checkFile('themes/merchants/Bootstrap/pending_tasks_data.tpl', '1916b1db72af25350e122542f2261eb3');
        $this->checkFile('themes/merchants/Bootstrap/pending_tasks_panel.tpl', '16eaedf4545a03d89f94b98e3adacfa4');
        $this->checkFile('themes/merchants/Bootstrap/pending_tasks_template.tpl', '091fb315fbb9a3d24bf16baa791bd32f');
        $this->checkFile('themes/merchants/Bootstrap/performance_rewards.tpl', 'e6376beacf92f7086e4cf7b1a3e97d29');
        $this->checkFile('themes/merchants/Bootstrap/performance_rewards_filter.tpl', 'daf43de0e8c03e9a97f0aaf22b173461');
        $this->checkFile('themes/merchants/Bootstrap/placement_overview_filter.tpl', '6132598add92f772fb46568f94f0e5cc');
        $this->checkFile('themes/merchants/Bootstrap/placement_overview_panel.tpl', 'd0d0bef4390bbf53b43e4207aba245f3');
        $this->checkFile('themes/merchants/Bootstrap/plugin_configuration.tpl', '9f4b075baf454033271fc4219c272737');
        $this->checkFile('themes/merchants/Bootstrap/plugin_detail.tpl', '097b49ceeac4111d1fd96f3cd8d2b049');
        $this->checkFile('themes/merchants/Bootstrap/plugins_list.tpl', '72c87aa08ebd9a6218fcb300d6ec675c');
        $this->checkFile('themes/merchants/Bootstrap/popup_actions_panel.tpl', 'ef01a0f4fa742fc99a03632e1d6876b4');
        $this->checkFile('themes/merchants/Bootstrap/popup_form_widget.tpl', '0f5d2ef3d678d026df06fe1f1e5991a8');
        $this->checkFile('themes/merchants/Bootstrap/postsignup_radio.tpl', '6b32ad7886413081192c2ba5dd514275');
        $this->checkFile('themes/merchants/Bootstrap/postsignup_settings_page.tpl', '3657e859769d3db637b6a83e45ab218d');
        $this->checkFile('themes/merchants/Bootstrap/postsignup_settings_url.tpl', 'c854a3cb764d4be9af656abf45398193');
        $this->checkFile('themes/merchants/Bootstrap/private_campaigns_feature_on_deactivate.tpl', 'ecef84105dc2779ac2fb428da2e9f25f');
        $this->checkFile('themes/merchants/Bootstrap/proxy_server_configuration.tpl', '618f166a4be6b32f563aaeffd5f1931e');
        $this->checkFile('themes/merchants/Bootstrap/qualityunit_news.stpl', '188a98161e9218eb440aab2d33341a0c');
        $this->checkFile('themes/merchants/Bootstrap/quick_report_base.tpl', '03394fc9a529f4d9d13f8cbcb664be8f');
        $this->checkFile('themes/merchants/Bootstrap/quick_report_content.stpl', 'a75ca3ba3fc385de73eae7311f79c650');
        $this->checkFile('themes/merchants/Bootstrap/quick_report_content_multitier.stpl', 'e45556a573992274576437d9d34bdd71');
        $this->checkFile('themes/merchants/Bootstrap/quick_report_filter_base.tpl', '40541d4b075161fc37bea2086e429e23');
        $this->checkFile('themes/merchants/Bootstrap/quick_report_multitier_widget.tpl', '24108ad66b123214ae2c170aaa4ec369');
        $this->checkFile('themes/merchants/Bootstrap/quick_stats_actions_panel.tpl', 'd0816b90a3fbe4f4ffa09a37aec14268');
        $this->checkFile('themes/merchants/Bootstrap/quick_stats_box.tpl', '745d64595b8a0e5869bfc1e9bf10b9c2');
        $this->checkFile('themes/merchants/Bootstrap/quicklaunch_settings.tpl', '1e595ebaeb4364f173ee3fec71c1762d');
        $this->checkFile('themes/merchants/Bootstrap/radio_button_group_row.tpl', '3713f6d400aa1ca96d9e404082304912');
        $this->checkFile('themes/merchants/Bootstrap/radio_form_panel.tpl', 'c56091f134178fc494aa76df1b6ad6a1');
        $this->checkFile('themes/merchants/Bootstrap/rebrand_pdf_feature_on_deactivate.tpl', '57adefe6824afba7c2477b79c5663843');
        $this->checkFile('themes/merchants/Bootstrap/recaptcha_settings.tpl', 'd40a2e0759211b13af22180aef80b380');
        $this->checkFile('themes/merchants/Bootstrap/recipients.tpl', '6c334400d00281b1b04bfc28c654f2a3');
        $this->checkFile('themes/merchants/Bootstrap/recurring_commission_edit.tpl', 'f144dcac07b3913bb6dfb866e4871d9d');
        $this->checkFile('themes/merchants/Bootstrap/recurring_commission_filter.tpl', 'bd70625a017204c62a4563c92cb72e72');
        $this->checkFile('themes/merchants/Bootstrap/recurring_commission_list.tpl', 'b6d7546e3e8ef3fafa122019d01531f8');
        $this->checkFile('themes/merchants/Bootstrap/recurring_commissions.tpl', '8c806617d38c467e2f29e22bb43e826c');
        $this->checkFile('themes/merchants/Bootstrap/referringurl_advanced_filter.tpl', 'e064d6689bc281e60c830c70acd8f3c3');
        $this->checkFile('themes/merchants/Bootstrap/refresh_panel.tpl', '5c709df4d219d5feb4f29003ca932f77');
        $this->checkFile('themes/merchants/Bootstrap/regional_settings.tpl', '899786b4a8c655defc732008fae917e7');
        $this->checkFile('themes/merchants/Bootstrap/regional_settings_tab.tpl', '808fee97d86d7a2400d4e4de198359dc');
        $this->checkFile('themes/merchants/Bootstrap/replicated_site_source_radio.tpl', '7d280f4647e9269bca20b70e4e64d077');
        $this->checkFile('themes/merchants/Bootstrap/report_filter.tpl', 'cfa31cd337c81b3e863f97b664581327');
        $this->checkFile('themes/merchants/Bootstrap/report_problems.tpl', '6c4035620c09202f2165e94e99635ceb');
        $this->checkFile('themes/merchants/Bootstrap/reports_screen.tpl', '7ec70fbbc8d7b81b1a98c932ea1c1267');
        $this->checkFile('themes/merchants/Bootstrap/request_new_password_form.tpl', 'e4e20e8042328f80b7b400e39d921986');
        $this->checkFile('themes/merchants/Bootstrap/resizable_text_area.tpl', '7995c217048ccd289dfee567a455b08e');
        $this->checkFile('themes/merchants/Bootstrap/richlistbox.tpl', '13229a43763945932dc8d5d7fa21d08e');
        $this->checkFile('themes/merchants/Bootstrap/richlistbox_popup.tpl', 'c155c59eea77770589bcadca0c75f1af');
        $this->checkFile('themes/merchants/Bootstrap/richtext_editor.tpl', '99af0e75e8761690e55e65fa238d8d4c');
        $this->checkFile('themes/merchants/Bootstrap/richtext_editor_toolbar.tpl', '3798b9151ed1d87c99e5783005c81773');
        $this->checkFile('themes/merchants/Bootstrap/richtexteditor_addlink.tpl', 'c9bd3a510535abef1076a29328f069e7');
        $this->checkFile('themes/merchants/Bootstrap/role_privileges.tpl', '30e7afc5bc26d51388efbf226e837411');
        $this->checkFile('themes/merchants/Bootstrap/rotator_preview_merchant.stpl', 'f4a8b7e2a320d263c11e080652136aa8');
        $this->checkFile('themes/merchants/Bootstrap/rule_conditions_panel.tpl', 'eb2d93cd36c8a15eb8b8c219d89cbec9');
        $this->checkFile('themes/merchants/Bootstrap/rule_conditions_panel_full.tpl', '52061284c52dc90ca96e902ac2d0e623');
        $this->checkFile('themes/merchants/Bootstrap/rule_panel.tpl', '836f9d642a2304b320b799fd156d04bf');
        $this->checkFile('themes/merchants/Bootstrap/search_filter.tpl', 'c43c492cae5282a628238b4ff75508b2');
        $this->checkFile('themes/merchants/Bootstrap/search_gadget.tpl', 'dd1ccaf3d497e365f8ea8d999a89cc29');
        $this->checkFile('themes/merchants/Bootstrap/search_gadget_entries_panel.tpl', 'b60a5fd89e628c401c86eee54073243e');
        $this->checkFile('themes/merchants/Bootstrap/search_gadget_popup.tpl', 'ad5359afa9edeb864b0929d40a05e466');
        $this->checkFile('themes/merchants/Bootstrap/search_gadget_popup_entry.tpl', 'd4c0f584509bbc3c0db48a061dab51fc');
        $this->checkFile('themes/merchants/Bootstrap/selectbutton_search.tpl', 'dedb23ce356b1b66377e648232dc2b8b');
        $this->checkFile('themes/merchants/Bootstrap/send_mail_to_affiliate.tpl', '757d0224a850eb6a32175367add64442');
        $this->checkFile('themes/merchants/Bootstrap/send_mass_mail.tpl', '515c3046b1058c4b313af52b6859a18d');
        $this->checkFile('themes/merchants/Bootstrap/set_new_password_form.tpl', '9270391a0892b67b03efbd67084806c6');
        $this->checkFile('themes/merchants/Bootstrap/sidebar.tpl', '65226d7e25dcdca0cf71a9f3118d8139');
        $this->checkFile('themes/merchants/Bootstrap/sidebar_closed.tpl', '3d903661713a9ee5fb402776ee06d310');
        $this->checkFile('themes/merchants/Bootstrap/sidebar_gadget.tpl', '1f904859e056808c8826836a4e256761');
        $this->checkFile('themes/merchants/Bootstrap/signup_commissions.tpl', 'e88a6f8eb2b970efe40609b59a103f45');
        $this->checkFile('themes/merchants/Bootstrap/signup_form_design.tpl', '5786a51864065a89ea059e03826048c7');
        $this->checkFile('themes/merchants/Bootstrap/signup_url_panel.tpl', '9578396ed90325350510e89493bc5101');
        $this->checkFile('themes/merchants/Bootstrap/simple_filter.tpl', 'a55a1095bcbdbef9d9d9f5e2078b19a2');
        $this->checkFile('themes/merchants/Bootstrap/simple_icon_object.tpl', 'bcbc9ea994d4aa8bbdee1eddc3ad19d8');
        $this->checkFile('themes/merchants/Bootstrap/simple_popup_window.tpl', 'd6c9101a0dcda906c3d090bdb58122bb');
        $this->checkFile('themes/merchants/Bootstrap/simplecolorpicker.tpl', '9c031fbdd2b35909faeea73e5f1203a1');
        $this->checkFile('themes/merchants/Bootstrap/single_content_panel.tpl', '529d4a42f9106d91881f8b8b8e87748b');
        $this->checkFile('themes/merchants/Bootstrap/site_replication_feature_on_deactivate.tpl', 'a9a5007e2b045fcddb5649780343250c');
        $this->checkFile('themes/merchants/Bootstrap/size_format_widget.tpl', 'ebfb7db6718ec601af59a570d8e0ccb3');
        $this->checkFile('themes/merchants/Bootstrap/spillover.tpl', 'b88774d1a43ea2c8b638a75c59411588');
        $this->checkFile('themes/merchants/Bootstrap/spillover_affiliate_panel.tpl', 'a31389658f2a6052020cad731dff7671');
        $this->checkFile('themes/merchants/Bootstrap/split_commissions_edit.tpl', '79b93073097985ea9b70b50708f9f361');
        $this->checkFile('themes/merchants/Bootstrap/split_commissions_edit_help.tpl', 'b8c0076fd8c6f725a44728f9c36e1633');
        $this->checkFile('themes/merchants/Bootstrap/split_commissions_feature_on_activate.tpl', '3c0a020b1e83cc8c0f13cc18c823c20d');
        $this->checkFile('themes/merchants/Bootstrap/start_button.tpl', '7aa2278c46b897536625cc042b4f5499');
        $this->checkFile('themes/merchants/Bootstrap/statistics_double_value_widget.tpl', '7e243a39277ad97843b418e45881a6d2');
        $this->checkFile('themes/merchants/Bootstrap/statistics_filter.tpl', '90764aa6c165d35f0eac8273a596c963');
        $this->checkFile('themes/merchants/Bootstrap/statistics_tab.tpl', '2848d44a5dc972d9812c2aa7f0b16614');
        $this->checkFile('themes/merchants/Bootstrap/stats_chart.tpl', 'b5bb3d9a0dd5361a4e34e479aacf2480');
        $this->checkFile('themes/merchants/Bootstrap/sub_menu_section.tpl', 'f14329a6ad21f2551a068111201c9918');
        $this->checkFile('themes/merchants/Bootstrap/sum_payouts_to_affiliates.tpl', '4c94936fcc7cc7be82f86e1eb2e8df9e');
        $this->checkFile('themes/merchants/Bootstrap/sum_payouts_to_affiliates_filter.tpl', '4ff8a5479e29e9ca336f282f0fd51b85');
        $this->checkFile('themes/merchants/Bootstrap/system_menu.tpl', '414133fa4f1a7e794444f72e6aad3cf7');
        $this->checkFile('themes/merchants/Bootstrap/tab_item.tpl', 'd869bc1a3b8c511712e039399333d129');
        $this->checkFile('themes/merchants/Bootstrap/tab_panel.tpl', '8c2853c4e62119a5b6f89c5e340af5d3');
        $this->checkFile('themes/merchants/Bootstrap/task.tpl', '38a4b70b6456a12285be4bb113c72575');
        $this->checkFile('themes/merchants/Bootstrap/taskbar.tpl', 'd7cf8ef7a71bf324aee5c1c7173afc7e');
        $this->checkFile('themes/merchants/Bootstrap/template_form.tpl', '1a0d6777f298f5a2a71f6efea7ac459f');
        $this->checkFile('themes/merchants/Bootstrap/template_form_constants.tpl', '91c398393e519cf7c6a53ba758eefc47');
        $this->checkFile('themes/merchants/Bootstrap/template_form_theme_entry.tpl', '91a40d5bfbb3ff3b61cd7771e24a2684');
        $this->checkFile('themes/merchants/Bootstrap/template_form_themes.tpl', 'e7158c1782ef49ddbf3fbe671c5c5b8a');
        $this->checkFile('themes/merchants/Bootstrap/template_form_variables.tpl', 'e1c008058f4be04a9e6e76ba72cc3290');
        $this->checkFile('themes/merchants/Bootstrap/templates_form.tpl', '7a0a1baf13edabb10c8c6bef5a3dac41');
        $this->checkFile('themes/merchants/Bootstrap/theme.php', '15b97fafa703d17061d636bbec86e163');
        $this->checkFile('themes/merchants/Bootstrap/theme_create_new.tpl', '847cc7b80df92aa24acf0da5afdd0ed3');
        $this->checkFile('themes/merchants/Bootstrap/theme_edit_editor.tpl', '1b1b3b083b418ba21ef37522b0934a5f');
        $this->checkFile('themes/merchants/Bootstrap/theme_edit_filetree.tpl', '0e6f1bd9c3b11a255eab1e4824f83475');
        $this->checkFile('themes/merchants/Bootstrap/theme_edit_image.tpl', 'cc7ae652219ab87a267bf87631e9dc43');
        $this->checkFile('themes/merchants/Bootstrap/theme_edit_none.tpl', '291239b715e2f1e962011564bf549e5e');
        $this->checkFile('themes/merchants/Bootstrap/theme_edit_unsupported.tpl', '2977467887b418fedc8b42576078f275');
        $this->checkFile('themes/merchants/Bootstrap/theme_editor_panel.tpl', '566661806fd2d4b3ce443277d71959f5');
        $this->checkFile('themes/merchants/Bootstrap/theme_panel.tpl', '07b850efc37a68fe58fcdb067a81271d');
        $this->checkFile('themes/merchants/Bootstrap/theme_settings.tpl', '5c596388ecc46c2ac89c029f811f565e');
        $this->checkFile('themes/merchants/Bootstrap/time_conditions_panel.tpl', '248cd742364ffa7052bdff9246ca225b');
        $this->checkFile('themes/merchants/Bootstrap/timezone_settings.tpl', 'f1bb95540fb8855093d35b284817369d');
        $this->checkFile('themes/merchants/Bootstrap/timezone_settings_tab.tpl', 'f89569e5d47f73e9c872ed4026fefcfa');
        $this->checkFile('themes/merchants/Bootstrap/tooltip_popup.tpl', 'e4a5b50c70875ee64d9fdf4f88fa8045');
        $this->checkFile('themes/merchants/Bootstrap/top_afffiliates_list.tpl', '286e2ac7096bc38ef5507691de9f17a6');
        $this->checkFile('themes/merchants/Bootstrap/top_affiliates_filter.tpl', 'b3ed7a34051548c53736298042eb2243');
        $this->checkFile('themes/merchants/Bootstrap/topurl_list.tpl', 'f108c2b8e2583a45a2016869735c87d3');
        $this->checkFile('themes/merchants/Bootstrap/tracking_tab.tpl', '8abcd2a1c88351a3a16795feda6750b4');
        $this->checkFile('themes/merchants/Bootstrap/traffic_info.tpl', 'd8084bc576645ae6485c9384c74b42e4');
        $this->checkFile('themes/merchants/Bootstrap/traffic_stats_gadget.tpl', 'da081a1eba4470008e9f5e0165ecd7d6');
        $this->checkFile('themes/merchants/Bootstrap/traffic_stats_in_gadget.tpl', 'b6ffda3596f992ce68d25d72fa923751');
        $this->checkFile('themes/merchants/Bootstrap/trafic_and_sales_report.tpl', '6723e4f293c26fed32855b086cb6318e');
        $this->checkFile('themes/merchants/Bootstrap/transaction_form.tpl', '8ef3d9c8be8655191b10b6ceb6b8627a');
        $this->checkFile('themes/merchants/Bootstrap/transaction_form_edit.tpl', '73debd09259e1daf3b7e6d50ccf8aee0');
        $this->checkFile('themes/merchants/Bootstrap/transaction_form_notes.tpl', '648b29094d534cfc6b8d7683440505f0');
        $this->checkFile('themes/merchants/Bootstrap/transaction_form_tracking.tpl', 'fc35d874eebd664e3b6da64f8d36b903');
        $this->checkFile('themes/merchants/Bootstrap/transaction_info.tpl', '689fb8c420b25ed9e1460edae68b92e0');
        $this->checkFile('themes/merchants/Bootstrap/transaction_list.tpl', '4d28f9612adefe432e937dea2f6ccf2a');
        $this->checkFile('themes/merchants/Bootstrap/transaction_list_filter_base.tpl', '7d0ad12c7fc041af03abba828a3bacc4');
        $this->checkFile('themes/merchants/Bootstrap/transaction_list_no_data.tpl', 'f91882c034dcec76ed668d2fa6e5863f');
        $this->checkFile('themes/merchants/Bootstrap/transaction_panel.tpl', '4f6297bd3273c5a64ae474c3989dd834');
        $this->checkFile('themes/merchants/Bootstrap/transaction_reports.tpl', 'ef0c25832283bcfe9d9cc37cd13ac41e');
        $this->checkFile('themes/merchants/Bootstrap/transactions_import.tpl', '18ea606dee038315e72e0e1049666ca3');
        $this->checkFile('themes/merchants/Bootstrap/trash.tpl', '270d020eabfcf284be7a97e7102924d5');
        $this->checkFile('themes/merchants/Bootstrap/tree_affiliate_widget.tpl', 'd6d133404cf44bcd4d057ddc9e0b573f');
        $this->checkFile('themes/merchants/Bootstrap/tree_draggable_items.tpl', '869b3cbe1a546cf76baa397b8360495b');
        $this->checkFile('themes/merchants/Bootstrap/trend_actions_stats.tpl', '01beef973c394417de5a58de2857a1e5');
        $this->checkFile('themes/merchants/Bootstrap/trend_actions_stats_widget.tpl', '7c26676ceb09baf3fafeb0dba3bdaec4');
        $this->checkFile('themes/merchants/Bootstrap/trend_stats.tpl', '5423abd62baeb237c0c5feb600e84937');
        $this->checkFile('themes/merchants/Bootstrap/trends_report.stpl', '18264d58de48af1de2b77137b0df48fb');
        $this->checkFile('themes/merchants/Bootstrap/trends_report.tpl', '8c3ecd3db7c864a8cbbd04e92363467c');
        $this->checkFile('themes/merchants/Bootstrap/trends_report_action.stpl', '929fa1c9535d05f1e8a0492013b9de33');
        $this->checkFile('themes/merchants/Bootstrap/trends_report_filter.tpl', 'cacaca9e199f9c7b74916541a340c31a');
        $this->checkFile('themes/merchants/Bootstrap/trends_report_no_data.tpl', '9d1dd7b6d3ef5f6ada42de2c7d182df2');
        $this->checkFile('themes/merchants/Bootstrap/troubleshooting.tpl', '8ec5482d68f08a103cf0883b10308e9f');
        $this->checkFile('themes/merchants/Bootstrap/update_version.stpl', '5602f52fe8248df474201a16c922048f');
        $this->checkFile('themes/merchants/Bootstrap/upload_panel.tpl', '222a0dd80ab37bb49060da0cf7eaf447');
        $this->checkFile('themes/merchants/Bootstrap/uploaded_file.tpl', 'fad11b13e3b41eff41a129b1af232e7e');
        $this->checkFile('themes/merchants/Bootstrap/user_edit.tpl', 'f41ba1817ee0d15f16c57dff5be39bb1');
        $this->checkFile('themes/merchants/Bootstrap/vat_settings.tpl', '628456504f54a037d9ba2f08ba3fbdc5');
        $this->checkFile('themes/merchants/Bootstrap/verify_panel.tpl', '79aa97bc204438e497a55b8e96ee3f6b');
        $this->checkFile('themes/merchants/Bootstrap/view_form.tpl', 'e37b380ed96bef78dc0de97ac2a3e379');
        $this->checkFile('themes/merchants/Bootstrap/view_form_edit_views.tpl', '957cda42f99a863bd72988472e4d008f');
        $this->checkFile('themes/merchants/Bootstrap/view_panel.tpl', '25340a99e4e6b4627de427ada4d1b2bc');
        $this->checkFile('themes/merchants/Bootstrap/views_list.tpl', 'eb42ebb392f0237879dfba6547578e98');
        $this->checkFile('themes/merchants/Bootstrap/visitor_affiliate_edit.tpl', '61506b2d8b383293922a9cc4929438da');
        $this->checkFile('themes/merchants/Bootstrap/visitor_affiliates_filter.tpl', '44d9d5e8bf93948d6220d00187359183');
        $this->checkFile('themes/merchants/Bootstrap/visitor_affiliates_list.tpl', '3493ae8f6c4fb7e655667b20a0b46ce9');
        $this->checkFile('themes/merchants/Bootstrap/visitor_nonrefclicks_filter.tpl', '6ef69cf81734100ad5d5cf1339ee0ad7');
        $this->checkFile('themes/merchants/Bootstrap/visitor_nonrefclicks_list.tpl', '202a7982f1ad5ae2e2310347969b8713');
        $this->checkFile('themes/merchants/Bootstrap/visits_sales_log_add.tpl', 'e8d580c16c576c3ec98c1baedac437fa');
        $this->checkFile('themes/merchants/Bootstrap/visits_sales_logs_filter.tpl', '5ffb18e5d3dcb8df3f61a03331c91552');
        $this->checkFile('themes/merchants/Bootstrap/visits_sales_logs_list.tpl', '2f2c6cb4ab210272ffd87e4d3bff95b4');
        $this->checkFile('themes/merchants/Bootstrap/visits_sales_logs_no_data.tpl', '969b350cc45c6f7c68fa6322e98a3de1');
        $this->checkFile('themes/merchants/Bootstrap/wallpaper_add_custom.tpl', '2210741b569ef188fa352c977a289261');
        $this->checkFile('themes/merchants/Bootstrap/wallpaper_entry.tpl', '64c85f4da7897cd0f34168c62de661b9');
        $this->checkFile('themes/merchants/Bootstrap/wallpaper_settings.tpl', 'd160dbed38556231aeac49a96213e4d4');
        $this->checkFile('themes/merchants/Bootstrap/welcome_message_panel.tpl', '86f2e7b763c27c55f65b269cd8b95a0d');
        $this->checkFile('themes/merchants/Bootstrap/window.tpl', '2391705887d707e05187606c4a819e73');
        $this->checkFile('themes/merchants/Bootstrap/window_bottom_left.tpl', 'd14b545c27afa02ab7a919bdeb4c9470');
        $this->checkFile('themes/merchants/Bootstrap/window_empty_content.tpl', 'b1535ec719cada5b9f5d98849074b9bd');
        $this->checkFile('themes/merchants/Bootstrap/window_header.tpl', '02a337d4184c3924a2792a84493794cc');
        $this->checkFile('themes/merchants/Bootstrap/window_header_refresh.tpl', 'fcd47f4585abcac3c3a61ee3991379bc');
        $this->checkFile('themes/merchants/Bootstrap/window_left.tpl', '984d69649ec171a5c6b522e795feb904');
        $this->checkFile('themes/merchants/Bootstrap/window_move_panel.tpl', 'f5bbd373a758bf76e6efadc94dca4b11');
        $this->checkFile('themes/merchants/Bootstrap/wizard_panel.tpl', '3142ce6354cb3e1c86b6c13c1d906189');
        $this->checkFile('themes/merchants/Bootstrap/zip_banner_feature_on_deactivate.tpl', '0d58a97804ba953e180301d3bb0d1a37');
        $this->checkFile('themes/merchants/Compact/TreeItemWidget.tpl', 'd1bfa5574da9cfa131eef997e0870e92');
        $this->checkFile('themes/merchants/Compact/account_form.tpl', 'bec2cc19f2320dfebd3e493c97eeae52');
        $this->checkFile('themes/merchants/Compact/account_form_show.tpl', '481066cec1fdf42f68f2db4c2fabca35');
        $this->checkFile('themes/merchants/Compact/account_form_view.tpl', '3c3a69f103776f35bf195a27db899cb9');
        $this->checkFile('themes/merchants/Compact/account_fraud_protection_clicks.tpl', '559a9b6630eb145dbdc5fa575a97ecb0');
        $this->checkFile('themes/merchants/Compact/account_fraud_protection_sales.tpl', '1eabaf9f7df78e8502403383c9393ad9');
        $this->checkFile('themes/merchants/Compact/account_info_data.tpl', '48e5394b52c65f2174b235bcd7ec792c');
        $this->checkFile('themes/merchants/Compact/account_notifications_form.tpl', '1fb8f96e9b5c02448da103459cdf6aa7');
        $this->checkFile('themes/merchants/Compact/account_private_campaign_settings.tpl', '940f4bcdbf2de9045887c436f31300ab');
        $this->checkFile('themes/merchants/Compact/account_screen.tpl', '738e8b0997ff8592a4524b3f6c6c4ad6');
        $this->checkFile('themes/merchants/Compact/account_settings.tpl', 'bef40a405c258ac960ea1370e7d02de7');
        $this->checkFile('themes/merchants/Compact/account_signup_settings_form.tpl', '68d7a20fdb3a245a8444d5ea27924b4c');
        $this->checkFile('themes/merchants/Compact/accounting_filter.tpl', '0943670f8ba31ff555e7dc4e5915fdf3');
        $this->checkFile('themes/merchants/Compact/accounting_gadget_data.tpl', 'd94f4bee085512317d28081b9f1d5c26');
        $this->checkFile('themes/merchants/Compact/accounting_gadget_template.tpl', '99927018924623a51361c651857aa116');
        $this->checkFile('themes/merchants/Compact/accounting_panel.tpl', 'd7f9fabde5bcf7c62aba29d35b80238b');
        $this->checkFile('themes/merchants/Compact/accounting_stats_data.tpl', '4f714be5959067fa8962919a6c50bb8c');
        $this->checkFile('themes/merchants/Compact/accounts_fields.tpl', '1d3c5c66916b50467c03d8602aa291c5');
        $this->checkFile('themes/merchants/Compact/accounts_filter.tpl', 'dd123439f945f76b09422ad55b2bd4cb');
        $this->checkFile('themes/merchants/Compact/accounts_invoices_panel.tpl', '72549ab9f2c93fa123b3a3d92bf79c25');
        $this->checkFile('themes/merchants/Compact/accounts_panel.tpl', '77b8fd37eb4f0427cf2b3a6f757e30d8');
        $this->checkFile('themes/merchants/Compact/add_affiliate_page.tpl', 'e69a0888131f7a941dc7e7c744f5dd11');
        $this->checkFile('themes/merchants/Compact/add_affiliate_page_content.tpl', '0f11dbecb7f2f1eea6ab769eb625e322');
        $this->checkFile('themes/merchants/Compact/add_affiliate_page_page.tpl', '70a1f240785c415fb99947f94972de26');
        $this->checkFile('themes/merchants/Compact/add_affiliate_page_url.tpl', '58f8f5e302e28d28522e7265e3694665');
        $this->checkFile('themes/merchants/Compact/add_affiliate_to_campaign.tpl', 'ddb8f68a2edb3955a5a209e11442b1bf');
        $this->checkFile('themes/merchants/Compact/add_affiliate_to_group.tpl', '4f69927d7cad9e8466fe91bd3e3af69c');
        $this->checkFile('themes/merchants/Compact/add_custom_translation.tpl', '91a22a74346db521569588e934048e79');
        $this->checkFile('themes/merchants/Compact/add_gadget_category.tpl', 'e2ec9306de4bf074a33e72c96ff238ca');
        $this->checkFile('themes/merchants/Compact/add_gadget_panel.tpl', 'be8c80e8aff49f52f5b5c1b79be9526f');
        $this->checkFile('themes/merchants/Compact/add_gadget_select_url.tpl', 'b9e3459257a1d9c8a6c66009c826d06c');
        $this->checkFile('themes/merchants/Compact/add_transaction_form.tpl', '6c9da9a05ee604bb7ad0cc4225c07e88');
        $this->checkFile('themes/merchants/Compact/add_user_to_group_form.tpl', 'f5353d26cbc32f5b59f99d0388244462');
        $this->checkFile('themes/merchants/Compact/additional_dynamic_form_panel.tpl', '39fe1aad3bb309004ee15c8537c90d15');
        $this->checkFile('themes/merchants/Compact/admin_panel.tpl', '974dc9641d622a6723650da268bebf5f');
        $this->checkFile('themes/merchants/Compact/admins_panel.tpl', '043af9e3cecec2e85866aa06c2a04a37');
        $this->checkFile('themes/merchants/Compact/admins_panel_filter.tpl', '4ec418856a865586f6d6ed313e0cffb6');
        $this->checkFile('themes/merchants/Compact/advanced_email_settings_form.tpl', '304064505236c0bb68e3a8f4bc3b1c08');
        $this->checkFile('themes/merchants/Compact/advanced_email_settings_tab.tpl', '4cdac3ab7ec6827e1307d48028f2d835');
        $this->checkFile('themes/merchants/Compact/advanced_integration_steps_icons.tpl', 'fc1f4fb9ee86fc80e6ef1e365e0d77f5');
        $this->checkFile('themes/merchants/Compact/aff_notifications_form.tpl', '10c7955484538d42dd52ccfcef274408');
        $this->checkFile('themes/merchants/Compact/affilate_advanced_filter.tpl', '11bde2dcecd82caeeb4616944f36ff5b');
        $this->checkFile('themes/merchants/Compact/affiliate_commission_groups.tpl', '9d4046dbc63fe4b678f8c62ffca79854');
        $this->checkFile('themes/merchants/Compact/affiliate_delete.tpl', '2157c7c0e31996f4fc0f85a185977ac5');
        $this->checkFile('themes/merchants/Compact/affiliate_details.tpl', 'bd86d96ae0a6f75ea0547ca235cabde6');
        $this->checkFile('themes/merchants/Compact/affiliate_edit_commission_groups_no_data.tpl', 'a9756aeb0730e4fd5f4fa9cb6de8012b');
        $this->checkFile('themes/merchants/Compact/affiliate_edit_details.tpl', '40b05e6ccbef405c6d1c7a79d777ebc5');
        $this->checkFile('themes/merchants/Compact/affiliate_edit_details_additional.tpl', '98de15bb9a88b36dc47ba266389cb413');
        $this->checkFile('themes/merchants/Compact/affiliate_edit_dialog.tpl', 'acaf92b10f7821b0f5794593db70df01');
        $this->checkFile('themes/merchants/Compact/affiliate_edit_no_payout_history.tpl', '0d40b1e330f67d9e74c3890beca74b29');
        $this->checkFile('themes/merchants/Compact/affiliate_fields.tpl', '93029409e097c73c17e08e7b8aa22058');
        $this->checkFile('themes/merchants/Compact/affiliate_general_settings.tpl', 'e747d64338280436d5f3478d1f0cb514');
        $this->checkFile('themes/merchants/Compact/affiliate_info_data.tpl', 'b57513f9b5504095638e810826ac3e63');
        $this->checkFile('themes/merchants/Compact/affiliate_list.tpl', 'cc032a88a7775b2938522ca3f58dc755');
        $this->checkFile('themes/merchants/Compact/affiliate_list_no_data.tpl', '7741570acae759090cf04aeb6f313bb2');
        $this->checkFile('themes/merchants/Compact/affiliate_logins.tpl', '9f5432cc0f1f1bb464a38a23fb16e6e3');
        $this->checkFile('themes/merchants/Compact/affiliate_logins_header.tpl', '7fc020dd9a1268955faaf16b973b82c7');
        $this->checkFile('themes/merchants/Compact/affiliate_logins_map.tpl', '76fe92abae4eacb0bfbd670ac54aa0b3');
        $this->checkFile('themes/merchants/Compact/affiliate_menu_settings.tpl', '3507cb91be549e264e21b007c3571ba8');
        $this->checkFile('themes/merchants/Compact/affiliate_panel_config.tpl', '99bc43fef7dbe936c4e733215585a277');
        $this->checkFile('themes/merchants/Compact/affiliate_payout_settings.tpl', '8304e34183caa27262c69cec69c12373');
        $this->checkFile('themes/merchants/Compact/affiliate_postsignup_settings.tpl', '295c4b2802684750cc74e93282fb5732');
        $this->checkFile('themes/merchants/Compact/affiliate_screen_detail.tpl', '1075539ad2bdd3dd1eeb74078b054f03');
        $this->checkFile('themes/merchants/Compact/affiliate_screen_header_edit.tpl', 'cb37af28ddbd0c61c9abadf675e7d8bc');
        $this->checkFile('themes/merchants/Compact/affiliate_screen_settings.tpl', '5fb92d5bc22ff7ede5ec1572ef94ced9');
        $this->checkFile('themes/merchants/Compact/affiliate_screen_settings_nodata.tpl', 'bb4ad3e2d922192ec998ee5ae5c51e50');
        $this->checkFile('themes/merchants/Compact/affiliate_screens_list.tpl', '08ad8cbadce365f01978ef5f8b0c7d32');
        $this->checkFile('themes/merchants/Compact/affiliate_signup_settings.tpl', 'c9a8f99f2c61ead6d8bdb0d125e0f183');
        $this->checkFile('themes/merchants/Compact/affiliate_signup_settings_button.tpl', 'adccd555745134a857328990ed086077');
        $this->checkFile('themes/merchants/Compact/affiliate_signup_settings_form.tpl', 'eb832a062e7059bb5074dbeec7f2f890');
        $this->checkFile('themes/merchants/Compact/affiliate_stats.tpl', 'b1c8b06e198d9ed22a5564a73ff26e0e');
        $this->checkFile('themes/merchants/Compact/affiliate_subaffiliates.tpl', '633205fc5244112afa932c8b18f58edd');
        $this->checkFile('themes/merchants/Compact/affiliate_tracking_code_filter.tpl', '614c11facd7d5ebaee38deae93e139c9');
        $this->checkFile('themes/merchants/Compact/affiliate_tracking_code_panel.tpl', '2563d59c5d920af9e929d25715e3758e');
        $this->checkFile('themes/merchants/Compact/affiliate_tracking_cookiepanel.tpl', 'afe8791a0c4895979c261a672103de97');
        $this->checkFile('themes/merchants/Compact/affiliate_tracking_options.tpl', '85a3391abee5f9a8dc727fe266534ed8');
        $this->checkFile('themes/merchants/Compact/affiliate_tracking_testlinks.tpl', '3407045ee29fe67b40621cdb381ff40e');
        $this->checkFile('themes/merchants/Compact/affiliate_tree.tpl', '875e8e5d865578c1b5efe31580b9e719');
        $this->checkFile('themes/merchants/Compact/affiliate_tree_filter.tpl', 'c676ed3f6a9ee3860ad9e60e62dbab86');
        $this->checkFile('themes/merchants/Compact/affiliate_tree_filter_edit.tpl', '959100eeceade475bc20ec5272660a38');
        $this->checkFile('themes/merchants/Compact/affiliate_tree_panel.tpl', '9ddd4e10bea7ad43a028f867760df9d6');
        $this->checkFile('themes/merchants/Compact/affiliate_url_page_editor.tpl', '1563cbaaa42ab9c7c0c8898a17b3b10a');
        $this->checkFile('themes/merchants/Compact/affiliate_urls_no_data.tpl', 'c9868414093445accf0f0d7551847116');
        $this->checkFile('themes/merchants/Compact/affiliates_group.tpl', 'e1f5bcb91bd2f949694890186ff3566a');
        $this->checkFile('themes/merchants/Compact/affiliates_group_filter.tpl', '466c832f6c6b327cbee63030a81d410c');
        $this->checkFile('themes/merchants/Compact/affiliates_import.tpl', '5d25493eca047e7b66627090a7bcf423');
        $this->checkFile('themes/merchants/Compact/affpanel_design.tpl', '47558761ee69c8a906f6b3f3c0b7fe1e');
        $this->checkFile('themes/merchants/Compact/after_signup_actions_fields_no_data.tpl', '2fe9a7bbd29402632be238ea0cb7f2dd');
        $this->checkFile('themes/merchants/Compact/after_signup_actions_no_data.tpl', 'c9868414093445accf0f0d7551847116');
        $this->checkFile('themes/merchants/Compact/after_signup_no_data.tpl', 'acc4136ac3d8c01816ce79b2281ca9f1');
        $this->checkFile('themes/merchants/Compact/align_widget.tpl', '124769dbcc410ae58c1dfd53f15b58d6');
        $this->checkFile('themes/merchants/Compact/api_integration.tpl', '87329cb5ed35f3bfbb29e45947ae8bab');
        $this->checkFile('themes/merchants/Compact/assigment.tpl', '48b84b37bf127adc78ef230b61a22e60');
        $this->checkFile('themes/merchants/Compact/assign_auto_panel.tpl', '4414ff53bc35c96dd1932aa630eb128f');
        $this->checkFile('themes/merchants/Compact/audit_log_filter.tpl', '67c7322e9a203c85a10210cb496b110e');
        $this->checkFile('themes/merchants/Compact/available_values_edit.tpl', 'e96fa729b9a61e7e4a21fbddf80565fb');
        $this->checkFile('themes/merchants/Compact/banner_and_link_form_panel.tpl', '5c7a5c4a303dffe6d76424abd90a0236');
        $this->checkFile('themes/merchants/Compact/banner_button.tpl', 'e1cb4d807552c33476c9dc37bca24dc6');
        $this->checkFile('themes/merchants/Compact/banner_category_edit.tpl', '2fc9f159a4666a456e4de83356cf2511');
        $this->checkFile('themes/merchants/Compact/banner_category_item.tpl', '55fcd96a4eabd7825f722f3f36bab5d4');
        $this->checkFile('themes/merchants/Compact/banner_category_selector.tpl', 'ba32ee51a99861b1a19d9b66e45f4db0');
        $this->checkFile('themes/merchants/Compact/banner_category_settings_panel.tpl', 'fa002655c612fad61b7cd5121e786391');
        $this->checkFile('themes/merchants/Compact/banner_clone_dialog.tpl', '87df8d4453785b4924425c45fc252f20');
        $this->checkFile('themes/merchants/Compact/banner_destination_url_panel.tpl', 'd2cf85ec3a941d8acc4f8c673c3c2781');
        $this->checkFile('themes/merchants/Compact/banner_destinations.tpl', 'c2466e9211af205aaa302153ecf54ec0');
        $this->checkFile('themes/merchants/Compact/banner_details.tpl', '02ec398758e8c9d094be8ddd3dea86e9');
        $this->checkFile('themes/merchants/Compact/banner_details_params.tpl', 'daca6d0de978ff1a272adbe072455399');
        $this->checkFile('themes/merchants/Compact/banner_edit_header.tpl', '8be5daca610e30e2fc600a9c8a03cf56');
        $this->checkFile('themes/merchants/Compact/banner_edit_panel.tpl', 'd371721abec7a70439373826893749c8');
        $this->checkFile('themes/merchants/Compact/banner_filter.tpl', 'c329bee9165d04cc757e990a92c1b019');
        $this->checkFile('themes/merchants/Compact/banner_format_form.tpl', '5f8fd9d50c3f4817158302d1834f7e26');
        $this->checkFile('themes/merchants/Compact/banner_in_rotator_edit_panel.tpl', '331b8b61058b5f85750cc690e63d08cc');
        $this->checkFile('themes/merchants/Compact/banner_list_no_data.tpl', '6ec4d243cc9d9b0ee86612709590882e');
        $this->checkFile('themes/merchants/Compact/banner_manager.tpl', '18d6d96df57962f8d1a9b8effe339b15');
        $this->checkFile('themes/merchants/Compact/banner_name.tpl', '0e8385998fddbc3260837cf0590a35a5');
        $this->checkFile('themes/merchants/Compact/banner_or_link_edit_template_panel.tpl', '346160178349fe7d0b8f4f55bbf96ecd');
        $this->checkFile('themes/merchants/Compact/banner_or_link_not_selected.tpl', '180941a437e8e722a4b7f7b44e73e0f0');
        $this->checkFile('themes/merchants/Compact/banner_own_size_panel.tpl', 'ec916344f7150972a863c771ccb676df');
        $this->checkFile('themes/merchants/Compact/banner_parameters_coupon.tpl', 'd7c6fc6e00c9e11d262f7c767454b9c7');
        $this->checkFile('themes/merchants/Compact/banner_parameters_flash.tpl', 'a6356eb54289b4b062c0250c5e9b7963');
        $this->checkFile('themes/merchants/Compact/banner_parameters_hover.tpl', 'f15317ed6c2ed30c9a2e897dbaaa79a6');
        $this->checkFile('themes/merchants/Compact/banner_parameters_html.tpl', 'f00f7657b51377b05cca05db4a27b4bf');
        $this->checkFile('themes/merchants/Compact/banner_parameters_image.tpl', 'f4227e6ffab89f9fecf00de0db1ea261');
        $this->checkFile('themes/merchants/Compact/banner_parameters_pagepeel.tpl', 'f0477017e173b2a6d887e3eabe77ccc8');
        $this->checkFile('themes/merchants/Compact/banner_parameters_pagepeelhtml.tpl', 'c4722a470e19f5966ee208dfd75b72cd');
        $this->checkFile('themes/merchants/Compact/banner_parameters_pdf.tpl', 'b02138b4e56eb4d1b40be08282348643');
        $this->checkFile('themes/merchants/Compact/banner_parameters_promo_email.tpl', '5d558a2ce40bd6997c670115425bc67b');
        $this->checkFile('themes/merchants/Compact/banner_parameters_rebrandpdf.tpl', '11451d812f2b92bf7928f77a448252ba');
        $this->checkFile('themes/merchants/Compact/banner_parameters_rebrandpdf_allvars.tpl', 'c01f39df6d7b58ed19794de908c314b2');
        $this->checkFile('themes/merchants/Compact/banner_parameters_rebrandpdf_filefield.tpl', '4f3e422e757c8bd5c3460a24dd453153');
        $this->checkFile('themes/merchants/Compact/banner_parameters_rotator.tpl', 'be18e74db4df618a8452b053fed379b6');
        $this->checkFile('themes/merchants/Compact/banner_parameters_site.tpl', '80b74b4c7419b3fd362fcffb1ebe0639');
        $this->checkFile('themes/merchants/Compact/banner_parameters_site_files.tpl', 'ce4cb65e15ec625747ee5a7359ad123b');
        $this->checkFile('themes/merchants/Compact/banner_parameters_site_files_local.tpl', 'a7f630aa7eb54c3cb467cb80f17674cc');
        $this->checkFile('themes/merchants/Compact/banner_parameters_site_files_url.tpl', '9e1571660d6fab85245ee3418abd1350');
        $this->checkFile('themes/merchants/Compact/banner_parameters_site_preview.tpl', '7dcf0d92d184a60ff334ad28adb1fd66');
        $this->checkFile('themes/merchants/Compact/banner_parameters_site_variables.tpl', 'adb74a84e21883cd904c0732316c0bce');
        $this->checkFile('themes/merchants/Compact/banner_parameters_zip.tpl', '262a21aedc240fc1e154b3274cf38cf5');
        $this->checkFile('themes/merchants/Compact/banner_parameters_zip_bannerpreview.tpl', '919258983eb853742ec1aabd2505f388');
        $this->checkFile('themes/merchants/Compact/banner_parameters_zip_files.tpl', '0d3f2c5edba5f03f8fb35dcbaeeebae2');
        $this->checkFile('themes/merchants/Compact/banner_parameters_zip_variables.tpl', 'bea861fe51d3a9e95f9ae5e5cf9c4e81');
        $this->checkFile('themes/merchants/Compact/banner_params_link.tpl', '16e7b10d24dd70483e8c67184d3ec46f');
        $this->checkFile('themes/merchants/Compact/banner_params_text_link.tpl', '36887496682c2c2872c526ca6acba1fd');
        $this->checkFile('themes/merchants/Compact/banner_preview.tpl', '75b30e1735f8ec02072cb2aa83a06047');
        $this->checkFile('themes/merchants/Compact/banner_preview_field.tpl', '71e5ce8dff03853ca9e30de9dfe5006c');
        $this->checkFile('themes/merchants/Compact/banner_preview_widget.tpl', 'f21248876762eecce70f4f6a6d64cad1');
        $this->checkFile('themes/merchants/Compact/banner_rotator_feature_on_deactivate.tpl', 'a1bfe671194574c6d8b231e70bbd0f08');
        $this->checkFile('themes/merchants/Compact/banner_size.tpl', 'e74a26d2165d73dc5a842acd7f481c97');
        $this->checkFile('themes/merchants/Compact/banner_stats_filter.tpl', '99385b61d4e01703bc055a1a910564a1');
        $this->checkFile('themes/merchants/Compact/banner_stats_list.tpl', '3e71f3763376f08380959fe865aad875');
        $this->checkFile('themes/merchants/Compact/banner_stats_list_no_data.tpl', '2bac0448c515370fac072b46a74938ec');
        $this->checkFile('themes/merchants/Compact/banner_with_category_filter_field.tpl', 'dd1d3439d1f76c0deda21232287fbdd2');
        $this->checkFile('themes/merchants/Compact/banner_wrapper_edit_panel.tpl', 'e13d8f01e20f4fa82847845bfac1026b');
        $this->checkFile('themes/merchants/Compact/banner_wrappers_table.tpl', '54f784f44c21afa6941daecd6088cd4a');
        $this->checkFile('themes/merchants/Compact/banners_and_links_format.tpl', 'a298ada6f4a07b79050cb51d23ac099f');
        $this->checkFile('themes/merchants/Compact/banners_categories_list.tpl', '4b6c1997242f90357b1c721a4303d816');
        $this->checkFile('themes/merchants/Compact/banners_categories_tree.tpl', 'fc55213c31030c3a47d4b80338c88783');
        $this->checkFile('themes/merchants/Compact/bannerscategories_no_data.tpl', '3df35d8c385cfc14c75759c80f11aa02');
        $this->checkFile('themes/merchants/Compact/bannerscategories_not_in_category.tpl', 'b4797977dcf354a6a7c77745910e839a');
        $this->checkFile('themes/merchants/Compact/branding_config.tpl', 'bd94806a4df51742d143a23dec8f2cdb');
        $this->checkFile('themes/merchants/Compact/breadcrumbs.tpl', '9981a5d8af1fb510574d67a2e0ba2481');
        $this->checkFile('themes/merchants/Compact/breadcrumbs_entry.tpl', '42ee9a25b7525589ed65bf9625adc890');
        $this->checkFile('themes/merchants/Compact/button.tpl', '40db744b463f7f71d97cd92ff46fecf4');
        $this->checkFile('themes/merchants/Compact/buy_feature.tpl', 'adfbf6783ae850e63499a923231e4f37');
        $this->checkFile('themes/merchants/Compact/calendar.tpl', 'd6831aa786acf1f829a90cec776126eb');
        $this->checkFile('themes/merchants/Compact/campaign_account.tpl', '9e2989cc05bb9dac952b80a40246e4e2');
        $this->checkFile('themes/merchants/Compact/campaign_capping.tpl', 'b9f6737a4b04f0eca0d7957191b51231');
        $this->checkFile('themes/merchants/Compact/campaign_category_edit.tpl', 'd1460a8d0cb69f821b18051a81907550');
        $this->checkFile('themes/merchants/Compact/campaign_category_item.tpl', 'de7ade79ce37b86264373c01e9ad4149');
        $this->checkFile('themes/merchants/Compact/campaign_category_selector.tpl', '4618de8975b4a1f2b94d168304707892');
        $this->checkFile('themes/merchants/Compact/campaign_category_settings_panel.tpl', '18e7ac241cca0c4c360bcf45e7d2ef71');
        $this->checkFile('themes/merchants/Compact/campaign_commissions_tab.tpl', '52c31b8ce3af03ce54ae51917ff87b7a');
        $this->checkFile('themes/merchants/Compact/campaign_filter.tpl', '7f3514d50b873ca8f3e464ad67139a31');
        $this->checkFile('themes/merchants/Compact/campaign_form_edit.tpl', 'b0f898bce9f2960a5b7b1ce53e4eb048');
        $this->checkFile('themes/merchants/Compact/campaign_form_show.tpl', '9bd49430f9655da593402eb6d221a59d');
        $this->checkFile('themes/merchants/Compact/campaign_list_no_data.tpl', 'd44d658e6b3fb7b4b2f6e0e3bbe938c7');
        $this->checkFile('themes/merchants/Compact/campaign_rule_conditions_panel.tpl', 'd4f35ff94140ca1eb7a5e28dbfd22d0c');
        $this->checkFile('themes/merchants/Compact/campaign_rule_conditions_panel_full.tpl', '46ac5265ab6c374aaae2b3c13d4a7734');
        $this->checkFile('themes/merchants/Compact/campaign_schedule_nodata.tpl', '3e87dc9b305506f1f13895478de1ee2e');
        $this->checkFile('themes/merchants/Compact/campaign_scheduler.tpl', '20870e8e684fb12348a0ade8874d66c8');
        $this->checkFile('themes/merchants/Compact/campaign_scheduling_rule_panel.tpl', 'b0403d7927d7e01cb056da9027b82a8b');
        $this->checkFile('themes/merchants/Compact/campaign_screen.tpl', '48d3e63714873d79a6092b2aa0417dd9');
        $this->checkFile('themes/merchants/Compact/campaign_screen_edit.tpl', '4dd40cd4020a39e251a16d01ffa65723');
        $this->checkFile('themes/merchants/Compact/campaign_shortdetails_form.tpl', '99bd3a0b3e5790f2307e9b897dcd6811');
        $this->checkFile('themes/merchants/Compact/campaign_stats_filter.tpl', '656adb646eecec0d3f5091cfce68095d');
        $this->checkFile('themes/merchants/Compact/campaign_stats_list.tpl', 'e45c163f75670253d0dcc5037f7168e2');
        $this->checkFile('themes/merchants/Compact/campaign_stats_list_no_data.tpl', '6991606b8141a584b01311f5eb86bb51');
        $this->checkFile('themes/merchants/Compact/campaign_status.tpl', 'b732873daaced1e1e9aa43cb2f4c09fa');
        $this->checkFile('themes/merchants/Compact/campaign_step_create.tpl', '2d419b7525bdd89abdec8c0d31d1f71d');
        $this->checkFile('themes/merchants/Compact/campaign_type.tpl', '831bfbcebd1f2ccb1040cfdaa2291011');
        $this->checkFile('themes/merchants/Compact/campaign_validity_edit.tpl', '22198581b13ee3fbd1e3729236df3189');
        $this->checkFile('themes/merchants/Compact/campaign_with_category_filter_field.tpl', 'baf1267e1481cb1cf5433a0ccaf80ee8');
        $this->checkFile('themes/merchants/Compact/campaign_wizard.tpl', 'e6f7ad6b18e7c273490cea2a19a19654');
        $this->checkFile('themes/merchants/Compact/campaigns_categories_list.tpl', '8169d41f1880ba87724c80ce89553605');
        $this->checkFile('themes/merchants/Compact/campaigns_categories_tree.tpl', '2d96c71a0f30a75176ae42f055de8ad0');
        $this->checkFile('themes/merchants/Compact/campaigns_grid_settings_affiliate_panel.tpl', '6830692ae10fdc0b2083cc58268baa4c');
        $this->checkFile('themes/merchants/Compact/campaigns_list.tpl', '983019d6bd514bd1a348f8ad840b8c7a');
        $this->checkFile('themes/merchants/Compact/campaignscategories_no_data.tpl', '7d8325a745599a8d918ac08217275012');
        $this->checkFile('themes/merchants/Compact/campaignscategories_not_in_category.tpl', '0dd23250bcee882b765ec32ad21249af');
        $this->checkFile('themes/merchants/Compact/captcha.tpl', '0326fedb283400e2c13eeae155d7b536');
        $this->checkFile('themes/merchants/Compact/category_list.tpl', '579457d7da6e88deda06b092844c5c52');
        $this->checkFile('themes/merchants/Compact/change_status_button.tpl', 'a0d13402819088b5078e8100a21a0159');
        $this->checkFile('themes/merchants/Compact/chart_datatype_popup.tpl', '7a1a0e024c8392ea5df8cd40b179d4f7');
        $this->checkFile('themes/merchants/Compact/check_box_group.tpl', 'e182dd7429a276dc85e09049b2a6c19e');
        $this->checkFile('themes/merchants/Compact/check_box_group_row.tpl', '97219c5c2d3c996953fd6bd882e6200c');
        $this->checkFile('themes/merchants/Compact/checkboxes_filter.tpl', 'fef5c1833920987bd3172dbe9d75797a');
        $this->checkFile('themes/merchants/Compact/clicks_list.tpl', 'bd1179311cf04f759ddcc79744179a93');
        $this->checkFile('themes/merchants/Compact/clicks_list_filter_base.tpl', '6b6ac3cc08d8a1d3a9d3e6e1e473a962');
        $this->checkFile('themes/merchants/Compact/clicks_list_no_data.tpl', 'e2f13b9b96a4f0a248ea753b0c7c9178');
        $this->checkFile('themes/merchants/Compact/clicks_tracking.tpl', 'a017892f84d373c678ecdc5276f9e6c3');
        $this->checkFile('themes/merchants/Compact/colorpicker.tpl', '297c4e74e89b8b3dedd12e7c319bce41');
        $this->checkFile('themes/merchants/Compact/commission_edit_values.tpl', 'b277423c214667a9202d3aefac1d7619');
        $this->checkFile('themes/merchants/Compact/commission_edit_values_tierpanel.tpl', 'ed403054ea7f2ccb731265f9d3f0ef4f');
        $this->checkFile('themes/merchants/Compact/commission_edit_with_fixedcost.tpl', '3af76ab79f10ff3d0629b1c4b0cc7ba9');
        $this->checkFile('themes/merchants/Compact/commission_group_panel.tpl', 'fbc95c3f3b9a95e9daf3df46d8dc8a2d');
        $this->checkFile('themes/merchants/Compact/commission_groups.tpl', 'cd9f803bcafdc842b0226fa653242f1b');
        $this->checkFile('themes/merchants/Compact/commission_groups_panel.tpl', '44d889bc8bf1f467cbc7d2c18c03c230');
        $this->checkFile('themes/merchants/Compact/commission_recurring.tpl', 'aa827abeee6bb0f472b500c096cd3625');
        $this->checkFile('themes/merchants/Compact/commission_sale.tpl', 'fbdf7f44f6df291e9da9e8172dcad9ce');
        $this->checkFile('themes/merchants/Compact/commission_subsales.tpl', 'c21fc8858085c294ac7630f53d6bd36e');
        $this->checkFile('themes/merchants/Compact/commission_tabs.tpl', '2eec354045cec652c7cd4ff1cfc8bf56');
        $this->checkFile('themes/merchants/Compact/commission_tiers_info_panel.tpl', '20e88ef5e3d641ecd6dd8fea0350b7e1');
        $this->checkFile('themes/merchants/Compact/commission_type_detail.tpl', 'd6d266aba20845c41e04fd8dbfa33732');
        $this->checkFile('themes/merchants/Compact/commission_type_sail_detail.tpl', '73a00350b64b30cb1b5341e050982d83');
        $this->checkFile('themes/merchants/Compact/commissions_details_view.tpl', '6481e92bb25a139b55290e0d5b209cdd');
        $this->checkFile('themes/merchants/Compact/commissions_edit.tpl', '9ec2a9da2c0eaf09392f96b836bc0310');
        $this->checkFile('themes/merchants/Compact/commissions_panel.tpl', 'ff232af7da984c8e346b2bc9b8a6ca88');
        $this->checkFile('themes/merchants/Compact/compressed_commission_settings.tpl', 'b355949c5d9849b51c1f59f96c7e4acc');
        $this->checkFile('themes/merchants/Compact/comunication_overview_panel.tpl', '06ea7c53421b51e4a8fed669637a909f');
        $this->checkFile('themes/merchants/Compact/config_aff_panel.tpl', '58c2a6eae06023e889cee734923b713e');
        $this->checkFile('themes/merchants/Compact/config_affiliates.tpl', '4870980191d1873460bbc2d8894b2bf2');
        $this->checkFile('themes/merchants/Compact/config_communication.tpl', 'b7af569e05800de423c52fc28d7bc40b');
        $this->checkFile('themes/merchants/Compact/config_currencies_form.tpl', 'cdff097c17040c60be3ace45afa62642');
        $this->checkFile('themes/merchants/Compact/config_currency_tab.tpl', '57c84054dcf9ca885c39c1d9bddb860c');
        $this->checkFile('themes/merchants/Compact/config_date_format.tpl', '771f72b6514cd4c9103217a955fb171d');
        $this->checkFile('themes/merchants/Compact/config_language_and_date_form.tpl', '1ad6231d44243a014dd06b3a18709fac');
        $this->checkFile('themes/merchants/Compact/config_overview.tpl', '60db4f006e3afe01077620baf9bc19fa');
        $this->checkFile('themes/merchants/Compact/config_signup_form.tpl', '884261ef7e0c23326874bd92cdda1094');
        $this->checkFile('themes/merchants/Compact/config_system.tpl', '783ebbddb4a39f395967456062db2396');
        $this->checkFile('themes/merchants/Compact/config_theme_panel.tpl', '6c2d25df8475293b96c1048c9fd15fd0');
        $this->checkFile('themes/merchants/Compact/config_themes.tpl', '0bab46cdedf333176ecb62c8cdc1d672');
        $this->checkFile('themes/merchants/Compact/config_tracking.tpl', '81056b36d3ec69a8fac9d843ed7d7240');
        $this->checkFile('themes/merchants/Compact/confirm_dialog.tpl', 'f92a8f6b3081444abf7fc4ab63c99302');
        $this->checkFile('themes/merchants/Compact/confirm_dialog_label_note.tpl', 'f76c3c08642335eb7b3e0ce42bfe753a');
        $this->checkFile('themes/merchants/Compact/confirm_dialog_label_value.tpl', '0c2d427e2c1c8f4545a90a3a56e64580');
        $this->checkFile('themes/merchants/Compact/confirm_dialog_with_checkbox.tpl', '9e1fd32194d6bfabb251bad0645755da');
        $this->checkFile('themes/merchants/Compact/confirm_dialog_with_value.tpl', '46e7630a0a094110f6819ea655683337');
        $this->checkFile('themes/merchants/Compact/content_gadget_panel.tpl', '79428f6a77f38592dfa1716653bbe79b');
        $this->checkFile('themes/merchants/Compact/context_menu.tpl', 'cddf235a2fec1ae75063d576ccdc6185');
        $this->checkFile('themes/merchants/Compact/cookie_lifetime_group.tpl', 'ea8a6a5ad128f265d7d6891a41fdf097');
        $this->checkFile('themes/merchants/Compact/cookies_tab.tpl', '0ee8a325e03187328807a5c149eb90be');
        $this->checkFile('themes/merchants/Compact/copy_campaign.tpl', 'a12f62962eb0cb273f54414f688f091a');
        $this->checkFile('themes/merchants/Compact/copy_user_role.tpl', '31c4493a09a1d2ad96e0c6133399199c');
        $this->checkFile('themes/merchants/Compact/countries_list_scrolling_wrapper.tpl', '4bf0a92924334c72075b4ddafd3b243b');
        $this->checkFile('themes/merchants/Compact/country_commission_type_panel.tpl', 'e7586309287420a9851dc0ab3ce65563');
        $this->checkFile('themes/merchants/Compact/country_select_panel.tpl', '8503f8f693cc44082380626a7b0ebbfc');
        $this->checkFile('themes/merchants/Compact/country_specific_commission_type_panel.tpl', 'db0122ec2a13ac87a9443a6dc4594302');
        $this->checkFile('themes/merchants/Compact/coupons_filter.tpl', '4caab93e4b46d2f0fff1d619536efb8b');
        $this->checkFile('themes/merchants/Compact/coupons_import.tpl', 'e9bb34e160a258ff1deb1dfe55f0e4a5');
        $this->checkFile('themes/merchants/Compact/coupons_panel.tpl', 'dcb054cd9abe5cbea02724014d27c7ef');
        $this->checkFile('themes/merchants/Compact/create_banners_buttons.tpl', 'd981b97a16d7f5620a85944aa8d550f7');
        $this->checkFile('themes/merchants/Compact/cron_job_integration.tpl', '0bd75d5d32d1d775a4c81a7cc1a41cdb');
        $this->checkFile('themes/merchants/Compact/currencies_no_data.tpl', 'e3a2a92b3119abe6bca9ce0b0e505c28');
        $this->checkFile('themes/merchants/Compact/currency_form.tpl', 'dbee13da7abe05b10990f7ee89eee4be');
        $this->checkFile('themes/merchants/Compact/currency_textbox.tpl', 'b25a0b754d14d14452ecb52e0a090d2a');
        $this->checkFile('themes/merchants/Compact/custom.css', '4877ef2467745239a93ebe1e79b2f813');
        $this->checkFile('themes/merchants/Compact/custom_cookie_panel.tpl', 'b1b3a9b5c5aa2b7de8e67fa2975bbf0e');
        $this->checkFile('themes/merchants/Compact/custom_date_panel.tpl', 'c624f3d63d0e94db867529dc13a827d1');
        $this->checkFile('themes/merchants/Compact/custom_filter_element.tpl', 'bf05e5d299fb1982ea8139f2a605846b');
        $this->checkFile('themes/merchants/Compact/custom_filter_field.tpl', '21c8ab135d5d89e320ec85456ec457e0');
        $this->checkFile('themes/merchants/Compact/custom_time_panel.tpl', 'd408a8352774d70124788d61a90493b6');
        $this->checkFile('themes/merchants/Compact/daily_report.tpl', 'ae280bf29c298b0a0e28944cc61c9e86');
        $this->checkFile('themes/merchants/Compact/daily_report_filter.tpl', '4fb9b31f01026eb252955d75c0428d99');
        $this->checkFile('themes/merchants/Compact/data_field.tpl', 'dd553594505158cd53cc285d3a91fe23');
        $this->checkFile('themes/merchants/Compact/data_field_with_help.tpl', '4615cdd789beea34c16b4c1f692a3a3b');
        $this->checkFile('themes/merchants/Compact/database_status_panel.tpl', '57191b13eff4abf914143e15b97bac30');
        $this->checkFile('themes/merchants/Compact/date_number_format_panel.tpl', 'e26284328d2ba7da47d30e8e458c13b1');
        $this->checkFile('themes/merchants/Compact/date_preset_panel.tpl', 'abc7d225baa948aed70cc1073b786fe8');
        $this->checkFile('themes/merchants/Compact/date_range_filter.tpl', '3875dbc075f33ccaac856190ee103557');
        $this->checkFile('themes/merchants/Compact/date_range_filter_field.tpl', '94048704212b6797b7b7a08fb7888da9');
        $this->checkFile('themes/merchants/Compact/date_textbox.tpl', '4d2bf89bd754bbaccc15e48d7a37dd02');
        $this->checkFile('themes/merchants/Compact/daterange_popup.tpl', 'dc1728d13b0440b8df5e12359010168a');
        $this->checkFile('themes/merchants/Compact/datetimepickercontent.tpl', '9771684f29bc88d974cc64283055d1d1');
        $this->checkFile('themes/merchants/Compact/deeplink_generator_network_setting_edit.tpl', '818d1c4a3bb685f4cb6e825a2c577d82');
        $this->checkFile('themes/merchants/Compact/default_campaign_form.tpl', '2524ebdb94130b6701af650fb63c9c68');
        $this->checkFile('themes/merchants/Compact/default_theme_config.tpl', 'fd3377e1da30c75e82ed6db948bc9199');
        $this->checkFile('themes/merchants/Compact/description_panel.tpl', 'eb196bc81ac670a6081876c8d17158c0');
        $this->checkFile('themes/merchants/Compact/design_panel.tpl', 'ee823fb6ea6bc06ff8ab43422a986363');
        $this->checkFile('themes/merchants/Compact/desktop.tpl', 'b653025800e416896bd453246061a535');
        $this->checkFile('themes/merchants/Compact/desktop_gadget.tpl', '21394ff13337e4716860c12b5e4fb312');
        $this->checkFile('themes/merchants/Compact/desktop_main_menu.tpl', '31eb02f3f6b767d24012753d50ff5159');
        $this->checkFile('themes/merchants/Compact/desktop_settings_mode.tpl', '1054d3be606383580f8d521f2d72682f');
        $this->checkFile('themes/merchants/Compact/destination.tpl', '3f11435e707dc3ef178328280ef4614e');
        $this->checkFile('themes/merchants/Compact/destination_panel.tpl', 'f8a860741ffc1e8bdd52437db021caaf');
        $this->checkFile('themes/merchants/Compact/direct_link_form.tpl', '021296b8ff10db11432c3429c779c8a6');
        $this->checkFile('themes/merchants/Compact/direct_link_grid_widget.tpl', '586c3b902d66c903d87e510bca5843ec');
        $this->checkFile('themes/merchants/Compact/directlinks_advanced_filter.tpl', '65c2e2150b56faacebc94ec4eb426935');
        $this->checkFile('themes/merchants/Compact/directlinks_list.tpl', '3047fe6b8e221bb3e186190f6eeeeb3f');
        $this->checkFile('themes/merchants/Compact/directlinks_list_no_data.tpl', 'f1f450f7a011578950f7253089286a34');
        $this->checkFile('themes/merchants/Compact/disclosure_content.tpl', '27557135898f8d0dc1ff849cba4f875a');
        $this->checkFile('themes/merchants/Compact/download_auto_reg_banner_form.tpl', '8ef3e7205380f487fa84bc4eaf5f5c63');
        $this->checkFile('themes/merchants/Compact/download_auto_reg_iframe_form.tpl', '59498b35efce960fd3b4871d26d7855b');
        $this->checkFile('themes/merchants/Compact/download_auto_reg_link_form.tpl', '33484bae042f1bde3a5a163eab5570f0');
        $this->checkFile('themes/merchants/Compact/download_login_form.tpl', 'd73ed70f4d96b76f37965d9f8c753ac5');
        $this->checkFile('themes/merchants/Compact/download_signup_form.tpl', 'e608aa9b32b4b044d528815cb9392516');
        $this->checkFile('themes/merchants/Compact/drag_container.tpl', '358104feb6f9c3c2a01206e460726eac');
        $this->checkFile('themes/merchants/Compact/dynamic_form_panel.tpl', 'ea42da62b4a44f1fa9caf50a59c29160');
        $this->checkFile('themes/merchants/Compact/edit_affiliate_page_page.tpl', '367f8d79bdffc8cb0dcc344e2c1c79bd');
        $this->checkFile('themes/merchants/Compact/edit_destination_url_widget.tpl', 'd0918936a67033179b7b41946e54ddb5');
        $this->checkFile('themes/merchants/Compact/edit_textarea_widget.tpl', '94b2c94dd103b5209bd89470fc70268c');
        $this->checkFile('themes/merchants/Compact/edit_tracking_code_widget.tpl', '059499fee95c96a9e0fc37b517b0e72a');
        $this->checkFile('themes/merchants/Compact/editor.tpl', 'a8c5483c720526b56fa899a91045c287');
        $this->checkFile('themes/merchants/Compact/editor_with_constants_panel.tpl', '6c9e8d91f33bc90c661e9b67ca5ff1e1');
        $this->checkFile('themes/merchants/Compact/email_form.tpl', '7809f19dc7e837c8dbe6f4d58e6574b7');
        $this->checkFile('themes/merchants/Compact/email_notifications.tpl', '6e8120071227fb823ed1af6f1b3ad223');
        $this->checkFile('themes/merchants/Compact/email_setting_smtp_form.tpl', 'd17124a143f842ab1876ed14a74bc762');
        $this->checkFile('themes/merchants/Compact/email_settings_spf.tpl', 'ca349c37b841ccef522f8767817bf1d2');
        $this->checkFile('themes/merchants/Compact/email_settings_tab.tpl', '029bff75bc5d1d6eda64c14de2c4d88e');
        $this->checkFile('themes/merchants/Compact/email_template_edit_panel.tpl', '0673c3c609ca2fa5a693bcc03986a0d6');
        $this->checkFile('themes/merchants/Compact/expand_matrix.tpl', 'dc72b136436320776269f40795008156');
        $this->checkFile('themes/merchants/Compact/expired_session_dialog.tpl', 'ba711bd5d1e932ffc4fbc8e601204905');
        $this->checkFile('themes/merchants/Compact/export_files_panel.tpl', 'ea4620e2d7d8da656e903d2a1ee80fec');
        $this->checkFile('themes/merchants/Compact/export_panel.tpl', '054b8f0de5cb1cd25ce50d914b6c64a1');
        $this->checkFile('themes/merchants/Compact/export_to_csv.tpl', '472a1e543ad141354022ce9ce4d16e56');
        $this->checkFile('themes/merchants/Compact/extendable_commission_data.tpl', '60acd2ed9b802d2113890dbb7110ae3f');
        $this->checkFile('themes/merchants/Compact/extendable_text.tpl', 'a69efdb298a3aae26e26793c9b9fea36');
        $this->checkFile('themes/merchants/Compact/extendable_text_content.tpl', 'cca4ebdf72f3cb7638b6c5bf0f59d9aa');
        $this->checkFile('themes/merchants/Compact/extendable_text_widget.tpl', '83288dfd8795a2a9105965dde2ebc927');
        $this->checkFile('themes/merchants/Compact/feature_detail.tpl', 'b23eb80665302207d86365efbef72846');
        $this->checkFile('themes/merchants/Compact/feature_on_activate.tpl', '544374f96c5524c306a5c6f6f956200c');
        $this->checkFile('themes/merchants/Compact/feature_on_deactivate.tpl', 'a1767954af4547adcfb12cf4107f3468');
        $this->checkFile('themes/merchants/Compact/feature_settings.tpl', '13e5f54c1b98e65f9a4132abe613c188');
        $this->checkFile('themes/merchants/Compact/fee_panel.tpl', '6c4f808bd9b75f8fc11e4fce3196994c');
        $this->checkFile('themes/merchants/Compact/field_type_edit.tpl', 'b1294ba5d4486ea1cf8022a51e277a11');
        $this->checkFile('themes/merchants/Compact/file_widget.tpl', 'a7410b3e376c1b177c47831f83a68c55');
        $this->checkFile('themes/merchants/Compact/files_tree_panel.tpl', 'e11e884c210779b572bc928e01cf3d96');
        $this->checkFile('themes/merchants/Compact/filter.tpl', 'd51de72535f52fc100a59cad0a15fd37');
        $this->checkFile('themes/merchants/Compact/filter_field_decorator.tpl', '531d57478d7718e216ea04ff79d493ca');
        $this->checkFile('themes/merchants/Compact/filter_form.tpl', '67551720cbc190c8df85c24d3f8a4cbe');
        $this->checkFile('themes/merchants/Compact/font/OpenSans/OpenSans-Bold.ttf', '50145685042b4df07a1fd19957275b81');
        $this->checkFile('themes/merchants/Compact/font/OpenSans/OpenSans-Bold.woff', '9c3358645bea28438a96b34355b58942');
        $this->checkFile('themes/merchants/Compact/font/OpenSans/OpenSans-BoldItalic.ttf', '78b08a68d05d5fabb0b8effd51bf6ade');
        $this->checkFile('themes/merchants/Compact/font/OpenSans/OpenSans-BoldItalic.woff', '58851fad50f52be1f51f4e01ebf38a56');
        $this->checkFile('themes/merchants/Compact/font/OpenSans/OpenSans-Extrabold.ttf', '8bac22ed4fd7c8a30536be18e2984f84');
        $this->checkFile('themes/merchants/Compact/font/OpenSans/OpenSans-Extrabold.woff', '9ccabd1c4ea479b66aeced76b5060c0f');
        $this->checkFile('themes/merchants/Compact/font/OpenSans/OpenSans-ExtraboldItalic.ttf', '73d6bb0d4f596a91992e6be32e82e3bc');
        $this->checkFile('themes/merchants/Compact/font/OpenSans/OpenSans-ExtraboldItalic.woff', 'd73d0d6b2a48d336534b668e7adc981f');
        $this->checkFile('themes/merchants/Compact/font/OpenSans/OpenSans-Italic.ttf', 'c7dcce084c445260a266f92db56f5517');
        $this->checkFile('themes/merchants/Compact/font/OpenSans/OpenSans-Italic.woff', 'c0d39dd78d6397286f2dc292465c3517');
        $this->checkFile('themes/merchants/Compact/font/OpenSans/OpenSans-Light.ttf', '1bf71be111189e76987a4bb9b3115cb7');
        $this->checkFile('themes/merchants/Compact/font/OpenSans/OpenSans-Light.woff', '5193f01d42787bba6c0fbda289658b6f');
        $this->checkFile('themes/merchants/Compact/font/OpenSans/OpenSans-Semibold.ttf', '33f225b8f5f7d6b34a0926f58f96c1e9');
        $this->checkFile('themes/merchants/Compact/font/OpenSans/OpenSans-Semibold.woff', 'bbaf165415d191c0b967d80aed2dea9c');
        $this->checkFile('themes/merchants/Compact/font/OpenSans/OpenSans-SemiboldItalic.ttf', '73f7301a9cd7a086295401eefe0c998f');
        $this->checkFile('themes/merchants/Compact/font/OpenSans/OpenSans-SemiboldItalic.woff', '6da7bfea96b6fce269b93524cb113af6');
        $this->checkFile('themes/merchants/Compact/font/OpenSans/OpenSans.ttf', '629a55a7e793da068dc580d184cc0e31');
        $this->checkFile('themes/merchants/Compact/font/OpenSans/OpenSans.woff', '10bb6c1975b08eb0833d810553a209d3');
        $this->checkFile('themes/merchants/Compact/font/OpenSans/OpenSansLight-Italic.ttf', '6943fb6fd4200f3d073469325c6acdc9');
        $this->checkFile('themes/merchants/Compact/font/OpenSans/OpenSansLight-Italic.woff', 'e8358540a6070aff786c6adece2863db');
        $this->checkFile('themes/merchants/Compact/font/fontello.eot', 'cc4c3813496412813e92ce25c7b963e3');
        $this->checkFile('themes/merchants/Compact/font/fontello.svg', '66090721850d522363f5745b6265983f');
        $this->checkFile('themes/merchants/Compact/font/fontello.ttf', 'baf30392615b9f8dd06420642304e9fb');
        $this->checkFile('themes/merchants/Compact/font/fontello.woff', 'aca17066a8fe19fe88404827ede14eee');
        $this->checkFile('themes/merchants/Compact/font/fontello.woff2', '58f62b369b922e87b001bacc5d4e2274');
        $this->checkFile('themes/merchants/Compact/fontello.css', '7abe36cc2ed0ccbbaad467c15445aa12');
        $this->checkFile('themes/merchants/Compact/footer.stpl', '3fbd103789f1ff2a151c16f490a913dd');
        $this->checkFile('themes/merchants/Compact/forced_matrix_panel.tpl', '0f06e2a7d0482fa847967cd918e0e614');
        $this->checkFile('themes/merchants/Compact/form_field.tpl', '5c7ae4b0f01f4a7753ab811e0a57f29f');
        $this->checkFile('themes/merchants/Compact/form_field_checkbox.tpl', 'c1f1746d1bf5c7abfaf9e5ddb7b4cc52');
        $this->checkFile('themes/merchants/Compact/form_field_checkboxgroup.tpl', 'be1b525a89f033d4f79433dd3eaab593');
        $this->checkFile('themes/merchants/Compact/form_field_radio.tpl', '9013ed97a5fc7b4b52052d816a9b25d0');
        $this->checkFile('themes/merchants/Compact/frame_panel.tpl', '7b13a1add8ba712d8a34f4285414b419');
        $this->checkFile('themes/merchants/Compact/fraud_protection_clicks.tpl', 'dc7b094c9897c52a10a67b4a527e5d31');
        $this->checkFile('themes/merchants/Compact/fraud_protection_form.tpl', 'd0992b66d5f952ca446613a5f74b5f3a');
        $this->checkFile('themes/merchants/Compact/fraud_protection_logins.tpl', '219e554a2a20528c0d83188d36e5cf67');
        $this->checkFile('themes/merchants/Compact/fraud_protection_sales.tpl', '793795df266e0941ce8bccff6813ab07');
        $this->checkFile('themes/merchants/Compact/fraud_protection_signups.tpl', '11dc6c3dd936cdda2667149211a62a19');
        $this->checkFile('themes/merchants/Compact/full_banner_stats.tpl', '9c8d43347b069c27ac3a1af40909a95e');
        $this->checkFile('themes/merchants/Compact/full_commision_stats.tpl', '267321735038275c392ddf30a5c4d35d');
        $this->checkFile('themes/merchants/Compact/full_payout_stats.tpl', '6c5e691e6069884d5d1be146054c14dd');
        $this->checkFile('themes/merchants/Compact/full_transaction_stats.tpl', '2669b46d3f14aa9c57872f5373c2797d');
        $this->checkFile('themes/merchants/Compact/general_no_data.stpl', '03433ae7bf79c177a476922c2ee779c5');
        $this->checkFile('themes/merchants/Compact/generate_coupons_form.tpl', 'beddaaf1aa37c10aab9838f1c4b8f1e8');
        $this->checkFile('themes/merchants/Compact/generate_htaccess.tpl', '05d9d8606bdf35455fb48ec7f928b702');
        $this->checkFile('themes/merchants/Compact/geoip_commissiontype_detailpanel.tpl', '734dc6f1a0cc432cd287f22ef5824f49');
        $this->checkFile('themes/merchants/Compact/geoip_fraudprotection_affiliates.tpl', '8fadf652ac9ea3507a4a6173faf8eb62');
        $this->checkFile('themes/merchants/Compact/geoip_fraudprotection_clicks.tpl', 'db19ca033fb30646f0ae504d43683c92');
        $this->checkFile('themes/merchants/Compact/geoip_fraudprotection_logins.tpl', '660ab5115a24ae974e9739dde8530d30');
        $this->checkFile('themes/merchants/Compact/geoip_fraudprotection_logins_aff.tpl', 'af98bdbc38201d8c9db2d63c83ccdf9d');
        $this->checkFile('themes/merchants/Compact/geoip_fraudprotection_sales.tpl', 'c2c170214c10ba59d591261e85dc4cff');
        $this->checkFile('themes/merchants/Compact/get_pdf.tpl', '7de69c1b98a6f1cac1f9c8e570e3b6b9');
        $this->checkFile('themes/merchants/Compact/getting_started_icons.tpl', '612e44ecb9bc1526bd8694a0655342bf');
        $this->checkFile('themes/merchants/Compact/getting_started_merchant.tpl', '9f02ac92cddb211fce5fb826fe7473e5');
        $this->checkFile('themes/merchants/Compact/google_recaptcha_settings.tpl', 'b93feccb5cdfccc02846aea495459127');
        $this->checkFile('themes/merchants/Compact/gpf.css', 'ec27b549fa06e9420afb4e6d56ee3a96');
        $this->checkFile('themes/merchants/Compact/gpf_db_mail.tpl', 'b5ea5e9ecef2152fdf967085a7689adc');
        $this->checkFile('themes/merchants/Compact/grid.tpl', 'c0efa81ea11d739f933438236d6fb12d');
        $this->checkFile('themes/merchants/Compact/grid_bottombuttons.tpl', '1aa9463da984fac10b988d8758c82297');
        $this->checkFile('themes/merchants/Compact/grid_bottomgridline.tpl', '9bf2013a170e094e82dc1ae0a2ed0f97');
        $this->checkFile('themes/merchants/Compact/grid_nodata.tpl', '340ff6de789cd7277a35d763f6366f24');
        $this->checkFile('themes/merchants/Compact/grid_pager.tpl', '46e6d959616563985ece2d92c0234826');
        $this->checkFile('themes/merchants/Compact/grid_selector.tpl', 'ff2d81e3866f53d540a0d063bdf7b480');
        $this->checkFile('themes/merchants/Compact/grid_topbuttons.tpl', 'b605a4f548962d4bf0c8d8662353b795');
        $this->checkFile('themes/merchants/Compact/grid_topgridline.tpl', '3ff9c43cb7f7fcbbcdc7f03c8822a70d');
        $this->checkFile('themes/merchants/Compact/header.tpl', '32d459ea9f7ebf7a241715058cc91f38');
        $this->checkFile('themes/merchants/Compact/home_edit.tpl', '1e659b8ee09e43c02d567356206c7c93');
        $this->checkFile('themes/merchants/Compact/home_edit_main_template.tpl', 'cd4fbd7e59c2c1813b4b1c9d54025223');
        $this->checkFile('themes/merchants/Compact/home_edit_merch_template.tpl', '1079945929a23a68a38676fe78432211');
        $this->checkFile('themes/merchants/Compact/home_panel.tpl', '1404c1c1a5f5048ce23760ddd33a49b3');
        $this->checkFile('themes/merchants/Compact/home_panel_content.stpl', '9c352e615bb4e6b3741e0362cb5888d4');
        $this->checkFile('themes/merchants/Compact/horizontal_layout_panel.tpl', '8b6098cd64720cff686cc24e06ac4c17');
        $this->checkFile('themes/merchants/Compact/hosted_account.tpl', 'e58e46daeeb498d85227982e6ee6ae2d');
        $this->checkFile('themes/merchants/Compact/hosted_account_plan.tpl', 'bfb67b63d21a4482e2528a4fb581629c');
        $this->checkFile('themes/merchants/Compact/htaccess_panel.tpl', 'b3632f76f8ab6d2e56f7a776401dedaf');
        $this->checkFile('themes/merchants/Compact/html_preview.tpl', '0e08da44b5c86ce6d47c50e3117ba5ba');
        $this->checkFile('themes/merchants/Compact/html_preview_iframe_panel.tpl', '22405951702ab2132d0fe99577f4968e');
        $this->checkFile('themes/merchants/Compact/html_preview_image_panel.tpl', 'ebc5b8605c42ac31f653b65deb66e04d');
        $this->checkFile('themes/merchants/Compact/icon_button.tpl', 'a7497a39fe733586fb4f5a1b9f424b0f');
        $this->checkFile('themes/merchants/Compact/icon_object.tpl', 'ff8d25e63eca03b325c4501e13358fb2');
        $this->checkFile('themes/merchants/Compact/icon_picker.tpl', '77a002b90f678df44bcca5776f314820');
        $this->checkFile('themes/merchants/Compact/icon_picker_panel.tpl', '4342c424a8cb290701f64d0cb63655ec');
        $this->checkFile('themes/merchants/Compact/icon_status_widget.tpl', 'ff9e2bc87e203324cc33c4b3ac365dfe');
        $this->checkFile('themes/merchants/Compact/icons_panel_with_header.tpl', '97091a954a48c0889fa82a2464266e84');
        $this->checkFile('themes/merchants/Compact/image_uploader.tpl', '9f93ea577dd2511b19071fa735b6b684');
        $this->checkFile('themes/merchants/Compact/img/FB_share_button.png', 'a56c7efd784eb61b5ac1e6f4111f59a8');
        $this->checkFile('themes/merchants/Compact/img/LinkedIn_share_button.png', 'd0dfb70a7e64ee73f718af05ce995875');
        $this->checkFile('themes/merchants/Compact/img/cards.jpg', '36a8e2ad3f39a4c9c71c8abbcec24823');
        $this->checkFile('themes/merchants/Compact/img/cron_job_example.png', 'f0cd89597b814b000ef2775c2f9dea1b');
        $this->checkFile('themes/merchants/Compact/img/dirty.gif', 'decca3b96e2c37cf6eb04ddb0d9f669b');
        $this->checkFile('themes/merchants/Compact/img/doc.png', 'c914d3518532910b13728f3d9b43056d');
        $this->checkFile('themes/merchants/Compact/img/draggable.png', 'ab4fb4e3c82ccb353b30640cc36eaf67');
        $this->checkFile('themes/merchants/Compact/img/favicon.ico', 'ac3e93c93589318e5dcf69efc8a76176');
        $this->checkFile('themes/merchants/Compact/img/feature.png', 'a17a20726ab706b8cc4d7ad89ee36ef9');
        $this->checkFile('themes/merchants/Compact/img/folder.png', '74ad8feccb7ac18bde1380dd7bdbdd06');
        $this->checkFile('themes/merchants/Compact/img/html.png', '23bf6c9bc9121ffd0c273b5414faaba0');
        $this->checkFile('themes/merchants/Compact/img/icon-128.png', 'a450a0dd5959518fdb2308cc5e523bcc');
        $this->checkFile('themes/merchants/Compact/img/icon-192.png', '8cb72062e4df9eab6c2a064459a5ee62');
        $this->checkFile('themes/merchants/Compact/img/image.png', '66517d22e9c688e521951b3c2d4498e0');
        $this->checkFile('themes/merchants/Compact/img/input.png', '0df09f38346ba18c1a69510138fc7bea');
        $this->checkFile('themes/merchants/Compact/img/insert.png', '1eb65fc224afb8e9bb81bf6182e7fe22');
        $this->checkFile('themes/merchants/Compact/img/line.short.gif', '13914f3810787c4d0571df1fd447627e');
        $this->checkFile('themes/merchants/Compact/img/no.theme.thumbnail.jpg', 'db2b9f70f5fe89a3c9c2f98d69b19254');
        $this->checkFile('themes/merchants/Compact/img/no_image.gif', '07f5f79d487dbf795f7ea37a04aa24c0');
        $this->checkFile('themes/merchants/Compact/img/pan-logo.svg', 'a19c0ad7bfad0399a0f82599a571db9a');
        $this->checkFile('themes/merchants/Compact/img/pap-logo.svg', '6280dc47fe440c1c1c3af00cc27f1ced');
        $this->checkFile('themes/merchants/Compact/img/paypal.jpg', '1e18c3feef21be6605c97f5ac72e7453');
        $this->checkFile('themes/merchants/Compact/img/pdf.png', 'f8dfa3fa0386adcd2370c6d509a0be91');
        $this->checkFile('themes/merchants/Compact/img/php.png', '2c63cf93ca9b1ff5d5b16c6646a59ddc');
        $this->checkFile('themes/merchants/Compact/img/secure.png', '4490e30d2ac3700e78315f510dfff342');
        $this->checkFile('themes/merchants/Compact/img/swf.png', '1623343ec1b366081175a4d28feb66ae');
        $this->checkFile('themes/merchants/Compact/img/tabs.png', 'fce94d82812219c0ed1b98840637ec3b');
        $this->checkFile('themes/merchants/Compact/img/theme_thumbnail.jpg', 'd394f587b9cf821fedbb2c4de3ec706c');
        $this->checkFile('themes/merchants/Compact/img/txt.png', '79520d0ef237730c55eb5bcd50b78ea2');
        $this->checkFile('themes/merchants/Compact/img/unknown_file.png', '3a00859ebcd6dfef1572ecdddbe693fe');
        $this->checkFile('themes/merchants/Compact/img/video.png', '9681c0591166287c6c3144837fdf1008');
        $this->checkFile('themes/merchants/Compact/img/wysiwyg.gif', '017283b1ab06fc9391f796f2c13b0da8');
        $this->checkFile('themes/merchants/Compact/img/xls.png', '3f2844cce5616ee82f1e0dc0b9f0d53b');
        $this->checkFile('themes/merchants/Compact/img/zip.png', 'ce15cafabf396370aac29085b3c1a5dd');
        $this->checkFile('themes/merchants/Compact/import_coupons_form.tpl', '8fc3b5964331ebd6232227b4f8fa937d');
        $this->checkFile('themes/merchants/Compact/import_custom_language_panel.tpl', 'f14fe8af188194edeb7896eb3284c5b1');
        $this->checkFile('themes/merchants/Compact/import_export_panel.tpl', '7562d00dfa6c2eb770a88757ba736996');
        $this->checkFile('themes/merchants/Compact/import_language.tpl', '20d22e5e6eebf43dc6143490803aaa03');
        $this->checkFile('themes/merchants/Compact/import_panel.tpl', 'd8370787bb8f6d6e702c72ed8f7a744d');
        $this->checkFile('themes/merchants/Compact/import_theme_panel.tpl', '5fbd6be91a3a7dbf7b2def44f344b889');
        $this->checkFile('themes/merchants/Compact/info_dialog.tpl', '886c377f8e8c1b2c6957451436e1d090');
        $this->checkFile('themes/merchants/Compact/integration.tpl', 'd3b95932324b2a694eb2928a089a828c');
        $this->checkFile('themes/merchants/Compact/integration_method.tpl', 'cfdd3053443ce85b757a89dc64ddd45e');
        $this->checkFile('themes/merchants/Compact/integration_method_step.tpl', '4661c951290cf670ee9c26b45fff0a8c');
        $this->checkFile('themes/merchants/Compact/integration_methods.tpl', 'f5f0fe244869bc5da0517349aba9d291');
        $this->checkFile('themes/merchants/Compact/integration_methods_advanced.tpl', '0e72005d09820e3a2f057ea3c71cb7a7');
        $this->checkFile('themes/merchants/Compact/invoice_data_panel.tpl', '1ac898a59516e468e0f047d97db210c6');
        $this->checkFile('themes/merchants/Compact/invoice_form.tpl', '62a0cbc7e109fc019bcc00457b556594');
        $this->checkFile('themes/merchants/Compact/invoices_filter.tpl', '77faa6e4fbeb2cc872a975a1800fa6a7');
        $this->checkFile('themes/merchants/Compact/invoices_list.tpl', '4ee98efc16f05c766be1ae760cc3837c');
        $this->checkFile('themes/merchants/Compact/ip_detail.tpl', 'ff7f24d21c8ac5aa1f3645cd8d59663a');
        $this->checkFile('themes/merchants/Compact/item.tpl', '717eff0e06a712a76effb2d6723183b5');
        $this->checkFile('themes/merchants/Compact/item_panel.tpl', 'b24ed05bdf4cb76a7afc1e9a9908def8');
        $this->checkFile('themes/merchants/Compact/keywords_performance.tpl', '0a76bec58708a4041df21ab9548abadc');
        $this->checkFile('themes/merchants/Compact/keywords_performance_advanced_filter.tpl', '618269ec4149b6ffab19282eb9d1a2c5');
        $this->checkFile('themes/merchants/Compact/label_panel.tpl', 'e0c85a01af8477fe16cb6770fbb5e7af');
        $this->checkFile('themes/merchants/Compact/language_create_new.tpl', '486f695b2fe3d17aaf29ae39e7f7e0ea');
        $this->checkFile('themes/merchants/Compact/language_edit_panel.tpl', '5b8d472500f9e38a967306d007409d1f');
        $this->checkFile('themes/merchants/Compact/language_translations_filter.tpl', '930f22e595469a617570927021bf9d15');
        $this->checkFile('themes/merchants/Compact/language_translations_grid.tpl', 'a4247bb921179c395cf7a2972cbcef3f');
        $this->checkFile('themes/merchants/Compact/languages_configuration.tpl', 'a146b693cd6b18b1f7711d750e444175');
        $this->checkFile('themes/merchants/Compact/layout_panel_content.tpl', '353b904baf333a2e0456ef5cb0fa179c');
        $this->checkFile('themes/merchants/Compact/layout_panel_header_navigation.tpl', '6b0d746501001da8615a22d57266dcb0');
        $this->checkFile('themes/merchants/Compact/layout_panel_tab.tpl', '27ee274cfd12ed770eff98d0913dd8e8');
        $this->checkFile('themes/merchants/Compact/license_invalid.tpl', '6181e1127345050c94d6708cd805aefb');
        $this->checkFile('themes/merchants/Compact/lifetime_referral_edit.tpl', '3d3923ef67ea430835a1f951955543b2');
        $this->checkFile('themes/merchants/Compact/lifetime_referrals_filter.tpl', 'dcac6d377be0092c4fbf75b5ff6824e8');
        $this->checkFile('themes/merchants/Compact/lifetime_referrals_import.tpl', '327f3397a82c6613ec6ab3718f916982');
        $this->checkFile('themes/merchants/Compact/lifetime_referrals_panel.tpl', '57fdc30f1434427f31e456701817165a');
        $this->checkFile('themes/merchants/Compact/link_button.tpl', '71fad92bff79f1fd2e1066818afac789');
        $this->checkFile('themes/merchants/Compact/link_method_panel.tpl', '9af6c599de2f311cb0149524b50ff20d');
        $this->checkFile('themes/merchants/Compact/linking_method.tpl', '7e0919bff0810701acf299531e0ef0eb');
        $this->checkFile('themes/merchants/Compact/listbox.tpl', '2739c2a9e22d54280cacf4d67ed2e7bc');
        $this->checkFile('themes/merchants/Compact/listbox_popup.tpl', '8c45877411c0727e814eb5e3caa76822');
        $this->checkFile('themes/merchants/Compact/listdown_button.tpl', 'a1cd26a1aec6d403420971d7469a6f1b');
        $this->checkFile('themes/merchants/Compact/lite_campaign_wizard.tpl', 'eaa5d01dd5deee48986f5f98f22caf40');
        $this->checkFile('themes/merchants/Compact/load_mail_from_template.tpl', '42c0029422eaf077a5b0c316cd3317b5');
        $this->checkFile('themes/merchants/Compact/loadable_tree.tpl', 'e2c214b134bffe5fe2bb38f679a64eb5');
        $this->checkFile('themes/merchants/Compact/loading_indicator.tpl', '8d3b3ac51e79a10e35aa11c9bd87d83c');
        $this->checkFile('themes/merchants/Compact/loading_screen.tpl', '5da99de875a9deebff88a2806fdad49f');
        $this->checkFile('themes/merchants/Compact/loading_template.tpl', '39be2fe5f53ed914cc8979ea146ac398');
        $this->checkFile('themes/merchants/Compact/log_filter.tpl', '7f09ae6ce70590ead04d534e6019fca9');
        $this->checkFile('themes/merchants/Compact/log_list.tpl', '17f5cd218930723c21afa914b4fee8fe');
        $this->checkFile('themes/merchants/Compact/logging_tab.tpl', 'bbe2b73c70c24bbafb56a75ed4279f81');
        $this->checkFile('themes/merchants/Compact/logging_tab_debug.tpl', '32912cc60dfc885333623335a44ab19c');
        $this->checkFile('themes/merchants/Compact/logging_tab_logins_history.tpl', 'e59ce588474c4019a05eafd91c45bd2c');
        $this->checkFile('themes/merchants/Compact/login.tpl', 'e7be8367104ee7221547730250f9b0f0');
        $this->checkFile('themes/merchants/Compact/login_form.tpl', '68fec5fc89be1ee473d62ac966211289');
        $this->checkFile('themes/merchants/Compact/login_main.tpl', '5b3eb0529047463ac6b90a529de64d85');
        $this->checkFile('themes/merchants/Compact/logins_history.tpl', '1ef6edb0f2167b8d05c961c7d6379f92');
        $this->checkFile('themes/merchants/Compact/loginshistory_filter.tpl', '6fa20923cc33142105a51ef6f3a51ad7');
        $this->checkFile('themes/merchants/Compact/logo_settings.tpl', '6c5dbe6195a7b19dd0e0dcb58a207523');
        $this->checkFile('themes/merchants/Compact/logs_no_data.tpl', 'c807c1484862c46a3f72f1ea0d276b3f');
        $this->checkFile('themes/merchants/Compact/mail_detail_data.tpl', '72d679a44b2ad0f888e829b479e6550e');
        $this->checkFile('themes/merchants/Compact/mail_outbox_panel.tpl', 'fa6291a64c1e5a21237be44f192a8c99');
        $this->checkFile('themes/merchants/Compact/mail_template_not_selected.tpl', '8f8e4d19a09cd7bc7e96df0e0729ef8d');
        $this->checkFile('themes/merchants/Compact/mail_template_preview.tpl', 'ea7d0df5aef2645e05d768c51a294389');
        $this->checkFile('themes/merchants/Compact/mail_template_test_form.tpl', 'd5c10c451945fe2cd1545ab10c11a959');
        $this->checkFile('themes/merchants/Compact/mail_templates.tpl', 'cceaeaa496bd10868bcf67ef9f9acc45');
        $this->checkFile('themes/merchants/Compact/mail_templates_list.tpl', '2834084fc2e4bef6ffd06fd86a650a17');
        $this->checkFile('themes/merchants/Compact/mailoutbox_filter.tpl', '59f66fe33f07d333de586095367ca23d');
        $this->checkFile('themes/merchants/Compact/mailoutbox_list_no_data.tpl', '12637515858ca4d960c6202e8a89042b');
        $this->checkFile('themes/merchants/Compact/main.tpl', 'fa8212eeec30d6ec2748f3a3815bd929');
        $this->checkFile('themes/merchants/Compact/main_error_html_doc.tpl', 'e99d46538cab7c9fe32dc247711589d3');
        $this->checkFile('themes/merchants/Compact/main_filter_panel.tpl', '0985a7421f898d75d4df72b4a6081c49');
        $this->checkFile('themes/merchants/Compact/main_html_doc.tpl', '85aea6ad1c65d7807bfad09f0d9d184e');
        $this->checkFile('themes/merchants/Compact/main_integration_steps_icons.tpl', '2107115d75013a0ad392566bb3fa1d54');
        $this->checkFile('themes/merchants/Compact/main_menu.tpl', '1036ce189dc092adca21d6405e83544f');
        $this->checkFile('themes/merchants/Compact/map_overlay.tpl', '9deb511a7295d19349480562f6771d87');
        $this->checkFile('themes/merchants/Compact/map_overlay_advanced_filter.tpl', 'd41f999b16fbe6f34fe9315aff388a67');
        $this->checkFile('themes/merchants/Compact/map_overlay_edit.tpl', 'd173ac586a3502e61f80a956597e1496');
        $this->checkFile('themes/merchants/Compact/mass_pay_export.tpl', 'c90a423ab30d28f949c8ce738bab8375');
        $this->checkFile('themes/merchants/Compact/mass_pay_export_form.tpl', 'c3b9939154fe31ce081f9c4edee7c410');
        $this->checkFile('themes/merchants/Compact/menu_entry.tpl', '64a9c8f6b89eb5d0fb9a2d174b5f0427');
        $this->checkFile('themes/merchants/Compact/menu_section.tpl', 'cec8b58c248868d64eaddc18923f7743');
        $this->checkFile('themes/merchants/Compact/merchant_category_info.tpl', 'ecf110e07235298eb0403fdb6c8a1448');
        $this->checkFile('themes/merchants/Compact/merchant_tutorial_video.tpl', 'ce8d0f0aad10353b46888942abfb96e5');
        $this->checkFile('themes/merchants/Compact/messages.tpl', 'bf1a3bac08c419320acb94673ad29f0b');
        $this->checkFile('themes/merchants/Compact/module_body.stpl', 'c079addcd33eb725ab7efbf09c16a793');
        $this->checkFile('themes/merchants/Compact/month_banner_stats.tpl', 'fc0ecc72cbc42efa3835713eebcf8d4f');
        $this->checkFile('themes/merchants/Compact/multi_editor.tpl', '6cd4d8823bd6b67cd3e0a2aa2cf52b29');
        $this->checkFile('themes/merchants/Compact/multi_form_widget.tpl', '3f92d96633ec487b28dc6bfae7cc8e30');
        $this->checkFile('themes/merchants/Compact/multiple_currencies_panel.tpl', 'c7b959fe11ad02a2fcbe22f5f62d344b');
        $this->checkFile('themes/merchants/Compact/multiselect.tpl', '9d1863b21edd131520315ce252fde639');
        $this->checkFile('themes/merchants/Compact/network_invoice.tpl', 'da2d8c12f409758081a229e78c1306fe');
        $this->checkFile('themes/merchants/Compact/network_proforma_invoice.tpl', '5f9dcea372e00363e6dc2ffbdd5a8187');
        $this->checkFile('themes/merchants/Compact/news_content.tpl', 'a576598444bb0db20fa8d47854f1ef34');
        $this->checkFile('themes/merchants/Compact/news_filter.tpl', '59508e33dc1a696ffa5a18d5f619eedd');
        $this->checkFile('themes/merchants/Compact/news_form_edit.tpl', '517272eac91c024292fe594cecae2c28');
        $this->checkFile('themes/merchants/Compact/news_item.tpl', '18161a56a8f4dc5df01f08191709f864');
        $this->checkFile('themes/merchants/Compact/news_list.tpl', 'f37df45ddce385805e34da5d81b17a1f');
        $this->checkFile('themes/merchants/Compact/news_panel.tpl', '0e6eda2d6e6edab31d596d86939f0933');
        $this->checkFile('themes/merchants/Compact/newsletter_broadcast_form.tpl', '1ccb4e8c2a3873263c7c8c1fc7c19f27');
        $this->checkFile('themes/merchants/Compact/newsletter_broadcasts.tpl', 'e85ba6dc04b3a921af601f6bf976a5b8');
        $this->checkFile('themes/merchants/Compact/newsletter_edit_panel.tpl', '73ddca2129beb12e11215b1c55e70461');
        $this->checkFile('themes/merchants/Compact/newsletter_form.tpl', 'e86bb366b8986ac4cb1b50c9ccc94b8e');
        $this->checkFile('themes/merchants/Compact/no_category_selected_settings_panel.tpl', '28bc9d284f2cbec3dde908dc0d4e9f7c');
        $this->checkFile('themes/merchants/Compact/no_content_gadgets.tpl', '1d4ce600d473f33e2b229101a50cbc3f');
        $this->checkFile('themes/merchants/Compact/no_language_selected.tpl', 'd61125f2b1cf78e4e66653d4e2f04bdd');
        $this->checkFile('themes/merchants/Compact/note_filter.tpl', '5984797bddb6b9dff4b4066106da1bcf');
        $this->checkFile('themes/merchants/Compact/notification_window.tpl', 'db781872bdb9748bc838e051b8e5e4e2');
        $this->checkFile('themes/merchants/Compact/offline_sale.tpl', '589eb1238aac5800197e6e56a26cacf7');
        $this->checkFile('themes/merchants/Compact/offline_sale_form.tpl', '86fe26a2a1e02d811e892233db9d6b5e');
        $this->checkFile('themes/merchants/Compact/online_users.tpl', '1242aa25d7ed7b3a278684e0d4a13c4c');
        $this->checkFile('themes/merchants/Compact/online_users_gadget_rolecount.tpl', '5fd6af0c5f2edec24d0e35dc00a9e870');
        $this->checkFile('themes/merchants/Compact/online_users_gadget_template.tpl', '80ebdfe2a212375942cac09081e371b2');
        $this->checkFile('themes/merchants/Compact/onlinegadgets_no_data.tpl', 'f5f692a433b4911963a92c41cc269768');
        $this->checkFile('themes/merchants/Compact/onlineusers_filter.tpl', 'a5ec412a7f620cb47ddcf48b9f0d6625');
        $this->checkFile('themes/merchants/Compact/order_id_filter.tpl', 'ea89a8c9ef5a3f13f5fca4c6dcbf6860');
        $this->checkFile('themes/merchants/Compact/orgchart_affiliate_widget.tpl', '32f4faf30d0289ffd4c9d53f92a39388');
        $this->checkFile('themes/merchants/Compact/overview_panel.tpl', '1874d6377cb2a53e5eba387cd0874215');
        $this->checkFile('themes/merchants/Compact/overview_stats_panel.tpl', '674d3c5e07dddbfcc6b89bfa7b420640');
        $this->checkFile('themes/merchants/Compact/page_header.tpl', '4fd5676c44341f95ee0435c1f78da534');
        $this->checkFile('themes/merchants/Compact/page_type_radio.tpl', 'd132376c54a57b3962d1ca08eda22000');
        $this->checkFile('themes/merchants/Compact/panel_footer.stpl', 'e2061441871211697aaefedf5a2217c9');
        $this->checkFile('themes/merchants/Compact/pap4.css', '8d7f799cd56b4c2f084afee204170895');
        $this->checkFile('themes/merchants/Compact/pap4.rtl.css', '5377379704e04eabc0d84e9f1256d805');
        $this->checkFile('themes/merchants/Compact/parameter_names_form.tpl', '32bfa373ae61cdae7c70a202ba921e62');
        $this->checkFile('themes/merchants/Compact/password_constraint_panel.tpl', '6d328bcd04ea68b87c18d4fd52099888');
        $this->checkFile('themes/merchants/Compact/password_panel.tpl', 'b1440553a785aae589233a91315b281f');
        $this->checkFile('themes/merchants/Compact/pay_affilates_form.tpl', '47ca863e6f0e46c4b2e631d2ebd313f0');
        $this->checkFile('themes/merchants/Compact/pay_affiliate_template.tpl', '692261c025aab9b05408b9651de9a894');
        $this->checkFile('themes/merchants/Compact/pay_affiliates.tpl', '9a08ef03ed4b0d076203c45c369918d1');
        $this->checkFile('themes/merchants/Compact/pay_affiliates_filter.tpl', 'c20e663c0b2145b6e7c8eaf4f26c6da4');
        $this->checkFile('themes/merchants/Compact/pay_affiliates_list.tpl', '85b17725f87d1ea59102020c1f290070');
        $this->checkFile('themes/merchants/Compact/pay_affiliates_no_data.tpl', 'bdd593288f13c714bdb19de5d264318c');
        $this->checkFile('themes/merchants/Compact/pay_invoice_form.tpl', 'c7490c619a883b6b90c2817b22025984');
        $this->checkFile('themes/merchants/Compact/payee_info.tpl', '740af57f0054d67e6c689466e90980d8');
        $this->checkFile('themes/merchants/Compact/payee_info_main.tpl', '8048bb0c734d26af0a077e1728b2e814');
        $this->checkFile('themes/merchants/Compact/payout_data.tpl', 'b6f6f6c19617690d683128ee13b8b688');
        $this->checkFile('themes/merchants/Compact/payout_fields_form.tpl', '0f8a8b9516b729ab4899926ead42be16');
        $this->checkFile('themes/merchants/Compact/payout_fields_no_data.tpl', '22728157d2ebba66c42b8632edcc2eee');
        $this->checkFile('themes/merchants/Compact/payout_history_form.tpl', 'fdf50ed31df6ef2a90efc52c043f13f8');
        $this->checkFile('themes/merchants/Compact/payout_history_list_no_data.tpl', 'eaea8ff071a4da8272b5b57616544789');
        $this->checkFile('themes/merchants/Compact/payout_history_template.tpl', '94edd75586374bd10a9e765ceb78e910');
        $this->checkFile('themes/merchants/Compact/payout_invoice_format.tpl', 'c33ad82f202fb7fc45f83d2c8d547efa');
        $this->checkFile('themes/merchants/Compact/payout_methods_filter_field.tpl', '3e44e83bdfd9080f05070dd2281dcfd2');
        $this->checkFile('themes/merchants/Compact/payout_option_form.tpl', '309c28785f0a1aa14ded20d7037c6d3e');
        $this->checkFile('themes/merchants/Compact/payout_options_form.tpl', '747bdbfe5eca6068d61275e19f4472a4');
        $this->checkFile('themes/merchants/Compact/payout_options_no_data.tpl', '19f1bead958da75d50d38d893f93f4e1');
        $this->checkFile('themes/merchants/Compact/payout_options_text_box.tpl', '9d7c675a676c204bafaa2c1f32b3f6a4');
        $this->checkFile('themes/merchants/Compact/payout_settings_icons.tpl', 'aa4813c156afb53ed10a02319166c340');
        $this->checkFile('themes/merchants/Compact/payouts_balance_form.tpl', 'd01274716d5700a7180cd8277b575cb0');
        $this->checkFile('themes/merchants/Compact/payouts_balance_settings.tpl', '61c8ca2e6971fef86250e0b1a3adcb41');
        $this->checkFile('themes/merchants/Compact/payouts_history.tpl', '8a1c74d4f1312a63ceee7907076e2d45');
        $this->checkFile('themes/merchants/Compact/payouts_history_filter.tpl', '49514d217f0a77dcd9cbae68ab504e38');
        $this->checkFile('themes/merchants/Compact/payouts_to_affiliates.tpl', '6e8868d55f61a825057b3890e0ec4afd');
        $this->checkFile('themes/merchants/Compact/payouts_to_affiliates_filter.tpl', '06f0e81d2ad6a474fb81ccaef755477d');
        $this->checkFile('themes/merchants/Compact/payoutstoaffiliates_list_no_data.tpl', '1bf1e39b51797acb2bac6428dabb0929');
        $this->checkFile('themes/merchants/Compact/peel_banner_feature_on_deactivate.tpl', '88a989ccfb54f68203c01176a104541f');
        $this->checkFile('themes/merchants/Compact/pending_backround_tasks.tpl', '9c91e4d0f413f7d7327783449c4222d7');
        $this->checkFile('themes/merchants/Compact/pending_tasks.tpl', '3aa9f9ee68b7ef3258fe7a9c3994f952');
        $this->checkFile('themes/merchants/Compact/pending_tasks_data.tpl', '1916b1db72af25350e122542f2261eb3');
        $this->checkFile('themes/merchants/Compact/pending_tasks_panel.tpl', '16eaedf4545a03d89f94b98e3adacfa4');
        $this->checkFile('themes/merchants/Compact/pending_tasks_template.tpl', '091fb315fbb9a3d24bf16baa791bd32f');
        $this->checkFile('themes/merchants/Compact/performance_rewards.tpl', 'e6376beacf92f7086e4cf7b1a3e97d29');
        $this->checkFile('themes/merchants/Compact/performance_rewards_filter.tpl', 'daf43de0e8c03e9a97f0aaf22b173461');
        $this->checkFile('themes/merchants/Compact/placement_overview_filter.tpl', '6132598add92f772fb46568f94f0e5cc');
        $this->checkFile('themes/merchants/Compact/placement_overview_panel.tpl', 'd0d0bef4390bbf53b43e4207aba245f3');
        $this->checkFile('themes/merchants/Compact/plugin_configuration.tpl', '9f4b075baf454033271fc4219c272737');
        $this->checkFile('themes/merchants/Compact/plugin_detail.tpl', '097b49ceeac4111d1fd96f3cd8d2b049');
        $this->checkFile('themes/merchants/Compact/plugins_list.tpl', '72c87aa08ebd9a6218fcb300d6ec675c');
        $this->checkFile('themes/merchants/Compact/popup_actions_panel.tpl', 'ef01a0f4fa742fc99a03632e1d6876b4');
        $this->checkFile('themes/merchants/Compact/popup_form_widget.tpl', '0f5d2ef3d678d026df06fe1f1e5991a8');
        $this->checkFile('themes/merchants/Compact/postsignup_radio.tpl', '6b32ad7886413081192c2ba5dd514275');
        $this->checkFile('themes/merchants/Compact/postsignup_settings_page.tpl', '3657e859769d3db637b6a83e45ab218d');
        $this->checkFile('themes/merchants/Compact/postsignup_settings_url.tpl', 'c854a3cb764d4be9af656abf45398193');
        $this->checkFile('themes/merchants/Compact/private_campaigns_feature_on_deactivate.tpl', 'ecef84105dc2779ac2fb428da2e9f25f');
        $this->checkFile('themes/merchants/Compact/proxy_server_configuration.tpl', '618f166a4be6b32f563aaeffd5f1931e');
        $this->checkFile('themes/merchants/Compact/qualityunit_news.stpl', '188a98161e9218eb440aab2d33341a0c');
        $this->checkFile('themes/merchants/Compact/quick_report_base.tpl', '03394fc9a529f4d9d13f8cbcb664be8f');
        $this->checkFile('themes/merchants/Compact/quick_report_content.stpl', 'a75ca3ba3fc385de73eae7311f79c650');
        $this->checkFile('themes/merchants/Compact/quick_report_content_multitier.stpl', 'e45556a573992274576437d9d34bdd71');
        $this->checkFile('themes/merchants/Compact/quick_report_filter_base.tpl', '40541d4b075161fc37bea2086e429e23');
        $this->checkFile('themes/merchants/Compact/quick_report_multitier_widget.tpl', '24108ad66b123214ae2c170aaa4ec369');
        $this->checkFile('themes/merchants/Compact/quick_stats_actions_panel.tpl', 'd0816b90a3fbe4f4ffa09a37aec14268');
        $this->checkFile('themes/merchants/Compact/quick_stats_box.tpl', '745d64595b8a0e5869bfc1e9bf10b9c2');
        $this->checkFile('themes/merchants/Compact/quicklaunch_settings.tpl', '1e595ebaeb4364f173ee3fec71c1762d');
        $this->checkFile('themes/merchants/Compact/radio_button_group_row.tpl', '3713f6d400aa1ca96d9e404082304912');
        $this->checkFile('themes/merchants/Compact/radio_form_panel.tpl', 'c56091f134178fc494aa76df1b6ad6a1');
        $this->checkFile('themes/merchants/Compact/rebrand_pdf_feature_on_deactivate.tpl', '57adefe6824afba7c2477b79c5663843');
        $this->checkFile('themes/merchants/Compact/recaptcha_settings.tpl', 'd40a2e0759211b13af22180aef80b380');
        $this->checkFile('themes/merchants/Compact/recipients.tpl', '6c334400d00281b1b04bfc28c654f2a3');
        $this->checkFile('themes/merchants/Compact/recurring_commission_edit.tpl', 'f144dcac07b3913bb6dfb866e4871d9d');
        $this->checkFile('themes/merchants/Compact/recurring_commission_filter.tpl', 'aface18c7b8fbf80da4810c240ce4bb7');
        $this->checkFile('themes/merchants/Compact/recurring_commission_list.tpl', 'b6d7546e3e8ef3fafa122019d01531f8');
        $this->checkFile('themes/merchants/Compact/recurring_commissions.tpl', '8c806617d38c467e2f29e22bb43e826c');
        $this->checkFile('themes/merchants/Compact/referringurl_advanced_filter.tpl', 'e064d6689bc281e60c830c70acd8f3c3');
        $this->checkFile('themes/merchants/Compact/refresh_panel.tpl', '5c709df4d219d5feb4f29003ca932f77');
        $this->checkFile('themes/merchants/Compact/regional_settings.tpl', '899786b4a8c655defc732008fae917e7');
        $this->checkFile('themes/merchants/Compact/regional_settings_tab.tpl', '808fee97d86d7a2400d4e4de198359dc');
        $this->checkFile('themes/merchants/Compact/replicated_site_source_radio.tpl', '7d280f4647e9269bca20b70e4e64d077');
        $this->checkFile('themes/merchants/Compact/report_filter.tpl', 'cfa31cd337c81b3e863f97b664581327');
        $this->checkFile('themes/merchants/Compact/report_problems.tpl', '6c4035620c09202f2165e94e99635ceb');
        $this->checkFile('themes/merchants/Compact/reports_screen.tpl', '7ec70fbbc8d7b81b1a98c932ea1c1267');
        $this->checkFile('themes/merchants/Compact/request_new_password_form.tpl', 'e4e20e8042328f80b7b400e39d921986');
        $this->checkFile('themes/merchants/Compact/resizable_text_area.tpl', '7995c217048ccd289dfee567a455b08e');
        $this->checkFile('themes/merchants/Compact/richlistbox.tpl', '13229a43763945932dc8d5d7fa21d08e');
        $this->checkFile('themes/merchants/Compact/richlistbox_popup.tpl', 'c155c59eea77770589bcadca0c75f1af');
        $this->checkFile('themes/merchants/Compact/richtext_editor.tpl', '99af0e75e8761690e55e65fa238d8d4c');
        $this->checkFile('themes/merchants/Compact/richtext_editor_toolbar.tpl', '3798b9151ed1d87c99e5783005c81773');
        $this->checkFile('themes/merchants/Compact/richtexteditor_addlink.tpl', 'c9bd3a510535abef1076a29328f069e7');
        $this->checkFile('themes/merchants/Compact/role_privileges.tpl', '30e7afc5bc26d51388efbf226e837411');
        $this->checkFile('themes/merchants/Compact/rotator_preview_merchant.stpl', 'f4a8b7e2a320d263c11e080652136aa8');
        $this->checkFile('themes/merchants/Compact/rule_conditions_panel.tpl', 'eb2d93cd36c8a15eb8b8c219d89cbec9');
        $this->checkFile('themes/merchants/Compact/rule_conditions_panel_full.tpl', 'd76b1053dd4ae7afd2d9febf80199b0c');
        $this->checkFile('themes/merchants/Compact/rule_panel.tpl', '836f9d642a2304b320b799fd156d04bf');
        $this->checkFile('themes/merchants/Compact/search_filter.tpl', 'c43c492cae5282a628238b4ff75508b2');
        $this->checkFile('themes/merchants/Compact/search_gadget.tpl', 'dd1ccaf3d497e365f8ea8d999a89cc29');
        $this->checkFile('themes/merchants/Compact/search_gadget_entries_panel.tpl', 'b60a5fd89e628c401c86eee54073243e');
        $this->checkFile('themes/merchants/Compact/search_gadget_popup.tpl', 'ad5359afa9edeb864b0929d40a05e466');
        $this->checkFile('themes/merchants/Compact/search_gadget_popup_entry.tpl', 'd4c0f584509bbc3c0db48a061dab51fc');
        $this->checkFile('themes/merchants/Compact/selectbutton_search.tpl', 'dedb23ce356b1b66377e648232dc2b8b');
        $this->checkFile('themes/merchants/Compact/send_mail_to_affiliate.tpl', '757d0224a850eb6a32175367add64442');
        $this->checkFile('themes/merchants/Compact/send_mass_mail.tpl', '515c3046b1058c4b313af52b6859a18d');
        $this->checkFile('themes/merchants/Compact/set_new_password_form.tpl', '9270391a0892b67b03efbd67084806c6');
        $this->checkFile('themes/merchants/Compact/sidebar.tpl', '65226d7e25dcdca0cf71a9f3118d8139');
        $this->checkFile('themes/merchants/Compact/sidebar_closed.tpl', '3d903661713a9ee5fb402776ee06d310');
        $this->checkFile('themes/merchants/Compact/sidebar_gadget.tpl', '1f904859e056808c8826836a4e256761');
        $this->checkFile('themes/merchants/Compact/signup_commissions.tpl', 'e88a6f8eb2b970efe40609b59a103f45');
        $this->checkFile('themes/merchants/Compact/signup_form_design.tpl', '5786a51864065a89ea059e03826048c7');
        $this->checkFile('themes/merchants/Compact/signup_url_panel.tpl', '9578396ed90325350510e89493bc5101');
        $this->checkFile('themes/merchants/Compact/simple_filter.tpl', 'a55a1095bcbdbef9d9d9f5e2078b19a2');
        $this->checkFile('themes/merchants/Compact/simple_icon_object.tpl', 'bcbc9ea994d4aa8bbdee1eddc3ad19d8');
        $this->checkFile('themes/merchants/Compact/simple_popup_window.tpl', 'e7d6ad58d85a85eab20414bb734b8c81');
        $this->checkFile('themes/merchants/Compact/simplecolorpicker.tpl', '9c031fbdd2b35909faeea73e5f1203a1');
        $this->checkFile('themes/merchants/Compact/single_content_panel.tpl', '529d4a42f9106d91881f8b8b8e87748b');
        $this->checkFile('themes/merchants/Compact/site_replication_feature_on_deactivate.tpl', 'a9a5007e2b045fcddb5649780343250c');
        $this->checkFile('themes/merchants/Compact/size_format_widget.tpl', 'ebfb7db6718ec601af59a570d8e0ccb3');
        $this->checkFile('themes/merchants/Compact/spillover.tpl', 'b88774d1a43ea2c8b638a75c59411588');
        $this->checkFile('themes/merchants/Compact/spillover_affiliate_panel.tpl', 'a31389658f2a6052020cad731dff7671');
        $this->checkFile('themes/merchants/Compact/split_commissions_edit.tpl', '79b93073097985ea9b70b50708f9f361');
        $this->checkFile('themes/merchants/Compact/split_commissions_edit_help.tpl', 'b8c0076fd8c6f725a44728f9c36e1633');
        $this->checkFile('themes/merchants/Compact/split_commissions_feature_on_activate.tpl', '3c0a020b1e83cc8c0f13cc18c823c20d');
        $this->checkFile('themes/merchants/Compact/start_button.tpl', '7aa2278c46b897536625cc042b4f5499');
        $this->checkFile('themes/merchants/Compact/statistics_double_value_widget.tpl', '7e243a39277ad97843b418e45881a6d2');
        $this->checkFile('themes/merchants/Compact/statistics_filter.tpl', '90764aa6c165d35f0eac8273a596c963');
        $this->checkFile('themes/merchants/Compact/statistics_tab.tpl', '44fda2baaf03641673bcb17e5724a22d');
        $this->checkFile('themes/merchants/Compact/stats_chart.tpl', 'b5bb3d9a0dd5361a4e34e479aacf2480');
        $this->checkFile('themes/merchants/Compact/sub_menu_section.tpl', 'f14329a6ad21f2551a068111201c9918');
        $this->checkFile('themes/merchants/Compact/sum_payouts_to_affiliates.tpl', '4c94936fcc7cc7be82f86e1eb2e8df9e');
        $this->checkFile('themes/merchants/Compact/sum_payouts_to_affiliates_filter.tpl', '4ff8a5479e29e9ca336f282f0fd51b85');
        $this->checkFile('themes/merchants/Compact/system_menu.tpl', 'd7f1ea46b5603e358d2b211d7b3eb1d9');
        $this->checkFile('themes/merchants/Compact/tab_item.tpl', 'd869bc1a3b8c511712e039399333d129');
        $this->checkFile('themes/merchants/Compact/tab_panel.tpl', '8c2853c4e62119a5b6f89c5e340af5d3');
        $this->checkFile('themes/merchants/Compact/task.tpl', '38a4b70b6456a12285be4bb113c72575');
        $this->checkFile('themes/merchants/Compact/taskbar.tpl', 'd7cf8ef7a71bf324aee5c1c7173afc7e');
        $this->checkFile('themes/merchants/Compact/template_form.tpl', '1a0d6777f298f5a2a71f6efea7ac459f');
        $this->checkFile('themes/merchants/Compact/template_form_constants.tpl', '91c398393e519cf7c6a53ba758eefc47');
        $this->checkFile('themes/merchants/Compact/template_form_theme_entry.tpl', '91a40d5bfbb3ff3b61cd7771e24a2684');
        $this->checkFile('themes/merchants/Compact/template_form_themes.tpl', 'e7158c1782ef49ddbf3fbe671c5c5b8a');
        $this->checkFile('themes/merchants/Compact/template_form_variables.tpl', 'e1c008058f4be04a9e6e76ba72cc3290');
        $this->checkFile('themes/merchants/Compact/templates_form.tpl', '7a0a1baf13edabb10c8c6bef5a3dac41');
        $this->checkFile('themes/merchants/Compact/theme.php', '0bfa134aafb90ab623736bd80a6ce3b6');
        $this->checkFile('themes/merchants/Compact/theme_create_new.tpl', '847cc7b80df92aa24acf0da5afdd0ed3');
        $this->checkFile('themes/merchants/Compact/theme_edit_editor.tpl', '1b1b3b083b418ba21ef37522b0934a5f');
        $this->checkFile('themes/merchants/Compact/theme_edit_filetree.tpl', '0e6f1bd9c3b11a255eab1e4824f83475');
        $this->checkFile('themes/merchants/Compact/theme_edit_image.tpl', 'cc7ae652219ab87a267bf87631e9dc43');
        $this->checkFile('themes/merchants/Compact/theme_edit_none.tpl', '291239b715e2f1e962011564bf549e5e');
        $this->checkFile('themes/merchants/Compact/theme_edit_unsupported.tpl', '2977467887b418fedc8b42576078f275');
        $this->checkFile('themes/merchants/Compact/theme_editor_panel.tpl', '566661806fd2d4b3ce443277d71959f5');
        $this->checkFile('themes/merchants/Compact/theme_panel.tpl', '07b850efc37a68fe58fcdb067a81271d');
        $this->checkFile('themes/merchants/Compact/theme_settings.tpl', '5c596388ecc46c2ac89c029f811f565e');
        $this->checkFile('themes/merchants/Compact/time_conditions_panel.tpl', '0266186f1510ff818fb15cf4b41862b2');
        $this->checkFile('themes/merchants/Compact/timezone_settings.tpl', 'f1bb95540fb8855093d35b284817369d');
        $this->checkFile('themes/merchants/Compact/timezone_settings_tab.tpl', 'f89569e5d47f73e9c872ed4026fefcfa');
        $this->checkFile('themes/merchants/Compact/tooltip_popup.tpl', 'e4a5b50c70875ee64d9fdf4f88fa8045');
        $this->checkFile('themes/merchants/Compact/top_afffiliates_list.tpl', '286e2ac7096bc38ef5507691de9f17a6');
        $this->checkFile('themes/merchants/Compact/top_affiliates_filter.tpl', 'b3ed7a34051548c53736298042eb2243');
        $this->checkFile('themes/merchants/Compact/topurl_list.tpl', 'f108c2b8e2583a45a2016869735c87d3');
        $this->checkFile('themes/merchants/Compact/tracking_tab.tpl', '8abcd2a1c88351a3a16795feda6750b4');
        $this->checkFile('themes/merchants/Compact/traffic_info.tpl', 'f668b37ad64d6e7f879135809c57505b');
        $this->checkFile('themes/merchants/Compact/traffic_stats_gadget.tpl', 'da081a1eba4470008e9f5e0165ecd7d6');
        $this->checkFile('themes/merchants/Compact/traffic_stats_in_gadget.tpl', 'b6ffda3596f992ce68d25d72fa923751');
        $this->checkFile('themes/merchants/Compact/trafic_and_sales_report.tpl', '6723e4f293c26fed32855b086cb6318e');
        $this->checkFile('themes/merchants/Compact/transaction_form.tpl', '8ef3d9c8be8655191b10b6ceb6b8627a');
        $this->checkFile('themes/merchants/Compact/transaction_form_edit.tpl', '73debd09259e1daf3b7e6d50ccf8aee0');
        $this->checkFile('themes/merchants/Compact/transaction_form_notes.tpl', '648b29094d534cfc6b8d7683440505f0');
        $this->checkFile('themes/merchants/Compact/transaction_form_tracking.tpl', 'fc35d874eebd664e3b6da64f8d36b903');
        $this->checkFile('themes/merchants/Compact/transaction_info.tpl', '689fb8c420b25ed9e1460edae68b92e0');
        $this->checkFile('themes/merchants/Compact/transaction_list.tpl', '4d28f9612adefe432e937dea2f6ccf2a');
        $this->checkFile('themes/merchants/Compact/transaction_list_filter_base.tpl', '7d0ad12c7fc041af03abba828a3bacc4');
        $this->checkFile('themes/merchants/Compact/transaction_list_no_data.tpl', 'f91882c034dcec76ed668d2fa6e5863f');
        $this->checkFile('themes/merchants/Compact/transaction_panel.tpl', '4f6297bd3273c5a64ae474c3989dd834');
        $this->checkFile('themes/merchants/Compact/transaction_reports.tpl', 'ef0c25832283bcfe9d9cc37cd13ac41e');
        $this->checkFile('themes/merchants/Compact/transactions_import.tpl', '18ea606dee038315e72e0e1049666ca3');
        $this->checkFile('themes/merchants/Compact/trash.tpl', '270d020eabfcf284be7a97e7102924d5');
        $this->checkFile('themes/merchants/Compact/tree_affiliate_widget.tpl', 'd6d133404cf44bcd4d057ddc9e0b573f');
        $this->checkFile('themes/merchants/Compact/tree_draggable_items.tpl', '869b3cbe1a546cf76baa397b8360495b');
        $this->checkFile('themes/merchants/Compact/trend_actions_stats.tpl', '01beef973c394417de5a58de2857a1e5');
        $this->checkFile('themes/merchants/Compact/trend_actions_stats_widget.tpl', '7c26676ceb09baf3fafeb0dba3bdaec4');
        $this->checkFile('themes/merchants/Compact/trend_stats.tpl', '5423abd62baeb237c0c5feb600e84937');
        $this->checkFile('themes/merchants/Compact/trends_report.stpl', '18264d58de48af1de2b77137b0df48fb');
        $this->checkFile('themes/merchants/Compact/trends_report.tpl', '8c3ecd3db7c864a8cbbd04e92363467c');
        $this->checkFile('themes/merchants/Compact/trends_report_action.stpl', '929fa1c9535d05f1e8a0492013b9de33');
        $this->checkFile('themes/merchants/Compact/trends_report_filter.tpl', 'cacaca9e199f9c7b74916541a340c31a');
        $this->checkFile('themes/merchants/Compact/trends_report_no_data.tpl', '9d1dd7b6d3ef5f6ada42de2c7d182df2');
        $this->checkFile('themes/merchants/Compact/troubleshooting.tpl', '8ec5482d68f08a103cf0883b10308e9f');
        $this->checkFile('themes/merchants/Compact/update_version.stpl', '5602f52fe8248df474201a16c922048f');
        $this->checkFile('themes/merchants/Compact/upload_panel.tpl', '222a0dd80ab37bb49060da0cf7eaf447');
        $this->checkFile('themes/merchants/Compact/uploaded_file.tpl', 'fad11b13e3b41eff41a129b1af232e7e');
        $this->checkFile('themes/merchants/Compact/user_edit.tpl', 'f41ba1817ee0d15f16c57dff5be39bb1');
        $this->checkFile('themes/merchants/Compact/vat_settings.tpl', '628456504f54a037d9ba2f08ba3fbdc5');
        $this->checkFile('themes/merchants/Compact/verify_panel.tpl', '79aa97bc204438e497a55b8e96ee3f6b');
        $this->checkFile('themes/merchants/Compact/view_form.tpl', 'e37b380ed96bef78dc0de97ac2a3e379');
        $this->checkFile('themes/merchants/Compact/view_form_edit_views.tpl', '957cda42f99a863bd72988472e4d008f');
        $this->checkFile('themes/merchants/Compact/view_panel.tpl', '25340a99e4e6b4627de427ada4d1b2bc');
        $this->checkFile('themes/merchants/Compact/views_list.tpl', 'eb42ebb392f0237879dfba6547578e98');
        $this->checkFile('themes/merchants/Compact/visitor_affiliate_edit.tpl', '61506b2d8b383293922a9cc4929438da');
        $this->checkFile('themes/merchants/Compact/visitor_affiliates_filter.tpl', '44d9d5e8bf93948d6220d00187359183');
        $this->checkFile('themes/merchants/Compact/visitor_affiliates_list.tpl', '3493ae8f6c4fb7e655667b20a0b46ce9');
        $this->checkFile('themes/merchants/Compact/visitor_nonrefclicks_filter.tpl', '6ef69cf81734100ad5d5cf1339ee0ad7');
        $this->checkFile('themes/merchants/Compact/visitor_nonrefclicks_list.tpl', '202a7982f1ad5ae2e2310347969b8713');
        $this->checkFile('themes/merchants/Compact/visits_sales_log_add.tpl', 'e8d580c16c576c3ec98c1baedac437fa');
        $this->checkFile('themes/merchants/Compact/visits_sales_logs_filter.tpl', '5ffb18e5d3dcb8df3f61a03331c91552');
        $this->checkFile('themes/merchants/Compact/visits_sales_logs_list.tpl', '2f2c6cb4ab210272ffd87e4d3bff95b4');
        $this->checkFile('themes/merchants/Compact/visits_sales_logs_no_data.tpl', '969b350cc45c6f7c68fa6322e98a3de1');
        $this->checkFile('themes/merchants/Compact/wallpaper_add_custom.tpl', '2210741b569ef188fa352c977a289261');
        $this->checkFile('themes/merchants/Compact/wallpaper_entry.tpl', '64c85f4da7897cd0f34168c62de661b9');
        $this->checkFile('themes/merchants/Compact/wallpaper_settings.tpl', 'd160dbed38556231aeac49a96213e4d4');
        $this->checkFile('themes/merchants/Compact/welcome_message_panel.tpl', '86f2e7b763c27c55f65b269cd8b95a0d');
        $this->checkFile('themes/merchants/Compact/window.tpl', '2391705887d707e05187606c4a819e73');
        $this->checkFile('themes/merchants/Compact/window_bottom_left.tpl', 'd14b545c27afa02ab7a919bdeb4c9470');
        $this->checkFile('themes/merchants/Compact/window_empty_content.tpl', 'b1535ec719cada5b9f5d98849074b9bd');
        $this->checkFile('themes/merchants/Compact/window_header.tpl', '02a337d4184c3924a2792a84493794cc');
        $this->checkFile('themes/merchants/Compact/window_header_refresh.tpl', 'fcd47f4585abcac3c3a61ee3991379bc');
        $this->checkFile('themes/merchants/Compact/window_left.tpl', '984d69649ec171a5c6b522e795feb904');
        $this->checkFile('themes/merchants/Compact/window_move_panel.tpl', 'f5bbd373a758bf76e6efadc94dca4b11');
        $this->checkFile('themes/merchants/Compact/wizard_panel.tpl', '3142ce6354cb3e1c86b6c13c1d906189');
        $this->checkFile('themes/merchants/Compact/zip_banner_feature_on_deactivate.tpl', '0d58a97804ba953e180301d3bb0d1a37');
        $this->checkFile('themes/merchants/Coupe_window/TreeItemWidget.tpl', 'd1bfa5574da9cfa131eef997e0870e92');
        $this->checkFile('themes/merchants/Coupe_window/account_form.tpl', 'bec2cc19f2320dfebd3e493c97eeae52');
        $this->checkFile('themes/merchants/Coupe_window/account_form_show.tpl', '481066cec1fdf42f68f2db4c2fabca35');
        $this->checkFile('themes/merchants/Coupe_window/account_form_view.tpl', '3c3a69f103776f35bf195a27db899cb9');
        $this->checkFile('themes/merchants/Coupe_window/account_fraud_protection_clicks.tpl', '559a9b6630eb145dbdc5fa575a97ecb0');
        $this->checkFile('themes/merchants/Coupe_window/account_fraud_protection_sales.tpl', '1eabaf9f7df78e8502403383c9393ad9');
        $this->checkFile('themes/merchants/Coupe_window/account_info_data.tpl', '48e5394b52c65f2174b235bcd7ec792c');
        $this->checkFile('themes/merchants/Coupe_window/account_notifications_form.tpl', '1fb8f96e9b5c02448da103459cdf6aa7');
        $this->checkFile('themes/merchants/Coupe_window/account_private_campaign_settings.tpl', '940f4bcdbf2de9045887c436f31300ab');
        $this->checkFile('themes/merchants/Coupe_window/account_screen.tpl', '738e8b0997ff8592a4524b3f6c6c4ad6');
        $this->checkFile('themes/merchants/Coupe_window/account_settings.tpl', 'bef40a405c258ac960ea1370e7d02de7');
        $this->checkFile('themes/merchants/Coupe_window/account_signup_settings_form.tpl', '68d7a20fdb3a245a8444d5ea27924b4c');
        $this->checkFile('themes/merchants/Coupe_window/accounting_filter.tpl', '0943670f8ba31ff555e7dc4e5915fdf3');
        $this->checkFile('themes/merchants/Coupe_window/accounting_gadget_data.tpl', 'd94f4bee085512317d28081b9f1d5c26');
        $this->checkFile('themes/merchants/Coupe_window/accounting_gadget_template.tpl', '99927018924623a51361c651857aa116');
        $this->checkFile('themes/merchants/Coupe_window/accounting_panel.tpl', 'd7f9fabde5bcf7c62aba29d35b80238b');
        $this->checkFile('themes/merchants/Coupe_window/accounting_stats_data.tpl', '4f714be5959067fa8962919a6c50bb8c');
        $this->checkFile('themes/merchants/Coupe_window/accounts_fields.tpl', '1d3c5c66916b50467c03d8602aa291c5');
        $this->checkFile('themes/merchants/Coupe_window/accounts_filter.tpl', 'dd123439f945f76b09422ad55b2bd4cb');
        $this->checkFile('themes/merchants/Coupe_window/accounts_invoices_panel.tpl', '72549ab9f2c93fa123b3a3d92bf79c25');
        $this->checkFile('themes/merchants/Coupe_window/accounts_panel.tpl', '77b8fd37eb4f0427cf2b3a6f757e30d8');
        $this->checkFile('themes/merchants/Coupe_window/add_affiliate_page.tpl', 'e69a0888131f7a941dc7e7c744f5dd11');
        $this->checkFile('themes/merchants/Coupe_window/add_affiliate_page_content.tpl', '0f11dbecb7f2f1eea6ab769eb625e322');
        $this->checkFile('themes/merchants/Coupe_window/add_affiliate_page_page.tpl', '70a1f240785c415fb99947f94972de26');
        $this->checkFile('themes/merchants/Coupe_window/add_affiliate_page_url.tpl', '58f8f5e302e28d28522e7265e3694665');
        $this->checkFile('themes/merchants/Coupe_window/add_affiliate_to_campaign.tpl', 'ddb8f68a2edb3955a5a209e11442b1bf');
        $this->checkFile('themes/merchants/Coupe_window/add_affiliate_to_group.tpl', '4f69927d7cad9e8466fe91bd3e3af69c');
        $this->checkFile('themes/merchants/Coupe_window/add_custom_translation.tpl', '91a22a74346db521569588e934048e79');
        $this->checkFile('themes/merchants/Coupe_window/add_gadget_category.tpl', 'e2ec9306de4bf074a33e72c96ff238ca');
        $this->checkFile('themes/merchants/Coupe_window/add_gadget_panel.tpl', 'be8c80e8aff49f52f5b5c1b79be9526f');
        $this->checkFile('themes/merchants/Coupe_window/add_gadget_select_url.tpl', 'b9e3459257a1d9c8a6c66009c826d06c');
        $this->checkFile('themes/merchants/Coupe_window/add_transaction_form.tpl', '6c9da9a05ee604bb7ad0cc4225c07e88');
        $this->checkFile('themes/merchants/Coupe_window/add_user_to_group_form.tpl', 'f5353d26cbc32f5b59f99d0388244462');
        $this->checkFile('themes/merchants/Coupe_window/additional_dynamic_form_panel.tpl', '39fe1aad3bb309004ee15c8537c90d15');
        $this->checkFile('themes/merchants/Coupe_window/admin_panel.tpl', '974dc9641d622a6723650da268bebf5f');
        $this->checkFile('themes/merchants/Coupe_window/admins_panel.tpl', '043af9e3cecec2e85866aa06c2a04a37');
        $this->checkFile('themes/merchants/Coupe_window/admins_panel_filter.tpl', '4ec418856a865586f6d6ed313e0cffb6');
        $this->checkFile('themes/merchants/Coupe_window/advanced_email_settings_form.tpl', '304064505236c0bb68e3a8f4bc3b1c08');
        $this->checkFile('themes/merchants/Coupe_window/advanced_email_settings_tab.tpl', '4cdac3ab7ec6827e1307d48028f2d835');
        $this->checkFile('themes/merchants/Coupe_window/advanced_integration_steps_icons.tpl', 'fc1f4fb9ee86fc80e6ef1e365e0d77f5');
        $this->checkFile('themes/merchants/Coupe_window/aff_notifications_form.tpl', '710e1c259bbe90a1ba43eefb07acc1c2');
        $this->checkFile('themes/merchants/Coupe_window/affilate_advanced_filter.tpl', '11bde2dcecd82caeeb4616944f36ff5b');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_commission_groups.tpl', '9d4046dbc63fe4b678f8c62ffca79854');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_delete.tpl', '2157c7c0e31996f4fc0f85a185977ac5');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_details.tpl', 'bd86d96ae0a6f75ea0547ca235cabde6');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_edit_commission_groups_no_data.tpl', 'a9756aeb0730e4fd5f4fa9cb6de8012b');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_edit_details.tpl', '0f2e7456470ab8dd66505d0805d4658c');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_edit_details_additional.tpl', '98de15bb9a88b36dc47ba266389cb413');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_edit_dialog.tpl', 'acaf92b10f7821b0f5794593db70df01');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_edit_no_payout_history.tpl', '0d40b1e330f67d9e74c3890beca74b29');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_fields.tpl', '90cb94708ed0ff485bee0d2bf3793989');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_general_settings.tpl', 'e747d64338280436d5f3478d1f0cb514');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_info_data.tpl', 'b57513f9b5504095638e810826ac3e63');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_list.tpl', 'cc032a88a7775b2938522ca3f58dc755');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_list_no_data.tpl', '7741570acae759090cf04aeb6f313bb2');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_logins.tpl', '9f5432cc0f1f1bb464a38a23fb16e6e3');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_logins_header.tpl', '7fc020dd9a1268955faaf16b973b82c7');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_logins_map.tpl', '76fe92abae4eacb0bfbd670ac54aa0b3');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_menu_settings.tpl', '3507cb91be549e264e21b007c3571ba8');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_panel_config.tpl', '99bc43fef7dbe936c4e733215585a277');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_payout_settings.tpl', '8304e34183caa27262c69cec69c12373');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_postsignup_settings.tpl', '295c4b2802684750cc74e93282fb5732');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_screen_detail.tpl', '1075539ad2bdd3dd1eeb74078b054f03');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_screen_header_edit.tpl', 'cb37af28ddbd0c61c9abadf675e7d8bc');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_screen_settings.tpl', '5fb92d5bc22ff7ede5ec1572ef94ced9');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_screen_settings_nodata.tpl', 'bb4ad3e2d922192ec998ee5ae5c51e50');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_screens_list.tpl', '08ad8cbadce365f01978ef5f8b0c7d32');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_signup_settings.tpl', 'c9a8f99f2c61ead6d8bdb0d125e0f183');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_signup_settings_button.tpl', 'adccd555745134a857328990ed086077');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_signup_settings_form.tpl', 'eb832a062e7059bb5074dbeec7f2f890');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_stats.tpl', 'b1c8b06e198d9ed22a5564a73ff26e0e');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_subaffiliates.tpl', '633205fc5244112afa932c8b18f58edd');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_tracking_code_filter.tpl', '614c11facd7d5ebaee38deae93e139c9');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_tracking_code_panel.tpl', '2563d59c5d920af9e929d25715e3758e');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_tracking_cookiepanel.tpl', 'afe8791a0c4895979c261a672103de97');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_tracking_options.tpl', '85a3391abee5f9a8dc727fe266534ed8');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_tracking_testlinks.tpl', '3407045ee29fe67b40621cdb381ff40e');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_tree.tpl', '875e8e5d865578c1b5efe31580b9e719');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_tree_filter.tpl', 'c676ed3f6a9ee3860ad9e60e62dbab86');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_tree_filter_edit.tpl', '959100eeceade475bc20ec5272660a38');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_tree_panel.tpl', '9ddd4e10bea7ad43a028f867760df9d6');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_url_page_editor.tpl', '1563cbaaa42ab9c7c0c8898a17b3b10a');
        $this->checkFile('themes/merchants/Coupe_window/affiliate_urls_no_data.tpl', 'c9868414093445accf0f0d7551847116');
        $this->checkFile('themes/merchants/Coupe_window/affiliates_group.tpl', 'e1f5bcb91bd2f949694890186ff3566a');
        $this->checkFile('themes/merchants/Coupe_window/affiliates_group_filter.tpl', '466c832f6c6b327cbee63030a81d410c');
        $this->checkFile('themes/merchants/Coupe_window/affiliates_import.tpl', '5d25493eca047e7b66627090a7bcf423');
        $this->checkFile('themes/merchants/Coupe_window/affpanel_design.tpl', '47558761ee69c8a906f6b3f3c0b7fe1e');
        $this->checkFile('themes/merchants/Coupe_window/after_signup_actions_fields_no_data.tpl', '2fe9a7bbd29402632be238ea0cb7f2dd');
        $this->checkFile('themes/merchants/Coupe_window/after_signup_actions_no_data.tpl', 'c9868414093445accf0f0d7551847116');
        $this->checkFile('themes/merchants/Coupe_window/after_signup_no_data.tpl', 'acc4136ac3d8c01816ce79b2281ca9f1');
        $this->checkFile('themes/merchants/Coupe_window/align_widget.tpl', '124769dbcc410ae58c1dfd53f15b58d6');
        $this->checkFile('themes/merchants/Coupe_window/api_integration.tpl', '87329cb5ed35f3bfbb29e45947ae8bab');
        $this->checkFile('themes/merchants/Coupe_window/assigment.tpl', '48b84b37bf127adc78ef230b61a22e60');
        $this->checkFile('themes/merchants/Coupe_window/assign_auto_panel.tpl', '4414ff53bc35c96dd1932aa630eb128f');
        $this->checkFile('themes/merchants/Coupe_window/audit_log_filter.tpl', '67c7322e9a203c85a10210cb496b110e');
        $this->checkFile('themes/merchants/Coupe_window/available_values_edit.tpl', 'e96fa729b9a61e7e4a21fbddf80565fb');
        $this->checkFile('themes/merchants/Coupe_window/banner_and_link_form_panel.tpl', '5c7a5c4a303dffe6d76424abd90a0236');
        $this->checkFile('themes/merchants/Coupe_window/banner_button.tpl', 'e1cb4d807552c33476c9dc37bca24dc6');
        $this->checkFile('themes/merchants/Coupe_window/banner_category_edit.tpl', '2fc9f159a4666a456e4de83356cf2511');
        $this->checkFile('themes/merchants/Coupe_window/banner_category_item.tpl', '55fcd96a4eabd7825f722f3f36bab5d4');
        $this->checkFile('themes/merchants/Coupe_window/banner_category_selector.tpl', 'ba32ee51a99861b1a19d9b66e45f4db0');
        $this->checkFile('themes/merchants/Coupe_window/banner_category_settings_panel.tpl', 'fa002655c612fad61b7cd5121e786391');
        $this->checkFile('themes/merchants/Coupe_window/banner_clone_dialog.tpl', '87df8d4453785b4924425c45fc252f20');
        $this->checkFile('themes/merchants/Coupe_window/banner_destination_url_panel.tpl', 'd2cf85ec3a941d8acc4f8c673c3c2781');
        $this->checkFile('themes/merchants/Coupe_window/banner_destinations.tpl', 'c2466e9211af205aaa302153ecf54ec0');
        $this->checkFile('themes/merchants/Coupe_window/banner_details.tpl', '02ec398758e8c9d094be8ddd3dea86e9');
        $this->checkFile('themes/merchants/Coupe_window/banner_details_params.tpl', 'daca6d0de978ff1a272adbe072455399');
        $this->checkFile('themes/merchants/Coupe_window/banner_edit_header.tpl', '8be5daca610e30e2fc600a9c8a03cf56');
        $this->checkFile('themes/merchants/Coupe_window/banner_edit_panel.tpl', 'd371721abec7a70439373826893749c8');
        $this->checkFile('themes/merchants/Coupe_window/banner_filter.tpl', '7b882e0c59b2b1e588d8c4b1be17dfde');
        $this->checkFile('themes/merchants/Coupe_window/banner_format_form.tpl', '5f8fd9d50c3f4817158302d1834f7e26');
        $this->checkFile('themes/merchants/Coupe_window/banner_in_rotator_edit_panel.tpl', '331b8b61058b5f85750cc690e63d08cc');
        $this->checkFile('themes/merchants/Coupe_window/banner_list_no_data.tpl', '6ec4d243cc9d9b0ee86612709590882e');
        $this->checkFile('themes/merchants/Coupe_window/banner_manager.tpl', '18d6d96df57962f8d1a9b8effe339b15');
        $this->checkFile('themes/merchants/Coupe_window/banner_name.tpl', '0e8385998fddbc3260837cf0590a35a5');
        $this->checkFile('themes/merchants/Coupe_window/banner_or_link_edit_template_panel.tpl', '346160178349fe7d0b8f4f55bbf96ecd');
        $this->checkFile('themes/merchants/Coupe_window/banner_or_link_not_selected.tpl', '180941a437e8e722a4b7f7b44e73e0f0');
        $this->checkFile('themes/merchants/Coupe_window/banner_own_size_panel.tpl', 'ec916344f7150972a863c771ccb676df');
        $this->checkFile('themes/merchants/Coupe_window/banner_parameters_coupon.tpl', 'd7c6fc6e00c9e11d262f7c767454b9c7');
        $this->checkFile('themes/merchants/Coupe_window/banner_parameters_flash.tpl', 'a6356eb54289b4b062c0250c5e9b7963');
        $this->checkFile('themes/merchants/Coupe_window/banner_parameters_hover.tpl', 'f15317ed6c2ed30c9a2e897dbaaa79a6');
        $this->checkFile('themes/merchants/Coupe_window/banner_parameters_html.tpl', 'f00f7657b51377b05cca05db4a27b4bf');
        $this->checkFile('themes/merchants/Coupe_window/banner_parameters_image.tpl', 'f4227e6ffab89f9fecf00de0db1ea261');
        $this->checkFile('themes/merchants/Coupe_window/banner_parameters_pagepeel.tpl', 'f0477017e173b2a6d887e3eabe77ccc8');
        $this->checkFile('themes/merchants/Coupe_window/banner_parameters_pagepeelhtml.tpl', 'c4722a470e19f5966ee208dfd75b72cd');
        $this->checkFile('themes/merchants/Coupe_window/banner_parameters_pdf.tpl', 'b02138b4e56eb4d1b40be08282348643');
        $this->checkFile('themes/merchants/Coupe_window/banner_parameters_promo_email.tpl', '5d558a2ce40bd6997c670115425bc67b');
        $this->checkFile('themes/merchants/Coupe_window/banner_parameters_rebrandpdf.tpl', '11451d812f2b92bf7928f77a448252ba');
        $this->checkFile('themes/merchants/Coupe_window/banner_parameters_rebrandpdf_allvars.tpl', 'c01f39df6d7b58ed19794de908c314b2');
        $this->checkFile('themes/merchants/Coupe_window/banner_parameters_rebrandpdf_filefield.tpl', '4f3e422e757c8bd5c3460a24dd453153');
        $this->checkFile('themes/merchants/Coupe_window/banner_parameters_rotator.tpl', 'be18e74db4df618a8452b053fed379b6');
        $this->checkFile('themes/merchants/Coupe_window/banner_parameters_site.tpl', '80b74b4c7419b3fd362fcffb1ebe0639');
        $this->checkFile('themes/merchants/Coupe_window/banner_parameters_site_files.tpl', 'ce4cb65e15ec625747ee5a7359ad123b');
        $this->checkFile('themes/merchants/Coupe_window/banner_parameters_site_files_local.tpl', 'a7f630aa7eb54c3cb467cb80f17674cc');
        $this->checkFile('themes/merchants/Coupe_window/banner_parameters_site_files_url.tpl', '9e1571660d6fab85245ee3418abd1350');
        $this->checkFile('themes/merchants/Coupe_window/banner_parameters_site_preview.tpl', '7dcf0d92d184a60ff334ad28adb1fd66');
        $this->checkFile('themes/merchants/Coupe_window/banner_parameters_site_variables.tpl', 'adb74a84e21883cd904c0732316c0bce');
        $this->checkFile('themes/merchants/Coupe_window/banner_parameters_zip.tpl', '262a21aedc240fc1e154b3274cf38cf5');
        $this->checkFile('themes/merchants/Coupe_window/banner_parameters_zip_bannerpreview.tpl', '919258983eb853742ec1aabd2505f388');
        $this->checkFile('themes/merchants/Coupe_window/banner_parameters_zip_files.tpl', '0d3f2c5edba5f03f8fb35dcbaeeebae2');
        $this->checkFile('themes/merchants/Coupe_window/banner_parameters_zip_variables.tpl', 'bea861fe51d3a9e95f9ae5e5cf9c4e81');
        $this->checkFile('themes/merchants/Coupe_window/banner_params_link.tpl', '16e7b10d24dd70483e8c67184d3ec46f');
        $this->checkFile('themes/merchants/Coupe_window/banner_params_text_link.tpl', '36887496682c2c2872c526ca6acba1fd');
        $this->checkFile('themes/merchants/Coupe_window/banner_preview.tpl', '75b30e1735f8ec02072cb2aa83a06047');
        $this->checkFile('themes/merchants/Coupe_window/banner_preview_field.tpl', '71e5ce8dff03853ca9e30de9dfe5006c');
        $this->checkFile('themes/merchants/Coupe_window/banner_preview_widget.tpl', 'f21248876762eecce70f4f6a6d64cad1');
        $this->checkFile('themes/merchants/Coupe_window/banner_rotator_feature_on_deactivate.tpl', 'a1bfe671194574c6d8b231e70bbd0f08');
        $this->checkFile('themes/merchants/Coupe_window/banner_size.tpl', 'e74a26d2165d73dc5a842acd7f481c97');
        $this->checkFile('themes/merchants/Coupe_window/banner_stats_filter.tpl', '99385b61d4e01703bc055a1a910564a1');
        $this->checkFile('themes/merchants/Coupe_window/banner_stats_list.tpl', '3e71f3763376f08380959fe865aad875');
        $this->checkFile('themes/merchants/Coupe_window/banner_stats_list_no_data.tpl', '2bac0448c515370fac072b46a74938ec');
        $this->checkFile('themes/merchants/Coupe_window/banner_with_category_filter_field.tpl', 'dd1d3439d1f76c0deda21232287fbdd2');
        $this->checkFile('themes/merchants/Coupe_window/banner_wrapper_edit_panel.tpl', 'e13d8f01e20f4fa82847845bfac1026b');
        $this->checkFile('themes/merchants/Coupe_window/banner_wrappers_table.tpl', '54f784f44c21afa6941daecd6088cd4a');
        $this->checkFile('themes/merchants/Coupe_window/banners_and_links_format.tpl', 'a298ada6f4a07b79050cb51d23ac099f');
        $this->checkFile('themes/merchants/Coupe_window/banners_categories_list.tpl', '4b6c1997242f90357b1c721a4303d816');
        $this->checkFile('themes/merchants/Coupe_window/banners_categories_tree.tpl', 'fc55213c31030c3a47d4b80338c88783');
        $this->checkFile('themes/merchants/Coupe_window/bannerscategories_no_data.tpl', '3df35d8c385cfc14c75759c80f11aa02');
        $this->checkFile('themes/merchants/Coupe_window/bannerscategories_not_in_category.tpl', 'b4797977dcf354a6a7c77745910e839a');
        $this->checkFile('themes/merchants/Coupe_window/branding_config.tpl', 'bd94806a4df51742d143a23dec8f2cdb');
        $this->checkFile('themes/merchants/Coupe_window/breadcrumbs.tpl', '9981a5d8af1fb510574d67a2e0ba2481');
        $this->checkFile('themes/merchants/Coupe_window/breadcrumbs_entry.tpl', '42ee9a25b7525589ed65bf9625adc890');
        $this->checkFile('themes/merchants/Coupe_window/button.tpl', '40db744b463f7f71d97cd92ff46fecf4');
        $this->checkFile('themes/merchants/Coupe_window/buy_feature.tpl', 'adfbf6783ae850e63499a923231e4f37');
        $this->checkFile('themes/merchants/Coupe_window/calendar.tpl', 'd6831aa786acf1f829a90cec776126eb');
        $this->checkFile('themes/merchants/Coupe_window/campaign_account.tpl', '9e2989cc05bb9dac952b80a40246e4e2');
        $this->checkFile('themes/merchants/Coupe_window/campaign_capping.tpl', 'b9f6737a4b04f0eca0d7957191b51231');
        $this->checkFile('themes/merchants/Coupe_window/campaign_category_edit.tpl', 'd1460a8d0cb69f821b18051a81907550');
        $this->checkFile('themes/merchants/Coupe_window/campaign_category_item.tpl', 'de7ade79ce37b86264373c01e9ad4149');
        $this->checkFile('themes/merchants/Coupe_window/campaign_category_selector.tpl', '4618de8975b4a1f2b94d168304707892');
        $this->checkFile('themes/merchants/Coupe_window/campaign_category_settings_panel.tpl', '18e7ac241cca0c4c360bcf45e7d2ef71');
        $this->checkFile('themes/merchants/Coupe_window/campaign_commissions_tab.tpl', '52c31b8ce3af03ce54ae51917ff87b7a');
        $this->checkFile('themes/merchants/Coupe_window/campaign_filter.tpl', '7f3514d50b873ca8f3e464ad67139a31');
        $this->checkFile('themes/merchants/Coupe_window/campaign_form_edit.tpl', 'b0f898bce9f2960a5b7b1ce53e4eb048');
        $this->checkFile('themes/merchants/Coupe_window/campaign_form_show.tpl', '9bd49430f9655da593402eb6d221a59d');
        $this->checkFile('themes/merchants/Coupe_window/campaign_list_no_data.tpl', 'd44d658e6b3fb7b4b2f6e0e3bbe938c7');
        $this->checkFile('themes/merchants/Coupe_window/campaign_rule_conditions_panel.tpl', 'd4f35ff94140ca1eb7a5e28dbfd22d0c');
        $this->checkFile('themes/merchants/Coupe_window/campaign_rule_conditions_panel_full.tpl', '46ac5265ab6c374aaae2b3c13d4a7734');
        $this->checkFile('themes/merchants/Coupe_window/campaign_schedule_nodata.tpl', '3e87dc9b305506f1f13895478de1ee2e');
        $this->checkFile('themes/merchants/Coupe_window/campaign_scheduler.tpl', '20870e8e684fb12348a0ade8874d66c8');
        $this->checkFile('themes/merchants/Coupe_window/campaign_scheduling_rule_panel.tpl', 'b0403d7927d7e01cb056da9027b82a8b');
        $this->checkFile('themes/merchants/Coupe_window/campaign_screen.tpl', '48d3e63714873d79a6092b2aa0417dd9');
        $this->checkFile('themes/merchants/Coupe_window/campaign_screen_edit.tpl', '4dd40cd4020a39e251a16d01ffa65723');
        $this->checkFile('themes/merchants/Coupe_window/campaign_shortdetails_form.tpl', '99bd3a0b3e5790f2307e9b897dcd6811');
        $this->checkFile('themes/merchants/Coupe_window/campaign_stats_filter.tpl', '656adb646eecec0d3f5091cfce68095d');
        $this->checkFile('themes/merchants/Coupe_window/campaign_stats_list.tpl', 'e45c163f75670253d0dcc5037f7168e2');
        $this->checkFile('themes/merchants/Coupe_window/campaign_stats_list_no_data.tpl', '6991606b8141a584b01311f5eb86bb51');
        $this->checkFile('themes/merchants/Coupe_window/campaign_status.tpl', 'b732873daaced1e1e9aa43cb2f4c09fa');
        $this->checkFile('themes/merchants/Coupe_window/campaign_step_create.tpl', '2d419b7525bdd89abdec8c0d31d1f71d');
        $this->checkFile('themes/merchants/Coupe_window/campaign_type.tpl', '831bfbcebd1f2ccb1040cfdaa2291011');
        $this->checkFile('themes/merchants/Coupe_window/campaign_validity_edit.tpl', '22198581b13ee3fbd1e3729236df3189');
        $this->checkFile('themes/merchants/Coupe_window/campaign_with_category_filter_field.tpl', 'baf1267e1481cb1cf5433a0ccaf80ee8');
        $this->checkFile('themes/merchants/Coupe_window/campaign_wizard.tpl', 'e6f7ad6b18e7c273490cea2a19a19654');
        $this->checkFile('themes/merchants/Coupe_window/campaigns_categories_list.tpl', '8169d41f1880ba87724c80ce89553605');
        $this->checkFile('themes/merchants/Coupe_window/campaigns_categories_tree.tpl', '2d96c71a0f30a75176ae42f055de8ad0');
        $this->checkFile('themes/merchants/Coupe_window/campaigns_grid_settings_affiliate_panel.tpl', '6830692ae10fdc0b2083cc58268baa4c');
        $this->checkFile('themes/merchants/Coupe_window/campaigns_list.tpl', '983019d6bd514bd1a348f8ad840b8c7a');
        $this->checkFile('themes/merchants/Coupe_window/campaignscategories_no_data.tpl', '7d8325a745599a8d918ac08217275012');
        $this->checkFile('themes/merchants/Coupe_window/campaignscategories_not_in_category.tpl', '0dd23250bcee882b765ec32ad21249af');
        $this->checkFile('themes/merchants/Coupe_window/captcha.tpl', '0326fedb283400e2c13eeae155d7b536');
        $this->checkFile('themes/merchants/Coupe_window/category_list.tpl', '579457d7da6e88deda06b092844c5c52');
        $this->checkFile('themes/merchants/Coupe_window/change_status_button.tpl', 'a0d13402819088b5078e8100a21a0159');
        $this->checkFile('themes/merchants/Coupe_window/chart_datatype_popup.tpl', '7a1a0e024c8392ea5df8cd40b179d4f7');
        $this->checkFile('themes/merchants/Coupe_window/check_box_group.tpl', 'e182dd7429a276dc85e09049b2a6c19e');
        $this->checkFile('themes/merchants/Coupe_window/check_box_group_row.tpl', '97219c5c2d3c996953fd6bd882e6200c');
        $this->checkFile('themes/merchants/Coupe_window/checkboxes_filter.tpl', 'fef5c1833920987bd3172dbe9d75797a');
        $this->checkFile('themes/merchants/Coupe_window/clicks_list.tpl', 'bd1179311cf04f759ddcc79744179a93');
        $this->checkFile('themes/merchants/Coupe_window/clicks_list_filter_base.tpl', '6b6ac3cc08d8a1d3a9d3e6e1e473a962');
        $this->checkFile('themes/merchants/Coupe_window/clicks_list_no_data.tpl', 'e2f13b9b96a4f0a248ea753b0c7c9178');
        $this->checkFile('themes/merchants/Coupe_window/clicks_tracking.tpl', '8b5b8f05d6849aea9e00a72a81b2307e');
        $this->checkFile('themes/merchants/Coupe_window/colorpicker.tpl', '297c4e74e89b8b3dedd12e7c319bce41');
        $this->checkFile('themes/merchants/Coupe_window/commission_edit_values.tpl', 'b277423c214667a9202d3aefac1d7619');
        $this->checkFile('themes/merchants/Coupe_window/commission_edit_values_tierpanel.tpl', 'ed403054ea7f2ccb731265f9d3f0ef4f');
        $this->checkFile('themes/merchants/Coupe_window/commission_edit_with_fixedcost.tpl', '3af76ab79f10ff3d0629b1c4b0cc7ba9');
        $this->checkFile('themes/merchants/Coupe_window/commission_group_panel.tpl', 'fbc95c3f3b9a95e9daf3df46d8dc8a2d');
        $this->checkFile('themes/merchants/Coupe_window/commission_groups.tpl', 'cd9f803bcafdc842b0226fa653242f1b');
        $this->checkFile('themes/merchants/Coupe_window/commission_groups_panel.tpl', '44d889bc8bf1f467cbc7d2c18c03c230');
        $this->checkFile('themes/merchants/Coupe_window/commission_recurring.tpl', 'aa827abeee6bb0f472b500c096cd3625');
        $this->checkFile('themes/merchants/Coupe_window/commission_sale.tpl', 'fbdf7f44f6df291e9da9e8172dcad9ce');
        $this->checkFile('themes/merchants/Coupe_window/commission_subsales.tpl', 'c21fc8858085c294ac7630f53d6bd36e');
        $this->checkFile('themes/merchants/Coupe_window/commission_tabs.tpl', '2eec354045cec652c7cd4ff1cfc8bf56');
        $this->checkFile('themes/merchants/Coupe_window/commission_tiers_info_panel.tpl', '20e88ef5e3d641ecd6dd8fea0350b7e1');
        $this->checkFile('themes/merchants/Coupe_window/commission_type_detail.tpl', 'd6d266aba20845c41e04fd8dbfa33732');
        $this->checkFile('themes/merchants/Coupe_window/commission_type_sail_detail.tpl', '73a00350b64b30cb1b5341e050982d83');
        $this->checkFile('themes/merchants/Coupe_window/commissions_details_view.tpl', '6481e92bb25a139b55290e0d5b209cdd');
        $this->checkFile('themes/merchants/Coupe_window/commissions_edit.tpl', '9ec2a9da2c0eaf09392f96b836bc0310');
        $this->checkFile('themes/merchants/Coupe_window/commissions_panel.tpl', 'ff232af7da984c8e346b2bc9b8a6ca88');
        $this->checkFile('themes/merchants/Coupe_window/compressed_commission_settings.tpl', 'b355949c5d9849b51c1f59f96c7e4acc');
        $this->checkFile('themes/merchants/Coupe_window/comunication_overview_panel.tpl', '06ea7c53421b51e4a8fed669637a909f');
        $this->checkFile('themes/merchants/Coupe_window/config_aff_panel.tpl', '58c2a6eae06023e889cee734923b713e');
        $this->checkFile('themes/merchants/Coupe_window/config_affiliates.tpl', '4870980191d1873460bbc2d8894b2bf2');
        $this->checkFile('themes/merchants/Coupe_window/config_communication.tpl', 'b7af569e05800de423c52fc28d7bc40b');
        $this->checkFile('themes/merchants/Coupe_window/config_currencies_form.tpl', 'cdff097c17040c60be3ace45afa62642');
        $this->checkFile('themes/merchants/Coupe_window/config_currency_tab.tpl', '57c84054dcf9ca885c39c1d9bddb860c');
        $this->checkFile('themes/merchants/Coupe_window/config_date_format.tpl', '771f72b6514cd4c9103217a955fb171d');
        $this->checkFile('themes/merchants/Coupe_window/config_language_and_date_form.tpl', '1ad6231d44243a014dd06b3a18709fac');
        $this->checkFile('themes/merchants/Coupe_window/config_overview.tpl', '60db4f006e3afe01077620baf9bc19fa');
        $this->checkFile('themes/merchants/Coupe_window/config_signup_form.tpl', '884261ef7e0c23326874bd92cdda1094');
        $this->checkFile('themes/merchants/Coupe_window/config_system.tpl', '783ebbddb4a39f395967456062db2396');
        $this->checkFile('themes/merchants/Coupe_window/config_theme_panel.tpl', '6c2d25df8475293b96c1048c9fd15fd0');
        $this->checkFile('themes/merchants/Coupe_window/config_themes.tpl', '0bab46cdedf333176ecb62c8cdc1d672');
        $this->checkFile('themes/merchants/Coupe_window/config_tracking.tpl', '81056b36d3ec69a8fac9d843ed7d7240');
        $this->checkFile('themes/merchants/Coupe_window/confirm_dialog.tpl', 'f92a8f6b3081444abf7fc4ab63c99302');
        $this->checkFile('themes/merchants/Coupe_window/confirm_dialog_label_note.tpl', 'f76c3c08642335eb7b3e0ce42bfe753a');
        $this->checkFile('themes/merchants/Coupe_window/confirm_dialog_label_value.tpl', '0c2d427e2c1c8f4545a90a3a56e64580');
        $this->checkFile('themes/merchants/Coupe_window/confirm_dialog_with_checkbox.tpl', '9e1fd32194d6bfabb251bad0645755da');
        $this->checkFile('themes/merchants/Coupe_window/confirm_dialog_with_value.tpl', '46e7630a0a094110f6819ea655683337');
        $this->checkFile('themes/merchants/Coupe_window/content_gadget_panel.tpl', '79428f6a77f38592dfa1716653bbe79b');
        $this->checkFile('themes/merchants/Coupe_window/context_menu.tpl', 'cddf235a2fec1ae75063d576ccdc6185');
        $this->checkFile('themes/merchants/Coupe_window/cookie_lifetime_group.tpl', 'ea8a6a5ad128f265d7d6891a41fdf097');
        $this->checkFile('themes/merchants/Coupe_window/cookies_tab.tpl', '0ee8a325e03187328807a5c149eb90be');
        $this->checkFile('themes/merchants/Coupe_window/copy_campaign.tpl', 'a12f62962eb0cb273f54414f688f091a');
        $this->checkFile('themes/merchants/Coupe_window/copy_user_role.tpl', '31c4493a09a1d2ad96e0c6133399199c');
        $this->checkFile('themes/merchants/Coupe_window/countries_list_scrolling_wrapper.tpl', '4bf0a92924334c72075b4ddafd3b243b');
        $this->checkFile('themes/merchants/Coupe_window/country_commission_type_panel.tpl', 'e7586309287420a9851dc0ab3ce65563');
        $this->checkFile('themes/merchants/Coupe_window/country_select_panel.tpl', '8503f8f693cc44082380626a7b0ebbfc');
        $this->checkFile('themes/merchants/Coupe_window/country_specific_commission_type_panel.tpl', 'db0122ec2a13ac87a9443a6dc4594302');
        $this->checkFile('themes/merchants/Coupe_window/coupons_filter.tpl', '4caab93e4b46d2f0fff1d619536efb8b');
        $this->checkFile('themes/merchants/Coupe_window/coupons_import.tpl', 'e9bb34e160a258ff1deb1dfe55f0e4a5');
        $this->checkFile('themes/merchants/Coupe_window/coupons_panel.tpl', 'dcb054cd9abe5cbea02724014d27c7ef');
        $this->checkFile('themes/merchants/Coupe_window/create_banners_buttons.tpl', 'd981b97a16d7f5620a85944aa8d550f7');
        $this->checkFile('themes/merchants/Coupe_window/cron_job_integration.tpl', '0bd75d5d32d1d775a4c81a7cc1a41cdb');
        $this->checkFile('themes/merchants/Coupe_window/currencies_no_data.tpl', 'e3a2a92b3119abe6bca9ce0b0e505c28');
        $this->checkFile('themes/merchants/Coupe_window/currency_form.tpl', 'dbee13da7abe05b10990f7ee89eee4be');
        $this->checkFile('themes/merchants/Coupe_window/currency_textbox.tpl', 'b25a0b754d14d14452ecb52e0a090d2a');
        $this->checkFile('themes/merchants/Coupe_window/custom.css', '4877ef2467745239a93ebe1e79b2f813');
        $this->checkFile('themes/merchants/Coupe_window/custom_cookie_panel.tpl', 'b1b3a9b5c5aa2b7de8e67fa2975bbf0e');
        $this->checkFile('themes/merchants/Coupe_window/custom_date_panel.tpl', 'c624f3d63d0e94db867529dc13a827d1');
        $this->checkFile('themes/merchants/Coupe_window/custom_filter_element.tpl', 'bf05e5d299fb1982ea8139f2a605846b');
        $this->checkFile('themes/merchants/Coupe_window/custom_filter_field.tpl', '21c8ab135d5d89e320ec85456ec457e0');
        $this->checkFile('themes/merchants/Coupe_window/custom_time_panel.tpl', 'd408a8352774d70124788d61a90493b6');
        $this->checkFile('themes/merchants/Coupe_window/daily_report.tpl', 'ae280bf29c298b0a0e28944cc61c9e86');
        $this->checkFile('themes/merchants/Coupe_window/daily_report_filter.tpl', '4fb9b31f01026eb252955d75c0428d99');
        $this->checkFile('themes/merchants/Coupe_window/data_field.tpl', 'dd553594505158cd53cc285d3a91fe23');
        $this->checkFile('themes/merchants/Coupe_window/data_field_with_help.tpl', '4615cdd789beea34c16b4c1f692a3a3b');
        $this->checkFile('themes/merchants/Coupe_window/database_status_panel.tpl', '57191b13eff4abf914143e15b97bac30');
        $this->checkFile('themes/merchants/Coupe_window/date_number_format_panel.tpl', 'e26284328d2ba7da47d30e8e458c13b1');
        $this->checkFile('themes/merchants/Coupe_window/date_preset_panel.tpl', 'abc7d225baa948aed70cc1073b786fe8');
        $this->checkFile('themes/merchants/Coupe_window/date_range_filter.tpl', '3875dbc075f33ccaac856190ee103557');
        $this->checkFile('themes/merchants/Coupe_window/date_range_filter_field.tpl', '94048704212b6797b7b7a08fb7888da9');
        $this->checkFile('themes/merchants/Coupe_window/date_textbox.tpl', '4d2bf89bd754bbaccc15e48d7a37dd02');
        $this->checkFile('themes/merchants/Coupe_window/daterange_popup.tpl', 'dc1728d13b0440b8df5e12359010168a');
        $this->checkFile('themes/merchants/Coupe_window/datetimepickercontent.tpl', '9771684f29bc88d974cc64283055d1d1');
        $this->checkFile('themes/merchants/Coupe_window/deeplink_generator_network_setting_edit.tpl', '818d1c4a3bb685f4cb6e825a2c577d82');
        $this->checkFile('themes/merchants/Coupe_window/default_campaign_form.tpl', '2524ebdb94130b6701af650fb63c9c68');
        $this->checkFile('themes/merchants/Coupe_window/default_theme_config.tpl', 'fd3377e1da30c75e82ed6db948bc9199');
        $this->checkFile('themes/merchants/Coupe_window/description_panel.tpl', 'eb196bc81ac670a6081876c8d17158c0');
        $this->checkFile('themes/merchants/Coupe_window/design_panel.tpl', 'ee823fb6ea6bc06ff8ab43422a986363');
        $this->checkFile('themes/merchants/Coupe_window/desktop.tpl', '96fc6ae799e2f8b67c48e6bcec8fc1d3');
        $this->checkFile('themes/merchants/Coupe_window/desktop_gadget.tpl', '21394ff13337e4716860c12b5e4fb312');
        $this->checkFile('themes/merchants/Coupe_window/desktop_main_menu.tpl', '31eb02f3f6b767d24012753d50ff5159');
        $this->checkFile('themes/merchants/Coupe_window/desktop_settings_mode.tpl', '1054d3be606383580f8d521f2d72682f');
        $this->checkFile('themes/merchants/Coupe_window/destination.tpl', '3f11435e707dc3ef178328280ef4614e');
        $this->checkFile('themes/merchants/Coupe_window/destination_panel.tpl', 'f8a860741ffc1e8bdd52437db021caaf');
        $this->checkFile('themes/merchants/Coupe_window/direct_link_form.tpl', '021296b8ff10db11432c3429c779c8a6');
        $this->checkFile('themes/merchants/Coupe_window/direct_link_grid_widget.tpl', '586c3b902d66c903d87e510bca5843ec');
        $this->checkFile('themes/merchants/Coupe_window/directlinks_advanced_filter.tpl', '65c2e2150b56faacebc94ec4eb426935');
        $this->checkFile('themes/merchants/Coupe_window/directlinks_list.tpl', '3047fe6b8e221bb3e186190f6eeeeb3f');
        $this->checkFile('themes/merchants/Coupe_window/directlinks_list_no_data.tpl', 'f1f450f7a011578950f7253089286a34');
        $this->checkFile('themes/merchants/Coupe_window/disclosure_content.tpl', '27557135898f8d0dc1ff849cba4f875a');
        $this->checkFile('themes/merchants/Coupe_window/download_auto_reg_banner_form.tpl', '8ef3e7205380f487fa84bc4eaf5f5c63');
        $this->checkFile('themes/merchants/Coupe_window/download_auto_reg_iframe_form.tpl', '59498b35efce960fd3b4871d26d7855b');
        $this->checkFile('themes/merchants/Coupe_window/download_auto_reg_link_form.tpl', '33484bae042f1bde3a5a163eab5570f0');
        $this->checkFile('themes/merchants/Coupe_window/download_login_form.tpl', 'd73ed70f4d96b76f37965d9f8c753ac5');
        $this->checkFile('themes/merchants/Coupe_window/download_signup_form.tpl', 'e608aa9b32b4b044d528815cb9392516');
        $this->checkFile('themes/merchants/Coupe_window/drag_container.tpl', '358104feb6f9c3c2a01206e460726eac');
        $this->checkFile('themes/merchants/Coupe_window/dynamic_form_panel.tpl', 'ea42da62b4a44f1fa9caf50a59c29160');
        $this->checkFile('themes/merchants/Coupe_window/edit_affiliate_page_page.tpl', '367f8d79bdffc8cb0dcc344e2c1c79bd');
        $this->checkFile('themes/merchants/Coupe_window/edit_destination_url_widget.tpl', 'd0918936a67033179b7b41946e54ddb5');
        $this->checkFile('themes/merchants/Coupe_window/edit_textarea_widget.tpl', '94b2c94dd103b5209bd89470fc70268c');
        $this->checkFile('themes/merchants/Coupe_window/edit_tracking_code_widget.tpl', '059499fee95c96a9e0fc37b517b0e72a');
        $this->checkFile('themes/merchants/Coupe_window/editor.tpl', 'a8c5483c720526b56fa899a91045c287');
        $this->checkFile('themes/merchants/Coupe_window/editor_with_constants_panel.tpl', '6c9e8d91f33bc90c661e9b67ca5ff1e1');
        $this->checkFile('themes/merchants/Coupe_window/email_form.tpl', '7809f19dc7e837c8dbe6f4d58e6574b7');
        $this->checkFile('themes/merchants/Coupe_window/email_notifications.tpl', '6e8120071227fb823ed1af6f1b3ad223');
        $this->checkFile('themes/merchants/Coupe_window/email_setting_smtp_form.tpl', 'd17124a143f842ab1876ed14a74bc762');
        $this->checkFile('themes/merchants/Coupe_window/email_settings_spf.tpl', 'ca349c37b841ccef522f8767817bf1d2');
        $this->checkFile('themes/merchants/Coupe_window/email_settings_tab.tpl', '029bff75bc5d1d6eda64c14de2c4d88e');
        $this->checkFile('themes/merchants/Coupe_window/email_template_edit_panel.tpl', '0673c3c609ca2fa5a693bcc03986a0d6');
        $this->checkFile('themes/merchants/Coupe_window/expand_matrix.tpl', 'dc72b136436320776269f40795008156');
        $this->checkFile('themes/merchants/Coupe_window/expired_session_dialog.tpl', 'ba711bd5d1e932ffc4fbc8e601204905');
        $this->checkFile('themes/merchants/Coupe_window/export_files_panel.tpl', 'ea4620e2d7d8da656e903d2a1ee80fec');
        $this->checkFile('themes/merchants/Coupe_window/export_panel.tpl', '054b8f0de5cb1cd25ce50d914b6c64a1');
        $this->checkFile('themes/merchants/Coupe_window/export_to_csv.tpl', '472a1e543ad141354022ce9ce4d16e56');
        $this->checkFile('themes/merchants/Coupe_window/extendable_commission_data.tpl', '43b5108a8212bccdb414370023388e10');
        $this->checkFile('themes/merchants/Coupe_window/extendable_text.tpl', 'a69efdb298a3aae26e26793c9b9fea36');
        $this->checkFile('themes/merchants/Coupe_window/extendable_text_content.tpl', 'cca4ebdf72f3cb7638b6c5bf0f59d9aa');
        $this->checkFile('themes/merchants/Coupe_window/extendable_text_widget.tpl', '83288dfd8795a2a9105965dde2ebc927');
        $this->checkFile('themes/merchants/Coupe_window/feature_detail.tpl', 'b23eb80665302207d86365efbef72846');
        $this->checkFile('themes/merchants/Coupe_window/feature_on_activate.tpl', '544374f96c5524c306a5c6f6f956200c');
        $this->checkFile('themes/merchants/Coupe_window/feature_on_deactivate.tpl', 'a1767954af4547adcfb12cf4107f3468');
        $this->checkFile('themes/merchants/Coupe_window/feature_settings.tpl', '13e5f54c1b98e65f9a4132abe613c188');
        $this->checkFile('themes/merchants/Coupe_window/fee_panel.tpl', '6c4f808bd9b75f8fc11e4fce3196994c');
        $this->checkFile('themes/merchants/Coupe_window/field_type_edit.tpl', 'b1294ba5d4486ea1cf8022a51e277a11');
        $this->checkFile('themes/merchants/Coupe_window/file_widget.tpl', 'a7410b3e376c1b177c47831f83a68c55');
        $this->checkFile('themes/merchants/Coupe_window/files_tree_panel.tpl', 'e11e884c210779b572bc928e01cf3d96');
        $this->checkFile('themes/merchants/Coupe_window/filter.tpl', 'd51de72535f52fc100a59cad0a15fd37');
        $this->checkFile('themes/merchants/Coupe_window/filter_field_decorator.tpl', '531d57478d7718e216ea04ff79d493ca');
        $this->checkFile('themes/merchants/Coupe_window/filter_form.tpl', '67551720cbc190c8df85c24d3f8a4cbe');
        $this->checkFile('themes/merchants/Coupe_window/font/OpenSans/OpenSans-Bold.ttf', '50145685042b4df07a1fd19957275b81');
        $this->checkFile('themes/merchants/Coupe_window/font/OpenSans/OpenSans-Bold.woff', '9c3358645bea28438a96b34355b58942');
        $this->checkFile('themes/merchants/Coupe_window/font/OpenSans/OpenSans-BoldItalic.ttf', '78b08a68d05d5fabb0b8effd51bf6ade');
        $this->checkFile('themes/merchants/Coupe_window/font/OpenSans/OpenSans-BoldItalic.woff', '58851fad50f52be1f51f4e01ebf38a56');
        $this->checkFile('themes/merchants/Coupe_window/font/OpenSans/OpenSans-Extrabold.ttf', '8bac22ed4fd7c8a30536be18e2984f84');
        $this->checkFile('themes/merchants/Coupe_window/font/OpenSans/OpenSans-Extrabold.woff', '9ccabd1c4ea479b66aeced76b5060c0f');
        $this->checkFile('themes/merchants/Coupe_window/font/OpenSans/OpenSans-ExtraboldItalic.ttf', '73d6bb0d4f596a91992e6be32e82e3bc');
        $this->checkFile('themes/merchants/Coupe_window/font/OpenSans/OpenSans-ExtraboldItalic.woff', 'd73d0d6b2a48d336534b668e7adc981f');
        $this->checkFile('themes/merchants/Coupe_window/font/OpenSans/OpenSans-Italic.ttf', 'c7dcce084c445260a266f92db56f5517');
        $this->checkFile('themes/merchants/Coupe_window/font/OpenSans/OpenSans-Italic.woff', 'c0d39dd78d6397286f2dc292465c3517');
        $this->checkFile('themes/merchants/Coupe_window/font/OpenSans/OpenSans-Light.ttf', '1bf71be111189e76987a4bb9b3115cb7');
        $this->checkFile('themes/merchants/Coupe_window/font/OpenSans/OpenSans-Light.woff', '5193f01d42787bba6c0fbda289658b6f');
        $this->checkFile('themes/merchants/Coupe_window/font/OpenSans/OpenSans-Semibold.ttf', '33f225b8f5f7d6b34a0926f58f96c1e9');
        $this->checkFile('themes/merchants/Coupe_window/font/OpenSans/OpenSans-Semibold.woff', 'bbaf165415d191c0b967d80aed2dea9c');
        $this->checkFile('themes/merchants/Coupe_window/font/OpenSans/OpenSans-SemiboldItalic.ttf', '73f7301a9cd7a086295401eefe0c998f');
        $this->checkFile('themes/merchants/Coupe_window/font/OpenSans/OpenSans-SemiboldItalic.woff', '6da7bfea96b6fce269b93524cb113af6');
        $this->checkFile('themes/merchants/Coupe_window/font/OpenSans/OpenSans.ttf', '629a55a7e793da068dc580d184cc0e31');
        $this->checkFile('themes/merchants/Coupe_window/font/OpenSans/OpenSans.woff', '10bb6c1975b08eb0833d810553a209d3');
        $this->checkFile('themes/merchants/Coupe_window/font/OpenSans/OpenSansLight-Italic.ttf', '6943fb6fd4200f3d073469325c6acdc9');
        $this->checkFile('themes/merchants/Coupe_window/font/OpenSans/OpenSansLight-Italic.woff', 'e8358540a6070aff786c6adece2863db');
        $this->checkFile('themes/merchants/Coupe_window/font/fontello.eot', 'cc4c3813496412813e92ce25c7b963e3');
        $this->checkFile('themes/merchants/Coupe_window/font/fontello.svg', '66090721850d522363f5745b6265983f');
        $this->checkFile('themes/merchants/Coupe_window/font/fontello.ttf', 'baf30392615b9f8dd06420642304e9fb');
        $this->checkFile('themes/merchants/Coupe_window/font/fontello.woff', 'aca17066a8fe19fe88404827ede14eee');
        $this->checkFile('themes/merchants/Coupe_window/font/fontello.woff2', '58f62b369b922e87b001bacc5d4e2274');
        $this->checkFile('themes/merchants/Coupe_window/fontello.css', '7abe36cc2ed0ccbbaad467c15445aa12');
        $this->checkFile('themes/merchants/Coupe_window/footer.stpl', '3fbd103789f1ff2a151c16f490a913dd');
        $this->checkFile('themes/merchants/Coupe_window/forced_matrix_panel.tpl', '0f06e2a7d0482fa847967cd918e0e614');
        $this->checkFile('themes/merchants/Coupe_window/form_field.tpl', '5c7ae4b0f01f4a7753ab811e0a57f29f');
        $this->checkFile('themes/merchants/Coupe_window/form_field_checkbox.tpl', '7cf751813e542ef0f0646087eadae2eb');
        $this->checkFile('themes/merchants/Coupe_window/form_field_checkboxgroup.tpl', 'be1b525a89f033d4f79433dd3eaab593');
        $this->checkFile('themes/merchants/Coupe_window/form_field_radio.tpl', '9013ed97a5fc7b4b52052d816a9b25d0');
        $this->checkFile('themes/merchants/Coupe_window/frame_panel.tpl', '7b13a1add8ba712d8a34f4285414b419');
        $this->checkFile('themes/merchants/Coupe_window/fraud_protection_clicks.tpl', '73301bfff7cb1dd3780e29dbb344c2e5');
        $this->checkFile('themes/merchants/Coupe_window/fraud_protection_form.tpl', 'd0992b66d5f952ca446613a5f74b5f3a');
        $this->checkFile('themes/merchants/Coupe_window/fraud_protection_logins.tpl', '0f1336ba44c6ad7ef8b70821b6961e20');
        $this->checkFile('themes/merchants/Coupe_window/fraud_protection_sales.tpl', '793795df266e0941ce8bccff6813ab07');
        $this->checkFile('themes/merchants/Coupe_window/fraud_protection_signups.tpl', '8508f6b4fac15675ef2dac406d7ad408');
        $this->checkFile('themes/merchants/Coupe_window/full_banner_stats.tpl', '9c8d43347b069c27ac3a1af40909a95e');
        $this->checkFile('themes/merchants/Coupe_window/full_commision_stats.tpl', '267321735038275c392ddf30a5c4d35d');
        $this->checkFile('themes/merchants/Coupe_window/full_payout_stats.tpl', '6c5e691e6069884d5d1be146054c14dd');
        $this->checkFile('themes/merchants/Coupe_window/full_transaction_stats.tpl', '2669b46d3f14aa9c57872f5373c2797d');
        $this->checkFile('themes/merchants/Coupe_window/general_no_data.stpl', '03433ae7bf79c177a476922c2ee779c5');
        $this->checkFile('themes/merchants/Coupe_window/generate_coupons_form.tpl', 'beddaaf1aa37c10aab9838f1c4b8f1e8');
        $this->checkFile('themes/merchants/Coupe_window/generate_htaccess.tpl', '05d9d8606bdf35455fb48ec7f928b702');
        $this->checkFile('themes/merchants/Coupe_window/geoip_commissiontype_detailpanel.tpl', '734dc6f1a0cc432cd287f22ef5824f49');
        $this->checkFile('themes/merchants/Coupe_window/geoip_fraudprotection_affiliates.tpl', '8fadf652ac9ea3507a4a6173faf8eb62');
        $this->checkFile('themes/merchants/Coupe_window/geoip_fraudprotection_clicks.tpl', 'db19ca033fb30646f0ae504d43683c92');
        $this->checkFile('themes/merchants/Coupe_window/geoip_fraudprotection_logins.tpl', '660ab5115a24ae974e9739dde8530d30');
        $this->checkFile('themes/merchants/Coupe_window/geoip_fraudprotection_logins_aff.tpl', 'af98bdbc38201d8c9db2d63c83ccdf9d');
        $this->checkFile('themes/merchants/Coupe_window/geoip_fraudprotection_sales.tpl', 'c2c170214c10ba59d591261e85dc4cff');
        $this->checkFile('themes/merchants/Coupe_window/get_pdf.tpl', '7de69c1b98a6f1cac1f9c8e570e3b6b9');
        $this->checkFile('themes/merchants/Coupe_window/getting_started_icons.tpl', '612e44ecb9bc1526bd8694a0655342bf');
        $this->checkFile('themes/merchants/Coupe_window/getting_started_merchant.tpl', '9f02ac92cddb211fce5fb826fe7473e5');
        $this->checkFile('themes/merchants/Coupe_window/google_recaptcha_settings.tpl', 'b93feccb5cdfccc02846aea495459127');
        $this->checkFile('themes/merchants/Coupe_window/gpf.css', 'd518df40fb06dbed6ae5e1d67365c7b1');
        $this->checkFile('themes/merchants/Coupe_window/gpf_db_mail.tpl', 'b5ea5e9ecef2152fdf967085a7689adc');
        $this->checkFile('themes/merchants/Coupe_window/grid.tpl', 'c0efa81ea11d739f933438236d6fb12d');
        $this->checkFile('themes/merchants/Coupe_window/grid_bottombuttons.tpl', '1aa9463da984fac10b988d8758c82297');
        $this->checkFile('themes/merchants/Coupe_window/grid_bottomgridline.tpl', '9bf2013a170e094e82dc1ae0a2ed0f97');
        $this->checkFile('themes/merchants/Coupe_window/grid_nodata.tpl', '340ff6de789cd7277a35d763f6366f24');
        $this->checkFile('themes/merchants/Coupe_window/grid_pager.tpl', '46e6d959616563985ece2d92c0234826');
        $this->checkFile('themes/merchants/Coupe_window/grid_selector.tpl', 'ff2d81e3866f53d540a0d063bdf7b480');
        $this->checkFile('themes/merchants/Coupe_window/grid_topbuttons.tpl', 'b605a4f548962d4bf0c8d8662353b795');
        $this->checkFile('themes/merchants/Coupe_window/grid_topgridline.tpl', '3ff9c43cb7f7fcbbcdc7f03c8822a70d');
        $this->checkFile('themes/merchants/Coupe_window/header.tpl', '32d459ea9f7ebf7a241715058cc91f38');
        $this->checkFile('themes/merchants/Coupe_window/home_edit.tpl', '1e659b8ee09e43c02d567356206c7c93');
        $this->checkFile('themes/merchants/Coupe_window/home_edit_main_template.tpl', 'cd4fbd7e59c2c1813b4b1c9d54025223');
        $this->checkFile('themes/merchants/Coupe_window/home_edit_merch_template.tpl', '1079945929a23a68a38676fe78432211');
        $this->checkFile('themes/merchants/Coupe_window/home_panel.tpl', '1404c1c1a5f5048ce23760ddd33a49b3');
        $this->checkFile('themes/merchants/Coupe_window/home_panel_content.stpl', '9c352e615bb4e6b3741e0362cb5888d4');
        $this->checkFile('themes/merchants/Coupe_window/horizontal_layout_panel.tpl', '8b6098cd64720cff686cc24e06ac4c17');
        $this->checkFile('themes/merchants/Coupe_window/hosted_account.tpl', 'e58e46daeeb498d85227982e6ee6ae2d');
        $this->checkFile('themes/merchants/Coupe_window/hosted_account_plan.tpl', 'bfb67b63d21a4482e2528a4fb581629c');
        $this->checkFile('themes/merchants/Coupe_window/htaccess_panel.tpl', 'b3632f76f8ab6d2e56f7a776401dedaf');
        $this->checkFile('themes/merchants/Coupe_window/html_preview.tpl', '0e08da44b5c86ce6d47c50e3117ba5ba');
        $this->checkFile('themes/merchants/Coupe_window/html_preview_iframe_panel.tpl', '22405951702ab2132d0fe99577f4968e');
        $this->checkFile('themes/merchants/Coupe_window/html_preview_image_panel.tpl', 'ebc5b8605c42ac31f653b65deb66e04d');
        $this->checkFile('themes/merchants/Coupe_window/icon_button.tpl', 'a7497a39fe733586fb4f5a1b9f424b0f');
        $this->checkFile('themes/merchants/Coupe_window/icon_object.tpl', 'ff8d25e63eca03b325c4501e13358fb2');
        $this->checkFile('themes/merchants/Coupe_window/icon_picker.tpl', '77a002b90f678df44bcca5776f314820');
        $this->checkFile('themes/merchants/Coupe_window/icon_picker_panel.tpl', '4342c424a8cb290701f64d0cb63655ec');
        $this->checkFile('themes/merchants/Coupe_window/icon_status_widget.tpl', 'ff9e2bc87e203324cc33c4b3ac365dfe');
        $this->checkFile('themes/merchants/Coupe_window/icons_panel_with_header.tpl', '97091a954a48c0889fa82a2464266e84');
        $this->checkFile('themes/merchants/Coupe_window/image_uploader.tpl', '9f93ea577dd2511b19071fa735b6b684');
        $this->checkFile('themes/merchants/Coupe_window/img/FB_share_button.png', 'a56c7efd784eb61b5ac1e6f4111f59a8');
        $this->checkFile('themes/merchants/Coupe_window/img/LinkedIn_share_button.png', 'd0dfb70a7e64ee73f718af05ce995875');
        $this->checkFile('themes/merchants/Coupe_window/img/cards.jpg', '36a8e2ad3f39a4c9c71c8abbcec24823');
        $this->checkFile('themes/merchants/Coupe_window/img/cron_job_example.png', 'f0cd89597b814b000ef2775c2f9dea1b');
        $this->checkFile('themes/merchants/Coupe_window/img/dirty.gif', 'decca3b96e2c37cf6eb04ddb0d9f669b');
        $this->checkFile('themes/merchants/Coupe_window/img/doc.png', 'c914d3518532910b13728f3d9b43056d');
        $this->checkFile('themes/merchants/Coupe_window/img/draggable.png', 'ab4fb4e3c82ccb353b30640cc36eaf67');
        $this->checkFile('themes/merchants/Coupe_window/img/favicon.ico', 'ac3e93c93589318e5dcf69efc8a76176');
        $this->checkFile('themes/merchants/Coupe_window/img/feature.png', 'a17a20726ab706b8cc4d7ad89ee36ef9');
        $this->checkFile('themes/merchants/Coupe_window/img/folder.png', '74ad8feccb7ac18bde1380dd7bdbdd06');
        $this->checkFile('themes/merchants/Coupe_window/img/html.png', '23bf6c9bc9121ffd0c273b5414faaba0');
        $this->checkFile('themes/merchants/Coupe_window/img/icon-128.png', 'a450a0dd5959518fdb2308cc5e523bcc');
        $this->checkFile('themes/merchants/Coupe_window/img/icon-192.png', '8cb72062e4df9eab6c2a064459a5ee62');
        $this->checkFile('themes/merchants/Coupe_window/img/image.png', '66517d22e9c688e521951b3c2d4498e0');
        $this->checkFile('themes/merchants/Coupe_window/img/input.png', '0df09f38346ba18c1a69510138fc7bea');
        $this->checkFile('themes/merchants/Coupe_window/img/insert.png', '1eb65fc224afb8e9bb81bf6182e7fe22');
        $this->checkFile('themes/merchants/Coupe_window/img/line.short.gif', '13914f3810787c4d0571df1fd447627e');
        $this->checkFile('themes/merchants/Coupe_window/img/no.theme.thumbnail.jpg', 'db2b9f70f5fe89a3c9c2f98d69b19254');
        $this->checkFile('themes/merchants/Coupe_window/img/no_image.gif', '07f5f79d487dbf795f7ea37a04aa24c0');
        $this->checkFile('themes/merchants/Coupe_window/img/pan-logo.svg', 'a19c0ad7bfad0399a0f82599a571db9a');
        $this->checkFile('themes/merchants/Coupe_window/img/pap-logo.svg', '6280dc47fe440c1c1c3af00cc27f1ced');
        $this->checkFile('themes/merchants/Coupe_window/img/paypal.jpg', '1e18c3feef21be6605c97f5ac72e7453');
        $this->checkFile('themes/merchants/Coupe_window/img/pdf.png', 'f8dfa3fa0386adcd2370c6d509a0be91');
        $this->checkFile('themes/merchants/Coupe_window/img/php.png', '2c63cf93ca9b1ff5d5b16c6646a59ddc');
        $this->checkFile('themes/merchants/Coupe_window/img/secure.png', '4490e30d2ac3700e78315f510dfff342');
        $this->checkFile('themes/merchants/Coupe_window/img/swf.png', '1623343ec1b366081175a4d28feb66ae');
        $this->checkFile('themes/merchants/Coupe_window/img/tabs.png', 'fce94d82812219c0ed1b98840637ec3b');
        $this->checkFile('themes/merchants/Coupe_window/img/theme_thumbnail.jpg', 'eb50910722c9a4fdc8af83de2fd39303');
        $this->checkFile('themes/merchants/Coupe_window/img/txt.png', '79520d0ef237730c55eb5bcd50b78ea2');
        $this->checkFile('themes/merchants/Coupe_window/img/unknown_file.png', '3a00859ebcd6dfef1572ecdddbe693fe');
        $this->checkFile('themes/merchants/Coupe_window/img/video.png', '9681c0591166287c6c3144837fdf1008');
        $this->checkFile('themes/merchants/Coupe_window/img/wysiwyg.gif', '017283b1ab06fc9391f796f2c13b0da8');
        $this->checkFile('themes/merchants/Coupe_window/img/xls.png', '3f2844cce5616ee82f1e0dc0b9f0d53b');
        $this->checkFile('themes/merchants/Coupe_window/img/zip.png', 'ce15cafabf396370aac29085b3c1a5dd');
        $this->checkFile('themes/merchants/Coupe_window/import_coupons_form.tpl', '8fc3b5964331ebd6232227b4f8fa937d');
        $this->checkFile('themes/merchants/Coupe_window/import_custom_language_panel.tpl', 'f14fe8af188194edeb7896eb3284c5b1');
        $this->checkFile('themes/merchants/Coupe_window/import_export_panel.tpl', '7562d00dfa6c2eb770a88757ba736996');
        $this->checkFile('themes/merchants/Coupe_window/import_language.tpl', '20d22e5e6eebf43dc6143490803aaa03');
        $this->checkFile('themes/merchants/Coupe_window/import_panel.tpl', 'd8370787bb8f6d6e702c72ed8f7a744d');
        $this->checkFile('themes/merchants/Coupe_window/import_theme_panel.tpl', '5fbd6be91a3a7dbf7b2def44f344b889');
        $this->checkFile('themes/merchants/Coupe_window/info_dialog.tpl', '886c377f8e8c1b2c6957451436e1d090');
        $this->checkFile('themes/merchants/Coupe_window/integration.tpl', 'd3b95932324b2a694eb2928a089a828c');
        $this->checkFile('themes/merchants/Coupe_window/integration_method.tpl', 'cfdd3053443ce85b757a89dc64ddd45e');
        $this->checkFile('themes/merchants/Coupe_window/integration_method_step.tpl', '4661c951290cf670ee9c26b45fff0a8c');
        $this->checkFile('themes/merchants/Coupe_window/integration_methods.tpl', 'aa6a8960f1a72146e31be3ff09c1a908');
        $this->checkFile('themes/merchants/Coupe_window/integration_methods_advanced.tpl', '0e72005d09820e3a2f057ea3c71cb7a7');
        $this->checkFile('themes/merchants/Coupe_window/invoice_data_panel.tpl', '1ac898a59516e468e0f047d97db210c6');
        $this->checkFile('themes/merchants/Coupe_window/invoice_form.tpl', '62a0cbc7e109fc019bcc00457b556594');
        $this->checkFile('themes/merchants/Coupe_window/invoices_filter.tpl', '77faa6e4fbeb2cc872a975a1800fa6a7');
        $this->checkFile('themes/merchants/Coupe_window/invoices_list.tpl', '4ee98efc16f05c766be1ae760cc3837c');
        $this->checkFile('themes/merchants/Coupe_window/ip_detail.tpl', 'ff7f24d21c8ac5aa1f3645cd8d59663a');
        $this->checkFile('themes/merchants/Coupe_window/item.tpl', '717eff0e06a712a76effb2d6723183b5');
        $this->checkFile('themes/merchants/Coupe_window/item_panel.tpl', '29d23d91da01848dcabcddb94eac62ec');
        $this->checkFile('themes/merchants/Coupe_window/keywords_performance.tpl', '0a76bec58708a4041df21ab9548abadc');
        $this->checkFile('themes/merchants/Coupe_window/keywords_performance_advanced_filter.tpl', '618269ec4149b6ffab19282eb9d1a2c5');
        $this->checkFile('themes/merchants/Coupe_window/label_panel.tpl', 'e0c85a01af8477fe16cb6770fbb5e7af');
        $this->checkFile('themes/merchants/Coupe_window/language_create_new.tpl', '486f695b2fe3d17aaf29ae39e7f7e0ea');
        $this->checkFile('themes/merchants/Coupe_window/language_edit_panel.tpl', '5b8d472500f9e38a967306d007409d1f');
        $this->checkFile('themes/merchants/Coupe_window/language_translations_filter.tpl', '930f22e595469a617570927021bf9d15');
        $this->checkFile('themes/merchants/Coupe_window/language_translations_grid.tpl', 'a4247bb921179c395cf7a2972cbcef3f');
        $this->checkFile('themes/merchants/Coupe_window/languages_configuration.tpl', 'a146b693cd6b18b1f7711d750e444175');
        $this->checkFile('themes/merchants/Coupe_window/layout_panel_content.tpl', '353b904baf333a2e0456ef5cb0fa179c');
        $this->checkFile('themes/merchants/Coupe_window/layout_panel_header_navigation.tpl', '6b0d746501001da8615a22d57266dcb0');
        $this->checkFile('themes/merchants/Coupe_window/layout_panel_tab.tpl', '27ee274cfd12ed770eff98d0913dd8e8');
        $this->checkFile('themes/merchants/Coupe_window/license_invalid.tpl', '6181e1127345050c94d6708cd805aefb');
        $this->checkFile('themes/merchants/Coupe_window/lifetime_referral_edit.tpl', '3d3923ef67ea430835a1f951955543b2');
        $this->checkFile('themes/merchants/Coupe_window/lifetime_referrals_filter.tpl', 'dcac6d377be0092c4fbf75b5ff6824e8');
        $this->checkFile('themes/merchants/Coupe_window/lifetime_referrals_import.tpl', '327f3397a82c6613ec6ab3718f916982');
        $this->checkFile('themes/merchants/Coupe_window/lifetime_referrals_panel.tpl', '57fdc30f1434427f31e456701817165a');
        $this->checkFile('themes/merchants/Coupe_window/link_button.tpl', '71fad92bff79f1fd2e1066818afac789');
        $this->checkFile('themes/merchants/Coupe_window/link_method_panel.tpl', '9af6c599de2f311cb0149524b50ff20d');
        $this->checkFile('themes/merchants/Coupe_window/linking_method.tpl', '7e0919bff0810701acf299531e0ef0eb');
        $this->checkFile('themes/merchants/Coupe_window/listbox.tpl', '2739c2a9e22d54280cacf4d67ed2e7bc');
        $this->checkFile('themes/merchants/Coupe_window/listbox_popup.tpl', '8c45877411c0727e814eb5e3caa76822');
        $this->checkFile('themes/merchants/Coupe_window/listdown_button.tpl', 'a1cd26a1aec6d403420971d7469a6f1b');
        $this->checkFile('themes/merchants/Coupe_window/lite_campaign_wizard.tpl', 'eaa5d01dd5deee48986f5f98f22caf40');
        $this->checkFile('themes/merchants/Coupe_window/load_mail_from_template.tpl', '42c0029422eaf077a5b0c316cd3317b5');
        $this->checkFile('themes/merchants/Coupe_window/loadable_tree.tpl', 'e2c214b134bffe5fe2bb38f679a64eb5');
        $this->checkFile('themes/merchants/Coupe_window/loading_indicator.tpl', '8d3b3ac51e79a10e35aa11c9bd87d83c');
        $this->checkFile('themes/merchants/Coupe_window/loading_screen.tpl', '5da99de875a9deebff88a2806fdad49f');
        $this->checkFile('themes/merchants/Coupe_window/loading_template.tpl', '39be2fe5f53ed914cc8979ea146ac398');
        $this->checkFile('themes/merchants/Coupe_window/log_filter.tpl', '7f09ae6ce70590ead04d534e6019fca9');
        $this->checkFile('themes/merchants/Coupe_window/log_list.tpl', '17f5cd218930723c21afa914b4fee8fe');
        $this->checkFile('themes/merchants/Coupe_window/logging_tab.tpl', 'bbe2b73c70c24bbafb56a75ed4279f81');
        $this->checkFile('themes/merchants/Coupe_window/logging_tab_debug.tpl', '32912cc60dfc885333623335a44ab19c');
        $this->checkFile('themes/merchants/Coupe_window/logging_tab_logins_history.tpl', 'e59ce588474c4019a05eafd91c45bd2c');
        $this->checkFile('themes/merchants/Coupe_window/login.tpl', 'e7be8367104ee7221547730250f9b0f0');
        $this->checkFile('themes/merchants/Coupe_window/login_form.tpl', '68fec5fc89be1ee473d62ac966211289');
        $this->checkFile('themes/merchants/Coupe_window/login_main.tpl', '5b3eb0529047463ac6b90a529de64d85');
        $this->checkFile('themes/merchants/Coupe_window/logins_history.tpl', '1ef6edb0f2167b8d05c961c7d6379f92');
        $this->checkFile('themes/merchants/Coupe_window/loginshistory_filter.tpl', '6fa20923cc33142105a51ef6f3a51ad7');
        $this->checkFile('themes/merchants/Coupe_window/logo_settings.tpl', '6c5dbe6195a7b19dd0e0dcb58a207523');
        $this->checkFile('themes/merchants/Coupe_window/logs_no_data.tpl', 'c807c1484862c46a3f72f1ea0d276b3f');
        $this->checkFile('themes/merchants/Coupe_window/mail_detail_data.tpl', '72d679a44b2ad0f888e829b479e6550e');
        $this->checkFile('themes/merchants/Coupe_window/mail_outbox_panel.tpl', 'fa6291a64c1e5a21237be44f192a8c99');
        $this->checkFile('themes/merchants/Coupe_window/mail_template_not_selected.tpl', '8f8e4d19a09cd7bc7e96df0e0729ef8d');
        $this->checkFile('themes/merchants/Coupe_window/mail_template_preview.tpl', 'ea7d0df5aef2645e05d768c51a294389');
        $this->checkFile('themes/merchants/Coupe_window/mail_template_test_form.tpl', 'd5c10c451945fe2cd1545ab10c11a959');
        $this->checkFile('themes/merchants/Coupe_window/mail_templates.tpl', 'cceaeaa496bd10868bcf67ef9f9acc45');
        $this->checkFile('themes/merchants/Coupe_window/mail_templates_list.tpl', '2834084fc2e4bef6ffd06fd86a650a17');
        $this->checkFile('themes/merchants/Coupe_window/mailoutbox_filter.tpl', '59f66fe33f07d333de586095367ca23d');
        $this->checkFile('themes/merchants/Coupe_window/mailoutbox_list_no_data.tpl', '12637515858ca4d960c6202e8a89042b');
        $this->checkFile('themes/merchants/Coupe_window/main.tpl', 'fa8212eeec30d6ec2748f3a3815bd929');
        $this->checkFile('themes/merchants/Coupe_window/main_error_html_doc.tpl', 'e99d46538cab7c9fe32dc247711589d3');
        $this->checkFile('themes/merchants/Coupe_window/main_filter_panel.tpl', '0985a7421f898d75d4df72b4a6081c49');
        $this->checkFile('themes/merchants/Coupe_window/main_html_doc.tpl', '85aea6ad1c65d7807bfad09f0d9d184e');
        $this->checkFile('themes/merchants/Coupe_window/main_integration_steps_icons.tpl', '2107115d75013a0ad392566bb3fa1d54');
        $this->checkFile('themes/merchants/Coupe_window/main_menu.tpl', '1036ce189dc092adca21d6405e83544f');
        $this->checkFile('themes/merchants/Coupe_window/map_overlay.tpl', '9deb511a7295d19349480562f6771d87');
        $this->checkFile('themes/merchants/Coupe_window/map_overlay_advanced_filter.tpl', 'd41f999b16fbe6f34fe9315aff388a67');
        $this->checkFile('themes/merchants/Coupe_window/map_overlay_edit.tpl', 'd173ac586a3502e61f80a956597e1496');
        $this->checkFile('themes/merchants/Coupe_window/mass_pay_export.tpl', 'c90a423ab30d28f949c8ce738bab8375');
        $this->checkFile('themes/merchants/Coupe_window/mass_pay_export_form.tpl', 'c3b9939154fe31ce081f9c4edee7c410');
        $this->checkFile('themes/merchants/Coupe_window/menu_entry.tpl', '64a9c8f6b89eb5d0fb9a2d174b5f0427');
        $this->checkFile('themes/merchants/Coupe_window/menu_section.tpl', 'cec8b58c248868d64eaddc18923f7743');
        $this->checkFile('themes/merchants/Coupe_window/merchant_category_info.tpl', 'ecf110e07235298eb0403fdb6c8a1448');
        $this->checkFile('themes/merchants/Coupe_window/merchant_tutorial_video.tpl', 'ce8d0f0aad10353b46888942abfb96e5');
        $this->checkFile('themes/merchants/Coupe_window/messages.tpl', 'bf1a3bac08c419320acb94673ad29f0b');
        $this->checkFile('themes/merchants/Coupe_window/module_body.stpl', 'c079addcd33eb725ab7efbf09c16a793');
        $this->checkFile('themes/merchants/Coupe_window/month_banner_stats.tpl', 'fc0ecc72cbc42efa3835713eebcf8d4f');
        $this->checkFile('themes/merchants/Coupe_window/multi_editor.tpl', '6cd4d8823bd6b67cd3e0a2aa2cf52b29');
        $this->checkFile('themes/merchants/Coupe_window/multi_form_widget.tpl', '3f92d96633ec487b28dc6bfae7cc8e30');
        $this->checkFile('themes/merchants/Coupe_window/multiple_currencies_panel.tpl', 'c7b959fe11ad02a2fcbe22f5f62d344b');
        $this->checkFile('themes/merchants/Coupe_window/multiselect.tpl', '9d1863b21edd131520315ce252fde639');
        $this->checkFile('themes/merchants/Coupe_window/network_invoice.tpl', 'da2d8c12f409758081a229e78c1306fe');
        $this->checkFile('themes/merchants/Coupe_window/network_proforma_invoice.tpl', '5f9dcea372e00363e6dc2ffbdd5a8187');
        $this->checkFile('themes/merchants/Coupe_window/news_content.tpl', 'a576598444bb0db20fa8d47854f1ef34');
        $this->checkFile('themes/merchants/Coupe_window/news_filter.tpl', '59508e33dc1a696ffa5a18d5f619eedd');
        $this->checkFile('themes/merchants/Coupe_window/news_form_edit.tpl', '517272eac91c024292fe594cecae2c28');
        $this->checkFile('themes/merchants/Coupe_window/news_item.tpl', '18161a56a8f4dc5df01f08191709f864');
        $this->checkFile('themes/merchants/Coupe_window/news_list.tpl', 'f37df45ddce385805e34da5d81b17a1f');
        $this->checkFile('themes/merchants/Coupe_window/news_panel.tpl', '0e6eda2d6e6edab31d596d86939f0933');
        $this->checkFile('themes/merchants/Coupe_window/newsletter_broadcast_form.tpl', '1ccb4e8c2a3873263c7c8c1fc7c19f27');
        $this->checkFile('themes/merchants/Coupe_window/newsletter_broadcasts.tpl', 'e85ba6dc04b3a921af601f6bf976a5b8');
        $this->checkFile('themes/merchants/Coupe_window/newsletter_edit_panel.tpl', '73ddca2129beb12e11215b1c55e70461');
        $this->checkFile('themes/merchants/Coupe_window/newsletter_form.tpl', 'e86bb366b8986ac4cb1b50c9ccc94b8e');
        $this->checkFile('themes/merchants/Coupe_window/no_category_selected_settings_panel.tpl', '28bc9d284f2cbec3dde908dc0d4e9f7c');
        $this->checkFile('themes/merchants/Coupe_window/no_content_gadgets.tpl', '1d4ce600d473f33e2b229101a50cbc3f');
        $this->checkFile('themes/merchants/Coupe_window/no_language_selected.tpl', 'd61125f2b1cf78e4e66653d4e2f04bdd');
        $this->checkFile('themes/merchants/Coupe_window/note_filter.tpl', '5984797bddb6b9dff4b4066106da1bcf');
        $this->checkFile('themes/merchants/Coupe_window/notification_window.tpl', 'db781872bdb9748bc838e051b8e5e4e2');
        $this->checkFile('themes/merchants/Coupe_window/offline_sale.tpl', '589eb1238aac5800197e6e56a26cacf7');
        $this->checkFile('themes/merchants/Coupe_window/offline_sale_form.tpl', '86fe26a2a1e02d811e892233db9d6b5e');
        $this->checkFile('themes/merchants/Coupe_window/online_users.tpl', '1242aa25d7ed7b3a278684e0d4a13c4c');
        $this->checkFile('themes/merchants/Coupe_window/online_users_gadget_rolecount.tpl', '5fd6af0c5f2edec24d0e35dc00a9e870');
        $this->checkFile('themes/merchants/Coupe_window/online_users_gadget_template.tpl', '80ebdfe2a212375942cac09081e371b2');
        $this->checkFile('themes/merchants/Coupe_window/onlinegadgets_no_data.tpl', 'f5f692a433b4911963a92c41cc269768');
        $this->checkFile('themes/merchants/Coupe_window/onlineusers_filter.tpl', 'a5ec412a7f620cb47ddcf48b9f0d6625');
        $this->checkFile('themes/merchants/Coupe_window/order_id_filter.tpl', 'ea89a8c9ef5a3f13f5fca4c6dcbf6860');
        $this->checkFile('themes/merchants/Coupe_window/orgchart_affiliate_widget.tpl', '32f4faf30d0289ffd4c9d53f92a39388');
        $this->checkFile('themes/merchants/Coupe_window/overview_panel.tpl', '1874d6377cb2a53e5eba387cd0874215');
        $this->checkFile('themes/merchants/Coupe_window/overview_stats_panel.tpl', '674d3c5e07dddbfcc6b89bfa7b420640');
        $this->checkFile('themes/merchants/Coupe_window/page_header.tpl', '55fc71480cbd743a225bd79b63bb1027');
        $this->checkFile('themes/merchants/Coupe_window/page_type_radio.tpl', 'd132376c54a57b3962d1ca08eda22000');
        $this->checkFile('themes/merchants/Coupe_window/pap4.css', '8f82c5d2bebc74c44a8cc4bce714d32a');
        $this->checkFile('themes/merchants/Coupe_window/pap4.rtl.css', '7cc0db3919fa5c97540fc5343f1a1d00');
        $this->checkFile('themes/merchants/Coupe_window/parameter_names_form.tpl', '32bfa373ae61cdae7c70a202ba921e62');
        $this->checkFile('themes/merchants/Coupe_window/password_constraint_panel.tpl', '6d328bcd04ea68b87c18d4fd52099888');
        $this->checkFile('themes/merchants/Coupe_window/password_panel.tpl', 'b1440553a785aae589233a91315b281f');
        $this->checkFile('themes/merchants/Coupe_window/pay_affilates_form.tpl', '47ca863e6f0e46c4b2e631d2ebd313f0');
        $this->checkFile('themes/merchants/Coupe_window/pay_affiliate_template.tpl', '692261c025aab9b05408b9651de9a894');
        $this->checkFile('themes/merchants/Coupe_window/pay_affiliates.tpl', '9a08ef03ed4b0d076203c45c369918d1');
        $this->checkFile('themes/merchants/Coupe_window/pay_affiliates_filter.tpl', 'c20e663c0b2145b6e7c8eaf4f26c6da4');
        $this->checkFile('themes/merchants/Coupe_window/pay_affiliates_list.tpl', '85b17725f87d1ea59102020c1f290070');
        $this->checkFile('themes/merchants/Coupe_window/pay_affiliates_no_data.tpl', 'bdd593288f13c714bdb19de5d264318c');
        $this->checkFile('themes/merchants/Coupe_window/pay_invoice_form.tpl', 'c7490c619a883b6b90c2817b22025984');
        $this->checkFile('themes/merchants/Coupe_window/payee_info.tpl', '740af57f0054d67e6c689466e90980d8');
        $this->checkFile('themes/merchants/Coupe_window/payee_info_main.tpl', '8048bb0c734d26af0a077e1728b2e814');
        $this->checkFile('themes/merchants/Coupe_window/payout_data.tpl', 'b6f6f6c19617690d683128ee13b8b688');
        $this->checkFile('themes/merchants/Coupe_window/payout_fields_form.tpl', '0f8a8b9516b729ab4899926ead42be16');
        $this->checkFile('themes/merchants/Coupe_window/payout_fields_no_data.tpl', '22728157d2ebba66c42b8632edcc2eee');
        $this->checkFile('themes/merchants/Coupe_window/payout_history_form.tpl', 'fdf50ed31df6ef2a90efc52c043f13f8');
        $this->checkFile('themes/merchants/Coupe_window/payout_history_list_no_data.tpl', 'eaea8ff071a4da8272b5b57616544789');
        $this->checkFile('themes/merchants/Coupe_window/payout_history_template.tpl', '94edd75586374bd10a9e765ceb78e910');
        $this->checkFile('themes/merchants/Coupe_window/payout_invoice_format.tpl', 'c33ad82f202fb7fc45f83d2c8d547efa');
        $this->checkFile('themes/merchants/Coupe_window/payout_methods_filter_field.tpl', '3e44e83bdfd9080f05070dd2281dcfd2');
        $this->checkFile('themes/merchants/Coupe_window/payout_option_form.tpl', '309c28785f0a1aa14ded20d7037c6d3e');
        $this->checkFile('themes/merchants/Coupe_window/payout_options_form.tpl', '747bdbfe5eca6068d61275e19f4472a4');
        $this->checkFile('themes/merchants/Coupe_window/payout_options_no_data.tpl', '19f1bead958da75d50d38d893f93f4e1');
        $this->checkFile('themes/merchants/Coupe_window/payout_options_text_box.tpl', '9d7c675a676c204bafaa2c1f32b3f6a4');
        $this->checkFile('themes/merchants/Coupe_window/payout_settings_icons.tpl', 'aa4813c156afb53ed10a02319166c340');
        $this->checkFile('themes/merchants/Coupe_window/payouts_balance_form.tpl', 'd01274716d5700a7180cd8277b575cb0');
        $this->checkFile('themes/merchants/Coupe_window/payouts_balance_settings.tpl', '61c8ca2e6971fef86250e0b1a3adcb41');
        $this->checkFile('themes/merchants/Coupe_window/payouts_history.tpl', '8a1c74d4f1312a63ceee7907076e2d45');
        $this->checkFile('themes/merchants/Coupe_window/payouts_history_filter.tpl', '49514d217f0a77dcd9cbae68ab504e38');
        $this->checkFile('themes/merchants/Coupe_window/payouts_to_affiliates.tpl', '6e8868d55f61a825057b3890e0ec4afd');
        $this->checkFile('themes/merchants/Coupe_window/payouts_to_affiliates_filter.tpl', '06f0e81d2ad6a474fb81ccaef755477d');
        $this->checkFile('themes/merchants/Coupe_window/payoutstoaffiliates_list_no_data.tpl', '1bf1e39b51797acb2bac6428dabb0929');
        $this->checkFile('themes/merchants/Coupe_window/peel_banner_feature_on_deactivate.tpl', '88a989ccfb54f68203c01176a104541f');
        $this->checkFile('themes/merchants/Coupe_window/pending_backround_tasks.tpl', '9c91e4d0f413f7d7327783449c4222d7');
        $this->checkFile('themes/merchants/Coupe_window/pending_tasks.tpl', '3aa9f9ee68b7ef3258fe7a9c3994f952');
        $this->checkFile('themes/merchants/Coupe_window/pending_tasks_data.tpl', '1916b1db72af25350e122542f2261eb3');
        $this->checkFile('themes/merchants/Coupe_window/pending_tasks_panel.tpl', '16eaedf4545a03d89f94b98e3adacfa4');
        $this->checkFile('themes/merchants/Coupe_window/pending_tasks_template.tpl', '091fb315fbb9a3d24bf16baa791bd32f');
        $this->checkFile('themes/merchants/Coupe_window/performance_rewards.tpl', 'e6376beacf92f7086e4cf7b1a3e97d29');
        $this->checkFile('themes/merchants/Coupe_window/performance_rewards_filter.tpl', 'daf43de0e8c03e9a97f0aaf22b173461');
        $this->checkFile('themes/merchants/Coupe_window/placement_overview_filter.tpl', '6132598add92f772fb46568f94f0e5cc');
        $this->checkFile('themes/merchants/Coupe_window/placement_overview_panel.tpl', 'd0d0bef4390bbf53b43e4207aba245f3');
        $this->checkFile('themes/merchants/Coupe_window/plugin_configuration.tpl', '9f4b075baf454033271fc4219c272737');
        $this->checkFile('themes/merchants/Coupe_window/plugin_detail.tpl', '097b49ceeac4111d1fd96f3cd8d2b049');
        $this->checkFile('themes/merchants/Coupe_window/plugins_list.tpl', '72c87aa08ebd9a6218fcb300d6ec675c');
        $this->checkFile('themes/merchants/Coupe_window/popup_actions_panel.tpl', 'ef01a0f4fa742fc99a03632e1d6876b4');
        $this->checkFile('themes/merchants/Coupe_window/popup_form_widget.tpl', '0f5d2ef3d678d026df06fe1f1e5991a8');
        $this->checkFile('themes/merchants/Coupe_window/postsignup_radio.tpl', '6b32ad7886413081192c2ba5dd514275');
        $this->checkFile('themes/merchants/Coupe_window/postsignup_settings_page.tpl', '3657e859769d3db637b6a83e45ab218d');
        $this->checkFile('themes/merchants/Coupe_window/postsignup_settings_url.tpl', 'c854a3cb764d4be9af656abf45398193');
        $this->checkFile('themes/merchants/Coupe_window/private_campaigns_feature_on_deactivate.tpl', 'ecef84105dc2779ac2fb428da2e9f25f');
        $this->checkFile('themes/merchants/Coupe_window/proxy_server_configuration.tpl', '618f166a4be6b32f563aaeffd5f1931e');
        $this->checkFile('themes/merchants/Coupe_window/qualityunit_news.stpl', '188a98161e9218eb440aab2d33341a0c');
        $this->checkFile('themes/merchants/Coupe_window/quick_report_base.tpl', '03394fc9a529f4d9d13f8cbcb664be8f');
        $this->checkFile('themes/merchants/Coupe_window/quick_report_content.stpl', 'a75ca3ba3fc385de73eae7311f79c650');
        $this->checkFile('themes/merchants/Coupe_window/quick_report_content_multitier.stpl', 'e45556a573992274576437d9d34bdd71');
        $this->checkFile('themes/merchants/Coupe_window/quick_report_filter_base.tpl', '40541d4b075161fc37bea2086e429e23');
        $this->checkFile('themes/merchants/Coupe_window/quick_report_multitier_widget.tpl', '24108ad66b123214ae2c170aaa4ec369');
        $this->checkFile('themes/merchants/Coupe_window/quick_stats_actions_panel.tpl', 'd0816b90a3fbe4f4ffa09a37aec14268');
        $this->checkFile('themes/merchants/Coupe_window/quick_stats_box.tpl', '745d64595b8a0e5869bfc1e9bf10b9c2');
        $this->checkFile('themes/merchants/Coupe_window/quicklaunch_settings.tpl', '1e595ebaeb4364f173ee3fec71c1762d');
        $this->checkFile('themes/merchants/Coupe_window/radio_button_group_row.tpl', '3713f6d400aa1ca96d9e404082304912');
        $this->checkFile('themes/merchants/Coupe_window/radio_form_panel.tpl', 'c56091f134178fc494aa76df1b6ad6a1');
        $this->checkFile('themes/merchants/Coupe_window/rebrand_pdf_feature_on_deactivate.tpl', '57adefe6824afba7c2477b79c5663843');
        $this->checkFile('themes/merchants/Coupe_window/recaptcha_settings.tpl', 'd40a2e0759211b13af22180aef80b380');
        $this->checkFile('themes/merchants/Coupe_window/recipients.tpl', '6c334400d00281b1b04bfc28c654f2a3');
        $this->checkFile('themes/merchants/Coupe_window/recurring_commission_edit.tpl', 'f144dcac07b3913bb6dfb866e4871d9d');
        $this->checkFile('themes/merchants/Coupe_window/recurring_commission_filter.tpl', 'aface18c7b8fbf80da4810c240ce4bb7');
        $this->checkFile('themes/merchants/Coupe_window/recurring_commission_list.tpl', 'b6d7546e3e8ef3fafa122019d01531f8');
        $this->checkFile('themes/merchants/Coupe_window/recurring_commissions.tpl', '8c806617d38c467e2f29e22bb43e826c');
        $this->checkFile('themes/merchants/Coupe_window/referringurl_advanced_filter.tpl', 'e064d6689bc281e60c830c70acd8f3c3');
        $this->checkFile('themes/merchants/Coupe_window/refresh_panel.tpl', '5c709df4d219d5feb4f29003ca932f77');
        $this->checkFile('themes/merchants/Coupe_window/regional_settings.tpl', '899786b4a8c655defc732008fae917e7');
        $this->checkFile('themes/merchants/Coupe_window/regional_settings_tab.tpl', '808fee97d86d7a2400d4e4de198359dc');
        $this->checkFile('themes/merchants/Coupe_window/replicated_site_source_radio.tpl', '7d280f4647e9269bca20b70e4e64d077');
        $this->checkFile('themes/merchants/Coupe_window/report_filter.tpl', 'cfa31cd337c81b3e863f97b664581327');
        $this->checkFile('themes/merchants/Coupe_window/report_problems.tpl', '6c4035620c09202f2165e94e99635ceb');
        $this->checkFile('themes/merchants/Coupe_window/reports_screen.tpl', '7ec70fbbc8d7b81b1a98c932ea1c1267');
        $this->checkFile('themes/merchants/Coupe_window/request_new_password_form.tpl', 'e4e20e8042328f80b7b400e39d921986');
        $this->checkFile('themes/merchants/Coupe_window/resizable_text_area.tpl', '7995c217048ccd289dfee567a455b08e');
        $this->checkFile('themes/merchants/Coupe_window/richlistbox.tpl', '13229a43763945932dc8d5d7fa21d08e');
        $this->checkFile('themes/merchants/Coupe_window/richlistbox_popup.tpl', 'c155c59eea77770589bcadca0c75f1af');
        $this->checkFile('themes/merchants/Coupe_window/richtext_editor.tpl', '99af0e75e8761690e55e65fa238d8d4c');
        $this->checkFile('themes/merchants/Coupe_window/richtext_editor_toolbar.tpl', '3798b9151ed1d87c99e5783005c81773');
        $this->checkFile('themes/merchants/Coupe_window/richtexteditor_addlink.tpl', 'c9bd3a510535abef1076a29328f069e7');
        $this->checkFile('themes/merchants/Coupe_window/role_privileges.tpl', '30e7afc5bc26d51388efbf226e837411');
        $this->checkFile('themes/merchants/Coupe_window/rotator_preview_merchant.stpl', 'f4a8b7e2a320d263c11e080652136aa8');
        $this->checkFile('themes/merchants/Coupe_window/rule_conditions_panel.tpl', 'eb2d93cd36c8a15eb8b8c219d89cbec9');
        $this->checkFile('themes/merchants/Coupe_window/rule_conditions_panel_full.tpl', 'd76b1053dd4ae7afd2d9febf80199b0c');
        $this->checkFile('themes/merchants/Coupe_window/rule_panel.tpl', '836f9d642a2304b320b799fd156d04bf');
        $this->checkFile('themes/merchants/Coupe_window/search_filter.tpl', 'c43c492cae5282a628238b4ff75508b2');
        $this->checkFile('themes/merchants/Coupe_window/search_gadget.tpl', 'dd1ccaf3d497e365f8ea8d999a89cc29');
        $this->checkFile('themes/merchants/Coupe_window/search_gadget_entries_panel.tpl', 'b60a5fd89e628c401c86eee54073243e');
        $this->checkFile('themes/merchants/Coupe_window/search_gadget_popup.tpl', 'ad5359afa9edeb864b0929d40a05e466');
        $this->checkFile('themes/merchants/Coupe_window/search_gadget_popup_entry.tpl', 'd5c4d6d4715b15c8a8c19ba0f3e0289e');
        $this->checkFile('themes/merchants/Coupe_window/selectbutton_search.tpl', 'dedb23ce356b1b66377e648232dc2b8b');
        $this->checkFile('themes/merchants/Coupe_window/send_mail_to_affiliate.tpl', '757d0224a850eb6a32175367add64442');
        $this->checkFile('themes/merchants/Coupe_window/send_mass_mail.tpl', '515c3046b1058c4b313af52b6859a18d');
        $this->checkFile('themes/merchants/Coupe_window/set_new_password_form.tpl', '9270391a0892b67b03efbd67084806c6');
        $this->checkFile('themes/merchants/Coupe_window/sidebar.tpl', '65226d7e25dcdca0cf71a9f3118d8139');
        $this->checkFile('themes/merchants/Coupe_window/sidebar_closed.tpl', '3d903661713a9ee5fb402776ee06d310');
        $this->checkFile('themes/merchants/Coupe_window/sidebar_gadget.tpl', '1f904859e056808c8826836a4e256761');
        $this->checkFile('themes/merchants/Coupe_window/signup_commissions.tpl', 'e88a6f8eb2b970efe40609b59a103f45');
        $this->checkFile('themes/merchants/Coupe_window/signup_form_design.tpl', '5786a51864065a89ea059e03826048c7');
        $this->checkFile('themes/merchants/Coupe_window/signup_url_panel.tpl', '9578396ed90325350510e89493bc5101');
        $this->checkFile('themes/merchants/Coupe_window/simple_filter.tpl', 'a55a1095bcbdbef9d9d9f5e2078b19a2');
        $this->checkFile('themes/merchants/Coupe_window/simple_icon_object.tpl', 'bcbc9ea994d4aa8bbdee1eddc3ad19d8');
        $this->checkFile('themes/merchants/Coupe_window/simple_popup_window.tpl', 'e7d6ad58d85a85eab20414bb734b8c81');
        $this->checkFile('themes/merchants/Coupe_window/simplecolorpicker.tpl', '9c031fbdd2b35909faeea73e5f1203a1');
        $this->checkFile('themes/merchants/Coupe_window/single_content_panel.tpl', '529d4a42f9106d91881f8b8b8e87748b');
        $this->checkFile('themes/merchants/Coupe_window/site_replication_feature_on_deactivate.tpl', 'a9a5007e2b045fcddb5649780343250c');
        $this->checkFile('themes/merchants/Coupe_window/size_format_widget.tpl', 'ebfb7db6718ec601af59a570d8e0ccb3');
        $this->checkFile('themes/merchants/Coupe_window/spillover.tpl', 'b88774d1a43ea2c8b638a75c59411588');
        $this->checkFile('themes/merchants/Coupe_window/spillover_affiliate_panel.tpl', 'a31389658f2a6052020cad731dff7671');
        $this->checkFile('themes/merchants/Coupe_window/split_commissions_edit.tpl', '79b93073097985ea9b70b50708f9f361');
        $this->checkFile('themes/merchants/Coupe_window/split_commissions_edit_help.tpl', 'b8c0076fd8c6f725a44728f9c36e1633');
        $this->checkFile('themes/merchants/Coupe_window/split_commissions_feature_on_activate.tpl', '3c0a020b1e83cc8c0f13cc18c823c20d');
        $this->checkFile('themes/merchants/Coupe_window/start_button.tpl', '7aa2278c46b897536625cc042b4f5499');
        $this->checkFile('themes/merchants/Coupe_window/statistics_double_value_widget.tpl', '7e243a39277ad97843b418e45881a6d2');
        $this->checkFile('themes/merchants/Coupe_window/statistics_filter.tpl', '90764aa6c165d35f0eac8273a596c963');
        $this->checkFile('themes/merchants/Coupe_window/statistics_tab.tpl', '44fda2baaf03641673bcb17e5724a22d');
        $this->checkFile('themes/merchants/Coupe_window/stats_chart.tpl', 'b5bb3d9a0dd5361a4e34e479aacf2480');
        $this->checkFile('themes/merchants/Coupe_window/sub_menu_section.tpl', 'f14329a6ad21f2551a068111201c9918');
        $this->checkFile('themes/merchants/Coupe_window/sum_payouts_to_affiliates.tpl', '4c94936fcc7cc7be82f86e1eb2e8df9e');
        $this->checkFile('themes/merchants/Coupe_window/sum_payouts_to_affiliates_filter.tpl', '4ff8a5479e29e9ca336f282f0fd51b85');
        $this->checkFile('themes/merchants/Coupe_window/system_menu.tpl', 'd7f1ea46b5603e358d2b211d7b3eb1d9');
        $this->checkFile('themes/merchants/Coupe_window/tab_item.tpl', 'd869bc1a3b8c511712e039399333d129');
        $this->checkFile('themes/merchants/Coupe_window/tab_panel.tpl', '8c2853c4e62119a5b6f89c5e340af5d3');
        $this->checkFile('themes/merchants/Coupe_window/task.tpl', '38a4b70b6456a12285be4bb113c72575');
        $this->checkFile('themes/merchants/Coupe_window/taskbar.tpl', 'd7cf8ef7a71bf324aee5c1c7173afc7e');
        $this->checkFile('themes/merchants/Coupe_window/template_form.tpl', '1a0d6777f298f5a2a71f6efea7ac459f');
        $this->checkFile('themes/merchants/Coupe_window/template_form_constants.tpl', '91c398393e519cf7c6a53ba758eefc47');
        $this->checkFile('themes/merchants/Coupe_window/template_form_theme_entry.tpl', '91a40d5bfbb3ff3b61cd7771e24a2684');
        $this->checkFile('themes/merchants/Coupe_window/template_form_themes.tpl', 'e7158c1782ef49ddbf3fbe671c5c5b8a');
        $this->checkFile('themes/merchants/Coupe_window/template_form_variables.tpl', 'e1c008058f4be04a9e6e76ba72cc3290');
        $this->checkFile('themes/merchants/Coupe_window/templates_form.tpl', '7a0a1baf13edabb10c8c6bef5a3dac41');
        $this->checkFile('themes/merchants/Coupe_window/theme.php', '1a295aad0aed590b443feabe81a76f51');
        $this->checkFile('themes/merchants/Coupe_window/theme_create_new.tpl', '847cc7b80df92aa24acf0da5afdd0ed3');
        $this->checkFile('themes/merchants/Coupe_window/theme_edit_editor.tpl', '1b1b3b083b418ba21ef37522b0934a5f');
        $this->checkFile('themes/merchants/Coupe_window/theme_edit_filetree.tpl', '0e6f1bd9c3b11a255eab1e4824f83475');
        $this->checkFile('themes/merchants/Coupe_window/theme_edit_image.tpl', 'cc7ae652219ab87a267bf87631e9dc43');
        $this->checkFile('themes/merchants/Coupe_window/theme_edit_none.tpl', '291239b715e2f1e962011564bf549e5e');
        $this->checkFile('themes/merchants/Coupe_window/theme_edit_unsupported.tpl', '2977467887b418fedc8b42576078f275');
        $this->checkFile('themes/merchants/Coupe_window/theme_editor_panel.tpl', '566661806fd2d4b3ce443277d71959f5');
        $this->checkFile('themes/merchants/Coupe_window/theme_panel.tpl', '07b850efc37a68fe58fcdb067a81271d');
        $this->checkFile('themes/merchants/Coupe_window/theme_settings.tpl', '5c596388ecc46c2ac89c029f811f565e');
        $this->checkFile('themes/merchants/Coupe_window/time_conditions_panel.tpl', '0266186f1510ff818fb15cf4b41862b2');
        $this->checkFile('themes/merchants/Coupe_window/timezone_settings.tpl', 'f1bb95540fb8855093d35b284817369d');
        $this->checkFile('themes/merchants/Coupe_window/timezone_settings_tab.tpl', 'f89569e5d47f73e9c872ed4026fefcfa');
        $this->checkFile('themes/merchants/Coupe_window/tooltip_popup.tpl', 'e4a5b50c70875ee64d9fdf4f88fa8045');
        $this->checkFile('themes/merchants/Coupe_window/top_afffiliates_list.tpl', '286e2ac7096bc38ef5507691de9f17a6');
        $this->checkFile('themes/merchants/Coupe_window/top_affiliates_filter.tpl', 'b3ed7a34051548c53736298042eb2243');
        $this->checkFile('themes/merchants/Coupe_window/topurl_list.tpl', 'f108c2b8e2583a45a2016869735c87d3');
        $this->checkFile('themes/merchants/Coupe_window/tracking_tab.tpl', '8abcd2a1c88351a3a16795feda6750b4');
        $this->checkFile('themes/merchants/Coupe_window/traffic_info.tpl', 'b51b449d5a2d9e30a4c39055672eb87c');
        $this->checkFile('themes/merchants/Coupe_window/traffic_stats_gadget.tpl', 'da081a1eba4470008e9f5e0165ecd7d6');
        $this->checkFile('themes/merchants/Coupe_window/traffic_stats_in_gadget.tpl', 'b6ffda3596f992ce68d25d72fa923751');
        $this->checkFile('themes/merchants/Coupe_window/trafic_and_sales_report.tpl', '6723e4f293c26fed32855b086cb6318e');
        $this->checkFile('themes/merchants/Coupe_window/transaction_form.tpl', '8ef3d9c8be8655191b10b6ceb6b8627a');
        $this->checkFile('themes/merchants/Coupe_window/transaction_form_edit.tpl', '73debd09259e1daf3b7e6d50ccf8aee0');
        $this->checkFile('themes/merchants/Coupe_window/transaction_form_notes.tpl', '648b29094d534cfc6b8d7683440505f0');
        $this->checkFile('themes/merchants/Coupe_window/transaction_form_tracking.tpl', 'fc35d874eebd664e3b6da64f8d36b903');
        $this->checkFile('themes/merchants/Coupe_window/transaction_info.tpl', '689fb8c420b25ed9e1460edae68b92e0');
        $this->checkFile('themes/merchants/Coupe_window/transaction_list.tpl', '4d28f9612adefe432e937dea2f6ccf2a');
        $this->checkFile('themes/merchants/Coupe_window/transaction_list_filter_base.tpl', '7d0ad12c7fc041af03abba828a3bacc4');
        $this->checkFile('themes/merchants/Coupe_window/transaction_list_no_data.tpl', 'f91882c034dcec76ed668d2fa6e5863f');
        $this->checkFile('themes/merchants/Coupe_window/transaction_panel.tpl', '4f6297bd3273c5a64ae474c3989dd834');
        $this->checkFile('themes/merchants/Coupe_window/transaction_reports.tpl', 'ef0c25832283bcfe9d9cc37cd13ac41e');
        $this->checkFile('themes/merchants/Coupe_window/transactions_import.tpl', '18ea606dee038315e72e0e1049666ca3');
        $this->checkFile('themes/merchants/Coupe_window/trash.tpl', '270d020eabfcf284be7a97e7102924d5');
        $this->checkFile('themes/merchants/Coupe_window/tree_affiliate_widget.tpl', 'd6d133404cf44bcd4d057ddc9e0b573f');
        $this->checkFile('themes/merchants/Coupe_window/tree_draggable_items.tpl', '869b3cbe1a546cf76baa397b8360495b');
        $this->checkFile('themes/merchants/Coupe_window/trend_actions_stats.tpl', '01beef973c394417de5a58de2857a1e5');
        $this->checkFile('themes/merchants/Coupe_window/trend_actions_stats_widget.tpl', '7c26676ceb09baf3fafeb0dba3bdaec4');
        $this->checkFile('themes/merchants/Coupe_window/trend_stats.tpl', '5423abd62baeb237c0c5feb600e84937');
        $this->checkFile('themes/merchants/Coupe_window/trends_report.stpl', '18264d58de48af1de2b77137b0df48fb');
        $this->checkFile('themes/merchants/Coupe_window/trends_report.tpl', '8c3ecd3db7c864a8cbbd04e92363467c');
        $this->checkFile('themes/merchants/Coupe_window/trends_report_action.stpl', '929fa1c9535d05f1e8a0492013b9de33');
        $this->checkFile('themes/merchants/Coupe_window/trends_report_filter.tpl', 'cacaca9e199f9c7b74916541a340c31a');
        $this->checkFile('themes/merchants/Coupe_window/trends_report_no_data.tpl', '9d1dd7b6d3ef5f6ada42de2c7d182df2');
        $this->checkFile('themes/merchants/Coupe_window/troubleshooting.tpl', '8ec5482d68f08a103cf0883b10308e9f');
        $this->checkFile('themes/merchants/Coupe_window/update_version.stpl', '5602f52fe8248df474201a16c922048f');
        $this->checkFile('themes/merchants/Coupe_window/upload_panel.tpl', '222a0dd80ab37bb49060da0cf7eaf447');
        $this->checkFile('themes/merchants/Coupe_window/uploaded_file.tpl', 'fad11b13e3b41eff41a129b1af232e7e');
        $this->checkFile('themes/merchants/Coupe_window/user_edit.tpl', 'f41ba1817ee0d15f16c57dff5be39bb1');
        $this->checkFile('themes/merchants/Coupe_window/vat_settings.tpl', '628456504f54a037d9ba2f08ba3fbdc5');
        $this->checkFile('themes/merchants/Coupe_window/verify_panel.tpl', '79aa97bc204438e497a55b8e96ee3f6b');
        $this->checkFile('themes/merchants/Coupe_window/view_form.tpl', 'e37b380ed96bef78dc0de97ac2a3e379');
        $this->checkFile('themes/merchants/Coupe_window/view_form_edit_views.tpl', '957cda42f99a863bd72988472e4d008f');
        $this->checkFile('themes/merchants/Coupe_window/view_panel.tpl', '25340a99e4e6b4627de427ada4d1b2bc');
        $this->checkFile('themes/merchants/Coupe_window/views_list.tpl', 'eb42ebb392f0237879dfba6547578e98');
        $this->checkFile('themes/merchants/Coupe_window/visitor_affiliate_edit.tpl', '61506b2d8b383293922a9cc4929438da');
        $this->checkFile('themes/merchants/Coupe_window/visitor_affiliates_filter.tpl', '44d9d5e8bf93948d6220d00187359183');
        $this->checkFile('themes/merchants/Coupe_window/visitor_affiliates_list.tpl', '3493ae8f6c4fb7e655667b20a0b46ce9');
        $this->checkFile('themes/merchants/Coupe_window/visitor_nonrefclicks_filter.tpl', '6ef69cf81734100ad5d5cf1339ee0ad7');
        $this->checkFile('themes/merchants/Coupe_window/visitor_nonrefclicks_list.tpl', '202a7982f1ad5ae2e2310347969b8713');
        $this->checkFile('themes/merchants/Coupe_window/visits_sales_log_add.tpl', 'e8d580c16c576c3ec98c1baedac437fa');
        $this->checkFile('themes/merchants/Coupe_window/visits_sales_logs_filter.tpl', '5ffb18e5d3dcb8df3f61a03331c91552');
        $this->checkFile('themes/merchants/Coupe_window/visits_sales_logs_list.tpl', '2f2c6cb4ab210272ffd87e4d3bff95b4');
        $this->checkFile('themes/merchants/Coupe_window/visits_sales_logs_no_data.tpl', '969b350cc45c6f7c68fa6322e98a3de1');
        $this->checkFile('themes/merchants/Coupe_window/wallpaper_add_custom.tpl', '2210741b569ef188fa352c977a289261');
        $this->checkFile('themes/merchants/Coupe_window/wallpaper_entry.tpl', 'c24d10203224f47e2b385b0fff40c2d5');
        $this->checkFile('themes/merchants/Coupe_window/wallpaper_settings.tpl', 'd160dbed38556231aeac49a96213e4d4');
        $this->checkFile('themes/merchants/Coupe_window/welcome_message_panel.tpl', '86f2e7b763c27c55f65b269cd8b95a0d');
        $this->checkFile('themes/merchants/Coupe_window/window.tpl', '2391705887d707e05187606c4a819e73');
        $this->checkFile('themes/merchants/Coupe_window/window_bottom_left.tpl', 'd14b545c27afa02ab7a919bdeb4c9470');
        $this->checkFile('themes/merchants/Coupe_window/window_empty_content.tpl', 'b1535ec719cada5b9f5d98849074b9bd');
        $this->checkFile('themes/merchants/Coupe_window/window_header.tpl', '02a337d4184c3924a2792a84493794cc');
        $this->checkFile('themes/merchants/Coupe_window/window_header_refresh.tpl', 'fcd47f4585abcac3c3a61ee3991379bc');
        $this->checkFile('themes/merchants/Coupe_window/window_left.tpl', '984d69649ec171a5c6b522e795feb904');
        $this->checkFile('themes/merchants/Coupe_window/window_move_panel.tpl', 'f5bbd373a758bf76e6efadc94dca4b11');
        $this->checkFile('themes/merchants/Coupe_window/wizard_panel.tpl', '3142ce6354cb3e1c86b6c13c1d906189');
        $this->checkFile('themes/merchants/Coupe_window/zip_banner_feature_on_deactivate.tpl', '0d58a97804ba953e180301d3bb0d1a37');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/README.txt', 'c5e378c3027a6b4f00637e35fa00d549');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/account_fee_form.tpl', '9e74206da597b60f808b058b3686f27e');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/account_form.tpl', '9b6e02a4c1ddcf5cec8753f7d5b37635');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/account_form_view.tpl', '76f6a5f02f8df4359de2dda1a9581294');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/account_fraud_protection_clicks.tpl', 'eed38afcdb96c6a53d22516fa6819e81');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/account_fraud_protection_sales.tpl', '1457df492b6b6977223aebfc41112ee9');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/account_notifications_form.tpl', 'ca91248156c8c478f21b1b6d34ccbd95');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/account_private_campaign_settings.tpl', '076b4500174106015db4fbe11d9f7704');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/account_screen.tpl', '5c13951b27df87346ad5c393d909bebf');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/account_settings.tpl', 'be80dd8c05f836b4b1e7f9001928a99f');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/account_signup_settings_form.tpl', '5982f764dd2119fda15a29660632d00b');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/accounting_filter.tpl', '5f78217db2b968d1b16d7a208f8a15ba');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/accounts_fields.tpl', '0be3fded1093b0a42d7529578cb308c2');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/accounts_filter.tpl', '35f24b04cce5ca4fed3ba8dfd155bfac');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/accounts_invoices_panel.tpl', '723dec758c5ac861d896f7a42ad72b96');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/accounts_panel.tpl', '0fbf4266edac3efffdae3e5c0ae373f0');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/add_affiliate_page.tpl', '8594c776ee6cc33950c7e196fb21718f');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/add_affiliate_to_campaign.tpl', 'd35481ca14a233514c4a9e56ad431b19');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/add_affiliate_to_group.tpl', '27a3e4aab7ce50f1c9224330428c6d3f');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/add_transaction_form.tpl', 'f383ced42307c376148111358ccda1fd');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/additional_dynamic_form_panel.tpl', '8dc83e325433617d829516f337dae593');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/admin_panel.tpl', 'd3e12f15f24491854b33ac4645b5558c');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/admins_panel.tpl', 'd6002a9112177fcb731ffdf675b60771');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/admins_panel_filter.tpl', '45fbd848cee916baed8844aaf2f3d5a8');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/aff_notifications_form.tpl', '89587941d01463bdc1d70c1ac0b427b8');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/affilate_advanced_filter.tpl', '605613a94ec1c4e35637adb245fe4fed');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/affiliate_edit_details.tpl', '61a691e2444e79201d858692363617ff');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/affiliate_edit_details_additional.tpl', '08769718854c73e30d5564bb0d2844de');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/affiliate_edit_dialog.tpl', '99a07e007c443862514d0ba22601905b');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/affiliate_fields.tpl', '431a50e309494d288da412e79652f731');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/affiliate_list.tpl', '5772529f9e320a22f30725a6f2f0f182');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/affiliate_logins.tpl', '9e8f20f0104d4860da467564065f6d36');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/affiliate_logins_header.tpl', '7f7e82219446cd8b3865d6b05b21b0bb');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/affiliate_logins_map.tpl', 'bb3102948e06f668f1a102a3bda74b89');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/affiliate_menu_settings.tpl', '3e2435ccfc5a5e688962fca52838cf99');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/affiliate_payout_settings.tpl', 'bb5737fe82ff3ac9057c5dc177dd15a2');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/affiliate_screen_settings.tpl', '1e3d80bafe69eeb2ef9ded264dcaf34f');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/affiliate_signup_settings.tpl', '566c43077b4bee97040e90d202f7f5e9');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/affiliate_tracking_code_filter.tpl', '79c59da805f6ddecd11ceaf09482f022');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/affiliate_tracking_code_panel.tpl', '79fcc29563d0c9d46d601cd344d3eca3');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/affiliate_tracking_cookiepanel.tpl', '3ad74a2fddfe41019ba552e125e9b3df');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/affiliate_tracking_options.tpl', 'ccd9edd430d59379f64df748846d2f4d');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/affiliate_tree_filter.tpl', '04701626ef186bd5dff7dc8065318153');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/affiliate_tree_filter_edit.tpl', '1a2a3172549bb9b01da0f28ed7fa94bd');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/affiliate_tree_panel.tpl', '247c030f80cf39c88870d7a69daaec62');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/affiliates_group.tpl', '5be45192c3d7046f7c283d5a175bbf14');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/affiliates_group_filter.tpl', 'b6e802622cef58c90a0c8558a80cef38');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/affiliates_import.tpl', '450765023efbacefb84bc94836c3b6c0');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/api_integration.tpl', 'e87aee7966c8333b253babd8f93540d0');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/audit_log_filter.tpl', 'ccb123eaa1d55e15cb1a48c4d8ac9a61');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/banner_category_selector.tpl', 'd01696d0cda657d415cdb3ad3887d44a');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/banner_category_settings_panel.tpl', '1029f38251830115e56122f98e0ef84b');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/banner_destination_url_panel.tpl', '449d1e9718f514a6e66026d0bf4cee1b');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/banner_destinations.tpl', 'f94e289d8a1e6740442692f2f9d72103');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/banner_details.tpl', '7290e65cb569a2ad05ec8bcbef87d63c');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/banner_details_params.tpl', '8df2356317b592876d7efacc30638b58');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/banner_edit_panel.tpl', '34ceae103ee6ba0b3a81599cde5ab76f');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/banner_filter.tpl', '524c65b47dc920003f528463a4310274');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/banner_manager.tpl', 'ab7a8a50fd8db81d837ba5e5d9a0cdc8');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/banner_parameters_pagepeel.tpl', '003e64ccceff9c3a594981a64ad5f8cf');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/banner_parameters_pdf.tpl', 'c1621bcc2aa376244da2c99540894fc2');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/banner_parameters_rebrandpdf_allvars.tpl', '3bb7976b2ce30daa455f0da9256f203a');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/banner_parameters_rebrandpdf_filefield.tpl', '3f328aff2fe69aa06b0f6e180f13f0ba');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/banner_parameters_site.tpl', '26cba4acc53c47daa1664a05ff6036de');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/banner_parameters_site_files.tpl', '9b2b526261d027efa252a11be8d7dad6');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/banner_parameters_site_preview.tpl', '96d6d4c681e55f26e1e084bd50685966');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/banner_parameters_zip.tpl', 'c512738cddbdc988ecf9031608e033bf');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/banner_parameters_zip_bannerpreview.tpl', 'cc5aabcec76361d648178539be2f4107');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/banner_parameters_zip_files.tpl', '609a2716b2bebd76ea5b5851870bc2cf');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/banner_params_text_link.tpl', '54b698be233a2f499c7e2d6d0ab21419');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/banner_preview_field.tpl', 'af988307bbe0b857630bdcc5f68d34a4');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/banner_stats_filter.tpl', 'e0727f72120ffe673e7a03e49e834e63');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/banners_and_links_format.tpl', '4c535b9e438bbc38c59dab38c3abcf84');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/banners_categories_tree.tpl', 'e610fa7fecc866668b0a87a0fbec9e0f');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/campaign_account.tpl', 'e574e36af06e378ae4a4c105fe979356');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/campaign_category_selector.tpl', '9a94d84a4f333bdce59b35693b2f2ab8');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/campaign_category_settings_panel.tpl', '12e6c5deeca0e65f94ec087e2f26ea54');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/campaign_filter.tpl', '748cf43abbb1f39fab2a79b32ba0ecb3');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/campaign_form_edit.tpl', 'ee81c07e1ee894ad6d90a5b3a331c40a');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/campaign_screen.tpl', '8f485785c01e52a5c8336f2264a9ea4a');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/campaign_stats_filter.tpl', '66617f0bdf81d4c46f9c12051b4482f3');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/campaign_stats_list.tpl', '43fb24a915ba60746a18c3244590c311');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/campaign_type.tpl', '1a359a72bd15182197e0f179fd3fd9b9');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/campaigns_categories_list.tpl', 'bf8f8856bd8a9bafcc0915b4a8172e62');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/campaigns_categories_tree.tpl', '07c1fdbef7b04940e440f67e0343e0bb');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/campaigns_list.tpl', 'cfed98136575161f0ee0d589335bc92d');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/category_list.tpl', '18255ecc35ff9f6d1e0ecbce75fa953e');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/clicks_list.tpl', '57af7762f6e7860649320fb078728950');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/clicks_list_filter_base.tpl', '341ac8689670aa50f1408deae0cf7d95');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/clicks_tracking.tpl', 'a3ec90de9c82c1dd4ed2488fdfad6eb5');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/commission_edit_with_fixedcost.tpl', 'ccfafbca4ad133889269114d5aa68ebe');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/commission_group_panel.tpl', '5f1560c70f6a5794beb7fdf2761aa1c8');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/commissions_edit.tpl', '3f774edc6af6c6e02430d6234be320c6');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/commissions_panel.tpl', 'ccc7d624f4e0f16addc1e1a2acd02a11');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/compressed_commission_settings.tpl', 'c477491432d8ceb308f2801f7a4ffaa6');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/config_aff_panel.tpl', 'e91b7be1568a9a11305a9773dcc1ca93');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/config_currencies_form.tpl', '830fc8bf095ae916911b21c28bb21f18');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/config_currency_tab.tpl', '1e4de31522d3e781fc6b436820ebdf69');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/cookies_tab.tpl', '18d6c62ac84fb696e252b16432eed2b2');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/country_list.tpl', 'a2c0e36008e2e5e004d376ee1895a036');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/country_select_panel.tpl', '08ed995b60b454e366d9ed87061aec41');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/coupons_filter.tpl', 'a8ace675eea8fa1c4a1d91120a07280f');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/coupons_import.tpl', '4033626108115abc6626486cee8ac5ce');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/create_banners_buttons.tpl', '08c6d9d2754a9eb3caef7bea1a4d46a1');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/cron_job_integration.tpl', '506355581c41a43ba66c03994dba41ef');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/custom.css', '4877ef2467745239a93ebe1e79b2f813');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/daily_report.tpl', 'b20880541206a63cd7cb9fe010ea1084');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/daily_report_filter.tpl', '95d7d11922c98d2c9cb9efe8008d6d4b');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/default_theme_config.tpl', 'd334aafd6ab32a0d07960ad3fc1a6481');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/direct_link_form.tpl', '0be97d8c324c5d4703ac14caff6c14ba');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/directlinks_advanced_filter.tpl', 'd0658831d485a01ffd417d0979d601ca');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/directlinks_list.tpl', '90fac97b55320c68acc06cc801cf5455');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/download_auto_reg_banner_form.tpl', 'd8e0c2d751872f7c08e2a4a4e20ca725');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/download_auto_reg_iframe_form.tpl', 'ddc0468484559430c1719fc3166e0e22');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/download_auto_reg_link_form.tpl', '62793684d38fabe657b56ee9d7e7590a');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/download_signup_form.tpl', '18f7ea0d0362a24bda6d0c083949a337');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/email_form.tpl', '7680c9a4c6b07280a8d62eaa759ab6ad');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/email_notifications.tpl', 'b8e4f2d92ff816ab553f2665be5f0e9d');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/email_template_edit_panel.tpl', 'b5dad7a3b3ecafa4289f98f490bd4cc8');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/export_files_panel.tpl', 'ec4d327e6d39d4ec35a4ceb5fb237691');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/export_panel.tpl', '89136240918568c41e0cf7c88747dbc1');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/feature_detail.tpl', '6a3a7169d6fb6738163528bcc04dd6b0');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/feature_settings.tpl', '87af7f525209730c8aa0573f91cbb956');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/filter.tpl', 'cc93c246e4fd3e0acfb93c5eeeaef8ee');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/filter_field_decorator.tpl', '0afa75f69e50c2a31dc1a1987dbf050f');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/filter_form.tpl', 'c86ee6fcf176a62414fa132c9ff795d0');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/footer.stpl', '3fbd103789f1ff2a151c16f490a913dd');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/forced_matrix_panel.tpl', 'b37fd0f3e7daf4de8a168cf0f0f9354f');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/getting_started_merchant.tpl', 'a35a659bc6e45494731d28bdf9159696');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/google_recaptcha_settings.tpl', 'b713c9b516436c27961116db91a65a8d');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/header.stpl', '6ff0df0074e609a194b53f5379916ef5');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/home_edit.tpl', '225c320d546d283cc6ce90e25f39cfbf');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/home_panel.tpl', 'c5490fde3ceac49e904d64db8672608a');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/home_panel_content.stpl', '3de3b0d666373c184b3398b24f743a06');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/htaccess_panel.tpl', 'f2f592df8e91fc493999fb07fd069ff3');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/icons_panel_with_header.tpl', '36294e05dea06c7ad45c5910401e1a6b');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/box_divider.png', '88ec74dba62142217c8daddbd30ad9ec');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/browser_secure.png', '5c95ff5b78267e9023bc63a36415e4fc');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/config-hover.png', '0e622df8cefda5590d2e187f7732d956');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/feature_icon.png', '47556c7aac8fcae73b927a914c2e45f0');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/header_divider.png', '9c04ac8b0e24b7815be8feda5e810d14');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-about-big.png', '428601da0d9ba4c3deea1b57259f53d9');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-about-middle.png', '6fc0eace07b68020677f7fb7c2181588');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-about-small.png', 'd7c377c6c1839c02d8ff4c08241d059e');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-accounting-big.png', 'fa93f5c4b60b9d095a2a23a52211168e');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-accounting-middle.png', 'ce15d7fe919f3baccb7ec11e8871de17');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-accounting-small.png', 'a14dd58b2eff427007308e6c395da74f');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-actioncommision-big.png', 'b7245ce1da39458df4478fb97c2ec907');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-actioncommision-middle.png', '7eb0586f935a67af185020db03ee57ec');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-actioncommision-small.png', '50647c7a2ce6e87c05e67856140a01be');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-admins-big.png', '57361cd2d4a488cd2eed00831b26bd5f');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-admins-middle.png', '244601e0d1d7647625e1bd20ca1d56d3');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-admins-small.png', '039ecbce68831dfb1dce0752932bf5a6');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-advancedfunc-big.png', '8691f9054949c63439b1c099c849fe37');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-advancedfunc-middle.png', '25cd291870396e2b6cf06a30b3040836');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-advancedfunc-small.png', 'f224df62fe414aa5b654a2aa9c9083ca');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-affiliateadd-big.png', 'd5c7131c1975085da373524f57febc48');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-affiliateadd-middle.png', 'bddd0c46250303debbcdd13164d88964');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-affiliateadd-small.png', '050c51fd19d53154f31252c2cec060c8');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-affiliatesettings-big.png', '6a8d19a4c2a2f49b7a483eb554c67a7e');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-affiliatesettings-middle.png', 'bff4513cb0ac7fc3651376312da1dacb');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-affiliatesettings-small.png', '477ab1aa47a3b25ec0edff418f3829c0');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-affiliateslist-big.png', '8531931a1a8deec989a128b251b7d8f5');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-affiliateslist-middle.png', '9869e3506102a1fd354c780332b50b9f');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-affiliateslist-small.png', 'd4c2e1649a26e4fd19dc1960dddbbd34');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-affiliatesoverview-big.png', '108370d42effb2502ba4ea4c947518f0');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-affiliatesoverview-middle.png', '24ee97e9eac08324347d2ed61b2b1b44');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-affiliatesoverview-small.png', 'f9e1bdcc59800c0c103b55291d10018c');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-affiliatetree-big.png', 'f3a3935903ffd1fc62078a69c94b3e96');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-affiliatetree-middle.png', '297f228e008b762991c0c9586523d3ea');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-affiliatetree-small.png', '987817c468127c8b45d72d965b8f808a');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-afflinkprotector-big.png', '41210425d22e80b3415aa664b00d398a');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-afflinkprotector-middle.png', 'b00984ccb6a7693b671b57697c37f62e');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-afflinkprotector-small.png', '8a6ca0c7bed131e76f4fae31000201ab');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-affpanel-big.png', 'ad0c3f7baf452316627482ce47ec9b37');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-affpanel-middle.png', 'ffc44262a749e2bdcd5ee4a030dc9e91');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-affpanel-small.png', '89acee5cdf219cfb2d1400d3b4a248a5');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-apiintegration-big.png', '702515b8933c9c7ed457d3280ea8e340');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-apiintegration-middle.png', 'd37af643a7d0e045a121f291388c91fd');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-apiintegration-small.png', '676c13fdb6c683af387767cb1789df66');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-banneradd-big.png', '1f5c8423f1a329ac06e2929dfee1b7e3');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-banneradd-middle.png', '6ff2ef8a8bddee3f52187074ffbf0b5e');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-banneradd-small.png', 'b3d8b98e27e2b98f160deae84ef556c2');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-banners-big.png', 'a13d36f6a14c4059befca90c969d12ee');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-banners-middle.png', '9c4cb78b0c5441a5ac15300afd4a301a');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-banners-small.png', '5ba134d161fe9424b876e7e50511d7dc');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-bannerscategories-big.png', 'a310cda6bf44049c1b0dd3d203e06140');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-bannerscategories-small.png', 'ae5c90546f68383ca6471da4a36870da');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-bannerslist-big.png', '1bf599dbf6524cb922f1f09e4bbda116');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-bannerslist-middle.png', '68dc7a4fda17deebdfb1d83119a1670a');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-bannerslist-small.png', 'c8f299bb45397ccdaecb7df3c9600ffe');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-bannersoverview-big.png', '8c7b4be8a563f9d0f8c657fbd7b064c0');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-bannersoverview-middle.png', '9c4cb78b0c5441a5ac15300afd4a301a');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-bannersoverview-small.png', 'b70ada457ab1c9981f8ab4bef5653e7e');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-bannersscategories-middle.png', '2c5dfa811b4f68b71eb3c78dc0e353ce');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-billinginfo-big.png', '819f4758f0faed71b211a3309f0e8dc1');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-billinginfo-middle.png', 'fc15f6e3aa4fa46571f63b3c2232a5d2');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-billinginfo-small.png', 'aafc8e41d2753a4f9b6516181acb2dfa');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-broadcastemail-big.png', '1d2cfa3b506deb6280ebf4cc98b8c010');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-broadcastemail-middle.png', 'f85bf24631dcc851559f51b9568c0f75');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-broadcastemail-small.png', '11b04a9929cd413f1cb3fce70c717a30');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-calccommission-big.png', '7086ebb3d568dcb605be0e4a0924896b');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-calccommission-middle.png', 'c4f5035411491e3a26d8fffe23b20b24');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-calccommission-small.png', 'b0f099674dc9c78dfa40e32a832a3b0a');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-calcsettings-big.png', '89d5be624ffbbc8474f2b8030c1cb92e');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-calcsettings-middle.png', '90836a1a3f58251a18bf1c3df92e483a');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-calcsettings-small.png', 'b963cdbae235cc78f68a8acfef8bc6e4');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-campaignadd-big.png', '69354264e1b50b1f050b35af8a1aebb5');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-campaignadd-middle.png', '1b8fd564ff105aab6e578391a528aad2');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-campaignadd-small.png', '9b4aae84c0f775bb20507a1414da70e1');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-campaignscategories-big.png', 'a310cda6bf44049c1b0dd3d203e06140');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-campaignscategories-middle.png', '2c5dfa811b4f68b71eb3c78dc0e353ce');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-campaignscategories-small.png', 'ae5c90546f68383ca6471da4a36870da');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-campaignslist-big.png', 'a52bc02f28d4f56220c320c6574f8f9c');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-campaignslist-middle.png', '569ab60e0e3ff10de816f1571925b5b6');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-campaignslist-small.png', '193e4f56908fa9d045972749abc9780c');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-campaignsoverview-big.png', 'ed8ad85caf2c1ff8c34dfdefb67965ed');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-campaignsoverview-middle.png', '6b3d072dd8c3d965eb097b66da7fcd54');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-campaignsoverview-small.png', '6df551a67a7077c5220e6b609359857a');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-channels-big.png', 'f76d1d8030637adbfa2981b132f80d96');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-channels-middle.png', '0a13491607b6fbc88a946f43b7bafdb4');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-channels-small.png', '03cfb7b9ad94827a4d0bf8336e7e52c0');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-channelstatsreport-big.png', '4b1c13143a301c246e9fcef695e58666');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-channelstatsreport-middle.png', '12b291a0caf561e006ca5535d9e09ba8');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-channelstatsreport-small.png', '302858f05a10b04f087efe27052206fe');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-clickcommission-big.png', '7da264525cc0d547db7d68817639093e');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-clickcommission-middle.png', '10e5545ae349e632483b1860544e010b');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-clickcommission-small.png', '2d37adb9026b332a059618cc27896c47');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-clickslist-big.png', 'fbda1422f6bd873d56894c1d7d95ba4f');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-clickslist-middle.png', 'a0b0d63612a9f48cf42c93f9fa3ed316');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-clickslist-small.png', 'e6570b0542c57f628986082628994f72');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-clickstracking-big.png', '14d844dae72c0e0511edd4ea5cf7a47a');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-clickstracking-middle.png', '94dc574d346a486ff452ec7f093e3673');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-clickstracking-small.png', '6aa780ce3413adaa4ac15e7bd95c3958');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-commissionadd-big.png', '622fad726c5bbc696241898640e20926');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-commissionadd-middle.png', '3f8f3b9b892e851a200c6f02b9e7165e');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-commissionadd-small.png', '80f1404144c2a625bcc331a5e5263eab');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-commissionslist-big.png', '0195a700dbe8d2c3ac1608f3cd883ad0');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-commissionslist-middle.png', '304c4f5a092da2d081683196a011e14d');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-commissionslist-small.png', 'b08f72525311b61be001eb1604554eeb');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-commreport-big.png', 'f4fce1db7a0c10e677de57dc38a2609e');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-commreport-middle.png', '57b04030103cf97fbe0d92a731e85e12');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-commreport-small.png', 'dcab4d1c0b0faf44f649a819071a0487');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-communication-big.png', '5accfde00d1b34b6e771d0faebc2b1b6');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-communication-middle.png', 'b4253d4909fd0a0cbafa4f813429d8fa');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-communication-small.png', 'cebe3e7324bb0d86051f9cbdedfd6ecb');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-configuration-big.png', '2cddf90ad25270348ab96a6d9d874152');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-configuration-middle.png', '55ac5018150298f812e2765a19550fdc');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-configuration-small.png', '7b0623ad383b0246f58aa6bc45277678');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-confirmationrequired-big.png', '90210b42d7d84c2185a4a0643454a9fa');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-confirmationrequired-middle.png', '1e661972fb77bd24788d319eecd4e962');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-confirmationrequired-small.png', '02c4ce14907c147b902e83da8c2f2abb');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-contactus-big.png', '925ea74565475d763da214a66848d090');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-contactus-middle.png', '35a5a52620dcf4421b3603850ad86ed9');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-contactus-small.png', 'e62035b9b08fd22200b9d0e63401a66b');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-content-big.png', '428601da0d9ba4c3deea1b57259f53d9');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-content-middle.png', '6fc0eace07b68020677f7fb7c2181588');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-content-small.png', 'd7c377c6c1839c02d8ff4c08241d059e');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-cookie-big.png', '3438d09467e579a8cd77d73556add8fe');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-cookie-middle.png', '651796ee7b2dea8243a37517fbf62250');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-cookie-small.png', '56bec98a07cb2dac95671393cda6c0d5');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-creditcardinfo-big.png', 'da75afb6f853e50437f2c1e98859b2d1');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-creditcardinfo-middle.png', 'b7c08296ef7fcfc0c5f4c8d525e5ec98');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-creditcardinfo-small.png', '8cf60780085fbfc3b7fae78d5f2e2a98');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-cron-big.png', '854e5c2afb7981b64009af910cb91c2a');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-cron-middle.png', '5d5b7a8b3068b16613bd526011b4095e');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-cron-small.png', '21af15916c7cb3887c3579a6362c34e3');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-currency-big.png', '599af390c3935dfadab5c6c8a36d717a');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-currency-middle.png', '23b48ed1f7c7d581105b15eb1aed05c0');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-currency-small.png', 'e00d0f217b9c13089a324ebb2a4a276c');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-dailyreports-big.png', '51f3e844ba86a439576661e6fd24ab10');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-dailyreports-middle.png', '1f48d2a78e794508530ccb2d8fa24fc4');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-dailyreports-small.png', 'b69fc28548f6ca7ae3f46bb3006a333e');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-databasestats-big.png', '92877608b8101fc8f19d6c73c66cf678');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-databasestats-middle.png', 'a647326ebbdfa5a7edf8add89a4f6c04');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-databasestats-small.png', '878c6102aacf869afa9faf11f88edfa3');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-dialog-big.png', '90210b42d7d84c2185a4a0643454a9fa');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-dialog-middle.png', '1e661972fb77bd24788d319eecd4e962');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-dialog-small.png', '02c4ce14907c147b902e83da8c2f2abb');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-directlink-big.png', 'c278ffcff33c372f76a7e60decf69bb1');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-directlink-middle.png', '347f26a3d31903a3fbf53650c525a329');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-directlink-small.png', 'ba793d7acb6322f1cf6ad3ce700fb640');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-directlinksmanager-big.png', 'c278ffcff33c372f76a7e60decf69bb1');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-directlinksmanager-middle.png', '347f26a3d31903a3fbf53650c525a329');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-directlinksmanager-small.png', 'ba793d7acb6322f1cf6ad3ce700fb640');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-domain-big.png', 'f32e5c64aaea31672065b30adb51ec11');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-domain-middle.png', 'd71bc87daf8b1edf3bda4680321f9f6b');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-domain-small.png', 'ea7e3479c5f47119261cfecef4ab309b');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-emailnotification-big.png', '24e0fa4c00e137fac96db534320154db');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-emailnotification-middle.png', 'afdc9afa184892bbcec0b84b3c6f3cd5');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-emailnotification-small.png', '9f5a038c227bbedcfc87ddcc568dd96c');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-emailsettings-big.png', '9f5d46acd00fb265ebbd545c32f3d9e2');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-emailsettings-middle.png', 'a9332d19d58bc0690331e2df4d19ccce');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-emailsettings-small.png', '727f303733ffea427cc17427fcad1c2c');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-emailtemplates-big.png', 'd0518c39e49dc80897d0f691060f1142');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-emailtemplates-middle.png', 'a2c81f3a5b895097eef35d722506bef3');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-emailtemplates-small.png', '1d78171288453cbc025021098d1b4982');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-eventlog-big.png', 'bbfa889e79729293e1303ed0a2ffe309');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-eventlog-middle.png', '50b3620c109dce278f12f8b2b340674f');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-eventlog-small.png', '3ca1dafbb4a2e956fdb9808be6b45f82');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-export-big.png', '35be33047c8e02e1a32d55be841a65d5');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-export-middle.png', '660f811c7fce5d3cb64739e3139cdd8b');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-export-small.png', '9835074ca5282cfeba17b8d7a036294a');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-exportfiles-big.png', '6ad2c2691a3ce2edb276ac28ee77f621');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-exportfiles-middle.png', '2aebf5fe0283ca6b536ea69c0db30151');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-exportfiles-small.png', '8a1316abaf6351d2ba61a39ca628eab2');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-features-big.png', 'dd45e0325fdac4e3d98c24b36e30bf19');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-features-middle.png', '7c23951c67dfd1c6b45eaba392c73b22');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-features-small.png', '39df80c8c1eb1bf6b29fa100ebad750d');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-folder-big.png', '964b4525aa06127c52b84a589049c3b8');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-folder-middle.png', '1f85a4d29265faf9aa15862b7ed1d7a3');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-folder-small.png', '365a922fabd91c200543597d98cf0564');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-foldergrey-big.png', 'e1942d05c09d21e20e56c094002f1fa0');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-foldergrey-middle.png', '0bc47f85c8177d32d7993a2c2604c408');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-foldergrey-small.png', '55104fb0a0d0492c26055bf2ba7c4f00');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-fraudprotection-big.png', '0f46b039dc06851045f36d4e9eb378e2');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-fraudprotection-middle.png', '8bcb3f94b6ead9502d5498a28fb17257');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-fraudprotection-small.png', '697acc0f7c159c13072eaae0033af2d4');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-gettingstarted-big.png', 'd197bbf5a9900bb8d536e66afed03206');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-gettingstarted-middle.png', '74997aac35c7c4f12c8fc0e7fc014e30');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-gettingstarted-small.png', '62ecdf49ec3da0bfad4211057e6e051e');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-help-big.png', '5b04efbf4559f7d56773ade80e8923c7');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-help-middle.png', '38204f96fa196244e088a8c095f0dca1');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-help-small.png', '61d96309c23e3ed484a8cb498313d9e4');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-home-big.png', '8c15857acaf46bf2bca9ee23ca005fdb');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-home-middle.png', 'fc15f6e3aa4fa46571f63b3c2232a5d2');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-home-small.png', 'aafc8e41d2753a4f9b6516181acb2dfa');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-import-big.png', 'a3994f14cdc5fdf9447cf1c5f222fb98');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-import-middle.png', 'ede5849ad737983ae60affb29777c3ea');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-import-small.png', 'ca31d217f2c82a3686c25caaf90f18eb');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-importexport-big.png', '22bc4deef07277d9c6157e960b4fccda');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-importexport-middle.png', '6eaa1d276bbfa7ac4b0293f908aa69a3');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-importexport-small.png', 'ad47885de018e70115fe1e4232b77269');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-impressioncommision-big.png', '495f55816ffa5216e4746c1d1eee9557');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-impressioncommision-middle.png', '6361429fa7303b1efb0735ef4548fed6');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-impressioncommision-small.png', 'e97f06809d7944cd2cebc2683aa22370');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-informations-big.png', '90210b42d7d84c2185a4a0643454a9fa');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-informations-middle.png', '1e661972fb77bd24788d319eecd4e962');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-informations-small.png', '02c4ce14907c147b902e83da8c2f2abb');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-integration-big.png', '6bd708116619dcfa262a6d40674d8e5b');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-integration-middle.png', '245668bb8c7796aec7c18d6b6a51483c');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-integration-small.png', 'c61bb436dc255ce9be68ce8bc94291b2');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-integrationmethods-big.png', '17e48a253c213fb67da54d8cdebf95f0');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-integrationmethods-middle.png', '795868d412ad71c3041f4266ca70a42f');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-integrationmethods-small.png', 'a3a8267d8fe64a8876f4b12150c7b143');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-invalidlicence-big.png', '28b65cd15641f0bcac4a7ca9ff12f3e2');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-invalidlicence-middle.png', '97de3a74719bbd0e97e6cff2f0081bf4');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-invalidlicence-small.png', '8abe2ba041d63018480d9a412e54db6c');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-invoice-big.png', '8c950adce63c0a3d575e5592aa2981b3');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-invoice-middle.png', 'bb1eaae413b6893cceea285a4d0607e4');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-invoice-small.png', '5bbc98c7efb943177890379332dc5109');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-invoiceformat-big.png', '5cffed26d74d9b98dbbfb01888b58559');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-invoiceformat-middle.png', 'aede063c8b9e337ea3e23082e8c8b51e');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-invoiceformat-small.png', '321e3605531407784effbe53635a8aef');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-languages-big.png', 'a0b72821e1d253339513db5d4643d3cf');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-languages-middle.png', '4a2ccb5b04b3c98e178252cb0d14df7e');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-languages-small.png', '9c3b59920c9e4dfd9cd7f96d775b9627');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-languagetranslations-big.png', '2103875d8558a3cc616f9a4abf85e713');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-languagetranslations-middle.png', 'd71bc87daf8b1edf3bda4680321f9f6b');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-languagetranslations-small.png', 'ea7e3479c5f47119261cfecef4ab309b');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-linkformats-big.png', 'b2202763a3a9a28a957a17bcb7007943');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-linkformats-middle.png', 'e6ba0774a7607e608f77841c46b6609d');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-linkformats-small.png', '8d2b611c63b8dca40d9dcb09fab53385');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-logging-big.png', 'f3f381ea4a2a4b8a1aa0e19de56437de');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-logging-middle.png', 'd9f7515eb7521d4163e2f4790387885f');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-logging-small.png', '741214ca11b87b38d0d904650cb3a717');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-logout-big.png', 'd4bba32201c5056c278d53fed4b1bbc7');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-logout-middle.png', '46b1e38582fba3c1d82cffd42ff65b9e');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-logout-small.png', '25d153721685338959a2dad7af6321ab');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-mapoverlay-big.png', '0f6b98425312f5c78b7f290cc8c89c35');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-mapoverlay-middle.png', '80a789d18aacb4013f1cbb83db9c431b');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-mapoverlay-small.png', '26d00c127fbf4a4ae6310f889758ad2d');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-message-big.png', '403ba3600f9e63e33ffc5c0dbb53c44f');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-message-middle.png', 'f0f630bee3a08f61161f095d3e47fbaa');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-message-small.png', 'ac79d200fb4199e60193d606ce574d8f');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-myinvoices-big.png', '8c950adce63c0a3d575e5592aa2981b3');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-myinvoices-middle.png', 'bb1eaae413b6893cceea285a4d0607e4');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-myinvoices-small.png', '5bbc98c7efb943177890379332dc5109');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-networkaccountadd-big.png', '1d869a10b51e3cb53738cf5d4b185511');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-networkaccountadd-middle.png', 'e3c42a7413200843e6dbdf82ff314470');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-networkaccountadd-small.png', '18bd89d5bd977cceb1656787f14771d2');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-networkaccountfields-big.png', 'b8bc6614fbbf1e4deae4d2cf5d2f4501');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-networkaccountfields-middle.png', '2ed54dec6cf0fdc65ba5264b02b31089');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-networkaccountfields-small.png', '8514ea6a22d424dd3a14876ec70cb3b2');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-networkaccounts-big.png', 'e6fe2e1cd1cda349384c87e57a26865d');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-networkaccounts-middle.png', 'a600fe8d8d41c26f81695a2eadbf8111');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-networkaccounts-small.png', 'a0432c0d3443735d331430568c69e4fa');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-news-big.png', '17b52a7a5c177b9f3054208cec5b8deb');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-news-middle.png', 'f126c6d4487489afa292c0c2530d1719');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-news-small.png', 'ffcf7c920c65aa1ee4c3363929ba0eb5');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-newsletter-big.png', 'd0b8e5c3b293ad29e1a66eeb383d2c8e');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-newsletter-middle.png', 'bf5c713d0d26b0890b5c6edea73dac34');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-newsletter-small.png', '7d52c62d5397230708b2448df035ca1d');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-offlinesale-big.png', '35127b1b9d03b19aea95b905e400c1ec');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-offlinesale-middle.png', '9fdd100b5a41e4f1ce8850c0b5c49bc0');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-offlinesale-small.png', 'f64a930d43970b319f484c35059114b8');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-onlineusers-big.png', '8a140f9f5787e65335573c35af435912');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-onlineusers-middle.png', '6418adf7bb30e826a0dee7e5afc57dbd');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-onlineusers-small.png', 'f969b9cec13f1afdbe832d0fd74d9e85');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-outbox-big.png', 'bd4be7e782336809737c3f56d0d95840');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-outbox-middle.png', '0a8f03555b8cc0a53214502a9f1d36e0');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-outbox-small.png', '793acba64f930962243773f51217e905');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-panelsettings-big.png', 'f7b70b68d910bc557de2e42f7d711a3a');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-panelsettings-middle.png', 'e5603910d6e7f850c7e8d3aacee031fc');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-panelsettings-small.png', 'b67eca984d0d89a6805d7712462f56d0');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-parameternames-big.png', '47a57e7c5d1a402c30d102bb8f73c2a6');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-parameternames-middle.png', '2676b02f65b5f2620a2dbcb8302b0d8c');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-parameternames-small.png', '192530feb2fa8aebe3ee491b6f5f1c5d');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-payaffiliates-big.png', '5262ba6c21f92887786620c1ea8b7637');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-payaffiliates-middle.png', '585633a4b8b38828f1faf1a6ede688d3');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-payaffiliates-small.png', '708f3f7485253ee76d8aa9882a3e81ae');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-paymentdetails-big.png', '2c3dcc019b163e58f6e991ec3cdeb93a');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-paymentdetails-middle.png', '00d39c41e921dd7325d5da86d8fba797');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-paymentdetails-small.png', 'e7cc29a55755c0c1c600f3eb29970e30');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-payoutsbalance-big.png', '6d5dfc08ff356dea7e5b4498351b2abb');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-payoutsbalance-middle.png', 'f29e1fa4fc12cf76d79dfb4cdb0b8b99');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-payoutsbalance-small.png', 'e7be75d8d0774747990ea964f1e0101d');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-payoutsbyaff-big.png', 'fb58c02622942f34bab91ebce940f3ec');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-payoutsbyaff-middle.png', 'cb3833b7044e920d8d941f6781fa2df3');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-payoutsbyaff-small.png', 'e61f9ac8562802dc0aac00ebc31eb31d');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-payoutsettings-big.png', 'ff7264578099e47bf2d4646d357742b2');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-payoutsettings-middle.png', '4ec26382ffb573c0ccc2e957f077c1e5');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-payoutsettings-small.png', 'ca9c7400e3ff2e50a1725d7b1732c5e3');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-payoutshistory-big.png', '8e87c06adbef25733e01ab3e51b4f6d3');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-payoutshistory-middle.png', 'fa0a56093d19e471f2ecd5b4c34beaa4');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-payoutshistory-small.png', '9e957f26370ef8282a267e5060bcea32');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-payoutslist-big.png', '1bede851415e062a888451c1ef493385');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-payoutslist-middle.png', '887ca9d34e9e545928c94b1f68fb8b94');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-payoutslist-small.png', '27c574fe08115a833acb8e0bdeaf50b9');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-payoutsoverview-big.png', '1bede851415e062a888451c1ef493385');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-payoutsoverview-middle.png', '887ca9d34e9e545928c94b1f68fb8b94');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-payoutsoverview-small.png', '27c574fe08115a833acb8e0bdeaf50b9');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-pendingtasks-big.png', 'efbc34dc0e67b2e87a108e524ddb16bf');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-pendingtasks-middle.png', '6907bcc9fa6fbe811b775ec0323757cf');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-pendingtasks-small.png', '038469d25098ca85aac324d68f46b9c2');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-personaldetails-big.png', 'db24999d6b323cc4160481b9197cf52e');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-personaldetails-middle.png', '84d4ba7eeab1224e6af2039176089267');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-personaldetails-small.png', '893a70e6fb2ac1b86c02d7c3bbe06c4a');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-plugins-big.png', 'bf88b03059137ed6ea16485f8e1d4545');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-plugins-middle.png', '7add6287f8be625735d47ac4d1e81b4a');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-plugins-small.png', '8c999c38a9d57971341676aa0002cd67');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-promotion-big.png', '7a839eab485f58c64f18373fb98071c1');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-promotion-middle.png', '288fd61451befab7496361770ea14d33');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-promotion-small.png', 'baddc96d178672ba3d353459432469ac');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-proxy-big.png', '873881ce0902d108856b66d6cd1bbeb5');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-proxy-middle.png', '230ff2e2fb3e95933026c0f9e4d6842c');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-proxy-small.png', 'f3b4244c5a02eb94ed262d6254d06298');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-quickreport-big.png', '13d6307a75e92e4a1dfa3dd47647cedb');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-quickreport-middle.png', '3bea495c70f8c47812a8d9775bffca63');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-quickreport-small.png', '931422301455d42e667b0472d3d43066');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-quickstart-big.png', 'd197bbf5a9900bb8d536e66afed03206');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-quickstart-middle.png', '74997aac35c7c4f12c8fc0e7fc014e30');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-quickstart-small.png', '62ecdf49ec3da0bfad4211057e6e051e');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-recurringcommissionslist-big.png', '8316e4d32f09f67d5b85deaa26577dcf');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-recurringcommissionslist-middle.png', 'dfa8f0fe9edb348b79aebfd6ab775a33');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-recurringcommissionslist-small.png', '3489d6da95b9a3f59dbe9d3b994b6c37');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-reportproblems-big.png', '9395e24a8125e59d979dcf106f5fa56a');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-reportproblems-middle.png', 'e3b0e0cef2bf97f63eabe07b2698e892');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-reportproblems-small.png', 'c3bcb16b71995ea184725313eab14ba3');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-reports-big.png', '4b6dce1244d75b94379200e21b318b45');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-reports-middle.png', '185720125c09730d91189ae69074ff17');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-reports-small.png', '8dcf1727963537d5dea129b9f0833684');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-salecommission-big.png', 'edad2d2af87b8f7cbff8c40cab472e8e');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-salecommission-middle.png', '6122ee20716d3f0dec569778abf17b6d');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-salecommission-small.png', 'edc571e2de6de0164b7b505b4ae22507');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-screen-big.png', '428601da0d9ba4c3deea1b57259f53d9');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-screen-middle.png', '6fc0eace07b68020677f7fb7c2181588');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-screen-small.png', 'd7c377c6c1839c02d8ff4c08241d059e');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-send-message-big.png', '925ea74565475d763da214a66848d090');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-send-message-middle.png', '35a5a52620dcf4421b3603850ad86ed9');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-send-message-small.png', 'e62035b9b08fd22200b9d0e63401a66b');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-signupform-big.png', '94d57c6ffa91773a9e094a7a3f3f09a7');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-signupform-middle.png', '0cc9db6f3dfd91fa73678c0ac36a05e7');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-signupform-small.png', 'ae097dc49a26bc036ad207cb9a5eca52');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-signupsubaff-big.png', 'a45245b27a33cf936d4c9b2d1251d981');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-signupsubaff-middle.png', '284b1281deda84131f40e429135600bd');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-signupsubaff-small.png', 'a3a9c4345b984dc9522d4ae2c932ab90');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-subaffiliates-big.png', 'd5886239b93fe9bfe1298d968395e761');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-subaffiliates-middle.png', '0cb6a0cddffa82ae33e3cf911a8d0a63');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-subaffiliates-small.png', '4a6501ad5d0cf5ee1098037345ea6f04');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-subaffiliatestat-big.png', 'a779b82895bf11652232bfbebbddcf3a');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-subaffiliatestat-middle.png', 'dc7cfd8b9e9ae721265f990b8faa1a1f');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-subaffiliatestat-small.png', 'e981446661750ce0b4aabdb056aa21af');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-subidtracking-big.png', 'a9f00f3f0d2880363eca08b4cb5f1077');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-subidtracking-middle.png', '782e7b4584e3605b08e63e1213b16e3a');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-subidtracking-small.png', '089f1ee83e8c314b3aa08c00b52ef773');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-systemconfiguration-big.png', '2cddf90ad25270348ab96a6d9d874152');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-systemconfiguration-middle.png', '55ac5018150298f812e2765a19550fdc');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-systemconfiguration-small.png', '7b0623ad383b0246f58aa6bc45277678');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-themes-big.png', 'f7b70b68d910bc557de2e42f7d711a3a');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-themes-middle.png', 'e5603910d6e7f850c7e8d3aacee031fc');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-themes-small.png', 'b67eca984d0d89a6805d7712462f56d0');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-tools-big.png', 'e0da1ad291513772326fefcddc8ab42d');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-tools-middle.png', '4602d231274ac2cac78fe20abfb49c9a');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-tools-small.png', '506cbde7bdb6c61fe786122b08c59c1c');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-topreferringurl-big.png', 'f1c63c47194544ad073ff2d8800aff57');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-topreferringurl-middle.png', '7743b51e3964c9ec09d0d20f3fda81e5');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-topreferringurl-small.png', 'c44b37822d23b4eb69107b80ca8c9996');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-trackingaffiliates-big.png', '5025622c054d25ce154025f58b04f3e1');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-trackingaffiliates-middle.png', '951449d8043c3a4b87d516dd29b7df2d');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-trackingaffiliates-small.png', '5750ed980100417d63819f951f7d3617');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-trackingsettings-big.png', 'fecc4f7d7b716f954f3324feed92ef23');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-trackingsettings-middle.png', '6ac879219f21fcc998338d9294877735');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-trackingsettings-small.png', '99e6af89545c48d6c7d2a7f9930a86ca');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-trafficinfo-big.png', '4b6dce1244d75b94379200e21b318b45');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-trafficinfo-middle.png', '185720125c09730d91189ae69074ff17');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-trafficinfo-small.png', '8dcf1727963537d5dea129b9f0833684');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-trafficstats-big.png', '4bbbb6d078d6804700d1282bdfdda165');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-trafficstats-middle.png', 'e3783a33c6f662dbe63f394c49fd8e57');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-trafficstats-small.png', '7ca396360b45a8e9c1d250d5b0824be2');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-transactionsoverview-big.png', '2a8079383dc03f24a774b3d087333826');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-transactionsoverview-middle.png', 'd4fca55f9fc90a7f385b122426884fc0');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-transactionsoverview-small.png', '6fd329efc615a54f433f8033024b9395');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-trendsreport-big.png', 'a9763385aa10959738675255bd887e23');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-trendsreport-middle.png', '669e6948c8a7b0a91d8ff1e000644d76');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-trendsreport-small.png', '8c89cd1902b375fc60c95cc7b750e00f');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-troubleshooting-big.png', '28b65cd15641f0bcac4a7ca9ff12f3e2');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-troubleshooting-middle.png', '97de3a74719bbd0e97e6cff2f0081bf4');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-troubleshooting-small.png', '8abe2ba041d63018480d9a412e54db6c');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-tutorialvideo-big.png', 'caff5c6e41fc7a40cd96a9b824736a97');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-tutorialvideo-middle.png', 'f7d43ef307e5090b3c5b0a8b1f2f430f');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-tutorialvideo-small.png', '1ea035f5e1baa010c6f146f8b2864dad');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-undefined-big.png', '90210b42d7d84c2185a4a0643454a9fa');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-undefined-middle.png', '1e661972fb77bd24788d319eecd4e962');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-undefined-small.png', '02c4ce14907c147b902e83da8c2f2abb');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-user-big.png', '0e702be569fe18fd148352dd35eef5e2');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-user-middle.png', 'a0bf2afecbcfbdb1571d9a061780c1a0');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-user-small.png', '7a1aa33a04a1e6b22cc6783e41dde93b');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-userprofile-big.png', 'bbfd648d5aa54e015218481966b13ce2');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-userprofile-middle.png', 'c1428282a47c10750493c744b45b0b6e');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-userprofile-small.png', '3033136cc1fad425f585eefadf311da8');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-userroleprivileges-big.png', 'cb55e04eed7cbee58b0f0b78019062e0');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-userroleprivileges-middle.png', '00fd7c474c52ae44a8687c1aaea9c864');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-userroleprivileges-small.png', 'b075544877b61c6a4b26a8a18936d1eb');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-vathandling-big.png', '6bd2f6913cb33846aa9f885c4d632ba0');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-vathandling-middle.png', '6363bb9c47ed899a15bbd87d47c5bc75');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-vathandling-small.png', '72a79ab793a44af78ff83ea71a8f68ff');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-views-big.png', '6da16ea156043161746b99da65cf1735');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-views-middle.png', '3532fa7ada483eae52c946efba4edfc9');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-views-small.png', '312f72396b458c3ea1f9186ae14fe548');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-youraccount-big.png', 'e34c37997a050e374482720524debbf6');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-youraccount-middle.png', '10f1c9bdb2d1836dc7935a22fb5677a4');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icon-youraccount-small.png', '7af5dbe9e8c8ab4580c904340d74e0d7');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/icons22.png', 'b2ea77f479d2b5020c4c4692d5c6e885');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/left_bg.gif', '6b805be091fa27230cc6750ccc38fc37');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/loading.gif', '546d9515580e0c8e3d0813c2e04ed9aa');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/logo_pan.jpg', 'e11b89662d01ad51927067143efe6298');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/logo_pan.png', '97ebd132ae8ec2dd08bbef552d03a0fd');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/logo_pap.jpg', 'aba77ff0db8d780333de3c6d61e34216');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/plugin_icon.png', '38f662af0c9848d4afc772c72f711af4');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/reports-month.png', '189ca5b357e070e385b693be11e0ad96');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/reports.png', '2cb48b10c4178fd34b55815ae51ed21c');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/theme_thumbnail.jpg', '034f67fa434f041afd3a7a347565442e');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/tree.png', 'b379dab92b732c6b3a9d857b4e2c7fc0');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/tree_long.png', '05eba31c803d05f11eb630e008a71b20');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/img/window.active.png', '83eda02ef182e2ad1345b2e9eb8bf201');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/import_language.tpl', '59feb2896334d5b05ac438a34de0096c');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/import_panel.tpl', '4bf50b677b91bf1330fbd45dbc12aabb');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/import_theme_panel.tpl', 'db7cd53a636368133854006ab17e5a5d');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/integration_methods.tpl', 'fb4d6d6ab5cb4bf2a821a3396878ab06');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/invoice_form.tpl', 'f3d6eef22289877706f22381034a7002');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/invoices_filter.tpl', '1e513f51a437071da6eeec9634865926');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/invoices_list.tpl', '3b92e66d3aab0135e6140956fcdeefb9');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/keywords_performance.tpl', 'ef30f3752248a81a9f74f8c834aa35d6');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/keywords_performance_advanced_filter.tpl', '1b8952cc990a08800d1e6fe2e93024e8');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/language_create_new.tpl', '1ff007e1bdb8357c18e771df0470bbf5');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/language_translations_filter.tpl', '0f3fed35d20981041e573afbe32050fb');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/lifetime_referral_edit.tpl', 'bbd962a5b1a6c516ad2c9ba3dcd4727a');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/lifetime_referrals_filter.tpl', '055e58bdb9c467837e8eb0a69557f0ab');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/lifetime_referrals_import.tpl', 'a96083e0e32644dd3a34f2d293d8df2b');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/lifetime_referrals_panel.tpl', '68968ce1c9c6997e6509d35471117932');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/lite_campaign_wizard.tpl', 'a8fa076be1f4feda5e8b98259d2f4752');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/log_filter.tpl', '33968c76c4bb92b6d041adac27fee434');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/log_list.tpl', '5764fdf24e0fb8cd0377e027d18ec1f3');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/logging_tab.tpl', '1dba1dee0c6b1db0101a53e2ec01770f');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/logging_tab_logins_history.tpl', 'c2b080804ea9cd59bb2cd13423857259');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/login_form.tpl', '8f9ca0e2231c804483f6f604549530b5');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/login_main.tpl', '9f3a1aa4ae4fb8a97c71e6fb5a718ce0');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/logins_history.tpl', 'ac0435af36ec2f5c2033081d8df222fd');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/loginshistory_filter.tpl', '74c90cd1052c15beddff88ecc8c02659');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/logo_settings.tpl', 'dd77690db09ddc71457bb16834022bd4');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/mail_outbox_panel.tpl', '3c2433f7d7fe2cff025bd9d72b95cd97');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/mail_template_test_form.tpl', '5d4baf31bb230fb2a53345b406267dd6');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/mail_templates.tpl', 'ffba40b7c8d526976a0d696431209dcd');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/mail_templates_list.tpl', 'd68cf4d9f0f51fbb8a0aff0d568ae036');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/mailoutbox_filter.tpl', '1f0e75aa4732301d54b6c56fa4956fee');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/main.tpl', '2abc009343fc2107057328cb6151dced');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/main_html_doc.tpl', '6d5da2c65ee10fe27b5a0441064a8629');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/main_menu.tpl', '5fddab52f7b44bcb5717c1d67875f567');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/map_overlay.tpl', 'dffbf0f882d537a1c30c1cd8e55763de');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/map_overlay_advanced_filter.tpl', 'ffdfe07e45aa362376da779aba520976');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/map_overlay_edit.tpl', '58c1dcbaf1643b0b720a1954f93ebadd');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/mass_pay_export.tpl', 'ba788f5be16ad512b204d391338af138');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/menu_entry.tpl', 'ae560837dfc1d2ff53ba3fea866de9ab');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/menu_section.tpl', 'da446dbc5a24b9881bd8417ce0371bb5');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/merchant_tutorial_video.tpl', 'aced7c1706ddc1b8f2bfa9e37921f928');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/multiple_currencies_panel.tpl', 'fb84a896121ea1e51868026ed7e71772');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/network_invoice.tpl', '84eae09e3bb75e6e36d9d44838156775');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/network_proforma_invoice.tpl', 'ca972dd21dbdf4598a7c4ed87b233526');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/news_content.tpl', '240db12f7ed3698d10779e4498ff1cd5');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/news_form_edit.tpl', '304c1e00b1237c64c08f1770828c9ab8');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/news_list.tpl', '718914ca77c83e65ddc0c2553268a4df');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/note_filter.tpl', '5984797bddb6b9dff4b4066106da1bcf');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/online_users.tpl', '85168cc7acd1c4717cdada26af70f974');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/onlineusers_filter.tpl', '4edca7157016faf110102bb4c36c8854');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/order_id_filter.tpl', '103e1ce5be4c9d2f1cc161390371e222');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/overview_panel.tpl', '365527ee9a7edde0c9dc20f65466a06b');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/overview_stats_panel.tpl', 'c84e4a8212524bbeae1fbd7be0d2452b');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/panel_footer.stpl', '940e5a3345f1058d0cfc751d22355e3b');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/pap4.css', '2ef084c3f64f04c2b5525860fdbb102b');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/parameter_names_form.tpl', '9b251360b35d7db317a692a5565c1f97');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/pay_affilates_form.tpl', '5e02a22d350050812ee07448b2d0d1a1');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/pay_affiliates.tpl', '7841520d27d0879d1dd338e8af2e422b');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/pay_affiliates_filter.tpl', '4f8deabfc1470643899ffb63980bf8f1');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/payout_invoice_format.tpl', 'daa0915e37859697415bd5ce1dc2276a');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/payout_option_form.tpl', 'b0a80b5ba5447317f45fc499486a0d05');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/payout_options_form.tpl', '648c35cf107ffecf820bfe4788827453');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/payouts_balance_form.tpl', 'd6ca8d1e226d542c8619c838dd50dbf7');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/payouts_balance_settings.tpl', '3cb0f78bc48d3864af40329faa70c4f0');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/payouts_history.tpl', '2ab9c99f4db555116cd232fcecfc3d68');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/payouts_history_filter.tpl', '581756a76965326732abb2494fbbe8df');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/payouts_to_affiliates.tpl', 'fe33732b1ae0f4713ac796370a4152ba');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/payouts_to_affiliates_filter.tpl', '6c6363ff9ad5a6965b6008497f121497');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/performance_rewards.tpl', '0f8911a11ad209a7eae56ba212e42e73');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/placement_overview_filter.tpl', '96549275298eade0fb6c935860f92e62');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/placement_overview_panel.tpl', 'da8b9662ebaea4d48eddb0251de7fe5b');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/plugin_configuration.tpl', '4cce88fd93f2df049f0df8215074fea8');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/plugin_detail.tpl', 'ff7f2c4b17fbeea4df799a97af83801f');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/plugins_list.tpl', '4857cea19eae2e1996f99b515450ec96');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/proxy_server_configuration.tpl', '8fd50dfcc47d2bf47b698b28bea6dba6');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/quick_report_base.tpl', '4d1dc556d29fa9283d67790fc9cadf55');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/quick_report_filter_base.tpl', '41f290eff66804a9c81f0d76d5024c66');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/recaptcha_settings.tpl', 'ce76b669d8d40445c8a2bafd42049fa6');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/recurring_commission_filter.tpl', 'a1a841a3f7ca025868ffc4c1b88f9922');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/recurring_commission_list.tpl', '64188c7768983359fd2c49ef0b8e9125');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/recurring_commissions.tpl', '77cacde5d1ca9c213f028074936de430');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/referringurl_advanced_filter.tpl', '0ea70362ff237897423e75f8fcea7540');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/report_filter.tpl', 'b37d7cb139866b0da13d266ad5e76941');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/report_problems.tpl', '5b12663b69fe33c59bea1483fca56c25');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/rule_conditions_panel.tpl', 'bb5087bba7ea52b7efd29e1c4fe6000e');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/rule_conditions_panel_full.tpl', '854936feb2fcd3e70186c5661b69e604');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/rule_panel.tpl', '575851b945a3f4bac95d33f609924535');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/send_mass_mail.tpl', '191a4a7ed33f0567331a53ddc7925245');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/signup_commissions.tpl', '38b3ede9d7f3610dabfe7f386156fe2d');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/signup_url_panel.tpl', '9273ab3d60fb3e2d2682c2f699503d20');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/statistics_filter.tpl', '448a9781cef8b1efcdc101ab2fb27b52');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/statistics_tab.tpl', '6e29eee869fe2fe6ba9abc3c13a7396e');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/sub_menu_section.tpl', 'f14329a6ad21f2551a068111201c9918');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/sum_payouts_to_affiliates.tpl', '18fc8eb5a0f5c7332ec51ca6a30816ef');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/sum_payouts_to_affiliates_filter.tpl', '36a15e0febeeb38c0ed8a124e1ffaa78');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/system_menu.tpl', '6b9db812d8f3eb02839850e4a9c3627d');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/template_form.tpl', 'ab02d6a94d38e13b05b4e55d396a06cd');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/theme.php', 'c8e9cd480a5624c8c383e2f85b1ca248');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/theme_edit_filetree.tpl', '0c72747749d4c1ab3b88a84ff0445fb4');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/theme_settings.tpl', 'e5cc392956225e60996dbe65455439d0');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/top_afffiliates_list.tpl', '1d32e1fbbc72fce0811f2725e363fdd4');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/top_affiliates_filter.tpl', 'ea273a73b3784310916c59314f18e74a');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/topurl_list.tpl', '80dc7467ce6fc992e3bb75b6d7b133dd');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/tracking_tab.tpl', 'd2ec4b52e15b0fe410322198bf1fb368');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/transaction_form_edit.tpl', 'f6f86256facb7b93d30b85acae1e466a');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/transaction_form_notes.tpl', 'ea49f3b3dd42a6be348e9bc96b4c62b0');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/transaction_form_tracking.tpl', '18fb11025532fa9a3bed7dad9fd8bbb6');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/transaction_list.tpl', 'a78be9990c0da9508d8d1a2174836d4f');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/transaction_list_filter_base.tpl', '43ae6a3cb07949dfafb5c3d7762c4b21');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/transactions_import.tpl', '6691d7fa355fc35292319202d5870682');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/trend_actions_stats.tpl', '5d6e55fa6711b536fad187f3a0d26e05');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/trend_actions_stats_widget.tpl', 'a30e19bae13d1fab8908907ca6f488ac');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/trend_stats.tpl', 'fa4185229e724a7ef92762cba12b53db');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/trends_report.tpl', '6183dd6df87166e37e04b7a10fbb76fd');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/trends_report_filter.tpl', '5268b13b945c790f5866597f9f0ee09d');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/troubleshooting.tpl', '55bf6ca81a04ecbae8689f8f228a3463');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/upload_panel.tpl', 'd9102db745c63e3da9295a373d5d0320');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/vat_settings.tpl', 'bad033fabaef4142e17eafdd84c18542');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/view_form.tpl', '64c9a652526f8742ed368c6a843f3b33');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/view_panel.tpl', 'bd0570427463e359dbdde9d319af883f');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/views_list.tpl', '055576733877a76393de0a6a8637d198');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/visitor_affiliate_edit.tpl', 'b5cacbb1c36eb906255ee0925c13463d');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/visitor_affiliates_filter.tpl', '6d38dcd6c5c92643aa07c0b8d6000ac4');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/visitor_nonrefclicks_filter.tpl', 'a1a2bd396334aa80a8b8fba213599286');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/visits_sales_log_add.tpl', '2508acff01c5623b7e4362a3216c236e');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/visits_sales_logs_filter.tpl', '3b18f801191e9ac8928414f1a6d9c9be');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/visits_sales_logs_list.tpl', 'c1e30e0ed75901a7236a8555ff830c4d');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/welcome_message_panel.tpl', '70e09b2f182f682ac64667f8fb404e14');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/window.tpl', '564d64cbe6768aab4554e85783c60d38');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/window_bottom_left.tpl', '6fb7ac67f0f538f52fc427b755ce8e5b');
        $this->checkFile('themes/merchants/Dash_for_Merchant_Panel/window_left.tpl', '984d69649ec171a5c6b522e795feb904');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/README.txt', 'c5e378c3027a6b4f00637e35fa00d549');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/account_fee_form.tpl', '9e74206da597b60f808b058b3686f27e');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/account_form.tpl', '9b6e02a4c1ddcf5cec8753f7d5b37635');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/account_form_view.tpl', '76f6a5f02f8df4359de2dda1a9581294');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/account_fraud_protection_clicks.tpl', 'eed38afcdb96c6a53d22516fa6819e81');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/account_fraud_protection_sales.tpl', '4da2d1811efd56cef18620d55a616810');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/account_notifications_form.tpl', 'ca91248156c8c478f21b1b6d34ccbd95');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/account_private_campaign_settings.tpl', '076b4500174106015db4fbe11d9f7704');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/account_settings.tpl', 'be80dd8c05f836b4b1e7f9001928a99f');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/account_signup_settings_form.tpl', 'c368b5b2be7ef188e1abc352f633516f');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/accounting_filter.tpl', '5f78217db2b968d1b16d7a208f8a15ba');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/accounts_fields.tpl', '0d39a1b0e3065a89acd2cb04bbf80b5d');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/accounts_filter.tpl', '35f24b04cce5ca4fed3ba8dfd155bfac');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/accounts_invoices_panel.tpl', '723dec758c5ac861d896f7a42ad72b96');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/accounts_panel.tpl', '0fbf4266edac3efffdae3e5c0ae373f0');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/add_affiliate_page.tpl', '8594c776ee6cc33950c7e196fb21718f');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/add_affiliate_to_campaign.tpl', 'd35481ca14a233514c4a9e56ad431b19');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/add_affiliate_to_group.tpl', '27a3e4aab7ce50f1c9224330428c6d3f');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/add_transaction_form.tpl', 'f383ced42307c376148111358ccda1fd');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/additional_dynamic_form_panel.tpl', '8dc83e325433617d829516f337dae593');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/admin_panel.tpl', 'd3e12f15f24491854b33ac4645b5558c');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/admins_panel.tpl', 'd6002a9112177fcb731ffdf675b60771');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/admins_panel_filter.tpl', '45fbd848cee916baed8844aaf2f3d5a8');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/aff_notifications_form.tpl', '2e07527f0562576c38a7d96f96708885');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/affilate_advanced_filter.tpl', '605613a94ec1c4e35637adb245fe4fed');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/affiliate_edit_details.tpl', '341f9483296b795249859cd26997089e');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/affiliate_edit_details_additional.tpl', '08769718854c73e30d5564bb0d2844de');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/affiliate_fields.tpl', '431a50e309494d288da412e79652f731');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/affiliate_list.tpl', '5772529f9e320a22f30725a6f2f0f182');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/affiliate_logins.tpl', '9e8f20f0104d4860da467564065f6d36');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/affiliate_logins_header.tpl', '7f7e82219446cd8b3865d6b05b21b0bb');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/affiliate_logins_map.tpl', 'bb3102948e06f668f1a102a3bda74b89');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/affiliate_menu_settings.tpl', '3e2435ccfc5a5e688962fca52838cf99');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/affiliate_payout_settings.tpl', 'af8ae2177ec6c44a2a5da4ef07defd63');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/affiliate_screen_settings.tpl', '1e3d80bafe69eeb2ef9ded264dcaf34f');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/affiliate_signup_settings.tpl', '566c43077b4bee97040e90d202f7f5e9');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/affiliate_tracking_code_filter.tpl', '79c59da805f6ddecd11ceaf09482f022');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/affiliate_tracking_code_panel.tpl', '79fcc29563d0c9d46d601cd344d3eca3');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/affiliate_tracking_cookiepanel.tpl', '854ffec87f59e053d55833448e7ce8ac');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/affiliate_tracking_options.tpl', 'b77d14ce31eb51c1449dee51d1ac9a88');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/affiliate_tree_filter.tpl', '04701626ef186bd5dff7dc8065318153');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/affiliate_tree_filter_edit.tpl', '1a2a3172549bb9b01da0f28ed7fa94bd');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/affiliate_tree_panel.tpl', '247c030f80cf39c88870d7a69daaec62');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/affiliates_group.tpl', '5be45192c3d7046f7c283d5a175bbf14');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/affiliates_group_filter.tpl', '852a8dd04342d748bb16027a2d7f068b');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/affiliates_import.tpl', 'a1a3d9ed8a27fee511d38a17e0688327');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/audit_log_filter.tpl', 'ccb123eaa1d55e15cb1a48c4d8ac9a61');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/banner_category_selector.tpl', 'd01696d0cda657d415cdb3ad3887d44a');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/banner_category_settings_panel.tpl', '1029f38251830115e56122f98e0ef84b');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/banner_destination_url_panel.tpl', '2482e069301b1c7aaf7508b48e43599f');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/banner_destinations.tpl', 'f94e289d8a1e6740442692f2f9d72103');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/banner_details.tpl', '8aad2a8734000f0a0288e47763433410');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/banner_details_params.tpl', '8df2356317b592876d7efacc30638b58');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/banner_filter.tpl', 'a5c4057471ab1eaa49c4e3a14cb8124f');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/banner_manager.tpl', 'ab7a8a50fd8db81d837ba5e5d9a0cdc8');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/banner_parameters_pagepeel.tpl', '003e64ccceff9c3a594981a64ad5f8cf');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/banner_parameters_pdf.tpl', 'c1621bcc2aa376244da2c99540894fc2');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/banner_parameters_rebrandpdf_allvars.tpl', '3bb7976b2ce30daa455f0da9256f203a');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/banner_parameters_rebrandpdf_filefield.tpl', '3f328aff2fe69aa06b0f6e180f13f0ba');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/banner_parameters_site.tpl', '26cba4acc53c47daa1664a05ff6036de');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/banner_parameters_site_files.tpl', '9b2b526261d027efa252a11be8d7dad6');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/banner_parameters_site_preview.tpl', '96d6d4c681e55f26e1e084bd50685966');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/banner_parameters_zip.tpl', 'c512738cddbdc988ecf9031608e033bf');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/banner_parameters_zip_bannerpreview.tpl', 'cc5aabcec76361d648178539be2f4107');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/banner_parameters_zip_files.tpl', '609a2716b2bebd76ea5b5851870bc2cf');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/banner_params_text_link.tpl', '54b698be233a2f499c7e2d6d0ab21419');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/banner_preview_field.tpl', 'af988307bbe0b857630bdcc5f68d34a4');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/banner_stats_filter.tpl', '5e949e9b5b3f7349982f1ff531bfd68d');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/banners_categories_tree.tpl', 'e610fa7fecc866668b0a87a0fbec9e0f');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/campaign_account.tpl', 'e574e36af06e378ae4a4c105fe979356');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/campaign_category_selector.tpl', '9a94d84a4f333bdce59b35693b2f2ab8');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/campaign_category_settings_panel.tpl', '12e6c5deeca0e65f94ec087e2f26ea54');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/campaign_filter.tpl', '748cf43abbb1f39fab2a79b32ba0ecb3');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/campaign_form_edit.tpl', 'e20b4403550e541c7499eb1071d80f52');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/campaign_stats_filter.tpl', '4f528e9343a13070868d67a2cb13298d');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/campaign_stats_list.tpl', '49fd3cca5137f3821380e6d718fa225d');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/campaign_type.tpl', '1a359a72bd15182197e0f179fd3fd9b9');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/campaigns_categories_tree.tpl', '07c1fdbef7b04940e440f67e0343e0bb');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/campaigns_list.tpl', 'cfed98136575161f0ee0d589335bc92d');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/category_list.tpl', '18255ecc35ff9f6d1e0ecbce75fa953e');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/clicks_list.tpl', '57af7762f6e7860649320fb078728950');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/clicks_list_filter_base.tpl', '341ac8689670aa50f1408deae0cf7d95');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/clicks_tracking.tpl', 'a3ec90de9c82c1dd4ed2488fdfad6eb5');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/commission_edit_with_fixedcost.tpl', 'ccfafbca4ad133889269114d5aa68ebe');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/commission_group_panel.tpl', '955da7d7fceee1f9919b2d59db05008b');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/commissions_edit.tpl', '3f774edc6af6c6e02430d6234be320c6');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/commissions_panel.tpl', 'ccc7d624f4e0f16addc1e1a2acd02a11');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/compressed_commission_settings.tpl', '072a5c2e3f83f7dddaccce7879c418c2');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/config_currencies_form.tpl', '8bc5d1dd94f16d97210fa29ef80d2bdc');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/config_currency_tab.tpl', '4fdb78bd6108fc60ecd63e82f5746265');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/cookies_tab.tpl', '05b71f311643e3e9879aff793583b647');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/country_list.tpl', 'a2c0e36008e2e5e004d376ee1895a036');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/country_select_panel.tpl', '08ed995b60b454e366d9ed87061aec41');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/coupons_filter.tpl', 'a8ace675eea8fa1c4a1d91120a07280f');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/coupons_import.tpl', '4033626108115abc6626486cee8ac5ce');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/custom.css', '4877ef2467745239a93ebe1e79b2f813');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/daily_report.tpl', 'b20880541206a63cd7cb9fe010ea1084');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/daily_report_filter.tpl', '95d7d11922c98d2c9cb9efe8008d6d4b');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/default_theme_config.tpl', 'd334aafd6ab32a0d07960ad3fc1a6481');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/direct_link_form.tpl', '0be97d8c324c5d4703ac14caff6c14ba');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/directlinks_advanced_filter.tpl', 'f8c934f8ff22999444e7b98682018175');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/directlinks_list.tpl', '90fac97b55320c68acc06cc801cf5455');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/download_auto_reg_banner_form.tpl', 'd8e0c2d751872f7c08e2a4a4e20ca725');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/download_auto_reg_iframe_form.tpl', 'ddc0468484559430c1719fc3166e0e22');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/download_auto_reg_link_form.tpl', '62793684d38fabe657b56ee9d7e7590a');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/download_signup_form.tpl', '21db3c8eb2f9e86f0181534753bac114');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/email_form.tpl', '8c7377490350afdf95314954a1c5041f');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/email_notifications.tpl', '2b8e3faf2abb306ac7f89d648b6ba4d8');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/export_files_panel.tpl', 'ec4d327e6d39d4ec35a4ceb5fb237691');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/export_panel.tpl', '89136240918568c41e0cf7c88747dbc1');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/feature_detail.tpl', '6a3a7169d6fb6738163528bcc04dd6b0');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/feature_settings.tpl', '87af7f525209730c8aa0573f91cbb956');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/filter.tpl', 'cc93c246e4fd3e0acfb93c5eeeaef8ee');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/filter_field_decorator.tpl', '0afa75f69e50c2a31dc1a1987dbf050f');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/filter_form.tpl', 'c86ee6fcf176a62414fa132c9ff795d0');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/footer.stpl', '3fbd103789f1ff2a151c16f490a913dd');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/forced_matrix_panel.tpl', 'b37fd0f3e7daf4de8a168cf0f0f9354f');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/getting_started_merchant.tpl', '79c389baa182b08f61b3dce0762b977c');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/google_recaptcha_settings.tpl', 'b713c9b516436c27961116db91a65a8d');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/header.stpl', '6ff0df0074e609a194b53f5379916ef5');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/home_edit.tpl', '225c320d546d283cc6ce90e25f39cfbf');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/home_panel.tpl', 'ed1cfa9f0c11e17221cd2118477c8fd1');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/home_panel_content.stpl', '486fcae0026c066f9fb0f03a674ced54');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/htaccess_panel.tpl', 'f2f592df8e91fc493999fb07fd069ff3');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/icons_panel_with_header.tpl', '49915f3e094bfd40d009b4bddecbe862');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/box_divider.png', '88ec74dba62142217c8daddbd30ad9ec');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/browser_secure.png', '5c95ff5b78267e9023bc63a36415e4fc');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/config-hover.png', '0e622df8cefda5590d2e187f7732d956');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/feature_icon.png', '47556c7aac8fcae73b927a914c2e45f0');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/header_divider.png', '9c04ac8b0e24b7815be8feda5e810d14');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-about-big.png', '428601da0d9ba4c3deea1b57259f53d9');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-about-middle.png', '08f103818c506e89fa2e7aee7d0970ec');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-about-small.png', 'd7c377c6c1839c02d8ff4c08241d059e');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-accounting-big.png', 'fa93f5c4b60b9d095a2a23a52211168e');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-accounting-middle.png', '7da96ba7ebbfb004234d789e5f36ce69');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-accounting-small.png', 'a14dd58b2eff427007308e6c395da74f');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-actioncommision-big.png', 'b7245ce1da39458df4478fb97c2ec907');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-actioncommision-middle.png', '7ae18337038f543b5defede7792eda07');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-actioncommision-small.png', '50647c7a2ce6e87c05e67856140a01be');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-admins-big.png', '57361cd2d4a488cd2eed00831b26bd5f');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-admins-middle.png', '46b9654e5de894bb1906ef4f498d35ac');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-admins-small.png', '039ecbce68831dfb1dce0752932bf5a6');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-advancedfunc-big.png', '8691f9054949c63439b1c099c849fe37');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-advancedfunc-middle.png', '31ca17b7f2dc610f34f9f36ad2078199');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-advancedfunc-small.png', 'f224df62fe414aa5b654a2aa9c9083ca');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-affiliateadd-big.png', 'd5c7131c1975085da373524f57febc48');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-affiliateadd-middle.png', 'c05ec87dd20e86e40c5ee7a23d184acf');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-affiliateadd-small.png', '050c51fd19d53154f31252c2cec060c8');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-affiliatesettings-big.png', '6a8d19a4c2a2f49b7a483eb554c67a7e');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-affiliatesettings-middle.png', '462b0a2b18b14dadb0a9359a3e3296ae');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-affiliatesettings-small.png', '477ab1aa47a3b25ec0edff418f3829c0');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-affiliateslist-big.png', '8531931a1a8deec989a128b251b7d8f5');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-affiliateslist-middle.png', '792702720d9f73f31b131a600e263b31');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-affiliateslist-small.png', 'd4c2e1649a26e4fd19dc1960dddbbd34');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-affiliatesoverview-big.png', '108370d42effb2502ba4ea4c947518f0');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-affiliatesoverview-middle.png', 'ad8de49bca55781e6f7b9366d10848f3');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-affiliatesoverview-small.png', 'f9e1bdcc59800c0c103b55291d10018c');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-affiliatetree-big.png', 'f3a3935903ffd1fc62078a69c94b3e96');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-affiliatetree-middle.png', '3efb3954dbfde93f0c7bd5d562b3c27c');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-affiliatetree-small.png', '987817c468127c8b45d72d965b8f808a');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-afflinkprotector-big.png', '41210425d22e80b3415aa664b00d398a');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-afflinkprotector-middle.png', 'f8f8399f715a2a31678b96bea47c9ae0');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-afflinkprotector-small.png', '8a6ca0c7bed131e76f4fae31000201ab');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-affpanel-big.png', 'ad0c3f7baf452316627482ce47ec9b37');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-affpanel-middle.png', '05d7b2248ad334121d39726a988b3493');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-affpanel-small.png', '89acee5cdf219cfb2d1400d3b4a248a5');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-apiintegration-big.png', '702515b8933c9c7ed457d3280ea8e340');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-apiintegration-middle.png', 'd37af643a7d0e045a121f291388c91fd');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-apiintegration-small.png', '676c13fdb6c683af387767cb1789df66');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-banneradd-big.png', '1f5c8423f1a329ac06e2929dfee1b7e3');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-banneradd-middle.png', '5faa76618891e14178f306de5c1c72c0');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-banneradd-small.png', 'b3d8b98e27e2b98f160deae84ef556c2');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-banners-big.png', 'a13d36f6a14c4059befca90c969d12ee');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-banners-middle.png', '0f4345a212b496cef45afec891b05c24');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-banners-small.png', '5ba134d161fe9424b876e7e50511d7dc');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-bannerscategories-big.png', 'a310cda6bf44049c1b0dd3d203e06140');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-bannerscategories-small.png', 'ae5c90546f68383ca6471da4a36870da');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-bannerslist-big.png', '1bf599dbf6524cb922f1f09e4bbda116');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-bannerslist-middle.png', '134ffe754f0e2f838a2f3a02693f0ecf');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-bannerslist-small.png', 'c8f299bb45397ccdaecb7df3c9600ffe');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-bannersoverview-big.png', '8c7b4be8a563f9d0f8c657fbd7b064c0');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-bannersoverview-middle.png', '1e2211f286811bfeba9ba96d1f32e5de');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-bannersoverview-small.png', 'b70ada457ab1c9981f8ab4bef5653e7e');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-bannersscategories-middle.png', '6d575e2b8cddb98be3f83386bf1f1431');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-billinginfo-big.png', '819f4758f0faed71b211a3309f0e8dc1');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-billinginfo-middle.png', 'c0628583bebe9e6174a1fe020f978c89');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-billinginfo-small.png', 'aafc8e41d2753a4f9b6516181acb2dfa');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-broadcastemail-big.png', '1d2cfa3b506deb6280ebf4cc98b8c010');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-broadcastemail-middle.png', '8a6537ef09913526b4c1206c170a69d7');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-broadcastemail-small.png', '11b04a9929cd413f1cb3fce70c717a30');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-calccommission-big.png', '7086ebb3d568dcb605be0e4a0924896b');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-calccommission-middle.png', '40ab427ab7b4e42ddb82e0dfcb9d1a1a');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-calccommission-small.png', 'b0f099674dc9c78dfa40e32a832a3b0a');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-calcsettings-big.png', '89d5be624ffbbc8474f2b8030c1cb92e');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-calcsettings-middle.png', '7ddfd7f2b19d63da77caf6a739876951');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-calcsettings-small.png', 'b963cdbae235cc78f68a8acfef8bc6e4');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-campaignadd-big.png', '69354264e1b50b1f050b35af8a1aebb5');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-campaignadd-middle.png', '398346125f7b6b9a61fc4f68220b3fc3');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-campaignadd-small.png', '9b4aae84c0f775bb20507a1414da70e1');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-campaignscategories-big.png', 'a310cda6bf44049c1b0dd3d203e06140');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-campaignscategories-middle.png', 'e6988def816a3b83d6485f81c97d228a');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-campaignscategories-small.png', 'ae5c90546f68383ca6471da4a36870da');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-campaignslist-big.png', 'a52bc02f28d4f56220c320c6574f8f9c');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-campaignslist-middle.png', '18d1cf55d9b41463bf1cc8a61082fd7e');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-campaignslist-small.png', '193e4f56908fa9d045972749abc9780c');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-campaignsoverview-big.png', 'ed8ad85caf2c1ff8c34dfdefb67965ed');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-campaignsoverview-middle.png', 'f2595a1a929404d07b7442927156bdf5');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-campaignsoverview-small.png', '6df551a67a7077c5220e6b609359857a');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-channels-big.png', 'f76d1d8030637adbfa2981b132f80d96');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-channels-middle.png', '2cb39c0ab010e237816a14f8f72c9e83');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-channels-small.png', '03cfb7b9ad94827a4d0bf8336e7e52c0');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-channelstatsreport-big.png', '4b1c13143a301c246e9fcef695e58666');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-channelstatsreport-middle.png', '5041b217680c01a939634c064db1680d');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-channelstatsreport-small.png', '302858f05a10b04f087efe27052206fe');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-clickcommission-big.png', '7da264525cc0d547db7d68817639093e');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-clickcommission-middle.png', '9062c8bdaed678780d9adcdfbf71805e');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-clickcommission-small.png', '2d37adb9026b332a059618cc27896c47');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-clickslist-big.png', 'fbda1422f6bd873d56894c1d7d95ba4f');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-clickslist-middle.png', '1e9e6fd98dede11eb46c274f84402a20');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-clickslist-small.png', 'e6570b0542c57f628986082628994f72');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-clickstracking-big.png', '14d844dae72c0e0511edd4ea5cf7a47a');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-clickstracking-middle.png', 'cbc4cdb681b448d9142ec67da772b748');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-clickstracking-small.png', '6aa780ce3413adaa4ac15e7bd95c3958');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-commissionadd-big.png', '622fad726c5bbc696241898640e20926');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-commissionadd-middle.png', '4c985782fca423e78dcd2b6745b45702');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-commissionadd-small.png', '80f1404144c2a625bcc331a5e5263eab');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-commissionslist-big.png', '0195a700dbe8d2c3ac1608f3cd883ad0');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-commissionslist-middle.png', 'c1825e4ab7760d62b2966b8a8f7c8fe6');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-commissionslist-small.png', 'b08f72525311b61be001eb1604554eeb');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-commreport-big.png', 'f4fce1db7a0c10e677de57dc38a2609e');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-commreport-middle.png', 'b2306eee5a0e98596eeba19e46fecdd1');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-commreport-small.png', 'dcab4d1c0b0faf44f649a819071a0487');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-communication-big.png', '5accfde00d1b34b6e771d0faebc2b1b6');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-communication-middle.png', '0dfd1e7a41c470dc778cd31304e87bbd');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-communication-small.png', 'cebe3e7324bb0d86051f9cbdedfd6ecb');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-configuration-big.png', '2cddf90ad25270348ab96a6d9d874152');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-configuration-middle.png', '3b15283fb36f3944926ac9f33c198b14');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-configuration-small.png', '7b0623ad383b0246f58aa6bc45277678');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-confirmationrequired-big.png', '90210b42d7d84c2185a4a0643454a9fa');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-confirmationrequired-middle.png', 'ac1eff9620b54544f2cade0ba324e6e7');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-confirmationrequired-small.png', '02c4ce14907c147b902e83da8c2f2abb');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-contactus-big.png', '925ea74565475d763da214a66848d090');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-contactus-middle.png', '002d837a4e1aa1f0c9c985e0bcd6a60e');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-contactus-small.png', 'e62035b9b08fd22200b9d0e63401a66b');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-content-big.png', '428601da0d9ba4c3deea1b57259f53d9');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-content-middle.png', '08f103818c506e89fa2e7aee7d0970ec');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-content-small.png', 'd7c377c6c1839c02d8ff4c08241d059e');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-cookie-big.png', '3438d09467e579a8cd77d73556add8fe');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-cookie-middle.png', 'f781aecc5805c2477ef59ea604102290');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-cookie-small.png', '56bec98a07cb2dac95671393cda6c0d5');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-creditcardinfo-big.png', 'da75afb6f853e50437f2c1e98859b2d1');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-creditcardinfo-middle.png', '54020083be89f51a509c9f256ca9cbd0');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-creditcardinfo-small.png', '8cf60780085fbfc3b7fae78d5f2e2a98');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-cron-big.png', '854e5c2afb7981b64009af910cb91c2a');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-cron-middle.png', '8aa0ecdb6c6cb2101af2a44262b0cff8');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-cron-small.png', '21af15916c7cb3887c3579a6362c34e3');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-currency-big.png', '599af390c3935dfadab5c6c8a36d717a');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-currency-middle.png', '476ebd22b8b3ee70914a986bf0ed44ee');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-currency-small.png', 'e00d0f217b9c13089a324ebb2a4a276c');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-dailyreports-big.png', '51f3e844ba86a439576661e6fd24ab10');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-dailyreports-middle.png', '8610d4e0dfd7208784d563d874fa887b');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-dailyreports-small.png', 'b69fc28548f6ca7ae3f46bb3006a333e');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-databasestats-big.png', '92877608b8101fc8f19d6c73c66cf678');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-databasestats-middle.png', 'b6ac069c16ff64ce58a6d21d620468c2');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-databasestats-small.png', '878c6102aacf869afa9faf11f88edfa3');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-dialog-big.png', '90210b42d7d84c2185a4a0643454a9fa');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-dialog-middle.png', 'ac1eff9620b54544f2cade0ba324e6e7');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-dialog-small.png', '02c4ce14907c147b902e83da8c2f2abb');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-directlink-big.png', 'c278ffcff33c372f76a7e60decf69bb1');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-directlink-middle.png', '680770b962b47fdbf8f67b31b0d646cd');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-directlink-small.png', 'ba793d7acb6322f1cf6ad3ce700fb640');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-directlinksmanager-big.png', 'c278ffcff33c372f76a7e60decf69bb1');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-directlinksmanager-middle.png', '680770b962b47fdbf8f67b31b0d646cd');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-directlinksmanager-small.png', 'ba793d7acb6322f1cf6ad3ce700fb640');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-domain-big.png', 'f32e5c64aaea31672065b30adb51ec11');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-domain-middle.png', '9b2d68e032e33fbe9bddad86cc3bef1c');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-domain-small.png', 'ea7e3479c5f47119261cfecef4ab309b');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-emailnotification-big.png', '24e0fa4c00e137fac96db534320154db');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-emailnotification-middle.png', 'c270a2eb37d703dced4196e94fbe7dde');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-emailnotification-small.png', '9f5a038c227bbedcfc87ddcc568dd96c');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-emailsettings-big.png', '9f5d46acd00fb265ebbd545c32f3d9e2');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-emailsettings-middle.png', '1239fedeb1606d41dcf1ccb234ed738c');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-emailsettings-small.png', '727f303733ffea427cc17427fcad1c2c');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-emailtemplates-big.png', 'd0518c39e49dc80897d0f691060f1142');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-emailtemplates-middle.png', 'be7414ea54e19ffe0650fa796d785733');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-emailtemplates-small.png', '1d78171288453cbc025021098d1b4982');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-eventlog-big.png', 'bbfa889e79729293e1303ed0a2ffe309');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-eventlog-middle.png', '338d53857746a8937c029b7ac569d335');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-eventlog-small.png', '3ca1dafbb4a2e956fdb9808be6b45f82');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-export-big.png', '35be33047c8e02e1a32d55be841a65d5');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-export-middle.png', 'ec292304e5b591c83ea7c9394275a9a9');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-export-small.png', '9835074ca5282cfeba17b8d7a036294a');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-exportfiles-big.png', '6ad2c2691a3ce2edb276ac28ee77f621');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-exportfiles-middle.png', 'fd0819f8105a837e30986da44f5bc6e4');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-exportfiles-small.png', '8a1316abaf6351d2ba61a39ca628eab2');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-features-big.png', 'dd45e0325fdac4e3d98c24b36e30bf19');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-features-middle.png', '7ea1404bd47a6185f1d67f367be0f2b2');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-features-small.png', '39df80c8c1eb1bf6b29fa100ebad750d');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-folder-big.png', '964b4525aa06127c52b84a589049c3b8');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-folder-middle.png', '5813b0412260d952b4460e19be72e7ea');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-folder-small.png', '365a922fabd91c200543597d98cf0564');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-foldergrey-big.png', 'e1942d05c09d21e20e56c094002f1fa0');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-foldergrey-middle.png', 'ec0d082b63dfe3a6830fbda08f4ff54c');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-foldergrey-small.png', '55104fb0a0d0492c26055bf2ba7c4f00');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-fraudprotection-big.png', '0f46b039dc06851045f36d4e9eb378e2');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-fraudprotection-middle.png', '1a73eae9b90951de01bc2ff730aa092e');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-fraudprotection-small.png', '697acc0f7c159c13072eaae0033af2d4');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-gettingstarted-big.png', 'd197bbf5a9900bb8d536e66afed03206');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-gettingstarted-middle.png', 'd2f4a4665a3fe71ca2dafc18d668f3cb');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-gettingstarted-small.png', '62ecdf49ec3da0bfad4211057e6e051e');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-help-big.png', '5b04efbf4559f7d56773ade80e8923c7');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-help-middle.png', '70a562cbc3713f88e521d05cb3dd7f1a');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-help-small.png', '61d96309c23e3ed484a8cb498313d9e4');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-home-big.png', '8c15857acaf46bf2bca9ee23ca005fdb');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-home-middle.png', 'c0628583bebe9e6174a1fe020f978c89');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-home-small.png', 'aafc8e41d2753a4f9b6516181acb2dfa');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-import-big.png', 'a3994f14cdc5fdf9447cf1c5f222fb98');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-import-middle.png', '6f71e329a1afc3045ce4d673a5266390');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-import-small.png', 'ca31d217f2c82a3686c25caaf90f18eb');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-importexport-big.png', '22bc4deef07277d9c6157e960b4fccda');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-importexport-middle.png', 'c1afe17385ddb0d901a90ad111415600');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-importexport-small.png', 'ad47885de018e70115fe1e4232b77269');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-impressioncommision-big.png', '495f55816ffa5216e4746c1d1eee9557');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-impressioncommision-middle.png', 'bb4d0494dd90f486d90783a343f2bf15');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-impressioncommision-small.png', 'e97f06809d7944cd2cebc2683aa22370');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-informations-big.png', '90210b42d7d84c2185a4a0643454a9fa');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-informations-middle.png', 'ac1eff9620b54544f2cade0ba324e6e7');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-informations-small.png', '02c4ce14907c147b902e83da8c2f2abb');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-integration-big.png', '6bd708116619dcfa262a6d40674d8e5b');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-integration-middle.png', '6bdc55939230fa36f99e61dc2ad49125');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-integration-small.png', 'c61bb436dc255ce9be68ce8bc94291b2');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-integrationmethods-big.png', '17e48a253c213fb67da54d8cdebf95f0');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-integrationmethods-middle.png', '0ae3248fdb2afb2fa8504f8f32838645');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-integrationmethods-small.png', 'a3a8267d8fe64a8876f4b12150c7b143');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-invalidlicence-big.png', '28b65cd15641f0bcac4a7ca9ff12f3e2');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-invalidlicence-middle.png', 'd4138638238334a9f1c101c18b7f3dc7');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-invalidlicence-small.png', '8abe2ba041d63018480d9a412e54db6c');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-invoice-big.png', '8c950adce63c0a3d575e5592aa2981b3');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-invoice-middle.png', 'eee62a121a1ddb1da1f8f1361876b447');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-invoice-small.png', '5bbc98c7efb943177890379332dc5109');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-invoiceformat-big.png', '5cffed26d74d9b98dbbfb01888b58559');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-invoiceformat-middle.png', 'f2ba0cc61a485dc665beb10a6f7a7c98');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-invoiceformat-small.png', '321e3605531407784effbe53635a8aef');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-languages-big.png', 'a0b72821e1d253339513db5d4643d3cf');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-languages-middle.png', 'aec76897d11268756df3ef7be19876f5');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-languages-small.png', '9c3b59920c9e4dfd9cd7f96d775b9627');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-languagetranslations-big.png', '2103875d8558a3cc616f9a4abf85e713');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-languagetranslations-middle.png', '9b2d68e032e33fbe9bddad86cc3bef1c');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-languagetranslations-small.png', 'ea7e3479c5f47119261cfecef4ab309b');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-linkformats-big.png', 'b2202763a3a9a28a957a17bcb7007943');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-linkformats-middle.png', '19db12b55ce7c4a1ffd3015f3fde7764');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-linkformats-small.png', '8d2b611c63b8dca40d9dcb09fab53385');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-logging-big.png', 'f3f381ea4a2a4b8a1aa0e19de56437de');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-logging-middle.png', 'a2f1359597d5f418e6ea3d635b6daf59');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-logging-small.png', '741214ca11b87b38d0d904650cb3a717');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-logout-big.png', 'd4bba32201c5056c278d53fed4b1bbc7');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-logout-middle.png', '1a1b1120551e1f9a8173859aa4f2cbe3');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-logout-small.png', '25d153721685338959a2dad7af6321ab');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-mapoverlay-big.png', '0f6b98425312f5c78b7f290cc8c89c35');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-mapoverlay-middle.png', '63a3414c94e2a41aea15d05456be47fe');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-mapoverlay-small.png', '26d00c127fbf4a4ae6310f889758ad2d');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-message-big.png', '403ba3600f9e63e33ffc5c0dbb53c44f');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-message-middle.png', '8dd9ebb863d0d76aa6f720eb8f332cd4');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-message-small.png', 'ac79d200fb4199e60193d606ce574d8f');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-myinvoices-big.png', '8c950adce63c0a3d575e5592aa2981b3');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-myinvoices-middle.png', 'eee62a121a1ddb1da1f8f1361876b447');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-myinvoices-small.png', '5bbc98c7efb943177890379332dc5109');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-networkaccountadd-big.png', '1d869a10b51e3cb53738cf5d4b185511');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-networkaccountadd-middle.png', '55133aa727cc82e002059e82abf4b699');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-networkaccountadd-small.png', '18bd89d5bd977cceb1656787f14771d2');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-networkaccountfields-big.png', 'b8bc6614fbbf1e4deae4d2cf5d2f4501');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-networkaccountfields-middle.png', 'fc399368b0b7044e891f8c83f713e97a');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-networkaccountfields-small.png', '8514ea6a22d424dd3a14876ec70cb3b2');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-networkaccounts-big.png', 'e6fe2e1cd1cda349384c87e57a26865d');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-networkaccounts-middle.png', 'c001bf4f7c6e94020dc00cc44e6682da');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-networkaccounts-small.png', 'a0432c0d3443735d331430568c69e4fa');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-news-big.png', '17b52a7a5c177b9f3054208cec5b8deb');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-news-middle.png', 'f126c6d4487489afa292c0c2530d1719');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-news-small.png', 'ffcf7c920c65aa1ee4c3363929ba0eb5');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-newsletter-big.png', 'd0b8e5c3b293ad29e1a66eeb383d2c8e');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-newsletter-middle.png', 'd06b7b2b542bb1cf12aaf0d939820cf5');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-newsletter-small.png', '7d52c62d5397230708b2448df035ca1d');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-offlinesale-big.png', '35127b1b9d03b19aea95b905e400c1ec');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-offlinesale-middle.png', 'a76f012b2b526bc2455c1be3df69b968');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-offlinesale-small.png', 'f64a930d43970b319f484c35059114b8');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-onlineusers-big.png', '8a140f9f5787e65335573c35af435912');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-onlineusers-middle.png', '40903caac39a38a1f4de08a19dc4f1d5');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-onlineusers-small.png', 'f969b9cec13f1afdbe832d0fd74d9e85');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-outbox-big.png', 'bd4be7e782336809737c3f56d0d95840');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-outbox-middle.png', '51da280d0b41b48e88af9492c74c5b11');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-outbox-small.png', '793acba64f930962243773f51217e905');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-panelsettings-big.png', 'f7b70b68d910bc557de2e42f7d711a3a');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-panelsettings-middle.png', '2d03ba94b420563960bb930bf36edf6e');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-panelsettings-small.png', 'b67eca984d0d89a6805d7712462f56d0');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-parameternames-big.png', '47a57e7c5d1a402c30d102bb8f73c2a6');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-parameternames-middle.png', '06d16585e4f3be531b154ee4b6788907');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-parameternames-small.png', '192530feb2fa8aebe3ee491b6f5f1c5d');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-payaffiliates-big.png', '5262ba6c21f92887786620c1ea8b7637');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-payaffiliates-middle.png', 'd3d46fc871afb345aed861b12b494411');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-payaffiliates-small.png', '708f3f7485253ee76d8aa9882a3e81ae');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-paymentdetails-big.png', '2c3dcc019b163e58f6e991ec3cdeb93a');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-paymentdetails-middle.png', 'ae0d1d42210ddf8010e4b18903a71a5b');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-paymentdetails-small.png', 'e7cc29a55755c0c1c600f3eb29970e30');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-payoutsbalance-big.png', '6d5dfc08ff356dea7e5b4498351b2abb');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-payoutsbalance-middle.png', 'e69a2216780616d8b3d3f051931a05b6');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-payoutsbalance-small.png', 'e7be75d8d0774747990ea964f1e0101d');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-payoutsbyaff-big.png', 'fb58c02622942f34bab91ebce940f3ec');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-payoutsbyaff-middle.png', 'eef1db9e3a6026586901b3fe33b36545');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-payoutsbyaff-small.png', 'e61f9ac8562802dc0aac00ebc31eb31d');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-payoutsettings-big.png', 'ff7264578099e47bf2d4646d357742b2');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-payoutsettings-middle.png', 'ebe350b6ff8af2d08075b28f5db11f3e');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-payoutsettings-small.png', 'ca9c7400e3ff2e50a1725d7b1732c5e3');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-payoutshistory-big.png', '8e87c06adbef25733e01ab3e51b4f6d3');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-payoutshistory-middle.png', '6130fe62b04a66ef19ba1241fb1404a2');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-payoutshistory-small.png', '9e957f26370ef8282a267e5060bcea32');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-payoutslist-big.png', '1bede851415e062a888451c1ef493385');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-payoutslist-middle.png', '6641a3364f458f94d91d6182cc01b176');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-payoutslist-small.png', '27c574fe08115a833acb8e0bdeaf50b9');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-payoutsoverview-big.png', '1bede851415e062a888451c1ef493385');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-payoutsoverview-middle.png', '6641a3364f458f94d91d6182cc01b176');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-payoutsoverview-small.png', '27c574fe08115a833acb8e0bdeaf50b9');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-pendingtasks-big.png', 'efbc34dc0e67b2e87a108e524ddb16bf');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-pendingtasks-middle.png', 'd48852893e28977e18edf8080200712c');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-pendingtasks-small.png', '038469d25098ca85aac324d68f46b9c2');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-personaldetails-big.png', 'db24999d6b323cc4160481b9197cf52e');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-personaldetails-middle.png', 'bcfcba468799c8309ffb8cb8d0cfaa6d');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-personaldetails-small.png', '893a70e6fb2ac1b86c02d7c3bbe06c4a');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-plugins-big.png', 'bf88b03059137ed6ea16485f8e1d4545');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-plugins-middle.png', 'c118bf8d916cf78e70202df8f9c75d4d');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-plugins-small.png', '8c999c38a9d57971341676aa0002cd67');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-promotion-big.png', '7a839eab485f58c64f18373fb98071c1');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-promotion-middle.png', '58f5cac0a7c05b9793088812a786d3ce');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-promotion-small.png', 'baddc96d178672ba3d353459432469ac');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-proxy-big.png', '873881ce0902d108856b66d6cd1bbeb5');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-proxy-middle.png', '9159eda478c488ff964fc3998c7166fe');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-proxy-small.png', 'f3b4244c5a02eb94ed262d6254d06298');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-quickreport-big.png', '13d6307a75e92e4a1dfa3dd47647cedb');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-quickreport-middle.png', '9ef336fd190f5b6e17ed3164d3cb0e9f');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-quickreport-small.png', '931422301455d42e667b0472d3d43066');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-quickstart-big.png', 'd197bbf5a9900bb8d536e66afed03206');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-quickstart-middle.png', 'd2f4a4665a3fe71ca2dafc18d668f3cb');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-quickstart-small.png', '62ecdf49ec3da0bfad4211057e6e051e');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-recurringcommissionslist-big.png', '8316e4d32f09f67d5b85deaa26577dcf');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-recurringcommissionslist-middle.png', '0933b97b1a7da82bf1225ab9eb6b0621');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-recurringcommissionslist-small.png', '3489d6da95b9a3f59dbe9d3b994b6c37');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-reportproblems-big.png', '9395e24a8125e59d979dcf106f5fa56a');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-reportproblems-middle.png', '5d83c6bcafab0d1cb343eaedf66cc855');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-reportproblems-small.png', 'c3bcb16b71995ea184725313eab14ba3');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-reports-big.png', '4b6dce1244d75b94379200e21b318b45');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-reports-middle.png', 'c131c83139fe6e3fe0632abcca35f7e5');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-reports-small.png', '8dcf1727963537d5dea129b9f0833684');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-salecommission-big.png', 'edad2d2af87b8f7cbff8c40cab472e8e');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-salecommission-middle.png', '0fb923346b00270c10d6383310bcb678');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-salecommission-small.png', 'edc571e2de6de0164b7b505b4ae22507');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-screen-big.png', '428601da0d9ba4c3deea1b57259f53d9');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-screen-middle.png', '08f103818c506e89fa2e7aee7d0970ec');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-screen-small.png', 'd7c377c6c1839c02d8ff4c08241d059e');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-send-message-big.png', '925ea74565475d763da214a66848d090');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-send-message-middle.png', '002d837a4e1aa1f0c9c985e0bcd6a60e');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-send-message-small.png', 'e62035b9b08fd22200b9d0e63401a66b');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-signupform-big.png', '94d57c6ffa91773a9e094a7a3f3f09a7');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-signupform-middle.png', 'e568fa54535e4f385eaf91a191e3d38e');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-signupform-small.png', 'ae097dc49a26bc036ad207cb9a5eca52');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-signupsubaff-big.png', 'a45245b27a33cf936d4c9b2d1251d981');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-signupsubaff-middle.png', '4e0de7731560b7c07be66a36fbd5c8a5');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-signupsubaff-small.png', 'a3a9c4345b984dc9522d4ae2c932ab90');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-subaffiliates-big.png', 'd5886239b93fe9bfe1298d968395e761');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-subaffiliates-middle.png', '37c376b667fdcfd16aac1344d5e04b59');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-subaffiliates-small.png', '4a6501ad5d0cf5ee1098037345ea6f04');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-subaffiliatestat-big.png', 'a779b82895bf11652232bfbebbddcf3a');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-subaffiliatestat-middle.png', '9f3d3636c930b1e3adc87e6aba12686c');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-subaffiliatestat-small.png', 'e981446661750ce0b4aabdb056aa21af');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-subidtracking-big.png', 'a9f00f3f0d2880363eca08b4cb5f1077');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-subidtracking-middle.png', 'e9c30cfcbdef74d756ed814f12817a1b');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-subidtracking-small.png', '089f1ee83e8c314b3aa08c00b52ef773');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-systemconfiguration-big.png', '2cddf90ad25270348ab96a6d9d874152');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-systemconfiguration-middle.png', '3b15283fb36f3944926ac9f33c198b14');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-systemconfiguration-small.png', '7b0623ad383b0246f58aa6bc45277678');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-themes-big.png', 'f7b70b68d910bc557de2e42f7d711a3a');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-themes-middle.png', '2d03ba94b420563960bb930bf36edf6e');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-themes-small.png', 'b67eca984d0d89a6805d7712462f56d0');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-tools-big.png', 'e0da1ad291513772326fefcddc8ab42d');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-tools-middle.png', 'b2a25a7a471bba57b2050857980124a5');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-tools-small.png', '506cbde7bdb6c61fe786122b08c59c1c');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-topreferringurl-big.png', 'f1c63c47194544ad073ff2d8800aff57');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-topreferringurl-middle.png', '0193ef9b3cd4c809fe167da539c8c8f0');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-topreferringurl-small.png', 'c44b37822d23b4eb69107b80ca8c9996');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-trackingaffiliates-big.png', '5025622c054d25ce154025f58b04f3e1');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-trackingaffiliates-middle.png', '951449d8043c3a4b87d516dd29b7df2d');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-trackingaffiliates-small.png', '5750ed980100417d63819f951f7d3617');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-trackingsettings-big.png', 'fecc4f7d7b716f954f3324feed92ef23');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-trackingsettings-middle.png', 'bbe8c71155ca22d61746abaff77904d6');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-trackingsettings-small.png', '99e6af89545c48d6c7d2a7f9930a86ca');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-trafficinfo-big.png', '4b6dce1244d75b94379200e21b318b45');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-trafficinfo-middle.png', 'c131c83139fe6e3fe0632abcca35f7e5');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-trafficinfo-small.png', '8dcf1727963537d5dea129b9f0833684');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-trafficstats-big.png', '4bbbb6d078d6804700d1282bdfdda165');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-trafficstats-middle.png', '2a0efd1e3b9a38d08e5dbd76b8326bea');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-trafficstats-small.png', '7ca396360b45a8e9c1d250d5b0824be2');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-transactionsoverview-big.png', '2a8079383dc03f24a774b3d087333826');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-transactionsoverview-middle.png', 'ddaee41388bb9555e6a0f9ec9eb85eb4');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-transactionsoverview-small.png', '6fd329efc615a54f433f8033024b9395');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-trendsreport-big.png', 'a9763385aa10959738675255bd887e23');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-trendsreport-middle.png', '9820cc73655c0705cffc88c3b4955c38');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-trendsreport-small.png', '8c89cd1902b375fc60c95cc7b750e00f');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-troubleshooting-big.png', '28b65cd15641f0bcac4a7ca9ff12f3e2');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-troubleshooting-middle.png', 'd4138638238334a9f1c101c18b7f3dc7');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-troubleshooting-small.png', '8abe2ba041d63018480d9a412e54db6c');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-tutorialvideo-big.png', 'caff5c6e41fc7a40cd96a9b824736a97');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-tutorialvideo-middle.png', 'a0f1663ecb761ec9cd9f56b9f5021749');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-tutorialvideo-small.png', '1ea035f5e1baa010c6f146f8b2864dad');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-undefined-big.png', '90210b42d7d84c2185a4a0643454a9fa');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-undefined-middle.png', 'ac1eff9620b54544f2cade0ba324e6e7');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-undefined-small.png', '02c4ce14907c147b902e83da8c2f2abb');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-user-big.png', '0e702be569fe18fd148352dd35eef5e2');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-user-middle.png', 'f878bab662c76b22ffa7d13ede296674');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-user-small.png', '7a1aa33a04a1e6b22cc6783e41dde93b');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-userprofile-big.png', 'bbfd648d5aa54e015218481966b13ce2');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-userprofile-middle.png', '2c8656debcb0755306adf8f907d39ceb');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-userprofile-small.png', '3033136cc1fad425f585eefadf311da8');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-userroleprivileges-big.png', 'cb55e04eed7cbee58b0f0b78019062e0');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-userroleprivileges-middle.png', '3b7b51ccd2f9e3beabf92773c15f3f74');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-userroleprivileges-small.png', 'b075544877b61c6a4b26a8a18936d1eb');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-vathandling-big.png', '6bd2f6913cb33846aa9f885c4d632ba0');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-vathandling-middle.png', 'af0af1db4bfada5d4ade650b586371e8');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-vathandling-small.png', '72a79ab793a44af78ff83ea71a8f68ff');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-views-big.png', '6da16ea156043161746b99da65cf1735');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-views-middle.png', 'b6670660397dd9d8f05c6f0260e732f0');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-views-small.png', '312f72396b458c3ea1f9186ae14fe548');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-youraccount-big.png', '446688a4e28a0a19af0fe261332f826f');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-youraccount-middle.png', '928934dacbc8b6fab797aebdd4b3160e');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icon-youraccount-small.png', '1f89840ae553c6253cc2ee2611f51845');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/icons22.png', 'b2ea77f479d2b5020c4c4692d5c6e885');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/left_bg.gif', '6b805be091fa27230cc6750ccc38fc37');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/loading.gif', 'a1ab7b44ef8951bc503b6a80a7a6f24a');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/logo_pan.jpg', 'e11b89662d01ad51927067143efe6298');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/logo_pan.png', '97ebd132ae8ec2dd08bbef552d03a0fd');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/logo_pap.jpg', 'aba77ff0db8d780333de3c6d61e34216');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/plugin_icon.png', '38f662af0c9848d4afc772c72f711af4');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/reports-month.png', '189ca5b357e070e385b693be11e0ad96');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/reports.png', '2cb48b10c4178fd34b55815ae51ed21c');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/theme_thumbnail.jpg', '8f02b47d14cf3de93b4ad4102091611a');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/img/window.active.png', '83eda02ef182e2ad1345b2e9eb8bf201');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/import_language.tpl', '59feb2896334d5b05ac438a34de0096c');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/import_panel.tpl', '0f278ca1adbfb902f625dac4d538c2c7');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/import_theme_panel.tpl', 'db7cd53a636368133854006ab17e5a5d');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/integration_methods.tpl', 'fb4d6d6ab5cb4bf2a821a3396878ab06');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/invoice_form.tpl', 'f3d6eef22289877706f22381034a7002');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/invoices_filter.tpl', '1e513f51a437071da6eeec9634865926');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/invoices_list.tpl', 'd225fa4ae5cdd0236ef32f0998cdc8d0');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/keywords_performance.tpl', 'ef30f3752248a81a9f74f8c834aa35d6');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/keywords_performance_advanced_filter.tpl', '1b8952cc990a08800d1e6fe2e93024e8');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/language_create_new.tpl', '1ff007e1bdb8357c18e771df0470bbf5');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/language_translations_filter.tpl', '0f3fed35d20981041e573afbe32050fb');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/lifetime_referral_edit.tpl', 'bbd962a5b1a6c516ad2c9ba3dcd4727a');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/lifetime_referrals_filter.tpl', 'ddacf9eada86c4e0f3cac33a31a8c921');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/lifetime_referrals_import.tpl', '4109a5f8ea79ed17d29cbed9461ab727');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/lifetime_referrals_panel.tpl', '68968ce1c9c6997e6509d35471117932');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/log_filter.tpl', '33968c76c4bb92b6d041adac27fee434');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/log_list.tpl', '5764fdf24e0fb8cd0377e027d18ec1f3');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/logging_tab.tpl', 'd7cf05a0e06e9f82f86e924f5f79c3a7');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/logging_tab_logins_history.tpl', 'c2b080804ea9cd59bb2cd13423857259');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/login_form.tpl', '8f9ca0e2231c804483f6f604549530b5');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/login_main.tpl', '9f3a1aa4ae4fb8a97c71e6fb5a718ce0');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/logins_history.tpl', 'ac0435af36ec2f5c2033081d8df222fd');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/loginshistory_filter.tpl', '74c90cd1052c15beddff88ecc8c02659');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/logo_settings.tpl', 'dd77690db09ddc71457bb16834022bd4');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/mail_outbox_panel.tpl', '3c2433f7d7fe2cff025bd9d72b95cd97');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/mail_template_test_form.tpl', '5d4baf31bb230fb2a53345b406267dd6');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/mail_templates_list.tpl', 'd68cf4d9f0f51fbb8a0aff0d568ae036');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/mailoutbox_filter.tpl', '9dffe85592a26c99d27501445cb0a6f2');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/main.tpl', 'a8499031cc4e8c6d22b76be141728717');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/main_html_doc.tpl', '6d5da2c65ee10fe27b5a0441064a8629');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/main_menu.tpl', '5fddab52f7b44bcb5717c1d67875f567');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/map_overlay_advanced_filter.tpl', '55028fe94ea8e47ca4df79c56a834ae8');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/map_overlay_edit.tpl', '58c1dcbaf1643b0b720a1954f93ebadd');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/mass_pay_export.tpl', 'ba788f5be16ad512b204d391338af138');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/menu_entry.tpl', 'ae560837dfc1d2ff53ba3fea866de9ab');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/menu_section.tpl', 'da446dbc5a24b9881bd8417ce0371bb5');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/multiple_currencies_panel.tpl', 'b6f2b91f00bd8fb19d1d6d6903755153');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/network_invoice.tpl', '84eae09e3bb75e6e36d9d44838156775');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/network_proforma_invoice.tpl', 'ca972dd21dbdf4598a7c4ed87b233526');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/news_content.tpl', '86f3e7fb8f2d71c1fa6013e734154a86');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/news_form_edit.tpl', '304c1e00b1237c64c08f1770828c9ab8');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/news_list.tpl', '718914ca77c83e65ddc0c2553268a4df');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/note_filter.tpl', '5984797bddb6b9dff4b4066106da1bcf');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/online_users.tpl', '85168cc7acd1c4717cdada26af70f974');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/onlineusers_filter.tpl', '4edca7157016faf110102bb4c36c8854');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/order_id_filter.tpl', '103e1ce5be4c9d2f1cc161390371e222');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/overview_panel.tpl', 'ae62662f04bfa67b6ef921d73e3bf5e1');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/overview_stats_panel.tpl', 'c84e4a8212524bbeae1fbd7be0d2452b');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/panel_footer.stpl', '940e5a3345f1058d0cfc751d22355e3b');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/pap4.css', '3da2f9c7599d46612fdfad133eba79e8');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/parameter_names_form.tpl', '42dc5220898dbbafca2daeb2c82e6bed');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/pay_affilates_form.tpl', 'd28bd1b7ef8d4caa2d81b5fcb5f381f7');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/pay_affiliates.tpl', '7841520d27d0879d1dd338e8af2e422b');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/pay_affiliates_filter.tpl', 'e7dbffd57e7dbfdd40accbfc43511e15');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/payout_invoice_format.tpl', '07051c719d4c94b9e386098396278c3a');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/payout_option_form.tpl', 'b0a80b5ba5447317f45fc499486a0d05');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/payout_options_form.tpl', 'e74c9d27195f4ce484c0d1bab821ed10');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/payouts_balance_form.tpl', 'f47af82c605509693e5a840435a6219c');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/payouts_balance_settings.tpl', '17e09e2b2ad93b751ab758527ce4a0d5');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/payouts_history.tpl', '2ab9c99f4db555116cd232fcecfc3d68');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/payouts_history_filter.tpl', '581756a76965326732abb2494fbbe8df');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/payouts_to_affiliates.tpl', 'fe33732b1ae0f4713ac796370a4152ba');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/payouts_to_affiliates_filter.tpl', '6c6363ff9ad5a6965b6008497f121497');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/performance_rewards.tpl', '178ca2c9ad2bd62b05873253b10fb4e0');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/placement_overview_filter.tpl', '96549275298eade0fb6c935860f92e62');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/placement_overview_panel.tpl', '8f563302d209e109f0232a8e39ccd1fe');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/plugin_configuration.tpl', '4cce88fd93f2df049f0df8215074fea8');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/plugin_detail.tpl', 'ff7f2c4b17fbeea4df799a97af83801f');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/plugins_list.tpl', 'd50d54d95ed40fdc51830e9361c32d61');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/proxy_server_configuration.tpl', '97a2349a78945e195c91d98b7daadc1c');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/quick_report_filter_base.tpl', 'a85461c0684786a94953835e79459859');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/recaptcha_settings.tpl', 'ce76b669d8d40445c8a2bafd42049fa6');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/recurring_commission_filter.tpl', 'a1a841a3f7ca025868ffc4c1b88f9922');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/recurring_commission_list.tpl', '64188c7768983359fd2c49ef0b8e9125');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/recurring_commissions.tpl', '77cacde5d1ca9c213f028074936de430');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/referringurl_advanced_filter.tpl', '0ea70362ff237897423e75f8fcea7540');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/report_filter.tpl', 'b37d7cb139866b0da13d266ad5e76941');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/report_problems.tpl', '5b12663b69fe33c59bea1483fca56c25');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/rule_conditions_panel.tpl', '0cc3de69312d83b489054f06c24e9b24');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/rule_conditions_panel_full.tpl', 'c858fe141569aeb45d09ae9e4bde3b02');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/rule_panel.tpl', '575851b945a3f4bac95d33f609924535');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/send_mass_mail.tpl', '0ff2d8bc967bd1b6f3f9331525a98c12');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/signup_commissions.tpl', '38b3ede9d7f3610dabfe7f386156fe2d');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/signup_url_panel.tpl', 'b59b8a4ce5e8ee3588f2f98f2372c685');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/statistics_filter.tpl', '448a9781cef8b1efcdc101ab2fb27b52');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/statistics_tab.tpl', '6e29eee869fe2fe6ba9abc3c13a7396e');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/sub_menu_section.tpl', 'f14329a6ad21f2551a068111201c9918');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/sum_payouts_to_affiliates.tpl', '18fc8eb5a0f5c7332ec51ca6a30816ef');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/sum_payouts_to_affiliates_filter.tpl', '36a15e0febeeb38c0ed8a124e1ffaa78');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/system_menu.tpl', '6b9db812d8f3eb02839850e4a9c3627d');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/template_form.tpl', 'ab02d6a94d38e13b05b4e55d396a06cd');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/theme.php', '33d047ffc9a5b4d1976f7d59b2367af1');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/theme_edit_filetree.tpl', '0c72747749d4c1ab3b88a84ff0445fb4');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/theme_settings.tpl', 'e5cc392956225e60996dbe65455439d0');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/top_afffiliates_list.tpl', '1d32e1fbbc72fce0811f2725e363fdd4');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/top_affiliates_filter.tpl', 'ea273a73b3784310916c59314f18e74a');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/topurl_list.tpl', '80dc7467ce6fc992e3bb75b6d7b133dd');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/tracking_tab.tpl', 'cecde5935a4a9fbf714a782240f1068b');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/transaction_form_edit.tpl', '087430916e41cb0db26de32d9126f6c6');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/transaction_form_notes.tpl', 'ea49f3b3dd42a6be348e9bc96b4c62b0');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/transaction_form_tracking.tpl', '8e7d7592367b4f8b34d862b8255e01b6');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/transaction_list.tpl', '64697567285be75c41a6147e4f86fc64');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/transaction_list_filter_base.tpl', 'bef9d40286ce9ba707cd7a269e0e0c99');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/transactions_import.tpl', 'b5848936e6d3e6355014293ce65834d4');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/trend_actions_stats.tpl', '5d6e55fa6711b536fad187f3a0d26e05');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/trend_actions_stats_widget.tpl', 'a30e19bae13d1fab8908907ca6f488ac');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/trend_stats.tpl', 'fa4185229e724a7ef92762cba12b53db');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/trends_report.tpl', '6183dd6df87166e37e04b7a10fbb76fd');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/trends_report_filter.tpl', '4c26cab4a3e31d1afc29a5b47c2556b0');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/troubleshooting.tpl', '0721ef34db08b3f6b8fe2e2e827e58ba');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/upload_panel.tpl', 'd9102db745c63e3da9295a373d5d0320');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/vat_settings.tpl', 'b9db71b9831d5a712909d460bfab5920');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/view_form.tpl', '64c9a652526f8742ed368c6a843f3b33');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/view_panel.tpl', 'bd0570427463e359dbdde9d319af883f');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/views_list.tpl', '055576733877a76393de0a6a8637d198');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/visitor_affiliate_edit.tpl', 'b5cacbb1c36eb906255ee0925c13463d');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/visitor_affiliates_filter.tpl', '6f7e6dc6ec47bc0727914451f6116c90');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/visitor_nonrefclicks_filter.tpl', 'a1a2bd396334aa80a8b8fba213599286');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/visits_sales_log_add.tpl', '2508acff01c5623b7e4362a3216c236e');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/visits_sales_logs_filter.tpl', '3b18f801191e9ac8928414f1a6d9c9be');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/visits_sales_logs_list.tpl', 'fec10c27f3100fa86ac087bc781e291e');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/welcome_message_panel.tpl', 'f3a67cc7fbf8926bb2a220c0a63fdd70');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/window.tpl', '564d64cbe6768aab4554e85783c60d38');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/window_bottom_left.tpl', '6fb7ac67f0f538f52fc427b755ce8e5b');
        $this->checkFile('themes/merchants/LiveAgent_Merchant_Theme/window_left.tpl', '984d69649ec171a5c6b522e795feb904');
        $this->checkFile('themes/merchants/Midnight_city/TreeItemWidget.tpl', 'd1bfa5574da9cfa131eef997e0870e92');
        $this->checkFile('themes/merchants/Midnight_city/account_form.tpl', 'bec2cc19f2320dfebd3e493c97eeae52');
        $this->checkFile('themes/merchants/Midnight_city/account_form_show.tpl', '481066cec1fdf42f68f2db4c2fabca35');
        $this->checkFile('themes/merchants/Midnight_city/account_form_view.tpl', '3c3a69f103776f35bf195a27db899cb9');
        $this->checkFile('themes/merchants/Midnight_city/account_fraud_protection_clicks.tpl', '559a9b6630eb145dbdc5fa575a97ecb0');
        $this->checkFile('themes/merchants/Midnight_city/account_fraud_protection_sales.tpl', '1eabaf9f7df78e8502403383c9393ad9');
        $this->checkFile('themes/merchants/Midnight_city/account_info_data.tpl', '48e5394b52c65f2174b235bcd7ec792c');
        $this->checkFile('themes/merchants/Midnight_city/account_notifications_form.tpl', '1fb8f96e9b5c02448da103459cdf6aa7');
        $this->checkFile('themes/merchants/Midnight_city/account_private_campaign_settings.tpl', '940f4bcdbf2de9045887c436f31300ab');
        $this->checkFile('themes/merchants/Midnight_city/account_screen.tpl', '738e8b0997ff8592a4524b3f6c6c4ad6');
        $this->checkFile('themes/merchants/Midnight_city/account_settings.tpl', 'bef40a405c258ac960ea1370e7d02de7');
        $this->checkFile('themes/merchants/Midnight_city/account_signup_settings_form.tpl', '68d7a20fdb3a245a8444d5ea27924b4c');
        $this->checkFile('themes/merchants/Midnight_city/accounting_filter.tpl', '0943670f8ba31ff555e7dc4e5915fdf3');
        $this->checkFile('themes/merchants/Midnight_city/accounting_gadget_data.tpl', 'd94f4bee085512317d28081b9f1d5c26');
        $this->checkFile('themes/merchants/Midnight_city/accounting_gadget_template.tpl', '99927018924623a51361c651857aa116');
        $this->checkFile('themes/merchants/Midnight_city/accounting_panel.tpl', 'a95d5eee70654bd6c562e736f4a9f0c5');
        $this->checkFile('themes/merchants/Midnight_city/accounting_stats_data.tpl', '4f714be5959067fa8962919a6c50bb8c');
        $this->checkFile('themes/merchants/Midnight_city/accounts_fields.tpl', '1d3c5c66916b50467c03d8602aa291c5');
        $this->checkFile('themes/merchants/Midnight_city/accounts_filter.tpl', 'dd123439f945f76b09422ad55b2bd4cb');
        $this->checkFile('themes/merchants/Midnight_city/accounts_invoices_panel.tpl', 'e62d96763f78f49afcb568b7de9933ad');
        $this->checkFile('themes/merchants/Midnight_city/accounts_panel.tpl', '77b8fd37eb4f0427cf2b3a6f757e30d8');
        $this->checkFile('themes/merchants/Midnight_city/add_affiliate_page.tpl', 'e69a0888131f7a941dc7e7c744f5dd11');
        $this->checkFile('themes/merchants/Midnight_city/add_affiliate_page_content.tpl', '0f11dbecb7f2f1eea6ab769eb625e322');
        $this->checkFile('themes/merchants/Midnight_city/add_affiliate_page_page.tpl', '70a1f240785c415fb99947f94972de26');
        $this->checkFile('themes/merchants/Midnight_city/add_affiliate_page_url.tpl', '58f8f5e302e28d28522e7265e3694665');
        $this->checkFile('themes/merchants/Midnight_city/add_affiliate_to_campaign.tpl', 'ddb8f68a2edb3955a5a209e11442b1bf');
        $this->checkFile('themes/merchants/Midnight_city/add_affiliate_to_group.tpl', '4f69927d7cad9e8466fe91bd3e3af69c');
        $this->checkFile('themes/merchants/Midnight_city/add_custom_translation.tpl', '91a22a74346db521569588e934048e79');
        $this->checkFile('themes/merchants/Midnight_city/add_gadget_category.tpl', 'e2ec9306de4bf074a33e72c96ff238ca');
        $this->checkFile('themes/merchants/Midnight_city/add_gadget_panel.tpl', 'be8c80e8aff49f52f5b5c1b79be9526f');
        $this->checkFile('themes/merchants/Midnight_city/add_gadget_select_url.tpl', 'b9e3459257a1d9c8a6c66009c826d06c');
        $this->checkFile('themes/merchants/Midnight_city/add_transaction_form.tpl', '6c9da9a05ee604bb7ad0cc4225c07e88');
        $this->checkFile('themes/merchants/Midnight_city/add_user_to_group_form.tpl', 'f5353d26cbc32f5b59f99d0388244462');
        $this->checkFile('themes/merchants/Midnight_city/additional_dynamic_form_panel.tpl', '39fe1aad3bb309004ee15c8537c90d15');
        $this->checkFile('themes/merchants/Midnight_city/admin_panel.tpl', '974dc9641d622a6723650da268bebf5f');
        $this->checkFile('themes/merchants/Midnight_city/admins_panel.tpl', '043af9e3cecec2e85866aa06c2a04a37');
        $this->checkFile('themes/merchants/Midnight_city/admins_panel_filter.tpl', '4ec418856a865586f6d6ed313e0cffb6');
        $this->checkFile('themes/merchants/Midnight_city/advanced_email_settings_form.tpl', 'd007dc036865e18a6c53de95f1bb77fc');
        $this->checkFile('themes/merchants/Midnight_city/advanced_email_settings_tab.tpl', '4cdac3ab7ec6827e1307d48028f2d835');
        $this->checkFile('themes/merchants/Midnight_city/advanced_integration_steps_icons.tpl', 'fc1f4fb9ee86fc80e6ef1e365e0d77f5');
        $this->checkFile('themes/merchants/Midnight_city/aff_notifications_form.tpl', '10c7955484538d42dd52ccfcef274408');
        $this->checkFile('themes/merchants/Midnight_city/affilate_advanced_filter.tpl', '11bde2dcecd82caeeb4616944f36ff5b');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_commission_groups.tpl', '9d4046dbc63fe4b678f8c62ffca79854');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_delete.tpl', '2157c7c0e31996f4fc0f85a185977ac5');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_details.tpl', 'e20195da0f46a47a524af53b1a7c4552');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_edit_commission_groups_no_data.tpl', 'a9756aeb0730e4fd5f4fa9cb6de8012b');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_edit_details.tpl', 'b911b7098ffb6e1511b33e3f35d6f9b2');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_edit_details_additional.tpl', '98de15bb9a88b36dc47ba266389cb413');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_edit_dialog.tpl', 'acaf92b10f7821b0f5794593db70df01');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_edit_no_payout_history.tpl', '0d40b1e330f67d9e74c3890beca74b29');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_fields.tpl', 'c54826ec0f80194f7381304b20b5e95e');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_general_settings.tpl', 'e747d64338280436d5f3478d1f0cb514');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_info_data.tpl', 'b57513f9b5504095638e810826ac3e63');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_list.tpl', 'cc032a88a7775b2938522ca3f58dc755');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_list_no_data.tpl', '7741570acae759090cf04aeb6f313bb2');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_logins.tpl', '9f5432cc0f1f1bb464a38a23fb16e6e3');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_logins_header.tpl', '7fc020dd9a1268955faaf16b973b82c7');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_logins_map.tpl', '76fe92abae4eacb0bfbd670ac54aa0b3');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_menu_settings.tpl', '3507cb91be549e264e21b007c3571ba8');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_panel_config.tpl', '99bc43fef7dbe936c4e733215585a277');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_payout_settings.tpl', '8304e34183caa27262c69cec69c12373');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_postsignup_settings.tpl', '295c4b2802684750cc74e93282fb5732');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_screen_detail.tpl', '1075539ad2bdd3dd1eeb74078b054f03');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_screen_header_edit.tpl', 'cb37af28ddbd0c61c9abadf675e7d8bc');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_screen_settings.tpl', '5fb92d5bc22ff7ede5ec1572ef94ced9');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_screen_settings_nodata.tpl', 'bb4ad3e2d922192ec998ee5ae5c51e50');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_screens_list.tpl', '08ad8cbadce365f01978ef5f8b0c7d32');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_signup_settings.tpl', 'c9a8f99f2c61ead6d8bdb0d125e0f183');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_signup_settings_button.tpl', 'adccd555745134a857328990ed086077');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_signup_settings_form.tpl', 'eb832a062e7059bb5074dbeec7f2f890');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_stats.tpl', 'b1c8b06e198d9ed22a5564a73ff26e0e');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_subaffiliates.tpl', '633205fc5244112afa932c8b18f58edd');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_tracking_code_filter.tpl', '614c11facd7d5ebaee38deae93e139c9');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_tracking_code_panel.tpl', '2563d59c5d920af9e929d25715e3758e');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_tracking_cookiepanel.tpl', 'afe8791a0c4895979c261a672103de97');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_tracking_options.tpl', '85a3391abee5f9a8dc727fe266534ed8');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_tracking_testlinks.tpl', '3407045ee29fe67b40621cdb381ff40e');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_tree.tpl', '875e8e5d865578c1b5efe31580b9e719');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_tree_filter.tpl', 'c676ed3f6a9ee3860ad9e60e62dbab86');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_tree_filter_edit.tpl', '959100eeceade475bc20ec5272660a38');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_tree_panel.tpl', '9ddd4e10bea7ad43a028f867760df9d6');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_url_page_editor.tpl', '1563cbaaa42ab9c7c0c8898a17b3b10a');
        $this->checkFile('themes/merchants/Midnight_city/affiliate_urls_no_data.tpl', 'c9868414093445accf0f0d7551847116');
        $this->checkFile('themes/merchants/Midnight_city/affiliates_group.tpl', 'e1f5bcb91bd2f949694890186ff3566a');
        $this->checkFile('themes/merchants/Midnight_city/affiliates_group_filter.tpl', '466c832f6c6b327cbee63030a81d410c');
        $this->checkFile('themes/merchants/Midnight_city/affiliates_import.tpl', '5d25493eca047e7b66627090a7bcf423');
        $this->checkFile('themes/merchants/Midnight_city/affpanel_design.tpl', '47558761ee69c8a906f6b3f3c0b7fe1e');
        $this->checkFile('themes/merchants/Midnight_city/after_signup_actions_fields_no_data.tpl', '2fe9a7bbd29402632be238ea0cb7f2dd');
        $this->checkFile('themes/merchants/Midnight_city/after_signup_actions_no_data.tpl', 'c9868414093445accf0f0d7551847116');
        $this->checkFile('themes/merchants/Midnight_city/after_signup_no_data.tpl', 'acc4136ac3d8c01816ce79b2281ca9f1');
        $this->checkFile('themes/merchants/Midnight_city/align_widget.tpl', '124769dbcc410ae58c1dfd53f15b58d6');
        $this->checkFile('themes/merchants/Midnight_city/api_integration.tpl', '87329cb5ed35f3bfbb29e45947ae8bab');
        $this->checkFile('themes/merchants/Midnight_city/assigment.tpl', '48b84b37bf127adc78ef230b61a22e60');
        $this->checkFile('themes/merchants/Midnight_city/assign_auto_panel.tpl', '4414ff53bc35c96dd1932aa630eb128f');
        $this->checkFile('themes/merchants/Midnight_city/audit_log_filter.tpl', '67c7322e9a203c85a10210cb496b110e');
        $this->checkFile('themes/merchants/Midnight_city/available_values_edit.tpl', 'e96fa729b9a61e7e4a21fbddf80565fb');
        $this->checkFile('themes/merchants/Midnight_city/banner_and_link_form_panel.tpl', '5c7a5c4a303dffe6d76424abd90a0236');
        $this->checkFile('themes/merchants/Midnight_city/banner_button.tpl', 'e1cb4d807552c33476c9dc37bca24dc6');
        $this->checkFile('themes/merchants/Midnight_city/banner_category_edit.tpl', '2fc9f159a4666a456e4de83356cf2511');
        $this->checkFile('themes/merchants/Midnight_city/banner_category_item.tpl', '55fcd96a4eabd7825f722f3f36bab5d4');
        $this->checkFile('themes/merchants/Midnight_city/banner_category_selector.tpl', 'ba32ee51a99861b1a19d9b66e45f4db0');
        $this->checkFile('themes/merchants/Midnight_city/banner_category_settings_panel.tpl', 'fa002655c612fad61b7cd5121e786391');
        $this->checkFile('themes/merchants/Midnight_city/banner_clone_dialog.tpl', '87df8d4453785b4924425c45fc252f20');
        $this->checkFile('themes/merchants/Midnight_city/banner_destination_url_panel.tpl', 'd2cf85ec3a941d8acc4f8c673c3c2781');
        $this->checkFile('themes/merchants/Midnight_city/banner_destinations.tpl', 'c2466e9211af205aaa302153ecf54ec0');
        $this->checkFile('themes/merchants/Midnight_city/banner_details.tpl', '02ec398758e8c9d094be8ddd3dea86e9');
        $this->checkFile('themes/merchants/Midnight_city/banner_details_params.tpl', 'daca6d0de978ff1a272adbe072455399');
        $this->checkFile('themes/merchants/Midnight_city/banner_edit_header.tpl', 'a7284446b5456bbaf25e073ca5e3dcbd');
        $this->checkFile('themes/merchants/Midnight_city/banner_edit_panel.tpl', 'd371721abec7a70439373826893749c8');
        $this->checkFile('themes/merchants/Midnight_city/banner_filter.tpl', 'c329bee9165d04cc757e990a92c1b019');
        $this->checkFile('themes/merchants/Midnight_city/banner_format_form.tpl', '5f8fd9d50c3f4817158302d1834f7e26');
        $this->checkFile('themes/merchants/Midnight_city/banner_in_rotator_edit_panel.tpl', '331b8b61058b5f85750cc690e63d08cc');
        $this->checkFile('themes/merchants/Midnight_city/banner_list_no_data.tpl', '6ec4d243cc9d9b0ee86612709590882e');
        $this->checkFile('themes/merchants/Midnight_city/banner_manager.tpl', '18d6d96df57962f8d1a9b8effe339b15');
        $this->checkFile('themes/merchants/Midnight_city/banner_name.tpl', '0e8385998fddbc3260837cf0590a35a5');
        $this->checkFile('themes/merchants/Midnight_city/banner_or_link_edit_template_panel.tpl', '346160178349fe7d0b8f4f55bbf96ecd');
        $this->checkFile('themes/merchants/Midnight_city/banner_or_link_not_selected.tpl', '180941a437e8e722a4b7f7b44e73e0f0');
        $this->checkFile('themes/merchants/Midnight_city/banner_own_size_panel.tpl', 'ec916344f7150972a863c771ccb676df');
        $this->checkFile('themes/merchants/Midnight_city/banner_parameters_coupon.tpl', 'd7c6fc6e00c9e11d262f7c767454b9c7');
        $this->checkFile('themes/merchants/Midnight_city/banner_parameters_flash.tpl', 'a6356eb54289b4b062c0250c5e9b7963');
        $this->checkFile('themes/merchants/Midnight_city/banner_parameters_hover.tpl', 'f15317ed6c2ed30c9a2e897dbaaa79a6');
        $this->checkFile('themes/merchants/Midnight_city/banner_parameters_html.tpl', 'f00f7657b51377b05cca05db4a27b4bf');
        $this->checkFile('themes/merchants/Midnight_city/banner_parameters_image.tpl', 'f4227e6ffab89f9fecf00de0db1ea261');
        $this->checkFile('themes/merchants/Midnight_city/banner_parameters_pagepeel.tpl', 'f0477017e173b2a6d887e3eabe77ccc8');
        $this->checkFile('themes/merchants/Midnight_city/banner_parameters_pagepeelhtml.tpl', 'c4722a470e19f5966ee208dfd75b72cd');
        $this->checkFile('themes/merchants/Midnight_city/banner_parameters_pdf.tpl', 'b02138b4e56eb4d1b40be08282348643');
        $this->checkFile('themes/merchants/Midnight_city/banner_parameters_promo_email.tpl', '5d558a2ce40bd6997c670115425bc67b');
        $this->checkFile('themes/merchants/Midnight_city/banner_parameters_rebrandpdf.tpl', '11451d812f2b92bf7928f77a448252ba');
        $this->checkFile('themes/merchants/Midnight_city/banner_parameters_rebrandpdf_allvars.tpl', 'c01f39df6d7b58ed19794de908c314b2');
        $this->checkFile('themes/merchants/Midnight_city/banner_parameters_rebrandpdf_filefield.tpl', '4f3e422e757c8bd5c3460a24dd453153');
        $this->checkFile('themes/merchants/Midnight_city/banner_parameters_rotator.tpl', 'be18e74db4df618a8452b053fed379b6');
        $this->checkFile('themes/merchants/Midnight_city/banner_parameters_site.tpl', '80b74b4c7419b3fd362fcffb1ebe0639');
        $this->checkFile('themes/merchants/Midnight_city/banner_parameters_site_files.tpl', 'ce4cb65e15ec625747ee5a7359ad123b');
        $this->checkFile('themes/merchants/Midnight_city/banner_parameters_site_files_local.tpl', 'a7f630aa7eb54c3cb467cb80f17674cc');
        $this->checkFile('themes/merchants/Midnight_city/banner_parameters_site_files_url.tpl', '9e1571660d6fab85245ee3418abd1350');
        $this->checkFile('themes/merchants/Midnight_city/banner_parameters_site_preview.tpl', '7dcf0d92d184a60ff334ad28adb1fd66');
        $this->checkFile('themes/merchants/Midnight_city/banner_parameters_site_variables.tpl', 'adb74a84e21883cd904c0732316c0bce');
        $this->checkFile('themes/merchants/Midnight_city/banner_parameters_zip.tpl', '262a21aedc240fc1e154b3274cf38cf5');
        $this->checkFile('themes/merchants/Midnight_city/banner_parameters_zip_bannerpreview.tpl', '919258983eb853742ec1aabd2505f388');
        $this->checkFile('themes/merchants/Midnight_city/banner_parameters_zip_files.tpl', '0d3f2c5edba5f03f8fb35dcbaeeebae2');
        $this->checkFile('themes/merchants/Midnight_city/banner_parameters_zip_variables.tpl', 'bea861fe51d3a9e95f9ae5e5cf9c4e81');
        $this->checkFile('themes/merchants/Midnight_city/banner_params_link.tpl', '16e7b10d24dd70483e8c67184d3ec46f');
        $this->checkFile('themes/merchants/Midnight_city/banner_params_text_link.tpl', '36887496682c2c2872c526ca6acba1fd');
        $this->checkFile('themes/merchants/Midnight_city/banner_preview.tpl', '75b30e1735f8ec02072cb2aa83a06047');
        $this->checkFile('themes/merchants/Midnight_city/banner_preview_field.tpl', '71e5ce8dff03853ca9e30de9dfe5006c');
        $this->checkFile('themes/merchants/Midnight_city/banner_preview_widget.tpl', 'f21248876762eecce70f4f6a6d64cad1');
        $this->checkFile('themes/merchants/Midnight_city/banner_rotator_feature_on_deactivate.tpl', 'a1bfe671194574c6d8b231e70bbd0f08');
        $this->checkFile('themes/merchants/Midnight_city/banner_size.tpl', 'e74a26d2165d73dc5a842acd7f481c97');
        $this->checkFile('themes/merchants/Midnight_city/banner_stats_filter.tpl', '99385b61d4e01703bc055a1a910564a1');
        $this->checkFile('themes/merchants/Midnight_city/banner_stats_list.tpl', '3e71f3763376f08380959fe865aad875');
        $this->checkFile('themes/merchants/Midnight_city/banner_stats_list_no_data.tpl', '2bac0448c515370fac072b46a74938ec');
        $this->checkFile('themes/merchants/Midnight_city/banner_with_category_filter_field.tpl', 'dd1d3439d1f76c0deda21232287fbdd2');
        $this->checkFile('themes/merchants/Midnight_city/banner_wrapper_edit_panel.tpl', 'e13d8f01e20f4fa82847845bfac1026b');
        $this->checkFile('themes/merchants/Midnight_city/banner_wrappers_table.tpl', '54f784f44c21afa6941daecd6088cd4a');
        $this->checkFile('themes/merchants/Midnight_city/banners_and_links_format.tpl', 'a298ada6f4a07b79050cb51d23ac099f');
        $this->checkFile('themes/merchants/Midnight_city/banners_categories_list.tpl', '4b6c1997242f90357b1c721a4303d816');
        $this->checkFile('themes/merchants/Midnight_city/banners_categories_tree.tpl', 'fc55213c31030c3a47d4b80338c88783');
        $this->checkFile('themes/merchants/Midnight_city/bannerscategories_no_data.tpl', '3df35d8c385cfc14c75759c80f11aa02');
        $this->checkFile('themes/merchants/Midnight_city/bannerscategories_not_in_category.tpl', 'b4797977dcf354a6a7c77745910e839a');
        $this->checkFile('themes/merchants/Midnight_city/branding_config.tpl', 'bd94806a4df51742d143a23dec8f2cdb');
        $this->checkFile('themes/merchants/Midnight_city/breadcrumbs.tpl', '9981a5d8af1fb510574d67a2e0ba2481');
        $this->checkFile('themes/merchants/Midnight_city/breadcrumbs_entry.tpl', '42ee9a25b7525589ed65bf9625adc890');
        $this->checkFile('themes/merchants/Midnight_city/button.tpl', '40db744b463f7f71d97cd92ff46fecf4');
        $this->checkFile('themes/merchants/Midnight_city/buy_feature.tpl', 'adfbf6783ae850e63499a923231e4f37');
        $this->checkFile('themes/merchants/Midnight_city/calendar.tpl', 'd6831aa786acf1f829a90cec776126eb');
        $this->checkFile('themes/merchants/Midnight_city/campaign_account.tpl', '9e2989cc05bb9dac952b80a40246e4e2');
        $this->checkFile('themes/merchants/Midnight_city/campaign_capping.tpl', 'b9f6737a4b04f0eca0d7957191b51231');
        $this->checkFile('themes/merchants/Midnight_city/campaign_category_edit.tpl', 'd1460a8d0cb69f821b18051a81907550');
        $this->checkFile('themes/merchants/Midnight_city/campaign_category_item.tpl', 'de7ade79ce37b86264373c01e9ad4149');
        $this->checkFile('themes/merchants/Midnight_city/campaign_category_selector.tpl', '4618de8975b4a1f2b94d168304707892');
        $this->checkFile('themes/merchants/Midnight_city/campaign_category_settings_panel.tpl', '18e7ac241cca0c4c360bcf45e7d2ef71');
        $this->checkFile('themes/merchants/Midnight_city/campaign_commissions_tab.tpl', '52c31b8ce3af03ce54ae51917ff87b7a');
        $this->checkFile('themes/merchants/Midnight_city/campaign_filter.tpl', '7f3514d50b873ca8f3e464ad67139a31');
        $this->checkFile('themes/merchants/Midnight_city/campaign_form_edit.tpl', 'ebbce6c2aba4d73403d2d9dc5a4967c1');
        $this->checkFile('themes/merchants/Midnight_city/campaign_form_show.tpl', 'a08f95172660634bb470e3e0b30fb6c5');
        $this->checkFile('themes/merchants/Midnight_city/campaign_list_no_data.tpl', 'd44d658e6b3fb7b4b2f6e0e3bbe938c7');
        $this->checkFile('themes/merchants/Midnight_city/campaign_rule_conditions_panel.tpl', 'd4f35ff94140ca1eb7a5e28dbfd22d0c');
        $this->checkFile('themes/merchants/Midnight_city/campaign_rule_conditions_panel_full.tpl', '46ac5265ab6c374aaae2b3c13d4a7734');
        $this->checkFile('themes/merchants/Midnight_city/campaign_schedule_nodata.tpl', '3e87dc9b305506f1f13895478de1ee2e');
        $this->checkFile('themes/merchants/Midnight_city/campaign_scheduler.tpl', '20870e8e684fb12348a0ade8874d66c8');
        $this->checkFile('themes/merchants/Midnight_city/campaign_scheduling_rule_panel.tpl', 'b0403d7927d7e01cb056da9027b82a8b');
        $this->checkFile('themes/merchants/Midnight_city/campaign_screen.tpl', '48d3e63714873d79a6092b2aa0417dd9');
        $this->checkFile('themes/merchants/Midnight_city/campaign_screen_edit.tpl', '4dd40cd4020a39e251a16d01ffa65723');
        $this->checkFile('themes/merchants/Midnight_city/campaign_shortdetails_form.tpl', '99bd3a0b3e5790f2307e9b897dcd6811');
        $this->checkFile('themes/merchants/Midnight_city/campaign_stats_filter.tpl', '656adb646eecec0d3f5091cfce68095d');
        $this->checkFile('themes/merchants/Midnight_city/campaign_stats_list.tpl', 'e45c163f75670253d0dcc5037f7168e2');
        $this->checkFile('themes/merchants/Midnight_city/campaign_stats_list_no_data.tpl', '6991606b8141a584b01311f5eb86bb51');
        $this->checkFile('themes/merchants/Midnight_city/campaign_status.tpl', 'b732873daaced1e1e9aa43cb2f4c09fa');
        $this->checkFile('themes/merchants/Midnight_city/campaign_step_create.tpl', '2d419b7525bdd89abdec8c0d31d1f71d');
        $this->checkFile('themes/merchants/Midnight_city/campaign_type.tpl', '831bfbcebd1f2ccb1040cfdaa2291011');
        $this->checkFile('themes/merchants/Midnight_city/campaign_validity_edit.tpl', '22198581b13ee3fbd1e3729236df3189');
        $this->checkFile('themes/merchants/Midnight_city/campaign_with_category_filter_field.tpl', 'baf1267e1481cb1cf5433a0ccaf80ee8');
        $this->checkFile('themes/merchants/Midnight_city/campaign_wizard.tpl', 'e6f7ad6b18e7c273490cea2a19a19654');
        $this->checkFile('themes/merchants/Midnight_city/campaigns_categories_list.tpl', '8169d41f1880ba87724c80ce89553605');
        $this->checkFile('themes/merchants/Midnight_city/campaigns_categories_tree.tpl', '2d96c71a0f30a75176ae42f055de8ad0');
        $this->checkFile('themes/merchants/Midnight_city/campaigns_grid_settings_affiliate_panel.tpl', '6830692ae10fdc0b2083cc58268baa4c');
        $this->checkFile('themes/merchants/Midnight_city/campaigns_list.tpl', '983019d6bd514bd1a348f8ad840b8c7a');
        $this->checkFile('themes/merchants/Midnight_city/campaignscategories_no_data.tpl', '7d8325a745599a8d918ac08217275012');
        $this->checkFile('themes/merchants/Midnight_city/campaignscategories_not_in_category.tpl', '0dd23250bcee882b765ec32ad21249af');
        $this->checkFile('themes/merchants/Midnight_city/captcha.tpl', '0326fedb283400e2c13eeae155d7b536');
        $this->checkFile('themes/merchants/Midnight_city/category_list.tpl', '579457d7da6e88deda06b092844c5c52');
        $this->checkFile('themes/merchants/Midnight_city/change_status_button.tpl', 'a0d13402819088b5078e8100a21a0159');
        $this->checkFile('themes/merchants/Midnight_city/chart_datatype_popup.tpl', '7a1a0e024c8392ea5df8cd40b179d4f7');
        $this->checkFile('themes/merchants/Midnight_city/check_box_group.tpl', 'e182dd7429a276dc85e09049b2a6c19e');
        $this->checkFile('themes/merchants/Midnight_city/check_box_group_row.tpl', '97219c5c2d3c996953fd6bd882e6200c');
        $this->checkFile('themes/merchants/Midnight_city/checkboxes_filter.tpl', 'fef5c1833920987bd3172dbe9d75797a');
        $this->checkFile('themes/merchants/Midnight_city/clicks_list.tpl', 'bd1179311cf04f759ddcc79744179a93');
        $this->checkFile('themes/merchants/Midnight_city/clicks_list_filter_base.tpl', '6b6ac3cc08d8a1d3a9d3e6e1e473a962');
        $this->checkFile('themes/merchants/Midnight_city/clicks_list_no_data.tpl', 'e2f13b9b96a4f0a248ea753b0c7c9178');
        $this->checkFile('themes/merchants/Midnight_city/clicks_tracking.tpl', 'a017892f84d373c678ecdc5276f9e6c3');
        $this->checkFile('themes/merchants/Midnight_city/colorpicker.tpl', '297c4e74e89b8b3dedd12e7c319bce41');
        $this->checkFile('themes/merchants/Midnight_city/commission_edit_values.tpl', 'b277423c214667a9202d3aefac1d7619');
        $this->checkFile('themes/merchants/Midnight_city/commission_edit_values_tierpanel.tpl', 'ed403054ea7f2ccb731265f9d3f0ef4f');
        $this->checkFile('themes/merchants/Midnight_city/commission_edit_with_fixedcost.tpl', '3af76ab79f10ff3d0629b1c4b0cc7ba9');
        $this->checkFile('themes/merchants/Midnight_city/commission_group_panel.tpl', 'fbc95c3f3b9a95e9daf3df46d8dc8a2d');
        $this->checkFile('themes/merchants/Midnight_city/commission_groups.tpl', 'cd9f803bcafdc842b0226fa653242f1b');
        $this->checkFile('themes/merchants/Midnight_city/commission_groups_panel.tpl', '44d889bc8bf1f467cbc7d2c18c03c230');
        $this->checkFile('themes/merchants/Midnight_city/commission_recurring.tpl', 'aa827abeee6bb0f472b500c096cd3625');
        $this->checkFile('themes/merchants/Midnight_city/commission_sale.tpl', 'fbdf7f44f6df291e9da9e8172dcad9ce');
        $this->checkFile('themes/merchants/Midnight_city/commission_subsales.tpl', 'c21fc8858085c294ac7630f53d6bd36e');
        $this->checkFile('themes/merchants/Midnight_city/commission_tabs.tpl', '2eec354045cec652c7cd4ff1cfc8bf56');
        $this->checkFile('themes/merchants/Midnight_city/commission_tiers_info_panel.tpl', '20e88ef5e3d641ecd6dd8fea0350b7e1');
        $this->checkFile('themes/merchants/Midnight_city/commission_type_detail.tpl', 'd6d266aba20845c41e04fd8dbfa33732');
        $this->checkFile('themes/merchants/Midnight_city/commission_type_sail_detail.tpl', '73a00350b64b30cb1b5341e050982d83');
        $this->checkFile('themes/merchants/Midnight_city/commissions_details_view.tpl', '6481e92bb25a139b55290e0d5b209cdd');
        $this->checkFile('themes/merchants/Midnight_city/commissions_edit.tpl', '9ec2a9da2c0eaf09392f96b836bc0310');
        $this->checkFile('themes/merchants/Midnight_city/commissions_panel.tpl', 'ff232af7da984c8e346b2bc9b8a6ca88');
        $this->checkFile('themes/merchants/Midnight_city/compressed_commission_settings.tpl', 'b355949c5d9849b51c1f59f96c7e4acc');
        $this->checkFile('themes/merchants/Midnight_city/comunication_overview_panel.tpl', '06ea7c53421b51e4a8fed669637a909f');
        $this->checkFile('themes/merchants/Midnight_city/config_aff_panel.tpl', '58c2a6eae06023e889cee734923b713e');
        $this->checkFile('themes/merchants/Midnight_city/config_affiliates.tpl', '4870980191d1873460bbc2d8894b2bf2');
        $this->checkFile('themes/merchants/Midnight_city/config_communication.tpl', 'b7af569e05800de423c52fc28d7bc40b');
        $this->checkFile('themes/merchants/Midnight_city/config_currencies_form.tpl', 'cdff097c17040c60be3ace45afa62642');
        $this->checkFile('themes/merchants/Midnight_city/config_currency_tab.tpl', '57c84054dcf9ca885c39c1d9bddb860c');
        $this->checkFile('themes/merchants/Midnight_city/config_date_format.tpl', '771f72b6514cd4c9103217a955fb171d');
        $this->checkFile('themes/merchants/Midnight_city/config_language_and_date_form.tpl', '1ad6231d44243a014dd06b3a18709fac');
        $this->checkFile('themes/merchants/Midnight_city/config_overview.tpl', '60db4f006e3afe01077620baf9bc19fa');
        $this->checkFile('themes/merchants/Midnight_city/config_signup_form.tpl', '884261ef7e0c23326874bd92cdda1094');
        $this->checkFile('themes/merchants/Midnight_city/config_system.tpl', '783ebbddb4a39f395967456062db2396');
        $this->checkFile('themes/merchants/Midnight_city/config_theme_panel.tpl', 'bf15ce015bc73d76afb7b4f7f23f3dd1');
        $this->checkFile('themes/merchants/Midnight_city/config_themes.tpl', '0bab46cdedf333176ecb62c8cdc1d672');
        $this->checkFile('themes/merchants/Midnight_city/config_tracking.tpl', '81056b36d3ec69a8fac9d843ed7d7240');
        $this->checkFile('themes/merchants/Midnight_city/confirm_dialog.tpl', 'f92a8f6b3081444abf7fc4ab63c99302');
        $this->checkFile('themes/merchants/Midnight_city/confirm_dialog_label_note.tpl', 'f76c3c08642335eb7b3e0ce42bfe753a');
        $this->checkFile('themes/merchants/Midnight_city/confirm_dialog_label_value.tpl', '0c2d427e2c1c8f4545a90a3a56e64580');
        $this->checkFile('themes/merchants/Midnight_city/confirm_dialog_with_checkbox.tpl', '9e1fd32194d6bfabb251bad0645755da');
        $this->checkFile('themes/merchants/Midnight_city/confirm_dialog_with_value.tpl', '46e7630a0a094110f6819ea655683337');
        $this->checkFile('themes/merchants/Midnight_city/content_gadget_panel.tpl', '79428f6a77f38592dfa1716653bbe79b');
        $this->checkFile('themes/merchants/Midnight_city/context_menu.tpl', 'cddf235a2fec1ae75063d576ccdc6185');
        $this->checkFile('themes/merchants/Midnight_city/cookie_lifetime_group.tpl', 'ea8a6a5ad128f265d7d6891a41fdf097');
        $this->checkFile('themes/merchants/Midnight_city/cookies_tab.tpl', '0ee8a325e03187328807a5c149eb90be');
        $this->checkFile('themes/merchants/Midnight_city/copy_campaign.tpl', 'a12f62962eb0cb273f54414f688f091a');
        $this->checkFile('themes/merchants/Midnight_city/copy_user_role.tpl', '31c4493a09a1d2ad96e0c6133399199c');
        $this->checkFile('themes/merchants/Midnight_city/countries_list_scrolling_wrapper.tpl', '4bf0a92924334c72075b4ddafd3b243b');
        $this->checkFile('themes/merchants/Midnight_city/country_commission_type_panel.tpl', '13728b6a4d83a9d3ca751ea1050e6c2d');
        $this->checkFile('themes/merchants/Midnight_city/country_select_panel.tpl', '8503f8f693cc44082380626a7b0ebbfc');
        $this->checkFile('themes/merchants/Midnight_city/country_specific_commission_type_panel.tpl', 'db0122ec2a13ac87a9443a6dc4594302');
        $this->checkFile('themes/merchants/Midnight_city/coupons_filter.tpl', '4caab93e4b46d2f0fff1d619536efb8b');
        $this->checkFile('themes/merchants/Midnight_city/coupons_import.tpl', 'e9bb34e160a258ff1deb1dfe55f0e4a5');
        $this->checkFile('themes/merchants/Midnight_city/coupons_panel.tpl', 'dcb054cd9abe5cbea02724014d27c7ef');
        $this->checkFile('themes/merchants/Midnight_city/create_banners_buttons.tpl', 'd981b97a16d7f5620a85944aa8d550f7');
        $this->checkFile('themes/merchants/Midnight_city/cron_job_integration.tpl', '0bd75d5d32d1d775a4c81a7cc1a41cdb');
        $this->checkFile('themes/merchants/Midnight_city/currencies_no_data.tpl', 'e3a2a92b3119abe6bca9ce0b0e505c28');
        $this->checkFile('themes/merchants/Midnight_city/currency_form.tpl', 'dbee13da7abe05b10990f7ee89eee4be');
        $this->checkFile('themes/merchants/Midnight_city/currency_textbox.tpl', '080f24de6b380aff2c36890c0c0caf40');
        $this->checkFile('themes/merchants/Midnight_city/custom.css', '4877ef2467745239a93ebe1e79b2f813');
        $this->checkFile('themes/merchants/Midnight_city/custom_cookie_panel.tpl', 'b1b3a9b5c5aa2b7de8e67fa2975bbf0e');
        $this->checkFile('themes/merchants/Midnight_city/custom_date_panel.tpl', 'c624f3d63d0e94db867529dc13a827d1');
        $this->checkFile('themes/merchants/Midnight_city/custom_filter_element.tpl', 'cbc6dbc57fd1831f71759489f15f513e');
        $this->checkFile('themes/merchants/Midnight_city/custom_filter_field.tpl', '21c8ab135d5d89e320ec85456ec457e0');
        $this->checkFile('themes/merchants/Midnight_city/custom_time_panel.tpl', 'd408a8352774d70124788d61a90493b6');
        $this->checkFile('themes/merchants/Midnight_city/daily_report.tpl', 'ae280bf29c298b0a0e28944cc61c9e86');
        $this->checkFile('themes/merchants/Midnight_city/daily_report_filter.tpl', '4fb9b31f01026eb252955d75c0428d99');
        $this->checkFile('themes/merchants/Midnight_city/data_field.tpl', 'dd553594505158cd53cc285d3a91fe23');
        $this->checkFile('themes/merchants/Midnight_city/data_field_with_help.tpl', '4615cdd789beea34c16b4c1f692a3a3b');
        $this->checkFile('themes/merchants/Midnight_city/database_status_panel.tpl', '57191b13eff4abf914143e15b97bac30');
        $this->checkFile('themes/merchants/Midnight_city/date_number_format_panel.tpl', 'e26284328d2ba7da47d30e8e458c13b1');
        $this->checkFile('themes/merchants/Midnight_city/date_preset_panel.tpl', 'abc7d225baa948aed70cc1073b786fe8');
        $this->checkFile('themes/merchants/Midnight_city/date_range_filter.tpl', '3875dbc075f33ccaac856190ee103557');
        $this->checkFile('themes/merchants/Midnight_city/date_range_filter_field.tpl', '94048704212b6797b7b7a08fb7888da9');
        $this->checkFile('themes/merchants/Midnight_city/date_textbox.tpl', '4d2bf89bd754bbaccc15e48d7a37dd02');
        $this->checkFile('themes/merchants/Midnight_city/daterange_popup.tpl', 'dc1728d13b0440b8df5e12359010168a');
        $this->checkFile('themes/merchants/Midnight_city/datetimepickercontent.tpl', '9771684f29bc88d974cc64283055d1d1');
        $this->checkFile('themes/merchants/Midnight_city/deeplink_generator_network_setting_edit.tpl', '818d1c4a3bb685f4cb6e825a2c577d82');
        $this->checkFile('themes/merchants/Midnight_city/default_campaign_form.tpl', '2524ebdb94130b6701af650fb63c9c68');
        $this->checkFile('themes/merchants/Midnight_city/default_theme_config.tpl', 'fd3377e1da30c75e82ed6db948bc9199');
        $this->checkFile('themes/merchants/Midnight_city/description_panel.tpl', 'eb196bc81ac670a6081876c8d17158c0');
        $this->checkFile('themes/merchants/Midnight_city/design_panel.tpl', 'ee823fb6ea6bc06ff8ab43422a986363');
        $this->checkFile('themes/merchants/Midnight_city/desktop.tpl', 'b653025800e416896bd453246061a535');
        $this->checkFile('themes/merchants/Midnight_city/desktop_gadget.tpl', '21394ff13337e4716860c12b5e4fb312');
        $this->checkFile('themes/merchants/Midnight_city/desktop_main_menu.tpl', '31eb02f3f6b767d24012753d50ff5159');
        $this->checkFile('themes/merchants/Midnight_city/desktop_settings_mode.tpl', '1054d3be606383580f8d521f2d72682f');
        $this->checkFile('themes/merchants/Midnight_city/destination.tpl', '3f11435e707dc3ef178328280ef4614e');
        $this->checkFile('themes/merchants/Midnight_city/destination_panel.tpl', 'f8a860741ffc1e8bdd52437db021caaf');
        $this->checkFile('themes/merchants/Midnight_city/direct_link_form.tpl', '021296b8ff10db11432c3429c779c8a6');
        $this->checkFile('themes/merchants/Midnight_city/direct_link_grid_widget.tpl', '586c3b902d66c903d87e510bca5843ec');
        $this->checkFile('themes/merchants/Midnight_city/directlinks_advanced_filter.tpl', '65c2e2150b56faacebc94ec4eb426935');
        $this->checkFile('themes/merchants/Midnight_city/directlinks_list.tpl', '3047fe6b8e221bb3e186190f6eeeeb3f');
        $this->checkFile('themes/merchants/Midnight_city/directlinks_list_no_data.tpl', 'f1f450f7a011578950f7253089286a34');
        $this->checkFile('themes/merchants/Midnight_city/disclosure_content.tpl', '27557135898f8d0dc1ff849cba4f875a');
        $this->checkFile('themes/merchants/Midnight_city/download_auto_reg_banner_form.tpl', '8ef3e7205380f487fa84bc4eaf5f5c63');
        $this->checkFile('themes/merchants/Midnight_city/download_auto_reg_iframe_form.tpl', '59498b35efce960fd3b4871d26d7855b');
        $this->checkFile('themes/merchants/Midnight_city/download_auto_reg_link_form.tpl', '33484bae042f1bde3a5a163eab5570f0');
        $this->checkFile('themes/merchants/Midnight_city/download_login_form.tpl', 'd73ed70f4d96b76f37965d9f8c753ac5');
        $this->checkFile('themes/merchants/Midnight_city/download_signup_form.tpl', 'e608aa9b32b4b044d528815cb9392516');
        $this->checkFile('themes/merchants/Midnight_city/drag_container.tpl', '358104feb6f9c3c2a01206e460726eac');
        $this->checkFile('themes/merchants/Midnight_city/dynamic_form_panel.tpl', 'ea42da62b4a44f1fa9caf50a59c29160');
        $this->checkFile('themes/merchants/Midnight_city/edit_affiliate_page_page.tpl', '367f8d79bdffc8cb0dcc344e2c1c79bd');
        $this->checkFile('themes/merchants/Midnight_city/edit_destination_url_widget.tpl', 'd0918936a67033179b7b41946e54ddb5');
        $this->checkFile('themes/merchants/Midnight_city/edit_textarea_widget.tpl', 'f2df50fdf017a67e8693da0eda5b5373');
        $this->checkFile('themes/merchants/Midnight_city/edit_tracking_code_widget.tpl', '059499fee95c96a9e0fc37b517b0e72a');
        $this->checkFile('themes/merchants/Midnight_city/editor.tpl', 'a8c5483c720526b56fa899a91045c287');
        $this->checkFile('themes/merchants/Midnight_city/editor_with_constants_panel.tpl', '6c9e8d91f33bc90c661e9b67ca5ff1e1');
        $this->checkFile('themes/merchants/Midnight_city/email_form.tpl', '7809f19dc7e837c8dbe6f4d58e6574b7');
        $this->checkFile('themes/merchants/Midnight_city/email_notifications.tpl', '6e8120071227fb823ed1af6f1b3ad223');
        $this->checkFile('themes/merchants/Midnight_city/email_setting_smtp_form.tpl', 'd17124a143f842ab1876ed14a74bc762');
        $this->checkFile('themes/merchants/Midnight_city/email_settings_spf.tpl', 'ca349c37b841ccef522f8767817bf1d2');
        $this->checkFile('themes/merchants/Midnight_city/email_settings_tab.tpl', '029bff75bc5d1d6eda64c14de2c4d88e');
        $this->checkFile('themes/merchants/Midnight_city/email_template_edit_panel.tpl', '0673c3c609ca2fa5a693bcc03986a0d6');
        $this->checkFile('themes/merchants/Midnight_city/expand_matrix.tpl', 'dc72b136436320776269f40795008156');
        $this->checkFile('themes/merchants/Midnight_city/expired_session_dialog.tpl', 'ba711bd5d1e932ffc4fbc8e601204905');
        $this->checkFile('themes/merchants/Midnight_city/export_files_panel.tpl', 'ea4620e2d7d8da656e903d2a1ee80fec');
        $this->checkFile('themes/merchants/Midnight_city/export_panel.tpl', '054b8f0de5cb1cd25ce50d914b6c64a1');
        $this->checkFile('themes/merchants/Midnight_city/export_to_csv.tpl', '472a1e543ad141354022ce9ce4d16e56');
        $this->checkFile('themes/merchants/Midnight_city/extendable_commission_data.tpl', '43b5108a8212bccdb414370023388e10');
        $this->checkFile('themes/merchants/Midnight_city/extendable_text.tpl', 'a69efdb298a3aae26e26793c9b9fea36');
        $this->checkFile('themes/merchants/Midnight_city/extendable_text_content.tpl', 'cca4ebdf72f3cb7638b6c5bf0f59d9aa');
        $this->checkFile('themes/merchants/Midnight_city/extendable_text_widget.tpl', '83288dfd8795a2a9105965dde2ebc927');
        $this->checkFile('themes/merchants/Midnight_city/feature_detail.tpl', 'b23eb80665302207d86365efbef72846');
        $this->checkFile('themes/merchants/Midnight_city/feature_on_activate.tpl', '544374f96c5524c306a5c6f6f956200c');
        $this->checkFile('themes/merchants/Midnight_city/feature_on_deactivate.tpl', 'a1767954af4547adcfb12cf4107f3468');
        $this->checkFile('themes/merchants/Midnight_city/feature_settings.tpl', '13e5f54c1b98e65f9a4132abe613c188');
        $this->checkFile('themes/merchants/Midnight_city/fee_panel.tpl', '6c4f808bd9b75f8fc11e4fce3196994c');
        $this->checkFile('themes/merchants/Midnight_city/field_type_edit.tpl', 'b1294ba5d4486ea1cf8022a51e277a11');
        $this->checkFile('themes/merchants/Midnight_city/file_widget.tpl', 'a7410b3e376c1b177c47831f83a68c55');
        $this->checkFile('themes/merchants/Midnight_city/files_tree_panel.tpl', 'e11e884c210779b572bc928e01cf3d96');
        $this->checkFile('themes/merchants/Midnight_city/filter.tpl', '10de4692c8015c544a44267942cf4017');
        $this->checkFile('themes/merchants/Midnight_city/filter_field_decorator.tpl', '531d57478d7718e216ea04ff79d493ca');
        $this->checkFile('themes/merchants/Midnight_city/filter_form.tpl', '67551720cbc190c8df85c24d3f8a4cbe');
        $this->checkFile('themes/merchants/Midnight_city/font/Roboto/Roboto-Black.ttf', '31d51f54d6fd75795fce785dcad65bea');
        $this->checkFile('themes/merchants/Midnight_city/font/Roboto/Roboto-Black.woff', '23d7e55956013dddec52a7bf4e3b411d');
        $this->checkFile('themes/merchants/Midnight_city/font/Roboto/Roboto-Bold.ttf', '27d971424eb4ddde73416cc6b04e9f30');
        $this->checkFile('themes/merchants/Midnight_city/font/Roboto/Roboto-Bold.woff', '72e37e5bf95a8dba938c78b1d7d91253');
        $this->checkFile('themes/merchants/Midnight_city/font/Roboto/Roboto-Light.ttf', '2f681219c70f2e32a091f1ccd1e072df');
        $this->checkFile('themes/merchants/Midnight_city/font/Roboto/Roboto-Light.woff', '56991a6627087ad081029dc0a64a91e4');
        $this->checkFile('themes/merchants/Midnight_city/font/Roboto/Roboto-Medium.ttf', '9aa5df0dfc4a7d26f1ed59527ed3475f');
        $this->checkFile('themes/merchants/Midnight_city/font/Roboto/Roboto-Medium.woff', 'f4fa50c4003f87e7dc10459e500933c3');
        $this->checkFile('themes/merchants/Midnight_city/font/Roboto/Roboto-Regular.ttf', 'f19e9ae531ffabc1847c2aa8c8e8a75d');
        $this->checkFile('themes/merchants/Midnight_city/font/Roboto/Roboto-Regular.woff', 'fc3d4b35e4d07d4e0485cc2db0e57c77');
        $this->checkFile('themes/merchants/Midnight_city/font/fontello.eot', 'cc4c3813496412813e92ce25c7b963e3');
        $this->checkFile('themes/merchants/Midnight_city/font/fontello.svg', '66090721850d522363f5745b6265983f');
        $this->checkFile('themes/merchants/Midnight_city/font/fontello.ttf', 'baf30392615b9f8dd06420642304e9fb');
        $this->checkFile('themes/merchants/Midnight_city/font/fontello.woff', 'aca17066a8fe19fe88404827ede14eee');
        $this->checkFile('themes/merchants/Midnight_city/font/fontello.woff2', '58f62b369b922e87b001bacc5d4e2274');
        $this->checkFile('themes/merchants/Midnight_city/fontello.css', '7abe36cc2ed0ccbbaad467c15445aa12');
        $this->checkFile('themes/merchants/Midnight_city/footer.stpl', '3fbd103789f1ff2a151c16f490a913dd');
        $this->checkFile('themes/merchants/Midnight_city/forced_matrix_panel.tpl', '0f06e2a7d0482fa847967cd918e0e614');
        $this->checkFile('themes/merchants/Midnight_city/form_field.tpl', '5c7ae4b0f01f4a7753ab811e0a57f29f');
        $this->checkFile('themes/merchants/Midnight_city/form_field_checkbox.tpl', 'c1f1746d1bf5c7abfaf9e5ddb7b4cc52');
        $this->checkFile('themes/merchants/Midnight_city/form_field_checkboxgroup.tpl', 'be1b525a89f033d4f79433dd3eaab593');
        $this->checkFile('themes/merchants/Midnight_city/form_field_radio.tpl', '9013ed97a5fc7b4b52052d816a9b25d0');
        $this->checkFile('themes/merchants/Midnight_city/frame_panel.tpl', '7b13a1add8ba712d8a34f4285414b419');
        $this->checkFile('themes/merchants/Midnight_city/fraud_protection_clicks.tpl', '73301bfff7cb1dd3780e29dbb344c2e5');
        $this->checkFile('themes/merchants/Midnight_city/fraud_protection_form.tpl', 'd0992b66d5f952ca446613a5f74b5f3a');
        $this->checkFile('themes/merchants/Midnight_city/fraud_protection_logins.tpl', '219e554a2a20528c0d83188d36e5cf67');
        $this->checkFile('themes/merchants/Midnight_city/fraud_protection_sales.tpl', 'ebff2d1c8e0f7d6ba3606830cfda484e');
        $this->checkFile('themes/merchants/Midnight_city/fraud_protection_signups.tpl', '11dc6c3dd936cdda2667149211a62a19');
        $this->checkFile('themes/merchants/Midnight_city/full_banner_stats.tpl', '9c8d43347b069c27ac3a1af40909a95e');
        $this->checkFile('themes/merchants/Midnight_city/full_commision_stats.tpl', '267321735038275c392ddf30a5c4d35d');
        $this->checkFile('themes/merchants/Midnight_city/full_payout_stats.tpl', '6c5e691e6069884d5d1be146054c14dd');
        $this->checkFile('themes/merchants/Midnight_city/full_transaction_stats.tpl', '2669b46d3f14aa9c57872f5373c2797d');
        $this->checkFile('themes/merchants/Midnight_city/general_no_data.stpl', '03433ae7bf79c177a476922c2ee779c5');
        $this->checkFile('themes/merchants/Midnight_city/generate_coupons_form.tpl', 'beddaaf1aa37c10aab9838f1c4b8f1e8');
        $this->checkFile('themes/merchants/Midnight_city/generate_htaccess.tpl', '05d9d8606bdf35455fb48ec7f928b702');
        $this->checkFile('themes/merchants/Midnight_city/geoip_commissiontype_detailpanel.tpl', '734dc6f1a0cc432cd287f22ef5824f49');
        $this->checkFile('themes/merchants/Midnight_city/geoip_fraudprotection_affiliates.tpl', '8fadf652ac9ea3507a4a6173faf8eb62');
        $this->checkFile('themes/merchants/Midnight_city/geoip_fraudprotection_clicks.tpl', 'db19ca033fb30646f0ae504d43683c92');
        $this->checkFile('themes/merchants/Midnight_city/geoip_fraudprotection_logins.tpl', '660ab5115a24ae974e9739dde8530d30');
        $this->checkFile('themes/merchants/Midnight_city/geoip_fraudprotection_logins_aff.tpl', 'af98bdbc38201d8c9db2d63c83ccdf9d');
        $this->checkFile('themes/merchants/Midnight_city/geoip_fraudprotection_sales.tpl', 'c2c170214c10ba59d591261e85dc4cff');
        $this->checkFile('themes/merchants/Midnight_city/get_pdf.tpl', '7de69c1b98a6f1cac1f9c8e570e3b6b9');
        $this->checkFile('themes/merchants/Midnight_city/getting_started_icons.tpl', '612e44ecb9bc1526bd8694a0655342bf');
        $this->checkFile('themes/merchants/Midnight_city/getting_started_merchant.tpl', '9f02ac92cddb211fce5fb826fe7473e5');
        $this->checkFile('themes/merchants/Midnight_city/google_recaptcha_settings.tpl', 'b93feccb5cdfccc02846aea495459127');
        $this->checkFile('themes/merchants/Midnight_city/gpf.css', 'ec27b549fa06e9420afb4e6d56ee3a96');
        $this->checkFile('themes/merchants/Midnight_city/gpf_db_mail.tpl', 'b5ea5e9ecef2152fdf967085a7689adc');
        $this->checkFile('themes/merchants/Midnight_city/grid.tpl', 'c0efa81ea11d739f933438236d6fb12d');
        $this->checkFile('themes/merchants/Midnight_city/grid_bottombuttons.tpl', '1aa9463da984fac10b988d8758c82297');
        $this->checkFile('themes/merchants/Midnight_city/grid_bottomgridline.tpl', '9bf2013a170e094e82dc1ae0a2ed0f97');
        $this->checkFile('themes/merchants/Midnight_city/grid_nodata.tpl', '340ff6de789cd7277a35d763f6366f24');
        $this->checkFile('themes/merchants/Midnight_city/grid_pager.tpl', '46e6d959616563985ece2d92c0234826');
        $this->checkFile('themes/merchants/Midnight_city/grid_selector.tpl', 'ff2d81e3866f53d540a0d063bdf7b480');
        $this->checkFile('themes/merchants/Midnight_city/grid_topbuttons.tpl', 'b605a4f548962d4bf0c8d8662353b795');
        $this->checkFile('themes/merchants/Midnight_city/grid_topgridline.tpl', '3ff9c43cb7f7fcbbcdc7f03c8822a70d');
        $this->checkFile('themes/merchants/Midnight_city/header.tpl', '32d459ea9f7ebf7a241715058cc91f38');
        $this->checkFile('themes/merchants/Midnight_city/home_edit.tpl', '1e659b8ee09e43c02d567356206c7c93');
        $this->checkFile('themes/merchants/Midnight_city/home_edit_main_template.tpl', 'cd4fbd7e59c2c1813b4b1c9d54025223');
        $this->checkFile('themes/merchants/Midnight_city/home_edit_merch_template.tpl', '1079945929a23a68a38676fe78432211');
        $this->checkFile('themes/merchants/Midnight_city/home_panel.tpl', '1404c1c1a5f5048ce23760ddd33a49b3');
        $this->checkFile('themes/merchants/Midnight_city/home_panel_content.stpl', 'c8265cd85552ee1a86a68214b000cc2b');
        $this->checkFile('themes/merchants/Midnight_city/horizontal_layout_panel.tpl', '8b6098cd64720cff686cc24e06ac4c17');
        $this->checkFile('themes/merchants/Midnight_city/hosted_account.tpl', 'e58e46daeeb498d85227982e6ee6ae2d');
        $this->checkFile('themes/merchants/Midnight_city/hosted_account_plan.tpl', 'bfb67b63d21a4482e2528a4fb581629c');
        $this->checkFile('themes/merchants/Midnight_city/htaccess_panel.tpl', 'b3632f76f8ab6d2e56f7a776401dedaf');
        $this->checkFile('themes/merchants/Midnight_city/html_preview.tpl', '08392603f2252347986bb4b341e964dd');
        $this->checkFile('themes/merchants/Midnight_city/html_preview_iframe_panel.tpl', '22405951702ab2132d0fe99577f4968e');
        $this->checkFile('themes/merchants/Midnight_city/html_preview_image_panel.tpl', 'ebc5b8605c42ac31f653b65deb66e04d');
        $this->checkFile('themes/merchants/Midnight_city/icon_button.tpl', 'a7497a39fe733586fb4f5a1b9f424b0f');
        $this->checkFile('themes/merchants/Midnight_city/icon_object.tpl', 'ff8d25e63eca03b325c4501e13358fb2');
        $this->checkFile('themes/merchants/Midnight_city/icon_picker.tpl', '77a002b90f678df44bcca5776f314820');
        $this->checkFile('themes/merchants/Midnight_city/icon_picker_panel.tpl', '4342c424a8cb290701f64d0cb63655ec');
        $this->checkFile('themes/merchants/Midnight_city/icon_status_widget.tpl', 'ff9e2bc87e203324cc33c4b3ac365dfe');
        $this->checkFile('themes/merchants/Midnight_city/icons_panel_with_header.tpl', '97091a954a48c0889fa82a2464266e84');
        $this->checkFile('themes/merchants/Midnight_city/image_uploader.tpl', '9f93ea577dd2511b19071fa735b6b684');
        $this->checkFile('themes/merchants/Midnight_city/img/FB_share_button.png', 'a56c7efd784eb61b5ac1e6f4111f59a8');
        $this->checkFile('themes/merchants/Midnight_city/img/LinkedIn_share_button.png', 'd0dfb70a7e64ee73f718af05ce995875');
        $this->checkFile('themes/merchants/Midnight_city/img/cards.jpg', '36a8e2ad3f39a4c9c71c8abbcec24823');
        $this->checkFile('themes/merchants/Midnight_city/img/cron_job_example.png', 'f0cd89597b814b000ef2775c2f9dea1b');
        $this->checkFile('themes/merchants/Midnight_city/img/favicon.ico', 'ac3e93c93589318e5dcf69efc8a76176');
        $this->checkFile('themes/merchants/Midnight_city/img/icon-128.png', 'a450a0dd5959518fdb2308cc5e523bcc');
        $this->checkFile('themes/merchants/Midnight_city/img/icon-192.png', '8cb72062e4df9eab6c2a064459a5ee62');
        $this->checkFile('themes/merchants/Midnight_city/img/pan-logo.svg', 'a19c0ad7bfad0399a0f82599a571db9a');
        $this->checkFile('themes/merchants/Midnight_city/img/pap-logo.svg', '6280dc47fe440c1c1c3af00cc27f1ced');
        $this->checkFile('themes/merchants/Midnight_city/img/paypal.jpg', '1e18c3feef21be6605c97f5ac72e7453');
        $this->checkFile('themes/merchants/Midnight_city/img/secure.png', '4490e30d2ac3700e78315f510dfff342');
        $this->checkFile('themes/merchants/Midnight_city/img/theme_thumbnail.jpg', 'd2bef367eaee14e26d706f61aeeaacdd');
        $this->checkFile('themes/merchants/Midnight_city/import_coupons_form.tpl', '8fc3b5964331ebd6232227b4f8fa937d');
        $this->checkFile('themes/merchants/Midnight_city/import_custom_language_panel.tpl', 'f14fe8af188194edeb7896eb3284c5b1');
        $this->checkFile('themes/merchants/Midnight_city/import_export_panel.tpl', '7562d00dfa6c2eb770a88757ba736996');
        $this->checkFile('themes/merchants/Midnight_city/import_language.tpl', '20d22e5e6eebf43dc6143490803aaa03');
        $this->checkFile('themes/merchants/Midnight_city/import_panel.tpl', 'd8370787bb8f6d6e702c72ed8f7a744d');
        $this->checkFile('themes/merchants/Midnight_city/import_theme_panel.tpl', '5fbd6be91a3a7dbf7b2def44f344b889');
        $this->checkFile('themes/merchants/Midnight_city/info_dialog.tpl', '886c377f8e8c1b2c6957451436e1d090');
        $this->checkFile('themes/merchants/Midnight_city/integration.tpl', '939839cb552c71fdcb243c4a34aa35ee');
        $this->checkFile('themes/merchants/Midnight_city/integration_method.tpl', 'cfdd3053443ce85b757a89dc64ddd45e');
        $this->checkFile('themes/merchants/Midnight_city/integration_method_step.tpl', '4661c951290cf670ee9c26b45fff0a8c');
        $this->checkFile('themes/merchants/Midnight_city/integration_methods.tpl', 'f5f0fe244869bc5da0517349aba9d291');
        $this->checkFile('themes/merchants/Midnight_city/integration_methods_advanced.tpl', '0e72005d09820e3a2f057ea3c71cb7a7');
        $this->checkFile('themes/merchants/Midnight_city/invoice_data_panel.tpl', '1ac898a59516e468e0f047d97db210c6');
        $this->checkFile('themes/merchants/Midnight_city/invoice_form.tpl', '62a0cbc7e109fc019bcc00457b556594');
        $this->checkFile('themes/merchants/Midnight_city/invoices_filter.tpl', '77faa6e4fbeb2cc872a975a1800fa6a7');
        $this->checkFile('themes/merchants/Midnight_city/invoices_list.tpl', '4ee98efc16f05c766be1ae760cc3837c');
        $this->checkFile('themes/merchants/Midnight_city/ip_detail.tpl', '4db34e70c575a3c8ead55d15c486599a');
        $this->checkFile('themes/merchants/Midnight_city/item.tpl', '717eff0e06a712a76effb2d6723183b5');
        $this->checkFile('themes/merchants/Midnight_city/item_panel.tpl', 'b24ed05bdf4cb76a7afc1e9a9908def8');
        $this->checkFile('themes/merchants/Midnight_city/keywords_performance.tpl', '0a76bec58708a4041df21ab9548abadc');
        $this->checkFile('themes/merchants/Midnight_city/keywords_performance_advanced_filter.tpl', '618269ec4149b6ffab19282eb9d1a2c5');
        $this->checkFile('themes/merchants/Midnight_city/label_panel.tpl', 'e0c85a01af8477fe16cb6770fbb5e7af');
        $this->checkFile('themes/merchants/Midnight_city/language_create_new.tpl', '486f695b2fe3d17aaf29ae39e7f7e0ea');
        $this->checkFile('themes/merchants/Midnight_city/language_edit_panel.tpl', '5b8d472500f9e38a967306d007409d1f');
        $this->checkFile('themes/merchants/Midnight_city/language_translations_filter.tpl', '930f22e595469a617570927021bf9d15');
        $this->checkFile('themes/merchants/Midnight_city/language_translations_grid.tpl', 'a4247bb921179c395cf7a2972cbcef3f');
        $this->checkFile('themes/merchants/Midnight_city/languages_configuration.tpl', 'a146b693cd6b18b1f7711d750e444175');
        $this->checkFile('themes/merchants/Midnight_city/layout_panel_content.tpl', '353b904baf333a2e0456ef5cb0fa179c');
        $this->checkFile('themes/merchants/Midnight_city/layout_panel_header_navigation.tpl', '6b0d746501001da8615a22d57266dcb0');
        $this->checkFile('themes/merchants/Midnight_city/layout_panel_tab.tpl', '27ee274cfd12ed770eff98d0913dd8e8');
        $this->checkFile('themes/merchants/Midnight_city/license_invalid.tpl', '6181e1127345050c94d6708cd805aefb');
        $this->checkFile('themes/merchants/Midnight_city/lifetime_referral_edit.tpl', '3d3923ef67ea430835a1f951955543b2');
        $this->checkFile('themes/merchants/Midnight_city/lifetime_referrals_filter.tpl', 'dcac6d377be0092c4fbf75b5ff6824e8');
        $this->checkFile('themes/merchants/Midnight_city/lifetime_referrals_import.tpl', '402219176174a0ed91b952fa0527bfab');
        $this->checkFile('themes/merchants/Midnight_city/lifetime_referrals_panel.tpl', '57fdc30f1434427f31e456701817165a');
        $this->checkFile('themes/merchants/Midnight_city/link_button.tpl', '71fad92bff79f1fd2e1066818afac789');
        $this->checkFile('themes/merchants/Midnight_city/link_method_panel.tpl', '9af6c599de2f311cb0149524b50ff20d');
        $this->checkFile('themes/merchants/Midnight_city/linking_method.tpl', '7e0919bff0810701acf299531e0ef0eb');
        $this->checkFile('themes/merchants/Midnight_city/listbox.tpl', '2739c2a9e22d54280cacf4d67ed2e7bc');
        $this->checkFile('themes/merchants/Midnight_city/listbox_popup.tpl', '8c45877411c0727e814eb5e3caa76822');
        $this->checkFile('themes/merchants/Midnight_city/listdown_button.tpl', 'a1cd26a1aec6d403420971d7469a6f1b');
        $this->checkFile('themes/merchants/Midnight_city/lite_campaign_wizard.tpl', 'eaa5d01dd5deee48986f5f98f22caf40');
        $this->checkFile('themes/merchants/Midnight_city/load_mail_from_template.tpl', '42c0029422eaf077a5b0c316cd3317b5');
        $this->checkFile('themes/merchants/Midnight_city/loadable_tree.tpl', 'e2c214b134bffe5fe2bb38f679a64eb5');
        $this->checkFile('themes/merchants/Midnight_city/loading_screen.tpl', '34ccb2c18cf3ba7225b2107a1c6a8002');
        $this->checkFile('themes/merchants/Midnight_city/log_filter.tpl', '7f09ae6ce70590ead04d534e6019fca9');
        $this->checkFile('themes/merchants/Midnight_city/log_list.tpl', '17f5cd218930723c21afa914b4fee8fe');
        $this->checkFile('themes/merchants/Midnight_city/logging_tab.tpl', 'bbe2b73c70c24bbafb56a75ed4279f81');
        $this->checkFile('themes/merchants/Midnight_city/logging_tab_debug.tpl', '32912cc60dfc885333623335a44ab19c');
        $this->checkFile('themes/merchants/Midnight_city/logging_tab_logins_history.tpl', 'e59ce588474c4019a05eafd91c45bd2c');
        $this->checkFile('themes/merchants/Midnight_city/login.tpl', 'e7be8367104ee7221547730250f9b0f0');
        $this->checkFile('themes/merchants/Midnight_city/login_form.tpl', '68fec5fc89be1ee473d62ac966211289');
        $this->checkFile('themes/merchants/Midnight_city/login_main.tpl', '5b3eb0529047463ac6b90a529de64d85');
        $this->checkFile('themes/merchants/Midnight_city/logins_history.tpl', '1ef6edb0f2167b8d05c961c7d6379f92');
        $this->checkFile('themes/merchants/Midnight_city/loginshistory_filter.tpl', '6fa20923cc33142105a51ef6f3a51ad7');
        $this->checkFile('themes/merchants/Midnight_city/logo_settings.tpl', '6c5dbe6195a7b19dd0e0dcb58a207523');
        $this->checkFile('themes/merchants/Midnight_city/logs_no_data.tpl', 'c807c1484862c46a3f72f1ea0d276b3f');
        $this->checkFile('themes/merchants/Midnight_city/mail_detail_data.tpl', '72d679a44b2ad0f888e829b479e6550e');
        $this->checkFile('themes/merchants/Midnight_city/mail_outbox_panel.tpl', 'fa6291a64c1e5a21237be44f192a8c99');
        $this->checkFile('themes/merchants/Midnight_city/mail_template_not_selected.tpl', '8f8e4d19a09cd7bc7e96df0e0729ef8d');
        $this->checkFile('themes/merchants/Midnight_city/mail_template_preview.tpl', 'ea7d0df5aef2645e05d768c51a294389');
        $this->checkFile('themes/merchants/Midnight_city/mail_template_test_form.tpl', 'd5c10c451945fe2cd1545ab10c11a959');
        $this->checkFile('themes/merchants/Midnight_city/mail_templates.tpl', 'cceaeaa496bd10868bcf67ef9f9acc45');
        $this->checkFile('themes/merchants/Midnight_city/mail_templates_list.tpl', '2834084fc2e4bef6ffd06fd86a650a17');
        $this->checkFile('themes/merchants/Midnight_city/mailoutbox_filter.tpl', '59f66fe33f07d333de586095367ca23d');
        $this->checkFile('themes/merchants/Midnight_city/mailoutbox_list_no_data.tpl', '12637515858ca4d960c6202e8a89042b');
        $this->checkFile('themes/merchants/Midnight_city/main.tpl', 'd36ba24c62ed647cce99c949744e7a0a');
        $this->checkFile('themes/merchants/Midnight_city/main_error_html_doc.tpl', '352d89f5f9190954ea3a357fb239379b');
        $this->checkFile('themes/merchants/Midnight_city/main_filter_panel.tpl', '0985a7421f898d75d4df72b4a6081c49');
        $this->checkFile('themes/merchants/Midnight_city/main_html_doc.tpl', '7c85935f6e55aa3de5dba437142040db');
        $this->checkFile('themes/merchants/Midnight_city/main_integration_steps_icons.tpl', '2107115d75013a0ad392566bb3fa1d54');
        $this->checkFile('themes/merchants/Midnight_city/main_menu.tpl', '1036ce189dc092adca21d6405e83544f');
        $this->checkFile('themes/merchants/Midnight_city/map_overlay.tpl', '9deb511a7295d19349480562f6771d87');
        $this->checkFile('themes/merchants/Midnight_city/map_overlay_advanced_filter.tpl', '37c42e9179e92fed26eee607e9ebe5b1');
        $this->checkFile('themes/merchants/Midnight_city/map_overlay_edit.tpl', 'd173ac586a3502e61f80a956597e1496');
        $this->checkFile('themes/merchants/Midnight_city/mass_pay_export.tpl', 'c90a423ab30d28f949c8ce738bab8375');
        $this->checkFile('themes/merchants/Midnight_city/menu_entry.tpl', '9245aaaa5732793ce089f5fe25d703ea');
        $this->checkFile('themes/merchants/Midnight_city/menu_section.tpl', 'cec8b58c248868d64eaddc18923f7743');
        $this->checkFile('themes/merchants/Midnight_city/merchant_category_info.tpl', 'ecf110e07235298eb0403fdb6c8a1448');
        $this->checkFile('themes/merchants/Midnight_city/merchant_tutorial_video.tpl', 'ce8d0f0aad10353b46888942abfb96e5');
        $this->checkFile('themes/merchants/Midnight_city/messages.tpl', 'bf1a3bac08c419320acb94673ad29f0b');
        $this->checkFile('themes/merchants/Midnight_city/module_body.stpl', 'c079addcd33eb725ab7efbf09c16a793');
        $this->checkFile('themes/merchants/Midnight_city/month_banner_stats.tpl', 'fc0ecc72cbc42efa3835713eebcf8d4f');
        $this->checkFile('themes/merchants/Midnight_city/multi_editor.tpl', '6cd4d8823bd6b67cd3e0a2aa2cf52b29');
        $this->checkFile('themes/merchants/Midnight_city/multi_form_widget.tpl', '3f92d96633ec487b28dc6bfae7cc8e30');
        $this->checkFile('themes/merchants/Midnight_city/multiple_currencies_panel.tpl', 'c7b959fe11ad02a2fcbe22f5f62d344b');
        $this->checkFile('themes/merchants/Midnight_city/multiselect.tpl', '9d1863b21edd131520315ce252fde639');
        $this->checkFile('themes/merchants/Midnight_city/network_invoice.tpl', 'da2d8c12f409758081a229e78c1306fe');
        $this->checkFile('themes/merchants/Midnight_city/network_proforma_invoice.tpl', '5f9dcea372e00363e6dc2ffbdd5a8187');
        $this->checkFile('themes/merchants/Midnight_city/news_content.tpl', 'a576598444bb0db20fa8d47854f1ef34');
        $this->checkFile('themes/merchants/Midnight_city/news_filter.tpl', '59508e33dc1a696ffa5a18d5f619eedd');
        $this->checkFile('themes/merchants/Midnight_city/news_form_edit.tpl', '517272eac91c024292fe594cecae2c28');
        $this->checkFile('themes/merchants/Midnight_city/news_item.tpl', '18161a56a8f4dc5df01f08191709f864');
        $this->checkFile('themes/merchants/Midnight_city/news_list.tpl', 'f37df45ddce385805e34da5d81b17a1f');
        $this->checkFile('themes/merchants/Midnight_city/news_panel.tpl', '0e6eda2d6e6edab31d596d86939f0933');
        $this->checkFile('themes/merchants/Midnight_city/newsletter_broadcast_form.tpl', '1ccb4e8c2a3873263c7c8c1fc7c19f27');
        $this->checkFile('themes/merchants/Midnight_city/newsletter_broadcasts.tpl', 'e85ba6dc04b3a921af601f6bf976a5b8');
        $this->checkFile('themes/merchants/Midnight_city/newsletter_edit_panel.tpl', '73ddca2129beb12e11215b1c55e70461');
        $this->checkFile('themes/merchants/Midnight_city/newsletter_form.tpl', 'e86bb366b8986ac4cb1b50c9ccc94b8e');
        $this->checkFile('themes/merchants/Midnight_city/no_category_selected_settings_panel.tpl', '28bc9d284f2cbec3dde908dc0d4e9f7c');
        $this->checkFile('themes/merchants/Midnight_city/no_content_gadgets.tpl', '1d4ce600d473f33e2b229101a50cbc3f');
        $this->checkFile('themes/merchants/Midnight_city/no_language_selected.tpl', 'd61125f2b1cf78e4e66653d4e2f04bdd');
        $this->checkFile('themes/merchants/Midnight_city/note_filter.tpl', '5984797bddb6b9dff4b4066106da1bcf');
        $this->checkFile('themes/merchants/Midnight_city/notification_window.tpl', 'db781872bdb9748bc838e051b8e5e4e2');
        $this->checkFile('themes/merchants/Midnight_city/offline_sale.tpl', '589eb1238aac5800197e6e56a26cacf7');
        $this->checkFile('themes/merchants/Midnight_city/offline_sale_form.tpl', '86fe26a2a1e02d811e892233db9d6b5e');
        $this->checkFile('themes/merchants/Midnight_city/online_users.tpl', '1242aa25d7ed7b3a278684e0d4a13c4c');
        $this->checkFile('themes/merchants/Midnight_city/online_users_gadget_rolecount.tpl', '5fd6af0c5f2edec24d0e35dc00a9e870');
        $this->checkFile('themes/merchants/Midnight_city/online_users_gadget_template.tpl', '80ebdfe2a212375942cac09081e371b2');
        $this->checkFile('themes/merchants/Midnight_city/onlinegadgets_no_data.tpl', 'f5f692a433b4911963a92c41cc269768');
        $this->checkFile('themes/merchants/Midnight_city/onlineusers_filter.tpl', 'a5ec412a7f620cb47ddcf48b9f0d6625');
        $this->checkFile('themes/merchants/Midnight_city/order_id_filter.tpl', 'e3b95af73c9456fd1cc3d3ecf3814ea2');
        $this->checkFile('themes/merchants/Midnight_city/orgchart_affiliate_widget.tpl', '32f4faf30d0289ffd4c9d53f92a39388');
        $this->checkFile('themes/merchants/Midnight_city/overview_panel.tpl', '1874d6377cb2a53e5eba387cd0874215');
        $this->checkFile('themes/merchants/Midnight_city/overview_stats_panel.tpl', '674d3c5e07dddbfcc6b89bfa7b420640');
        $this->checkFile('themes/merchants/Midnight_city/page_header.tpl', '4fd5676c44341f95ee0435c1f78da534');
        $this->checkFile('themes/merchants/Midnight_city/page_type_radio.tpl', 'd132376c54a57b3962d1ca08eda22000');
        $this->checkFile('themes/merchants/Midnight_city/panel_footer.stpl', '9ac4165a950d1760c4b0ed086c71788e');
        $this->checkFile('themes/merchants/Midnight_city/pap4.css', 'e2d8bc617168d057b75d3686c7839c3c');
        $this->checkFile('themes/merchants/Midnight_city/pap4.rtl.css', '5b1760b7cdc19c1a21288eb703c9d50d');
        $this->checkFile('themes/merchants/Midnight_city/parameter_names_form.tpl', '32bfa373ae61cdae7c70a202ba921e62');
        $this->checkFile('themes/merchants/Midnight_city/password_constraint_panel.tpl', '6d328bcd04ea68b87c18d4fd52099888');
        $this->checkFile('themes/merchants/Midnight_city/password_panel.tpl', 'b1440553a785aae589233a91315b281f');
        $this->checkFile('themes/merchants/Midnight_city/pay_affilates_form.tpl', '47ca863e6f0e46c4b2e631d2ebd313f0');
        $this->checkFile('themes/merchants/Midnight_city/pay_affiliate_template.tpl', '692261c025aab9b05408b9651de9a894');
        $this->checkFile('themes/merchants/Midnight_city/pay_affiliates.tpl', '9a08ef03ed4b0d076203c45c369918d1');
        $this->checkFile('themes/merchants/Midnight_city/pay_affiliates_filter.tpl', 'b614af81b7bae93abeec49415de0f758');
        $this->checkFile('themes/merchants/Midnight_city/pay_affiliates_list.tpl', '85b17725f87d1ea59102020c1f290070');
        $this->checkFile('themes/merchants/Midnight_city/pay_affiliates_no_data.tpl', 'bdd593288f13c714bdb19de5d264318c');
        $this->checkFile('themes/merchants/Midnight_city/pay_invoice_form.tpl', 'c7490c619a883b6b90c2817b22025984');
        $this->checkFile('themes/merchants/Midnight_city/payee_info.tpl', '740af57f0054d67e6c689466e90980d8');
        $this->checkFile('themes/merchants/Midnight_city/payee_info_main.tpl', '8048bb0c734d26af0a077e1728b2e814');
        $this->checkFile('themes/merchants/Midnight_city/payout_data.tpl', 'b6f6f6c19617690d683128ee13b8b688');
        $this->checkFile('themes/merchants/Midnight_city/payout_fields_form.tpl', '0f8a8b9516b729ab4899926ead42be16');
        $this->checkFile('themes/merchants/Midnight_city/payout_fields_no_data.tpl', '22728157d2ebba66c42b8632edcc2eee');
        $this->checkFile('themes/merchants/Midnight_city/payout_history_form.tpl', 'fdf50ed31df6ef2a90efc52c043f13f8');
        $this->checkFile('themes/merchants/Midnight_city/payout_history_list_no_data.tpl', 'eaea8ff071a4da8272b5b57616544789');
        $this->checkFile('themes/merchants/Midnight_city/payout_history_template.tpl', '94edd75586374bd10a9e765ceb78e910');
        $this->checkFile('themes/merchants/Midnight_city/payout_invoice_format.tpl', 'c33ad82f202fb7fc45f83d2c8d547efa');
        $this->checkFile('themes/merchants/Midnight_city/payout_methods_filter_field.tpl', '3e44e83bdfd9080f05070dd2281dcfd2');
        $this->checkFile('themes/merchants/Midnight_city/payout_option_form.tpl', '309c28785f0a1aa14ded20d7037c6d3e');
        $this->checkFile('themes/merchants/Midnight_city/payout_options_form.tpl', '747bdbfe5eca6068d61275e19f4472a4');
        $this->checkFile('themes/merchants/Midnight_city/payout_options_no_data.tpl', '19f1bead958da75d50d38d893f93f4e1');
        $this->checkFile('themes/merchants/Midnight_city/payout_options_text_box.tpl', '9d7c675a676c204bafaa2c1f32b3f6a4');
        $this->checkFile('themes/merchants/Midnight_city/payout_settings_icons.tpl', 'aa4813c156afb53ed10a02319166c340');
        $this->checkFile('themes/merchants/Midnight_city/payouts_balance_form.tpl', 'd01274716d5700a7180cd8277b575cb0');
        $this->checkFile('themes/merchants/Midnight_city/payouts_balance_settings.tpl', '61c8ca2e6971fef86250e0b1a3adcb41');
        $this->checkFile('themes/merchants/Midnight_city/payouts_history.tpl', '8a1c74d4f1312a63ceee7907076e2d45');
        $this->checkFile('themes/merchants/Midnight_city/payouts_history_filter.tpl', '49514d217f0a77dcd9cbae68ab504e38');
        $this->checkFile('themes/merchants/Midnight_city/payouts_to_affiliates.tpl', '6e8868d55f61a825057b3890e0ec4afd');
        $this->checkFile('themes/merchants/Midnight_city/payouts_to_affiliates_filter.tpl', '06f0e81d2ad6a474fb81ccaef755477d');
        $this->checkFile('themes/merchants/Midnight_city/payoutstoaffiliates_list_no_data.tpl', '1bf1e39b51797acb2bac6428dabb0929');
        $this->checkFile('themes/merchants/Midnight_city/peel_banner_feature_on_deactivate.tpl', '88a989ccfb54f68203c01176a104541f');
        $this->checkFile('themes/merchants/Midnight_city/pending_backround_tasks.tpl', '9c91e4d0f413f7d7327783449c4222d7');
        $this->checkFile('themes/merchants/Midnight_city/pending_tasks.tpl', '3aa9f9ee68b7ef3258fe7a9c3994f952');
        $this->checkFile('themes/merchants/Midnight_city/pending_tasks_data.tpl', '1916b1db72af25350e122542f2261eb3');
        $this->checkFile('themes/merchants/Midnight_city/pending_tasks_panel.tpl', '16eaedf4545a03d89f94b98e3adacfa4');
        $this->checkFile('themes/merchants/Midnight_city/pending_tasks_template.tpl', '091fb315fbb9a3d24bf16baa791bd32f');
        $this->checkFile('themes/merchants/Midnight_city/performance_rewards.tpl', 'e6376beacf92f7086e4cf7b1a3e97d29');
        $this->checkFile('themes/merchants/Midnight_city/performance_rewards_filter.tpl', 'daf43de0e8c03e9a97f0aaf22b173461');
        $this->checkFile('themes/merchants/Midnight_city/placement_overview_filter.tpl', '6132598add92f772fb46568f94f0e5cc');
        $this->checkFile('themes/merchants/Midnight_city/placement_overview_panel.tpl', 'd0d0bef4390bbf53b43e4207aba245f3');
        $this->checkFile('themes/merchants/Midnight_city/plugin_configuration.tpl', '9f4b075baf454033271fc4219c272737');
        $this->checkFile('themes/merchants/Midnight_city/plugin_detail.tpl', '097b49ceeac4111d1fd96f3cd8d2b049');
        $this->checkFile('themes/merchants/Midnight_city/plugins_list.tpl', '72c87aa08ebd9a6218fcb300d6ec675c');
        $this->checkFile('themes/merchants/Midnight_city/popup_actions_panel.tpl', 'ef01a0f4fa742fc99a03632e1d6876b4');
        $this->checkFile('themes/merchants/Midnight_city/popup_form_widget.tpl', '0f5d2ef3d678d026df06fe1f1e5991a8');
        $this->checkFile('themes/merchants/Midnight_city/postsignup_radio.tpl', '6b32ad7886413081192c2ba5dd514275');
        $this->checkFile('themes/merchants/Midnight_city/postsignup_settings_page.tpl', '3657e859769d3db637b6a83e45ab218d');
        $this->checkFile('themes/merchants/Midnight_city/postsignup_settings_url.tpl', 'c854a3cb764d4be9af656abf45398193');
        $this->checkFile('themes/merchants/Midnight_city/private_campaigns_feature_on_deactivate.tpl', 'ecef84105dc2779ac2fb428da2e9f25f');
        $this->checkFile('themes/merchants/Midnight_city/proxy_server_configuration.tpl', '618f166a4be6b32f563aaeffd5f1931e');
        $this->checkFile('themes/merchants/Midnight_city/qualityunit_news.stpl', '188a98161e9218eb440aab2d33341a0c');
        $this->checkFile('themes/merchants/Midnight_city/quick_report_base.tpl', '03394fc9a529f4d9d13f8cbcb664be8f');
        $this->checkFile('themes/merchants/Midnight_city/quick_report_content.stpl', 'a75ca3ba3fc385de73eae7311f79c650');
        $this->checkFile('themes/merchants/Midnight_city/quick_report_content_multitier.stpl', 'e45556a573992274576437d9d34bdd71');
        $this->checkFile('themes/merchants/Midnight_city/quick_report_filter_base.tpl', '40541d4b075161fc37bea2086e429e23');
        $this->checkFile('themes/merchants/Midnight_city/quick_report_multitier_widget.tpl', '24108ad66b123214ae2c170aaa4ec369');
        $this->checkFile('themes/merchants/Midnight_city/quick_stats_actions_panel.tpl', 'd0816b90a3fbe4f4ffa09a37aec14268');
        $this->checkFile('themes/merchants/Midnight_city/quick_stats_box.tpl', '745d64595b8a0e5869bfc1e9bf10b9c2');
        $this->checkFile('themes/merchants/Midnight_city/quicklaunch_settings.tpl', '1e595ebaeb4364f173ee3fec71c1762d');
        $this->checkFile('themes/merchants/Midnight_city/radio_button_group_row.tpl', '3713f6d400aa1ca96d9e404082304912');
        $this->checkFile('themes/merchants/Midnight_city/radio_form_panel.tpl', 'c56091f134178fc494aa76df1b6ad6a1');
        $this->checkFile('themes/merchants/Midnight_city/rebrand_pdf_feature_on_deactivate.tpl', '57adefe6824afba7c2477b79c5663843');
        $this->checkFile('themes/merchants/Midnight_city/recaptcha_settings.tpl', 'd40a2e0759211b13af22180aef80b380');
        $this->checkFile('themes/merchants/Midnight_city/recipients.tpl', '6c334400d00281b1b04bfc28c654f2a3');
        $this->checkFile('themes/merchants/Midnight_city/recurring_commission_edit.tpl', 'f144dcac07b3913bb6dfb866e4871d9d');
        $this->checkFile('themes/merchants/Midnight_city/recurring_commission_filter.tpl', 'bd70625a017204c62a4563c92cb72e72');
        $this->checkFile('themes/merchants/Midnight_city/recurring_commission_list.tpl', 'b6d7546e3e8ef3fafa122019d01531f8');
        $this->checkFile('themes/merchants/Midnight_city/recurring_commissions.tpl', '8c806617d38c467e2f29e22bb43e826c');
        $this->checkFile('themes/merchants/Midnight_city/referringurl_advanced_filter.tpl', 'e064d6689bc281e60c830c70acd8f3c3');
        $this->checkFile('themes/merchants/Midnight_city/refresh_panel.tpl', '5c709df4d219d5feb4f29003ca932f77');
        $this->checkFile('themes/merchants/Midnight_city/regional_settings.tpl', '899786b4a8c655defc732008fae917e7');
        $this->checkFile('themes/merchants/Midnight_city/regional_settings_tab.tpl', '808fee97d86d7a2400d4e4de198359dc');
        $this->checkFile('themes/merchants/Midnight_city/replicated_site_source_radio.tpl', '7d280f4647e9269bca20b70e4e64d077');
        $this->checkFile('themes/merchants/Midnight_city/report_filter.tpl', 'cfa31cd337c81b3e863f97b664581327');
        $this->checkFile('themes/merchants/Midnight_city/report_problems.tpl', '6c4035620c09202f2165e94e99635ceb');
        $this->checkFile('themes/merchants/Midnight_city/reports_screen.tpl', '7ec70fbbc8d7b81b1a98c932ea1c1267');
        $this->checkFile('themes/merchants/Midnight_city/request_new_password_form.tpl', 'e4e20e8042328f80b7b400e39d921986');
        $this->checkFile('themes/merchants/Midnight_city/resizable_text_area.tpl', '7995c217048ccd289dfee567a455b08e');
        $this->checkFile('themes/merchants/Midnight_city/richlistbox.tpl', '13229a43763945932dc8d5d7fa21d08e');
        $this->checkFile('themes/merchants/Midnight_city/richlistbox_popup.tpl', 'c155c59eea77770589bcadca0c75f1af');
        $this->checkFile('themes/merchants/Midnight_city/richtext_editor.tpl', '99af0e75e8761690e55e65fa238d8d4c');
        $this->checkFile('themes/merchants/Midnight_city/richtext_editor_toolbar.tpl', '3798b9151ed1d87c99e5783005c81773');
        $this->checkFile('themes/merchants/Midnight_city/richtextarea.css', 'fea0087e5f21ad14e23a515fd17123d1');
        $this->checkFile('themes/merchants/Midnight_city/richtexteditor_addlink.tpl', 'c9bd3a510535abef1076a29328f069e7');
        $this->checkFile('themes/merchants/Midnight_city/role_privileges.tpl', '30e7afc5bc26d51388efbf226e837411');
        $this->checkFile('themes/merchants/Midnight_city/rotator_preview_merchant.stpl', 'f4a8b7e2a320d263c11e080652136aa8');
        $this->checkFile('themes/merchants/Midnight_city/rule_conditions_panel.tpl', 'eb2d93cd36c8a15eb8b8c219d89cbec9');
        $this->checkFile('themes/merchants/Midnight_city/rule_conditions_panel_full.tpl', '999a870f9084cc2269befe4f628e51cc');
        $this->checkFile('themes/merchants/Midnight_city/rule_panel.tpl', '836f9d642a2304b320b799fd156d04bf');
        $this->checkFile('themes/merchants/Midnight_city/search_filter.tpl', 'c43c492cae5282a628238b4ff75508b2');
        $this->checkFile('themes/merchants/Midnight_city/search_gadget.tpl', 'dd1ccaf3d497e365f8ea8d999a89cc29');
        $this->checkFile('themes/merchants/Midnight_city/search_gadget_entries_panel.tpl', 'b60a5fd89e628c401c86eee54073243e');
        $this->checkFile('themes/merchants/Midnight_city/search_gadget_popup.tpl', 'ad5359afa9edeb864b0929d40a05e466');
        $this->checkFile('themes/merchants/Midnight_city/search_gadget_popup_entry.tpl', 'd4c0f584509bbc3c0db48a061dab51fc');
        $this->checkFile('themes/merchants/Midnight_city/selectbutton_search.tpl', 'dedb23ce356b1b66377e648232dc2b8b');
        $this->checkFile('themes/merchants/Midnight_city/send_mail_to_affiliate.tpl', '757d0224a850eb6a32175367add64442');
        $this->checkFile('themes/merchants/Midnight_city/send_mass_mail.tpl', '515c3046b1058c4b313af52b6859a18d');
        $this->checkFile('themes/merchants/Midnight_city/set_new_password_form.tpl', '9270391a0892b67b03efbd67084806c6');
        $this->checkFile('themes/merchants/Midnight_city/sidebar.tpl', '65226d7e25dcdca0cf71a9f3118d8139');
        $this->checkFile('themes/merchants/Midnight_city/sidebar_closed.tpl', '3d903661713a9ee5fb402776ee06d310');
        $this->checkFile('themes/merchants/Midnight_city/sidebar_gadget.tpl', '1f904859e056808c8826836a4e256761');
        $this->checkFile('themes/merchants/Midnight_city/signup_commissions.tpl', 'e88a6f8eb2b970efe40609b59a103f45');
        $this->checkFile('themes/merchants/Midnight_city/signup_form_design.tpl', '5786a51864065a89ea059e03826048c7');
        $this->checkFile('themes/merchants/Midnight_city/signup_url_panel.tpl', '9578396ed90325350510e89493bc5101');
        $this->checkFile('themes/merchants/Midnight_city/simple_filter.tpl', 'a55a1095bcbdbef9d9d9f5e2078b19a2');
        $this->checkFile('themes/merchants/Midnight_city/simple_icon_object.tpl', 'bcbc9ea994d4aa8bbdee1eddc3ad19d8');
        $this->checkFile('themes/merchants/Midnight_city/simple_popup_window.tpl', 'e7d6ad58d85a85eab20414bb734b8c81');
        $this->checkFile('themes/merchants/Midnight_city/simplecolorpicker.tpl', '9c031fbdd2b35909faeea73e5f1203a1');
        $this->checkFile('themes/merchants/Midnight_city/single_content_panel.tpl', '529d4a42f9106d91881f8b8b8e87748b');
        $this->checkFile('themes/merchants/Midnight_city/site_replication_feature_on_deactivate.tpl', 'a9a5007e2b045fcddb5649780343250c');
        $this->checkFile('themes/merchants/Midnight_city/size_format_widget.tpl', 'ebfb7db6718ec601af59a570d8e0ccb3');
        $this->checkFile('themes/merchants/Midnight_city/spillover.tpl', 'b88774d1a43ea2c8b638a75c59411588');
        $this->checkFile('themes/merchants/Midnight_city/spillover_affiliate_panel.tpl', 'a31389658f2a6052020cad731dff7671');
        $this->checkFile('themes/merchants/Midnight_city/split_commissions_edit.tpl', '79b93073097985ea9b70b50708f9f361');
        $this->checkFile('themes/merchants/Midnight_city/split_commissions_edit_help.tpl', 'b8c0076fd8c6f725a44728f9c36e1633');
        $this->checkFile('themes/merchants/Midnight_city/split_commissions_feature_on_activate.tpl', '3c0a020b1e83cc8c0f13cc18c823c20d');
        $this->checkFile('themes/merchants/Midnight_city/start_button.tpl', '7aa2278c46b897536625cc042b4f5499');
        $this->checkFile('themes/merchants/Midnight_city/statistics_double_value_widget.tpl', '7e243a39277ad97843b418e45881a6d2');
        $this->checkFile('themes/merchants/Midnight_city/statistics_filter.tpl', '90764aa6c165d35f0eac8273a596c963');
        $this->checkFile('themes/merchants/Midnight_city/statistics_tab.tpl', '2848d44a5dc972d9812c2aa7f0b16614');
        $this->checkFile('themes/merchants/Midnight_city/stats_chart.tpl', 'b5bb3d9a0dd5361a4e34e479aacf2480');
        $this->checkFile('themes/merchants/Midnight_city/sub_menu_section.tpl', 'f14329a6ad21f2551a068111201c9918');
        $this->checkFile('themes/merchants/Midnight_city/sum_payouts_to_affiliates.tpl', '4c94936fcc7cc7be82f86e1eb2e8df9e');
        $this->checkFile('themes/merchants/Midnight_city/sum_payouts_to_affiliates_filter.tpl', '4ff8a5479e29e9ca336f282f0fd51b85');
        $this->checkFile('themes/merchants/Midnight_city/system_menu.tpl', '414133fa4f1a7e794444f72e6aad3cf7');
        $this->checkFile('themes/merchants/Midnight_city/tab_item.tpl', 'd869bc1a3b8c511712e039399333d129');
        $this->checkFile('themes/merchants/Midnight_city/tab_panel.tpl', '8c2853c4e62119a5b6f89c5e340af5d3');
        $this->checkFile('themes/merchants/Midnight_city/task.tpl', '38a4b70b6456a12285be4bb113c72575');
        $this->checkFile('themes/merchants/Midnight_city/taskbar.tpl', 'd7cf8ef7a71bf324aee5c1c7173afc7e');
        $this->checkFile('themes/merchants/Midnight_city/template_form.tpl', '1a0d6777f298f5a2a71f6efea7ac459f');
        $this->checkFile('themes/merchants/Midnight_city/template_form_constants.tpl', '91c398393e519cf7c6a53ba758eefc47');
        $this->checkFile('themes/merchants/Midnight_city/template_form_theme_entry.tpl', '91a40d5bfbb3ff3b61cd7771e24a2684');
        $this->checkFile('themes/merchants/Midnight_city/template_form_themes.tpl', 'e7158c1782ef49ddbf3fbe671c5c5b8a');
        $this->checkFile('themes/merchants/Midnight_city/template_form_variables.tpl', 'e1c008058f4be04a9e6e76ba72cc3290');
        $this->checkFile('themes/merchants/Midnight_city/templates_form.tpl', '7a0a1baf13edabb10c8c6bef5a3dac41');
        $this->checkFile('themes/merchants/Midnight_city/theme.php', 'a053f81cac36a046fbc32a76b68bb16b');
        $this->checkFile('themes/merchants/Midnight_city/theme_create_new.tpl', '847cc7b80df92aa24acf0da5afdd0ed3');
        $this->checkFile('themes/merchants/Midnight_city/theme_edit_editor.tpl', '1b1b3b083b418ba21ef37522b0934a5f');
        $this->checkFile('themes/merchants/Midnight_city/theme_edit_filetree.tpl', '0e6f1bd9c3b11a255eab1e4824f83475');
        $this->checkFile('themes/merchants/Midnight_city/theme_edit_image.tpl', 'cc7ae652219ab87a267bf87631e9dc43');
        $this->checkFile('themes/merchants/Midnight_city/theme_edit_none.tpl', '291239b715e2f1e962011564bf549e5e');
        $this->checkFile('themes/merchants/Midnight_city/theme_edit_unsupported.tpl', '2977467887b418fedc8b42576078f275');
        $this->checkFile('themes/merchants/Midnight_city/theme_editor_panel.tpl', '566661806fd2d4b3ce443277d71959f5');
        $this->checkFile('themes/merchants/Midnight_city/theme_panel.tpl', '07b850efc37a68fe58fcdb067a81271d');
        $this->checkFile('themes/merchants/Midnight_city/theme_settings.tpl', '5c596388ecc46c2ac89c029f811f565e');
        $this->checkFile('themes/merchants/Midnight_city/time_conditions_panel.tpl', '0266186f1510ff818fb15cf4b41862b2');
        $this->checkFile('themes/merchants/Midnight_city/timezone_settings.tpl', 'f1bb95540fb8855093d35b284817369d');
        $this->checkFile('themes/merchants/Midnight_city/timezone_settings_tab.tpl', 'f89569e5d47f73e9c872ed4026fefcfa');
        $this->checkFile('themes/merchants/Midnight_city/tooltip_popup.tpl', 'e4a5b50c70875ee64d9fdf4f88fa8045');
        $this->checkFile('themes/merchants/Midnight_city/top_afffiliates_list.tpl', '286e2ac7096bc38ef5507691de9f17a6');
        $this->checkFile('themes/merchants/Midnight_city/top_affiliates_filter.tpl', 'b3ed7a34051548c53736298042eb2243');
        $this->checkFile('themes/merchants/Midnight_city/topurl_list.tpl', 'f108c2b8e2583a45a2016869735c87d3');
        $this->checkFile('themes/merchants/Midnight_city/tracking_tab.tpl', '8abcd2a1c88351a3a16795feda6750b4');
        $this->checkFile('themes/merchants/Midnight_city/traffic_info.tpl', 'd8084bc576645ae6485c9384c74b42e4');
        $this->checkFile('themes/merchants/Midnight_city/traffic_stats_gadget.tpl', 'da081a1eba4470008e9f5e0165ecd7d6');
        $this->checkFile('themes/merchants/Midnight_city/traffic_stats_in_gadget.tpl', 'b6ffda3596f992ce68d25d72fa923751');
        $this->checkFile('themes/merchants/Midnight_city/trafic_and_sales_report.tpl', '6723e4f293c26fed32855b086cb6318e');
        $this->checkFile('themes/merchants/Midnight_city/transaction_form.tpl', '8ef3d9c8be8655191b10b6ceb6b8627a');
        $this->checkFile('themes/merchants/Midnight_city/transaction_form_edit.tpl', '73debd09259e1daf3b7e6d50ccf8aee0');
        $this->checkFile('themes/merchants/Midnight_city/transaction_form_notes.tpl', '648b29094d534cfc6b8d7683440505f0');
        $this->checkFile('themes/merchants/Midnight_city/transaction_form_tracking.tpl', 'fc35d874eebd664e3b6da64f8d36b903');
        $this->checkFile('themes/merchants/Midnight_city/transaction_info.tpl', '689fb8c420b25ed9e1460edae68b92e0');
        $this->checkFile('themes/merchants/Midnight_city/transaction_list.tpl', '4d28f9612adefe432e937dea2f6ccf2a');
        $this->checkFile('themes/merchants/Midnight_city/transaction_list_filter_base.tpl', '7d0ad12c7fc041af03abba828a3bacc4');
        $this->checkFile('themes/merchants/Midnight_city/transaction_list_no_data.tpl', 'f91882c034dcec76ed668d2fa6e5863f');
        $this->checkFile('themes/merchants/Midnight_city/transaction_panel.tpl', '4f6297bd3273c5a64ae474c3989dd834');
        $this->checkFile('themes/merchants/Midnight_city/transaction_reports.tpl', 'ef0c25832283bcfe9d9cc37cd13ac41e');
        $this->checkFile('themes/merchants/Midnight_city/transactions_import.tpl', '18ea606dee038315e72e0e1049666ca3');
        $this->checkFile('themes/merchants/Midnight_city/trash.tpl', '270d020eabfcf284be7a97e7102924d5');
        $this->checkFile('themes/merchants/Midnight_city/tree_affiliate_widget.tpl', 'd6d133404cf44bcd4d057ddc9e0b573f');
        $this->checkFile('themes/merchants/Midnight_city/tree_draggable_items.tpl', '869b3cbe1a546cf76baa397b8360495b');
        $this->checkFile('themes/merchants/Midnight_city/trend_actions_stats.tpl', '01beef973c394417de5a58de2857a1e5');
        $this->checkFile('themes/merchants/Midnight_city/trend_actions_stats_widget.tpl', '7c26676ceb09baf3fafeb0dba3bdaec4');
        $this->checkFile('themes/merchants/Midnight_city/trend_stats.tpl', '5423abd62baeb237c0c5feb600e84937');
        $this->checkFile('themes/merchants/Midnight_city/trends_report.stpl', '18264d58de48af1de2b77137b0df48fb');
        $this->checkFile('themes/merchants/Midnight_city/trends_report.tpl', '8c3ecd3db7c864a8cbbd04e92363467c');
        $this->checkFile('themes/merchants/Midnight_city/trends_report_action.stpl', '929fa1c9535d05f1e8a0492013b9de33');
        $this->checkFile('themes/merchants/Midnight_city/trends_report_filter.tpl', 'cacaca9e199f9c7b74916541a340c31a');
        $this->checkFile('themes/merchants/Midnight_city/trends_report_no_data.tpl', '9d1dd7b6d3ef5f6ada42de2c7d182df2');
        $this->checkFile('themes/merchants/Midnight_city/troubleshooting.tpl', '8ec5482d68f08a103cf0883b10308e9f');
        $this->checkFile('themes/merchants/Midnight_city/update_version.stpl', '5602f52fe8248df474201a16c922048f');
        $this->checkFile('themes/merchants/Midnight_city/upload_panel.tpl', '222a0dd80ab37bb49060da0cf7eaf447');
        $this->checkFile('themes/merchants/Midnight_city/uploaded_file.tpl', 'fad11b13e3b41eff41a129b1af232e7e');
        $this->checkFile('themes/merchants/Midnight_city/user_edit.tpl', 'f41ba1817ee0d15f16c57dff5be39bb1');
        $this->checkFile('themes/merchants/Midnight_city/vat_settings.tpl', '628456504f54a037d9ba2f08ba3fbdc5');
        $this->checkFile('themes/merchants/Midnight_city/verify_panel.tpl', '79aa97bc204438e497a55b8e96ee3f6b');
        $this->checkFile('themes/merchants/Midnight_city/view_form.tpl', 'e37b380ed96bef78dc0de97ac2a3e379');
        $this->checkFile('themes/merchants/Midnight_city/view_form_edit_views.tpl', '957cda42f99a863bd72988472e4d008f');
        $this->checkFile('themes/merchants/Midnight_city/view_panel.tpl', '25340a99e4e6b4627de427ada4d1b2bc');
        $this->checkFile('themes/merchants/Midnight_city/views_list.tpl', 'eb42ebb392f0237879dfba6547578e98');
        $this->checkFile('themes/merchants/Midnight_city/visitor_affiliate_edit.tpl', '61506b2d8b383293922a9cc4929438da');
        $this->checkFile('themes/merchants/Midnight_city/visitor_affiliates_filter.tpl', '44d9d5e8bf93948d6220d00187359183');
        $this->checkFile('themes/merchants/Midnight_city/visitor_affiliates_list.tpl', '3493ae8f6c4fb7e655667b20a0b46ce9');
        $this->checkFile('themes/merchants/Midnight_city/visitor_nonrefclicks_filter.tpl', '6ef69cf81734100ad5d5cf1339ee0ad7');
        $this->checkFile('themes/merchants/Midnight_city/visitor_nonrefclicks_list.tpl', '202a7982f1ad5ae2e2310347969b8713');
        $this->checkFile('themes/merchants/Midnight_city/visits_sales_log_add.tpl', 'e8d580c16c576c3ec98c1baedac437fa');
        $this->checkFile('themes/merchants/Midnight_city/visits_sales_logs_filter.tpl', '5ffb18e5d3dcb8df3f61a03331c91552');
        $this->checkFile('themes/merchants/Midnight_city/visits_sales_logs_list.tpl', '2f2c6cb4ab210272ffd87e4d3bff95b4');
        $this->checkFile('themes/merchants/Midnight_city/visits_sales_logs_no_data.tpl', '969b350cc45c6f7c68fa6322e98a3de1');
        $this->checkFile('themes/merchants/Midnight_city/wallpaper_add_custom.tpl', '2210741b569ef188fa352c977a289261');
        $this->checkFile('themes/merchants/Midnight_city/wallpaper_entry.tpl', '64c85f4da7897cd0f34168c62de661b9');
        $this->checkFile('themes/merchants/Midnight_city/wallpaper_settings.tpl', 'd160dbed38556231aeac49a96213e4d4');
        $this->checkFile('themes/merchants/Midnight_city/welcome_message_panel.tpl', '86f2e7b763c27c55f65b269cd8b95a0d');
        $this->checkFile('themes/merchants/Midnight_city/window.tpl', '2391705887d707e05187606c4a819e73');
        $this->checkFile('themes/merchants/Midnight_city/window_bottom_left.tpl', 'd14b545c27afa02ab7a919bdeb4c9470');
        $this->checkFile('themes/merchants/Midnight_city/window_empty_content.tpl', 'b1535ec719cada5b9f5d98849074b9bd');
        $this->checkFile('themes/merchants/Midnight_city/window_header.tpl', '02a337d4184c3924a2792a84493794cc');
        $this->checkFile('themes/merchants/Midnight_city/window_header_refresh.tpl', 'fcd47f4585abcac3c3a61ee3991379bc');
        $this->checkFile('themes/merchants/Midnight_city/window_left.tpl', '984d69649ec171a5c6b522e795feb904');
        $this->checkFile('themes/merchants/Midnight_city/window_move_panel.tpl', 'f5bbd373a758bf76e6efadc94dca4b11');
        $this->checkFile('themes/merchants/Midnight_city/wizard_panel.tpl', '3142ce6354cb3e1c86b6c13c1d906189');
        $this->checkFile('themes/merchants/Midnight_city/zip_banner_feature_on_deactivate.tpl', '0d58a97804ba953e180301d3bb0d1a37');
        $this->checkFile('themes/merchants/WooPrice/TreeItemWidget.tpl', 'd1bfa5574da9cfa131eef997e0870e92');
        $this->checkFile('themes/merchants/WooPrice/account_form.tpl', 'bec2cc19f2320dfebd3e493c97eeae52');
        $this->checkFile('themes/merchants/WooPrice/account_form_show.tpl', '481066cec1fdf42f68f2db4c2fabca35');
        $this->checkFile('themes/merchants/WooPrice/account_form_view.tpl', '3c3a69f103776f35bf195a27db899cb9');
        $this->checkFile('themes/merchants/WooPrice/account_fraud_protection_clicks.tpl', '559a9b6630eb145dbdc5fa575a97ecb0');
        $this->checkFile('themes/merchants/WooPrice/account_fraud_protection_sales.tpl', '1eabaf9f7df78e8502403383c9393ad9');
        $this->checkFile('themes/merchants/WooPrice/account_info_data.tpl', '48e5394b52c65f2174b235bcd7ec792c');
        $this->checkFile('themes/merchants/WooPrice/account_notifications_form.tpl', '1fb8f96e9b5c02448da103459cdf6aa7');
        $this->checkFile('themes/merchants/WooPrice/account_private_campaign_settings.tpl', '940f4bcdbf2de9045887c436f31300ab');
        $this->checkFile('themes/merchants/WooPrice/account_screen.tpl', '738e8b0997ff8592a4524b3f6c6c4ad6');
        $this->checkFile('themes/merchants/WooPrice/account_settings.tpl', 'bef40a405c258ac960ea1370e7d02de7');
        $this->checkFile('themes/merchants/WooPrice/account_signup_settings_form.tpl', '68d7a20fdb3a245a8444d5ea27924b4c');
        $this->checkFile('themes/merchants/WooPrice/accounting_filter.tpl', '0943670f8ba31ff555e7dc4e5915fdf3');
        $this->checkFile('themes/merchants/WooPrice/accounting_gadget_data.tpl', 'd94f4bee085512317d28081b9f1d5c26');
        $this->checkFile('themes/merchants/WooPrice/accounting_gadget_template.tpl', '99927018924623a51361c651857aa116');
        $this->checkFile('themes/merchants/WooPrice/accounting_panel.tpl', 'a95d5eee70654bd6c562e736f4a9f0c5');
        $this->checkFile('themes/merchants/WooPrice/accounting_stats_data.tpl', '4f714be5959067fa8962919a6c50bb8c');
        $this->checkFile('themes/merchants/WooPrice/accounts_fields.tpl', '1d3c5c66916b50467c03d8602aa291c5');
        $this->checkFile('themes/merchants/WooPrice/accounts_filter.tpl', 'dd123439f945f76b09422ad55b2bd4cb');
        $this->checkFile('themes/merchants/WooPrice/accounts_invoices_panel.tpl', 'e62d96763f78f49afcb568b7de9933ad');
        $this->checkFile('themes/merchants/WooPrice/accounts_panel.tpl', '77b8fd37eb4f0427cf2b3a6f757e30d8');
        $this->checkFile('themes/merchants/WooPrice/add_affiliate_page.tpl', 'e69a0888131f7a941dc7e7c744f5dd11');
        $this->checkFile('themes/merchants/WooPrice/add_affiliate_page_content.tpl', '0f11dbecb7f2f1eea6ab769eb625e322');
        $this->checkFile('themes/merchants/WooPrice/add_affiliate_page_page.tpl', '70a1f240785c415fb99947f94972de26');
        $this->checkFile('themes/merchants/WooPrice/add_affiliate_page_url.tpl', '58f8f5e302e28d28522e7265e3694665');
        $this->checkFile('themes/merchants/WooPrice/add_affiliate_to_campaign.tpl', 'ddb8f68a2edb3955a5a209e11442b1bf');
        $this->checkFile('themes/merchants/WooPrice/add_affiliate_to_group.tpl', '4f69927d7cad9e8466fe91bd3e3af69c');
        $this->checkFile('themes/merchants/WooPrice/add_custom_translation.tpl', '91a22a74346db521569588e934048e79');
        $this->checkFile('themes/merchants/WooPrice/add_gadget_category.tpl', 'e2ec9306de4bf074a33e72c96ff238ca');
        $this->checkFile('themes/merchants/WooPrice/add_gadget_panel.tpl', 'be8c80e8aff49f52f5b5c1b79be9526f');
        $this->checkFile('themes/merchants/WooPrice/add_gadget_select_url.tpl', 'b9e3459257a1d9c8a6c66009c826d06c');
        $this->checkFile('themes/merchants/WooPrice/add_transaction_form.tpl', '6c9da9a05ee604bb7ad0cc4225c07e88');
        $this->checkFile('themes/merchants/WooPrice/add_user_to_group_form.tpl', 'f5353d26cbc32f5b59f99d0388244462');
        $this->checkFile('themes/merchants/WooPrice/additional_dynamic_form_panel.tpl', '39fe1aad3bb309004ee15c8537c90d15');
        $this->checkFile('themes/merchants/WooPrice/admin_panel.tpl', '974dc9641d622a6723650da268bebf5f');
        $this->checkFile('themes/merchants/WooPrice/admins_panel.tpl', '043af9e3cecec2e85866aa06c2a04a37');
        $this->checkFile('themes/merchants/WooPrice/admins_panel_filter.tpl', '4ec418856a865586f6d6ed313e0cffb6');
        $this->checkFile('themes/merchants/WooPrice/advanced_email_settings_form.tpl', '304064505236c0bb68e3a8f4bc3b1c08');
        $this->checkFile('themes/merchants/WooPrice/advanced_email_settings_tab.tpl', '4cdac3ab7ec6827e1307d48028f2d835');
        $this->checkFile('themes/merchants/WooPrice/advanced_integration_steps_icons.tpl', 'fc1f4fb9ee86fc80e6ef1e365e0d77f5');
        $this->checkFile('themes/merchants/WooPrice/aff_notifications_form.tpl', '91da03bbf53967e23ec56d61214477e1');
        $this->checkFile('themes/merchants/WooPrice/affilate_advanced_filter.tpl', '11bde2dcecd82caeeb4616944f36ff5b');
        $this->checkFile('themes/merchants/WooPrice/affiliate_commission_groups.tpl', '9d4046dbc63fe4b678f8c62ffca79854');
        $this->checkFile('themes/merchants/WooPrice/affiliate_delete.tpl', '2157c7c0e31996f4fc0f85a185977ac5');
        $this->checkFile('themes/merchants/WooPrice/affiliate_details.tpl', 'bd86d96ae0a6f75ea0547ca235cabde6');
        $this->checkFile('themes/merchants/WooPrice/affiliate_edit_commission_groups_no_data.tpl', 'a9756aeb0730e4fd5f4fa9cb6de8012b');
        $this->checkFile('themes/merchants/WooPrice/affiliate_edit_details.tpl', 'b911b7098ffb6e1511b33e3f35d6f9b2');
        $this->checkFile('themes/merchants/WooPrice/affiliate_edit_details_additional.tpl', '98de15bb9a88b36dc47ba266389cb413');
        $this->checkFile('themes/merchants/WooPrice/affiliate_edit_dialog.tpl', 'acaf92b10f7821b0f5794593db70df01');
        $this->checkFile('themes/merchants/WooPrice/affiliate_edit_no_payout_history.tpl', '0d40b1e330f67d9e74c3890beca74b29');
        $this->checkFile('themes/merchants/WooPrice/affiliate_fields.tpl', 'c54826ec0f80194f7381304b20b5e95e');
        $this->checkFile('themes/merchants/WooPrice/affiliate_general_settings.tpl', 'e747d64338280436d5f3478d1f0cb514');
        $this->checkFile('themes/merchants/WooPrice/affiliate_info_data.tpl', 'b57513f9b5504095638e810826ac3e63');
        $this->checkFile('themes/merchants/WooPrice/affiliate_list.tpl', 'cc032a88a7775b2938522ca3f58dc755');
        $this->checkFile('themes/merchants/WooPrice/affiliate_list_no_data.tpl', '7741570acae759090cf04aeb6f313bb2');
        $this->checkFile('themes/merchants/WooPrice/affiliate_logins.tpl', '9f5432cc0f1f1bb464a38a23fb16e6e3');
        $this->checkFile('themes/merchants/WooPrice/affiliate_logins_header.tpl', '7fc020dd9a1268955faaf16b973b82c7');
        $this->checkFile('themes/merchants/WooPrice/affiliate_logins_map.tpl', '76fe92abae4eacb0bfbd670ac54aa0b3');
        $this->checkFile('themes/merchants/WooPrice/affiliate_menu_settings.tpl', '3507cb91be549e264e21b007c3571ba8');
        $this->checkFile('themes/merchants/WooPrice/affiliate_panel_config.tpl', '99bc43fef7dbe936c4e733215585a277');
        $this->checkFile('themes/merchants/WooPrice/affiliate_payout_settings.tpl', '8304e34183caa27262c69cec69c12373');
        $this->checkFile('themes/merchants/WooPrice/affiliate_postsignup_settings.tpl', '295c4b2802684750cc74e93282fb5732');
        $this->checkFile('themes/merchants/WooPrice/affiliate_screen_detail.tpl', '1075539ad2bdd3dd1eeb74078b054f03');
        $this->checkFile('themes/merchants/WooPrice/affiliate_screen_header_edit.tpl', 'cb37af28ddbd0c61c9abadf675e7d8bc');
        $this->checkFile('themes/merchants/WooPrice/affiliate_screen_settings.tpl', '5fb92d5bc22ff7ede5ec1572ef94ced9');
        $this->checkFile('themes/merchants/WooPrice/affiliate_screen_settings_nodata.tpl', 'bb4ad3e2d922192ec998ee5ae5c51e50');
        $this->checkFile('themes/merchants/WooPrice/affiliate_screens_list.tpl', '08ad8cbadce365f01978ef5f8b0c7d32');
        $this->checkFile('themes/merchants/WooPrice/affiliate_signup_settings.tpl', 'c9a8f99f2c61ead6d8bdb0d125e0f183');
        $this->checkFile('themes/merchants/WooPrice/affiliate_signup_settings_button.tpl', 'adccd555745134a857328990ed086077');
        $this->checkFile('themes/merchants/WooPrice/affiliate_signup_settings_form.tpl', 'eb832a062e7059bb5074dbeec7f2f890');
        $this->checkFile('themes/merchants/WooPrice/affiliate_stats.tpl', 'b1c8b06e198d9ed22a5564a73ff26e0e');
        $this->checkFile('themes/merchants/WooPrice/affiliate_subaffiliates.tpl', '633205fc5244112afa932c8b18f58edd');
        $this->checkFile('themes/merchants/WooPrice/affiliate_tracking_code_filter.tpl', '614c11facd7d5ebaee38deae93e139c9');
        $this->checkFile('themes/merchants/WooPrice/affiliate_tracking_code_panel.tpl', '2563d59c5d920af9e929d25715e3758e');
        $this->checkFile('themes/merchants/WooPrice/affiliate_tracking_cookiepanel.tpl', 'afe8791a0c4895979c261a672103de97');
        $this->checkFile('themes/merchants/WooPrice/affiliate_tracking_options.tpl', '85a3391abee5f9a8dc727fe266534ed8');
        $this->checkFile('themes/merchants/WooPrice/affiliate_tracking_testlinks.tpl', '3407045ee29fe67b40621cdb381ff40e');
        $this->checkFile('themes/merchants/WooPrice/affiliate_tree.tpl', '875e8e5d865578c1b5efe31580b9e719');
        $this->checkFile('themes/merchants/WooPrice/affiliate_tree_filter.tpl', 'c676ed3f6a9ee3860ad9e60e62dbab86');
        $this->checkFile('themes/merchants/WooPrice/affiliate_tree_filter_edit.tpl', '959100eeceade475bc20ec5272660a38');
        $this->checkFile('themes/merchants/WooPrice/affiliate_tree_panel.tpl', '9ddd4e10bea7ad43a028f867760df9d6');
        $this->checkFile('themes/merchants/WooPrice/affiliate_url_page_editor.tpl', '1563cbaaa42ab9c7c0c8898a17b3b10a');
        $this->checkFile('themes/merchants/WooPrice/affiliate_urls_no_data.tpl', 'c9868414093445accf0f0d7551847116');
        $this->checkFile('themes/merchants/WooPrice/affiliates_group.tpl', 'e1f5bcb91bd2f949694890186ff3566a');
        $this->checkFile('themes/merchants/WooPrice/affiliates_group_filter.tpl', '466c832f6c6b327cbee63030a81d410c');
        $this->checkFile('themes/merchants/WooPrice/affiliates_import.tpl', '5d25493eca047e7b66627090a7bcf423');
        $this->checkFile('themes/merchants/WooPrice/affpanel_design.tpl', '47558761ee69c8a906f6b3f3c0b7fe1e');
        $this->checkFile('themes/merchants/WooPrice/after_signup_actions_fields_no_data.tpl', '2fe9a7bbd29402632be238ea0cb7f2dd');
        $this->checkFile('themes/merchants/WooPrice/after_signup_actions_no_data.tpl', 'c9868414093445accf0f0d7551847116');
        $this->checkFile('themes/merchants/WooPrice/after_signup_no_data.tpl', 'acc4136ac3d8c01816ce79b2281ca9f1');
        $this->checkFile('themes/merchants/WooPrice/align_widget.tpl', '124769dbcc410ae58c1dfd53f15b58d6');
        $this->checkFile('themes/merchants/WooPrice/api_integration.tpl', '87329cb5ed35f3bfbb29e45947ae8bab');
        $this->checkFile('themes/merchants/WooPrice/assigment.tpl', '48b84b37bf127adc78ef230b61a22e60');
        $this->checkFile('themes/merchants/WooPrice/assign_auto_panel.tpl', '4414ff53bc35c96dd1932aa630eb128f');
        $this->checkFile('themes/merchants/WooPrice/audit_log_filter.tpl', '67c7322e9a203c85a10210cb496b110e');
        $this->checkFile('themes/merchants/WooPrice/available_values_edit.tpl', 'e96fa729b9a61e7e4a21fbddf80565fb');
        $this->checkFile('themes/merchants/WooPrice/banner_and_link_form_panel.tpl', '5c7a5c4a303dffe6d76424abd90a0236');
        $this->checkFile('themes/merchants/WooPrice/banner_button.tpl', 'e1cb4d807552c33476c9dc37bca24dc6');
        $this->checkFile('themes/merchants/WooPrice/banner_category_edit.tpl', '2fc9f159a4666a456e4de83356cf2511');
        $this->checkFile('themes/merchants/WooPrice/banner_category_item.tpl', '55fcd96a4eabd7825f722f3f36bab5d4');
        $this->checkFile('themes/merchants/WooPrice/banner_category_selector.tpl', 'ba32ee51a99861b1a19d9b66e45f4db0');
        $this->checkFile('themes/merchants/WooPrice/banner_category_settings_panel.tpl', 'fa002655c612fad61b7cd5121e786391');
        $this->checkFile('themes/merchants/WooPrice/banner_clone_dialog.tpl', '87df8d4453785b4924425c45fc252f20');
        $this->checkFile('themes/merchants/WooPrice/banner_destination_url_panel.tpl', 'd2cf85ec3a941d8acc4f8c673c3c2781');
        $this->checkFile('themes/merchants/WooPrice/banner_destinations.tpl', 'c2466e9211af205aaa302153ecf54ec0');
        $this->checkFile('themes/merchants/WooPrice/banner_details.tpl', '02ec398758e8c9d094be8ddd3dea86e9');
        $this->checkFile('themes/merchants/WooPrice/banner_details_params.tpl', 'daca6d0de978ff1a272adbe072455399');
        $this->checkFile('themes/merchants/WooPrice/banner_edit_header.tpl', '8be5daca610e30e2fc600a9c8a03cf56');
        $this->checkFile('themes/merchants/WooPrice/banner_edit_panel.tpl', 'd371721abec7a70439373826893749c8');
        $this->checkFile('themes/merchants/WooPrice/banner_filter.tpl', 'c329bee9165d04cc757e990a92c1b019');
        $this->checkFile('themes/merchants/WooPrice/banner_format_form.tpl', '5f8fd9d50c3f4817158302d1834f7e26');
        $this->checkFile('themes/merchants/WooPrice/banner_in_rotator_edit_panel.tpl', '331b8b61058b5f85750cc690e63d08cc');
        $this->checkFile('themes/merchants/WooPrice/banner_list_no_data.tpl', '6ec4d243cc9d9b0ee86612709590882e');
        $this->checkFile('themes/merchants/WooPrice/banner_manager.tpl', '18d6d96df57962f8d1a9b8effe339b15');
        $this->checkFile('themes/merchants/WooPrice/banner_name.tpl', '0e8385998fddbc3260837cf0590a35a5');
        $this->checkFile('themes/merchants/WooPrice/banner_or_link_edit_template_panel.tpl', '346160178349fe7d0b8f4f55bbf96ecd');
        $this->checkFile('themes/merchants/WooPrice/banner_or_link_not_selected.tpl', '180941a437e8e722a4b7f7b44e73e0f0');
        $this->checkFile('themes/merchants/WooPrice/banner_own_size_panel.tpl', 'ec916344f7150972a863c771ccb676df');
        $this->checkFile('themes/merchants/WooPrice/banner_parameters_coupon.tpl', 'd7c6fc6e00c9e11d262f7c767454b9c7');
        $this->checkFile('themes/merchants/WooPrice/banner_parameters_flash.tpl', 'a6356eb54289b4b062c0250c5e9b7963');
        $this->checkFile('themes/merchants/WooPrice/banner_parameters_hover.tpl', 'f15317ed6c2ed30c9a2e897dbaaa79a6');
        $this->checkFile('themes/merchants/WooPrice/banner_parameters_html.tpl', 'f00f7657b51377b05cca05db4a27b4bf');
        $this->checkFile('themes/merchants/WooPrice/banner_parameters_image.tpl', 'f4227e6ffab89f9fecf00de0db1ea261');
        $this->checkFile('themes/merchants/WooPrice/banner_parameters_pagepeel.tpl', 'f0477017e173b2a6d887e3eabe77ccc8');
        $this->checkFile('themes/merchants/WooPrice/banner_parameters_pagepeelhtml.tpl', 'c4722a470e19f5966ee208dfd75b72cd');
        $this->checkFile('themes/merchants/WooPrice/banner_parameters_pdf.tpl', 'b02138b4e56eb4d1b40be08282348643');
        $this->checkFile('themes/merchants/WooPrice/banner_parameters_promo_email.tpl', '5d558a2ce40bd6997c670115425bc67b');
        $this->checkFile('themes/merchants/WooPrice/banner_parameters_rebrandpdf.tpl', '11451d812f2b92bf7928f77a448252ba');
        $this->checkFile('themes/merchants/WooPrice/banner_parameters_rebrandpdf_allvars.tpl', 'c01f39df6d7b58ed19794de908c314b2');
        $this->checkFile('themes/merchants/WooPrice/banner_parameters_rebrandpdf_filefield.tpl', '4f3e422e757c8bd5c3460a24dd453153');
        $this->checkFile('themes/merchants/WooPrice/banner_parameters_rotator.tpl', 'be18e74db4df618a8452b053fed379b6');
        $this->checkFile('themes/merchants/WooPrice/banner_parameters_site.tpl', '80b74b4c7419b3fd362fcffb1ebe0639');
        $this->checkFile('themes/merchants/WooPrice/banner_parameters_site_files.tpl', 'ce4cb65e15ec625747ee5a7359ad123b');
        $this->checkFile('themes/merchants/WooPrice/banner_parameters_site_files_local.tpl', 'a7f630aa7eb54c3cb467cb80f17674cc');
        $this->checkFile('themes/merchants/WooPrice/banner_parameters_site_files_url.tpl', '9e1571660d6fab85245ee3418abd1350');
        $this->checkFile('themes/merchants/WooPrice/banner_parameters_site_preview.tpl', '7dcf0d92d184a60ff334ad28adb1fd66');
        $this->checkFile('themes/merchants/WooPrice/banner_parameters_site_variables.tpl', 'adb74a84e21883cd904c0732316c0bce');
        $this->checkFile('themes/merchants/WooPrice/banner_parameters_zip.tpl', '262a21aedc240fc1e154b3274cf38cf5');
        $this->checkFile('themes/merchants/WooPrice/banner_parameters_zip_bannerpreview.tpl', '919258983eb853742ec1aabd2505f388');
        $this->checkFile('themes/merchants/WooPrice/banner_parameters_zip_files.tpl', '0d3f2c5edba5f03f8fb35dcbaeeebae2');
        $this->checkFile('themes/merchants/WooPrice/banner_parameters_zip_variables.tpl', 'bea861fe51d3a9e95f9ae5e5cf9c4e81');
        $this->checkFile('themes/merchants/WooPrice/banner_params_link.tpl', '16e7b10d24dd70483e8c67184d3ec46f');
        $this->checkFile('themes/merchants/WooPrice/banner_params_text_link.tpl', '36887496682c2c2872c526ca6acba1fd');
        $this->checkFile('themes/merchants/WooPrice/banner_preview.tpl', '75b30e1735f8ec02072cb2aa83a06047');
        $this->checkFile('themes/merchants/WooPrice/banner_preview_field.tpl', '71e5ce8dff03853ca9e30de9dfe5006c');
        $this->checkFile('themes/merchants/WooPrice/banner_preview_widget.tpl', 'f21248876762eecce70f4f6a6d64cad1');
        $this->checkFile('themes/merchants/WooPrice/banner_rotator_feature_on_deactivate.tpl', 'a1bfe671194574c6d8b231e70bbd0f08');
        $this->checkFile('themes/merchants/WooPrice/banner_size.tpl', 'e74a26d2165d73dc5a842acd7f481c97');
        $this->checkFile('themes/merchants/WooPrice/banner_stats_filter.tpl', '99385b61d4e01703bc055a1a910564a1');
        $this->checkFile('themes/merchants/WooPrice/banner_stats_list.tpl', '3e71f3763376f08380959fe865aad875');
        $this->checkFile('themes/merchants/WooPrice/banner_stats_list_no_data.tpl', '2bac0448c515370fac072b46a74938ec');
        $this->checkFile('themes/merchants/WooPrice/banner_with_category_filter_field.tpl', 'dd1d3439d1f76c0deda21232287fbdd2');
        $this->checkFile('themes/merchants/WooPrice/banner_wrapper_edit_panel.tpl', 'e13d8f01e20f4fa82847845bfac1026b');
        $this->checkFile('themes/merchants/WooPrice/banner_wrappers_table.tpl', '54f784f44c21afa6941daecd6088cd4a');
        $this->checkFile('themes/merchants/WooPrice/banners_and_links_format.tpl', 'a298ada6f4a07b79050cb51d23ac099f');
        $this->checkFile('themes/merchants/WooPrice/banners_categories_list.tpl', '4b6c1997242f90357b1c721a4303d816');
        $this->checkFile('themes/merchants/WooPrice/banners_categories_tree.tpl', 'fc55213c31030c3a47d4b80338c88783');
        $this->checkFile('themes/merchants/WooPrice/bannerscategories_no_data.tpl', '3df35d8c385cfc14c75759c80f11aa02');
        $this->checkFile('themes/merchants/WooPrice/bannerscategories_not_in_category.tpl', 'b4797977dcf354a6a7c77745910e839a');
        $this->checkFile('themes/merchants/WooPrice/branding_config.tpl', 'bd94806a4df51742d143a23dec8f2cdb');
        $this->checkFile('themes/merchants/WooPrice/breadcrumbs.tpl', '9981a5d8af1fb510574d67a2e0ba2481');
        $this->checkFile('themes/merchants/WooPrice/breadcrumbs_entry.tpl', '42ee9a25b7525589ed65bf9625adc890');
        $this->checkFile('themes/merchants/WooPrice/button.tpl', '40db744b463f7f71d97cd92ff46fecf4');
        $this->checkFile('themes/merchants/WooPrice/buy_feature.tpl', 'adfbf6783ae850e63499a923231e4f37');
        $this->checkFile('themes/merchants/WooPrice/calendar.tpl', 'd6831aa786acf1f829a90cec776126eb');
        $this->checkFile('themes/merchants/WooPrice/campaign_account.tpl', '9e2989cc05bb9dac952b80a40246e4e2');
        $this->checkFile('themes/merchants/WooPrice/campaign_capping.tpl', 'b9f6737a4b04f0eca0d7957191b51231');
        $this->checkFile('themes/merchants/WooPrice/campaign_category_edit.tpl', 'd1460a8d0cb69f821b18051a81907550');
        $this->checkFile('themes/merchants/WooPrice/campaign_category_item.tpl', 'de7ade79ce37b86264373c01e9ad4149');
        $this->checkFile('themes/merchants/WooPrice/campaign_category_selector.tpl', '4618de8975b4a1f2b94d168304707892');
        $this->checkFile('themes/merchants/WooPrice/campaign_category_settings_panel.tpl', '18e7ac241cca0c4c360bcf45e7d2ef71');
        $this->checkFile('themes/merchants/WooPrice/campaign_commissions_tab.tpl', '52c31b8ce3af03ce54ae51917ff87b7a');
        $this->checkFile('themes/merchants/WooPrice/campaign_filter.tpl', '7f3514d50b873ca8f3e464ad67139a31');
        $this->checkFile('themes/merchants/WooPrice/campaign_form_edit.tpl', 'ebbce6c2aba4d73403d2d9dc5a4967c1');
        $this->checkFile('themes/merchants/WooPrice/campaign_form_show.tpl', '9bd49430f9655da593402eb6d221a59d');
        $this->checkFile('themes/merchants/WooPrice/campaign_list_no_data.tpl', 'd44d658e6b3fb7b4b2f6e0e3bbe938c7');
        $this->checkFile('themes/merchants/WooPrice/campaign_rule_conditions_panel.tpl', '8f31d1ef17d39c1454d285fedbb9819b');
        $this->checkFile('themes/merchants/WooPrice/campaign_rule_conditions_panel_full.tpl', '46ac5265ab6c374aaae2b3c13d4a7734');
        $this->checkFile('themes/merchants/WooPrice/campaign_schedule_nodata.tpl', '3e87dc9b305506f1f13895478de1ee2e');
        $this->checkFile('themes/merchants/WooPrice/campaign_scheduler.tpl', '20870e8e684fb12348a0ade8874d66c8');
        $this->checkFile('themes/merchants/WooPrice/campaign_scheduling_rule_panel.tpl', '4ded51f31a3dbf59ed1a11c660d80fec');
        $this->checkFile('themes/merchants/WooPrice/campaign_screen.tpl', '48d3e63714873d79a6092b2aa0417dd9');
        $this->checkFile('themes/merchants/WooPrice/campaign_screen_edit.tpl', '4dd40cd4020a39e251a16d01ffa65723');
        $this->checkFile('themes/merchants/WooPrice/campaign_shortdetails_form.tpl', '99bd3a0b3e5790f2307e9b897dcd6811');
        $this->checkFile('themes/merchants/WooPrice/campaign_stats_filter.tpl', '656adb646eecec0d3f5091cfce68095d');
        $this->checkFile('themes/merchants/WooPrice/campaign_stats_list.tpl', 'e45c163f75670253d0dcc5037f7168e2');
        $this->checkFile('themes/merchants/WooPrice/campaign_stats_list_no_data.tpl', '6991606b8141a584b01311f5eb86bb51');
        $this->checkFile('themes/merchants/WooPrice/campaign_status.tpl', 'b732873daaced1e1e9aa43cb2f4c09fa');
        $this->checkFile('themes/merchants/WooPrice/campaign_step_create.tpl', '2d419b7525bdd89abdec8c0d31d1f71d');
        $this->checkFile('themes/merchants/WooPrice/campaign_type.tpl', '831bfbcebd1f2ccb1040cfdaa2291011');
        $this->checkFile('themes/merchants/WooPrice/campaign_validity_edit.tpl', '22198581b13ee3fbd1e3729236df3189');
        $this->checkFile('themes/merchants/WooPrice/campaign_with_category_filter_field.tpl', 'baf1267e1481cb1cf5433a0ccaf80ee8');
        $this->checkFile('themes/merchants/WooPrice/campaign_wizard.tpl', 'e6f7ad6b18e7c273490cea2a19a19654');
        $this->checkFile('themes/merchants/WooPrice/campaigns_categories_list.tpl', '8169d41f1880ba87724c80ce89553605');
        $this->checkFile('themes/merchants/WooPrice/campaigns_categories_tree.tpl', '2d96c71a0f30a75176ae42f055de8ad0');
        $this->checkFile('themes/merchants/WooPrice/campaigns_grid_settings_affiliate_panel.tpl', '6830692ae10fdc0b2083cc58268baa4c');
        $this->checkFile('themes/merchants/WooPrice/campaigns_list.tpl', '983019d6bd514bd1a348f8ad840b8c7a');
        $this->checkFile('themes/merchants/WooPrice/campaignscategories_no_data.tpl', '7d8325a745599a8d918ac08217275012');
        $this->checkFile('themes/merchants/WooPrice/campaignscategories_not_in_category.tpl', '0dd23250bcee882b765ec32ad21249af');
        $this->checkFile('themes/merchants/WooPrice/captcha.tpl', '0326fedb283400e2c13eeae155d7b536');
        $this->checkFile('themes/merchants/WooPrice/category_list.tpl', '579457d7da6e88deda06b092844c5c52');
        $this->checkFile('themes/merchants/WooPrice/change_status_button.tpl', 'a0d13402819088b5078e8100a21a0159');
        $this->checkFile('themes/merchants/WooPrice/chart_datatype_popup.tpl', '7a1a0e024c8392ea5df8cd40b179d4f7');
        $this->checkFile('themes/merchants/WooPrice/check_box_group.tpl', 'e182dd7429a276dc85e09049b2a6c19e');
        $this->checkFile('themes/merchants/WooPrice/check_box_group_row.tpl', '97219c5c2d3c996953fd6bd882e6200c');
        $this->checkFile('themes/merchants/WooPrice/checkboxes_filter.tpl', 'fef5c1833920987bd3172dbe9d75797a');
        $this->checkFile('themes/merchants/WooPrice/clicks_list.tpl', 'bd1179311cf04f759ddcc79744179a93');
        $this->checkFile('themes/merchants/WooPrice/clicks_list_filter_base.tpl', '6b6ac3cc08d8a1d3a9d3e6e1e473a962');
        $this->checkFile('themes/merchants/WooPrice/clicks_list_no_data.tpl', 'e2f13b9b96a4f0a248ea753b0c7c9178');
        $this->checkFile('themes/merchants/WooPrice/clicks_tracking.tpl', 'a017892f84d373c678ecdc5276f9e6c3');
        $this->checkFile('themes/merchants/WooPrice/colorpicker.tpl', '297c4e74e89b8b3dedd12e7c319bce41');
        $this->checkFile('themes/merchants/WooPrice/commission_edit_values.tpl', 'b277423c214667a9202d3aefac1d7619');
        $this->checkFile('themes/merchants/WooPrice/commission_edit_values_tierpanel.tpl', 'ed403054ea7f2ccb731265f9d3f0ef4f');
        $this->checkFile('themes/merchants/WooPrice/commission_edit_with_fixedcost.tpl', '3af76ab79f10ff3d0629b1c4b0cc7ba9');
        $this->checkFile('themes/merchants/WooPrice/commission_group_panel.tpl', 'fbc95c3f3b9a95e9daf3df46d8dc8a2d');
        $this->checkFile('themes/merchants/WooPrice/commission_groups.tpl', 'cd9f803bcafdc842b0226fa653242f1b');
        $this->checkFile('themes/merchants/WooPrice/commission_groups_panel.tpl', '44d889bc8bf1f467cbc7d2c18c03c230');
        $this->checkFile('themes/merchants/WooPrice/commission_recurring.tpl', 'aa827abeee6bb0f472b500c096cd3625');
        $this->checkFile('themes/merchants/WooPrice/commission_sale.tpl', 'fbdf7f44f6df291e9da9e8172dcad9ce');
        $this->checkFile('themes/merchants/WooPrice/commission_subsales.tpl', 'c21fc8858085c294ac7630f53d6bd36e');
        $this->checkFile('themes/merchants/WooPrice/commission_tabs.tpl', '2eec354045cec652c7cd4ff1cfc8bf56');
        $this->checkFile('themes/merchants/WooPrice/commission_tiers_info_panel.tpl', '20e88ef5e3d641ecd6dd8fea0350b7e1');
        $this->checkFile('themes/merchants/WooPrice/commission_type_detail.tpl', 'd6d266aba20845c41e04fd8dbfa33732');
        $this->checkFile('themes/merchants/WooPrice/commission_type_sail_detail.tpl', '73a00350b64b30cb1b5341e050982d83');
        $this->checkFile('themes/merchants/WooPrice/commissions_details_view.tpl', '6481e92bb25a139b55290e0d5b209cdd');
        $this->checkFile('themes/merchants/WooPrice/commissions_edit.tpl', '9ec2a9da2c0eaf09392f96b836bc0310');
        $this->checkFile('themes/merchants/WooPrice/commissions_panel.tpl', 'ff232af7da984c8e346b2bc9b8a6ca88');
        $this->checkFile('themes/merchants/WooPrice/compressed_commission_settings.tpl', 'b355949c5d9849b51c1f59f96c7e4acc');
        $this->checkFile('themes/merchants/WooPrice/comunication_overview_panel.tpl', '06ea7c53421b51e4a8fed669637a909f');
        $this->checkFile('themes/merchants/WooPrice/config_aff_panel.tpl', '58c2a6eae06023e889cee734923b713e');
        $this->checkFile('themes/merchants/WooPrice/config_affiliates.tpl', '4870980191d1873460bbc2d8894b2bf2');
        $this->checkFile('themes/merchants/WooPrice/config_communication.tpl', 'b7af569e05800de423c52fc28d7bc40b');
        $this->checkFile('themes/merchants/WooPrice/config_currencies_form.tpl', 'cdff097c17040c60be3ace45afa62642');
        $this->checkFile('themes/merchants/WooPrice/config_currency_tab.tpl', '57c84054dcf9ca885c39c1d9bddb860c');
        $this->checkFile('themes/merchants/WooPrice/config_date_format.tpl', '771f72b6514cd4c9103217a955fb171d');
        $this->checkFile('themes/merchants/WooPrice/config_language_and_date_form.tpl', '1ad6231d44243a014dd06b3a18709fac');
        $this->checkFile('themes/merchants/WooPrice/config_overview.tpl', '60db4f006e3afe01077620baf9bc19fa');
        $this->checkFile('themes/merchants/WooPrice/config_signup_form.tpl', '884261ef7e0c23326874bd92cdda1094');
        $this->checkFile('themes/merchants/WooPrice/config_system.tpl', '783ebbddb4a39f395967456062db2396');
        $this->checkFile('themes/merchants/WooPrice/config_theme_panel.tpl', '0de67f6fa7a5bed65cbd6268fa414fd0');
        $this->checkFile('themes/merchants/WooPrice/config_themes.tpl', '0bab46cdedf333176ecb62c8cdc1d672');
        $this->checkFile('themes/merchants/WooPrice/config_tracking.tpl', '81056b36d3ec69a8fac9d843ed7d7240');
        $this->checkFile('themes/merchants/WooPrice/confirm_dialog.tpl', 'f92a8f6b3081444abf7fc4ab63c99302');
        $this->checkFile('themes/merchants/WooPrice/confirm_dialog_label_note.tpl', 'f76c3c08642335eb7b3e0ce42bfe753a');
        $this->checkFile('themes/merchants/WooPrice/confirm_dialog_label_value.tpl', '0c2d427e2c1c8f4545a90a3a56e64580');
        $this->checkFile('themes/merchants/WooPrice/confirm_dialog_with_checkbox.tpl', '9e1fd32194d6bfabb251bad0645755da');
        $this->checkFile('themes/merchants/WooPrice/confirm_dialog_with_value.tpl', '46e7630a0a094110f6819ea655683337');
        $this->checkFile('themes/merchants/WooPrice/content_gadget_panel.tpl', '79428f6a77f38592dfa1716653bbe79b');
        $this->checkFile('themes/merchants/WooPrice/context_menu.tpl', 'cddf235a2fec1ae75063d576ccdc6185');
        $this->checkFile('themes/merchants/WooPrice/cookie_lifetime_group.tpl', 'ea8a6a5ad128f265d7d6891a41fdf097');
        $this->checkFile('themes/merchants/WooPrice/cookies_tab.tpl', '0ee8a325e03187328807a5c149eb90be');
        $this->checkFile('themes/merchants/WooPrice/copy_campaign.tpl', 'a12f62962eb0cb273f54414f688f091a');
        $this->checkFile('themes/merchants/WooPrice/copy_user_role.tpl', '31c4493a09a1d2ad96e0c6133399199c');
        $this->checkFile('themes/merchants/WooPrice/countries_list_scrolling_wrapper.tpl', '4bf0a92924334c72075b4ddafd3b243b');
        $this->checkFile('themes/merchants/WooPrice/country_commission_type_panel.tpl', 'e7586309287420a9851dc0ab3ce65563');
        $this->checkFile('themes/merchants/WooPrice/country_select_panel.tpl', '8503f8f693cc44082380626a7b0ebbfc');
        $this->checkFile('themes/merchants/WooPrice/country_specific_commission_type_panel.tpl', 'db0122ec2a13ac87a9443a6dc4594302');
        $this->checkFile('themes/merchants/WooPrice/coupons_filter.tpl', '4caab93e4b46d2f0fff1d619536efb8b');
        $this->checkFile('themes/merchants/WooPrice/coupons_import.tpl', 'e9bb34e160a258ff1deb1dfe55f0e4a5');
        $this->checkFile('themes/merchants/WooPrice/coupons_panel.tpl', 'dcb054cd9abe5cbea02724014d27c7ef');
        $this->checkFile('themes/merchants/WooPrice/create_banners_buttons.tpl', 'd981b97a16d7f5620a85944aa8d550f7');
        $this->checkFile('themes/merchants/WooPrice/cron_job_integration.tpl', '0bd75d5d32d1d775a4c81a7cc1a41cdb');
        $this->checkFile('themes/merchants/WooPrice/currencies_no_data.tpl', 'e3a2a92b3119abe6bca9ce0b0e505c28');
        $this->checkFile('themes/merchants/WooPrice/currency_form.tpl', 'dbee13da7abe05b10990f7ee89eee4be');
        $this->checkFile('themes/merchants/WooPrice/currency_textbox.tpl', 'b25a0b754d14d14452ecb52e0a090d2a');
        $this->checkFile('themes/merchants/WooPrice/custom.css', '4877ef2467745239a93ebe1e79b2f813');
        $this->checkFile('themes/merchants/WooPrice/custom_cookie_panel.tpl', 'b1b3a9b5c5aa2b7de8e67fa2975bbf0e');
        $this->checkFile('themes/merchants/WooPrice/custom_date_panel.tpl', 'c624f3d63d0e94db867529dc13a827d1');
        $this->checkFile('themes/merchants/WooPrice/custom_filter_element.tpl', 'bf05e5d299fb1982ea8139f2a605846b');
        $this->checkFile('themes/merchants/WooPrice/custom_filter_field.tpl', '21c8ab135d5d89e320ec85456ec457e0');
        $this->checkFile('themes/merchants/WooPrice/custom_time_panel.tpl', 'd408a8352774d70124788d61a90493b6');
        $this->checkFile('themes/merchants/WooPrice/daily_report.tpl', 'ae280bf29c298b0a0e28944cc61c9e86');
        $this->checkFile('themes/merchants/WooPrice/daily_report_filter.tpl', '4fb9b31f01026eb252955d75c0428d99');
        $this->checkFile('themes/merchants/WooPrice/data_field.tpl', 'dd553594505158cd53cc285d3a91fe23');
        $this->checkFile('themes/merchants/WooPrice/data_field_with_help.tpl', '4615cdd789beea34c16b4c1f692a3a3b');
        $this->checkFile('themes/merchants/WooPrice/database_status_panel.tpl', '57191b13eff4abf914143e15b97bac30');
        $this->checkFile('themes/merchants/WooPrice/date_number_format_panel.tpl', 'e26284328d2ba7da47d30e8e458c13b1');
        $this->checkFile('themes/merchants/WooPrice/date_preset_panel.tpl', 'abc7d225baa948aed70cc1073b786fe8');
        $this->checkFile('themes/merchants/WooPrice/date_range_filter.tpl', '3875dbc075f33ccaac856190ee103557');
        $this->checkFile('themes/merchants/WooPrice/date_range_filter_field.tpl', '94048704212b6797b7b7a08fb7888da9');
        $this->checkFile('themes/merchants/WooPrice/date_textbox.tpl', '4d2bf89bd754bbaccc15e48d7a37dd02');
        $this->checkFile('themes/merchants/WooPrice/daterange_popup.tpl', 'dc1728d13b0440b8df5e12359010168a');
        $this->checkFile('themes/merchants/WooPrice/datetimepickercontent.tpl', '9771684f29bc88d974cc64283055d1d1');
        $this->checkFile('themes/merchants/WooPrice/deeplink_generator_network_setting_edit.tpl', '818d1c4a3bb685f4cb6e825a2c577d82');
        $this->checkFile('themes/merchants/WooPrice/default_campaign_form.tpl', '2524ebdb94130b6701af650fb63c9c68');
        $this->checkFile('themes/merchants/WooPrice/default_theme_config.tpl', 'fd3377e1da30c75e82ed6db948bc9199');
        $this->checkFile('themes/merchants/WooPrice/description_panel.tpl', 'eb196bc81ac670a6081876c8d17158c0');
        $this->checkFile('themes/merchants/WooPrice/design_panel.tpl', 'ee823fb6ea6bc06ff8ab43422a986363');
        $this->checkFile('themes/merchants/WooPrice/desktop.tpl', 'b653025800e416896bd453246061a535');
        $this->checkFile('themes/merchants/WooPrice/desktop_gadget.tpl', '21394ff13337e4716860c12b5e4fb312');
        $this->checkFile('themes/merchants/WooPrice/desktop_main_menu.tpl', '31eb02f3f6b767d24012753d50ff5159');
        $this->checkFile('themes/merchants/WooPrice/desktop_settings_mode.tpl', '1054d3be606383580f8d521f2d72682f');
        $this->checkFile('themes/merchants/WooPrice/destination.tpl', '3f11435e707dc3ef178328280ef4614e');
        $this->checkFile('themes/merchants/WooPrice/destination_panel.tpl', 'f8a860741ffc1e8bdd52437db021caaf');
        $this->checkFile('themes/merchants/WooPrice/direct_link_form.tpl', '021296b8ff10db11432c3429c779c8a6');
        $this->checkFile('themes/merchants/WooPrice/direct_link_grid_widget.tpl', '586c3b902d66c903d87e510bca5843ec');
        $this->checkFile('themes/merchants/WooPrice/directlinks_advanced_filter.tpl', '65c2e2150b56faacebc94ec4eb426935');
        $this->checkFile('themes/merchants/WooPrice/directlinks_list.tpl', '3047fe6b8e221bb3e186190f6eeeeb3f');
        $this->checkFile('themes/merchants/WooPrice/directlinks_list_no_data.tpl', 'f1f450f7a011578950f7253089286a34');
        $this->checkFile('themes/merchants/WooPrice/disclosure_content.tpl', '27557135898f8d0dc1ff849cba4f875a');
        $this->checkFile('themes/merchants/WooPrice/download_auto_reg_banner_form.tpl', '8ef3e7205380f487fa84bc4eaf5f5c63');
        $this->checkFile('themes/merchants/WooPrice/download_auto_reg_iframe_form.tpl', '59498b35efce960fd3b4871d26d7855b');
        $this->checkFile('themes/merchants/WooPrice/download_auto_reg_link_form.tpl', '33484bae042f1bde3a5a163eab5570f0');
        $this->checkFile('themes/merchants/WooPrice/download_login_form.tpl', 'd73ed70f4d96b76f37965d9f8c753ac5');
        $this->checkFile('themes/merchants/WooPrice/download_signup_form.tpl', 'e608aa9b32b4b044d528815cb9392516');
        $this->checkFile('themes/merchants/WooPrice/drag_container.tpl', '358104feb6f9c3c2a01206e460726eac');
        $this->checkFile('themes/merchants/WooPrice/dynamic_form_panel.tpl', 'ea42da62b4a44f1fa9caf50a59c29160');
        $this->checkFile('themes/merchants/WooPrice/edit_affiliate_page_page.tpl', '367f8d79bdffc8cb0dcc344e2c1c79bd');
        $this->checkFile('themes/merchants/WooPrice/edit_destination_url_widget.tpl', 'd0918936a67033179b7b41946e54ddb5');
        $this->checkFile('themes/merchants/WooPrice/edit_textarea_widget.tpl', '94b2c94dd103b5209bd89470fc70268c');
        $this->checkFile('themes/merchants/WooPrice/edit_tracking_code_widget.tpl', '059499fee95c96a9e0fc37b517b0e72a');
        $this->checkFile('themes/merchants/WooPrice/editor.tpl', 'a8c5483c720526b56fa899a91045c287');
        $this->checkFile('themes/merchants/WooPrice/editor_with_constants_panel.tpl', '6c9e8d91f33bc90c661e9b67ca5ff1e1');
        $this->checkFile('themes/merchants/WooPrice/email_form.tpl', '7809f19dc7e837c8dbe6f4d58e6574b7');
        $this->checkFile('themes/merchants/WooPrice/email_notifications.tpl', '6e8120071227fb823ed1af6f1b3ad223');
        $this->checkFile('themes/merchants/WooPrice/email_setting_smtp_form.tpl', 'd17124a143f842ab1876ed14a74bc762');
        $this->checkFile('themes/merchants/WooPrice/email_settings_spf.tpl', 'ca349c37b841ccef522f8767817bf1d2');
        $this->checkFile('themes/merchants/WooPrice/email_settings_tab.tpl', '029bff75bc5d1d6eda64c14de2c4d88e');
        $this->checkFile('themes/merchants/WooPrice/email_template_edit_panel.tpl', '0673c3c609ca2fa5a693bcc03986a0d6');
        $this->checkFile('themes/merchants/WooPrice/expand_matrix.tpl', 'dc72b136436320776269f40795008156');
        $this->checkFile('themes/merchants/WooPrice/expired_session_dialog.tpl', 'ba711bd5d1e932ffc4fbc8e601204905');
        $this->checkFile('themes/merchants/WooPrice/export_files_panel.tpl', 'ea4620e2d7d8da656e903d2a1ee80fec');
        $this->checkFile('themes/merchants/WooPrice/export_panel.tpl', '054b8f0de5cb1cd25ce50d914b6c64a1');
        $this->checkFile('themes/merchants/WooPrice/export_to_csv.tpl', '472a1e543ad141354022ce9ce4d16e56');
        $this->checkFile('themes/merchants/WooPrice/extendable_commission_data.tpl', '43b5108a8212bccdb414370023388e10');
        $this->checkFile('themes/merchants/WooPrice/extendable_text.tpl', 'a69efdb298a3aae26e26793c9b9fea36');
        $this->checkFile('themes/merchants/WooPrice/extendable_text_content.tpl', 'cca4ebdf72f3cb7638b6c5bf0f59d9aa');
        $this->checkFile('themes/merchants/WooPrice/extendable_text_widget.tpl', '83288dfd8795a2a9105965dde2ebc927');
        $this->checkFile('themes/merchants/WooPrice/feature_detail.tpl', 'b23eb80665302207d86365efbef72846');
        $this->checkFile('themes/merchants/WooPrice/feature_on_activate.tpl', '544374f96c5524c306a5c6f6f956200c');
        $this->checkFile('themes/merchants/WooPrice/feature_on_deactivate.tpl', 'a1767954af4547adcfb12cf4107f3468');
        $this->checkFile('themes/merchants/WooPrice/feature_settings.tpl', '13e5f54c1b98e65f9a4132abe613c188');
        $this->checkFile('themes/merchants/WooPrice/fee_panel.tpl', '6c4f808bd9b75f8fc11e4fce3196994c');
        $this->checkFile('themes/merchants/WooPrice/field_type_edit.tpl', 'b1294ba5d4486ea1cf8022a51e277a11');
        $this->checkFile('themes/merchants/WooPrice/file_widget.tpl', 'a7410b3e376c1b177c47831f83a68c55');
        $this->checkFile('themes/merchants/WooPrice/files_tree_panel.tpl', 'e11e884c210779b572bc928e01cf3d96');
        $this->checkFile('themes/merchants/WooPrice/filter.tpl', 'd51de72535f52fc100a59cad0a15fd37');
        $this->checkFile('themes/merchants/WooPrice/filter_field_decorator.tpl', '531d57478d7718e216ea04ff79d493ca');
        $this->checkFile('themes/merchants/WooPrice/filter_form.tpl', '67551720cbc190c8df85c24d3f8a4cbe');
        $this->checkFile('themes/merchants/WooPrice/font/Titillium/TitilliumWeb-Black.ttf', '42f7635089a79cbee683dea44317d627');
        $this->checkFile('themes/merchants/WooPrice/font/Titillium/TitilliumWeb-Black.woff', '2c43c3759ff678fb0b343380e1813b2e');
        $this->checkFile('themes/merchants/WooPrice/font/Titillium/TitilliumWeb-Bold.ttf', '5ead9f49abe9f8e6245c0d9f5c31fde4');
        $this->checkFile('themes/merchants/WooPrice/font/Titillium/TitilliumWeb-Bold.woff', 'e9542b9f4b66d94ec265e87a679e8d88');
        $this->checkFile('themes/merchants/WooPrice/font/Titillium/TitilliumWeb-Light.ttf', 'aefd3e5229c69eb9d6af08a08df46255');
        $this->checkFile('themes/merchants/WooPrice/font/Titillium/TitilliumWeb-Light.woff', '1541d554558df286b889c2c4848204ff');
        $this->checkFile('themes/merchants/WooPrice/font/Titillium/TitilliumWeb-Regular.ttf', 'ad51f12c62f6e11300c25bd2ea696266');
        $this->checkFile('themes/merchants/WooPrice/font/Titillium/TitilliumWeb-Regular.woff', '48573bcb38bf5624363f2c538019a682');
        $this->checkFile('themes/merchants/WooPrice/font/Titillium/TitilliumWeb-SemiBold.ttf', '292d3d436d085b5e691f23722cdee7ae');
        $this->checkFile('themes/merchants/WooPrice/font/Titillium/TitilliumWeb-SemiBold.woff', 'e4ac435feb5ea77c7672924cc9ec1b0d');
        $this->checkFile('themes/merchants/WooPrice/font/fontello.eot', 'cc4c3813496412813e92ce25c7b963e3');
        $this->checkFile('themes/merchants/WooPrice/font/fontello.svg', '66090721850d522363f5745b6265983f');
        $this->checkFile('themes/merchants/WooPrice/font/fontello.ttf', 'baf30392615b9f8dd06420642304e9fb');
        $this->checkFile('themes/merchants/WooPrice/font/fontello.woff', 'aca17066a8fe19fe88404827ede14eee');
        $this->checkFile('themes/merchants/WooPrice/font/fontello.woff2', '58f62b369b922e87b001bacc5d4e2274');
        $this->checkFile('themes/merchants/WooPrice/fontello.css', '7abe36cc2ed0ccbbaad467c15445aa12');
        $this->checkFile('themes/merchants/WooPrice/footer.stpl', '3fbd103789f1ff2a151c16f490a913dd');
        $this->checkFile('themes/merchants/WooPrice/forced_matrix_panel.tpl', '0f06e2a7d0482fa847967cd918e0e614');
        $this->checkFile('themes/merchants/WooPrice/form_field.tpl', '5c7ae4b0f01f4a7753ab811e0a57f29f');
        $this->checkFile('themes/merchants/WooPrice/form_field_checkbox.tpl', 'c1f1746d1bf5c7abfaf9e5ddb7b4cc52');
        $this->checkFile('themes/merchants/WooPrice/form_field_checkboxgroup.tpl', 'be1b525a89f033d4f79433dd3eaab593');
        $this->checkFile('themes/merchants/WooPrice/form_field_radio.tpl', '9013ed97a5fc7b4b52052d816a9b25d0');
        $this->checkFile('themes/merchants/WooPrice/frame_panel.tpl', '7b13a1add8ba712d8a34f4285414b419');
        $this->checkFile('themes/merchants/WooPrice/fraud_protection_clicks.tpl', '73301bfff7cb1dd3780e29dbb344c2e5');
        $this->checkFile('themes/merchants/WooPrice/fraud_protection_form.tpl', 'd0992b66d5f952ca446613a5f74b5f3a');
        $this->checkFile('themes/merchants/WooPrice/fraud_protection_logins.tpl', '219e554a2a20528c0d83188d36e5cf67');
        $this->checkFile('themes/merchants/WooPrice/fraud_protection_sales.tpl', '793795df266e0941ce8bccff6813ab07');
        $this->checkFile('themes/merchants/WooPrice/fraud_protection_signups.tpl', '11dc6c3dd936cdda2667149211a62a19');
        $this->checkFile('themes/merchants/WooPrice/full_banner_stats.tpl', '9c8d43347b069c27ac3a1af40909a95e');
        $this->checkFile('themes/merchants/WooPrice/full_commision_stats.tpl', '267321735038275c392ddf30a5c4d35d');
        $this->checkFile('themes/merchants/WooPrice/full_payout_stats.tpl', '6c5e691e6069884d5d1be146054c14dd');
        $this->checkFile('themes/merchants/WooPrice/full_transaction_stats.tpl', '2669b46d3f14aa9c57872f5373c2797d');
        $this->checkFile('themes/merchants/WooPrice/general_no_data.stpl', '03433ae7bf79c177a476922c2ee779c5');
        $this->checkFile('themes/merchants/WooPrice/generate_coupons_form.tpl', 'beddaaf1aa37c10aab9838f1c4b8f1e8');
        $this->checkFile('themes/merchants/WooPrice/generate_htaccess.tpl', '05d9d8606bdf35455fb48ec7f928b702');
        $this->checkFile('themes/merchants/WooPrice/geoip_commissiontype_detailpanel.tpl', '734dc6f1a0cc432cd287f22ef5824f49');
        $this->checkFile('themes/merchants/WooPrice/geoip_fraudprotection_affiliates.tpl', '8fadf652ac9ea3507a4a6173faf8eb62');
        $this->checkFile('themes/merchants/WooPrice/geoip_fraudprotection_clicks.tpl', 'db19ca033fb30646f0ae504d43683c92');
        $this->checkFile('themes/merchants/WooPrice/geoip_fraudprotection_logins.tpl', '660ab5115a24ae974e9739dde8530d30');
        $this->checkFile('themes/merchants/WooPrice/geoip_fraudprotection_logins_aff.tpl', 'af98bdbc38201d8c9db2d63c83ccdf9d');
        $this->checkFile('themes/merchants/WooPrice/geoip_fraudprotection_sales.tpl', 'c2c170214c10ba59d591261e85dc4cff');
        $this->checkFile('themes/merchants/WooPrice/get_pdf.tpl', '7de69c1b98a6f1cac1f9c8e570e3b6b9');
        $this->checkFile('themes/merchants/WooPrice/getting_started_icons.tpl', '612e44ecb9bc1526bd8694a0655342bf');
        $this->checkFile('themes/merchants/WooPrice/getting_started_merchant.tpl', '9f02ac92cddb211fce5fb826fe7473e5');
        $this->checkFile('themes/merchants/WooPrice/google_recaptcha_settings.tpl', 'b93feccb5cdfccc02846aea495459127');
        $this->checkFile('themes/merchants/WooPrice/gpf.css', 'ec27b549fa06e9420afb4e6d56ee3a96');
        $this->checkFile('themes/merchants/WooPrice/gpf_db_mail.tpl', 'b5ea5e9ecef2152fdf967085a7689adc');
        $this->checkFile('themes/merchants/WooPrice/grid.tpl', 'c0efa81ea11d739f933438236d6fb12d');
        $this->checkFile('themes/merchants/WooPrice/grid_bottombuttons.tpl', '1aa9463da984fac10b988d8758c82297');
        $this->checkFile('themes/merchants/WooPrice/grid_bottomgridline.tpl', '9bf2013a170e094e82dc1ae0a2ed0f97');
        $this->checkFile('themes/merchants/WooPrice/grid_nodata.tpl', '340ff6de789cd7277a35d763f6366f24');
        $this->checkFile('themes/merchants/WooPrice/grid_pager.tpl', '46e6d959616563985ece2d92c0234826');
        $this->checkFile('themes/merchants/WooPrice/grid_selector.tpl', 'ff2d81e3866f53d540a0d063bdf7b480');
        $this->checkFile('themes/merchants/WooPrice/grid_topbuttons.tpl', 'b605a4f548962d4bf0c8d8662353b795');
        $this->checkFile('themes/merchants/WooPrice/grid_topgridline.tpl', '3ff9c43cb7f7fcbbcdc7f03c8822a70d');
        $this->checkFile('themes/merchants/WooPrice/header.tpl', '32d459ea9f7ebf7a241715058cc91f38');
        $this->checkFile('themes/merchants/WooPrice/home_edit.tpl', '1e659b8ee09e43c02d567356206c7c93');
        $this->checkFile('themes/merchants/WooPrice/home_edit_main_template.tpl', 'cd4fbd7e59c2c1813b4b1c9d54025223');
        $this->checkFile('themes/merchants/WooPrice/home_edit_merch_template.tpl', '1079945929a23a68a38676fe78432211');
        $this->checkFile('themes/merchants/WooPrice/home_panel.tpl', '1404c1c1a5f5048ce23760ddd33a49b3');
        $this->checkFile('themes/merchants/WooPrice/home_panel_content.stpl', '9c352e615bb4e6b3741e0362cb5888d4');
        $this->checkFile('themes/merchants/WooPrice/horizontal_layout_panel.tpl', '8b6098cd64720cff686cc24e06ac4c17');
        $this->checkFile('themes/merchants/WooPrice/hosted_account.tpl', 'e58e46daeeb498d85227982e6ee6ae2d');
        $this->checkFile('themes/merchants/WooPrice/hosted_account_plan.tpl', 'bfb67b63d21a4482e2528a4fb581629c');
        $this->checkFile('themes/merchants/WooPrice/htaccess_panel.tpl', 'b3632f76f8ab6d2e56f7a776401dedaf');
        $this->checkFile('themes/merchants/WooPrice/html_preview.tpl', '08392603f2252347986bb4b341e964dd');
        $this->checkFile('themes/merchants/WooPrice/html_preview_iframe_panel.tpl', '22405951702ab2132d0fe99577f4968e');
        $this->checkFile('themes/merchants/WooPrice/html_preview_image_panel.tpl', 'ebc5b8605c42ac31f653b65deb66e04d');
        $this->checkFile('themes/merchants/WooPrice/icon_button.tpl', 'a7497a39fe733586fb4f5a1b9f424b0f');
        $this->checkFile('themes/merchants/WooPrice/icon_object.tpl', 'ff8d25e63eca03b325c4501e13358fb2');
        $this->checkFile('themes/merchants/WooPrice/icon_picker.tpl', '77a002b90f678df44bcca5776f314820');
        $this->checkFile('themes/merchants/WooPrice/icon_picker_panel.tpl', '4342c424a8cb290701f64d0cb63655ec');
        $this->checkFile('themes/merchants/WooPrice/icon_status_widget.tpl', 'ff9e2bc87e203324cc33c4b3ac365dfe');
        $this->checkFile('themes/merchants/WooPrice/icons_panel_with_header.tpl', '97091a954a48c0889fa82a2464266e84');
        $this->checkFile('themes/merchants/WooPrice/image_uploader.tpl', '9f93ea577dd2511b19071fa735b6b684');
        $this->checkFile('themes/merchants/WooPrice/img/FB_share_button.png', 'a56c7efd784eb61b5ac1e6f4111f59a8');
        $this->checkFile('themes/merchants/WooPrice/img/LinkedIn_share_button.png', 'd0dfb70a7e64ee73f718af05ce995875');
        $this->checkFile('themes/merchants/WooPrice/img/cards.jpg', '36a8e2ad3f39a4c9c71c8abbcec24823');
        $this->checkFile('themes/merchants/WooPrice/img/cron_job_example.png', 'f0cd89597b814b000ef2775c2f9dea1b');
        $this->checkFile('themes/merchants/WooPrice/img/dirty.gif', 'decca3b96e2c37cf6eb04ddb0d9f669b');
        $this->checkFile('themes/merchants/WooPrice/img/doc.png', 'c914d3518532910b13728f3d9b43056d');
        $this->checkFile('themes/merchants/WooPrice/img/draggable.png', 'ab4fb4e3c82ccb353b30640cc36eaf67');
        $this->checkFile('themes/merchants/WooPrice/img/favicon.ico', 'ac3e93c93589318e5dcf69efc8a76176');
        $this->checkFile('themes/merchants/WooPrice/img/feature.png', 'a17a20726ab706b8cc4d7ad89ee36ef9');
        $this->checkFile('themes/merchants/WooPrice/img/folder.png', '74ad8feccb7ac18bde1380dd7bdbdd06');
        $this->checkFile('themes/merchants/WooPrice/img/html.png', '23bf6c9bc9121ffd0c273b5414faaba0');
        $this->checkFile('themes/merchants/WooPrice/img/icon-128.png', 'a450a0dd5959518fdb2308cc5e523bcc');
        $this->checkFile('themes/merchants/WooPrice/img/icon-192.png', '8cb72062e4df9eab6c2a064459a5ee62');
        $this->checkFile('themes/merchants/WooPrice/img/image.png', '66517d22e9c688e521951b3c2d4498e0');
        $this->checkFile('themes/merchants/WooPrice/img/input.png', '0df09f38346ba18c1a69510138fc7bea');
        $this->checkFile('themes/merchants/WooPrice/img/insert.png', '1eb65fc224afb8e9bb81bf6182e7fe22');
        $this->checkFile('themes/merchants/WooPrice/img/line.short.gif', '13914f3810787c4d0571df1fd447627e');
        $this->checkFile('themes/merchants/WooPrice/img/no.theme.thumbnail.jpg', 'db2b9f70f5fe89a3c9c2f98d69b19254');
        $this->checkFile('themes/merchants/WooPrice/img/no_image.gif', '07f5f79d487dbf795f7ea37a04aa24c0');
        $this->checkFile('themes/merchants/WooPrice/img/pan-logo.svg', 'a00e0890d1da3f81a0ddf2d27c111504');
        $this->checkFile('themes/merchants/WooPrice/img/pap-logo.svg', '5e82bd9eddbcd704a8b581b5c5037d54');
        $this->checkFile('themes/merchants/WooPrice/img/paypal.jpg', '1e18c3feef21be6605c97f5ac72e7453');
        $this->checkFile('themes/merchants/WooPrice/img/pdf.png', 'f8dfa3fa0386adcd2370c6d509a0be91');
        $this->checkFile('themes/merchants/WooPrice/img/php.png', '2c63cf93ca9b1ff5d5b16c6646a59ddc');
        $this->checkFile('themes/merchants/WooPrice/img/secure.png', '4490e30d2ac3700e78315f510dfff342');
        $this->checkFile('themes/merchants/WooPrice/img/swf.png', '1623343ec1b366081175a4d28feb66ae');
        $this->checkFile('themes/merchants/WooPrice/img/tabs.png', 'fce94d82812219c0ed1b98840637ec3b');
        $this->checkFile('themes/merchants/WooPrice/img/theme_thumbnail.jpg', '3014bad2020df24b2faf687683f95b47');
        $this->checkFile('themes/merchants/WooPrice/img/txt.png', '79520d0ef237730c55eb5bcd50b78ea2');
        $this->checkFile('themes/merchants/WooPrice/img/unknown_file.png', '3a00859ebcd6dfef1572ecdddbe693fe');
        $this->checkFile('themes/merchants/WooPrice/img/video.png', '9681c0591166287c6c3144837fdf1008');
        $this->checkFile('themes/merchants/WooPrice/img/wysiwyg.gif', '017283b1ab06fc9391f796f2c13b0da8');
        $this->checkFile('themes/merchants/WooPrice/img/xls.png', '3f2844cce5616ee82f1e0dc0b9f0d53b');
        $this->checkFile('themes/merchants/WooPrice/img/zip.png', 'ce15cafabf396370aac29085b3c1a5dd');
        $this->checkFile('themes/merchants/WooPrice/import_coupons_form.tpl', '8fc3b5964331ebd6232227b4f8fa937d');
        $this->checkFile('themes/merchants/WooPrice/import_custom_language_panel.tpl', 'f14fe8af188194edeb7896eb3284c5b1');
        $this->checkFile('themes/merchants/WooPrice/import_export_panel.tpl', '7562d00dfa6c2eb770a88757ba736996');
        $this->checkFile('themes/merchants/WooPrice/import_language.tpl', '20d22e5e6eebf43dc6143490803aaa03');
        $this->checkFile('themes/merchants/WooPrice/import_panel.tpl', 'd8370787bb8f6d6e702c72ed8f7a744d');
        $this->checkFile('themes/merchants/WooPrice/import_theme_panel.tpl', '5fbd6be91a3a7dbf7b2def44f344b889');
        $this->checkFile('themes/merchants/WooPrice/info_dialog.tpl', '886c377f8e8c1b2c6957451436e1d090');
        $this->checkFile('themes/merchants/WooPrice/integration.tpl', '939839cb552c71fdcb243c4a34aa35ee');
        $this->checkFile('themes/merchants/WooPrice/integration_method.tpl', 'cfdd3053443ce85b757a89dc64ddd45e');
        $this->checkFile('themes/merchants/WooPrice/integration_method_step.tpl', '4661c951290cf670ee9c26b45fff0a8c');
        $this->checkFile('themes/merchants/WooPrice/integration_methods.tpl', 'f5f0fe244869bc5da0517349aba9d291');
        $this->checkFile('themes/merchants/WooPrice/integration_methods_advanced.tpl', '0e72005d09820e3a2f057ea3c71cb7a7');
        $this->checkFile('themes/merchants/WooPrice/invoice_data_panel.tpl', '1ac898a59516e468e0f047d97db210c6');
        $this->checkFile('themes/merchants/WooPrice/invoice_form.tpl', '62a0cbc7e109fc019bcc00457b556594');
        $this->checkFile('themes/merchants/WooPrice/invoices_filter.tpl', '77faa6e4fbeb2cc872a975a1800fa6a7');
        $this->checkFile('themes/merchants/WooPrice/invoices_list.tpl', '4ee98efc16f05c766be1ae760cc3837c');
        $this->checkFile('themes/merchants/WooPrice/ip_detail.tpl', 'ff7f24d21c8ac5aa1f3645cd8d59663a');
        $this->checkFile('themes/merchants/WooPrice/item.tpl', '717eff0e06a712a76effb2d6723183b5');
        $this->checkFile('themes/merchants/WooPrice/item_panel.tpl', 'b24ed05bdf4cb76a7afc1e9a9908def8');
        $this->checkFile('themes/merchants/WooPrice/keywords_performance.tpl', '0a76bec58708a4041df21ab9548abadc');
        $this->checkFile('themes/merchants/WooPrice/keywords_performance_advanced_filter.tpl', '618269ec4149b6ffab19282eb9d1a2c5');
        $this->checkFile('themes/merchants/WooPrice/label_panel.tpl', 'e0c85a01af8477fe16cb6770fbb5e7af');
        $this->checkFile('themes/merchants/WooPrice/language_create_new.tpl', '486f695b2fe3d17aaf29ae39e7f7e0ea');
        $this->checkFile('themes/merchants/WooPrice/language_edit_panel.tpl', '5b8d472500f9e38a967306d007409d1f');
        $this->checkFile('themes/merchants/WooPrice/language_translations_filter.tpl', '930f22e595469a617570927021bf9d15');
        $this->checkFile('themes/merchants/WooPrice/language_translations_grid.tpl', 'a4247bb921179c395cf7a2972cbcef3f');
        $this->checkFile('themes/merchants/WooPrice/languages_configuration.tpl', 'a146b693cd6b18b1f7711d750e444175');
        $this->checkFile('themes/merchants/WooPrice/layout_panel_content.tpl', '353b904baf333a2e0456ef5cb0fa179c');
        $this->checkFile('themes/merchants/WooPrice/layout_panel_header_navigation.tpl', '6b0d746501001da8615a22d57266dcb0');
        $this->checkFile('themes/merchants/WooPrice/layout_panel_tab.tpl', '27ee274cfd12ed770eff98d0913dd8e8');
        $this->checkFile('themes/merchants/WooPrice/license_invalid.tpl', '6181e1127345050c94d6708cd805aefb');
        $this->checkFile('themes/merchants/WooPrice/lifetime_referral_edit.tpl', '3d3923ef67ea430835a1f951955543b2');
        $this->checkFile('themes/merchants/WooPrice/lifetime_referrals_filter.tpl', 'dcac6d377be0092c4fbf75b5ff6824e8');
        $this->checkFile('themes/merchants/WooPrice/lifetime_referrals_import.tpl', '327f3397a82c6613ec6ab3718f916982');
        $this->checkFile('themes/merchants/WooPrice/lifetime_referrals_panel.tpl', '57fdc30f1434427f31e456701817165a');
        $this->checkFile('themes/merchants/WooPrice/link_button.tpl', '71fad92bff79f1fd2e1066818afac789');
        $this->checkFile('themes/merchants/WooPrice/link_method_panel.tpl', '9af6c599de2f311cb0149524b50ff20d');
        $this->checkFile('themes/merchants/WooPrice/linking_method.tpl', '7e0919bff0810701acf299531e0ef0eb');
        $this->checkFile('themes/merchants/WooPrice/listbox.tpl', '2739c2a9e22d54280cacf4d67ed2e7bc');
        $this->checkFile('themes/merchants/WooPrice/listbox_popup.tpl', '8c45877411c0727e814eb5e3caa76822');
        $this->checkFile('themes/merchants/WooPrice/listdown_button.tpl', 'a1cd26a1aec6d403420971d7469a6f1b');
        $this->checkFile('themes/merchants/WooPrice/lite_campaign_wizard.tpl', 'eaa5d01dd5deee48986f5f98f22caf40');
        $this->checkFile('themes/merchants/WooPrice/load_mail_from_template.tpl', '42c0029422eaf077a5b0c316cd3317b5');
        $this->checkFile('themes/merchants/WooPrice/loadable_tree.tpl', 'e2c214b134bffe5fe2bb38f679a64eb5');
        $this->checkFile('themes/merchants/WooPrice/loading_screen.tpl', '34ccb2c18cf3ba7225b2107a1c6a8002');
        $this->checkFile('themes/merchants/WooPrice/log_filter.tpl', '7f09ae6ce70590ead04d534e6019fca9');
        $this->checkFile('themes/merchants/WooPrice/log_list.tpl', '17f5cd218930723c21afa914b4fee8fe');
        $this->checkFile('themes/merchants/WooPrice/logging_tab.tpl', 'bbe2b73c70c24bbafb56a75ed4279f81');
        $this->checkFile('themes/merchants/WooPrice/logging_tab_debug.tpl', '32912cc60dfc885333623335a44ab19c');
        $this->checkFile('themes/merchants/WooPrice/logging_tab_logins_history.tpl', 'e59ce588474c4019a05eafd91c45bd2c');
        $this->checkFile('themes/merchants/WooPrice/login.tpl', 'e7be8367104ee7221547730250f9b0f0');
        $this->checkFile('themes/merchants/WooPrice/login_form.tpl', '68fec5fc89be1ee473d62ac966211289');
        $this->checkFile('themes/merchants/WooPrice/login_main.tpl', '5b3eb0529047463ac6b90a529de64d85');
        $this->checkFile('themes/merchants/WooPrice/logins_history.tpl', '1ef6edb0f2167b8d05c961c7d6379f92');
        $this->checkFile('themes/merchants/WooPrice/loginshistory_filter.tpl', '6fa20923cc33142105a51ef6f3a51ad7');
        $this->checkFile('themes/merchants/WooPrice/logo_settings.tpl', '6c5dbe6195a7b19dd0e0dcb58a207523');
        $this->checkFile('themes/merchants/WooPrice/logs_no_data.tpl', 'c807c1484862c46a3f72f1ea0d276b3f');
        $this->checkFile('themes/merchants/WooPrice/mail_detail_data.tpl', '72d679a44b2ad0f888e829b479e6550e');
        $this->checkFile('themes/merchants/WooPrice/mail_outbox_panel.tpl', 'fa6291a64c1e5a21237be44f192a8c99');
        $this->checkFile('themes/merchants/WooPrice/mail_template_not_selected.tpl', '8f8e4d19a09cd7bc7e96df0e0729ef8d');
        $this->checkFile('themes/merchants/WooPrice/mail_template_preview.tpl', 'ea7d0df5aef2645e05d768c51a294389');
        $this->checkFile('themes/merchants/WooPrice/mail_template_test_form.tpl', 'd5c10c451945fe2cd1545ab10c11a959');
        $this->checkFile('themes/merchants/WooPrice/mail_templates.tpl', 'cceaeaa496bd10868bcf67ef9f9acc45');
        $this->checkFile('themes/merchants/WooPrice/mail_templates_list.tpl', '2834084fc2e4bef6ffd06fd86a650a17');
        $this->checkFile('themes/merchants/WooPrice/mailoutbox_filter.tpl', '59f66fe33f07d333de586095367ca23d');
        $this->checkFile('themes/merchants/WooPrice/mailoutbox_list_no_data.tpl', '12637515858ca4d960c6202e8a89042b');
        $this->checkFile('themes/merchants/WooPrice/main.tpl', '13404ad9b5a64fa4683f5d12c05c1e03');
        $this->checkFile('themes/merchants/WooPrice/main_error_html_doc.tpl', 'e99d46538cab7c9fe32dc247711589d3');
        $this->checkFile('themes/merchants/WooPrice/main_filter_panel.tpl', '0985a7421f898d75d4df72b4a6081c49');
        $this->checkFile('themes/merchants/WooPrice/main_html_doc.tpl', '6573d111c7572702244cad9b8ade1d09');
        $this->checkFile('themes/merchants/WooPrice/main_integration_steps_icons.tpl', '2107115d75013a0ad392566bb3fa1d54');
        $this->checkFile('themes/merchants/WooPrice/main_menu.tpl', '1036ce189dc092adca21d6405e83544f');
        $this->checkFile('themes/merchants/WooPrice/map_overlay.tpl', '9deb511a7295d19349480562f6771d87');
        $this->checkFile('themes/merchants/WooPrice/map_overlay_advanced_filter.tpl', 'd41f999b16fbe6f34fe9315aff388a67');
        $this->checkFile('themes/merchants/WooPrice/map_overlay_edit.tpl', 'd173ac586a3502e61f80a956597e1496');
        $this->checkFile('themes/merchants/WooPrice/mass_pay_export.tpl', 'c90a423ab30d28f949c8ce738bab8375');
        $this->checkFile('themes/merchants/WooPrice/mass_pay_export_form.tpl', 'c3b9939154fe31ce081f9c4edee7c410');
        $this->checkFile('themes/merchants/WooPrice/menu_entry.tpl', '64a9c8f6b89eb5d0fb9a2d174b5f0427');
        $this->checkFile('themes/merchants/WooPrice/menu_section.tpl', 'cec8b58c248868d64eaddc18923f7743');
        $this->checkFile('themes/merchants/WooPrice/merchant_category_info.tpl', 'ecf110e07235298eb0403fdb6c8a1448');
        $this->checkFile('themes/merchants/WooPrice/merchant_tutorial_video.tpl', 'ce8d0f0aad10353b46888942abfb96e5');
        $this->checkFile('themes/merchants/WooPrice/messages.tpl', 'bf1a3bac08c419320acb94673ad29f0b');
        $this->checkFile('themes/merchants/WooPrice/module_body.stpl', 'c079addcd33eb725ab7efbf09c16a793');
        $this->checkFile('themes/merchants/WooPrice/month_banner_stats.tpl', 'fc0ecc72cbc42efa3835713eebcf8d4f');
        $this->checkFile('themes/merchants/WooPrice/multi_editor.tpl', '6cd4d8823bd6b67cd3e0a2aa2cf52b29');
        $this->checkFile('themes/merchants/WooPrice/multi_form_widget.tpl', '3f92d96633ec487b28dc6bfae7cc8e30');
        $this->checkFile('themes/merchants/WooPrice/multiple_currencies_panel.tpl', 'c7b959fe11ad02a2fcbe22f5f62d344b');
        $this->checkFile('themes/merchants/WooPrice/multiselect.tpl', '9d1863b21edd131520315ce252fde639');
        $this->checkFile('themes/merchants/WooPrice/network_invoice.tpl', 'da2d8c12f409758081a229e78c1306fe');
        $this->checkFile('themes/merchants/WooPrice/network_proforma_invoice.tpl', '5f9dcea372e00363e6dc2ffbdd5a8187');
        $this->checkFile('themes/merchants/WooPrice/news_content.tpl', 'a576598444bb0db20fa8d47854f1ef34');
        $this->checkFile('themes/merchants/WooPrice/news_filter.tpl', '59508e33dc1a696ffa5a18d5f619eedd');
        $this->checkFile('themes/merchants/WooPrice/news_form_edit.tpl', '517272eac91c024292fe594cecae2c28');
        $this->checkFile('themes/merchants/WooPrice/news_item.tpl', '18161a56a8f4dc5df01f08191709f864');
        $this->checkFile('themes/merchants/WooPrice/news_list.tpl', 'f37df45ddce385805e34da5d81b17a1f');
        $this->checkFile('themes/merchants/WooPrice/news_panel.tpl', '0e6eda2d6e6edab31d596d86939f0933');
        $this->checkFile('themes/merchants/WooPrice/newsletter_broadcast_form.tpl', '1ccb4e8c2a3873263c7c8c1fc7c19f27');
        $this->checkFile('themes/merchants/WooPrice/newsletter_broadcasts.tpl', 'e85ba6dc04b3a921af601f6bf976a5b8');
        $this->checkFile('themes/merchants/WooPrice/newsletter_edit_panel.tpl', '73ddca2129beb12e11215b1c55e70461');
        $this->checkFile('themes/merchants/WooPrice/newsletter_form.tpl', 'e86bb366b8986ac4cb1b50c9ccc94b8e');
        $this->checkFile('themes/merchants/WooPrice/no_category_selected_settings_panel.tpl', '28bc9d284f2cbec3dde908dc0d4e9f7c');
        $this->checkFile('themes/merchants/WooPrice/no_content_gadgets.tpl', '1d4ce600d473f33e2b229101a50cbc3f');
        $this->checkFile('themes/merchants/WooPrice/no_language_selected.tpl', 'd61125f2b1cf78e4e66653d4e2f04bdd');
        $this->checkFile('themes/merchants/WooPrice/note_filter.tpl', '5984797bddb6b9dff4b4066106da1bcf');
        $this->checkFile('themes/merchants/WooPrice/notification_window.tpl', 'db781872bdb9748bc838e051b8e5e4e2');
        $this->checkFile('themes/merchants/WooPrice/offline_sale.tpl', '589eb1238aac5800197e6e56a26cacf7');
        $this->checkFile('themes/merchants/WooPrice/offline_sale_form.tpl', '86fe26a2a1e02d811e892233db9d6b5e');
        $this->checkFile('themes/merchants/WooPrice/online_users.tpl', '1242aa25d7ed7b3a278684e0d4a13c4c');
        $this->checkFile('themes/merchants/WooPrice/online_users_gadget_rolecount.tpl', '5fd6af0c5f2edec24d0e35dc00a9e870');
        $this->checkFile('themes/merchants/WooPrice/online_users_gadget_template.tpl', '80ebdfe2a212375942cac09081e371b2');
        $this->checkFile('themes/merchants/WooPrice/onlinegadgets_no_data.tpl', 'f5f692a433b4911963a92c41cc269768');
        $this->checkFile('themes/merchants/WooPrice/onlineusers_filter.tpl', 'a5ec412a7f620cb47ddcf48b9f0d6625');
        $this->checkFile('themes/merchants/WooPrice/order_id_filter.tpl', 'ea89a8c9ef5a3f13f5fca4c6dcbf6860');
        $this->checkFile('themes/merchants/WooPrice/orgchart_affiliate_widget.tpl', '32f4faf30d0289ffd4c9d53f92a39388');
        $this->checkFile('themes/merchants/WooPrice/overview_panel.tpl', '1874d6377cb2a53e5eba387cd0874215');
        $this->checkFile('themes/merchants/WooPrice/overview_stats_panel.tpl', '674d3c5e07dddbfcc6b89bfa7b420640');
        $this->checkFile('themes/merchants/WooPrice/page_header.tpl', '4fd5676c44341f95ee0435c1f78da534');
        $this->checkFile('themes/merchants/WooPrice/page_type_radio.tpl', 'd132376c54a57b3962d1ca08eda22000');
        $this->checkFile('themes/merchants/WooPrice/panel_footer.stpl', '9ac4165a950d1760c4b0ed086c71788e');
        $this->checkFile('themes/merchants/WooPrice/pap4.css', 'b3562faade40c2a98af54992a1b16b4c');
        $this->checkFile('themes/merchants/WooPrice/pap4.rtl.css', '5b744d25c853662fd04eec8a17255704');
        $this->checkFile('themes/merchants/WooPrice/parameter_names_form.tpl', '32bfa373ae61cdae7c70a202ba921e62');
        $this->checkFile('themes/merchants/WooPrice/password_constraint_panel.tpl', '6d328bcd04ea68b87c18d4fd52099888');
        $this->checkFile('themes/merchants/WooPrice/password_panel.tpl', 'b1440553a785aae589233a91315b281f');
        $this->checkFile('themes/merchants/WooPrice/pay_affilates_form.tpl', '47ca863e6f0e46c4b2e631d2ebd313f0');
        $this->checkFile('themes/merchants/WooPrice/pay_affiliate_template.tpl', '692261c025aab9b05408b9651de9a894');
        $this->checkFile('themes/merchants/WooPrice/pay_affiliates.tpl', '9a08ef03ed4b0d076203c45c369918d1');
        $this->checkFile('themes/merchants/WooPrice/pay_affiliates_filter.tpl', 'b614af81b7bae93abeec49415de0f758');
        $this->checkFile('themes/merchants/WooPrice/pay_affiliates_list.tpl', '85b17725f87d1ea59102020c1f290070');
        $this->checkFile('themes/merchants/WooPrice/pay_affiliates_no_data.tpl', 'bdd593288f13c714bdb19de5d264318c');
        $this->checkFile('themes/merchants/WooPrice/pay_invoice_form.tpl', 'c7490c619a883b6b90c2817b22025984');
        $this->checkFile('themes/merchants/WooPrice/payee_info.tpl', '740af57f0054d67e6c689466e90980d8');
        $this->checkFile('themes/merchants/WooPrice/payee_info_main.tpl', '8048bb0c734d26af0a077e1728b2e814');
        $this->checkFile('themes/merchants/WooPrice/payout_data.tpl', 'b6f6f6c19617690d683128ee13b8b688');
        $this->checkFile('themes/merchants/WooPrice/payout_fields_form.tpl', '0f8a8b9516b729ab4899926ead42be16');
        $this->checkFile('themes/merchants/WooPrice/payout_fields_no_data.tpl', '22728157d2ebba66c42b8632edcc2eee');
        $this->checkFile('themes/merchants/WooPrice/payout_history_form.tpl', 'fdf50ed31df6ef2a90efc52c043f13f8');
        $this->checkFile('themes/merchants/WooPrice/payout_history_list_no_data.tpl', 'eaea8ff071a4da8272b5b57616544789');
        $this->checkFile('themes/merchants/WooPrice/payout_history_template.tpl', '94edd75586374bd10a9e765ceb78e910');
        $this->checkFile('themes/merchants/WooPrice/payout_invoice_format.tpl', 'c33ad82f202fb7fc45f83d2c8d547efa');
        $this->checkFile('themes/merchants/WooPrice/payout_methods_filter_field.tpl', '3e44e83bdfd9080f05070dd2281dcfd2');
        $this->checkFile('themes/merchants/WooPrice/payout_option_form.tpl', '309c28785f0a1aa14ded20d7037c6d3e');
        $this->checkFile('themes/merchants/WooPrice/payout_options_form.tpl', '747bdbfe5eca6068d61275e19f4472a4');
        $this->checkFile('themes/merchants/WooPrice/payout_options_no_data.tpl', '19f1bead958da75d50d38d893f93f4e1');
        $this->checkFile('themes/merchants/WooPrice/payout_options_text_box.tpl', '9d7c675a676c204bafaa2c1f32b3f6a4');
        $this->checkFile('themes/merchants/WooPrice/payout_settings_icons.tpl', 'aa4813c156afb53ed10a02319166c340');
        $this->checkFile('themes/merchants/WooPrice/payouts_balance_form.tpl', 'd01274716d5700a7180cd8277b575cb0');
        $this->checkFile('themes/merchants/WooPrice/payouts_balance_settings.tpl', '61c8ca2e6971fef86250e0b1a3adcb41');
        $this->checkFile('themes/merchants/WooPrice/payouts_history.tpl', '8a1c74d4f1312a63ceee7907076e2d45');
        $this->checkFile('themes/merchants/WooPrice/payouts_history_filter.tpl', '49514d217f0a77dcd9cbae68ab504e38');
        $this->checkFile('themes/merchants/WooPrice/payouts_to_affiliates.tpl', '6e8868d55f61a825057b3890e0ec4afd');
        $this->checkFile('themes/merchants/WooPrice/payouts_to_affiliates_filter.tpl', '06f0e81d2ad6a474fb81ccaef755477d');
        $this->checkFile('themes/merchants/WooPrice/payoutstoaffiliates_list_no_data.tpl', '1bf1e39b51797acb2bac6428dabb0929');
        $this->checkFile('themes/merchants/WooPrice/peel_banner_feature_on_deactivate.tpl', '88a989ccfb54f68203c01176a104541f');
        $this->checkFile('themes/merchants/WooPrice/pending_backround_tasks.tpl', '9c91e4d0f413f7d7327783449c4222d7');
        $this->checkFile('themes/merchants/WooPrice/pending_tasks.tpl', '3aa9f9ee68b7ef3258fe7a9c3994f952');
        $this->checkFile('themes/merchants/WooPrice/pending_tasks_data.tpl', '1916b1db72af25350e122542f2261eb3');
        $this->checkFile('themes/merchants/WooPrice/pending_tasks_panel.tpl', '16eaedf4545a03d89f94b98e3adacfa4');
        $this->checkFile('themes/merchants/WooPrice/pending_tasks_template.tpl', '091fb315fbb9a3d24bf16baa791bd32f');
        $this->checkFile('themes/merchants/WooPrice/performance_rewards.tpl', 'e6376beacf92f7086e4cf7b1a3e97d29');
        $this->checkFile('themes/merchants/WooPrice/performance_rewards_filter.tpl', 'daf43de0e8c03e9a97f0aaf22b173461');
        $this->checkFile('themes/merchants/WooPrice/placement_overview_filter.tpl', '6132598add92f772fb46568f94f0e5cc');
        $this->checkFile('themes/merchants/WooPrice/placement_overview_panel.tpl', 'd0d0bef4390bbf53b43e4207aba245f3');
        $this->checkFile('themes/merchants/WooPrice/plugin_configuration.tpl', '9f4b075baf454033271fc4219c272737');
        $this->checkFile('themes/merchants/WooPrice/plugin_detail.tpl', '097b49ceeac4111d1fd96f3cd8d2b049');
        $this->checkFile('themes/merchants/WooPrice/plugins_list.tpl', '72c87aa08ebd9a6218fcb300d6ec675c');
        $this->checkFile('themes/merchants/WooPrice/popup_actions_panel.tpl', 'ef01a0f4fa742fc99a03632e1d6876b4');
        $this->checkFile('themes/merchants/WooPrice/popup_form_widget.tpl', '0f5d2ef3d678d026df06fe1f1e5991a8');
        $this->checkFile('themes/merchants/WooPrice/postsignup_radio.tpl', '6b32ad7886413081192c2ba5dd514275');
        $this->checkFile('themes/merchants/WooPrice/postsignup_settings_page.tpl', '3657e859769d3db637b6a83e45ab218d');
        $this->checkFile('themes/merchants/WooPrice/postsignup_settings_url.tpl', 'c854a3cb764d4be9af656abf45398193');
        $this->checkFile('themes/merchants/WooPrice/private_campaigns_feature_on_deactivate.tpl', 'ecef84105dc2779ac2fb428da2e9f25f');
        $this->checkFile('themes/merchants/WooPrice/proxy_server_configuration.tpl', '618f166a4be6b32f563aaeffd5f1931e');
        $this->checkFile('themes/merchants/WooPrice/qualityunit_news.stpl', '188a98161e9218eb440aab2d33341a0c');
        $this->checkFile('themes/merchants/WooPrice/quick_report_base.tpl', '03394fc9a529f4d9d13f8cbcb664be8f');
        $this->checkFile('themes/merchants/WooPrice/quick_report_content.stpl', 'a75ca3ba3fc385de73eae7311f79c650');
        $this->checkFile('themes/merchants/WooPrice/quick_report_content_multitier.stpl', 'e45556a573992274576437d9d34bdd71');
        $this->checkFile('themes/merchants/WooPrice/quick_report_filter_base.tpl', '40541d4b075161fc37bea2086e429e23');
        $this->checkFile('themes/merchants/WooPrice/quick_report_multitier_widget.tpl', '24108ad66b123214ae2c170aaa4ec369');
        $this->checkFile('themes/merchants/WooPrice/quick_stats_actions_panel.tpl', 'd0816b90a3fbe4f4ffa09a37aec14268');
        $this->checkFile('themes/merchants/WooPrice/quick_stats_box.tpl', '745d64595b8a0e5869bfc1e9bf10b9c2');
        $this->checkFile('themes/merchants/WooPrice/quicklaunch_settings.tpl', '1e595ebaeb4364f173ee3fec71c1762d');
        $this->checkFile('themes/merchants/WooPrice/radio_button_group_row.tpl', '3713f6d400aa1ca96d9e404082304912');
        $this->checkFile('themes/merchants/WooPrice/radio_form_panel.tpl', 'c56091f134178fc494aa76df1b6ad6a1');
        $this->checkFile('themes/merchants/WooPrice/rebrand_pdf_feature_on_deactivate.tpl', '57adefe6824afba7c2477b79c5663843');
        $this->checkFile('themes/merchants/WooPrice/recaptcha_settings.tpl', 'd40a2e0759211b13af22180aef80b380');
        $this->checkFile('themes/merchants/WooPrice/recipients.tpl', '6c334400d00281b1b04bfc28c654f2a3');
        $this->checkFile('themes/merchants/WooPrice/recurring_commission_edit.tpl', 'f144dcac07b3913bb6dfb866e4871d9d');
        $this->checkFile('themes/merchants/WooPrice/recurring_commission_filter.tpl', 'bd70625a017204c62a4563c92cb72e72');
        $this->checkFile('themes/merchants/WooPrice/recurring_commission_list.tpl', 'b6d7546e3e8ef3fafa122019d01531f8');
        $this->checkFile('themes/merchants/WooPrice/recurring_commissions.tpl', '8c806617d38c467e2f29e22bb43e826c');
        $this->checkFile('themes/merchants/WooPrice/referringurl_advanced_filter.tpl', 'e064d6689bc281e60c830c70acd8f3c3');
        $this->checkFile('themes/merchants/WooPrice/refresh_panel.tpl', '5c709df4d219d5feb4f29003ca932f77');
        $this->checkFile('themes/merchants/WooPrice/regional_settings.tpl', '899786b4a8c655defc732008fae917e7');
        $this->checkFile('themes/merchants/WooPrice/regional_settings_tab.tpl', '808fee97d86d7a2400d4e4de198359dc');
        $this->checkFile('themes/merchants/WooPrice/replicated_site_source_radio.tpl', '7d280f4647e9269bca20b70e4e64d077');
        $this->checkFile('themes/merchants/WooPrice/report_filter.tpl', 'cfa31cd337c81b3e863f97b664581327');
        $this->checkFile('themes/merchants/WooPrice/report_problems.tpl', '6c4035620c09202f2165e94e99635ceb');
        $this->checkFile('themes/merchants/WooPrice/reports_screen.tpl', '7ec70fbbc8d7b81b1a98c932ea1c1267');
        $this->checkFile('themes/merchants/WooPrice/request_new_password_form.tpl', 'e4e20e8042328f80b7b400e39d921986');
        $this->checkFile('themes/merchants/WooPrice/resizable_text_area.tpl', '7995c217048ccd289dfee567a455b08e');
        $this->checkFile('themes/merchants/WooPrice/richlistbox.tpl', '13229a43763945932dc8d5d7fa21d08e');
        $this->checkFile('themes/merchants/WooPrice/richlistbox_popup.tpl', 'c155c59eea77770589bcadca0c75f1af');
        $this->checkFile('themes/merchants/WooPrice/richtext_editor.tpl', '99af0e75e8761690e55e65fa238d8d4c');
        $this->checkFile('themes/merchants/WooPrice/richtext_editor_toolbar.tpl', '3798b9151ed1d87c99e5783005c81773');
        $this->checkFile('themes/merchants/WooPrice/richtexteditor_addlink.tpl', 'c9bd3a510535abef1076a29328f069e7');
        $this->checkFile('themes/merchants/WooPrice/role_privileges.tpl', '30e7afc5bc26d51388efbf226e837411');
        $this->checkFile('themes/merchants/WooPrice/rotator_preview_merchant.stpl', 'f4a8b7e2a320d263c11e080652136aa8');
        $this->checkFile('themes/merchants/WooPrice/rule_conditions_panel.tpl', 'eb2d93cd36c8a15eb8b8c219d89cbec9');
        $this->checkFile('themes/merchants/WooPrice/rule_conditions_panel_full.tpl', '52061284c52dc90ca96e902ac2d0e623');
        $this->checkFile('themes/merchants/WooPrice/rule_panel.tpl', '836f9d642a2304b320b799fd156d04bf');
        $this->checkFile('themes/merchants/WooPrice/search_filter.tpl', 'c43c492cae5282a628238b4ff75508b2');
        $this->checkFile('themes/merchants/WooPrice/search_gadget.tpl', 'dd1ccaf3d497e365f8ea8d999a89cc29');
        $this->checkFile('themes/merchants/WooPrice/search_gadget_entries_panel.tpl', 'b60a5fd89e628c401c86eee54073243e');
        $this->checkFile('themes/merchants/WooPrice/search_gadget_popup.tpl', 'ad5359afa9edeb864b0929d40a05e466');
        $this->checkFile('themes/merchants/WooPrice/search_gadget_popup_entry.tpl', 'd4c0f584509bbc3c0db48a061dab51fc');
        $this->checkFile('themes/merchants/WooPrice/selectbutton_search.tpl', 'dedb23ce356b1b66377e648232dc2b8b');
        $this->checkFile('themes/merchants/WooPrice/send_mail_to_affiliate.tpl', '757d0224a850eb6a32175367add64442');
        $this->checkFile('themes/merchants/WooPrice/send_mass_mail.tpl', '515c3046b1058c4b313af52b6859a18d');
        $this->checkFile('themes/merchants/WooPrice/set_new_password_form.tpl', '9270391a0892b67b03efbd67084806c6');
        $this->checkFile('themes/merchants/WooPrice/sidebar.tpl', '65226d7e25dcdca0cf71a9f3118d8139');
        $this->checkFile('themes/merchants/WooPrice/sidebar_closed.tpl', '3d903661713a9ee5fb402776ee06d310');
        $this->checkFile('themes/merchants/WooPrice/sidebar_gadget.tpl', '1f904859e056808c8826836a4e256761');
        $this->checkFile('themes/merchants/WooPrice/signup_commissions.tpl', 'e88a6f8eb2b970efe40609b59a103f45');
        $this->checkFile('themes/merchants/WooPrice/signup_form_design.tpl', '5786a51864065a89ea059e03826048c7');
        $this->checkFile('themes/merchants/WooPrice/signup_url_panel.tpl', '9578396ed90325350510e89493bc5101');
        $this->checkFile('themes/merchants/WooPrice/simple_filter.tpl', 'a55a1095bcbdbef9d9d9f5e2078b19a2');
        $this->checkFile('themes/merchants/WooPrice/simple_icon_object.tpl', 'bcbc9ea994d4aa8bbdee1eddc3ad19d8');
        $this->checkFile('themes/merchants/WooPrice/simple_popup_window.tpl', 'e7d6ad58d85a85eab20414bb734b8c81');
        $this->checkFile('themes/merchants/WooPrice/simplecolorpicker.tpl', '9c031fbdd2b35909faeea73e5f1203a1');
        $this->checkFile('themes/merchants/WooPrice/single_content_panel.tpl', '529d4a42f9106d91881f8b8b8e87748b');
        $this->checkFile('themes/merchants/WooPrice/site_replication_feature_on_deactivate.tpl', 'a9a5007e2b045fcddb5649780343250c');
        $this->checkFile('themes/merchants/WooPrice/size_format_widget.tpl', 'ebfb7db6718ec601af59a570d8e0ccb3');
        $this->checkFile('themes/merchants/WooPrice/spillover.tpl', 'b88774d1a43ea2c8b638a75c59411588');
        $this->checkFile('themes/merchants/WooPrice/spillover_affiliate_panel.tpl', 'a31389658f2a6052020cad731dff7671');
        $this->checkFile('themes/merchants/WooPrice/split_commissions_edit.tpl', '79b93073097985ea9b70b50708f9f361');
        $this->checkFile('themes/merchants/WooPrice/split_commissions_edit_help.tpl', 'b8c0076fd8c6f725a44728f9c36e1633');
        $this->checkFile('themes/merchants/WooPrice/split_commissions_feature_on_activate.tpl', '3c0a020b1e83cc8c0f13cc18c823c20d');
        $this->checkFile('themes/merchants/WooPrice/start_button.tpl', '7aa2278c46b897536625cc042b4f5499');
        $this->checkFile('themes/merchants/WooPrice/statistics_double_value_widget.tpl', '7e243a39277ad97843b418e45881a6d2');
        $this->checkFile('themes/merchants/WooPrice/statistics_filter.tpl', '90764aa6c165d35f0eac8273a596c963');
        $this->checkFile('themes/merchants/WooPrice/statistics_tab.tpl', '2848d44a5dc972d9812c2aa7f0b16614');
        $this->checkFile('themes/merchants/WooPrice/stats_chart.tpl', 'b5bb3d9a0dd5361a4e34e479aacf2480');
        $this->checkFile('themes/merchants/WooPrice/sub_menu_section.tpl', 'f14329a6ad21f2551a068111201c9918');
        $this->checkFile('themes/merchants/WooPrice/sum_payouts_to_affiliates.tpl', '4c94936fcc7cc7be82f86e1eb2e8df9e');
        $this->checkFile('themes/merchants/WooPrice/sum_payouts_to_affiliates_filter.tpl', '4ff8a5479e29e9ca336f282f0fd51b85');
        $this->checkFile('themes/merchants/WooPrice/system_menu.tpl', '414133fa4f1a7e794444f72e6aad3cf7');
        $this->checkFile('themes/merchants/WooPrice/tab_item.tpl', 'd869bc1a3b8c511712e039399333d129');
        $this->checkFile('themes/merchants/WooPrice/tab_panel.tpl', '8c2853c4e62119a5b6f89c5e340af5d3');
        $this->checkFile('themes/merchants/WooPrice/task.tpl', '38a4b70b6456a12285be4bb113c72575');
        $this->checkFile('themes/merchants/WooPrice/taskbar.tpl', 'd7cf8ef7a71bf324aee5c1c7173afc7e');
        $this->checkFile('themes/merchants/WooPrice/template_form.tpl', '1a0d6777f298f5a2a71f6efea7ac459f');
        $this->checkFile('themes/merchants/WooPrice/template_form_constants.tpl', '91c398393e519cf7c6a53ba758eefc47');
        $this->checkFile('themes/merchants/WooPrice/template_form_theme_entry.tpl', '91a40d5bfbb3ff3b61cd7771e24a2684');
        $this->checkFile('themes/merchants/WooPrice/template_form_themes.tpl', 'e7158c1782ef49ddbf3fbe671c5c5b8a');
        $this->checkFile('themes/merchants/WooPrice/template_form_variables.tpl', 'e1c008058f4be04a9e6e76ba72cc3290');
        $this->checkFile('themes/merchants/WooPrice/templates_form.tpl', '7a0a1baf13edabb10c8c6bef5a3dac41');
        $this->checkFile('themes/merchants/WooPrice/theme.php', 'e89a4aebd73b5313f4c73661cc851997');
        $this->checkFile('themes/merchants/WooPrice/theme_create_new.tpl', '847cc7b80df92aa24acf0da5afdd0ed3');
        $this->checkFile('themes/merchants/WooPrice/theme_edit_editor.tpl', '1b1b3b083b418ba21ef37522b0934a5f');
        $this->checkFile('themes/merchants/WooPrice/theme_edit_filetree.tpl', '0e6f1bd9c3b11a255eab1e4824f83475');
        $this->checkFile('themes/merchants/WooPrice/theme_edit_image.tpl', 'cc7ae652219ab87a267bf87631e9dc43');
        $this->checkFile('themes/merchants/WooPrice/theme_edit_none.tpl', '291239b715e2f1e962011564bf549e5e');
        $this->checkFile('themes/merchants/WooPrice/theme_edit_unsupported.tpl', '2977467887b418fedc8b42576078f275');
        $this->checkFile('themes/merchants/WooPrice/theme_editor_panel.tpl', '566661806fd2d4b3ce443277d71959f5');
        $this->checkFile('themes/merchants/WooPrice/theme_panel.tpl', '07b850efc37a68fe58fcdb067a81271d');
        $this->checkFile('themes/merchants/WooPrice/theme_settings.tpl', '5c596388ecc46c2ac89c029f811f565e');
        $this->checkFile('themes/merchants/WooPrice/time_conditions_panel.tpl', '5942b39a9c0a5cec26c315580d9df644');
        $this->checkFile('themes/merchants/WooPrice/timezone_settings.tpl', 'f1bb95540fb8855093d35b284817369d');
        $this->checkFile('themes/merchants/WooPrice/timezone_settings_tab.tpl', 'f89569e5d47f73e9c872ed4026fefcfa');
        $this->checkFile('themes/merchants/WooPrice/tooltip_popup.tpl', 'e4a5b50c70875ee64d9fdf4f88fa8045');
        $this->checkFile('themes/merchants/WooPrice/top_afffiliates_list.tpl', '286e2ac7096bc38ef5507691de9f17a6');
        $this->checkFile('themes/merchants/WooPrice/top_affiliates_filter.tpl', 'b3ed7a34051548c53736298042eb2243');
        $this->checkFile('themes/merchants/WooPrice/topurl_list.tpl', 'f108c2b8e2583a45a2016869735c87d3');
        $this->checkFile('themes/merchants/WooPrice/tracking_tab.tpl', '8abcd2a1c88351a3a16795feda6750b4');
        $this->checkFile('themes/merchants/WooPrice/traffic_info.tpl', 'd8084bc576645ae6485c9384c74b42e4');
        $this->checkFile('themes/merchants/WooPrice/traffic_stats_gadget.tpl', 'da081a1eba4470008e9f5e0165ecd7d6');
        $this->checkFile('themes/merchants/WooPrice/traffic_stats_in_gadget.tpl', 'b6ffda3596f992ce68d25d72fa923751');
        $this->checkFile('themes/merchants/WooPrice/trafic_and_sales_report.tpl', '6723e4f293c26fed32855b086cb6318e');
        $this->checkFile('themes/merchants/WooPrice/transaction_form.tpl', '8ef3d9c8be8655191b10b6ceb6b8627a');
        $this->checkFile('themes/merchants/WooPrice/transaction_form_edit.tpl', '73debd09259e1daf3b7e6d50ccf8aee0');
        $this->checkFile('themes/merchants/WooPrice/transaction_form_notes.tpl', '648b29094d534cfc6b8d7683440505f0');
        $this->checkFile('themes/merchants/WooPrice/transaction_form_tracking.tpl', 'fc35d874eebd664e3b6da64f8d36b903');
        $this->checkFile('themes/merchants/WooPrice/transaction_info.tpl', '689fb8c420b25ed9e1460edae68b92e0');
        $this->checkFile('themes/merchants/WooPrice/transaction_list.tpl', '4d28f9612adefe432e937dea2f6ccf2a');
        $this->checkFile('themes/merchants/WooPrice/transaction_list_filter_base.tpl', '7d0ad12c7fc041af03abba828a3bacc4');
        $this->checkFile('themes/merchants/WooPrice/transaction_list_no_data.tpl', 'f91882c034dcec76ed668d2fa6e5863f');
        $this->checkFile('themes/merchants/WooPrice/transaction_panel.tpl', '4f6297bd3273c5a64ae474c3989dd834');
        $this->checkFile('themes/merchants/WooPrice/transaction_reports.tpl', 'ef0c25832283bcfe9d9cc37cd13ac41e');
        $this->checkFile('themes/merchants/WooPrice/transactions_import.tpl', '18ea606dee038315e72e0e1049666ca3');
        $this->checkFile('themes/merchants/WooPrice/trash.tpl', '270d020eabfcf284be7a97e7102924d5');
        $this->checkFile('themes/merchants/WooPrice/tree_affiliate_widget.tpl', 'd6d133404cf44bcd4d057ddc9e0b573f');
        $this->checkFile('themes/merchants/WooPrice/tree_draggable_items.tpl', '869b3cbe1a546cf76baa397b8360495b');
        $this->checkFile('themes/merchants/WooPrice/trend_actions_stats.tpl', '01beef973c394417de5a58de2857a1e5');
        $this->checkFile('themes/merchants/WooPrice/trend_actions_stats_widget.tpl', '7c26676ceb09baf3fafeb0dba3bdaec4');
        $this->checkFile('themes/merchants/WooPrice/trend_stats.tpl', '5423abd62baeb237c0c5feb600e84937');
        $this->checkFile('themes/merchants/WooPrice/trends_report.stpl', '18264d58de48af1de2b77137b0df48fb');
        $this->checkFile('themes/merchants/WooPrice/trends_report.tpl', '8c3ecd3db7c864a8cbbd04e92363467c');
        $this->checkFile('themes/merchants/WooPrice/trends_report_action.stpl', '929fa1c9535d05f1e8a0492013b9de33');
        $this->checkFile('themes/merchants/WooPrice/trends_report_filter.tpl', 'cacaca9e199f9c7b74916541a340c31a');
        $this->checkFile('themes/merchants/WooPrice/trends_report_no_data.tpl', '9d1dd7b6d3ef5f6ada42de2c7d182df2');
        $this->checkFile('themes/merchants/WooPrice/troubleshooting.tpl', '8ec5482d68f08a103cf0883b10308e9f');
        $this->checkFile('themes/merchants/WooPrice/update_version.stpl', '5602f52fe8248df474201a16c922048f');
        $this->checkFile('themes/merchants/WooPrice/upload_panel.tpl', '222a0dd80ab37bb49060da0cf7eaf447');
        $this->checkFile('themes/merchants/WooPrice/uploaded_file.tpl', 'fad11b13e3b41eff41a129b1af232e7e');
        $this->checkFile('themes/merchants/WooPrice/user_edit.tpl', 'f41ba1817ee0d15f16c57dff5be39bb1');
        $this->checkFile('themes/merchants/WooPrice/vat_settings.tpl', '628456504f54a037d9ba2f08ba3fbdc5');
        $this->checkFile('themes/merchants/WooPrice/verify_panel.tpl', '79aa97bc204438e497a55b8e96ee3f6b');
        $this->checkFile('themes/merchants/WooPrice/view_form.tpl', 'e37b380ed96bef78dc0de97ac2a3e379');
        $this->checkFile('themes/merchants/WooPrice/view_form_edit_views.tpl', '957cda42f99a863bd72988472e4d008f');
        $this->checkFile('themes/merchants/WooPrice/view_panel.tpl', '25340a99e4e6b4627de427ada4d1b2bc');
        $this->checkFile('themes/merchants/WooPrice/views_list.tpl', 'eb42ebb392f0237879dfba6547578e98');
        $this->checkFile('themes/merchants/WooPrice/visitor_affiliate_edit.tpl', '61506b2d8b383293922a9cc4929438da');
        $this->checkFile('themes/merchants/WooPrice/visitor_affiliates_filter.tpl', '44d9d5e8bf93948d6220d00187359183');
        $this->checkFile('themes/merchants/WooPrice/visitor_affiliates_list.tpl', '3493ae8f6c4fb7e655667b20a0b46ce9');
        $this->checkFile('themes/merchants/WooPrice/visitor_nonrefclicks_filter.tpl', '6ef69cf81734100ad5d5cf1339ee0ad7');
        $this->checkFile('themes/merchants/WooPrice/visitor_nonrefclicks_list.tpl', '202a7982f1ad5ae2e2310347969b8713');
        $this->checkFile('themes/merchants/WooPrice/visits_sales_log_add.tpl', 'e8d580c16c576c3ec98c1baedac437fa');
        $this->checkFile('themes/merchants/WooPrice/visits_sales_logs_filter.tpl', '5ffb18e5d3dcb8df3f61a03331c91552');
        $this->checkFile('themes/merchants/WooPrice/visits_sales_logs_list.tpl', '2f2c6cb4ab210272ffd87e4d3bff95b4');
        $this->checkFile('themes/merchants/WooPrice/visits_sales_logs_no_data.tpl', '969b350cc45c6f7c68fa6322e98a3de1');
        $this->checkFile('themes/merchants/WooPrice/wallpaper_add_custom.tpl', '2210741b569ef188fa352c977a289261');
        $this->checkFile('themes/merchants/WooPrice/wallpaper_entry.tpl', '64c85f4da7897cd0f34168c62de661b9');
        $this->checkFile('themes/merchants/WooPrice/wallpaper_settings.tpl', 'd160dbed38556231aeac49a96213e4d4');
        $this->checkFile('themes/merchants/WooPrice/welcome_message_panel.tpl', '86f2e7b763c27c55f65b269cd8b95a0d');
        $this->checkFile('themes/merchants/WooPrice/window.tpl', '2391705887d707e05187606c4a819e73');
        $this->checkFile('themes/merchants/WooPrice/window_bottom_left.tpl', 'd14b545c27afa02ab7a919bdeb4c9470');
        $this->checkFile('themes/merchants/WooPrice/window_empty_content.tpl', 'b1535ec719cada5b9f5d98849074b9bd');
        $this->checkFile('themes/merchants/WooPrice/window_header.tpl', '02a337d4184c3924a2792a84493794cc');
        $this->checkFile('themes/merchants/WooPrice/window_header_refresh.tpl', 'fcd47f4585abcac3c3a61ee3991379bc');
        $this->checkFile('themes/merchants/WooPrice/window_left.tpl', '984d69649ec171a5c6b522e795feb904');
        $this->checkFile('themes/merchants/WooPrice/window_move_panel.tpl', 'f5bbd373a758bf76e6efadc94dca4b11');
        $this->checkFile('themes/merchants/WooPrice/wizard_panel.tpl', '3142ce6354cb3e1c86b6c13c1d906189');
        $this->checkFile('themes/merchants/WooPrice/zip_banner_feature_on_deactivate.tpl', '0d58a97804ba953e180301d3bb0d1a37');
        $this->checkFile('themes/merchants/_common_templates/TreeItemWidget.tpl', 'd1bfa5574da9cfa131eef997e0870e92');
        $this->checkFile('themes/merchants/_common_templates/account_fee_form.tpl', '3127f4b9e1a99ead6129392ec1c3aed1');
        $this->checkFile('themes/merchants/_common_templates/account_form.tpl', 'b086a00922e3fc19888a96e53111d52a');
        $this->checkFile('themes/merchants/_common_templates/account_form_show.tpl', '481066cec1fdf42f68f2db4c2fabca35');
        $this->checkFile('themes/merchants/_common_templates/account_form_view.tpl', '9fa67cbce7c6fcf16e1ec708f0662ef7');
        $this->checkFile('themes/merchants/_common_templates/account_fraud_protection_clicks.tpl', '201bc1cdaf3d9126afc12f33b0e2ec4c');
        $this->checkFile('themes/merchants/_common_templates/account_fraud_protection_sales.tpl', '80dc68b2cfdf1f5706cc720476dad18f');
        $this->checkFile('themes/merchants/_common_templates/account_info_data.tpl', '9e3b4acae6a6ca2d3ce297791e17f19d');
        $this->checkFile('themes/merchants/_common_templates/account_notifications_form.tpl', 'c5233b014ed1765c28963f7b3dc080d5');
        $this->checkFile('themes/merchants/_common_templates/account_private_campaign_settings.tpl', 'c934375989b101a4c6f4fbf31b0810b2');
        $this->checkFile('themes/merchants/_common_templates/account_screen.tpl', 'f761462d9dce13d1fb13f66badba9837');
        $this->checkFile('themes/merchants/_common_templates/account_settings.tpl', 'b0b76aa5b006447954a0da6bc152b8d3');
        $this->checkFile('themes/merchants/_common_templates/account_signup_settings_form.tpl', 'c64b207c8692c90afc57d9b40fb2f5af');
        $this->checkFile('themes/merchants/_common_templates/accounting_filter.tpl', '12371fd509ce8e9d4316835b7bafb9bb');
        $this->checkFile('themes/merchants/_common_templates/accounting_gadget_data.tpl', 'd94f4bee085512317d28081b9f1d5c26');
        $this->checkFile('themes/merchants/_common_templates/accounting_gadget_template.tpl', '99927018924623a51361c651857aa116');
        $this->checkFile('themes/merchants/_common_templates/accounting_panel.tpl', 'a95d5eee70654bd6c562e736f4a9f0c5');
        $this->checkFile('themes/merchants/_common_templates/accounting_stats_data.tpl', 'e87e60c2a0ef766fe4d79ba80daf0ee9');
        $this->checkFile('themes/merchants/_common_templates/accounts_fields.tpl', '0aa69c5f580ee041863871cb41f4354e');
        $this->checkFile('themes/merchants/_common_templates/accounts_filter.tpl', 'f4b96ed27c3145eb6c469205688e7bab');
        $this->checkFile('themes/merchants/_common_templates/accounts_invoices_panel.tpl', 'c6457fe6dd3d80e258b585bbdfce5016');
        $this->checkFile('themes/merchants/_common_templates/accounts_panel.tpl', '8872aa136c25f7fc31e15118b4280d20');
        $this->checkFile('themes/merchants/_common_templates/add_affiliate_page.tpl', 'f99335e7e5084182d10829e846bf4349');
        $this->checkFile('themes/merchants/_common_templates/add_affiliate_page_content.tpl', '0f11dbecb7f2f1eea6ab769eb625e322');
        $this->checkFile('themes/merchants/_common_templates/add_affiliate_page_page.tpl', '70a1f240785c415fb99947f94972de26');
        $this->checkFile('themes/merchants/_common_templates/add_affiliate_page_url.tpl', '58f8f5e302e28d28522e7265e3694665');
        $this->checkFile('themes/merchants/_common_templates/add_affiliate_to_campaign.tpl', '9a0839f135b007bafb64f2f1e45423bf');
        $this->checkFile('themes/merchants/_common_templates/add_affiliate_to_group.tpl', 'b10bd30ca3483a5aa3d4e384335478e3');
        $this->checkFile('themes/merchants/_common_templates/add_transaction_form.tpl', '6c9da9a05ee604bb7ad0cc4225c07e88');
        $this->checkFile('themes/merchants/_common_templates/add_user_to_group_form.tpl', 'f5353d26cbc32f5b59f99d0388244462');
        $this->checkFile('themes/merchants/_common_templates/admin_panel.tpl', 'e390458a0704f37afd884ee3c72b34f1');
        $this->checkFile('themes/merchants/_common_templates/admins_panel.tpl', '791cc8cdc1a96c4e3ed4fc336abcf636');
        $this->checkFile('themes/merchants/_common_templates/admins_panel_filter.tpl', '923527607fac98a6b18aa33e8081195e');
        $this->checkFile('themes/merchants/_common_templates/advanced_integration_steps_icons.tpl', 'fc1f4fb9ee86fc80e6ef1e365e0d77f5');
        $this->checkFile('themes/merchants/_common_templates/aff_notifications_form.tpl', 'f2030fa063514f02972b81025f5a0790');
        $this->checkFile('themes/merchants/_common_templates/affilate_advanced_filter.tpl', '2b1a903d62e40405223229d7bf1ebb90');
        $this->checkFile('themes/merchants/_common_templates/affiliate_commission_groups.tpl', '9d4046dbc63fe4b678f8c62ffca79854');
        $this->checkFile('themes/merchants/_common_templates/affiliate_delete.tpl', '8f1ebe30b713a229a5e4482beac7f912');
        $this->checkFile('themes/merchants/_common_templates/affiliate_details.tpl', '69e43b4f90512527e8bbb4c74b6053bd');
        $this->checkFile('themes/merchants/_common_templates/affiliate_edit_commission_groups_no_data.tpl', 'a9756aeb0730e4fd5f4fa9cb6de8012b');
        $this->checkFile('themes/merchants/_common_templates/affiliate_edit_details.tpl', 'f7410b1d1d18f1f8d3af1f1cc8a64161');
        $this->checkFile('themes/merchants/_common_templates/affiliate_edit_details_additional.tpl', 'b4f78aa88431df8c3ced23a3f877b5cf');
        $this->checkFile('themes/merchants/_common_templates/affiliate_edit_dialog.tpl', 'acaf92b10f7821b0f5794593db70df01');
        $this->checkFile('themes/merchants/_common_templates/affiliate_edit_no_payout_history.tpl', 'bf348991cf3025dd361ac16d290b1f1a');
        $this->checkFile('themes/merchants/_common_templates/affiliate_field.tpl', 'a627b9cc7e6ce7dbbacf7de80342a97a');
        $this->checkFile('themes/merchants/_common_templates/affiliate_fields.tpl', '2847d63c50fc09034818285f388ce992');
        $this->checkFile('themes/merchants/_common_templates/affiliate_general_settings.tpl', '7488db48de8eb25f4012f41e618ca1f8');
        $this->checkFile('themes/merchants/_common_templates/affiliate_info_data.tpl', '4f8d6b076fb89623f8ebe5d9fc9d210c');
        $this->checkFile('themes/merchants/_common_templates/affiliate_list.tpl', '6f4b8ede1a1e54acfe042349ec0b29e6');
        $this->checkFile('themes/merchants/_common_templates/affiliate_list_no_data.tpl', 'b8ca946fdb1f1f200be0e5dea98012d4');
        $this->checkFile('themes/merchants/_common_templates/affiliate_logins.tpl', 'b6a412c7d18564ddd673448e01ac41a3');
        $this->checkFile('themes/merchants/_common_templates/affiliate_logins_header.tpl', 'c5258ba5d80c3c44b8d60fd50d455ba9');
        $this->checkFile('themes/merchants/_common_templates/affiliate_logins_map.tpl', '14cd6ec3d9f5efb45740c67bc295e30c');
        $this->checkFile('themes/merchants/_common_templates/affiliate_menu_settings.tpl', '88673536893a3b06d7669c06813f0b37');
        $this->checkFile('themes/merchants/_common_templates/affiliate_panel_config.tpl', '99bc43fef7dbe936c4e733215585a277');
        $this->checkFile('themes/merchants/_common_templates/affiliate_payout_settings.tpl', '153de9b9dbfb94f61bd1b5482b22863a');
        $this->checkFile('themes/merchants/_common_templates/affiliate_postsignup_settings.tpl', '295c4b2802684750cc74e93282fb5732');
        $this->checkFile('themes/merchants/_common_templates/affiliate_screen_detail.tpl', 'a0e8a4ca9edeaa455867a80e6ee1d462');
        $this->checkFile('themes/merchants/_common_templates/affiliate_screen_header_edit.tpl', '8ad3a49fcda8f8981e1e8ee211c5fd1f');
        $this->checkFile('themes/merchants/_common_templates/affiliate_screen_settings.tpl', '1647c9e27136cb2123d56a6410dab4f5');
        $this->checkFile('themes/merchants/_common_templates/affiliate_screen_settings_nodata.tpl', 'bb4ad3e2d922192ec998ee5ae5c51e50');
        $this->checkFile('themes/merchants/_common_templates/affiliate_screens_list.tpl', '163420bb11e3cd547f23446684bc5392');
        $this->checkFile('themes/merchants/_common_templates/affiliate_signup_settings.tpl', 'c71577926b561808fe85412598b7f814');
        $this->checkFile('themes/merchants/_common_templates/affiliate_signup_settings_button.tpl', 'adccd555745134a857328990ed086077');
        $this->checkFile('themes/merchants/_common_templates/affiliate_signup_settings_form.tpl', 'eb832a062e7059bb5074dbeec7f2f890');
        $this->checkFile('themes/merchants/_common_templates/affiliate_stats.tpl', '0cbf07216f436d891429f4b82fe175ed');
        $this->checkFile('themes/merchants/_common_templates/affiliate_subaffiliates.tpl', '5a806ddefdf442e60ed99accdfcb1aaa');
        $this->checkFile('themes/merchants/_common_templates/affiliate_tracking_code_filter.tpl', 'fbace673cf9148f22091d670e1fe79ea');
        $this->checkFile('themes/merchants/_common_templates/affiliate_tracking_code_panel.tpl', 'e861afad8a80b19cb239dc550000fe41');
        $this->checkFile('themes/merchants/_common_templates/affiliate_tracking_cookiepanel.tpl', '59ed367a9fca61c9626dc740ed6eae9f');
        $this->checkFile('themes/merchants/_common_templates/affiliate_tracking_options.tpl', '3950dbf70f6a009f32da9dea72e44231');
        $this->checkFile('themes/merchants/_common_templates/affiliate_tracking_testlinks.tpl', '3407045ee29fe67b40621cdb381ff40e');
        $this->checkFile('themes/merchants/_common_templates/affiliate_tree.tpl', '875e8e5d865578c1b5efe31580b9e719');
        $this->checkFile('themes/merchants/_common_templates/affiliate_tree_filter.tpl', '80bb480f356fe108ed8416d0dc54aa97');
        $this->checkFile('themes/merchants/_common_templates/affiliate_tree_filter_edit.tpl', 'c528d052fec4a264473341826d99b76a');
        $this->checkFile('themes/merchants/_common_templates/affiliate_tree_panel.tpl', '7fac95b6532d4d3cc91d89f19076e037');
        $this->checkFile('themes/merchants/_common_templates/affiliate_url_page_editor.tpl', '1563cbaaa42ab9c7c0c8898a17b3b10a');
        $this->checkFile('themes/merchants/_common_templates/affiliate_urls_no_data.tpl', 'c32a33fe8cf5fdd50ea6e7e9aad67a32');
        $this->checkFile('themes/merchants/_common_templates/affiliates_group.tpl', 'b0452c56a3c513d2e7d0f5ccdb782262');
        $this->checkFile('themes/merchants/_common_templates/affiliates_group_filter.tpl', 'dcd4e9e0621af94502c3db22a8f418b4');
        $this->checkFile('themes/merchants/_common_templates/affiliates_import.tpl', '801e6bad9ed238c47c215be7f0371039');
        $this->checkFile('themes/merchants/_common_templates/affpanel_design.tpl', '18908388fc80a9783adc868eae27495a');
        $this->checkFile('themes/merchants/_common_templates/after_signup_actions_fields_no_data.tpl', 'd26d4b799b1f7dd4bfbca21ac2b47397');
        $this->checkFile('themes/merchants/_common_templates/after_signup_actions_no_data.tpl', 'b4afe408bd288f80a96d7fca392e5359');
        $this->checkFile('themes/merchants/_common_templates/after_signup_no_data.tpl', 'd3ba442d2d4764bbebeab6db805aa737');
        $this->checkFile('themes/merchants/_common_templates/api_integration.tpl', '0c6ea17785537652c7e98918b69d895a');
        $this->checkFile('themes/merchants/_common_templates/assigment.tpl', '77e33b188e0e94db23c89eb987669eaa');
        $this->checkFile('themes/merchants/_common_templates/assign_auto_panel.tpl', '2171c1b5a33c4c815089fbeff1e20d22');
        $this->checkFile('themes/merchants/_common_templates/audit_log_filter.tpl', 'e76227667150e1c50fb8906b1f208007');
        $this->checkFile('themes/merchants/_common_templates/banner_and_link_form_panel.tpl', '5c7a5c4a303dffe6d76424abd90a0236');
        $this->checkFile('themes/merchants/_common_templates/banner_button.tpl', 'e1cb4d807552c33476c9dc37bca24dc6');
        $this->checkFile('themes/merchants/_common_templates/banner_category_edit.tpl', 'be680d160d4cd72ef9bb346eb567f0fd');
        $this->checkFile('themes/merchants/_common_templates/banner_category_item.tpl', 'be4de5f6751bf912bdff3fd6415eaa8c');
        $this->checkFile('themes/merchants/_common_templates/banner_category_selector.tpl', '478886eecf1280d369ef48b7919b9980');
        $this->checkFile('themes/merchants/_common_templates/banner_category_settings_panel.tpl', '0244e21f9f617980a19733456df39de1');
        $this->checkFile('themes/merchants/_common_templates/banner_clone_dialog.tpl', '81ce64dde0a094eb79656cf3583a52df');
        $this->checkFile('themes/merchants/_common_templates/banner_destination_country_panel.tpl', '371c65812a768103220b82dd6fe3079b');
        $this->checkFile('themes/merchants/_common_templates/banner_destination_url_panel.tpl', '59090bb2a19ba20412bac3bb67725d08');
        $this->checkFile('themes/merchants/_common_templates/banner_destinations.tpl', '0dbdadecb2e33ee5bf1299da00d0e934');
        $this->checkFile('themes/merchants/_common_templates/banner_details.tpl', '8457aa922f853b8f8ab7ecb41ca5f48b');
        $this->checkFile('themes/merchants/_common_templates/banner_details_destination.tpl', '6ac6a3f1487fa1b5a64277c2df042cfb');
        $this->checkFile('themes/merchants/_common_templates/banner_details_params.tpl', '1320568e66752b25e4e34fd3329c723c');
        $this->checkFile('themes/merchants/_common_templates/banner_edit_header.tpl', 'dc6349c773791304ce3bc8391753f8ab');
        $this->checkFile('themes/merchants/_common_templates/banner_edit_panel.tpl', 'd371721abec7a70439373826893749c8');
        $this->checkFile('themes/merchants/_common_templates/banner_filter.tpl', 'e2e4083ffdb51795408cf95279bbe488');
        $this->checkFile('themes/merchants/_common_templates/banner_format_form.tpl', '5f8fd9d50c3f4817158302d1834f7e26');
        $this->checkFile('themes/merchants/_common_templates/banner_in_rotator_edit_panel.tpl', '331b8b61058b5f85750cc690e63d08cc');
        $this->checkFile('themes/merchants/_common_templates/banner_list_no_data.tpl', '7cbbeb457d0ad799bd7e960c889ee07e');
        $this->checkFile('themes/merchants/_common_templates/banner_manager.tpl', '3b8f4cd31299d8188b702ea621a4fa9b');
        $this->checkFile('themes/merchants/_common_templates/banner_name.tpl', '0e8385998fddbc3260837cf0590a35a5');
        $this->checkFile('themes/merchants/_common_templates/banner_or_link_edit_template_panel.tpl', 'c891838c99fa48a6273f5e426bc941ea');
        $this->checkFile('themes/merchants/_common_templates/banner_or_link_not_selected.tpl', 'e23ef0cab36daacee99af94a48601ae6');
        $this->checkFile('themes/merchants/_common_templates/banner_own_size_panel.tpl', 'bf9d961ef3e8c1c73a70a70711c74034');
        $this->checkFile('themes/merchants/_common_templates/banner_panel.tpl', '67062f6edcd6086b2b35689c3833dfd4');
        $this->checkFile('themes/merchants/_common_templates/banner_parameters_coupon.tpl', 'd7c6fc6e00c9e11d262f7c767454b9c7');
        $this->checkFile('themes/merchants/_common_templates/banner_parameters_flash.tpl', 'a6356eb54289b4b062c0250c5e9b7963');
        $this->checkFile('themes/merchants/_common_templates/banner_parameters_hover.tpl', 'f15317ed6c2ed30c9a2e897dbaaa79a6');
        $this->checkFile('themes/merchants/_common_templates/banner_parameters_html.tpl', 'f00f7657b51377b05cca05db4a27b4bf');
        $this->checkFile('themes/merchants/_common_templates/banner_parameters_image.tpl', 'f4227e6ffab89f9fecf00de0db1ea261');
        $this->checkFile('themes/merchants/_common_templates/banner_parameters_pagepeel.tpl', '67b5ccd900a6d389bc683877b20c713e');
        $this->checkFile('themes/merchants/_common_templates/banner_parameters_pagepeelhtml.tpl', '62f63fef543a0010cecde45cf2fb19c9');
        $this->checkFile('themes/merchants/_common_templates/banner_parameters_pdf.tpl', 'b02138b4e56eb4d1b40be08282348643');
        $this->checkFile('themes/merchants/_common_templates/banner_parameters_popup.tpl', '6b7bdf2070f676aad45245ca7bf849ca');
        $this->checkFile('themes/merchants/_common_templates/banner_parameters_promo_email.tpl', '5d558a2ce40bd6997c670115425bc67b');
        $this->checkFile('themes/merchants/_common_templates/banner_parameters_rebrandpdf.tpl', 'cf9a671721f070ae347706b8ec013894');
        $this->checkFile('themes/merchants/_common_templates/banner_parameters_rebrandpdf_allvars.tpl', 'b35fb8dec4e572039be5621070dde964');
        $this->checkFile('themes/merchants/_common_templates/banner_parameters_rebrandpdf_filefield.tpl', '4f3e422e757c8bd5c3460a24dd453153');
        $this->checkFile('themes/merchants/_common_templates/banner_parameters_rotator.tpl', 'be18e74db4df618a8452b053fed379b6');
        $this->checkFile('themes/merchants/_common_templates/banner_parameters_site.tpl', '1e3571542ef5ecccfe68d34c7578cdcb');
        $this->checkFile('themes/merchants/_common_templates/banner_parameters_site_files.tpl', 'b70e3346cecfdf9d7594f336f3cff834');
        $this->checkFile('themes/merchants/_common_templates/banner_parameters_site_files_local.tpl', 'a7f630aa7eb54c3cb467cb80f17674cc');
        $this->checkFile('themes/merchants/_common_templates/banner_parameters_site_files_url.tpl', '9e1571660d6fab85245ee3418abd1350');
        $this->checkFile('themes/merchants/_common_templates/banner_parameters_site_preview.tpl', '7dcf0d92d184a60ff334ad28adb1fd66');
        $this->checkFile('themes/merchants/_common_templates/banner_parameters_site_variables.tpl', '4a06de715bf27495f497e7ba57021cd6');
        $this->checkFile('themes/merchants/_common_templates/banner_parameters_zip.tpl', 'b2d3042655c6050c5c84dd691b15ba96');
        $this->checkFile('themes/merchants/_common_templates/banner_parameters_zip_bannerpreview.tpl', '919258983eb853742ec1aabd2505f388');
        $this->checkFile('themes/merchants/_common_templates/banner_parameters_zip_files.tpl', '0d3f2c5edba5f03f8fb35dcbaeeebae2');
        $this->checkFile('themes/merchants/_common_templates/banner_parameters_zip_variables.tpl', 'bea861fe51d3a9e95f9ae5e5cf9c4e81');
        $this->checkFile('themes/merchants/_common_templates/banner_params_link.tpl', '16e7b10d24dd70483e8c67184d3ec46f');
        $this->checkFile('themes/merchants/_common_templates/banner_params_text_link.tpl', '36887496682c2c2872c526ca6acba1fd');
        $this->checkFile('themes/merchants/_common_templates/banner_preview.tpl', '75b30e1735f8ec02072cb2aa83a06047');
        $this->checkFile('themes/merchants/_common_templates/banner_preview_field.tpl', '71e5ce8dff03853ca9e30de9dfe5006c');
        $this->checkFile('themes/merchants/_common_templates/banner_preview_widget.tpl', 'f21248876762eecce70f4f6a6d64cad1');
        $this->checkFile('themes/merchants/_common_templates/banner_rotator_feature_on_deactivate.tpl', 'a1bfe671194574c6d8b231e70bbd0f08');
        $this->checkFile('themes/merchants/_common_templates/banner_size.tpl', 'f8f55044ecc4027d5f99bb17713ded9a');
        $this->checkFile('themes/merchants/_common_templates/banner_stats_filter.tpl', 'c5a9e81c4903ded13d838138c8e2484c');
        $this->checkFile('themes/merchants/_common_templates/banner_stats_list.tpl', '8f03dbd8c7daeedf4f2d376550f01a74');
        $this->checkFile('themes/merchants/_common_templates/banner_stats_list_no_data.tpl', 'a1ebe10fc45d75e5414fced94a0d79ec');
        $this->checkFile('themes/merchants/_common_templates/banner_with_category_filter_field.tpl', 'd2f7cf7d2bede0108ac2952156be4e4a');
        $this->checkFile('themes/merchants/_common_templates/banner_wrapper_edit_panel.tpl', '26e3fbbfd44bda38d098ed63e30b4283');
        $this->checkFile('themes/merchants/_common_templates/banner_wrappers_table.tpl', '54f784f44c21afa6941daecd6088cd4a');
        $this->checkFile('themes/merchants/_common_templates/banners_and_links_format.tpl', '94e7984bc8690410df7d30aaf3eacafb');
        $this->checkFile('themes/merchants/_common_templates/banners_categories_list.tpl', '71e9c01c1193a717eaf1a9e950b31e36');
        $this->checkFile('themes/merchants/_common_templates/banners_categories_tree.tpl', '7e731d26ad51bb9b9d72284af1829f43');
        $this->checkFile('themes/merchants/_common_templates/bannerscategories_no_data.tpl', '3df35d8c385cfc14c75759c80f11aa02');
        $this->checkFile('themes/merchants/_common_templates/bannerscategories_not_in_category.tpl', '78c5430a80f25cdb9be49dad63656630');
        $this->checkFile('themes/merchants/_common_templates/branding_config.tpl', 'bd94806a4df51742d143a23dec8f2cdb');
        $this->checkFile('themes/merchants/_common_templates/buy_feature.tpl', '4e61e98614c27e2a9649909c3ac47a7a');
        $this->checkFile('themes/merchants/_common_templates/campaign_account.tpl', '50071850cd95497d5e384372c8b42400');
        $this->checkFile('themes/merchants/_common_templates/campaign_capping.tpl', 'b9f6737a4b04f0eca0d7957191b51231');
        $this->checkFile('themes/merchants/_common_templates/campaign_category_edit.tpl', 'a2c90cd1f1ca3cde3a32658a486b123f');
        $this->checkFile('themes/merchants/_common_templates/campaign_category_item.tpl', 'a3c6ce8058e6b313f60a41c3089d6552');
        $this->checkFile('themes/merchants/_common_templates/campaign_category_selector.tpl', 'c36efad2f278bc9ff61d52efafedd9f4');
        $this->checkFile('themes/merchants/_common_templates/campaign_category_settings_panel.tpl', 'd417bebb5724a67b3eee4b8682b09a0b');
        $this->checkFile('themes/merchants/_common_templates/campaign_commissions_tab.tpl', '86fd78ec94470a2033f73607b0e324db');
        $this->checkFile('themes/merchants/_common_templates/campaign_filter.tpl', 'fdd431532df338c6d4286e16f876520c');
        $this->checkFile('themes/merchants/_common_templates/campaign_form_edit.tpl', '6d4c9cd66044e0113be6949b802c0b04');
        $this->checkFile('themes/merchants/_common_templates/campaign_form_show.tpl', '87bc0a13eb30ba5d4948a4fdbdc29d37');
        $this->checkFile('themes/merchants/_common_templates/campaign_list_no_data.tpl', 'a81b22976f169e237766e655f6c82838');
        $this->checkFile('themes/merchants/_common_templates/campaign_panel.tpl', '628f617ceaf7b1c0017526527a288160');
        $this->checkFile('themes/merchants/_common_templates/campaign_rule_conditions_panel.tpl', '8fb3fa3de4e61f5e505d561bfb27c871');
        $this->checkFile('themes/merchants/_common_templates/campaign_rule_conditions_panel_full.tpl', '2b140194becbf47b830c742b8852e690');
        $this->checkFile('themes/merchants/_common_templates/campaign_schedule_nodata.tpl', '3e87dc9b305506f1f13895478de1ee2e');
        $this->checkFile('themes/merchants/_common_templates/campaign_scheduler.tpl', 'c72d0e7cf504418eca8a452c113f8f9e');
        $this->checkFile('themes/merchants/_common_templates/campaign_scheduling_rule_panel.tpl', 'd312aaa5e7b54fc1b7b81f9e307f31e1');
        $this->checkFile('themes/merchants/_common_templates/campaign_screen.tpl', '48d3e63714873d79a6092b2aa0417dd9');
        $this->checkFile('themes/merchants/_common_templates/campaign_screen_edit.tpl', '4dd40cd4020a39e251a16d01ffa65723');
        $this->checkFile('themes/merchants/_common_templates/campaign_shortdetails_form.tpl', '99bd3a0b3e5790f2307e9b897dcd6811');
        $this->checkFile('themes/merchants/_common_templates/campaign_stats_filter.tpl', '246ac04426696332ac3b272fbf528ca8');
        $this->checkFile('themes/merchants/_common_templates/campaign_stats_list.tpl', 'd85d06d50a5b5570c9cfe95a5f982b1c');
        $this->checkFile('themes/merchants/_common_templates/campaign_stats_list_no_data.tpl', 'a7d3a0de70332e0bc3d38a9545f706d5');
        $this->checkFile('themes/merchants/_common_templates/campaign_status.tpl', 'b732873daaced1e1e9aa43cb2f4c09fa');
        $this->checkFile('themes/merchants/_common_templates/campaign_step_create.tpl', '2d419b7525bdd89abdec8c0d31d1f71d');
        $this->checkFile('themes/merchants/_common_templates/campaign_type.tpl', '653ea0c458377857718df884a3bafbd4');
        $this->checkFile('themes/merchants/_common_templates/campaign_validity_edit.tpl', '22198581b13ee3fbd1e3729236df3189');
        $this->checkFile('themes/merchants/_common_templates/campaign_with_category_filter_field.tpl', 'bbe44733dbe7c3923c054d1981d08ed4');
        $this->checkFile('themes/merchants/_common_templates/campaign_wizard.tpl', 'e6f7ad6b18e7c273490cea2a19a19654');
        $this->checkFile('themes/merchants/_common_templates/campaigns_categories_list.tpl', 'bb0faa504048be846e938bb145aa51ff');
        $this->checkFile('themes/merchants/_common_templates/campaigns_categories_tree.tpl', '9b39c5fc43f0fa8c4bb9771d014ac041');
        $this->checkFile('themes/merchants/_common_templates/campaigns_grid_settings_affiliate_panel.tpl', '6830692ae10fdc0b2083cc58268baa4c');
        $this->checkFile('themes/merchants/_common_templates/campaigns_list.tpl', '85c8bb65216d10f6da71af29c264577e');
        $this->checkFile('themes/merchants/_common_templates/campaignscategories_no_data.tpl', 'b6fdeaa9e97591514e8bc48fc1762f47');
        $this->checkFile('themes/merchants/_common_templates/campaignscategories_not_in_category.tpl', '055663c37925323d64288fa6f66dbf6f');
        $this->checkFile('themes/merchants/_common_templates/category_list.tpl', '6f5b9c38fbe05e421df953b06a7f3a4d');
        $this->checkFile('themes/merchants/_common_templates/category_panel.tpl', 'a2995f00bc890e828cac9b097be9d7b0');
        $this->checkFile('themes/merchants/_common_templates/clicks_list.tpl', 'a06cd4140d02c209f9a7ea8d27b86cda');
        $this->checkFile('themes/merchants/_common_templates/clicks_list_filter_base.tpl', '53f51dff8cc6941f57e6e2ee2d55e890');
        $this->checkFile('themes/merchants/_common_templates/clicks_list_no_data.tpl', '5e9694a72b3daf0b595572fb4bc31d9e');
        $this->checkFile('themes/merchants/_common_templates/clicks_tracking.tpl', 'e08901f244d18a4cb8e5a0c06b0005c9');
        $this->checkFile('themes/merchants/_common_templates/commission_edit_values.tpl', 'b277423c214667a9202d3aefac1d7619');
        $this->checkFile('themes/merchants/_common_templates/commission_edit_values_tierpanel.tpl', 'ed403054ea7f2ccb731265f9d3f0ef4f');
        $this->checkFile('themes/merchants/_common_templates/commission_edit_with_fixedcost.tpl', '9de4fcc3fe5b2d1b44fccd10b475ba2d');
        $this->checkFile('themes/merchants/_common_templates/commission_group_panel.tpl', '66cb9c9b96d711e29e2a1a0efe952cac');
        $this->checkFile('themes/merchants/_common_templates/commission_groups.tpl', 'cd9f803bcafdc842b0226fa653242f1b');
        $this->checkFile('themes/merchants/_common_templates/commission_groups_panel.tpl', 'a0cd6f388272491e72460e2f462a6e98');
        $this->checkFile('themes/merchants/_common_templates/commission_recurring.tpl', 'aa827abeee6bb0f472b500c096cd3625');
        $this->checkFile('themes/merchants/_common_templates/commission_sale.tpl', 'fbdf7f44f6df291e9da9e8172dcad9ce');
        $this->checkFile('themes/merchants/_common_templates/commission_subsales.tpl', 'c21fc8858085c294ac7630f53d6bd36e');
        $this->checkFile('themes/merchants/_common_templates/commission_tabs.tpl', '2eec354045cec652c7cd4ff1cfc8bf56');
        $this->checkFile('themes/merchants/_common_templates/commission_tiers_info_panel.tpl', '67bd161520dcf9bd0a11b71d175af743');
        $this->checkFile('themes/merchants/_common_templates/commission_type_detail.tpl', 'dadf4ef5971687787066b76a07d6a28d');
        $this->checkFile('themes/merchants/_common_templates/commission_type_sail_detail.tpl', '61596aba1e2536ccc5b766523fe7b76f');
        $this->checkFile('themes/merchants/_common_templates/commissions_details_view.tpl', '6481e92bb25a139b55290e0d5b209cdd');
        $this->checkFile('themes/merchants/_common_templates/commissions_edit.tpl', 'ccbe729356f996184e31dde2267405e3');
        $this->checkFile('themes/merchants/_common_templates/commissions_panel.tpl', '8a12ac6c66ca5fd7217cd1ea6f80ef22');
        $this->checkFile('themes/merchants/_common_templates/compressed_commission_settings.tpl', 'a9cfd393004f3b3fd1a771b8a128a182');
        $this->checkFile('themes/merchants/_common_templates/comunication_overview_panel.tpl', '9e58a4489b9a29d7ad5b8ab038c63a94');
        $this->checkFile('themes/merchants/_common_templates/config_aff_panel.tpl', '400735d2d598cc8440c74735d19565d9');
        $this->checkFile('themes/merchants/_common_templates/config_affiliates.tpl', '4870980191d1873460bbc2d8894b2bf2');
        $this->checkFile('themes/merchants/_common_templates/config_communication.tpl', 'b7af569e05800de423c52fc28d7bc40b');
        $this->checkFile('themes/merchants/_common_templates/config_currencies_form.tpl', 'c1805e2fb028b6daada1d5f0e04ef9f6');
        $this->checkFile('themes/merchants/_common_templates/config_currency_tab.tpl', '4fdb78bd6108fc60ecd63e82f5746265');
        $this->checkFile('themes/merchants/_common_templates/config_date_format.tpl', '771f72b6514cd4c9103217a955fb171d');
        $this->checkFile('themes/merchants/_common_templates/config_language_and_date_form.tpl', '1ad6231d44243a014dd06b3a18709fac');
        $this->checkFile('themes/merchants/_common_templates/config_overview.tpl', '7e12a0ed95221bf996302949ba0de125');
        $this->checkFile('themes/merchants/_common_templates/config_signup_form.tpl', 'f02db10c54c6ae8dbeda648a35b751c0');
        $this->checkFile('themes/merchants/_common_templates/config_system.tpl', '783ebbddb4a39f395967456062db2396');
        $this->checkFile('themes/merchants/_common_templates/config_themes.tpl', '0bab46cdedf333176ecb62c8cdc1d672');
        $this->checkFile('themes/merchants/_common_templates/config_tracking.tpl', '81056b36d3ec69a8fac9d843ed7d7240');
        $this->checkFile('themes/merchants/_common_templates/confirm_dialog_label_note.tpl', 'f76c3c08642335eb7b3e0ce42bfe753a');
        $this->checkFile('themes/merchants/_common_templates/cookie_lifetime_group.tpl', 'ea8a6a5ad128f265d7d6891a41fdf097');
        $this->checkFile('themes/merchants/_common_templates/cookies_tab.tpl', 'c0371d408e67d5a94e28c7aa1b2225b8');
        $this->checkFile('themes/merchants/_common_templates/copy_campaign.tpl', 'b6681af626836e623461cb6151e99b1c');
        $this->checkFile('themes/merchants/_common_templates/copy_commission_group.tpl', 'be24a255ae39c342157dc6ee3e1a83c1');
        $this->checkFile('themes/merchants/_common_templates/countries_list_scrolling_wrapper.tpl', '4bf0a92924334c72075b4ddafd3b243b');
        $this->checkFile('themes/merchants/_common_templates/country_commission_type_panel.tpl', 'e83ee2d89183d207077f1d90e2ba27e4');
        $this->checkFile('themes/merchants/_common_templates/country_list.tpl', '7c8af2cd7e2042d54b067bfaaf576f37');
        $this->checkFile('themes/merchants/_common_templates/country_select_panel.tpl', '8503f8f693cc44082380626a7b0ebbfc');
        $this->checkFile('themes/merchants/_common_templates/country_specific_commission_type_panel.tpl', 'c8cfeab3d80fd3124afe34f9d4e2b0fb');
        $this->checkFile('themes/merchants/_common_templates/coupons_filter.tpl', '2456ca77bc8afde1eee8cf9987a5a07b');
        $this->checkFile('themes/merchants/_common_templates/coupons_import.tpl', 'f160fd47b653afc96203b47c161d933e');
        $this->checkFile('themes/merchants/_common_templates/coupons_panel.tpl', 'dcb054cd9abe5cbea02724014d27c7ef');
        $this->checkFile('themes/merchants/_common_templates/create_banners_buttons.tpl', 'fc7e78bcca710d7bacc99115527f71ce');
        $this->checkFile('themes/merchants/_common_templates/cron_job_integration.tpl', '5c3f21fcfc5a0ee9fb7605b73377a652');
        $this->checkFile('themes/merchants/_common_templates/currencies_no_data.tpl', '16b4e5d712f43751925fafe7fb004f18');
        $this->checkFile('themes/merchants/_common_templates/currency_form.tpl', 'dbee13da7abe05b10990f7ee89eee4be');
        $this->checkFile('themes/merchants/_common_templates/custom_cookie_panel.tpl', 'b1b3a9b5c5aa2b7de8e67fa2975bbf0e');
        $this->checkFile('themes/merchants/_common_templates/daily_report.tpl', '696092e06570b6eebad4c345d98c5ca9');
        $this->checkFile('themes/merchants/_common_templates/daily_report_filter.tpl', '4cdffc97f8e329ddd13a37d99bdaaa9b');
        $this->checkFile('themes/merchants/_common_templates/database_status_panel.tpl', 'dc082d04be2db97cc136ca23f901ffdc');
        $this->checkFile('themes/merchants/_common_templates/deeplink_generator_configuration_panel.tpl', '3c2760073f6820b0f98e425cafb9d39a');
        $this->checkFile('themes/merchants/_common_templates/deeplink_generator_network_setting_edit.tpl', '818d1c4a3bb685f4cb6e825a2c577d82');
        $this->checkFile('themes/merchants/_common_templates/default_campaign_form.tpl', '2524ebdb94130b6701af650fb63c9c68');
        $this->checkFile('themes/merchants/_common_templates/default_theme_config.tpl', '53ee706b04dada1cac18c10430d8111f');
        $this->checkFile('themes/merchants/_common_templates/description_panel.tpl', 'eb196bc81ac670a6081876c8d17158c0');
        $this->checkFile('themes/merchants/_common_templates/design_panel.tpl', '44aa20339b9d6fb87a52a35b37477008');
        $this->checkFile('themes/merchants/_common_templates/destination.tpl', 'ce4d79af3bb02b4c2cd278d713462101');
        $this->checkFile('themes/merchants/_common_templates/destination_panel.tpl', 'b1a945222a9e090a579b5caa53e59032');
        $this->checkFile('themes/merchants/_common_templates/direct_link_form.tpl', 'da0df20ceab32db25682ce9277298055');
        $this->checkFile('themes/merchants/_common_templates/direct_link_grid_widget.tpl', '586c3b902d66c903d87e510bca5843ec');
        $this->checkFile('themes/merchants/_common_templates/directlinks_advanced_filter.tpl', '29fc27db75bbb2253c290d8deaf867b5');
        $this->checkFile('themes/merchants/_common_templates/directlinks_list.tpl', 'db24b558dd34d4b0b71f032a4d28ca96');
        $this->checkFile('themes/merchants/_common_templates/directlinks_list_no_data.tpl', '48930e247a25f61797107f6c2c4e793b');
        $this->checkFile('themes/merchants/_common_templates/disclosure_content.tpl', '27557135898f8d0dc1ff849cba4f875a');
        $this->checkFile('themes/merchants/_common_templates/download_auto_reg_banner_form.tpl', '64f1eace6ea5e2759b128934675db4b1');
        $this->checkFile('themes/merchants/_common_templates/download_auto_reg_iframe_form.tpl', 'a9b2b41ce070f593c3c9866f038035c0');
        $this->checkFile('themes/merchants/_common_templates/download_auto_reg_link_form.tpl', '6fe0959c4d3db3d7dfb2a3120baf0cf5');
        $this->checkFile('themes/merchants/_common_templates/download_login_form.tpl', 'd73ed70f4d96b76f37965d9f8c753ac5');
        $this->checkFile('themes/merchants/_common_templates/download_signup_form.tpl', '0bc2be1fcca2803330a93c17f4dd30cb');
        $this->checkFile('themes/merchants/_common_templates/edit_affiliate_page_page.tpl', '367f8d79bdffc8cb0dcc344e2c1c79bd');
        $this->checkFile('themes/merchants/_common_templates/edit_destination_url_widget.tpl', 'f96cdffccc8152ee75ee1cc83d9b3f5c');
        $this->checkFile('themes/merchants/_common_templates/edit_tracking_code_widget.tpl', 'e14dfec682b48f070dafe64ad663e0ed');
        $this->checkFile('themes/merchants/_common_templates/email_notifications.tpl', 'ee78b917ed16b92555c63a9bb55759e9');
        $this->checkFile('themes/merchants/_common_templates/expand_matrix.tpl', 'dc72b136436320776269f40795008156');
        $this->checkFile('themes/merchants/_common_templates/export_files_panel.tpl', '03c49f3791214f420d6a73485ee4ae04');
        $this->checkFile('themes/merchants/_common_templates/export_panel.tpl', 'c0a441bad637a8d1bcf553173f1d4d86');
        $this->checkFile('themes/merchants/_common_templates/extendable_commission_data.tpl', '189a7a2e1e5cbaeeb306c64ef1295e2a');
        $this->checkFile('themes/merchants/_common_templates/fee_panel.tpl', '858f0cf0fa23905c35b5b2952342314c');
        $this->checkFile('themes/merchants/_common_templates/field_type_listbox.tpl', '3f8a808917e52550c6295d4c1177d5df');
        $this->checkFile('themes/merchants/_common_templates/file_widget.tpl', '9bbc3cc3dab5406cfb7581ebcdbdf71e');
        $this->checkFile('themes/merchants/_common_templates/files_tree_panel.tpl', 'e11e884c210779b572bc928e01cf3d96');
        $this->checkFile('themes/merchants/_common_templates/filter_field_decorator.tpl', '5e64b134ec320a59cc5fe5da1342f578');
        $this->checkFile('themes/merchants/_common_templates/fixed_field.tpl', '3eacc22f15be59cb0308e696e815db2e');
        $this->checkFile('themes/merchants/_common_templates/forced_matrix_panel.tpl', '0f06e2a7d0482fa847967cd918e0e614');
        $this->checkFile('themes/merchants/_common_templates/fraud_protection_clicks.tpl', 'd480915860a1a88c9c1ca4dc4aee972e');
        $this->checkFile('themes/merchants/_common_templates/fraud_protection_form.tpl', '64a1de739c1cca5950f14a50a4a98eca');
        $this->checkFile('themes/merchants/_common_templates/fraud_protection_logins.tpl', '94f64e42557970f4d72b1d5eb0c990bc');
        $this->checkFile('themes/merchants/_common_templates/fraud_protection_sales.tpl', '626a5c748af09a1498f17de9d410f8ec');
        $this->checkFile('themes/merchants/_common_templates/fraud_protection_signups.tpl', '29376bea9b6b48f05dccc052f38cf441');
        $this->checkFile('themes/merchants/_common_templates/full_banner_stats.tpl', 'c328c4ab71d9137de7429502800fef6f');
        $this->checkFile('themes/merchants/_common_templates/full_commision_stats.tpl', '964c317f4ba871629fc27b5fb615b48e');
        $this->checkFile('themes/merchants/_common_templates/full_payout_stats.tpl', 'ca37e302d9c33ec1c7c243424c049558');
        $this->checkFile('themes/merchants/_common_templates/full_transaction_stats.tpl', '87b41cd6a4f025b58de4907cefe73fba');
        $this->checkFile('themes/merchants/_common_templates/generate_coupons_form.tpl', 'beddaaf1aa37c10aab9838f1c4b8f1e8');
        $this->checkFile('themes/merchants/_common_templates/generate_htaccess.tpl', '05d9d8606bdf35455fb48ec7f928b702');
        $this->checkFile('themes/merchants/_common_templates/geoip_commissiontype_detailpanel.tpl', '734dc6f1a0cc432cd287f22ef5824f49');
        $this->checkFile('themes/merchants/_common_templates/geoip_fraudprotection_affiliates.tpl', '954829c7383fb904ed6d6e23161613f0');
        $this->checkFile('themes/merchants/_common_templates/geoip_fraudprotection_clicks.tpl', '7e63e03d3df801f93770f287c1523fea');
        $this->checkFile('themes/merchants/_common_templates/geoip_fraudprotection_logins.tpl', '19f44b0596a9814e8567b43e4b66a3ed');
        $this->checkFile('themes/merchants/_common_templates/geoip_fraudprotection_logins_aff.tpl', 'a88c149269897952da650673d9db4e92');
        $this->checkFile('themes/merchants/_common_templates/geoip_fraudprotection_sales.tpl', '58c8a0ddacca6592e527a6faa08d40d0');
        $this->checkFile('themes/merchants/_common_templates/get_pdf.tpl', '7de69c1b98a6f1cac1f9c8e570e3b6b9');
        $this->checkFile('themes/merchants/_common_templates/getting_started_icons.tpl', '612e44ecb9bc1526bd8694a0655342bf');
        $this->checkFile('themes/merchants/_common_templates/getting_started_merchant.tpl', 'b81977a90b5fd73d1a21c2657e0ece7a');
        $this->checkFile('themes/merchants/_common_templates/google_recaptcha_settings.tpl', '299aa39596402442ff94381e0aa83bf5');
        $this->checkFile('themes/merchants/_common_templates/home_edit.tpl', '235157e954934d2f30570619d35f36fc');
        $this->checkFile('themes/merchants/_common_templates/home_edit_main_template.tpl', 'cd4fbd7e59c2c1813b4b1c9d54025223');
        $this->checkFile('themes/merchants/_common_templates/home_edit_merch_template.tpl', '1079945929a23a68a38676fe78432211');
        $this->checkFile('themes/merchants/_common_templates/home_panel.tpl', 'ab81295304acd6c6580822d4c4222144');
        $this->checkFile('themes/merchants/_common_templates/home_panel_content.stpl', 'cce2ff61cdf92368b077b779608295df');
        $this->checkFile('themes/merchants/_common_templates/hosted_account.tpl', 'e58e46daeeb498d85227982e6ee6ae2d');
        $this->checkFile('themes/merchants/_common_templates/hosted_account_plan.tpl', 'bfb67b63d21a4482e2528a4fb581629c');
        $this->checkFile('themes/merchants/_common_templates/htaccess_panel.tpl', '70b5aa26f7709f3a7ddf916a4e770fba');
        $this->checkFile('themes/merchants/_common_templates/html_preview.tpl', '08392603f2252347986bb4b341e964dd');
        $this->checkFile('themes/merchants/_common_templates/html_preview_iframe_panel.tpl', '22405951702ab2132d0fe99577f4968e');
        $this->checkFile('themes/merchants/_common_templates/html_preview_image_panel.tpl', 'ebc5b8605c42ac31f653b65deb66e04d');
        $this->checkFile('themes/merchants/_common_templates/icons_panel_with_header.tpl', '411d0a73f9c83ae2f8637c24ed01fd08');
        $this->checkFile('themes/merchants/_common_templates/img/aff.jpg', '13682fa292c9b48a02d9365c82711e76');
        $this->checkFile('themes/merchants/_common_templates/img/aff.tracking.explained.gif', '6e8da7554baac1aceb9cecddfaa79b7a');
        $this->checkFile('themes/merchants/_common_templates/img/aff_hover.jpg', '8ba078c58c0a97f976092d56e5e25df0');
        $this->checkFile('themes/merchants/_common_templates/img/affiliate.default.png', '4fe6ffc5c01d77a5e8b6408feb4d89b7');
        $this->checkFile('themes/merchants/_common_templates/img/affiliates-image-hover.png', '3d54662bc194e6e38306ce201fc7052f');
        $this->checkFile('themes/merchants/_common_templates/img/affiliates-image.png', '945069bbda8fbf650bb66d8542393b1c');
        $this->checkFile('themes/merchants/_common_templates/img/affpanel.jpg', '47db14c8b8dd0ae9293553f2dbde9ab8');
        $this->checkFile('themes/merchants/_common_templates/img/affpanel_hover.jpg', 'dd791c252c89c6d9df563150fc6fe25f');
        $this->checkFile('themes/merchants/_common_templates/img/arrow.png', 'b72be4305475c0fa0a29949d5a9679d9');
        $this->checkFile('themes/merchants/_common_templates/img/back.png', 'b2bf946d1b2861b355661fa214589cb9');
        $this->checkFile('themes/merchants/_common_templates/img/background.gif', 'f42b9c9652e64d73bb1656afbe3efa80');
        $this->checkFile('themes/merchants/_common_templates/img/banner_coupon.png', '45b7128d20566cb9930fdca7e53b689d');
        $this->checkFile('themes/merchants/_common_templates/img/banner_flash.png', '36f4e485ce10d8f5d661cd369497b58a');
        $this->checkFile('themes/merchants/_common_templates/img/banner_hover.png', 'a2d7ae1cf71c70056e330f2569b703ca');
        $this->checkFile('themes/merchants/_common_templates/img/banner_html.png', '0c5d9dc22178ea9e12aca239ca067fc5');
        $this->checkFile('themes/merchants/_common_templates/img/banner_image.png', '27edf0f1545e6f0acc40cd11732f1e6a');
        $this->checkFile('themes/merchants/_common_templates/img/banner_link.png', '2b460f46d03323eb892a0b6e71bb5b69');
        $this->checkFile('themes/merchants/_common_templates/img/banner_pdf.gif', 'f376b73bf71f3f2ea1dc874086182783');
        $this->checkFile('themes/merchants/_common_templates/img/banner_pdf.png', '5659684fa51315488c700d5e28cf7b86');
        $this->checkFile('themes/merchants/_common_templates/img/banner_peel.png', '349692c03196bc32abcf7af659904afc');
        $this->checkFile('themes/merchants/_common_templates/img/banner_peel_html.png', 'aaac3ee0e19bced62cdfb0bbaa37876d');
        $this->checkFile('themes/merchants/_common_templates/img/banner_promoemail.png', 'ea8b7efcdbd3a1248b2f768c606e9470');
        $this->checkFile('themes/merchants/_common_templates/img/banner_rebrand_pdf.png', 'aa36b576aecb4ba12d26aa9e07524027');
        $this->checkFile('themes/merchants/_common_templates/img/banner_rotator.png', '791084a79a84f2ea51f733c74a3e9b7c');
        $this->checkFile('themes/merchants/_common_templates/img/banner_site.png', 'c4a32d5ab850482b7ab3111988af2b76');
        $this->checkFile('themes/merchants/_common_templates/img/banner_text.png', '2b0128371e3fb3f1370bb3d91753e9e1');
        $this->checkFile('themes/merchants/_common_templates/img/banner_zip.png', 'fc08870d95436f47a15ff7cfbf5ff45a');
        $this->checkFile('themes/merchants/_common_templates/img/bigcheckbox-checked.png', '44c716fa1cfd38fcbf95b1a8d4ef9230');
        $this->checkFile('themes/merchants/_common_templates/img/bigcheckbox-unchecked.png', '3544ad8efff0df50aaf39d0a61639a24');
        $this->checkFile('themes/merchants/_common_templates/img/box.b.png', '72be5551673120e6816eb0e3ee2dc688');
        $this->checkFile('themes/merchants/_common_templates/img/box.back.png', '50b024acb551e45265fa4dee472bbb2a');
        $this->checkFile('themes/merchants/_common_templates/img/box.bl.png', '834d3c0fb17a3a96b7ce77534dc71fa9');
        $this->checkFile('themes/merchants/_common_templates/img/box.br.png', '6ff2020b65abb3f7c0310b39b8d0a6b6');
        $this->checkFile('themes/merchants/_common_templates/img/box.l.png', '5c0e5add93feb84e651aab9f0204bf98');
        $this->checkFile('themes/merchants/_common_templates/img/box.r.png', '76af05f4dee8ae1f08c78c8c768d97a5');
        $this->checkFile('themes/merchants/_common_templates/img/box.t.png', '85fb53437974e94f988a78e707b0d379');
        $this->checkFile('themes/merchants/_common_templates/img/box.tl.png', 'c7782b3fe7e15b0b2e80872ae3fcc43d');
        $this->checkFile('themes/merchants/_common_templates/img/box.tr.png', 'd0d5167fe921b51ee289efefb9545216');
        $this->checkFile('themes/merchants/_common_templates/img/boxBlue.b.png', '1dd1ae460985efdfe739a876adad83ff');
        $this->checkFile('themes/merchants/_common_templates/img/boxBlue.back.png', 'ef59b91125034c263d6952b918774062');
        $this->checkFile('themes/merchants/_common_templates/img/boxBlue.bl.png', '54cee8fc385c953ca890371659afed20');
        $this->checkFile('themes/merchants/_common_templates/img/boxBlue.br.png', 'f7d98b69224fa42616d8e210edd3bef0');
        $this->checkFile('themes/merchants/_common_templates/img/boxBlue.l.png', '77a56aeacc2bafedef0df992da2470a9');
        $this->checkFile('themes/merchants/_common_templates/img/boxBlue.r.png', '574308c7a0635af7e49aaa94eb6b6f20');
        $this->checkFile('themes/merchants/_common_templates/img/boxBlue.t.png', 'e889b833a7a41f3ef457f30fc2adddbd');
        $this->checkFile('themes/merchants/_common_templates/img/boxBlue.tl.png', '8e79363c67150527a64756308d6744fe');
        $this->checkFile('themes/merchants/_common_templates/img/boxBlue.tr.png', 'f36516fd4f09c7eacfa86474bc812987');
        $this->checkFile('themes/merchants/_common_templates/img/browser_secure.png', '5c95ff5b78267e9023bc63a36415e4fc');
        $this->checkFile('themes/merchants/_common_templates/img/button.icon.banner_rebrand_pdf.png', '2e9d58dc5d39c843ed7310e2d2c82cfc');
        $this->checkFile('themes/merchants/_common_templates/img/button.icon.coupon.png', 'e38de70bbd3c0535e90d31f5e26dc837');
        $this->checkFile('themes/merchants/_common_templates/img/button.icon.flash.png', '8ec346412290fc353e63b1b334962113');
        $this->checkFile('themes/merchants/_common_templates/img/button.icon.hover.png', '38e73330dad0b0008e3953e9da761836');
        $this->checkFile('themes/merchants/_common_templates/img/button.icon.html.png', 'bf779e6be27fc9f565827e3b44ac1964');
        $this->checkFile('themes/merchants/_common_templates/img/button.icon.image.png', 'd3c71dd4c221da70bd2a01dd52402cce');
        $this->checkFile('themes/merchants/_common_templates/img/button.icon.invoice.png', '9e77bab051d73681cf35d6f763e39851');
        $this->checkFile('themes/merchants/_common_templates/img/button.icon.labelaspaid.png', 'f0ce20cb7eb9051f87f88280bc61336a');
        $this->checkFile('themes/merchants/_common_templates/img/button.icon.link.png', 'dfbc23b903320223dec4b206e3bbde04');
        $this->checkFile('themes/merchants/_common_templates/img/button.icon.pdf.png', '33d0e16ed152aaeeb45be8a897225139');
        $this->checkFile('themes/merchants/_common_templates/img/button.icon.peel.png', '2417dc2f99298d017651faee616b2a67');
        $this->checkFile('themes/merchants/_common_templates/img/button.icon.peel_html.png', 'cde7a5f76399b839cfec297196bfa2b8');
        $this->checkFile('themes/merchants/_common_templates/img/button.icon.promoemail.png', '02f0749e2bb9d04c1915cfbb5d916336');
        $this->checkFile('themes/merchants/_common_templates/img/button.icon.rotator.png', '633d9a8526c1ce798670b125f7d591d2');
        $this->checkFile('themes/merchants/_common_templates/img/button.icon.site.png', '98cfb6286cf9b18e1dadde85b0e0ff90');
        $this->checkFile('themes/merchants/_common_templates/img/button.icon.text.png', '0d77cd10a601be67f3dee483f87a8d97');
        $this->checkFile('themes/merchants/_common_templates/img/button.icon.zip.png', '9b0852c44f21a912eeba89d2fd911c35');
        $this->checkFile('themes/merchants/_common_templates/img/campaign.default.png', '1be5bc07868c30ec347da3490788c07d');
        $this->checkFile('themes/merchants/_common_templates/img/cards.jpg', '36a8e2ad3f39a4c9c71c8abbcec24823');
        $this->checkFile('themes/merchants/_common_templates/img/cards.png', '6bf7d070a6bb5c4d897a5361d0edc894');
        $this->checkFile('themes/merchants/_common_templates/img/changelogo.png', 'd015ce4e7baa25013c5b2a02206fc088');
        $this->checkFile('themes/merchants/_common_templates/img/clear-image.png', '93a97ee0ef5b50f5ede6f4d7783f386b');
        $this->checkFile('themes/merchants/_common_templates/img/commission.background.png', '5bbfa22d7961d7934f73197070b6bfd2');
        $this->checkFile('themes/merchants/_common_templates/img/commissiontype.png', 'c83b5c2396b91b7179c4ad08da3bbb33');
        $this->checkFile('themes/merchants/_common_templates/img/commissiontype_disabled.png', '80ec9374c59c01524a1c87583a5d87b4');
        $this->checkFile('themes/merchants/_common_templates/img/cron_job_example.png', 'f0cd89597b814b000ef2775c2f9dea1b');
        $this->checkFile('themes/merchants/_common_templates/img/down.png', '5981ae525e3e3b7e9511c26e09eb18b5');
        $this->checkFile('themes/merchants/_common_templates/img/edit-user-profile.png', '432705ddac6f1effab7a0e25c0e39f76');
        $this->checkFile('themes/merchants/_common_templates/img/email.jpg', 'f1781bfc99de39e56daabcb62caea59b');
        $this->checkFile('themes/merchants/_common_templates/img/email_hover.jpg', '95bf6f820cc5fa578e06ee8251e7d757');
        $this->checkFile('themes/merchants/_common_templates/img/favicon.ico', 'e15128807c80c86ddc36d69e0712d019');
        $this->checkFile('themes/merchants/_common_templates/img/favicon.png', 'b7b49aa6d5f1611aa416c3623d057db8');
        $this->checkFile('themes/merchants/_common_templates/img/features_multi_chat.jpg', 'f1b68ab618de66191de40cd8733af6b3');
        $this->checkFile('themes/merchants/_common_templates/img/general.jpg', '6b7310c1c4b1fe69b03ddbb5300f858b');
        $this->checkFile('themes/merchants/_common_templates/img/general_hover.jpg', 'e6d0acb22eb44438717b33d1c1bf2bd6');
        $this->checkFile('themes/merchants/_common_templates/img/hosting_plan_active_b.gif', '31ad45ecc82fcc6eab4c7eec40b4e60b');
        $this->checkFile('themes/merchants/_common_templates/img/hosting_plan_active_bg.gif', '772bb758a43f230b5bf63e5b70c631a1');
        $this->checkFile('themes/merchants/_common_templates/img/hosting_plan_active_t.gif', '962855a522a8e9e8c2567f3d9b5de838');
        $this->checkFile('themes/merchants/_common_templates/img/hosting_plan_b.gif', 'cd9f56a0d5cf8832cd1d75a949863b6b');
        $this->checkFile('themes/merchants/_common_templates/img/hosting_plan_bg.gif', '2be4be6872bdfb46d2bbeff2f6adea95');
        $this->checkFile('themes/merchants/_common_templates/img/hosting_plan_li.gif', 'b363b85b47d29140570ca312c375082a');
        $this->checkFile('themes/merchants/_common_templates/img/hosting_plan_t.gif', '76a3c38f0d5f8e67ca36196c837da264');
        $this->checkFile('themes/merchants/_common_templates/img/howitworks_left.jpg', '24cb87e8a13c03037ff995f5c69006aa');
        $this->checkFile('themes/merchants/_common_templates/img/howitworks_right.jpg', 'd4b1ef220e6fdbd41be098807c630a16');
        $this->checkFile('themes/merchants/_common_templates/img/howto_integrate.jpg', 'cc6209de565500240cc4b94e1271508d');
        $this->checkFile('themes/merchants/_common_templates/img/icon-accounting-big.png', 'fa93f5c4b60b9d095a2a23a52211168e');
        $this->checkFile('themes/merchants/_common_templates/img/icon-accounting-middle.png', '7da96ba7ebbfb004234d789e5f36ce69');
        $this->checkFile('themes/merchants/_common_templates/img/icon-accounting-small.png', 'a14dd58b2eff427007308e6c395da74f');
        $this->checkFile('themes/merchants/_common_templates/img/icon-actioncommision-big.png', '699dc662dfe42872afc96a702562a3c7');
        $this->checkFile('themes/merchants/_common_templates/img/icon-actioncommision-middle.png', '34c506634c221c66d9254eeba2b82bcf');
        $this->checkFile('themes/merchants/_common_templates/img/icon-actioncommision-small.png', 'e7b6f38aa84c86e69e0db0c35ed85313');
        $this->checkFile('themes/merchants/_common_templates/img/icon-affiliateadd-big.png', '26cca94c4c749056882bd4556d907bfd');
        $this->checkFile('themes/merchants/_common_templates/img/icon-affiliateadd-middle.png', '31ea2f9625850f1a599926887ddf2f3b');
        $this->checkFile('themes/merchants/_common_templates/img/icon-affiliateadd-small.png', 'acc87948b57319a9b577fefcafdf3c67');
        $this->checkFile('themes/merchants/_common_templates/img/icon-affiliateslist-small.png', '5f8c8a8cff8512fc608ddba8b4ab93bd');
        $this->checkFile('themes/merchants/_common_templates/img/icon-affiliatetree-big.png', '16637581ac6ae00036ed4cf0e95edbed');
        $this->checkFile('themes/merchants/_common_templates/img/icon-affiliatetree-middle.png', '50da22141c8638e2e33579a96730d447');
        $this->checkFile('themes/merchants/_common_templates/img/icon-affiliatetree-small.png', '8fe777e521204a54ef685caf830773ac');
        $this->checkFile('themes/merchants/_common_templates/img/icon-apiintegration-big.png', '8ffaaf6917c42e391f8dfac25603dc2c');
        $this->checkFile('themes/merchants/_common_templates/img/icon-apiintegration-middle.png', '61c67a4e19292e3a41d467a9255c617e');
        $this->checkFile('themes/merchants/_common_templates/img/icon-apiintegration-small.png', '2c63cf93ca9b1ff5d5b16c6646a59ddc');
        $this->checkFile('themes/merchants/_common_templates/img/icon-banneradd-big.png', '81df063ae38e46bf38935e9cefc0327d');
        $this->checkFile('themes/merchants/_common_templates/img/icon-banneradd-middle.png', 'f9eed2f2063ae89a43dd119cd957a81c');
        $this->checkFile('themes/merchants/_common_templates/img/icon-banneradd-small.png', 'ce4bc4ce2e5f8e34580dc6333b208aa8');
        $this->checkFile('themes/merchants/_common_templates/img/icon-bannerscategories-big.png', 'faea92b05cd5199241c814f685484394');
        $this->checkFile('themes/merchants/_common_templates/img/icon-bannerscategories-small.png', '81844453c555423b54b39aa264118425');
        $this->checkFile('themes/merchants/_common_templates/img/icon-bannersscategories-middle.png', '774c6fa7bfe558afe5fda5fde938fafc');
        $this->checkFile('themes/merchants/_common_templates/img/icon-billinginfo-big.png', '46fad7bed165099bc5c520b1ab962fed');
        $this->checkFile('themes/merchants/_common_templates/img/icon-billinginfo-middle.png', '051d86170471f4c07947c14be0768bc0');
        $this->checkFile('themes/merchants/_common_templates/img/icon-billinginfo-small.png', 'c5b62a0af020b01ed1791e44e76aec4f');
        $this->checkFile('themes/merchants/_common_templates/img/icon-broadcastemail-big.png', 'f2c91ecade89182f16fea8d893ae70fa');
        $this->checkFile('themes/merchants/_common_templates/img/icon-broadcastemail-middle.png', 'a84a478aab18a99fe403344166a6d7fd');
        $this->checkFile('themes/merchants/_common_templates/img/icon-broadcastemail-small.png', '52dcfbc66219534f2cacb336e3d7da8a');
        $this->checkFile('themes/merchants/_common_templates/img/icon-calccommission-big.png', 'b88131af43864361414eecae42f65860');
        $this->checkFile('themes/merchants/_common_templates/img/icon-calccommission-middle.png', '511a64884ae7c537179549d2a79e322b');
        $this->checkFile('themes/merchants/_common_templates/img/icon-calccommission-small.png', '7fc14c2584cce9f02df8e54fa825545c');
        $this->checkFile('themes/merchants/_common_templates/img/icon-calcsettings-big.png', '7c3b1590dd6bea9564d93f406062f968');
        $this->checkFile('themes/merchants/_common_templates/img/icon-calcsettings-middle.png', '755675398819a380039075bc1ee1ff6e');
        $this->checkFile('themes/merchants/_common_templates/img/icon-calcsettings-small.png', 'd6f3b62f678dcc50de2b50f026a6559a');
        $this->checkFile('themes/merchants/_common_templates/img/icon-campaignadd-big.png', 'bcde6cec8d0312a5e207211d8a591233');
        $this->checkFile('themes/merchants/_common_templates/img/icon-campaignadd-middle.png', '150ea540b710cbfa76359c33f17400ab');
        $this->checkFile('themes/merchants/_common_templates/img/icon-campaignadd-small.png', 'd412d150a33ac60e3473147b9629bfa3');
        $this->checkFile('themes/merchants/_common_templates/img/icon-campaignscategories-big.png', 'faea92b05cd5199241c814f685484394');
        $this->checkFile('themes/merchants/_common_templates/img/icon-campaignscategories-middle.png', '774c6fa7bfe558afe5fda5fde938fafc');
        $this->checkFile('themes/merchants/_common_templates/img/icon-campaignscategories-small.png', '81844453c555423b54b39aa264118425');
        $this->checkFile('themes/merchants/_common_templates/img/icon-clickcommission-big.png', '36e5ade0af6dadf475f4dbac18b853e1');
        $this->checkFile('themes/merchants/_common_templates/img/icon-clickcommission-middle.png', 'aff86bed51ff309b10dbcb3b5abf9770');
        $this->checkFile('themes/merchants/_common_templates/img/icon-clickcommission-small.png', '5fd3fa783a954bb9b095aefbddda05eb');
        $this->checkFile('themes/merchants/_common_templates/img/icon-commissionadd-big.png', 'c09448d768479c3c116cea35d25d1a64');
        $this->checkFile('themes/merchants/_common_templates/img/icon-commissionadd-middle.png', '308ff5c4c45e8135f7b1047dd26b56f1');
        $this->checkFile('themes/merchants/_common_templates/img/icon-commissionadd-small.png', '762eb56287f9a3943224a393c40b59d6');
        $this->checkFile('themes/merchants/_common_templates/img/icon-commissionslist-big.png', 'c09448d768479c3c116cea35d25d1a64');
        $this->checkFile('themes/merchants/_common_templates/img/icon-commissionslist-middle.png', '308ff5c4c45e8135f7b1047dd26b56f1');
        $this->checkFile('themes/merchants/_common_templates/img/icon-commissionslist-small.png', '762eb56287f9a3943224a393c40b59d6');
        $this->checkFile('themes/merchants/_common_templates/img/icon-communication-big.png', 'd9634c6d21ab0388db756a302b43c24b');
        $this->checkFile('themes/merchants/_common_templates/img/icon-communication-middle.png', 'dad7567ea8455db8f9d04f62827f95b7');
        $this->checkFile('themes/merchants/_common_templates/img/icon-communication-small.png', '4ca468f4707653aea90c10a8aee280be');
        $this->checkFile('themes/merchants/_common_templates/img/icon-cookie-big.png', '8a245985191ed381885daa40336a9d3c');
        $this->checkFile('themes/merchants/_common_templates/img/icon-cookie-middle.png', 'ac167af6efcca0b5b5c07ffee0088f74');
        $this->checkFile('themes/merchants/_common_templates/img/icon-cookie-small.png', 'db41360e227b890774ecea23c9291ac5');
        $this->checkFile('themes/merchants/_common_templates/img/icon-creditcardinfo-big.png', '4097374ea71eacf24b851b377519cca2');
        $this->checkFile('themes/merchants/_common_templates/img/icon-creditcardinfo-middle.png', '737248672afd083ecdb80467bf7b1932');
        $this->checkFile('themes/merchants/_common_templates/img/icon-creditcardinfo-small.png', 'f4d12911b67ae75aeb68725833395a1f');
        $this->checkFile('themes/merchants/_common_templates/img/icon-cron-big.png', 'a8986017aef2d39fcce5647aa166623a');
        $this->checkFile('themes/merchants/_common_templates/img/icon-cron-middle.png', '5a85f870602dbb253d9e321aa2302c81');
        $this->checkFile('themes/merchants/_common_templates/img/icon-cron-small.png', '4edb02cc7eb9fcd59f17fcdcd8925a2d');
        $this->checkFile('themes/merchants/_common_templates/img/icon-currency-big.png', '816bb049bcffc480c9b350704a8adbc2');
        $this->checkFile('themes/merchants/_common_templates/img/icon-currency-middle.png', '10fe7d529a376968cf05ad721f3bb605');
        $this->checkFile('themes/merchants/_common_templates/img/icon-currency-small.png', 'd5f81da7b49a3421cfa7f54ad050c790');
        $this->checkFile('themes/merchants/_common_templates/img/icon-dailyreports-big.png', '7cc246a3a285c2e3e16fc3f449da598f');
        $this->checkFile('themes/merchants/_common_templates/img/icon-dailyreports-middle.png', '1dedab44e1e695c57597adab0e42320e');
        $this->checkFile('themes/merchants/_common_templates/img/icon-dailyreports-small.png', '14a6064d2c1aeb957ae01c8b2b2a8b5f');
        $this->checkFile('themes/merchants/_common_templates/img/icon-domain-big.png', 'deef24e04a5df724664a652494d1fa6f');
        $this->checkFile('themes/merchants/_common_templates/img/icon-domain-middle.png', '84629e5b4f85c5131175c567692dfe00');
        $this->checkFile('themes/merchants/_common_templates/img/icon-domain-small.png', 'f2f26fcf1aba80559fdd8538b6fbaf41');
        $this->checkFile('themes/merchants/_common_templates/img/icon-emailtemplates-big.png', 'c4cb709797ed19238676c29cb1472c70');
        $this->checkFile('themes/merchants/_common_templates/img/icon-emailtemplates-middle.png', 'f5e1a27dc997f8480d67f4461c825edd');
        $this->checkFile('themes/merchants/_common_templates/img/icon-emailtemplates-small.png', '5d49ee20c991a906969ad4d36c7e413d');
        $this->checkFile('themes/merchants/_common_templates/img/icon-folder-big.png', 'befebaf27b76b65ef3a0a2056b6717b5');
        $this->checkFile('themes/merchants/_common_templates/img/icon-folder-middle.png', '44212fdaf6e707dcd63f96b91254fa6d');
        $this->checkFile('themes/merchants/_common_templates/img/icon-folder-small.png', 'ea493e348f302fae514119d7f83c45c6');
        $this->checkFile('themes/merchants/_common_templates/img/icon-foldergrey-big.png', '0ebd3c105f9148e6b3c2f148429e3a39');
        $this->checkFile('themes/merchants/_common_templates/img/icon-foldergrey-middle.png', '6606aad448bf6e880b16ee07917368d1');
        $this->checkFile('themes/merchants/_common_templates/img/icon-foldergrey-small.png', '6f79edef86528343b6edd4687671008c');
        $this->checkFile('themes/merchants/_common_templates/img/icon-fraudprotection-big.png', '9010f7b5556d925a916511445f28af47');
        $this->checkFile('themes/merchants/_common_templates/img/icon-fraudprotection-middle.png', '26b7b0ce01dc95ff89f934e449e23c27');
        $this->checkFile('themes/merchants/_common_templates/img/icon-fraudprotection-small.png', 'a86fc50a3868eb1e583828e8a1f036b3');
        $this->checkFile('themes/merchants/_common_templates/img/icon-impressioncommision-big.png', '4c1e7a03efa32fe7635a30fbbd8f2c85');
        $this->checkFile('themes/merchants/_common_templates/img/icon-impressioncommision-middle.png', '55960d902a1fc6db9e60ded10a7ed23c');
        $this->checkFile('themes/merchants/_common_templates/img/icon-impressioncommision-small.png', '10a3ee7b00176808f90b91b87e8d0789');
        $this->checkFile('themes/merchants/_common_templates/img/icon-invoice-big.png', 'ad77071d26277108741750ce3c29e4ba');
        $this->checkFile('themes/merchants/_common_templates/img/icon-invoice-middle.png', '8eaee3186c342a787159e27267e22d43');
        $this->checkFile('themes/merchants/_common_templates/img/icon-invoice-small.png', '85bd979002fa06ec1cf65d38b7d7a7fe');
        $this->checkFile('themes/merchants/_common_templates/img/icon-invoiceformat-big.png', '6bf9da1c9eb48ed0c19257ead306f8dd');
        $this->checkFile('themes/merchants/_common_templates/img/icon-invoiceformat-middle.png', '76c95db323aa1516ca1f565d900cff47');
        $this->checkFile('themes/merchants/_common_templates/img/icon-invoiceformat-small.png', 'f961da6366d582d141e04b425df167ca');
        $this->checkFile('themes/merchants/_common_templates/img/icon-languages-big.png', 'cae29a0f574666e60b484da7dc02c42d');
        $this->checkFile('themes/merchants/_common_templates/img/icon-languages-middle.png', '2579c343d6a2659a91e2b11b03fa7831');
        $this->checkFile('themes/merchants/_common_templates/img/icon-languages-small.png', '69a22cf6c18734c3f5f34f534f59d0dc');
        $this->checkFile('themes/merchants/_common_templates/img/icon-linkformats-big.png', '0b7c3b7cfe7b0d4fb13b13119c9d4e3e');
        $this->checkFile('themes/merchants/_common_templates/img/icon-linkformats-middle.png', '4e9a9be9246491551816510d7cfad3da');
        $this->checkFile('themes/merchants/_common_templates/img/icon-linkformats-small.png', '5e117734176b4174b1d3fc855f9bdee1');
        $this->checkFile('themes/merchants/_common_templates/img/icon-liveagent-big.png', 'eb8a8d704ddeb8169d7acc791025b019');
        $this->checkFile('themes/merchants/_common_templates/img/icon-liveagent-middle.png', '1013b101a0914f3ddfedc66acbdf2ff2');
        $this->checkFile('themes/merchants/_common_templates/img/icon-liveagent-small.png', 'cd947a9498aefe06551852e9633d4e5f');
        $this->checkFile('themes/merchants/_common_templates/img/icon-logging-big.png', 'a836bc888a51cc3272c440b76e1f4489');
        $this->checkFile('themes/merchants/_common_templates/img/icon-logging-middle.png', 'b4d937e0513feaaa49c951690e65b6ab');
        $this->checkFile('themes/merchants/_common_templates/img/icon-logging-small.png', 'c8001b73dd7b9c29222a358fa7439cf6');
        $this->checkFile('themes/merchants/_common_templates/img/icon-mapoverlay-big.png', 'f95e21092dcec6999407f32482de8654');
        $this->checkFile('themes/merchants/_common_templates/img/icon-mapoverlay-middle.png', '1ff8bf5448529154c95588e3da6b2bd5');
        $this->checkFile('themes/merchants/_common_templates/img/icon-mapoverlay-small.png', '4b9dddb70e5e0f41b1b069de5d129b0f');
        $this->checkFile('themes/merchants/_common_templates/img/icon-myinvoices-big.png', 'ad77071d26277108741750ce3c29e4ba');
        $this->checkFile('themes/merchants/_common_templates/img/icon-myinvoices-middle.png', '8eaee3186c342a787159e27267e22d43');
        $this->checkFile('themes/merchants/_common_templates/img/icon-myinvoices-small.png', '85bd979002fa06ec1cf65d38b7d7a7fe');
        $this->checkFile('themes/merchants/_common_templates/img/icon-networkaccountadd-big.png', '418a388c12bd60225f5899b1c87ac0b9');
        $this->checkFile('themes/merchants/_common_templates/img/icon-networkaccountadd-middle.png', '231dfa7e08303b7c4558d23170d5cb4e');
        $this->checkFile('themes/merchants/_common_templates/img/icon-networkaccountadd-small.png', 'ba4724b82d7f2747d0792e2073f8a7b2');
        $this->checkFile('themes/merchants/_common_templates/img/icon-networkaccountfields-big.png', '6cd403a39def5fb616f49f3d7e0b3fe2');
        $this->checkFile('themes/merchants/_common_templates/img/icon-networkaccountfields-middle.png', '0b174b7645e1ac9a8cd04da69dd5a859');
        $this->checkFile('themes/merchants/_common_templates/img/icon-networkaccountfields-small.png', 'e601d9478659d4205021d2a77c04c2eb');
        $this->checkFile('themes/merchants/_common_templates/img/icon-networkaccounts-big.png', '418a388c12bd60225f5899b1c87ac0b9');
        $this->checkFile('themes/merchants/_common_templates/img/icon-networkaccounts-middle.png', '231dfa7e08303b7c4558d23170d5cb4e');
        $this->checkFile('themes/merchants/_common_templates/img/icon-networkaccounts-small.png', 'ba4724b82d7f2747d0792e2073f8a7b2');
        $this->checkFile('themes/merchants/_common_templates/img/icon-news-big.png', '40bb8cc702f44fc780915538395f4bcc');
        $this->checkFile('themes/merchants/_common_templates/img/icon-news-middle.png', '06e1bacdbe2a9098e98b883dd1a65ab3');
        $this->checkFile('themes/merchants/_common_templates/img/icon-news-small.png', '8d9da5c42931d0869eab8201c76a78ce');
        $this->checkFile('themes/merchants/_common_templates/img/icon-offlinesale-big.png', 'ec90135d4a9d0130e8e304bae081c440');
        $this->checkFile('themes/merchants/_common_templates/img/icon-offlinesale-middle.png', '66dcbbf01bbf792063fc9fada45885a2');
        $this->checkFile('themes/merchants/_common_templates/img/icon-offlinesale-small.png', 'f7f3f63493c0322becb736a5728e5bd3');
        $this->checkFile('themes/merchants/_common_templates/img/icon-parameternames-big.png', '9dfb5dd726b437a4365e7c45a7c408d3');
        $this->checkFile('themes/merchants/_common_templates/img/icon-parameternames-middle.png', '43de9c57262992d30beb88f52fb3af21');
        $this->checkFile('themes/merchants/_common_templates/img/icon-parameternames-small.png', '4bbe462e5afa4a1e0215f368d0fb8903');
        $this->checkFile('themes/merchants/_common_templates/img/icon-payaffiliates-big.png', '4334ddecb0a08a61b26044e1185e87d1');
        $this->checkFile('themes/merchants/_common_templates/img/icon-payaffiliates-middle.png', 'd473f2fb10ab1b3ef84ae1285c90647f');
        $this->checkFile('themes/merchants/_common_templates/img/icon-payaffiliates-small.png', '014347b0105edd288bd701e5fc544a5a');
        $this->checkFile('themes/merchants/_common_templates/img/icon-payoutsbalance-big.png', '6cd403a39def5fb616f49f3d7e0b3fe2');
        $this->checkFile('themes/merchants/_common_templates/img/icon-payoutsbalance-middle.png', '0b174b7645e1ac9a8cd04da69dd5a859');
        $this->checkFile('themes/merchants/_common_templates/img/icon-payoutsbalance-small.png', 'e601d9478659d4205021d2a77c04c2eb');
        $this->checkFile('themes/merchants/_common_templates/img/icon-proxy-big.png', '67899c6630a1d54cb882ac30bc4c1fea');
        $this->checkFile('themes/merchants/_common_templates/img/icon-proxy-middle.png', '8c84e7263189e5302b4ef463bc29e6b1');
        $this->checkFile('themes/merchants/_common_templates/img/icon-proxy-small.png', 'de57ff1e951414cdf1d4c495db128aea');
        $this->checkFile('themes/merchants/_common_templates/img/icon-recurringcommissionslist-big.png', 'f0069a7b12a4c842189d353a16787d63');
        $this->checkFile('themes/merchants/_common_templates/img/icon-recurringcommissionslist-middle.png', 'e22b0e87b75fa45fbcce9fd7bc0e3a32');
        $this->checkFile('themes/merchants/_common_templates/img/icon-recurringcommissionslist-small.png', 'd9fd1789958cb9843284d5182d239541');
        $this->checkFile('themes/merchants/_common_templates/img/icon-reportproblems-big.png', 'ea668db8e90d4d2dd5891be9c3662d65');
        $this->checkFile('themes/merchants/_common_templates/img/icon-reportproblems-middle.png', '72a5e3a0a993e899b89747f7a977c3b8');
        $this->checkFile('themes/merchants/_common_templates/img/icon-reportproblems-small.png', 'aba167c8a15a1f84f1cc004498e2fcd1');
        $this->checkFile('themes/merchants/_common_templates/img/icon-rss-big.png', '72ced7ea320583602b850ff6e5c7fbdc');
        $this->checkFile('themes/merchants/_common_templates/img/icon-salecommission-big.png', '8e29539a67c5649a182722073913a313');
        $this->checkFile('themes/merchants/_common_templates/img/icon-salecommission-middle.png', 'e6f76cab2074540649a7a42cabf9f3ca');
        $this->checkFile('themes/merchants/_common_templates/img/icon-salecommission-small.png', '1a5ca460dd7ec1682c789d9fdcaafd08');
        $this->checkFile('themes/merchants/_common_templates/img/icon-topreferringurl-big.png', '418a388c12bd60225f5899b1c87ac0b9');
        $this->checkFile('themes/merchants/_common_templates/img/icon-topreferringurl-middle.png', '231dfa7e08303b7c4558d23170d5cb4e');
        $this->checkFile('themes/merchants/_common_templates/img/icon-topreferringurl-small.png', 'ba4724b82d7f2747d0792e2073f8a7b2');
        $this->checkFile('themes/merchants/_common_templates/img/icon-trackingaffiliates-big.png', 'f717823f3c85d837811ed97caeb2a66b');
        $this->checkFile('themes/merchants/_common_templates/img/icon-trackingaffiliates-middle.png', 'd457fbb7ee85000bdfc251ac1502b413');
        $this->checkFile('themes/merchants/_common_templates/img/icon-trackingaffiliates-small.png', '4c2ebf2c84cb6b1236b8b22004798df9');
        $this->checkFile('themes/merchants/_common_templates/img/icon-trafficinfo-big.png', '52bdc4d11bae3a9c174ea5789fb54458');
        $this->checkFile('themes/merchants/_common_templates/img/icon-trafficinfo-middle.png', '84629e5b4f85c5131175c567692dfe00');
        $this->checkFile('themes/merchants/_common_templates/img/icon-trafficinfo-small.png', 'f2f26fcf1aba80559fdd8538b6fbaf41');
        $this->checkFile('themes/merchants/_common_templates/img/icon-troubleshooting-big.png', '28b65cd15641f0bcac4a7ca9ff12f3e2');
        $this->checkFile('themes/merchants/_common_templates/img/icon-vathandling-big.png', '514522fd956ad10fd392ff7a145c6873');
        $this->checkFile('themes/merchants/_common_templates/img/icon-vathandling-middle.png', 'b1f77e628bfe32b0f9898b97d091779a');
        $this->checkFile('themes/merchants/_common_templates/img/icon-vathandling-small.png', 'c212e16c531c0b338b81bd97083e2a50');
        $this->checkFile('themes/merchants/_common_templates/img/icon-views-big.png', '9c84c38db0ea8cbb675db9e03c54bd38');
        $this->checkFile('themes/merchants/_common_templates/img/icon-views-middle.png', 'c9e3031d5c622b524e418aef9a9c768b');
        $this->checkFile('themes/merchants/_common_templates/img/icon-views-small.png', '0297aac207d61c873818888fa2112d19');
        $this->checkFile('themes/merchants/_common_templates/img/icon-youraccount-big.png', '93aee3ef0df883c5b513b90605b12e55');
        $this->checkFile('themes/merchants/_common_templates/img/icon-youraccount-middle.png', 'b094943bdff3a224535cc2ed898b502f');
        $this->checkFile('themes/merchants/_common_templates/img/icon-youraccount-small.png', 'c1f9bf50c046924bb0ea5b00bff5d223');
        $this->checkFile('themes/merchants/_common_templates/img/icon.chart.affiliates.png', 'dd89b0ee9721ebabfb2b87f2504d123d');
        $this->checkFile('themes/merchants/_common_templates/img/icon.invoice.png', '9e77bab051d73681cf35d6f763e39851');
        $this->checkFile('themes/merchants/_common_templates/img/icon.labelaspaid.png', 'f0ce20cb7eb9051f87f88280bc61336a');
        $this->checkFile('themes/merchants/_common_templates/img/icon.logintopanel.png', '46b5c978c4b387012d3c17e6e9ff7e63');
        $this->checkFile('themes/merchants/_common_templates/img/icon.month.statistics.png', '5ba6e93c333e6c59eb9eeb9c529c3ea9');
        $this->checkFile('themes/merchants/_common_templates/img/icon.quick.links.png', 'df7f69d2e875af0d7f442aa46ee1cd4a');
        $this->checkFile('themes/merchants/_common_templates/img/icon.reports.png', '0b5391d854a26b2e45fd2bfa124736e6');
        $this->checkFile('themes/merchants/_common_templates/img/icon.statistics.png', 'cb716511b447e02152ac8f6a21c2c8a3');
        $this->checkFile('themes/merchants/_common_templates/img/icon.top.affiliates.png', 'dd89b0ee9721ebabfb2b87f2504d123d');
        $this->checkFile('themes/merchants/_common_templates/img/integration-clicks-onover.jpg', 'e92c977985801c1eadb5c4adb975de7c');
        $this->checkFile('themes/merchants/_common_templates/img/integration-clicks.jpg', '8a8621a4f3601b9d3e31f71d838cddb0');
        $this->checkFile('themes/merchants/_common_templates/img/integration-sales-onover.jpg', '5dbb155a5324f3cabc20c995794fa35c');
        $this->checkFile('themes/merchants/_common_templates/img/integration-sales.jpg', 'a18f04ab96315bad8edf5df95ac68993');
        $this->checkFile('themes/merchants/_common_templates/img/loading.gif', '546d9515580e0c8e3d0813c2e04ed9aa');
        $this->checkFile('themes/merchants/_common_templates/img/logo_pan.jpg', 'e11b89662d01ad51927067143efe6298');
        $this->checkFile('themes/merchants/_common_templates/img/logo_pan.png', '97ebd132ae8ec2dd08bbef552d03a0fd');
        $this->checkFile('themes/merchants/_common_templates/img/logo_pap.jpg', 'cd14b7752b98bf01c9723d525a3f8e4b');
        $this->checkFile('themes/merchants/_common_templates/img/logo_pap.png', '011698765bb35b0ae0dd13f8f16955d5');
        $this->checkFile('themes/merchants/_common_templates/img/mail_hover.jpg', 'de17b3999706cee9ce02caac224be7be');
        $this->checkFile('themes/merchants/_common_templates/img/mailoutbox-image-hover.png', '5f4176b9c17b03798c58efbd0ebf94a9');
        $this->checkFile('themes/merchants/_common_templates/img/mailoutbox-image.png', '9433716887a3276d9fa6a18d299350f1');
        $this->checkFile('themes/merchants/_common_templates/img/method.png', '07f5e9c63b63dcbc298ab40a9ae23614');
        $this->checkFile('themes/merchants/_common_templates/img/no_image.gif', '07f5f79d487dbf795f7ea37a04aa24c0');
        $this->checkFile('themes/merchants/_common_templates/img/overview.png', '63ec9d3983440826362b89e3d42db410');
        $this->checkFile('themes/merchants/_common_templates/img/pa.logo.jpg', 'd3470f84298df66e743f49cfb1384b70');
        $this->checkFile('themes/merchants/_common_templates/img/pap4.logo.jpg', '401e48f00975e0f33b54c27e19864fba');
        $this->checkFile('themes/merchants/_common_templates/img/payout-image-hover.png', 'b560c99b47c447e645be903516a2b0b4');
        $this->checkFile('themes/merchants/_common_templates/img/payout-image.png', '60fbe68dd02acf2520b16ef6d0c4a6d1');
        $this->checkFile('themes/merchants/_common_templates/img/payout.jpg', 'c473faeb71f0df5c09c17e5a02e5af9a');
        $this->checkFile('themes/merchants/_common_templates/img/payout_hover.jpg', 'e3ca5fca7240404ddc3e6e16967ac1ef');
        $this->checkFile('themes/merchants/_common_templates/img/paypal.jpg', '1e18c3feef21be6605c97f5ac72e7453');
        $this->checkFile('themes/merchants/_common_templates/img/plugins.jpg', 'e9f5963f43601288647497cbf67b4ca1');
        $this->checkFile('themes/merchants/_common_templates/img/plugins_hover.jpg', '1640f46be8ecf8e6d0aa4840ce0709d0');
        $this->checkFile('themes/merchants/_common_templates/img/post_affiliate_pro_box.jpg', '591c1b7627f2c09e86890a954cf93797');
        $this->checkFile('themes/merchants/_common_templates/img/post_affiliate_pro_box.png', '0bd1d6963b5a7e94781b7b82504342c1');
        $this->checkFile('themes/merchants/_common_templates/img/quick.stats.back.png', '05ce0cf5ecf5ea386e729590c7faceee');
        $this->checkFile('themes/merchants/_common_templates/img/quick.stats.l.png', '9aa3ec2b704ad520fed399546aed3871');
        $this->checkFile('themes/merchants/_common_templates/img/quick.stats.r.png', '8ae86e9165bf1dd2bbd1652bec9923a0');
        $this->checkFile('themes/merchants/_common_templates/img/quickstats.b.png', 'b90c4f3c94a53daa7757b576f057a963');
        $this->checkFile('themes/merchants/_common_templates/img/quickstats.back.png', 'f892d80dd6abae197d47a76f6183ca58');
        $this->checkFile('themes/merchants/_common_templates/img/quickstats.bl.png', '44e4483ad3f6008c68f9cb3d8a7bd6da');
        $this->checkFile('themes/merchants/_common_templates/img/quickstats.br.png', 'de984b634714f0dee9d4b17cdae7c0fc');
        $this->checkFile('themes/merchants/_common_templates/img/quickstats.l.png', 'ced1100151837d7fd878608e3e1cdeb5');
        $this->checkFile('themes/merchants/_common_templates/img/quickstats.r.png', '32789e7f6134020fd5dcb93d4993750f');
        $this->checkFile('themes/merchants/_common_templates/img/quickstats.t.png', 'e7a43e28a33bbe58dc6accae43fee1a2');
        $this->checkFile('themes/merchants/_common_templates/img/quickstats.tl.png', '660a8cabb636a29197fd7bbde111fc9d');
        $this->checkFile('themes/merchants/_common_templates/img/quickstats.tr.png', '624d9de86dc1a84ba3a25531d16fb8a3');
        $this->checkFile('themes/merchants/_common_templates/img/restart.png', 'eec6024832d1cc0eee8140c15e5d9ecd');
        $this->checkFile('themes/merchants/_common_templates/img/secure.png', '4490e30d2ac3700e78315f510dfff342');
        $this->checkFile('themes/merchants/_common_templates/img/settings-image-hover.png', '98ad6bbb3e500df44c79e784f7e67362');
        $this->checkFile('themes/merchants/_common_templates/img/settings-image.png', 'c6bb48ab4ce777e4ef4d79ff6e1f4985');
        $this->checkFile('themes/merchants/_common_templates/img/signup.jpg', '1d14e7d0f7a74d0a8409cadf047e4f55');
        $this->checkFile('themes/merchants/_common_templates/img/signup_hover.jpg', '8b9482521349591d8c41b344a86b0435');
        $this->checkFile('themes/merchants/_common_templates/img/smpl_aff_edit_no_payout_hist.jpg', 'a25cbbb947cf88b9156b8c0a39b3b6c7');
        $this->checkFile('themes/merchants/_common_templates/img/smpl_aff_list.jpg', '95dedfb0a4268e86719a99fd7bb7e4a2');
        $this->checkFile('themes/merchants/_common_templates/img/smpl_after_signup.jpg', 'e7b4779eaed1f320f3acd2396ae29109');
        $this->checkFile('themes/merchants/_common_templates/img/smpl_banner_list.jpg', '5e6e5ef0aba44aecf4259adabaf928ca');
        $this->checkFile('themes/merchants/_common_templates/img/smpl_campaign_list.jpg', '573efa7bfdbdd52df3b8d1d725e36dd7');
        $this->checkFile('themes/merchants/_common_templates/img/smpl_currencies.jpg', '51667b8093617f92c138c3bc99f618ab');
        $this->checkFile('themes/merchants/_common_templates/img/smpl_directlinks_list.jpg', 'bd33145d2e575bb16649251184200e66');
        $this->checkFile('themes/merchants/_common_templates/img/smpl_mailoutbox_list.jpg', '2cad0e41d23b7982c1114507a076d01d');
        $this->checkFile('themes/merchants/_common_templates/img/smpl_pay_aff.jpg', '26da011438f5124a2ef1fd0167cb04ab');
        $this->checkFile('themes/merchants/_common_templates/img/smpl_payout_fields.jpg', '7a4efb3ae9e0edb2d8f2a4e507d8d28a');
        $this->checkFile('themes/merchants/_common_templates/img/smpl_payout_hist.jpg', '99aed93a1e7552a677be985e788a384e');
        $this->checkFile('themes/merchants/_common_templates/img/smpl_payout_options.jpg', '3ac652642557a5288257407c06bf4fa4');
        $this->checkFile('themes/merchants/_common_templates/img/smpl_payoutstoaffiliates.jpg', 'c14fc4bd8206beaf3c4a87d4d7266251');
        $this->checkFile('themes/merchants/_common_templates/img/smpl_rawclick_list.jpg', '02ecd7e7091b956070383367c7f9fcf1');
        $this->checkFile('themes/merchants/_common_templates/img/smpl_subid_report_clicks.jpg', '9eb7fd8cdf4317a491d7a1543675fc38');
        $this->checkFile('themes/merchants/_common_templates/img/smpl_transact_list.jpg', 'eda2e2553a466ce13269c6f6d4b1f5e1');
        $this->checkFile('themes/merchants/_common_templates/img/stars_0_5.gif', 'aedc5033d5861ae69f81e140956e4c00');
        $this->checkFile('themes/merchants/_common_templates/img/stars_1_5.gif', '26405d126a615ce671888683cdd6980e');
        $this->checkFile('themes/merchants/_common_templates/img/stars_2_5.gif', 'fa039a9341450e7c9a257f3c5218a2e7');
        $this->checkFile('themes/merchants/_common_templates/img/stars_3_5.gif', '55ad328099473e930235e219c35d01bd');
        $this->checkFile('themes/merchants/_common_templates/img/stars_4_5.gif', '9795d68b4b545807fc5843338fd83396');
        $this->checkFile('themes/merchants/_common_templates/img/stars_5_5.gif', '1195b171374f0065ba82fa32325a9d04');
        $this->checkFile('themes/merchants/_common_templates/img/started.b.png', 'e728cac13b48901d58249f89a10ee8d1');
        $this->checkFile('themes/merchants/_common_templates/img/started.back.png', 'fa66dc302ae7ce1382b043617bd2842b');
        $this->checkFile('themes/merchants/_common_templates/img/started.bl.png', '74d54ab3288333401e950c06faa3ce02');
        $this->checkFile('themes/merchants/_common_templates/img/started.br.png', '469108c636b3e6d69b4567ba7e536c78');
        $this->checkFile('themes/merchants/_common_templates/img/started.l.png', 'c782b173a52425e6a7f190ae3a8e1253');
        $this->checkFile('themes/merchants/_common_templates/img/started.r.png', '63ce5a6234d691ea1bf46a8f339d2f4b');
        $this->checkFile('themes/merchants/_common_templates/img/started.t.png', '80f863809f1b1559d5d8534927da1eb1');
        $this->checkFile('themes/merchants/_common_templates/img/started.tl.png', '814cc397cea40d84ef0b32ce366d0161');
        $this->checkFile('themes/merchants/_common_templates/img/started.tr.png', '517fb99677ca8004d88ff539d0b18bbc');
        $this->checkFile('themes/merchants/_common_templates/img/step.png', '051cd8c1c1e82c6fa41f52936a7a844d');
        $this->checkFile('themes/merchants/_common_templates/img/theme.jpg', '236fa690707a3626d5e6c7f0b7dae9a9');
        $this->checkFile('themes/merchants/_common_templates/img/theme_hover.jpg', '77f4a3a3db7fa62cdbd964fcdb7265bf');
        $this->checkFile('themes/merchants/_common_templates/img/track.jpg', 'd01b40806dac17f630aecc238c744dce');
        $this->checkFile('themes/merchants/_common_templates/img/track_hover.jpg', 'f4559ea9d0d4291930852af7e15d5538');
        $this->checkFile('themes/merchants/_common_templates/img/tracking-image-hover.png', '426439ccf404f570f4a657b92212372e');
        $this->checkFile('themes/merchants/_common_templates/img/tracking-image.png', 'ceb909120169697e85fcf61b87cf4aa0');
        $this->checkFile('themes/merchants/_common_templates/img/why_open_account.jpg', '7cdc81bc6bad3bba34bb5a0035998f38');
        $this->checkFile('themes/merchants/_common_templates/import_coupons_form.tpl', '8fc3b5964331ebd6232227b4f8fa937d');
        $this->checkFile('themes/merchants/_common_templates/import_export_panel.tpl', '1c85aa7c0a205b7e719b851b9b0577ae');
        $this->checkFile('themes/merchants/_common_templates/import_panel.tpl', '95e84810a119ccb38b21e76433deb0b0');
        $this->checkFile('themes/merchants/_common_templates/import_theme_panel.tpl', '432abe37f646bab80a593385454d1074');
        $this->checkFile('themes/merchants/_common_templates/integration.tpl', '939839cb552c71fdcb243c4a34aa35ee');
        $this->checkFile('themes/merchants/_common_templates/integration_method.tpl', '16ea9f14a759b0ba844c29e517e273a6');
        $this->checkFile('themes/merchants/_common_templates/integration_method_step.tpl', '38dbef72ee33c64acd1f1c85663fca12');
        $this->checkFile('themes/merchants/_common_templates/integration_methods.tpl', 'd9edfa810074a70754a0551d65c1aa1f');
        $this->checkFile('themes/merchants/_common_templates/integration_methods_advanced.tpl', '0e72005d09820e3a2f057ea3c71cb7a7');
        $this->checkFile('themes/merchants/_common_templates/invoice_data_panel.tpl', '99f5472c9142ddd506d4d4d1ffdb3acb');
        $this->checkFile('themes/merchants/_common_templates/invoice_form.tpl', '3568c3cb472ca2ee0d5af3b45eb3e2a6');
        $this->checkFile('themes/merchants/_common_templates/invoices_filter.tpl', 'c48f2bcf23ee0003b2a20578e3b8fc00');
        $this->checkFile('themes/merchants/_common_templates/invoices_list.tpl', 'eb5ea9f3ddc679dabb97f1f5955b5936');
        $this->checkFile('themes/merchants/_common_templates/keywords_performance.tpl', 'ff04186585d9589e4d0dbc48ac0f70c4');
        $this->checkFile('themes/merchants/_common_templates/keywords_performance_advanced_filter.tpl', 'f8064b272b30dc22965b002fdb4749a3');
        $this->checkFile('themes/merchants/_common_templates/label_panel.tpl', 'e0c85a01af8477fe16cb6770fbb5e7af');
        $this->checkFile('themes/merchants/_common_templates/language_translations_filter.tpl', '82db4b6588f78c94ec3dcbc26dd94907');
        $this->checkFile('themes/merchants/_common_templates/lifetime_referral_edit.tpl', '6a0bb5b27a3932f8c30df1caf6de1b1b');
        $this->checkFile('themes/merchants/_common_templates/lifetime_referrals_filter.tpl', 'bedc2061ff2f4f23a4995b04f9696116');
        $this->checkFile('themes/merchants/_common_templates/lifetime_referrals_import.tpl', '4b5445af5cdecc338e08709e922da43d');
        $this->checkFile('themes/merchants/_common_templates/lifetime_referrals_panel.tpl', '4cf3b121d2112e66eb25bb7c15e54c65');
        $this->checkFile('themes/merchants/_common_templates/link_method_panel.tpl', '9af6c599de2f311cb0149524b50ff20d');
        $this->checkFile('themes/merchants/_common_templates/linking_method.tpl', '7e0919bff0810701acf299531e0ef0eb');
        $this->checkFile('themes/merchants/_common_templates/lite_campaign_wizard.tpl', 'f4dd039cadd53c84b42c00add7ea75ea');
        $this->checkFile('themes/merchants/_common_templates/load_mail_from_template.tpl', 'ea8100528686a687181767b7eac64c17');
        $this->checkFile('themes/merchants/_common_templates/log_filter.tpl', 'dd07023ff77fc4347c5fb16ee47945c3');
        $this->checkFile('themes/merchants/_common_templates/log_list.tpl', 'cde7638e5cdee1c96ead564c74def6ba');
        $this->checkFile('themes/merchants/_common_templates/logging_tab.tpl', '311fa0b71a0ba9e9bff13146a6860d19');
        $this->checkFile('themes/merchants/_common_templates/logging_tab_debug.tpl', '5e90619daceb0fbd649012350683098f');
        $this->checkFile('themes/merchants/_common_templates/logging_tab_logins_history.tpl', '69e7f02649ea66ffae54eb912eee5926');
        $this->checkFile('themes/merchants/_common_templates/login_form.tpl', '68fec5fc89be1ee473d62ac966211289');
        $this->checkFile('themes/merchants/_common_templates/login_main.tpl', '5b3eb0529047463ac6b90a529de64d85');
        $this->checkFile('themes/merchants/_common_templates/logo_settings.tpl', 'a8fcdb4ced87b436c0da164018e1f2ee');
        $this->checkFile('themes/merchants/_common_templates/main.tpl', 'f37bda6e1ab2178f610bad16314fec78');
        $this->checkFile('themes/merchants/_common_templates/main_integration_steps_icons.tpl', '377949c9a64101045d7d8ab4d4e5a676');
        $this->checkFile('themes/merchants/_common_templates/map_overlay.tpl', '3837a3909a6dd85d355e2e9425ceccc6');
        $this->checkFile('themes/merchants/_common_templates/map_overlay_advanced_filter.tpl', 'e89ef5239b7f6b21722ea3179ae74ed5');
        $this->checkFile('themes/merchants/_common_templates/map_overlay_edit.tpl', 'd173ac586a3502e61f80a956597e1496');
        $this->checkFile('themes/merchants/_common_templates/mass_pay_export.tpl', '5388d4b7f22b6222eb26fa1cd3ec6589');
        $this->checkFile('themes/merchants/_common_templates/menu_section.tpl', 'ce9552c9579aa842bfd16e9c61b1cd0e');
        $this->checkFile('themes/merchants/_common_templates/merchant_category_info.tpl', 'ecf110e07235298eb0403fdb6c8a1448');
        $this->checkFile('themes/merchants/_common_templates/merchant_tutorial_video.tpl', 'dbc5add56be954268859d520e9cda3f0');
        $this->checkFile('themes/merchants/_common_templates/month_banner_stats.tpl', '83d1c8c11720897ff9ee102aa029776e');
        $this->checkFile('themes/merchants/_common_templates/multi_form_widget.tpl', '9fc7c1627778dfdfcfb43a0309f3b155');
        $this->checkFile('themes/merchants/_common_templates/multiple_currencies_panel.tpl', '6e047edf242e91f0900fb0d44c0697aa');
        $this->checkFile('themes/merchants/_common_templates/network_invoice.tpl', 'cf949b304f5a73c125bbae158235e09a');
        $this->checkFile('themes/merchants/_common_templates/network_proforma_invoice.tpl', '75f791b24480a3565244e7849e569013');
        $this->checkFile('themes/merchants/_common_templates/news_content.tpl', '08d9f1f5e6ebcc1c34812ee3daf52065');
        $this->checkFile('themes/merchants/_common_templates/news_filter.tpl', 'ec2d72d8614abd3f6b140103419883e5');
        $this->checkFile('themes/merchants/_common_templates/news_form_edit.tpl', 'e81874e53fcfee327bcb27920173f068');
        $this->checkFile('themes/merchants/_common_templates/news_item.tpl', '18161a56a8f4dc5df01f08191709f864');
        $this->checkFile('themes/merchants/_common_templates/news_list.tpl', 'a8b250f5a2e75248da88066fb6519d1f');
        $this->checkFile('themes/merchants/_common_templates/news_panel.tpl', 'f9a090f76ec6dc6cd2a3ac978482424b');
        $this->checkFile('themes/merchants/_common_templates/no_category_selected_settings_panel.tpl', '91e0fabbc6b6008b7bdb8136c20e6cfb');
        $this->checkFile('themes/merchants/_common_templates/note_filter.tpl', '5984797bddb6b9dff4b4066106da1bcf');
        $this->checkFile('themes/merchants/_common_templates/offline_sale.tpl', 'e93c59ee7dda028d3df6b697fc6bd0c5');
        $this->checkFile('themes/merchants/_common_templates/offline_sale_form.tpl', '86fe26a2a1e02d811e892233db9d6b5e');
        $this->checkFile('themes/merchants/_common_templates/online_users_gadget_template.tpl', '80ebdfe2a212375942cac09081e371b2');
        $this->checkFile('themes/merchants/_common_templates/order_id_filter.tpl', '103e1ce5be4c9d2f1cc161390371e222');
        $this->checkFile('themes/merchants/_common_templates/orgchart_affiliate_widget.tpl', '32f4faf30d0289ffd4c9d53f92a39388');
        $this->checkFile('themes/merchants/_common_templates/overview_panel.tpl', '0acba2369c61375baf2a50f30efcc832');
        $this->checkFile('themes/merchants/_common_templates/overview_stats_panel.tpl', '6bfec488423b936db1d7687cf6d47a0f');
        $this->checkFile('themes/merchants/_common_templates/page_type_radio.tpl', 'd132376c54a57b3962d1ca08eda22000');
        $this->checkFile('themes/merchants/_common_templates/pap4.css', '8088e140a02ebc9c085d78be314162b2');
        $this->checkFile('themes/merchants/_common_templates/parameter_names_form.tpl', '30af501856e2f120a2fa3c7ce929ba38');
        $this->checkFile('themes/merchants/_common_templates/parentuser_field.tpl', '85c7a5339f96a3420cbfc6611417b185');
        $this->checkFile('themes/merchants/_common_templates/password_field.tpl', 'e9f0cf0c9e3f494063cfb3fc907fbca6');
        $this->checkFile('themes/merchants/_common_templates/pay_affilates_form.tpl', '5d05b3aaf0ffaf488b32e7cc2d660d72');
        $this->checkFile('themes/merchants/_common_templates/pay_affiliate_template.tpl', '692261c025aab9b05408b9651de9a894');
        $this->checkFile('themes/merchants/_common_templates/pay_affiliates.tpl', '999d9d7228922379c464c51ce37366eb');
        $this->checkFile('themes/merchants/_common_templates/pay_affiliates_filter.tpl', 'eeb79004385a7155fe332f4366d6a4f0');
        $this->checkFile('themes/merchants/_common_templates/pay_affiliates_list.tpl', '85b17725f87d1ea59102020c1f290070');
        $this->checkFile('themes/merchants/_common_templates/pay_affiliates_no_data.tpl', 'bdc28971e5d6cef3a878e01842dc8ce7');
        $this->checkFile('themes/merchants/_common_templates/pay_invoice_form.tpl', 'af754b7223787fe98b3c23a4d3a2d5a3');
        $this->checkFile('themes/merchants/_common_templates/payee_info.tpl', '4295c82c593e787295ad9c64d044aa73');
        $this->checkFile('themes/merchants/_common_templates/payee_info_main.tpl', '8048bb0c734d26af0a077e1728b2e814');
        $this->checkFile('themes/merchants/_common_templates/payout_data.tpl', 'd1e88682626172910d5753981c6eed94');
        $this->checkFile('themes/merchants/_common_templates/payout_fields_form.tpl', '0f8a8b9516b729ab4899926ead42be16');
        $this->checkFile('themes/merchants/_common_templates/payout_fields_no_data.tpl', '5f1ccef46819e8e4bc63f23270fec160');
        $this->checkFile('themes/merchants/_common_templates/payout_history_form.tpl', 'a2232ac60e9b0feb41bd921c73be763a');
        $this->checkFile('themes/merchants/_common_templates/payout_history_list_no_data.tpl', 'ec4077af0c4adef0c936eca37659dc92');
        $this->checkFile('themes/merchants/_common_templates/payout_history_template.tpl', '57b001e6c12b48707fb323078e00215f');
        $this->checkFile('themes/merchants/_common_templates/payout_invoice_format.tpl', '4ce2db954c83c7a499090bad5095c3ab');
        $this->checkFile('themes/merchants/_common_templates/payout_methods_filter_field.tpl', '3e44e83bdfd9080f05070dd2281dcfd2');
        $this->checkFile('themes/merchants/_common_templates/payout_option_form.tpl', '7f6cefc05e6aef546ec114df1892e840');
        $this->checkFile('themes/merchants/_common_templates/payout_options_form.tpl', '9517d8e335b95fb0192b09c427f903b4');
        $this->checkFile('themes/merchants/_common_templates/payout_options_no_data.tpl', 'de7179971e1f8b16531ef8fba9183e93');
        $this->checkFile('themes/merchants/_common_templates/payout_options_text_box.tpl', '9d7c675a676c204bafaa2c1f32b3f6a4');
        $this->checkFile('themes/merchants/_common_templates/payout_settings_icons.tpl', 'aa4813c156afb53ed10a02319166c340');
        $this->checkFile('themes/merchants/_common_templates/payouts_balance_form.tpl', 'd01274716d5700a7180cd8277b575cb0');
        $this->checkFile('themes/merchants/_common_templates/payouts_balance_settings.tpl', 'ee787952642013d98ce60b2d0175e39c');
        $this->checkFile('themes/merchants/_common_templates/payouts_history.tpl', '7bcfa2c7650a10091139bf513af0a79b');
        $this->checkFile('themes/merchants/_common_templates/payouts_history_filter.tpl', '0fc22bfd9e4bd79e5b586d1c27fccbf1');
        $this->checkFile('themes/merchants/_common_templates/payouts_to_affiliates.tpl', '96ba40caf1e7d28a1b38f8da75646c45');
        $this->checkFile('themes/merchants/_common_templates/payouts_to_affiliates_filter.tpl', 'ed46b195b29fc222d3239775ab486919');
        $this->checkFile('themes/merchants/_common_templates/payoutstoaffiliates_list_no_data.tpl', 'ec51b843936b65302d9d32be1305d369');
        $this->checkFile('themes/merchants/_common_templates/peel_banner_feature_on_deactivate.tpl', '88a989ccfb54f68203c01176a104541f');
        $this->checkFile('themes/merchants/_common_templates/pending_tasks.tpl', '3aa9f9ee68b7ef3258fe7a9c3994f952');
        $this->checkFile('themes/merchants/_common_templates/pending_tasks_data.tpl', '1916b1db72af25350e122542f2261eb3');
        $this->checkFile('themes/merchants/_common_templates/pending_tasks_panel.tpl', '16eaedf4545a03d89f94b98e3adacfa4');
        $this->checkFile('themes/merchants/_common_templates/pending_tasks_template.tpl', '091fb315fbb9a3d24bf16baa791bd32f');
        $this->checkFile('themes/merchants/_common_templates/performance_rewards.tpl', 'b00ce7ab890ee0474b028b33b9febda8');
        $this->checkFile('themes/merchants/_common_templates/performance_rewards_filter.tpl', 'a9f8ab25ca000ae23c0a735cb4aefd52');
        $this->checkFile('themes/merchants/_common_templates/placement_overview_filter.tpl', 'c72280b8533adb571789b48008da4d17');
        $this->checkFile('themes/merchants/_common_templates/placement_overview_panel.tpl', '0de09a6e1f5bb261f727565843115c71');
        $this->checkFile('themes/merchants/_common_templates/popup_actions_panel.tpl', 'ef01a0f4fa742fc99a03632e1d6876b4');
        $this->checkFile('themes/merchants/_common_templates/postsignup_radio.tpl', 'bdc70b0faa8b5b2ba28971cc37f41193');
        $this->checkFile('themes/merchants/_common_templates/postsignup_settings_page.tpl', '3657e859769d3db637b6a83e45ab218d');
        $this->checkFile('themes/merchants/_common_templates/postsignup_settings_url.tpl', '79c6a9a4b545bcb281f15b7fdb599f02');
        $this->checkFile('themes/merchants/_common_templates/private_campaigns_feature_on_deactivate.tpl', 'ecef84105dc2779ac2fb428da2e9f25f');
        $this->checkFile('themes/merchants/_common_templates/qualityunit_news.stpl', '188a98161e9218eb440aab2d33341a0c');
        $this->checkFile('themes/merchants/_common_templates/quick_report_base.tpl', '9ab056e97e59a1ef7e81e5a2ddafd977');
        $this->checkFile('themes/merchants/_common_templates/quick_report_content.stpl', '2153d19cb2b73cfa943c32124e69e181');
        $this->checkFile('themes/merchants/_common_templates/quick_report_content_multitier.stpl', 'a8e0e2d4eff1b053cc532d7290d81ddd');
        $this->checkFile('themes/merchants/_common_templates/quick_report_filter_base.tpl', '5302a61cfb5e98486cfe4322b51f35ff');
        $this->checkFile('themes/merchants/_common_templates/quick_report_multitier_widget.tpl', '24108ad66b123214ae2c170aaa4ec369');
        $this->checkFile('themes/merchants/_common_templates/quick_stats_actions_panel.tpl', 'd0816b90a3fbe4f4ffa09a37aec14268');
        $this->checkFile('themes/merchants/_common_templates/quick_stats_box.tpl', '745d64595b8a0e5869bfc1e9bf10b9c2');
        $this->checkFile('themes/merchants/_common_templates/radio_button_group_row.tpl', '3713f6d400aa1ca96d9e404082304912');
        $this->checkFile('themes/merchants/_common_templates/radio_form_panel.tpl', 'c56091f134178fc494aa76df1b6ad6a1');
        $this->checkFile('themes/merchants/_common_templates/rebrand_pdf_feature_on_deactivate.tpl', '57adefe6824afba7c2477b79c5663843');
        $this->checkFile('themes/merchants/_common_templates/recaptcha_settings.tpl', 'edaa6a6225d6323db3f7b88fc181d160');
        $this->checkFile('themes/merchants/_common_templates/recipients.tpl', '1664c519d05866b798916d1d794e5548');
        $this->checkFile('themes/merchants/_common_templates/recurring_commission_edit.tpl', 'f144dcac07b3913bb6dfb866e4871d9d');
        $this->checkFile('themes/merchants/_common_templates/recurring_commission_filter.tpl', '5952c04cf0627694717d6f4eb5f138db');
        $this->checkFile('themes/merchants/_common_templates/recurring_commission_list.tpl', 'd1ad4da7be15504d6586baed12a2dbd2');
        $this->checkFile('themes/merchants/_common_templates/recurring_commissions.tpl', '8c806617d38c467e2f29e22bb43e826c');
        $this->checkFile('themes/merchants/_common_templates/referringurl_advanced_filter.tpl', 'ab412ddcd34eb8078de7ad501894e200');
        $this->checkFile('themes/merchants/_common_templates/replicated_site_source_radio.tpl', '7d280f4647e9269bca20b70e4e64d077');
        $this->checkFile('themes/merchants/_common_templates/report_problems.tpl', '4e1bad44459cfd89e2334efef15bf21d');
        $this->checkFile('themes/merchants/_common_templates/reports_screen.tpl', 'bbf6174808124c49d1e305b099fa02c6');
        $this->checkFile('themes/merchants/_common_templates/richtextarea.css', '877a241a478b0fdd41c3f80b32fc4523');
        $this->checkFile('themes/merchants/_common_templates/rotator_preview_merchant.stpl', 'f4a8b7e2a320d263c11e080652136aa8');
        $this->checkFile('themes/merchants/_common_templates/rule_conditions_panel.tpl', 'd5daac16db9fcac2ad3bf746a137e5fc');
        $this->checkFile('themes/merchants/_common_templates/rule_conditions_panel_full.tpl', 'd6d03701b7ef6b28bd1a3e10c01e3b07');
        $this->checkFile('themes/merchants/_common_templates/rule_panel.tpl', '56a529ae916e9bd626f6bbdfcf00fe45');
        $this->checkFile('themes/merchants/_common_templates/sales_list.tpl', '5af405985c7c15163235dc47143cdd68');
        $this->checkFile('themes/merchants/_common_templates/search_gadget.tpl', 'dd1ccaf3d497e365f8ea8d999a89cc29');
        $this->checkFile('themes/merchants/_common_templates/search_gadget_entries_panel.tpl', 'b60a5fd89e628c401c86eee54073243e');
        $this->checkFile('themes/merchants/_common_templates/search_gadget_popup.tpl', 'ad5359afa9edeb864b0929d40a05e466');
        $this->checkFile('themes/merchants/_common_templates/search_gadget_popup_entry.tpl', 'd4c0f584509bbc3c0db48a061dab51fc');
        $this->checkFile('themes/merchants/_common_templates/send_mail_to_affiliate.tpl', 'c006df4300021f8c1862ea72b664c5ef');
        $this->checkFile('themes/merchants/_common_templates/send_mass_mail.tpl', '738a7db5645240b6463da604837fb4ab');
        $this->checkFile('themes/merchants/_common_templates/settings/invoice_commission_list.stpl', '5bf14188808c6f4ad9f01b003fe41028');
        $this->checkFile('themes/merchants/_common_templates/settings/invoice_vat_commission_list.stpl', '5bf14188808c6f4ad9f01b003fe41028');
        $this->checkFile('themes/merchants/_common_templates/settings/network_invoice.stpl', '585f2eee6dd41bf137aa04ec0ba7e0e1');
        $this->checkFile('themes/merchants/_common_templates/settings/network_invoice_commission_list.stpl', '5bf14188808c6f4ad9f01b003fe41028');
        $this->checkFile('themes/merchants/_common_templates/settings/network_proforma_invoice.stpl', '2a73c8cfdad66822e082c70597e45bd7');
        $this->checkFile('themes/merchants/_common_templates/settings/network_proforma_invoice_commission_list.stpl', '5bf14188808c6f4ad9f01b003fe41028');
        $this->checkFile('themes/merchants/_common_templates/settings/payout_invoice.stpl', '80426ffb0b1951f7bfd2bb4750be9650');
        $this->checkFile('themes/merchants/_common_templates/settings/payout_invoice_with_vat.stpl', '450de162a1cfecf949ac5ca300e6e9fc');
        $this->checkFile('themes/merchants/_common_templates/signup_commissions.tpl', 'ce7ed3b0ec05faf3b45a0ea83014fb0b');
        $this->checkFile('themes/merchants/_common_templates/signup_form_design.tpl', '9c077d9a31df6cde24a3238055feace6');
        $this->checkFile('themes/merchants/_common_templates/signup_url_panel.tpl', '995b8697f540e2a634c7c9b1d3e36d83');
        $this->checkFile('themes/merchants/_common_templates/site_replication_feature_on_deactivate.tpl', 'a9a5007e2b045fcddb5649780343250c');
        $this->checkFile('themes/merchants/_common_templates/spillover.tpl', 'b88774d1a43ea2c8b638a75c59411588');
        $this->checkFile('themes/merchants/_common_templates/spillover_affiliate_panel.tpl', 'a31389658f2a6052020cad731dff7671');
        $this->checkFile('themes/merchants/_common_templates/split_commissions_edit.tpl', '8fc860522e21875e63c40335323c7e7c');
        $this->checkFile('themes/merchants/_common_templates/split_commissions_edit_help.tpl', 'b8c0076fd8c6f725a44728f9c36e1633');
        $this->checkFile('themes/merchants/_common_templates/split_commissions_feature_on_activate.tpl', '3c0a020b1e83cc8c0f13cc18c823c20d');
        $this->checkFile('themes/merchants/_common_templates/statistics_double_value_widget.tpl', '7e243a39277ad97843b418e45881a6d2');
        $this->checkFile('themes/merchants/_common_templates/statistics_filter.tpl', '67b94db58c2fec25ff78c61e4ad075c6');
        $this->checkFile('themes/merchants/_common_templates/statistics_tab.tpl', 'f7eadcc820f1ad1d1df738dad03d786f');
        $this->checkFile('themes/merchants/_common_templates/stats_chart.tpl', 'ae416723ccb917fc5b17ed3929842bfa');
        $this->checkFile('themes/merchants/_common_templates/subscription_product.tpl', 'f371c4f99cf47d40d77f9fa4da081b6f');
        $this->checkFile('themes/merchants/_common_templates/sum_payouts_to_affiliates.tpl', '8807be79ce1dd08225e3bca51c25d8d2');
        $this->checkFile('themes/merchants/_common_templates/sum_payouts_to_affiliates_filter.tpl', '211b8a9300581ecb9e0827a62b914c8b');
        $this->checkFile('themes/merchants/_common_templates/system_menu.tpl', '096aba55c31d9fb7ccf249f5bcd8a596');
        $this->checkFile('themes/merchants/_common_templates/terms_and_conditions_confirmation.tpl', 'd80b7e300b4b81e3bb35d1d2516e2ee7');
        $this->checkFile('themes/merchants/_common_templates/theme_create_new.tpl', '9c1e28eb5f1eda40629310f37f879716');
        $this->checkFile('themes/merchants/_common_templates/theme_edit_editor.tpl', '64d48ea1150e9de0edbd7e993b2463da');
        $this->checkFile('themes/merchants/_common_templates/theme_edit_filetree.tpl', '0c72747749d4c1ab3b88a84ff0445fb4');
        $this->checkFile('themes/merchants/_common_templates/theme_edit_image.tpl', '6b9c432558322b656695a0fca1077916');
        $this->checkFile('themes/merchants/_common_templates/theme_edit_none.tpl', '75d830256e49bb367e33539f1e29aa47');
        $this->checkFile('themes/merchants/_common_templates/theme_edit_unsupported.tpl', '2977467887b418fedc8b42576078f275');
        $this->checkFile('themes/merchants/_common_templates/theme_editor_panel.tpl', 'edfa561a7e5e8dbb9c42693f5b032a31');
        $this->checkFile('themes/merchants/_common_templates/time_conditions_panel.tpl', 'fade58fb15af27c6d1c34bc35a29560d');
        $this->checkFile('themes/merchants/_common_templates/top_afffiliates_list.tpl', 'f3aeb980062c88135fc3a5e807450879');
        $this->checkFile('themes/merchants/_common_templates/top_affiliates_filter.tpl', '2db6138b57171088804fb3a141c03ab6');
        $this->checkFile('themes/merchants/_common_templates/topurl_list.tpl', 'd0880f68969dcf6e1ce2473ae194290e');
        $this->checkFile('themes/merchants/_common_templates/tracking_tab.tpl', 'a991c08c3cf8be9bebff1cdb34f89555');
        $this->checkFile('themes/merchants/_common_templates/traffic_info.tpl', '896704bef45acb3a72f956506b82c338');
        $this->checkFile('themes/merchants/_common_templates/traffic_stats_gadget.tpl', 'da081a1eba4470008e9f5e0165ecd7d6');
        $this->checkFile('themes/merchants/_common_templates/traffic_stats_in_gadget.tpl', 'b6ffda3596f992ce68d25d72fa923751');
        $this->checkFile('themes/merchants/_common_templates/trafic_and_sales_report.tpl', '6723e4f293c26fed32855b086cb6318e');
        $this->checkFile('themes/merchants/_common_templates/transaction_form.tpl', '8ef3d9c8be8655191b10b6ceb6b8627a');
        $this->checkFile('themes/merchants/_common_templates/transaction_form_edit.tpl', '89ba9da00433c00fab5cffd1b28d71c9');
        $this->checkFile('themes/merchants/_common_templates/transaction_form_notes.tpl', '160083fd267e3c2b22ff4258da2cf847');
        $this->checkFile('themes/merchants/_common_templates/transaction_form_tracking.tpl', '5c8ea841d6f3ce6f41a0e483d6572a34');
        $this->checkFile('themes/merchants/_common_templates/transaction_info.tpl', 'ebbf37209123148b7340fee9125ff2bd');
        $this->checkFile('themes/merchants/_common_templates/transaction_list.tpl', '061330956dc8a3a52de554ba63979d58');
        $this->checkFile('themes/merchants/_common_templates/transaction_list_filter_base.tpl', 'e4ad28ae1c73b967f16f58487c9350da');
        $this->checkFile('themes/merchants/_common_templates/transaction_list_no_data.tpl', 'af721399a5baf2e217c7a16fa2f304e1');
        $this->checkFile('themes/merchants/_common_templates/transaction_panel.tpl', '454732b1a0a2d1fa7e3a52fe5345e745');
        $this->checkFile('themes/merchants/_common_templates/transaction_reports.tpl', 'ef0c25832283bcfe9d9cc37cd13ac41e');
        $this->checkFile('themes/merchants/_common_templates/transactions_import.tpl', 'bfe96714aede1eed77fc5361404b952d');
        $this->checkFile('themes/merchants/_common_templates/tree_affiliate_widget.tpl', '131b5c534d7b52a34057ac6986255da5');
        $this->checkFile('themes/merchants/_common_templates/tree_draggable_items.tpl', '869b3cbe1a546cf76baa397b8360495b');
        $this->checkFile('themes/merchants/_common_templates/trend_actions_stats.tpl', '790735d304a6cb007b73b383ad981082');
        $this->checkFile('themes/merchants/_common_templates/trend_actions_stats_widget.tpl', '7c26676ceb09baf3fafeb0dba3bdaec4');
        $this->checkFile('themes/merchants/_common_templates/trend_stats.tpl', '095f81f317cc90564bd9572029ef486d');
        $this->checkFile('themes/merchants/_common_templates/trends_report.stpl', 'ed319211378d00968c7cb9a540e37b72');
        $this->checkFile('themes/merchants/_common_templates/trends_report.tpl', '5d7081a351ec7050e08073543cf29f00');
        $this->checkFile('themes/merchants/_common_templates/trends_report_action.stpl', 'f8db7f9e68767e369ee9463662b583b4');
        $this->checkFile('themes/merchants/_common_templates/trends_report_filter.tpl', '73695acc640d4d31af301faf4cad8467');
        $this->checkFile('themes/merchants/_common_templates/trends_report_no_data.tpl', '1df74a6e3299c9176ac8047b05fd26dd');
        $this->checkFile('themes/merchants/_common_templates/troubleshooting.tpl', '2230839f521690f2a0e4b4f6a466766c');
        $this->checkFile('themes/merchants/_common_templates/username_field.tpl', '7d9c6a63d83fa465a8c73be7532d6c8f');
        $this->checkFile('themes/merchants/_common_templates/vat_settings.tpl', 'c6606709918784bf9074549579497075');
        $this->checkFile('themes/merchants/_common_templates/verify_panel.tpl', '24cd5d864fb844fef943171d6879b15a');
        $this->checkFile('themes/merchants/_common_templates/view_form_edit_views.tpl', '611c4ad261682fb8be4f1a683ef5acd7');
        $this->checkFile('themes/merchants/_common_templates/view_panel.tpl', '51e88d2723d6aea2d6742ca146e5b7a9');
        $this->checkFile('themes/merchants/_common_templates/views_list.tpl', '423b0330051ae06d63e4af728930f4e9');
        $this->checkFile('themes/merchants/_common_templates/visitor_affiliate_edit.tpl', '384f1b6ca780dc63d6d19eb0d06b20ed');
        $this->checkFile('themes/merchants/_common_templates/visitor_affiliates_filter.tpl', '406f7cac562f03b7624cbf9e6ad14303');
        $this->checkFile('themes/merchants/_common_templates/visitor_affiliates_list.tpl', 'd188948b641367d0c37d6ca8e64b88c5');
        $this->checkFile('themes/merchants/_common_templates/visitor_nonrefclicks_filter.tpl', '821e43e939347b8bb3387fbc85528c1d');
        $this->checkFile('themes/merchants/_common_templates/visitor_nonrefclicks_list.tpl', 'e220e9cfea8b63509640bd40c941d353');
        $this->checkFile('themes/merchants/_common_templates/visits_sales_log_add.tpl', '66ed948e5a8641641dbaa41b35c8d291');
        $this->checkFile('themes/merchants/_common_templates/visits_sales_logs_filter.tpl', '7d43b308fc95bbd237f0704b65677899');
        $this->checkFile('themes/merchants/_common_templates/visits_sales_logs_list.tpl', '3646fd744012f17f91135e3289a079f1');
        $this->checkFile('themes/merchants/_common_templates/welcome_message_panel.tpl', '86f2e7b763c27c55f65b269cd8b95a0d');
        $this->checkFile('themes/merchants/_common_templates/zip_banner_feature_on_deactivate.tpl', '0d58a97804ba953e180301d3bb0d1a37');
        $this->checkFile('themes/merchants/blue_aero/README.txt', 'c5e378c3027a6b4f00637e35fa00d549');
        $this->checkFile('themes/merchants/blue_aero/custom.css', '4877ef2467745239a93ebe1e79b2f813');
        $this->checkFile('themes/merchants/blue_aero/desktop.tpl', '96fc6ae799e2f8b67c48e6bcec8fc1d3');
        $this->checkFile('themes/merchants/blue_aero/img/browser_secure.png', '5c95ff5b78267e9023bc63a36415e4fc');
        $this->checkFile('themes/merchants/blue_aero/img/button.start.png', 'b3b5e432bf0a2341518fb536b3433453');
        $this->checkFile('themes/merchants/blue_aero/img/fieldset.background.png', '4b7f6a73070e0ec1141544824eebf286');
        $this->checkFile('themes/merchants/blue_aero/img/gadgetin.b.png', 'f06e13c0620d89fc464cf0223df9d349');
        $this->checkFile('themes/merchants/blue_aero/img/gadgetin.back.png', '23e4e12e286d074c423d1b387bf8902f');
        $this->checkFile('themes/merchants/blue_aero/img/gadgetin.bl.png', '07c07e8c743573064ee8eeca1c799a34');
        $this->checkFile('themes/merchants/blue_aero/img/gadgetin.br.png', '4148944211041cf9bf7807ac222e7082');
        $this->checkFile('themes/merchants/blue_aero/img/gadgetin.l.png', '48659819a474cc38eaf46ae58be0ada0');
        $this->checkFile('themes/merchants/blue_aero/img/gadgetin.r.png', '48659819a474cc38eaf46ae58be0ada0');
        $this->checkFile('themes/merchants/blue_aero/img/gadgetin.t.png', 'f06e13c0620d89fc464cf0223df9d349');
        $this->checkFile('themes/merchants/blue_aero/img/gadgetin.tl.png', '045b6145e46d3ad85a7a4aa34013b64f');
        $this->checkFile('themes/merchants/blue_aero/img/gadgetin.tr.png', '6737317d906258d61f9f9c80fc04b3e9');
        $this->checkFile('themes/merchants/blue_aero/img/theme_thumbnail.jpg', 'dd8f23908534c823fbd79bdc417c5f1d');
        $this->checkFile('themes/merchants/blue_aero/pap4.css', 'cab01a0901516795ce129bf9f7f19f7a');
        $this->checkFile('themes/merchants/blue_aero/theme.php', '0d1a327556c5af7ffa8ffafaad225e31');
        $this->checkFile('themes/merchants/classic_wide/README.txt', 'c5e378c3027a6b4f00637e35fa00d549');
        $this->checkFile('themes/merchants/classic_wide/custom.css', '4877ef2467745239a93ebe1e79b2f813');
        $this->checkFile('themes/merchants/classic_wide/footer.stpl', '8a95ee5e8ad15f8ab65dece5b66861b7');
        $this->checkFile('themes/merchants/classic_wide/header.stpl', 'df1554f66a8c1190a6ea07dd634fedf9');
        $this->checkFile('themes/merchants/classic_wide/img/browser_secure.png', '5c95ff5b78267e9023bc63a36415e4fc');
        $this->checkFile('themes/merchants/classic_wide/img/content.bottom.gif', '752b9cf627b4c7dbccc857d5a691d4b9');
        $this->checkFile('themes/merchants/classic_wide/img/content.bottom.left.gif', 'f050f014c1de2756f669817b104181b0');
        $this->checkFile('themes/merchants/classic_wide/img/content.bottom.right.gif', 'f7196a6f7f8e41930f25cb60103297e4');
        $this->checkFile('themes/merchants/classic_wide/img/content.left.gif', 'd8538d3756f8c6027414a583858618a8');
        $this->checkFile('themes/merchants/classic_wide/img/content.right.gif', '97177491028c3422434d64a29fce343b');
        $this->checkFile('themes/merchants/classic_wide/img/content.top.gif', '1206ee1251333832e10a09d0dd84c3f8');
        $this->checkFile('themes/merchants/classic_wide/img/content.top.left.gif', '8a397076700e439a1c8f24aa9e1c1760');
        $this->checkFile('themes/merchants/classic_wide/img/content.top.right.gif', '13947f410657fe4b089d663c9b9922a2');
        $this->checkFile('themes/merchants/classic_wide/img/fieldset.background.png', '4b7f6a73070e0ec1141544824eebf286');
        $this->checkFile('themes/merchants/classic_wide/img/left.column-rtl.gif', 'b5fc073d676545e3b6407ea59cb5c94b');
        $this->checkFile('themes/merchants/classic_wide/img/left.column.gif', '1ea7ba64fdb58c3b6b90ef45427db330');
        $this->checkFile('themes/merchants/classic_wide/img/logo_pan.jpg', 'e11b89662d01ad51927067143efe6298');
        $this->checkFile('themes/merchants/classic_wide/img/logo_pan.png', '97ebd132ae8ec2dd08bbef552d03a0fd');
        $this->checkFile('themes/merchants/classic_wide/img/logo_pap.jpg', 'cd14b7752b98bf01c9723d525a3f8e4b');
        $this->checkFile('themes/merchants/classic_wide/img/menu.divider-rtl.gif', '1b2bc17e8857716a7cdf75dfc3dae977');
        $this->checkFile('themes/merchants/classic_wide/img/menu.divider.gif', '041bb37bea32338b1c0a9d031c9d4a68');
        $this->checkFile('themes/merchants/classic_wide/img/menu.entry-over-rtl.gif', 'e1459b50df8553106bdb23ef80078b0a');
        $this->checkFile('themes/merchants/classic_wide/img/menu.entry-over.gif', 'da0c7a49ad258dbb35e190602a70b628');
        $this->checkFile('themes/merchants/classic_wide/img/menu.entry.back-over-rtl.gif', 'f9b4443d2c43c02fdd1ce4ce1d961dfd');
        $this->checkFile('themes/merchants/classic_wide/img/menu.entry.back-over.gif', '80eee6c80b01a1a97026ad89f4285af4');
        $this->checkFile('themes/merchants/classic_wide/img/menu.entry.bottom-over-rtl.gif', '6535e027928a92528ee27cdff2a82e05');
        $this->checkFile('themes/merchants/classic_wide/img/menu.entry.bottom-over.gif', '32819c898e14b221264804785147b5d0');
        $this->checkFile('themes/merchants/classic_wide/img/menu.entry.top-over-rtl.gif', '1c3a6a486d590df3d89f0338acb76fed');
        $this->checkFile('themes/merchants/classic_wide/img/menu.entry.top-over.gif', 'ca840699467392d1da2eb8d6e173dff6');
        $this->checkFile('themes/merchants/classic_wide/img/submenu-rtl.gif', '8e96bfd8f3a175b6a81d4eb2291db331');
        $this->checkFile('themes/merchants/classic_wide/img/submenu.entry-over.gif', '7296aeb880fb7a28f64ebc4fdbd9c1b0');
        $this->checkFile('themes/merchants/classic_wide/img/submenu.entry-rtl.gif', '40bf261a700bb616fc5bdf40409ff740');
        $this->checkFile('themes/merchants/classic_wide/img/submenu.entry.back-over-rtl.gif', '5a52ace4443cec172f1524ae39dd602d');
        $this->checkFile('themes/merchants/classic_wide/img/submenu.entry.back-over.gif', '9ebfeff8b4172af9c299920a3ac78d65');
        $this->checkFile('themes/merchants/classic_wide/img/submenu.entry.bottom-over-rtl.gif', '225a12172a7b4c111c32b657dde915da');
        $this->checkFile('themes/merchants/classic_wide/img/submenu.entry.bottom-over.gif', '22622c2c689e004e658f1c47e112d6b1');
        $this->checkFile('themes/merchants/classic_wide/img/submenu.entry.gif', '2e00d05fbf25527e21ef327e42aaf05c');
        $this->checkFile('themes/merchants/classic_wide/img/submenu.entry.top-over-rtl.gif', '217f2d6b380191c057e5cdbe8ca4aedd');
        $this->checkFile('themes/merchants/classic_wide/img/submenu.entry.top-over.gif', 'c4313a7313ac6f6ce0208b70db0c99ff');
        $this->checkFile('themes/merchants/classic_wide/img/theme_thumbnail.jpg', '7dfee14767777bfd5fdfdf5b86b59f22');
        $this->checkFile('themes/merchants/classic_wide/main.tpl', 'eb632cd295fe927321345e6120d0e235');
        $this->checkFile('themes/merchants/classic_wide/main_menu.tpl', '5fddab52f7b44bcb5717c1d67875f567');
        $this->checkFile('themes/merchants/classic_wide/menu_entry.tpl', '7607d6b22315cc526abad1fd026c74f5');
        $this->checkFile('themes/merchants/classic_wide/menu_section.tpl', 'da446dbc5a24b9881bd8417ce0371bb5');
        $this->checkFile('themes/merchants/classic_wide/pap4.css', '0c6f60ebb090440eac743e853a53cab5');
        $this->checkFile('themes/merchants/classic_wide/system_menu.tpl', '6b9db812d8f3eb02839850e4a9c3627d');
        $this->checkFile('themes/merchants/classic_wide/theme.php', '0e4930d3511d2bfa21609ab0364c7ab8');
        $this->checkFile('themes/resources/bigflags.jpg', '9e825a4fdc39e3edadd99374f8b377ad');
        $this->checkFile('themes/resources/flags.jpg', 'ec669e22b760cc12ffc539da975038c2');
        $this->checkFile('themes/signup/Bootstrap/README.txt', 'c5e378c3027a6b4f00637e35fa00d549');
        $this->checkFile('themes/signup/Bootstrap/account_header.stpl', '9997d8954474fcaf0bd1210390dbaee0');
        $this->checkFile('themes/signup/Bootstrap/account_main_static_html_doc.stpl', '4b3350d984287bf504d7d265d49b5d74');
        $this->checkFile('themes/signup/Bootstrap/account_post_signup_page.tpl', '699861ca8c3f9767fa20b14ff967e6f0');
        $this->checkFile('themes/signup/Bootstrap/account_signup_form.tpl', '74bfc57daa9296fd6c32f0e7d1998ed0');
        $this->checkFile('themes/signup/Bootstrap/account_signup_form_panel.tpl', '6213e8dfe138c1dc04bb481f76b79b75');
        $this->checkFile('themes/signup/Bootstrap/account_signup_main.stpl', 'a2563ff76f4ca35964393f5e08e52d98');
        $this->checkFile('themes/signup/Bootstrap/account_topmenu.stpl', '54a5ee87f2556fd22d1e1536f4936bf9');
        $this->checkFile('themes/signup/Bootstrap/affiliate_manager.tpl', '961e886fb7c3928a7fb23e3b0128ecb6');
        $this->checkFile('themes/signup/Bootstrap/calendar.tpl', 'd6831aa786acf1f829a90cec776126eb');
        $this->checkFile('themes/signup/Bootstrap/captcha.tpl', '87774ee0cef4e0c01a16cd8c88e101c7');
        $this->checkFile('themes/signup/Bootstrap/check_box_group_row.tpl', 'c68539a0d02b06d4177798b9a8c4378c');
        $this->checkFile('themes/signup/Bootstrap/contactus_fields.tpl', 'e98f1e549da1da8a85b9d7f7e570f38c');
        $this->checkFile('themes/signup/Bootstrap/contactus_form.tpl', '2d5aab05bd95b7a2ba254fb678d70a96');
        $this->checkFile('themes/signup/Bootstrap/custom.css', '4877ef2467745239a93ebe1e79b2f813');
        $this->checkFile('themes/signup/Bootstrap/dynamic_form_panel.tpl', 'b1ae5e7923f267450769fad1e366c1cc');
        $this->checkFile('themes/signup/Bootstrap/faq_public.stpl', 'e7a202b0af50846a3505eccb66f4f54c');
        $this->checkFile('themes/signup/Bootstrap/footer.stpl', 'fddc876aaa0d46e4107627a56b202c33');
        $this->checkFile('themes/signup/Bootstrap/form_field.tpl', 'fc9cec620cc2941fc0f8dc826d241e47');
        $this->checkFile('themes/signup/Bootstrap/form_field_checkbox.tpl', 'c9c7ab6638af4fd177b41ef049a89cfb');
        $this->checkFile('themes/signup/Bootstrap/header.stpl', 'ba0870b8783ffd1c527bd2b441de7bc7');
        $this->checkFile('themes/signup/Bootstrap/img/app_market.png', 'fa0b46877d482c8b34aab1689d925628');
        $this->checkFile('themes/signup/Bootstrap/img/favicon.ico', 'ac3e93c93589318e5dcf69efc8a76176');
        $this->checkFile('themes/signup/Bootstrap/img/icon-128.png', 'a450a0dd5959518fdb2308cc5e523bcc');
        $this->checkFile('themes/signup/Bootstrap/img/icon-192.png', '8cb72062e4df9eab6c2a064459a5ee62');
        $this->checkFile('themes/signup/Bootstrap/img/pan-logo.svg', 'a00e0890d1da3f81a0ddf2d27c111504');
        $this->checkFile('themes/signup/Bootstrap/img/theme_thumbnail.jpg', '6e146b0e757e6dec52734b28ef0f498d');
        $this->checkFile('themes/signup/Bootstrap/index.stpl', 'a6e3f7fec1eae75305c6a56ecd305dcd');
        $this->checkFile('themes/signup/Bootstrap/license_invalid.tpl', '1f00d288374c95dff5e2a1230b37e6a1');
        $this->checkFile('themes/signup/Bootstrap/login_annotation.tpl', '7189ae99b486d1688e319900b9ef248e');
        $this->checkFile('themes/signup/Bootstrap/login_form.tpl', '7daab726646ce27aa3a44d99cfdd4e32');
        $this->checkFile('themes/signup/Bootstrap/login_main.tpl', '0cd828d3f67418d0795faf78316d9aaf');
        $this->checkFile('themes/signup/Bootstrap/main_aff_html_doc.stpl', 'f8ecc2ea215970aeefa0169685fb27bc');
        $this->checkFile('themes/signup/Bootstrap/main_static_html_doc.stpl', '5c2d32a1feeba4ea2532ce78f6989e41');
        $this->checkFile('themes/signup/Bootstrap/merchant_index.stpl', '136264696ac53a2ba40bacdebe2e84be');
        $this->checkFile('themes/signup/Bootstrap/merchant_login_annotation.tpl', 'cf6c77707530f5eb8688f4ebca04cbfd');
        $this->checkFile('themes/signup/Bootstrap/panel_includes.stpl', 'e385c1f51656b2a25dff992bfc5a93e8');
        $this->checkFile('themes/signup/Bootstrap/pap4.css', '4d85959c269fc0beaf9af11e4fe4dff9');
        $this->checkFile('themes/signup/Bootstrap/pap4.rtl.css', '08875e1e220dd02c454aa3b122fa2782');
        $this->checkFile('themes/signup/Bootstrap/payout_methods.tpl', '2aa7ef7da74454635cbb8b4a2b3486bc');
        $this->checkFile('themes/signup/Bootstrap/post_signup_page.tpl', '8cb68a51d0da7889fcfa73b5567c60f9');
        $this->checkFile('themes/signup/Bootstrap/request_new_password_form.tpl', 'a305fc1891c9e48d7f4b2fdc20f1fe43');
        $this->checkFile('themes/signup/Bootstrap/root_index.stpl', '083479631ae2dd9b22239014eb4dd6a7');
        $this->checkFile('themes/signup/Bootstrap/samples_tests.stpl', '1581e8d44cb199f5a2627ae407738ea9');
        $this->checkFile('themes/signup/Bootstrap/samples_tests_account_signup_html.stpl', '3b83b5064d507c064743829dc25795c7');
        $this->checkFile('themes/signup/Bootstrap/samples_tests_banners_linking.stpl', '00e341613f545be86150b44359f083d2');
        $this->checkFile('themes/signup/Bootstrap/samples_tests_banners_sample.stpl', '73a67946cd80a41f8c8e59e3dac2d9e3');
        $this->checkFile('themes/signup/Bootstrap/samples_tests_banners_subid.stpl', 'e382d3e98e3e806f992d5671dc33e2a7');
        $this->checkFile('themes/signup/Bootstrap/samples_tests_cookie_info.stpl', '2ba6e515ea82f8a02258fe945470a808');
        $this->checkFile('themes/signup/Bootstrap/samples_tests_sale_tracking_docu.stpl', '993f5962cab78827e4a1b81d3063440a');
        $this->checkFile('themes/signup/Bootstrap/samples_tests_sale_tracking_normal.stpl', 'b19c00764e500ae4888b76b4bcfda8ad');
        $this->checkFile('themes/signup/Bootstrap/samples_tests_sample_homepage.stpl', 'b5e475fa21eca981b7de33be63d8a2e2');
        $this->checkFile('themes/signup/Bootstrap/samples_tests_signup_html.stpl', '98d37fc1bd9a695cb5417f35b2648c1a');
        $this->checkFile('themes/signup/Bootstrap/select_account_form.tpl', '3a2853957b890efd31a9119072cc097f');
        $this->checkFile('themes/signup/Bootstrap/set_new_password_form.tpl', 'f7ee059b2612c4d1b92d4437e0bf5b21');
        $this->checkFile('themes/signup/Bootstrap/signup_fields.tpl', 'afa5e92aedbddadd6ea58222a4327661');
        $this->checkFile('themes/signup/Bootstrap/signup_form.tpl', 'd2f385af86317dcd914b1bec5379f77e');
        $this->checkFile('themes/signup/Bootstrap/static_page_includes.stpl', 'f6eca714dcd0a0527aa61a1365ba263f');
        $this->checkFile('themes/signup/Bootstrap/theme.php', '15b97fafa703d17061d636bbec86e163');
        $this->checkFile('themes/signup/Coupe/README.txt', 'c5e378c3027a6b4f00637e35fa00d549');
        $this->checkFile('themes/signup/Coupe/account_header.stpl', 'dcdedba26b23dcfdab15514f0e74f6c9');
        $this->checkFile('themes/signup/Coupe/account_main_static_html_doc.stpl', '4b3350d984287bf504d7d265d49b5d74');
        $this->checkFile('themes/signup/Coupe/account_post_signup_page.tpl', '04f95fc7c942e9bcad570fd398a17cd0');
        $this->checkFile('themes/signup/Coupe/account_signup_form.tpl', '6cae40ec4b249aec35c16f2af8afd400');
        $this->checkFile('themes/signup/Coupe/account_signup_form_panel.tpl', '02faedac77eed084209abc2bbfedd930');
        $this->checkFile('themes/signup/Coupe/account_signup_main.stpl', 'a2563ff76f4ca35964393f5e08e52d98');
        $this->checkFile('themes/signup/Coupe/account_topmenu.stpl', 'ebd01cd8988c679ce73e73e64633dd9e');
        $this->checkFile('themes/signup/Coupe/affiliate_manager.tpl', '961e886fb7c3928a7fb23e3b0128ecb6');
        $this->checkFile('themes/signup/Coupe/calendar.tpl', 'd6831aa786acf1f829a90cec776126eb');
        $this->checkFile('themes/signup/Coupe/captcha.tpl', '87774ee0cef4e0c01a16cd8c88e101c7');
        $this->checkFile('themes/signup/Coupe/check_box_group_row.tpl', 'a5f3089ec38f79becece26174dceaaaf');
        $this->checkFile('themes/signup/Coupe/contactus_fields.tpl', 'f3873f615849d1ed94253100d1de71b5');
        $this->checkFile('themes/signup/Coupe/contactus_form.tpl', 'b64db0eece831578bf138879688e2906');
        $this->checkFile('themes/signup/Coupe/custom.css', '4877ef2467745239a93ebe1e79b2f813');
        $this->checkFile('themes/signup/Coupe/custom_license_invalid.tpl', '4df09bd6de29e5f46d70ebc36194dc9a');
        $this->checkFile('themes/signup/Coupe/dynamic_form_panel.tpl', 'b1ae5e7923f267450769fad1e366c1cc');
        $this->checkFile('themes/signup/Coupe/faq_public.stpl', '3e22dfce78535c62fd2a2423a6931360');
        $this->checkFile('themes/signup/Coupe/footer.stpl', '4700359166a0004125f7071f68feee54');
        $this->checkFile('themes/signup/Coupe/form_field.tpl', 'fc9cec620cc2941fc0f8dc826d241e47');
        $this->checkFile('themes/signup/Coupe/form_field_checkbox.tpl', '678f3b602c0adf5254174af9abcbab91');
        $this->checkFile('themes/signup/Coupe/header.stpl', 'a201b400252ca4fc73b19677350f2ecc');
        $this->checkFile('themes/signup/Coupe/img/app_market.png', 'fa0b46877d482c8b34aab1689d925628');
        $this->checkFile('themes/signup/Coupe/img/bg-inverted.svg', 'b29531d2357a09e63f7cbefa78c19366');
        $this->checkFile('themes/signup/Coupe/img/bg.svg', '2716d0e352228223b4cab0ced26fbdfc');
        $this->checkFile('themes/signup/Coupe/img/dirigent.svg', '0b46626ef5771157f7c297f6c3b3d1f0');
        $this->checkFile('themes/signup/Coupe/img/favicon.ico', 'ac3e93c93589318e5dcf69efc8a76176');
        $this->checkFile('themes/signup/Coupe/img/icon-128.png', 'a450a0dd5959518fdb2308cc5e523bcc');
        $this->checkFile('themes/signup/Coupe/img/icon-192.png', '8cb72062e4df9eab6c2a064459a5ee62');
        $this->checkFile('themes/signup/Coupe/img/pan-logo.svg', 'a00e0890d1da3f81a0ddf2d27c111504');
        $this->checkFile('themes/signup/Coupe/img/pap-logo.svg', 'a547f2e21fdd3a4f34466790d70124fd');
        $this->checkFile('themes/signup/Coupe/img/sprite.symbol.html', '8990da9a97b22c8c08725099ceb50d17');
        $this->checkFile('themes/signup/Coupe/img/sprite.view.html', '0d7c3d7746f110561d40251cbc65a875');
        $this->checkFile('themes/signup/Coupe/img/svg/sprite.symbol.svg', '7cf55182070b594e72d624325c663289');
        $this->checkFile('themes/signup/Coupe/img/svg/sprite.view.svg', '55a4311b1f14df66702f1f860f847a19');
        $this->checkFile('themes/signup/Coupe/img/theme_thumbnail.jpg', '5e7de7f7b469d44bb49e4e216acfa73c');
        $this->checkFile('themes/signup/Coupe/index.stpl', 'ebbbb3631310669f21087f5ceb4d36ec');
        $this->checkFile('themes/signup/Coupe/license_invalid.tpl', '265a5ff0ceeb0c7938f99ba176de663c');
        $this->checkFile('themes/signup/Coupe/loading_indicator.tpl', '8d3b3ac51e79a10e35aa11c9bd87d83c');
        $this->checkFile('themes/signup/Coupe/loading_screen.tpl', '65e4573e16d2b2e74ef60ec14f17250a');
        $this->checkFile('themes/signup/Coupe/login_annotation.tpl', '7278a3c2c73a14e72f2dd20e3097fb07');
        $this->checkFile('themes/signup/Coupe/login_form.tpl', '5eddfddc22f91f5617bfa38362327df7');
        $this->checkFile('themes/signup/Coupe/login_main.tpl', '0cd828d3f67418d0795faf78316d9aaf');
        $this->checkFile('themes/signup/Coupe/main_aff_html_doc.stpl', 'f8ecc2ea215970aeefa0169685fb27bc');
        $this->checkFile('themes/signup/Coupe/main_static_html_doc.stpl', '5c2d32a1feeba4ea2532ce78f6989e41');
        $this->checkFile('themes/signup/Coupe/merchant_index.stpl', '36f94f863c5536f5daad697bd4bcfc2f');
        $this->checkFile('themes/signup/Coupe/merchant_login_annotation.tpl', 'cf6c77707530f5eb8688f4ebca04cbfd');
        $this->checkFile('themes/signup/Coupe/panel_includes.stpl', 'ee62bb6d577602c94dc039a647f82207');
        $this->checkFile('themes/signup/Coupe/pap4.css', '11dcd0e75b8e2f127b3afd0e781bb4a3');
        $this->checkFile('themes/signup/Coupe/pap4.rtl.css', 'a8b74660e16145ea658e602c85153019');
        $this->checkFile('themes/signup/Coupe/payout_methods.tpl', '359f1e7f1fe68da740c63021283c3f4d');
        $this->checkFile('themes/signup/Coupe/post_signup_page.tpl', '6155c187d2e2b4f0a96be13c16ef8dd7');
        $this->checkFile('themes/signup/Coupe/request_new_password_form.tpl', 'ad5617418f407eda76a6fdf774e910e3');
        $this->checkFile('themes/signup/Coupe/root_index.stpl', 'ff17ef1bc9517688c3d878082aa0b9e3');
        $this->checkFile('themes/signup/Coupe/samples_tests.stpl', '28b3b5343690f76344eea6766f339637');
        $this->checkFile('themes/signup/Coupe/samples_tests_account_signup_html.stpl', '9e2f4512e436eb02837ca260ffa87df1');
        $this->checkFile('themes/signup/Coupe/samples_tests_banners_linking.stpl', '00e341613f545be86150b44359f083d2');
        $this->checkFile('themes/signup/Coupe/samples_tests_banners_sample.stpl', '323c9741367666a60b17342f2576b89e');
        $this->checkFile('themes/signup/Coupe/samples_tests_banners_subid.stpl', 'e382d3e98e3e806f992d5671dc33e2a7');
        $this->checkFile('themes/signup/Coupe/samples_tests_cookie_info.stpl', '7f75f9c20ee49955e3e351ea3b488238');
        $this->checkFile('themes/signup/Coupe/samples_tests_sale_tracking_docu.stpl', '03ac524aefc4173ca81366c7a914e7af');
        $this->checkFile('themes/signup/Coupe/samples_tests_sale_tracking_normal.stpl', 'b19c00764e500ae4888b76b4bcfda8ad');
        $this->checkFile('themes/signup/Coupe/samples_tests_sample_homepage.stpl', 'b5e475fa21eca981b7de33be63d8a2e2');
        $this->checkFile('themes/signup/Coupe/samples_tests_signup_html.stpl', '5b2c9fb50a7bc840d01db7a3dba8681a');
        $this->checkFile('themes/signup/Coupe/select_account_form.tpl', '3a2853957b890efd31a9119072cc097f');
        $this->checkFile('themes/signup/Coupe/set_new_password_form.tpl', 'dbeb9cbfa273a40759e4811621ec4bc0');
        $this->checkFile('themes/signup/Coupe/signup_fields.tpl', '1b6b7545b616e71dbdb50c5bea3cf770');
        $this->checkFile('themes/signup/Coupe/signup_form.tpl', '918ca353241fac36a7f04bdcaeb653ec');
        $this->checkFile('themes/signup/Coupe/static_page_includes.stpl', 'f6eca714dcd0a0527aa61a1365ba263f');
        $this->checkFile('themes/signup/Coupe/theme.php', 'b605ed51dcc0b19bad8a16710794bad6');
        $this->checkFile('themes/signup/Dash_for_signup/README.txt', 'c5e378c3027a6b4f00637e35fa00d549');
        $this->checkFile('themes/signup/Dash_for_signup/account_header.stpl', '0dd98de127e16242a7f7541e768fb1d9');
        $this->checkFile('themes/signup/Dash_for_signup/account_post_signup_page.tpl', '8be75fdcd7e5d4926d59aecfde16b47b');
        $this->checkFile('themes/signup/Dash_for_signup/account_signup_form.tpl', 'd13513c0c0a434c0f89bdee89d671092');
        $this->checkFile('themes/signup/Dash_for_signup/account_signup_form_panel.tpl', 'a742f18bdce6c069e0f70831a290ed7f');
        $this->checkFile('themes/signup/Dash_for_signup/account_signup_main.stpl', 'ac08fe800fb88d601cc5a8ebdc1960c6');
        $this->checkFile('themes/signup/Dash_for_signup/account_topmenu.stpl', 'e3552f05168ff2e09371d732d886b69e');
        $this->checkFile('themes/signup/Dash_for_signup/affiliate_manager.tpl', '961e886fb7c3928a7fb23e3b0128ecb6');
        $this->checkFile('themes/signup/Dash_for_signup/captcha.tpl', 'a1b7a1c46e5ee4f5775db5cf99bf7a94');
        $this->checkFile('themes/signup/Dash_for_signup/contactus_fields.tpl', 'd73d250edfdea3718fba0d65282e4412');
        $this->checkFile('themes/signup/Dash_for_signup/contactus_form.tpl', '1f66dcfa3d3ebb647fad17828a951fce');
        $this->checkFile('themes/signup/Dash_for_signup/custom.css', '4877ef2467745239a93ebe1e79b2f813');
        $this->checkFile('themes/signup/Dash_for_signup/faq_public.stpl', '176e6071baefcfec665fa2602a9c5702');
        $this->checkFile('themes/signup/Dash_for_signup/footer.stpl', '452dd5e5a0f5aa96e4f57c45fd955b5c');
        $this->checkFile('themes/signup/Dash_for_signup/form_field.tpl', '982687bcd496c3b8628f8ca3fe50c8bf');
        $this->checkFile('themes/signup/Dash_for_signup/header.stpl', '395cbf62778fd9900a85541dbbc24d4c');
        $this->checkFile('themes/signup/Dash_for_signup/img/affiliates_bg.jpg', 'b2fa83afa7f110a5e5c77c823ba0b077');
        $this->checkFile('themes/signup/Dash_for_signup/img/app_market.png', 'fa0b46877d482c8b34aab1689d925628');
        $this->checkFile('themes/signup/Dash_for_signup/img/arrow_bottom.png', '699141013fcaa64a1a9bde89bffb7d1d');
        $this->checkFile('themes/signup/Dash_for_signup/img/arrow_right.png', '8fa866e027e36b36a2878123873ad7ca');
        $this->checkFile('themes/signup/Dash_for_signup/img/error.png', '327f275d6c40fe9f6883107a357d86df');
        $this->checkFile('themes/signup/Dash_for_signup/img/loading.gif', '546d9515580e0c8e3d0813c2e04ed9aa');
        $this->checkFile('themes/signup/Dash_for_signup/img/merchants_bg.jpg', '9b5584a9883f93f04d000dbb5e212612');
        $this->checkFile('themes/signup/Dash_for_signup/img/qmark.png', '2d3ad7caf2769fbfb9441f331a77f0ef');
        $this->checkFile('themes/signup/Dash_for_signup/img/root_bg.jpg', '4e0ab15e7658c8e207d807b8260f0ab5');
        $this->checkFile('themes/signup/Dash_for_signup/img/sample_banners.jpg', '6c579106cb9c0e59a8c21c95da110090');
        $this->checkFile('themes/signup/Dash_for_signup/img/sample_page.jpg', '7a00ba4b3e188324d90a9f3c9dc23505');
        $this->checkFile('themes/signup/Dash_for_signup/img/sample_referral.jpg', '9b8460b786db632f3a7495b2c88f032e');
        $this->checkFile('themes/signup/Dash_for_signup/img/sample_sale.jpg', '620d2b0c13b33bff6b933024353f307e');
        $this->checkFile('themes/signup/Dash_for_signup/img/samples_bg.jpg', '9fb98ffd9d708e4473001d2bf1497d60');
        $this->checkFile('themes/signup/Dash_for_signup/img/social_buttons_3.png', 'ec2adf506decca619efa2d80eb7fb4a4');
        $this->checkFile('themes/signup/Dash_for_signup/img/theme_thumbnail.jpg', '8326e96cdc858fce14721723ead442ed');
        $this->checkFile('themes/signup/Dash_for_signup/img/transparent-95.png', '03be98067b8c0e04a43930e671620c32');
        $this->checkFile('themes/signup/Dash_for_signup/img/transparent.png', 'c63e7f3d2a41cab628be8e4b86de789e');
        $this->checkFile('themes/signup/Dash_for_signup/index.stpl', '9c838b404c24a5d3f1bac8873e0a395a');
        $this->checkFile('themes/signup/Dash_for_signup/login_annotation.tpl', '7189ae99b486d1688e319900b9ef248e');
        $this->checkFile('themes/signup/Dash_for_signup/login_form.tpl', 'd0c4ef8a677c312eca15b25ca88d6d79');
        $this->checkFile('themes/signup/Dash_for_signup/login_main.tpl', '0cd828d3f67418d0795faf78316d9aaf');
        $this->checkFile('themes/signup/Dash_for_signup/merchant_index.stpl', 'a5043c87ba0c4812c0da6d37f6aa8d8d');
        $this->checkFile('themes/signup/Dash_for_signup/merchant_login_annotation.tpl', 'cf6c77707530f5eb8688f4ebca04cbfd');
        $this->checkFile('themes/signup/Dash_for_signup/panel_includes.stpl', '338b7e979b4e6cf6599ea86737694451');
        $this->checkFile('themes/signup/Dash_for_signup/pap4.css', 'f2223c04983b7f9cb6373cfb644ae24e');
        $this->checkFile('themes/signup/Dash_for_signup/post_signup_page.tpl', '9179ed74ba67fce32c090a6a038e93a3');
        $this->checkFile('themes/signup/Dash_for_signup/request_new_password_form.tpl', '846bf1e794395c82919cbcb6d61e8697');
        $this->checkFile('themes/signup/Dash_for_signup/root_index.stpl', '2436b07b31ae0c63033eaec28344641c');
        $this->checkFile('themes/signup/Dash_for_signup/samples_tests.stpl', '533d802350c2f302fe763241cded6a99');
        $this->checkFile('themes/signup/Dash_for_signup/samples_tests_account_signup_html.stpl', 'b3872af93656ff5926df867bdc56a7bb');
        $this->checkFile('themes/signup/Dash_for_signup/samples_tests_banners_linking.stpl', 'a4554af6fbc0300d6657b0b4e1db20e9');
        $this->checkFile('themes/signup/Dash_for_signup/samples_tests_banners_sample.stpl', '39203143fa3d69819f847e7c31bb922e');
        $this->checkFile('themes/signup/Dash_for_signup/samples_tests_banners_subid.stpl', '92ee597899945df2fc0e46b6544905d4');
        $this->checkFile('themes/signup/Dash_for_signup/samples_tests_cookie_info.stpl', '50d4e7e7bd8975399e5b25c7ad5ad2e0');
        $this->checkFile('themes/signup/Dash_for_signup/samples_tests_sale_tracking_docu.stpl', '81286cf5edb652472e566def54531e2e');
        $this->checkFile('themes/signup/Dash_for_signup/samples_tests_sale_tracking_normal.stpl', 'c344dde733621cc02c9f27196ebf308e');
        $this->checkFile('themes/signup/Dash_for_signup/samples_tests_sample_homepage.stpl', '5fa91608f699ef2bae641c0e983e9e62');
        $this->checkFile('themes/signup/Dash_for_signup/samples_tests_signup_html.stpl', 'e6e09f75338ca3ac7dc8724856265409');
        $this->checkFile('themes/signup/Dash_for_signup/set_new_password_form.tpl', '37ce538d029bccd1787349261af27ed8');
        $this->checkFile('themes/signup/Dash_for_signup/signup_fields.tpl', '2ec4345e41dc5f1e7122531dbd27cf0b');
        $this->checkFile('themes/signup/Dash_for_signup/signup_form.tpl', '58207dd87695837d156e25995b4e84b2');
        $this->checkFile('themes/signup/Dash_for_signup/signup_form_disabled.tpl', 'b8c8f592d8115f1ca4f58bbaff1d5b4c');
        $this->checkFile('themes/signup/Dash_for_signup/static_page_includes.stpl', '1fa0cf1819352cb2d518c4b3d793eb24');
        $this->checkFile('themes/signup/Dash_for_signup/theme.php', 'f578203d6102e6a40c65c09851bcc81e');
        $this->checkFile('themes/signup/_common_templates/account_header.stpl', '678effa8c10be4061a47c4d36afcc640');
        $this->checkFile('themes/signup/_common_templates/account_main_static_html_doc.stpl', 'fe3a3cd7cf1cea64c31d88ff28706310');
        $this->checkFile('themes/signup/_common_templates/account_post_signup_page.tpl', '49fe3fde00f67ebe0e92f438cbd948c9');
        $this->checkFile('themes/signup/_common_templates/account_signup_form.tpl', '0309dad8ae6862af88d9d0868fa02aa2');
        $this->checkFile('themes/signup/_common_templates/account_signup_form_panel.tpl', '65315f28539ce2cf75e00ca43db88627');
        $this->checkFile('themes/signup/_common_templates/account_signup_main.stpl', 'ac08fe800fb88d601cc5a8ebdc1960c6');
        $this->checkFile('themes/signup/_common_templates/account_topmenu.stpl', 'a32cd89653ed9a76cb3cd414d9c21312');
        $this->checkFile('themes/signup/_common_templates/affiliate_manager.tpl', '99ec9ed095b074029efd4670ff3dfe1a');
        $this->checkFile('themes/signup/_common_templates/contactus_fields.tpl', '50ebd6d5a6f4bbb7a04d4590fcd8e5d5');
        $this->checkFile('themes/signup/_common_templates/contactus_form.tpl', '03ec58fffc095c02d19080a5968cd987');
        $this->checkFile('themes/signup/_common_templates/custom_license_invalid.tpl', '9157ecde6accdbe2f6cd622084e79d53');
        $this->checkFile('themes/signup/_common_templates/faq_public.stpl', 'a315a1c9763c2f123a81438075814d7f');
        $this->checkFile('themes/signup/_common_templates/footer.stpl', '27752f0c20b329ef6ddd2c1441f600a9');
        $this->checkFile('themes/signup/_common_templates/footer.tpl', '68b329da9893e34099c7d8ad5cb9c940');
        $this->checkFile('themes/signup/_common_templates/header.stpl', '0a8f10d8b0b4d2499ec183b6f5bfa48a');
        $this->checkFile('themes/signup/_common_templates/img/button.gif', '4ade3d1a6f70ab99565469a8899c4721');
        $this->checkFile('themes/signup/_common_templates/img/content_bottom.gif', '752b9cf627b4c7dbccc857d5a691d4b9');
        $this->checkFile('themes/signup/_common_templates/img/content_bottom_left.gif', 'f050f014c1de2756f669817b104181b0');
        $this->checkFile('themes/signup/_common_templates/img/content_bottom_right.gif', 'f7196a6f7f8e41930f25cb60103297e4');
        $this->checkFile('themes/signup/_common_templates/img/content_left.gif', 'd8538d3756f8c6027414a583858618a8');
        $this->checkFile('themes/signup/_common_templates/img/content_right.gif', '97177491028c3422434d64a29fce343b');
        $this->checkFile('themes/signup/_common_templates/img/content_top.gif', '1206ee1251333832e10a09d0dd84c3f8');
        $this->checkFile('themes/signup/_common_templates/img/content_top_left.gif', '8a397076700e439a1c8f24aa9e1c1760');
        $this->checkFile('themes/signup/_common_templates/img/content_top_right.gif', '13947f410657fe4b089d663c9b9922a2');
        $this->checkFile('themes/signup/_common_templates/img/favicon.ico', 'e15128807c80c86ddc36d69e0712d019');
        $this->checkFile('themes/signup/_common_templates/img/favicon.png', 'b7b49aa6d5f1611aa416c3623d057db8');
        $this->checkFile('themes/signup/_common_templates/img/logo_pan.gif', 'bd072bd3f89ebe8996238a1e8b3765c5');
        $this->checkFile('themes/signup/_common_templates/img/logo_pan.png', '97ebd132ae8ec2dd08bbef552d03a0fd');
        $this->checkFile('themes/signup/_common_templates/img/logo_pap.png', '011698765bb35b0ae0dd13f8f16955d5');
        $this->checkFile('themes/signup/_common_templates/img/window.active.b.png', '967a8ff8f5c83f54e9f18cc0245cd902');
        $this->checkFile('themes/signup/_common_templates/img/window.active.bl.png', '5cdb5b0bbbf85dcc85fa5925f063816d');
        $this->checkFile('themes/signup/_common_templates/img/window.active.br.png', '6cad7b47bbcf9bfb729fca5f513fed27');
        $this->checkFile('themes/signup/_common_templates/img/window.active.l.png', 'c88c0bd5208d8163f671e11ad9f74bbd');
        $this->checkFile('themes/signup/_common_templates/img/window.active.r.png', 'd8551cffd12798341df2f41c3380cea5');
        $this->checkFile('themes/signup/_common_templates/img/window.active.t.png', 'd63210562c198f21a6f9519de7c82022');
        $this->checkFile('themes/signup/_common_templates/img/window.active.tl.png', '350c2830a33619e6dc16ff3c3739e692');
        $this->checkFile('themes/signup/_common_templates/img/window.active.tr.png', '3481a5762a92ba4540e4b4c55d5b8140');
        $this->checkFile('themes/signup/_common_templates/index.stpl', 'a4dec9540dd3e93c3060e9f512add7e7');
        $this->checkFile('themes/signup/_common_templates/join_now.stpl', 'd3f6f25fe291738af4810f0076b591bf');
        $this->checkFile('themes/signup/_common_templates/login_annotation.tpl', '7189ae99b486d1688e319900b9ef248e');
        $this->checkFile('themes/signup/_common_templates/login_form.tpl', '34cd762666efcdafa6f88c537f09162d');
        $this->checkFile('themes/signup/_common_templates/main_aff_html_doc.stpl', '31af4382bc12e2392237e1afbf21a507');
        $this->checkFile('themes/signup/_common_templates/main_signup_html_doc.stpl', 'fdc7729a145dbf5243044f3f5bd6ecfa');
        $this->checkFile('themes/signup/_common_templates/main_static_html_doc.stpl', 'abee7112688a2b2c0f6941a39b51a2d8');
        $this->checkFile('themes/signup/_common_templates/merchant_index.stpl', '5c01543d7ba7ebf7977f53bfd757fa19');
        $this->checkFile('themes/signup/_common_templates/merchant_login_annotation.tpl', 'cf6c77707530f5eb8688f4ebca04cbfd');
        $this->checkFile('themes/signup/_common_templates/panel_footer.stpl', '2ecfae35d4c9436786fd4b2c26747242');
        $this->checkFile('themes/signup/_common_templates/panel_includes.stpl', '0f94d032ed0894e4a4fbaf4d54bf3dc0');
        $this->checkFile('themes/signup/_common_templates/pap4.css', '031e3714eb8ab756bbcf35f223fb418b');
        $this->checkFile('themes/signup/_common_templates/payout_methods.tpl', '2d3c13608f9b0a01a80f1d6b1757562a');
        $this->checkFile('themes/signup/_common_templates/post_signup_page.tpl', 'bc2e61d53da4dd93d9a9d014437a5590');
        $this->checkFile('themes/signup/_common_templates/request_new_password_form.tpl', '8e3cf09095e9c60ed9c948d95863f942');
        $this->checkFile('themes/signup/_common_templates/root_index.stpl', '1e0528e12caec3e1759e43f5fa26383b');
        $this->checkFile('themes/signup/_common_templates/samples_tests.stpl', '0634a3ce444cd6e3366ff624dbc1e0e6');
        $this->checkFile('themes/signup/_common_templates/samples_tests_account_signup_html.stpl', '703e33542dbd5eeeddfbc30a9fadaa8c');
        $this->checkFile('themes/signup/_common_templates/samples_tests_banners_linking.stpl', 'f9a979e548e804217e4156b5db56f077');
        $this->checkFile('themes/signup/_common_templates/samples_tests_banners_sample.stpl', '1e88cfca068bc3a289405870eb32fe02');
        $this->checkFile('themes/signup/_common_templates/samples_tests_banners_subid.stpl', 'ddb73689966f648559202245bdb3a12f');
        $this->checkFile('themes/signup/_common_templates/samples_tests_cookie_info.stpl', '88ed53fd0b7788f36573d35197c6878e');
        $this->checkFile('themes/signup/_common_templates/samples_tests_sale_tracking_docu.stpl', 'ddfa49aff745844b5f666940071f9ebf');
        $this->checkFile('themes/signup/_common_templates/samples_tests_sale_tracking_normal.stpl', '76c7333b1e0d1d31627844a854636e86');
        $this->checkFile('themes/signup/_common_templates/samples_tests_sample_homepage.stpl', 'c0454086b416dda8d9be8df1de7095d3');
        $this->checkFile('themes/signup/_common_templates/samples_tests_signup_html.stpl', '8edfd252cb725f0327031f2d9e2abab5');
        $this->checkFile('themes/signup/_common_templates/signup_fields.tpl', '486049d03b932b208ae00829b86b642d');
        $this->checkFile('themes/signup/_common_templates/signup_form.tpl', 'a55f02ab4d649b4eb23fbd252e3555fb');
        $this->checkFile('themes/signup/_common_templates/signup_form_disabled.tpl', '1a6f146b4f44c559cabdc9130c8c3d06');
        $this->checkFile('themes/signup/_common_templates/static_page_includes.stpl', '4264e28d547ddc63c1ba569a877b2aa2');
        $this->checkFile('themes/signup/_common_templates/topmenu.stpl', '140f583a395f24c4b0fde0fd3f826952');
        $this->checkFile('themes/signup/_common_templates/topmenu_logged.stpl', 'f22355a494ee8109ab8dd2deff2b56c5');
        $this->checkFile('themes/signup/_common_templates/topmenu_notlogged.stpl', '0e1277021ceff8927fc75d4c09b48d28');
        $this->checkFile('themes/signup/_common_templates/tour.stpl', 'b1c31639869480f4266eac531d50550a');
        $this->checkFile('themes/signup/classic/README.txt', 'c5e378c3027a6b4f00637e35fa00d549');
        $this->checkFile('themes/signup/classic/custom.css', '4877ef2467745239a93ebe1e79b2f813');
        $this->checkFile('themes/signup/classic/img/content.bottom.gif', '752b9cf627b4c7dbccc857d5a691d4b9');
        $this->checkFile('themes/signup/classic/img/content.bottom.left.gif', 'f050f014c1de2756f669817b104181b0');
        $this->checkFile('themes/signup/classic/img/content.bottom.right.gif', 'f7196a6f7f8e41930f25cb60103297e4');
        $this->checkFile('themes/signup/classic/img/content.left.gif', 'd8538d3756f8c6027414a583858618a8');
        $this->checkFile('themes/signup/classic/img/content.right.gif', '97177491028c3422434d64a29fce343b');
        $this->checkFile('themes/signup/classic/img/content.top.gif', '1206ee1251333832e10a09d0dd84c3f8');
        $this->checkFile('themes/signup/classic/img/content.top.left.gif', '8a397076700e439a1c8f24aa9e1c1760');
        $this->checkFile('themes/signup/classic/img/content.top.right.gif', '13947f410657fe4b089d663c9b9922a2');
        $this->checkFile('themes/signup/classic/img/left.column.gif', '995b4c343022cd59c15a10f49d360eaa');
        $this->checkFile('themes/signup/classic/img/theme_thumbnail.jpg', '83abae8ef8b0fea2e5ed37aabf27daf2');
        $this->checkFile('themes/signup/classic/pap4.css', 'c689421b4c56722faca1a9c45d633d73');
        $this->checkFile('themes/signup/classic/theme.php', '8730072b8a80d3b2f2fbff914b874db2');
        $this->checkFile('themes/signup/compact/README.txt', 'c5e378c3027a6b4f00637e35fa00d549');
        $this->checkFile('themes/signup/compact/custom.css', '4877ef2467745239a93ebe1e79b2f813');
        $this->checkFile('themes/signup/compact/img/theme_thumbnail.jpg', 'fba7912449e3a2634f6a0f9a5c01355f');
        $this->checkFile('themes/signup/compact/index.stpl', 'df7a2a85a552be8302052dbfde64f051');
        $this->checkFile('themes/signup/compact/login_form.tpl', 'a2941a521992ab59ac2a76fdf09abb30');
        $this->checkFile('themes/signup/compact/login_main.tpl', '0cd828d3f67418d0795faf78316d9aaf');
        $this->checkFile('themes/signup/compact/pap4.css', 'ade5c98bae05f2143e99a7d1a48b1708');
        $this->checkFile('themes/signup/compact/theme.php', '3e16f80c07b6dba5d318ba02b03e4c32');
        $this->checkFile('themes/signup/cool/README.txt', 'c5e378c3027a6b4f00637e35fa00d549');
        $this->checkFile('themes/signup/cool/account_header.stpl', 'e2ef577921d80847c7a9e8db670ed170');
        $this->checkFile('themes/signup/cool/account_post_signup_page.tpl', '7f5f799dfa45741e809edd14ed79a3e7');
        $this->checkFile('themes/signup/cool/account_signup_form.tpl', '474800373aef66a39843c3bdea197ff1');
        $this->checkFile('themes/signup/cool/account_topmenu.stpl', 'cda6bf6ebc3bc50329a096ac4618893c');
        $this->checkFile('themes/signup/cool/contactus_form.tpl', 'b626bc48769baa3836a565e65c9cbe61');
        $this->checkFile('themes/signup/cool/custom.css', '4877ef2467745239a93ebe1e79b2f813');
        $this->checkFile('themes/signup/cool/faq_public.stpl', 'cf54f414a21a71a88ac0a0b2cdc4258f');
        $this->checkFile('themes/signup/cool/footer.stpl', 'd31a9346b2f9cf323c486e45833ffbbb');
        $this->checkFile('themes/signup/cool/header.stpl', '941777bb91268b14843bc262d291c8ed');
        $this->checkFile('themes/signup/cool/img/background.bottom.png', 'f99fffce75905cbf3ee4a3afad1fc619');
        $this->checkFile('themes/signup/cool/img/header.background.jpg', '9d26f8c5c8200673aec7f4cebc0753f0');
        $this->checkFile('themes/signup/cool/img/join.button.png', '1c1467c3462fd72d0c4cfe007c75c526');
        $this->checkFile('themes/signup/cool/img/navigation.left.png', '3935bf693de4c1348a8cc96fcc5f9171');
        $this->checkFile('themes/signup/cool/img/theme_thumbnail.jpg', '1dcbc49f24156a54588a2b66941e0cb6');
        $this->checkFile('themes/signup/cool/index.stpl', '00b705c80df3d682ad26e6506aa86b2d');
        $this->checkFile('themes/signup/cool/join_now.stpl', '01d2e03f5f9856ccfc2218966db02060');
        $this->checkFile('themes/signup/cool/login_form.tpl', 'b98adeeb810fa86a76a71bd0c6ddb800');
        $this->checkFile('themes/signup/cool/login_main.tpl', '0cd828d3f67418d0795faf78316d9aaf');
        $this->checkFile('themes/signup/cool/merchant_index.stpl', '48c07db6a09e526636aac031eb8afcfa');
        $this->checkFile('themes/signup/cool/pap4.css', 'a4c4b1ec28b26a43ae3f2efaff3ed464');
        $this->checkFile('themes/signup/cool/post_signup_page.tpl', '15caa4705a773c8ab121e0eba4eb6ce0');
        $this->checkFile('themes/signup/cool/request_new_password_form.tpl', '06d1caa3fa7a511b2d188988d43032f0');
        $this->checkFile('themes/signup/cool/root_index.stpl', 'c9eb3a0e6230a3b4d414f09313fb5ae4');
        $this->checkFile('themes/signup/cool/samples_tests.stpl', 'c66bd753aa2389d68eb90911085fbebd');
        $this->checkFile('themes/signup/cool/samples_tests_account_signup_html.stpl', '201135c45b283605790f375d596a60fc');
        $this->checkFile('themes/signup/cool/samples_tests_banners_linking.stpl', 'd7e6ead040b26c3963c8dc75dab204a2');
        $this->checkFile('themes/signup/cool/samples_tests_banners_sample.stpl', '17490a0b8271dc039625d6cbeaaadd86');
        $this->checkFile('themes/signup/cool/samples_tests_banners_subid.stpl', '1bbe360e3d6d9bd4fe01954b64637b6c');
        $this->checkFile('themes/signup/cool/samples_tests_cookie_info.stpl', '001b973c3cb4bfb112750fb85162f304');
        $this->checkFile('themes/signup/cool/samples_tests_sale_tracking_docu.stpl', 'a33fee3723b0f93e0e62c20b1c3ebf2b');
        $this->checkFile('themes/signup/cool/samples_tests_sale_tracking_normal.stpl', 'c5e7755b066758d31ff9ae46c2b390fb');
        $this->checkFile('themes/signup/cool/samples_tests_sample_homepage.stpl', 'e92c000318548f5096e8433b28093860');
        $this->checkFile('themes/signup/cool/samples_tests_signup_html.stpl', 'df0bc89983d989a919efd4e352bc72e6');
        $this->checkFile('themes/signup/cool/signup_form.tpl', 'c0892fc6ebb01e61356dce8e6ef47507');
        $this->checkFile('themes/signup/cool/signup_form_disabled.tpl', '3b86b1e40f06f34e8c543c70088e9c63');
        $this->checkFile('themes/signup/cool/theme.php', 'cad4af731a518dca04331e2a64edf28b');
        $this->checkFile('themes/signup/cool/topmenu_logged.stpl', '2d52bdc6d28514b0057ca515e6d40573');
        $this->checkFile('themes/signup/cool/topmenu_notlogged.stpl', '1ad5c175f9edb516248a98b84f0c55cc');
        $this->checkFile('themes/signup/cool/tour.stpl', 'eb5549c6ad5eef568d3fa591e1cdf25d');
        $this->checkFile('vendor/autoload.php', '77cd679372a4feaea76b56f2a553e7de');
        $this->checkFile('vendor/bandwidth-throttle/token-bucket/.travis.yml', '30dd9dbc421d4f41ffad38160d136c0a');
        $this->checkFile('vendor/bandwidth-throttle/token-bucket/LICENSE', '8365d07beeb5f39d87e846dca3ae7b64');
        $this->checkFile('vendor/bandwidth-throttle/token-bucket/README.md', 'da0f968e1d0b8f503f689bc18541aaf8');
        $this->checkFile('vendor/bandwidth-throttle/token-bucket/classes/BlockingConsumer.php', 'd2c3e5d05fe07cf9c7cc5a5b3b9aa2d2');
        $this->checkFile('vendor/bandwidth-throttle/token-bucket/classes/Rate.php', '552f7328ac652e3f1e9a3adcca171b05');
        $this->checkFile('vendor/bandwidth-throttle/token-bucket/classes/TokenBucket.php', '014db270d86d87a610166d8bed1bb749');
        $this->checkFile('vendor/bandwidth-throttle/token-bucket/classes/TokenBucketException.php', '37162dd1c47350999a6aa673ebd058e4');
        $this->checkFile('vendor/bandwidth-throttle/token-bucket/classes/storage/FileStorage.php', '33a9d82715861b5971b03320538c187a');
        $this->checkFile('vendor/bandwidth-throttle/token-bucket/classes/storage/IPCStorage.php', '4033adb120ba6c7030fe29432affe842');
        $this->checkFile('vendor/bandwidth-throttle/token-bucket/classes/storage/MemcacheStorage.php', 'd010f7c14d14cfb556c9171836f79767');
        $this->checkFile('vendor/bandwidth-throttle/token-bucket/classes/storage/MemcachedStorage.php', 'cce81e70ba59a1475d7830cea5e110dd');
        $this->checkFile('vendor/bandwidth-throttle/token-bucket/classes/storage/PDOStorage.php', 'cd4a22400219a4336706d16d1e1fe339');
        $this->checkFile('vendor/bandwidth-throttle/token-bucket/classes/storage/PHPRedisStorage.php', '0f60678af41528d28ce9cf3c1ebdb005');
        $this->checkFile('vendor/bandwidth-throttle/token-bucket/classes/storage/PredisStorage.php', 'a678e5c2060388447c34c8152685f6aa');
        $this->checkFile('vendor/bandwidth-throttle/token-bucket/classes/storage/SessionStorage.php', '0c93e4adebaec1c6b9ac71b440fec698');
        $this->checkFile('vendor/bandwidth-throttle/token-bucket/classes/storage/SingleProcessStorage.php', '4c6cd6811538b204e7a6ffe1f381a18b');
        $this->checkFile('vendor/bandwidth-throttle/token-bucket/classes/storage/Storage.php', '79590359d207a711e413b813d5266983');
        $this->checkFile('vendor/bandwidth-throttle/token-bucket/classes/storage/StorageException.php', 'a28ae31e45cc15b53657cedf98a5d94f');
        $this->checkFile('vendor/bandwidth-throttle/token-bucket/classes/storage/scope/GlobalScope.php', 'ce4f8e6dc90a023766e854842a997776');
        $this->checkFile('vendor/bandwidth-throttle/token-bucket/classes/storage/scope/RequestScope.php', '61a846e20232025b193b2532ff3dd062');
        $this->checkFile('vendor/bandwidth-throttle/token-bucket/classes/storage/scope/SessionScope.php', 'f2fcfccbc983c3122cadb6cb915d7b52');
        $this->checkFile('vendor/bandwidth-throttle/token-bucket/classes/util/DoublePacker.php', '4a532228f9ef9a7dcf9e6b583898ffa9');
        $this->checkFile('vendor/bandwidth-throttle/token-bucket/classes/util/TokenConverter.php', '44d65e591aa9a9bcf5c47656eac5c34b');
        $this->checkFile('vendor/bandwidth-throttle/token-bucket/composer.json', '98fa61fc3d5190587a67b91ebe99afea');
        $this->checkFile('vendor/bandwidth-throttle/token-bucket/phpunit.xml', '33bf758dd98677812ec3784a43ff08f6');
        $this->checkFile('vendor/bandwidth-throttle/token-bucket/tests/BlockingConsumerTest.php', '41611815c4175f46d203c624aa40764d');
        $this->checkFile('vendor/bandwidth-throttle/token-bucket/tests/RateTest.php', '4e9515e2a002009ba1dbb6f17b5c0bf8');
        $this->checkFile('vendor/bandwidth-throttle/token-bucket/tests/TokenBucketTest.php', '721016ca93333919fbccdf6e7b9e094b');
        $this->checkFile('vendor/bandwidth-throttle/token-bucket/tests/php-travis.ini', '44a880defdbad5bd588b563fcb16d478');
        $this->checkFile('vendor/bandwidth-throttle/token-bucket/tests/storage/FileStorageTest.php', '437fe89407078deb985dabf79bb1f466');
        $this->checkFile('vendor/bandwidth-throttle/token-bucket/tests/storage/IPCStorageTest.php', '5543f02c3c27dd5e1b8d105ea3ce57c4');
        $this->checkFile('vendor/bandwidth-throttle/token-bucket/tests/storage/MemcachedStorageTest.php', '2a392e56a51fd15dab1a83be56c5a6d2');
        $this->checkFile('vendor/bandwidth-throttle/token-bucket/tests/storage/PDOStorageTest.php', '678668c06dd8a2712fa56fcf8938d3f5');
        $this->checkFile('vendor/bandwidth-throttle/token-bucket/tests/storage/PHPRedisStorageTest.php', '8d2267f8d1ca160f376fd1d3c800b0f1');
        $this->checkFile('vendor/bandwidth-throttle/token-bucket/tests/storage/PredisStorageTest.php', '29a3f60211b291970230fe694a2d11e2');
        $this->checkFile('vendor/bandwidth-throttle/token-bucket/tests/storage/SharedStorageTest.php', '9daa3ee7af824e79bce210fc1a6d32f3');
        $this->checkFile('vendor/bandwidth-throttle/token-bucket/tests/storage/StorageTest.php', 'ddcb3ed03c92b7aa5e38f5139ed4f8ab');
        $this->checkFile('vendor/bandwidth-throttle/token-bucket/tests/util/DoublePackerTest.php', 'ec01cc6035e7c170734402f5cff90a45');
        $this->checkFile('vendor/bandwidth-throttle/token-bucket/tests/util/TokenConverterTest.php', '26c57e61981d03eb5b03abf266b8aa35');
        $this->checkFile('vendor/composer/ClassLoader.php', 'a0899dd7d97c25fe1d872a542afa6081');
        $this->checkFile('vendor/composer/LICENSE', '955d5fe58c231244f6b49000f383b5e2');
        $this->checkFile('vendor/composer/autoload_classmap.php', 'b95832606bf4a8a4e8e03c2d46707080');
        $this->checkFile('vendor/composer/autoload_files.php', 'a06e101370ea55acdeeec764886ffca6');
        $this->checkFile('vendor/composer/autoload_namespaces.php', '7070fb79b2aa014a59f7c522f7d2da8e');
        $this->checkFile('vendor/composer/autoload_psr4.php', 'e377732266488d6958b94fda55cbabd6');
        $this->checkFile('vendor/composer/autoload_real.php', '0df51e0286ea1b50eac595eaaadef8ad');
        $this->checkFile('vendor/composer/autoload_static.php', '995082af5ec48cec4d48e2a5867e3289');
        $this->checkFile('vendor/composer/ca-bundle/LICENSE', '783e50a8f248e56536e25b4746d035af');
        $this->checkFile('vendor/composer/ca-bundle/README.md', '158204f9739fb656c0161e58913d724f');
        $this->checkFile('vendor/composer/ca-bundle/composer.json', 'c42d508997f7bf8811b644e9fae8800f');
        $this->checkFile('vendor/composer/ca-bundle/res/cacert.pem', 'c726ae88fd600aa26df1d30f42b51fec');
        $this->checkFile('vendor/composer/ca-bundle/src/CaBundle.php', '5f01c5547cff9611dd425d60a07a084f');
        $this->checkFile('vendor/composer/installed.json', '1af5c4401598753de5bc6ceb4063b73f');
        $this->checkFile('vendor/geoip2/geoip2/.php_cs', '8b5f40e5650feee8e4330ca56294d942');
        $this->checkFile('vendor/geoip2/geoip2/CHANGELOG.md', '5439321556c0b8a3e08a52eb56dff55e');
        $this->checkFile('vendor/geoip2/geoip2/LICENSE', '3b83ef96387f14655fc854ddc3c6bd57');
        $this->checkFile('vendor/geoip2/geoip2/README.md', '9246ee548774cccd0f285f44b6a957c6');
        $this->checkFile('vendor/geoip2/geoip2/composer.json', '718e7f27cbb44a440d4abcccd8ad8708');
        $this->checkFile('vendor/geoip2/geoip2/src/Database/Reader.php', 'a6c50a1c416776fa983103500c83d8b5');
        $this->checkFile('vendor/geoip2/geoip2/src/Exception/AddressNotFoundException.php', 'f7b42f2f1952b78482e1cc6ae3e9c92e');
        $this->checkFile('vendor/geoip2/geoip2/src/Exception/AuthenticationException.php', 'a664ef571be82c82fa584545e66ff1fb');
        $this->checkFile('vendor/geoip2/geoip2/src/Exception/GeoIp2Exception.php', 'b14e09b853d258d93f7a0fd50e07b1d3');
        $this->checkFile('vendor/geoip2/geoip2/src/Exception/HttpException.php', 'c86ccb666bb3ea3c19fdf7070d0ac0cb');
        $this->checkFile('vendor/geoip2/geoip2/src/Exception/InvalidRequestException.php', '4961bbe3eefdb5ff7f52c99e2578bcbf');
        $this->checkFile('vendor/geoip2/geoip2/src/Exception/OutOfQueriesException.php', '35f4fa482a66d2e424b0f0ca9d19d390');
        $this->checkFile('vendor/geoip2/geoip2/src/Model/AbstractModel.php', '401fd28f4889ff43a435cca85b00a5e5');
        $this->checkFile('vendor/geoip2/geoip2/src/Model/AnonymousIp.php', '65ba6d67ebdd9c7cf93cebbcb844680b');
        $this->checkFile('vendor/geoip2/geoip2/src/Model/Asn.php', '9cda840b9d0aba3110b768cdbe2102dc');
        $this->checkFile('vendor/geoip2/geoip2/src/Model/City.php', '01ec038be43ed9ca59215c7a9bff4a58');
        $this->checkFile('vendor/geoip2/geoip2/src/Model/ConnectionType.php', '649de5e0533abf2d4ec02151ddfb3022');
        $this->checkFile('vendor/geoip2/geoip2/src/Model/Country.php', '00a651902332d08f1291b4f35280b495');
        $this->checkFile('vendor/geoip2/geoip2/src/Model/Domain.php', '6e34a41e469abf304a43c6206eb2be6b');
        $this->checkFile('vendor/geoip2/geoip2/src/Model/Enterprise.php', '84a185363a94f5f6be326b5033faaebc');
        $this->checkFile('vendor/geoip2/geoip2/src/Model/Insights.php', '8c47c61b8cdf3da3be9d310a56e730ee');
        $this->checkFile('vendor/geoip2/geoip2/src/Model/Isp.php', 'ba941470d9bdadb850aadb5d478190db');
        $this->checkFile('vendor/geoip2/geoip2/src/ProviderInterface.php', '5abfcd7ff82a064e66c7d9bc7b849d15');
        $this->checkFile('vendor/geoip2/geoip2/src/Record/AbstractPlaceRecord.php', '0b60c4490c2e3a8f9b137fe2605052e4');
        $this->checkFile('vendor/geoip2/geoip2/src/Record/AbstractRecord.php', '24e06b4117ce60c06c77dcceecb87984');
        $this->checkFile('vendor/geoip2/geoip2/src/Record/City.php', '1c28af2c83a094beaf45da8ee6860e3b');
        $this->checkFile('vendor/geoip2/geoip2/src/Record/Continent.php', '9971444c87dfde61aa5b093fe0af2406');
        $this->checkFile('vendor/geoip2/geoip2/src/Record/Country.php', 'fb94b8972c30c1a75a25c911ade6f99a');
        $this->checkFile('vendor/geoip2/geoip2/src/Record/Location.php', 'e110f1597d83898c603876e8fd85464a');
        $this->checkFile('vendor/geoip2/geoip2/src/Record/MaxMind.php', 'a544719364369e2b22be90558f0687f0');
        $this->checkFile('vendor/geoip2/geoip2/src/Record/Postal.php', '4dc2628d5022d1198a78d9594030f1e0');
        $this->checkFile('vendor/geoip2/geoip2/src/Record/RepresentedCountry.php', '3e58561044e8fbb0af6dad7c5036190a');
        $this->checkFile('vendor/geoip2/geoip2/src/Record/Subdivision.php', '9b06d8ef3b75c289fd1c53b982ecb56c');
        $this->checkFile('vendor/geoip2/geoip2/src/Record/Traits.php', '3b10486f16c4b4609ae9d7b36dc525f6');
        $this->checkFile('vendor/geoip2/geoip2/src/WebService/Client.php', 'e2b6a8ba3b2a1714aeaaca3f89d57a8f');
        $this->checkFile('vendor/guzzlehttp/guzzle/.php_cs', 'f034d3a776ad1076f9d24ac59a34c5a6');
        $this->checkFile('vendor/guzzlehttp/guzzle/CHANGELOG.md', '3312f0b19a06a43c108cd138c3427bec');
        $this->checkFile('vendor/guzzlehttp/guzzle/Dockerfile', '80e398f1c3adb70d2731859d860805f2');
        $this->checkFile('vendor/guzzlehttp/guzzle/LICENSE', '5de578bad5eaf55998cd4fbb17e4c47a');
        $this->checkFile('vendor/guzzlehttp/guzzle/README.md', '4dd141449410a5f7fcae8359acad5fe9');
        $this->checkFile('vendor/guzzlehttp/guzzle/UPGRADING.md', 'ead9d27be0b570022a26246714bb2a63');
        $this->checkFile('vendor/guzzlehttp/guzzle/composer.json', '08c0fb6eccf507bb7586d828a3f33baf');
        $this->checkFile('vendor/guzzlehttp/guzzle/src/Client.php', '3a09f95a50a513c55a9a88163f283fe6');
        $this->checkFile('vendor/guzzlehttp/guzzle/src/ClientInterface.php', 'c6bb8297736bf7d33b388f947ae65539');
        $this->checkFile('vendor/guzzlehttp/guzzle/src/Cookie/CookieJar.php', '75540254f89f232161ad7635bd2d1c3c');
        $this->checkFile('vendor/guzzlehttp/guzzle/src/Cookie/CookieJarInterface.php', '7533eb0806d95fb17bbc1d3aa789ccf8');
        $this->checkFile('vendor/guzzlehttp/guzzle/src/Cookie/FileCookieJar.php', '153cb09aa11cb23e82f0240846a5fb9d');
        $this->checkFile('vendor/guzzlehttp/guzzle/src/Cookie/SessionCookieJar.php', 'd0654bb217a12e5f2519496048ebabfc');
        $this->checkFile('vendor/guzzlehttp/guzzle/src/Cookie/SetCookie.php', '3b261572f770d99735cdeb2fee4fd308');
        $this->checkFile('vendor/guzzlehttp/guzzle/src/Exception/BadResponseException.php', '7e1c1332c6434c46725456a488ce3302');
        $this->checkFile('vendor/guzzlehttp/guzzle/src/Exception/ClientException.php', 'd1b8b2a79c00297b1882847057997220');
        $this->checkFile('vendor/guzzlehttp/guzzle/src/Exception/ConnectException.php', '4c3a541bc2a97f9278417c8ccd49a256');
        $this->checkFile('vendor/guzzlehttp/guzzle/src/Exception/GuzzleException.php', '9a8d08931c57b6eee31b8fe7fc1107db');
        $this->checkFile('vendor/guzzlehttp/guzzle/src/Exception/InvalidArgumentException.php', '8e5b4860cf34750f27d8631ddc46731f');
        $this->checkFile('vendor/guzzlehttp/guzzle/src/Exception/RequestException.php', 'f06db206086064fb9dc38fdcb5844d50');
        $this->checkFile('vendor/guzzlehttp/guzzle/src/Exception/SeekException.php', 'd3321b4b634f612a98acd08e08ef6e74');
        $this->checkFile('vendor/guzzlehttp/guzzle/src/Exception/ServerException.php', '2626a47283b55872bd43b53586591f62');
        $this->checkFile('vendor/guzzlehttp/guzzle/src/Exception/TooManyRedirectsException.php', '858be1e34ed7abcad4c702b3b707169e');
        $this->checkFile('vendor/guzzlehttp/guzzle/src/Exception/TransferException.php', 'e7aa5a47414a3a7ff399bbe438cee829');
        $this->checkFile('vendor/guzzlehttp/guzzle/src/Handler/CurlFactory.php', 'b26c46d1877be54b84e617110f93c8d0');
        $this->checkFile('vendor/guzzlehttp/guzzle/src/Handler/CurlFactoryInterface.php', 'b4dbdca4de39177941fbea19855eb74f');
        $this->checkFile('vendor/guzzlehttp/guzzle/src/Handler/CurlHandler.php', '18c8727a9457cf6d1f382b4cb394979f');
        $this->checkFile('vendor/guzzlehttp/guzzle/src/Handler/CurlMultiHandler.php', '0bd0df0eb598905e31cdeea04826b1b7');
        $this->checkFile('vendor/guzzlehttp/guzzle/src/Handler/EasyHandle.php', '02eec42dd5ec3cd6ef6cca4735c2eb9b');
        $this->checkFile('vendor/guzzlehttp/guzzle/src/Handler/MockHandler.php', '78f903829e7cb9c0ea58cb6b527b3550');
        $this->checkFile('vendor/guzzlehttp/guzzle/src/Handler/Proxy.php', '0eade7e36c32b1b98a70483348ca98f9');
        $this->checkFile('vendor/guzzlehttp/guzzle/src/Handler/StreamHandler.php', '9a1527716819b4d8840b5f9387d9a3fc');
        $this->checkFile('vendor/guzzlehttp/guzzle/src/HandlerStack.php', 'ea3c43f1cab8c4d6823a7dcf9917b067');
        $this->checkFile('vendor/guzzlehttp/guzzle/src/MessageFormatter.php', 'aa7ae3b25b9fbf9d21e852bf30741da6');
        $this->checkFile('vendor/guzzlehttp/guzzle/src/Middleware.php', 'b28b11197e215b8e3e77c51184938a8c');
        $this->checkFile('vendor/guzzlehttp/guzzle/src/Pool.php', '96418ea0f5996e8cc5a8aff046344a73');
        $this->checkFile('vendor/guzzlehttp/guzzle/src/PrepareBodyMiddleware.php', 'f5ba26890bc5f826ee63571ce6e35caa');
        $this->checkFile('vendor/guzzlehttp/guzzle/src/RedirectMiddleware.php', 'd3863b0292d1c14924f75d82f01e9e6f');
        $this->checkFile('vendor/guzzlehttp/guzzle/src/RequestOptions.php', '225dd0e0e60f6020df5e372a3b1576c4');
        $this->checkFile('vendor/guzzlehttp/guzzle/src/RetryMiddleware.php', 'a8015d35bf3c606e2e7f46570bb1767d');
        $this->checkFile('vendor/guzzlehttp/guzzle/src/TransferStats.php', '9690c8b858639495d1693f9700409926');
        $this->checkFile('vendor/guzzlehttp/guzzle/src/UriTemplate.php', '1915a39780656e4b1966b450778549c8');
        $this->checkFile('vendor/guzzlehttp/guzzle/src/Utils.php', 'a3dfd474f48c775c2d6ac5e41879bfdf');
        $this->checkFile('vendor/guzzlehttp/guzzle/src/functions.php', '9867c7b0e1e1a4538451b8059430a80b');
        $this->checkFile('vendor/guzzlehttp/guzzle/src/functions_include.php', '5f6ee7f97cc86838635c9c1350415bc8');
        $this->checkFile('vendor/guzzlehttp/promises/CHANGELOG.md', '17cf5a6f7d04ce8a66b6669e21685fe8');
        $this->checkFile('vendor/guzzlehttp/promises/LICENSE', 'ea21094b920dfbacf39b9ce046e309c0');
        $this->checkFile('vendor/guzzlehttp/promises/Makefile', '12320a1adefd23c1e0c95dae541e3af1');
        $this->checkFile('vendor/guzzlehttp/promises/README.md', '1eaac047b33b33317b39ffcc7b2364fd');
        $this->checkFile('vendor/guzzlehttp/promises/composer.json', '5ba93cdefe8345ce39f4aff3747e8e45');
        $this->checkFile('vendor/guzzlehttp/promises/src/AggregateException.php', 'babe9fcc334d0b4fea85e9e05f4d552e');
        $this->checkFile('vendor/guzzlehttp/promises/src/CancellationException.php', 'a9a2fbcbd5dcfb0fdfb3feaf5c7b4324');
        $this->checkFile('vendor/guzzlehttp/promises/src/Coroutine.php', 'e85129b6991bc6e91430d638b94acaf2');
        $this->checkFile('vendor/guzzlehttp/promises/src/EachPromise.php', 'df6789b4bd35f2bbd68cb5faf46d79ad');
        $this->checkFile('vendor/guzzlehttp/promises/src/FulfilledPromise.php', 'd6001563130d4d92f1b58eeb714c117d');
        $this->checkFile('vendor/guzzlehttp/promises/src/Promise.php', 'c04d0b15ab275748b0d51ad596ab344a');
        $this->checkFile('vendor/guzzlehttp/promises/src/PromiseInterface.php', 'd89b4dc299c87456f210c253c6b94e22');
        $this->checkFile('vendor/guzzlehttp/promises/src/PromisorInterface.php', 'a9d3c230da1e74e747cf37099bbf3dfa');
        $this->checkFile('vendor/guzzlehttp/promises/src/RejectedPromise.php', '0dec3a7152df237c1138075adba8f77a');
        $this->checkFile('vendor/guzzlehttp/promises/src/RejectionException.php', 'dcf7b821573f91b31bf52e9f00e494bd');
        $this->checkFile('vendor/guzzlehttp/promises/src/TaskQueue.php', 'f689afac69023ad70c4239acc0594760');
        $this->checkFile('vendor/guzzlehttp/promises/src/TaskQueueInterface.php', '93f20d7dee241a3a2acfb9f378d0446c');
        $this->checkFile('vendor/guzzlehttp/promises/src/functions.php', '2ff33484d4b21748efdd577c6b6a45c1');
        $this->checkFile('vendor/guzzlehttp/promises/src/functions_include.php', 'f5cb9de3f9980feda6ea3341215bf7ac');
        $this->checkFile('vendor/guzzlehttp/psr7/CHANGELOG.md', 'c440ec076b3f9080163c715341f9e938');
        $this->checkFile('vendor/guzzlehttp/psr7/LICENSE', '582d7d97bab524143526a38575956e46');
        $this->checkFile('vendor/guzzlehttp/psr7/README.md', '4c8d0bb6860449db2a2b13ff3307c0d8');
        $this->checkFile('vendor/guzzlehttp/psr7/composer.json', '3bb519815582f64fbc41bf4a1224a199');
        $this->checkFile('vendor/guzzlehttp/psr7/src/AppendStream.php', 'e0684f44ea745ae64d56e6b3a1a76712');
        $this->checkFile('vendor/guzzlehttp/psr7/src/BufferStream.php', 'ca89bcf988c8e4d13a39d5febb985331');
        $this->checkFile('vendor/guzzlehttp/psr7/src/CachingStream.php', '9044f074880bee4ad2d17f1097055e68');
        $this->checkFile('vendor/guzzlehttp/psr7/src/DroppingStream.php', 'adac9db8a35c6892151e065e9eadd8ac');
        $this->checkFile('vendor/guzzlehttp/psr7/src/FnStream.php', '4a319fdba69140a62fefa489a34f3b58');
        $this->checkFile('vendor/guzzlehttp/psr7/src/InflateStream.php', '4bd9450899694acd4aadb12cb899dbe3');
        $this->checkFile('vendor/guzzlehttp/psr7/src/LazyOpenStream.php', '2648cdbb073317f8ea813383393aee2b');
        $this->checkFile('vendor/guzzlehttp/psr7/src/LimitStream.php', 'b27e80154c9497c63da6e209603cfd3c');
        $this->checkFile('vendor/guzzlehttp/psr7/src/MessageTrait.php', 'e45dc8d86394c528185a70cd64ce038f');
        $this->checkFile('vendor/guzzlehttp/psr7/src/MultipartStream.php', '418b48dc402a57881438b3bd5b22473a');
        $this->checkFile('vendor/guzzlehttp/psr7/src/NoSeekStream.php', 'a0717a0ab4fe202dcc050b0aa46e375b');
        $this->checkFile('vendor/guzzlehttp/psr7/src/PumpStream.php', '55ac4bb5f9a26cd93e5fa10a1f5132c3');
        $this->checkFile('vendor/guzzlehttp/psr7/src/Request.php', '70807251be0125634918035689186580');
        $this->checkFile('vendor/guzzlehttp/psr7/src/Response.php', 'e08eeea547655fff0ba880428b3a601c');
        $this->checkFile('vendor/guzzlehttp/psr7/src/Rfc7230.php', '1144f7cdab644cac7b033a32b6b3be97');
        $this->checkFile('vendor/guzzlehttp/psr7/src/ServerRequest.php', 'a1d9d29984796187d10b90e4937fe518');
        $this->checkFile('vendor/guzzlehttp/psr7/src/Stream.php', '79c1b89afc51f1d4e0425347d22e23a6');
        $this->checkFile('vendor/guzzlehttp/psr7/src/StreamDecoratorTrait.php', 'd4b43ceea144a8327ee0ef440c83bf8b');
        $this->checkFile('vendor/guzzlehttp/psr7/src/StreamWrapper.php', '3f09c98d37706bf0cb82e8879660eca1');
        $this->checkFile('vendor/guzzlehttp/psr7/src/UploadedFile.php', 'a36b94212547cd38bb7857f030258a01');
        $this->checkFile('vendor/guzzlehttp/psr7/src/Uri.php', '3407068f73a7cbbd55c35c8d062863ed');
        $this->checkFile('vendor/guzzlehttp/psr7/src/UriNormalizer.php', '0c59600f6357c91a23038769fd848810');
        $this->checkFile('vendor/guzzlehttp/psr7/src/UriResolver.php', '726fdbffbc9cf405810e5c912e281465');
        $this->checkFile('vendor/guzzlehttp/psr7/src/functions.php', '38df19b75f0d7bc34440442f31980fff');
        $this->checkFile('vendor/guzzlehttp/psr7/src/functions_include.php', '847190da01ae741e44241753f23cc1da');
        $this->checkFile('vendor/malkusch/lock/LICENSE', '8365d07beeb5f39d87e846dca3ae7b64');
        $this->checkFile('vendor/malkusch/lock/README.md', '815d0ae1605870384267d924f6a19d3c');
        $this->checkFile('vendor/malkusch/lock/classes/exception/DeadlineException.php', 'b6c28226f166bba397b9ac1dc0c959bf');
        $this->checkFile('vendor/malkusch/lock/classes/exception/ExecutionOutsideLockException.php', '9db0fdf5dc257fce5e952b0cd3314998');
        $this->checkFile('vendor/malkusch/lock/classes/exception/LockAcquireException.php', '233b37612e8dc648d49677122def8cc5');
        $this->checkFile('vendor/malkusch/lock/classes/exception/LockReleaseException.php', 'd78e7d05d450a68fe0e3b72788ecfb8f');
        $this->checkFile('vendor/malkusch/lock/classes/exception/MutexException.php', '5d3688758ea1f933281f6a8ccc9064b6');
        $this->checkFile('vendor/malkusch/lock/classes/exception/TimeoutException.php', '8c2f0d889e3a20905f32ebe40cd61bf1');
        $this->checkFile('vendor/malkusch/lock/classes/mutex/CASMutex.php', 'ffa237a9a040346d96687579d65628f9');
        $this->checkFile('vendor/malkusch/lock/classes/mutex/FlockMutex.php', '5f52fe919cfdb8b29cbe654bcca23adc');
        $this->checkFile('vendor/malkusch/lock/classes/mutex/LockMutex.php', 'd47cade5bc4895a68abf7d822a737f4c');
        $this->checkFile('vendor/malkusch/lock/classes/mutex/MemcacheMutex.php', 'c7344350d9c9a447c3ceef71b130aed6');
        $this->checkFile('vendor/malkusch/lock/classes/mutex/MemcachedMutex.php', '0c3e916b56ec75ed57829a5f77854454');
        $this->checkFile('vendor/malkusch/lock/classes/mutex/Mutex.php', 'b38f94841b883a3279a2454e89c8ec54');
        $this->checkFile('vendor/malkusch/lock/classes/mutex/MySQLMutex.php', 'f895df16c444ba53ebfe31656e31e20f');
        $this->checkFile('vendor/malkusch/lock/classes/mutex/NoMutex.php', '92a820ff1b767c99c2356a9dd794c180');
        $this->checkFile('vendor/malkusch/lock/classes/mutex/PHPRedisMutex.php', '63a0349af6598cac36e3419f09304283');
        $this->checkFile('vendor/malkusch/lock/classes/mutex/PgAdvisoryLockMutex.php', 'c6c64824fb49be084c2c389c97e945e2');
        $this->checkFile('vendor/malkusch/lock/classes/mutex/PredisMutex.php', '04676d764e7ad420847aec6fba1fd311');
        $this->checkFile('vendor/malkusch/lock/classes/mutex/RedisMutex.php', '08f56ef8eb29b58c3d0569c8a9ae73df');
        $this->checkFile('vendor/malkusch/lock/classes/mutex/SemaphoreMutex.php', 'd0b50db55e55250a4c1fe4afbc2584c9');
        $this->checkFile('vendor/malkusch/lock/classes/mutex/SpinlockMutex.php', 'babe3a504c7571e285e64cca9ef4d1e9');
        $this->checkFile('vendor/malkusch/lock/classes/mutex/TransactionalMutex.php', 'b989561113824dfaf7812cb79cbfcf70');
        $this->checkFile('vendor/malkusch/lock/classes/util/DoubleCheckedLocking.php', 'cef3beb5c82e59979e7b86e0188538e0');
        $this->checkFile('vendor/malkusch/lock/classes/util/Loop.php', '2b8f3c6ac8effb804c6d98c33c2e4d8a');
        $this->checkFile('vendor/malkusch/lock/classes/util/PcntlTimeout.php', 'd9bc67a8456fda738834e0fe5febab6d');
        $this->checkFile('vendor/malkusch/lock/composer.json', '7631e6e46d8371dd0746ab14c7ee7d90');
        $this->checkFile('vendor/maxmind/web-service-common/CHANGELOG.md', 'f4462745aac12e9dbc45661e86593567');
        $this->checkFile('vendor/maxmind/web-service-common/LICENSE', '3b83ef96387f14655fc854ddc3c6bd57');
        $this->checkFile('vendor/maxmind/web-service-common/README.md', '83be6354795a8df517e15178dd796d1f');
        $this->checkFile('vendor/maxmind/web-service-common/composer.json', 'e6a7ea65b946cbeaaf4f13bfc7b554fa');
        $this->checkFile('vendor/maxmind/web-service-common/dev-bin/release.sh', '21a161f1436dfb30628d6fa80c4f6c5a');
        $this->checkFile('vendor/maxmind/web-service-common/src/Exception/AuthenticationException.php', '4b236c4a50a88b6530759f67a5db9481');
        $this->checkFile('vendor/maxmind/web-service-common/src/Exception/HttpException.php', '9434316c23197db770e6c7c6037a6b31');
        $this->checkFile('vendor/maxmind/web-service-common/src/Exception/InsufficientFundsException.php', '14886d684f1be0b4b28a66f4b22e490f');
        $this->checkFile('vendor/maxmind/web-service-common/src/Exception/InvalidInputException.php', '72dc20089eb4a5cfaccafe6e2b17a36e');
        $this->checkFile('vendor/maxmind/web-service-common/src/Exception/InvalidRequestException.php', '0c16475216cb97056385eda43f7174e7');
        $this->checkFile('vendor/maxmind/web-service-common/src/Exception/IpAddressNotFoundException.php', '16313ab0d82195477e1ba071e7696313');
        $this->checkFile('vendor/maxmind/web-service-common/src/Exception/PermissionRequiredException.php', 'f832cea2f10902ae2ffa4521e13c73d1');
        $this->checkFile('vendor/maxmind/web-service-common/src/Exception/WebServiceException.php', '6882e0d113e22478202f99caf306bde9');
        $this->checkFile('vendor/maxmind/web-service-common/src/WebService/Client.php', '61a0136d3b539c17b75623e5d36df349');
        $this->checkFile('vendor/maxmind/web-service-common/src/WebService/Http/CurlRequest.php', 'b7e7704b7a92e40360df29395f4008a0');
        $this->checkFile('vendor/maxmind/web-service-common/src/WebService/Http/Request.php', '978f4b64578cb9aad8bf0745c457f8af');
        $this->checkFile('vendor/maxmind/web-service-common/src/WebService/Http/RequestFactory.php', 'ea623b76279567c2d1017e949eaeaf6b');
        $this->checkFile('vendor/maxmind-db/reader/CHANGELOG.md', 'fd5f7b07d58241b5cff02522e30f3dcc');
        $this->checkFile('vendor/maxmind-db/reader/LICENSE', '3b83ef96387f14655fc854ddc3c6bd57');
        $this->checkFile('vendor/maxmind-db/reader/README.md', '86acda048eae8583dcebce62233aa9db');
        $this->checkFile('vendor/maxmind-db/reader/autoload.php', '56ab7e16d09c4901d4f758502faea924');
        $this->checkFile('vendor/maxmind-db/reader/composer.json', '870a8eff3bd97b171b594624db41c05a');
        $this->checkFile('vendor/maxmind-db/reader/ext/config.m4', 'c44fc8d5bfcdab2ca76601dc8f091712');
        $this->checkFile('vendor/maxmind-db/reader/ext/maxminddb.c', 'e0842d57df25b47db26cae354f88a64b');
        $this->checkFile('vendor/maxmind-db/reader/ext/php_maxminddb.h', 'cea06ce146b92c8dba4793725912d797');
        $this->checkFile('vendor/maxmind-db/reader/ext/tests/001-load.phpt', '8251507e4949ac272bf4cc8503a32f1e');
        $this->checkFile('vendor/maxmind-db/reader/ext/tests/002-final.phpt', '264e0cadaead64525696692c7ef0ea68');
        $this->checkFile('vendor/maxmind-db/reader/ext/tests/003-open-basedir.phpt', '746a330ff866f4407b808be3d31e5106');
        $this->checkFile('vendor/maxmind-db/reader/src/MaxMind/Db/Reader/Decoder.php', 'fdae49000ed7f2244bf8a6200620f309');
        $this->checkFile('vendor/maxmind-db/reader/src/MaxMind/Db/Reader/InvalidDatabaseException.php', '30a5d8369ea2012e747ac1e59f78c76f');
        $this->checkFile('vendor/maxmind-db/reader/src/MaxMind/Db/Reader/Metadata.php', '9a5a3cba86e689c77b0e7e47e1a26628');
        $this->checkFile('vendor/maxmind-db/reader/src/MaxMind/Db/Reader/Util.php', '67c42bf8daa9c064deddac400cadf3fd');
        $this->checkFile('vendor/maxmind-db/reader/src/MaxMind/Db/Reader.php', 'ba29d548beb5240749bb339dbd5e301f');
        $this->checkFile('vendor/mobiledetect/mobiledetectlib/LICENSE.txt', '19f7bdc7912247751d52ccffd5a9ac55');
        $this->checkFile('vendor/mobiledetect/mobiledetectlib/Mobile_Detect.json', '4d90794ab4cbec6ce4443880f89bc0d6');
        $this->checkFile('vendor/mobiledetect/mobiledetectlib/Mobile_Detect.php', '9497bb90a488333b9ab0a431521fc7d5');
        $this->checkFile('vendor/mobiledetect/mobiledetectlib/README.md', 'c3ed5ca7e839c91beb6a3bed4d7d75a0');
        $this->checkFile('vendor/mobiledetect/mobiledetectlib/composer.json', '0b2dade87fccf91b6834eb6541e636a9');
        $this->checkFile('vendor/mobiledetect/mobiledetectlib/composer.lock', '1fc7e90a71f4e96bfa55292286749214');
        $this->checkFile('vendor/mobiledetect/mobiledetectlib/docker-compose.yml', 'b23990087da9ef80bc3bbdcc9ac3f8d9');
        $this->checkFile('vendor/mobiledetect/mobiledetectlib/docs/CONTRIBUTING.md', '11e1c55c98fb55940e4913a54f8e5728');
        $this->checkFile('vendor/mobiledetect/mobiledetectlib/docs/HISTORY.md', '8ab725b6fa97f5a6f89048f4089cce87');
        $this->checkFile('vendor/mobiledetect/mobiledetectlib/docs/ISSUE_TEMPLATE.md', '177b63a3df6c10a406af7d95c91a7b15');
        $this->checkFile('vendor/mobiledetect/mobiledetectlib/docs/KNOWN_LIMITATIONS.md', '806feb54148159801cfc6899c0baa218');
        $this->checkFile('vendor/mobiledetect/mobiledetectlib/export/exportToJSON.php', '4199140b66662904e33c7777ee4c6dca');
        $this->checkFile('vendor/mobiledetect/mobiledetectlib/namespaced/Detection/MobileDetect.php', '746976663e7feb11fad965add5012aba');
        $this->checkFile('vendor/mobiledetect/mobiledetectlib/phpcs.xml', '8ac3a84152de91e42031905745fbf791');
        $this->checkFile('vendor/paragonie/random_compat/LICENSE', '5c1048c9d62123819aa63e62e1578be6');
        $this->checkFile('vendor/paragonie/random_compat/composer.json', '138b552489da13d333852a1aaa330f62');
        $this->checkFile('vendor/paragonie/random_compat/dist/random_compat.phar.pubkey', '36dae3cf3fd10ae5093aaec29b7b5125');
        $this->checkFile('vendor/paragonie/random_compat/dist/random_compat.phar.pubkey.asc', '3ec788adbb0519a92243e569789cfcb9');
        $this->checkFile('vendor/paragonie/random_compat/lib/byte_safe_strings.php', '73d9b996e37833b33843da6698358d63');
        $this->checkFile('vendor/paragonie/random_compat/lib/cast_to_int.php', '79297a8a910b48162ff884043efc1612');
        $this->checkFile('vendor/paragonie/random_compat/lib/error_polyfill.php', 'a5862c390f82e0eef09f9ad9c147b811');
        $this->checkFile('vendor/paragonie/random_compat/lib/random.php', 'ebf7c66a2e660b0fef9d599715f31c47');
        $this->checkFile('vendor/paragonie/random_compat/lib/random_bytes_com_dotnet.php', '062d36d41c22af3f24625bc58144835f');
        $this->checkFile('vendor/paragonie/random_compat/lib/random_bytes_dev_urandom.php', '1f3482decf6b49549fa5dfc03dd6802f');
        $this->checkFile('vendor/paragonie/random_compat/lib/random_bytes_libsodium.php', '78479b3f06ef4d06788a96afba6c7ccc');
        $this->checkFile('vendor/paragonie/random_compat/lib/random_bytes_libsodium_legacy.php', 'c6ea1aff1de4231c937abaa7a64be6ae');
        $this->checkFile('vendor/paragonie/random_compat/lib/random_bytes_mcrypt.php', '46d5eb6fac0c2981b70f879a82649ae3');
        $this->checkFile('vendor/paragonie/random_compat/lib/random_int.php', '39a119c9afaebb018caa5e3f0dea3eb4');
        $this->checkFile('vendor/psr/http-message/CHANGELOG.md', 'c5bb41d4c198d17245a30bc77121ef63');
        $this->checkFile('vendor/psr/http-message/LICENSE', '1b0b156bcf7972a5f131e1e461e84b30');
        $this->checkFile('vendor/psr/http-message/README.md', '515a9aec472cb9a51fb7af5679e8f895');
        $this->checkFile('vendor/psr/http-message/composer.json', '1cbeade761cf023fec4118789f35c352');
        $this->checkFile('vendor/psr/http-message/src/MessageInterface.php', '5b86144b4235dd435ae390a2d2b497e1');
        $this->checkFile('vendor/psr/http-message/src/RequestInterface.php', '9f968a5accc656ebb969b6a973f43610');
        $this->checkFile('vendor/psr/http-message/src/ResponseInterface.php', '3a902ea57f57a8250e371ba6ea40c3b1');
        $this->checkFile('vendor/psr/http-message/src/ServerRequestInterface.php', '8694cf6882b28ef2c24c444d290682ea');
        $this->checkFile('vendor/psr/http-message/src/StreamInterface.php', 'dde87a38357aa58a17128df6bca5a554');
        $this->checkFile('vendor/psr/http-message/src/UploadedFileInterface.php', 'bf303071ee88d14c0b9f4482002698a0');
        $this->checkFile('vendor/psr/http-message/src/UriInterface.php', '77f0ea01e2cd3a2848d1dec182b2c9eb');
        $this->checkFile('vendor/psr/log/LICENSE', '1a74629072fd794937be394ab689327e');
        $this->checkFile('vendor/psr/log/Psr/Log/AbstractLogger.php', '26eb607e5318188016615326bd89a9be');
        $this->checkFile('vendor/psr/log/Psr/Log/InvalidArgumentException.php', '7d2f0bd1583524d739fff12f0507de65');
        $this->checkFile('vendor/psr/log/Psr/Log/LogLevel.php', 'cc226142fd5d390d030b39c61cf97843');
        $this->checkFile('vendor/psr/log/Psr/Log/LoggerAwareInterface.php', 'cfac6d4dc3ebf2c7f0e49f74d1bcd44a');
        $this->checkFile('vendor/psr/log/Psr/Log/LoggerAwareTrait.php', '221f47ac7d3da4800d2c0e26cdfb351b');
        $this->checkFile('vendor/psr/log/Psr/Log/LoggerInterface.php', '460689f292a11ebce586ef066313dd5d');
        $this->checkFile('vendor/psr/log/Psr/Log/LoggerTrait.php', '80438cede9b432c45cd59838fc3080af');
        $this->checkFile('vendor/psr/log/Psr/Log/NullLogger.php', '0cfdfa8d81e5b22c24c96ae7014213c0');
        $this->checkFile('vendor/psr/log/Psr/Log/Test/DummyTest.php', '52cb71ea2645f556b4e1e519d1c78a76');
        $this->checkFile('vendor/psr/log/Psr/Log/Test/LoggerInterfaceTest.php', 'a653a140fb81bf4c37da14a60c2ad1d7');
        $this->checkFile('vendor/psr/log/Psr/Log/Test/TestLogger.php', '885f63b13ecb1ab70b3da51573770ef4');
        $this->checkFile('vendor/psr/log/README.md', '0073e95256311bd375ebe2ed5fbc95e8');
        $this->checkFile('vendor/psr/log/composer.json', '770ed2c20c6b6665a84464a5249bd949');
        $this->checkFile('vendor/ralouphie/getallheaders/LICENSE', 'f7786f46efa7706a39adcd5b5e1ec2c3');
        $this->checkFile('vendor/ralouphie/getallheaders/README.md', '94653dfef8ea30f7a1e0b51684e5b565');
        $this->checkFile('vendor/ralouphie/getallheaders/composer.json', '83262caccfdbc4fe204642750540335c');
        $this->checkFile('vendor/ralouphie/getallheaders/src/getallheaders.php', 'fe517816cb82a5e67e62c8d0241fce3a');
        $this->checkFile('vendor/slim/slim/.htaccess', 'fa908fe268b76bb7527be4674ff6991f');
        $this->checkFile('vendor/slim/slim/.travis.yml', '5ff0e50d85fc8d84644dbf1abc68be54');
        $this->checkFile('vendor/slim/slim/CONTRIBUTING.md', '5978524837f5d5804dc9f8dc935f2fac');
        $this->checkFile('vendor/slim/slim/LICENSE', 'a6255086dd42dab5e9bd97699e76f154');
        $this->checkFile('vendor/slim/slim/README.markdown', '6186c57ef40974eda653f37cc5d858c2');
        $this->checkFile('vendor/slim/slim/Slim/Environment.php', 'a77ef114f4f89d2332d1c5444f53c224');
        $this->checkFile('vendor/slim/slim/Slim/Exception/Pass.php', 'a9a2652468e613e5f84f2d26ec68d25d');
        $this->checkFile('vendor/slim/slim/Slim/Exception/Stop.php', 'e10e9009e8e15e4f81b60729996cdd38');
        $this->checkFile('vendor/slim/slim/Slim/Helper/Set.php', '6303cd6df1f6756506b19bfbf903aa82');
        $this->checkFile('vendor/slim/slim/Slim/Http/Cookies.php', 'aee9e68e75b55f22ac03d296fa1a9580');
        $this->checkFile('vendor/slim/slim/Slim/Http/Headers.php', 'ea6a07d523d93b1a193e5164b72deee0');
        $this->checkFile('vendor/slim/slim/Slim/Http/Request.php', 'cc835dfcd351fa8dcdfade742d100321');
        $this->checkFile('vendor/slim/slim/Slim/Http/Response.php', '77e3a0bebdeb19f3a7f4d725c550a8d1');
        $this->checkFile('vendor/slim/slim/Slim/Http/Util.php', '02747df3baa0d64788333a902b704275');
        $this->checkFile('vendor/slim/slim/Slim/Log.php', '8b35dbb2f941bc8a44d4236eda096454');
        $this->checkFile('vendor/slim/slim/Slim/LogWriter.php', 'ddf322f04aa96c1eda9a4423490e1e4d');
        $this->checkFile('vendor/slim/slim/Slim/Middleware/ContentTypes.php', '62e177e5f8c1a2ce048f6c1d1f3bd953');
        $this->checkFile('vendor/slim/slim/Slim/Middleware/Flash.php', 'e3f24e9fda7bf69eb7a95a031478e885');
        $this->checkFile('vendor/slim/slim/Slim/Middleware/MethodOverride.php', '2bf05a75336e82e208c61b7dec1ef60f');
        $this->checkFile('vendor/slim/slim/Slim/Middleware/PrettyExceptions.php', '76cd355a74b12f478bf81c6f5df2d1b7');
        $this->checkFile('vendor/slim/slim/Slim/Middleware/SessionCookie.php', '617571d7cc4f165a4e7815680f808444');
        $this->checkFile('vendor/slim/slim/Slim/Middleware.php', 'd539253a54a486a902d22691b6818d3d');
        $this->checkFile('vendor/slim/slim/Slim/Route.php', '77cc7c5c7e9f76167bc1b3a88c34960a');
        $this->checkFile('vendor/slim/slim/Slim/Router.php', 'a23a374c1a233683be08529783ca2222');
        $this->checkFile('vendor/slim/slim/Slim/Slim.php', 'c7e72ae663d893e55632f16df11957a4');
        $this->checkFile('vendor/slim/slim/Slim/View.php', 'f09f325cbf96fc0fd540b16bbb10ece9');
        $this->checkFile('vendor/slim/slim/composer.json', '45b17a6833c24e92635fb7bd930723ee');
        $this->checkFile('vendor/slim/slim/index.php', '49a91e6edeed6d7e9297e06b7cef67f9');
        $this->checkFile('vendor/slim/slim/phpunit.xml.dist', 'f2ad7b5bd8abe8ef2d455202fad44238');
        $this->checkFile('vendor/slim/slim/tests/EnvironmentTest.php', 'ffd877e92a525d85b8a9141ff86b9b7d');
        $this->checkFile('vendor/slim/slim/tests/Foo.php', '8c1711ca97f27529cbf8b938c0f1384c');
        $this->checkFile('vendor/slim/slim/tests/Helper/SetTest.php', 'df6bcd044f3a0adbd7ab479dd1bff3a1');
        $this->checkFile('vendor/slim/slim/tests/Http/CookiesTest.php', 'cf618aaec1a0a8c12c1711de2969a5bf');
        $this->checkFile('vendor/slim/slim/tests/Http/HeadersTest.php', '6fc0208859c50907cc8b4a15f839009f');
        $this->checkFile('vendor/slim/slim/tests/Http/RequestTest.php', '3931f7b39d42b8c0806d3c85f796251a');
        $this->checkFile('vendor/slim/slim/tests/Http/ResponseTest.php', '3059d55bc494f55bb496af9d101a12a9');
        $this->checkFile('vendor/slim/slim/tests/Http/UtilTest.php', '8498f74f8106b4e32186299bfb112e90');
        $this->checkFile('vendor/slim/slim/tests/LogTest.php', '0638699f99bcaf0b227654305237ae11');
        $this->checkFile('vendor/slim/slim/tests/LogWriterTest.php', 'bd86c9fbcec860d0335e276a89a0ccd3');
        $this->checkFile('vendor/slim/slim/tests/Middleware/ContentTypesTest.php', '21a95365ac7640006c75ae2c4cfc7175');
        $this->checkFile('vendor/slim/slim/tests/Middleware/FlashTest.php', 'dc98843d99c2257416342c94f3122202');
        $this->checkFile('vendor/slim/slim/tests/Middleware/MethodOverrideTest.php', '8f6d764949512ae2bd49763f98d37a87');
        $this->checkFile('vendor/slim/slim/tests/Middleware/PrettyExceptionsTest.php', 'dbdd5a30d493eba020ccf1db4158bbad');
        $this->checkFile('vendor/slim/slim/tests/Middleware/SessionCookieTest.php', 'bf4fd4c597351b9b2f1eef31bfdcb440');
        $this->checkFile('vendor/slim/slim/tests/MiddlewareTest.php', '533c0d23e2340e5b1e584b7cac70c232');
        $this->checkFile('vendor/slim/slim/tests/README', '0214f0eb08e2dfd3494061fd13c258c6');
        $this->checkFile('vendor/slim/slim/tests/RouteTest.php', 'bddb0e1701fe8f20a19f95ac28c50461');
        $this->checkFile('vendor/slim/slim/tests/RouterTest.php', 'dc6ce2c441a3ea8f38c7044831129403');
        $this->checkFile('vendor/slim/slim/tests/SlimTest.php', '41ab0cd0bedc3b8e1756ad4456b2e477');
        $this->checkFile('vendor/slim/slim/tests/ViewTest.php', '1a691a48c0281d2873b9963a67d1065f');
        $this->checkFile('vendor/slim/slim/tests/bootstrap.php', '2cf27ca58a651a79be2408c1b22c92b3');
        $this->checkFile('vendor/slim/slim/tests/templates/test.php', '8ecadba0c82f2e6f08ee997f9e682053');
        $this->checkFile('vendor/symfony/polyfill-intl-idn/Idn.php', '9aa4b05328a2ce3899f6459ef0b08f06');
        $this->checkFile('vendor/symfony/polyfill-intl-idn/LICENSE', 'f082cc77e5ce76aa7e7fad8aa1d0cbeb');
        $this->checkFile('vendor/symfony/polyfill-intl-idn/README.md', '9f938d4668c5a96074428df1471e2b90');
        $this->checkFile('vendor/symfony/polyfill-intl-idn/bootstrap.php', '556713b794c93e8f3212caca7e243c2d');
        $this->checkFile('vendor/symfony/polyfill-intl-idn/composer.json', '7f9a9b7da7846dde82b1f90021bea55c');
        $this->checkFile('vendor/symfony/polyfill-mbstring/LICENSE', 'd05e73887eedc78611070af6a52dd160');
        $this->checkFile('vendor/symfony/polyfill-mbstring/Mbstring.php', '25c15e476421c92b6cbb1d938c70c767');
        $this->checkFile('vendor/symfony/polyfill-mbstring/README.md', '03e947016ec315b3a4668ae1ceef0bf8');
        $this->checkFile('vendor/symfony/polyfill-mbstring/Resources/unidata/lowerCase.php', '64ad19d5007926db720b51895b7fccf3');
        $this->checkFile('vendor/symfony/polyfill-mbstring/Resources/unidata/titleCaseRegexp.php', 'a161350864050f78bf9161f7f3c94172');
        $this->checkFile('vendor/symfony/polyfill-mbstring/Resources/unidata/upperCase.php', 'd866e3aa286a7c657752218e027b3bff');
        $this->checkFile('vendor/symfony/polyfill-mbstring/bootstrap.php', '16914647d0a95780f3ba76cb914f8483');
        $this->checkFile('vendor/symfony/polyfill-mbstring/composer.json', '540a3d72eb5e026e1e19d7555a2715e4');
        $this->checkFile('vendor/symfony/polyfill-php72/LICENSE', 'd05e73887eedc78611070af6a52dd160');
        $this->checkFile('vendor/symfony/polyfill-php72/Php72.php', '7ad85a07b94ca467e7d7c5b117ccb1bf');
        $this->checkFile('vendor/symfony/polyfill-php72/README.md', 'e43a8d174b3e05ace27aa4dbbd4acde4');
        $this->checkFile('vendor/symfony/polyfill-php72/bootstrap.php', 'b392bc7fc38f9b0d2cbd64627407859c');
        $this->checkFile('vendor/symfony/polyfill-php72/composer.json', 'a91c06ff5e86e1c637d65b6a09a64b84');

    }

    protected function initRemovedFiles() {
        $this->removedFiles[] = 'plugins/GoogleGears/';
        $this->removedFiles[] = 'plugins/GoogleGears/Definition.class.php';
        $this->removedFiles[] = 'plugins/GoogleGears/gears_init.js';
        $this->removedFiles[] = 'plugins/GoogleGears/Main.class.php';
        $this->removedFiles[] = 'plugins/GoogleMaps/';
        $this->removedFiles[] = 'plugins/GoogleMaps/Definition.class.php';
        $this->removedFiles[] = 'plugins/GoogleMaps/Main.class.php';
        $this->removedFiles[] = 'plugins/SysInfo/';
        $this->removedFiles[] = 'plugins/SysInfo/phpsysinfo';
        $this->removedFiles[] = 'plugins/SysInfo/Definition.class.php';
        $this->removedFiles[] = 'plugins/SysInfo/Main.class.php';
        $this->removedFiles[] = 'plugins/AffiliateHomeStatsAdditionalData/Definition.class.php';
        $this->removedFiles[] = 'plugins/AffiliateHomeStatsAdditionalData/Main.class.php';
        $this->removedFiles[] = 'include/Gpf/SmartyPlugins/compiler.widget.php';
        $this->removedFiles[] = 'include/Gpf/SmartyPlugins/function.fetch.php';
        $this->removedFiles[] = 'include/Gpf/SmartyPlugins/function.localize.php';
        $this->removedFiles[] = 'include/Gpf/SmartyPlugins/function.ratioColon.php';
        $this->removedFiles[] = 'include/Gpf/SmartyPlugins/function.server_widget.php';
        $this->removedFiles[] = 'include/Gpf/SmartyPlugins/function.widget_dynamic.php';
        $this->removedFiles[] = 'include/Gpf/SmartyPlugins/modifier.date.php';
        $this->removedFiles[] = 'include/Gpf/SmartyPlugins/modifier.escape_single_quotes.php';
        $this->removedFiles[] = 'include/Gpf/SmartyPlugins/modifier.file_size.php';
        $this->removedFiles[] = 'include/Gpf/SmartyPlugins/modifier.number.php';
        $this->removedFiles[] = 'include/Gpf/SmartyPlugins/modifier.number_span.php';
        $this->removedFiles[] = 'include/Gpf/SmartyPlugins/resource.template.php';
        $this->removedFiles[] = 'include/Gpf/SmartyPlugins/resource.text.php';
        $this->removedFiles[] = 'include/Stripe/';
        $this->removedFiles[] = 'include/Stripe.class.php';
    }
}

?>